/*-
 *   BSD LICENSE
 *
 *   Copyright(c) 2010-2014 Intel Corporation. All rights reserved.
 *   All rights reserved.
 *
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions
 *   are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in
 *       the documentation and/or other materials provided with the
 *       distribution.
 *     * Neither the name of Intel Corporation nor the names of its
 *       contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 *   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef _TEST_LPM_ROUTES_H_
#define _TEST_LPM_ROUTES_H_

struct rules_tbl_entry {
	uint8_t ip[16];
	uint8_t depth;
	uint8_t next_hop;
};

struct ips_tbl_entry {
	uint8_t ip[16];
	uint8_t next_hop;
};

static struct rules_tbl_entry large_route_table[] =
{
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50, 146},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54, 141},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 67, 23},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 97, 252},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54, 6},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9, 137},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 82, 9},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 120, 163},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 79, 197},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54, 249},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47, 88},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52, 104},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10, 36},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54, 239},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 67, 201},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33, 94},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51, 241},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 24, 239},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 66, 151},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 12, 137},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41, 231},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 44, 11},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 96, 20},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15, 68},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 101, 64},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33, 152},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6, 217},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2, 101},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15, 58},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27, 254},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32, 148},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126, 126},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 123, 76},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54, 240},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54, 33},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25, 47},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 109, 41},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 62, 72},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 46, 43},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 68, 26},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42, 139},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13, 219},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 58, 105},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47, 210},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 17, 151},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42, 28},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9, 64},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 121, 9},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 92, 250},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 66, 200},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 127, 132},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 71, 182},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 102, 7},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 100, 146},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 0}, 70, 98},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 86, 179},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 77, 245},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 64, 2},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 17, 5},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 66, 169},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33, 52},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9, 177},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27, 74},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 122, 212},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 122, 238},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19, 18},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 75, 155},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 24, 97},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32, 8},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9, 123},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 92, 11},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13, 211},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20, 116},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11, 57},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 108, 178},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 102, 93},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 92, 3},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 121, 162},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 109, 125},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34, 33},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9, 254},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 74, 66},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 30, 4},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 86, 122},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 46, 59},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 117, 99},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27, 41},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8, 112},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 85, 255},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 44, 106},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 0}, 62, 170},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16, 86},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 79, 155},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35, 65},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36, 39},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 90, 162},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10, 69},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 64, 163},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 90, 116},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53, 19},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36, 48},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49, 230},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 78, 155},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 96, 158},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 113, 252},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 110, 176},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 66, 211},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28, 15},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 68, 95},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34, 169},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 44, 249},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 105, 61},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 23, 63},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 14, 43},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 81, 228},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 0}, 78, 165},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 0}, 64, 3},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57, 211},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33, 210},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 99, 61},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10, 120},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47, 94},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41, 153},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18, 221},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 87, 163},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 106, 188},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 124, 15},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 63, 28},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 84, 240},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 93, 59},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 90, 195},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 66, 10},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 88, 206},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2, 137},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 22, 225},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10, 223},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15, 29},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 103, 166},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 80, 178},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 55, 38},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9, 141},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 116, 230},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 99, 124},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 118, 54},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32, 162},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13, 32},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 102, 237},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 7, 215},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 22, 138},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 118, 73},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 90, 43},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 112, 88},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 119, 91},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 0}, 69, 140},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37, 65},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 122, 201},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 72, 69},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35, 170},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40, 192},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 89, 21},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 46, 35},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 71, 235},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21, 240},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 30, 136},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 0}, 60, 186},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 95, 174},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 79, 153},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35, 118},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 60, 113},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6, 58},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 101, 206},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 111, 42},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 55, 230},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 67, 6},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13, 254},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 108, 214},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 107, 43},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 67, 178},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16, 179},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 87, 236},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 98, 184},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 91, 95},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 127, 152},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2, 113},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 108, 137},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 46, 224},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6, 61},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41, 205},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 124, 170},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53, 117},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 0}, 70, 225},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 0}, 72, 34},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 17, 5},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50, 92},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 55, 230},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 112, 61},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 117, 221},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 121, 105},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11, 181},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 79, 110},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 86, 103},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 123, 218},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56, 146},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 0}, 67, 90},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 108, 197},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 103, 158},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 81, 118},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 0}, 62, 95},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33, 152},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45, 239},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50, 48},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5, 228},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 30, 247},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 85, 12},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10, 129},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4, 50},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 128, 250},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 0}, 77, 249},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 1, 230},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 92, 228},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 0}, 64, 181},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16, 206},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 0}, 63, 122},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 72, 81},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 95, 175},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 118, 170},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47, 174},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29, 104},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 114, 113},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 80, 89},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 113, 151},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11, 108},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 7, 224},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9, 95},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 14, 173},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 93, 176},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 119, 84},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 78, 104},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49, 236},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 116, 153},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11, 190},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13, 202},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8, 54},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34, 156},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 126, 245},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6, 218},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 93, 72},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 112, 183},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2, 183},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42, 241},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47, 106},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40, 180},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 96, 142},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 100, 6},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 118, 33},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34, 224},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 78, 14},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10, 149},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 108, 131},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 121, 133},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 89, 33},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28, 204},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52, 43},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51, 168},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28, 180},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 112, 208},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 90, 25},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 111, 50},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 109, 110},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 109, 21},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36, 147},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43, 56},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 117, 144},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 100, 198},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 90, 235},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38, 105},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45, 138},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49, 122},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 65, 193},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43, 231},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 64, 250},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 86, 24},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 55, 191},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 117, 111},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 111, 205},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 1, 133},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122, 122},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 87, 227},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 46, 53},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 0}, 72, 224},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26, 199},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 17, 79},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21, 19},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 96, 211},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 120, 6},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 121, 143},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31, 135},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 109, 21},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38, 220},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 68, 151},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 60, 111},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20, 63},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57, 112},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41, 48},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 126, 100},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 60, 156},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 95, 120},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16, 5},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4, 103},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4, 84},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 101, 24},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 86, 81},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29, 96},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 121, 6},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 119, 40},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 0}, 62, 143},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 68, 69},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 92, 48},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 0}, 64, 115},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 115, 130},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 86, 57},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8, 97},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9, 146},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 117, 194},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 114, 129},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 97, 159},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 117, 242},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 104, 162},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 102, 140},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 113, 77},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 82, 121},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 69, 102},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 23, 28},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 89, 154},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 76, 39},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 78, 163},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 0}, 68, 42},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 92, 207},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8, 25},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18, 150},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 0}, 76, 103},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 71, 155},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 96, 142},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 112, 2},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19, 59},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4, 112},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48, 166},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 0}, 73, 62},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50, 176},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 100, 6},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29, 26},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5, 6},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5, 13},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37, 41},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36, 135},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 93, 171},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19, 20},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 89, 119},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 112, 49},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4, 141},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47, 132},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 105, 176},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 12, 186},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 67, 93},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 111, 242},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 24, 163},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42, 184},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 0}, 68, 188},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 126, 193},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 78, 63},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 115, 160},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 117, 251},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 0}, 72, 228},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 0}, 72, 168},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18, 194},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47, 166},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 122, 210},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 89, 254},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 75, 49},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 96, 95},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33, 193},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 58, 155},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15, 133},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38, 10},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33, 31},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 127, 98},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 96, 22},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20, 214},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50, 217},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 98, 102},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 83, 169},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27, 152},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 103, 214},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 99, 178},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45, 164},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 7, 15},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 76, 94},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 70, 239},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 0}, 73, 82},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 55, 54},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 98, 47},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 84, 214},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37, 215},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 84, 153},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 122, 245},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8, 118},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 123, 128},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8, 7},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 80, 152},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 114, 248},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 85, 143},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 30, 159},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 24, 11},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31, 110},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 97, 181},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 121, 4},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 0}, 67, 101},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11, 38},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 78, 57},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 17, 142},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 24, 184},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27, 91},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41, 224},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 78, 114},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 118, 184},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28, 215},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 120, 167},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 89, 233},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29, 101},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 67, 139},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 79, 32},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32, 57},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 91, 151},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49, 0},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 63, 227},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 118, 124},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 104, 228},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27, 64},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25, 179},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 0}, 70, 107},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 104, 206},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 0}, 68, 95},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 96, 219},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 119, 138},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53, 84},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11, 161},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52, 25},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 107, 113},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2, 46},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 63, 72},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 93, 230},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 117, 142},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41, 134},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 112, 100},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 109, 45},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 30, 219},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16, 52},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 83, 240},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 90, 13},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 84, 191},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 106, 95},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28, 65},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45, 195},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 103, 21},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4, 114},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31, 92},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42, 237},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 125, 172},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 98, 116},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 55, 54},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8, 203},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16, 74},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 96, 220},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 0}, 67, 219},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3, 179},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 61, 194},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32, 187},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50, 79},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19, 87},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8, 126},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11, 106},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50, 96},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47, 45},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 110, 8},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 62, 226},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36, 222},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 71, 218},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 116, 59},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8, 80},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 58, 177},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 98, 44},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 93, 206},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27, 64},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 96, 236},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 22, 101},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26, 49},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11, 179},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 109, 112},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 96, 31},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41, 111},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 86, 65},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 78, 222},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 58, 4},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 0}, 67, 67},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 109, 197},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 22, 121},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 1, 167},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38, 140},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 106, 193},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 90, 47},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21, 187},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56, 102},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 46, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 103, 237},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 107, 115},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 84, 217},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 79, 21},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 113, 3},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48, 62},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47, 80},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51, 184},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 0}, 80, 197},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13, 63},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 99, 62},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 114, 231},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 67, 158},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 101, 118},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 30, 237},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 79, 15},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 122, 84},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 119, 205},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 82, 220},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40, 42},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51, 144},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37, 74},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19, 89},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 88, 77},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 94, 2},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 14, 75},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 0}, 65, 18},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 46, 246},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 114, 10},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 14, 207},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 68, 41},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 89, 102},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118, 118},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10, 146},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 104, 122},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 107, 6},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 58, 18},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 70, 83},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 99, 90},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32, 140},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4, 242},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50, 31},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 111, 9},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 1, 230},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47, 50},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41, 34},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 17, 11},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8, 71},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 22, 146},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 124, 249},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 39, 143},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 110, 17},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 119, 60},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 1, 162},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 12, 5},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 62, 139},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 39, 8},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 114, 246},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42, 171},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 88, 206},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28, 163},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 62, 166},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51, 128},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31, 59},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32, 179},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 124, 87},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 114, 29},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 91, 184},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 14, 45},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 55, 144},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 114, 119},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 64, 113},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 82, 50},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56, 207},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21, 3},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58, 13},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 59, 42},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50, 31},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 94, 30},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29, 94},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 71, 190},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 59, 238},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 30, 20},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51, 84},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42, 108},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 89, 136},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 93, 196},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28, 67},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 12, 104},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 55, 15},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 128, 237},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 116, 224},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36, 179},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 0}, 67, 84},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 22, 65},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5, 178},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 55, 154},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27, 106},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 67, 125},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9, 118},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 0}, 73, 52},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 58, 173},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 113, 8},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 74, 211},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 0}, 61, 253},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 59, 47},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 112, 73},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19, 192},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 128, 55},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 94, 147},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 125, 86},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 82, 16},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 111, 167},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 0}, 67, 148},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54, 66},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 104, 70},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16, 166},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 44, 109},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5, 226},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32, 8},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 85, 218},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 78, 54},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 67, 48},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51, 244},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 74, 50},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54, 173},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 84, 245},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 121, 54},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 113, 86},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2, 115},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 24, 144},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 89, 171},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 93, 231},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 88, 34},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53, 225},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38, 174},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 113, 37},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 121, 39},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 23, 59},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34, 96},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3, 147},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 110, 56},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 111, 234},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 46, 199},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 69, 191},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40, 235},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20, 45},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 67, 164},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 121, 130},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18, 166},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 24, 140},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 118, 47},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 111, 148},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3, 103},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 116, 94},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19, 85},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 109, 250},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16, 153},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 125, 182},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 94, 23},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 108, 38},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 110, 121},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 87, 146},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16, 138},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 94, 149},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 88, 232},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45, 255},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51, 148},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48, 117},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 14, 237},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19, 113},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57, 162},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21, 225},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 92, 210},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 22, 34},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29, 224},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16, 143},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 68, 216},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 120, 239},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 111, 54},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9, 35},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 119, 230},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45, 234},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 115, 70},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32, 246},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 127, 217},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 128, 201},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 17, 49},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57, 2},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38, 64},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 0}, 62, 239},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 116, 47},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 80, 43},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 94, 17},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26, 5},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 81, 240},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50, 197},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 84, 192},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47, 160},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 84, 199},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 127, 217},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 83, 75},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 106, 222},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 85, 39},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45, 9},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33, 217},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25, 142},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 0}, 62, 18},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 104, 180},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56, 205},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 57, 251},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 22, 178},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 59, 198},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34, 84},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 66, 128},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 97, 75},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 101, 192},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 114, 60},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 0}, 63, 169},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 62, 10},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 118, 64},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 127, 182},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13, 29},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3, 39},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51, 93},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 75, 228},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34, 236},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56, 190},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49, 217},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 93, 74},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61, 180},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 55, 91},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54, 230},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52, 175},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 75, 171},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 120, 202},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49, 113},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 96, 187},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 120, 38},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26, 35},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38, 115},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51, 18},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 39, 34},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 87, 75},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33, 232},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 91, 154},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19, 195},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 70, 122},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 24, 97},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5, 220},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 7, 80},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 77, 133},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38, 93},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 110, 176},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 95, 68},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 103, 247},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29, 240},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 74, 83},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 55, 132},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 24, 217},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3, 214},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34, 193},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 71, 61},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 39, 65},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 91, 108},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28, 244},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 95, 194},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 124, 82},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 116, 45},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48, 224},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 22, 17},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 44, 133},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 85, 125},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3, 42},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 96, 140},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28, 91},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48, 92},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13, 125},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 106, 249},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40, 202},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13, 107},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13, 124},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53, 57},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 92, 181},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 24, 107},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 128, 101},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4, 102},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 0}, 62, 136},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45, 114},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 22, 215},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 0}, 79, 249},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 88, 29},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 44, 71},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 127, 112},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31, 72},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 73, 155},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 61, 66},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 91, 77},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3, 109},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 72, 37},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 91, 56},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 103, 5},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25, 15},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29, 183},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 105, 171},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 112, 202},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5, 136},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37, 107},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 87, 193},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52, 4},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 96, 68},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 7, 40},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 39, 255},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18, 108},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 14, 219},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 108, 12},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40, 84},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 96, 33},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 91, 199},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 46, 52},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 113, 184},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18, 124},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 109, 128},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49, 255},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 105, 146},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 24, 172},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 70, 116},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 0}, 66, 189},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 70, 10},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 98, 184},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33, 98},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42, 37},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 46, 174},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 67, 251},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42, 115},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 107, 252},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40, 176},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 91, 155},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 124, 36},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 88, 202},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5, 208},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 77, 158},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 72, 136},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28, 191},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 120, 126},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 128, 139},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25, 216},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29, 93},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4, 196},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 81, 119},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 104, 93},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 96, 183},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52, 207},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9, 102},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19, 36},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 93, 41},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47, 70},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 0}, 63, 218},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 120, 226},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 114, 25},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 98, 6},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11, 26},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52, 149},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 46, 127},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 62, 144},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56, 213},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 58, 115},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 83, 146},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26, 58},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47, 222},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50, 16},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 65, 169},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40, 175},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32, 3},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 96, 2},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36, 193},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 118, 151},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51, 182},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10, 148},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42, 53},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11, 87},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 73, 235},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 23, 51},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 116, 11},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 0}, 68, 28},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 96, 73},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28, 216},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16, 99},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18, 35},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 127, 195},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 108, 176},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 87, 217},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 126, 244},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3, 125},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50, 219},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18, 165},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 117, 6},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53, 47},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 23, 73},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47, 98},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52, 21},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32, 142},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 93, 34},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 74, 41},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 55, 80},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 22, 11},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 58, 254},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45, 95},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40, 8},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 14, 212},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 95, 217},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57, 15},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 84, 66},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28, 122},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 97, 12},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 71, 171},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 106, 42},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28, 194},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 107, 237},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 93, 151},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 109, 238},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 0}, 59, 128},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26, 227},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 127, 138},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10, 60},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18, 148},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 128, 129},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49, 202},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 81, 88},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 90, 3},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 108, 243},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 80, 95},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 87, 255},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26, 48},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50, 38},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 115, 20},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43, 41},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 92, 133},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 95, 189},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 95, 151},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 68, 100},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49, 118},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34, 164},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 98, 71},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9, 251},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57, 51},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3, 185},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10, 144},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 84, 51},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 87, 32},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 70, 137},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 60, 2},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 0}, 63, 163},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 100, 162},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10, 192},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36, 185},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 59, 51},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54, 93},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2, 159},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 72, 189},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21, 248},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 123, 38},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 76, 167},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51, 28},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 125, 37},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 107, 234},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9, 70},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 108, 50},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51, 171},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 113, 236},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4, 3},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 86, 64},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 108, 213},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54, 15},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20, 145},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57, 27},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 127, 75},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 123, 76},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 113, 247},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43, 121},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 30, 214},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26, 221},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 63, 102},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2, 191},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 39, 197},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 79, 106},
};

static struct ips_tbl_entry large_ips_table[] =
{
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 194, 147, 115, 142, 16, 127, 8}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 229, 23, 195, 4, 249, 2}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 84, 128, 8, 36, 26}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 203, 219, 206}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 136, 152, 202, 50}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 5, 152, 190, 60, 210, 175, 81, 101}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 72, 237, 205, 48, 61}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 141, 41, 73, 9, 48, 30, 122, 18}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 43, 198, 176, 9, 240, 180}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 219, 60, 216, 227, 85, 97, 202, 243}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 185, 206, 43, 179, 129, 115, 166, 131, 102}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 88, 13, 78}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 216, 146, 183, 156, 118, 54, 250, 238, 4}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 2, 79}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 61, 9, 147, 80}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 217, 179, 60, 30, 230, 203}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 86, 177, 17, 57, 191, 148}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 183, 12, 211, 118, 249, 169, 219}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 119, 197, 52, 238, 81, 191, 112}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 100, 145, 120}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 230, 252}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 51, 116}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 69, 132, 25, 226}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 29, 50, 25, 251, 126, 167}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 105, 206, 38, 242, 19, 169}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 241, 65, 232, 169}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 98, 218, 119, 149, 192}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 182, 103}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 63, 60, 122, 11, 248, 145, 149, 224, 39}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 154, 104, 241, 221, 216, 89, 163, 74, 77}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 87, 149}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 217, 248, 111, 129, 119, 118}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 114, 29, 173, 243, 47, 62, 112}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 165, 58, 168, 164}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 8, 20, 67, 95, 80}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 230, 234, 164, 55, 21, 105, 115, 227}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 242, 114, 211, 159, 242}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 23, 36, 201, 102, 160, 208}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 5, 252, 137, 97, 245, 7, 115, 20, 51}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 249, 106, 198, 190, 23, 28, 20, 24, 214}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 12, 2, 115, 42}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 156, 225, 23}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 6, 253, 87, 178, 67, 237}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 238, 6, 238, 63}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 46, 212, 97, 16}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 141, 110, 89, 188, 166, 68}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 239, 190, 110, 60, 81, 148, 203, 221, 214}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 171, 145, 15, 135}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 146, 194}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 252, 81, 209, 1, 127, 134}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 244, 124, 19, 48, 19, 179, 32, 169, 72}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 216, 65, 92, 84}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 204, 126}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 45, 240, 229, 141, 221, 111}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 81, 244, 218, 21, 42, 248}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 190, 2, 138, 170, 49, 96}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 25, 212, 101, 84, 241}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 222, 35, 234, 212}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 31, 253, 169}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 39, 101}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 165, 183, 69, 28}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 19, 125, 169, 46, 44, 137, 1, 136, 111}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 122, 168, 211, 57, 14, 162, 55, 211}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 161, 107, 124}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 126, 35, 107, 201, 21, 140, 15, 246}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 70, 233, 179, 218, 33}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 199, 202, 185, 226, 209}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 245, 205, 239, 116, 228, 171, 199, 226, 214}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 11, 44, 36, 55, 249, 213, 120}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 28, 193, 217, 220, 104, 255}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 124, 197, 195}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 80, 124, 199}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 103, 30}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 181, 183, 49, 182, 210, 82, 135, 16}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 183, 182}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 249, 91, 47, 60}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 0, 51, 228, 125, 220, 71, 10}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 20, 10, 247, 72, 120, 44, 79, 150, 118}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 123, 72, 190, 210, 143, 29, 197, 249, 169}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 0, 239, 246, 133, 146, 235, 153, 223}, 146},
	{{66, 70, 154, 143, 197, 233, 0, 0, 207, 124, 153, 121, 5, 242, 157, 173}, 146},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 23, 185, 140, 139, 103, 142, 106}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 185, 15, 51, 2, 207, 128, 233}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 252, 177, 6}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 217, 157, 143, 150}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 164, 17, 162, 72, 176, 60, 79}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 165, 219, 227, 69, 234, 211}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 155, 93, 182, 88, 109}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 40, 180, 73, 180, 154, 67, 254, 51}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 231, 179, 32, 174, 173, 96, 36, 53}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 56, 168, 98, 111}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 239, 60, 33, 23, 217}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 99, 247}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 74, 90, 7, 5, 71, 46, 75}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 193, 240, 139, 99, 182, 157, 108}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 144, 159, 7}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 180}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 149, 168, 187, 209, 186, 15, 23, 185, 46}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 85, 105, 215, 122, 146}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 253, 123, 24, 192, 161}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 58, 253, 77, 222, 34}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 57}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 103}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 239, 32, 67, 206, 156, 187}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 188, 68, 182, 43, 122, 149, 93, 183}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 63, 23, 17, 133, 247, 150, 13}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 238, 84}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 34, 58, 184, 194, 11, 119, 165, 244}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 9, 195, 194, 222, 80, 28, 20}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 53, 32, 179, 2, 203, 84, 204, 56}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 196, 167, 118}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 34, 116, 134, 156, 29, 92, 178}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 224, 104, 226, 104, 168}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 167, 190, 234, 157, 115, 238, 4, 193}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 144, 199, 189}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 122, 250, 151, 194, 106}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 77, 157, 57, 89, 21, 168}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 78, 31, 174, 130, 146, 52, 56, 74}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 91, 125, 201, 35, 116, 188, 164, 252}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 245, 31}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 27, 55, 108}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 120, 215}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 153, 175, 0, 89}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 95, 210, 157}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 187, 43, 158, 70, 171, 33, 205}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 152, 70, 141, 31, 221, 103, 174}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 243, 33, 81, 214, 37, 116, 228}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 211, 126}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 138, 208, 196, 178, 255}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 216, 169, 43, 121, 215, 65, 200, 82}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 26, 17, 43, 72, 37, 99, 10, 168, 98}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 254, 199, 57, 240}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 30, 64, 213, 26, 221, 132, 12, 59}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 74, 13, 197, 157, 100, 175, 194, 224}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 176, 81, 26, 37}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 7, 218, 171, 158, 176, 85, 57}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 52, 206}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 252, 122}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 82, 206}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 230, 211, 109, 58, 219, 165}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 72, 155, 98}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 17, 222, 31, 151}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 236, 182}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 132, 252, 246, 173, 253}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 132, 199, 200, 117, 150, 141}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 189, 113, 154, 76, 249}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 143, 4, 77, 201, 223, 120}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 204, 55, 76}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 41, 155, 198, 49, 25, 201}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 26, 132, 211, 6, 57, 251, 37, 211}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 158, 233}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 164, 71, 141, 193, 223}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 202, 200}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 92, 110, 137, 158, 112, 255}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 163, 167, 14, 36, 59, 58}, 141},
	{{107, 79, 18, 235, 142, 84, 80, 0, 0, 0, 0, 0, 0, 110, 197, 154}, 141},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 180, 250, 184, 27, 86, 91}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 143, 254, 149}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 195, 197, 228}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 237, 101, 21, 175, 105}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 86, 164, 92, 85, 60}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 23}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 192, 220, 99, 80}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 202, 0, 167}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 43, 96, 151, 166, 39}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 25, 217, 213, 232, 190, 106, 17}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 239, 86, 149, 133}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 184}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 35, 65, 32, 131, 169, 32}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 36, 58, 147, 71, 141, 4}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 248, 65, 211, 179, 206, 85}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 95, 236, 202, 248}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 192, 175, 60, 105, 148}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 204, 201, 176}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 192, 45}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 72, 147}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 192, 45, 131, 232, 28}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 17, 77, 199, 129, 99}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 170, 233, 63, 187}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 141, 209, 134, 233, 198}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 114}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 175, 158, 25, 163, 230, 24, 233}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 21, 243, 104, 20, 64, 129, 69}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 172, 66, 53, 209}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 176, 210, 235, 5}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 34, 125, 189}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 254}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 20, 67}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 163, 119, 83}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 122, 205, 65, 128, 233, 10, 136}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 204, 52, 24, 71}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 135, 215, 40, 133, 253, 42, 29}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 32, 167, 28, 223}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 1, 232}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 15, 195, 45, 100, 206}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 214, 82, 203, 3}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 99}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 239, 213, 185, 226, 120, 186}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 198, 119, 227, 110}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 201, 141, 27, 99}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 244}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 154}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 173, 9, 76, 225, 199, 160}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 45, 204, 81, 211}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 77, 84, 167, 164, 243, 3, 12}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 174, 47}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 169}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 152, 104, 155, 52, 188}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 179, 99, 140}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 166, 61, 219, 47, 68, 69}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 206, 9, 124, 78, 117}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 84, 158}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 27, 243, 93, 225}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 189, 22, 24}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 172, 139, 224, 173}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 14, 208, 208, 144, 211, 98}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 42, 30, 148}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 21, 161, 36}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 144, 247, 65}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 173, 12, 131, 36, 16, 200}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 247, 61}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 137, 65, 227, 212, 117}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 191}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 247, 173, 74, 168}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 51, 44, 35, 114, 105, 175, 71}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 11, 96, 90, 42, 72, 205, 83}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 196, 8, 106, 99, 151}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 86, 245, 24, 209}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 182}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 135, 172, 217, 250, 57}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 141}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 43, 152, 244}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 91, 172, 104, 36}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 164}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 81}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 36, 217, 78, 46, 137, 197}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 32}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 82}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 225, 147}, 23},
	{{247, 132, 113, 1, 215, 247, 183, 239, 128, 0, 0, 0, 0, 0, 0, 0}, 23},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 85, 160}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 115}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 1, 244}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 198}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 98, 57, 127}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 15, 18, 26}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 241, 79}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 129}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 14, 129, 101}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 17, 64}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 186}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 207, 231}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 72, 118}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 202, 75}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 79, 202, 136}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 147, 188}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 26}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 212, 68}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 203}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 28, 89, 18}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 126}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 175, 244}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 186}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 242, 217, 242}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 246, 239}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 185, 134, 190}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 238, 227}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 50}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 41, 189, 65}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 141, 189, 141}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 201, 122, 55}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 31, 205, 118}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 122, 104}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 252}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 190, 9}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 169, 168, 251}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 113, 241, 133}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 247, 119}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 71, 100}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 224}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 178, 59, 195}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 128, 203, 86}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 8, 41, 235}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 16, 197}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 123}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 165, 2}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 27, 229}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 63, 158}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 244, 44}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 125, 33}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 222, 11}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 194, 191}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 40, 252, 201}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 61, 105, 128}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 10, 26}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 188, 225}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 177, 106}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 206, 53}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 2, 22, 95}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 218}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 188, 127, 40}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 111, 158}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 195, 150, 178}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 104, 1, 27}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 222}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 50}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 0}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 33, 112}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 68, 5}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 213, 44, 7}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 8}, 252},
	{{48, 19, 41, 12, 76, 101, 114, 160, 45, 103, 134, 146, 128, 0, 0, 18}, 252},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 160, 126, 159, 189, 251, 157, 4}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 46, 99, 76, 221, 248, 157, 78}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 219, 170, 221, 145}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 140, 180, 70, 51, 253, 59, 197, 2}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 155, 17, 148, 91, 79, 55, 184, 129}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 64, 244, 22, 187, 211, 6, 167, 107, 214}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 226, 222}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 62, 16, 53, 47, 161, 159, 193}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 55, 152, 181, 157}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 28, 224, 188, 69, 120, 84}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 147, 161, 198}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 181, 228, 170, 121, 204, 247}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 237, 69, 91, 180, 38, 104, 143}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 221, 145, 208, 217}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 169, 255, 172, 182, 203}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 145, 203, 184}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 28, 160, 146}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 88, 44, 236, 84, 63, 58, 9, 66}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 17, 0, 107, 195, 141}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 7, 93, 86, 46, 8, 175, 144}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 8, 236, 137, 219, 194, 71}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 141, 240, 125, 157, 221, 143, 146, 237}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 85, 38, 93, 11, 172, 63, 240, 86, 229}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 58, 173, 12}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 27, 233, 163}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 46, 132}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 126, 16, 235, 31}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 107, 43, 144, 93, 210, 164, 155, 191}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 108, 82}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 65, 68, 116, 217, 194, 202}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 185, 168, 18, 247}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 169}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 141, 220, 223, 91}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 58}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 84, 215, 108, 189, 67}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 170, 100, 146, 135, 9, 197, 62}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 246, 171, 35, 61, 245}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 227, 50, 78, 110, 178, 238, 241}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 76, 155, 124, 238, 79, 226}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 109, 167, 163, 53, 248}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 129, 53, 219, 24, 140, 114}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 72, 128, 25, 8, 218, 90, 72}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 45, 201, 53, 254, 150, 161}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 51}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 133}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 197, 238}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 49, 91, 218, 100, 17, 119, 31}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 31, 70, 200, 125}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 8, 54, 2, 3, 81, 94, 56, 45}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 171}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 51, 69, 170, 250, 8, 85, 181}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 116, 113, 183, 163, 26, 48, 103}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 54, 136, 156, 80, 8, 30, 142, 219}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 2, 227, 102}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 46, 9, 90, 100, 125, 108, 141}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 146, 25, 220, 214, 40, 194, 156, 126}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 100, 80, 104}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 89, 169, 143, 55, 86}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 211, 229}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 133, 151}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 142, 3, 5}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 157, 253, 71, 85, 89, 23, 21, 186}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 141, 222, 11, 124, 182, 165, 184}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 79, 44, 251, 19, 23, 185, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 8, 42, 236}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 2, 237, 145, 124, 206, 41}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 229, 254, 54}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 17, 175, 208, 32, 57, 95, 161}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 208, 205, 157}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 201, 210, 111, 227, 103, 248, 54, 225, 96}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 140}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 79, 145, 224, 247, 201, 42, 134, 148}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 207, 29, 32, 157, 98, 75, 86}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 4, 111, 63, 133, 4}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 127, 116, 94, 247, 108, 197, 47, 167}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 8, 122, 204, 245, 84}, 6},
	{{5, 70, 208, 170, 19, 0, 116, 0, 0, 0, 0, 0, 149, 221, 33, 92}, 6},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 26, 202, 126, 207}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 152, 23, 119, 35, 158, 137, 196, 202, 143}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 141, 132, 60, 168, 17, 121, 48}, 137},
	{{1, 0, 0, 0, 0, 0, 47, 72, 65, 68, 107, 192, 67, 125, 110, 16}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 114, 253, 200}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 211}, 137},
	{{1, 0, 0, 189, 178, 25, 10, 102, 117, 30, 95, 106, 167, 200, 28, 4}, 137},
	{{1, 0, 0, 0, 0, 0, 183, 128, 193, 70, 212, 12, 102, 86, 239, 44}, 137},
	{{1, 0, 0, 125, 109, 248, 123, 97, 195, 100, 47, 147, 207, 150, 84, 69}, 137},
	{{1, 0, 0, 0, 0, 0, 139, 248, 221, 32, 147, 173, 186, 229, 218, 199}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 171, 228, 69, 23, 9, 182, 178, 169}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 97}, 137},
	{{1, 0, 0, 0, 65, 75, 138, 130, 29, 57, 180, 1, 52, 237, 57, 27}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 144, 100, 64, 90, 143, 215, 237, 193, 129}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 224, 36, 68, 219}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 189, 61}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 128, 6, 154, 80, 92}, 137},
	{{1, 0, 30, 6, 115, 81, 20, 120, 187, 153, 141, 64, 210, 218, 120, 213}, 137},
	{{1, 0, 0, 0, 0, 211, 23, 76, 209, 36, 48, 25, 88, 126, 100, 203}, 137},
	{{1, 0, 0, 0, 0, 57, 132, 73, 91, 128, 211, 1, 108, 85, 3, 236}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 129, 218, 58, 64, 117, 40, 112, 54, 53}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 14, 184, 56, 117, 18, 239, 211, 235, 248}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 88, 10, 30}, 137},
	{{1, 0, 0, 0, 89, 75, 149, 114, 6, 84, 63, 89, 176, 199, 1, 122}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 254, 173, 101, 204, 138, 223, 106, 17, 130}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 94, 88}, 137},
	{{1, 0, 0, 216, 224, 79, 242, 94, 39, 83, 100, 26, 79, 61, 144, 236}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 121}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 253, 48, 242, 173, 112, 71, 254}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 132}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 166, 1, 134, 96, 222}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 121, 122, 120, 70, 179}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 0, 71, 27}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 67, 195, 168, 248}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 10, 85, 132, 225, 224, 48, 196, 66, 224}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 0, 0, 165, 89, 177, 144, 198, 57, 149, 3, 56, 213}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 170, 99, 166, 123}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 141, 98, 238, 9, 251, 194, 206, 113, 158}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 47, 96, 181, 205, 139, 227, 211}, 137},
	{{1, 0, 0, 73, 32, 235, 233, 92, 184, 3, 153, 24, 250, 11, 109, 199}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 64}, 137},
	{{1, 0, 0, 0, 0, 0, 207, 158, 60, 29, 206, 104, 20, 225, 83, 176}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 17, 71, 177, 22}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 245, 245, 63, 250, 195, 139, 232}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 0, 38, 86, 59, 153, 53, 34, 16, 28, 21, 166, 22}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 143, 250, 23}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 92, 202, 187}, 137},
	{{1, 0, 0, 0, 0, 0, 155, 119, 5, 230, 144, 128, 158, 139, 92, 91}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 228, 51, 79, 161, 100, 251, 193}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 114, 229}, 137},
	{{1, 0, 0, 0, 236, 163, 225, 226, 35, 135, 122, 179, 2, 209, 67, 22}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 140, 14, 246}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 59, 61, 22, 244}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 93, 23, 80, 25, 127, 251, 17}, 137},
	{{1, 0, 0, 0, 0, 0, 183, 32, 122, 115, 142, 101, 71, 239, 197, 26}, 137},
	{{1, 0, 0, 0, 112, 236, 94, 178, 254, 201, 120, 240, 93, 58, 37, 230}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 219, 173, 97, 3, 113, 227, 248, 23, 55}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 164}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 34, 106, 69, 113, 66}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 155, 129, 254}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 199, 174, 52, 243}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 107, 174, 63}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 98}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 84, 180, 49, 188}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 172, 185, 175}, 137},
	{{1, 0, 0, 0, 243, 49, 203, 199, 69, 222, 234, 170, 16, 224, 37, 244}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 201, 135, 156, 109}, 137},
	{{1, 0, 0, 0, 0, 107, 220, 206, 41, 70, 187, 178, 64, 79, 165, 74}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 85, 254, 68, 224, 11, 104, 189}, 137},
	{{1, 0, 0, 168, 8, 62, 41, 41, 240, 178, 229, 191, 176, 41, 216, 180}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 241, 253, 37, 46, 120, 224, 16, 201, 40}, 137},
	{{1, 0, 0, 0, 217, 48, 2, 246, 191, 226, 2, 7, 92, 202, 140, 97}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 179, 176, 24, 142, 178, 34, 227}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 13}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 244, 208, 190, 159, 253}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 255, 23, 255, 213, 17, 98, 30, 216}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 132, 173, 193, 251, 1, 247, 226, 5, 122}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 47, 138, 17, 100, 255, 113, 65, 244, 171}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 3, 231, 31, 102, 71, 143, 82}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 137},
	{{12, 188, 26, 18, 0, 0, 0, 93, 161, 248, 97, 91, 37, 42, 217, 30}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 110, 145}, 9},
	{{12, 188, 26, 18, 0, 0, 63, 201, 143, 114, 238, 32, 35, 120, 248, 32}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 57}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 54, 246, 15, 248, 250, 117, 149}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 238}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 224, 218, 62, 128}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 116, 253, 85, 230, 75}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 119, 204, 207, 183}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 173, 19}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 51, 242, 8, 150, 198, 58, 26, 87, 111}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 50, 155, 108, 136, 144, 37, 189}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 87, 33, 71, 231, 3, 172, 210}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 156}, 9},
	{{12, 188, 26, 18, 0, 0, 199, 31, 235, 22, 225, 103, 213, 204, 205, 221}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 221, 33, 255, 15, 196, 35, 16}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 17}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 87, 5, 38, 162, 165, 64, 106, 75}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 117, 228, 19, 79}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 71, 69, 245, 231, 180, 182, 134, 131}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 90, 175, 31, 58, 38, 78, 110, 247, 249}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 230, 197, 182, 6}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 220, 216}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 40, 154, 3, 60, 162, 26}, 9},
	{{12, 188, 26, 18, 0, 136, 172, 244, 138, 85, 113, 233, 232, 37, 166, 216}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 207, 237, 92, 110, 61, 179, 200, 112, 252}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 253, 51, 122, 208, 149, 57}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 84}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 4, 176}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 122, 85, 227, 147}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 239, 60, 217, 221, 120, 118, 47, 87}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 249, 62, 128, 243, 87, 201, 243, 70}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 241, 196, 119, 39, 85, 219, 54, 171}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 238, 6, 178, 142, 14, 82, 79}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 13, 188, 112, 82, 83, 172, 217, 180}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 29}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 130, 247}, 9},
	{{12, 188, 26, 18, 0, 0, 97, 234, 171, 195, 79, 18, 108, 13, 192, 234}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 112, 167, 68, 166, 243}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 170, 251, 211, 241, 153, 195, 39, 41}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 3, 90, 149, 113}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 132, 117, 27, 33, 79, 38, 113, 200, 96}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 84, 233, 80, 148, 92}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 177, 179, 127, 13, 157}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 166, 247}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 67, 206}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 219, 74, 218, 247, 117, 241, 158, 74}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 27, 220, 38, 200}, 9},
	{{12, 188, 26, 18, 0, 0, 45, 20, 19, 140, 74, 81, 2, 247, 16, 207}, 9},
	{{12, 188, 26, 18, 0, 0, 28, 202, 227, 156, 60, 230, 225, 21, 70, 236}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 176, 115, 138, 176, 207, 101, 247, 250}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 253}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 241, 80, 73, 176}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 170, 119, 248, 161, 12, 114, 49, 44, 172}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 140, 107, 83, 230, 115, 156, 220}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 165, 152, 42, 175, 140, 162}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 140, 83, 84, 57}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 159, 61, 46, 112}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 32, 53, 67, 63, 181, 231}, 9},
	{{12, 188, 26, 18, 0, 46, 84, 44, 231, 151, 9, 8, 184, 2, 77, 55}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 148, 150, 51, 36, 219, 75, 212, 81, 125}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 184, 110, 82, 210, 227, 2}, 9},
	{{12, 188, 26, 18, 0, 0, 52, 209, 95, 150, 123, 249, 125, 28, 215, 126}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 81, 193, 83, 204, 35, 252}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 82}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 248, 152}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 250, 123, 201, 37, 238}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 113, 150, 22, 94, 76, 9}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 199, 87}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 161}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 42, 67, 161, 227, 142, 23, 218}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 150, 51}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 188, 67, 17, 199, 92, 24, 232}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 154, 35, 64, 251}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 11, 97, 167, 5, 134}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 56}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 17, 53}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 184, 216, 5, 159, 164}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 9},
	{{12, 188, 26, 18, 0, 0, 1, 20, 241, 26, 48, 129, 12, 232, 243, 126}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 51, 131, 13, 52, 111, 59, 105}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 135, 118}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 124, 5, 132, 241}, 9},
	{{12, 188, 26, 18, 0, 206, 163, 116, 153, 252, 1, 168, 241, 64, 255, 60}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 147, 6, 197, 143}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{12, 188, 26, 18, 0, 0, 195, 232, 192, 182, 32, 169, 17, 149, 10, 62}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 179, 35, 234, 55, 233}, 9},
	{{12, 188, 26, 18, 0, 33, 236, 106, 253, 166, 10, 229, 21, 11, 76, 77}, 9},
	{{12, 188, 26, 18, 0, 0, 0, 0, 0, 0, 0, 88, 38, 206, 100, 108}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 33, 229}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 10, 125, 12, 76, 74}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 160}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 238, 95, 240, 9, 139}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 111}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 82}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 175, 126, 253, 232, 24}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 171, 234}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 84, 97}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 80, 83, 173, 11}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 166}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 16, 166}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 83, 20, 135}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 144, 42, 61}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 35, 26, 213}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 150, 175, 249}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 103, 113, 52, 222, 56}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 19, 68}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 27, 100, 253, 67, 91}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 210, 39, 96, 229}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 25, 65}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 84, 46}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 40}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 66, 251, 254, 189}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 172, 237}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 142, 216}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 244, 28}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 14}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 158, 253, 73}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 24, 201, 252, 179}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 161, 31, 77, 132}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 79, 60}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 252}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 252}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 63, 50}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 215, 206, 4}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 115}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 42}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 143}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 70, 110, 237}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 3, 136}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 51, 130, 116}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 114, 207}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 38}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 16, 125, 162}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 157, 83, 181, 171}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 154, 160, 39, 134, 138}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 129, 96}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 205}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 85, 200, 142, 196, 175}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 43, 194}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 132, 63}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 187, 126, 44, 86, 42}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 78, 225}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 210, 12, 64, 129, 108}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 238, 116, 68, 82, 239}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 167, 159}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 115}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 243, 67, 14, 23, 211}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 5}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 226, 245, 27}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 118, 190}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 231, 96}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 94, 81, 16}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 235, 43}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 30}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 43, 148, 70, 17}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 209, 187, 145}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 247, 68, 69}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 36, 22, 59, 234, 236}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 0}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 222, 108, 195}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 249, 183, 52}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 29}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 50, 198}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 70, 155}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 45, 7, 54, 237}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 68, 206, 54}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 118, 235, 86, 82, 8}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 107, 110, 247, 59}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 253, 175, 14, 116, 121}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 28}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 51, 193}, 9},
	{{1, 235, 101, 202, 26, 92, 23, 22, 179, 223, 128, 0, 0, 0, 0, 64}, 9},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{215, 19, 224, 102, 45, 133, 102, 249, 56, 20, 214, 219, 93, 125, 52, 0}, 163},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 190, 251, 174, 110, 15}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 113, 244, 191}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 223, 20, 210, 31}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 109, 68, 76, 246, 147}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 53, 240}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 180, 79, 203, 43}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 123, 145}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 143, 8, 213, 179}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 123, 59}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 135, 92, 201, 156, 65}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 246, 164, 69}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 159, 240, 85}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 173, 232, 162, 228, 254}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 163, 57}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 143, 17, 110, 47, 163}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 216, 243}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 45, 126, 104, 109, 55}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 22, 23}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 182}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 73, 41, 155, 208, 57}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 225, 53, 88, 117}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 4}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 157, 62, 233, 3}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 26}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 204, 187, 64}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 25, 194, 192, 108}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 225, 94, 61, 171, 221}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 183}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 76, 231}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 74, 177, 241, 27}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 237}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 226, 212, 18}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 108, 218}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 44, 213, 77}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 167, 218, 188, 75, 241}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 119, 70, 77, 168, 212}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 227, 152, 188, 7}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 216, 110}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 75, 233}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 97, 198, 118, 156, 155}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 124, 51, 144, 180, 189}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 233, 185, 247, 186, 98}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 23, 100}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 211, 90}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 229, 150, 170}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 34}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 192, 230, 104}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 158, 190, 169}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 243}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 38, 227, 66, 102}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 128, 170, 96}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 203, 105}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 110, 209, 243, 123}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 208}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 197, 75, 214}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 162, 21, 252}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 221, 235, 170}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 253, 204, 21, 233}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 102, 118, 218}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 10, 27, 106, 60}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 112, 250, 224, 169}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 253, 149}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 171}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 157}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 60, 151}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 204}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 237, 99}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 42, 240, 154}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 248, 10, 14, 47, 135}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 213, 115}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 205}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 197, 117, 30, 30}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 5, 238}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 22, 144, 186}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 104, 44, 246, 190, 235}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 18, 115, 87, 63, 240}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 0}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 53, 18, 115, 79}, 197},
	{{178, 183, 109, 64, 136, 84, 11, 53, 217, 102, 0, 0, 0, 0, 0, 93}, 197},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 24, 248, 47}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 163, 46, 109}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 88, 248, 245, 194, 198, 156, 1}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 4, 219, 136}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 234, 73}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 90, 46, 243, 239, 104, 46, 174}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 167, 90, 13, 106}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 228, 191, 24}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 178, 120, 230, 253, 195, 173, 127}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 77, 145, 138, 12}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 69, 242, 182, 193}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 217, 167, 201, 86, 197, 198}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 43, 250, 5, 49, 22, 15, 54}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 14, 78}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 214, 48, 227, 130}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 137, 174, 87}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 171, 87, 246}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 99}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 220, 198, 99, 108, 166, 85, 138, 192}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 213, 43, 241, 252}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 251, 21}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 116, 234, 81, 30, 20, 11, 111, 246}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 88, 55, 194}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 7, 134}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 140, 232, 134, 17, 127, 175, 103}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 112, 131, 233, 65, 121}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 55, 162}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 212, 84, 213, 114, 105, 95}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 1, 238, 169, 5}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 162, 230, 56, 155, 128, 52, 124, 196}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 214, 32, 120}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 50, 110}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 144, 139}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 25, 147, 39, 67, 71, 117, 20, 15, 194}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 156, 53, 128, 47}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 34, 71, 79, 166}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 112, 239, 57, 139, 240, 227}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 188, 113, 172, 56}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 39, 249, 145, 67, 95}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 82, 31, 76}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 134, 26, 122, 13, 187, 1, 209}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 90, 28, 191, 92, 88, 57, 15, 4}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 208, 153, 100, 77}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 59, 1, 219, 220, 221}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 123, 119, 153, 40, 187, 135}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 171}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 212}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 110, 54, 33, 124, 240, 168, 84}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 32, 242, 127, 199, 71, 34, 189, 41}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 254, 96, 31, 217, 163, 67, 1}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 21, 238, 228}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 10, 70, 13, 250}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 153, 26, 78, 210, 24, 108, 211, 165}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 137, 32, 128, 233, 57, 229, 237}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 5, 201, 187, 193, 240, 237, 115}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 128, 244, 245, 59, 201}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 74}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 112, 7, 236, 231, 7, 195, 80}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 237, 226}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 219, 187, 29}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 101, 2}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 249, 163, 87, 39, 75, 130, 92, 221}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 24, 161, 209, 215}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 137}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 129, 85}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 143, 178, 19, 73, 151, 95, 149, 191}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 8, 94}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 206, 221, 26, 186}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 87, 106, 187, 79, 50, 113, 185}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 147}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 21}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 150, 85, 238, 30, 16, 236, 128, 71}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 101, 83, 33, 241, 154, 215, 103}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 64, 106, 57}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 226, 225, 218, 69, 238, 109, 194}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 191, 255, 215, 29, 119, 244, 67}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 125, 127, 201, 34, 196, 41, 194}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 86, 85, 195}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 0, 0, 0, 75}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 212, 168, 223, 95, 209, 150}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 175, 55, 27, 235, 255, 208, 89}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 0, 0, 0, 6, 227, 129, 112}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 6, 23, 2, 89, 157, 118, 146, 15}, 249},
	{{212, 39, 158, 71, 253, 98, 248, 0, 0, 90, 74, 63, 194, 210, 94, 187}, 249},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 169, 181, 122}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 238, 211, 206, 190, 144, 21}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 57, 23, 41, 202, 141}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 79, 210, 49}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 133, 176, 79, 92, 247, 51, 93, 154, 32}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 148, 190, 220, 172, 121, 26, 18, 48}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 88, 66, 221}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 139, 88, 12, 248, 0, 234, 217, 235}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 154, 165, 152, 85, 90, 70, 90, 132}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 239, 101, 78, 173, 50, 240, 187, 187}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 13, 152, 244, 245, 144, 2, 58}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 236, 55, 0}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 44, 117, 194, 211, 177, 130, 55, 189}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 122, 129, 203}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 79, 96, 164, 207, 122, 88, 78, 150, 43}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 40, 183, 247, 255, 84, 41}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 212, 14, 15, 120, 147, 199, 104}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 102, 251, 188, 254, 185}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 28, 176, 254, 240, 251, 164}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 215, 26, 94, 185}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 35, 87}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 182, 58, 81, 54, 176}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 57, 117, 119}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 42, 126, 68}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 53, 82, 116, 3, 170}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 83, 203, 238, 201, 55, 168, 132, 225, 251}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 252, 138, 129, 93, 234, 247, 3, 248, 171}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 15, 5, 78, 39}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 212, 117, 32}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 64, 17, 166, 167}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 153, 83, 29, 161, 94, 12, 8, 18}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 148, 46}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 184, 40, 246, 99}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 218, 166, 147, 79, 246, 219, 153, 192, 212}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 71, 206, 209}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 187, 213, 150, 147, 241, 125, 68}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 247, 118, 241, 110, 84}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 226, 232}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 69, 40, 210, 243, 220, 78}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 29, 131, 209, 206, 94, 117}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 116, 44, 138, 102, 240}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 248, 244, 85, 117}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 217, 93, 58, 25, 14, 235, 161, 11}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 238, 89, 46, 31, 173}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 112, 9}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 222, 176, 227, 236, 241}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 95, 47, 62, 144}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 122, 38, 19, 138, 241}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 122, 166}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 121, 118, 226, 169, 26, 141, 62, 35, 54}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 186, 102, 135, 194, 198, 35}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 168, 66}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 18, 128, 139, 93, 195, 104, 120, 152, 112}, 88},
	{{92, 58, 159, 130, 105, 56, 202, 125, 96, 25, 143, 200, 105, 87, 149, 15}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 33, 112, 114, 219, 219, 85}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 176, 153}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 64, 207, 67, 41, 72}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 207, 99, 42, 112, 177, 104, 233, 171, 82}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 206, 49, 46, 244}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 120, 77, 245, 40, 41, 123, 107}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 170, 241, 93, 144, 160, 238}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 13, 223, 170, 153}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 189, 240}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 112, 115, 129, 203, 173, 17, 116, 215}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 101, 89, 205, 229, 212, 193}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 2, 191}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 93, 114}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 120, 8, 34, 170, 74, 205, 169, 11}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 158, 177, 209, 154, 229, 45, 222, 215}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 174, 242, 167, 137}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 120, 121}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 148, 247, 65}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 47, 100, 159, 254, 236, 253, 70, 103, 56}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 75, 123, 63, 243, 216, 167}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 146, 51, 212, 65, 109}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 227, 135, 210, 10, 200, 9}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 175, 108, 42, 233, 99, 26}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 88},
	{{92, 58, 159, 130, 105, 56, 196, 7, 105, 44, 65, 96, 41, 197, 56, 30}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 146, 228, 128, 81, 7, 129, 4, 85}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 130, 228, 104, 152}, 88},
	{{92, 58, 159, 130, 105, 56, 0, 0, 0, 0, 0, 0, 0, 0, 80, 96}, 88},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 17, 211, 249, 68, 140, 53, 97, 115, 111}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 75}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 132, 246}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 220, 51, 254, 225, 199, 251, 158}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 211, 145, 24, 37, 139, 184}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 126, 198, 100}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 41, 229, 77, 253, 60, 204}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 13, 114, 134, 126}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 38, 123, 241, 147, 195, 152, 23}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 200, 61, 0, 96, 35, 219}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 107, 250, 123, 9, 240, 236, 47, 126, 239}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 205, 110, 185, 253, 4}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 193, 240, 91, 56, 37, 91}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 151, 194, 45}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 12, 11, 219}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 67, 77, 93}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 249, 71, 182, 1, 231}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 198, 2, 225, 76, 237, 89, 244}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 253, 198}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 32, 218, 210, 43, 228, 171, 112, 159}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 217, 91, 189, 37}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 156, 5, 100, 232, 141, 218}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 70, 52}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 94, 117, 0, 241, 152}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 236, 191, 125, 184, 32}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 125, 142, 123}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 161, 116, 11, 205, 169}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 3, 152, 206, 54, 121, 63, 145, 7}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 155, 116, 246, 207, 25, 48, 220, 53}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 210, 46, 85, 43}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 141, 160, 72, 246, 132}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 201, 134, 133, 162, 76, 11, 185, 26}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 38, 95, 120, 233, 178, 124, 146, 193, 172}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 77, 36, 104, 242}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 160, 230, 203, 149, 49, 187, 245}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 120, 189}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 39, 246}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 152, 106, 36, 219, 19, 228}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 208, 80, 142, 236}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 57, 45}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 19, 253, 185, 113, 11, 32, 156}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 225, 71}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 235, 151, 132, 162, 161, 252, 76}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 177, 110, 171, 135, 149}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 192, 115}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 211, 12, 81, 200, 212, 235, 101, 83, 221}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 144, 137, 203, 255, 40, 65}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 247, 222, 145, 26, 152, 78, 166, 189, 111}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 67, 37}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 116, 163, 12, 119, 78, 129, 204, 226, 193}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 151, 114, 253, 17, 29, 38}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 41, 209, 195, 244, 70, 56, 22, 113}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 5, 125, 198, 106, 137, 125, 40, 132}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 213, 72, 145, 159, 88, 42, 162, 65}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 173}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 73, 124, 52, 54, 73}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 214, 225, 255, 231, 253}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 175, 144, 132, 64, 116, 181, 56, 142}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 255, 33, 35, 56}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 17, 45, 201, 89, 211, 72, 100, 183}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 103, 151, 216, 197, 4}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 6, 141, 50, 51, 202, 163, 210, 244}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 164, 63}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 152, 184, 101, 58}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 209, 178, 139, 125}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 21, 104, 233, 212, 106, 253, 187, 74}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 50, 184, 13, 9}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 15, 149}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 224, 48, 245, 249, 1, 125, 146, 167}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 185}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 213, 9, 13, 170, 169, 26}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 250, 79, 132}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 180, 211, 157, 92, 186, 126, 86}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 2, 0, 31, 11, 185, 23, 223, 37}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 57, 126, 57, 212}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 115, 151, 11, 223, 254, 166}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 10, 151, 181, 177}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 129, 89, 174, 49, 235}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 130, 180, 20, 217}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 196, 49, 67, 9, 73, 222, 42}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 76, 214, 168}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 0, 0, 0, 0, 99, 105}, 104},
	{{118, 140, 65, 198, 212, 93, 144, 0, 0, 0, 35, 6, 57, 185, 234, 4}, 104},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 46, 103, 232, 6, 22, 12}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 27}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 193, 175, 170, 235, 210, 189, 247}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 151, 130, 211, 190, 104, 51, 128}, 36},
	{{86, 64, 0, 50, 237, 255, 240, 48, 176, 208, 192, 155, 27, 146, 247, 55}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 210, 134}, 36},
	{{86, 64, 0, 0, 193, 143, 112, 130, 185, 133, 145, 43, 251, 228, 162, 94}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 146, 192, 56, 77, 97, 210, 215, 202, 169}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 118, 64, 8, 22}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 81, 35}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 220, 12, 142, 255, 243, 221, 96, 57}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 221, 107, 108, 63, 39, 164, 122, 7}, 36},
	{{86, 64, 0, 0, 0, 132, 209, 112, 167, 176, 187, 37, 105, 96, 222, 30}, 36},
	{{86, 64, 0, 0, 34, 84, 158, 243, 232, 78, 217, 210, 8, 225, 71, 71}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 209}, 36},
	{{86, 64, 0, 0, 0, 238, 85, 22, 118, 145, 239, 186, 140, 221, 189, 125}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 71, 111, 79, 240, 61, 72}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 190, 232, 3, 222, 218, 0, 41}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 84, 63, 237, 22}, 36},
	{{86, 64, 0, 0, 0, 0, 18, 80, 41, 148, 78, 176, 162, 130, 66, 108}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 144, 136, 39, 227}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 21, 232, 16, 179, 205, 154}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 136, 245, 241, 142, 4, 31, 57, 170}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 194, 48, 232, 23, 160, 114, 55, 140}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 138}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 50, 120, 252, 4, 140, 59, 170}, 36},
	{{86, 64, 0, 0, 173, 237, 124, 128, 32, 40, 153, 137, 215, 147, 1, 91}, 36},
	{{86, 64, 0, 195, 93, 210, 55, 63, 163, 123, 238, 46, 85, 109, 125, 206}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 236, 182}, 36},
	{{86, 64, 0, 0, 0, 0, 231, 116, 153, 74, 239, 241, 2, 39, 192, 97}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 84, 172, 106, 109}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 59, 125, 163, 216, 132, 241, 245, 95}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 206, 78, 177}, 36},
	{{86, 64, 0, 0, 224, 59, 179, 30, 217, 123, 153, 222, 126, 150, 139, 194}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{86, 64, 0, 0, 0, 5, 215, 54, 151, 52, 215, 198, 236, 1, 111, 230}, 36},
	{{86, 64, 0, 0, 213, 199, 96, 15, 253, 154, 240, 35, 203, 86, 65, 123}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 144, 180, 231, 192, 91, 161, 22, 206, 189}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 162, 30, 185, 131, 182, 102, 105, 21, 2}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{86, 64, 28, 161, 250, 206, 50, 52, 72, 97, 141, 71, 16, 109, 183, 168}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 99}, 36},
	{{86, 64, 70, 199, 173, 6, 48, 156, 176, 164, 249, 232, 229, 76, 65, 113}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 156}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 144, 42, 179, 64, 141, 54}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 2}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 121, 151, 210, 55, 93, 239, 214, 18, 22}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{86, 64, 0, 0, 0, 63, 175, 137, 42, 4, 218, 83, 221, 213, 147, 115}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 111, 164}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 66, 148, 115, 134}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 76, 192, 141, 117, 126, 69, 198, 135, 72}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 156, 199, 195, 48, 165, 109, 231, 13, 61}, 36},
	{{86, 64, 0, 16, 128, 127, 164, 248, 164, 201, 53, 64, 216, 140, 203, 13}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 188, 242, 180, 177, 226, 94}, 36},
	{{86, 64, 0, 201, 107, 91, 91, 11, 168, 51, 157, 254, 183, 160, 201, 59}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 42, 42, 33, 162, 159, 89}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 1, 143}, 36},
	{{86, 64, 183, 47, 122, 128, 213, 138, 163, 167, 131, 127, 21, 119, 166, 139}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 86, 169, 119, 29, 33, 251}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 236, 115, 228, 181, 161, 61, 24, 82, 32}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 193, 198, 3}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 18, 238, 17, 96, 63, 98, 205, 161, 48}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 226, 89, 68, 176, 66, 136, 190, 146, 239}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 76, 171, 103}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 132}, 36},
	{{86, 64, 0, 0, 0, 0, 11, 148, 35, 184, 176, 234, 227, 177, 132, 164}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 132, 242, 173}, 36},
	{{86, 64, 0, 0, 29, 240, 144, 20, 243, 27, 72, 183, 169, 32, 157, 88}, 36},
	{{86, 64, 0, 0, 225, 81, 10, 194, 212, 13, 21, 205, 47, 18, 243, 129}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 144, 100, 70, 61}, 36},
	{{86, 64, 0, 0, 181, 118, 214, 198, 173, 167, 4, 28, 95, 191, 67, 240}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{86, 64, 0, 212, 134, 168, 52, 41, 95, 242, 189, 26, 128, 78, 214, 52}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{86, 64, 0, 0, 93, 70, 120, 21, 83, 1, 78, 38, 24, 162, 67, 29}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 196, 145, 231, 44, 141, 187, 145, 90, 222}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 112, 82, 253, 233, 162, 238, 205, 7}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 86}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 121, 172, 168, 230, 200, 98, 192, 109}, 36},
	{{86, 64, 0, 76, 66, 150, 107, 41, 6, 186, 221, 150, 29, 2, 242, 202}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 141, 27}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 5, 19, 50, 31}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 23}, 36},
	{{86, 64, 73, 42, 126, 207, 187, 72, 14, 52, 238, 1, 29, 103, 131, 126}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 69, 157, 202, 12, 66, 16, 94, 229, 161}, 36},
	{{86, 64, 248, 105, 187, 184, 51, 201, 20, 71, 178, 122, 234, 76, 224, 130}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 161, 176, 10, 145, 129, 10, 233}, 36},
	{{86, 64, 0, 0, 0, 0, 0, 0, 0, 141, 156, 66, 249, 240, 166, 184}, 36},
	{{86, 64, 0, 0, 0, 0, 122, 187, 111, 66, 134, 182, 178, 45, 71, 3}, 36},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 47, 73, 60, 100, 211, 198}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 195, 168, 141, 165, 96, 67, 83, 67}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 230, 71, 77, 38, 245, 220}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 36, 195, 149, 235, 218}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 205, 157, 26, 83, 146, 191}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 79, 151, 245, 208}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 142, 29, 207, 76, 96, 228}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 148, 173, 251, 39, 32, 9, 201}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 170, 201}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 82, 206}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 137}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 164, 100, 129, 63, 87, 10, 147}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 32, 4, 17, 67, 61, 103}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 112, 214, 51, 114, 154, 63, 28, 125, 71}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 195, 10, 42, 220, 179}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 113, 247, 186, 172}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 114, 34}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 159, 218}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 244, 98, 142, 34}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 104, 87, 115, 250, 142, 244, 192}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 242, 124, 225, 166, 190}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 199, 173, 45, 120, 145, 208, 229}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 39, 153, 62, 54, 152, 165, 167}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 3, 38, 166}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 165, 148}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 239, 13, 32}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 196, 167, 14, 93, 14, 58, 190}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 236, 140, 60, 117, 184}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 1, 194, 195, 227, 98}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 137, 224, 238, 246, 191}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 243, 154, 142}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 91, 20, 39, 88, 42, 154, 131}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 89, 107, 4, 151, 152}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 17, 195, 94, 107, 239}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 190, 103, 192, 111, 8, 144}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 113, 234, 156, 4}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 133, 182, 178, 197, 145, 49, 15, 158}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 131, 255, 236, 173, 108}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 32, 159, 24, 104, 119}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 176, 78}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 216, 150}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 193, 197, 11}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 234, 44, 230, 42, 223, 31}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 38, 81, 8, 127, 118, 208}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 42, 73, 234, 185, 247, 166, 117, 135}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 210, 232, 97}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 30, 42, 254, 120, 144, 174, 138, 108}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 105, 36, 174, 118, 228, 35, 52, 57}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 76, 104, 177, 145, 78, 79, 87}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 245, 206, 14}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 182, 161, 128, 231, 37}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 181, 147, 129, 6, 139, 94, 58, 39}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 81, 147, 65, 176, 155, 113}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 165, 195, 227, 132}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 86, 39, 123, 106}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 29, 146}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 139, 153, 255}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 133, 70, 138, 221}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 132, 180, 202, 136, 57, 234}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 108, 13, 61, 41, 222, 70, 134, 13}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 177, 145, 112, 224, 100, 174}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 49, 56, 168, 139, 40, 208, 212}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 97, 234, 32}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 200, 138, 116, 230, 157, 36, 223, 252, 68}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 239, 153, 94, 146}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 175, 127, 166, 183}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 84, 96}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 211, 219, 96, 181}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 125, 226, 235, 186, 79, 50, 71}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 156, 187, 181, 208, 139, 193}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 105, 204, 77, 160, 175, 73}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 4, 162, 242}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 175, 232, 49, 38, 179}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 21, 145, 108, 248, 123}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 112, 182, 171, 156}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 102, 143, 51, 175, 192, 122, 173}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 10, 245, 197, 231, 186}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 32, 132, 93, 176, 102, 158, 72, 94}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 70, 8}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 2, 19, 43, 245, 58, 147, 175}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 141, 32, 112, 223, 9, 70, 36, 13}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 193, 187, 236}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 67, 194, 24, 73, 202, 148, 168}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 25, 211, 112, 112, 188, 42}, 239},
	{{79, 135, 242, 193, 197, 11, 200, 0, 0, 0, 0, 0, 0, 0, 106, 142}, 239},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 12, 32}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 145, 143, 97, 204, 109, 78, 25}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 46, 249, 217, 44, 24}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 94, 94, 192, 222, 94, 107}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 244, 246, 119, 176, 57, 164, 82}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 235, 140, 30, 201, 225}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 118, 109, 242}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 78, 206}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 16, 35, 232, 61, 76, 155, 69}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 176, 64, 128}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 165, 232, 34}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 29}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 160, 114}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 158, 35}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 69, 26, 129, 227, 172}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 89, 187, 195, 69, 28, 190}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 41}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 70, 166, 83, 142, 191}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 161, 183, 155, 92}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 85, 81, 128, 220, 88}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 151, 249, 46, 10, 137}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 54, 60, 51, 190, 72}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 187, 229, 225, 141, 192, 117, 192}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 198, 30, 156, 228, 50, 129, 22}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 37}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 174, 221, 2, 114, 55}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 144, 182, 183}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 191, 69, 157}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 38, 106, 34}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 241, 191, 98, 32, 143, 182}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 214, 239, 190, 179, 104}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 144, 185}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 68, 7, 72, 126}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 230, 187, 33, 75, 71, 167}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 183, 193, 162, 149, 50, 211}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 19, 216, 61, 17, 222}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 59, 32, 122}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 8, 74, 136, 52, 1}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 94, 12, 99, 123, 153, 174}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 232, 50, 97, 245, 150}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 34, 108, 10, 143, 177}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 170, 157, 30, 43, 94, 157, 169}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 111, 89, 96, 108, 188, 138, 100}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 4, 95, 165, 138, 39}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 224, 152, 32, 90}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 128}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 37}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 230, 53, 230, 229, 246, 40, 67}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 222}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 72, 161}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 105}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 196}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 174, 47, 226, 101}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 43, 100, 180, 22, 75}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 241, 145, 92, 226, 32}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 58, 203, 10}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 240, 207, 11, 167, 173}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 5, 119}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 24, 177, 217, 254, 8}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 39, 31}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 101, 211, 111, 210, 120, 149}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 245, 234}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 107, 158, 35, 51}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 248, 14, 141, 12, 79}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 163, 5}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 66, 41, 40, 175, 160, 226, 119}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 105, 122, 16, 4, 17, 149}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 143}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 190, 226, 14, 250, 154}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 175, 224, 127, 74, 148}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 90, 176}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 135, 42, 62, 137}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 58, 244, 81, 165, 231, 225}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 0}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 139, 2, 104}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 34, 163}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 34, 240, 92, 61, 150}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 0, 132}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 38, 184, 214}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 89, 123, 39, 116, 226, 194, 170}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 0, 0, 0, 0, 155, 190}, 201},
	{{163, 228, 239, 80, 41, 66, 176, 176, 0, 0, 239, 31, 226, 173, 86, 174}, 201},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 230}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 216, 129}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 145, 67, 23, 248, 188, 207}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 106, 247}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 8, 41, 133, 113, 221, 204}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 56, 68, 146, 56, 16, 219, 107, 115}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 156, 104, 158, 70, 166, 73, 215, 84, 162}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 141, 155, 93, 140}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 230, 40, 40, 205, 204, 58, 241, 227, 177}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 25}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 132, 154, 116, 46, 176}, 94},
	{{31, 9, 231, 42, 0, 0, 53, 3, 127, 32, 234, 114, 182, 56, 9, 198}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 133, 39, 107, 33, 244, 86, 201, 26, 112}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 2}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 56, 139, 250, 208, 28, 82, 252, 216, 28}, 94},
	{{31, 9, 231, 42, 0, 0, 100, 215, 171, 242, 68, 124, 87, 30, 54, 99}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 59, 154, 248, 191, 31, 169}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 217}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 78, 154}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 11, 136, 106, 218, 215, 248, 242}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 45, 232, 77, 158, 151}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 191, 223, 83, 230, 51, 1, 107}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 121, 185, 154, 46, 31, 9, 237, 18}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 144, 105, 186, 233}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 156, 137, 12, 119, 41}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 244, 105, 2, 109, 88, 4, 31, 78, 219}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 229, 240, 151, 10, 67}, 94},
	{{31, 9, 231, 42, 0, 158, 55, 20, 87, 9, 144, 226, 63, 114, 88, 228}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 204, 92}, 94},
	{{31, 9, 231, 42, 0, 0, 166, 140, 220, 64, 41, 136, 213, 47, 154, 167}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 157, 172, 70, 28, 181, 174}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 170}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 36}, 94},
	{{31, 9, 231, 42, 0, 0, 169, 234, 178, 13, 156, 249, 113, 45, 71, 176}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 107, 159, 52, 1}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 197, 218, 23, 60}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 120}, 94},
	{{31, 9, 231, 42, 0, 0, 33, 49, 7, 90, 0, 226, 231, 248, 20, 200}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 222}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 193, 220, 112, 81, 83, 214, 42, 230}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 56, 118, 183, 208, 119, 248, 213, 130}, 94},
	{{31, 9, 231, 42, 0, 0, 210, 61, 50, 40, 86, 159, 0, 31, 250, 156}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 119, 135, 78, 17, 11, 0, 48, 247, 69}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{31, 9, 231, 42, 0, 0, 189, 251, 27, 205, 253, 206, 47, 208, 242, 3}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 243}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 18, 15, 149, 26, 78, 243, 67}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 113, 148, 184, 85, 145, 107, 68, 106}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 172, 117, 6, 208, 54, 72}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 191, 172, 159, 66}, 94},
	{{31, 9, 231, 42, 0, 94, 70, 17, 160, 1, 60, 93, 17, 194, 73, 182}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 121, 47, 94, 10, 24, 57, 111, 4}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 121, 115, 225, 210}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 34, 215, 168, 55, 202, 65, 121, 129}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 106, 138, 247, 152, 254}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 8, 114}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 172, 164, 232, 105, 108, 151, 133, 67, 120}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 150, 1}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 200, 63, 131, 198, 220, 30, 164}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 40, 164, 73, 119, 90, 205, 172}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 47, 199, 189, 91, 143, 81, 253, 229, 0}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 35, 112, 68, 107, 227, 161, 214, 181}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 219, 78, 217, 42, 99, 81, 13}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 152, 144}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 219}, 94},
	{{31, 9, 231, 42, 0, 181, 180, 57, 252, 219, 155, 61, 229, 26, 160, 203}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 74, 194}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 54, 82, 208, 19, 237, 69}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 196, 227, 97, 63, 54, 49, 77, 66, 74}, 94},
	{{31, 9, 231, 42, 0, 0, 160, 246, 94, 99, 116, 53, 101, 186, 170, 183}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 181, 109, 250, 196, 114, 154, 244}, 94},
	{{31, 9, 231, 42, 0, 0, 131, 235, 211, 229, 9, 240, 242, 167, 148, 43}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 127, 231, 229, 253, 93, 8, 85, 110}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 61, 136, 213, 189}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 251, 112}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 224, 5}, 94},
	{{31, 9, 231, 42, 0, 0, 187, 115, 188, 59, 175, 121, 55, 91, 163, 140}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 145, 106, 54, 83, 89, 198, 75, 167, 193}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 132, 88, 43, 94, 86, 202, 53, 218}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 143, 188, 141, 63, 157, 41, 244, 182, 147}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 34}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 156, 89, 97, 0}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 236, 31}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 62, 159, 10, 112, 143}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 86, 133, 214, 112, 47, 52, 191, 1}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 214, 153, 246, 46, 146}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 57}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 110, 52, 186, 32, 254, 73, 207, 2, 53}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 0, 0, 0, 0, 0, 160, 147, 37, 161}, 94},
	{{31, 9, 231, 42, 0, 0, 0, 230, 32, 236, 121, 136, 10, 127, 138, 137}, 94},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 94, 142, 154, 19, 204, 114, 205}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 115, 71, 107, 3, 18, 249, 158, 159, 89}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 127, 246}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 3, 169, 59, 202, 191, 63, 78, 66, 241}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 90, 26, 225, 87}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 213, 215, 122, 56, 253}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 15, 10, 113, 136, 183}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 193, 9, 234, 62, 155, 121, 49, 162}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 50, 50}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 35, 187, 19, 41, 248, 62}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 20, 62}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 192, 228}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 11, 51, 199, 180, 239, 91, 249, 198, 112}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 168, 237}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 40, 230, 151, 242, 54}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 92, 210, 54, 51}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 64, 212, 92, 98, 29, 244, 73}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 247, 57, 119, 195, 132, 244, 164}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 163, 187, 213, 27, 40, 46}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 109, 200, 99, 141, 41, 207}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 55, 202, 244, 151, 19, 238, 173}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 41, 211, 79, 29, 17, 69}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 177, 138, 112, 234, 115, 207}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 171, 239, 176, 179, 86, 183, 13, 205, 245}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 94, 88, 96, 181}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 113, 134, 216, 220}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 37, 196, 95, 97, 7, 36, 15}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 143, 117, 121, 252, 46, 83, 110}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 10, 71}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 151, 221}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 92, 64, 206, 226, 129}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 124, 129, 161, 6, 134, 84, 82, 127}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 79, 87, 151}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 204, 196, 242, 8, 245, 167, 227, 226, 122}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 225, 79}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 9, 245, 225, 142, 44, 43, 17}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 23, 21}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 146, 231, 1, 17, 239}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 240, 206, 9, 88, 3, 192, 40, 194}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 99, 224}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 32, 90}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 62, 219, 49, 131, 153, 48, 145}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 200, 202, 11, 87, 9, 154, 112, 228}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 26, 202, 63, 104, 136, 229}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 130, 50, 190, 223, 108, 1, 130, 59}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 33, 189, 226, 249, 89, 220, 236}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 160, 51, 127, 30, 112, 136, 209}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 49, 133}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 154, 159, 117}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 15, 255, 144, 187, 243, 208}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 213, 34, 109, 136, 195}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 227, 162, 137, 133, 9, 171, 196, 10, 34}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 14, 55, 198, 186, 146, 93}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 177, 180, 153, 126, 211, 180}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 82, 25, 152, 194, 86}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 148, 95, 52, 78, 230, 94, 76}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 129, 80, 240, 226, 116, 46, 91}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 219, 148, 114, 226}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 167, 53}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 157, 34, 235, 117}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 54, 159, 30, 53, 221, 128, 9, 61, 22}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 2, 73, 254, 19}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 3, 238, 135, 155, 40, 199, 229}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 225, 222, 140}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 225, 47, 109, 43, 33, 63}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 96, 221}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 53}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 98, 82, 211, 44, 165, 226, 4, 128, 176}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 49, 190, 32, 110, 99, 217, 159, 120}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 156, 144, 138, 233, 229}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 100}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 24, 154, 145, 24, 64, 140, 50, 212, 212}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 167, 114, 22, 92, 63, 172, 74}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 37, 110, 104}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 217, 193}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 91, 79, 183, 86, 37, 153, 33}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 239, 65}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 127, 67, 227, 92, 254}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 0, 169, 13, 129}, 241},
	{{108, 144, 205, 39, 215, 26, 96, 0, 0, 0, 0, 0, 222, 212, 144, 44}, 241},
	{{247, 217, 172, 0, 0, 0, 0, 17, 70, 130, 136, 120, 54, 96, 241, 39}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 38, 208}, 239},
	{{247, 217, 172, 0, 244, 4, 22, 163, 92, 34, 165, 216, 210, 229, 132, 25}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 200, 164, 142, 253, 68, 223, 89, 208, 253}, 239},
	{{247, 217, 172, 0, 0, 0, 110, 126, 45, 56, 107, 58, 85, 166, 159, 18}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 239},
	{{247, 217, 172, 0, 0, 0, 101, 159, 79, 60, 162, 199, 249, 53, 72, 24}, 239},
	{{247, 217, 172, 0, 198, 178, 30, 32, 62, 201, 123, 186, 47, 24, 39, 12}, 239},
	{{247, 217, 172, 0, 119, 167, 172, 112, 35, 70, 129, 58, 143, 28, 91, 207}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 19, 32}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 49, 153, 201}, 239},
	{{247, 217, 172, 0, 135, 69, 76, 85, 8, 18, 3, 20, 176, 102, 99, 113}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 254, 11}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 215, 127}, 239},
	{{247, 217, 172, 0, 0, 0, 234, 182, 170, 172, 120, 205, 51, 119, 4, 127}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 42, 90, 31, 51, 239, 13}, 239},
	{{247, 217, 172, 0, 0, 66, 84, 26, 169, 164, 39, 214, 218, 89, 119, 216}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 196, 170, 103, 139, 146, 200}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 71, 109}, 239},
	{{247, 217, 172, 0, 0, 0, 109, 40, 63, 113, 60, 199, 107, 9, 21, 70}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 172, 51, 114, 48, 58}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 191, 52, 54, 164, 225, 233, 115, 128, 1}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 224, 14, 80, 85, 12, 9, 109}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 246, 246, 221, 133, 24, 218}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 20}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 194, 117, 41, 243, 198}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 164, 24, 137, 186, 50, 239, 133}, 239},
	{{247, 217, 172, 0, 0, 0, 116, 224, 55, 9, 215, 81, 85, 42, 243, 169}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 19, 223, 14}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 97, 95, 213, 122, 201}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 209, 78, 192, 167, 173}, 239},
	{{247, 217, 172, 0, 0, 67, 139, 166, 58, 172, 192, 221, 85, 204, 243, 133}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 193}, 239},
	{{247, 217, 172, 0, 0, 21, 117, 75, 179, 223, 54, 111, 81, 6, 90, 179}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 96, 203}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 222}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 192, 89, 178, 151, 18, 57, 11, 53}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 135}, 239},
	{{247, 217, 172, 0, 0, 0, 14, 88, 70, 156, 73, 101, 199, 254, 182, 171}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 171, 191, 251, 19, 150, 23, 66, 104}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 148, 103, 212, 70, 66}, 239},
	{{247, 217, 172, 0, 0, 0, 210, 174, 74, 99, 31, 49, 7, 110, 246, 40}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 250, 194, 34, 30, 81, 162, 25}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 25, 82, 51, 79, 138}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 239},
	{{247, 217, 172, 0, 0, 133, 69, 139, 192, 131, 178, 39, 126, 117, 127, 41}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 148}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 226, 137, 99, 7, 200}, 239},
	{{247, 217, 172, 0, 0, 173, 158, 253, 29, 122, 71, 165, 59, 28, 255, 55}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 254}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 148, 175, 65, 2, 241, 135, 143, 103}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 181}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 167, 71, 145, 84, 102, 207, 82}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 119, 63, 23}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 244}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 227}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 176, 70, 21, 111, 6, 60, 106, 115, 148}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 27, 193, 127, 80, 137}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 188, 18, 102, 42, 115, 124, 114, 66}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 207, 165, 188, 166, 211}, 239},
	{{247, 217, 172, 0, 0, 222, 144, 221, 86, 194, 99, 159, 11, 248, 62, 112}, 239},
	{{247, 217, 172, 0, 248, 180, 246, 12, 207, 207, 191, 117, 217, 254, 201, 225}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 86, 164, 83, 175, 109, 202}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{247, 217, 172, 0, 0, 0, 243, 120, 210, 177, 224, 191, 140, 128, 250, 72}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 67, 131, 121, 128, 43, 184, 90, 67, 187}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 252}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 36, 218, 250, 38, 239, 192}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 239},
	{{247, 217, 172, 0, 189, 42, 175, 105, 241, 105, 189, 151, 23, 222, 9, 101}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 132, 151, 109, 151, 137, 184}, 239},
	{{247, 217, 172, 0, 0, 147, 53, 69, 126, 162, 164, 106, 162, 96, 134, 141}, 239},
	{{247, 217, 172, 0, 0, 59, 115, 190, 214, 30, 174, 191, 213, 149, 204, 210}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 69, 105}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 205, 135, 152, 113, 229, 160}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 58}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 168, 40, 9, 95, 241, 198, 125}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 83, 171, 199, 6, 5, 17, 201, 88, 246}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 72, 105, 244, 215, 31}, 239},
	{{247, 217, 172, 0, 0, 0, 10, 96, 17, 157, 251, 4, 93, 208, 210, 11}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 16, 77, 213, 157, 94, 203, 90, 45, 28}, 239},
	{{247, 217, 172, 0, 0, 223, 145, 197, 79, 194, 31, 143, 192, 36, 113, 9}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{247, 217, 172, 0, 0, 164, 65, 59, 55, 159, 14, 200, 26, 57, 233, 44}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 95, 1, 95, 215, 148}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 170, 158, 73, 197, 18, 207}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 6, 218, 132}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 103, 67, 166, 185, 69, 234, 113, 55}, 239},
	{{247, 217, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 45}, 239},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 28, 166, 210}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 66, 13, 88, 252}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 115, 49, 216, 188, 51, 182}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 255, 68, 32, 84}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 245, 224, 150, 162, 14, 55, 175}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 7, 59, 17, 183, 16, 166}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 220}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 210, 62, 110, 217, 206, 139}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 67, 105, 146, 134, 163}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 187, 86, 137, 255, 221}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 208, 162, 188, 125, 229, 96, 56}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 101, 221, 65, 250, 132}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 99}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 150, 164, 169, 153, 147, 203}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 135, 206, 163}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 174, 197}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 236}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 193, 205, 50, 210, 67, 181}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 179, 116}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 159, 150, 17, 91}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 84, 220, 160, 224, 99, 230}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 206}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 152}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 233, 140, 187, 72, 13, 235}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 158}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 40, 158, 222, 35, 95, 125, 122}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 26, 50, 165, 71, 77, 21, 62}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 201, 103, 25, 171}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 153, 117, 55, 56, 218, 84}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 157, 75}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 6, 2}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 99}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 119, 200, 143, 66, 227, 112}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 27, 229, 181, 220, 242, 77, 137}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 40, 6, 28, 10, 168}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 70, 127, 3, 208, 149}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 218, 95, 143, 45, 57, 75}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 158, 236, 173}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 99, 249, 180, 104}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 136, 210}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 199, 44, 185, 243, 140}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 4}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 77, 1, 29}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 133, 233, 118, 124, 7, 56, 207}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 81, 237, 255}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 157}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 151, 102}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 190, 189, 209}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 8, 246, 161}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 151, 109, 121, 69}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 1, 222, 223}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 63, 120, 127}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 225, 37, 126, 100, 26, 225}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 142, 149, 147}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 5, 205, 221}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 200, 112, 72, 178}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 155, 113, 171}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 50, 200, 243}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 243, 57, 63, 50}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 241, 104}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 16, 195, 227}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 37}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 222, 137, 7, 8, 119, 54, 96}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 189, 238, 52, 76, 168}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 237, 167, 101, 184, 201, 203}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 14, 22, 13, 238, 147, 210, 208}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 94, 199}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 240, 87, 222}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 222, 164, 143, 12}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 109, 224, 234, 129}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 180, 52}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 13, 225, 203, 183, 220, 128}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 97, 136, 50, 44, 34, 29}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 33, 93, 65, 213, 85}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 49, 70}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 226, 94, 81, 128}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 173, 237, 223, 65}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 86, 27, 193, 194}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 74, 242, 23, 210, 46, 218, 229}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 112, 33, 25, 6, 128, 192}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 8, 241, 94, 102, 42}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 1, 193, 7}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 162, 131, 51}, 151},
	{{24, 186, 73, 182, 240, 251, 125, 165, 0, 0, 0, 0, 0, 0, 128, 103}, 151},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 115, 81, 177, 8, 86, 50, 58}, 137},
	{{245, 112, 0, 0, 0, 16, 215, 156, 108, 221, 92, 108, 16, 199, 194, 113}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 130, 137}, 137},
	{{245, 112, 0, 0, 0, 67, 135, 40, 77, 201, 46, 205, 117, 26, 200, 124}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 135, 4, 239, 76}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 60, 94, 96, 129, 177, 39}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 198, 62, 14, 207}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 74, 28, 77, 145, 75, 104}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 112, 242, 146, 246, 93, 28, 141}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 191}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 145, 139, 48, 251, 246, 177}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 52, 2, 164, 40}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 223, 158, 200, 54, 231, 51, 203, 191}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 166, 165, 223, 45, 151, 187, 92, 51}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 197, 5, 86, 228, 16, 172, 93, 70, 64}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 223}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 106, 83, 194, 95, 194, 174, 113, 21}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 159, 179, 176, 227, 15, 121, 235, 202, 80}, 137},
	{{245, 112, 0, 0, 0, 0, 90, 227, 203, 141, 123, 177, 184, 236, 243, 32}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 203, 37, 129, 0, 60, 184, 170}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 188, 230}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 166, 237, 182, 70}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{245, 112, 0, 0, 0, 0, 180, 123, 125, 115, 121, 7, 113, 29, 193, 126}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 99, 222, 133, 201, 45, 209}, 137},
	{{245, 112, 198, 218, 144, 2, 16, 201, 29, 99, 27, 234, 107, 61, 88, 188}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 148, 69, 49, 42, 105, 73, 123, 40, 134}, 137},
	{{245, 112, 0, 0, 0, 0, 1, 85, 155, 249, 241, 131, 86, 4, 65, 100}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 60}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 222, 116, 131, 62, 200, 123, 56}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 141, 234, 115, 57, 95, 201, 64, 196}, 137},
	{{245, 112, 0, 0, 51, 147, 14, 245, 22, 208, 53, 106, 136, 127, 153, 156}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 117, 208, 227}, 137},
	{{245, 112, 0, 0, 0, 0, 194, 85, 40, 222, 226, 90, 205, 52, 200, 205}, 137},
	{{245, 112, 0, 90, 6, 188, 52, 134, 178, 202, 246, 130, 62, 155, 120, 111}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{245, 112, 0, 0, 0, 102, 90, 157, 90, 103, 94, 8, 87, 57, 205, 69}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 134, 217, 23, 61}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 211, 234, 193, 195}, 137},
	{{245, 112, 0, 0, 0, 212, 157, 132, 80, 195, 37, 8, 36, 211, 178, 99}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 120, 4, 227, 62, 82, 78, 113, 243, 166}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 253, 91, 9, 88, 198, 185}, 137},
	{{245, 112, 0, 0, 0, 63, 157, 131, 36, 108, 198, 197, 149, 78, 52, 192}, 137},
	{{245, 112, 0, 0, 0, 83, 79, 96, 58, 125, 209, 205, 49, 26, 167, 38}, 137},
	{{245, 112, 0, 17, 57, 251, 226, 107, 229, 114, 44, 167, 152, 37, 229, 176}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 40, 163}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{245, 112, 0, 253, 6, 224, 65, 7, 133, 120, 4, 50, 122, 165, 244, 88}, 137},
	{{245, 112, 0, 0, 188, 162, 49, 233, 43, 204, 81, 96, 189, 77, 82, 60}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 226}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 137},
	{{245, 112, 0, 0, 180, 139, 20, 120, 155, 76, 12, 197, 200, 191, 96, 41}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 114, 98, 129, 189, 216, 153, 246, 106, 22}, 137},
	{{245, 112, 0, 0, 0, 25, 138, 238, 179, 172, 201, 67, 209, 25, 175, 130}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 105, 62, 106, 63}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 180, 121}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 214, 10, 165, 0, 79, 82, 157, 65}, 137},
	{{245, 112, 0, 0, 0, 97, 148, 165, 48, 51, 229, 113, 104, 183, 104, 94}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 165, 253, 45, 47}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 215}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 182, 54}, 137},
	{{245, 112, 0, 0, 16, 174, 66, 128, 92, 48, 168, 15, 14, 104, 129, 66}, 137},
	{{245, 112, 0, 248, 144, 17, 33, 175, 84, 227, 35, 250, 24, 90, 116, 219}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 63, 234}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 125, 105}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 154, 169, 192, 180, 244, 166, 26, 185}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 255, 49, 155, 82}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 214}, 137},
	{{245, 112, 0, 0, 0, 173, 147, 153, 111, 29, 227, 112, 10, 25, 159, 228}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 133, 81, 65, 145}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 214}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 137},
	{{245, 112, 0, 0, 0, 0, 246, 73, 205, 79, 236, 50, 244, 204, 190, 38}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 40, 255, 128, 169, 185, 10, 4, 159, 67}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 125, 72, 88, 193, 215, 36, 20, 145}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 164, 178, 130, 1}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 0}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 191, 11, 154, 186, 99, 244, 27, 66}, 137},
	{{245, 112, 154, 237, 29, 76, 120, 218, 37, 102, 157, 143, 35, 188, 156, 238}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 31, 217, 100}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 79, 114, 182}, 137},
	{{245, 112, 0, 0, 19, 56, 17, 105, 143, 32, 50, 112, 193, 57, 91, 167}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 16, 51, 172, 241, 189, 77, 186, 152, 90}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 179, 169, 162, 30, 241, 21, 84, 245, 209}, 137},
	{{245, 112, 0, 0, 0, 0, 0, 0, 0, 0, 244, 63, 11, 224, 243, 230}, 137},
	{{245, 112, 0, 10, 88, 209, 190, 151, 28, 97, 74, 160, 38, 83, 22, 170}, 137},
	{{245, 112, 0, 0, 117, 111, 75, 146, 119, 170, 72, 179, 172, 127, 197, 45}, 137},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 43, 220, 58, 78, 17, 175, 14}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 109, 75, 193, 85, 75, 233}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 234, 8, 113, 40, 35, 21, 156, 24, 9}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 139}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 215, 60, 165}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 206, 23, 203, 34}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 149, 167, 233, 42, 58, 135, 167, 12, 191}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 56, 12, 186}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 231},
	{{44, 94, 138, 224, 168, 0, 216, 67, 147, 241, 166, 8, 191, 54, 175, 146}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 197}, 231},
	{{44, 94, 138, 224, 168, 0, 39, 184, 253, 4, 23, 254, 253, 7, 211, 210}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 111, 110, 70, 51, 211, 178, 56, 119}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 124, 14, 209, 155, 20}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 218, 27, 43, 235, 225}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 219, 173, 157}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 20}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 29, 184, 73, 198}, 231},
	{{44, 94, 138, 224, 168, 0, 114, 142, 102, 28, 130, 99, 236, 14, 87, 178}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 114, 241, 238, 149, 76, 234, 138}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 244, 225, 123, 98, 129, 170, 203}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 177, 241, 162, 210, 244, 67, 237, 41}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 133, 214, 116}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 81, 238, 146, 2}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 115, 239, 101}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 248, 31, 194, 6, 145}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 83}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 117, 232, 183, 18, 34}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 60, 75, 45, 169, 157, 28, 128, 199}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 190, 167, 190}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 184, 31, 184, 113}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 28, 34, 130, 152, 128, 2, 201, 130}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 64, 217, 205, 71, 57, 233, 195, 89, 188}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 150, 166, 50, 191, 149}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 234, 166, 68, 156}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 149, 236, 133, 92, 202, 154, 174, 123}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 7, 99, 70, 102}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 246}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 242, 34, 21, 5, 130, 214}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 47, 245, 62, 106, 201}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 212, 194, 212}, 231},
	{{44, 94, 138, 224, 168, 0, 202, 153, 60, 89, 147, 157, 34, 132, 46, 119}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 125, 116, 77}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 179, 168, 180, 5, 220, 226, 34}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 231},
	{{44, 94, 138, 224, 168, 0, 164, 82, 93, 1, 60, 2, 155, 155, 172, 110}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 170, 195, 188, 93, 182, 193, 17}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 132, 86, 0, 98, 171, 69, 61}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 16, 124, 58, 163, 60, 24}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 90, 223, 148, 61, 139, 72, 252}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 82, 22, 176, 93, 40, 35, 216}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 253, 93, 85, 215, 200, 83, 174, 130, 19}, 231},
	{{44, 94, 138, 224, 168, 0, 163, 0, 90, 129, 136, 163, 236, 204, 253, 121}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 103}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 7, 144, 35, 222, 21, 84}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 25, 217, 228, 87, 64, 199}, 231},
	{{44, 94, 138, 224, 168, 0, 69, 94, 82, 167, 83, 238, 112, 17, 16, 139}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 242, 45, 175, 33, 5}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 198, 113, 223, 124, 159, 125, 225}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 78, 56, 97, 188, 204, 196, 107, 238, 249}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 217, 191, 211, 168, 229, 216, 212, 188}, 231},
	{{44, 94, 138, 224, 168, 0, 216, 38, 61, 59, 22, 52, 66, 100, 213, 2}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 164, 176, 37, 58, 232}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 94, 228, 244, 162}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 201, 42, 92}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 82, 104, 244, 141, 103, 195, 7, 139}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 151, 4, 164, 207, 253, 14, 148, 221, 54}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 176, 191, 124, 69, 131}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 234, 255, 229, 30, 238, 127, 125, 89, 209}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 48, 146, 88, 243, 115, 54}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 115}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 235, 223, 233, 139, 182, 116, 141, 119}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 45, 31, 219, 9}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 241, 46, 17, 114, 58}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 211, 135, 131}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 116, 185, 228, 240}, 231},
	{{44, 94, 138, 224, 168, 0, 55, 175, 94, 110, 75, 11, 73, 235, 243, 233}, 231},
	{{44, 94, 138, 224, 168, 0, 80, 77, 188, 47, 232, 225, 159, 151, 129, 27}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 31, 86, 108, 72}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 194}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 220, 224, 151, 70, 25, 139, 2}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 56, 229, 249, 2, 125, 232, 169, 32}, 231},
	{{44, 94, 138, 224, 168, 0, 134, 206, 38, 83, 103, 122, 160, 116, 71, 110}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 106, 164, 175, 206, 103, 65, 78, 173, 180}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 186, 148, 234, 91, 221, 240, 35}, 231},
	{{44, 94, 138, 224, 168, 0, 0, 0, 0, 0, 0, 207, 200, 157, 122, 253}, 231},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 114, 52, 108, 236, 35, 129}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 165, 237, 2, 192, 37, 168, 82, 89, 43}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 29, 222, 182}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 90, 218, 196, 144}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 39, 56, 15, 23}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 142, 89, 161, 222, 56, 24, 89, 43, 206}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 199, 60, 45, 49, 225, 203, 115, 197, 6}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 164, 219, 16, 255, 27, 174, 102, 199}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 106, 170, 224, 54, 27}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 243, 203, 12, 252}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 171, 58, 144, 89, 137, 157, 120, 176}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 64, 184, 143}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 123, 14, 89, 12, 150, 223, 68, 225}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 225, 116, 8, 77, 102}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 39, 194, 216, 177}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 172, 116, 168}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 14, 163, 153, 231}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 186, 33, 250, 233, 87, 229, 220, 164}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 141, 109, 56}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 21, 232, 10, 190, 51, 175, 39, 136, 99}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 2, 113, 162, 44, 73, 240, 229, 185, 14, 35}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 238, 116, 219, 145, 24, 252, 106, 241}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 254, 223, 55, 107, 59, 140, 174}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 180, 117, 114, 76, 193}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 68, 152, 110, 152, 197, 167}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 124, 15}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 140, 36, 178}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 6, 130, 208, 81}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 226, 123, 134}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 88, 55, 218, 1, 237, 185, 228, 35, 127}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 191, 29, 50, 251, 65, 154, 23, 97}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 245, 156}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 190, 86, 107, 107, 90, 105, 241}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 149, 94, 187, 68, 84, 39, 128}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 54, 1, 61}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 53, 233, 230, 191, 27, 215, 226, 203}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 120, 16, 174, 157, 44, 174, 240, 145}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 241, 89}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 124, 191, 20}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 152, 130, 86, 25}, 11},
	{{184, 221, 109, 135, 225, 32, 68, 14, 172, 203, 249, 250, 210, 234, 105, 37}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 37, 65, 205, 207, 105, 84}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 112, 59, 93, 178}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 160, 189}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 120, 26, 135, 178, 233, 150, 73}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 99, 229, 200, 4, 6, 63}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 245, 95, 3, 45, 47, 16, 187, 45, 204, 120}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 128, 148, 233}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 90, 84, 101, 111, 177, 57, 64, 242}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 207, 214, 22, 65, 134, 36, 195}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 199, 186, 208, 104, 89, 157, 170, 180}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 255, 8, 216, 31}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 168, 225}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 116, 167}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 249, 250, 84, 147, 224, 248, 94, 13, 229}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 231, 209, 34, 172, 120, 62, 65}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 137, 190, 106, 211, 128, 13, 59}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 171, 86, 219, 14, 132, 250, 96}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 123, 88, 255, 31, 115, 255, 23, 42, 17}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 89, 52, 9, 14}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 70, 222, 207, 148, 183}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 178, 193, 163, 231, 249}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 38, 167, 133}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 192, 251, 92}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 116, 224, 55, 0, 18, 253, 44, 3}, 11},
	{{184, 221, 109, 135, 225, 32, 195, 167, 137, 244, 85, 140, 197, 183, 98, 49}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 184, 200, 206, 241, 17, 27, 40, 255, 164}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 40, 84}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 73, 68, 193, 184, 27, 225}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 39, 203}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 157, 173, 22, 251, 28, 48, 160, 168}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 198, 93, 123}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 116, 234, 139, 224, 223, 61}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 9, 93, 186, 51, 35, 146}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 100, 108, 77, 104, 247, 230, 179, 169}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 228, 60, 122, 179, 16, 248, 34}, 11},
	{{184, 221, 109, 135, 225, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201}, 11},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 61, 198}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 243, 27, 46}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 67, 73}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 227, 183, 15}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 219, 212, 160}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 57, 6}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 253, 20, 61}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 8}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 144, 133, 233}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 240, 55}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 58, 21}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 230, 87}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 230, 134}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 1, 30}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 206, 81}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 205}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 165, 253}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 109, 213}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 187, 152, 119}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 167, 58}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 116, 67, 145}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 81, 73}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 230}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 148, 102, 46}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 14}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 240, 16}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 225, 221}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 247, 41}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 128}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 14, 188, 71}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 59, 19, 243}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 102, 122}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 220}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 91, 249}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 89, 94, 10}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 87, 122}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 144, 118, 209}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 59, 185, 77}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 106, 234, 16}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 253, 146}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 100, 63, 177}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 246}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 233, 101}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 178, 218, 12}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 100}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 43}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 241}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 15}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 92, 110, 188}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 72}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 44, 244, 101}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 111, 86, 144}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 177}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 112}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 144, 180, 230}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 219}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 26, 187, 117}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 55}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 2}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 144, 172, 146}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 208}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 205, 161, 1}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 173}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 185, 210}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 183, 234, 28}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 107, 173, 165}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 138}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 57, 103, 39}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 135, 16}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 141, 55}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 196}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 0, 0}, 20},
	{{51, 179, 136, 184, 30, 118, 24, 16, 26, 161, 206, 101, 0, 0, 123, 185}, 20},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 221, 12, 9, 238, 86, 227}, 68},
	{{48, 46, 0, 0, 0, 203, 57, 10, 203, 53, 37, 21, 38, 135, 219, 107}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 24, 7, 31, 193, 75, 35, 4, 12, 49}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 50, 145}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 69, 51, 198, 162, 79, 24, 143, 117}, 68},
	{{48, 46, 0, 0, 0, 53, 137, 201, 30, 182, 226, 46, 244, 44, 2, 108}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 64, 71, 9}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 243}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 88, 9, 154, 103, 140, 199, 154, 56, 174}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 103, 211, 38}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 41}, 68},
	{{48, 46, 0, 0, 0, 240, 104, 168, 105, 222, 152, 114, 158, 96, 47, 82}, 68},
	{{48, 46, 0, 0, 41, 232, 124, 80, 44, 138, 212, 88, 30, 163, 245, 97}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 246, 233, 44, 42, 47, 154}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 66, 109, 105, 160, 227, 73, 115, 79, 8}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 11, 227}, 68},
	{{48, 46, 0, 0, 43, 236, 82, 249, 86, 73, 148, 99, 192, 105, 171, 248}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 2, 106, 65, 35, 109, 237, 123}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 58, 163, 150, 74, 38, 97}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 207, 59}, 68},
	{{48, 46, 0, 125, 144, 36, 245, 52, 16, 215, 101, 50, 86, 90, 174, 234}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 224, 214, 128, 135, 29, 39}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 181, 85, 79, 134}, 68},
	{{48, 46, 0, 0, 0, 0, 17, 131, 198, 1, 198, 143, 184, 219, 45, 226}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 33, 81, 96, 168, 130, 4, 97}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 151, 102, 138, 15, 185, 153, 57}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 27, 188, 236, 176, 179, 217}, 68},
	{{48, 46, 0, 0, 116, 146, 105, 243, 220, 65, 135, 172, 232, 254, 94, 235}, 68},
	{{48, 46, 0, 0, 0, 0, 117, 158, 201, 11, 220, 138, 47, 129, 22, 54}, 68},
	{{48, 46, 0, 0, 0, 125, 196, 95, 138, 163, 139, 43, 13, 209, 234, 162}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 121}, 68},
	{{48, 46, 0, 0, 234, 190, 137, 169, 233, 69, 29, 47, 139, 174, 247, 193}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 25, 150}, 68},
	{{48, 46, 0, 32, 117, 212, 4, 135, 137, 12, 80, 235, 244, 218, 24, 220}, 68},
	{{48, 46, 0, 0, 0, 0, 4, 153, 35, 20, 103, 95, 103, 46, 104, 49}, 68},
	{{48, 46, 0, 80, 96, 66, 255, 49, 58, 22, 51, 190, 86, 133, 2, 91}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 198, 190, 26, 122, 181, 164, 160, 33}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 237, 69, 174}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 33, 203, 239, 136, 196, 38, 33}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 36, 119, 210, 225, 0, 122, 22, 172}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 68},
	{{48, 46, 0, 0, 97, 131, 195, 188, 119, 111, 194, 41, 247, 206, 110, 90}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 96, 234}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 65, 216}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 59, 124, 3, 100, 232, 92, 192, 104}, 68},
	{{48, 46, 0, 0, 0, 73, 106, 2, 23, 168, 61, 226, 209, 101, 74, 73}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 3, 159}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 5, 160, 38, 229, 82, 7, 134}, 68},
	{{48, 46, 0, 0, 0, 224, 185, 122, 103, 45, 5, 135, 253, 75, 104, 61}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 123}, 68},
	{{48, 46, 0, 171, 183, 104, 225, 119, 71, 116, 214, 125, 4, 212, 196, 60}, 68},
	{{48, 46, 0, 0, 0, 212, 238, 204, 61, 38, 180, 65, 75, 151, 103, 158}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 211, 120, 217}, 68},
	{{48, 46, 0, 252, 83, 64, 230, 127, 132, 71, 90, 128, 137, 71, 105, 50}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 5}, 68},
	{{48, 46, 0, 174, 99, 251, 57, 123, 140, 15, 168, 97, 207, 204, 95, 186}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 51, 174}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 176, 146, 62, 129, 27, 138, 72}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 14, 173, 210, 18, 72, 153, 181}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 64, 9}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 156, 7}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 36, 29, 153, 224}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 163, 150, 224, 69, 182, 77, 91}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 125, 10, 165}, 68},
	{{48, 46, 0, 0, 0, 0, 52, 190, 158, 222, 92, 224, 212, 221, 41, 156}, 68},
	{{48, 46, 0, 0, 188, 4, 192, 199, 181, 179, 219, 201, 230, 209, 51, 247}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 105, 137, 118, 198, 128, 145, 238, 222, 172}, 68},
	{{48, 46, 0, 0, 19, 36, 30, 15, 10, 98, 33, 152, 143, 174, 238, 92}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 219, 252}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 44}, 68},
	{{48, 46, 0, 0, 252, 24, 226, 107, 187, 136, 124, 129, 17, 216, 179, 66}, 68},
	{{48, 46, 0, 0, 0, 0, 48, 72, 8, 128, 171, 223, 60, 14, 219, 95}, 68},
	{{48, 46, 0, 0, 0, 0, 250, 49, 153, 251, 205, 24, 157, 184, 40, 214}, 68},
	{{48, 46, 0, 0, 63, 169, 23, 150, 222, 127, 182, 9, 99, 153, 200, 50}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 244, 77}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 222, 9, 168, 70, 60, 52, 150, 204}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 250}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 85, 122, 128, 132, 204, 55, 234}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 6, 51}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 226, 159, 36}, 68},
	{{48, 46, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 68},
	{{48, 46, 0, 0, 0, 176, 165, 143, 144, 232, 106, 21, 154, 198, 153, 178}, 68},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 227}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 219, 171}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 95}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 95}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 74, 110}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 41, 220, 158}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 223}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 102, 207, 239}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 7, 131}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 55}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 229, 148}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 54, 146, 63}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 230}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 161}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 75, 165}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 238}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 214, 43}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 158, 209, 43}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 167, 28, 79}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 80, 107}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 239}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 147, 85}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 187, 212, 109}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 12, 201, 235}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 48, 142}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 171}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 244, 243}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 186}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 190, 17}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 89, 166}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 114, 158, 131}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 200, 41, 101}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 216, 243}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 97, 140}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 49}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 145}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 81, 46, 153}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 147, 45}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 42}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 190}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 228, 27}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 114, 152}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 19, 210}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 225}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 102, 115}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 225, 244}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 81, 28}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 152}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 162, 204}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 126, 226, 84}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 95}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 106}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 47}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 8}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 19, 5}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 190, 127}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 175}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 254, 68, 222}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 172, 98}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 141, 184, 199}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 49, 87}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 122, 66, 88}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 77}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 98, 157}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 107, 119}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 153}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 168}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 129}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 223, 220}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 0}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 246, 252}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 241}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 179}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 0, 11}, 64},
	{{143, 235, 237, 220, 89, 119, 187, 143, 209, 94, 46, 58, 120, 0, 236, 132}, 64},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 167, 228, 61, 250, 115, 161}, 152},
	{{121, 190, 90, 177, 128, 0, 29, 173, 80, 159, 106, 45, 17, 141, 39, 249}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 2, 167, 6, 9, 103, 151}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 117, 115, 170, 11, 56, 178, 47, 58}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 178, 13, 52, 129, 193, 144, 103}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 31, 157, 120, 159, 237, 254}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 66}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 138, 93, 100, 244, 64}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 67, 9, 103, 159}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 149, 51, 18, 115}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 12, 188, 2, 74, 47, 160, 135}, 152},
	{{121, 190, 90, 177, 128, 38, 141, 144, 76, 74, 98, 166, 131, 96, 230, 74}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 166, 222, 10}, 152},
	{{121, 190, 90, 177, 128, 163, 10, 156, 242, 15, 233, 185, 94, 143, 213, 106}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 9}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 75, 152, 100, 34, 79, 155, 166, 243, 167}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 251, 36, 122}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 94, 205, 68, 50, 185, 232, 208}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 160, 93, 50}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 244, 52, 29, 49}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 174, 197, 11, 57, 93, 246, 235}, 152},
	{{121, 190, 90, 177, 128, 0, 197, 155, 80, 93, 84, 250, 225, 231, 114, 47}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 240, 43, 159, 76, 236, 28}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 16, 12, 129, 184, 33, 34, 215}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 233, 21, 14, 140, 107, 149, 62, 34}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 109, 0, 66, 220, 3, 42, 14}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 15, 102, 59, 96, 78, 69, 73, 137}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 234}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 234, 188, 210, 210, 91, 110, 213, 25}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 211}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 55, 12, 217, 144, 63, 97, 201, 246, 77}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 61, 139, 101, 238, 155}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 40, 140, 195, 47, 110, 12, 203, 165, 158}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 94, 161, 216, 82, 152, 82}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 183}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 31}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 56, 156, 170, 227}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 179, 99, 163, 75, 88}, 152},
	{{121, 190, 90, 177, 128, 0, 185, 211, 101, 132, 208, 218, 143, 207, 176, 75}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 64, 12, 3, 142}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 113, 146, 155, 81, 84}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 9, 178, 224, 45, 78, 190, 170, 234, 137, 144}, 152},
	{{121, 190, 90, 177, 128, 121, 29, 170, 2, 181, 182, 180, 210, 111, 136, 113}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 219, 231, 176, 200, 63, 152, 48, 50, 186, 206}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 74, 154, 183, 159, 44}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 75, 92, 20, 60, 59, 97}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 93, 86, 248, 116}, 152},
	{{121, 190, 90, 177, 128, 0, 144, 254, 238, 149, 123, 210, 180, 181, 81, 153}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 245, 121, 239, 243, 89, 21}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 240, 241, 50, 137, 31, 173}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 126, 1, 129, 3, 142, 233}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 192}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 254, 167, 193, 246, 210}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 70, 249, 233, 236, 0, 8, 148, 107, 47, 92}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 133}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 45, 42, 203, 190, 49, 49, 142, 198, 223}, 152},
	{{121, 190, 90, 177, 128, 9, 5, 34, 99, 38, 213, 40, 78, 182, 32, 67}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 140, 175, 107, 242, 177, 24, 168, 147}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 157, 251, 128, 245, 56, 112, 71, 197}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 28, 140, 38, 121, 239, 176, 176}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 160, 115, 217, 94, 205, 14, 91}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 43, 13, 86, 12, 143, 83, 6, 178, 240}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 112, 143, 19, 127, 176, 159}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 13, 231, 97, 150, 78}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 22, 234, 29}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 23, 222, 114, 179, 88, 146, 255, 73, 14}, 152},
	{{121, 190, 90, 177, 128, 0, 247, 106, 22, 194, 178, 25, 87, 152, 28, 230}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 24, 84, 75, 182, 84}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 106, 166, 38}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 58, 82, 199, 14, 111, 67, 0, 176, 174}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 134, 254, 213}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 96, 89, 129, 56, 241, 56, 249, 230, 29}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 100, 168, 25, 124, 147, 220, 249, 237}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 11, 92, 222}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 171, 180, 194, 156, 68, 124, 209}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 181, 86, 254, 179}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 163, 132, 185, 208, 149, 181, 250, 53, 173}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 80, 69, 20, 131, 12, 208, 203, 218}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 240, 106, 180, 157, 126, 62}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 246, 155, 99, 235, 242}, 152},
	{{121, 190, 90, 177, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230}, 152},
	{{121, 190, 90, 177, 128, 232, 225, 126, 152, 199, 252, 102, 48, 92, 166, 253}, 152},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 218, 47, 253}, 218},
	{{128, 0, 105, 170, 78, 198, 254, 172, 85, 253, 0, 12, 220, 175, 2, 190}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 170}, 218},
	{{128, 0, 0, 0, 0, 171, 43, 71, 250, 17, 10, 217, 114, 131, 185, 65}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 224}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 227, 128}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 250, 126, 177, 193, 152, 38, 198}, 218},
	{{128, 0, 0, 0, 0, 0, 189, 118, 93, 198, 146, 79, 9, 46, 39, 39}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 248, 170, 23, 229, 90}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 15, 40, 255, 148, 26, 217, 207}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 5, 225, 228, 118, 255, 215, 75, 158, 161}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 72, 209}, 218},
	{{128, 0, 0, 0, 0, 35, 68, 160, 138, 56, 248, 43, 10, 176, 161, 75}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 113, 136, 90, 181}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 50, 202, 107, 250, 31, 60, 250, 209}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 19, 197, 23, 178, 116}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 78, 165, 77, 184, 212, 13, 200, 54, 164, 124}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 174, 66, 41, 8, 104}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 211, 175, 168, 19}, 218},
	{{128, 0, 92, 72, 42, 195, 226, 217, 197, 101, 102, 64, 48, 11, 201, 241}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 26, 80, 55, 106, 181, 167, 63, 228, 120}, 218},
	{{128, 0, 0, 0, 47, 9, 169, 243, 253, 46, 166, 87, 216, 20, 189, 112}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 230, 123, 57, 246, 212}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 143, 197, 213, 29, 104, 170, 11}, 218},
	{{128, 0, 0, 0, 0, 104, 192, 232, 136, 206, 72, 92, 143, 185, 17, 200}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 173, 138}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 155, 124, 255, 88, 44, 225, 82, 248, 33, 218, 179, 5, 124, 228}, 218},
	{{128, 0, 0, 244, 150, 69, 108, 70, 129, 203, 74, 128, 19, 27, 209, 206}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 73, 201, 80, 101, 135}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 100, 112, 109, 197, 231, 132, 92}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 223, 217, 134, 172}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 247, 30, 66}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 150, 94, 210, 225, 3, 201, 88, 62, 2}, 218},
	{{128, 0, 0, 95, 47, 162, 171, 96, 82, 3, 234, 153, 3, 4, 157, 164}, 218},
	{{128, 0, 0, 0, 0, 174, 68, 163, 250, 89, 181, 222, 16, 112, 2, 183}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 51, 122, 90, 157, 180, 107, 51}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 90, 109, 77, 95}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 11, 180, 103, 255, 156, 143, 5, 225}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 159, 244, 21, 67, 255, 126, 249}, 218},
	{{128, 0, 0, 211, 158, 243, 40, 116, 233, 224, 200, 12, 212, 36, 162, 53}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 206, 62, 169, 247, 218, 191, 28, 183}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 126, 67, 227, 36, 5, 216, 163}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 168, 17, 111, 118, 225}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 42, 93, 32, 0, 144}, 218},
	{{128, 0, 0, 0, 0, 0, 181, 17, 44, 80, 242, 56, 151, 92, 131, 176}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 216, 149, 71, 172}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 129}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 85, 60, 44, 195, 139, 40, 1, 151, 56}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 83, 89, 105, 133, 32, 102, 5, 32, 163, 251, 207, 204, 123}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 46, 193, 219, 33, 227, 0, 5, 43, 65}, 218},
	{{128, 0, 7, 248, 56, 33, 123, 188, 122, 129, 236, 78, 128, 223, 91, 202}, 218},
	{{128, 0, 0, 0, 180, 243, 16, 76, 251, 16, 48, 196, 116, 121, 38, 48}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 146, 102, 159, 186, 162, 239, 77, 178}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 126}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 141, 154, 27, 19, 221, 58, 10, 95, 176, 138, 189}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 75, 193, 255, 120}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 233, 131, 107, 60, 191, 159, 47, 111}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 194, 78, 239, 130, 204, 141, 62, 175, 56}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 137, 123, 24, 1, 132, 127, 148, 123, 92}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 5, 109, 128, 155, 114}, 218},
	{{128, 0, 0, 0, 223, 15, 169, 235, 103, 232, 208, 65, 92, 20, 221, 247}, 218},
	{{128, 0, 0, 0, 46, 244, 114, 146, 119, 244, 99, 127, 53, 40, 69, 177}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 140, 234}, 218},
	{{128, 0, 0, 0, 0, 215, 239, 186, 54, 202, 152, 149, 87, 25, 239, 182}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 123, 221, 85, 40, 55}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 195, 104, 126, 246, 163, 153, 159, 101}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 6, 168, 45}, 218},
	{{128, 0, 0, 0, 0, 94, 5, 234, 133, 127, 51, 218, 2, 229, 208, 31}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 157, 68, 21, 87}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 218},
	{{128, 0, 0, 107, 19, 226, 241, 122, 140, 50, 136, 100, 115, 179, 249, 119}, 218},
	{{128, 117, 120, 215, 217, 15, 117, 20, 145, 69, 219, 214, 223, 203, 204, 42}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 199, 201, 41, 19, 53, 124, 63, 160, 13}, 218},
	{{128, 0, 0, 0, 0, 0, 130, 171, 170, 38, 27, 156, 200, 141, 237, 69}, 218},
	{{128, 0, 0, 0, 0, 107, 220, 39, 144, 172, 19, 185, 193, 162, 75, 112}, 218},
	{{128, 0, 120, 171, 236, 163, 184, 180, 144, 77, 244, 247, 196, 170, 71, 13}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 23, 9, 11, 127, 51, 157, 169, 55}, 218},
	{{128, 0, 0, 0, 0, 113, 241, 18, 102, 175, 4, 188, 209, 250, 206, 78}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 27, 245, 129, 57, 225}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 8, 139, 32, 202, 188, 224, 14, 65, 199}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 22, 239, 246, 66, 10, 118, 183, 147}, 218},
	{{128, 0, 0, 0, 174, 23, 0, 95, 125, 139, 158, 187, 20, 184, 243, 27}, 218},
	{{128, 0, 0, 0, 121, 221, 16, 246, 5, 129, 173, 44, 146, 41, 146, 164}, 218},
	{{128, 0, 0, 0, 0, 0, 61, 51, 100, 95, 181, 66, 233, 161, 59, 239}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 45, 252, 128, 228, 58}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 123, 101, 242, 175}, 218},
	{{128, 79, 39, 87, 254, 32, 62, 112, 197, 249, 194, 4, 224, 251, 2, 35}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 60}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 192, 117, 168, 33, 23, 139, 84, 29, 62, 239, 176, 21}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190}, 218},
	{{128, 0, 0, 0, 255, 115, 252, 1, 54, 206, 61, 77, 249, 153, 3, 146}, 218},
	{{128, 0, 0, 0, 0, 0, 249, 175, 87, 143, 123, 172, 206, 223, 49, 66}, 218},
	{{128, 0, 252, 234, 64, 192, 199, 37, 90, 76, 33, 172, 217, 53, 235, 232}, 218},
	{{128, 0, 0, 0, 0, 49, 132, 153, 110, 165, 133, 121, 52, 197, 79, 183}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 60, 130, 86, 35, 96, 194, 128}, 218},
	{{128, 0, 0, 108, 80, 201, 104, 122, 249, 49, 32, 164, 233, 174, 255, 60}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 90}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 183, 171, 148, 70, 15, 186, 226}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 24, 86, 18, 251, 199, 251, 17, 4, 20}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 252, 87, 57, 98, 122}, 218},
	{{128, 0, 87, 45, 136, 4, 221, 237, 240, 23, 125, 29, 116, 31, 12, 107}, 218},
	{{128, 0, 0, 0, 0, 212, 83, 17, 50, 160, 168, 17, 223, 67, 112, 177}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 212, 58, 184, 102, 136, 211, 247, 95}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 36, 109, 22, 222}, 218},
	{{128, 0, 0, 176, 5, 48, 82, 71, 246, 165, 196, 137, 134, 177, 207, 89}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 131, 105, 193, 125}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 2, 114}, 218},
	{{128, 0, 0, 0, 90, 29, 119, 108, 143, 76, 198, 135, 181, 131, 116, 16}, 218},
	{{128, 0, 0, 120, 148, 94, 123, 45, 66, 58, 16, 10, 29, 130, 53, 26}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 0, 69, 86, 176}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 137, 110, 54, 104, 161, 131, 101, 252, 29}, 218},
	{{128, 0, 0, 0, 65, 253, 235, 1, 128, 210, 180, 33, 112, 146, 242, 211}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 150, 91, 201, 226, 109, 31, 26}, 218},
	{{128, 0, 0, 0, 0, 0, 190, 118, 207, 240, 160, 187, 173, 4, 219, 229}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 93, 134, 225, 104}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 188, 27, 159, 104, 126, 215, 52, 128, 95}, 218},
	{{128, 0, 0, 0, 0, 0, 37, 19, 199, 217, 108, 148, 147, 35, 98, 62}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 194, 250, 5, 2}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 185, 22, 231, 126}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 42}, 218},
	{{128, 0, 0, 76, 135, 170, 16, 158, 78, 182, 15, 19, 175, 212, 50, 144}, 218},
	{{128, 0, 0, 0, 0, 157, 176, 47, 66, 66, 63, 53, 229, 188, 12, 111}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 34, 252, 222, 98}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 148, 153, 254}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99}, 218},
	{{128, 0, 0, 0, 117, 56, 77, 186, 202, 239, 241, 34, 71, 229, 82, 186}, 218},
	{{128, 0, 0, 0, 0, 26, 24, 126, 157, 201, 156, 242, 245, 4, 147, 58}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 189}, 218},
	{{128, 0, 0, 130, 100, 102, 244, 242, 33, 78, 56, 214, 66, 155, 22, 108}, 218},
	{{128, 0, 0, 0, 0, 0, 245, 173, 88, 107, 101, 157, 155, 24, 144, 160}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 247, 51}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 41, 77, 160}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 138, 227, 108, 172, 205, 26, 163}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 70, 204, 231, 165, 184}, 218},
	{{128, 35, 120, 52, 159, 210, 136, 210, 182, 227, 151, 9, 210, 38, 92, 113}, 218},
	{{128, 0, 0, 0, 83, 233, 90, 135, 201, 34, 201, 121, 38, 61, 15, 132}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 233, 222, 97, 157, 27, 244, 26, 140, 140}, 218},
	{{128, 0, 0, 0, 0, 0, 116, 50, 198, 114, 25, 31, 219, 64, 104, 204}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 184, 0, 38, 133, 158, 155, 251, 73}, 218},
	{{128, 0, 197, 113, 199, 165, 3, 124, 138, 50, 193, 49, 94, 207, 120, 118}, 218},
	{{128, 0, 0, 0, 220, 99, 54, 107, 229, 116, 227, 197, 153, 174, 254, 57}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 156, 243, 52, 149}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 112, 129, 183, 1}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 236}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 65, 13, 121, 10, 223, 140, 145, 56}, 218},
	{{128, 0, 0, 0, 0, 0, 154, 155, 156, 130, 69, 54, 13, 241, 252, 82}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 231, 216, 161, 253, 79, 233, 71}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 107, 141, 64}, 218},
	{{128, 0, 0, 21, 166, 170, 104, 28, 200, 75, 235, 68, 224, 13, 192, 33}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 176, 97, 181}, 218},
	{{128, 0, 0, 0, 0, 0, 5, 64, 185, 27, 175, 68, 78, 233, 169, 41}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 12, 138, 237, 118, 9}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 193, 38, 228, 49, 94, 122, 196, 225, 111}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 122, 212, 38, 32, 245, 176, 197, 76}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 203, 47}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 84, 172, 218, 254, 34, 112, 133, 189}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 203, 208, 149, 161, 146}, 218},
	{{128, 0, 0, 0, 109, 103, 168, 147, 154, 126, 135, 187, 62, 136, 24, 251}, 218},
	{{128, 109, 162, 128, 148, 64, 177, 14, 66, 193, 250, 157, 33, 52, 127, 28}, 218},
	{{128, 155, 71, 143, 62, 97, 44, 100, 93, 69, 84, 224, 156, 155, 159, 166}, 218},
	{{128, 0, 247, 109, 199, 205, 158, 8, 220, 98, 46, 197, 64, 97, 219, 130}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 236, 195, 134, 165, 146, 218, 98, 94, 221}, 218},
	{{128, 0, 0, 0, 126, 121, 58, 155, 69, 4, 16, 180, 196, 38, 50, 244}, 218},
	{{128, 0, 0, 15, 41, 242, 125, 128, 161, 67, 84, 84, 62, 23, 99, 131}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 112, 101, 229}, 218},
	{{128, 0, 0, 249, 166, 125, 48, 110, 205, 238, 193, 217, 39, 186, 229, 178}, 218},
	{{128, 0, 0, 146, 205, 172, 151, 215, 32, 224, 200, 2, 254, 157, 167, 82}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 45, 196, 222, 80}, 218},
	{{128, 0, 0, 0, 0, 181, 240, 8, 117, 242, 102, 180, 121, 223, 67, 86}, 218},
	{{128, 69, 202, 249, 2, 28, 230, 51, 126, 173, 170, 32, 116, 210, 112, 99}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 148, 108}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 154}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 228, 59, 187, 81, 207, 190, 105, 171}, 218},
	{{128, 0, 0, 0, 127, 71, 186, 33, 243, 104, 15, 71, 157, 234, 17, 198}, 218},
	{{128, 0, 0, 221, 254, 155, 191, 204, 131, 14, 109, 161, 2, 194, 149, 168}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{111, 214, 0, 0, 121, 4, 28, 7, 123, 41, 115, 31, 91, 141, 163, 57}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 150, 196, 105, 123}, 58},
	{{111, 214, 0, 0, 160, 27, 218, 189, 24, 30, 6, 92, 255, 26, 66, 64}, 58},
	{{111, 214, 0, 0, 0, 0, 205, 73, 2, 28, 70, 201, 109, 194, 223, 107}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 78, 94, 0, 161, 227, 128}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 180, 115, 5, 111, 219, 190}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 136, 255, 253}, 58},
	{{111, 214, 0, 84, 33, 209, 98, 179, 219, 211, 49, 55, 225, 2, 68, 47}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 153, 27, 30}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 168, 59}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 41, 104, 106, 215, 208, 43, 113}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 80, 196, 149, 165, 89, 107, 211}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 53, 222}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 176, 207, 238, 230, 70, 65}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 114, 34, 119, 193, 137, 2, 137}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 27, 253, 169, 102, 29, 233}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{111, 214, 0, 0, 0, 114, 121, 178, 219, 117, 93, 138, 43, 171, 88, 74}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 23, 51, 204, 239, 1, 19, 145, 93}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 110, 231, 147, 216}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 187, 28, 99}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{111, 214, 0, 15, 212, 45, 219, 89, 47, 104, 209, 41, 91, 93, 227, 172}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 184, 35, 198, 57}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 234, 160, 168, 16, 143, 5}, 58},
	{{111, 214, 0, 0, 0, 110, 186, 64, 3, 181, 38, 144, 57, 142, 28, 203}, 58},
	{{111, 214, 0, 128, 201, 47, 142, 164, 65, 229, 67, 128, 52, 140, 91, 42}, 58},
	{{111, 214, 0, 149, 1, 225, 152, 3, 211, 143, 210, 119, 121, 50, 15, 43}, 58},
	{{111, 214, 0, 0, 174, 165, 145, 43, 197, 13, 168, 4, 164, 133, 183, 110}, 58},
	{{111, 214, 0, 0, 0, 161, 163, 153, 148, 250, 64, 143, 11, 167, 149, 108}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 121, 238, 48, 158}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 136, 196, 27, 78, 94, 172}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 16, 154, 93, 245, 245, 185, 96, 97}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 235}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 175}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 58},
	{{111, 214, 0, 0, 0, 0, 237, 241, 172, 161, 134, 139, 153, 134, 50, 113}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 31, 113, 23, 52, 57, 104, 107}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 207, 221, 206, 245, 165, 214, 128}, 58},
	{{111, 214, 0, 38, 192, 11, 225, 46, 223, 68, 85, 193, 158, 8, 105, 185}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 120, 253, 221, 213, 216, 169, 204, 135}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 72}, 58},
	{{111, 214, 0, 0, 0, 236, 97, 132, 109, 176, 208, 243, 18, 113, 110, 88}, 58},
	{{111, 214, 0, 0, 0, 17, 158, 0, 99, 33, 27, 184, 150, 202, 11, 43}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 216, 196, 114, 220, 158, 75, 156}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 133, 122, 54, 138, 138, 52}, 58},
	{{111, 214, 0, 0, 141, 183, 37, 88, 162, 96, 31, 110, 180, 96, 41, 118}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 245, 20, 22}, 58},
	{{111, 214, 0, 0, 0, 113, 211, 51, 72, 188, 104, 26, 18, 116, 101, 211}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 131, 101, 204}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{111, 214, 0, 221, 113, 77, 199, 250, 49, 51, 227, 237, 135, 197, 23, 173}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 144, 232, 93}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 58},
	{{111, 214, 0, 182, 151, 225, 12, 194, 139, 150, 138, 73, 145, 193, 226, 96}, 58},
	{{111, 214, 0, 0, 0, 0, 174, 72, 103, 0, 191, 214, 184, 6, 21, 88}, 58},
	{{111, 214, 0, 0, 0, 64, 84, 225, 209, 133, 109, 69, 250, 97, 229, 8}, 58},
	{{111, 214, 0, 64, 254, 142, 56, 17, 182, 220, 232, 197, 16, 103, 148, 75}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 9, 82, 100, 223, 168, 115}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 140, 13, 95, 23, 244, 4, 107, 50, 244}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 126, 131, 16, 43, 93, 17, 189, 79}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 58},
	{{111, 214, 0, 0, 0, 0, 199, 142, 10, 47, 204, 66, 90, 50, 159, 132}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 2, 34, 182}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 163, 133, 73, 223, 230, 18, 62}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 242, 82, 99}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 73, 131, 165, 171, 233, 148}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 94, 35, 2}, 58},
	{{111, 214, 0, 0, 0, 239, 41, 243, 129, 222, 121, 177, 222, 208, 190, 96}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 198}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 101, 180, 84, 146}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 236, 245, 195, 219, 72, 17, 236}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 48, 194}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 114, 131, 109, 8}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 11, 105, 201, 117, 134, 8, 51, 119}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 161, 169, 148, 46, 216, 22, 14, 25}, 58},
	{{111, 214, 0, 151, 19, 146, 225, 171, 26, 192, 198, 239, 221, 143, 55, 172}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 29, 2, 215, 49, 24, 65, 60, 133}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 236, 45, 73, 214}, 58},
	{{111, 214, 0, 0, 0, 0, 173, 92, 11, 16, 28, 231, 41, 35, 68, 233}, 58},
	{{111, 214, 0, 16, 197, 51, 107, 111, 46, 102, 171, 254, 130, 181, 116, 224}, 58},
	{{111, 214, 0, 0, 144, 33, 9, 41, 37, 48, 230, 32, 210, 28, 106, 219}, 58},
	{{111, 214, 0, 156, 30, 176, 90, 110, 99, 70, 167, 102, 162, 213, 164, 171}, 58},
	{{111, 214, 0, 0, 15, 108, 115, 240, 223, 111, 213, 96, 90, 83, 183, 113}, 58},
	{{111, 214, 0, 99, 115, 10, 224, 140, 81, 50, 188, 128, 61, 24, 197, 73}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 61, 81, 189, 237, 180, 27, 6, 173, 167}, 58},
	{{111, 214, 0, 0, 34, 200, 139, 60, 210, 60, 235, 103, 240, 128, 5, 36}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 186, 138, 39, 183, 229, 113, 214, 153}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 166, 23, 234, 33, 232, 18}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 44, 182, 132}, 58},
	{{111, 214, 0, 0, 0, 97, 127, 13, 211, 39, 119, 90, 166, 32, 5, 252}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 242, 199, 184, 232}, 58},
	{{111, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 97}, 58},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 178, 75, 221, 23, 87, 225}, 254},
	{{162, 23, 52, 64, 0, 150, 186, 146, 135, 28, 50, 114, 13, 119, 74, 91}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 174, 174, 145, 162, 41, 57, 242}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 89, 36, 233, 136, 189, 169, 56}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 149, 221, 125, 26, 16}, 254},
	{{162, 23, 52, 64, 0, 0, 70, 162, 48, 65, 135, 151, 64, 42, 127, 32}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 21}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 33, 207, 109, 84}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 180, 237, 247, 164, 125}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 221, 10, 82, 176, 104, 238, 137}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 44, 253, 138, 58, 204, 64}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 30, 58, 100, 218, 66, 81, 120}, 254},
	{{162, 23, 52, 64, 3, 5, 236, 208, 10, 156, 199, 169, 205, 56, 247, 115}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 103, 48, 216, 163, 25, 172, 152, 227}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 90, 15, 115, 41, 61, 63, 150, 77, 56}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 36, 119, 82, 90, 189, 138}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 73, 38, 184, 158, 145, 108}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 118, 69, 35, 139}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 76, 234, 240, 7, 167, 236, 28}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 40, 106, 31, 172, 147, 51, 49, 203}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 136, 196, 247, 23}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 198, 35, 189, 71, 4}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 87, 58, 136, 60, 215, 204, 76, 101, 238}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 53, 250, 124, 232, 45}, 254},
	{{162, 23, 52, 64, 0, 0, 39, 88, 218, 207, 225, 143, 251, 181, 33, 182}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 71, 176, 119, 71, 232}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 43}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 243, 148, 76, 46, 28, 233, 88, 28, 151}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 44, 141, 14, 193}, 254},
	{{162, 23, 52, 64, 162, 117, 222, 113, 71, 246, 123, 153, 149, 92, 40, 19}, 254},
	{{162, 23, 52, 64, 0, 0, 199, 166, 204, 224, 186, 156, 58, 35, 220, 190}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 177}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 126, 57, 75, 89, 5, 23, 91}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 108}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 161, 22, 142, 55, 179, 38, 100}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 128, 34, 226, 88, 132, 114}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 66, 1}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 26, 217, 51, 23, 239, 231, 28, 161}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 195, 92, 11, 177}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 184}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 16, 188, 90, 207, 179, 14}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 55, 157, 5, 16, 80, 91, 186, 139}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 130, 53, 194, 124, 66, 20, 222, 128, 213}, 254},
	{{162, 23, 52, 64, 0, 0, 219, 235, 90, 240, 174, 119, 169, 119, 77, 100}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 250, 160, 52, 158, 5, 182, 113, 89}, 254},
	{{162, 23, 52, 64, 0, 165, 54, 36, 174, 59, 157, 53, 12, 10, 55, 139}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 114, 69}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 124, 22}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 170, 8, 191, 12, 224, 221, 17, 145, 113}, 254},
	{{162, 23, 52, 64, 0, 0, 245, 175, 70, 120, 225, 142, 234, 113, 155, 196}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 142, 71, 233, 193}, 254},
	{{162, 23, 52, 64, 0, 0, 13, 252, 129, 239, 206, 246, 96, 81, 244, 250}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 157, 203, 193, 133, 5, 21, 238}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 34, 54, 111, 184, 195, 121, 240}, 254},
	{{162, 23, 52, 64, 0, 0, 52, 106, 3, 77, 90, 117, 193, 157, 144, 83}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 216, 76, 47, 177, 134, 182, 145, 74, 253}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 6, 93, 113, 119, 229, 177, 66, 17}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 248, 62, 10, 219, 144, 247}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 70, 140, 10, 10, 81, 96, 149, 137}, 254},
	{{162, 23, 52, 64, 0, 161, 103, 184, 176, 79, 74, 35, 116, 127, 241, 249}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 170, 76, 76, 103, 95, 230, 65, 115, 73}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 235, 74, 53, 144, 61, 179, 104, 9}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 120, 149, 113, 247, 236}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 45, 246, 51, 228, 57}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 208, 219, 8, 43, 134, 136, 48}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 121, 153, 108, 5, 63, 92, 25, 82, 139}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 155, 122, 8, 77, 200}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 87, 51, 126, 195, 231, 143, 211}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 72, 176, 59, 156, 6, 39, 226, 254, 164}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 131, 176}, 254},
	{{162, 23, 52, 64, 167, 246, 183, 187, 82, 175, 187, 18, 253, 184, 254, 62}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 31, 212, 254, 26, 194, 223, 65, 219, 165}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 242, 66, 242, 63, 200}, 254},
	{{162, 23, 52, 64, 93, 246, 189, 72, 230, 19, 114, 168, 61, 27, 81, 13}, 254},
	{{162, 23, 52, 64, 44, 148, 49, 122, 151, 253, 31, 108, 233, 205, 84, 218}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 58, 140, 246, 154, 203, 195}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 253, 153, 253, 149, 46, 113, 146}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 33, 169, 136, 42, 234, 140, 237, 235}, 254},
	{{162, 23, 52, 64, 0, 0, 125, 128, 235, 235, 122, 10, 97, 142, 148, 219}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 3, 50, 95, 75, 43, 224}, 254},
	{{162, 23, 52, 64, 73, 81, 136, 7, 128, 150, 39, 103, 111, 162, 207, 25}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 55, 54, 165, 248, 102, 153, 52, 17}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 144, 154, 1, 18, 115}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 222, 154, 16, 11, 140, 242, 195}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 196, 220, 11, 157, 101, 101}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 111, 75, 36, 150}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 29, 0, 39, 124, 164, 113, 45}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 110, 202, 160, 210, 99, 245, 2, 134, 145}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 254},
	{{162, 23, 52, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 254},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 242}, 148},
	{{76, 103, 44, 79, 0, 0, 106, 178, 10, 117, 75, 248, 93, 202, 19, 151}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 36, 133, 31, 134, 25, 161, 232, 90, 80}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 33, 81, 225, 245}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 245, 40, 220, 50, 119, 42}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 218, 137, 0, 88}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 172, 27, 233, 42, 36, 253, 86, 58}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 214, 7, 71, 5, 230}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 45, 245, 192, 150, 30, 220, 164}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 210, 11, 136, 212, 67}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 154, 20, 134, 220}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 66}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 95, 103, 207, 4, 161, 246, 78, 218}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 41, 207, 196, 60, 204, 203}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 177, 241}, 148},
	{{76, 103, 44, 79, 0, 0, 53, 211, 139, 32, 189, 242, 211, 197, 126, 126}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 255, 224, 228, 126, 217, 229, 13, 62, 103}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 27}, 148},
	{{76, 103, 44, 79, 0, 0, 85, 112, 190, 25, 51, 19, 143, 155, 253, 144}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 169, 20}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 33}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 27, 155, 204, 24, 95, 251, 120, 84, 54}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 228, 156, 48, 77, 4}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 214, 69}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 99, 104, 240, 80}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 95, 188}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 41, 237, 182, 136, 205, 98}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 108, 108, 181, 226, 237, 23}, 148},
	{{76, 103, 44, 79, 0, 134, 143, 171, 252, 222, 15, 165, 216, 80, 214, 239}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 237, 190, 210, 22, 150, 211, 158}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 167, 127, 177, 141, 200}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 28, 8, 221, 226, 77, 217}, 148},
	{{76, 103, 44, 79, 0, 0, 196, 15, 168, 69, 88, 226, 231, 120, 112, 217}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 145, 40}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 123, 128}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 95, 70, 169, 153, 9, 175, 162, 45, 199}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 126, 42}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 59}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 247, 245, 42, 185, 140, 34, 155, 239, 226}, 148},
	{{76, 103, 44, 79, 0, 242, 5, 86, 63, 6, 194, 111, 12, 25, 91, 96}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 187, 156}, 148},
	{{76, 103, 44, 79, 0, 0, 101, 5, 105, 99, 13, 196, 44, 63, 84, 132}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 175, 66, 185, 182, 253, 23, 18, 74, 84}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 138}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 22, 15, 223, 218, 134, 32, 224}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 243, 141, 62, 209}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 228, 107, 50, 115, 79, 243, 163, 53}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{76, 103, 44, 79, 0, 0, 132, 33, 195, 215, 112, 165, 170, 215, 156, 85}, 148},
	{{76, 103, 44, 79, 0, 0, 142, 16, 233, 208, 193, 39, 70, 207, 126, 80}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 188, 230, 187, 10, 120, 46, 207}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 144, 116}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 145, 230, 16, 184, 231, 210, 64}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 171, 26, 93, 188, 220, 150, 180}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 136, 168, 238, 88, 78, 90, 54}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 147, 91, 33, 2, 80, 184, 141, 181}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{76, 103, 44, 79, 0, 0, 234, 134, 105, 74, 83, 191, 234, 233, 45, 225}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 61, 191, 199, 54, 212}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 49, 230, 201, 79, 80, 141, 21}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 44}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{76, 103, 44, 79, 0, 0, 197, 43, 89, 212, 214, 235, 201, 131, 86, 142}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{76, 103, 44, 79, 0, 0, 106, 206, 24, 227, 215, 138, 198, 247, 175, 95}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 229, 122, 88, 151, 198}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 93, 69}, 148},
	{{76, 103, 44, 79, 0, 0, 45, 136, 59, 44, 163, 253, 176, 122, 89, 79}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 51, 187}, 148},
	{{76, 103, 44, 79, 0, 90, 41, 142, 40, 3, 230, 126, 119, 185, 240, 62}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 213}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 132, 34, 50, 164, 162, 44, 67, 241}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 222}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 79, 100, 76, 239, 225}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 52, 75, 187, 217}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 222, 172, 122, 190, 47, 158, 140, 13, 197}, 148},
	{{76, 103, 44, 79, 0, 0, 98, 77, 172, 126, 98, 89, 164, 24, 27, 60}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 29}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 197, 224, 61, 241, 179}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{76, 103, 44, 79, 0, 80, 159, 112, 49, 18, 246, 69, 72, 49, 78, 182}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 120, 216, 83, 143, 228, 57, 199, 63, 243}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 88, 123, 142, 229, 216, 215, 24}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 226, 107}, 148},
	{{76, 103, 44, 79, 0, 0, 0, 0, 87, 226, 46, 153, 199, 187, 188, 162}, 148},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 85, 219, 214, 12, 4, 65, 129, 162, 148, 208, 78, 39, 69, 94, 184}, 126},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{80, 54, 251, 28, 152, 23, 244, 192, 151, 83, 6, 144, 223, 213, 224, 128}, 76},
	{{39, 232, 237, 103, 191, 188, 36, 0, 236, 22, 156, 13, 228, 251, 121, 235}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 88, 58}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 142, 12, 227, 71, 95, 170, 55, 245, 59}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 44, 239, 48, 39, 88}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 168, 189, 238, 20}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 68, 57}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 71, 161, 239, 15, 11, 127, 125, 217}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 167, 152, 113}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 16}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 19, 230, 28, 72, 11, 139, 74}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 114, 58, 55, 28, 204, 85, 184, 24}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 200, 213, 211}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 221, 205}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 15, 224, 166, 84, 85, 58, 44}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 36, 82, 118, 95, 213, 56}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 33, 130}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 9, 1}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 233, 166, 218}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 160, 103}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 244, 250, 239, 242}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 91, 219, 170, 180, 179, 139}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 126, 30}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 237, 203, 146, 229, 183, 112, 218, 195}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 228, 2}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 190}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 131, 233, 234, 233, 36}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 162, 32, 10, 197, 44}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 98, 41, 115, 5, 154, 251, 206, 5}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 173, 190, 170, 132, 53}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 229, 224, 203, 120, 57, 1, 212, 196}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 110, 140, 231, 100}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 240, 133, 151, 252, 57, 194, 177}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 13, 78, 9}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 47, 39, 151, 34}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 173, 129, 196, 163, 142, 155, 141}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 40, 43, 213, 221, 173, 159, 140, 190}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 216, 206}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 51, 198, 1, 53, 233, 177, 167}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 220, 190, 48}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 144, 116, 6, 87, 13, 114, 50, 121}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 25, 181, 3, 68, 208, 3, 197}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 13, 16, 61, 236, 78, 189}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 64, 87, 26, 78}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 83, 58, 36, 42, 168, 163, 150, 53}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 139, 50, 76, 87, 250, 96, 207}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 227, 27}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 25, 24}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 237, 179, 88, 69, 48, 98}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 92, 229, 95}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 42, 249}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 77, 181, 50}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 238, 96, 33, 153}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 129, 120, 38, 123}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 206, 177, 154, 221, 231, 230, 184, 174}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 76, 206, 238, 76, 231, 57, 70, 146}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 175, 17}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 39, 110, 0}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 214, 178, 185, 199}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 183, 47, 28, 66, 139, 48, 36, 165}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 98, 157, 36, 241, 194, 132, 67, 123, 114}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 218, 74, 34}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 122, 191, 142, 129, 133, 37, 146}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 105, 157, 49, 81, 251, 137, 206, 30}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 46, 44, 41, 222, 26, 194}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 123}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 161, 125, 155, 240, 118, 147}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 57, 155, 6, 163, 219}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 13, 213, 249, 161}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 128, 188, 35, 224, 222, 210}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 7, 44, 115, 0, 64}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 191, 201, 28, 221}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 225, 245, 156, 184, 174, 170, 231, 66}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 112, 109, 205, 62, 172, 72, 122}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 94, 208, 61, 222, 183, 88}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 140, 224}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 205, 170, 59}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 185, 198, 62}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 82, 174}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 225, 113, 148, 162}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 47, 222, 79, 26, 65, 110, 178}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 226, 176, 22, 213, 49, 92, 90}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 247, 103, 147}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 116, 210, 56, 112, 100}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 151, 135, 223, 129, 41, 48}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 89, 190, 224, 33}, 240},
	{{39, 232, 237, 103, 191, 188, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 206, 248}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 139, 155, 44}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 218, 11, 237}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 114, 5, 58, 58}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 198, 11, 255, 218, 14, 27}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 3, 173, 59, 80, 27, 226, 218}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 144, 157}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 174, 14, 193}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 199, 11, 243, 168, 252, 241, 134, 3}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 118, 239}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 117, 145, 175, 81}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 159, 171, 83, 146, 201, 102, 85, 94}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 203, 118, 177, 36, 187, 118}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 196, 177, 102, 199, 237}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 77, 196, 98, 32}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 34, 45}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 111, 202, 156, 25}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 72, 108, 163}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 247, 51, 20, 252}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 246, 204, 205, 108, 228, 165, 83}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 96, 113, 149, 32, 200, 162, 248, 66}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 241, 124, 114, 20, 95}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 200, 0, 21, 211, 114}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 15, 4, 241, 25}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 49, 77, 73}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 159, 74, 60, 149}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 166, 29, 162, 32, 235, 136, 216, 24, 179}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 4, 50, 78, 204, 23, 2, 59, 90}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 130}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 185, 229}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 142, 138, 218, 162}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 158, 199, 211, 240, 4, 125, 56, 107}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 6, 7}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 194, 222, 0, 195, 225}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 137, 21, 152, 17, 157, 162}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 117, 94}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 154, 32}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 172, 133, 97, 52, 141}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 19, 15, 255}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 62, 133, 86, 130}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 78, 104, 140, 88, 27, 143, 181, 160}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 151, 160, 150, 155, 253, 43}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 135, 43, 220, 108, 160, 211}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 225, 71}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 142, 253, 188, 27, 147, 93, 43, 132}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 41, 129, 87, 79, 183, 126, 45, 218, 116}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 125, 218, 190, 136, 198, 136, 180, 113}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 91, 201, 10, 126, 132, 184, 99}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 217, 126}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 74, 180, 22, 62, 239, 125, 28}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 86, 67, 188, 15, 6, 167, 26, 70, 36}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 35, 9, 193}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 247, 151, 38, 107}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 246, 212, 193, 189, 178, 138, 135}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 211, 212, 2, 149, 202, 219, 211}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 138, 208, 247, 38, 54}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 33, 121, 176, 243, 216, 147, 104}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 66, 145, 42, 176, 4, 64, 30, 14}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 215, 30, 91, 242, 255, 72}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 47, 84}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 77, 25, 215, 39, 117, 39, 194}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 250, 38}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 109, 146}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 9, 169, 121, 84, 65, 180}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 93, 38, 143, 150, 26, 123, 236}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 190, 104, 148, 34}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 196, 133, 139}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 220, 208, 235, 4, 58, 14, 243, 103}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 45, 221, 162, 105, 55, 230, 211}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 153, 203, 245, 163, 180, 96, 217, 55}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 214, 103, 169, 162, 216, 154, 202}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 153}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 233, 44, 10}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 175, 167}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 202, 161, 34, 139, 227, 201}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 254, 27}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 0, 0, 175, 214}, 33},
	{{20, 231, 89, 210, 167, 173, 80, 0, 0, 0, 0, 0, 119, 233, 149, 201}, 33},
	{{125, 67, 198, 128, 0, 51, 236, 50, 245, 53, 235, 175, 239, 223, 210, 197}, 47},
	{{125, 67, 198, 128, 0, 123, 130, 151, 79, 15, 162, 141, 183, 139, 116, 109}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 103}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 200, 182, 110, 217, 79, 65}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 83}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 61, 139, 195, 163}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 245, 175, 109, 154, 84, 107}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 155, 179, 57, 123, 236, 13, 72}, 47},
	{{125, 67, 198, 128, 0, 176, 60, 244, 130, 230, 212, 183, 244, 127, 153, 122}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 191, 165, 129, 83, 121, 117, 200, 109}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 121, 164, 12, 224, 219, 157, 146}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 98}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 143, 114, 198, 133, 234, 130, 63, 196, 239}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 30, 175, 166, 221, 139}, 47},
	{{125, 67, 198, 128, 0, 41, 219, 66, 241, 9, 37, 146, 173, 73, 28, 4}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 114, 193, 59, 113, 210, 165, 233, 22}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 143, 182, 47, 49, 74}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 155, 185}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 165, 228}, 47},
	{{125, 67, 198, 128, 112, 21, 4, 158, 195, 45, 163, 62, 20, 100, 186, 5}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 211, 2, 25, 253, 94, 74, 109, 170, 38}, 47},
	{{125, 67, 198, 128, 0, 0, 159, 153, 156, 168, 53, 238, 255, 146, 137, 29}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 4, 231, 171, 85, 109}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 231, 186, 10, 86, 24, 123, 200, 55}, 47},
	{{125, 67, 198, 128, 140, 239, 17, 231, 130, 166, 2, 163, 83, 208, 173, 160}, 47},
	{{125, 67, 198, 128, 0, 0, 95, 172, 121, 175, 29, 83, 8, 248, 194, 131}, 47},
	{{125, 67, 198, 128, 0, 8, 88, 167, 92, 52, 230, 243, 136, 43, 79, 205}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 194, 145, 242, 6, 236, 41, 251}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 255, 73, 219, 185, 234, 37, 245}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 229, 34}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 12, 49}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 203, 248}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 97, 252, 211, 247, 47, 241, 153, 191}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 200, 77, 114, 204}, 47},
	{{125, 67, 198, 128, 0, 0, 79, 128, 27, 62, 112, 234, 178, 121, 249, 226}, 47},
	{{125, 67, 198, 128, 0, 116, 159, 77, 238, 160, 17, 236, 106, 118, 41, 77}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 49, 165, 62, 55, 25, 161, 106, 130, 130}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 147, 2, 180, 66, 19, 156, 155}, 47},
	{{125, 67, 198, 128, 0, 168, 200, 112, 70, 206, 145, 101, 253, 239, 57, 158}, 47},
	{{125, 67, 198, 128, 0, 0, 142, 93, 28, 245, 23, 128, 250, 95, 142, 45}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 111}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 110, 98, 113, 217, 155, 120, 230}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 206, 110, 72, 194, 185}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 194, 80, 227, 214, 74, 169, 232, 221}, 47},
	{{125, 67, 198, 128, 0, 108, 79, 7, 96, 93, 204, 175, 199, 136, 30, 224}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 27, 129, 119, 241, 67}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 118, 209, 111, 44, 98, 98, 251}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 99, 156, 235, 243, 70, 8, 55, 245, 59}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 244}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 141, 24, 241, 193, 135, 206}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 24, 216, 15, 16, 151, 155, 153, 195}, 47},
	{{125, 67, 198, 128, 0, 0, 121, 207, 72, 33, 10, 2, 156, 189, 247, 247}, 47},
	{{125, 67, 198, 128, 0, 0, 69, 84, 217, 50, 169, 88, 186, 140, 13, 206}, 47},
	{{125, 67, 198, 128, 214, 24, 110, 56, 93, 254, 217, 223, 3, 24, 22, 58}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 3, 107, 158, 73, 244, 214, 97, 208}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 185, 232, 236, 19, 253, 146, 149, 148, 215}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 177, 185}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 54, 224, 19, 143, 58, 82, 95}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 172, 113, 231, 218, 49, 51, 254, 70, 240}, 47},
	{{125, 67, 198, 128, 127, 3, 105, 9, 142, 172, 73, 124, 196, 16, 4, 36}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 153, 134, 214, 8, 162, 253, 205, 17, 54}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 243, 232, 25, 139, 31, 211, 91}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 44, 239}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 237, 224, 201, 62}, 47},
	{{125, 67, 198, 128, 193, 76, 184, 147, 146, 166, 231, 127, 33, 18, 32, 211}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 182, 122, 2, 44, 196, 226, 37, 232, 118}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 63, 150}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 123, 130, 2, 103, 121}, 47},
	{{125, 67, 198, 128, 0, 0, 210, 18, 175, 3, 214, 18, 102, 22, 187, 103}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 127, 56, 47, 115, 46, 24, 200, 148, 189}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 144, 108, 131, 120, 194, 251}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 12, 192, 114, 130, 135, 172}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 198, 31, 46, 234, 211, 255}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 50, 125, 118, 154, 54, 42}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 42, 170, 112, 26, 123}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 39}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 60, 248, 73, 174, 194, 55, 132, 104}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 203, 14, 80, 114, 175, 109, 239, 187, 31}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 28, 244}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 254, 237, 13, 159, 168, 227, 235, 31}, 47},
	{{125, 67, 198, 128, 50, 197, 56, 239, 139, 144, 243, 166, 221, 153, 107, 90}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 51}, 47},
	{{125, 67, 198, 128, 0, 0, 19, 240, 125, 35, 174, 76, 57, 31, 74, 31}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 173, 0, 66, 107, 8, 40, 23}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 210, 92, 109, 199, 163, 32}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 214}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{125, 67, 198, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 97}, 47},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 123}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 98}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 126}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 97, 106}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 241}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 102}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 165}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 135}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 157}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 249}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 47}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 5}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 53}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 10}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 31, 80}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 238, 230}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 213}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 157}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 67}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 205}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 250}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 116}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 36}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 157, 231}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 105}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 255}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 88, 183}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 118}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 73, 128}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 130}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 64}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 175}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 23}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 158, 212}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 190}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 109, 33}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 214}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 174}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 203}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 183}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 23, 133}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 73}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 40}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 130, 172}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 206}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 191, 138}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 148}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 96}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 11}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 42}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 14}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 227}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 18}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 247}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 0}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 48, 134}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 0, 90}, 41},
	{{26, 239, 153, 5, 213, 121, 31, 114, 161, 46, 84, 15, 148, 160, 252, 96}, 41},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 83}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 195, 167, 229, 0, 231}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 74, 212, 71}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 104, 16, 246, 32}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 192, 32, 4, 165, 46, 103, 106}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 167, 203, 226, 115, 126, 48, 97}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 22, 37, 52, 89, 222, 47}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 54, 233, 50, 108, 241, 231}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 112, 188, 199, 116}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 107, 205, 98, 184, 17}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 220, 46, 140, 183, 17, 50}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 190, 44, 105, 240, 40}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 160}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 202, 197}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 184}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 196, 73, 35, 53, 85}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 249, 252, 248}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 215}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 14, 4, 241, 138, 246, 164, 136}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 141, 244, 242, 32}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 36, 75, 10, 207, 99, 77}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 182, 228, 205, 84, 14, 132}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 150, 28, 21, 41, 142}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 107, 134, 3}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 112}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 140, 18, 0, 127, 2, 189, 86, 112}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 237, 110, 206}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 211, 113, 207}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 59, 51, 19, 1, 21}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 248, 91}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 33}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 252, 57, 103, 39}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 177, 220, 145, 147, 100, 88, 249}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 52}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 53, 76, 7, 96, 57, 23}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 58, 190, 228}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 224}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 107, 182, 78, 93}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 52}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 245, 179, 236, 109, 103, 157}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 73, 47, 133, 50}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 59, 63, 58, 159, 94, 215}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 194, 140, 14, 69}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 76}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 188, 123, 140, 179, 172}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 195}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 113, 184, 207, 15, 222}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 116, 140, 238, 179, 194, 219}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 133, 173, 234, 10, 86}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 47, 233, 224, 141, 105}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 135, 245}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 34, 220, 113, 163, 1}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 64, 11, 120}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 50, 209}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 169, 68, 76, 239, 234, 104, 183}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 243, 187, 243, 56, 155}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 200, 184, 75, 31, 251, 150, 209, 86}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 58, 158, 160, 7, 130, 197}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 154, 242, 156, 107, 159, 26}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 8, 210, 33, 182}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 216, 144, 10}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 166, 99, 53, 72}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 112, 201}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 195}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 152, 146, 100, 3, 22, 59, 206}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 163}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 254, 172, 108, 78, 197, 84}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 123, 12, 20, 132, 33, 104, 252, 224}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 242, 120, 116, 224, 184}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 74, 15}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 81, 90, 150, 192, 166, 6, 85}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 252}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 197, 157}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 172, 245}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 111}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 228, 202, 24}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 101, 80, 152, 37, 44, 123, 170}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 105}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 65}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 70, 155, 46, 118, 133, 196}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 43}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 216, 62, 179}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 170, 217, 141}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 160, 213, 211, 57, 92}, 72},
	{{102, 212, 159, 118, 223, 115, 134, 172, 0, 0, 0, 0, 0, 0, 0, 86}, 72},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 251, 74, 117, 181, 138, 180, 43, 77}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 95, 166}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 171, 70, 221, 173}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 72, 25}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 8, 153, 79, 221, 45, 149}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 124, 25, 103, 228, 100, 66, 189, 72, 213}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 220, 182, 154, 28, 237, 182, 42, 77, 85}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 114, 184, 209}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 228, 0, 189, 153, 157, 229, 180}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 125, 16}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 127, 80, 141, 82, 7}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 243, 81, 80, 199, 141}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 9, 183, 69, 158, 66, 233, 111}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 220, 94, 35, 251, 104}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 22, 195, 83, 232, 255, 120, 106, 211}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 182, 20, 113, 254, 132, 201}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 201, 246, 223, 234, 143}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 240, 88, 162, 175, 138, 160, 145, 109}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 1, 26}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 119, 196, 139, 163, 216, 215, 184, 24}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 254, 51, 206, 91, 133, 56, 252, 71}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 30, 250, 231, 206}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 85, 241, 93, 255, 55}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 52, 190, 220, 98}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 180, 147}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 74, 242}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 106, 41, 108, 84, 168, 7, 24, 170}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 175, 141}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 119, 61, 102, 102, 186, 116, 102, 4, 122}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 68, 163, 19}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 119, 195, 248, 106}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 64, 230, 11, 34, 182}, 43},
	{{85, 181, 241, 127, 3, 44, 115, 251, 62, 149, 150, 149, 81, 206, 10, 12}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 119, 38, 167, 103, 41, 209, 82, 227}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 175, 174, 128, 236, 97, 19, 113}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 63, 238, 215}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 215, 5, 143, 3}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 153, 69, 56, 96, 68, 44, 7}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 146, 69, 162, 195, 69, 50, 101, 185}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 118, 155, 180, 201, 159, 100, 14, 122}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 182, 53, 141, 44, 116, 161, 96, 55}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 155, 130}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 25, 63}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 98, 219, 149, 225, 66, 107}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 154, 133, 70, 10, 11, 146, 85, 202}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 195, 222, 136, 247, 124, 47, 23, 90}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 22, 222, 244, 73, 49, 72, 223, 31, 236}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 113, 175, 252, 21}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 134, 18, 159}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 218, 223, 225, 244, 210, 150, 26, 104, 236}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 88, 240, 186}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 13, 152, 56, 207}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 84, 241, 8, 190, 169, 37}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 151, 47, 121, 48, 53, 3, 68, 229, 51}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 56, 154, 141, 52, 210}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 48, 146, 108}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 208, 47, 162, 64, 40, 176, 141, 78}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 160, 137, 96, 169, 89, 188, 183}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 193, 105, 80}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 183, 85, 0, 110}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 245, 52, 196, 98, 196, 255}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 32, 44, 14, 189, 250, 211}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 199, 187, 100, 173, 201, 48}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 71, 224, 240, 150, 53, 238, 36}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 62, 149, 79}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 100, 176, 36, 67, 165, 127, 220}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 117, 163, 89, 227, 180, 133, 86, 132, 15}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 140, 235, 246, 49, 20, 163}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 173, 11, 172, 98, 46}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 92, 73}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 147, 8, 35}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 234, 220, 42, 44}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 201, 112, 209, 1, 78, 149, 33, 84}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 71, 194, 204}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 214, 34, 111, 50, 20, 74, 33, 166}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 43},
	{{85, 181, 241, 127, 3, 44, 0, 250, 232, 174, 149, 130, 250, 135, 253, 182}, 43},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 22, 171, 129, 71, 184, 231, 14}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 81, 133, 6, 84, 146, 99, 6}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 162, 77, 88, 119}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 58, 61, 160, 206, 150}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 126, 192, 250}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 194, 84}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 211, 146, 29, 191, 138}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 213, 125, 204}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 198}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 91}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 183, 44, 51, 16, 110, 120}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 154, 230, 17, 184}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 24, 185}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 240, 139, 214, 60}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 206, 139, 243}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 226, 254}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 93, 96, 250, 240}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 42, 129}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 4, 180, 80, 2}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 153, 178, 222}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 126, 167, 185}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 43}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 100, 161, 60}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 134, 212, 224, 248, 130}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 242, 78, 181, 65, 111}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 134, 134, 0, 50}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 213, 179, 88, 226, 160}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 220, 94, 169}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 1, 205, 201, 78, 163}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 206, 27, 3, 115, 174, 248}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 156, 80, 100}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 85, 8, 44, 60, 49, 124}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 86, 236, 172, 54, 206}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 88, 64, 171, 132, 59, 214, 3}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 34, 199, 146, 126, 178, 137}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 240, 86}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 65, 22}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 244}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 161}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 118, 221, 2, 177}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 217}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 181, 6, 94, 18}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 129}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 170}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 1, 157, 35, 205, 154, 128}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 9, 74, 209, 21, 102, 26}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 248, 63, 2, 205, 176}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 180, 183, 123}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 35, 232, 250, 3, 191}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 68, 130, 251, 75, 149, 126, 222}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 18, 143, 52, 2}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 175, 167, 63, 80, 7}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 206, 235}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 177, 20, 126, 64, 152}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 170, 233, 190}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 33, 177, 248, 20, 226, 42, 64}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 181, 147}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 97, 14, 164, 52, 50, 86}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 89, 105, 39, 125}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 176, 247, 74, 7, 184, 2, 174}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 21, 114, 251, 68, 67}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 185, 201, 113, 236, 192, 7}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 87, 176, 112, 51}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 27, 92, 34, 132, 22, 71}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 64, 41, 70, 78}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 98, 4, 102, 136, 208}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 178}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 220, 162, 162, 250, 78, 107}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 245, 80, 48, 72, 232}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 100, 121, 222, 107, 191, 245}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 36, 117, 56, 35, 205}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 152, 218, 211, 162, 208, 81}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 182, 207}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 14, 84, 235, 54, 179, 117, 44}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 236, 190, 198, 182, 103, 246, 196}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 236, 82, 97}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 109, 35, 145, 125}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 155, 51, 243, 91}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 251, 190, 117, 138}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 103, 214, 146, 8, 142, 184, 104}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 202, 123, 53, 85}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 146, 2, 147, 62, 72, 17}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 15, 235, 39, 104, 235, 63}, 26},
	{{61, 199, 131, 226, 3, 230, 94, 119, 240, 0, 0, 0, 0, 25, 140, 18}, 26},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 196, 118, 233, 149}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 113, 136, 60, 156, 221}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 83, 229, 95, 229, 224, 137, 60}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 204, 27}, 139},
	{{0, 143, 160, 184, 162, 192, 167, 216, 55, 204, 199, 49, 207, 154, 113, 176}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 202, 148, 117, 218, 189, 147, 230, 111, 81}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 110, 19, 42, 88, 62, 181}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 117, 78, 191, 241, 11}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 72, 216, 225, 38, 13, 201, 214, 98, 89}, 139},
	{{0, 143, 160, 184, 162, 192, 5, 236, 22, 190, 99, 222, 168, 78, 215, 209}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 168, 79, 218, 86}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 245, 151, 56, 40, 219, 88, 228, 46, 24}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 147, 97}, 139},
	{{0, 143, 160, 184, 162, 192, 189, 117, 254, 89, 111, 110, 155, 213, 245, 139}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 200, 13, 115, 249, 128, 153, 69, 253, 92}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 95, 116, 65, 195, 160, 76, 61, 174}, 139},
	{{0, 143, 160, 184, 162, 192, 97, 227, 187, 148, 219, 178, 107, 66, 13, 212}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 112, 128}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 59, 43, 176, 121, 136, 116, 206, 169, 254}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 45, 209, 74, 21, 76, 186, 0, 191, 43}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 28, 223, 225, 200}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 172, 202, 23, 197, 37, 148}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 30, 145, 148, 208, 120, 151, 150, 254, 249}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 139},
	{{0, 143, 160, 184, 162, 192, 102, 44, 118, 226, 215, 231, 29, 232, 33, 176}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 172, 89, 7, 104, 169}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 158, 177, 35}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 210, 194, 175}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 221, 148, 78, 174, 156, 53}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 140, 216, 245, 114, 169, 125, 221, 93, 217}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 31, 255, 169, 123, 172, 62, 151, 57}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 38, 81, 9, 172, 90, 194, 119, 246, 188}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 246, 79, 157, 102, 187, 177, 139, 111}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 145, 123}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 38, 228, 110, 241, 98, 72}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 126, 12, 30, 28, 30, 5, 51, 16, 4}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 139, 4, 4, 124}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 204, 164, 65}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 122, 150, 131, 207}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 160, 230, 201, 110, 68, 141, 194, 28, 112}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 34, 116, 44, 59, 134, 146}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 199, 23, 48}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 100, 97, 69, 129, 10, 151, 255}, 139},
	{{0, 143, 160, 184, 162, 192, 59, 30, 142, 69, 244, 73, 185, 215, 192, 29}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 191, 207, 22, 153, 235}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 242, 91, 19}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 73, 225, 102, 242, 231}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 254, 21, 36, 243, 207, 85, 133}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 123, 230, 186, 148}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 229, 229, 191, 141, 14, 116, 52}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 158, 149, 65, 183, 240, 62, 137, 6, 70}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 82, 112, 24, 0, 209, 143, 28, 251, 226}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 38, 161, 96, 32, 66}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 224, 171}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 16, 162, 99, 151, 27, 38, 229, 150, 191}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 21, 5, 224, 101, 95, 204, 91, 53}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 215, 147, 145, 63, 75, 220, 98, 90}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 128, 0, 45, 209}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 88, 51, 160}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 225, 76, 166, 234, 52, 150, 15}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 183, 187, 153, 154, 11, 29, 158}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 168, 28}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{0, 143, 160, 184, 162, 192, 10, 114, 14, 211, 214, 27, 195, 250, 156, 134}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73}, 139},
	{{0, 143, 160, 184, 162, 192, 55, 124, 67, 78, 119, 67, 108, 4, 233, 4}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 161, 11, 3, 103}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 199, 35, 227}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 139},
	{{0, 143, 160, 184, 162, 192, 208, 92, 246, 169, 99, 254, 203, 53, 184, 252}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 55, 201, 19}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 145, 63, 151, 79, 12}, 139},
	{{0, 143, 160, 184, 162, 192, 23, 209, 206, 187, 170, 48, 187, 229, 169, 254}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 192, 133, 135, 36, 232, 156, 247, 224, 123}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 39, 165, 80, 82, 42}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 16, 74, 168, 58, 245, 247, 75}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 29, 124, 27, 249, 36}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 253, 55, 226, 211, 166, 124}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 13, 35, 68, 151, 54, 6, 60, 190}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 241, 71, 30, 21, 59, 122, 64, 204, 250}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 91, 71}, 139},
	{{0, 143, 160, 184, 162, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192}, 139},
	{{170, 24, 0, 0, 0, 0, 78, 106, 202, 236, 223, 135, 43, 67, 157, 56}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 170, 219, 114, 61}, 219},
	{{170, 24, 0, 0, 69, 117, 217, 95, 180, 100, 219, 166, 22, 23, 228, 204}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 243, 67, 130, 232, 66, 69, 122, 167}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 60, 40, 106, 136, 158, 68, 167}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 205, 165, 88, 239, 56, 241, 130, 122}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 66, 202}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 190, 77, 119, 165}, 219},
	{{170, 24, 0, 0, 84, 29, 49, 206, 146, 171, 238, 74, 203, 250, 57, 213}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 152, 51, 239}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 137, 174}, 219},
	{{170, 24, 0, 0, 0, 0, 81, 6, 117, 184, 6, 199, 148, 52, 218, 85}, 219},
	{{170, 24, 0, 47, 210, 240, 198, 120, 253, 242, 163, 162, 237, 26, 231, 77}, 219},
	{{170, 24, 0, 0, 196, 162, 113, 51, 150, 156, 253, 29, 253, 175, 123, 190}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 201, 252, 159, 35}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 46, 245, 75, 88}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 161, 124, 151, 199, 241, 246, 79, 120}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 117, 104, 159}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{170, 24, 0, 0, 108, 255, 142, 224, 114, 28, 201, 90, 138, 11, 128, 137}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 219},
	{{170, 24, 19, 76, 22, 171, 224, 78, 29, 172, 161, 88, 23, 96, 219, 29}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 163, 166}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 240}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 136, 239, 37, 153, 254, 210}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 85}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 102, 118, 127, 186, 166, 102, 45, 96}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{170, 24, 145, 92, 27, 108, 235, 34, 236, 141, 82, 172, 13, 153, 219, 95}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 32, 245, 80, 108}, 219},
	{{170, 24, 48, 247, 31, 124, 139, 34, 199, 194, 50, 51, 116, 182, 23, 53}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 146, 102, 21, 225, 163, 129, 160}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 42, 81, 67, 200, 4, 75, 10}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 94, 163, 84, 68, 77, 30, 238, 45, 181}, 219},
	{{170, 24, 0, 19, 113, 41, 129, 107, 62, 181, 236, 88, 125, 250, 153, 88}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 174, 137, 233}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 63, 10, 103, 35, 151, 211, 28, 235}, 219},
	{{170, 24, 0, 153, 138, 9, 11, 176, 30, 99, 235, 68, 201, 84, 69, 196}, 219},
	{{170, 24, 0, 193, 184, 221, 88, 55, 251, 39, 32, 67, 23, 55, 125, 249}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 143, 151}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 121}, 219},
	{{170, 24, 0, 130, 192, 212, 69, 204, 59, 137, 122, 6, 7, 130, 157, 186}, 219},
	{{170, 24, 0, 0, 0, 0, 135, 31, 90, 40, 51, 218, 163, 120, 152, 111}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 102, 172, 12, 130}, 219},
	{{170, 24, 0, 0, 0, 0, 43, 93, 195, 22, 30, 58, 2, 207, 65, 27}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 3, 22, 134, 171, 135, 12, 194, 184, 53}, 219},
	{{170, 24, 0, 0, 0, 131, 181, 47, 67, 206, 89, 55, 135, 57, 139, 98}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 40, 188, 235, 186, 145, 178, 137}, 219},
	{{170, 24, 0, 0, 2, 127, 24, 121, 21, 38, 56, 163, 215, 97, 118, 245}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 31, 189, 85, 198, 136, 241, 26, 168, 209}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 9, 212, 248, 165, 207, 47, 174, 24, 20}, 219},
	{{170, 24, 0, 44, 176, 112, 132, 24, 140, 48, 185, 4, 179, 148, 196, 3}, 219},
	{{170, 24, 0, 0, 189, 154, 143, 174, 204, 99, 226, 76, 239, 129, 37, 158}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 148}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 170, 14, 211, 141, 115, 133, 125, 115, 112}, 219},
	{{170, 24, 0, 229, 19, 168, 8, 98, 36, 64, 25, 233, 22, 17, 54, 208}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 88, 128, 176, 159, 26, 194, 29, 21}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 220, 48, 28, 73, 72, 16, 2}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 12, 230, 99, 140, 30, 128}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{170, 24, 0, 0, 0, 0, 144, 227, 153, 15, 3, 198, 4, 51, 71, 198}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 213, 147, 4, 211, 69, 123}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 98, 213, 176, 6, 51, 170, 218}, 219},
	{{170, 24, 0, 5, 199, 15, 10, 191, 30, 207, 188, 221, 117, 110, 35, 244}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 116, 142, 251, 137, 174, 45}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 217, 168}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{170, 24, 0, 0, 93, 133, 66, 80, 14, 65, 184, 79, 245, 44, 82, 248}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 136, 88, 14, 31, 230, 33, 154, 147, 86}, 219},
	{{170, 24, 0, 0, 0, 0, 103, 25, 143, 148, 195, 147, 114, 62, 153, 71}, 219},
	{{170, 24, 0, 0, 0, 0, 149, 31, 168, 18, 190, 123, 1, 242, 181, 148}, 219},
	{{170, 24, 0, 0, 0, 49, 223, 103, 219, 203, 97, 174, 133, 180, 171, 170}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 162, 56, 8, 185, 233, 144, 212, 159, 106}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 193, 141, 57, 218, 9, 214, 95}, 219},
	{{170, 24, 0, 0, 0, 0, 145, 104, 68, 251, 90, 94, 241, 23, 80, 81}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 38}, 219},
	{{170, 24, 0, 0, 73, 3, 159, 223, 120, 72, 38, 94, 241, 226, 223, 139}, 219},
	{{170, 24, 0, 175, 53, 185, 223, 1, 162, 219, 66, 92, 233, 72, 99, 75}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 219},
	{{170, 24, 0, 0, 0, 198, 125, 178, 130, 71, 1, 39, 132, 217, 53, 95}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 208, 77, 222, 247, 37, 172}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 137}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 141, 240, 155}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 197, 108, 212, 123, 150, 191, 107, 1, 196}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 39, 75}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 238}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 46, 4, 121, 154, 224, 156, 229, 80}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 132, 108, 31}, 219},
	{{170, 24, 0, 0, 75, 40, 27, 44, 63, 185, 236, 39, 31, 141, 65, 201}, 219},
	{{170, 24, 0, 0, 0, 0, 0, 0, 0, 16, 246, 90, 37, 49, 38, 102}, 219},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 235}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 188, 47, 221, 234}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 43, 250, 176, 154, 76, 57, 165, 175}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 133, 92}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 165, 203, 129, 41, 46, 170, 135}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 216, 35, 34, 49, 4, 26, 204}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 170, 214}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 123, 216}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 132, 54, 142}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 254, 135, 12}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 47}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 192, 61, 170, 247, 51, 133, 42, 176}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 215, 47, 35, 249, 53}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 236, 229, 233, 229, 145}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 201, 161, 165, 252}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 59}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 142, 22, 173, 220, 155}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 177, 162, 49, 84, 206, 113, 170, 106}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 225, 135, 143, 230, 29, 74, 109, 49}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 13}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 13, 74, 151}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 107, 12, 84, 233, 188}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 3, 31, 249}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 109, 249}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 73, 177, 98, 237, 11, 206}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 37, 169, 206, 123}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 236}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 16, 246, 246, 55}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 248, 208}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 80, 246, 245, 138, 164}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 189, 218, 16, 220, 254}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 20, 47, 101, 119, 19, 255, 136}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 40, 31}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 130}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 188, 237, 31, 51, 131}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 79, 244, 0, 179, 234}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 218, 169, 156, 146, 87, 132, 6}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 202, 148}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 143, 35, 130}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 2, 96, 152, 52, 78, 179, 227}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 214}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 194, 25}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 246, 125, 95}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 126, 228, 66, 168, 1, 121, 192}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 181, 144, 24, 11, 192, 163}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 228, 75, 36, 9, 105, 34, 152, 103}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 186}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 59, 149, 98}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 240, 155, 52, 183}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 184, 185, 223, 203}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 242, 12}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 33, 151, 48}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 71, 79}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 173, 167, 40, 98, 74, 83, 3, 146}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 22, 105, 199, 89, 169}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 112, 156, 80, 181}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 15}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 195}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 241, 164, 122, 129, 55, 225, 81, 64}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 255, 38, 108, 82, 225, 96, 247}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 5, 127, 147, 137, 159}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 1, 173, 56, 98, 254, 89, 63}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 33}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 194, 22}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 236, 25, 20, 136, 54}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 138, 28, 90}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 8, 122, 101}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 116}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 53, 52, 86, 240, 58, 76, 178}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 18, 175, 23, 181, 5, 124}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 182, 65}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 77, 8, 92, 57}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 111, 169, 195}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 160, 8}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 23, 91}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 133, 193, 60}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 184, 128, 16, 62, 28, 107, 152}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 104, 13, 60, 192, 180, 194}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 195, 153, 8}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 169, 73, 151}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 247, 2, 157, 73}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 206, 209, 184, 169, 246, 56, 146, 139}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 181, 126, 25, 17, 90, 96}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 36, 112, 153, 237, 232, 21, 193}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 0, 0, 169}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 31, 170, 148, 152}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 225, 64, 250, 150}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 135, 182, 15, 11, 66}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 197, 243, 230, 217, 130, 237, 168}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 26, 9, 116, 16}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 81, 104, 25, 131, 63}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 38, 221, 231, 223, 41, 218, 108}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 116, 193, 78, 154, 78}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 0, 195, 222, 73}, 105},
	{{61, 122, 24, 251, 124, 122, 202, 192, 0, 0, 0, 0, 124, 105, 204, 69}, 105},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 174, 136}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 83, 194, 136, 28, 163}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 80, 230}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 93, 64, 22, 71, 188, 207, 50, 22, 175}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 51, 173, 2, 124}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 89, 183, 132, 216, 181}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 28, 14, 141, 70, 135, 186, 48}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 29, 180, 24, 182, 48, 194, 73}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 43, 5, 59, 139, 207, 9, 203, 230, 213}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 222, 243, 144}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 170, 100, 10, 244}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 181, 2, 42}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 134, 179, 69}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 235, 126, 165, 122, 246, 0, 237, 127}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 5, 179, 18}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 58, 200, 228}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 120, 232, 205, 227, 65}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 128, 25, 223, 18, 134, 76, 174, 208}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 149, 87, 173, 40, 1, 76, 33}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 79, 200, 90}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 251, 216, 112, 246, 48, 175, 146, 33, 86}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 30, 7, 253, 0, 33, 118, 165, 241, 187}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 245, 139, 129, 172, 174, 231}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 176, 98, 249, 32, 208, 55, 81, 207}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 177, 242, 182}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 24, 165, 143, 171, 226, 153, 190, 191, 113}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 101, 56, 202, 7, 130, 226}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 184, 15, 9}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 4, 1, 227}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 170, 52, 76, 56, 196, 156}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 83, 228, 214}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 9, 82, 116, 15, 188, 58, 241}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 79, 175, 146}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 132, 110, 81, 110, 58, 118, 220, 22, 227}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 59, 251, 198, 216, 179, 204, 216, 225}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 166, 56, 120, 234, 165, 158, 214}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 68, 100, 58, 208, 191, 140, 151, 157}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 5, 22, 163, 102}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 222, 187, 250, 38, 199, 89, 148, 77}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 73, 242, 23, 61, 130, 217, 32, 251, 130}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 133, 130, 63, 234, 66, 112, 170}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 159, 221, 9, 157, 177, 4, 4, 80}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 177, 205, 194, 159, 239, 200, 0}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 232, 101, 247, 198, 38, 251, 24, 157}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 39, 67}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 235, 163, 144, 185, 21, 226}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 83, 98, 99, 53, 81, 31, 51}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 234, 182}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 250, 224, 124, 157, 138, 92, 45, 157}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 215, 58, 22, 196, 210, 37}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 150, 85, 165, 34, 5, 74, 74, 33, 62}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 240, 0}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 207, 51, 138, 19, 113, 162, 102, 78, 76}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 91, 6}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 209, 167, 229, 230, 141, 113, 64}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 39, 217, 110, 69, 192, 43, 149, 143, 29}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 233, 237, 132, 2}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 253, 179, 43, 98}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 186, 62, 35, 88, 108}, 210},
	{{33, 219, 226, 3, 180, 190, 177, 164, 29, 29, 53, 130, 112, 178, 84, 53}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 172, 46, 46, 253, 40, 2}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 114, 225, 227, 123, 102, 56, 4, 197}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 1, 227, 144, 25, 172, 87, 176, 165}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 225, 105, 73, 207, 209, 34, 204, 217, 24}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 16, 232, 169, 40, 176}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 98, 40, 228}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 114, 137, 41, 34, 169, 126, 74}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 189, 157, 62, 58, 144, 77, 91, 84}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 75, 229, 239, 120, 88, 124, 60, 223, 199}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 150, 84}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 185, 88, 220}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 127, 196, 94, 180, 2, 216, 175, 69}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 251, 156, 19, 148, 34, 102, 207, 242, 222}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 101, 158, 40, 40, 225, 36}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 79, 50, 148, 104, 34, 24, 82, 242}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 192, 84, 72, 238, 129, 70, 44, 84}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 100, 158, 11}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 211, 246, 97, 26, 77, 79, 51, 137, 217}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 0, 174, 221}, 210},
	{{33, 219, 226, 3, 180, 190, 0, 0, 0, 0, 0, 0, 0, 59, 236, 44}, 210},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 181, 58, 236, 212, 247, 202, 250}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 175, 230, 238, 108, 224, 88, 129}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 111, 182, 39, 193, 203, 25, 101, 108, 87}, 151},
	{{51, 251, 0, 0, 73, 209, 174, 209, 90, 72, 152, 163, 62, 130, 229, 158}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 33, 88, 221, 67, 21, 212, 18, 78}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 84, 36, 4, 245, 140, 9}, 151},
	{{51, 251, 0, 0, 0, 149, 16, 143, 255, 179, 139, 143, 97, 125, 125, 197}, 151},
	{{51, 251, 0, 0, 0, 0, 168, 203, 245, 93, 189, 81, 238, 251, 43, 229}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 151, 219, 21, 189, 137, 253}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 4, 175, 242, 251, 169, 157, 113, 135}, 151},
	{{51, 251, 0, 0, 43, 35, 206, 229, 184, 186, 78, 234, 170, 207, 159, 123}, 151},
	{{51, 251, 0, 36, 73, 138, 191, 40, 134, 231, 103, 193, 245, 36, 254, 127}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 223}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 62, 46, 108}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 14, 163, 106, 111, 196, 79, 205}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 54, 45}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 197, 160, 101, 246, 127, 184, 172, 49, 173}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 94, 50, 9, 1, 18, 231, 167, 244}, 151},
	{{51, 251, 0, 0, 0, 0, 129, 192, 223, 250, 216, 2, 75, 240, 184, 131}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 131, 101}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 119, 156, 161, 101, 5, 186}, 151},
	{{51, 251, 0, 0, 100, 49, 2, 79, 150, 65, 230, 153, 44, 248, 173, 187}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{51, 251, 0, 0, 0, 106, 179, 155, 225, 74, 8, 11, 39, 117, 239, 198}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 191, 232, 134, 187, 172, 19, 36, 191}, 151},
	{{51, 251, 0, 0, 0, 0, 35, 55, 245, 182, 71, 105, 31, 108, 80, 204}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 172, 145}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 162}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 151},
	{{51, 251, 0, 0, 0, 240, 144, 48, 54, 184, 119, 49, 97, 58, 182, 240}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 103, 151}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{51, 251, 0, 0, 45, 22, 108, 209, 96, 224, 134, 45, 183, 199, 209, 220}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 69, 228, 161, 249, 13, 104, 138}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 230, 41, 216}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 141, 33, 105, 142, 75, 69}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 245, 23, 104, 118, 36, 103}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 253, 173, 39, 116}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 126, 79, 178, 51, 23, 7, 237}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 51, 186, 132}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 27, 111, 130, 81, 7, 30, 171}, 151},
	{{51, 251, 0, 0, 60, 48, 24, 6, 247, 213, 169, 28, 6, 47, 117, 174}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 210, 217, 67, 58, 152, 216, 40}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 150, 117}, 151},
	{{51, 251, 0, 225, 6, 187, 67, 221, 194, 192, 73, 81, 246, 54, 90, 214}, 151},
	{{51, 251, 0, 208, 229, 34, 5, 151, 211, 48, 0, 227, 71, 89, 232, 99}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 151}, 151},
	{{51, 251, 0, 24, 123, 71, 125, 202, 182, 91, 212, 216, 186, 241, 129, 36}, 151},
	{{51, 251, 0, 0, 0, 57, 79, 227, 68, 175, 35, 151, 160, 70, 9, 78}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 223}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 57, 241, 125, 142, 213, 49, 27}, 151},
	{{51, 251, 0, 0, 0, 220, 210, 75, 90, 16, 13, 67, 183, 210, 80, 75}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 4, 137, 99, 31, 215, 151, 253, 14}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 74, 117, 74, 202, 152, 141, 74, 252}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 251, 94, 6}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 164, 176, 120, 137, 184, 97, 114, 28, 195}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 172, 79, 37, 3, 234, 161}, 151},
	{{51, 251, 0, 69, 76, 55, 17, 162, 38, 69, 145, 119, 71, 246, 180, 10}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 106, 26, 188, 107, 102, 223, 165}, 151},
	{{51, 251, 0, 0, 0, 51, 191, 162, 158, 10, 131, 195, 24, 250, 80, 78}, 151},
	{{51, 251, 0, 199, 155, 4, 227, 188, 24, 56, 197, 192, 83, 16, 233, 7}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 89}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{51, 251, 0, 56, 131, 94, 98, 244, 214, 191, 71, 165, 88, 105, 76, 154}, 151},
	{{51, 251, 0, 238, 58, 126, 144, 241, 249, 224, 75, 51, 77, 23, 191, 224}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 211}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 21, 78, 149, 31, 108, 34, 172, 246, 88}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 91, 217, 60, 13, 54, 253, 120, 155}, 151},
	{{51, 251, 0, 0, 0, 166, 214, 12, 217, 51, 92, 223, 212, 118, 197, 52}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 175, 137, 231, 246, 67, 201, 70, 240, 219}, 151},
	{{51, 251, 0, 228, 249, 46, 154, 132, 15, 112, 52, 124, 70, 160, 73, 56}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 42, 181}, 151},
	{{51, 251, 0, 0, 186, 43, 31, 97, 65, 135, 140, 55, 244, 3, 36, 175}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 226}, 151},
	{{51, 251, 0, 0, 0, 230, 71, 185, 153, 245, 26, 217, 212, 131, 21, 54}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 1, 180, 220}, 151},
	{{51, 251, 0, 0, 0, 163, 238, 15, 42, 141, 22, 204, 37, 215, 107, 167}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 121, 151, 250, 224, 147, 33, 246, 64}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 163, 154, 146, 136}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 19, 15, 111, 187, 230, 26}, 151},
	{{51, 251, 0, 0, 0, 0, 110, 118, 80, 88, 213, 67, 203, 141, 160, 66}, 151},
	{{51, 251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 128, 162}, 151},
	{{51, 251, 0, 0, 0, 0, 57, 84, 156, 22, 168, 95, 175, 76, 5, 94}, 151},
	{{51, 251, 0, 0, 0, 0, 18, 81, 16, 153, 149, 248, 98, 165, 216, 238}, 151},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 81, 195}, 28},
	{{106, 185, 11, 122, 197, 192, 167, 28, 156, 216, 3, 51, 236, 86, 51, 197}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 155, 27, 38, 97}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 109, 172, 124, 12, 237, 26, 119, 176}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 219, 173, 47, 94, 59, 83, 203, 183}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 24, 166}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 154, 89, 172, 92, 203, 22, 58, 205, 104}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 207, 69, 4, 80, 63, 189, 4, 247, 190}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 75, 165, 29, 161, 207, 66, 105, 250}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 106, 59}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 122, 91, 188, 233}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 31, 124, 246, 132, 123}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 183, 162, 156, 167, 86, 186}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 225, 237, 107, 228, 25, 124, 44}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 249, 220, 241, 17, 49, 92}, 28},
	{{106, 185, 11, 122, 197, 192, 175, 81, 172, 162, 212, 6, 48, 84, 51, 6}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 17, 46, 61}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 215, 132, 220, 255, 160}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 107, 1, 226, 181, 188, 85, 46, 191}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 69, 47, 59, 116, 212, 186, 27}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 89, 208, 74, 232, 16, 173}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 148, 203, 64, 61, 184, 35}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 65, 155, 204, 65, 147, 119}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 125, 27, 59, 208, 44}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 195, 159, 117}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 53, 56, 235}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 252, 167, 0, 28, 154, 72, 251, 131}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 22, 158, 196, 34}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 65, 105, 183, 224, 190}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 67, 187, 55}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 202, 186, 233, 0, 196}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 103, 165, 149}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 230, 68, 212, 187, 230, 251, 43, 12, 166}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 40, 34, 10, 246, 192, 188, 121, 50}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 17, 42, 9, 162, 15, 44}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 106, 82}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 41, 170, 253, 66, 22, 114, 209, 200, 85}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 22, 101}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 239, 245, 202, 183}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 108, 198, 50, 194, 97}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 28, 181, 162, 193, 15, 190}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 215, 133, 8, 239, 144}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 124, 85}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 143, 172, 246, 201, 22}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 162, 27, 2, 233, 224, 21}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 8, 37, 250, 117, 189}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 251, 246, 210, 163, 27}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 35, 22, 136, 236, 15}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 174, 184, 95, 50, 32, 123}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 156, 39, 167}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 223, 172, 127}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 165, 81, 31}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 101, 118, 149, 209, 51, 217, 155}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 34, 0, 206, 233, 243, 182}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 18, 66, 67, 35, 233}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 95, 204, 251}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 135, 245, 198, 103, 75}, 28},
	{{106, 185, 11, 122, 197, 192, 234, 90, 127, 52, 72, 19, 146, 59, 154, 123}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 207, 141}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 17, 168, 251, 71, 41, 77}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 78, 223, 199, 119, 242, 30}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 12, 100, 12, 121, 201, 185, 148, 244}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 52, 162, 216, 64, 9, 139, 161, 94, 106}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 244, 146, 185, 139, 106, 36, 234, 32}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 113, 9, 55, 225, 123, 25, 201, 44}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 46, 74, 186, 11, 52, 204, 8, 245, 67}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 134, 151, 46, 42, 92, 24, 240}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 152, 55, 89, 131, 136, 213, 40, 194, 245}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 247, 53, 80, 160, 214, 171, 119, 57, 172}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 100, 224}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 69, 217, 146, 97, 50}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 18, 158, 240, 184, 234, 123, 129, 44, 20}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 116, 254, 86}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 133, 84, 222, 222, 222, 194, 74, 214, 219}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 162, 207, 148, 210, 41, 107, 146}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 143, 237, 224, 240, 167, 193, 11}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 0, 165, 70, 227, 2}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 242, 44, 156, 199, 152, 17, 52, 191, 161}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 62, 220, 160, 177, 174, 23, 194, 2}, 28},
	{{106, 185, 11, 122, 197, 192, 0, 0, 0, 0, 0, 191, 93, 6, 33, 102}, 28},
	{{192, 0, 0, 0, 0, 0, 0, 0, 173, 95, 55, 208, 191, 193, 22, 64}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 72, 224, 223, 129, 154, 6, 91, 129}, 64},
	{{192, 0, 0, 0, 0, 226, 234, 7, 22, 243, 59, 163, 108, 48, 138, 102}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 100, 92, 165, 126, 254, 185, 255, 125}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 27, 237, 220, 209, 158, 175, 34, 185, 21, 92, 65, 79, 109, 234}, 64},
	{{192, 0, 0, 212, 125, 6, 72, 153, 110, 196, 23, 188, 144, 240, 97, 239}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 232, 146, 185, 133, 186, 102, 30}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 212, 118, 99, 59, 255}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 75, 152, 236}, 64},
	{{192, 0, 0, 0, 0, 234, 209, 47, 173, 213, 186, 93, 245, 231, 176, 39}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 45, 98}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 10, 138, 194, 211}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 61, 198, 8}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 28, 226}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 38, 161, 52}, 64},
	{{192, 0, 0, 0, 0, 0, 119, 48, 91, 158, 122, 8, 84, 191, 129, 157}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 137}, 64},
	{{192, 0, 0, 0, 0, 0, 5, 68, 72, 129, 26, 229, 96, 88, 90, 146}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 115}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 173, 0, 133, 74, 130}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 19, 32, 130, 147, 161}, 64},
	{{192, 0, 0, 0, 0, 0, 172, 35, 185, 117, 197, 99, 83, 49, 52, 73}, 64},
	{{192, 0, 0, 0, 0, 122, 219, 208, 46, 90, 205, 189, 187, 108, 203, 97}, 64},
	{{192, 0, 0, 0, 0, 28, 115, 163, 108, 218, 249, 100, 235, 47, 237, 128}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 150, 227, 94, 65, 107, 128, 28, 163}, 64},
	{{192, 0, 0, 0, 90, 92, 41, 185, 35, 167, 202, 115, 186, 87, 25, 68}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 250, 60, 109}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 153, 165}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 225, 135, 103, 97, 219}, 64},
	{{192, 0, 0, 0, 0, 77, 122, 106, 230, 232, 148, 232, 3, 151, 211, 212}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 91, 25, 176}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 23, 142, 199, 35, 155}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 205, 84, 118, 191}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 64},
	{{192, 0, 0, 0, 0, 0, 62, 212, 121, 129, 130, 221, 232, 200, 126, 59}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 143}, 64},
	{{192, 0, 0, 130, 152, 242, 239, 69, 235, 144, 130, 91, 190, 175, 223, 131}, 64},
	{{192, 0, 0, 0, 117, 46, 201, 92, 74, 125, 199, 234, 124, 151, 21, 250}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 82, 53, 254, 101, 69, 36, 103}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 189, 123, 234, 12, 164, 27, 245, 156}, 64},
	{{192, 0, 0, 0, 0, 0, 39, 233, 69, 201, 245, 83, 197, 246, 115, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 44, 108, 192, 77, 56, 253, 141, 233, 166}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 3, 5}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 69, 42, 78, 237, 47, 104, 51, 6, 2}, 64},
	{{192, 0, 0, 0, 0, 151, 205, 17, 10, 126, 1, 223, 132, 190, 167, 50}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 146, 197, 110, 242}, 64},
	{{192, 0, 185, 124, 143, 83, 86, 6, 226, 92, 168, 219, 58, 106, 81, 249}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 243, 229, 230, 143, 117}, 64},
	{{192, 0, 0, 0, 229, 15, 184, 10, 28, 78, 26, 43, 159, 241, 155, 222}, 64},
	{{192, 0, 0, 0, 0, 0, 228, 40, 55, 187, 242, 225, 84, 58, 128, 5}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 64},
	{{192, 0, 0, 29, 108, 103, 4, 8, 195, 158, 193, 128, 237, 226, 221, 247}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 24, 53}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 108, 142, 76, 24}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 245, 165, 150, 40, 176, 182, 152, 65, 117, 27, 222, 158, 190}, 64},
	{{192, 0, 0, 253, 227, 254, 8, 189, 147, 39, 23, 251, 81, 154, 79, 187}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 249, 176, 202}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 209, 217, 76, 213, 47, 34, 201, 19, 128}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 201, 114, 236, 177, 84, 135, 175, 144, 45, 193}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 144, 212, 234}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 251, 114}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 207}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 133, 156, 86, 131, 176, 47, 65}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 177, 115, 231}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 67, 246, 199, 143, 143}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 7, 22}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 53, 8, 9, 235}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 82, 130}, 64},
	{{192, 0, 0, 0, 0, 0, 105, 53, 49, 110, 210, 173, 193, 41, 39, 91}, 64},
	{{192, 0, 0, 0, 0, 46, 60, 103, 192, 192, 100, 38, 176, 25, 253, 190}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 103, 204, 124, 32}, 64},
	{{192, 0, 68, 152, 151, 122, 27, 22, 96, 10, 177, 180, 58, 104, 131, 145}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 126, 92, 58, 181, 69}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 18, 205, 178, 158, 25}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 171, 134, 94, 64, 127, 226, 130, 48, 99}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 183, 141, 229}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 147, 129, 238}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 242, 158}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 38, 132, 33, 88, 13}, 64},
	{{192, 0, 135, 221, 237, 114, 233, 43, 185, 25, 116, 194, 51, 109, 100, 203}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 131, 176}, 64},
	{{192, 0, 0, 0, 0, 238, 24, 80, 213, 146, 156, 210, 200, 21, 234, 66}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 210}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192}, 64},
	{{192, 0, 0, 0, 0, 214, 158, 245, 178, 238, 254, 138, 136, 19, 222, 244}, 64},
	{{192, 0, 0, 0, 0, 0, 136, 101, 186, 45, 90, 126, 199, 96, 34, 176}, 64},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{239, 195, 77, 239, 131, 156, 2, 246, 191, 178, 204, 160, 21, 213, 30, 128}, 9},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 38, 153, 139}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 75, 222, 209, 241}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 1}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 57, 132, 96}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 202, 54, 59}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 59}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 237, 194, 59}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 149, 133}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 223, 111, 113, 211}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 7, 28, 186}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 242}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 242, 205}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 77, 245, 170}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 184, 44, 130}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 77}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 187, 104, 141}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 26, 163, 65}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 62}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 2, 46, 227, 145}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 44, 226}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 52}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 226}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 2, 89, 80}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 104, 117, 106}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 9}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 206, 82, 155}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 138, 89, 53}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 115, 57, 70, 23}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 58, 48, 132}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 76}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 133, 46}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 251}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 158, 118, 148}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 128, 16, 244}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 101, 196, 188}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 241, 8, 231}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 51, 175}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 12}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 111, 96, 38, 99}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 200, 215, 76, 180}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 172}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 144, 242, 199}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 81, 28}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 35, 144}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 154, 100, 239, 243}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 134, 97, 234}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 139, 215, 220, 21}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 112}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 38, 53}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 57, 37, 66}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 219, 124}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 28, 19}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 194, 239, 88}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 140}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 139, 14, 191, 6}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 153, 81, 173}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 62, 63}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 1}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 235, 174}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 167, 200, 244}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 105}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 235, 186, 174}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 232, 159, 169, 132}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 183, 142}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 26, 187}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 223, 109}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 108}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 34, 200, 200}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 228, 91, 241}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 0}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 101, 202}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 0, 172}, 250},
	{{141, 207, 181, 99, 55, 245, 151, 228, 65, 50, 85, 16, 0, 0, 152, 188}, 250},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 85, 14, 173, 131}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 232}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 183, 125}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 165, 237, 174, 98, 128, 250, 202}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 196, 79}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 199, 170, 183, 207, 171, 49, 228}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 177, 141, 217, 189, 125, 102, 24}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 22, 34, 90, 105}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 166, 74}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 114, 205, 82, 33, 47, 176}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 40, 233, 153, 199, 217, 20, 21}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 70}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 158, 90, 207, 255, 195, 155}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 90, 6, 40}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 122, 38, 67, 24, 205, 156, 209}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 64}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 59, 92}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 137, 207}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 161}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 131, 115}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 101}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 30, 48, 72, 106, 53}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 199, 191}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 193, 11}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 199}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 167, 96}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 242, 150, 123, 159}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 72, 48, 250, 46, 239}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 127, 159, 105}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 228, 229}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 24, 11, 57, 139, 231, 238}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 150, 53, 28}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 163, 249, 195, 147}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 144, 91}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 136, 192, 55}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 38}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 120, 188, 14, 116}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 205, 248, 35, 34}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 79, 204, 170, 197, 126, 213}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 71, 120, 254, 40, 233, 156, 81}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 36, 153, 94, 17, 3, 243, 102}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 17, 99}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 127, 187, 254, 103}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 103, 199, 147, 37, 207, 26, 132}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 97}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 119, 148, 137, 96, 141, 44, 32}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 69, 159}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 27, 154, 136, 117, 12, 66}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 245, 26, 201, 104, 157, 171, 113}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 131, 96, 165, 197, 35, 221}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 162, 216, 16, 122, 36, 80, 55}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 102, 98, 118, 19, 198, 185, 99}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 140, 63, 161, 129}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 151, 219}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 212, 217, 223, 177, 76}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 34, 69, 229, 14, 203, 34}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 93, 74, 127, 171, 61, 97}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 13}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 239, 207, 160, 101, 139}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 78, 73, 206, 160}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 222}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 120, 157, 240, 182, 164}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 118, 41, 111, 75, 252}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 251, 76, 78, 167, 6}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 8}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 98}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 84, 196, 54, 224, 99}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 236, 248, 168, 165}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 203, 237, 113, 103, 190}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 115}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 211}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 135, 60, 112, 31, 150, 196}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 60, 108, 216, 224, 137, 103}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 249, 55}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 186}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 20, 32, 132, 25, 244, 71, 236}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 74, 147, 59, 172, 119, 137, 19}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 49, 240, 41}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 4, 222, 215, 135, 80}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 7, 248, 250, 162, 118}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 60, 216, 248, 91, 175, 23}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 136, 95, 1}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 70, 251, 36, 191, 225, 255}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 41, 51, 109, 200, 162}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 40, 173}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{110, 159, 230, 251, 224, 210, 58, 49, 0, 0, 0, 0, 0, 0, 0, 0}, 200},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{134, 26, 104, 32, 129, 41, 201, 50, 164, 69, 178, 156, 156, 133, 8, 218}, 132},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 101, 148, 230, 236, 56}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 179}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 181, 116}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 231, 62, 51, 193, 114, 83}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 233, 2, 129, 72, 155, 112}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 229, 217, 101}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 49, 219, 184}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 93, 253, 192, 67}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 27, 222, 229, 134, 7}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 71, 117, 167, 9, 92, 149}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 19}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 72, 239, 55}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 160, 192, 62, 147, 73, 137}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 137, 247, 4}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 145, 6, 173}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 129, 245, 242, 99, 82, 97}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 147, 97, 105, 34, 144, 20}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 223, 211, 250, 145, 98}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 169, 29, 241}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 64, 38, 10}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 100, 39, 17, 149, 24, 117}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 55, 71, 39}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 217, 170, 209}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 172, 92}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 45, 224, 228}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 231, 235, 71, 169, 196}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 198, 114, 135, 200, 214}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 58}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 46, 139, 166, 166}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 126, 9, 121, 207, 221}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 227, 219, 164, 224, 128}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 155, 20, 4, 235}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 250, 178, 56, 1}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 182, 139}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 45, 23, 97, 25}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 61, 146, 231}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 27, 219, 107, 14}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 39, 85}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 227, 247, 11, 86}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 247, 155, 249}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 89, 46, 90}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 18, 102, 85, 32}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 178, 69, 197}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 137, 130}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 221, 32, 183}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 145, 52, 116, 16, 63, 28}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 201, 70, 77}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 49, 116, 37, 195}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 65}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 210}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 217, 38}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 127, 157, 242, 26, 126, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 213, 253, 113}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 10, 73}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 171, 47, 48, 223}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 199, 24, 237}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 96, 223, 183, 2, 109}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 255, 14, 184, 18, 43}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 252}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 231, 149, 156, 193}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 66, 123, 191, 225}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 96, 113, 22}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 19}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 143, 158, 122, 195, 63, 254}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 235, 49, 159, 220, 67}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 159}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 97}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 63, 18}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 244}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 141, 231}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 253}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 183, 254, 228}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 236, 225}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 253}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 254, 253}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 146, 155}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 128, 219, 178, 196, 47, 91}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 197, 183, 81, 176, 116}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 204, 238, 106, 29, 133, 97}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 104, 85, 243}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 6, 167, 89, 228, 22}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 123, 124, 40}, 182},
	{{253, 207, 116, 105, 210, 166, 186, 99, 182, 0, 0, 0, 0, 152, 164, 31}, 182},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 45}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 66, 254}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 245, 44}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 148}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 229, 42}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 26}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 149, 248}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 253}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 221, 24}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 89, 168}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 223}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 90, 156}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 245}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 177, 199}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 241, 35}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 78}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 170, 99}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 19}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 76}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 63, 79, 159}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 136, 141}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 223}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 210, 166}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 180}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 191, 16}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 71, 78}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 63, 238}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 255}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 50, 107}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 103, 145}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 102, 167}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 17, 1}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 210, 129}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 103}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 114}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 182}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 16}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 1, 69, 52}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 49, 17, 162}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 134, 183}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 80}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 91, 243}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 76}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 212, 24}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 157, 197}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 219, 147}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 203}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 4, 171}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 249}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 8}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 142, 228}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 30, 223}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 115}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 47}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 234}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 228, 41}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 107}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 43, 185}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 54}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 244, 67}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 92}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 74}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 248, 184, 167}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 236}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 0}, 7},
	{{211, 73, 38, 80, 183, 168, 52, 138, 25, 214, 112, 8, 252, 0, 0, 20}, 7},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 171, 189, 205}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 71}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 167}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 222}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 248}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 7}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 213}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 156, 223}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 98, 210, 245}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 151}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 137}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 220}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 10, 56, 28}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 166, 130, 190}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 215, 153}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 16, 56}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 244, 123, 146}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 120}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 232, 163, 122}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 128}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 201, 245}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 77, 25}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 197}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 153, 34, 135}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 209}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 14, 117, 211}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 130}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 149}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 127, 207, 141}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 163}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 196, 126}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 76}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 240, 226, 161}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 160}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 84, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 185, 74}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 249}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 187, 124}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 30, 139}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 100, 57, 57}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 47, 180}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 23}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 244, 87, 238}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 49, 174}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 88}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 46}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 37, 98}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 227}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 179, 103}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 13}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 191, 240, 101}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 41, 127}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 49, 81, 41}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 138, 67}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 135}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 211}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 27}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 110}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 37}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 88, 116, 127}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 203}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 245, 137}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 175}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 229, 102, 241}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 193}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 164}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 163, 64}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 145}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 229, 42}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 59, 60}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 44}, 146},
	{{200, 244, 108, 238, 164, 141, 215, 39, 233, 249, 120, 80, 112, 0, 0, 0}, 146},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 12}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 3}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 132, 23, 1, 200, 245, 24}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 27, 244, 175}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 198, 172, 197, 161, 211, 94}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 217, 158, 19, 9, 70}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 81}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 231, 191, 193, 63, 145}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 118, 87, 188, 189, 165, 210, 48}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 52, 192, 208, 103, 85}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 195, 115}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 140, 119, 217, 189, 72, 56, 224}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 198, 193, 135, 251, 80, 99, 180}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 171, 50, 254, 187}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 239, 137, 123}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 130, 166, 252, 11, 162, 123, 128}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 19, 42, 148, 57, 244}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 41}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 124}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 103, 1, 79, 255}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 41, 117}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 156, 163, 161, 20, 57, 38}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 47, 126, 105, 75, 177, 22}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 192, 76, 127}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 190, 201, 147, 219, 56}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 96, 81, 60}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 143, 255, 8, 193, 16}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 75, 29, 153, 223, 18, 14}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 163, 193, 89, 101, 58}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 237}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 202, 155, 245, 152, 106, 197}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 149, 45, 4, 230, 129}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 153}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 87, 14, 249, 50, 79}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 140, 215}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 236}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 211, 126, 202, 238, 196, 192}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 212, 209, 23, 202, 142, 253}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 27, 28, 92, 34, 217, 98}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 6, 250, 66}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 208, 85, 128, 146}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 31, 209}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 53, 250, 56, 245, 195, 218}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 190, 180}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 20, 203, 58, 135, 33, 163}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 17}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 23, 159, 183, 132, 174, 119}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 195, 66, 42, 142}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 81}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 228, 58, 203, 109}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 12}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 65, 31, 164}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 152, 161}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 127, 109, 3, 77, 217}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 156, 51, 126, 251}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 175, 150, 118, 192, 83, 212}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 137, 252}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 40, 202, 123, 138, 4, 203}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 103, 179, 50, 253}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 4, 90, 91, 103, 173}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 171, 57, 80}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 19, 199, 155, 179}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 152, 87, 77, 189, 141}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 125, 169, 195, 150, 46, 223}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 171, 34}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 169, 124, 21, 184, 9}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 182, 57, 139, 28, 198, 35}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 169, 54, 249}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 74, 108, 12}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 85, 62, 124, 27}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 156, 41, 168, 63, 12, 211, 72}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 10, 164, 119, 133, 231, 119}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 109}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 36, 237}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 103, 140}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 35, 34, 200, 196, 78}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 132, 19, 129, 187, 150}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 97, 187, 161, 82}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 115}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 15, 254, 121, 206, 229, 228}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 173, 120, 181, 95}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 81, 124, 204, 211, 89}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 10, 25, 64, 203, 27}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 146, 159, 103, 194, 46, 165}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 152, 13, 153, 234}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 221, 88, 94, 199, 78}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 179, 13, 176, 66, 249}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 0, 234, 20, 76, 169}, 98},
	{{107, 44, 250, 202, 64, 37, 107, 105, 140, 0, 0, 203, 244, 141, 128, 186}, 98},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 218, 177, 243, 233}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 196, 76, 199}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 80}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 18, 180, 30}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 72, 188}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 96, 97, 137}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 121, 232}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 115, 182, 167, 176}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 111, 176, 180, 177, 176}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 146, 241, 47}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 152}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 187}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 41, 149, 128, 118}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 216, 46, 133}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 84}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 23, 224}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 90, 228, 218, 42}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 226, 42, 141}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 128, 182}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 26}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 91}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 180, 85, 71, 126}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 119}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 108, 219, 19}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 91, 191, 104}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 88}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 18}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 72, 121}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 13}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 113, 45, 77, 147}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 140, 192}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 117}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 213, 67, 229, 80}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 121, 32, 142, 185, 132}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 4, 139, 183, 76}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 108}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 65, 28, 119}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 102, 71, 232, 2}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 231, 232, 66, 131}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 241}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 105, 232, 98}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 78}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 37, 16, 106, 245}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 34}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 125, 203, 236, 122, 51}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 65, 158}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 25}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 120}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 67, 221, 154, 64, 166}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 124, 152, 56}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 178, 153}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 184}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 2, 172, 130, 3}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 17, 144, 61}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 249, 105}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 6}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 205, 242, 219}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 97, 12}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 167, 117, 62, 219}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 55}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 181}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 85, 94, 74, 164, 229}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 64, 192}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 139, 60, 123}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 43, 234, 94, 87}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 120, 212, 170, 106}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 254, 25, 88, 7}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 71, 244, 183, 208}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 255, 138, 118}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 2, 152, 164}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 0, 0, 0, 0, 0}, 179},
	{{93, 86, 56, 27, 159, 195, 126, 39, 240, 201, 48, 18, 135, 93, 192, 90}, 179},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 30, 219}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 213}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 128, 170, 68, 136, 138}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 64}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 189, 124, 118, 181, 207, 236}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 137}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 131, 77, 136, 55, 31, 185}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 21, 47, 207, 120}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 149, 109, 55}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 221, 239, 148}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 179}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 175, 50, 33}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 79, 37, 12, 114}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 182}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 118, 178, 10, 42}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 38}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 222, 228, 128, 155}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 120, 205}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 160, 145, 242, 91}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 76, 190, 69, 83}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 74, 107, 217, 232}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 192, 93, 5}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 23, 157, 68, 221}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 151, 147, 133, 115}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 217, 1, 49}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 28, 164, 3}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 151, 233, 255, 35}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 228, 56, 20, 154, 191, 151}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 91, 211, 55, 155, 109}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 200, 36, 112, 122, 13, 27}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 156, 162, 179}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 105, 33, 222}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 126}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 62, 255, 32}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 58, 140, 122, 206, 235}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 122, 242, 132, 152, 252}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 214, 75, 195, 166, 165}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 252, 61, 216, 137}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 131, 45}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 67, 209}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 202, 102, 231, 57, 213}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 253, 167, 114}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 37, 62, 109}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 106, 252, 31, 20, 249, 111}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 153, 179}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 134, 40, 184, 137, 69}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 155, 101, 130, 191}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 176, 193, 235, 228, 63}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 202, 222}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 66, 227, 250, 65, 48}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 14, 112, 1, 53}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 55, 217}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 238, 18, 92, 189}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 40, 56}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 184, 117}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 208, 139, 19, 26, 211}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 180}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 111, 209, 202, 73, 141, 11}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 64, 177}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 176, 220, 15, 233, 164}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 156, 239, 49}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 169, 144, 148, 197, 157}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 111, 226, 12, 172, 179}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 253, 187, 26}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 203}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 132, 9, 90, 55, 57, 158}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 152, 114, 146, 207}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 175, 197, 208}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 68, 118, 190}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 200}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 157, 183, 186, 61, 173}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 206}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 0, 0, 0}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 0, 49, 113, 113}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 105, 30, 143, 249}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 0, 60, 196, 60, 150}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 114, 48, 97, 170, 32}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 115, 171, 233, 236, 13}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 164, 78, 4, 135, 194}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 0, 73, 197, 105, 238, 79}, 245},
	{{32, 202, 214, 242, 39, 141, 61, 146, 138, 96, 232, 44, 72, 59, 21, 71}, 245},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 230, 128, 78, 28}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 75, 23, 233, 252}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 240, 94, 117, 114, 129, 101, 232}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 46}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 58, 168, 171, 153, 116, 245}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 72, 26, 253, 161, 98, 104, 129}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 21}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 243, 36, 92, 191}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 230, 160, 86, 31, 252, 229, 144}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 169, 214, 57, 1}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 9, 75, 179, 199, 175, 175}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 57, 3, 174, 225, 131, 55, 185}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 26, 122}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 81, 235, 81, 119, 124}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 131, 61}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 240, 217, 63, 107, 50, 223, 157}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 49, 93, 109, 82, 90, 94}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 246}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 178, 246, 73, 110, 246, 164, 96}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 187, 89, 20, 52, 0, 60, 195}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 21, 126, 16, 70}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 22, 200, 93, 126}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 85, 123, 66}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 128}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 15, 63, 182, 172, 248, 10, 220}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 83, 66, 8, 25}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 204, 148, 170, 221, 150, 168, 109}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 16, 51}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 213, 251, 142}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 239, 162, 2, 7, 70}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 227, 34, 139, 51, 207, 251, 157}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 195, 94, 105, 57, 129, 57}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 137, 245, 164, 208, 68, 229, 165}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 104}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 36, 215}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 69}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 236}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 34, 187, 150}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 88, 102}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 65}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 163, 119, 186, 38, 70}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 80, 80, 208}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 46, 28, 76, 30, 22, 219, 204}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 66}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 44}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 129}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 126, 206, 68}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 156, 74, 240, 198, 195, 99}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 25, 176, 62, 164, 242}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 5, 224, 119, 148}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 4, 103, 117, 46, 150}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 2, 38, 148}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 23, 234, 167, 34, 24}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 20, 181, 4, 227, 85, 81}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 239, 108, 139, 121, 6, 8}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 12, 140}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 185, 204, 220, 64, 192}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 96, 4}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 172, 102}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 48}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 143, 72, 210, 248, 137, 218}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 239, 72, 231, 27, 23}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 106, 40, 236}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 107, 41, 82, 16, 224, 147, 224}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 151, 51, 79}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 135, 92, 176, 155, 92, 217}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 32, 167, 210}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 67, 227, 53, 53}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 46, 193, 255, 58, 70, 203}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 45, 126, 151, 155}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 41, 97, 98, 205, 167, 159}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 168, 174, 96}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 31}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 162, 204, 19, 64, 31}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 143, 153}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 37, 10}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 133, 164, 139, 168, 209, 242, 133}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 255, 212}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 124, 202, 153, 46, 238, 28}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 125, 25, 248, 35, 14, 12, 19}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 146}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{167, 77, 249, 28, 210, 196, 227, 241, 0, 0, 0, 0, 0, 145, 139, 142}, 2},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 102, 154, 91, 92, 245, 185}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 101, 113, 221, 12, 47, 98, 196}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 184}, 5},
	{{241, 59, 128, 153, 49, 46, 107, 116, 98, 211, 15, 31, 12, 255, 123, 82}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 124, 170, 199, 165, 120, 162, 200, 92, 209}, 5},
	{{241, 59, 128, 0, 229, 39, 28, 234, 118, 177, 240, 92, 40, 98, 22, 96}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 165, 127, 38}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 165, 248, 52}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 177, 21}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 222, 77, 48, 30, 21, 138, 54}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 207, 126}, 5},
	{{241, 59, 128, 0, 244, 58, 3, 88, 232, 48, 180, 230, 83, 39, 9, 172}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 105, 53, 229}, 5},
	{{241, 59, 128, 88, 185, 84, 82, 11, 235, 100, 25, 11, 207, 130, 99, 65}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 97, 203, 54, 143, 104, 34, 52, 113}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 98, 99}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 105, 62, 71, 203, 202, 124}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 149, 49, 242}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 68, 224, 18, 229, 246, 132, 145, 25}, 5},
	{{241, 59, 128, 0, 0, 0, 210, 48, 139, 69, 81, 158, 97, 26, 144, 182}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 176, 87, 116}, 5},
	{{241, 59, 128, 0, 0, 235, 161, 47, 55, 14, 136, 89, 113, 45, 87, 122}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 209}, 5},
	{{241, 59, 128, 0, 58, 96, 162, 15, 202, 186, 78, 89, 13, 172, 184, 126}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 19, 129, 54}, 5},
	{{241, 59, 128, 0, 0, 0, 127, 23, 147, 107, 49, 234, 69, 114, 57, 106}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 179, 234, 36, 152, 21}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 10, 247, 60, 3, 156, 134}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 188, 152, 216, 236, 56, 83, 128, 96, 217}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 115, 155, 119, 14, 171, 89}, 5},
	{{241, 59, 128, 0, 232, 66, 8, 100, 63, 171, 221, 72, 180, 32, 241, 218}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 226, 220, 116}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 255, 252, 84, 175, 94}, 5},
	{{241, 59, 128, 0, 0, 224, 200, 241, 161, 85, 193, 117, 66, 160, 46, 250}, 5},
	{{241, 59, 128, 0, 0, 0, 235, 78, 74, 130, 250, 94, 206, 187, 83, 118}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 223, 238, 191}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192}, 5},
	{{241, 59, 128, 0, 234, 216, 50, 86, 198, 93, 73, 85, 51, 27, 190, 110}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 69, 113, 222, 181, 205, 214, 8, 70}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 103, 220, 60, 222, 214, 107, 193}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 138, 38}, 5},
	{{241, 59, 128, 0, 0, 111, 14, 168, 45, 149, 81, 194, 38, 45, 109, 50}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 61, 243, 149, 151, 192, 155, 162, 27}, 5},
	{{241, 59, 128, 0, 49, 191, 243, 239, 213, 90, 182, 213, 247, 142, 168, 196}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 30, 61, 171, 117, 74, 223}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 227, 181, 103}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 228, 8}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{241, 59, 128, 132, 68, 32, 145, 153, 158, 248, 187, 224, 69, 202, 115, 16}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 142, 13, 46, 10, 62, 71, 211, 137}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 82, 200}, 5},
	{{241, 59, 128, 46, 215, 189, 40, 210, 212, 158, 238, 120, 78, 14, 113, 226}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 172, 210, 26}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 145, 230, 227, 210, 172, 32, 229}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 226, 236, 121, 211, 17, 27, 254, 128, 18}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 5},
	{{241, 59, 128, 0, 36, 177, 76, 11, 190, 192, 124, 199, 174, 192, 193, 18}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 47, 9, 71}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 35, 242, 52, 20, 241, 255}, 5},
	{{241, 59, 128, 0, 0, 93, 12, 140, 151, 194, 234, 121, 249, 43, 58, 196}, 5},
	{{241, 59, 128, 151, 100, 28, 70, 101, 153, 47, 77, 56, 171, 93, 210, 67}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 88, 21, 178, 100, 158}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 10, 30, 212, 203, 209, 235, 91, 108, 113}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 150, 18, 43, 18, 124}, 5},
	{{241, 59, 128, 0, 0, 187, 184, 6, 179, 134, 110, 85, 81, 143, 9, 7}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 230, 92, 34, 49, 43}, 5},
	{{241, 59, 128, 9, 61, 250, 30, 168, 50, 202, 104, 200, 80, 136, 250, 151}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 22}, 5},
	{{241, 59, 128, 0, 236, 34, 108, 76, 88, 128, 77, 43, 213, 119, 117, 205}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 194, 70, 220, 126, 200, 49, 18, 211, 123}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 134, 65, 186}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 132, 111, 99, 54, 250, 63, 195}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 249, 144, 34}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 13, 201, 24, 131, 213}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 95, 0, 105, 109, 180, 168}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 194, 210, 141, 30, 115}, 5},
	{{241, 59, 128, 0, 191, 245, 29, 57, 116, 227, 16, 72, 5, 191, 114, 208}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 96}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 75, 0, 2, 116, 63, 206, 169, 90}, 5},
	{{241, 59, 128, 23, 101, 236, 69, 151, 15, 150, 3, 108, 95, 78, 178, 0}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 0, 0, 0, 102, 204, 69, 119, 166}, 5},
	{{241, 59, 128, 0, 0, 91, 46, 131, 154, 141, 47, 21, 190, 122, 2, 32}, 5},
	{{241, 59, 128, 0, 0, 0, 194, 16, 176, 48, 91, 19, 224, 144, 65, 107}, 5},
	{{241, 59, 128, 0, 0, 0, 0, 0, 33, 14, 175, 113, 32, 146, 234, 95}, 5},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 175, 203, 118, 70, 58, 74, 158}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 148, 193, 55, 97, 67, 59, 38}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 41}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 217, 105, 163, 235, 27, 90, 80}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 144, 42, 239, 222, 250, 178}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 203, 48, 154}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 48}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 247, 91, 213, 141}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 138, 236, 47}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 150}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 76, 174}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 57, 82, 235, 116, 107, 173}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 203, 18, 7, 192, 222, 255, 69}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 236}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 4, 3, 250, 131}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 177, 157, 40, 189}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 232, 119, 164}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 127, 40, 179, 171}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 255, 115, 239, 78, 50, 122, 106}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 90}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 193, 61, 169, 187}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 246, 123, 120, 19, 61, 192, 11}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 160, 181, 50, 32, 125, 62, 38}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 10, 146, 59, 153, 6}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 116, 172, 48, 192, 197}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 245, 153, 118, 192, 162, 192}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 90, 17, 108, 243, 58}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 124, 103, 39, 23, 59, 27, 111}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 242, 24, 222, 136, 142}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 93, 241, 158, 137, 92}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 157, 157, 84, 77, 15, 174}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 228, 214, 112}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 255, 227, 112, 219}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 31, 169, 167, 88, 252, 34}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 251, 82, 12, 57, 117, 173, 217}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 186, 15}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 99, 128, 182}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 163, 185, 95}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 153, 195, 2}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 106, 123}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 36, 199, 19}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 214, 135, 172, 75, 134}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 253, 250, 125, 205, 249}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 173, 189}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 223, 0, 216, 73}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 114, 20, 223, 64}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 89, 250, 40}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 168, 15}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 205, 103, 142, 150, 154, 9}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 65, 255, 231, 149, 212, 142}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 255, 42, 133, 184, 196}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 108, 81}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 4, 222, 70, 58}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 206, 46, 250}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 28, 85, 216}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 15, 73, 13}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 229, 43, 200}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 171, 128, 65}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 252, 196, 14, 63, 58, 104, 100}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 230}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 27, 134, 62, 209}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 223, 218, 38, 34, 119}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 191, 70, 40, 1}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 171}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 120, 76, 208}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 13}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 225, 50, 9}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 36, 217, 118, 181, 244}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 234, 211}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 105, 161}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 186, 190, 57, 114, 14, 19}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 212}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 252, 43, 58, 24}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 1, 28}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 54, 101}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 21, 147, 52, 249}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 197, 171, 147, 28, 18, 52, 103}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 219, 238, 197}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 104, 173, 153, 51, 96}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 245, 136, 72}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 171}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 161, 46, 224, 74, 65, 146, 69}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 124, 102, 208, 43, 94}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 195, 6, 52, 44}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 202, 213, 107, 65, 67}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 194, 7, 175, 240, 233}, 169},
	{{143, 68, 146, 210, 173, 155, 251, 173, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{167, 180, 226, 144, 0, 49, 48, 196, 28, 75, 141, 198, 177, 193, 29, 186}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 78, 85}, 52},
	{{167, 180, 226, 144, 0, 192, 108, 166, 128, 59, 213, 246, 224, 88, 251, 17}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 20, 72, 159, 87}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{167, 180, 226, 144, 0, 0, 229, 106, 82, 99, 14, 54, 146, 55, 53, 201}, 52},
	{{167, 180, 226, 144, 0, 148, 83, 190, 33, 206, 92, 167, 48, 17, 172, 120}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 191, 134, 15, 134, 3, 33, 38, 199}, 52},
	{{167, 180, 226, 144, 0, 0, 1, 231, 212, 205, 157, 176, 56, 156, 237, 212}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 218, 60, 152, 16, 167, 79}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 60}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 166, 42, 11, 14}, 52},
	{{167, 180, 226, 144, 0, 0, 23, 106, 46, 168, 104, 185, 151, 116, 211, 170}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 200, 245, 243, 236, 42, 181, 77, 22}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 219, 70}, 52},
	{{167, 180, 226, 144, 0, 0, 96, 108, 25, 250, 93, 200, 142, 221, 87, 132}, 52},
	{{167, 180, 226, 144, 0, 232, 161, 71, 170, 6, 247, 15, 83, 109, 98, 253}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 9}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 253, 4, 30, 150}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 158}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 53, 174, 72, 216, 82, 62}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 147, 197, 105, 242, 23, 73, 100, 124}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 233, 122, 236, 3, 74, 115}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 52},
	{{167, 180, 226, 144, 0, 0, 164, 112, 63, 143, 208, 187, 146, 185, 42, 75}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 80, 118, 213, 81, 247, 128, 37}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 71, 193, 227, 85, 145, 86, 120}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 143, 146, 113, 1, 22, 247, 170, 85, 70}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 52}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 87}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 179, 232, 114, 0}, 52},
	{{167, 180, 226, 144, 0, 233, 120, 108, 85, 67, 116, 86, 108, 179, 130, 142}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 46, 203, 153, 193, 178, 56, 5}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 91, 227, 238, 219, 93, 151, 171, 191}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 179, 158, 17, 81, 57, 149, 197}, 52},
	{{167, 180, 226, 144, 0, 154, 231, 55, 55, 58, 142, 79, 75, 176, 2, 117}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 235}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 216, 218, 130, 229}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 181, 95, 33, 91, 203}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 95, 111, 59, 232, 206, 161, 170}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 210, 182, 122, 44, 195, 35, 1, 173, 16}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 74, 239, 224, 180, 229, 235, 150, 176}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 69, 126}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 171, 246, 176, 204, 189, 45}, 52},
	{{167, 180, 226, 144, 0, 0, 188, 184, 218, 245, 227, 82, 118, 95, 11, 102}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 119}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 38, 209, 233, 97, 116, 37, 236, 95}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 202, 189, 80, 26, 79, 24, 166, 106}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 51, 221, 242, 213, 64, 107, 46, 38, 248}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 119}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 212, 131}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 166, 46, 236, 245, 7, 108}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 125, 71, 161, 68, 177, 168, 41, 254, 88}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 52},
	{{167, 180, 226, 144, 0, 0, 255, 151, 243, 147, 25, 169, 33, 73, 73, 235}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 246, 99}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 118, 220, 162, 12}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 137, 132}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 66, 145, 96, 146, 252, 8, 86, 164}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 229, 91, 118, 212}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 25, 218, 22, 1, 75, 130}, 52},
	{{167, 180, 226, 144, 0, 9, 62, 245, 200, 178, 44, 122, 199, 13, 143, 201}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 5, 10, 219, 159, 203, 88, 9, 181, 212}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 34, 56, 217, 157, 30}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 211, 0, 80, 35, 106, 101, 225, 109}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 95, 138, 226, 180, 250, 38, 161, 118}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 189, 213, 1, 56}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 167, 226}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 28, 157}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 47, 48, 221, 105, 234, 226}, 52},
	{{167, 180, 226, 144, 0, 0, 227, 52, 161, 43, 80, 12, 202, 110, 225, 200}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 64, 215}, 52},
	{{167, 180, 226, 144, 0, 173, 55, 48, 211, 254, 249, 212, 91, 129, 107, 253}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 82}, 52},
	{{167, 180, 226, 144, 0, 0, 33, 228, 181, 174, 24, 148, 2, 243, 53, 182}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 35, 115, 38, 103, 254, 134}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 142, 84}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 49, 229, 246, 114, 229, 37}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 199, 154}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 116, 186}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 73, 75}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 27, 74, 170, 85, 184, 100, 130, 122}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 254, 180, 167, 2, 68}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 167, 74, 38, 240}, 52},
	{{167, 180, 226, 144, 0, 172, 76, 195, 165, 206, 160, 68, 8, 196, 244, 64}, 52},
	{{167, 180, 226, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 55, 216}, 52},
	{{241, 0, 0, 211, 24, 250, 230, 57, 204, 33, 116, 248, 12, 187, 115, 249}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 220, 240, 127, 248, 216, 57, 71}, 149},
	{{241, 0, 154, 218, 55, 105, 197, 102, 251, 123, 2, 237, 221, 249, 167, 209}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 213, 149, 209, 32}, 149},
	{{241, 0, 0, 0, 111, 112, 8, 101, 45, 184, 144, 41, 46, 155, 151, 31}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 165, 33, 237, 211, 184, 126, 178}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 30, 22, 128, 109, 62, 237, 242, 181}, 149},
	{{241, 0, 0, 19, 205, 184, 7, 134, 148, 67, 238, 209, 18, 188, 127, 126}, 149},
	{{241, 0, 0, 217, 118, 38, 186, 176, 39, 160, 215, 35, 197, 17, 52, 240}, 149},
	{{241, 0, 239, 245, 109, 214, 88, 154, 158, 204, 86, 190, 230, 214, 198, 99}, 149},
	{{241, 0, 0, 86, 224, 176, 184, 62, 75, 166, 205, 66, 213, 219, 39, 208}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 83, 175, 90, 245, 118, 111, 60}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 26, 237, 255, 30, 201, 0, 174, 50, 9}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 117, 125, 49}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 55}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 242, 133}, 149},
	{{241, 0, 0, 0, 64, 175, 146, 146, 136, 219, 201, 144, 184, 20, 127, 114}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 56, 116, 80, 243, 165, 9, 73, 138, 96, 111, 117, 183, 173, 117}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 166, 15, 197, 225}, 149},
	{{241, 0, 0, 196, 36, 122, 250, 83, 105, 160, 67, 226, 243, 190, 55, 197}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 92, 119, 12, 62, 83, 244, 140}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 174, 205, 51}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 232, 86, 236, 192}, 149},
	{{241, 0, 0, 160, 130, 75, 170, 198, 157, 117, 36, 137, 216, 77, 135, 194}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 11, 138, 124, 14, 91, 97, 192, 238}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 37, 101, 119, 227, 83, 202, 171, 116}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 210, 245, 201, 52}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 47, 239, 86, 150}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 253, 201, 89}, 149},
	{{241, 0, 75, 132, 108, 205, 78, 136, 75, 137, 229, 109, 116, 101, 250, 22}, 149},
	{{241, 0, 241, 199, 176, 75, 48, 196, 81, 36, 241, 44, 74, 203, 103, 76}, 149},
	{{241, 0, 0, 0, 0, 122, 99, 150, 19, 20, 135, 212, 141, 245, 144, 17}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 199}, 149},
	{{241, 0, 0, 160, 184, 188, 250, 70, 4, 154, 118, 47, 163, 139, 205, 180}, 149},
	{{241, 0, 0, 0, 0, 86, 170, 217, 226, 20, 33, 251, 6, 235, 177, 49}, 149},
	{{241, 0, 217, 39, 99, 47, 126, 129, 135, 60, 251, 24, 250, 14, 49, 246}, 149},
	{{241, 0, 0, 0, 0, 0, 123, 13, 119, 161, 76, 252, 209, 28, 14, 171}, 149},
	{{241, 0, 0, 0, 20, 195, 101, 106, 250, 21, 28, 81, 96, 45, 83, 163}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 72, 184, 221, 240, 43, 116, 99, 244, 160}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 17, 11}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 108}, 149},
	{{241, 0, 0, 174, 160, 122, 237, 108, 186, 103, 230, 100, 182, 166, 134, 204}, 149},
	{{241, 0, 0, 0, 0, 74, 206, 23, 55, 135, 55, 108, 154, 132, 227, 22}, 149},
	{{241, 0, 0, 0, 0, 0, 57, 57, 131, 253, 66, 191, 109, 212, 72, 166}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 149},
	{{241, 0, 83, 41, 174, 102, 101, 181, 42, 226, 179, 208, 163, 18, 159, 1}, 149},
	{{241, 0, 0, 0, 124, 91, 169, 93, 147, 33, 255, 136, 176, 25, 244, 204}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 15, 210, 143, 154, 32, 47, 212}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 177, 85, 9, 101, 231}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 46, 154, 58, 240}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 36, 205}, 149},
	{{241, 0, 0, 0, 0, 188, 27, 207, 213, 5, 114, 57, 212, 213, 72, 59}, 149},
	{{241, 0, 0, 0, 0, 110, 105, 188, 152, 166, 111, 38, 190, 10, 251, 174}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 0, 192, 92, 248, 163, 93, 168, 228, 76, 168, 216, 233, 50, 42}, 149},
	{{241, 0, 0, 0, 0, 0, 183, 17, 235, 94, 224, 167, 124, 111, 242, 231}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 21, 135, 173, 120}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 137, 188, 199, 199, 162, 41, 207, 191}, 149},
	{{241, 0, 0, 101, 74, 226, 212, 197, 129, 208, 90, 205, 240, 56, 216, 34}, 149},
	{{241, 0, 0, 0, 0, 109, 137, 35, 181, 131, 92, 142, 115, 144, 165, 210}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 44, 201, 128, 155, 166, 168, 124}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 124, 40, 205}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 70}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 155, 166, 158}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 141, 54, 196, 51, 253}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 157, 212, 248, 182, 209, 141, 200, 232}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 30, 53, 131, 214}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 189, 73, 40}, 149},
	{{241, 0, 0, 0, 248, 187, 148, 166, 6, 241, 73, 92, 127, 110, 202, 119}, 149},
	{{241, 0, 0, 0, 0, 154, 33, 0, 171, 177, 30, 239, 186, 105, 169, 216}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 0, 16, 59, 165, 221, 56, 69, 31, 105, 91, 210, 112, 242, 207}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 2, 206, 123}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 121, 238, 236, 175, 194, 148, 73, 66}, 149},
	{{241, 0, 0, 0, 0, 0, 166, 146, 56, 110, 176, 158, 195, 32, 170, 36}, 149},
	{{241, 0, 0, 78, 0, 73, 232, 191, 167, 249, 225, 136, 197, 173, 150, 149}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 244, 230, 3, 170}, 149},
	{{241, 0, 0, 0, 0, 144, 65, 23, 102, 117, 92, 107, 76, 130, 77, 45}, 149},
	{{241, 0, 0, 0, 198, 80, 89, 84, 248, 192, 8, 99, 132, 86, 229, 178}, 149},
	{{241, 0, 0, 0, 238, 230, 146, 213, 0, 107, 196, 125, 50, 10, 94, 115}, 149},
	{{241, 0, 0, 0, 0, 200, 159, 230, 84, 169, 200, 50, 152, 47, 167, 63}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 48, 120, 128}, 149},
	{{241, 0, 0, 0, 230, 200, 178, 21, 244, 30, 122, 246, 216, 218, 9, 242}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 135, 44, 82, 76, 42, 175, 94, 209, 74}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 80, 241, 114, 127, 31, 81, 45, 134, 254}, 149},
	{{241, 0, 0, 182, 36, 81, 171, 218, 184, 73, 82, 154, 85, 72, 36, 182}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 213, 47, 142, 69, 175, 141, 39}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 229, 11, 223}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 83, 64, 103, 132, 128, 200, 195, 137}, 149},
	{{241, 0, 0, 56, 179, 42, 14, 46, 26, 202, 111, 5, 160, 117, 221, 251}, 149},
	{{238, 9, 168, 96, 0, 137, 68, 34, 36, 32, 203, 246, 76, 207, 51, 215}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 164, 238}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 33, 184, 201, 188, 82, 73}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 39}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 156, 241, 100, 32, 185, 231, 98}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 57, 242, 106, 16, 140, 34}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 223, 33, 59, 195, 156, 22}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 28, 250, 254, 19, 191, 193, 186, 17}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 60, 131, 70, 20, 63, 129, 200, 99}, 74},
	{{238, 9, 168, 96, 3, 185, 95, 111, 189, 156, 67, 25, 101, 84, 191, 197}, 74},
	{{238, 9, 168, 96, 0, 0, 162, 175, 251, 247, 26, 57, 235, 103, 247, 113}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 172, 59, 119, 203, 127, 103, 18, 3, 82}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 66, 121, 74, 4, 27, 75, 244, 107}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 123, 89, 239, 6, 19, 21, 15, 71, 31}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 35}, 74},
	{{238, 9, 168, 96, 0, 0, 96, 59, 124, 71, 133, 199, 98, 217, 231, 181}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 160, 27, 172, 103, 113, 206, 184}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 125, 46, 213, 118, 205, 161, 200}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 240, 254, 197, 61, 209, 32, 10, 87, 118}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 42, 6, 48, 79, 25, 179, 223, 49, 254}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 189, 29, 113, 79, 119, 138, 33}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 187, 90, 62, 203, 40, 115, 35, 161, 112}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 255, 103}, 74},
	{{238, 9, 168, 96, 17, 223, 176, 161, 237, 187, 24, 151, 16, 9, 218, 194}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 204, 87}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 56, 195, 81, 174}, 74},
	{{238, 9, 168, 96, 32, 57, 67, 191, 163, 163, 149, 202, 24, 179, 248, 11}, 74},
	{{238, 9, 168, 96, 0, 0, 209, 247, 53, 64, 5, 57, 51, 100, 224, 12}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 123, 170}, 74},
	{{238, 9, 168, 96, 0, 0, 182, 146, 59, 124, 203, 30, 195, 106, 13, 66}, 74},
	{{238, 9, 168, 96, 0, 0, 205, 88, 253, 210, 70, 234, 162, 191, 220, 149}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 33, 222, 169, 165, 150, 223, 93, 71}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 23, 46}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 255, 40}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 73, 77, 54, 28, 30, 231, 152, 151, 111}, 74},
	{{238, 9, 168, 96, 0, 0, 179, 95, 119, 146, 221, 183, 46, 23, 27, 251}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 198, 251, 82, 164, 36, 113, 73, 91, 197}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{238, 9, 168, 96, 82, 176, 71, 44, 209, 57, 151, 231, 201, 156, 227, 175}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 24, 149, 8, 63, 227}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 127, 138, 40, 130}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 83, 81}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 21, 90, 78, 251, 92, 118, 29, 121}, 74},
	{{238, 9, 168, 96, 0, 0, 51, 215, 117, 208, 109, 13, 169, 35, 183, 176}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 202, 148, 112, 210, 80, 252}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 142, 72}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 218, 98, 244, 231, 119, 236, 248}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 124, 0, 10, 254, 244, 33, 55, 74}, 74},
	{{238, 9, 168, 96, 1, 149, 194, 222, 195, 212, 28, 177, 80, 213, 6, 248}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 113, 243}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 116, 34, 15, 24, 134, 91, 182}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 63, 23, 75, 79, 76, 84, 159}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 51, 234}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 222, 232, 4, 48}, 74},
	{{238, 9, 168, 96, 0, 84, 59, 154, 247, 56, 122, 65, 213, 4, 28, 129}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 139, 231, 34, 104, 252, 63, 129}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 137, 81, 89, 251, 176}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 93, 202, 45, 131, 95, 37, 49, 47, 50}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 131, 141}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 67, 6, 251, 251, 178, 106, 203}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120}, 74},
	{{238, 9, 168, 96, 0, 0, 174, 156, 87, 68, 210, 248, 184, 15, 234, 134}, 74},
	{{238, 9, 168, 96, 10, 123, 255, 81, 197, 194, 58, 94, 135, 112, 135, 231}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{238, 9, 168, 96, 0, 71, 6, 143, 170, 114, 153, 14, 248, 5, 162, 125}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 57, 239, 177, 217, 138}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 12, 176, 243, 58, 130, 110}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223}, 74},
	{{238, 9, 168, 96, 0, 24, 177, 170, 160, 38, 231, 63, 227, 20, 70, 146}, 74},
	{{238, 9, 168, 96, 0, 0, 51, 173, 23, 225, 10, 137, 42, 42, 215, 81}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{238, 9, 168, 96, 0, 1, 17, 201, 117, 195, 3, 251, 217, 139, 226, 237}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 196, 88, 246, 231, 151, 200}, 74},
	{{238, 9, 168, 96, 0, 212, 11, 234, 19, 31, 54, 98, 52, 73, 0, 191}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 240, 13, 247, 34}, 74},
	{{238, 9, 168, 96, 0, 0, 24, 27, 35, 57, 189, 126, 168, 146, 82, 39}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 126, 132}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 74}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 116, 26}, 74},
	{{238, 9, 168, 96, 0, 7, 186, 159, 130, 190, 87, 195, 47, 251, 213, 222}, 74},
	{{238, 9, 168, 96, 0, 0, 199, 8, 180, 160, 145, 205, 132, 49, 146, 119}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 219, 46, 21, 199}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 135, 67, 224, 148, 253, 31, 164, 143}, 74},
	{{238, 9, 168, 96, 0, 50, 33, 235, 125, 57, 107, 1, 77, 89, 217, 241}, 74},
	{{238, 9, 168, 96, 167, 42, 21, 100, 88, 14, 112, 161, 73, 47, 38, 131}, 74},
	{{238, 9, 168, 96, 0, 17, 71, 170, 211, 13, 148, 92, 78, 67, 219, 148}, 74},
	{{238, 9, 168, 96, 0, 0, 0, 0, 0, 213, 168, 180, 94, 252, 61, 63}, 74},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{203, 148, 16, 96, 125, 18, 86, 1, 91, 244, 251, 20, 31, 14, 75, 128}, 212},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{111, 227, 137, 94, 65, 21, 77, 137, 119, 130, 159, 19, 159, 45, 18, 192}, 238},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 196, 65, 144, 228, 20, 170}, 18},
	{{59, 144, 0, 0, 102, 163, 220, 197, 18, 236, 117, 18, 114, 130, 231, 134}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164}, 18},
	{{59, 144, 0, 0, 0, 74, 197, 147, 1, 37, 107, 67, 126, 181, 25, 162}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 69}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 197, 54, 104, 92, 212, 135, 232, 197}, 18},
	{{59, 144, 0, 0, 161, 186, 79, 187, 107, 163, 126, 245, 165, 207, 124, 243}, 18},
	{{59, 144, 0, 0, 0, 0, 174, 190, 49, 37, 133, 95, 239, 194, 130, 59}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 176, 221}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 17}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{59, 144, 0, 0, 0, 144, 228, 96, 27, 87, 18, 135, 74, 245, 129, 201}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 242, 181, 221, 22}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 18},
	{{59, 144, 0, 0, 0, 203, 184, 188, 65, 253, 149, 76, 168, 158, 130, 189}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 196, 88, 54, 107, 102, 179, 253, 73}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 212, 11, 158, 126}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 77, 217, 58, 118, 25, 108}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 235, 227, 61, 189}, 18},
	{{59, 144, 0, 0, 131, 200, 105, 51, 133, 81, 210, 80, 40, 214, 201, 36}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 223, 122, 226}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 235}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 52, 122, 175, 3}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 9, 246, 82}, 18},
	{{59, 144, 0, 0, 0, 0, 58, 12, 11, 97, 6, 197, 124, 126, 147, 160}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 19, 103, 64, 164, 72, 175, 126}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 120, 80, 195, 201, 54, 162, 94, 99, 104}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{59, 144, 0, 0, 0, 0, 74, 194, 66, 175, 48, 60, 84, 217, 72, 199}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{59, 144, 0, 0, 253, 97, 146, 231, 156, 14, 165, 22, 48, 123, 67, 183}, 18},
	{{59, 144, 0, 156, 162, 205, 178, 73, 222, 99, 55, 153, 85, 248, 251, 234}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 182, 4, 134, 54, 100, 125, 16, 164}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 123, 166, 177, 39}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 110, 100, 244, 62, 50, 254}, 18},
	{{59, 144, 0, 0, 0, 42, 142, 64, 136, 98, 157, 112, 84, 19, 44, 145}, 18},
	{{59, 144, 0, 0, 0, 0, 142, 173, 27, 117, 50, 243, 5, 253, 210, 31}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 152, 223, 205, 140, 36, 169}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 163, 44, 254, 51}, 18},
	{{59, 144, 0, 0, 0, 0, 66, 35, 12, 51, 81, 105, 96, 209, 97, 82}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 82, 124, 250}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 184, 76, 179}, 18},
	{{59, 144, 0, 0, 0, 42, 39, 144, 255, 219, 58, 57, 178, 153, 107, 130}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 77, 42, 115, 159, 186, 230, 236, 160, 16}, 18},
	{{59, 144, 0, 0, 0, 0, 34, 63, 60, 67, 29, 191, 245, 216, 221, 117}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 42, 216, 15, 221, 182, 57, 198, 218, 82}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 136, 204, 222, 144}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 118, 201, 243}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 172}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 45, 98, 185, 215, 100, 248, 27, 183, 34}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 249, 239}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 47, 213}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 144, 7, 120, 138, 174, 195, 110, 147}, 18},
	{{59, 144, 0, 0, 0, 0, 163, 126, 189, 197, 23, 145, 63, 10, 231, 64}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{59, 144, 0, 0, 0, 97, 180, 201, 78, 69, 29, 33, 50, 115, 89, 60}, 18},
	{{59, 144, 0, 0, 56, 106, 216, 28, 238, 112, 95, 27, 82, 93, 106, 201}, 18},
	{{59, 144, 0, 0, 105, 192, 36, 205, 179, 32, 113, 165, 225, 182, 96, 105}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 239, 116}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 109}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 102, 230, 193, 189, 177, 193, 201, 160}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 202, 7, 128, 30, 76, 76, 204}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 22, 231, 8}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 37, 37, 43, 162, 148, 169, 56, 236, 4}, 18},
	{{59, 144, 0, 0, 124, 184, 96, 128, 146, 11, 242, 238, 74, 232, 254, 120}, 18},
	{{59, 144, 0, 0, 0, 0, 120, 244, 6, 159, 122, 3, 26, 71, 8, 171}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 84, 132, 243, 226, 233, 135, 71, 137}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 71, 216, 179, 126, 122, 82}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 71, 104, 69}, 18},
	{{59, 144, 0, 0, 0, 0, 170, 139, 119, 192, 162, 63, 93, 226, 194, 136}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 229, 19, 66, 188, 138, 246, 89}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 78}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 168, 186, 126, 141, 31, 97, 9, 69}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 176}, 18},
	{{59, 144, 0, 0, 0, 205, 134, 86, 243, 151, 22, 233, 176, 95, 176, 9}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 100, 203}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 127, 125, 251, 23, 240, 44, 215}, 18},
	{{59, 144, 0, 0, 237, 25, 2, 7, 117, 186, 132, 204, 99, 155, 163, 123}, 18},
	{{59, 144, 0, 171, 177, 209, 41, 228, 161, 248, 134, 194, 224, 104, 60, 121}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 53, 55}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 118, 72, 14, 129, 253, 89}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 185, 17, 226, 41, 199, 11}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 154, 244, 84, 251}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 86, 13, 127, 203, 24, 81, 14, 64}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 151, 111, 176}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 165, 212}, 18},
	{{59, 144, 0, 0, 0, 64, 124, 233, 167, 115, 8, 155, 27, 98, 70, 212}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 0, 0, 138, 78, 211, 243, 179, 143}, 18},
	{{59, 144, 0, 0, 0, 0, 0, 0, 180, 38, 9, 160, 88, 24, 90, 105}, 18},
	{{59, 144, 0, 0, 89, 239, 22, 122, 128, 131, 203, 215, 205, 178, 190, 105}, 18},
	{{59, 144, 0, 0, 0, 0, 255, 154, 120, 107, 225, 230, 146, 71, 179, 120}, 18},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 49, 238, 164}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 158, 178, 114, 47, 101, 203}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 36, 136}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 32}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 226}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 19, 80, 100, 37, 206, 218}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 191, 219, 32, 69, 54}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 79}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 34}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 197, 66, 230, 244, 99, 30}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 113, 212, 172, 170}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 151, 253, 111, 185}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 135, 233}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 77, 108, 72, 183, 29}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 38}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 28, 94, 230, 108, 122}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 35, 75, 202}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 3, 120, 226, 206, 181, 158}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 228, 157, 228, 53}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 23, 62, 23}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 175, 203}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 135, 21, 204, 95, 86}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 247}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 40, 55, 175, 162, 162}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 90}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 57}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 68, 23, 153, 173}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 198, 8, 194, 14}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 86, 181, 70}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 240, 50}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 166, 128, 29}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 211, 227, 108, 102, 158}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 186, 207, 56, 186, 22}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 158, 23, 127, 94, 248}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 175, 128}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 237}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 124, 218}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 207, 65}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 140, 132, 49, 182}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 14, 75, 140}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 67, 154, 177, 194}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 189, 46, 22, 119, 125, 80}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 252, 96, 44, 184, 244}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 234, 154, 189, 87, 126}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 147, 191}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 118, 237}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 156, 67}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 250, 123, 202, 94, 144}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 63, 126, 138, 134}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 94, 180, 58, 63, 191, 191}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 150, 70, 136, 80, 234, 153}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 30}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 51, 158, 13, 19, 250}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 136, 169, 184, 18}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 202, 11, 61, 51, 176, 77}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 16}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 129}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 204, 73, 151, 87, 101}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 126, 72, 241, 137, 1, 23}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 242, 200}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 226, 152, 91}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 45, 195}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 51, 197, 181, 44}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 113, 169, 97, 222, 90}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 207}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 217, 92}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 83, 112, 141, 194, 77}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 131, 58, 228, 14, 227}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 137, 69, 18}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 72, 172, 251}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 167, 129, 140, 212}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 29, 215}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 219, 199, 179, 157, 138, 171}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 253}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 180, 233, 27, 204}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 49, 99, 123, 47}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 166, 10, 251, 33}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 213, 202, 148, 218}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 58, 80, 60, 93, 17, 225}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 14}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 107, 25, 220, 31}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 0}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 0, 0, 0, 16}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 76, 82, 73, 146}, 155},
	{{110, 192, 255, 120, 84, 215, 3, 130, 38, 224, 0, 0, 102, 176, 41, 140}, 155},
	{{152, 79, 219, 0, 0, 208, 83, 188, 96, 181, 55, 63, 95, 37, 49, 233}, 97},
	{{152, 79, 219, 0, 86, 133, 47, 231, 225, 51, 130, 214, 70, 160, 195, 202}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 40, 191, 167, 36, 243, 171}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 155, 224, 166, 215, 41, 214, 52}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 86, 132}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 153, 107, 179, 13, 120, 78, 56, 92, 47}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 251}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 175, 210, 245, 224, 232, 57, 199}, 97},
	{{152, 79, 219, 0, 0, 0, 123, 43, 177, 185, 229, 84, 103, 223, 112, 42}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 31, 172, 205}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 17, 213, 187, 52, 203, 143, 213}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 110, 47, 143, 49, 226, 66, 91}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 226, 233, 213, 43, 215, 250, 75, 61}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 231, 243, 146, 180, 101, 233}, 97},
	{{152, 79, 219, 0, 0, 229, 178, 229, 181, 199, 190, 253, 136, 109, 79, 151}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 150, 111, 16, 24, 13, 92, 139, 68, 109}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 98, 79, 53, 58, 220}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 248, 199, 151, 139, 39, 227, 132}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 247, 42, 17, 121, 184, 207, 32, 117, 183}, 97},
	{{152, 79, 219, 0, 0, 45, 106, 223, 114, 156, 41, 141, 12, 236, 219, 183}, 97},
	{{152, 79, 219, 0, 0, 0, 105, 202, 246, 78, 149, 84, 142, 63, 6, 166}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 93, 3, 162, 160, 217, 158, 230, 106}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 168}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 236, 157, 121, 203, 213, 154}, 97},
	{{152, 79, 219, 0, 0, 0, 54, 96, 119, 26, 156, 212, 75, 18, 36, 75}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 71, 74, 177, 241, 14, 6, 178}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 102, 58, 144, 40, 251, 24}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 222, 76, 109, 6, 22, 181, 21, 24}, 97},
	{{152, 79, 219, 0, 218, 104, 245, 140, 27, 108, 53, 53, 139, 148, 79, 214}, 97},
	{{152, 79, 219, 0, 0, 254, 17, 21, 8, 215, 126, 179, 116, 49, 228, 136}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 27, 176, 122, 58, 197, 192, 199, 3}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 182}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 205, 227, 102}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 120, 41, 70}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 147, 158, 212, 199, 112, 111, 209}, 97},
	{{152, 79, 219, 0, 0, 164, 93, 50, 214, 182, 102, 180, 28, 167, 139, 112}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 110, 61, 219, 48, 246, 20}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 23, 4, 175, 180, 91, 38}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 204, 244}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 126, 18, 10, 134, 88, 116, 150, 184, 146}, 97},
	{{152, 79, 219, 0, 0, 0, 97, 189, 183, 69, 19, 190, 210, 24, 75, 192}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 232, 117, 24, 37, 85}, 97},
	{{152, 79, 219, 0, 244, 117, 244, 14, 83, 58, 15, 127, 6, 178, 147, 2}, 97},
	{{152, 79, 219, 0, 0, 0, 28, 121, 233, 131, 255, 110, 97, 72, 45, 66}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 237, 44, 106, 1, 68, 177, 83, 80, 16}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 27, 62, 86, 119, 73, 55, 115, 19}, 97},
	{{152, 79, 219, 0, 0, 59, 31, 240, 208, 246, 143, 20, 63, 240, 191, 190}, 97},
	{{152, 79, 219, 0, 224, 2, 187, 230, 149, 36, 185, 157, 30, 189, 31, 176}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 119, 136, 216}, 97},
	{{152, 79, 219, 0, 219, 51, 170, 161, 28, 190, 54, 198, 165, 139, 101, 19}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{152, 79, 219, 0, 180, 180, 155, 35, 125, 88, 180, 254, 68, 63, 221, 190}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 248, 150, 241, 52, 59, 133}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 178, 196, 15}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 126, 28, 103, 178, 192, 76, 236, 30}, 97},
	{{152, 79, 219, 0, 0, 216, 234, 178, 206, 203, 150, 117, 148, 93, 86, 178}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 67, 83, 41, 147, 206, 141}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 173, 208, 76, 96, 225, 112, 153}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 224, 156}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 111, 145, 132, 211, 255}, 97},
	{{152, 79, 219, 0, 0, 0, 152, 9, 7, 178, 58, 146, 54, 206, 101, 42}, 97},
	{{152, 79, 219, 0, 190, 157, 182, 184, 87, 111, 47, 0, 202, 100, 54, 244}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 97},
	{{152, 79, 219, 0, 0, 59, 183, 74, 71, 180, 237, 232, 179, 22, 155, 224}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 172, 136, 79, 174, 250, 96}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 139, 28, 145, 209, 185, 251, 217, 150, 161}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 213, 180}, 97},
	{{152, 79, 219, 0, 112, 104, 242, 58, 152, 139, 95, 12, 35, 87, 153, 94}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 200, 76, 211}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 116, 189, 111, 135, 155, 31, 245, 193, 86}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 119, 221, 251, 64, 158, 168}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 92}, 97},
	{{152, 79, 219, 0, 0, 0, 123, 64, 166, 219, 36, 239, 154, 232, 78, 113}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 251, 223, 197, 200, 188, 186, 4, 134}, 97},
	{{152, 79, 219, 0, 0, 111, 185, 13, 17, 28, 200, 200, 120, 30, 216, 142}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191}, 97},
	{{152, 79, 219, 0, 40, 135, 69, 131, 153, 48, 222, 85, 44, 104, 25, 69}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 91, 217, 249, 206, 248, 77, 92, 177, 214}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 23, 117}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 234, 168, 209, 95, 70, 0, 105}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 83}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 198, 192, 51, 96, 86}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81}, 97},
	{{152, 79, 219, 0, 0, 0, 0, 0, 0, 0, 226, 117, 12, 72, 19, 153}, 97},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 82, 222, 227, 178, 82, 20, 190}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 132, 54}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 71, 183, 86, 188, 45, 224}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 219, 75}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 133, 107, 60, 54, 74}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 209, 13, 217, 39, 46, 162, 240, 90}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 148}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 184, 112, 74, 109, 12, 88, 233, 152, 231}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 187, 17}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 82, 243, 29, 238, 38}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 193, 201, 227, 141, 240, 203}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 49, 235, 126, 20, 206, 72, 206}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 108}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 69, 25, 162, 252, 189}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 14, 198, 144, 247, 0, 13, 170}, 8},
	{{118, 186, 157, 248, 0, 86, 183, 41, 26, 30, 170, 13, 229, 143, 62, 111}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 158}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 53, 176, 167, 3, 225, 72}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 182, 141}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 58, 142, 69, 247, 83}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 198, 22, 162, 96, 226, 87, 225}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 28, 150, 57, 41, 75, 243, 240}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 218, 229, 203, 118, 0, 242}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 157}, 8},
	{{118, 186, 157, 248, 0, 0, 183, 61, 232, 87, 182, 200, 86, 68, 129, 255}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 85}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 89, 233, 134, 20}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 223}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 174, 165, 121, 171, 7, 231, 184, 218}, 8},
	{{118, 186, 157, 248, 0, 74, 8, 103, 189, 148, 251, 235, 43, 214, 171, 173}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 97, 73, 248, 80, 204, 181, 205, 108, 65}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 225, 142, 205, 130, 24}, 8},
	{{118, 186, 157, 248, 0, 0, 248, 62, 5, 232, 52, 54, 148, 42, 1, 0}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 133, 89, 213, 146, 59, 245, 191, 167, 219}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 57, 99, 240, 31, 54}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 177, 57, 11, 205, 103, 60, 132, 205, 238}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 233, 16, 78, 90, 80, 98, 167, 125}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 54, 101, 153, 101, 253, 152, 227, 225}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 86, 24, 139, 59, 128, 178, 198, 50}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 8},
	{{118, 186, 157, 248, 0, 1, 253, 215, 134, 136, 94, 150, 18, 114, 220, 68}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 221, 165, 137, 125, 214}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 248}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 90, 95, 105, 180, 21}, 8},
	{{118, 186, 157, 248, 0, 120, 186, 217, 126, 182, 105, 146, 252, 251, 117, 248}, 8},
	{{118, 186, 157, 248, 0, 108, 135, 227, 235, 111, 249, 54, 185, 121, 82, 18}, 8},
	{{118, 186, 157, 248, 0, 58, 126, 121, 35, 205, 1, 12, 20, 151, 200, 23}, 8},
	{{118, 186, 157, 248, 0, 0, 111, 144, 231, 93, 123, 226, 184, 188, 3, 26}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 118, 253}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 93, 211}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152}, 8},
	{{118, 186, 157, 248, 0, 127, 179, 200, 153, 197, 60, 217, 29, 125, 144, 158}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 85, 142, 235, 83, 12, 39, 124}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 74, 240, 147, 93, 253, 203}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 71, 213, 60, 85, 34}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 126, 139}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 23, 198, 96, 25, 69, 52, 235, 45}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 92, 15, 76, 147}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{118, 186, 157, 248, 0, 141, 225, 194, 98, 89, 54, 189, 32, 42, 220, 251}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 119}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 193, 162, 77, 113, 94, 7, 202}, 8},
	{{118, 186, 157, 248, 0, 9, 6, 194, 139, 159, 83, 48, 225, 220, 49, 232}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 170, 99, 103, 235, 228}, 8},
	{{118, 186, 157, 248, 0, 177, 19, 61, 123, 97, 108, 220, 96, 24, 1, 206}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 86, 138, 65, 177, 222, 224}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 220, 112, 2, 23, 176, 92, 35, 9}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 242, 21, 37, 199, 139, 177, 201}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 86, 169}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 42, 234, 158, 15, 132}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 2, 83, 108, 239, 38, 246, 172, 198, 72}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{118, 186, 157, 248, 0, 0, 140, 128, 190, 176, 93, 248, 4, 166, 99, 85}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 65, 12, 111, 8}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 117, 232}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 230, 10, 125, 131, 3, 237, 74, 132, 85}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 207, 211, 145, 254}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 69, 206, 240, 243}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 137, 194}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 133, 80, 49, 173}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 215, 171, 79, 45, 235, 234}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 166, 58, 127, 223, 35, 126, 20}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 30, 178, 247, 177}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 8},
	{{118, 186, 157, 248, 0, 110, 242, 102, 22, 164, 136, 88, 40, 131, 81, 120}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 8, 107, 113, 201, 0}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 164, 113}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 162, 23, 211, 0, 224, 81, 31, 36}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 91, 241, 251, 187, 197, 155, 240, 39, 216}, 8},
	{{118, 186, 157, 248, 0, 232, 144, 136, 230, 239, 197, 58, 54, 62, 170, 139}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 59, 254, 78, 244, 90, 51}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 182}, 8},
	{{118, 186, 157, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 238, 184}, 8},
	{{118, 186, 157, 248, 0, 0, 47, 39, 73, 171, 99, 158, 116, 174, 233, 233}, 8},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 94, 221}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 128, 162, 207, 209, 113, 22, 97, 95, 0}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 96, 34, 133, 119, 20, 35, 161}, 123},
	{{70, 128, 0, 0, 0, 222, 14, 236, 201, 171, 208, 181, 97, 175, 147, 234}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 60, 32, 203, 41, 89, 102, 48}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 251, 194, 255, 235, 255, 183, 159, 192}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 226, 124, 255, 1, 160, 202, 136}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 123, 80}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 43, 21, 234, 41, 140, 199}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 17}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 253, 100, 10, 194}, 123},
	{{70, 128, 0, 0, 0, 209, 74, 140, 214, 70, 119, 70, 138, 66, 0, 164}, 123},
	{{70, 128, 0, 178, 152, 16, 64, 130, 211, 206, 93, 196, 151, 70, 75, 56}, 123},
	{{70, 128, 0, 0, 175, 23, 150, 33, 144, 94, 108, 52, 90, 205, 139, 144}, 123},
	{{70, 128, 28, 201, 85, 103, 58, 50, 130, 241, 128, 112, 219, 123, 219, 205}, 123},
	{{70, 128, 0, 0, 0, 42, 51, 192, 21, 194, 125, 236, 112, 146, 108, 44}, 123},
	{{70, 128, 0, 0, 204, 195, 120, 74, 125, 226, 245, 91, 238, 67, 6, 23}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 161, 244, 128, 119}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 63, 173, 195, 105, 155, 5, 6, 85}, 123},
	{{70, 128, 0, 0, 0, 11, 215, 17, 237, 121, 149, 17, 109, 22, 15, 60}, 123},
	{{70, 128, 0, 0, 0, 0, 144, 14, 21, 207, 68, 77, 139, 44, 247, 211}, 123},
	{{70, 128, 0, 0, 0, 0, 131, 197, 249, 242, 61, 196, 192, 127, 105, 97}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 123},
	{{70, 128, 0, 14, 236, 113, 29, 183, 76, 157, 5, 67, 98, 161, 12, 100}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 67, 246, 86, 92, 232, 36, 171, 89, 202}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 181, 248}, 123},
	{{70, 128, 0, 0, 0, 0, 101, 6, 222, 17, 220, 184, 146, 81, 74, 130}, 123},
	{{70, 128, 0, 0, 0, 245, 145, 44, 249, 85, 168, 4, 252, 205, 170, 169}, 123},
	{{70, 128, 0, 0, 0, 173, 87, 80, 131, 66, 169, 68, 159, 153, 227, 239}, 123},
	{{70, 128, 0, 12, 15, 111, 1, 105, 149, 185, 169, 65, 82, 33, 76, 73}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 54, 252, 237, 4, 158, 69, 12}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 152, 70, 178, 152, 49, 145, 87}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 12, 0, 237, 193, 212, 242, 119, 248}, 123},
	{{70, 128, 0, 0, 242, 182, 30, 155, 128, 39, 242, 223, 206, 53, 136, 6}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 45, 183}, 123},
	{{70, 128, 0, 0, 0, 0, 142, 153, 48, 181, 104, 136, 111, 239, 119, 238}, 123},
	{{70, 128, 0, 0, 0, 0, 186, 26, 108, 94, 147, 160, 117, 65, 49, 100}, 123},
	{{70, 128, 0, 0, 0, 50, 49, 69, 61, 64, 161, 113, 76, 205, 96, 23}, 123},
	{{70, 128, 0, 0, 0, 255, 239, 168, 254, 98, 61, 182, 70, 17, 124, 167}, 123},
	{{70, 128, 69, 97, 171, 66, 181, 10, 59, 36, 38, 66, 5, 53, 41, 63}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 84}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 126, 72, 27, 34}, 123},
	{{70, 128, 0, 0, 70, 141, 78, 39, 172, 185, 155, 166, 122, 165, 53, 114}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 170, 142, 158, 156, 147, 61}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 221, 94, 135, 25, 20, 233, 195, 151}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 160, 223, 230, 27}, 123},
	{{70, 128, 0, 0, 0, 0, 55, 193, 189, 23, 58, 255, 241, 109, 252, 61}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 90, 92, 27, 220, 148, 141, 196, 3, 55}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 28, 160}, 123},
	{{70, 128, 0, 22, 146, 90, 209, 10, 135, 163, 54, 139, 240, 198, 237, 246}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 235, 186, 188, 34, 49, 23}, 123},
	{{70, 128, 0, 0, 0, 108, 151, 147, 165, 89, 75, 173, 156, 148, 192, 35}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 251, 240, 158, 182, 117, 120, 119, 104, 156}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 223, 79, 11, 226, 105, 202}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 214, 244, 214, 85, 0, 234, 5}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 212, 68, 118, 10, 191, 28}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 109, 9, 52, 229, 215, 233, 233, 100}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 149, 16, 24, 66, 17, 95}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 168, 163}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 123},
	{{70, 128, 0, 0, 0, 6, 156, 198, 206, 163, 44, 70, 181, 184, 3, 171}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 136, 235}, 123},
	{{70, 128, 0, 34, 216, 175, 173, 235, 244, 42, 62, 74, 169, 139, 186, 1}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 111, 12, 154, 157, 175, 10, 172, 102}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 128, 1, 218, 39}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 210, 154, 119, 82, 55, 177, 229}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 155, 147, 234, 245, 131, 81}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 49}, 123},
	{{70, 128, 0, 0, 0, 0, 85, 213, 226, 71, 155, 89, 81, 193, 229, 95}, 123},
	{{70, 128, 36, 114, 112, 189, 159, 85, 68, 194, 101, 204, 63, 64, 155, 89}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 82, 84, 21, 13, 223, 105, 159, 100}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 24, 156, 147, 248, 31, 185, 137}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 1}, 123},
	{{70, 128, 0, 0, 0, 100, 226, 245, 223, 167, 116, 170, 235, 177, 9, 73}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 123},
	{{70, 128, 0, 0, 0, 0, 188, 35, 32, 191, 127, 27, 111, 180, 7, 139}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 181, 203}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 142}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 124, 212}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 109, 23, 212, 235, 147, 79}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 159, 229, 183, 58, 65, 66, 205, 230}, 123},
	{{70, 128, 0, 0, 0, 124, 182, 25, 130, 134, 220, 27, 218, 232, 28, 152}, 123},
	{{70, 128, 0, 0, 45, 250, 51, 228, 121, 236, 184, 124, 0, 182, 241, 111}, 123},
	{{70, 128, 0, 0, 36, 205, 9, 71, 193, 70, 188, 226, 207, 19, 211, 88}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 186, 121}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 196, 51}, 123},
	{{70, 128, 0, 0, 0, 0, 160, 98, 250, 126, 170, 3, 155, 50, 247, 243}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 4, 92, 173, 130, 142, 243}, 123},
	{{70, 128, 0, 0, 49, 149, 220, 51, 237, 113, 146, 189, 9, 210, 166, 9}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 100, 3, 64}, 123},
	{{70, 128, 130, 179, 96, 32, 179, 5, 115, 61, 51, 14, 219, 144, 28, 13}, 123},
	{{70, 128, 0, 252, 196, 253, 7, 151, 106, 96, 120, 217, 79, 59, 28, 18}, 123},
	{{70, 128, 0, 0, 0, 91, 170, 244, 233, 43, 241, 184, 33, 68, 116, 138}, 123},
	{{70, 128, 0, 199, 149, 58, 32, 6, 86, 21, 229, 200, 149, 167, 132, 138}, 123},
	{{70, 128, 0, 0, 0, 0, 0, 0, 131, 42, 58, 141, 215, 53, 107, 117}, 123},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 41}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 164, 50, 229}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 63}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 122, 165, 8, 212}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 74, 64, 71}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 67, 82, 135}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 50, 140}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 4}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 77}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 72, 25}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 184, 166}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 8, 37, 183, 186}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 50, 153, 47}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 53, 189, 195, 152}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 56}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 62, 15, 131}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 134, 220}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 67, 169, 96, 209}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 156, 27}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 168}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 250, 79}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 5}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 19, 212}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 95}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 39}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 42, 107, 111, 206}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 106, 186, 69, 122}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 199, 224}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 159}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 129, 138, 64, 167}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 82}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 80}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 107, 155, 161}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 206}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 122, 105, 164, 219}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 12, 173, 157, 9}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 165, 27}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 243, 156, 116}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 143, 113}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 192}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 181, 51}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 99, 217, 78}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 13, 28}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 70}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 184, 30, 132}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 219, 114, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 121, 215, 156, 185}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 171, 27, 169}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 126, 95, 126}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 66}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 219, 89}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 117, 131}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 211, 243, 66}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 191}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 146}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 241, 95}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 17}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 90}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 177}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 144}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 127, 87}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 2, 47, 62}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 37, 43, 89}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 50, 226, 102}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 117}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 36, 238}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 112}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 48, 109}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 36}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 126}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 105}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 143, 247}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 53}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 71, 19, 75}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 212, 98, 2}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 89, 240}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 0, 0}, 11},
	{{253, 119, 114, 227, 18, 243, 81, 61, 238, 107, 190, 144, 0, 0, 224, 116}, 11},
	{{166, 112, 0, 190, 25, 219, 187, 102, 1, 20, 198, 20, 249, 174, 23, 231}, 211},
	{{166, 112, 0, 0, 0, 26, 149, 172, 231, 217, 23, 103, 106, 23, 201, 71}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 108}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 67, 225}, 211},
	{{166, 112, 0, 0, 223, 83, 171, 151, 74, 177, 6, 37, 219, 69, 233, 89}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 99, 172, 97, 16, 56, 254}, 211},
	{{166, 112, 251, 98, 181, 225, 36, 127, 73, 56, 209, 248, 89, 88, 56, 232}, 211},
	{{166, 112, 0, 0, 155, 125, 94, 147, 14, 171, 60, 115, 189, 236, 170, 37}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 17, 186, 4, 170, 165, 5, 195, 236, 113}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 99}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 4, 155, 138, 214, 36, 100, 218, 159, 62}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 255, 246, 113, 11, 169, 196, 183, 16, 82}, 211},
	{{166, 112, 0, 0, 0, 0, 182, 201, 231, 123, 201, 59, 194, 111, 196, 36}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 5, 16, 86, 246, 155, 190, 226}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 202, 107, 206, 79}, 211},
	{{166, 112, 0, 0, 0, 0, 109, 72, 212, 197, 239, 205, 226, 255, 171, 206}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 110}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 120, 94, 219, 65, 229, 115, 224}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 153}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 245, 35, 77, 39, 53, 110, 241}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 87}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 42, 85, 80, 45}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 191}, 211},
	{{166, 112, 117, 222, 211, 118, 157, 76, 25, 57, 131, 235, 241, 64, 153, 93}, 211},
	{{166, 112, 0, 188, 14, 166, 43, 100, 147, 185, 88, 216, 19, 60, 255, 27}, 211},
	{{166, 112, 0, 0, 0, 52, 205, 96, 67, 187, 91, 251, 14, 146, 49, 184}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 74, 252, 104, 145, 82, 15, 10, 165, 63}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 142, 15, 77, 99, 83, 5}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 100, 49, 65}, 211},
	{{166, 112, 0, 0, 0, 0, 248, 95, 47, 30, 133, 176, 232, 103, 100, 249}, 211},
	{{166, 112, 0, 0, 0, 0, 145, 26, 126, 199, 212, 212, 49, 56, 201, 59}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 114, 53, 203, 79, 128, 251}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 232, 160, 102, 226, 6, 22, 90, 130, 104}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 158, 42, 226, 127}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 114, 110, 8}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 80, 217, 190, 2, 224, 155, 173}, 211},
	{{166, 112, 0, 0, 124, 110, 152, 102, 80, 47, 177, 54, 19, 45, 181, 82}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 42, 67, 135, 11}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 195, 123, 142, 106}, 211},
	{{166, 112, 0, 223, 83, 153, 34, 10, 138, 243, 3, 107, 166, 34, 106, 38}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 31, 238, 172}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 192, 216, 79, 227, 79, 224, 10, 147, 116}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 186, 153, 48, 62}, 211},
	{{166, 112, 0, 0, 0, 0, 181, 36, 208, 169, 208, 11, 199, 154, 7, 147}, 211},
	{{166, 112, 0, 0, 0, 49, 69, 200, 203, 57, 181, 36, 155, 151, 68, 171}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 254, 26, 98, 191}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 102, 223, 107, 250}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 104}, 211},
	{{166, 112, 0, 0, 0, 197, 59, 20, 247, 70, 201, 193, 9, 222, 155, 60}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 117, 105, 193, 168, 19, 113, 34}, 211},
	{{166, 112, 0, 0, 0, 0, 119, 159, 4, 228, 81, 3, 223, 111, 112, 246}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 35, 91, 126, 119}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 186, 116, 231, 255, 30, 168, 110}, 211},
	{{166, 112, 0, 0, 169, 192, 89, 202, 9, 172, 152, 16, 126, 232, 18, 34}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 46, 110, 7, 212}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{166, 112, 0, 0, 0, 0, 205, 115, 54, 127, 211, 59, 237, 187, 31, 225}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 185, 74, 104}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 233, 153, 86, 162}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 62, 131, 195, 140, 119, 146, 18}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 60, 111, 201, 219, 120, 110}, 211},
	{{166, 112, 221, 51, 5, 181, 16, 89, 16, 110, 223, 189, 124, 1, 243, 100}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 5, 201, 249, 194}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 182}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 140, 181, 40}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 24, 60, 124, 120, 193, 232}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 25, 179, 90, 55, 109, 247}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 27, 135, 100, 201, 227, 165}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59}, 211},
	{{166, 112, 0, 0, 0, 81, 20, 100, 163, 154, 205, 96, 183, 228, 246, 115}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 48}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 151}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 211},
	{{166, 112, 0, 105, 52, 149, 99, 246, 131, 46, 223, 109, 76, 168, 4, 183}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 87, 66, 170, 228, 32, 6}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 38, 184, 208, 234, 85, 120, 58, 135, 125}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 10, 2, 99, 110, 190, 166, 24, 98}, 211},
	{{166, 112, 0, 243, 253, 123, 2, 4, 142, 28, 20, 49, 30, 142, 82, 49}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 232, 23, 240, 154, 214, 81, 95}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 32, 99, 88, 237, 67, 185, 47, 101, 190}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 223, 108, 45}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 220, 245, 132}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 224, 8, 178, 218, 122, 214, 108, 90, 57}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 145, 138, 248, 146, 185, 208, 150}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 125, 148}, 211},
	{{166, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{43, 95, 224, 0, 186, 235, 217, 42, 160, 69, 219, 155, 93, 209, 163, 175}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 231, 124, 215, 178, 244, 97}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{43, 95, 224, 0, 0, 0, 174, 4, 109, 203, 209, 132, 128, 129, 172, 162}, 116},
	{{43, 95, 224, 0, 0, 0, 183, 81, 118, 30, 40, 141, 221, 103, 148, 223}, 116},
	{{43, 95, 224, 0, 0, 0, 65, 82, 102, 236, 221, 45, 157, 74, 148, 104}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 116},
	{{43, 95, 224, 0, 94, 176, 48, 101, 185, 96, 57, 109, 67, 30, 3, 76}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 45}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 246, 194, 245}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 83, 59, 100, 112, 255, 109, 206}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 100, 84, 170, 39, 92}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 235}, 116},
	{{43, 95, 224, 0, 84, 205, 85, 41, 51, 212, 43, 213, 113, 226, 156, 170}, 116},
	{{43, 95, 224, 0, 50, 140, 108, 38, 24, 206, 159, 126, 16, 121, 66, 85}, 116},
	{{43, 95, 224, 204, 234, 128, 248, 83, 242, 203, 231, 216, 142, 123, 32, 228}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 33, 201, 230, 1, 109, 28, 162}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 101, 83, 106, 159, 147}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 138, 158, 113, 3, 149}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 63, 161, 155, 221, 77, 11}, 116},
	{{43, 95, 224, 0, 0, 0, 154, 228, 149, 116, 76, 232, 73, 204, 232, 158}, 116},
	{{43, 95, 224, 0, 0, 70, 2, 220, 17, 179, 137, 122, 249, 72, 82, 166}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 155, 89, 239}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 249, 1}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 47, 155, 166, 227, 147, 135, 221, 15}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 246, 146}, 116},
	{{43, 95, 224, 0, 79, 152, 19, 161, 202, 162, 13, 178, 80, 149, 55, 51}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 237, 16, 89, 161, 237, 144}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 64, 240, 242, 112, 20, 136}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 61}, 116},
	{{43, 95, 224, 0, 0, 149, 122, 157, 98, 57, 64, 142, 217, 191, 115, 55}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 44, 75}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 230, 136, 254}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 219, 102, 216, 185, 153, 43}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 3, 109, 213, 239, 177, 233}, 116},
	{{43, 95, 224, 0, 0, 0, 110, 89, 253, 39, 21, 200, 213, 16, 243, 24}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 230, 153, 36, 130, 18, 184, 102}, 116},
	{{43, 95, 224, 0, 0, 229, 248, 74, 52, 115, 176, 82, 211, 236, 198, 37}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 133, 215, 73}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 91, 242, 21, 145, 39, 30, 57, 254, 144}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{43, 95, 224, 0, 0, 0, 232, 146, 101, 6, 228, 154, 113, 253, 51, 183}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{43, 95, 224, 0, 0, 129, 78, 49, 74, 26, 31, 232, 199, 110, 149, 99}, 116},
	{{43, 95, 224, 0, 59, 107, 143, 254, 40, 214, 163, 9, 177, 103, 167, 212}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 31, 251, 63, 153, 143}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 143, 189}, 116},
	{{43, 95, 224, 0, 49, 231, 173, 119, 192, 239, 236, 70, 67, 91, 254, 246}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 222, 135, 30, 37, 59}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 190, 150, 191}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 157, 138}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 246, 83, 94, 22, 110}, 116},
	{{43, 95, 224, 0, 17, 54, 112, 187, 164, 198, 165, 216, 236, 139, 214, 169}, 116},
	{{43, 95, 224, 203, 30, 87, 207, 20, 113, 36, 250, 57, 228, 147, 213, 171}, 116},
	{{43, 95, 224, 0, 2, 229, 57, 221, 122, 230, 142, 165, 182, 169, 227, 2}, 116},
	{{43, 95, 224, 0, 93, 17, 21, 187, 3, 130, 28, 44, 36, 116, 180, 175}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 34, 163, 12}, 116},
	{{43, 95, 224, 0, 0, 0, 19, 203, 111, 81, 7, 112, 130, 158, 233, 67}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 195}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 69, 136}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 138}, 116},
	{{43, 95, 224, 0, 0, 128, 217, 201, 99, 177, 1, 63, 47, 22, 170, 229}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 155, 210, 153, 12, 240, 46, 46, 21, 34}, 116},
	{{43, 95, 224, 85, 50, 51, 150, 54, 171, 165, 12, 255, 210, 170, 25, 140}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 35, 109, 165, 153, 213, 193, 154, 38}, 116},
	{{43, 95, 224, 187, 47, 16, 66, 232, 172, 167, 35, 145, 233, 238, 1, 164}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 140, 84, 236, 224, 232, 84}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 199, 89, 241, 94, 144, 154, 31, 122, 140}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 42, 195, 137}, 116},
	{{43, 95, 224, 0, 0, 251, 251, 143, 174, 206, 155, 169, 145, 91, 28, 80}, 116},
	{{43, 95, 224, 0, 0, 106, 167, 73, 175, 43, 36, 125, 40, 160, 118, 82}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 183, 151, 66, 62, 223}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 183, 17}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 146, 27, 233, 156, 235, 7, 187}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 20, 244}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 157, 130, 49, 174, 241, 205, 14, 208}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 47, 201, 156, 0, 224, 96, 135}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 199, 90, 227, 153, 37}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 27, 108}, 116},
	{{43, 95, 224, 157, 163, 245, 141, 37, 97, 76, 126, 223, 17, 79, 26, 241}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 227, 108}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 50, 76}, 116},
	{{43, 95, 224, 0, 0, 0, 104, 94, 124, 244, 79, 159, 199, 70, 228, 252}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 106, 209}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 76, 31, 217}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 29, 180, 114, 135, 116, 78, 40, 195}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 0, 236, 102, 157, 38, 124, 73, 149, 127}, 116},
	{{43, 95, 224, 0, 0, 0, 0, 40, 116, 43, 160, 242, 215, 17, 85, 234}, 116},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 41, 247}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 57},
	{{94, 128, 0, 0, 0, 0, 144, 229, 92, 66, 45, 124, 193, 59, 19, 75}, 57},
	{{94, 128, 0, 116, 105, 185, 240, 49, 241, 238, 249, 15, 218, 37, 218, 189}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 181, 155, 80, 6}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 36, 8, 191}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 6, 93, 162, 70, 41, 131, 102, 168}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 242}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 73, 232, 220, 10, 218, 142, 74, 159, 114}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 121, 59, 242, 191, 126, 92, 71}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 117, 244, 14}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 223, 67, 125, 31, 134, 42, 228, 140}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 130, 253, 165, 232}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{94, 128, 0, 0, 0, 174, 37, 227, 218, 13, 254, 33, 181, 176, 36, 178}, 57},
	{{94, 128, 0, 0, 36, 238, 17, 199, 230, 160, 125, 77, 214, 102, 56, 209}, 57},
	{{94, 128, 0, 0, 0, 23, 177, 92, 130, 8, 109, 192, 155, 7, 152, 8}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 108, 198}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 190, 115, 66, 25, 241, 132, 185, 15, 87}, 57},
	{{94, 128, 0, 0, 28, 29, 57, 235, 136, 233, 107, 163, 167, 89, 108, 155}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184}, 57},
	{{94, 128, 0, 0, 0, 0, 230, 198, 51, 88, 102, 229, 33, 84, 128, 66}, 57},
	{{94, 128, 0, 0, 238, 254, 36, 230, 62, 52, 144, 136, 158, 77, 13, 190}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 9, 92, 118, 55, 147, 54, 203, 73, 62}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{94, 128, 0, 0, 0, 0, 15, 149, 166, 149, 197, 131, 78, 68, 171, 165}, 57},
	{{94, 128, 0, 211, 89, 38, 56, 21, 128, 26, 18, 60, 213, 113, 241, 83}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 131, 197, 66, 87, 46, 197}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 23, 114, 199, 186}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 89, 184, 134, 100, 248, 12, 78, 109, 121}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 250, 59, 140, 48, 54, 198}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 245, 255, 218}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 182, 65, 233, 145, 209, 210, 134, 56}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{94, 128, 0, 0, 0, 63, 121, 164, 192, 187, 171, 58, 190, 212, 67, 222}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 197, 238, 0, 55, 53, 81, 184, 185}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 191, 210, 137, 60}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 162, 144, 178, 21, 226, 63, 152, 195}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 231, 207}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 30, 236, 153, 90}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 196, 167, 206, 176, 26, 237}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 159, 5}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 201, 63}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 241, 176, 149, 40, 156, 10}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 14, 89, 166, 139, 219, 65, 188, 133}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 255, 206, 3}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 87}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 92, 155}, 57},
	{{94, 128, 103, 246, 140, 201, 218, 30, 2, 61, 214, 51, 248, 10, 165, 62}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 57},
	{{94, 128, 0, 0, 0, 0, 55, 101, 9, 93, 45, 124, 62, 221, 21, 172}, 57},
	{{94, 128, 0, 0, 182, 25, 190, 224, 76, 36, 212, 40, 174, 188, 193, 12}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 138, 26, 57, 32, 187, 204, 53, 63, 226}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 9, 74, 134, 16}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 34, 95, 191, 61, 251, 236, 67}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 71, 136}, 57},
	{{94, 128, 0, 91, 69, 22, 228, 37, 185, 35, 1, 186, 212, 90, 29, 21}, 57},
	{{94, 128, 0, 0, 147, 122, 61, 151, 9, 177, 217, 101, 182, 211, 159, 184}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 255, 155, 176, 230, 74, 166, 161, 187, 61}, 57},
	{{94, 128, 0, 0, 0, 0, 7, 141, 74, 190, 207, 55, 219, 225, 93, 88}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 236, 166}, 57},
	{{94, 128, 0, 0, 0, 0, 88, 192, 48, 55, 194, 72, 155, 7, 177, 231}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 70}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 47, 33, 188, 187, 40, 117, 182, 70}, 57},
	{{94, 128, 0, 0, 0, 0, 212, 77, 28, 226, 165, 115, 199, 120, 237, 109}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 126, 255, 94, 17, 25, 242}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 148, 85, 89, 229}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 158, 16}, 57},
	{{94, 128, 0, 251, 144, 212, 27, 183, 1, 138, 233, 230, 10, 105, 85, 91}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 162, 96, 248, 101, 19, 154, 32}, 57},
	{{94, 128, 0, 0, 77, 115, 3, 224, 55, 202, 223, 16, 189, 61, 182, 160}, 57},
	{{94, 128, 0, 0, 107, 8, 182, 54, 0, 16, 26, 224, 238, 151, 177, 181}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 57},
	{{94, 128, 0, 0, 0, 175, 232, 29, 206, 234, 27, 50, 142, 170, 194, 173}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 38, 86, 79, 134}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 228, 39, 216, 70, 26, 127, 237}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 142, 23, 184, 80, 32, 14, 117, 254}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 135, 29, 249, 212, 43, 47, 166, 236, 156}, 57},
	{{94, 128, 0, 57, 216, 160, 34, 162, 188, 121, 140, 127, 172, 224, 67, 226}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 104, 13, 144, 123, 168, 13, 132, 17}, 57},
	{{94, 128, 0, 0, 0, 87, 40, 253, 246, 210, 81, 45, 131, 18, 232, 175}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 183, 119}, 57},
	{{94, 128, 0, 0, 177, 165, 178, 131, 178, 207, 45, 130, 177, 219, 119, 245}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 220, 250}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 64, 59, 152, 39, 10, 8}, 57},
	{{94, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 171}, 57},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 69}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 196}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 205}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 233, 133}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 101}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 149, 231}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 253}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 33}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 180}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 182}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 66, 89}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 66, 52}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 217}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 88}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 245}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 212}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 107}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 92}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 10}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 232}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 62, 102}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 255}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 67}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 145}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 122, 29}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 214}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 120, 242}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 110}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 152}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 187}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 107}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 214, 171}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 97}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 168}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 60, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 141}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 208, 121}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 46}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 32}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 75, 208}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 60}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 65, 45}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 94, 93}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 214}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 104}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 119}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 217}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 97, 200}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 47}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 139, 159}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 100, 17}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 24}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 181, 225}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 205}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 142}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 21}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 31, 139}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 0}, 178},
	{{182, 251, 195, 132, 66, 7, 208, 146, 223, 231, 211, 181, 25, 176, 0, 218}, 178},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 106, 198}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 45, 255}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 106, 161}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 63, 86}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 230}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 127, 178}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 60, 208}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 171}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 147}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 199}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 188, 61}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 216, 110}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 8}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 159, 49}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 247, 12}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 84, 138}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 194}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 191}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 62}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 107}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 9}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 16}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 59, 47}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 7, 72, 119}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 3, 163}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 237, 30}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 212, 51}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 110}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 171, 146, 68}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 88, 212, 127}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 51, 174}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 245, 0, 194}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 30, 233}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 19, 189}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 254, 20, 236}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 54, 154, 48}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 145}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 131, 158}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 214}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 170, 204}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 141}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 29}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 84}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 224, 186}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 180}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 124}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 152, 72}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 218}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 21, 19}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 193}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 154}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 184, 143}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 86, 158}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 10, 56}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 245, 82}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 16}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 71, 203}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 159}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 64}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 59, 91}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 141}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 0, 0}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 42, 152}, 93},
	{{152, 166, 111, 233, 194, 17, 230, 41, 221, 253, 69, 123, 108, 0, 55, 107}, 93},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 109, 89, 5}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 92, 125}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 138, 158, 217, 32}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 140, 54}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 189, 210, 124}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 215, 151}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 207, 96}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 112, 192, 177, 29}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 93, 224, 203}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 133, 130, 173, 189}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 142, 216, 122}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 186, 85, 140}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 254, 229, 240, 107}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 238, 65, 120}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 181, 83, 229}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 185, 30}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 51, 56}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 236}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 118}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 44, 243, 143, 242}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 138, 144, 78, 13}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 190, 197, 47}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 182, 13}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 39, 165}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 110, 197, 82, 248}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 241, 31}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 30, 62, 119, 130}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 60}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 21}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 12, 59, 78}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 240, 204, 115}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 64, 4, 215}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 227, 39}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 65, 226}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 149}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 69}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 156, 119, 238, 106}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 180, 196, 122}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 231}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 123}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 206, 247, 238}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 15}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 110, 69}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 201, 42, 76}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 156}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 175}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 252}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 19, 26, 213, 176}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 119, 155, 56}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 145, 119, 54}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 139, 11, 224}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 89, 37, 148, 164}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 184, 123}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 115, 150, 248}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 188}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 182}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 221, 80}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 253, 253}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 137, 45, 189}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 228}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 48, 254, 46, 208}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 109, 138, 226}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 102, 187, 182}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 61, 37}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 50}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 183, 59, 254}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 50, 252}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 196, 80}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 93, 74}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 57, 56}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 135, 18, 111}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 89, 203, 238, 57}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 236, 119}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 240, 65, 10}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 244}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 133}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 161, 225}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 100, 107, 2}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 82}, 3},
	{{106, 141, 235, 190, 82, 241, 152, 186, 195, 81, 86, 144, 0, 0, 0, 0}, 3},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{32, 81, 210, 153, 151, 29, 11, 62, 127, 177, 194, 254, 103, 83, 58, 128}, 162},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 160, 142}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 251, 194}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 196, 188}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 237}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 241}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 173}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 84, 90}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 86, 139}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 83}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 5}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 225}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 248}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 150}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 181}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 47}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 129}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 158}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 231}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 190}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 244, 144}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 17, 74}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 59, 34}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 68}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 159, 252}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 20}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 225}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 164}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 54}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 126}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 104}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 228}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 189}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 250, 160}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 252}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 60}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 145}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 76}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 80, 181}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 158}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 162}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 27}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 100, 88}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 20}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 189}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 217}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 107}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 135}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 160}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 36}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 23}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 145, 174}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 208}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 176}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 235}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 0, 0}, 125},
	{{79, 112, 224, 26, 174, 39, 98, 181, 115, 57, 209, 189, 136, 48, 196, 189}, 125},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 21, 186, 154, 209, 54, 75, 167}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 25, 119, 116, 142, 51, 124}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 251, 92, 240, 64, 49}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 16, 187, 186, 210, 226, 152, 166}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 191, 149, 31, 206, 165, 131}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 116, 13, 84, 159}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 90, 54, 134, 34, 212}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 214, 74, 132, 47, 215}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 68, 47, 242, 131, 43, 255, 233, 146, 173}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 235, 218, 3, 134, 81, 212, 9}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 88, 178, 219, 53, 136}, 33},
	{{106, 197, 83, 151, 64, 0, 71, 64, 93, 203, 238, 143, 159, 184, 224, 111}, 33},
	{{106, 197, 83, 151, 64, 4, 109, 151, 90, 97, 9, 229, 93, 118, 129, 234}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 249}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 177}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 33}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 222}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 82}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 255, 172, 226, 161, 126, 96, 141, 237}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 108}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 66, 53, 229, 112, 227, 94}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 152, 195, 0, 249, 199, 176, 245, 189, 106}, 33},
	{{106, 197, 83, 151, 64, 92, 87, 239, 8, 246, 122, 115, 65, 197, 206, 185}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 117, 24, 236, 80, 209, 253}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 13, 23, 191, 229, 40, 232, 53}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 109}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 145, 11, 172, 98, 20}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 28, 97, 17, 95, 194, 139}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 71, 41, 168, 222, 9, 252}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 57, 108, 111, 227, 194}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 3, 36, 173}, 33},
	{{106, 197, 83, 151, 64, 0, 254, 11, 83, 111, 156, 247, 112, 180, 55, 84}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 70, 64, 131, 127, 80, 132, 174, 179}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 21, 83, 177, 218, 145, 16, 39, 220, 125}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 204, 131, 120, 43, 212}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 30, 196, 227, 86, 134, 99}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 102, 92, 10, 93, 122, 55}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{106, 197, 83, 151, 64, 0, 161, 63, 63, 96, 110, 95, 101, 145, 197, 168}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 35, 223, 198, 141, 63, 233}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 220}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 213, 72, 60, 60, 239, 98, 187}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 29, 146, 48, 214, 139, 51, 52}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 19, 17, 56, 164, 140, 221, 237, 22}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 75, 170, 164, 42, 87, 70, 2, 211}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 221}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 8}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 108, 92, 126, 8}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 77, 213, 171, 183, 182, 39}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 129, 68, 44, 252, 35, 249, 214}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 49}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 124, 195, 208, 59}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 108, 204, 162, 86, 244, 246, 112, 238, 77}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 136, 193, 111, 117, 254, 118, 32, 22, 169}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 52, 171, 248, 90, 151, 81, 1, 23}, 33},
	{{106, 197, 83, 151, 64, 248, 132, 46, 141, 72, 230, 115, 40, 29, 138, 77}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 125, 106, 76}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 24}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 167, 218, 95, 38, 110}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 48, 0, 253, 115, 226}, 33},
	{{106, 197, 83, 151, 64, 0, 184, 197, 109, 46, 16, 16, 219, 251, 99, 201}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 73, 30, 194}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 109, 242, 83, 53}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 144, 188, 71}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 168, 239, 55, 240, 4}, 33},
	{{106, 197, 83, 151, 64, 0, 165, 199, 252, 39, 68, 147, 223, 11, 212, 44}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 47, 90, 47, 119, 104}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 231, 33, 67, 218, 121, 137, 182, 50, 98}, 33},
	{{106, 197, 83, 151, 64, 35, 51, 94, 210, 97, 114, 175, 18, 182, 67, 140}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 38, 80, 64, 204, 128, 207, 160, 156, 34}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 178, 63, 227, 9}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 153, 75, 214, 201, 19, 70}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 50, 131, 128, 14, 63}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 198, 179, 70, 185, 52, 18, 136, 134}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 181, 104, 88, 125, 35, 20, 226, 227, 235}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 144, 184, 89}, 33},
	{{106, 197, 83, 151, 64, 0, 139, 15, 164, 17, 2, 98, 159, 28, 142, 40}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 26}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 249, 54, 157, 211}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 38, 169, 189}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 221, 14, 78, 171, 178, 158, 100, 144, 222}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 41, 120, 138, 157, 111, 221, 89, 35}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 164, 34, 122, 16, 246, 145, 205, 90}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 33},
	{{106, 197, 83, 151, 64, 0, 0, 120, 227, 26, 93, 106, 225, 135, 173, 170}, 33},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 70, 81}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 159, 207, 251, 185, 138}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 119, 183, 43, 147, 138}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{190, 0, 156, 206, 135, 248, 76, 115, 174, 113, 88, 192, 228, 71, 241, 30}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 179, 131}, 254},
	{{190, 0, 0, 0, 215, 19, 155, 224, 24, 90, 65, 43, 60, 39, 209, 219}, 254},
	{{190, 0, 0, 0, 151, 62, 171, 23, 100, 15, 142, 137, 86, 225, 148, 54}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 47, 53}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 224, 61}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 76}, 254},
	{{190, 0, 0, 0, 0, 166, 36, 64, 42, 15, 139, 4, 216, 166, 145, 172}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 30, 6, 75, 202, 39, 2, 18}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 9}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 228, 171}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 97, 177, 242, 71, 77, 226, 37}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 78, 164, 46}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 158}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 246}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 194, 106, 245, 88, 121, 104, 217, 228, 252}, 254},
	{{190, 0, 0, 0, 0, 0, 210, 78, 255, 35, 249, 103, 28, 213, 247, 248}, 254},
	{{190, 0, 168, 33, 105, 204, 90, 24, 73, 132, 192, 18, 235, 185, 220, 145}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 239, 88, 89, 85}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 154, 23}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 196, 123, 222, 83, 143, 86, 20, 62}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 114, 250, 116, 85}, 254},
	{{190, 0, 0, 0, 0, 190, 249, 113, 38, 178, 87, 241, 228, 23, 10, 230}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 225}, 254},
	{{190, 0, 0, 0, 102, 127, 227, 43, 8, 235, 11, 31, 223, 121, 136, 250}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 243, 175, 181, 224, 134, 31, 50, 45}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 50, 40}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 242, 93, 254, 45}, 254},
	{{190, 0, 123, 26, 222, 100, 255, 236, 4, 137, 112, 8, 220, 11, 201, 198}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 66, 199, 247}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 98, 217, 168}, 254},
	{{190, 0, 0, 0, 197, 189, 150, 240, 228, 213, 63, 140, 91, 69, 2, 53}, 254},
	{{190, 0, 0, 19, 132, 172, 254, 98, 157, 80, 105, 32, 31, 78, 86, 217}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 156, 56}, 254},
	{{190, 0, 0, 0, 0, 159, 112, 222, 184, 142, 204, 183, 63, 67, 181, 38}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 74, 229, 189}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 50}, 254},
	{{190, 0, 0, 0, 0, 0, 43, 208, 91, 15, 28, 240, 7, 162, 60, 246}, 254},
	{{190, 0, 0, 52, 203, 175, 117, 174, 23, 254, 140, 116, 174, 152, 149, 140}, 254},
	{{190, 0, 0, 0, 0, 0, 71, 91, 251, 61, 171, 66, 210, 179, 229, 17}, 254},
	{{190, 0, 75, 3, 104, 53, 225, 50, 179, 1, 235, 128, 67, 141, 67, 64}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 193, 166, 0}, 254},
	{{190, 0, 0, 77, 38, 61, 184, 147, 227, 151, 87, 78, 129, 231, 111, 217}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 92, 54, 110, 4, 36, 103, 60, 116}, 254},
	{{190, 0, 0, 0, 111, 23, 138, 79, 245, 111, 107, 1, 205, 230, 14, 15}, 254},
	{{190, 0, 0, 0, 0, 88, 24, 228, 189, 70, 197, 61, 31, 112, 116, 77}, 254},
	{{190, 0, 0, 0, 0, 139, 250, 82, 77, 37, 107, 118, 92, 83, 156, 47}, 254},
	{{190, 0, 0, 0, 171, 131, 157, 15, 150, 26, 39, 161, 7, 195, 155, 128}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 110, 131, 107, 176, 146, 98, 194, 106, 9}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 180, 177, 244, 187}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 2, 14}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 151, 253, 150, 8}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 127}, 254},
	{{190, 0, 99, 175, 181, 38, 172, 177, 232, 94, 62, 82, 153, 198, 187, 70}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 12, 129, 160, 114, 179, 199, 161, 43}, 254},
	{{190, 0, 0, 0, 0, 0, 113, 252, 43, 151, 114, 30, 182, 40, 251, 78}, 254},
	{{190, 0, 95, 104, 204, 77, 75, 220, 37, 15, 111, 2, 125, 164, 46, 59}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 64, 47, 28, 104, 121}, 254},
	{{190, 0, 0, 107, 38, 208, 193, 153, 235, 202, 179, 245, 227, 184, 15, 29}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 232, 161, 50, 4, 166, 1, 241}, 254},
	{{190, 0, 0, 0, 0, 0, 41, 19, 39, 167, 251, 212, 41, 202, 165, 190}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 16, 240, 66, 20, 113, 225, 128, 26}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 90, 121, 121, 150, 58}, 254},
	{{190, 0, 121, 233, 2, 4, 76, 73, 111, 37, 55, 208, 32, 147, 62, 255}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 120, 158, 211}, 254},
	{{190, 0, 0, 0, 0, 94, 50, 22, 198, 203, 188, 219, 143, 248, 130, 194}, 254},
	{{190, 0, 0, 0, 0, 192, 146, 68, 176, 226, 142, 78, 7, 12, 173, 38}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 100, 52, 138}, 254},
	{{190, 0, 0, 130, 60, 177, 131, 118, 19, 211, 137, 211, 249, 68, 37, 48}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 154}, 254},
	{{190, 0, 0, 0, 0, 118, 221, 6, 51, 161, 198, 186, 146, 89, 139, 183}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 66, 23}, 254},
	{{190, 0, 242, 65, 164, 46, 222, 178, 72, 113, 245, 162, 59, 67, 66, 206}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 106}, 254},
	{{190, 0, 0, 0, 0, 0, 27, 95, 223, 142, 202, 64, 138, 178, 58, 159}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 87, 210, 89, 83, 123}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 177, 109, 15, 209, 200, 74, 64, 48}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 94, 227, 84, 24, 182}, 254},
	{{190, 0, 0, 0, 0, 27, 209, 147, 25, 64, 96, 66, 19, 93, 93, 37}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 165}, 254},
	{{190, 0, 0, 0, 0, 208, 225, 46, 19, 56, 17, 247, 100, 188, 136, 141}, 254},
	{{190, 0, 0, 0, 89, 33, 197, 129, 220, 148, 59, 10, 86, 0, 201, 48}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 207, 254, 164, 240}, 254},
	{{190, 0, 157, 16, 172, 6, 128, 181, 184, 159, 133, 96, 220, 99, 151, 238}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 254},
	{{190, 0, 0, 0, 0, 0, 0, 0, 0, 19, 202, 54, 180, 15, 195, 139}, 254},
	{{190, 0, 0, 127, 115, 114, 184, 218, 224, 133, 177, 103, 75, 219, 190, 176}, 254},
	{{190, 0, 100, 96, 18, 167, 33, 84, 49, 82, 95, 161, 0, 75, 230, 81}, 254},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 9}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 58}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 153, 106, 14, 110, 26, 28}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 103, 107, 11, 130}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 174, 79, 81, 32, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 131}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 174, 241, 183, 28, 59}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 31, 50, 96, 212}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 199, 45, 190, 190, 45}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 154, 191, 144, 113, 246}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 207, 9, 123, 115}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 186, 7, 107, 203, 170}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 189, 182}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 131, 42, 98, 142, 199, 78}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 174, 44}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 171, 161, 133, 42}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 22, 37}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 36}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 96, 65}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 177, 110}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 1, 223, 41}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 159, 238}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 204, 194, 175, 83}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 44, 102, 107, 163, 59, 230}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 116, 167, 86, 248, 102}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 183, 130, 198}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 216, 92, 145}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 114, 180, 153}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 182, 41, 104, 194, 172}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 201, 76, 139, 187}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 168, 35, 126, 94, 63}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 164, 144, 216, 215, 99}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 153, 118, 240, 37, 135, 175}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 136}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 86, 122, 195, 58}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 184, 25, 13, 172}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 237}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 214, 53, 115}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 194, 99, 173, 35}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 100, 15, 185, 187, 115, 229}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 200}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 107, 92, 239}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 217, 68, 221}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 15, 86, 84, 57, 235}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 129, 240, 209, 106}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 11, 155, 100, 7, 199}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 173, 125, 208, 213, 38, 59}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 185}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 242, 242, 154, 98, 119, 242}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 120, 230, 144, 56, 190, 252}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 19, 195, 193}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 48, 159, 5, 145}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 227}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 17, 72, 85}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 95, 236, 159}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 115, 174, 160, 17}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 213, 191, 207, 40}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 88, 85, 157}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 100, 3, 15, 72, 109}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 180, 59, 120, 50, 167}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 240, 140, 54}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 74, 140, 92, 240}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 39, 90}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 105, 29, 249}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 68, 56}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 187}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 43, 136, 134, 198}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 232, 211, 176}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 70, 28}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 213, 73}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 72, 179, 81, 154, 23}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 240, 123, 217, 144, 45, 50}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 21, 196, 158}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 69}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 104, 188, 213, 2, 220}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 85, 122, 34, 92}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 107, 74, 111, 203}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 91, 193}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 38, 228, 198}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 221, 44, 149}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 75, 219, 164, 5, 114, 106}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 241, 238, 149, 78, 252, 13}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 0, 0}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 66, 183}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 0, 0, 37, 29}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 0, 0, 130, 181, 250, 85}, 66},
	{{156, 73, 249, 148, 55, 192, 20, 42, 142, 128, 213, 118, 193, 22, 29, 146}, 66},
	{{64, 107, 36, 120, 0, 0, 0, 80, 199, 85, 29, 58, 18, 156, 159, 120}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 31}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 106, 124, 84, 212, 76, 16}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 163, 199, 111, 170, 12, 67, 107, 170}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 30, 140, 153, 145}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 57}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 226, 253, 161, 202}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 219, 192, 94, 25, 142}, 4},
	{{64, 107, 36, 120, 0, 186, 66, 162, 234, 119, 244, 192, 19, 213, 43, 219}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 15, 156}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 20, 101, 63, 56, 114, 18, 232, 104, 53}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 193, 125, 218, 131, 108}, 4},
	{{64, 107, 36, 120, 0, 22, 220, 119, 47, 48, 54, 177, 253, 195, 74, 198}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 186}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 103, 241, 254, 111}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 185, 176, 17, 167, 191, 13, 114, 206}, 4},
	{{64, 107, 36, 120, 0, 0, 194, 146, 145, 139, 171, 40, 212, 60, 127, 206}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 225, 251, 111, 121, 62, 175, 234, 59, 114}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 212, 150, 173, 245, 117, 24, 103}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 18, 31, 215, 36, 137, 250, 242, 172, 26}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{64, 107, 36, 120, 78, 249, 212, 44, 225, 112, 79, 108, 141, 119, 219, 173}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 69, 2, 162, 197, 91, 16}, 4},
	{{64, 107, 36, 120, 192, 179, 60, 25, 204, 228, 113, 175, 244, 195, 131, 247}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 190}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 238, 237}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 28, 240}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 188, 126, 214, 55, 67, 75, 211, 64}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 55, 209, 106, 211, 60, 0}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 65, 215, 175, 41}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 57, 128, 244, 138, 173, 197, 87}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 67, 184, 242, 198}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 49, 80, 168, 30, 35, 64, 167, 99, 30}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 248, 144, 124, 170}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 176, 144, 91, 110, 62, 158}, 4},
	{{64, 107, 36, 120, 0, 232, 84, 34, 9, 1, 33, 126, 210, 226, 127, 199}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 73, 226, 188, 93, 98, 96, 130, 42}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 86, 128, 164, 87, 175, 118}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 122, 0, 46, 251, 109, 176, 186}, 4},
	{{64, 107, 36, 120, 220, 133, 95, 233, 49, 236, 44, 42, 189, 226, 170, 54}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 248, 65, 68, 235, 144, 181, 123, 204, 126}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 172, 112, 138, 93, 189, 166}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 96, 10}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 44, 17, 109, 136}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 78, 100, 5, 188, 79, 68, 244}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 130, 92, 91, 17, 102, 239, 86}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 197, 63, 71, 219, 225, 103, 188, 96}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 219, 189, 121, 126, 249, 233}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 52, 28, 95, 228, 200, 175, 195}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 96, 24, 200, 233}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 225, 89, 67, 57, 179, 172}, 4},
	{{64, 107, 36, 120, 0, 155, 249, 60, 119, 34, 47, 73, 60, 150, 155, 138}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 248, 205, 41, 49, 45, 79, 66, 253, 125}, 4},
	{{64, 107, 36, 120, 0, 0, 122, 14, 167, 162, 195, 230, 62, 173, 16, 144}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 17, 70, 117, 86}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 248}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 153, 221, 194, 12, 206, 50, 179, 0}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 41}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 211, 43, 38, 60, 151, 18}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 104, 3, 85, 19, 89, 98}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 244, 252, 253, 207, 19, 157, 29, 213}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 96, 138, 63, 50, 36, 215}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 154, 108, 22, 38, 227, 219, 188}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 81}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 95}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 109, 129, 173, 206, 99, 148, 94, 24, 134}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 11, 115, 155, 9}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 111, 72, 188, 157, 14, 128, 174, 199}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 156}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 203, 24, 202, 143, 208, 223, 140, 175}, 4},
	{{64, 107, 36, 120, 0, 29, 170, 14, 137, 24, 169, 52, 8, 168, 93, 133}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 4},
	{{64, 107, 36, 120, 0, 0, 166, 191, 205, 127, 80, 251, 5, 218, 161, 57}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 121, 163, 65, 195, 103, 110, 136}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 28, 233, 95, 12, 12, 208}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 217}, 4},
	{{64, 107, 36, 120, 0, 0, 14, 3, 76, 115, 223, 171, 26, 230, 235, 114}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 158, 60, 166, 234, 138, 135, 243, 96}, 4},
	{{64, 107, 36, 120, 0, 0, 0, 0, 0, 198, 203, 196, 224, 187, 195, 201}, 4},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 242}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 41, 85, 183}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 91, 176, 200}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 9}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 201, 103, 247, 151, 97}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 240, 240, 197}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 151, 182, 82, 110}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 149, 27, 219}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 48}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 171}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 92, 56}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 220}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 159, 145}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 47, 233, 228}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 157, 11, 214, 194}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 106, 232, 195, 138, 39}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 66}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 253, 140, 166, 169}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 89, 121, 58, 39}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 62, 211, 105, 123}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 187, 34, 42, 93}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 78}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 51, 38, 231, 254}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 38, 124, 97, 112}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 25, 189, 196}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 207, 198, 50, 113}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 168}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 149, 103, 193}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 11}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 114}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 151, 209, 35, 171, 230}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 88}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 227, 2, 236, 200, 9}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 199, 214, 235, 12, 94}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 68, 203, 14}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 231}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 198, 140, 35, 251, 135}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 164}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 119, 6}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 51}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 33, 166, 64, 120}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 59, 111, 239}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 238, 144}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 171, 205, 175, 6}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 205, 33, 96}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 213}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 37, 48}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 8, 93, 41, 127}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 87}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 43, 248, 35, 88}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 138, 99}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 177, 170, 115, 48}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 64, 167, 157, 108}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 38}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 31, 165}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 163, 233, 17}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 125, 80}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 200}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 105}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 20}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 252, 104, 78, 99, 251}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 108, 54, 242, 143, 200}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 79, 254, 85, 100, 24}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 59, 126, 226}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 25}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 106, 28, 236, 82}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 142, 38, 208}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 103, 168, 76, 110}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 85}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 16, 28}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 59}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 44, 146, 60}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 136}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 228, 133, 54, 92}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 66, 72, 45}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 21, 195}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 81}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 138}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 30, 243, 56}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 23, 95, 85, 25}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 86}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 0}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 0, 47}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 87, 166, 220, 223, 214}, 122},
	{{115, 148, 71, 250, 158, 174, 168, 249, 106, 110, 196, 0, 0, 0, 68, 87}, 122},
	{{18, 139, 152, 44, 38, 88, 0, 0, 109, 223, 185, 181, 20, 181, 113, 56}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 229, 145, 185, 176, 120, 236, 233, 122, 66}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 104, 144, 112}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 198, 98}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 171, 76, 46, 135, 204}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 59},
	{{18, 139, 152, 44, 38, 88, 239, 46, 123, 130, 59, 7, 179, 231, 75, 20}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 159, 144, 87, 252}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 123, 10, 54, 233}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 84, 248, 39, 183, 56, 42}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 253, 206, 161, 214, 40, 16, 193, 66, 250}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 59},
	{{18, 139, 152, 44, 38, 88, 244, 16, 24, 91, 32, 49, 176, 40, 206, 189}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 140, 236, 87}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 148, 152, 195, 190, 208}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 173, 97, 135, 123}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 87, 50, 13, 210, 82}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 141, 34, 7, 232, 6, 141, 207, 61, 235}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 17, 172, 50, 218, 44, 251, 61, 244, 219}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 127, 149}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 100, 255, 25, 91, 251}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 221, 78, 203}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 218, 181, 158, 26, 226, 42, 83}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 62, 254, 16, 226, 233, 153, 86, 139}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 220, 220, 139, 35, 74, 100, 51, 226}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 114, 13, 109, 35, 207, 145, 128, 73, 121}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 152, 222, 129, 73, 82, 69, 247, 177}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 202, 210}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 64, 153, 179}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 240, 175, 66, 210, 172, 155, 205}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 193, 205, 19, 180, 52, 188, 85, 237}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 15, 144, 194, 5, 48}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 147, 153}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 131, 152, 246, 225, 154, 3, 96}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 152, 114, 169, 155, 154, 232, 239, 210}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 171, 201, 160, 20, 98, 53, 116, 63, 115}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 64, 212}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 228, 98, 246, 49, 86}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 14, 91, 135, 229, 202}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 179, 74, 44, 119}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 42, 222, 181, 14, 208, 227, 34}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 169, 142, 30}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 234, 71, 243}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 51, 50, 98, 203, 199, 132, 48, 158}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 27, 6, 198, 8}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 235, 50, 218, 116, 91, 159, 226, 11, 102}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 29, 178, 83, 114}, 59},
	{{18, 139, 152, 44, 38, 88, 243, 75, 34, 46, 36, 222, 131, 38, 155, 43}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 122, 43, 197, 114}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 17, 50, 32, 223, 133, 128}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 176, 40, 92, 254, 130, 121, 41, 27, 175}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 218, 41, 130}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 128, 6, 100, 80, 161, 202, 186}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 211, 175}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 129, 174}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 192, 154, 197, 248, 94, 189, 149}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 182, 254, 133, 227, 145}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 41, 62}, 59},
	{{18, 139, 152, 44, 38, 88, 155, 113, 131, 99, 221, 41, 5, 28, 146, 122}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 51, 87, 214, 21, 91, 171, 221, 197}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 247, 49, 145, 211}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 93, 121, 55, 195, 6}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 57, 227, 211, 160, 149, 214, 72}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 21, 201, 201, 195, 223}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 153, 214, 254, 142, 146}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 172, 235, 221, 236, 85, 125, 178}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 75, 223, 34, 252, 176, 200, 182}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 201, 216, 255, 149, 245, 139, 126, 131, 121}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 175, 173, 219, 217, 149, 236, 204, 106, 168}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 169, 231, 72, 147}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 37, 228}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 50, 57, 48, 234, 196}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 29, 9, 18, 140, 235, 197, 181, 215}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 223, 112, 37, 36, 29}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 73, 231, 90, 239}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 242, 248, 102, 42}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 78, 189, 29, 244}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 103, 245, 207}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 129, 129, 63, 141, 208, 74, 108, 170, 116}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 163, 222}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{18, 139, 152, 44, 38, 88, 0, 193, 253, 132, 146, 6, 34, 17, 223, 124}, 59},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 224}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 77}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 127}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 20}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 70}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 125}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 29}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 129}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 23}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 87}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 170}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 35}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 130}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 170}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 171}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 127}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 104}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 219}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 88}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 185}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 218}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 216}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 91}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 173}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 0}, 99},
	{{55, 229, 117, 106, 146, 95, 74, 220, 122, 0, 84, 202, 183, 138, 120, 21}, 99},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 53, 76}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 224, 18, 6, 198, 204, 113, 105, 211, 193}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 87, 0}, 41},
	{{153, 211, 3, 96, 0, 66, 148, 128, 170, 38, 29, 59, 25, 184, 219, 149}, 41},
	{{153, 211, 3, 96, 0, 0, 83, 103, 73, 50, 114, 64, 135, 238, 238, 208}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 18}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 130, 63}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 129, 3, 196, 74, 75, 25}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 224}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 252, 133, 109, 49, 224, 90}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 109, 173, 164, 194, 87, 13, 157, 154}, 41},
	{{153, 211, 3, 96, 0, 164, 105, 167, 25, 182, 177, 180, 105, 202, 82, 111}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 2, 6, 72, 4, 117, 125, 16, 154}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 216, 56}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 40, 114, 80, 216}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 30, 35, 183, 188, 85, 56, 207, 137}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 80, 129}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 140, 251, 71, 5, 195, 5, 74, 201, 110}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 174, 149, 193, 88, 97, 212, 235}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 140, 162, 83, 214, 196, 27}, 41},
	{{153, 211, 3, 96, 0, 78, 71, 28, 173, 142, 108, 240, 214, 123, 41, 179}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 1, 184}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{153, 211, 3, 96, 0, 0, 73, 82, 129, 239, 20, 83, 215, 152, 104, 206}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 48, 137, 28, 47, 199, 124, 152, 135}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 44, 48, 135, 41, 167, 33, 63}, 41},
	{{153, 211, 3, 96, 0, 0, 136, 133, 86, 60, 246, 193, 176, 167, 31, 17}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 91, 240, 160, 169, 101, 144}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 105, 218, 215, 165}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 103, 131, 86, 64}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 2, 71}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 206, 79, 172, 31, 60, 47, 52, 170}, 41},
	{{153, 211, 3, 96, 0, 0, 42, 198, 22, 0, 65, 225, 233, 113, 13, 229}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 193, 72, 158, 183, 69}, 41},
	{{153, 211, 3, 96, 0, 141, 15, 126, 230, 143, 191, 208, 153, 116, 44, 71}, 41},
	{{153, 211, 3, 96, 0, 0, 52, 59, 82, 73, 50, 179, 229, 229, 128, 52}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 41},
	{{153, 211, 3, 96, 0, 0, 67, 8, 110, 58, 44, 85, 167, 138, 65, 179}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 150, 202, 224, 184, 228, 70}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 54, 174, 219, 46, 104, 200, 201, 211}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 95, 187, 31, 155, 198, 244, 69, 239}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{153, 211, 3, 96, 0, 0, 218, 200, 32, 46, 56, 67, 113, 85, 148, 182}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{153, 211, 3, 96, 0, 40, 98, 144, 97, 199, 234, 227, 187, 101, 199, 75}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 213, 76}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 128, 113, 24, 64, 234, 122, 198}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 183, 238, 230, 63}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 185}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 52, 126, 115, 69}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 216, 217, 148, 249, 89, 107, 5}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 201, 223, 239, 19, 152, 17, 198, 33, 127}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 241, 90, 30, 91, 50, 33, 238, 85}, 41},
	{{153, 211, 3, 96, 0, 5, 194, 150, 57, 157, 194, 236, 210, 237, 183, 124}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{153, 211, 3, 96, 0, 0, 211, 140, 137, 132, 207, 214, 14, 93, 139, 177}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 13, 118}, 41},
	{{153, 211, 3, 96, 91, 111, 160, 35, 205, 9, 227, 61, 94, 207, 133, 180}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 94, 81, 168, 26, 155, 174, 118, 117, 4}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 204, 78, 134, 233, 129, 135, 228}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 157, 92, 40, 52, 167, 226}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 53, 238, 36, 207, 176, 175, 157, 71, 132}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 2, 131, 215, 130, 121, 115}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 169, 252, 154, 233, 68, 69, 144, 232, 9}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 217, 154, 17, 29}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 233}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 193, 13, 38, 25, 181, 215, 103, 249, 246}, 41},
	{{153, 211, 3, 96, 0, 136, 156, 110, 179, 190, 4, 223, 101, 162, 59, 22}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{153, 211, 3, 96, 0, 183, 233, 0, 137, 254, 173, 170, 129, 71, 89, 69}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 167, 101, 185, 158, 152, 248}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 74, 46, 45, 4}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 161, 243, 160, 94, 55, 202, 216, 221}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 212, 42}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 108, 209, 217, 245, 84, 30}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 200, 181, 201, 231, 241, 245, 27, 85}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 32, 165}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 70, 99}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 133, 168}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 138, 103, 95, 114, 126, 82, 90, 226, 23}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 79, 210, 59, 16, 149, 88, 138}, 41},
	{{153, 211, 3, 96, 0, 219, 174, 158, 236, 188, 42, 64, 82, 42, 184, 203}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 207}, 41},
	{{153, 211, 3, 96, 217, 114, 129, 24, 1, 137, 225, 22, 60, 255, 166, 55}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 41},
	{{153, 211, 3, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 197, 99, 80, 140}, 137},
	{{1, 0, 231, 101, 27, 71, 216, 95, 98, 77, 161, 110, 63, 147, 21, 117}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 137},
	{{1, 0, 0, 52, 166, 34, 96, 218, 194, 201, 233, 91, 205, 205, 151, 54}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 49, 142, 149}, 137},
	{{1, 0, 0, 31, 90, 12, 247, 229, 182, 135, 220, 221, 253, 106, 44, 150}, 137},
	{{1, 0, 0, 0, 131, 96, 95, 120, 214, 138, 206, 159, 165, 168, 10, 44}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 232, 185, 221, 218, 112, 97, 17}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 47, 123, 255, 214}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 29, 204, 17, 102, 122, 20, 68}, 137},
	{{1, 0, 0, 0, 0, 173, 33, 89, 216, 174, 202, 21, 112, 49, 191, 159}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 107, 176}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 173, 136, 155, 233, 93}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 11, 79, 202, 17, 203, 178, 243, 181, 142, 58, 1, 248, 217}, 137},
	{{1, 0, 193, 175, 94, 138, 4, 117, 31, 249, 36, 46, 89, 94, 90, 206}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 82, 94, 240, 22, 20, 95, 151, 103, 97, 166, 225, 26}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 27}, 137},
	{{1, 0, 170, 151, 7, 242, 10, 2, 148, 37, 133, 79, 247, 34, 32, 219}, 137},
	{{1, 0, 0, 0, 0, 0, 92, 188, 135, 200, 32, 29, 185, 188, 166, 153}, 137},
	{{1, 0, 245, 9, 192, 242, 178, 177, 130, 37, 81, 19, 115, 148, 164, 39}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 42, 7, 88, 30, 242}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 48, 178, 83}, 137},
	{{1, 0, 0, 171, 71, 163, 67, 120, 185, 161, 149, 77, 215, 67, 103, 199}, 137},
	{{1, 0, 249, 172, 190, 219, 4, 28, 50, 159, 130, 70, 38, 140, 144, 115}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 167, 208, 145, 187, 29, 36, 76, 85}, 137},
	{{1, 0, 0, 0, 0, 0, 153, 123, 232, 18, 241, 224, 30, 19, 50, 247}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 35, 81, 64, 78, 191, 26, 164, 26, 142, 146, 154, 163}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 45, 148, 135}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 47, 108, 118, 247, 74, 238, 176, 86, 11}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 180, 117, 96, 102, 190}, 137},
	{{1, 0, 0, 0, 148, 239, 244, 75, 247, 125, 135, 71, 162, 255, 143, 109}, 137},
	{{1, 0, 143, 112, 158, 172, 16, 200, 63, 84, 175, 107, 169, 30, 53, 131}, 137},
	{{1, 0, 33, 12, 242, 6, 4, 96, 42, 160, 186, 134, 118, 60, 248, 255}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189}, 137},
	{{1, 0, 221, 45, 216, 87, 79, 238, 68, 134, 209, 153, 98, 120, 28, 241}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 223, 115, 184, 178, 72, 192, 149, 244}, 137},
	{{1, 0, 0, 0, 127, 101, 222, 38, 58, 81, 230, 97, 248, 112, 4, 57}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 22, 172, 161, 142, 77, 176, 253}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 71, 5, 83, 169, 204, 53, 80, 24}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 164, 61}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 99, 143, 32, 224, 153}, 137},
	{{1, 0, 167, 32, 148, 106, 219, 2, 231, 169, 28, 163, 171, 27, 100, 36}, 137},
	{{1, 0, 0, 0, 0, 126, 5, 224, 243, 240, 16, 56, 242, 160, 101, 119}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 150, 241, 34, 109, 119}, 137},
	{{1, 0, 0, 48, 193, 33, 194, 97, 159, 95, 90, 195, 34, 185, 176, 228}, 137},
	{{1, 0, 0, 0, 0, 0, 168, 192, 42, 214, 215, 184, 186, 94, 240, 155}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 68, 203, 147, 162}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 255, 143, 216, 206, 47, 229, 69, 15}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 23, 173}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 249, 36, 144, 127, 93, 195, 211, 174, 80}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 227}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 0, 6, 163, 216, 51, 172, 213, 83, 132, 111, 184, 179}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 239, 81, 228, 75, 142, 162, 210}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 102, 86, 19, 3, 211, 0, 102}, 137},
	{{1, 0, 0, 0, 0, 204, 252, 166, 10, 6, 230, 116, 6, 254, 206, 132}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 62, 93}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 85, 122, 136, 32, 94, 56, 154}, 137},
	{{1, 0, 0, 0, 0, 0, 189, 61, 245, 172, 64, 48, 75, 193, 77, 234}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 111, 23, 109, 152, 252, 76, 177}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 203, 212, 208, 135, 236, 123, 48, 190, 97}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 222}, 137},
	{{1, 0, 97, 195, 96, 138, 182, 69, 246, 118, 33, 106, 105, 150, 251, 40}, 137},
	{{1, 0, 0, 0, 0, 159, 47, 159, 166, 204, 50, 209, 76, 60, 3, 187}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 216, 208, 52, 108, 85, 206, 230, 172}, 137},
	{{1, 0, 0, 0, 0, 156, 133, 124, 149, 42, 80, 150, 181, 232, 179, 184}, 137},
	{{1, 0, 0, 0, 27, 156, 201, 250, 202, 75, 129, 251, 29, 19, 150, 79}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 25, 66, 53, 109, 125, 19, 109}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 246, 226}, 137},
	{{1, 0, 0, 0, 0, 18, 59, 213, 76, 27, 138, 122, 188, 117, 253, 230}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 153, 104}, 137},
	{{1, 0, 0, 0, 106, 200, 114, 24, 154, 36, 106, 89, 141, 33, 34, 212}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 61, 174, 108, 191, 155, 170, 214, 206}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 137},
	{{1, 0, 0, 0, 212, 129, 26, 199, 132, 221, 102, 145, 161, 231, 249, 35}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 179, 236, 67, 134, 9, 97, 127}, 137},
	{{1, 0, 0, 146, 186, 182, 103, 82, 4, 49, 13, 142, 156, 41, 241, 61}, 137},
	{{1, 0, 0, 0, 5, 149, 75, 223, 69, 41, 21, 133, 2, 33, 103, 52}, 137},
	{{1, 0, 180, 69, 7, 172, 160, 185, 14, 52, 189, 84, 114, 183, 117, 93}, 137},
	{{1, 0, 59, 168, 228, 29, 119, 119, 124, 100, 47, 185, 176, 24, 121, 231}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 89, 49, 243}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 24}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 77, 27, 164}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 142, 199, 49, 51, 42, 223, 191, 64, 98}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 231, 199}, 137},
	{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 118}, 137},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 86, 140, 70, 133}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 148, 100, 234, 25}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 84, 150, 35, 224}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 125}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 177, 13}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 103, 153}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 41}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 250}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 76, 175}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 146, 71}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 206, 29}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 44}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 202, 212, 205, 21}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 31, 232}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 197}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 203, 191}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 144}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 15, 202}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 109}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 46, 89, 17, 76, 207}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 229}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 238, 46, 183}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 23, 154, 46, 139}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 193, 214}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 15}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 89, 80}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 72, 67}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 192, 1, 245, 4}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 62, 78, 22, 53}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 251, 7, 44}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 197, 226, 163, 143}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 239, 11}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 167, 157, 1, 175}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 76, 214}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 176, 245, 25, 206, 167}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 97}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 154, 151, 234}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 26, 155, 15, 191}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 40, 58, 234}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 64}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 251, 176}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 149, 134, 14, 90}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 123, 130, 151, 234}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 84}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 165, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 73}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 198, 166, 138}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 36, 24, 127, 188}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 179, 195, 178, 197}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 44, 33, 197, 164}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 69}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 97, 65, 100}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 190}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 100}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 237, 79, 157, 95}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 226, 250, 191, 121}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 38, 145}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 179, 76, 34, 176}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 165, 46, 35, 252, 113}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 97, 214}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 20, 20, 233, 255}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 169, 93, 192, 154}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 7, 28, 36, 75, 216}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 36, 223}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 59}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 14}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 72, 158, 31}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 227, 205}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 64, 79, 98, 139, 183}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 104, 42, 35}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 182, 16}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 111, 102}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 237}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 237, 180, 151}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 83, 57, 155, 192}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 0}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 75, 116}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 116}, 255},
	{{49, 192, 102, 142, 216, 3, 114, 64, 165, 128, 168, 0, 0, 0, 0, 51}, 255},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 197, 163}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 253, 202, 147, 27, 57, 174, 204}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 139, 168}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 66, 110, 185, 205, 126, 237}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 122, 64, 220, 168, 46, 44, 122, 78}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 107, 211}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 20, 12, 60, 198, 188, 101, 184, 239}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 167, 202, 120, 53, 4}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 199, 223, 75, 157, 218, 45, 177, 1, 161}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 114, 114}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 74, 110, 50, 255}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 5, 42, 44, 53}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 162, 150, 187, 197, 78, 175, 61, 113}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 81, 184, 175, 186, 40, 188}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 115, 61, 38, 172, 218, 199, 89}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 138, 92, 165, 156, 138, 45, 62, 126, 9}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 199, 126, 64}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 35, 28, 197, 73, 84}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 164, 40, 70, 218, 104, 247}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 150, 72, 99, 101, 241}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 181, 162, 195, 171}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 201, 118, 191, 77, 248, 84, 123, 173}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 110, 242, 180, 74, 104, 191, 30, 80}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 46, 84, 9, 49}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 129, 87, 146, 183, 155}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 104, 158, 63, 51, 141, 32, 55, 193}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 123, 185, 102, 38, 63, 213, 50, 158, 215}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 160, 209, 227}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 66, 246, 147}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 226, 137, 34, 9}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 28, 29, 247, 238, 122, 72}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 162, 138, 104, 149, 104, 242}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 144, 198}, 106},
	{{201, 143, 240, 240, 209, 224, 145, 28, 179, 129, 243, 162, 72, 135, 27, 46}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 117, 42, 3, 30, 47, 46}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 167, 104, 213, 156, 125, 211, 202, 110}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 62, 44, 176, 100}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 104, 106, 237, 75, 156}, 106},
	{{201, 143, 240, 240, 209, 224, 142, 219, 198, 23, 162, 113, 63, 161, 113, 223}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 77, 198, 22, 222, 149, 162, 182}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 216, 248, 82, 133, 175, 40, 50}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 3, 129, 11, 250, 79, 134, 88, 213, 217}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 81, 111, 140, 249}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 26, 245, 64}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 151, 138, 62}, 106},
	{{201, 143, 240, 240, 209, 224, 58, 0, 239, 137, 148, 197, 71, 50, 97, 167}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 198, 176, 42}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 83, 165, 90, 101, 11}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 192, 239, 228, 204, 40}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 229, 34, 23, 40, 60, 234, 159, 177, 107}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 119, 191, 70}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 223, 102}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 88, 10, 251}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 64, 113, 237}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 131, 184, 2, 54, 18, 234, 173, 193, 179}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 207, 118, 27, 101}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 23, 202, 178, 218, 186, 138, 77}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 83, 164, 217, 67, 228, 109}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 101, 198}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 221, 110, 80, 215}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 86, 18, 5, 104}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 112, 223}, 106},
	{{201, 143, 240, 240, 209, 224, 15, 36, 202, 255, 6, 145, 220, 151, 1, 58}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 224, 81, 102}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 200, 250}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 8, 244, 33, 122, 176, 11, 112, 218, 172}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 9, 8, 165, 174, 99, 130, 5, 132, 151}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 184, 88, 241, 155, 236, 1, 182, 154, 231}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 255, 116, 251, 170, 98, 228}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 136, 196, 59, 75, 95}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 97, 224, 106, 7, 254, 108, 112}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 22, 212, 194, 47, 198, 119}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 113, 66, 182}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 124, 89, 250, 187, 36, 70, 86, 18, 29}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 112, 151}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 169, 73, 152}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 184, 157, 64, 29, 151, 32, 111, 62}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 126, 34, 21, 83}, 106},
	{{201, 143, 240, 240, 209, 224, 103, 227, 128, 136, 20, 184, 151, 78, 149, 193}, 106},
	{{201, 143, 240, 240, 209, 224, 0, 0, 0, 0, 0, 0, 135, 10, 145, 172}, 106},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 18}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 19, 100}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 191, 129}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 82, 114, 120}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 8, 209, 11, 234, 143, 109, 63}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 133}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 222, 240, 144, 224, 56}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 72, 156, 99, 151}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 93, 109}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 113, 77, 186, 38, 32, 72, 166}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 173, 12, 111, 189, 129, 214, 26}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 168, 17, 117, 226}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 6, 60, 23}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 139, 53}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 38}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 84}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 13, 107}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 186}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 63, 208, 89, 149, 170, 146}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 229, 131, 253, 11}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 137, 180, 12, 178, 52}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 133, 101, 178, 70, 24}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 34, 102}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 216, 143, 53}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 76, 230, 123, 214, 232, 100, 15}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 79, 10, 197, 128, 243, 172}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 194, 95, 15, 83, 161, 200, 117}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 175, 208, 85}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 8, 136, 178, 135, 23, 13}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 73, 175}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 140, 232, 49, 181, 14}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 95, 220, 60, 171, 190, 236}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 231, 92, 207, 152, 245, 147}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 174, 100, 248}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 127, 119, 48, 18}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 92, 86, 102}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 238}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 58, 80, 7, 117, 241, 177}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 177, 9, 228}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 204, 51, 78, 196, 5, 173, 117}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 219, 19, 37}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 193, 50, 125}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 14, 208, 224, 52, 100}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 254, 218, 18, 218, 175}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 17, 115, 60, 210, 184, 39, 163}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 108}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 155}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 133, 132, 250, 235}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 118, 242, 67, 159}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 228, 248, 213, 142, 147, 233, 153}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 67, 222, 8, 119, 133, 42}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 135, 44, 118, 228}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 71, 3, 184, 86}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 20, 109, 73, 210}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 22, 46, 131, 116}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 131, 25, 152, 33, 156, 224, 135}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 89, 30, 98, 179, 140, 200}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 129, 63, 162, 218, 82, 254}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 104, 54}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 98}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 94, 226, 72, 214, 71}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 54, 77}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 98}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 186, 7, 154, 138, 166, 79, 219}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 179}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 153, 219, 52, 146, 4, 172}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 28, 128, 190}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 68, 12, 9, 21, 198}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 25, 129}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 144, 179, 132, 47, 16, 55}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 74, 146, 115, 6, 129, 36}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 29}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 244, 171, 162, 207, 168, 248}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 46, 100, 50, 25, 7}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 207, 208, 19, 166, 109, 37}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 7, 85, 195, 212, 198, 121}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 10, 250, 99, 102, 160, 200, 113}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 176, 43}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 40, 235, 28, 144, 85, 162, 69}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 46, 246, 163, 84, 98, 22}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 115, 59, 195, 120, 48, 209, 96, 55}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 152, 202, 139}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 108, 207, 27, 192, 82, 224}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 89, 87, 90, 44}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 131, 134, 141}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 92, 169, 205, 113, 62}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 136, 205, 158, 254, 39, 46}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 0, 0, 0, 84}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 74, 127, 56, 91}, 170},
	{{158, 19, 164, 196, 87, 162, 33, 120, 0, 0, 0, 0, 21, 119, 7, 160}, 170},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 150, 46, 238, 164}, 86},
	{{5, 114, 0, 0, 0, 0, 91, 210, 74, 139, 141, 144, 93, 27, 178, 25}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 86},
	{{5, 114, 0, 15, 143, 130, 47, 147, 19, 175, 132, 149, 188, 237, 100, 135}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 212, 43, 75, 50, 53, 225, 189}, 86},
	{{5, 114, 0, 0, 208, 105, 242, 201, 168, 41, 92, 79, 192, 86, 255, 110}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 1, 186}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 18, 130, 243}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 162, 70, 123, 23, 193, 14}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 184, 49, 141, 12, 77, 194, 140, 108, 235}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 170, 46, 194}, 86},
	{{5, 114, 0, 51, 237, 36, 43, 96, 213, 102, 201, 138, 92, 30, 248, 175}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 112}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 218, 25}, 86},
	{{5, 114, 0, 248, 182, 60, 232, 69, 250, 123, 35, 113, 129, 138, 92, 156}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 59, 21, 192}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 124, 170, 205, 163, 146, 28, 232}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 251, 235, 0, 12, 189, 133, 227, 167}, 86},
	{{5, 114, 0, 0, 101, 121, 108, 191, 29, 86, 167, 40, 13, 162, 142, 101}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 149, 164, 118}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 202, 242, 92, 66, 168, 60, 133, 121, 170}, 86},
	{{5, 114, 0, 0, 0, 0, 236, 173, 172, 160, 186, 22, 195, 99, 104, 182}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 52, 124, 168, 109, 137, 40, 160, 19, 254}, 86},
	{{5, 114, 0, 0, 0, 0, 235, 174, 91, 215, 210, 198, 54, 236, 229, 68}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 86},
	{{5, 114, 0, 0, 199, 28, 253, 223, 25, 167, 202, 82, 32, 8, 214, 154}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 14, 173, 128, 230, 219, 70}, 86},
	{{5, 114, 0, 0, 122, 41, 92, 114, 186, 150, 239, 222, 14, 143, 163, 212}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 238, 246, 123, 189, 170, 163}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 37, 186, 47, 23}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 129, 7, 57, 103, 118, 3, 247}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 149, 142, 234, 226, 96, 40, 45, 13}, 86},
	{{5, 114, 0, 176, 185, 238, 95, 209, 88, 18, 172, 220, 236, 160, 240, 126}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 86},
	{{5, 114, 0, 0, 0, 0, 130, 40, 78, 243, 158, 120, 94, 106, 29, 217}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 191}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 2, 147}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 13, 72, 60, 241, 198, 148, 17}, 86},
	{{5, 114, 0, 0, 0, 0, 130, 222, 22, 142, 108, 25, 148, 30, 37, 119}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 149, 67}, 86},
	{{5, 114, 0, 0, 0, 0, 12, 160, 236, 44, 242, 19, 237, 188, 175, 91}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 138}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 79}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 207, 153, 171, 184, 249, 24, 31, 250}, 86},
	{{5, 114, 0, 0, 0, 0, 192, 163, 38, 79, 251, 121, 156, 111, 13, 89}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 184, 203}, 86},
	{{5, 114, 0, 0, 0, 0, 237, 193, 0, 35, 197, 251, 51, 180, 221, 196}, 86},
	{{5, 114, 0, 154, 41, 11, 111, 178, 233, 46, 230, 74, 129, 168, 43, 22}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 196, 81, 51, 149, 24, 16, 154, 101, 103}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 89, 138, 218, 4, 37, 139, 93}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 238, 128, 227}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 203}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 173, 38, 87, 137, 227, 160, 216}, 86},
	{{5, 114, 0, 201, 110, 175, 244, 73, 126, 79, 32, 54, 179, 159, 164, 54}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 167, 92, 66, 89}, 86},
	{{5, 114, 0, 0, 0, 0, 252, 39, 38, 51, 226, 190, 73, 18, 90, 155}, 86},
	{{5, 114, 0, 0, 0, 0, 244, 65, 143, 18, 164, 243, 100, 159, 95, 51}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 159, 18, 0, 24, 201, 40, 130, 148, 188}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 135, 235, 171, 125, 113, 84, 15}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 86},
	{{5, 114, 0, 0, 0, 0, 254, 113, 8, 79, 174, 202, 154, 146, 60, 211}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 105, 126, 133, 232, 142, 130, 96, 26, 5}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 199, 90, 22, 6}, 86},
	{{5, 114, 0, 65, 226, 6, 126, 75, 221, 69, 97, 184, 130, 53, 89, 243}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 35}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 219, 144, 87}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 86},
	{{5, 114, 0, 0, 0, 110, 96, 81, 115, 214, 161, 170, 80, 217, 141, 164}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 77, 80, 22, 211, 91, 68}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 251, 145, 232, 82}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 11, 175, 49, 219, 151, 187, 148, 40}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 65}, 86},
	{{5, 114, 0, 0, 137, 21, 242, 194, 79, 88, 2, 216, 116, 221, 24, 25}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 179, 78}, 86},
	{{5, 114, 0, 0, 0, 74, 70, 16, 54, 227, 239, 205, 3, 243, 195, 104}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 86},
	{{5, 114, 0, 0, 0, 0, 161, 229, 99, 44, 49, 100, 70, 20, 128, 233}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 168, 66, 116, 43, 75, 146}, 86},
	{{5, 114, 0, 0, 0, 24, 62, 230, 126, 75, 244, 41, 247, 126, 69, 102}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 103, 145, 47, 233, 81, 158, 28, 162, 106}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 252, 245, 123, 84, 85, 63, 172, 102}, 86},
	{{5, 114, 0, 0, 0, 252, 229, 208, 127, 195, 86, 75, 237, 17, 81, 143}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 234, 106, 158, 119, 241, 235}, 86},
	{{5, 114, 0, 223, 180, 0, 79, 122, 89, 107, 133, 241, 244, 155, 39, 151}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 25, 175, 179}, 86},
	{{5, 114, 0, 0, 0, 76, 63, 239, 7, 222, 125, 241, 0, 54, 24, 210}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 153, 169, 237, 22, 193, 164, 142, 3}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 230, 85}, 86},
	{{5, 114, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 229, 161, 7}, 86},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 200, 50, 202, 109}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 145, 232, 99}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 107, 32, 146, 171, 100}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 146, 224}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 21, 103, 76, 11, 34}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 158, 161, 241, 188}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 43, 80, 134}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 108, 142}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 34, 73, 87, 73}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 9, 154}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 109, 55}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 59, 237, 85, 71, 15}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 85, 246, 120}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 119, 174, 146, 199, 190}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 139, 92, 64, 84}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 107, 155, 49, 163, 121}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 14, 52, 12, 6}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 110, 159}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 106, 34}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 219, 225, 55, 77}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 210}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 158}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 125, 102, 185, 123}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 3, 3}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 104, 84, 196, 251, 254}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 83, 91}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 189}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 149, 242, 74, 149, 203}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 222, 242}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 82, 152, 166, 220}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 212, 175}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 229}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 64, 22, 185, 226, 187}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 167, 210, 149}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 120}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 159, 81}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 175, 70, 56}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 229}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 106, 46, 255, 148}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 211, 46, 82}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 91}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 20, 153}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 183}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 110}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 165, 151, 5}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 169, 46, 131}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 144, 253}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 153, 195, 1}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 41, 22}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 207}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 83, 48, 46}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 88, 116, 211, 222}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 158, 246, 30}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 232, 15, 138}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 214, 235, 4}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 186, 179}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 24, 207, 98}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 88, 3}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 123, 251, 10, 48, 242}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 228, 128, 224}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 176, 63, 176, 62, 145}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 84, 11, 148, 159, 231}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 52, 196}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 111}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 109, 6}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 185, 202, 224}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 84, 31, 251, 15, 199, 74}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 247, 161}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 169, 66, 129, 104, 148}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 43, 81, 165, 247}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 206, 191, 102, 98}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 73, 234}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 0}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 147, 114}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 81, 15, 76, 247}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 96, 245, 238}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 32}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 248, 244}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 6, 135}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 0, 0, 0, 222}, 155},
	{{34, 170, 246, 62, 198, 85, 193, 227, 252, 68, 0, 0, 164, 220, 108, 89}, 155},
	{{21, 52, 9, 86, 224, 221, 10, 137, 203, 67, 29, 49, 200, 107, 252, 103}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 59, 79, 244, 121, 76, 78}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 124, 38, 117, 27, 107}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 150, 38, 239, 219, 39, 255}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 66}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 141}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 210, 116, 109, 197, 114, 160}, 65},
	{{21, 52, 9, 86, 224, 192, 137, 98, 86, 11, 251, 146, 167, 106, 144, 99}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 66, 42, 28, 241, 190, 52, 81, 37}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 80, 27, 8}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 231, 45, 79}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 7}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 220, 40, 26, 142}, 65},
	{{21, 52, 9, 86, 224, 151, 135, 108, 57, 36, 156, 28, 94, 170, 18, 116}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 212, 8, 65, 108, 230, 14}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 95, 15, 115, 182, 150}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 141, 202, 224, 91, 134}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 98, 160, 139, 148, 26}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 47, 15, 135, 110}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 198, 127, 72, 6, 165, 70, 20}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 65},
	{{21, 52, 9, 86, 224, 107, 161, 143, 51, 10, 163, 42, 152, 51, 215, 105}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 145, 199, 233, 14, 239, 168, 154}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 249, 205, 245, 181, 239, 115, 116, 181, 67}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 57, 192, 152, 129, 19, 149, 154, 124, 198}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 251, 66, 218, 254, 42, 17}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 156, 219, 216, 151, 4, 109, 136, 185, 238}, 65},
	{{21, 52, 9, 86, 224, 0, 11, 228, 247, 3, 58, 140, 6, 101, 143, 47}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 186}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 215, 113, 156, 134, 231, 132}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 32, 106, 3}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 140, 123, 17, 188, 29, 192, 255, 17, 48}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 238, 187, 98, 53, 193}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 241, 107, 166, 21, 119, 3}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 233, 197, 184, 124, 67, 19, 136, 28}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 192, 41, 113, 45, 195}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 106}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 93, 228, 130, 118, 237}, 65},
	{{21, 52, 9, 86, 224, 0, 223, 3, 133, 184, 136, 223, 122, 173, 148, 128}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 55, 221, 202, 119, 114, 157, 140, 76, 22}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 109, 51, 233, 248, 72, 206, 203}, 65},
	{{21, 52, 9, 86, 224, 0, 223, 133, 85, 41, 228, 104, 111, 39, 197, 136}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 172, 251, 2}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 163, 151, 124}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 62, 148, 218, 211}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 174, 64, 238, 91, 59, 97}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 91, 209, 125}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 74, 213, 150, 100}, 65},
	{{21, 52, 9, 86, 224, 0, 114, 153, 23, 230, 243, 60, 179, 113, 243, 142}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 217, 14, 245, 120, 179, 222}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 175, 164, 222, 245, 81, 176}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 104, 124, 75, 18, 82, 155, 185}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 1, 9, 93}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 5, 78, 72, 8}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 238, 84, 253, 60, 76}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 184, 73, 144, 191, 129, 101}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 140, 2, 193, 205, 61}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 67, 54, 22, 121}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 29, 183, 135, 131, 211, 194, 198, 28, 152}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 180, 193, 138, 189, 152}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 213, 220, 255}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 188, 169, 0, 109, 181, 54, 32, 65, 231}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 91, 52, 212, 26, 164, 11}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 229, 58, 74, 116, 9, 202, 2, 41}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 251, 237, 74, 233, 116, 112}, 65},
	{{21, 52, 9, 86, 224, 4, 251, 103, 32, 6, 12, 60, 184, 118, 3, 197}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 143, 174, 247}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 119, 7, 209, 160, 233, 159, 157, 4}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{21, 52, 9, 86, 224, 217, 32, 42, 6, 249, 92, 183, 14, 37, 101, 148}, 65},
	{{21, 52, 9, 86, 224, 0, 150, 188, 18, 49, 216, 0, 21, 254, 161, 184}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 15, 239, 111, 220, 213, 63, 169}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 65},
	{{21, 52, 9, 86, 224, 0, 67, 130, 242, 236, 0, 64, 63, 189, 180, 156}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 70, 216, 181, 117, 169, 189, 8, 40}, 65},
	{{21, 52, 9, 86, 224, 38, 149, 190, 38, 226, 253, 111, 229, 56, 81, 80}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 180, 174, 30, 23, 80, 88, 173, 155, 67}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 34, 168, 161, 60}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 131, 119, 72, 97, 109, 124}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 64, 239, 114, 164, 192, 114, 255}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 14, 2, 159, 209, 219, 4, 104}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 172, 64, 23, 229, 206, 134, 249, 26}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 0, 189, 92, 133}, 65},
	{{21, 52, 9, 86, 224, 0, 211, 92, 68, 14, 78, 223, 121, 122, 219, 197}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 0, 0, 0, 113, 15, 168, 202}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 186, 221, 84, 67, 172, 118, 13, 127, 1}, 65},
	{{21, 52, 9, 86, 224, 0, 0, 0, 0, 129, 167, 239, 82, 141, 177, 94}, 65},
	{{203, 81, 49, 171, 224, 0, 0, 16, 135, 71, 130, 161, 145, 197, 16, 151}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 76, 226, 251, 146, 98}, 39},
	{{203, 81, 49, 171, 224, 203, 219, 116, 30, 214, 186, 66, 128, 229, 33, 176}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 160, 128, 131}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 35, 34, 92}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 164, 235, 0, 174}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 196, 99, 178, 149, 104}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 156, 255, 60, 189, 86, 64, 200, 190, 213}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 226, 185, 175, 252, 96, 122, 152}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 254, 64, 26, 9, 41, 172, 17, 188}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 176, 167, 105, 73}, 39},
	{{203, 81, 49, 171, 224, 0, 51, 248, 140, 139, 197, 27, 96, 234, 166, 132}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 144, 151, 97}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 39},
	{{203, 81, 49, 171, 224, 118, 185, 227, 3, 85, 48, 157, 4, 136, 102, 64}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 22, 16, 42, 157}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 53, 136, 2, 193, 217, 106}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 207}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 113, 27, 52, 246, 45}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 103, 119, 13, 41, 239, 169, 79}, 39},
	{{203, 81, 49, 171, 224, 0, 198, 0, 135, 37, 234, 116, 148, 250, 242, 218}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 125, 183, 24, 43, 24, 62, 201}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 45}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 39},
	{{203, 81, 49, 171, 224, 81, 224, 120, 136, 34, 11, 194, 27, 108, 129, 109}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 10, 97, 136, 114, 39, 99, 215}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 241, 35, 163, 211, 204, 214}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 69, 30, 109, 112, 50}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 67, 57, 221, 139, 18, 41, 21, 103}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 14, 88, 229, 58}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 150, 149, 239}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 69, 167, 18}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 30, 159, 40, 109, 122, 25}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 82, 131, 134, 219, 66}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 211, 167, 51, 250, 59, 32, 229}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 103}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 145, 100, 93}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 169}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 140, 204, 83, 211, 213, 168}, 39},
	{{203, 81, 49, 171, 224, 193, 76, 143, 127, 45, 37, 35, 165, 173, 43, 87}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 93, 85, 128, 42, 69, 45}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 174, 120, 168}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 51, 151, 93, 9, 8, 243, 79}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 138}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 99, 50, 157}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 202}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 12, 250, 132, 229, 51, 67}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 119, 222, 0, 29, 132}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 138, 249, 120, 53, 176, 73, 148, 109, 82}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 19, 219, 12, 94, 48}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 57, 148, 238, 227, 16, 173}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 44, 165, 190, 244, 89}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 137, 141, 226, 114, 255, 198, 26}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 95, 29, 18, 97, 151, 187}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 11, 230, 182, 175, 130}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 178}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 81, 163, 151}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 69}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 58, 18, 41, 193, 49, 129, 72, 34, 27}, 39},
	{{203, 81, 49, 171, 224, 33, 36, 62, 193, 26, 92, 153, 222, 212, 61, 148}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 39},
	{{203, 81, 49, 171, 224, 122, 28, 161, 3, 139, 87, 78, 31, 86, 96, 159}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 120, 193, 74, 24, 151}, 39},
	{{203, 81, 49, 171, 224, 0, 93, 41, 101, 238, 24, 116, 164, 110, 98, 19}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 21, 186, 188, 206, 20}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 196}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 222, 86, 44, 105, 220, 240}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 104}, 39},
	{{203, 81, 49, 171, 224, 39, 235, 140, 157, 202, 10, 36, 101, 127, 121, 179}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 149, 48, 203, 255, 232}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 191, 182, 110}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 71, 12, 170}, 39},
	{{203, 81, 49, 171, 224, 0, 236, 175, 158, 245, 210, 3, 11, 65, 188, 156}, 39},
	{{203, 81, 49, 171, 224, 0, 51, 242, 133, 207, 145, 101, 14, 59, 13, 111}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 147}, 39},
	{{203, 81, 49, 171, 224, 66, 179, 4, 176, 85, 112, 95, 71, 153, 91, 203}, 39},
	{{203, 81, 49, 171, 224, 0, 59, 59, 206, 203, 215, 173, 213, 84, 182, 229}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 222, 162, 140, 52, 48, 205}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 3, 42, 156, 86}, 39},
	{{203, 81, 49, 171, 224, 0, 0, 0, 0, 0, 0, 0, 0, 69, 21, 212}, 39},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 168, 1, 200}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 209, 142}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 119, 244, 164}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 68, 194, 221, 142}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 178, 207, 126}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 235, 7, 138, 10}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 128, 31, 25}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 117, 243, 196}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 99, 140, 52}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 193, 147, 67}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 124, 184, 37}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 224, 89}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 164}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 164, 214, 143}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 42, 212}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 125, 230, 18}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 69}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 157, 118, 127}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 89, 239}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 108, 16, 174, 32}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 18}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 236, 60, 134}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 146}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 216, 112}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 160, 10}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 247, 102, 82}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 115}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 55, 114}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 153, 103, 0, 216}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 13}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 103}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 128, 101}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 50, 5, 60}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 30, 7, 92, 138}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 159, 68, 207}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 61}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 183, 177}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 127}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 11, 7}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 37}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 98}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 7}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 220, 65}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 145}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 227, 255, 229, 58}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 237, 67, 173}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 164}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 245, 248, 185}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 72, 253, 173, 252}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 147, 78, 170, 69}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 201}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 91, 178, 204, 237}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 204}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 18, 45, 64, 226}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 219, 27}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 235, 10}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 26}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 123}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 11, 178, 29}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 125, 8}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 135}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 163, 128}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 75, 241, 201}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 102, 204}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 149, 116, 83}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 68}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 118}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 22}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 142, 154, 227}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 4, 223, 107, 192}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 53}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 212}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 107}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 183}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 165, 234, 12, 132}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 0, 0}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 253, 141}, 162},
	{{211, 218, 87, 244, 93, 181, 118, 41, 156, 143, 254, 0, 0, 0, 70, 129}, 162},
	{{77, 64, 0, 0, 0, 0, 0, 165, 234, 71, 48, 174, 146, 240, 112, 2}, 69},
	{{77, 64, 0, 0, 0, 232, 191, 31, 22, 206, 179, 104, 86, 254, 81, 120}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 166, 4, 108, 65, 136, 186, 144, 5}, 69},
	{{77, 64, 0, 0, 0, 0, 90, 203, 103, 108, 76, 100, 76, 109, 181, 219}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 57, 22, 37}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 47, 199, 101, 157, 191, 174, 194, 108, 113}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 42}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 111, 69, 108, 0, 242, 226, 45}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 69},
	{{77, 64, 0, 0, 0, 36, 107, 213, 229, 54, 252, 240, 8, 131, 21, 45}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 71, 4, 199}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 192, 106, 252}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 96, 124, 130, 104, 249, 249}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 37, 160, 127}, 69},
	{{77, 64, 0, 0, 0, 80, 0, 249, 49, 193, 233, 104, 139, 11, 17, 198}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 234, 132, 103, 8}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 245, 9, 242, 216}, 69},
	{{77, 64, 0, 17, 204, 206, 73, 13, 225, 94, 182, 79, 100, 61, 21, 125}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 208}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 140, 124, 219, 104}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 143, 12, 158, 89, 233, 234}, 69},
	{{77, 64, 0, 0, 0, 134, 174, 168, 25, 79, 181, 206, 122, 251, 247, 176}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{77, 64, 167, 21, 150, 44, 57, 207, 154, 30, 22, 175, 182, 226, 78, 117}, 69},
	{{77, 64, 0, 0, 0, 151, 112, 98, 23, 11, 132, 123, 75, 237, 239, 69}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 131, 53, 96, 244, 57, 34, 191, 149}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 17, 136, 216, 67}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 71, 83, 105, 87, 25, 250, 199}, 69},
	{{77, 64, 0, 225, 185, 124, 222, 127, 231, 17, 67, 145, 165, 31, 158, 104}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 130, 241, 13, 22, 45, 25, 205, 160, 56}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 50, 174, 208, 219, 24, 157, 49, 45, 145}, 69},
	{{77, 64, 0, 0, 0, 0, 128, 187, 132, 156, 4, 211, 49, 77, 64, 71}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{77, 64, 48, 109, 53, 241, 191, 175, 179, 41, 221, 173, 120, 225, 70, 87}, 69},
	{{77, 64, 0, 0, 164, 13, 161, 60, 227, 152, 93, 20, 89, 49, 209, 33}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 43, 118, 139, 81, 29, 27, 56, 11}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 48, 68, 176, 233, 248, 161, 102}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 212, 8, 228}, 69},
	{{77, 64, 0, 0, 131, 110, 171, 117, 216, 251, 12, 208, 58, 80, 199, 163}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 53, 203, 150}, 69},
	{{77, 64, 0, 0, 0, 43, 51, 8, 187, 220, 129, 116, 3, 159, 66, 42}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 201, 103, 240, 228, 26, 183, 96, 158}, 69},
	{{77, 64, 0, 0, 0, 0, 84, 217, 57, 110, 150, 2, 167, 171, 60, 71}, 69},
	{{77, 64, 147, 217, 187, 7, 18, 211, 32, 123, 51, 71, 139, 85, 184, 186}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 141, 41, 148, 245, 190, 48}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 104, 223}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 98, 26, 47, 15, 157, 160, 73, 112, 167}, 69},
	{{77, 64, 0, 141, 117, 47, 115, 44, 92, 128, 246, 61, 253, 71, 174, 179}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 122, 156, 120, 227, 210, 216, 18}, 69},
	{{77, 64, 0, 0, 0, 0, 254, 205, 119, 150, 5, 27, 114, 251, 124, 108}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 228, 74, 189, 28, 236, 184, 189, 137}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 251, 97, 202, 8}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{77, 64, 0, 188, 145, 70, 192, 141, 199, 107, 141, 69, 235, 234, 72, 197}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 199, 38, 34, 197}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 82, 39}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 94}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 221, 134, 231}, 69},
	{{77, 64, 0, 253, 128, 227, 30, 209, 134, 74, 215, 110, 106, 165, 178, 13}, 69},
	{{77, 64, 0, 0, 128, 52, 185, 200, 219, 211, 120, 164, 177, 225, 62, 164}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 246, 98, 123, 115}, 69},
	{{77, 64, 228, 240, 14, 49, 201, 141, 185, 79, 45, 113, 230, 224, 137, 233}, 69},
	{{77, 64, 0, 0, 0, 0, 134, 199, 92, 35, 148, 132, 16, 112, 114, 126}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 215, 78, 79, 153, 51, 92}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 122, 199}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 156, 4, 112}, 69},
	{{77, 64, 129, 7, 132, 191, 61, 212, 150, 209, 17, 206, 241, 214, 101, 142}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 254, 248}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 227, 52, 139, 22, 25, 61, 199, 250, 166}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 141, 183, 72, 175, 2, 194, 86, 144}, 69},
	{{77, 64, 0, 20, 217, 125, 53, 61, 7, 77, 72, 75, 35, 98, 248, 129}, 69},
	{{77, 64, 230, 123, 155, 33, 164, 118, 129, 109, 131, 202, 96, 97, 18, 125}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 2, 222}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 166, 123, 224, 227, 201, 170, 163}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 248, 246, 94}, 69},
	{{77, 64, 225, 228, 243, 104, 236, 3, 227, 203, 214, 196, 174, 109, 171, 207}, 69},
	{{77, 64, 0, 0, 0, 0, 98, 202, 184, 6, 67, 22, 213, 153, 41, 135}, 69},
	{{77, 64, 0, 29, 134, 90, 105, 135, 254, 135, 249, 30, 161, 97, 48, 199}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 63, 227}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 231}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 110, 29, 99, 62, 41, 113, 227, 150}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 144, 45, 4, 215, 222, 11, 227, 83}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 85, 118, 9, 208, 129, 184, 131, 87, 105}, 69},
	{{77, 64, 0, 0, 201, 143, 1, 202, 83, 201, 157, 151, 175, 167, 249, 167}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 219, 54, 13, 197}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 145, 165, 192, 167, 29, 226}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 160, 209, 232}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 0, 105, 224, 64, 255, 179, 163, 51}, 69},
	{{77, 64, 0, 0, 0, 0, 0, 0, 21, 173, 146, 181, 6, 137, 136, 219}, 69},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 129, 132, 122}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 58}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 116, 32, 55}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 173, 25, 60}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 70, 57, 44, 0, 215}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 213, 65, 217}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 153, 246, 54}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 72}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 100}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 152, 45, 129, 87, 1, 92, 26}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 88}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 64, 120, 66}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 147}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 112, 53, 157, 142}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 225, 226, 129}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 152, 162, 70, 116, 173, 247}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 49, 196}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 171}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 87, 82}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 205}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 94, 202, 12, 84, 221, 216}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 161, 225, 227}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 81, 242}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 223, 49, 33, 254, 154, 116, 183}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 32}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 79, 153, 245, 226, 63, 75, 230}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 187}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 230, 73, 197, 88, 233}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 249, 107, 81, 235, 214}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 110, 193, 243, 108, 135, 44, 189}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 120, 199, 220}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 140, 11, 28, 113, 26, 139, 242}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 122, 62, 160, 44, 149}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 218, 65, 171, 233, 170, 139, 119}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 162, 248, 85}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 19}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 90, 195, 10, 135, 16, 90, 16}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 208, 60, 208, 109}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 156, 237}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 37}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 219, 193, 122}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 227, 120, 237, 141, 242, 153, 94}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 117, 217, 31, 184, 28, 126, 45}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 137, 67, 20, 155}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 114, 166}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 53, 186, 115, 95, 243, 53, 185}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 157, 242}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 7, 157, 29, 104, 135}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 61, 141, 164}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 236, 6, 95, 108}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 230, 21, 11, 204, 19, 10, 105}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 155, 249}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 134}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 42}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 254, 135}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 11, 26, 17}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 43, 221, 9}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 202, 206, 170, 110, 12, 15}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 115, 70}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 141, 67, 145, 193, 88}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 227, 106, 30}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 12, 179, 221, 194, 20, 180, 218}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 69, 47, 245}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 31, 203}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 75, 253, 30, 22}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 44, 182, 141, 82}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 190, 69, 194, 161, 82, 71, 21}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 83, 83}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 76}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 137, 105, 252, 182, 94, 161}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 165, 128, 251, 153, 119, 113}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 152, 98, 174}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 138, 252, 222, 48, 250, 28, 189}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 181, 88, 60, 204, 84, 163, 252}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 231, 123, 145, 203}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 58, 11, 97, 142}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 28, 154, 2, 168}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 74, 139, 116, 255, 197, 243}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 19, 142, 42}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 33, 45}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 162, 86, 31, 108, 19, 210}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 123, 153, 179, 57}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 177, 101, 77, 253, 131}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 145, 58, 17, 110, 141}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 0, 0, 0, 0, 0, 0, 163}, 163},
	{{158, 219, 219, 39, 4, 219, 100, 63, 0, 138, 80, 52, 159, 111, 218, 219}, 163},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 222, 117, 141}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 75, 237}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 13, 228}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 26, 28, 207}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 82, 181, 109}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 213, 172}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 197}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 75}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 242}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 157}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 104, 39, 118, 49}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 37, 149, 202, 226}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 164}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 6, 203, 6, 147}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 96, 189}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 226, 194, 209}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 50}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 1, 84}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 41, 23, 127}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 90, 114}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 7, 164}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 107, 19, 175}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 192, 49, 116}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 141}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 212}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 87, 34, 108}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 206, 188, 103, 60}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 220, 146, 73}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 205, 77, 244, 11}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 16, 89}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 124, 211, 85, 251}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 223, 62}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 48, 238, 160}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 181, 155}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 200}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 252, 80, 253}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 99, 97, 175}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 253, 40, 24, 48}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 101, 80, 18, 95}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 201, 47}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 204, 138, 152}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 32}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 192, 119}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 43, 96, 110}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 31, 216}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 248}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 72, 66, 150}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 140}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 155, 10, 132, 212}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 165, 108, 197}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 16, 59, 2}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 154, 41, 151, 106}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 116, 128, 73, 95}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 79, 29, 186, 128}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 72, 253}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 175, 177, 103}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 120}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 224, 124, 209, 185}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 28, 121, 48, 25}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 80, 92}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 221, 234, 124}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 145}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 108, 51, 162}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 123, 103}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 167}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 2}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 222}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 54, 124, 113, 164}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 141, 192, 92}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 228, 112, 183}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 0}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 0, 0, 63}, 116},
	{{61, 50, 232, 1, 185, 252, 243, 54, 189, 240, 170, 192, 0, 178, 221, 240}, 116},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 90, 89, 18, 131, 8, 219, 115}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 82}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 154, 11, 2, 179, 70}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 123, 246, 85, 115, 13, 18, 153, 136, 75}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 62, 67, 40, 94, 23, 225, 182, 127, 33}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 105, 103, 180, 97}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 208, 252, 220, 233, 20}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 235, 82, 146}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 229, 51, 134, 213, 2, 206, 111, 73}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 25, 43, 97, 22, 10, 239}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 250, 142, 158, 5, 6}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 160, 15, 42, 163}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 126, 225, 128, 47, 67, 46, 36}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 125, 46, 91, 107}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 212, 216, 127}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 215, 10, 17, 146, 252}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 230, 231, 78, 52, 64}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 215, 210, 25, 48, 184, 227}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 147, 147, 20, 136, 11, 193, 119, 188, 163}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 93, 173}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 181, 113}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 81, 205, 136, 92, 101, 175}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 22, 123, 95, 249, 16, 191}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 131, 97, 170}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 47, 8}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 253, 186, 217, 183}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 92, 51, 39, 100, 80, 39, 199, 47, 35}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 34, 164, 125, 84, 121, 80}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 217}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 179, 182, 210, 73, 155, 255, 101}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 226, 50, 91, 77}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 125, 14, 143, 94, 113, 119, 207}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 202, 55}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 171, 153, 136, 69, 196}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 167, 39, 190}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 42, 41, 208, 228, 228, 84, 90}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 43, 35}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 170, 223, 121, 200, 130, 69, 100, 244, 190}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 210, 155, 77, 4}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 186, 161, 192, 226, 6, 103}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 163, 3, 209, 205, 82}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 221, 178, 7}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 139, 17, 253, 135}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 56, 26, 153}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 139, 217, 161, 189}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 78}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 165, 2, 157, 16, 53, 7, 1, 179}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 105, 35, 8, 173, 247, 241, 224, 196}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 195, 133}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 252, 155, 2, 128, 150}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 94, 3, 67, 208, 33, 79, 81, 154}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 114, 33, 26, 238}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 70, 77, 134, 66, 112}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 187, 204}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 212, 127, 85}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 219, 142}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 38, 214, 145, 168, 230, 23}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 249, 168, 141, 10, 41, 129, 212}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 126, 56, 161, 190, 82, 129, 231, 252}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 2, 86, 116}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 82, 41, 76, 245, 207, 160, 56, 157}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 108, 157, 207}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 117, 132, 193, 245, 109, 119, 55}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 209, 118, 138, 210, 94, 11}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 208, 64, 87, 39, 82, 120, 219}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 1, 193, 228, 184, 13, 10, 255, 134}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 123, 87, 148, 171}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 145, 138, 42, 255, 20, 189, 24, 142}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 92, 91, 149, 66, 89}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 80, 221, 155, 158, 200, 230}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 90, 138, 178, 108, 94, 62}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 90, 183, 183, 20}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 123}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 46, 247, 226, 251}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 76, 191, 138}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 21, 253, 109, 255, 174, 25, 113}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 232, 203}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 165, 77, 185}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 68, 109, 14, 93, 181, 119, 50, 244}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 238, 118, 220, 211, 33, 234}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 186, 141, 115, 196}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 135, 1, 104, 6, 57, 132, 2}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 159, 43, 36, 57, 69}, 19},
	{{241, 143, 33, 19, 247, 55, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{61, 28, 61, 252, 32, 0, 0, 193, 42, 192, 42, 57, 183, 244, 90, 150}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 236, 50, 37, 97, 144, 173, 183}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 252, 116, 40}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 47}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 32}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 176, 139, 139, 76, 8}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 178, 190, 35, 141}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 70}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 124, 122, 144, 3, 20, 240, 233, 209, 85}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 191, 201, 229, 138, 111, 127, 241}, 48},
	{{61, 28, 61, 252, 32, 62, 202, 154, 145, 219, 67, 196, 241, 25, 158, 224}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 217, 158, 219, 228, 44, 187}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 252, 9, 218, 156, 70}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 131, 37, 29, 231, 189, 28, 108, 44}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 209, 137, 203, 85, 70, 42}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 29, 94, 113, 235, 158, 186, 4, 116}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 181, 70, 40, 46, 7, 162, 30, 172}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 25, 38, 229, 9, 71, 129}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 144, 130, 165, 11, 190, 50, 142, 163, 120}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 238, 43, 218, 168, 89, 182}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 248, 86, 154, 227}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 111, 238, 245, 59, 108}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 183, 84, 209, 151}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 45, 235, 180, 93, 245}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 147, 27, 202, 220, 243, 167, 215, 196}, 48},
	{{61, 28, 61, 252, 32, 0, 53, 24, 102, 217, 140, 162, 180, 249, 14, 47}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 212}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 238, 85, 146, 140, 136, 199}, 48},
	{{61, 28, 61, 252, 32, 0, 67, 89, 144, 121, 52, 168, 108, 79, 236, 9}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 166, 156, 123, 65, 133, 7, 237, 126, 74}, 48},
	{{61, 28, 61, 252, 32, 0, 151, 13, 81, 42, 90, 60, 131, 40, 15, 155}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 17, 241, 182, 95, 229, 25}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 200, 180, 58, 116, 165, 247}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 220}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 21, 160, 139, 57, 136, 137, 129, 53}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 96, 253, 16}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 172, 33, 162, 66, 219, 33}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 132, 14, 133, 14, 164, 181, 245, 162}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 66, 120, 239, 153}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 221, 232, 164, 145}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 238, 230, 236, 223, 101, 174, 222, 135, 113}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 84, 27, 105, 34, 27}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 66, 30, 137, 116, 21, 22, 205, 149, 206}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 108, 79, 165, 26, 88, 140, 25, 100, 203}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 22, 27, 140, 85, 152, 221, 215}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 39, 64, 17, 57, 41, 85}, 48},
	{{61, 28, 61, 252, 32, 91, 177, 166, 253, 15, 36, 15, 202, 134, 101, 107}, 48},
	{{61, 28, 61, 252, 32, 0, 227, 131, 82, 154, 130, 166, 236, 162, 113, 196}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 131}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 180}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 123, 74, 8, 224, 87, 188, 196}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 19, 188, 112, 217, 53, 36}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 102}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 117}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 25, 197, 238, 63, 88}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 34, 25, 127}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 83}, 48},
	{{61, 28, 61, 252, 32, 0, 126, 96, 102, 119, 34, 96, 79, 63, 205, 202}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 148, 103, 254}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 181}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 6}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 95, 59, 147}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 253, 84, 180, 176, 80, 104, 94, 0}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 158, 90, 241, 56, 5, 155, 123, 64}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 60, 126, 130, 43, 108, 240, 167}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 24}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 197, 94, 211}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 237, 20, 86, 4}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 165, 250, 218, 17, 248, 71, 120}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 154, 110, 216, 235}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 144}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 9, 95, 209}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 107, 148, 21, 123, 17, 95, 11, 139}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 83, 16, 37, 103}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 182, 20, 115, 200, 151, 214}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 226, 229, 175, 36, 101}, 48},
	{{61, 28, 61, 252, 32, 70, 192, 176, 128, 196, 116, 226, 37, 235, 14, 67}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 170, 203, 221, 215, 137, 190, 110, 49, 179}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 247, 48, 252, 235, 73, 246, 40}, 48},
	{{61, 28, 61, 252, 32, 0, 117, 227, 153, 131, 94, 36, 108, 26, 155, 83}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 47, 2, 101, 191, 84}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 255, 36, 143, 237, 213, 79, 255, 130}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 54, 134, 198, 104, 83, 211, 214}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 42, 27, 106, 48, 208, 57, 120, 244}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 91, 6, 93}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 48},
	{{61, 28, 61, 252, 32, 0, 61, 172, 29, 245, 112, 175, 75, 99, 89, 198}, 48},
	{{61, 28, 61, 252, 32, 0, 0, 0, 0, 110, 11, 108, 207, 102, 2, 220}, 48},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 41, 69, 20, 63, 206}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 91, 105, 72, 62, 179, 94, 180}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 178, 40, 137, 244}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 51, 187, 58, 8, 156, 36, 115}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 123, 234, 89, 70, 33, 71}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 169, 108}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 185, 95, 145, 110, 225}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 243, 244}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 150, 204, 18, 198, 8, 50, 251, 203, 23}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 151, 152, 62, 253, 20, 77, 85}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 71, 160, 177, 162, 189, 8}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 224, 34, 103, 255}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 207, 255, 19, 87, 105, 164, 88}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 50, 51}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 110, 85, 118, 205, 6}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 215, 98, 60, 202, 63, 144, 72}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 161, 105, 223, 61, 253}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 60, 115, 179, 65, 140, 68, 21, 230, 200}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 41, 40, 9, 133}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 200, 111, 223, 90, 49, 162}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 80, 61, 94, 139, 248}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 189, 243, 15, 184, 141, 88, 67}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 197, 6}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 53}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 169, 219, 238}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 231, 94, 110, 213, 196, 125, 138}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 190, 110, 94, 218, 17, 67, 82}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 178, 64, 101}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 159, 66, 75}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 64, 177, 81, 12}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 49, 152, 54, 18, 77}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 247, 151, 12, 14}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 91, 226, 96, 240, 101, 231, 202}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 223, 226, 190, 139, 41, 190, 10, 216}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 195, 212, 68, 246, 22, 38}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 59, 244, 151, 184, 143, 115, 129, 169, 233}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 142, 191, 14, 232}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 161, 45, 225, 25}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 151}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 134, 187, 4, 116, 195, 208}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 71, 92, 76, 191, 12, 88}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 39, 37}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 38, 145, 22}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 44, 148, 56, 122, 189, 2, 43}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 138, 191, 47, 148, 206, 214, 37, 102, 187}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 202, 201, 171, 193, 251, 184, 85, 101, 151}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 137, 131, 251, 52, 90, 179}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 42, 48, 177, 184}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 158, 17, 55, 118}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 110, 72}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 203, 1, 31, 240}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 76, 39, 219, 186, 187, 174, 95, 62}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 62, 184}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 134, 223, 90, 232, 234, 68}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 126, 22, 16, 182, 216}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 34, 96, 243, 98, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 136}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 246, 130}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 33, 134, 207, 191, 218, 91}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 153, 118, 57}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 148, 138, 148, 80, 121, 194}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 112, 164, 121, 113, 95}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 251, 177, 186, 14}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 208, 171, 113, 249, 99, 203}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 196, 237, 49, 183, 85, 132, 166, 240, 123}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 126, 175}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 213, 132, 150, 4, 83}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 71, 196, 16, 127, 10, 31}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 163, 101, 127, 179, 92, 146}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 51, 91, 163, 19, 31}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 135, 216}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 57, 186, 231, 86, 77, 109}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 87, 110, 181, 3, 138, 210}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 115, 172, 192, 27, 203, 235, 184}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 203, 198, 137, 182, 116, 157, 204}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 7, 94, 88, 143, 145, 159, 215}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 87, 174, 118, 41, 167, 4, 117, 93, 155}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 246, 53, 1, 125, 250}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 0, 97, 189}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 0, 0, 0, 0, 0, 35, 36, 243}, 230},
	{{102, 112, 194, 108, 90, 253, 128, 0, 150, 135, 159, 90, 101, 136, 29, 93}, 230},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 185}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 152}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 77}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 234, 174, 218}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 155, 219, 70}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 150, 174, 172, 242}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 214, 204, 57, 16, 161}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 15, 42, 9, 2, 92}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 30}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 86}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 205, 44, 109, 195}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 62}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 126, 227, 143, 43, 112, 101}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 33, 102, 136}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 174, 61, 103, 251}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 210, 33, 93, 88, 136}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 35, 96, 79, 11}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 202}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 77}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 155, 180, 239, 196}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 171, 47, 17}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 234, 168, 182}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 67, 207, 131, 58, 123}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 193}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 124}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 92, 176, 76, 122}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 45, 171}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 203}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 251}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 15, 212, 201, 76, 58}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 17, 53}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 3, 187, 210, 8, 153}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 172, 70, 139, 92}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 229, 44, 90}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 178}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 99}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 173, 142, 64}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 205, 103, 251, 212, 240, 149}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 58, 221, 17, 157, 218, 91}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 208, 185}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 192, 213, 197}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 116, 110, 126, 48}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 148, 155, 38, 125, 238}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 235, 75, 53}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 9, 144, 36}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 76, 110}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 134, 177, 156, 160}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 210, 201, 203, 23, 89}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 144, 189, 47, 116, 168}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 9, 162, 40, 93}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 12, 161, 189}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 58, 46, 195, 163, 70}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 183, 191}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 13, 161, 68, 172, 61}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 200, 138, 13, 79, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 192, 17}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 229, 44, 86, 224, 99}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 182}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 103, 75, 249, 63}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 160, 139, 148, 244, 89, 26}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 138, 52, 47, 74}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 214, 224, 51}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 241}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 104, 144, 59, 36, 248}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 245, 120}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 91, 99, 145, 49, 167}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 187, 186, 147}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 220, 112, 86, 121}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 196}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 153, 245, 57}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 251, 130, 215}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 170, 77}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 7, 160, 80, 185}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 141, 226, 45, 60}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 225, 216, 12, 93, 34}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 0}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 17, 146}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 253, 29, 1}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 72, 196}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 0, 1}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 99, 133}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 244, 191, 56, 6}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 49, 145, 82}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 17, 4, 173, 71, 163}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 0, 200, 16}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 0, 0, 137, 78, 176}, 155},
	{{74, 88, 58, 66, 172, 41, 144, 204, 195, 240, 0, 35, 133, 29, 2, 180}, 155},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 6, 174, 34}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 255}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 122}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 67, 34}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 175, 23}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 99}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 56, 155, 100}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 89, 38, 93}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 41, 202}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 63, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 89, 115}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 158}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 165}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 65, 223}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 188, 128}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 163, 36, 136}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 244}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 73}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 3, 200, 171}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 46, 41}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 1, 87, 65}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 183}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 87, 182, 98}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 22, 244, 32}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 245, 242, 58}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 132, 224, 191}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 209}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 71}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 149, 39}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 185, 154}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 63}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 146}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 21}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 128, 197, 77}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 213, 11}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 212, 157}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 114, 109, 21}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 122}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 84, 218}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 189}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 218, 5}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 91, 123}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 55, 143, 3}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 35}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 159}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 9, 117, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 68, 251, 213}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 154}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 82}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 212}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 212}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 59, 179}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 195, 183, 139}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 104}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 142, 168, 231}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 76}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 106}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 63}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 7, 18}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 68, 64, 250}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 215}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 217}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 65, 115, 83}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 171, 195, 110}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 147, 181, 238}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 239}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{44, 148, 187, 58, 190, 59, 190, 187, 124, 138, 222, 131, 0, 0, 0, 0}, 158},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 247}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 227}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 228}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 2}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 79}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 122}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 247}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 97}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 216}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 168}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 134}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 99}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 219}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 107}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 106}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 98}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 195}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 171}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 87}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 213}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 143}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 242}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 137}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 85}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 32}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 130}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 29}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 31}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 64}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 50}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 226}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 93}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 74}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 128}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 241}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 54}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 6}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 6}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 0}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 86}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 111}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 88}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 81}, 252},
	{{67, 7, 216, 139, 93, 224, 20, 135, 186, 86, 209, 111, 60, 80, 0, 85}, 252},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 242}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 137, 67}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 61, 219}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 120}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 235}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 156}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 97}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 70, 151}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 235}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 99}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 143}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 199}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 3}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 161, 57}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 175}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 213}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 49, 202}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 105, 30}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 43}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 173}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 111}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 245, 111}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 23}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 220}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 209}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 17}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 150}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 77}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 212}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 41}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 11}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 130}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 69, 4}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 5}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 215}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 106, 75}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 1, 25}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 246}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 10}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 254, 52}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 31}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 199}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 66}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 36}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 20, 179}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{209, 26, 12, 174, 5, 101, 164, 181, 237, 63, 192, 57, 54, 120, 0, 0}, 176},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 223}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 244, 103, 188, 138, 148, 90}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 26, 255, 79, 17, 99, 112}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 89, 244, 64}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 6, 68, 117, 11, 135}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 229, 122, 225, 180, 233, 30, 40}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 85}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 56, 15}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 83, 155, 189, 63, 255, 135}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 99, 34, 204, 133, 91}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 84, 32, 144, 220}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 220, 11, 110, 126}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 104, 73, 228}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 148, 112}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 50, 24, 231}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 223}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 20, 185, 164, 5, 129, 82}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 104}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 122, 81, 54, 227}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 56}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 162, 4, 36, 103, 147, 83}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 211}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 242, 204, 78, 87, 160, 252, 174}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 181, 57}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 211, 43, 85, 10}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 64, 25, 222, 56, 2, 162}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 9, 105, 84, 31, 80}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 1, 169, 176, 22, 232, 155, 182}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 68}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 165}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 103, 187, 66, 32, 60, 194, 224}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 249}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 210, 30, 107, 229, 30, 108}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 253, 188, 139, 217}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 248}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 203, 159, 40}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 93}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 218, 110}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 210}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 36, 112, 202, 216, 32, 82, 59}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 218, 241, 142, 166, 164}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 213, 176, 20, 119, 232}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 237, 168, 58, 142}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 87, 185, 123}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 220, 98, 236, 28, 145, 223}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 64, 224, 9, 101, 36, 25, 6}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 253, 146, 90, 9, 153, 17, 247}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 104}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 4, 38, 18, 151}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 179}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 94, 142, 154, 82, 23}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 236, 227, 195, 121, 160, 5}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 3, 31, 201, 202}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 82, 66, 32, 184, 21, 83, 201}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 248, 145}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 121, 249, 184, 84, 187, 212}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 175, 246, 239, 151, 120, 184, 164}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 222, 65, 87}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 222, 180, 49, 7}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 117, 157}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 83, 200, 192}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 60, 187, 150, 251, 227, 233, 73}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 246}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 15}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 45}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 99, 96, 249, 55, 231}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 210, 73}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 71, 164, 50}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 161, 39, 205, 200, 255}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 190, 70, 79, 193}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 254}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 120, 63, 124, 218, 97}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 126, 97}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 234}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 164, 51, 185, 58, 140}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 161}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 101, 118}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 96, 15, 69, 183, 9, 51}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 0, 0, 72}, 211},
	{{4, 66, 232, 52, 239, 56, 48, 58, 192, 0, 0, 0, 0, 79, 28, 205}, 211},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 168, 212, 63, 217, 114}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 184, 11, 45, 175, 102, 162, 129}, 15},
	{{158, 165, 2, 144, 0, 0, 164, 190, 2, 69, 8, 229, 42, 246, 94, 193}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 135, 226, 50, 109, 49}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 105, 112, 0, 57, 22, 74, 106}, 15},
	{{158, 165, 2, 144, 0, 99, 52, 105, 55, 99, 196, 103, 118, 251, 125, 10}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 112, 81, 62, 136, 229, 117}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 51}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 196, 176, 6, 157, 228}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 242, 187, 19, 183, 48}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 140, 165, 250, 100, 209, 58, 31}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 139, 44, 229, 214, 149}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 214, 196, 118, 127, 243, 146}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 122}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 33, 3, 250, 127, 202, 80, 136}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 97, 206, 143, 179, 122, 145, 209}, 15},
	{{158, 165, 2, 144, 0, 114, 203, 135, 37, 219, 86, 157, 53, 198, 142, 145}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 60, 122, 162, 173, 238, 168, 69, 54, 134}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 62}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 208, 155, 72, 156}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 57}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 65}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 206, 45, 131, 27, 109}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 23, 203, 230, 21, 178, 110, 233}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 156, 88, 59, 172, 4}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 215}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 139, 167}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 236, 172, 59, 220, 74}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 103, 189, 61, 222, 216, 53}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 54, 48, 108, 144, 28, 109, 36, 22}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 15},
	{{158, 165, 2, 144, 0, 0, 34, 237, 164, 160, 9, 49, 3, 181, 134, 70}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 211, 204, 65, 142, 59, 99}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 44, 246, 168, 202, 142, 23, 118}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 43, 38, 227, 60, 214, 98, 234, 158}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 120, 92, 177, 216, 77, 9, 10, 181, 118}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 129, 78, 46, 65, 249, 17}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 65, 190, 63, 107, 33}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 71}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{158, 165, 2, 144, 0, 195, 80, 190, 224, 69, 53, 186, 111, 65, 233, 242}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 194, 206, 222, 241, 51, 180, 199}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 58, 187, 173, 203, 158, 5, 91, 189}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 135, 121, 135, 33}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 180, 184, 89, 232, 184, 147, 125, 172}, 15},
	{{158, 165, 2, 144, 0, 0, 240, 221, 200, 172, 252, 77, 29, 174, 241, 132}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 245, 77, 217, 59, 112}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 34, 42, 208, 8, 169}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 56, 109}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 86, 134, 20, 49, 43, 96}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 231, 218, 108, 72, 117, 38, 139, 181, 127}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 131, 46}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 20, 47, 77, 124, 176, 168, 52, 89}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 126, 247, 81, 21, 153}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 251, 14, 38, 22, 77, 152}, 15},
	{{158, 165, 2, 144, 0, 0, 121, 121, 113, 73, 14, 116, 14, 143, 182, 72}, 15},
	{{158, 165, 2, 144, 0, 140, 161, 29, 203, 84, 31, 9, 130, 186, 184, 154}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 190, 200, 16, 238, 68, 158, 139, 106, 73}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 12, 203, 141, 0, 194, 11, 250}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 188, 221, 255, 214}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 133, 229, 55, 89, 86, 211, 107, 128, 180}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 159, 2, 171, 193, 86, 223, 23, 82}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 189, 154, 113, 26, 7, 3}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 85, 233, 6, 231}, 15},
	{{158, 165, 2, 144, 4, 71, 57, 2, 118, 14, 18, 88, 74, 68, 10, 222}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 65}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 167, 182, 198, 1, 55}, 15},
	{{158, 165, 2, 144, 0, 0, 232, 17, 7, 172, 232, 22, 76, 63, 30, 64}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 191, 211, 187, 149, 173, 0}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 78, 195, 36, 128, 241, 79}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 80, 149, 90, 83, 129, 236, 89, 226, 219}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 74, 170, 156, 116, 62}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 55}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 151, 166, 89, 128, 194, 47, 241, 120}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 78, 162, 16, 85, 143, 22}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 13, 197}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 109, 104}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 216, 120, 10, 251, 35}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 251, 181, 72, 247, 5, 130}, 15},
	{{158, 165, 2, 144, 161, 121, 51, 99, 220, 53, 183, 198, 229, 31, 225, 50}, 15},
	{{158, 165, 2, 144, 0, 80, 180, 182, 193, 160, 244, 3, 194, 117, 58, 27}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 141, 153}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 249, 73, 8, 159, 113, 176, 231, 166, 8}, 15},
	{{158, 165, 2, 144, 0, 0, 182, 102, 92, 6, 116, 200, 236, 14, 52, 252}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 168, 196}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 175, 55, 39, 9, 186, 65, 150, 225}, 15},
	{{158, 165, 2, 144, 0, 0, 108, 29, 229, 171, 34, 45, 196, 117, 200, 216}, 15},
	{{158, 165, 2, 144, 0, 0, 0, 0, 0, 0, 0, 0, 103, 68, 96, 74}, 15},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 86, 249, 27, 85, 25}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 34, 206, 24, 232}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 184, 245, 40, 21}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 201, 203, 41}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 82}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 63, 92, 141, 57, 194}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 185, 242, 250}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 156}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 210, 42, 75, 214, 119}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 198, 100, 16, 171, 246}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 47, 160, 116}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 163, 240, 207}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 214, 97, 130, 240, 92, 99, 241}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 245, 228, 113, 31, 189}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 46, 215, 119, 5, 8, 111, 98}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 15, 203, 117, 235, 169, 133, 180}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 242, 120, 185, 161, 125, 203, 198}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 96, 100, 163, 57, 71, 61}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 189, 6, 48, 141, 244, 216}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 74, 181}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 74, 254, 10}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 197, 26, 92, 182}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 249, 66, 128, 216, 166}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 251, 225, 84, 65, 78}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 126, 186, 118, 6}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 241, 247, 192}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 212, 188}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 115, 20, 73, 246, 195}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 129, 246, 149, 16}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 138, 179, 123, 19}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 229, 190, 71, 205, 181}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 97, 27, 115, 247}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 66, 250, 161}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 62, 80, 64, 110, 178, 122, 245}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 214, 8, 183, 147, 139}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 143, 34}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 189, 155, 46, 129, 235, 76}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 56, 35, 102, 98}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 161}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 127, 104, 138}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 140, 71, 185, 50, 152, 18}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 244, 245, 176}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 95, 201}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 54, 224, 59, 162, 128, 95}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 16, 162, 57, 156}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 184, 195, 105, 110}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 128, 255, 116, 111, 6, 2}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 199, 250, 73, 166}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 191, 91, 221, 140, 88, 186, 27}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 202, 252, 186, 141, 145, 151}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 25, 92, 79, 57, 196, 80, 76}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 248, 83, 133}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 185}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 174, 254, 154, 188}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 223, 139, 183, 105}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 244, 26, 219}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 185, 223, 61, 173, 149, 62}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 232, 208, 221, 101}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 122, 169}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 165, 42, 86, 12, 124}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 164, 67, 168}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 224, 213, 71, 177, 163, 253}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 99}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 166, 1, 159, 182, 170, 237, 233}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 182, 193, 215}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 10, 183, 64, 181, 235}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 51, 144, 61}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 104, 190}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 122, 105, 38, 217, 197}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 35, 207, 67, 255, 145}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 33, 10}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 133, 78, 7}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 120, 189}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 211, 159, 101, 17}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 212}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 81, 166, 7, 13, 13}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 193, 100, 174, 245}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 123, 184, 100}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 8, 25, 224, 150}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 0, 0, 0, 25}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 32, 59, 154, 255, 85}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 155, 172, 4, 68, 130, 242}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 0, 0, 189, 251, 184, 203}, 95},
	{{85, 204, 245, 198, 68, 44, 39, 71, 32, 0, 34, 89, 31, 164, 146, 168}, 95},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 106, 210, 86}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 98, 203, 127, 167, 0, 240, 177, 254}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 187, 168, 10, 92}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 144, 238, 207, 4, 214, 170, 155, 136}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 79, 217, 93}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 127, 156, 136}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 10, 107, 5, 131, 2, 181, 226, 173}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 193, 14, 190, 180, 132}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 212, 188, 89}, 169},
	{{181, 134, 25, 87, 128, 0, 195, 66, 207, 96, 74, 235, 91, 224, 173, 247}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 91, 157, 211, 239, 160, 159, 128, 67, 51}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 191, 79, 183, 8, 124}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 59, 34, 91, 94, 83, 22}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 31, 204, 106, 49, 203, 103, 26, 78, 193}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 144, 30, 124, 86, 106, 220, 74}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 86, 255, 112, 118, 137, 105, 70, 174, 6}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 254, 100, 61, 128, 161, 88, 56}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 53, 180, 11}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 27, 190, 117, 179, 99}, 169},
	{{181, 134, 25, 87, 128, 0, 50, 123, 29, 100, 62, 252, 240, 115, 95, 12}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 162, 181, 255}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 254, 74, 198, 11, 98, 186}, 169},
	{{181, 134, 25, 87, 128, 0, 252, 75, 102, 252, 41, 159, 42, 155, 176, 217}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 224, 157, 86, 12, 139}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 34}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 243, 9, 207, 210, 221, 155}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 215, 138, 68, 66, 242, 169, 129, 247, 45}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 218, 121, 24, 126, 56, 92, 144, 163, 93}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 58, 205, 245, 92, 37, 48, 170}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 224, 18, 32, 96, 240, 78, 155, 138, 153}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 163, 31, 208, 211, 5, 225, 49, 184}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 198, 13, 21}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 162, 201, 62}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 67, 199, 79, 91, 116}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 67, 246, 24, 243, 134}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 164}, 169},
	{{181, 134, 25, 87, 128, 0, 84, 12, 129, 244, 2, 166, 215, 170, 142, 243}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 25, 76, 253, 13, 156, 160}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 35, 158, 21, 193, 243, 231, 182, 121}, 169},
	{{181, 134, 25, 87, 128, 0, 162, 183, 125, 226, 165, 130, 153, 150, 58, 100}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 184, 145, 94, 53, 46}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 191, 147, 78, 196, 158, 195, 116, 59}, 169},
	{{181, 134, 25, 87, 128, 113, 174, 85, 73, 238, 65, 161, 177, 176, 196, 16}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 0}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 159, 195, 194, 188, 241, 165, 198, 91}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 58, 175, 229, 96, 169, 113, 195, 247}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 101, 200, 130, 95, 234, 74}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 42, 129, 199, 120, 169, 168, 110, 222}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 37, 133, 20, 205, 11, 30}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 169, 223, 117, 79, 240, 45, 112, 134, 162}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 55, 200, 220}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 184, 204, 124, 6, 46, 135}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 249, 84, 89, 105, 134}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 229, 19, 99, 20}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 95, 80, 174, 247, 206}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 161}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 164, 73, 128, 73}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 99, 154, 126, 98, 67, 17, 126, 54, 129}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 211, 229, 195, 222, 250, 4, 107, 158, 216}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 247, 255, 31}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 51, 225, 243, 242, 7, 245, 145}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 171, 177, 182, 153, 34, 221, 58, 207, 244}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 41, 29, 103, 252, 183}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 9, 26, 184}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 151, 75, 87, 57, 248, 178, 187, 100, 34}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 175, 191, 37, 68, 189, 31, 60, 209, 85}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 186, 167, 55, 50, 217, 222, 129, 254, 91}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 9, 148, 171, 104}, 169},
	{{181, 134, 25, 87, 128, 0, 129, 67, 202, 16, 246, 6, 135, 238, 111, 2}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 32, 181, 165, 81, 129, 198, 151, 22}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 32, 123, 4}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 228, 230, 146, 113, 90, 33, 132, 210}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 112, 13, 147, 117, 103, 45, 35}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 14, 188, 9}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 169},
	{{181, 134, 25, 87, 128, 239, 182, 61, 163, 201, 111, 222, 15, 235, 220, 135}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 80, 107, 167, 143, 237, 142, 17}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 242, 206, 239, 10, 114}, 169},
	{{181, 134, 25, 87, 128, 0, 237, 173, 173, 92, 221, 88, 126, 111, 249, 151}, 169},
	{{181, 134, 25, 87, 128, 225, 62, 29, 218, 67, 218, 224, 27, 125, 80, 185}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 2, 180, 180, 85}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 124, 225, 188, 15, 0, 177}, 169},
	{{181, 134, 25, 87, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 64, 248, 15, 253, 84, 137}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 48, 109, 137, 120, 229, 57, 26, 240}, 249},
	{{26, 230, 61, 36, 79, 192, 195, 231, 51, 66, 238, 62, 84, 179, 46, 221}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 177, 196, 252, 101, 225, 245}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 174, 153, 216, 65}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 85, 146, 227}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 114, 210}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 85, 51, 53, 195}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 201, 251}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 164, 29, 89, 252}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 69, 118, 219, 128}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 197, 68, 134, 61, 137, 231, 157, 106}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 51, 51, 57, 13, 152, 103, 220, 199, 212}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 87, 201, 200, 196, 110, 207, 60}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 116, 64, 43, 94}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 1, 56, 18, 165, 91}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 173, 140, 11, 251}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 69, 241, 100, 159}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 233, 122, 113, 91, 250, 3, 217, 143}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 6, 112, 38, 225, 97, 248, 170}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 100, 248, 214, 119, 188, 70, 167, 253}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 77, 126}, 249},
	{{26, 230, 61, 36, 79, 192, 116, 211, 184, 157, 233, 44, 194, 183, 131, 196}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 56, 79, 109, 1, 8, 128}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 69, 54, 155, 132}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 25, 16, 93, 4, 50, 34, 102, 169, 208}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 192, 92, 58, 168, 253, 23, 108}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 171, 159, 214}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 184, 197, 123}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 135, 110, 38, 201, 178, 11}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 46, 250, 56, 65}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 179, 25, 204, 107, 33, 229, 0, 195, 144}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 224, 135}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 33, 107, 243, 129, 213, 11, 55}, 249},
	{{26, 230, 61, 36, 79, 192, 206, 141, 232, 252, 252, 159, 176, 188, 111, 162}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 117, 102, 221, 197, 102, 13, 18}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 197, 40, 10, 100, 221, 66, 41, 103}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 3, 0, 101, 77, 242, 113, 82, 238, 215}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 195, 75, 64, 204, 162, 253, 116, 251, 90}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 67, 115, 51, 71}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 44, 196, 187, 249, 245, 139, 91}, 249},
	{{26, 230, 61, 36, 79, 192, 70, 95, 166, 157, 99, 56, 205, 115, 178, 164}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 163, 156, 251, 102, 224, 198, 9}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 7, 145, 222, 112, 23, 204, 160, 207, 149}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 125, 88}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 238, 181, 177}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 234, 114, 72, 74}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 181, 38, 136, 121, 227}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 105, 49, 153, 151, 174}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 206, 164, 95, 101, 126, 195}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 187, 206, 200, 147, 140, 159}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 132, 2, 235, 57, 122, 9}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 255, 123, 56, 9, 238}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 253, 252, 148, 52}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 24, 152, 184, 33, 129, 84, 109}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 135, 206, 149, 85, 184, 191, 133, 44, 72}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 245, 29, 241, 209, 207, 118, 131, 201, 70}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 128, 115, 32, 149, 184, 213, 145, 131, 215}, 249},
	{{26, 230, 61, 36, 79, 192, 32, 226, 254, 2, 72, 119, 234, 164, 232, 7}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 83, 8, 238, 170, 9, 184}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 141, 77, 128}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 238, 88, 186, 104, 251, 62, 191, 225}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 104, 214, 171, 56}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 40, 85, 1, 161, 145, 3}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 155, 78, 9, 98, 222, 111}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 102, 174, 141, 110}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 14, 52, 117, 95, 146}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 196, 144}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 211, 46, 129, 34, 106, 169, 157, 159, 113}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 71, 172, 121, 18, 50, 192, 72, 64, 42}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 48, 75, 114, 236}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 152, 110, 182, 25, 21, 24}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 34, 87, 103, 186, 193}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 128, 32, 100}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 236, 72, 4, 196, 86}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 50, 181, 123, 174, 47, 201, 43}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 132, 24}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 120, 224, 59, 219, 4, 56, 112, 158}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 234, 234, 43, 199}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 166, 99, 164, 146, 71, 124, 105}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 219, 68, 123, 47}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 115, 246, 131, 162, 118, 138}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 162, 88, 135, 60}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 186, 180, 230, 58, 194, 46, 38, 28, 251}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 243, 106, 231, 54, 77, 50, 40}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 75, 130, 12, 186, 242}, 249},
	{{26, 230, 61, 36, 79, 192, 0, 0, 0, 0, 0, 0, 0, 0, 85, 51}, 249},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 136, 88}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 18}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 62, 158}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 195}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 110}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 203}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 154, 123}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 41, 136}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 253}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 5}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 57}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 193}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 68}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 240}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 1}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 42}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 39, 53}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 240}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 208, 12}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 161}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 234, 42}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 239, 218}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 225, 244}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 57, 42}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 47, 59}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 225, 142}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 37, 253}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 239}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 38}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 225}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 216, 88}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 173, 132}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 188}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 91, 236}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 45, 174}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 121, 228}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 115, 18}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 49, 24}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 187, 86}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 252}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 138, 243}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 68, 42}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 157, 147}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 235}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 155, 139}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 252, 25}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 100, 233}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 134, 115}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 33}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 124}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 233, 206}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 251, 146}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 103}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 208, 229}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 148, 88}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 30, 16}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 26}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 199, 168}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 139, 165}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 0, 0}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 43, 170}, 61},
	{{5, 170, 198, 139, 65, 186, 188, 45, 42, 253, 165, 89, 206, 0, 59, 203}, 61},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 77, 31, 186, 99, 78, 84, 130}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 106, 221, 15, 176, 161, 73, 15}, 63},
	{{211, 245, 62, 0, 74, 129, 113, 228, 87, 44, 251, 62, 19, 17, 28, 68}, 63},
	{{211, 245, 62, 0, 0, 0, 60, 95, 180, 109, 150, 224, 124, 246, 185, 34}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 144, 84, 198, 138, 239, 151, 165}, 63},
	{{211, 245, 62, 59, 77, 227, 198, 205, 105, 37, 178, 147, 86, 157, 144, 134}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 234, 76, 217, 131, 247, 142, 23}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 170}, 63},
	{{211, 245, 62, 0, 0, 0, 56, 193, 232, 120, 157, 45, 124, 235, 37, 196}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 229}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 39}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 73, 204, 44, 209, 57, 165, 187, 203}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 123, 175, 40, 70, 246, 186, 190, 27}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 78, 86, 89}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 208, 80, 70, 142, 103, 203, 3}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 63}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 195}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 217, 127, 44, 238, 234, 252, 80, 83, 44}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 243, 171, 123, 227, 123, 162, 213, 137}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 120, 170, 29}, 63},
	{{211, 245, 62, 104, 162, 47, 62, 132, 152, 62, 12, 248, 253, 78, 66, 37}, 63},
	{{211, 245, 62, 0, 0, 0, 208, 13, 97, 108, 142, 179, 219, 55, 167, 65}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 166}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 172, 60}, 63},
	{{211, 245, 62, 0, 0, 34, 39, 177, 213, 119, 205, 110, 191, 144, 187, 81}, 63},
	{{211, 245, 62, 0, 177, 97, 226, 17, 9, 114, 201, 1, 31, 68, 80, 36}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 155, 19, 65, 219, 255, 5, 23, 59, 140}, 63},
	{{211, 245, 62, 0, 0, 88, 250, 94, 26, 46, 108, 17, 133, 237, 202, 166}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 3, 135, 51, 59, 48}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 251, 22, 115, 100, 12, 112, 9}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{211, 245, 62, 0, 0, 187, 244, 224, 24, 237, 141, 123, 232, 196, 146, 71}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 198, 87, 61, 232, 246, 71, 111, 70, 243}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 60}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{211, 245, 62, 0, 0, 204, 208, 170, 16, 197, 45, 183, 57, 252, 210, 163}, 63},
	{{211, 245, 62, 0, 0, 0, 222, 9, 97, 128, 221, 248, 44, 90, 159, 94}, 63},
	{{211, 245, 62, 0, 0, 59, 26, 115, 130, 190, 152, 186, 1, 137, 177, 75}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 162, 194, 189, 209, 136}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 250, 93, 13}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 90, 79, 230, 55, 244}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 131, 209, 111, 14, 243, 92, 73, 118, 73}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 78}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 182, 150, 54}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 63},
	{{211, 245, 62, 0, 0, 0, 227, 169, 206, 84, 38, 230, 44, 243, 200, 210}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 135, 228, 110, 206, 212}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 66, 246, 33}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 115, 198, 165, 190, 55}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 249, 99, 101, 239, 73, 183}, 63},
	{{211, 245, 62, 0, 0, 0, 163, 161, 152, 158, 37, 55, 206, 171, 207, 116}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 244, 93, 224, 3, 113, 132, 160}, 63},
	{{211, 245, 62, 0, 0, 0, 20, 115, 144, 17, 110, 37, 173, 229, 178, 211}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 184, 88, 125, 150, 45, 194, 86}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 149, 93, 67, 235, 234, 38, 199, 100, 188}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 214, 178, 221, 17, 64, 61, 64, 86, 56}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 121, 151, 88}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 207, 61}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 89, 203, 138, 191, 177, 42, 102, 28}, 63},
	{{211, 245, 62, 0, 0, 0, 119, 21, 45, 175, 179, 182, 143, 117, 72, 19}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 213, 127, 57, 122, 137, 44}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 157, 67, 23}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 203, 7, 178, 35, 60, 3, 88, 171}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 80, 237, 32, 25, 18, 40, 142}, 63},
	{{211, 245, 62, 0, 0, 0, 69, 9, 162, 140, 10, 52, 65, 94, 73, 37}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 227, 184, 225, 210, 146}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 165, 133, 251, 87, 90, 89, 1}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 133, 10, 107, 27, 88, 22, 237, 211, 252}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 31, 64, 114, 197, 187, 84, 137, 51}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 169, 201, 95, 13, 209, 69, 178}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 68, 161}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 21, 220, 205, 39, 2, 246, 85}, 63},
	{{211, 245, 62, 0, 56, 115, 112, 25, 111, 90, 185, 108, 170, 119, 46, 238}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 168, 89}, 63},
	{{211, 245, 62, 0, 0, 241, 196, 174, 234, 161, 250, 101, 47, 46, 176, 238}, 63},
	{{211, 245, 62, 0, 0, 235, 139, 208, 229, 208, 221, 176, 251, 10, 113, 246}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 133, 194, 0, 123, 255, 135}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{211, 245, 62, 0, 0, 242, 82, 46, 119, 15, 18, 130, 181, 0, 56, 11}, 63},
	{{211, 245, 62, 0, 239, 223, 194, 136, 70, 141, 154, 23, 174, 191, 21, 20}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 135, 156, 239, 162, 153, 58}, 63},
	{{211, 245, 62, 0, 226, 229, 210, 218, 96, 169, 11, 81, 95, 219, 112, 171}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{211, 245, 62, 0, 164, 17, 135, 211, 34, 216, 147, 67, 35, 188, 179, 54}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 69, 178, 37, 106, 234, 135}, 63},
	{{211, 245, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 63},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 175, 185}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 206, 93, 15, 167, 243, 44, 99, 214}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 188, 6, 139, 178, 86, 48, 234, 246, 223}, 43},
	{{117, 68, 0, 0, 0, 0, 205, 103, 61, 235, 239, 44, 142, 252, 179, 160}, 43},
	{{117, 68, 0, 225, 104, 90, 11, 47, 115, 110, 63, 14, 75, 111, 169, 54}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 180, 176, 14, 166, 49, 7, 66, 233, 132}, 43},
	{{117, 68, 0, 132, 219, 230, 175, 153, 250, 192, 221, 74, 131, 211, 127, 252}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 119, 3, 235, 77, 14, 104, 3, 224, 16}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 72}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 8, 0}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 61, 79, 28, 33, 77, 192, 209, 11}, 43},
	{{117, 68, 0, 0, 0, 200, 160, 94, 147, 19, 183, 11, 142, 204, 194, 25}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 148}, 43},
	{{117, 68, 0, 102, 105, 90, 57, 142, 170, 98, 123, 70, 221, 145, 84, 251}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 81, 32, 229}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 241}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 199, 246}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 1, 45}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 112, 134, 215, 206, 7, 247, 2, 219}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 188, 27, 20, 158, 249, 188}, 43},
	{{117, 68, 0, 0, 0, 232, 247, 4, 125, 45, 163, 183, 95, 199, 42, 79}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 1, 250, 15}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 147, 100, 193}, 43},
	{{117, 68, 0, 241, 40, 247, 152, 174, 24, 165, 208, 106, 223, 205, 75, 28}, 43},
	{{117, 68, 0, 0, 0, 0, 64, 128, 215, 218, 27, 205, 41, 150, 236, 93}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 8, 162, 161, 157, 184, 160, 30}, 43},
	{{117, 68, 0, 0, 0, 77, 200, 58, 105, 210, 138, 181, 245, 124, 6, 104}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 172, 183, 227, 191, 8, 253, 214}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 20, 24}, 43},
	{{117, 68, 0, 0, 0, 0, 138, 137, 85, 236, 189, 219, 197, 59, 119, 10}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 199, 237, 70}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 39}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 56, 80, 16, 59, 241, 146, 147, 78, 98}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 184, 13, 49, 164, 244, 59}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 172, 128, 105}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 145, 169, 83, 193, 69, 166, 202, 238}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 69, 114, 113, 168, 249, 114}, 43},
	{{117, 68, 0, 0, 80, 189, 252, 25, 46, 254, 242, 170, 167, 128, 164, 63}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 111, 80, 152, 205, 214, 180, 98}, 43},
	{{117, 68, 0, 239, 48, 15, 182, 228, 13, 113, 105, 200, 20, 204, 116, 236}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 21, 137, 66, 143, 249, 161}, 43},
	{{117, 68, 0, 0, 128, 110, 17, 234, 177, 124, 62, 65, 35, 78, 248, 175}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 246, 213}, 43},
	{{117, 68, 0, 19, 47, 184, 153, 201, 104, 183, 166, 237, 166, 88, 55, 178}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175}, 43},
	{{117, 68, 0, 0, 46, 2, 199, 41, 37, 58, 57, 123, 101, 15, 202, 47}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 185, 99, 180, 6}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 167, 95}, 43},
	{{117, 68, 0, 0, 0, 8, 12, 226, 1, 147, 44, 48, 86, 224, 84, 25}, 43},
	{{117, 68, 0, 0, 232, 230, 10, 249, 86, 115, 134, 73, 255, 21, 130, 242}, 43},
	{{117, 68, 0, 0, 0, 0, 72, 255, 219, 168, 181, 56, 24, 241, 226, 200}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 121, 28, 226, 122, 41, 254, 206, 170}, 43},
	{{117, 68, 0, 227, 128, 195, 54, 161, 147, 2, 56, 51, 49, 231, 188, 185}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 2, 177, 223, 192, 152, 170}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 242, 11, 246}, 43},
	{{117, 68, 0, 0, 16, 1, 57, 67, 78, 9, 245, 164, 17, 191, 183, 127}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 192, 12}, 43},
	{{117, 68, 0, 173, 182, 255, 179, 31, 4, 153, 47, 115, 191, 138, 142, 154}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 249, 176, 9}, 43},
	{{117, 68, 0, 0, 0, 0, 104, 121, 236, 35, 51, 38, 83, 249, 11, 32}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 229, 117, 247, 249, 151, 16, 169, 37, 206}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 45, 35, 194, 99, 55, 3, 122}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 15, 0, 254, 107, 12, 82, 148, 210, 90}, 43},
	{{117, 68, 0, 0, 0, 31, 159, 96, 76, 42, 237, 195, 153, 37, 170, 27}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 47, 12, 232, 77, 77, 94, 38, 212}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 15, 47, 137, 87, 227, 238, 133, 132}, 43},
	{{117, 68, 0, 23, 180, 78, 30, 102, 175, 202, 41, 199, 10, 219, 104, 84}, 43},
	{{117, 68, 0, 0, 0, 68, 26, 211, 147, 122, 13, 2, 178, 125, 140, 186}, 43},
	{{117, 68, 0, 0, 140, 114, 43, 73, 167, 173, 123, 94, 102, 227, 120, 113}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 136, 68, 149, 177}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 24, 164}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 251, 117, 237, 92, 45, 216}, 43},
	{{117, 68, 0, 0, 0, 0, 26, 244, 77, 254, 58, 191, 42, 91, 19, 143}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 100}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 38, 16}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 34, 52, 68, 112, 123, 110, 200, 46, 235}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 11, 69, 197, 104, 106, 240, 124, 198}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 172, 202, 189, 72, 5, 52, 7, 180}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 102, 81, 177, 219, 47, 81, 142, 31}, 43},
	{{117, 68, 0, 0, 152, 89, 166, 116, 108, 170, 138, 63, 113, 187, 101, 17}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{117, 68, 0, 0, 191, 180, 5, 106, 239, 113, 141, 116, 7, 149, 141, 76}, 43},
	{{117, 68, 0, 0, 13, 99, 253, 47, 35, 65, 35, 70, 73, 167, 191, 160}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 7, 103, 77, 245, 166, 171}, 43},
	{{117, 68, 224, 60, 43, 48, 62, 142, 215, 141, 74, 49, 178, 15, 103, 32}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 78}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 97, 248, 64, 27}, 43},
	{{117, 68, 0, 0, 0, 171, 148, 35, 199, 227, 158, 52, 188, 83, 120, 60}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{117, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 52, 54, 190}, 43},
	{{117, 68, 0, 0, 119, 57, 243, 201, 253, 31, 122, 222, 231, 165, 40, 120}, 43},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 61, 137}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 213}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 204}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 210, 102, 164}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 118, 71, 210}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 16, 159, 24, 214, 61}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 117}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 74, 183}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 4, 60, 111, 253, 148}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 95, 6, 45}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 100, 128}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 91, 33, 11, 77}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 94, 33}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 141}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 247, 139, 7}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 161, 212, 248, 249}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 137, 4, 179}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 57, 57, 91}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 140, 210, 169}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 70, 205}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 96, 176, 154}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 48}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 98}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 76}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 5, 31, 13, 219, 58}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 141, 199}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 73}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 55, 190, 143, 164, 111}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 57, 95, 142, 70}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 214, 119, 191, 134}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 217, 139}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 16}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 229, 50}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 14}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 136, 216, 188}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 48}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 106, 233, 32, 49, 6}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 53, 178, 187, 106}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 107, 227, 121}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 196, 215, 25, 26, 27}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 123, 123, 92, 139}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 172, 230, 73}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 78, 11}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 67, 114, 167, 94}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 11, 182}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 38}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 129, 1, 119}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 40, 99, 218, 87, 5}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 71}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 87}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 76, 188, 183, 214, 169}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 112, 190, 29, 179, 9}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 34}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 81}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 185, 194, 211, 55}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 198, 11, 68}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 61, 223, 52, 175, 91}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 181, 2}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 235, 173}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 74, 222, 156, 73, 168}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 97, 39, 183}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 40, 33, 232, 236}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 143}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 117, 34, 13, 122, 10}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 28, 229, 63, 185}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 3, 116, 127, 199, 2}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 51, 57, 175, 244}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 193}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 213, 194, 125, 233, 106}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 153, 165, 64}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 90, 156, 240, 63}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 222, 108, 98, 140, 105}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 38}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 75, 246, 77}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 248, 130, 110}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 244, 197, 243, 185}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 125, 107, 34, 33, 111}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 191, 10}, 228},
	{{103, 17, 123, 102, 70, 206, 90, 92, 124, 198, 0, 0, 0, 0, 0, 0}, 228},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 128, 38, 148, 75, 180}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 75, 47, 221, 28, 123}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 0}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 38, 244, 55, 55}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 66, 44, 195}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 80}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 0}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 132}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 127, 4}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 193, 16, 245}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 173, 200, 59, 179, 234}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 107, 19, 188, 4, 16}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 65, 185, 9}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 138}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 227, 122, 166}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 45, 101, 197}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 83}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 25, 130, 69, 89}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 73}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 148, 206, 119}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 234, 106, 241, 74}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 9}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 249}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 217, 88, 202, 89}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 27}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 132, 38, 30, 115}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 175, 207}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 37, 88, 120, 225}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 2, 90, 108, 237}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 133, 139, 166, 55}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 0}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 99, 184, 204, 59, 234}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 46, 254, 215}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 228, 41, 177, 187, 227}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 124, 18, 201, 209}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 134, 96, 47, 201}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 108, 150}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 201, 91, 158}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 107, 214, 149, 143, 137}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 169, 173, 253, 133, 222}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 50}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 45, 179, 45}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 13, 244, 134, 247}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 229, 125}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 136}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 253, 187, 244, 242, 105, 251}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 217, 189, 48, 219}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 44, 97, 217, 25}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 45}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 4, 92, 150, 219}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 43, 151}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 233, 188}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 20}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 13, 37, 119}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 75}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 222, 69, 244, 98, 190}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 134, 206}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 245, 210, 160, 188, 86}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 90, 242, 218, 146}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 33, 194}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 0}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 148, 236, 39, 126}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 114, 235, 179}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 0}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 15, 157}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 9}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 173, 219}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 0}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 160, 21, 191}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 52, 85, 97, 94}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 188}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 80, 127, 161}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 107, 181, 116, 124, 250}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 238, 7, 43, 17, 236}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 200, 55, 249, 184, 91}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 240}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 0}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 83, 151, 113, 209, 27, 27}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 76}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 23, 105, 253}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 0}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 105}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 195}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 38, 181, 114, 6}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 13, 27, 82}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 98, 91, 78, 132, 136}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 86, 125, 127, 65}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 0}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 119}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 72}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 130}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 0}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 251, 36, 132}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 75, 187}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 147}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 94, 230}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 0, 0, 0}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 94, 83, 171}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 0, 0, 193, 164, 179}, 165},
	{{192, 237, 88, 244, 53, 30, 61, 160, 143, 64, 0, 27, 210, 240, 26, 104}, 165},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 219, 238, 9}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 205, 28, 142}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 161, 200, 144, 48, 255, 234}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 161, 86, 168, 204, 56, 197}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 167, 159}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 143, 129, 19, 64}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 13, 27, 105, 103, 161}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 19}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 101, 254, 214, 22, 99}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 4, 235, 71, 250, 243, 127}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 201, 5, 138, 38, 253, 73, 2}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 213, 191}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 213}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 31, 225, 242}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 180}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 80, 53, 45, 237}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 164, 42}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 51}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 208, 241, 193, 136, 20, 207, 71}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 75, 134, 35, 38, 236, 196}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 28, 83, 178, 114, 194, 255}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 138, 231, 155, 226}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 159, 160}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 137, 80, 153, 81, 246, 75}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 117, 112, 8, 72, 227}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 243, 220, 78, 154, 108, 228, 21}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 97, 107, 232}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 155, 31, 105, 205}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 76, 142, 15, 34, 75}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 51, 106, 135, 70, 227}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 123}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 90, 210, 172}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 140, 250, 12, 184, 64, 33, 243}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 231, 149, 44, 183, 225, 105, 115}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 157, 201, 86, 78, 47}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 4, 7, 27, 237}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 221, 38, 21, 206, 225, 10}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 193}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 131, 55, 197, 106, 67, 151, 176}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 57, 24, 145, 223, 122, 71}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 102, 83, 79, 162}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 77, 119}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 243, 115, 60, 98}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 187, 253, 237, 196, 198, 159, 239}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 143, 231}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 168, 38, 47}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 4, 50, 128, 78}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 126}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 2, 127, 153, 165, 80, 104}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 180, 61, 26, 126, 149, 200, 168}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 145}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 161, 148, 62, 72, 212, 201}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 55}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 159, 135, 86}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 95}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 51, 43, 60, 140}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 105, 5, 244, 3, 99, 142, 103}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 127, 185}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 156, 69, 225, 148}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 44, 26}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 85}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 102, 24, 73, 53, 98, 175}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 59, 247, 252, 149, 106, 41}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 46, 76, 79, 11, 45, 68, 244}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 35, 204}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 34, 216, 27, 73, 198}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 71}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 255, 120, 178}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 239, 62}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 121}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 3, 56, 144, 129, 149, 150, 132}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 182}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 248}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 35, 245, 124}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 144, 198, 150, 102, 108}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 186}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 245, 83, 189}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 199, 175, 8, 21, 170, 65, 86}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 211, 71, 217, 53}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 230, 39, 42, 52}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 160, 158, 147, 61, 30, 50}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 78, 25, 81, 105}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 112, 8, 131, 3, 120, 81, 56}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 233, 218, 25, 128, 17, 147, 9}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 0, 193}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 0, 0, 0, 0, 148, 37}, 3},
	{{199, 82, 217, 183, 2, 179, 195, 6, 0, 0, 198, 249, 43, 215, 93, 62}, 3},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 92, 246}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 161, 142}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 157, 70, 136, 185, 247, 179}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 186, 36}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 192, 164, 237}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 171, 97}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 68, 138, 38}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 56, 137, 34, 111, 199}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 189, 185, 44, 248, 143, 178}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 233, 200, 71, 222, 255, 210}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 186, 232, 140, 11, 149, 48, 184}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 124, 41, 224, 226, 64, 201, 84, 141}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 168, 211, 87, 131, 231}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 31, 142, 140, 157, 16}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 215}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 160, 201, 67, 117, 153, 32, 235, 229}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 123, 54}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 240, 54, 195, 139, 196, 224}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 199, 59, 88, 89, 63}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 6, 122}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 240, 182, 31, 199}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 149, 111, 192, 167, 122}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 140, 126}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 141, 144}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 24, 171, 40, 151, 108}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 135, 202, 59, 77, 11, 104, 253}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 55, 169, 45}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 146, 64, 199, 191, 110}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 41, 39}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 201, 130, 232}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 215}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 252, 158, 209, 20}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 113, 157, 240, 196, 7, 186}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 7, 95, 57, 63, 108}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 235, 111, 77}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 64, 80, 34, 78}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 200, 99, 220, 106, 153, 19}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 87, 147, 119, 69, 97, 142}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 63, 170}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 125, 1, 37, 62, 210}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 107, 27}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 212, 167, 174, 66, 68}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 242, 145, 170, 20}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 152, 185, 9, 213}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 43, 142, 148}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 245, 251, 227}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 15, 50, 161, 163, 154, 190, 14, 20}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 160, 203}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 206, 221, 49, 190, 214, 176}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 169, 45, 181, 89, 104}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 3, 222, 113, 65, 175, 88}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 91, 71, 148, 78, 79, 221}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 224, 94}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 113, 236}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 164, 173, 184, 85, 253}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 90, 207, 25, 165, 131, 167, 114}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 125, 192, 87, 118, 199, 158}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 243, 221, 146, 200}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 151, 99, 5}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 61, 244}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 232}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 56, 242, 243, 143, 42}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 133, 237, 10, 129, 197, 15, 255}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 181, 7, 57, 198, 52, 78, 193}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 214, 209, 42}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 113, 157, 244}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 174, 251}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 208, 35, 248, 22, 85, 231}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 220, 243, 212}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 106, 217}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 200}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 175, 77, 157, 187}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 203, 126, 15, 118}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 249, 229, 183}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 155, 18}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 215}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 187, 35}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 171, 15, 219, 142, 141, 241, 29, 48}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 254, 98, 223, 93, 255, 37, 94}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 186, 153}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 252, 182, 120, 41, 89}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 0, 0, 0, 0, 0, 249, 78}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 42, 52, 29, 151, 23, 229, 130}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 0, 181, 166, 204, 225, 132, 152, 144}, 211},
	{{157, 230, 79, 162, 57, 125, 152, 0, 102, 52, 226, 134, 18, 72, 146, 220}, 211},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 146, 24, 88, 122, 38, 199}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 94, 7, 160, 207, 83, 124, 106}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 213, 16, 159, 210, 31, 199, 225}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 111, 182, 67}, 210},
	{{27, 67, 64, 235, 128, 0, 214, 207, 238, 102, 201, 27, 143, 189, 204, 127}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 55}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 12, 58, 98, 29, 79, 104, 206, 219}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 172, 61, 119}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 112, 146, 58, 31, 15, 78, 220}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 229, 195, 125, 157, 156, 60, 166, 142, 78}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 48, 127, 17, 129, 167, 144, 227}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 252, 193, 61, 183}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 67}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 220, 125, 22, 107, 45, 218}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 98, 101, 20, 46, 114, 248, 227, 21, 52}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 89, 113, 106}, 210},
	{{27, 67, 64, 235, 128, 162, 19, 230, 214, 39, 123, 241, 31, 58, 152, 237}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 215, 202, 60, 76, 60, 134, 4, 82, 69}, 210},
	{{27, 67, 64, 235, 128, 232, 106, 69, 252, 88, 12, 113, 11, 152, 245, 176}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 145, 28, 173, 104, 204, 182, 102, 45}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 73, 132, 20, 186, 152}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 163, 197, 22, 107}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 30, 211, 229, 162, 161, 35}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 45, 255, 19, 134, 30, 174, 202}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 168, 198, 162, 195, 195, 86, 35, 40, 212}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 6, 224, 115, 205, 163, 168, 224, 205, 21}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 232, 205, 50}, 210},
	{{27, 67, 64, 235, 128, 0, 13, 210, 14, 55, 44, 30, 249, 253, 224, 226}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 99, 87, 170}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 102, 157, 127, 19}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 2, 186, 3, 8}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 190, 48, 189, 207, 250, 115}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 130, 15, 183, 151, 247, 173, 93, 216}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 208, 45, 237, 156, 188, 178, 227}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 91}, 210},
	{{27, 67, 64, 235, 128, 152, 175, 191, 13, 218, 10, 77, 84, 25, 121, 183}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 31, 218, 60, 193, 243}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 109, 22, 98, 187, 81, 138, 175}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 221, 74, 226, 44, 115}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 210}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 172, 115, 206, 204}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 241, 114, 170, 47, 215, 172, 148}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 210},
	{{27, 67, 64, 235, 128, 151, 187, 252, 226, 16, 12, 224, 143, 44, 214, 247}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 249, 186, 86, 69, 8, 84, 70, 128, 31}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 17, 30, 119, 95, 140, 69}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 131, 235, 22, 198, 137, 227, 21, 227}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 254, 209, 76, 198, 159, 228}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 121, 76, 157, 68, 152, 230, 111, 67, 26}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 48}, 210},
	{{27, 67, 64, 235, 128, 107, 239, 128, 161, 171, 241, 11, 249, 133, 92, 240}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 70, 55, 78, 29, 90, 235}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 16, 94, 77, 189, 216, 66, 194, 117, 10}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 157, 61, 101, 112, 108}, 210},
	{{27, 67, 64, 235, 128, 95, 63, 98, 40, 103, 225, 57, 196, 228, 233, 5}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 38, 150, 60, 96}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 36, 134, 23, 53, 56, 4, 11}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 235}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47}, 210},
	{{27, 67, 64, 235, 128, 0, 136, 75, 239, 28, 65, 0, 216, 87, 87, 172}, 210},
	{{27, 67, 64, 235, 128, 0, 23, 135, 45, 141, 44, 241, 45, 34, 69, 176}, 210},
	{{27, 67, 64, 235, 128, 0, 194, 160, 77, 35, 109, 115, 2, 15, 173, 73}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 26, 104, 223, 15, 210, 236, 84, 25, 173}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 213, 107, 116, 125, 39}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 232, 29, 42, 208}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234}, 210},
	{{27, 67, 64, 235, 128, 93, 200, 251, 108, 203, 10, 216, 147, 44, 156, 162}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 109, 70, 118, 62, 211}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 252, 14, 182, 189, 226}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 176, 18, 171, 230, 197, 227}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 63, 73, 40, 184, 245, 124}, 210},
	{{27, 67, 64, 235, 128, 57, 53, 209, 107, 152, 244, 255, 246, 55, 184, 19}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 63, 195, 238, 251, 17, 203}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 129, 55, 70, 82, 74, 193}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 78}, 210},
	{{27, 67, 64, 235, 128, 0, 221, 186, 182, 155, 44, 218, 145, 237, 54, 232}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 11, 161, 156, 110}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 232}, 210},
	{{27, 67, 64, 235, 128, 0, 238, 117, 56, 221, 97, 46, 249, 232, 245, 58}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 40}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 0, 0, 223, 86, 128}, 210},
	{{27, 67, 64, 235, 128, 0, 0, 0, 0, 0, 0, 46, 121, 41, 119, 88}, 210},
	{{27, 67, 64, 235, 128, 0, 133, 215, 91, 225, 168, 61, 126, 191, 28, 75}, 210},
	{{27, 67, 64, 235, 128, 0, 214, 222, 47, 216, 80, 17, 7, 22, 70, 101}, 210},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 143, 177}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 14, 94}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 27, 94}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 44}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 52, 118}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 222}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 250}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 152}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 70, 2, 30}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 46, 153}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 21, 103}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 174}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 105}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 22, 155, 243}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 19, 4, 201}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 61, 188, 6}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 65, 54}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 182, 72}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 228, 127, 3}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 161, 222, 212}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 84, 57}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 38, 231}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 115, 201, 232}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 220, 133}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 40, 164, 150}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 241, 47, 89}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 189, 233}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 69, 214}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 87, 128, 155}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 207, 73}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 96, 49, 127}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 72, 38, 169}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 175, 251, 116}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 252}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 161}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 138, 248, 159}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 46}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 7, 133, 89}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 157, 2, 21}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 182, 126, 158}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 160, 246}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 56}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 120, 77}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 139}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 140, 112}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 239, 101}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 241, 212}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 190, 214}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 246, 237}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 233, 149}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 130}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 43}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 114, 134, 54}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 215, 49}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 228, 16}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 190, 94, 37}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 210, 74}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 146}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 82, 118}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 203}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 118, 180, 141}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 30, 168, 95}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 204, 96}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 27, 181, 75}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 151}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 231, 13, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 214, 166, 125}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 199, 110}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 90}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 128, 49, 36}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 29}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 0}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 55, 94}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 0, 0, 150}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 228, 42, 118}, 61},
	{{72, 158, 163, 106, 193, 137, 190, 7, 250, 165, 249, 73, 64, 197, 143, 31}, 61},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 249}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 65, 22, 205, 193, 161, 153, 59, 231}, 120},
	{{34, 192, 0, 177, 163, 136, 90, 227, 4, 157, 179, 64, 78, 37, 155, 227}, 120},
	{{34, 192, 0, 0, 0, 44, 159, 76, 55, 222, 163, 156, 13, 166, 214, 180}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 187, 37, 240, 113, 90, 79, 67, 130}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 243, 179, 135}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 165, 20, 12, 136}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 255}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 50, 85, 70, 154}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 166}, 120},
	{{34, 192, 0, 44, 101, 200, 243, 95, 97, 48, 123, 56, 202, 151, 118, 81}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 101, 203, 247, 126, 126, 235, 185, 35, 138}, 120},
	{{34, 192, 0, 0, 22, 190, 147, 88, 85, 123, 167, 136, 31, 227, 249, 200}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 14, 225, 108, 188, 171, 214, 173, 21, 146}, 120},
	{{34, 192, 0, 0, 0, 128, 92, 242, 83, 93, 12, 6, 175, 34, 141, 126}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 143}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 240, 154, 185, 129, 116, 149, 198, 243, 33}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 54, 52, 199, 67, 254, 45, 10}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 216}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 213, 6, 124, 180}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 141, 178, 81, 35, 239, 248}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 176, 104, 89}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 41, 113, 195, 104}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 241}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 20, 33, 165, 68, 204, 121, 44, 216, 191}, 120},
	{{34, 192, 0, 0, 0, 0, 91, 93, 4, 228, 242, 253, 63, 2, 1, 205}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 146, 124, 113, 160}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 148, 246, 202, 96, 221, 88, 145, 132, 253}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 59, 125}, 120},
	{{34, 192, 0, 0, 0, 73, 54, 230, 182, 9, 165, 56, 101, 193, 231, 240}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 203, 106, 90, 8}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 74, 232, 142, 96, 187, 202, 67}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 34, 147, 200}, 120},
	{{34, 192, 0, 0, 0, 0, 171, 38, 199, 160, 52, 96, 207, 220, 58, 21}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 17, 149, 73, 134}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 16, 109, 116, 14}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 120},
	{{34, 192, 38, 227, 131, 115, 239, 51, 86, 148, 23, 96, 60, 229, 177, 184}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 177, 189, 98, 24}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 194, 8, 26}, 120},
	{{34, 192, 99, 200, 87, 153, 114, 61, 177, 195, 91, 32, 204, 146, 188, 72}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 208, 84, 68, 129}, 120},
	{{34, 192, 0, 0, 0, 0, 29, 223, 248, 192, 36, 186, 136, 207, 65, 41}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 199, 152, 180, 191, 21, 30, 133, 89}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 155, 9, 12, 113, 11, 242, 60, 156, 114}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 86}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 151, 176, 241}, 120},
	{{34, 192, 0, 0, 218, 218, 188, 186, 247, 120, 162, 67, 47, 205, 221, 127}, 120},
	{{34, 192, 0, 0, 0, 135, 199, 54, 182, 41, 107, 101, 143, 34, 250, 75}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 50, 81, 254}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 84, 37, 99, 223}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 126, 245, 62}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 242, 130, 16, 128, 73, 247, 5, 129, 230}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 235, 20, 174, 23, 84, 113}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 107, 140, 156, 140, 185, 212, 225, 224, 39}, 120},
	{{34, 192, 0, 251, 147, 181, 13, 100, 45, 175, 181, 27, 164, 229, 81, 7}, 120},
	{{34, 192, 69, 17, 9, 58, 58, 115, 63, 219, 244, 143, 168, 50, 158, 235}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 31, 36, 193, 240, 12, 108, 21, 83, 117}, 120},
	{{34, 192, 0, 0, 0, 104, 251, 189, 69, 39, 219, 252, 14, 245, 73, 31}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 220}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 129, 196, 57, 22, 6, 241, 176}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 122, 74, 146}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 120},
	{{34, 192, 0, 0, 70, 216, 90, 38, 34, 45, 239, 98, 149, 165, 39, 188}, 120},
	{{34, 192, 242, 201, 249, 250, 137, 139, 119, 233, 189, 207, 27, 177, 72, 42}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 226, 205, 207}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 234, 30, 153, 185, 230, 217, 26}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 234, 239, 134, 242, 190, 24, 154, 32}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 6}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 21, 98, 95, 46, 48, 81, 203, 106}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 88, 200, 120, 239, 72, 51, 132, 223}, 120},
	{{34, 192, 0, 0, 0, 0, 222, 221, 17, 43, 13, 81, 171, 79, 78, 181}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 130, 247, 77, 1, 211, 64}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 137, 119}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 144, 226}, 120},
	{{34, 192, 9, 100, 77, 9, 81, 30, 0, 17, 205, 28, 233, 123, 62, 135}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 176, 196, 60, 7, 85, 233, 15, 84, 109}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 12, 205, 213, 171, 37, 123}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 243, 192, 44, 58, 144, 109, 165, 197}, 120},
	{{34, 192, 0, 0, 0, 0, 94, 158, 237, 240, 27, 93, 95, 137, 137, 114}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 97, 172, 98, 140, 47, 158, 74}, 120},
	{{34, 192, 0, 0, 0, 167, 214, 144, 127, 164, 81, 9, 152, 218, 148, 117}, 120},
	{{34, 192, 0, 0, 0, 0, 24, 236, 42, 5, 216, 74, 145, 57, 73, 233}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 71}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 164, 230, 236, 233}, 120},
	{{34, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 115, 21}, 120},
	{{34, 192, 0, 0, 0, 0, 179, 123, 176, 177, 33, 152, 218, 230, 47, 185}, 120},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 19, 103, 90, 147, 229, 247}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 89, 181, 18, 131, 77, 7, 151}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 83, 131, 177, 245, 75, 244, 149, 212, 2}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 245, 150, 119, 81, 50}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 216, 128, 164, 213, 38, 15, 210, 114, 41}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 104, 232, 131, 140, 131}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 139, 237, 119, 165, 80, 66, 212, 243, 249}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 221, 40, 255, 86, 235, 238, 2}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 199, 188, 226, 216}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 35, 225, 233, 65, 110, 17}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 16, 221, 3, 168, 118, 103, 4, 145}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 239, 255}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 241, 158, 116, 128, 253, 228, 229, 15}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 18, 119}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 16, 199, 18, 186}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 177, 75, 70, 224, 193, 160, 170}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 177, 216, 65, 199, 50, 189}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 76, 242}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 83, 115, 67, 166, 22}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 76, 1, 5, 169, 58, 242, 23}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 152, 201, 109, 167, 197, 164, 8, 221}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 22, 74, 18, 42}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 13, 87, 186, 161, 42}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 33, 12, 79, 43, 229, 19, 240}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 174, 183}, 94},
	{{215, 141, 95, 192, 189, 62, 80, 152, 106, 120, 212, 212, 250, 153, 112, 125}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 81, 209, 232, 143, 13, 85, 224, 170}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 76, 13, 211, 31, 156, 197, 225, 2}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 213, 120, 118, 213, 47, 253}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 164, 216, 245, 56, 195, 216}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 117, 47}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 105, 86, 157, 108, 59, 188}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 193, 140}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 118, 60, 194, 222, 252}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 181, 139, 206, 116}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 34, 145, 250}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 143, 47, 178, 239, 131, 174, 134}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 144, 15}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 221, 17, 52}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 77, 135, 151, 114, 191}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 245, 49, 133, 127, 58, 103, 20, 229, 62}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 232, 181, 111, 176}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 122, 33, 16, 238, 61}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 90, 71, 4, 160, 151}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 155, 218, 64, 49, 77, 227, 49, 205, 139}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 178, 35, 133, 230, 171, 239, 160, 174, 187}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 255, 125, 239, 219, 179}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 186, 208, 177, 105, 115, 70, 252, 210, 68}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 138, 205}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 231, 172, 168}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 9, 61, 170, 124, 211}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 5, 75, 162, 147, 46}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 239, 31, 11, 208}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 120, 183, 158}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 238, 229, 213, 236, 10, 57, 68, 132}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 66, 246, 180, 27, 19}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 118, 214, 202, 60, 158}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 145, 212, 214, 112, 61, 19, 141, 52, 227}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 255, 229, 194, 165, 67}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 101, 160, 187}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 130, 6}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 91, 195, 59, 64, 142, 88}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 45, 247, 72, 227}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 192, 216, 105, 125, 88, 62, 54}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 203, 126, 143, 45, 136, 150, 142}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 208, 56, 237, 57, 127, 6}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 188, 19, 109, 253, 123, 4, 207, 7}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 181, 255, 206}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 29, 140, 2, 30, 142}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 86, 12, 205}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 163, 29, 110, 45, 90}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 85, 198, 244}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 111, 203, 0, 2, 109, 68, 145, 244}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 203, 27, 187, 180, 38, 235, 75, 219}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 238, 106, 100, 26, 121, 151, 187, 208}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 191, 67, 96}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 190, 52, 31, 229, 249, 193, 213, 29, 42}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 118, 40, 200, 207, 104}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 99, 242, 244, 100, 162}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54}, 94},
	{{215, 141, 95, 192, 189, 62, 0, 107, 170, 3, 54, 121, 246, 95, 56, 208}, 94},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 4, 30}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 17, 162}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 193, 19, 201, 103}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 113, 185, 235}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 219, 29, 110, 245}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 255, 84, 106, 105, 194, 74, 23, 167, 54}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 144, 154, 93, 204, 105, 133, 173, 234, 92}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 109, 132, 222, 10, 141, 104}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 159, 51, 143, 50, 61, 167, 189}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 187, 237, 36}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 91, 224, 13, 109, 153, 129, 22}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 209, 106, 20}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 11, 221, 167}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{31, 181, 56, 141, 120, 128, 144, 163, 10, 95, 245, 218, 151, 2, 115, 247}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 84, 138, 187, 94, 240, 108, 136}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 15, 248, 58, 178, 192, 10}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 140, 225, 87, 37, 50, 221, 160, 187}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 106, 249, 226, 225, 98, 160, 248}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 146, 29, 62, 107, 127, 14, 176, 203}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 52, 150, 180, 60, 207}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 134, 49, 92, 40, 58}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 224, 129, 114, 253, 169, 66, 249}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 197, 108, 175, 202, 244}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 215, 177}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 131, 86, 31, 68, 109, 166, 39, 14}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 52, 206, 144}, 153},
	{{31, 181, 56, 141, 120, 128, 125, 89, 68, 209, 58, 201, 199, 54, 1, 118}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 98, 24, 18}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 112, 222, 0, 117, 228, 15, 218, 240, 33}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 187, 166, 216, 251, 220, 170}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 152, 204}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 113, 19}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 181, 163}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 255, 189, 97, 212, 7}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 221, 153, 170, 162, 224, 63}, 153},
	{{31, 181, 56, 141, 120, 128, 160, 108, 68, 37, 143, 168, 149, 167, 193, 120}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 9, 175, 143, 92, 67, 210}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 140, 123}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 198, 220}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 122, 59, 226}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 97, 31}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 87, 41, 96, 145, 199}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 45, 193, 147, 200, 245, 33, 176, 196}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 54, 43, 152}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 64, 108, 126, 249, 184, 13, 152, 133, 8}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 116, 121, 188, 51, 23, 82, 156}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 252, 180, 78, 169}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 160, 35, 162, 5, 89, 202, 99, 36, 84}, 153},
	{{31, 181, 56, 141, 120, 128, 115, 49, 70, 19, 12, 13, 177, 43, 178, 191}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{31, 181, 56, 141, 120, 128, 110, 218, 30, 120, 148, 13, 192, 24, 90, 47}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 159, 59, 94, 219}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 229, 243, 53, 94, 50, 40, 118, 235, 188}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 20, 164, 185, 163, 35, 6, 65, 112}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 132, 212, 128}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 22, 76, 105, 243, 40, 60, 229}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 163, 34, 141, 34, 98, 57, 204, 163}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 236, 168}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 110, 172}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 190, 126, 231, 71, 155, 62}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 227, 186, 0}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 205, 107, 130, 119, 61}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 10, 52, 246, 53}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 236, 202, 249, 141, 170, 178}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 33, 36, 17, 217, 99, 143, 102, 16}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 247, 178, 186}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 221, 31, 172, 141, 175, 22, 208, 202, 255}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 140, 119, 77, 208, 88, 214, 56}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 108, 18, 82, 2, 76, 46, 123, 227}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 237, 137, 27, 221, 138, 116, 116, 181, 68}, 153},
	{{31, 181, 56, 141, 120, 128, 40, 34, 169, 167, 12, 62, 99, 7, 224, 15}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 14, 238, 198, 9, 228}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 241, 53, 129, 135, 201, 245, 167, 135, 57}, 153},
	{{31, 181, 56, 141, 120, 128, 240, 83, 136, 171, 113, 146, 62, 127, 150, 194}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 141, 242}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 170, 187, 233, 102, 173}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 114, 215, 244}, 153},
	{{31, 181, 56, 141, 120, 128, 145, 53, 68, 181, 223, 210, 234, 178, 128, 236}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 22, 58}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 139, 152, 227, 231, 242, 25, 43, 68}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 0, 0, 0, 137, 184, 215, 201}, 153},
	{{31, 181, 56, 141, 120, 128, 0, 0, 0, 66, 207, 192, 210, 207, 1, 250}, 153},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 40, 127, 15, 197, 198, 80, 87}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 109, 242, 222, 127, 118, 92, 118}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 227, 117, 204, 104, 136}, 221},
	{{153, 73, 128, 0, 10, 212, 117, 252, 244, 31, 121, 8, 113, 125, 235, 12}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 210, 247, 153}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 30, 251, 20, 110, 5, 20, 39, 107}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 238, 199, 205, 103, 112, 165, 165}, 221},
	{{153, 73, 128, 111, 172, 83, 53, 247, 101, 241, 202, 39, 165, 251, 54, 98}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 21, 51, 231, 189, 195, 134, 222, 40, 44}, 221},
	{{153, 73, 128, 0, 48, 239, 213, 142, 82, 86, 14, 94, 157, 225, 146, 255}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 215}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 220, 46, 188, 146, 179, 194, 162}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 9, 80, 16, 105, 58, 96, 99, 138}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 104, 100, 20}, 221},
	{{153, 73, 128, 0, 40, 76, 144, 118, 103, 111, 122, 156, 44, 111, 25, 94}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 9, 252, 109, 25, 255}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 239, 92, 73, 208, 212, 4, 175}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 175, 228, 212, 215, 251}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 243}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 228, 106, 25, 85, 65, 99, 74, 93}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 182, 37, 233, 62, 235, 114}, 221},
	{{153, 73, 128, 0, 0, 149, 158, 176, 139, 148, 126, 142, 94, 126, 13, 126}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 183, 37, 127, 134, 105, 2, 182, 254, 151}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 184}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 149, 209, 59, 170, 96}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 249, 249}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 206, 145, 103, 146, 251}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 139}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 178, 44, 198, 56, 93, 197, 14}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 104, 26, 203, 80, 108, 174, 208}, 221},
	{{153, 73, 128, 68, 159, 150, 172, 150, 4, 222, 44, 124, 121, 221, 127, 217}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 196, 40, 40}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 90, 39, 239, 29, 3, 105, 110}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 146, 223}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 124, 62, 157}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 180, 82, 75}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 206}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 19, 190}, 221},
	{{153, 73, 128, 0, 0, 0, 205, 140, 212, 47, 175, 71, 11, 189, 110, 86}, 221},
	{{153, 73, 128, 0, 20, 62, 79, 221, 183, 43, 58, 160, 70, 90, 155, 125}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 24}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 215, 8}, 221},
	{{153, 73, 128, 0, 0, 246, 74, 138, 219, 78, 164, 55, 239, 47, 229, 19}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 179, 27, 212}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 20, 116, 114}, 221},
	{{153, 73, 128, 0, 0, 13, 203, 108, 104, 224, 194, 73, 163, 7, 136, 6}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 189, 98, 232, 51, 224, 213, 100, 246}, 221},
	{{153, 73, 128, 0, 165, 249, 20, 184, 156, 78, 180, 248, 144, 106, 158, 3}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 108}, 221},
	{{153, 73, 128, 0, 105, 227, 82, 154, 84, 120, 86, 72, 195, 64, 6, 62}, 221},
	{{153, 73, 128, 0, 0, 233, 220, 137, 157, 149, 173, 22, 2, 191, 164, 200}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 224, 135}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 252, 110}, 221},
	{{153, 73, 128, 0, 0, 0, 234, 251, 114, 106, 79, 216, 174, 130, 93, 120}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 30, 220, 225}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 35, 201, 176, 180, 196, 171}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 63, 160, 38, 30, 192, 157, 36, 101}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 108, 133, 124, 4, 8, 150}, 221},
	{{153, 73, 128, 40, 176, 227, 252, 69, 88, 221, 225, 109, 101, 202, 94, 198}, 221},
	{{153, 73, 128, 0, 0, 250, 207, 91, 31, 37, 82, 68, 145, 93, 179, 211}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 206, 140, 78, 136, 138, 190}, 221},
	{{153, 73, 128, 0, 0, 0, 108, 93, 41, 226, 251, 56, 26, 219, 247, 179}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 164, 113, 183, 230, 140, 124, 240, 225, 121}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 42}, 221},
	{{153, 73, 128, 0, 121, 148, 41, 145, 132, 45, 69, 158, 136, 148, 151, 209}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 171, 122}, 221},
	{{153, 73, 128, 0, 225, 122, 218, 122, 14, 51, 171, 39, 206, 245, 101, 79}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 20, 65, 165, 169, 102, 198}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 92, 27, 83}, 221},
	{{153, 73, 128, 0, 0, 0, 115, 18, 116, 122, 88, 180, 213, 102, 0, 140}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 54, 201, 120, 55, 30, 95, 25, 252}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 61}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 182, 188, 106, 144, 126}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 61, 19, 177, 20, 21, 17, 150}, 221},
	{{153, 73, 128, 0, 0, 142, 167, 94, 91, 62, 3, 108, 149, 103, 40, 77}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 134, 31, 174, 38, 44, 57, 196, 16, 121}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 12}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 249}, 221},
	{{153, 73, 128, 0, 0, 0, 206, 34, 83, 208, 249, 43, 108, 25, 18, 65}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 29, 1}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 148}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 119, 5}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 180, 214, 113, 198, 105, 154, 70}, 221},
	{{153, 73, 128, 0, 162, 213, 22, 197, 211, 253, 164, 194, 23, 132, 15, 231}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 151, 143, 221, 228, 107, 36, 41}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 252, 231, 198, 224, 75, 108, 58, 165}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{153, 73, 128, 0, 0, 0, 0, 0, 203, 150, 243, 50, 140, 143, 53, 194}, 221},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 252, 31, 132, 72}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 142, 206, 82, 67, 122}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 195, 30, 170}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 177, 4}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 188, 100, 143}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 89, 127, 204, 93}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 61, 122}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 122, 230, 119, 88}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 50, 36, 111, 47}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 14, 216, 134, 167}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 1}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 48, 68}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 60}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 242}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 91, 212, 20}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 98, 89}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 220, 136, 208, 254}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 242, 189, 225}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 136, 212, 151, 93}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 1, 5}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 190, 200, 89, 75}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 51, 40, 112}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 25, 28}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 153, 178}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 206, 215}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 128, 123}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 212, 177, 88}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 219, 131, 66}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 202, 44}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 131, 17, 159, 195}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 249}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 58, 220, 111, 69}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 71, 232, 219}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 38}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 87, 188}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 97, 116}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 217, 182, 41}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 159, 169}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 14}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 184, 103, 43, 249}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 69, 139, 30}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 205}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 26, 137}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 14, 138, 199, 79}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 36, 129, 212}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 225, 65}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 36}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 97, 18, 29, 92, 108}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 233}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 2, 5, 244, 253}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 117}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 193, 24}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 69, 16, 236, 224}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 193, 96}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 140}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 3, 172, 229, 235, 67}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 194}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 17, 181, 160}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 252}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 63, 204, 174, 55}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 253, 136, 83, 180}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 139, 216}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 46, 123}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 105, 153, 237, 114}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 154}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 251, 10, 234}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 133, 31, 94, 63}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 16, 56, 160, 186}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 253, 137, 178}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 151, 142}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 64, 47, 100, 177}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 158, 18, 200, 156}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 184, 97, 54}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 11, 103, 236}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 117}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 230, 168, 28, 246, 82}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 99}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 159, 35, 133}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 174, 100}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 122, 141}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 73}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 124}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{162, 107, 41, 189, 165, 155, 22, 139, 165, 72, 96, 0, 0, 0, 0, 0}, 163},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 64, 82}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 9, 205}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 158, 221}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 88}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 62}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 227, 183}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 50}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 191}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 254, 193}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 162}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 147}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 210, 92}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 122}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 132, 79}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 86, 131}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 151}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 140, 161}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 16, 217}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 132, 140}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 18}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 212, 102}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 255, 88}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 158}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 93}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 250, 35}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 111}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 135, 74}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 164}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 128, 173}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 82}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 84}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 207, 13}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 164}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 6, 77}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 45}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 241, 135}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 32, 47}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 115, 79}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 173}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 23}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 101, 176}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 32, 162}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 178}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 18}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 230}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 85}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 84, 32}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 171}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 135}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 213, 17}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 47}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 71}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 112, 95}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 101}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 2}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 31, 123}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 167, 41}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 190, 48}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 228, 148}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 35, 201}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 70, 189}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 225}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 0}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 248}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 152}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 67}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 90}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 0, 111}, 188},
	{{218, 17, 204, 165, 217, 251, 107, 45, 29, 15, 192, 167, 75, 0, 91, 47}, 188},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{200, 124, 238, 213, 35, 228, 94, 141, 86, 187, 101, 60, 115, 52, 131, 16}, 15},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 163}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 22, 72, 93}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 251, 153, 219, 253, 249, 79, 140}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 146}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 142, 139, 62, 245}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 251, 43, 127}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 244, 94}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 183, 220, 116, 72, 107, 163}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 224, 236, 132, 91}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 81, 244, 245, 70}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 218, 77, 210, 174, 156, 52, 160}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 170, 160, 194, 57, 85, 6, 50}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 153, 166, 245, 213, 216, 139, 158}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 35, 123, 65, 201, 178, 83, 189}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 162}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 55, 37, 100}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 214, 233, 188, 111, 23, 199, 138}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 208, 114, 126, 235, 238, 206, 79}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 212, 52, 223}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 84, 138, 151, 107, 88}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 236, 54, 72, 242}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 245, 252, 201, 137, 123}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 103, 99, 208, 118, 180, 212, 124}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 87, 234, 132, 211, 71}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 145, 157, 255, 197, 7}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 151, 5, 192}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 161, 47, 5, 253, 42}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 121}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 101, 25, 217}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 90, 170, 214, 77, 175}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 234, 172, 134, 144, 25, 106, 78, 56}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 111, 89, 134, 59, 241}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 210, 181, 113, 67, 42, 76}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 255, 145, 233}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 130, 108, 228, 75}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 58, 167}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 199, 28, 66, 207, 215, 214}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 2, 63, 153, 197}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 26, 4, 5, 155, 161, 50, 123}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 144, 231, 128, 251}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 129, 38, 159}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 72, 108, 172}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 129, 94, 209, 85}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 73, 138}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 187, 198, 211}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 250, 111, 4, 50, 184, 197}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 99, 113, 224, 158, 102}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 7, 235, 204}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 126, 188}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 221, 120, 240, 24, 183, 183, 129}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 189, 83, 170, 119}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 227, 180, 77, 3, 98, 252}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 175, 159, 88, 154, 3, 51}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 166, 160, 7}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 220, 231, 233, 202}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 152, 104}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 15, 114, 125}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 197, 74, 132, 87, 54}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 118, 107, 80}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 173}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 131, 1}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 229, 137, 129, 116, 4, 249, 122, 169}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 240, 228, 100, 191}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 159, 106, 151, 84, 222}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 33}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 245, 32, 155}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 202, 26, 98, 219}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 185}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 249, 238, 215, 62, 17, 254, 214}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 217, 93, 189, 36, 239, 136}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 178, 10}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 155, 233, 112, 23, 128}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 158, 125}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 243, 190, 148, 116}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 28}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 171, 191, 35, 94}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 99, 78}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 186, 235, 163, 254}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 49, 76}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 211}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 204, 212, 82, 91, 115, 89, 193}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 71, 210, 54, 138, 26, 135, 93}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 132, 213, 198}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 179}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 195, 221}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 5, 244, 57}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 212}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 74, 13, 76, 91, 89}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 134, 76, 18, 167, 163, 58, 202}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 11, 152, 183}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{74, 237, 160, 56, 141, 217, 191, 16, 0, 0, 0, 0, 0, 186, 109, 60}, 28},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 142, 167, 68, 96}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 104}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 228, 36, 77, 28, 24}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 16, 89, 167, 126, 91}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 119}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 97, 188, 48, 1}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 226, 3, 112, 144}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 206, 51, 230, 80}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 194, 161}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 207, 165, 124, 146, 245}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 219}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 186}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 111, 138, 73, 236, 199}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 27}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 129, 146, 207, 96, 245}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 254, 5}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 154, 140}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 228, 234}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 40, 243, 240, 251, 71}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 155, 110, 146}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 52}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 6, 197, 40, 214}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 58}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 147, 90, 201}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 9, 92, 200, 225}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 65, 149, 198}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 130}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 99}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 165, 39, 77, 46}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 45, 143}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 38, 86, 188, 112, 36}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 90, 105}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 141}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 71}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 120, 32, 138, 180, 19}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 71}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 230, 135, 112}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 165}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 211, 129, 8, 57}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 236, 167, 100, 29}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 169, 155, 247, 168}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 136}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 195, 58, 165, 126}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 75}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 3, 107, 148, 94}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 253, 63}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 19, 131, 250}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 106, 205, 13, 232}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 213, 208, 39}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 87, 135, 107, 57}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 26, 14, 12}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 112, 161}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 57, 150}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 78}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 239, 63, 176}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 103, 186, 149, 60}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 40, 251, 103}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 154, 36, 178, 30}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 57, 108}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 173, 195, 213}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 48, 240, 37, 241}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 112}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 105}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 32}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 183, 139, 50, 106}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 215}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 178}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 75}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 101, 107, 76, 105}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 120, 120}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 74, 89}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 98, 153}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 108}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 29, 247}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 152, 16, 224, 43, 22}, 240},
	{{163, 47, 242, 103, 173, 217, 88, 154, 38, 200, 32, 0, 0, 0, 0, 0}, 240},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 7}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 31, 216}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 165, 144, 62}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 87, 1, 83, 104}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 46, 253}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 177, 50, 106, 174}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 75, 125}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 41, 17, 238}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 154, 100}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 101, 168}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 255, 208}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 172, 165, 159, 184}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 210, 221, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 213, 193, 156, 110}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 18, 102}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 253, 145, 224}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 33, 184, 232, 119}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 82, 16}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 158, 19}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 127, 14}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 28}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 233}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 29}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 215, 59}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 116, 218, 232}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 208, 158, 9, 98}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 136, 49, 89}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 131, 48, 46, 157}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 215}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 230, 99, 134}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 177, 164, 225, 159}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 16}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 134, 82, 205}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 2}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 61, 170, 83}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 198}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 99, 79, 220, 156}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 33, 234}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 193, 154, 231}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 63}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 108, 191}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 33}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 196, 59}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 35}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 120, 22}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 132}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 223, 148, 178}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 131, 68}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 222}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 172, 142}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 176}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 9}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 187}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 205, 253}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 24, 91}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 115}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 15, 217, 233}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 33}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 206, 145, 45}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 252, 4, 58}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 55}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 175, 179, 174}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 252}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 134, 107, 196}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 116}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 106, 44}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 79, 62}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 23}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 34}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 163}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 29, 17}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 208, 144, 132}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 158}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 30, 101, 31}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 195}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 254, 6, 133}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 242, 28, 55}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 84}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 105, 61}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 0}, 59},
	{{20, 227, 128, 28, 144, 147, 22, 13, 94, 129, 107, 88, 0, 0, 0, 139}, 59},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 111, 184}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 75, 58, 238, 174}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 34, 143}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 63, 50, 163}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 90, 182, 188, 19}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 227}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 56, 216}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 229, 26, 131}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 12, 28, 167, 249}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 220, 240, 168}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 114}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 17, 79, 186, 192}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 118, 171, 173}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 148, 139, 30}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 242, 239, 164}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 89, 161, 60, 62}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 52, 33}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 100}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 35, 114, 102}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 23, 157, 214, 120}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 152, 124, 216}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 34}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 184, 165}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 225}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 120, 166}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 106, 88, 242, 147}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 91}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 62, 136}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 231, 161, 123}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 221, 12, 244}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 83, 253, 252, 128}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 171, 22, 255}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 255, 49, 221}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 18, 240}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 112, 209, 217}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 209, 64}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 71, 50, 1, 253}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 203}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 123}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 202}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 223}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 32, 181, 5, 11}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 100}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 187, 197, 6, 10}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 255, 42}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 179}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 56, 26, 155, 4}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 215, 179}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 230, 126}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 2, 194, 125}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 59}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 220, 238}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 217, 93, 45, 161}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 80, 33, 51, 84}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 198}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 175, 90}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 80, 255, 174}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 164, 220, 177, 196}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 110, 7, 129}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 114, 22, 114}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 189}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 190}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 248, 118, 30}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 200, 240}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 194}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 97, 157}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 61, 75}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 144, 52}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 85, 75, 81}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 46, 14}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 216, 44, 202, 23}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 19, 235, 49}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 200, 92, 49, 53}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 97, 112, 85, 249}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 69, 82, 237, 156}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 226, 177, 104, 201}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 209, 43, 69, 2}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 144, 126}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 228, 98}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 80, 57}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 0}, 195},
	{{95, 144, 229, 107, 218, 125, 204, 233, 161, 42, 180, 64, 0, 0, 0, 9}, 195},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 193, 145, 246, 45, 142, 150}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 143, 15, 226, 129}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 148}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 127, 18, 42, 231, 49}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 111, 240, 179, 168, 1, 199, 155}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 108, 205, 230}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 63, 242, 220, 89, 65}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 248, 93, 55, 150}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 14, 239, 151, 3, 90, 107, 244}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 41, 79, 80}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 249, 117, 14}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 176, 183, 220, 117, 236, 19}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 248, 188, 106, 219, 212, 96}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 222}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 206, 92, 15, 141, 213}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 148, 92, 126}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 230, 227, 199}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 197, 226, 100, 187}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 249, 40, 227, 244}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 28, 222, 153, 117, 95, 90, 247}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 226, 93, 59, 73, 35, 211}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 250, 219, 28, 88}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 106, 12, 168, 180, 4, 171}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 206, 38, 124, 215}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 55, 106, 194, 5}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 195, 147, 224, 214}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 211, 235, 79, 164}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 227, 214}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 217, 87, 102, 49, 151}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 173, 233, 12}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 39, 86, 226, 160, 187, 105, 28}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 55, 45, 123}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 53, 159, 210}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 97, 78, 240, 235, 208, 89, 25}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 102, 41, 160}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 59, 88, 157, 33, 217, 30}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 228, 31, 220, 148}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 142, 250}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 185, 234, 187, 174, 107}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 171, 20, 84, 139, 77}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 10, 61, 84, 96, 30}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 158, 140, 117, 168, 182, 210, 232}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 172, 147}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 33, 214, 165}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 178}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 141, 226, 105, 108, 38, 9, 107}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 193, 28, 168, 61, 67, 76}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 94, 90}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 174}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 121, 44, 24, 195, 64, 51, 233}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 213, 99, 75}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 2, 29, 218, 186, 87}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 70, 208, 127}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 242, 181, 222, 216, 197, 114}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 197, 172, 123, 186, 228, 111}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 93, 190, 210, 54}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 144, 119, 242, 57, 4}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 164}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 157, 193}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 171, 132, 140}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 143, 36, 239, 93, 174, 208}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 220, 145}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 211, 200, 197, 203, 153}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 152, 211, 45, 14, 203, 137}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 224, 245, 39}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 103, 66, 25, 235}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 156, 253}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 57, 213, 227}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 111, 204, 59}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 253, 94, 105, 53, 106, 253, 14}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 24, 217, 79, 184}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 247, 241, 111}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 161, 178, 131, 182}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 138, 8, 170, 163, 61, 163}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 161, 173, 20, 146}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 107, 60, 28, 195, 70, 93, 149}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 128, 98, 100, 8, 185, 133, 154}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 100, 230, 93, 37, 84}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 250, 105, 184, 111, 156, 191}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 72, 14, 107, 192, 219, 213}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 36, 168, 41}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 249, 75}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 144, 93, 59, 245, 88}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 80, 89}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 138, 23, 234, 53, 196}, 10},
	{{155, 220, 83, 208, 108, 16, 134, 156, 128, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 141, 140}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 128, 175, 138}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 17, 32, 176}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 155}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 39, 106, 227}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 38, 202, 80}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 149}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 214}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 119, 3, 86, 243}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 94, 107}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 38, 179, 191, 227}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 179, 158, 148}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 81}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 35, 186, 214, 169}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 89, 164, 147, 46}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 220, 31}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 213, 63, 240, 247}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 124, 79, 30}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 207, 79, 59, 64}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 176, 109, 242}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 209, 241, 138}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 237, 108, 209, 2}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 149, 58}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 36, 127}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 71, 102}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 223}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 186, 89, 218}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 223, 89, 140, 243}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 64}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 159, 121}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 124, 9, 184, 29}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 92, 243}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 173, 157}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 174, 78}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 71}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 120, 108}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 41, 254, 83}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 63, 177, 135}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 147, 89, 181}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 57}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 94}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 66, 151, 202, 190}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 192, 216, 173}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 95, 180, 133}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 222}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 64, 70, 65}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 183, 59, 70}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 160}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 192, 155, 102, 208}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 168, 56, 13}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 236, 104}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 128, 8, 78, 21}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 34, 155, 120}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 229, 120}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 94, 174, 200}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 43}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 48, 28}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 229, 114}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 72, 45}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 67, 73, 194}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 22, 235, 159}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 84}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 129, 186, 101, 145}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 11, 100}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 231, 148, 147}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 41, 98}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 34, 177}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 175, 220, 252}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 128, 42, 19, 60}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 80, 23}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 243, 76, 99}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 252}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 88, 238}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 0, 0}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 0, 34, 250}, 206},
	{{179, 138, 55, 80, 190, 153, 12, 237, 22, 120, 69, 0, 0, 144, 214, 30}, 206},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 255}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 124, 101, 207, 199}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 12, 233, 85, 154, 204, 13}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 117, 65}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 48, 130, 105, 49}, 61},
	{{0, 0, 0, 114, 140, 201, 116, 122, 158, 70, 136, 193, 156, 81, 229, 185}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 30, 67, 83}, 61},
	{{0, 0, 0, 0, 0, 160, 163, 245, 22, 211, 158, 202, 22, 157, 176, 166}, 61},
	{{0, 0, 0, 0, 252, 108, 68, 173, 199, 166, 43, 163, 228, 0, 53, 166}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 118}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 153, 85, 125, 7}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 62, 55}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 122, 94, 117, 89, 158, 49}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 95, 147, 175, 67, 66, 129, 245, 136, 110}, 61},
	{{0, 0, 0, 0, 0, 0, 244, 28, 242, 27, 235, 91, 81, 115, 3, 147}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 125, 189, 209, 76, 234, 97, 254, 18, 68}, 61},
	{{0, 173, 242, 202, 12, 65, 85, 160, 121, 198, 14, 75, 241, 38, 147, 150}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 61},
	{{0, 0, 0, 0, 0, 2, 80, 215, 165, 150, 99, 153, 246, 67, 124, 7}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 198, 218, 90}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 69, 156, 206, 0, 149, 111, 65, 9}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 171, 211, 26, 215, 21, 48, 130, 16, 155}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 129, 198, 248, 224, 83, 153, 126, 184}, 61},
	{{0, 0, 0, 2, 153, 124, 225, 165, 1, 252, 30, 56, 66, 118, 8, 105}, 61},
	{{0, 0, 0, 0, 0, 0, 49, 108, 154, 125, 4, 167, 103, 206, 129, 90}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 32, 232, 45, 178, 60, 230}, 61},
	{{0, 0, 222, 150, 124, 81, 189, 200, 40, 245, 108, 158, 6, 166, 140, 62}, 61},
	{{0, 0, 0, 246, 78, 85, 157, 19, 84, 179, 76, 113, 39, 221, 62, 199}, 61},
	{{0, 0, 0, 172, 44, 199, 12, 181, 230, 20, 182, 209, 49, 244, 110, 24}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 135}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 89, 11}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 212, 239, 89, 191, 67, 17, 244, 162, 225}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 253, 28, 167, 96, 87}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 200, 203, 23}, 61},
	{{0, 0, 144, 101, 70, 50, 78, 237, 163, 4, 245, 177, 179, 240, 109, 80}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 89, 253, 107, 25, 250}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 112, 4, 79, 178}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 15, 72}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 80, 85, 82}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 131, 225}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 92, 114, 161, 33, 184}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 210, 143, 4, 37, 240, 240, 108, 184, 247}, 61},
	{{0, 0, 0, 0, 98, 126, 50, 222, 88, 49, 11, 185, 106, 2, 47, 146}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 123, 76}, 61},
	{{0, 0, 164, 55, 100, 21, 174, 71, 221, 227, 76, 248, 54, 173, 176, 55}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 117, 214, 31, 27, 105}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 26, 50, 37, 225, 109, 97, 50, 14, 39}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 45}, 61},
	{{0, 0, 0, 0, 0, 0, 185, 9, 90, 109, 115, 215, 89, 13, 128, 52}, 61},
	{{0, 0, 0, 0, 235, 195, 134, 60, 201, 238, 109, 33, 188, 61, 56, 169}, 61},
	{{0, 0, 0, 0, 0, 0, 172, 253, 185, 159, 103, 7, 16, 184, 224, 191}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 126, 173, 54, 33, 107}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 197, 166, 185, 105, 84, 199, 0, 183}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 98, 132, 253, 13, 184, 70, 219, 32, 124}, 61},
	{{0, 0, 218, 117, 125, 83, 16, 134, 174, 192, 210, 195, 187, 225, 221, 182}, 61},
	{{0, 152, 238, 186, 251, 153, 32, 16, 117, 124, 35, 151, 182, 248, 138, 191}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 21, 233, 160, 51}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 215, 238, 113, 23, 232}, 61},
	{{0, 0, 0, 0, 233, 3, 177, 96, 233, 4, 97, 124, 129, 119, 255, 244}, 61},
	{{0, 132, 189, 22, 113, 103, 152, 4, 115, 24, 121, 60, 69, 74, 228, 233}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 164, 244, 102, 82, 9, 152, 12, 124}, 61},
	{{0, 0, 0, 0, 0, 201, 167, 240, 163, 86, 156, 15, 23, 120, 29, 235}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 46, 155, 164}, 61},
	{{0, 215, 30, 37, 154, 255, 210, 76, 22, 176, 107, 52, 35, 88, 212, 192}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 24}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 195, 132, 63, 234, 4, 18, 2, 99}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 125}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 61},
	{{0, 0, 0, 0, 0, 253, 1, 138, 126, 247, 190, 241, 215, 111, 91, 226}, 61},
	{{0, 0, 0, 0, 0, 0, 146, 169, 9, 154, 128, 52, 18, 8, 135, 59}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 27, 57, 195, 146, 56, 167, 92, 162}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 61, 140, 83, 64}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 214, 119}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 209, 51, 192, 178, 241, 12, 193, 141}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 148, 92, 105, 161}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 107, 199, 244, 215, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 70, 231, 188}, 61},
	{{0, 0, 0, 0, 0, 0, 220, 21, 255, 198, 103, 34, 163, 90, 101, 1}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 116, 240, 157, 233}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 64, 182, 33, 221, 33, 42, 93, 244}, 61},
	{{0, 0, 0, 0, 0, 0, 18, 234, 233, 158, 21, 246, 65, 93, 3, 199}, 61},
	{{0, 0, 0, 0, 0, 87, 234, 165, 93, 191, 8, 215, 87, 109, 130, 143}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 112, 1, 246, 50, 10, 115, 62, 99}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 131}, 61},
	{{0, 0, 0, 114, 124, 157, 211, 62, 164, 8, 33, 49, 118, 238, 75, 90}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 102, 47, 223, 155, 32}, 61},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 138}, 225},
	{{3, 119, 148, 0, 0, 0, 199, 254, 193, 211, 90, 213, 182, 208, 232, 5}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 1, 18, 239, 238, 97, 145, 236, 135, 213}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 55, 185}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 47, 2, 77, 88, 150, 159, 169, 245}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 105, 82}, 225},
	{{3, 119, 148, 0, 0, 0, 85, 100, 235, 50, 37, 64, 122, 194, 116, 236}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 228, 225, 42, 242, 94, 147, 225, 180}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 247}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 115, 31, 49, 19, 150, 49, 235}, 225},
	{{3, 119, 148, 0, 0, 0, 141, 70, 42, 196, 19, 12, 120, 190, 199, 22}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 211, 219, 86, 106, 43}, 225},
	{{3, 119, 148, 0, 0, 145, 85, 200, 128, 12, 148, 158, 132, 102, 226, 58}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 84, 154, 250, 8, 101, 150}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 242, 191, 141}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 52, 32, 98}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 49, 148, 4, 144, 192}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 132}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 44, 17, 253, 200, 140, 225, 158, 194}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 63, 45, 210}, 225},
	{{3, 119, 148, 0, 0, 30, 138, 139, 217, 36, 94, 78, 94, 205, 146, 95}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 173, 128, 228, 195, 61, 252, 101, 118}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 203}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 102, 170, 173, 131, 104, 236, 84, 209, 20}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 160, 227, 135}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 124, 128, 174, 165, 142}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 145, 233, 64, 172, 56, 139}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 225},
	{{3, 119, 148, 0, 0, 16, 36, 71, 99, 227, 249, 171, 106, 106, 4, 229}, 225},
	{{3, 119, 148, 0, 128, 111, 4, 127, 12, 139, 220, 118, 9, 87, 185, 199}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 90, 62}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 236, 59, 126, 17, 198, 119, 240}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 165}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 180, 176, 225, 221, 123, 57, 126, 7}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 223}, 225},
	{{3, 119, 148, 0, 0, 0, 200, 196, 208, 182, 89, 219, 146, 99, 117, 243}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 247}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 44, 54, 9, 169, 216, 161, 34}, 225},
	{{3, 119, 148, 0, 0, 170, 65, 154, 62, 226, 156, 152, 102, 57, 71, 115}, 225},
	{{3, 119, 148, 0, 0, 0, 4, 14, 26, 28, 241, 1, 208, 121, 200, 44}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 209, 118, 203, 47, 104, 182}, 225},
	{{3, 119, 148, 7, 13, 129, 59, 125, 182, 158, 204, 56, 178, 7, 55, 39}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 37}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 223, 217, 102, 129, 99, 62}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 223, 247, 151, 122, 201, 176, 165, 47}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 138, 126, 69}, 225},
	{{3, 119, 148, 0, 0, 35, 13, 208, 34, 41, 61, 98, 32, 21, 186, 108}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75}, 225},
	{{3, 119, 148, 0, 0, 253, 235, 251, 244, 248, 188, 130, 249, 88, 220, 86}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 141, 123, 120, 77, 236, 47, 222, 15}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 135, 87, 168, 23, 56, 67, 236}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 51, 114, 46, 128, 6, 38, 86, 90}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 168, 231, 76, 215, 65, 200, 224, 182}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 92, 107, 110, 99, 178}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{3, 119, 148, 0, 0, 0, 78, 180, 108, 38, 234, 94, 31, 237, 49, 39}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 199, 230, 153, 113, 189, 57, 230, 131, 251}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 226, 222, 196, 44, 236}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 57}, 225},
	{{3, 119, 148, 0, 0, 0, 62, 172, 255, 215, 52, 97, 179, 37, 198, 193}, 225},
	{{3, 119, 148, 0, 40, 157, 56, 32, 132, 110, 188, 42, 177, 72, 211, 231}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 95, 158, 167}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 142, 116, 183, 197, 40, 214, 232, 102, 218}, 225},
	{{3, 119, 148, 0, 0, 0, 174, 205, 38, 248, 44, 221, 236, 66, 199, 210}, 225},
	{{3, 119, 148, 0, 0, 0, 210, 227, 205, 231, 252, 205, 203, 168, 164, 155}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 102, 141, 54}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 9}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 73, 0, 30, 130, 93, 193}, 225},
	{{3, 119, 148, 0, 0, 11, 238, 41, 65, 114, 24, 246, 30, 123, 33, 244}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 227, 123}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 144, 141, 27, 154, 201, 11, 116, 214}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 197, 217, 41, 240, 173, 10, 92, 54, 228}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 241, 166, 225, 185, 120, 168, 49}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 145, 41, 7, 55, 213, 108}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 118, 176, 246, 219, 133, 209}, 225},
	{{3, 119, 148, 0, 0, 0, 213, 220, 199, 48, 112, 200, 35, 59, 186, 118}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 88, 240, 110}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 7, 251, 218, 150, 63, 195, 137, 235, 59}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 15, 207, 209, 36, 30, 58}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 28, 118}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 218, 24, 191}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 180, 3, 196, 41, 132}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 233, 61}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 130, 137}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 126, 173, 52, 93, 83, 243, 27}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 253, 56, 40, 109, 160, 34, 142, 66, 116}, 225},
	{{3, 119, 148, 0, 0, 157, 100, 0, 251, 199, 245, 28, 195, 15, 162, 97}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 237, 15, 89, 205, 180, 150, 210, 63, 251}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 115, 15, 192, 226, 131, 205}, 225},
	{{3, 119, 148, 0, 63, 85, 38, 96, 37, 43, 84, 193, 61, 243, 156, 12}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 63}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 219, 132, 197}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 209, 220, 231, 214, 154, 226, 254, 1}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{3, 119, 148, 0, 0, 0, 0, 187, 154, 242, 162, 162, 42, 227, 78, 85}, 225},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 62, 232, 131, 169, 74, 195, 133}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 230, 191, 189, 10}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 249}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 118, 33, 214, 255, 28, 59, 142, 134, 55}, 223},
	{{13, 192, 0, 166, 156, 18, 168, 82, 121, 83, 162, 98, 50, 195, 164, 233}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 100, 97, 34, 178, 4, 62}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 230, 252, 221, 220, 127, 134, 28, 148, 71}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 201, 233, 192, 182, 213, 87, 200, 252, 44}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 223},
	{{13, 192, 0, 0, 131, 157, 185, 172, 221, 103, 140, 243, 95, 223, 49, 40}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 142, 201, 178, 165, 209, 174, 200, 201}, 223},
	{{13, 192, 225, 220, 6, 119, 61, 185, 75, 43, 137, 31, 184, 179, 127, 102}, 223},
	{{13, 192, 0, 0, 0, 114, 241, 254, 106, 173, 176, 218, 183, 207, 133, 244}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 62, 222, 184}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 40, 150, 88, 26, 205, 1}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 66}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 190, 6, 57}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 5, 38}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 70}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 18}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 141, 59, 152, 184, 211, 229}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 76, 177, 56, 211, 112, 107, 57, 119}, 223},
	{{13, 192, 0, 0, 0, 194, 136, 47, 191, 179, 40, 187, 14, 246, 223, 145}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 190, 252, 219}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 94, 67, 76, 146, 213, 249, 39, 28}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 159, 200, 245, 61, 17, 139, 128}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 182, 199, 214, 185, 222, 149, 237, 122}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 10, 203, 61, 72}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 243, 144, 226, 69, 195, 122}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 223},
	{{13, 192, 0, 116, 234, 3, 250, 37, 96, 13, 181, 64, 40, 88, 76, 217}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 232, 121, 17, 203, 102, 141, 36}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 18, 227, 218}, 223},
	{{13, 192, 122, 13, 92, 228, 4, 105, 133, 46, 142, 255, 199, 220, 146, 22}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 182, 121, 92, 227, 228, 175, 204, 230, 55}, 223},
	{{13, 192, 0, 0, 0, 179, 114, 92, 25, 88, 34, 23, 14, 17, 110, 2}, 223},
	{{13, 192, 0, 28, 237, 22, 207, 168, 92, 142, 230, 94, 125, 222, 71, 235}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 68, 255, 159, 240, 249, 77, 249}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 145, 16, 107}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 231, 146, 90, 100, 86, 161}, 223},
	{{13, 192, 0, 0, 0, 0, 68, 9, 203, 179, 138, 137, 183, 61, 45, 71}, 223},
	{{13, 192, 250, 51, 52, 19, 168, 188, 165, 33, 63, 135, 39, 40, 53, 88}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 175, 80, 201, 90, 143, 233}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 112}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 243, 98, 136, 208, 179, 57, 116}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 53, 164, 81}, 223},
	{{13, 192, 0, 0, 47, 106, 85, 81, 164, 111, 9, 40, 18, 237, 74, 35}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 14, 0, 150, 92}, 223},
	{{13, 192, 0, 180, 1, 162, 138, 193, 177, 80, 215, 111, 223, 41, 155, 91}, 223},
	{{13, 192, 0, 81, 73, 91, 55, 184, 135, 29, 236, 62, 145, 34, 29, 54}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 56, 218, 8, 119, 119, 166, 28}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 134}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 154, 8, 157, 190, 212, 15, 30, 109, 254}, 223},
	{{13, 192, 0, 0, 0, 0, 198, 216, 124, 131, 214, 43, 91, 224, 164, 38}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 75, 163, 186, 164}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 175, 103, 11, 209, 254, 230, 169, 120}, 223},
	{{13, 192, 20, 162, 59, 202, 252, 62, 140, 124, 72, 82, 18, 87, 213, 33}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 111, 186}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 88, 207}, 223},
	{{13, 192, 0, 0, 0, 0, 16, 12, 80, 219, 202, 30, 83, 107, 78, 52}, 223},
	{{13, 192, 0, 0, 0, 0, 116, 177, 254, 85, 214, 27, 162, 68, 55, 2}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 127, 65, 63, 26, 142, 71, 29, 174, 189}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 222, 102, 22, 1, 141, 202, 200, 198, 193}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 141, 169, 252, 103, 140, 119}, 223},
	{{13, 192, 0, 0, 166, 225, 200, 177, 233, 232, 182, 91, 150, 124, 216, 174}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 175, 115, 245, 123, 121, 72, 58}, 223},
	{{13, 192, 0, 0, 0, 0, 142, 182, 153, 184, 195, 40, 210, 202, 115, 80}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 141, 170, 6, 223}, 223},
	{{13, 192, 36, 74, 7, 182, 249, 33, 116, 80, 76, 55, 101, 158, 96, 199}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 230, 171, 255}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 221, 67, 140, 217, 148, 4, 38}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 217, 122, 27, 151, 23, 193, 255, 69}, 223},
	{{13, 192, 0, 0, 0, 181, 178, 232, 165, 66, 111, 106, 243, 9, 121, 2}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 176, 230, 237}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 214, 209, 229, 113, 49, 203, 128, 57, 141}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 152, 14, 56, 156}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 235}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 63, 218, 59}, 223},
	{{13, 192, 0, 0, 0, 0, 109, 141, 142, 111, 146, 242, 9, 110, 94, 24}, 223},
	{{13, 192, 0, 219, 81, 226, 63, 72, 51, 226, 84, 61, 119, 182, 94, 238}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 223}, 223},
	{{13, 192, 131, 59, 192, 52, 174, 178, 61, 218, 175, 230, 158, 35, 101, 230}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 223},
	{{13, 192, 0, 0, 221, 20, 237, 226, 50, 188, 85, 11, 53, 248, 72, 179}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 192, 220, 207}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 82, 110, 247}, 223},
	{{13, 192, 14, 94, 252, 120, 55, 204, 67, 207, 41, 154, 235, 136, 178, 58}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 149, 139, 147, 136}, 223},
	{{13, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 185, 63, 92, 251}, 223},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 118, 0, 32}, 29},
	{{117, 28, 0, 0, 0, 0, 172, 176, 141, 63, 80, 223, 58, 31, 6, 76}, 29},
	{{117, 28, 0, 226, 225, 147, 85, 47, 216, 21, 225, 144, 216, 150, 105, 205}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 220, 158, 97}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 100, 244, 242, 227, 186, 247, 158, 205, 106}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 126, 161, 155, 45, 215, 91, 126, 235}, 29},
	{{117, 28, 0, 0, 166, 239, 123, 30, 230, 227, 221, 80, 166, 132, 45, 119}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 19, 26, 172, 189, 15, 149, 153, 172}, 29},
	{{117, 28, 0, 226, 74, 122, 16, 87, 254, 244, 2, 172, 122, 3, 28, 238}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 3, 45, 197, 114, 198, 224}, 29},
	{{117, 28, 0, 0, 0, 241, 154, 122, 37, 115, 214, 250, 122, 241, 171, 22}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{117, 28, 0, 0, 0, 6, 10, 171, 92, 57, 191, 14, 25, 103, 151, 113}, 29},
	{{117, 28, 0, 0, 0, 141, 11, 218, 57, 44, 197, 229, 205, 182, 172, 35}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 13, 99, 224, 131, 236, 29}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 29}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 28, 201, 50, 223, 129, 99}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 81}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 208, 110, 148, 147, 37, 94, 18, 220}, 29},
	{{117, 28, 0, 137, 156, 225, 254, 31, 94, 24, 5, 97, 15, 150, 29, 92}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 97, 29, 19, 147, 26, 124, 211, 206, 137}, 29},
	{{117, 28, 0, 0, 0, 0, 125, 129, 0, 208, 91, 41, 179, 82, 187, 174}, 29},
	{{117, 28, 0, 0, 0, 11, 92, 159, 89, 68, 74, 153, 44, 67, 152, 144}, 29},
	{{117, 28, 0, 240, 223, 114, 154, 221, 132, 150, 84, 38, 233, 114, 185, 76}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 79, 220, 118, 204, 67, 236}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 88, 185, 33, 19}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 62, 45}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 177, 70}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 244, 20, 145, 147, 155, 52, 248, 222, 28}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 114, 171, 123, 170}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 103, 57, 150, 22}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{117, 28, 0, 0, 48, 96, 89, 48, 12, 217, 133, 57, 164, 133, 87, 255}, 29},
	{{117, 28, 0, 0, 0, 0, 219, 233, 81, 140, 148, 132, 240, 237, 209, 187}, 29},
	{{117, 28, 0, 0, 139, 199, 16, 24, 223, 88, 145, 145, 159, 10, 24, 109}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 203, 224, 31, 106, 191, 79}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 225}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 52, 58, 103, 21, 164, 112}, 29},
	{{117, 28, 0, 0, 0, 0, 240, 202, 15, 182, 107, 90, 146, 247, 174, 112}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 220}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 212, 214, 149, 50, 219, 51, 219, 167, 177}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 247, 200, 190, 10, 101, 1, 192, 217}, 29},
	{{117, 28, 0, 212, 141, 226, 76, 137, 136, 143, 32, 178, 38, 138, 56, 72}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 50, 93, 190, 52, 55, 182}, 29},
	{{117, 28, 0, 0, 127, 104, 194, 118, 44, 78, 141, 78, 251, 96, 244, 56}, 29},
	{{117, 28, 0, 0, 0, 0, 229, 191, 78, 235, 13, 86, 26, 116, 144, 168}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 221, 191, 9, 85, 196, 210, 193, 104, 228}, 29},
	{{117, 28, 0, 121, 13, 222, 154, 7, 26, 91, 228, 55, 54, 153, 235, 217}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 57, 59, 35}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 69, 42}, 29},
	{{117, 28, 0, 0, 0, 45, 178, 23, 124, 177, 61, 57, 58, 51, 149, 160}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 189, 41}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 252}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 251, 129, 128}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 130, 9, 246, 12, 190, 209, 99, 110, 131}, 29},
	{{117, 28, 0, 0, 0, 0, 115, 89, 163, 164, 62, 124, 202, 215, 228, 70}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 232, 8, 202, 190, 53, 175, 71}, 29},
	{{117, 28, 0, 0, 0, 38, 193, 155, 208, 116, 230, 152, 89, 230, 124, 170}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 130, 83, 182, 170, 10, 125}, 29},
	{{117, 28, 0, 154, 33, 199, 52, 110, 2, 253, 100, 227, 250, 36, 156, 252}, 29},
	{{117, 28, 0, 57, 200, 189, 251, 171, 83, 203, 186, 237, 121, 129, 26, 231}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 29},
	{{117, 28, 139, 182, 45, 81, 249, 53, 63, 94, 113, 173, 164, 33, 243, 59}, 29},
	{{117, 28, 0, 0, 0, 70, 129, 180, 217, 154, 226, 45, 36, 129, 104, 126}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 133, 27, 118, 172}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 167, 219, 108, 175, 165, 89, 171, 79}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 207}, 29},
	{{117, 28, 0, 0, 0, 134, 202, 248, 125, 199, 235, 45, 125, 93, 247, 10}, 29},
	{{117, 28, 0, 135, 163, 6, 106, 92, 204, 59, 185, 14, 205, 247, 95, 190}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 230}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 178, 130, 130, 81, 109, 9, 1, 186}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 252, 25, 159, 44}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 210, 80, 215}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 202, 148, 16}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 138}, 29},
	{{117, 28, 0, 201, 53, 133, 99, 143, 11, 248, 60, 194, 32, 93, 90, 207}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 141, 135, 134, 105, 97, 77}, 29},
	{{117, 28, 0, 39, 166, 70, 101, 10, 164, 253, 97, 214, 245, 227, 196, 255}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 75, 206, 143, 98, 227, 210}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 121, 29}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 226, 241}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 141, 222, 162, 156, 139, 18}, 29},
	{{117, 28, 0, 0, 0, 243, 78, 237, 187, 248, 205, 62, 131, 177, 152, 62}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 10, 175, 30, 10, 183, 182, 50, 228, 43}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 33}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 226, 226, 45, 157}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 63, 20, 208, 217, 64, 218, 147, 56}, 29},
	{{117, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 229}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 254}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 74, 195}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 5, 133}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 20}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 135, 78}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 100, 64}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 209, 186}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 151, 239}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 13, 4}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 55, 145}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 133, 150, 37}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 132}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 36, 47}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 92}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 130, 149}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 133}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 239, 248}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 51}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 63, 207}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 62}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 120}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 153}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 192, 93}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 30, 16}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 3, 32}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 4, 246}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 251, 134}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 194}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 243}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 5, 147}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 57}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 106}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 214}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 59, 77}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 20}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 109}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 146, 124}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 150}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 222, 160}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 215}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 165}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 157}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 115}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 13}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 171, 181}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 89}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 99}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 182, 119}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 95}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 25, 10}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 174}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 216}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 168}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 197, 3, 14}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 216}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 214, 95}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 171}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 88, 243}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 133}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 148}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 77}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 135, 150}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 96}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 22}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 200, 184}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 135, 147}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 216}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{164, 19, 195, 47, 136, 190, 156, 255, 30, 74, 143, 134, 162, 0, 0, 0}, 166},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 148, 201, 220, 172, 50}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 101}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 34, 210, 43}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 178, 48, 69, 17}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 55}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 35, 81, 149, 101, 116}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 48, 198}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 42}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 38, 174, 146}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 211}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 162, 56, 48, 77}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 82, 211, 209, 46}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 219, 33, 167, 195}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 180, 68, 67, 61, 199}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 249}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 83, 136}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 164, 124, 179, 245}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 10}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 74, 135, 235, 25}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 129, 87, 49, 228, 43}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 184, 193}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 77, 55, 32, 82}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 78}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 145}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 190, 171, 210, 211, 148}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 41}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 249, 58, 141}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 203, 194, 221, 209}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 32}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 174, 160, 139}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 222, 42, 121, 236}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 113, 148, 1}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 228, 43, 94, 182, 223}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 175}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 110, 100, 113, 138, 24}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 232}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 153, 38, 131, 42}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 203, 8}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 19, 88, 139}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 59, 13, 93, 139, 87}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 36}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 86, 208}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 164}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 84, 134}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 148, 171, 95, 248, 65}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 187, 83, 62, 140}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 248, 14, 35}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 158, 59, 194, 189, 98}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 175, 237}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 183, 88, 156}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 210}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 120}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 117, 112}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 189, 207, 231, 179}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 178}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 55, 77}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 111, 203, 56, 209}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 144, 44, 180, 155, 254}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 8, 72}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 8}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 254, 181, 211}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 97, 105, 238}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 115}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 165, 46, 220, 165, 156}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 104}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 168, 247, 139, 0, 133}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 164, 37, 71, 77}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 68, 219, 96}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 49}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 137, 37, 2, 132, 247}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 103, 30, 212, 179}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 150, 139, 115, 145, 9}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 113, 120}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 106, 39}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 22, 75, 51}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 239, 141, 97}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 92, 53, 20, 219, 190}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 127, 145}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 0, 0, 0}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 117, 71, 152, 253, 254}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 45, 67, 46, 232, 145}, 178},
	{{40, 235, 94, 135, 135, 230, 71, 33, 64, 233, 0, 0, 0, 60, 157, 76}, 178},
	{{222, 151, 166, 97, 129, 250, 140, 148, 251, 245, 45, 46, 248, 51, 3, 112}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 233, 92, 212}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 156, 185, 233, 37, 147}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 125, 222, 163, 61, 208}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 75, 112, 34, 236, 151, 228, 134, 77}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 142, 106, 237, 41, 57, 71, 139}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 26, 151}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 29, 77, 67, 87, 18, 168, 188, 162}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 145, 179, 141, 196, 238}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 105, 33, 250, 192, 61, 204, 88}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 14, 54, 33, 35, 176, 17}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 236, 52, 28}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 137, 67, 24, 190, 1, 26, 44, 83}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 250, 29, 74, 46, 204, 4, 218}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 116, 218, 100, 153, 23, 89}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 116, 119, 226, 55}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 60, 49, 124, 76}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 91, 99, 206, 132, 20, 221}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 9, 249, 29, 149}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 38, 179, 184, 196, 145, 193, 137, 185, 2}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 245, 193, 18, 1, 152}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 29, 73, 96, 117, 172, 135}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 87, 190, 64, 239, 184, 227, 98, 42}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 217}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 196, 89, 171, 180, 129}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 35, 179, 33, 192, 199}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 180, 210, 91, 250, 227}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 224, 29}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 240, 82, 142, 213, 187}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 108, 16, 254, 0, 171, 52, 197, 172}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 33, 49, 185, 27, 83, 255, 236, 138, 214}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 151, 230, 165, 123, 3}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 182, 127}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 225, 117}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 210, 153, 66, 39, 121, 42, 72, 182}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 98, 113, 232, 9, 42}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 196, 15, 15, 193, 75, 237, 135}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 198, 103}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 178, 47, 159, 24, 25}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 134, 8, 106, 93, 169}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 95, 216, 155, 119, 48, 3, 171, 208}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 75, 122, 16, 234, 113, 102, 204, 170}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 108, 145, 3, 116, 25, 170, 52, 214}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 71, 77}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 52, 155, 208, 31, 1, 57, 186, 44}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 232, 89, 71, 184}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 233, 251, 212, 95, 134, 112, 27, 218}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 51, 195, 150, 90, 139, 175}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 8, 57, 108, 22, 113}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 33, 172}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 20, 250, 38, 120}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 112, 14, 197}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 137, 131, 149}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 224, 215, 212}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 78, 168, 150, 176, 200}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 111, 137, 83, 51, 21, 35}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 199, 215, 36, 68, 117, 205, 39, 216}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 105, 8, 46, 150, 100}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 235, 255}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 51, 36, 89}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 91, 238}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 238, 150, 9, 189, 151, 52, 118}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 227, 130, 174, 42, 147, 185, 9, 127}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 160, 182, 7}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 87, 60, 104, 119, 75}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 102, 1, 58, 173, 34, 22, 156}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 159, 204, 235, 202}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 125, 234, 148, 121, 11, 16}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 109, 117, 101, 93, 149, 189, 83, 86}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 2, 162, 132}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 64, 74, 232, 79, 97, 249, 3}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 218, 38, 155}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 42, 214, 12, 83, 249}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 239, 188, 8, 143, 243, 65}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 0, 252, 147}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 54, 167, 147, 46, 209, 12, 122}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 67, 35, 59, 17, 166}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 255, 205, 118, 202, 179, 160, 173, 110}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 0, 247, 23, 195}, 38},
	{{222, 151, 166, 97, 129, 250, 140, 0, 0, 0, 0, 0, 87, 188, 176, 199}, 38},
	{{174, 128, 0, 51, 120, 228, 150, 109, 139, 177, 234, 42, 141, 145, 109, 71}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 113, 85}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 120}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 109}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 173, 22}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 41, 190, 4, 102, 94, 84, 254}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 11, 114, 169, 153}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 37, 52, 23, 209, 234, 176, 113}, 141},
	{{174, 128, 0, 0, 0, 232, 229, 109, 227, 112, 113, 67, 48, 184, 60, 184}, 141},
	{{174, 128, 0, 11, 147, 238, 44, 195, 236, 233, 238, 124, 66, 191, 58, 25}, 141},
	{{174, 128, 0, 0, 0, 0, 238, 20, 19, 249, 5, 199, 81, 138, 75, 37}, 141},
	{{174, 128, 0, 174, 53, 159, 72, 182, 222, 198, 137, 84, 1, 67, 188, 56}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 185, 22}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 53, 13, 55, 116, 13, 121, 55, 114}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 67}, 141},
	{{174, 128, 0, 255, 138, 80, 241, 67, 79, 112, 129, 40, 196, 90, 125, 10}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{174, 128, 0, 0, 47, 143, 145, 178, 17, 179, 156, 69, 247, 112, 198, 10}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 37, 54, 23, 21, 59, 251, 165}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 182, 137, 19, 157, 203, 212, 224}, 141},
	{{174, 128, 0, 0, 0, 0, 85, 245, 69, 135, 181, 225, 150, 185, 220, 153}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 247}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 211, 129, 196, 247}, 141},
	{{174, 128, 0, 0, 238, 174, 143, 187, 117, 17, 156, 154, 28, 248, 0, 154}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 13, 59, 197, 91}, 141},
	{{174, 128, 0, 0, 27, 98, 71, 208, 213, 236, 42, 17, 172, 88, 160, 180}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 100, 237, 3, 105, 5, 177, 78, 182}, 141},
	{{174, 128, 0, 0, 231, 223, 66, 48, 246, 74, 49, 145, 253, 190, 61, 4}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 87, 196, 165, 74}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 30, 64, 94}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 84, 114, 236, 36}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{174, 128, 0, 0, 0, 0, 44, 21, 200, 124, 81, 10, 23, 216, 120, 217}, 141},
	{{174, 128, 13, 90, 189, 214, 38, 163, 242, 97, 180, 194, 113, 24, 202, 12}, 141},
	{{174, 128, 0, 0, 239, 95, 244, 234, 174, 51, 240, 174, 130, 1, 163, 159}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 129, 56, 212, 27, 108, 244, 119}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 249}, 141},
	{{174, 128, 0, 212, 234, 203, 144, 4, 201, 201, 227, 200, 22, 84, 173, 228}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 237, 13, 144, 135, 10, 5}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 177, 222, 156, 200, 12, 178, 199, 248, 6}, 141},
	{{174, 128, 0, 0, 138, 249, 128, 64, 242, 1, 202, 37, 4, 248, 38, 131}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 205, 33, 71, 255}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{174, 128, 3, 85, 218, 4, 109, 222, 124, 130, 130, 205, 5, 215, 30, 165}, 141},
	{{174, 128, 0, 231, 191, 57, 147, 56, 237, 245, 21, 199, 231, 85, 34, 128}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 141},
	{{174, 128, 0, 16, 226, 213, 90, 159, 19, 171, 165, 212, 160, 219, 168, 171}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 92, 153, 191, 85}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 8, 241, 232, 162}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 72, 239}, 141},
	{{174, 128, 0, 0, 0, 0, 20, 118, 128, 87, 224, 7, 222, 27, 122, 171}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 233, 94}, 141},
	{{174, 128, 0, 0, 2, 66, 187, 124, 180, 86, 231, 111, 29, 177, 27, 110}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 177, 90, 144, 137, 169, 101, 235}, 141},
	{{174, 128, 0, 0, 0, 97, 41, 137, 88, 240, 115, 250, 240, 233, 149, 195}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 64, 131}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 215, 181, 17}, 141},
	{{174, 128, 0, 0, 0, 213, 104, 175, 66, 140, 213, 140, 36, 61, 220, 134}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 83, 190}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 123, 213, 172, 92, 191, 219, 28, 132, 162}, 141},
	{{174, 128, 0, 0, 0, 0, 216, 211, 49, 125, 70, 70, 82, 143, 252, 60}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 184, 236, 204, 248, 58, 5, 42, 187}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 167}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 113}, 141},
	{{174, 128, 206, 4, 173, 178, 29, 59, 211, 49, 221, 179, 48, 251, 84, 191}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 165, 81, 255, 222, 61, 246, 14}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 63, 139, 154, 188, 239, 60, 59, 114}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 44}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 141},
	{{174, 128, 0, 0, 0, 134, 67, 91, 123, 25, 45, 66, 97, 75, 124, 252}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 94, 147, 161}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 74, 81, 160, 172, 114, 34, 153}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 197, 181, 166, 28, 64, 164, 26}, 141},
	{{174, 128, 0, 241, 1, 242, 208, 184, 75, 243, 34, 251, 150, 193, 80, 118}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 141},
	{{174, 128, 0, 0, 236, 130, 8, 221, 196, 254, 98, 70, 180, 223, 30, 28}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{174, 128, 0, 0, 0, 43, 11, 100, 249, 199, 163, 145, 94, 150, 173, 221}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 188, 50, 208, 174}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 51, 43, 148, 189, 138, 178, 222, 199, 124}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 67, 112, 69, 70, 113, 214}, 141},
	{{174, 128, 0, 0, 40, 238, 217, 255, 236, 201, 5, 144, 141, 231, 84, 35}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 69, 179, 113, 250, 212, 227, 8, 95, 77}, 141},
	{{174, 128, 0, 0, 0, 27, 212, 241, 198, 188, 44, 65, 108, 49, 74, 112}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 73, 61, 191, 184, 185, 52, 156, 59, 136}, 141},
	{{174, 128, 0, 0, 0, 0, 86, 118, 121, 9, 98, 51, 190, 103, 117, 214}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 62, 190, 47, 116, 10, 157, 97, 41, 187}, 141},
	{{174, 128, 0, 0, 0, 0, 174, 2, 37, 19, 123, 46, 93, 78, 149, 242}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 40, 58, 222, 135, 36, 206, 100}, 141},
	{{174, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 141},
	{{174, 128, 0, 166, 42, 140, 193, 255, 203, 78, 23, 158, 77, 95, 28, 106}, 141},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 90}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 199}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 37}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 174}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 221}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 22}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 217}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 163}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 33}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 64}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 179}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 200}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 27}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 150}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 229}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 9}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 48}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 58}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 52}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 7}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 119}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 185}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 19}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 245}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 177}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 201}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 32}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 249}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 43}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 247}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 38}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 251}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 194}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 0}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 181}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 92}, 230},
	{{6, 189, 100, 150, 250, 13, 46, 98, 228, 139, 50, 52, 52, 196, 128, 160}, 230},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 165}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 185}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 115, 57, 180}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 65, 223, 192}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 99, 186, 89}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 242}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 167}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 109, 189}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 174, 9}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 53, 108}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 108, 79}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 140, 53}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 208, 182, 52}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 161, 147}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 87, 156}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 184}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 62}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 196, 205, 197}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 227, 79}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 6, 99}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 51, 128}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 198}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 13}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 159, 107}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 126, 226, 81}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 114, 61}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 48}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 73, 212}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 223, 184}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 159, 165}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 84}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 209}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 186, 120}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 112, 153, 94}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 253, 175}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 117}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 116, 191}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 187, 103}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 174}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 49, 153}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 216}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 35, 214, 65}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 191}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 21, 86}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 192}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 57, 149, 16}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 204}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 177}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 127, 111}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 69, 190}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 57}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 48, 246}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 20}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 53, 75}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 126, 50, 97}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 245}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 43, 161}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 97, 190, 28}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 154}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 131}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 176, 67}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 118}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 98}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 55, 76}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 49, 188}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 59}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 64}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 108}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 79}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 54}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 15, 179}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 125, 248, 159}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 107, 201}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 97, 49}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 230, 43}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 116, 245, 246}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 232, 212}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 53}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 83}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 46, 185}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 38}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 0}, 124},
	{{75, 252, 89, 205, 37, 52, 106, 79, 188, 120, 54, 119, 160, 0, 0, 105}, 124},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 34}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 118}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 181}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 68}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 19}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 219}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 60}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 43}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 68}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 120}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 60}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 189}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 29}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 221}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 182}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{38, 18, 146, 6, 63, 64, 231, 10, 152, 199, 5, 143, 147, 4, 252, 0}, 54},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 143}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 198, 123, 111, 127}, 162},
	{{111, 119, 169, 51, 0, 210, 248, 45, 11, 25, 193, 165, 203, 125, 253, 231}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 98, 114, 147, 245, 116, 104, 104, 30}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 125, 221, 10, 190, 238, 205}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 63, 180, 153, 208, 93, 173, 7, 184}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 11, 46, 249, 28}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 173, 216, 212, 57, 200, 131, 77, 137, 97}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 203}, 162},
	{{111, 119, 169, 51, 0, 0, 154, 75, 31, 114, 145, 237, 138, 3, 67, 91}, 162},
	{{111, 119, 169, 51, 0, 0, 218, 54, 201, 99, 170, 165, 155, 249, 197, 31}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 60, 128, 173, 126, 133, 173}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 185, 63}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 125}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 83, 29, 212, 9, 160, 220, 191, 207, 124}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 208, 221, 240, 164, 104, 222, 106, 81}, 162},
	{{111, 119, 169, 51, 0, 0, 45, 200, 65, 55, 253, 170, 63, 95, 54, 120}, 162},
	{{111, 119, 169, 51, 0, 0, 81, 149, 36, 1, 63, 218, 177, 209, 82, 72}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 180}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 1, 73}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 56, 251, 225, 166, 52}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 3, 9, 190, 54, 127, 8, 239, 143, 28}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 57, 33}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 35, 188, 174, 70, 185}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 24, 92, 35, 62, 39, 198, 205}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 171, 249, 20, 249}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 77, 236, 32, 147}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 60, 37, 95, 2, 249, 232}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 16}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 69, 209, 70, 15}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 90}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 164}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 90, 80, 199, 107, 79, 160, 154}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 197}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 236}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 226, 174, 211, 148}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 89, 132, 94, 2, 4, 128, 232, 252}, 162},
	{{111, 119, 169, 51, 0, 0, 165, 98, 179, 108, 51, 239, 54, 135, 132, 33}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 20, 117, 232, 236, 42, 28}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 67, 23, 24, 209, 223}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 67, 122, 88, 208, 52, 238, 67}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 65}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 105, 216, 87, 178, 160, 255, 15}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 95, 56, 71, 109, 48, 249, 236, 32}, 162},
	{{111, 119, 169, 51, 0, 160, 81, 239, 50, 155, 67, 23, 77, 200, 255, 253}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 165, 7, 179, 145, 201, 241, 229, 227}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 250, 18, 52, 59, 174, 61, 48, 180, 252}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 70, 203, 200, 250, 232, 162, 29}, 162},
	{{111, 119, 169, 51, 0, 0, 65, 234, 167, 120, 111, 68, 19, 139, 157, 41}, 162},
	{{111, 119, 169, 51, 0, 0, 236, 156, 108, 80, 117, 201, 128, 211, 157, 79}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 238, 7, 174, 139, 82, 31}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 26, 255, 250, 116, 102, 252, 61, 183}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 17, 188, 206, 167, 98, 45, 88, 22}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 68, 167}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 43, 10, 17, 219}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 52, 217}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 1, 32, 106, 7, 44, 252, 187}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 49, 182, 240, 201, 176}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 246, 249, 247, 139, 250}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 23, 68, 232, 127}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 125, 163, 108, 221, 108}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 207, 62, 4, 152, 237, 38}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 255, 196}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 151, 248, 55, 97}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 74, 26, 44, 144}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 204, 27, 43, 197, 237, 45, 24, 66}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 137, 190, 232, 176}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182}, 162},
	{{111, 119, 169, 51, 0, 190, 201, 34, 210, 26, 187, 141, 45, 97, 63, 70}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 112, 76, 230, 46, 183}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 63}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 126, 140, 222, 10, 186, 239, 53}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 240, 33, 115, 78, 237, 136}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 191, 205}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 138, 29, 153, 241, 106, 189, 149}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 25, 88, 12, 201, 68, 203, 201, 88, 59}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 202, 159, 188, 244, 15, 23, 216, 14, 16}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 165, 143, 166, 53, 210, 114, 149}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 76, 81, 58, 47, 173, 10, 132}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 238, 162, 30, 187, 73, 122}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 117, 209, 142, 1, 189, 82, 92, 15}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 198}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 176, 177, 75, 240, 161, 167}, 162},
	{{111, 119, 169, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21}, 162},
	{{105, 128, 0, 0, 0, 0, 0, 0, 208, 201, 251, 235, 207, 97, 80, 135}, 32},
	{{105, 128, 0, 0, 0, 0, 205, 170, 53, 155, 8, 82, 241, 85, 124, 53}, 32},
	{{105, 128, 0, 0, 0, 0, 44, 59, 233, 156, 246, 79, 154, 31, 67, 29}, 32},
	{{105, 128, 0, 0, 0, 0, 231, 11, 171, 243, 133, 246, 69, 51, 72, 176}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 13, 83, 214, 214}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 141, 199}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 154, 203, 239, 8, 104, 26}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 232, 116}, 32},
	{{105, 128, 0, 0, 0, 95, 170, 16, 20, 26, 74, 118, 167, 5, 71, 35}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 32},
	{{105, 128, 190, 197, 26, 56, 35, 133, 146, 201, 81, 205, 61, 200, 195, 33}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 83, 203, 71, 86}, 32},
	{{105, 128, 0, 198, 21, 118, 208, 180, 1, 52, 167, 69, 59, 172, 205, 158}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 242, 72, 168, 46, 242, 206, 145, 193, 78}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 3, 69, 36, 28}, 32},
	{{105, 128, 0, 0, 0, 59, 185, 202, 124, 51, 2, 129, 145, 137, 122, 230}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 27}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30}, 32},
	{{105, 128, 0, 0, 0, 229, 189, 154, 191, 46, 86, 239, 213, 48, 215, 93}, 32},
	{{105, 128, 0, 0, 0, 47, 115, 65, 67, 163, 203, 112, 147, 88, 93, 37}, 32},
	{{105, 128, 0, 0, 22, 134, 140, 13, 128, 0, 153, 39, 26, 234, 126, 201}, 32},
	{{105, 128, 0, 0, 0, 48, 102, 210, 233, 136, 106, 53, 237, 199, 59, 221}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 197, 82, 52, 143, 181, 152, 146, 193}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 201}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 66, 16}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 216, 130}, 32},
	{{105, 128, 0, 0, 0, 0, 216, 70, 244, 57, 135, 66, 233, 132, 252, 191}, 32},
	{{105, 128, 0, 0, 77, 123, 222, 133, 193, 76, 75, 24, 99, 234, 222, 223}, 32},
	{{105, 128, 0, 0, 0, 0, 37, 234, 145, 229, 167, 163, 232, 124, 109, 238}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 135, 23, 198, 152, 69, 69, 134, 189, 8}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 173, 242, 89, 222}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 70, 118, 144, 227}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32},
	{{105, 128, 0, 0, 50, 215, 35, 48, 208, 238, 167, 219, 66, 67, 122, 209}, 32},
	{{105, 128, 77, 37, 9, 165, 227, 181, 191, 171, 120, 94, 153, 168, 215, 9}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 34, 111}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 201, 2}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32},
	{{105, 128, 0, 58, 68, 229, 211, 171, 32, 147, 209, 26, 224, 17, 175, 78}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 110, 24, 44}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 234}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 31, 214, 119, 93, 227, 247}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 59, 178, 84, 7, 79, 210}, 32},
	{{105, 128, 0, 0, 0, 0, 59, 32, 43, 189, 176, 177, 50, 113, 86, 53}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 199}, 32},
	{{105, 128, 0, 0, 156, 64, 113, 119, 93, 164, 206, 62, 201, 62, 115, 131}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 135, 164, 46, 81, 124, 36, 174, 227}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 200, 133, 110, 187, 0, 37, 2, 77, 151}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 142, 173, 35, 113, 169, 159, 155, 21, 31}, 32},
	{{105, 128, 0, 183, 127, 244, 245, 36, 246, 142, 34, 123, 95, 194, 77, 130}, 32},
	{{105, 128, 0, 0, 0, 0, 139, 62, 144, 241, 239, 189, 213, 156, 181, 53}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 11, 64, 114, 11, 230, 156, 166, 1, 71}, 32},
	{{105, 128, 0, 0, 0, 0, 57, 112, 121, 25, 137, 29, 126, 139, 79, 31}, 32},
	{{105, 128, 104, 93, 130, 41, 4, 189, 227, 227, 172, 75, 182, 34, 33, 197}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 58, 137, 144, 213, 69, 90, 251, 204}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 60, 166, 181, 34}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 111}, 32},
	{{105, 128, 0, 137, 86, 150, 3, 240, 128, 34, 8, 209, 168, 88, 69, 254}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 234, 61, 36, 186, 61, 141, 61}, 32},
	{{105, 128, 0, 0, 197, 134, 231, 147, 209, 130, 198, 212, 126, 222, 93, 37}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 192, 89, 41, 84, 220, 110}, 32},
	{{105, 128, 0, 0, 0, 109, 249, 241, 93, 203, 110, 109, 148, 94, 29, 131}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 12, 34, 105, 81, 185, 60, 184}, 32},
	{{105, 128, 0, 0, 0, 60, 114, 70, 50, 103, 63, 48, 173, 102, 91, 214}, 32},
	{{105, 128, 56, 172, 246, 39, 67, 225, 208, 216, 242, 134, 246, 207, 59, 250}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 30, 114, 193, 171, 120, 39, 86, 161}, 32},
	{{105, 128, 0, 8, 25, 253, 3, 67, 193, 142, 75, 38, 255, 170, 9, 175}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 49}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 114}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 142, 148, 208, 120, 168, 148, 19}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 204, 133, 227}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 223}, 32},
	{{105, 128, 0, 54, 157, 7, 54, 139, 151, 93, 211, 190, 85, 85, 216, 127}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 39, 122, 138, 180, 149, 75, 34, 149, 75}, 32},
	{{105, 128, 0, 0, 126, 154, 168, 177, 108, 129, 154, 128, 47, 159, 137, 22}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 37, 64, 57, 72, 143, 245, 140}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 87, 247, 14, 63, 249, 40, 116, 155}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 14, 128, 18, 212, 50, 97, 146, 231, 193}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 223, 7, 27, 22, 34, 222, 93, 144, 196}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 29, 95, 219, 110}, 32},
	{{105, 128, 0, 0, 0, 29, 139, 7, 149, 215, 14, 103, 40, 45, 198, 7}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 32},
	{{105, 128, 0, 0, 0, 0, 147, 67, 205, 70, 30, 144, 182, 140, 149, 88}, 32},
	{{105, 128, 0, 157, 94, 153, 128, 168, 142, 238, 189, 123, 138, 246, 67, 57}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 82, 241, 43}, 32},
	{{105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 138, 97, 241, 26, 175, 118}, 32},
	{{105, 128, 0, 0, 0, 0, 191, 127, 77, 56, 21, 173, 199, 249, 165, 253}, 32},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 99}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 15}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 130, 125}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 44, 30}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 76, 127}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 41, 61}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 179, 124}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 2, 245}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 155}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 3}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 91}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 214}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 252, 53}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 221, 23}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 201}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 48, 240}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 53}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 48}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 97}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 49, 233}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 74, 109, 252}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 89, 162}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 30, 209, 196}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 10, 200}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 165}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 39}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 175, 50}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 201, 147}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 207, 37}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 79, 155, 50}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 137}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 35, 234}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 173}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 60, 218}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 66}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 30, 168}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 10, 172}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 91}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 241, 34}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 70, 141}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 19}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 93, 241, 184}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 60}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 45}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 235, 59, 150}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 139, 205}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 245, 200}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 32}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 188}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 1, 110, 180}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 74}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 140}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 222, 50}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 186}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 78, 210, 52}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 196, 23}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 243}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 229}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 214, 2, 21}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 194}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 108, 191}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 83, 122}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 118, 125, 94}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 116}, 237},
	{{143, 57, 57, 101, 98, 182, 74, 227, 205, 143, 253, 237, 8, 0, 0, 0}, 237},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 215},
	{{30, 0, 0, 0, 0, 220, 210, 91, 47, 5, 120, 229, 241, 133, 56, 81}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 217}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 228, 99, 252, 105, 158, 113, 190, 74}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 174, 144}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 72, 114, 26}, 215},
	{{30, 0, 0, 0, 0, 0, 127, 11, 244, 90, 79, 211, 108, 240, 175, 50}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 110, 165, 117, 99, 124}, 215},
	{{30, 0, 0, 0, 0, 83, 225, 148, 51, 173, 196, 64, 112, 86, 231, 226}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 215},
	{{30, 0, 0, 184, 70, 181, 86, 85, 108, 73, 91, 41, 189, 96, 187, 181}, 215},
	{{30, 0, 0, 0, 0, 231, 123, 157, 140, 153, 14, 18, 188, 194, 110, 132}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 41, 145, 43, 227, 56, 54, 17}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 29, 254, 207, 47, 236}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 255, 222}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 221, 56, 231, 88, 244, 99, 88}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 225, 232, 23, 190, 145, 114, 12, 17}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 211, 216, 125, 172, 207}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 100, 252, 215, 239, 126, 70, 23, 8, 199}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 194, 54, 250, 108, 131, 125, 100}, 215},
	{{30, 0, 29, 170, 205, 156, 183, 2, 89, 33, 169, 224, 206, 218, 20, 5}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 167, 150, 156, 79, 153, 58, 166}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 115, 155, 221, 227}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 241, 134, 33, 20, 180}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 235, 133, 240}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 6, 80, 61, 5, 157}, 215},
	{{30, 0, 3, 97, 43, 84, 169, 53, 250, 230, 225, 213, 204, 20, 247, 130}, 215},
	{{30, 0, 189, 222, 157, 97, 221, 120, 168, 28, 5, 238, 185, 112, 195, 12}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 39, 0, 233, 202, 240}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 218, 239, 91, 116, 125}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 116, 253, 99, 133, 196, 195, 27}, 215},
	{{30, 0, 0, 0, 0, 0, 157, 53, 222, 56, 151, 91, 130, 44, 167, 131}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 0, 146, 39, 175}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 44, 128, 202, 142, 108, 158, 243}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 162, 241, 37, 227, 73}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 143, 12, 228, 246}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 176, 237, 115, 213, 54, 83, 127, 67}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 92, 212, 204, 234}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 166, 65, 40, 42, 189, 211, 82}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 88, 110, 154, 177, 32, 109, 109}, 215},
	{{30, 0, 0, 71, 68, 197, 247, 26, 197, 200, 36, 135, 35, 3, 200, 25}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 59, 28}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 141, 244, 38, 156, 21, 122, 188}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 131, 133}, 215},
	{{30, 0, 0, 0, 0, 240, 199, 175, 73, 47, 123, 27, 175, 230, 72, 11}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 194, 95, 66, 118, 11, 54, 185, 151}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 33, 245, 185}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 215},
	{{30, 0, 0, 0, 0, 0, 99, 126, 40, 0, 58, 167, 130, 109, 155, 101}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 23, 20, 30, 85, 30}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 63, 141, 92, 203}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 66}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 235, 149, 56, 198, 191, 10, 224, 110, 148}, 215},
	{{30, 0, 0, 0, 0, 250, 216, 62, 55, 184, 95, 122, 59, 95, 154, 104}, 215},
	{{30, 0, 0, 84, 107, 151, 201, 175, 89, 8, 54, 227, 126, 114, 224, 217}, 215},
	{{30, 0, 244, 58, 249, 116, 169, 76, 119, 45, 20, 87, 235, 51, 85, 112}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 187, 168, 56, 141, 56, 228, 198}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 215, 219, 127}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 30}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 137, 33, 235, 219}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 142, 151, 184, 94, 68, 110, 206, 36, 155}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 27, 42, 205}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 176, 4, 79, 126, 103, 177, 252, 220, 130}, 215},
	{{30, 0, 0, 0, 0, 0, 105, 166, 208, 208, 7, 200, 240, 190, 236, 55}, 215},
	{{30, 0, 165, 18, 51, 187, 46, 213, 107, 126, 73, 210, 242, 114, 209, 65}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 49, 170, 62, 213, 171, 84, 253, 39}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 84, 70}, 215},
	{{30, 0, 0, 0, 0, 0, 23, 200, 8, 170, 41, 124, 199, 166, 40, 57}, 215},
	{{30, 0, 119, 162, 158, 204, 84, 171, 129, 125, 66, 243, 90, 135, 60, 136}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 41, 41, 219, 195, 152, 60, 110}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 144, 241}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 175}, 215},
	{{30, 0, 0, 0, 115, 118, 72, 57, 123, 159, 171, 54, 184, 188, 129, 69}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 19, 16, 201, 203, 12, 16, 207, 253}, 215},
	{{30, 0, 26, 124, 188, 57, 23, 156, 167, 216, 55, 58, 157, 29, 129, 7}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 48, 150, 186, 129, 65, 3, 172, 29, 85}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 244, 148, 242}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 174, 47, 144, 150}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 206, 182, 41, 201, 97, 103, 5, 60}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 184, 14, 111, 165, 165, 226, 178, 32, 165}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 9}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 206, 186, 223, 177}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 19, 248, 108, 196}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 203, 64, 87, 115, 58}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 220, 119, 155, 159, 234, 132, 229, 117, 91}, 215},
	{{30, 0, 12, 172, 90, 5, 208, 83, 32, 92, 70, 167, 145, 111, 242, 203}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 112, 27, 160}, 215},
	{{30, 0, 18, 98, 16, 14, 64, 74, 164, 205, 161, 113, 182, 233, 160, 158}, 215},
	{{30, 0, 0, 0, 0, 0, 0, 5, 145, 129, 105, 156, 71, 42, 107, 51}, 215},
	{{14, 232, 48, 0, 0, 0, 0, 0, 190, 37, 182, 11, 226, 146, 107, 147}, 138},
	{{14, 232, 48, 0, 28, 229, 52, 164, 77, 121, 90, 172, 25, 126, 124, 136}, 138},
	{{14, 232, 48, 0, 0, 148, 179, 122, 94, 159, 207, 19, 198, 193, 2, 190}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 199}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 115, 202, 89}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 98, 240, 54, 34, 46}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{14, 232, 48, 0, 0, 221, 87, 5, 226, 102, 60, 2, 58, 17, 214, 39}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 37, 206, 189, 94, 93, 246, 188}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{14, 232, 48, 0, 0, 250, 215, 18, 250, 191, 19, 193, 157, 198, 182, 79}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 138},
	{{14, 232, 48, 0, 0, 164, 189, 193, 49, 237, 208, 141, 120, 17, 49, 221}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 213, 162, 41}, 138},
	{{14, 232, 48, 0, 0, 0, 63, 251, 9, 118, 107, 129, 47, 195, 113, 82}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 84, 178, 159, 46, 76, 168, 221, 8, 55}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 212, 140, 109, 56, 57, 143, 146, 30, 66}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 132, 222, 108, 108, 19, 34, 124, 8, 208}, 138},
	{{14, 232, 48, 0, 0, 42, 156, 181, 2, 82, 3, 136, 211, 197, 152, 142}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 226, 65, 131, 182, 216, 145, 52, 82, 230}, 138},
	{{14, 232, 48, 55, 245, 170, 21, 72, 67, 216, 77, 163, 216, 138, 179, 83}, 138},
	{{14, 232, 48, 0, 211, 159, 18, 147, 212, 213, 91, 7, 126, 136, 134, 77}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 214, 105}, 138},
	{{14, 232, 48, 0, 0, 0, 9, 127, 223, 74, 249, 237, 239, 56, 13, 88}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 111, 40}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 206, 129, 36, 188, 91, 134, 96, 117, 215}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 42, 233, 249, 161, 227}, 138},
	{{14, 232, 48, 0, 0, 0, 137, 6, 110, 128, 14, 98, 188, 229, 207, 48}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 107, 76, 93, 254, 34}, 138},
	{{14, 232, 48, 0, 154, 92, 22, 16, 46, 246, 22, 6, 111, 111, 236, 6}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 170}, 138},
	{{14, 232, 48, 0, 0, 218, 151, 63, 210, 103, 20, 101, 118, 206, 233, 92}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 186, 67, 41, 236, 73, 85, 147, 8}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 68, 109, 205, 157, 239, 189}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 159, 123, 12, 164, 163, 103, 201, 110, 86}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 138},
	{{14, 232, 48, 0, 91, 15, 61, 250, 224, 95, 98, 201, 124, 64, 120, 148}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 183, 87, 237, 109, 197, 73, 187}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 82, 37, 171}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 96, 213, 118, 194, 44, 17, 20, 12}, 138},
	{{14, 232, 48, 229, 122, 50, 88, 179, 74, 57, 204, 135, 226, 165, 10, 52}, 138},
	{{14, 232, 48, 0, 60, 20, 164, 157, 131, 250, 22, 55, 115, 254, 186, 221}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 85}, 138},
	{{14, 232, 48, 0, 0, 172, 148, 124, 151, 201, 150, 40, 209, 218, 72, 96}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 247, 182, 165, 150, 127, 5, 85, 224, 108}, 138},
	{{14, 232, 48, 0, 0, 0, 50, 195, 32, 57, 67, 75, 152, 79, 61, 37}, 138},
	{{14, 232, 48, 0, 0, 0, 177, 182, 142, 175, 3, 128, 190, 157, 191, 204}, 138},
	{{14, 232, 48, 0, 0, 0, 60, 108, 232, 33, 49, 58, 137, 29, 214, 141}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 88, 236, 234, 224, 166}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 230, 46, 158, 78, 121, 75, 233, 90, 23}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 190, 74, 199}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 176, 157, 9, 207, 41, 30, 25}, 138},
	{{14, 232, 48, 0, 209, 150, 139, 11, 20, 33, 164, 63, 41, 203, 142, 243}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 58, 33, 234}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 34, 230, 23, 249, 233, 212, 51, 63, 222}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 124}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 113, 123, 97, 131, 206}, 138},
	{{14, 232, 48, 0, 216, 77, 110, 172, 148, 5, 81, 11, 172, 120, 37, 81}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 139, 194, 59, 71, 157, 83, 161, 253, 227}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 79, 87, 170, 138, 241, 13, 68}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 136, 107, 237, 151, 103, 166}, 138},
	{{14, 232, 48, 0, 0, 0, 111, 156, 127, 115, 132, 254, 143, 121, 45, 10}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 9, 154}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 238, 14}, 138},
	{{14, 232, 48, 0, 0, 0, 128, 131, 191, 62, 233, 136, 205, 149, 194, 157}, 138},
	{{14, 232, 48, 0, 0, 0, 30, 240, 158, 172, 216, 163, 55, 209, 120, 74}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 228}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 90, 250, 159, 151, 86, 235, 105, 149, 30}, 138},
	{{14, 232, 48, 0, 0, 0, 105, 191, 109, 117, 143, 213, 161, 111, 156, 132}, 138},
	{{14, 232, 48, 0, 41, 121, 80, 153, 194, 63, 236, 115, 196, 226, 22, 29}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 57}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 128, 8, 184, 127, 64, 216, 151}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 247}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 48, 98, 35, 151, 42, 255}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 236, 199, 37, 232, 141, 55, 25, 221}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 93, 51, 204, 48, 251}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 60, 138, 119, 10, 91, 244}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 129, 3, 35, 19, 255, 32}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 21, 1, 53, 56, 100, 77, 114, 164}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 44, 7, 15, 67, 68, 115, 19, 2}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 122}, 138},
	{{14, 232, 48, 0, 0, 157, 138, 158, 71, 149, 252, 110, 203, 233, 2, 26}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 165, 177, 248, 101, 156, 25, 51}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 147, 219, 47, 214, 126, 68, 245, 69}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 125, 36, 208, 240, 147, 253, 28}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 37, 122}, 138},
	{{14, 232, 48, 0, 158, 219, 110, 14, 151, 26, 124, 166, 61, 94, 233, 86}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 62, 37, 202, 248, 33, 67, 251, 221}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 184, 217, 104, 240, 6, 136}, 138},
	{{14, 232, 48, 0, 0, 0, 157, 139, 134, 215, 117, 163, 129, 251, 158, 155}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 192, 81, 138, 96, 84, 188}, 138},
	{{14, 232, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10}, 138},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 202}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 248}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 110}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 40}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 113}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 3}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 33}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 73}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 242}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 101}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 219}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 9}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 40}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 247}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 47}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 28}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 34}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 109}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 142}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 36}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{14, 53, 67, 216, 229, 155, 149, 139, 31, 253, 184, 126, 133, 108, 40, 0}, 73},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 127}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 13}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 106, 157, 151}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 92, 54}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 100, 70, 186, 36}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 236}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 84, 123, 80}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 247}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 165, 221}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 204, 118}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 179, 233, 182}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 112}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 125, 253}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 70}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 237, 72, 234}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 119, 253}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 113, 176}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 14, 23}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 136, 19, 225, 202}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 170, 232, 148, 60}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 110}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 101, 76, 72}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 236, 91, 50}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 165}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 62, 98, 194}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 114, 205, 225}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 121, 115}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 204, 209, 254, 110}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 72, 103}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 193, 252}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 3, 45, 95, 26}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 8, 80}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 95, 29}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 82, 211}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 28, 197}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 179, 94, 230}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 253}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 75, 106, 230}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 218, 180, 85, 209}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 208}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 139, 19}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 220, 216, 133}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 130}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 130}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 104, 45}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 200, 168}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 120, 86, 133, 74}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 119, 215}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 79, 151, 133}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 40}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 198, 108}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 227, 197}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 53}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 205, 232}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 89}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 140, 9}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 181, 243}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 114, 245, 50, 112}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 224, 44}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 89, 112}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 19, 201, 202, 203}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 192, 53, 70}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 254}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 22}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 84}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 82, 214, 88}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 238, 229, 160}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 21, 169, 215}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 202}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 222, 208, 9, 178}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 218, 133, 29}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 37, 169, 251}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 110}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 0}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 0, 187}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 247, 108}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 208, 33}, 43},
	{{22, 58, 40, 143, 188, 132, 239, 14, 181, 252, 81, 192, 0, 0, 73, 196}, 43},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 107}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 220}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 146}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 14}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 29}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 61}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 193}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 175}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 125}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 118}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 184}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 221}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 172}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 142}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 4}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 165}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 53}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 255}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 104}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 207}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 126}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 161}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 213}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 203}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 202}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 102}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 39}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 119}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 148}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 213}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 100}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 244}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 10}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 204}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 99}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 119}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 167}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 153}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 147}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 16}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 188}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 98}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 14}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 75}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 74}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 51}, 88},
	{{11, 222, 185, 243, 248, 150, 79, 230, 214, 213, 3, 23, 193, 196, 0, 0}, 88},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 142}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 6}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 184}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 255}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 244}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 169}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 79}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{14, 226, 198, 117, 84, 93, 22, 96, 77, 241, 173, 68, 68, 204, 72, 0}, 91},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 11, 99}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 34}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 213, 183, 205, 43}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 161, 75, 11}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 1}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 224, 193, 120, 60}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 200}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 112, 76, 235}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 171, 182, 155, 97, 2, 127}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 117, 119, 186, 125}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 154, 43}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 119, 163}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 67, 211, 210}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 215, 199, 223, 179, 116}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 38, 41, 198, 231, 112, 0}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 31, 58}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 200, 62, 80, 21, 235}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 176, 8, 211, 75, 191, 88}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 197, 90, 173, 110, 238}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 120, 92}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 185, 20, 214}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 35}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 109, 66, 2, 5, 67}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 152, 66}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 166, 240, 88}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 10, 93, 84, 183, 155, 129, 38}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 171, 217, 69, 254, 48, 20}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 10, 102, 225, 39}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 166, 91, 202}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 30, 252, 36, 121}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 51, 186, 133, 251, 124}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 172}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 202, 168, 154, 100, 66, 108}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 146}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 23, 112, 127}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 13, 109, 120}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 235, 145}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 229}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 192, 153, 6}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 9, 126, 141, 45, 111, 115}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 60, 62, 32, 42}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 200, 231, 14}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 158, 45, 17, 115, 88, 223}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 252}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 161, 54, 13, 238}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 228, 189, 232, 141, 133}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 97, 179}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 127, 137, 132, 64, 198}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 9, 111, 65, 133, 37, 30}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 165, 70, 15, 2, 167, 215}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 249, 226, 195, 13, 137, 48}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 144, 160, 38, 252, 43, 53}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 197, 215}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 211}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 188, 180, 230, 59}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 137, 247, 116, 41}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 61, 24, 134}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 18, 11, 113, 206, 14}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 133, 242, 220, 115, 121}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 69, 58, 37, 26}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 189, 80, 26, 170}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 197, 56, 22, 35, 113}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 145, 239, 94}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 177, 216, 92}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 215}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 31, 175, 61}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 157, 208, 46, 197, 234, 3}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 23, 176}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 215}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 235}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 128, 57, 44, 210}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 51, 25, 188}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 238, 215, 241, 213}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 116, 145, 29, 133, 55, 79, 223}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 66, 49}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 68, 38, 161, 109, 235, 214, 8}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 32}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 199, 166, 251, 30, 41, 33}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 208, 134, 141, 103, 156}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 22, 218}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 23, 236, 188, 12, 37}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 162, 132, 20}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 68, 171, 140, 183, 65, 83, 2}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 125}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 195}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 0, 0, 42}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 0, 0, 178, 137, 115}, 140},
	{{15, 103, 247, 219, 150, 142, 92, 50, 144, 0, 0, 237, 221, 245, 178, 213}, 140},
	{{0, 213, 77, 244, 64, 0, 0, 0, 79, 241, 103, 108, 137, 252, 89, 17}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 130, 169, 156, 110, 74, 218, 191}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 184, 3, 89, 206, 198, 108, 141, 73}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 26, 25, 96, 255, 25, 67, 193}, 65},
	{{0, 213, 77, 244, 64, 232, 55, 134, 59, 108, 161, 78, 104, 234, 99, 199}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 139, 201, 227, 18, 38, 225, 204, 68, 132}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 95, 173, 177, 237, 26, 106, 187}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 160, 243, 119, 135, 143}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 63, 55, 50, 239, 87, 208}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 144, 149, 165}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 108, 38, 55, 134, 137, 38, 194, 216}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 223, 61, 252, 18, 150, 252, 235}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 206, 69, 89, 44, 105}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 118, 171, 43, 153, 13, 112, 125}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 95, 136, 28, 192}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 29, 43, 142}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 245, 217, 247, 36, 240}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 48}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 48, 63, 127, 30, 76, 184, 196, 199}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 149, 240, 180, 188, 60, 130, 22, 221}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 72, 146, 0, 123, 158, 206, 3, 181, 157}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 174, 115, 79}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 46, 103, 64, 77, 242, 182}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 187, 55, 19, 233, 245, 247}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 82, 238, 158, 0, 168, 178, 67, 132, 165}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 227, 187, 146, 166, 142, 99, 250, 3, 66}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 170, 146, 168, 55, 134}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 216, 66, 96, 144, 19, 52}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 146, 128, 238, 203, 62, 220, 23}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 63, 83, 226, 249, 234, 84, 221, 229}, 65},
	{{0, 213, 77, 244, 64, 0, 213, 227, 254, 82, 78, 19, 228, 119, 57, 142}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 65},
	{{0, 213, 77, 244, 64, 0, 35, 249, 145, 158, 118, 231, 38, 221, 112, 147}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 254, 50, 99, 190, 109, 218}, 65},
	{{0, 213, 77, 244, 64, 0, 101, 233, 125, 207, 47, 244, 133, 220, 48, 238}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 116, 64, 101, 40}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 66, 247, 89, 8, 135, 99}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 124}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 149, 172, 191, 72, 128, 127}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 107, 233, 23}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 82, 254, 162}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 238, 103, 206, 49}, 65},
	{{0, 213, 77, 244, 64, 0, 218, 181, 157, 100, 31, 51, 115, 47, 40, 51}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 69, 117, 42, 3, 19, 178}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 100, 86, 111, 25, 184, 208, 218}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 33, 170, 155, 93, 34, 14, 107, 34, 39}, 65},
	{{0, 213, 77, 244, 64, 0, 29, 126, 254, 30, 128, 59, 179, 62, 99, 156}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 123, 204, 42, 234, 249}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 109, 255, 71, 106, 29, 134, 237, 157, 166}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 65},
	{{0, 213, 77, 244, 64, 0, 124, 198, 137, 163, 24, 156, 169, 215, 220, 35}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 11, 79, 127, 12, 136, 152, 87}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 73, 9, 204, 126, 171, 193, 81, 5}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 19, 65, 157, 234, 27, 98, 158}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 85, 52, 94, 182, 186, 113, 51, 71}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 182, 80, 40, 166, 126, 254}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 242, 72, 211, 151, 200, 139, 31, 42, 181}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 154}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 8, 237, 64, 35, 170, 117}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 203, 138, 145, 16, 195, 127, 222}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 20, 64, 204, 235, 31, 250, 142, 77, 206}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 188}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 80, 240, 92, 84, 95, 233, 20, 127, 45}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 175, 185, 167, 103}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 20, 249, 244, 176, 7, 250, 59}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 96, 230, 56, 50, 236, 15, 49, 96}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 62, 103, 1, 53, 135, 79, 243, 2}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 11, 101, 68}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180}, 65},
	{{0, 213, 77, 244, 64, 0, 86, 229, 59, 122, 191, 31, 30, 92, 5, 96}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 219, 18, 112, 197, 181}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 166, 85, 170, 41, 1, 224, 175, 46}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 203, 11, 0, 10}, 65},
	{{0, 213, 77, 244, 64, 0, 211, 12, 153, 166, 186, 63, 77, 237, 254, 255}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 28, 54, 155}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 5, 50, 118, 190, 199, 238, 77, 26, 199}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 108, 191, 157, 255, 53, 167}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 81}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 249, 171, 74, 124, 42}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 221, 123, 122, 213}, 65},
	{{0, 213, 77, 244, 64, 0, 143, 133, 200, 141, 91, 50, 95, 10, 244, 205}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 65},
	{{0, 213, 77, 244, 64, 0, 0, 0, 58, 91, 223, 213, 187, 2, 177, 16}, 65},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{178, 174, 174, 239, 72, 181, 36, 217, 40, 169, 12, 104, 149, 157, 125, 128}, 201},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 61, 76, 188}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 61, 29, 190}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 184, 179, 97, 208, 185}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 40, 26, 7, 219, 28, 103}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 143}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 47, 16, 176, 202, 188, 250}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 95, 133, 17, 60}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 209, 152, 9, 175, 193}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 7, 10, 23, 22, 202}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 202}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 195, 157}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 8, 252, 59, 222, 26, 129}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 104, 71, 55, 189}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 22, 236}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 126, 254, 160}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 186, 210, 224}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 242, 20, 226}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 240, 89}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 208, 152}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 23, 120}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 226, 111}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 192, 58, 150}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 194}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 207, 118, 116, 224}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 117, 96}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 37}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 136, 155, 241, 212}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 64, 172, 130, 75, 139}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 115, 185, 173, 212, 160}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 19, 126, 208}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 165, 225, 30, 191, 192}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 52}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 106, 65, 192, 240, 194}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 86, 23, 221, 120}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 11, 107, 238, 63}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 147, 25, 164, 172, 193, 118}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 72}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 83}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 74, 41, 130, 54}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 104, 21, 218, 134, 143, 74}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 255, 77}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 29, 219, 78}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 232, 238, 85, 108}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 125}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 120}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 30, 1, 232, 3, 237}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 82}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 127, 152}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 251, 223, 61, 208, 226, 36}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 175, 49, 141, 27, 19, 65}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 81, 151, 250, 12, 37, 154}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 111, 244, 192, 237, 45, 54}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 125, 212, 189, 82, 14}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 251, 179, 30}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 109, 99, 192, 25}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 85, 112, 168, 163, 10}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 221, 48, 193, 154}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 62, 83, 66, 217, 74, 111}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 66, 199, 32}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 9}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 191, 219, 88, 231}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 106, 33}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 2, 18, 171}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 224, 152, 104, 199, 3}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 111, 159}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 182, 187}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 99, 96, 191}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 160, 203, 206, 93, 136}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 18, 32, 1, 125, 72, 11}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 202, 145, 57}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 197}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 125, 131}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 194, 79, 21}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 54, 89, 193, 100, 5}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 39, 132, 117}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 74, 176, 100, 200, 30}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 62, 193}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 61, 66}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 129, 126, 187, 164, 97, 161}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 154, 220, 220, 53, 89}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 0, 0, 175}, 69},
	{{118, 53, 55, 17, 97, 227, 243, 176, 2, 0, 0, 0, 0, 94, 169, 23}, 69},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 23, 169, 64, 126, 26, 130, 155}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 56, 154, 210, 230, 168, 19, 161, 50}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 16, 49, 33, 118, 20, 17, 104, 232}, 170},
	{{21, 253, 4, 47, 0, 0, 168, 66, 201, 122, 154, 216, 190, 97, 167, 228}, 170},
	{{21, 253, 4, 47, 0, 0, 165, 78, 199, 127, 199, 51, 232, 7, 158, 143}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 4, 35, 180, 13, 83, 164, 155}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 92, 64, 228, 25}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 125, 40, 23, 112, 57}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 123, 39}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 29, 78, 32, 49, 63, 201}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 76, 15, 102, 112}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 60, 245, 224, 172}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{21, 253, 4, 47, 0, 139, 75, 81, 233, 45, 49, 236, 172, 93, 37, 131}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 133, 130, 51, 121, 214, 211, 109, 41}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 232, 35, 211, 101, 190, 8, 185, 250, 146}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 65, 19, 148, 152, 69}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 184, 17, 206, 228, 221}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 143, 171, 122, 188, 223, 75}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 150, 38}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 52, 132, 156, 43, 50, 117, 32, 2}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 229, 81, 213, 227, 124, 24, 249, 170, 81}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 88, 61, 239, 192, 253, 199, 65}, 170},
	{{21, 253, 4, 47, 0, 0, 146, 250, 212, 11, 50, 1, 249, 37, 77, 157}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 16, 2, 106, 147}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 92, 223, 193, 159, 183, 224, 57, 75, 172}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 69, 10, 62, 206, 205, 138, 67}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 2, 212, 50, 83, 7, 65, 216, 149, 21}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 103, 243, 80, 94, 142}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 171, 189, 169, 187, 209}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 55, 175, 140, 178}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 170},
	{{21, 253, 4, 47, 0, 0, 76, 17, 41, 186, 2, 140, 29, 21, 83, 245}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 101, 103, 91, 108, 201, 69, 99, 107, 133}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 217, 157, 248, 13, 87}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 190, 210, 186, 147, 34, 44}, 170},
	{{21, 253, 4, 47, 0, 137, 255, 193, 200, 253, 156, 121, 163, 116, 48, 199}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 63}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 66, 114, 45, 22}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 149, 53, 8, 47}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 105, 211, 151, 184, 14, 201, 29, 141, 12}, 170},
	{{21, 253, 4, 47, 0, 89, 170, 0, 170, 143, 87, 177, 66, 240, 225, 87}, 170},
	{{21, 253, 4, 47, 0, 0, 6, 105, 30, 118, 172, 12, 147, 102, 156, 24}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 124, 118, 13, 43, 42, 134, 246, 148, 246}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 183, 8, 97, 236, 142}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 148, 6, 7, 209, 21}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 77, 66, 204, 209, 142, 1, 34, 110, 157}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 172, 157, 212, 39, 192}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 188, 178, 23, 75, 194, 139}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 32, 160, 62, 45}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 161, 64, 36, 113, 242}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 226, 147, 20, 118}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 93, 231, 93, 203, 224, 76}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 114}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{21, 253, 4, 47, 0, 238, 93, 93, 144, 230, 153, 237, 24, 110, 14, 0}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 12, 195, 161, 229}, 170},
	{{21, 253, 4, 47, 0, 70, 2, 250, 158, 184, 233, 230, 149, 72, 211, 38}, 170},
	{{21, 253, 4, 47, 0, 22, 104, 183, 32, 229, 232, 232, 37, 3, 249, 183}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 26, 31, 214, 17, 141, 102}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 59, 17, 89, 135, 141, 147, 38, 23, 18}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 188, 78, 154, 91, 62, 94, 192, 230, 163}, 170},
	{{21, 253, 4, 47, 0, 3, 252, 224, 238, 45, 250, 101, 111, 244, 147, 135}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 237, 54, 9, 228, 249, 191, 163, 118, 77}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 160, 219, 198, 174, 44, 234, 16, 134, 109}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 182, 111, 94, 233, 97, 78, 248, 242, 97}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 151, 59}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 69, 104}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 99, 166, 118, 49, 69, 243}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 9}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 26, 38, 123, 213, 160, 165, 218}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 242}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 188, 56}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 23}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 155, 185, 217, 181, 50, 154, 169, 35}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 70, 170, 208, 252, 239}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 105}, 170},
	{{21, 253, 4, 47, 0, 78, 60, 160, 117, 146, 191, 244, 2, 84, 109, 36}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 133, 7, 132, 217, 42, 125, 57, 47}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 137, 3, 35, 51, 133}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 75, 10, 210, 16, 229, 39, 103}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 22, 227, 86, 51}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 216, 174, 33, 97, 114, 96, 152}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 80, 80, 68, 2, 95, 137, 229, 205, 193}, 170},
	{{21, 253, 4, 47, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 50}, 170},
	{{21, 253, 4, 47, 0, 0, 212, 138, 198, 36, 126, 122, 63, 85, 163, 118}, 170},
	{{5, 249, 186, 133, 68, 0, 0, 0, 230, 56, 109, 216, 113, 133, 196, 94}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 135}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 39, 88, 132}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 57, 70, 207}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 213, 175, 35, 203, 223}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 76, 50, 23, 86, 245, 194, 234, 63}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 85, 125, 208, 180, 107, 6, 208, 63}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 36, 230, 8, 244, 79, 47}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 195, 89, 197, 106}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 99, 144, 4, 122}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 1, 9, 134, 174, 113, 197, 178, 73}, 192},
	{{5, 249, 186, 133, 68, 0, 145, 165, 39, 153, 70, 84, 164, 156, 229, 224}, 192},
	{{5, 249, 186, 133, 68, 0, 145, 118, 0, 65, 198, 140, 203, 243, 105, 44}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 127, 143, 206}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 99, 97, 232}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 5, 241, 11, 87, 85, 170}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 116, 73, 64, 106, 175, 167}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 205, 64, 73, 247, 72}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 195, 6, 29, 146, 62, 234, 76, 147}, 192},
	{{5, 249, 186, 133, 68, 0, 151, 106, 205, 37, 110, 215, 253, 248, 21, 113}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 247, 114, 127, 235, 146, 181, 81}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 162, 51, 72, 213, 107, 60, 24, 244}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 179, 251, 26, 248}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 132, 116, 94, 219, 237}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 187, 107, 62}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 79, 210, 142, 169, 22, 222, 103, 8, 58}, 192},
	{{5, 249, 186, 133, 68, 0, 226, 171, 156, 51, 71, 73, 195, 201, 50, 201}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 27, 150, 133, 16, 51}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 88, 144, 156, 112, 46}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 24, 78, 143, 227, 132}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 7, 147, 229, 8, 177, 95, 242, 167, 57}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 177, 225, 139, 5, 43, 16, 190}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 134, 205, 117, 190}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 71, 216, 20, 16, 207, 234, 132}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 134, 196, 209, 53}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 42, 159, 119, 14, 248, 255, 2}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 248, 106, 149, 172}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 75, 229, 71, 237, 254}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 53, 154, 93, 210, 35, 63, 197}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 121, 194, 187, 2, 22}, 192},
	{{5, 249, 186, 133, 68, 0, 224, 51, 185, 235, 169, 102, 254, 105, 148, 68}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 227, 186, 44, 162}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 180, 233, 46, 205, 141, 117}, 192},
	{{5, 249, 186, 133, 68, 0, 139, 72, 188, 14, 249, 226, 234, 26, 168, 190}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 4, 37, 210, 232}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 156, 249, 185, 239, 141, 252, 123}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 142, 82, 26, 42, 103, 107, 157, 41, 217}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 245, 154, 171, 2}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 215, 181, 175, 238, 123, 187}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 23, 194, 3, 131, 122, 102, 170, 246, 188}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 0}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 241, 169, 2, 82, 184, 254, 33, 251, 13}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 39, 224, 94, 196, 137, 136}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 199, 73, 58, 30}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 211, 125, 241, 218, 220, 247, 33, 45, 83}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 195, 179, 89, 135}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 224, 132, 72}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 96, 246, 159, 144, 190, 18, 157, 45}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 108}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 127, 141, 142, 2, 235}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 183, 180, 99, 121, 197, 64}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 163, 71, 173, 21, 93}, 192},
	{{5, 249, 186, 133, 68, 0, 25, 137, 222, 102, 225, 8, 204, 11, 49, 228}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 15}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 119, 226, 252, 33, 137, 39, 243}, 192},
	{{5, 249, 186, 133, 68, 0, 140, 176, 110, 25, 178, 197, 197, 148, 137, 112}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 172}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 51, 151, 187, 94, 133, 155, 15, 48}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 176, 205, 184, 142, 228, 160, 54}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 7, 212, 131, 85, 195, 192, 195, 170, 139}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 160, 96, 198, 249, 9}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 148, 178, 49, 190, 46, 112, 136, 223}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 37, 80, 83, 223, 232, 144, 73, 193}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 88, 83, 194, 242, 148, 181, 191, 250, 188}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 76, 128, 101}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 160, 224, 144}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 122, 255, 17}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 173, 25, 138, 110}, 192},
	{{5, 249, 186, 133, 68, 0, 95, 119, 7, 206, 110, 174, 61, 234, 238, 209}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 183, 195, 55, 50, 3, 66, 3, 182, 196}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{5, 249, 186, 133, 68, 0, 0, 0, 0, 0, 0, 0, 50, 43, 146, 10}, 192},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 227, 210, 206}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 248}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 34, 57}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 25, 147, 22, 251}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 81, 62, 144, 25}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 228, 153, 180}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 26, 180, 127, 76}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 138, 173, 173, 220}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 219, 222}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 232, 20, 3, 128}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 182, 150, 144, 8}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 53, 178}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 57, 102}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 60, 98}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 235}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 37, 250}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 125, 64}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 190}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 38, 149}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 118, 15, 184}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 37, 82}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 61, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 248, 53}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 55}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 198}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 61, 189}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 127, 92, 242, 78}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 104, 185, 219, 203}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 149, 115, 245, 78}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 172}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 36, 44}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 212, 158, 14, 79}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 137, 71, 41}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 122, 120, 176, 128}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 214, 157, 20}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 73, 148}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 186, 206, 26}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 244, 30, 6}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 20}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 202}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 190, 245, 114}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 140, 190, 198, 22}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 89, 101}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 134, 70, 240, 125}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 176}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 55, 41, 186}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 218, 99, 143, 67}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 203, 59, 228, 112}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 184}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 12}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 149}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 190, 81}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 180, 94}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 9, 214, 238, 211}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 129}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 102, 213, 164, 74}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 251, 227}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 108, 91, 83}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 247, 96, 30, 22}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 106, 159}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 225, 6}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 153, 140, 95, 14}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 75, 36, 239}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 155}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 125, 144, 230, 213}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 66, 199}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 172, 59, 189}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 109, 63, 75}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 158, 115, 124, 201}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 154, 33, 123}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 115}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 39, 175}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 144, 167}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 128, 84}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 164, 249}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 39}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 146, 161}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 42, 31, 207}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 248, 86, 58}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 0}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 0, 10}, 21},
	{{47, 79, 35, 66, 11, 178, 161, 28, 87, 180, 45, 128, 0, 0, 109, 167}, 21},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 34, 195, 38, 41, 131, 11, 60}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 86, 82, 179, 198}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 240, 53, 23, 178, 225, 255, 142, 39, 179}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 164, 59, 135, 220, 13, 159, 177, 91}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 165, 93, 251, 214, 58, 143, 209}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 106, 27, 20, 46, 193}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 39, 136, 184, 228, 15, 171}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 11, 99, 240, 67, 214}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 99, 218, 202, 25, 229, 195, 250}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 142, 219, 237, 156, 184, 152, 191, 151, 163}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 12, 149, 71, 171, 121, 252, 12, 105, 141}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 23, 136}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 8, 7, 50, 135, 28}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 249, 85, 161, 227, 74, 129}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 178, 172, 74, 153, 10, 251}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 240, 73, 168, 149, 180}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 205, 62}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 135, 230, 44, 238, 159, 6, 118}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 73, 102}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 88, 250}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 59, 194, 14, 240, 42, 100, 121, 24}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 147, 123, 75, 247, 59, 163, 252}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 63, 104, 218, 188}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 103, 169}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 32, 235, 107, 1, 209}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 226, 209, 145, 172, 66, 194}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 241, 20, 201, 157, 235, 173, 62, 197, 161}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 139, 34, 168, 74, 91, 137}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 1, 147, 188, 239, 24, 129, 218, 39}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 170, 29, 115, 216}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 115, 46, 170, 23}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 76, 73, 43, 226, 138}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 252, 182, 13, 163, 70, 164, 123}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 40, 70}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 145, 30, 68, 70}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 153, 95, 172, 111, 197, 122, 39}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 160, 23, 205}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 40, 203, 115, 108, 235, 65, 238}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 209, 156, 235, 11, 225, 223, 116, 200, 19}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 52, 192, 100, 199, 14, 49, 118, 6}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 155, 82, 109, 32}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 101, 171, 174, 241}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 214, 95, 141, 188, 159}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 238, 154, 158, 85, 223}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 70, 102, 252, 56, 253, 205}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 43, 214, 73, 75}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 125, 231, 63, 11, 169, 131, 194, 121}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 40, 140, 196, 177, 144}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 240, 111, 227, 177}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 62, 232}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 127, 53, 129, 86, 29, 232, 87, 151, 230}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 147, 231, 167, 12}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 156, 227, 30, 139, 159}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 230, 173, 7, 110, 144}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 130, 167, 89}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 173, 39, 103, 98, 16}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 110, 47}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 143, 210, 221, 160, 194, 19, 225}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 186, 36, 76, 43, 205, 156}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 45, 234}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 191, 144, 221, 127, 122, 253}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 27, 117, 77, 235, 116}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 18, 224, 226, 232, 25, 213}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 221, 171, 180, 167, 203, 137, 128}, 35},
	{{242, 227, 20, 73, 150, 196, 162, 23, 239, 97, 183, 199, 84, 78, 225, 139}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 21, 160, 221, 126, 101}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 159, 101, 53, 22, 110, 54, 247}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 234, 239, 66, 64, 180, 176}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 230, 118, 147}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 186, 38, 206, 13, 48, 6, 215, 55}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 208, 219, 64, 132, 106, 161, 35, 210, 66}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 107, 46, 175}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 228, 154, 133, 141}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 87, 99, 49, 235, 154, 181, 19, 92}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 97, 143, 15, 31, 196, 135, 11, 87, 241}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 138, 135, 54}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 211, 69, 246, 183, 182}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 105, 121, 235, 245, 107}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 0, 0, 227, 241}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 194, 64, 121, 208, 152, 168}, 35},
	{{242, 227, 20, 73, 150, 196, 0, 0, 0, 0, 0, 0, 83, 108, 82, 170}, 35},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 151, 191, 89, 150}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 114, 8, 249}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 249}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 255, 238, 54, 197, 84}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 127, 88, 76}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 228, 51, 5}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 192, 234, 187}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 253, 37}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 150, 75}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 122, 240, 222, 46}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 131}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 187, 36}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 183, 131}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 133}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 152, 114}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 160, 79, 16, 240}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 29}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 39}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 252, 51, 65, 104}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 79}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 153, 27, 149, 68}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 199}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 98, 114, 185, 28, 253, 173}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 210, 9}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 55, 115, 66, 127}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 251, 225, 219, 208}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 120}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 59}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 117, 178, 147, 91}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 4, 254, 89, 96}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 49, 191}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 57, 189, 49, 80}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 243, 228}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 14, 88}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 124, 51, 6}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 91, 143, 219}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 38, 47, 216}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 253}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 115, 79, 69, 61, 253, 233}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 223, 27}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 87, 176, 194, 157, 121, 201}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 203}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 45, 20, 46, 155, 133, 160}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 102, 171}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 146, 160}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 221, 152}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 49, 134}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 130, 90, 51, 80, 210}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 130}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 81, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 32, 252}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 27, 211, 121, 251}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 90, 127, 67, 36, 4, 183}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 177, 66, 7}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 225, 47, 177, 230, 212}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 205, 230, 46, 1, 207}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 162, 15}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 78, 42, 142, 222}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 200, 220, 110, 10, 194, 56}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 232, 146, 14, 130, 180}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 53, 37, 59}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 1}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 66, 90, 60, 169}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 202, 181, 10, 83, 230}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 20, 156, 151, 138}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 80, 191, 217}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 237, 248, 132, 153, 173, 159}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 215, 214, 213}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 10}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 40}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 236, 252, 99, 101}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 14, 1, 177}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 84}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 31, 152, 59, 154}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 65, 191, 105}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 101, 60, 195}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 57, 55, 115, 213, 199, 30, 112}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 26}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 244, 119, 215, 64, 45}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 184, 151, 168, 121, 72}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 49, 235}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 141, 195, 17, 23, 25}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 93, 238, 232, 51}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 0, 36, 120, 154}, 235},
	{{121, 169, 102, 118, 157, 192, 154, 186, 126, 0, 0, 0, 226, 171, 245, 224}, 235},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 111, 1, 126, 210, 175}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 142}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 100, 165, 196, 164, 54, 23, 204, 125}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 5, 51, 254, 119, 58, 246, 50, 249, 7}, 240},
	{{9, 138, 192, 0, 0, 0, 235, 76, 3, 252, 178, 135, 218, 87, 40, 201}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 151, 52, 39, 205, 161}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 108, 208, 218, 48, 126}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 186, 46, 21, 42, 50, 217, 192, 117}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 180, 231, 8, 188, 202, 43, 131}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 238, 119, 11, 194, 51, 65, 177, 2}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 3, 116, 39, 54, 137, 102, 170, 169}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 200, 165}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 69, 13, 131, 85, 59, 227}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 233, 54, 146, 152, 166, 35, 255}, 240},
	{{9, 138, 192, 0, 0, 0, 116, 174, 96, 181, 64, 186, 167, 211, 173, 142}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 172, 188, 242, 155, 177, 39, 161}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 72}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207}, 240},
	{{9, 138, 192, 0, 0, 88, 96, 53, 162, 99, 235, 142, 88, 98, 103, 73}, 240},
	{{9, 138, 192, 211, 172, 98, 220, 229, 153, 245, 166, 98, 29, 188, 124, 2}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 230, 84, 199, 105, 163, 35, 141, 217}, 240},
	{{9, 138, 192, 0, 0, 40, 101, 83, 61, 82, 189, 248, 19, 52, 34, 119}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 141, 211, 161, 212, 252, 203, 44, 218, 27}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 52, 147, 64, 23, 243, 87, 203, 50, 44}, 240},
	{{9, 138, 192, 0, 0, 0, 98, 187, 37, 215, 84, 119, 145, 99, 35, 218}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 97, 61, 3, 26, 148, 164}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 43}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 64, 167, 225, 155, 132, 191}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 86, 8, 130}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 203, 59, 5, 229, 179}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{9, 138, 192, 0, 0, 0, 134, 100, 27, 230, 242, 208, 234, 55, 138, 166}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 68, 102, 25, 188, 247}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 53, 177, 201}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 244, 211, 26, 250, 94, 54, 231, 0}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 72, 95, 185, 36, 12, 112}, 240},
	{{9, 138, 192, 0, 36, 29, 6, 46, 1, 250, 83, 33, 108, 173, 19, 61}, 240},
	{{9, 138, 192, 0, 0, 187, 128, 74, 163, 63, 191, 195, 82, 196, 226, 244}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 187, 66, 73, 181, 174, 121, 58}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 248, 44}, 240},
	{{9, 138, 192, 0, 102, 251, 174, 221, 89, 33, 116, 205, 255, 175, 90, 237}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 75, 91, 103}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{9, 138, 192, 136, 166, 156, 113, 162, 239, 192, 208, 160, 176, 76, 139, 228}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 184, 254, 189}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 245}, 240},
	{{9, 138, 192, 0, 0, 0, 244, 195, 86, 179, 42, 205, 223, 118, 135, 58}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 116, 145, 91, 184, 20, 191, 158}, 240},
	{{9, 138, 192, 0, 0, 192, 158, 201, 16, 24, 168, 247, 165, 52, 180, 238}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 50, 76, 18}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 166, 139, 67, 128, 45, 69, 62}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 58, 32, 71, 73, 252}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 154, 177}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 70, 175, 133, 48, 9, 198, 250}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 208, 246, 84}, 240},
	{{9, 138, 192, 0, 159, 236, 226, 227, 228, 197, 156, 26, 13, 103, 110, 189}, 240},
	{{9, 138, 192, 0, 0, 205, 64, 221, 9, 77, 162, 220, 234, 246, 11, 80}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 76, 6, 84, 221, 142, 76, 193, 164, 3}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 238, 15, 4}, 240},
	{{9, 138, 192, 0, 251, 143, 75, 48, 217, 155, 224, 67, 197, 201, 189, 213}, 240},
	{{9, 138, 192, 0, 0, 0, 157, 42, 192, 118, 83, 47, 251, 8, 178, 80}, 240},
	{{9, 138, 192, 0, 0, 0, 94, 187, 10, 205, 45, 72, 89, 18, 107, 75}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 240},
	{{9, 138, 192, 0, 0, 113, 75, 251, 87, 203, 93, 149, 30, 202, 236, 238}, 240},
	{{9, 138, 192, 0, 181, 12, 219, 81, 203, 23, 179, 211, 124, 136, 255, 206}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 151, 115, 130, 36, 130, 102, 99, 121, 36}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 228, 240, 202, 147, 118, 243, 111}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 220, 98}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65}, 240},
	{{9, 138, 192, 0, 0, 0, 169, 35, 231, 250, 73, 250, 226, 85, 93, 20}, 240},
	{{9, 138, 192, 0, 195, 69, 223, 226, 235, 125, 17, 133, 120, 76, 87, 150}, 240},
	{{9, 138, 192, 0, 0, 63, 169, 144, 25, 200, 242, 192, 245, 175, 93, 32}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 85, 35}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 79, 88}, 240},
	{{9, 138, 192, 0, 70, 139, 124, 214, 53, 200, 177, 200, 77, 56, 210, 129}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 6, 68, 211, 115, 125, 185, 12, 69, 83}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 110}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 224, 105, 191, 92, 244}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 33}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 240},
	{{9, 138, 192, 102, 49, 77, 35, 25, 37, 142, 20, 205, 152, 99, 212, 63}, 240},
	{{9, 138, 192, 0, 0, 0, 116, 143, 149, 41, 187, 35, 187, 147, 27, 189}, 240},
	{{9, 138, 192, 0, 0, 163, 109, 21, 144, 144, 5, 13, 170, 113, 12, 125}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 162}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 154}, 240},
	{{9, 138, 192, 0, 226, 18, 89, 140, 213, 75, 250, 173, 136, 25, 172, 129}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 112, 117, 198, 190, 146}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 159, 198, 8}, 240},
	{{9, 138, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 84, 161}, 240},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 77, 9, 167, 93}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 87, 56, 3, 221, 123, 100, 131}, 136},
	{{45, 173, 14, 72, 67, 135, 148, 202, 80, 160, 172, 55, 251, 127, 77, 31}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 23}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 77}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 119, 34, 227, 89, 220, 115}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 31, 130, 179, 79, 50}, 136},
	{{45, 173, 14, 72, 0, 0, 42, 65, 44, 208, 178, 8, 20, 213, 166, 198}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 74, 26, 60, 97, 42, 207}, 136},
	{{45, 173, 14, 72, 0, 0, 164, 133, 3, 140, 154, 73, 61, 86, 142, 139}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 131, 113, 24, 159, 100}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 120, 165}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 154}, 136},
	{{45, 173, 14, 72, 0, 0, 100, 81, 83, 70, 59, 85, 162, 79, 235, 113}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 112, 211, 210, 161}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 19, 213}, 136},
	{{45, 173, 14, 72, 0, 95, 156, 84, 153, 115, 176, 160, 11, 209, 114, 200}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 96, 189, 6, 184, 3}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 39, 199}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 65, 36}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 53, 210, 12, 89, 45}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 155, 149}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 5, 7}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 244}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 15, 249, 218, 193}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 249, 2, 6, 113, 59, 189}, 136},
	{{45, 173, 14, 72, 0, 0, 131, 94, 231, 43, 142, 23, 214, 45, 156, 161}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 95, 222, 91, 71, 9, 27, 19}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 255, 91, 125, 47, 120, 102, 78, 100}, 136},
	{{45, 173, 14, 72, 0, 0, 129, 32, 184, 249, 19, 18, 5, 116, 199, 245}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 221, 45, 78, 97, 240, 174, 209, 203}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 92}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 82, 102, 195, 63, 131, 58, 171, 94, 162}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 44, 239, 159, 146}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 135, 193, 238, 77, 210, 194, 64, 82, 41}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 136},
	{{45, 173, 14, 72, 0, 0, 127, 145, 234, 220, 207, 181, 223, 194, 40, 210}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{45, 173, 14, 72, 0, 187, 1, 73, 58, 6, 17, 130, 58, 175, 252, 153}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 82, 225, 244, 123, 64, 93, 35, 113}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 53}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 205, 218, 166, 138, 185}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 200, 173}, 136},
	{{45, 173, 14, 72, 0, 104, 247, 84, 230, 246, 166, 90, 37, 213, 31, 51}, 136},
	{{45, 173, 14, 72, 0, 0, 131, 121, 138, 215, 160, 227, 164, 9, 51, 100}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 28, 117, 24, 81, 161, 236, 48, 242, 138}, 136},
	{{45, 173, 14, 72, 0, 177, 109, 219, 17, 208, 41, 42, 146, 126, 81, 241}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 138, 71, 102, 123, 16, 19, 75}, 136},
	{{45, 173, 14, 72, 0, 10, 89, 199, 6, 19, 87, 115, 58, 15, 246, 40}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 44, 190}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 206, 21, 255, 25, 233, 103, 51}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 136},
	{{45, 173, 14, 72, 185, 249, 251, 206, 54, 100, 41, 106, 40, 176, 144, 6}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 5, 46, 196, 198, 87}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 148, 226, 204, 146, 51, 122, 123, 77}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 250, 108, 246, 28, 41}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 148, 119, 61, 113, 218, 146, 244, 1}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 182, 21, 189, 224}, 136},
	{{45, 173, 14, 72, 0, 159, 176, 168, 100, 249, 124, 213, 6, 115, 62, 52}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 108}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 178, 255, 219, 95, 252}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 252, 203, 70, 102, 113, 114}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 205, 35, 9, 32}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 121, 163, 245, 91, 129, 240, 130, 32}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 209, 233, 91, 67, 244, 61, 62, 204}, 136},
	{{45, 173, 14, 72, 0, 0, 79, 150, 71, 62, 179, 86, 50, 228, 23, 205}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 156, 87}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 36}, 136},
	{{45, 173, 14, 72, 0, 0, 36, 159, 136, 48, 40, 193, 91, 27, 219, 166}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 44, 39, 107, 157, 27, 106}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 246, 30, 53, 115, 150, 119, 22, 224}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 177, 137, 36, 146, 114, 19, 216, 27, 151}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 42, 232, 183, 83, 153, 65, 253, 110, 7}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 249, 214, 177, 237, 83, 112}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 240, 14, 54, 235, 146, 171}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 195}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{45, 173, 14, 72, 0, 110, 132, 108, 67, 127, 56, 38, 234, 114, 144, 132}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 230, 11, 28, 43, 236}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 152, 184, 255, 85}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 82, 169}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 72}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 227, 232, 250, 250}, 136},
	{{45, 173, 14, 72, 0, 0, 82, 232, 89, 63, 152, 155, 200, 72, 217, 160}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 35, 102}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 39, 234, 51, 104}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 15, 146}, 136},
	{{45, 173, 14, 72, 0, 41, 255, 82, 185, 103, 127, 6, 174, 45, 126, 181}, 136},
	{{45, 173, 14, 72, 0, 0, 242, 82, 33, 152, 77, 72, 193, 79, 112, 100}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 23, 219, 235, 113}, 136},
	{{45, 173, 14, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 69, 97}, 136},
	{{45, 173, 14, 72, 0, 0, 122, 115, 142, 231, 119, 156, 249, 251, 228, 97}, 136},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 186}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 178}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 97, 17, 210, 210, 221}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 8, 175, 206, 247, 124}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 121, 162, 234}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 82, 124, 145, 222, 247, 107, 73, 244}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 65, 249}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 204, 31, 145, 210, 37}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 73, 98, 90, 137, 59, 171, 84}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 111, 92, 60, 75, 224, 5}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 87, 174}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 87, 207, 154}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 212, 180, 12, 172, 236, 49, 224}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 207, 50, 35, 33, 2, 45, 191}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 76}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 27, 191, 37, 133, 163, 35}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 253, 89, 102, 241, 117, 122, 253, 193}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 215, 24, 41, 39, 55, 35}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 23, 57}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 16}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 158}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 17, 165, 93, 202, 250, 69}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 91, 243, 67, 133}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 7, 210, 125, 218}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 61, 152, 143, 142, 201, 154}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 62, 237, 168, 212, 112, 244, 223, 100}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 78, 35}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 91, 133, 157, 175, 187, 115, 81, 180}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 12, 15, 6, 185, 244, 100, 179, 202}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 138, 106, 192, 64, 233, 165, 186}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 180, 108, 75}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 40, 228}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 119, 246, 165, 2, 74, 75}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 18, 128, 44, 126, 126}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 65, 82, 47, 195, 217}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 157, 90, 12, 216, 190}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 218, 200, 8}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 218, 249, 68}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 37, 67, 150, 243, 238, 173}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 218, 237}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 31, 253, 126, 227, 67}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 176, 185, 75, 157, 111, 81}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 156, 245, 210, 65}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 74, 208}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 68, 246, 85, 88, 193, 215, 220}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 32}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 184, 126, 96, 71, 34, 100}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 239, 162, 34, 39, 13, 62}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 130}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 92, 1, 40}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 175, 13, 101, 188, 248}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 245}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 125, 202, 239, 77, 112, 223, 43}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 220}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 177, 109, 38, 39, 218, 19, 125}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 171}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 237, 171, 185, 238, 19}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 42, 73, 138, 202, 8, 181}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 78, 181, 250, 1, 40}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 116}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 36, 44, 14, 97, 30, 232, 120}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 149, 53, 67, 240, 127, 88}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 170, 14}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 14, 162, 46, 11, 96}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 199, 231, 16, 31}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 88, 9, 53}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 4}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 207, 4, 252}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 96, 190, 81}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 217}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 118, 73, 10, 251, 130, 136, 137}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 56, 193, 2, 102, 218, 142}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 221, 88}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 246}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 165, 178, 4, 163, 249}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 213, 170, 153, 28, 113}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 230, 90, 205, 216, 88, 38, 227, 154}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 90}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 108, 241, 24, 152, 239, 42, 57}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 164}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 77, 127}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 27}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 194, 158, 65, 179}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 88, 31, 196, 147, 2}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 68, 166, 99}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 78, 163, 98}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 0, 0, 120}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 17, 52, 136, 227}, 186},
	{{127, 47, 51, 201, 236, 45, 142, 80, 0, 0, 0, 0, 0, 248, 197, 150}, 186},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 67, 97}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 91}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 214, 17}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 247, 43, 159}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 63}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 141, 108, 243}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 242, 45}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 79, 125}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 1, 145, 210}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 174, 55}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 233}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 104, 45}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 138}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 203, 226, 55, 215}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 37, 92, 86}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 103, 16}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 60, 117, 87}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 99}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 101}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 151}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 228, 52}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 25, 70}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 140, 47}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 101, 151, 189}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 67, 110}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 226}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 162}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 204, 181}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 138, 17}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 213, 115, 225}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 244, 100, 99}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 41, 18}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 52, 180, 109}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 93, 192}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 58, 84, 223}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 101, 170}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 42, 156, 200}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 203, 209, 210}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 4}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 75, 30, 152}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 217, 102}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 120, 151, 217}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 54}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 118, 254}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 202}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 96}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 45, 44, 225}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 72, 62}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 58, 151}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 237}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 214, 201, 183}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 218, 139}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 36}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 37, 225, 220, 78}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 208}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 222, 225}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 78, 214}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 174}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 190, 87}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 129, 116, 26}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 67, 74}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 95, 81, 93}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 132, 106, 57}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 67, 206, 138, 138}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 114, 162, 88}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 233, 133, 60}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 38}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 61, 14}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 152, 177, 32, 196}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 157}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 226}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 28}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 114, 216}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 54, 141, 61, 69}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 104, 37, 87}, 174},
	{{247, 233, 34, 38, 181, 207, 127, 20, 224, 118, 59, 148, 0, 0, 0, 0}, 174},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 64, 99}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 135}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 194}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 12, 134, 20, 219}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 159, 231, 216, 102}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 128, 176}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 168, 167, 168, 128}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 143, 108, 114}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 116, 82, 208, 93, 60}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 101, 36}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 108, 228, 121}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 68, 9, 80}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 96}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 182, 186}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 175, 45, 140}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 68, 84}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 219, 241, 136, 20, 206}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 3, 32}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 171, 249}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 239}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 79, 192, 18}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 183, 99, 197, 201, 227}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 115, 57, 237, 39, 99}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 80}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 165, 140, 44}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 50, 218, 229}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 104, 232, 167, 227}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 34, 63, 127, 22}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 224, 187, 183, 156, 215}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 129, 86, 225, 184, 194, 104}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 95}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 180, 155}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 109, 136, 2}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 227, 102, 201, 250}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 143, 182, 158}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 192, 176, 108, 129}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 234, 250, 163}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 243, 247, 240}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 243, 249, 196, 166}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 86, 27, 30}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 70, 255}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 234, 116}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 65}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 165, 57, 120, 220}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 145, 218}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 216, 14, 85, 125}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 190, 126, 199, 163, 110}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 137, 40, 33}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 162, 52, 184}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 35, 44, 103}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 197, 172, 74}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 50, 250, 86, 28, 49}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 150, 71, 192}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 227, 43, 161, 221, 1}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 249, 170}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 76, 179, 244}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 41, 149}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 203, 158, 7}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 124, 11, 21, 58, 31}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 10, 190, 246, 42}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 92}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 85, 12, 180}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 21, 147, 115, 235, 159}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 95, 214, 46, 22, 123}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 136, 147}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 158, 38, 239, 242, 45}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 220, 82, 146, 166}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 126, 176, 69}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 67, 188, 112, 56, 189}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 108, 11, 88}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 113}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 140, 136, 180, 170}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 84, 183}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 213, 151, 113, 99, 120}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 32, 136, 251}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 157, 150}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 69}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 48, 75, 228, 92, 247}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 222}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 0, 0, 0, 0}, 153},
	{{126, 187, 198, 104, 245, 223, 219, 18, 31, 124, 0, 0, 117, 60, 205, 247}, 153},
	{{3, 163, 107, 228, 192, 0, 37, 174, 219, 248, 179, 90, 165, 20, 22, 113}, 118},
	{{3, 163, 107, 228, 192, 35, 115, 176, 116, 76, 84, 57, 8, 111, 45, 158}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 137, 130, 83, 74, 193}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 215, 173, 85, 104}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 77, 223, 248}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 59}, 118},
	{{3, 163, 107, 228, 192, 0, 27, 166, 177, 233, 51, 179, 118, 10, 68, 252}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 93, 137, 79}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 75}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 225, 209, 244, 212, 168, 124, 125, 91, 89}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 3, 146, 170, 126, 235, 90}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 126, 103, 82, 152, 11}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 105, 114, 201, 35, 12}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 45, 46, 114, 143, 4}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 79, 251, 101, 188, 165, 146, 151, 137}, 118},
	{{3, 163, 107, 228, 192, 210, 69, 81, 30, 58, 175, 102, 88, 152, 17, 254}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 14, 72, 213, 215, 175, 245, 219}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 208, 145, 63, 200, 244, 132, 20, 141, 19}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 99, 89, 99, 251, 254, 135, 51}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 84, 239, 13, 138, 226, 176, 6, 121}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 247, 227, 157, 134}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 57, 34, 31, 56, 87, 55, 80}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 118},
	{{3, 163, 107, 228, 192, 117, 205, 220, 243, 83, 237, 151, 155, 4, 208, 51}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 153, 145, 217, 78}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 130, 13, 44, 218, 115, 250, 218, 76, 234}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 46, 198, 125, 26}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 243, 153, 192}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 18, 54, 104, 171, 219, 174, 120, 113}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 173, 94, 76, 68, 113, 100, 219, 208, 75}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 249, 85, 244, 128, 231, 82, 180}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 20, 96, 126, 95, 27, 208}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{3, 163, 107, 228, 192, 69, 115, 165, 59, 208, 184, 55, 69, 237, 213, 24}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 230, 9, 141, 67, 219, 169, 190, 110, 27}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 198, 98, 18, 105, 188, 56, 244, 45}, 118},
	{{3, 163, 107, 228, 192, 13, 246, 111, 215, 109, 4, 148, 209, 239, 54, 232}, 118},
	{{3, 163, 107, 228, 192, 0, 172, 68, 16, 127, 30, 32, 108, 224, 254, 110}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 226}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 190, 181, 127, 222, 4}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 104, 69, 193, 185}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 41, 58, 13, 5, 46}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 225, 155, 38, 161}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 144, 107, 128, 40, 79, 174}, 118},
	{{3, 163, 107, 228, 192, 93, 167, 166, 216, 91, 206, 37, 241, 138, 41, 113}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 81, 213, 233, 154, 83, 173, 44, 60, 134}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 45, 79, 31, 102, 221, 34, 131, 50}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 51, 62, 44, 195, 21, 72, 204, 56}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 87, 207, 206, 183, 84, 200, 200, 174, 220}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{3, 163, 107, 228, 192, 0, 43, 13, 42, 197, 115, 16, 37, 10, 170, 115}, 118},
	{{3, 163, 107, 228, 192, 0, 190, 109, 60, 232, 41, 203, 49, 131, 241, 162}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 28, 117, 86, 96, 61, 248, 176, 186, 150}, 118},
	{{3, 163, 107, 228, 192, 113, 101, 94, 160, 24, 145, 151, 11, 45, 252, 44}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 112, 74, 227, 171, 153, 103}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 51, 134, 132, 122}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 192}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 136, 242, 236, 223, 108, 100}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 186, 153, 5, 175}, 118},
	{{3, 163, 107, 228, 192, 125, 97, 186, 27, 206, 91, 63, 234, 140, 27, 206}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 155, 157, 14, 248, 160}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 118, 158, 68}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{3, 163, 107, 228, 192, 150, 59, 30, 94, 139, 199, 194, 26, 91, 177, 85}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 120, 22, 48, 248, 7, 181, 235, 160}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 64, 77, 228, 26, 253, 244, 44, 158}, 118},
	{{3, 163, 107, 228, 192, 0, 124, 124, 186, 15, 76, 84, 145, 127, 58, 195}, 118},
	{{3, 163, 107, 228, 192, 173, 100, 158, 118, 27, 103, 138, 129, 125, 222, 41}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 150, 141, 47}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 35, 147, 133, 214, 135}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 25, 213, 250}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 36, 55, 242, 63, 239, 0, 127}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 216, 84, 248}, 118},
	{{3, 163, 107, 228, 192, 0, 134, 230, 224, 247, 227, 54, 151, 227, 124, 115}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 78, 8, 190, 159, 135, 40, 224, 22}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 120, 152, 185}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 62, 203, 189, 39}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111}, 118},
	{{3, 163, 107, 228, 192, 0, 98, 166, 219, 20, 119, 115, 88, 133, 240, 191}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 131, 12, 8, 237, 27, 199, 112, 0}, 118},
	{{3, 163, 107, 228, 192, 156, 95, 41, 154, 65, 110, 71, 129, 13, 63, 30}, 118},
	{{3, 163, 107, 228, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 223}, 118},
	{{3, 163, 107, 228, 192, 188, 223, 84, 39, 217, 215, 127, 243, 39, 174, 249}, 118},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 41, 216, 173, 157}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 139}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 252, 107, 225, 207}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 201, 242, 88, 60}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 101, 162, 107, 70, 135, 178, 46, 146}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 209, 233, 30}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 55, 238}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 63, 8, 255, 195, 120, 80}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 82, 54, 105}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 246, 204}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 41}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 92, 190, 177}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 147, 34, 183, 215, 245, 230, 21, 222}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 229, 148, 103}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 217, 1, 110, 75}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 130, 225, 42, 250, 220, 127, 9, 30}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 63, 198, 37, 65, 102, 129, 165}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 53, 57, 95}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 97}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 36}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 164, 222, 152}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 213, 34}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 16, 108, 71, 222, 234, 187, 187}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 238, 112, 161, 23, 42, 230, 15}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 124, 12, 157, 21}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 47, 243, 129, 101, 177, 40, 111, 96}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 207, 56, 2, 235, 87}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 112, 218, 123, 68, 144, 230, 235, 193}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 129, 234}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 36, 208, 42, 122, 108, 252, 208}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 249, 108}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 128, 22, 6, 160, 146, 11}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 140, 15, 154, 89}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 83, 100, 39, 39}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 249, 207, 111, 154, 216, 9}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 18, 90, 143}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 92, 19, 59, 186, 28, 232, 196}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 81}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 91, 183, 175, 90, 236}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 8, 37, 6, 160, 4, 178}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 104}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 132}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 235, 115, 143}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 211, 11, 230, 176, 116, 162}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 250, 82, 130, 210}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 48, 60, 133, 100, 128, 191}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 116, 198, 12, 41, 109}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 191, 96, 206}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 21, 156}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 175, 236, 131}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 251, 17, 152}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 82, 48}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 57, 155, 56, 30, 23}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 70, 186, 201, 14, 125, 245, 18, 64}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 189, 51, 164, 77}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 87, 56, 199, 33, 148, 236, 22}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 196, 85}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 42, 218, 204, 109, 139, 227, 189}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 20}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 88, 32}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 78, 235, 186, 108}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 63, 54}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 121, 226}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 65, 205, 251, 87}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 255, 195, 189, 251, 51, 235, 134, 78}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 119, 9, 212}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 39, 223, 155, 1, 9, 78}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 2, 143, 142, 78}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 154, 87, 204, 43, 29, 136}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 255, 215, 252}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 179, 85, 246, 139, 179, 160, 194, 87}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 52, 76, 50, 68, 229, 72}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 16, 231}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 105, 209, 163, 197, 222, 222, 203}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 158, 162, 242, 22, 161, 114, 225}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 146, 96, 29, 194, 26, 43}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 210, 205}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 250, 108, 254, 68, 205, 242, 254, 52}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 224, 42, 187, 53}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 75, 149, 177}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 61, 108, 184, 233, 65, 217}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 123, 17, 93, 105, 23, 73, 187}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 200, 121, 252, 171, 49, 151, 25}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 107, 178, 233}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 102, 170, 225, 108, 186}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 70, 152, 163, 107}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{167, 109, 2, 95, 11, 62, 45, 128, 103, 217, 172, 110, 226, 147, 74, 58}, 113},
	{{76, 0, 0, 0, 0, 125, 40, 62, 88, 127, 161, 74, 191, 8, 241, 71}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 77, 246, 115, 96, 157, 68, 239}, 58},
	{{76, 0, 0, 0, 172, 17, 67, 91, 252, 180, 11, 155, 110, 145, 126, 66}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 245}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 154, 13, 229, 82, 174, 78, 40, 140}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 101, 108, 137, 26, 173, 208, 200, 143}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 155, 113, 25}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 24, 70, 46, 7}, 58},
	{{76, 0, 0, 0, 116, 248, 7, 171, 143, 246, 207, 120, 9, 219, 25, 66}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 236}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177}, 58},
	{{76, 0, 0, 0, 0, 33, 117, 197, 37, 78, 87, 110, 131, 59, 125, 184}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 20, 140, 243, 106, 212, 170, 96, 22}, 58},
	{{76, 0, 114, 254, 75, 98, 176, 212, 162, 153, 221, 122, 163, 196, 148, 56}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 16, 232, 134, 206}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 236, 64, 88, 162, 112}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 177, 54, 54, 209, 198, 223, 46}, 58},
	{{76, 0, 0, 0, 0, 18, 134, 149, 33, 67, 192, 15, 123, 70, 104, 245}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 254, 128, 164, 127, 95}, 58},
	{{76, 0, 0, 171, 196, 154, 106, 198, 139, 169, 81, 59, 111, 80, 154, 53}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 181, 26, 177}, 58},
	{{76, 0, 0, 22, 30, 54, 52, 206, 70, 86, 7, 147, 183, 113, 122, 93}, 58},
	{{76, 0, 0, 232, 54, 22, 242, 231, 42, 70, 87, 160, 216, 24, 120, 198}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 224, 104, 59, 58, 128, 66, 60}, 58},
	{{76, 0, 0, 6, 159, 206, 192, 234, 152, 219, 33, 23, 254, 198, 96, 250}, 58},
	{{76, 0, 0, 0, 0, 154, 124, 54, 245, 157, 103, 155, 166, 132, 83, 201}, 58},
	{{76, 0, 0, 0, 0, 0, 196, 153, 81, 113, 171, 98, 13, 161, 9, 25}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 92, 244, 17, 246, 146, 126, 160, 148}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50}, 58},
	{{76, 0, 0, 0, 3, 1, 223, 100, 113, 219, 213, 143, 215, 174, 125, 193}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 26, 4}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 171, 114, 213, 75, 129, 86, 70, 6}, 58},
	{{76, 0, 0, 0, 0, 53, 135, 108, 218, 8, 97, 239, 152, 230, 217, 204}, 58},
	{{76, 0, 0, 240, 229, 237, 3, 103, 23, 23, 83, 220, 91, 36, 23, 106}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 24, 172, 118, 13}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 59, 134, 52}, 58},
	{{76, 0, 189, 87, 128, 62, 248, 59, 158, 213, 189, 221, 57, 170, 165, 87}, 58},
	{{76, 0, 0, 0, 233, 77, 69, 160, 221, 226, 174, 107, 123, 237, 54, 252}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 52, 22, 144, 84}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 106, 116, 57}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 58},
	{{76, 0, 0, 0, 0, 162, 141, 206, 91, 153, 91, 6, 18, 201, 14, 39}, 58},
	{{76, 0, 0, 44, 13, 91, 50, 224, 146, 113, 22, 135, 98, 137, 0, 82}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 36, 144, 180, 132, 182, 176, 221}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 97, 227, 152}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 13, 81}, 58},
	{{76, 0, 0, 209, 56, 255, 37, 70, 233, 148, 114, 192, 122, 208, 16, 78}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 99, 220}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 220, 203, 44, 19, 253}, 58},
	{{76, 0, 0, 39, 22, 95, 137, 2, 145, 91, 188, 52, 80, 224, 79, 97}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 43, 228, 63, 95, 122, 251, 197, 6, 246}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 196, 191, 87, 67}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 51, 72, 113, 96, 61, 30, 64, 1, 237}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 126}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 129, 91}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 119, 198, 94, 101, 112}, 58},
	{{76, 0, 0, 50, 35, 67, 153, 16, 65, 57, 9, 103, 237, 17, 221, 179}, 58},
	{{76, 0, 0, 195, 56, 81, 80, 123, 56, 80, 183, 171, 170, 222, 216, 26}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 133, 154, 235}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 209, 143, 241, 234, 241, 173, 220, 246}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 196, 50}, 58},
	{{76, 0, 144, 209, 148, 20, 210, 86, 38, 212, 25, 50, 231, 154, 178, 103}, 58},
	{{76, 0, 0, 0, 0, 0, 147, 37, 133, 49, 213, 46, 255, 156, 183, 2}, 58},
	{{76, 0, 0, 0, 0, 220, 17, 179, 138, 79, 174, 21, 5, 43, 153, 5}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{76, 0, 0, 237, 106, 26, 231, 206, 227, 122, 178, 172, 169, 243, 160, 80}, 58},
	{{76, 0, 0, 147, 76, 135, 223, 153, 97, 67, 0, 134, 249, 59, 223, 129}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 149, 196, 91, 68, 82, 47, 79, 216}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 101, 107, 36, 81, 22, 28, 243}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 123, 121, 93}, 58},
	{{76, 0, 0, 0, 168, 153, 141, 132, 229, 114, 197, 13, 148, 152, 234, 35}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 53, 173, 35, 29, 3}, 58},
	{{76, 0, 86, 102, 109, 226, 124, 207, 224, 35, 97, 178, 21, 127, 72, 193}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 224, 49, 166, 132, 30}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 195, 122, 222, 242, 254, 156, 30}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 183, 48, 154, 34, 23}, 58},
	{{76, 0, 0, 225, 1, 197, 6, 237, 235, 68, 15, 154, 201, 230, 248, 213}, 58},
	{{76, 0, 86, 186, 185, 124, 244, 186, 99, 66, 31, 78, 44, 98, 101, 38}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 208, 73, 83}, 58},
	{{76, 0, 0, 0, 0, 111, 173, 65, 242, 187, 5, 7, 112, 237, 5, 226}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 211, 186}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 62, 92, 127, 196, 93, 30, 164}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 144, 7, 166, 20}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 154, 166, 76, 111, 209}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 219, 140, 125, 174}, 58},
	{{76, 0, 0, 0, 0, 230, 8, 242, 39, 184, 105, 82, 122, 210, 170, 100}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 160, 18, 173, 63}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 6, 99, 46}, 58},
	{{76, 0, 35, 13, 33, 0, 30, 218, 234, 0, 159, 160, 249, 151, 57, 52}, 58},
	{{76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 40}, 58},
	{{76, 0, 0, 186, 79, 65, 86, 52, 192, 212, 57, 97, 238, 225, 235, 62}, 58},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 85}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 188, 189, 129}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 205, 126}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 221, 154, 11}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 132, 87}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 177}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 126, 238}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 224}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 12, 167}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 116, 22}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 31, 161}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 79, 148}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 72, 205}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 79}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 38}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 203}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 123, 166, 56}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 11, 234, 46}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 186}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 199, 131, 193}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 75}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 14, 63}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 236}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 238, 11, 71}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 119, 106}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 45, 131, 114}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 223}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 32, 141}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 37, 91}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 143, 32, 10}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 95}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 239}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 82, 161, 129}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 100, 95}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 80, 50}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 229, 172}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 30}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 13}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 14, 199}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 173, 51}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 155, 250, 34}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 61}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 171}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 211}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 64, 174, 162}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 123, 209}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 244}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 247, 57}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 10, 188, 126}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 164, 146}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 127}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 190, 191, 151}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 137}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 72}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 153, 173, 39}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 104, 21, 67}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 76, 144}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 60, 158}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 215, 56}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 32}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 111}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 45}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 48, 39}, 206},
	{{58, 190, 204, 151, 222, 147, 47, 78, 38, 203, 9, 17, 64, 0, 0, 0}, 206},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 138}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 214}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 69}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 36}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 198}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 132}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 162}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 1}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 120}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 254, 56}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 146}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 202}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 158}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 70}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 53}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 42}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 237}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 222}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 56}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 204}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 72, 252}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 234}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 11}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 85}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 31}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 8}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 172}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 109}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 206}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 235, 218}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 114}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 106}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 195}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 55}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 240, 205}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 219}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 233}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 77}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 213}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 94}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 189, 113}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 232}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 36}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 99}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 37}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 84}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 222}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 164}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 129}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 103}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 211}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 1}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 251}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 57}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 0}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 199, 25}, 42},
	{{254, 220, 254, 220, 204, 79, 35, 127, 242, 63, 106, 232, 127, 180, 0, 90}, 42},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 83, 184, 153, 102, 143}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 255, 14, 143, 170, 228, 185, 137, 131}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 119, 164}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 162, 197, 223, 91, 80}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 30}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 13, 240}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 140}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 204, 233, 100, 148, 246}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 195, 245, 25, 124, 107}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 44, 154, 178, 4, 131, 163, 109, 92}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 42, 197, 34, 109, 31, 127, 60}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 89, 199, 167, 218}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 51, 172, 221, 51, 18}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 118, 239, 12, 7, 240, 133, 170, 61, 107}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 39, 163, 179, 186}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 165, 116}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 89, 127}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 226, 251, 19, 49, 225}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 251, 73, 96, 214, 241, 130, 117, 218}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 88, 216, 235, 189, 204, 88}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 62, 235}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 126, 147, 180, 175, 96, 222, 202, 21}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 36, 53, 158, 87, 65, 202}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 247, 188, 186, 194, 252, 216, 237}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 138, 138, 24, 37, 246, 135, 129, 218}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 78, 91, 169, 4}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 144, 104, 207, 163}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 2, 155, 242, 174}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 196}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 236, 234, 217, 27}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 126, 133}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 17, 226, 27, 134, 250}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 71, 161, 166, 43}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 103, 203}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 236, 217}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 254}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 43, 163, 203, 179}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 179, 111}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 249, 140, 117, 181, 4, 228}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 2, 226, 110, 10, 5}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 22, 148, 15, 167, 135}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 107, 248, 11}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 201, 134, 164, 249, 205, 236}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 114, 31, 113, 21, 126, 13, 70}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 47, 196}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 26, 118, 21, 104, 254}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 225, 251, 146, 234, 180}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 222, 84, 55, 78}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 176, 53, 91, 210, 113, 150}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 216, 98, 176, 64, 12, 112, 124, 160}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 105, 89, 101, 137, 103, 169}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 18, 228, 82, 24, 172, 125, 64}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 253, 85, 149, 240}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 173, 240, 195, 135, 80, 9}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 77, 147, 113, 105}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 146, 128, 170, 158}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 213, 20, 3}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 122, 4, 249, 176}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 48, 39, 101, 167, 44, 193, 27}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 206, 16, 6, 102}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 199, 224, 58, 204, 16}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 109, 219, 18}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 129, 116, 92, 3, 131, 152}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 244, 134, 89, 74}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 20, 80, 148, 200, 29, 42, 130, 220}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 5, 204, 206}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 201, 33, 224, 133, 160}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 251, 179, 66, 207, 96, 188, 232, 125}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 148, 196, 13, 101}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 203, 250, 146}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 229, 214, 182, 36, 154, 146}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 51, 247, 128, 88}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 123, 109}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 250, 19, 187, 204, 74, 64, 63, 99}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 232, 133, 210, 201, 182, 59, 185, 181, 204}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 18, 160, 81, 246, 148, 131}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 125, 55, 160, 252}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 0, 139}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 35, 84, 230, 6}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 253, 110}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 0, 0, 0, 32, 176}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 155, 134, 204, 205, 223, 30, 142}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 201, 212, 142, 81, 26}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 0, 0, 56, 168, 44, 183, 10}, 230},
	{{77, 156, 8, 209, 181, 37, 70, 0, 0, 178, 24, 213, 195, 226, 173, 44}, 230},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 103, 173}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 175, 45, 209, 77, 251}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 173}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 28, 230, 194}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 83, 124}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 110, 159, 109}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 120, 235, 26, 245}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 125, 176}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 173}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 170, 68, 17, 140, 101}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 210, 243, 50, 162}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 164, 120, 70, 246, 193, 132, 134}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 153, 128, 204, 120, 19}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 174, 177, 144, 63, 99}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 46, 106, 92, 236}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 41, 170}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 177}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 87, 24, 99, 187, 79}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 116, 193, 229, 234}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 249, 74, 174}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 125, 142, 198, 175}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 77, 193, 143, 133}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 240, 234, 160}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 5, 176, 129}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 121, 40, 10, 123, 48, 201}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 156, 72}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 113}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 83, 57, 63}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 229, 154, 124, 69, 41, 104}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 158}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 226, 250, 249}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 214, 176, 6}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 153, 156}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 26, 160, 20, 3, 164, 6}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 154, 173}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 201, 81, 182, 122, 173, 36}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 133, 151, 208, 109, 185, 1, 187}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 233, 71, 222}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 235, 161, 178}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 185, 94, 3}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 174, 96}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 103, 214, 125, 102, 233, 252}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 118, 17, 177, 184, 120, 124, 91}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 34, 181, 84, 209, 31}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 210}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 39, 114, 63}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 186}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 72, 200, 212, 247}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 159, 249, 43, 46, 172}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 103}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 8, 56, 95, 236}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 163, 215, 154, 232, 71, 95, 75}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 64, 226, 25, 86}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 91, 134, 99, 73}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 30}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 202, 238, 173, 169, 160}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 153, 124, 34, 223, 63, 24, 127}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 92}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 96, 83, 68, 60, 111, 123, 48}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 166}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 10, 206}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 75, 173}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 1, 173, 220, 202, 209, 145, 241}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 168, 183, 146, 236, 177}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 185}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 178, 84}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 61, 3, 34, 203, 200, 210}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 241, 254}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 105}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 193, 185, 91, 97, 90, 251, 10}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 59, 43, 101, 24, 106, 193, 139}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 103, 229, 81, 113, 139, 176}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 145, 27, 242, 54, 132, 237}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 99, 39}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 118, 217, 106, 254}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 126, 78, 199, 74, 86, 139, 155}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 229, 237, 232, 52, 41}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 251, 107, 63, 19, 166, 148, 205}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 86, 28, 137, 172, 68, 11, 84}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 179, 99, 218, 172, 29, 168}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 0, 0, 0, 24}, 6},
	{{65, 89, 137, 76, 208, 199, 166, 90, 128, 0, 0, 0, 235, 6, 9, 220}, 6},
	{{47, 232, 0, 0, 0, 228, 168, 178, 36, 168, 138, 55, 207, 29, 220, 134}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 189, 107}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169}, 254},
	{{47, 232, 0, 0, 72, 27, 182, 17, 125, 251, 49, 33, 252, 29, 68, 161}, 254},
	{{47, 232, 0, 240, 159, 240, 170, 63, 47, 138, 65, 103, 22, 95, 242, 50}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 15, 13, 181, 64, 155, 130}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 64, 188, 199}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 218, 40, 94, 75, 103, 46}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 184, 65, 158, 106, 72, 128}, 254},
	{{47, 232, 0, 0, 0, 197, 231, 66, 124, 81, 213, 178, 209, 223, 230, 20}, 254},
	{{47, 232, 0, 0, 0, 0, 76, 152, 65, 140, 7, 18, 86, 169, 61, 18}, 254},
	{{47, 232, 0, 0, 30, 25, 78, 112, 254, 136, 95, 133, 59, 29, 153, 155}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 184, 146, 232, 73, 153, 221, 207}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 185, 12, 235}, 254},
	{{47, 232, 0, 0, 0, 63, 129, 129, 94, 207, 27, 166, 106, 141, 230, 196}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 222, 74, 138}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 100, 113, 94, 57, 18, 73, 206}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 197, 223, 117, 183, 159, 28, 180, 185, 20}, 254},
	{{47, 232, 0, 0, 0, 0, 11, 138, 214, 202, 65, 33, 174, 247, 60, 60}, 254},
	{{47, 232, 0, 0, 0, 4, 111, 55, 87, 203, 90, 235, 111, 252, 94, 15}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 26, 92, 29, 184}, 254},
	{{47, 232, 186, 106, 47, 81, 168, 16, 9, 51, 114, 103, 154, 139, 27, 236}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 79, 29, 126, 64, 178, 130, 164, 63}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 27, 8, 170, 23, 162, 44, 37}, 254},
	{{47, 232, 0, 0, 0, 0, 183, 192, 227, 14, 168, 63, 193, 26, 151, 1}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 20, 219, 83, 160, 107, 216}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 231, 96, 147, 111}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 50, 116, 8}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 248, 75, 174, 189, 118, 99}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 189, 244}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 18, 139, 127, 180, 114, 131}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 76, 147, 67, 173, 236, 202, 221, 165}, 254},
	{{47, 232, 0, 0, 0, 19, 54, 27, 255, 154, 202, 78, 143, 236, 219, 16}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 105, 128, 52}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{47, 232, 0, 0, 47, 174, 197, 153, 211, 78, 214, 113, 199, 88, 254, 147}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 219, 40, 255, 139, 24, 166, 182}, 254},
	{{47, 232, 0, 0, 139, 26, 170, 148, 138, 251, 173, 240, 1, 154, 4, 100}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 10}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 220, 124, 64}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 172, 162, 50, 152, 185, 150, 180, 255, 110}, 254},
	{{47, 232, 0, 149, 88, 165, 70, 228, 131, 183, 172, 9, 101, 59, 64, 105}, 254},
	{{47, 232, 0, 138, 49, 86, 194, 52, 221, 71, 49, 247, 111, 187, 164, 45}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 198, 131, 17, 120, 59, 25, 195, 180, 133}, 254},
	{{47, 232, 0, 181, 232, 72, 148, 47, 133, 12, 145, 127, 150, 48, 131, 196}, 254},
	{{47, 232, 0, 43, 10, 14, 35, 218, 101, 180, 254, 122, 248, 105, 38, 153}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 78, 229, 40, 133}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185}, 254},
	{{47, 232, 0, 0, 0, 159, 7, 191, 57, 68, 10, 167, 30, 43, 183, 188}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{47, 232, 0, 10, 130, 155, 67, 33, 81, 49, 43, 216, 131, 94, 89, 219}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 149, 81, 221, 82}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 161}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 101, 71, 234, 199, 66, 89, 195, 85}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 138, 212, 38, 205}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 130, 107, 243, 72, 214, 74, 152, 198}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 117, 227, 156}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 33, 18, 57, 35, 108, 44, 76, 88}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 22, 188, 156, 160}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 192, 204}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{47, 232, 0, 176, 39, 150, 14, 164, 95, 54, 118, 52, 243, 185, 52, 24}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{47, 232, 0, 0, 137, 11, 210, 135, 179, 142, 246, 87, 10, 66, 114, 239}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 228, 55, 75, 182}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 239, 113, 124}, 254},
	{{47, 232, 0, 0, 0, 147, 172, 111, 236, 138, 124, 30, 4, 142, 30, 148}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 189, 123, 158, 126}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 122, 136, 181, 233, 2, 182, 207}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 138, 203, 87}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{47, 232, 0, 0, 0, 36, 48, 101, 152, 171, 206, 116, 140, 190, 161, 2}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 71}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 53, 226, 13, 7, 154, 156, 237, 26}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 219}, 254},
	{{47, 232, 35, 47, 79, 84, 51, 217, 194, 54, 67, 253, 165, 249, 251, 111}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 149, 44}, 254},
	{{47, 232, 0, 0, 0, 0, 88, 23, 84, 78, 102, 133, 241, 149, 154, 25}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 132, 251, 233, 29, 55, 85, 225, 94, 240}, 254},
	{{47, 232, 0, 0, 113, 81, 231, 71, 118, 106, 238, 91, 152, 55, 87, 130}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 88, 32, 210}, 254},
	{{47, 232, 0, 0, 0, 0, 240, 93, 6, 222, 11, 128, 51, 77, 8, 103}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 238, 67, 240, 164, 177, 171, 91, 92, 136}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218}, 254},
	{{47, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 221, 119, 33, 72}, 254},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 43, 205}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 219}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 209}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 173, 36}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 19}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 93}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 176, 226}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 121, 93}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 176}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 51}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 227}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 114, 104}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 151}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 1}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 63}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 116}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 128, 50}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 125}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 1}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 53}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 84}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 143, 159}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 2}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 204}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 115, 157}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 205}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 219}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 114}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 154}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 74}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 114, 55}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 203}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 203}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 229}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 202, 235}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 212, 116}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 233}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 131, 157}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 1}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 134}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 217}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 113}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 213, 12}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 237}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 115}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 121, 205}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 253, 56}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 177}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 11, 156}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 211}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 186}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 164, 63}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 33}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 107}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 94}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 148, 106}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 120, 190}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 253}, 214},
	{{172, 154, 12, 108, 77, 37, 106, 8, 234, 7, 248, 212, 112, 160, 0, 0}, 214},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 254, 209}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 246, 90}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 20, 48}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 153, 234}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 108}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 195}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 190, 187}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 167}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 246}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 191}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 154}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 122}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 221}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 87}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 32}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 150}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 105}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 227, 118}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 34, 15}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 159, 33}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 3}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 41, 131}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 106, 13}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 5}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 98, 151}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 241, 205}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 168, 18}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 139, 88}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 112, 65}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 144, 200}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 78, 186}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 211}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 55, 124}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 67, 36}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 187, 245}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 211}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 191}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 52, 21}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 43}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 158}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 9, 25}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 13}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 212, 234}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 105}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 118}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 38, 187}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 220}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 59}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 54, 131}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 74}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 38, 255}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 206, 88}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 3, 19}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 185}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 79}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 0}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 77}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 148}, 43},
	{{254, 117, 239, 244, 154, 89, 166, 241, 12, 108, 127, 153, 206, 160, 0, 190}, 43},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 58, 109, 150}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 211, 16}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 103, 114}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 110, 166, 59, 188}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 218, 230, 109, 245, 64}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 116, 211, 135, 167, 27, 110}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 64, 200, 253}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 49, 42, 70, 84}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 199, 223, 85, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 222}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 242, 224, 151, 204, 3, 59, 253}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 127, 221, 50, 157, 206, 151, 83}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 52, 177, 73, 138, 143, 98, 162}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 136, 219}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 222}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 22, 199, 186, 100}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 151, 56, 2, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 116}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 196}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 174, 196, 248, 32, 232}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 18}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 248, 247, 70, 207, 113, 22}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 206}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 174}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 152}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 231, 169}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 29}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 171, 121, 51, 90}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 114, 48, 115, 176}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 53, 117, 42, 127, 13, 4, 143}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 217, 43, 22, 181}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 121, 127, 83, 178, 142}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 4, 238, 158, 146, 17, 47}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 140, 159, 20, 124, 154}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 206}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 20, 48, 131}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 117, 149, 140, 224, 101, 237, 95}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 222}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 74}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 102}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 15}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 23, 68, 28, 133, 230, 212}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 22, 255, 251, 87, 103, 237}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 227, 218, 140, 56, 106, 94, 217}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 72, 106, 7}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 218, 132, 46}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 53, 136, 132}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 150, 16, 68, 157}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 37}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 102, 107, 161}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 39, 105}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 246, 100}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 94}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 66, 12, 94, 243, 15, 14}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 133, 164, 171, 168}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 111, 30, 185}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 93, 108, 105, 160, 218, 42, 10}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 172, 175, 88, 240, 75, 216}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 98, 204}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 54, 195, 7, 124, 202}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 244, 75, 165, 181, 31, 254}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 182, 43, 146, 131, 12, 139}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 24, 101}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 125, 11, 81, 245, 39}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 188, 11, 249, 13, 93, 214}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 170, 28, 84, 53, 29}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 207, 229, 40}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 80, 213, 38, 45, 127}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 176, 41, 183, 159, 193, 248, 56}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 234, 220}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 95, 237, 92, 214, 167}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 154, 39, 86, 53, 1, 100, 99}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 99, 226, 184, 104, 237}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 9, 199}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 223, 180, 153, 76}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 212, 205}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 35}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 71, 175, 189, 161, 106, 131, 44}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 51, 148, 233, 51, 7, 156, 97}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 52, 154, 25}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 59}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 65, 196, 44, 115}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 0, 121, 51}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 76, 185, 56}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 146, 222, 40, 113, 227, 78}, 178},
	{{113, 160, 206, 52, 143, 12, 9, 148, 224, 0, 0, 0, 0, 41, 99, 71}, 178},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 181, 233, 32, 215, 68, 50, 149}, 179},
	{{178, 130, 0, 0, 145, 62, 123, 157, 251, 109, 76, 131, 134, 239, 179, 98}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 198}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 204, 202, 210, 124, 227, 34}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 234, 95, 221, 140, 1, 34, 67, 29, 172}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 7, 91, 123}, 179},
	{{178, 130, 0, 0, 0, 0, 145, 175, 224, 56, 111, 52, 150, 90, 30, 86}, 179},
	{{178, 130, 0, 0, 245, 163, 203, 105, 151, 216, 170, 231, 109, 215, 193, 214}, 179},
	{{178, 130, 0, 230, 4, 41, 23, 202, 108, 17, 145, 197, 101, 29, 33, 64}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 250, 47, 251}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 5}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 147}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 153, 186, 29, 181}, 179},
	{{178, 130, 0, 109, 116, 132, 7, 54, 119, 71, 212, 19, 105, 141, 181, 164}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 209, 9}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 163}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 105, 78, 77, 121, 68, 164, 53}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 166, 27, 88, 34, 86, 68}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 89, 84, 61, 162, 34, 211, 228}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 24, 4}, 179},
	{{178, 130, 0, 0, 0, 86, 78, 228, 155, 129, 31, 156, 16, 210, 116, 238}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 238}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 9, 174, 199, 62, 139, 234}, 179},
	{{178, 130, 0, 0, 214, 227, 131, 210, 142, 166, 43, 130, 108, 129, 118, 5}, 179},
	{{178, 130, 0, 202, 193, 53, 4, 3, 235, 231, 142, 18, 196, 213, 254, 194}, 179},
	{{178, 130, 0, 239, 158, 1, 12, 158, 46, 222, 237, 64, 75, 221, 45, 144}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 194, 16, 223}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 50, 218, 232, 156, 181, 35, 5}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{178, 130, 0, 0, 0, 0, 222, 206, 228, 114, 76, 239, 105, 224, 129, 246}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 197}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 141}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 193, 159, 230, 62}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 137, 77, 73, 228, 124, 198, 107, 131}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 43}, 179},
	{{178, 130, 0, 0, 0, 0, 108, 237, 168, 129, 79, 232, 102, 101, 218, 136}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 212, 50}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 224, 131, 187, 204, 122, 204, 219}, 179},
	{{178, 130, 0, 0, 116, 227, 174, 133, 188, 160, 182, 136, 94, 23, 234, 39}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 87, 227, 36, 237, 120, 199, 144, 140, 126}, 179},
	{{178, 130, 0, 0, 54, 220, 93, 176, 190, 97, 204, 122, 182, 245, 74, 196}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 87, 91, 83, 186, 133, 183}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 124, 84, 0, 170, 7, 77, 3, 115, 176}, 179},
	{{178, 130, 0, 0, 0, 0, 173, 239, 30, 62, 70, 228, 168, 35, 134, 160}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 58, 77}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{178, 130, 0, 0, 0, 0, 147, 189, 40, 24, 199, 145, 8, 4, 61, 104}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 183, 160, 34, 209, 23, 219}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 123, 28}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 179},
	{{178, 130, 0, 0, 0, 177, 210, 62, 179, 139, 91, 224, 236, 57, 144, 230}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 207, 6, 166, 45}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 9, 165, 213, 94, 234, 72, 23, 156, 226}, 179},
	{{178, 130, 0, 158, 141, 59, 222, 117, 197, 236, 187, 198, 89, 32, 229, 211}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 194, 202, 165, 109, 120, 143, 224}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 158, 205, 124, 134, 195, 13, 96, 143}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 165, 15}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 37}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 179},
	{{178, 130, 0, 90, 166, 242, 59, 109, 77, 181, 12, 171, 169, 120, 201, 238}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 33, 12, 55, 1, 171, 50, 165, 233}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{178, 130, 0, 0, 192, 155, 84, 155, 32, 2, 123, 17, 46, 166, 247, 103}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 186}, 179},
	{{178, 130, 0, 0, 241, 247, 104, 160, 9, 92, 39, 83, 159, 156, 156, 75}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 38, 24, 166, 146, 206, 17, 60, 2}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 208}, 179},
	{{178, 130, 0, 0, 0, 0, 213, 239, 141, 249, 148, 233, 217, 183, 198, 32}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 46, 210, 255}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 104, 66, 74, 172, 51, 140, 41, 255}, 179},
	{{178, 130, 0, 0, 0, 215, 171, 167, 74, 183, 35, 104, 52, 74, 119, 236}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 161, 56, 188, 105, 116, 99, 91, 88}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 200, 56, 255, 148}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 60, 245}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 6}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 150, 93, 235, 85, 209, 65}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 126, 26, 229, 162, 133, 158, 83}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 58, 228, 107, 122, 60, 84, 209}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{178, 130, 0, 0, 0, 119, 2, 223, 227, 43, 16, 33, 174, 29, 101, 11}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 62, 125, 216, 21}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 11}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 204}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 156, 138, 246}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 56}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 191, 146, 33, 122, 7, 86, 244, 114}, 179},
	{{178, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 47, 71, 99}, 179},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 138}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 217, 233}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 123}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 40, 242, 255, 143}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 216, 61}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 136, 50, 40}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 29}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 39}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 208, 217, 212, 232}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 98}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 200, 218, 73}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 36}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 120, 48, 173}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 92, 33, 37, 224, 7}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 239, 100}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 167, 209}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 221, 83, 97}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 229, 169, 33}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 138, 17, 38}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 60, 24, 219, 77}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 158, 124}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 82}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 24, 244, 114}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 91, 29, 249}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 166}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 91, 137}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 167, 154, 59}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 253, 41, 172}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 38, 123}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 12, 220}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 71, 140, 71, 34}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 33, 55}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 188, 157, 61}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 143}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 169, 152}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 249, 126}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 31, 52, 236, 242, 229}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 201, 247, 93}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 113, 6}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 117}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 13, 68, 26}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 206, 151, 180, 86}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 95, 83}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 76}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 62}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 92}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 141}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 107}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 86}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 230, 120, 216, 145}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 161}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 186, 125}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 68, 138}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 17}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 169, 138}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 32, 48}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 219, 144, 116, 75}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 92, 37, 138, 251}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 129, 128, 61}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 23, 82, 138}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 40, 141}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 100, 86, 224, 120}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 203}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 58, 54, 189, 144}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 239, 154, 140}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 13}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 84, 143, 19}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 186, 167, 45, 238}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 200, 91, 251}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 227}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 250, 110, 205, 171}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 247, 133}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 212}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 79, 81}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 199}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 118, 95}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 82, 19, 246}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 0}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 129}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 0, 224}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 133, 71, 226}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 172, 190, 126, 214}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 0, 0, 169, 244}, 236},
	{{229, 177, 28, 106, 59, 75, 182, 241, 36, 79, 224, 0, 131, 194, 120, 85}, 236},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 193, 129}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 255}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 107, 159}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 117, 203, 122}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 76, 188}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 174, 43}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 220}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 48, 114, 4}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 143, 167, 145}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 209}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 239, 40}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 181}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 227}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 128}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 14, 25}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 118, 167}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 42, 187}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 181}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 181, 164, 117}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 169, 226}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 243}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 195}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 245}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 139, 81}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 53}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 67, 159, 126}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 176, 152, 96}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 74}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 165}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 75, 28, 255}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 29}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 201, 248}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 22}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 198}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 133, 197, 11}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 167}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 100, 24}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 161, 62, 255}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 238}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 156, 24, 132}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 150}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 119, 218}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 228, 38}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 38, 99}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 204}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 211}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 86}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 182}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 56}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 75}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 38, 151, 126}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 217, 148}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 185}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 75, 163, 158}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 220, 41}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 38, 19}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 3}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 244, 148}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 70}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 41}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 115}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 96, 65}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 54}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 110}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 63}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 198, 90, 237}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 17, 178, 232}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 148, 189}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 7, 0}, 184},
	{{156, 72, 93, 193, 50, 235, 75, 228, 88, 115, 89, 119, 128, 0, 0, 30}, 184},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 207, 246}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 194}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 185}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 221}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 11}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 14, 85, 191}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 174, 9, 185}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 255, 21}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 119, 125, 152}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 175, 209, 202}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 235, 5}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 83, 232, 211}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 233, 241, 255}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 159}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 56, 47, 191}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 215}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 143}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 171, 187}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 159, 123, 152}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 36, 48, 83, 245}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 107, 75, 141}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 123, 9, 107}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 84}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 117}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 204}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 136}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 158}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 238, 44, 175}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 147, 65}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 248, 198}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 60, 253}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 135}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 10}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 62}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 2}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 60, 63, 94, 15}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 183, 77, 182, 190}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 141, 157}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 138}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 4, 51}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 174, 213}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 173, 176, 98}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 227, 136, 206, 227}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 37}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 244}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 195}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 67, 75, 31, 42}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 133, 91, 83}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 117, 4, 233}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 84, 42}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 64}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 42, 201, 23}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 55}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 94, 46}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 107, 219, 3}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 28, 43, 226}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 121, 212}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 217, 27, 241}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 108, 67}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 16, 227, 96}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 101, 233}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 21}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 13, 237}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 239}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 192, 233}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 205, 27}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 204, 77, 63, 246}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 112}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 138}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 193, 116, 169}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 231}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 116, 152}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 247}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 0}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 107}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 198, 191, 136}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 17}, 95},
	{{28, 232, 28, 249, 83, 105, 211, 7, 136, 147, 231, 64, 0, 0, 0, 223}, 95},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{217, 33, 23, 107, 74, 42, 135, 197, 144, 34, 40, 243, 13, 126, 36, 136}, 152},
	{{64, 0, 0, 0, 0, 0, 0, 0, 188, 2, 50, 189, 32, 193, 16, 67}, 84},
	{{64, 0, 240, 79, 27, 61, 108, 140, 10, 144, 205, 204, 108, 21, 178, 39}, 84},
	{{64, 0, 0, 0, 167, 93, 84, 244, 103, 80, 13, 174, 161, 210, 15, 201}, 84},
	{{64, 0, 0, 0, 0, 0, 32, 76, 80, 104, 232, 229, 205, 85, 152, 187}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 221, 22, 17, 177, 235, 184, 155}, 84},
	{{64, 0, 0, 0, 0, 43, 200, 211, 246, 157, 217, 197, 151, 114, 132, 181}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 6, 44, 51, 63, 10, 25, 81, 176}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 199, 168, 134, 149, 86, 17, 49, 251, 146}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 205}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 108, 45, 141, 195, 98, 195, 39}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 23}, 84},
	{{64, 0, 95, 161, 207, 75, 88, 144, 105, 151, 125, 73, 118, 229, 21, 55}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 168, 168, 57, 230, 76}, 84},
	{{64, 0, 0, 0, 0, 135, 192, 33, 57, 241, 29, 68, 108, 232, 197, 81}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 8, 46, 102, 181, 216}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 122, 152, 192, 243}, 84},
	{{64, 0, 0, 0, 0, 194, 75, 60, 232, 221, 151, 122, 249, 45, 37, 14}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 234}, 84},
	{{64, 0, 0, 0, 0, 11, 211, 55, 56, 153, 148, 233, 236, 217, 99, 235}, 84},
	{{64, 247, 218, 113, 36, 122, 237, 82, 122, 173, 20, 164, 32, 205, 124, 42}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 181, 145, 223, 50, 190}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 84},
	{{64, 0, 0, 0, 43, 172, 167, 124, 136, 62, 134, 21, 93, 85, 22, 233}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 140, 105, 63, 160, 28, 141, 130, 172}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 183, 253, 44, 11, 83}, 84},
	{{64, 107, 159, 210, 73, 143, 208, 188, 78, 57, 13, 111, 31, 190, 229, 220}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 208, 107, 90, 80, 2}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 226, 221, 226, 254, 87, 29, 24, 196, 115, 136, 201, 53}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 84},
	{{64, 0, 0, 166, 171, 206, 252, 172, 155, 191, 160, 214, 206, 110, 122, 220}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 236, 38, 165, 109, 104, 140, 187, 98, 141, 83}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 119}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 21, 110, 88, 123, 85, 189, 235, 68, 242}, 84},
	{{64, 242, 83, 50, 117, 229, 211, 55, 163, 102, 188, 214, 76, 170, 48, 200}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 51, 45, 250, 11, 235, 216, 49, 193, 205}, 84},
	{{64, 0, 0, 0, 0, 0, 236, 140, 75, 247, 189, 143, 138, 88, 78, 219}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 125, 138}, 84},
	{{64, 0, 0, 0, 0, 0, 22, 182, 216, 234, 78, 153, 63, 3, 186, 136}, 84},
	{{64, 0, 0, 0, 0, 159, 79, 17, 1, 179, 109, 247, 73, 248, 106, 16}, 84},
	{{64, 0, 242, 143, 3, 182, 193, 67, 244, 146, 89, 60, 156, 184, 225, 147}, 84},
	{{64, 0, 0, 0, 0, 4, 136, 85, 173, 164, 169, 145, 49, 44, 12, 255}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 208, 115, 178, 84}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182}, 84},
	{{64, 0, 0, 0, 0, 0, 116, 161, 95, 154, 7, 209, 229, 210, 187, 43}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 120, 8, 109, 204, 137}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 86, 186, 150, 94, 88, 129, 18, 144, 202}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 137, 7, 179, 210, 89, 137, 203}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 43, 55, 198, 119, 30, 167, 117, 1}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 108, 103, 176, 244, 5, 181, 27}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 121, 136, 84, 225, 226, 212, 239, 71, 98, 91, 87, 14, 83, 191}, 84},
	{{64, 153, 100, 144, 145, 12, 242, 204, 120, 178, 46, 223, 33, 81, 36, 138}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 2, 58, 214, 72, 109, 121, 229, 110, 194}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 125, 22, 106}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 64, 10, 50}, 84},
	{{64, 0, 0, 0, 225, 86, 218, 201, 174, 164, 58, 252, 51, 0, 248, 177}, 84},
	{{64, 0, 108, 126, 8, 252, 134, 162, 76, 46, 129, 86, 46, 225, 234, 84}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 52, 175, 246, 133, 145, 227, 240, 235, 98, 60, 66, 14, 225, 166}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 78, 174, 234, 221, 91}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 142, 128, 141, 163, 154}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 84, 3, 167, 133}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 254, 237, 250, 137, 61}, 84},
	{{64, 0, 228, 130, 148, 127, 144, 103, 176, 90, 14, 56, 154, 133, 233, 103}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 227, 18}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 73, 199, 121, 33, 212, 130, 200, 212, 11, 14, 97, 4, 5, 67}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 119, 108}, 84},
	{{64, 0, 0, 0, 247, 114, 143, 34, 139, 83, 144, 88, 192, 149, 254, 53}, 84},
	{{64, 0, 52, 70, 54, 230, 160, 4, 203, 194, 231, 81, 64, 71, 103, 91}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 45, 108, 88}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 112, 13, 90, 120, 111, 252, 121}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 11, 159, 44}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 242, 204, 92, 207, 91, 240, 228, 65}, 84},
	{{64, 212, 102, 109, 230, 24, 245, 40, 248, 217, 224, 36, 247, 120, 199, 2}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 3}, 84},
	{{64, 0, 0, 0, 0, 0, 115, 243, 23, 142, 141, 95, 7, 151, 146, 124}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 164, 66, 94, 36, 75}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 113, 124, 151, 190, 224, 172, 138}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 44, 125, 197, 197, 86, 184, 233, 89, 10, 30}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 181}, 84},
	{{64, 0, 14, 249, 233, 170, 40, 79, 172, 92, 245, 53, 67, 196, 97, 158}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 120, 120, 166, 230}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 163, 85, 43, 24, 138, 103, 95, 92}, 84},
	{{64, 0, 0, 0, 87, 197, 238, 6, 131, 153, 202, 165, 236, 87, 216, 167}, 84},
	{{64, 175, 245, 164, 121, 58, 114, 224, 105, 113, 238, 68, 42, 239, 205, 0}, 84},
	{{64, 0, 0, 49, 234, 247, 67, 129, 63, 184, 66, 36, 76, 41, 66, 227}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 223, 108, 211, 206, 182, 15, 30, 83}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 205, 141, 157, 88, 24, 104, 24}, 84},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 226}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 56}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 90, 178}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 53}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 254}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 129}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 205}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 32}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 219, 180}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 146}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 255, 31}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 202}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 101, 90}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 65}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 110}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 187, 121}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 152, 4}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 159}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 88}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 97, 38}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 182, 149}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 90}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 55}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 164}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 33}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 112, 14}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 176}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 101}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 240}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 59}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 65}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 193, 229}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 62, 17}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 14, 145}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 162}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 44}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 8, 157}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 209}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 162}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 33}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 54}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 234, 107}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 164}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 8, 93}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 177}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 79}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 33}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 175}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 168, 193}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 83}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 131, 203}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 237}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 89}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 233}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 7}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 121}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 12, 12}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 233, 98}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 3}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 26, 69}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 65, 95}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 206}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 0}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 248}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 242}, 137},
	{{85, 172, 121, 126, 213, 57, 225, 54, 197, 73, 85, 251, 9, 64, 0, 81}, 137},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 163, 73, 248, 59, 208, 167}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 246, 50, 104}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 62, 210, 85, 110, 223, 90}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 226, 219, 169, 101, 9, 62}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 107, 220}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 29, 91}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 24, 80, 57, 79, 173, 51, 40}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 92, 195, 23, 134, 144, 23, 223}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 83, 38, 253, 5, 81, 137, 235}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 69, 197}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 49, 187, 227}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 20, 82, 221, 157, 75, 74, 71}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 252, 19, 114, 20, 145, 199, 200, 167}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 252, 16, 90, 187, 126, 88, 178, 59, 19}, 224},
	{{104, 46, 25, 71, 86, 220, 155, 192, 55, 67, 26, 205, 36, 101, 105, 119}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 6, 207, 239, 133, 35, 152, 52}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 13, 98}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 66, 158}, 224},
	{{104, 46, 25, 71, 86, 220, 2, 53, 164, 160, 37, 232, 204, 205, 202, 248}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 61, 62, 174, 129, 44, 189, 71, 229}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 246, 95, 11, 71}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 77, 43}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 97, 9, 25}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 79, 240, 72, 231, 241, 51, 201}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 51, 134, 189, 149, 123, 4, 116}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 140, 105, 148}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 93, 2}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 198, 215}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 18, 61, 240, 192, 59, 184, 101, 89, 180}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 212, 248, 166, 96, 130, 174, 13, 158}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 216, 119, 126, 116, 43, 26, 12, 213, 101}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 41, 10, 98, 23, 168, 63, 45, 59}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 146, 157, 224, 79, 37}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 17, 90, 70, 163, 59, 239}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 46, 109, 120, 26, 105, 155, 181, 166}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 125, 44}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 112, 219, 25, 181, 13, 193, 133}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 139, 143, 121, 164, 250, 39}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 251, 64, 4, 0, 12, 198, 139, 235, 254}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 65, 221}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 251, 158, 150, 84, 133, 211}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 199, 223, 47, 225, 115, 213, 81, 68, 44}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 165, 195, 147, 213, 96, 17, 230}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 140, 195, 153, 15, 60, 171, 81, 251}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 236, 12, 63, 158, 238, 231, 8, 78, 123}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 1, 41, 119, 98}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 217, 236, 119, 23}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 131, 191, 0, 92, 181, 83, 240, 67}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 218, 177, 74, 197, 68, 196, 72, 149}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 39, 155}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 182, 221}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 49, 92, 75, 203, 71, 4, 240, 61}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 16, 183, 200, 237, 155, 34, 180, 169}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 186, 166, 155, 156, 238}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 199, 130, 69, 245, 77, 116, 186, 10, 129}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 151, 134, 188}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 97, 240, 129, 82, 80, 194}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 69, 229, 42, 22}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 35, 144, 220, 123}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 241, 193, 254, 219, 145, 151, 252, 167, 65}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 75, 187, 218, 229, 253, 239, 171, 249, 113}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 46, 195, 210, 7, 183, 50}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 221, 27, 24, 89, 167, 255, 232}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 63, 102, 57, 10, 253, 201, 14, 112}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 174, 244, 137, 225, 14, 172, 251, 47, 252}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 21, 240, 70, 113}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 53, 189, 49}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 28, 97, 195, 215, 120}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 1, 224, 0, 172, 15, 235}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 170, 43, 182, 178, 16}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 203, 128, 38, 36}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 88, 130, 235, 59, 219, 48, 229, 217, 12}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 196, 106, 30, 234, 203, 148, 167}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 44, 21, 213, 199, 31, 81, 78}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 20, 154, 65, 104, 156}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 9, 224, 183, 114}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 130, 254, 179, 190, 179}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 241, 62, 155, 104, 133, 238, 37, 179, 119}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 0, 71, 221, 0, 220, 22, 175, 64, 252}, 224},
	{{104, 46, 25, 71, 86, 220, 0, 75, 223, 198, 82, 28, 254, 175, 133, 76}, 224},
	{{0, 0, 0, 0, 0, 0, 247, 48, 239, 34, 6, 131, 144, 5, 119, 109}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 202, 26, 209, 3, 121, 194}, 61},
	{{0, 0, 0, 0, 0, 179, 89, 74, 250, 222, 111, 117, 103, 193, 101, 45}, 61},
	{{0, 0, 0, 0, 0, 0, 200, 108, 98, 122, 215, 242, 189, 40, 209, 218}, 61},
	{{0, 0, 0, 0, 0, 0, 39, 153, 13, 51, 254, 222, 72, 229, 217, 107}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 65, 138, 58, 179, 254, 163, 82, 73}, 61},
	{{0, 0, 0, 0, 0, 0, 196, 252, 122, 215, 19, 84, 9, 237, 31, 193}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 162, 81, 122}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 74, 45, 106, 196, 183, 64}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 61},
	{{0, 0, 0, 0, 141, 163, 204, 83, 126, 21, 92, 53, 51, 42, 104, 250}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218}, 61},
	{{0, 0, 0, 0, 94, 91, 27, 191, 71, 207, 143, 192, 174, 55, 241, 231}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 185, 173}, 61},
	{{0, 25, 22, 107, 194, 244, 209, 205, 123, 47, 73, 147, 111, 223, 59, 129}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 145, 90, 82}, 61},
	{{0, 0, 0, 0, 0, 191, 219, 129, 154, 140, 22, 36, 143, 174, 104, 41}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 211}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 68, 205, 194, 29, 123, 154, 95, 46, 176}, 61},
	{{0, 0, 0, 0, 0, 157, 242, 185, 84, 146, 30, 152, 11, 125, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 61},
	{{0, 0, 0, 75, 147, 197, 88, 1, 78, 253, 93, 75, 60, 198, 149, 47}, 61},
	{{0, 0, 0, 27, 255, 177, 209, 74, 46, 113, 50, 161, 83, 146, 252, 241}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 154, 196, 42, 61, 204, 236}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 2, 181, 128, 182, 245, 53, 120, 37, 164}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 197, 14, 190}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 124, 243, 63}, 61},
	{{0, 0, 0, 0, 0, 2, 206, 147, 106, 151, 50, 165, 107, 191, 108, 244}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 213, 38, 186}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157}, 61},
	{{0, 0, 0, 0, 0, 0, 215, 217, 27, 216, 241, 219, 5, 42, 128, 80}, 61},
	{{0, 0, 0, 0, 0, 50, 237, 230, 189, 154, 122, 254, 8, 28, 233, 115}, 61},
	{{0, 0, 0, 202, 158, 121, 10, 204, 47, 26, 206, 45, 29, 9, 32, 181}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 61},
	{{0, 0, 0, 0, 0, 0, 83, 213, 40, 246, 73, 35, 30, 89, 221, 154}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 61, 95}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 202, 23, 174, 77}, 61},
	{{0, 0, 202, 212, 164, 44, 179, 95, 199, 81, 33, 121, 78, 172, 24, 224}, 61},
	{{0, 0, 0, 0, 0, 0, 187, 117, 6, 177, 175, 236, 161, 4, 192, 168}, 61},
	{{0, 0, 0, 0, 213, 248, 199, 191, 158, 220, 9, 186, 110, 75, 225, 197}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 252, 61, 135, 75, 75, 0, 88, 22, 54}, 61},
	{{0, 0, 0, 0, 0, 198, 28, 36, 117, 90, 144, 129, 251, 104, 117, 92}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 242, 168, 199, 158, 238, 166}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 130, 41, 150, 50, 66, 129, 156, 163, 40, 150, 250}, 61},
	{{0, 0, 0, 0, 117, 233, 14, 132, 187, 0, 228, 84, 141, 54, 192, 60}, 61},
	{{0, 0, 0, 0, 0, 0, 51, 89, 254, 164, 197, 70, 196, 104, 82, 53}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 209, 131, 201}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 66}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 76, 135, 202, 1, 156, 16}, 61},
	{{0, 0, 0, 0, 0, 244, 138, 235, 216, 229, 114, 112, 9, 101, 99, 179}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 55, 194, 253}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 18, 162, 161, 139, 110, 190, 242, 184}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 28, 204, 59}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 143, 66, 52, 249}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 132, 150, 164, 85, 165, 99, 225, 18, 159}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 230, 44, 162, 173, 148, 245, 123, 72}, 61},
	{{0, 0, 0, 158, 228, 142, 173, 2, 166, 255, 170, 245, 11, 109, 26, 110}, 61},
	{{0, 0, 243, 213, 101, 130, 175, 72, 72, 8, 209, 248, 255, 58, 17, 178}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 103, 86, 76, 17, 12, 75, 194, 226}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 108, 183, 183, 98, 204, 158}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 192}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 86, 115, 191}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 57, 216, 122}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 121, 156, 15, 178, 224, 215}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 172, 217}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 158, 211, 58, 91, 53}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 136, 84, 177, 84, 198, 146, 186, 114, 92}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 134, 141, 12, 56, 60, 19, 227, 222, 236}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 92, 54, 254, 76, 141, 88, 10, 159}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 151}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 197, 109}, 61},
	{{0, 0, 0, 0, 0, 0, 185, 26, 107, 251, 146, 178, 136, 194, 169, 249}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 14, 88, 148, 0, 81, 116}, 61},
	{{0, 0, 0, 0, 0, 0, 173, 166, 51, 114, 107, 79, 46, 27, 46, 36}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 71, 145, 179, 145}, 61},
	{{0, 0, 0, 0, 0, 237, 205, 42, 18, 28, 234, 157, 100, 60, 225, 82}, 61},
	{{0, 0, 0, 189, 211, 93, 219, 220, 210, 224, 213, 77, 110, 160, 93, 242}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 115, 245}, 61},
	{{0, 0, 0, 0, 0, 0, 152, 157, 200, 192, 179, 143, 117, 252, 179, 30}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 243, 227, 111, 45}, 61},
	{{0, 0, 0, 0, 0, 182, 70, 169, 180, 132, 31, 29, 86, 208, 135, 211}, 61},
	{{0, 0, 0, 0, 41, 190, 200, 141, 155, 78, 221, 241, 46, 89, 165, 110}, 61},
	{{0, 0, 0, 0, 0, 208, 174, 78, 157, 245, 237, 66, 88, 142, 147, 189}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 46}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 156, 119, 24, 27}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 80, 167, 41, 120, 235, 173, 45, 195}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 222, 175, 93, 58, 43, 29}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 77, 234, 124, 76, 58}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 107, 33, 128, 200, 108}, 61},
	{{0, 0, 0, 19, 75, 149, 79, 157, 87, 111, 148, 120, 247, 255, 195, 187}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 87, 224, 171, 181, 204, 49, 159, 37}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 236, 255, 49}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 54, 234, 223}, 61},
	{{0, 0, 0, 0, 0, 0, 246, 9, 77, 115, 142, 244, 231, 179, 156, 65}, 61},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 154, 0, 120, 85}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 69, 139, 11, 21, 183, 95, 153, 171, 49}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 136, 142, 254, 38, 249, 105, 109, 209}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 113, 48, 81, 29}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 52, 244}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 82, 68, 34, 235, 201, 197, 117}, 205},
	{{241, 113, 254, 106, 53, 128, 93, 238, 33, 59, 55, 91, 204, 205, 104, 202}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 69, 177, 21, 116}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 23, 75}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 77, 33, 250, 134, 112, 104, 48, 84, 253}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 252, 120, 180, 226, 43, 80, 88, 122}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 116, 215}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 21, 247, 33}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 73, 148, 186, 96, 178, 167}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 118, 62, 25, 226, 166, 94, 245}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 189, 244, 69, 135, 44}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 192, 89, 155, 30, 227, 249, 74, 114, 42}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 181, 163, 40, 215}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 236, 113, 165, 89, 169, 242}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 3, 68, 97, 92, 164, 69, 205, 200, 217}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 142, 51, 135, 134, 253, 53}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 9, 211, 181, 129, 193, 178, 154}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 30, 151, 27, 142, 131, 128}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 209, 6, 72, 22, 174, 150, 243}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 52, 238, 125, 94, 187, 144, 16, 230}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 181, 132, 201, 197, 115, 251, 127, 178}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 27, 230, 87, 154, 0, 209, 19}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 176, 57, 132, 225, 176, 80}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 247, 80, 202, 115, 183, 82, 128, 161, 184}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 53, 28, 170, 62}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 239, 206, 92, 224, 200, 189, 138}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{241, 113, 254, 106, 53, 128, 51, 56, 57, 132, 229, 104, 126, 15, 68, 5}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 179, 209, 75}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 177, 55, 235, 79}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 217, 20, 235, 149, 211, 162, 150}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 29, 191, 66}, 205},
	{{241, 113, 254, 106, 53, 128, 96, 182, 223, 181, 177, 40, 73, 215, 80, 51}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 211, 142, 111, 1}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 150, 106, 31}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 134, 27}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 60, 130, 217}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 209, 116, 61}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 66, 194, 49, 204, 32, 19, 196, 26, 148}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 215, 34, 89, 178, 187, 157, 15, 78, 165}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 17, 83, 25, 239, 20, 230}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 136, 130, 52, 53, 218, 93, 26, 204, 28}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 83, 253, 152, 50, 88, 125, 133, 12, 183}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 41, 53, 38, 236, 164, 19, 128, 84, 16}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 195, 201}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 144, 192, 184, 45, 180}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 137, 119, 97, 3, 172, 34, 76, 122}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 20, 130, 217, 155, 147}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 204, 148, 92, 222, 163, 214, 214, 5, 166}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 157, 65}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 33, 145, 254, 217, 243, 59, 59, 57, 141}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 233, 212}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 153, 252, 154, 255, 243, 92, 103, 142, 212}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 102, 244, 171}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 38, 168, 83, 152}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 23, 211, 212, 15, 116, 11}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 110, 123, 222, 108, 78, 200}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 48, 89, 118, 56, 11, 214}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 230, 89}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 41, 146, 4}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 87, 191, 102, 170, 169, 166}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 151, 145, 0, 194, 64, 74, 52}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 143, 65, 180, 240, 65, 83, 195, 158}, 205},
	{{241, 113, 254, 106, 53, 128, 92, 224, 145, 108, 4, 9, 155, 35, 245, 135}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 132, 27, 107, 88, 66, 77}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 172, 182, 82, 212, 185}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 97, 144, 221, 58, 184}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 73, 90, 173, 58}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 59, 15, 26, 163, 78, 221, 107, 253}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 40, 193, 84, 239, 29, 114, 144}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 92, 233, 208, 255}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 74, 122}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 47, 100, 21, 184, 190, 214, 167, 1}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 230, 36, 72}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 150, 139, 188, 122}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 110, 191, 238, 164, 6, 220, 156, 20, 72}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 0, 0, 0, 0, 0, 138, 97, 112}, 205},
	{{241, 113, 254, 106, 53, 128, 0, 0, 217, 57, 231, 10, 94, 202, 224, 189}, 205},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{29, 36, 12, 244, 197, 127, 240, 8, 167, 134, 154, 248, 199, 123, 143, 240}, 170},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 73, 247, 25, 34, 26}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 94, 178, 5, 221, 29, 75, 88}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 128, 138, 254}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 86, 85, 179, 128, 223, 245, 105, 158, 66}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 39, 193, 49}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 218, 184, 132, 3, 110}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 226, 95, 130, 234, 30, 12}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 184, 29, 47, 244, 42, 58, 187}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 67, 48, 34}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 239, 123, 209, 115}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 111, 76, 62, 92, 162, 193, 113, 236}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 79, 142, 9, 13, 74, 81, 155}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 38, 148}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 76, 56, 219, 174, 245, 73, 98}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 253, 48, 14, 67, 84, 201, 153}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 58, 9}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 82, 206, 160, 148, 98, 50, 81}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 119, 108}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 67, 202, 103, 75}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 21, 112, 194, 126, 6, 168, 80, 28}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 124, 232, 180, 188, 193, 100, 229, 181, 42}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 106, 54, 74}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 179, 94, 12, 244, 64, 161, 150}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 93, 186, 206}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 62, 0, 179, 114, 192, 240, 128}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 188, 63, 253, 52, 28, 148, 62, 219}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 97, 117, 5, 162, 67}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 163, 111, 133, 68, 250, 20, 84}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 248, 18, 177}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 101, 86, 200}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 180, 106, 49, 171, 69, 49}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 206, 98, 89, 195, 95}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 75, 107}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 155, 216, 231, 108, 84, 12}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 179, 147, 47, 109, 187}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 64, 0}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 172, 155, 138, 66, 99, 146}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 215, 168, 97, 203, 136, 139, 44}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 180}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 112, 1, 226, 74}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 139, 236, 146, 65, 85, 177}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 202, 111, 79, 166, 130, 23}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 211, 200, 190}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 126, 111, 214, 82, 168, 31}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 214, 29, 76, 115, 197, 43, 8}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 152, 245, 167, 41, 57, 126, 9}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 122, 152, 40, 10}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 213, 93, 1}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 47, 61, 255}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 65, 77, 25, 152}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 94, 159, 0, 165, 130, 189, 133, 52, 176}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 149, 21, 97, 147, 127, 212, 160, 101, 19}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 6, 153, 111, 13, 76, 93}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 197, 153, 187, 25}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 171, 1, 161, 146, 144, 85, 187, 192}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 158, 167, 31, 204, 114}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 124, 134, 197, 230, 69}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 203, 197}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 95, 249}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 3, 246, 125, 91, 254, 60}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 111, 233, 253, 148}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 112, 24, 197, 2, 203}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 33, 217, 143, 60, 134, 25}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 57, 49, 98, 235, 235, 7, 230, 118}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 173, 174, 61, 54, 215}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 254, 179, 123, 200, 167, 97, 181}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 202, 235, 173, 181}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 188, 198, 167}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 134, 222, 154, 241}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 197, 118}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 113, 124, 156, 63, 72}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 223, 135, 68}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 151, 121, 100}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 231, 246, 199}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 151, 101, 96, 177}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 194, 14, 7}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 33, 69, 211, 129, 102, 29}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 226, 174, 202, 187, 204, 86}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 0, 0, 0, 147, 4}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 98, 191, 34, 159, 157}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 194, 248, 225, 143, 67, 203, 117}, 117},
	{{58, 29, 129, 94, 43, 139, 224, 0, 0, 0, 0, 219, 253, 253, 53, 49}, 117},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 246, 237, 248}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 68, 40, 24, 149}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 140, 51, 0, 124}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 81, 39, 210, 24, 32, 147}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 22, 167}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 139}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 53, 0, 222}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 131}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 201, 196, 15, 220}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 7, 55}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 154, 102, 205}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 139, 227}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 200, 71}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 102, 19, 213, 126, 250, 244}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 126, 15, 158}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 55, 197, 35, 119, 197, 16, 89}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 216, 233}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 63, 85, 163, 219}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 165}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 51, 93, 78, 91, 50, 105}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 98, 12, 121, 43, 171}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 223, 237, 246, 57, 12}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 131, 46}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 78, 171, 72, 166}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 43, 111, 10, 192, 82, 205}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 170}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 184, 189, 105, 191}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 2}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 97}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 166, 206, 92}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 8, 35, 226, 123, 208}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 138}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 29, 204, 172, 51, 141, 205}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 74, 45, 196, 61}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 181, 248, 97, 219}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 42}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 93, 234}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 246, 40}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 158, 134, 133, 157}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 234, 219, 190}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 161, 35}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 60}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 9, 112, 247, 108, 74, 155}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 223, 36, 192, 118, 97, 222, 31}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 143, 68, 210, 202}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 83, 12, 5}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 135, 129, 182}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 155, 121}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 45}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 145}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 222, 92, 141, 203, 141, 184}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 175, 13}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 60, 91, 5}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 31, 7, 100}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 112}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 187, 185, 85, 93, 122, 126, 146}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 218, 167, 118, 219}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 217, 74, 246, 70}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 118, 43, 168, 145}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 165, 113}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 66, 159, 98}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 92, 66, 205}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 233, 39, 80, 147, 172}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 156, 133, 211, 150, 132, 164}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 202, 27, 89, 121, 142, 46}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 188}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 146, 150, 212}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 186, 188, 162}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 16, 100}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 250, 163, 56, 155}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 242, 254, 32}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 44}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 69, 162, 159, 102, 156, 138, 81}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 90, 35, 20, 225, 176}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 196, 202, 171}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 138, 172, 158, 90, 227}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 16, 43, 49, 127, 236}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 98, 217}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 14, 69, 143}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 182}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 209, 113, 5, 118, 171, 45}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 205, 56, 229, 11}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 104, 188, 189, 11, 155}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 66, 225, 83, 240, 94, 189}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 134, 152, 55, 192, 207, 17}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 80, 28, 196, 127, 59}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 77, 11, 71, 242, 46, 131, 128}, 225},
	{{213, 124, 147, 196, 7, 82, 67, 70, 228, 0, 0, 0, 0, 247, 138, 245}, 225},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 154, 76, 231, 52, 55}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 55, 25}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 47, 117}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 35, 170, 86, 128, 198}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 111, 211, 254, 103, 246}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 249, 123}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 163, 218, 117}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 150, 97, 30}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 201, 65}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 56, 133, 177, 73}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 133, 23, 192, 102}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 66, 223, 155, 48}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 42, 197, 218, 69, 186, 38}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 124, 242, 122, 147, 118}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 158, 233, 72}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 154, 206, 62, 217, 104, 255}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 21, 228}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 11, 165}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 83, 105}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 88, 68, 18, 222, 140}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 116}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 181, 36}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 230, 122, 108, 95, 173, 89}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 127, 105, 121, 214, 129, 166}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 3}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 234}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 3, 208}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 187, 157, 205, 181, 27}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 73, 220, 59, 41}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 135, 126, 18, 95}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 158}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 118, 94, 125, 26, 21}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 49}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 3, 96, 57, 158, 224, 174}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 194, 214, 2, 226}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 147, 127}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 149, 191, 22, 88, 178}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 113, 60, 144, 22, 107, 254}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 161}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 204, 213, 40, 41, 109}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 23}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 194, 7, 24, 182}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 85, 101, 7, 175}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 178, 240, 181, 135}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 242, 59, 17}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 119, 107}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 187, 10, 5, 11, 199}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 44, 202, 10, 216, 213}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 16, 97, 239, 169, 187}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 56, 205, 249}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 215}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 6, 130}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 68, 170, 170, 156}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 5, 148, 159, 180, 229, 165}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 31, 174, 225, 185}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 122, 76, 248, 88}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 163, 249}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 72, 251, 78, 50}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 237, 189, 5}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 204, 215, 71, 68}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 243}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 9, 79, 235}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 68, 193, 158, 246, 238, 115}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 68, 203, 3, 28, 74, 24}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 189}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 104, 183, 35, 227}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 120, 132}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 188, 68, 51, 210, 96}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 245, 233, 93}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 154, 22, 181, 193, 224}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 209, 220}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 158, 120, 204, 151, 164, 239}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 137, 127, 141, 228, 43, 66}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 241}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 6, 143, 175, 135, 74}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 140, 82}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 128, 237, 144}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 224}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 207, 255, 189}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 37, 112}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 122, 113, 245, 70, 18, 136}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 31}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 198}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 87, 174, 86, 13, 31}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 129, 209, 118}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 15, 160, 210, 52, 45, 5}, 34},
	{{164, 168, 161, 140, 87, 85, 250, 41, 34, 0, 93, 196, 178, 115, 84, 217}, 34},
	{{186, 142, 128, 0, 0, 0, 0, 42, 58, 113, 181, 155, 54, 145, 207, 111}, 5},
	{{186, 142, 128, 0, 207, 129, 175, 88, 22, 67, 49, 191, 159, 238, 254, 109}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 56, 73}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 19, 146, 41, 75, 5}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 99, 55, 14, 214, 107, 171}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 81, 134, 182, 217, 120, 81, 81, 103}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 212, 156, 193}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 141, 62, 56, 91, 54, 67, 121, 94}, 5},
	{{186, 142, 128, 0, 0, 25, 249, 44, 162, 217, 21, 187, 156, 29, 198, 172}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 117, 23}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 142, 127}, 5},
	{{186, 142, 128, 0, 84, 165, 201, 225, 43, 72, 214, 99, 2, 112, 184, 99}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 27, 105, 65, 58, 248}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 152, 102, 188, 116, 221, 22}, 5},
	{{186, 142, 128, 0, 0, 0, 167, 191, 91, 133, 191, 191, 96, 29, 183, 211}, 5},
	{{186, 142, 128, 0, 0, 0, 164, 96, 26, 236, 174, 125, 219, 129, 206, 144}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 171, 169, 61, 39, 189, 19, 66, 214, 155}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 14, 255, 30}, 5},
	{{186, 142, 128, 0, 152, 246, 213, 221, 241, 192, 79, 25, 68, 117, 14, 61}, 5},
	{{186, 142, 128, 0, 0, 48, 65, 0, 72, 178, 200, 196, 115, 106, 128, 217}, 5},
	{{186, 142, 128, 0, 0, 0, 255, 58, 148, 181, 188, 83, 154, 88, 93, 101}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 49}, 5},
	{{186, 142, 128, 0, 108, 194, 35, 48, 161, 204, 77, 233, 26, 208, 185, 251}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 80, 101}, 5},
	{{186, 142, 128, 0, 0, 139, 116, 4, 239, 163, 165, 178, 255, 212, 6, 162}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 91}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 186, 157, 132}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 64, 199, 61, 216, 231, 242, 39, 56}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 183, 247, 222, 251, 228}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 2, 253, 5, 93, 221, 37}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 243, 42, 108}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 32}, 5},
	{{186, 142, 128, 0, 61, 253, 249, 102, 98, 62, 79, 120, 219, 144, 124, 228}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 225, 216, 35}, 5},
	{{186, 142, 128, 0, 163, 174, 56, 14, 247, 237, 17, 148, 124, 57, 135, 56}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 130}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 30, 14, 151, 31, 219, 129}, 5},
	{{186, 142, 128, 0, 73, 77, 206, 118, 74, 224, 48, 110, 58, 219, 119, 77}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 124, 241, 99}, 5},
	{{186, 142, 128, 61, 133, 139, 184, 184, 181, 115, 183, 34, 33, 155, 219, 250}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 163, 7}, 5},
	{{186, 142, 128, 0, 0, 0, 16, 132, 215, 188, 193, 159, 74, 130, 245, 189}, 5},
	{{186, 142, 128, 0, 54, 146, 39, 30, 97, 142, 211, 50, 118, 249, 194, 197}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 12, 243, 166, 99, 104, 185, 20, 76, 8}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 242, 255, 221, 79, 26}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 30}, 5},
	{{186, 142, 128, 0, 0, 166, 31, 46, 245, 43, 251, 81, 75, 198, 165, 18}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 49, 222, 133}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 220, 86, 65, 199, 37, 136, 234, 170}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 180}, 5},
	{{186, 142, 128, 0, 0, 0, 118, 81, 118, 222, 250, 9, 166, 99, 121, 183}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 5},
	{{186, 142, 128, 142, 215, 201, 120, 60, 228, 6, 101, 102, 96, 37, 144, 11}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 229, 23, 3, 151, 216}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 222, 252}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 132, 234, 119}, 5},
	{{186, 142, 128, 0, 0, 0, 223, 215, 182, 123, 165, 201, 233, 54, 112, 253}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 89, 54, 215, 9, 158, 69, 32}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 57, 58, 145, 52, 135}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 42}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{186, 142, 128, 0, 0, 0, 28, 43, 216, 17, 25, 72, 184, 11, 167, 151}, 5},
	{{186, 142, 128, 0, 0, 174, 1, 73, 18, 229, 27, 253, 112, 3, 148, 8}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 160, 179, 110, 22, 224, 77}, 5},
	{{186, 142, 128, 0, 0, 0, 212, 178, 51, 205, 90, 48, 1, 208, 12, 186}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 110, 28, 157, 250, 49, 163, 222, 48}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 132, 47}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 249, 214, 213, 202, 92, 137}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 92}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 32, 37, 161, 247, 196, 15, 217, 77}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 112, 59, 173, 92, 37, 206, 132}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 103, 151, 98, 235, 244}, 5},
	{{186, 142, 128, 0, 51, 90, 217, 140, 248, 82, 217, 165, 117, 172, 228, 168}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 19, 199, 95, 154, 104, 177, 197}, 5},
	{{186, 142, 128, 0, 0, 35, 180, 174, 89, 128, 211, 32, 55, 81, 106, 151}, 5},
	{{186, 142, 128, 0, 0, 0, 225, 223, 11, 113, 152, 226, 15, 18, 80, 219}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 38, 109, 217, 107, 65, 76, 151, 109}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 54, 36, 143}, 5},
	{{186, 142, 128, 0, 0, 0, 99, 127, 65, 31, 213, 171, 90, 114, 84, 78}, 5},
	{{186, 142, 128, 24, 160, 248, 135, 249, 153, 60, 222, 130, 60, 36, 233, 71}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 64, 96}, 5},
	{{186, 142, 128, 179, 27, 161, 125, 24, 247, 235, 229, 183, 214, 75, 2, 10}, 5},
	{{186, 142, 128, 42, 243, 151, 245, 217, 55, 69, 255, 209, 221, 135, 164, 9}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 190, 121, 26, 143, 89, 32, 167}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 153, 12, 182}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 85, 204, 248, 220, 55, 173, 161, 179}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 197, 118}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{186, 142, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 190}, 5},
	{{186, 142, 128, 0, 0, 236, 110, 141, 10, 120, 131, 244, 151, 253, 135, 92}, 5},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 143, 59, 246, 51, 76, 173, 99, 16}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 200}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 206, 235, 134, 112, 241, 61, 108}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 251, 111, 88, 238, 52, 3}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 173, 116, 131, 27}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 83, 106, 44, 177, 56, 132, 191, 107}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 127}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 12, 222, 127, 178}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 115, 71}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 178, 219, 175, 184, 193, 196, 209}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 57}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 70, 18, 204}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 3, 43, 34, 180}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 121, 142, 77, 153, 19, 75, 160, 46}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 179, 204, 81, 167, 65, 212, 129, 43}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 76, 84, 134, 21, 207, 244, 217}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 171, 3}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 215, 203, 25, 163, 112, 241, 223}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 231, 23, 141, 191, 78, 62, 58}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 14, 174, 229, 219, 171, 254, 114, 44}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 81, 130, 147, 74, 175, 115}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 174, 90, 25, 209}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 198, 224, 148, 212, 211, 91}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 15, 246, 199, 114, 173, 102, 20, 100}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 176, 32}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 106, 244, 54, 176, 165, 112, 8}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 59, 194, 41}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 163, 11, 181}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 40, 197, 60, 37, 255}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 203, 207, 104, 232, 152, 123, 168, 210, 57}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 8, 150, 206, 64, 133, 169, 203}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 211, 76, 248, 75, 104, 127, 157, 232}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 126, 61, 247, 155, 80, 20, 236, 25}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 215, 134, 49, 208}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 23, 217, 192, 54, 49, 8}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 155, 192, 102, 76, 110}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 155}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 211, 79}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 208, 18, 19, 0, 245}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 255, 104, 140, 144, 208, 177, 93, 196}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 124, 253, 118, 235, 19, 225, 72, 95}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 50, 137, 59, 226}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 72, 117, 88, 78, 76, 196, 219}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 104, 246, 221, 88}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 110}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 120, 250, 39, 79, 61, 50, 153, 154}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 93, 46, 25, 123, 76, 222, 192}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 45, 176, 115}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 158, 221, 186, 109, 216, 197, 89, 75, 103}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 181, 124, 185, 210, 212}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 90, 116, 249, 142, 131, 177}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 242, 152, 74, 56, 120, 245, 116, 166}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 191, 126, 248, 133, 104}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 148, 136, 238, 248, 245}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 186, 215, 27, 72, 197}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 199, 20}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 107, 166, 249}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 111, 166, 36}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 82, 70}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 167, 107, 215, 198}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 204, 215, 78}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 214, 66}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 115, 116, 29, 253}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 114, 27, 70, 148, 220, 218}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 112, 141, 223, 17, 194, 98, 64}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 255, 100}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 189, 136, 185, 99, 42, 59}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 249, 244, 83, 27, 216, 31, 223, 33, 168}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 28, 189, 228, 170, 12, 38}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 105, 0, 175, 28, 32}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 153, 122, 107, 45, 65, 141, 97, 247, 123}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 32, 125}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 58, 119}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 78, 40, 106, 66, 52}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 0, 0, 5, 107, 108}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 8, 72, 21, 239, 78, 169, 76, 163}, 92},
	{{237, 249, 9, 70, 247, 97, 64, 0, 0, 0, 0, 58, 21, 29, 161, 184}, 92},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 38, 17, 0, 235, 35, 98, 191, 143}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 19, 113}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 115, 16}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 39, 74, 200, 39}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 209, 21}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 219, 35, 205, 125, 91, 174}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 142, 154, 148, 153, 90, 77}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 242, 84, 59, 206, 14, 226, 33}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 151, 3}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 99}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 10, 70, 64, 203}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 137, 234, 104, 169, 38, 121, 149, 122}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 173, 152, 200, 203, 237}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 158}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 182, 165, 131, 45, 247, 66, 197, 161}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 41, 126}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 168, 143, 207, 221, 79, 1, 109}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 105, 187, 31, 37, 89, 197, 206}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 195, 27, 156, 67}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 18, 9, 151, 99}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 139, 110}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 120, 19, 30, 234, 76, 255, 248}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 66, 41, 247, 233, 135}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 53, 138, 126, 167, 177}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 79, 213}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 61, 161, 123}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 73, 85, 103, 227}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 170, 32, 86}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 166, 121, 237, 70, 67, 248}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 33, 234, 114, 228, 215, 83, 253, 193}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 112, 209, 249, 41, 80, 180}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 179, 58}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 216, 15, 170, 120, 185, 192, 8, 91}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 244, 53, 31, 161, 19, 172, 71}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 38, 254, 123, 200, 0, 242, 128}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 134, 94, 83, 111, 158, 205, 87}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 169, 47, 146, 217, 208}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 240, 116, 115, 62, 149}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 182, 141, 156, 42, 126, 192, 230, 164}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 187, 249, 127, 158, 129, 24, 226, 255, 24}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 192, 226, 86, 173, 25, 7, 96}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 156, 176, 207, 71, 137, 160}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 164, 225, 178, 161, 135, 146, 102, 213}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 237, 81, 79, 156}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 97, 72, 179, 241, 207}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 105, 208, 229, 60, 30, 14, 147, 25}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 227, 70, 244, 97, 4, 29, 168}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 125, 75}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 93, 249, 110, 19, 251}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 93, 44, 5}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 202, 166, 56, 62, 146, 2, 164}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 206, 116}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 156, 202, 82, 103, 157, 120, 162, 24}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 112, 173}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 154, 97, 93, 192}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 40, 220, 97, 127, 213, 174, 157}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 42, 239, 34, 184}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 246, 203, 241, 218, 173, 202, 228, 117}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 84, 225, 38, 28, 52, 135, 77}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 70, 126, 59, 69, 108, 22, 174, 87}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 78, 248, 128, 39, 169, 201, 37, 178}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 131, 49}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 109, 100, 222, 50, 157, 232, 14}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 111, 206, 146}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 72, 69, 180, 202, 221, 236}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 196, 153, 24, 49, 87, 67, 228, 34}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 164, 210, 175, 98, 14, 3}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 47, 37, 53, 66, 129, 16}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 211, 58}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 122, 246, 216, 154, 127, 196, 67, 253, 102}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 128, 238, 207, 4, 9}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 112, 25, 202, 140}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 67}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 220, 44, 54, 52, 155, 192}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 88, 7, 38, 168, 104, 58, 131, 212}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 248, 51, 164, 89}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 0, 238, 219}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 53, 134, 9, 96, 37, 111, 157}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 0, 0, 0, 0, 0, 123, 10, 79}, 230},
	{{155, 92, 145, 218, 125, 226, 226, 0, 196, 60, 202, 67, 26, 100, 243, 139}, 230},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 78}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 177}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 123}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 196}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 55}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 97}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 213}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 234}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 139}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 66}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 29}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 249}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 173}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 19}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 133}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 136}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 175}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 142}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 81}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 118}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 72}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 187}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 62}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 116}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 135}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 166}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 66}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 148}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 179}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 155}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 206}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 206}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 77}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 247}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 177}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 144}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 55}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 87}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 26}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 184}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 212}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 60}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 193}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 26}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 0}, 61},
	{{35, 169, 62, 156, 86, 4, 125, 219, 119, 113, 191, 75, 198, 113, 0, 249}, 61},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 103}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 191}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 46}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 205}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 206}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 193}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 50}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 153}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 48}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 101}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 71}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 19}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 238}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 117}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 229}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 39}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 213}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 24}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 79}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 161}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{207, 63, 96, 186, 26, 68, 115, 161, 163, 59, 190, 166, 18, 78, 232, 0}, 221},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{86, 40, 200, 199, 247, 86, 159, 179, 191, 184, 117, 173, 211, 158, 0, 128}, 105},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 75}, 181},
	{{104, 64, 0, 0, 224, 73, 208, 64, 31, 142, 3, 190, 111, 85, 91, 24}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 68, 204}, 181},
	{{104, 64, 0, 0, 0, 5, 68, 109, 92, 8, 239, 137, 161, 192, 215, 221}, 181},
	{{104, 64, 0, 0, 243, 55, 162, 167, 202, 92, 224, 188, 95, 167, 233, 224}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 145, 241, 40, 254}, 181},
	{{104, 64, 0, 199, 223, 53, 117, 190, 182, 39, 217, 197, 140, 35, 26, 90}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 144, 1, 172, 50, 172, 48, 137, 167}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 39, 61, 56, 150, 114, 123, 5, 109, 14}, 181},
	{{104, 64, 0, 0, 0, 0, 76, 187, 68, 241, 103, 209, 134, 95, 59, 22}, 181},
	{{104, 64, 0, 0, 201, 4, 8, 242, 1, 151, 3, 158, 130, 160, 214, 89}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 219, 174, 215, 60}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 60, 89, 71, 221}, 181},
	{{104, 64, 206, 5, 198, 84, 91, 207, 97, 203, 80, 162, 87, 245, 193, 230}, 181},
	{{104, 64, 0, 0, 0, 0, 73, 72, 65, 57, 104, 207, 143, 88, 117, 201}, 181},
	{{104, 64, 0, 0, 0, 173, 6, 35, 93, 67, 59, 83, 122, 214, 73, 186}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 175}, 181},
	{{104, 64, 0, 114, 164, 129, 157, 27, 100, 44, 11, 195, 0, 54, 203, 3}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34}, 181},
	{{104, 64, 0, 0, 0, 180, 101, 184, 88, 80, 103, 229, 77, 145, 39, 50}, 181},
	{{104, 64, 0, 0, 8, 92, 235, 136, 92, 234, 175, 115, 1, 24, 61, 91}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 202, 202}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 49, 162, 19, 114, 213, 138, 102, 119}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 171, 164, 165, 174, 3, 230, 244, 16, 186}, 181},
	{{104, 64, 0, 216, 123, 50, 138, 47, 4, 118, 7, 221, 143, 48, 68, 183}, 181},
	{{104, 64, 0, 204, 200, 236, 92, 6, 148, 126, 22, 246, 193, 83, 53, 190}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{104, 64, 0, 0, 0, 219, 5, 9, 238, 162, 206, 77, 17, 124, 196, 187}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 244, 180}, 181},
	{{104, 64, 0, 92, 30, 100, 21, 209, 10, 159, 184, 144, 120, 140, 90, 130}, 181},
	{{104, 64, 0, 0, 141, 25, 52, 189, 255, 0, 40, 12, 140, 80, 50, 167}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 253, 117, 49, 162, 17, 165, 33, 86, 174}, 181},
	{{104, 64, 0, 0, 0, 0, 247, 203, 151, 231, 161, 16, 117, 225, 122, 8}, 181},
	{{104, 64, 0, 0, 0, 39, 245, 139, 38, 27, 3, 198, 20, 50, 65, 225}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 242, 105, 168, 72}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 85, 70, 82, 214}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 0, 22, 63}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 10, 129, 6, 254, 72, 104}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 56, 178, 218, 218}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 138, 105, 6}, 181},
	{{104, 64, 0, 0, 0, 0, 78, 233, 219, 158, 228, 78, 209, 171, 254, 150}, 181},
	{{104, 64, 111, 199, 193, 45, 5, 159, 44, 169, 182, 44, 15, 211, 250, 24}, 181},
	{{104, 64, 0, 23, 148, 193, 27, 16, 100, 71, 95, 38, 223, 153, 203, 213}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 245, 177, 215, 57, 153, 108}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 113, 214, 216, 165}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{104, 64, 0, 154, 163, 60, 149, 139, 73, 174, 168, 30, 183, 47, 106, 97}, 181},
	{{104, 64, 0, 0, 0, 197, 158, 33, 83, 11, 2, 124, 250, 168, 201, 237}, 181},
	{{104, 64, 0, 98, 104, 45, 81, 196, 233, 134, 179, 197, 66, 249, 167, 9}, 181},
	{{104, 64, 0, 0, 1, 177, 105, 66, 230, 91, 166, 27, 168, 150, 150, 109}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 75, 185, 213}, 181},
	{{104, 64, 0, 0, 0, 172, 167, 163, 157, 206, 233, 151, 245, 82, 171, 56}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 190, 190, 245, 80, 177, 16, 187, 125}, 181},
	{{104, 64, 0, 0, 182, 21, 112, 59, 41, 151, 71, 170, 207, 174, 9, 21}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 242, 30}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 198, 181, 23}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 169, 13, 228, 136, 90, 193, 158, 58, 138}, 181},
	{{104, 64, 0, 211, 216, 60, 54, 117, 77, 124, 82, 36, 94, 207, 151, 244}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 61}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 98, 0}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 70, 94, 171, 219}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 235, 14}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 89, 175}, 181},
	{{104, 64, 0, 0, 0, 121, 161, 154, 101, 50, 241, 250, 191, 239, 126, 253}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 22, 64, 1, 103, 196, 230, 21}, 181},
	{{104, 64, 0, 253, 161, 229, 79, 232, 146, 39, 24, 203, 249, 189, 239, 32}, 181},
	{{104, 64, 68, 174, 112, 245, 0, 16, 211, 77, 208, 34, 235, 188, 155, 182}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 155, 121, 158, 118, 83, 115, 4, 129, 73}, 181},
	{{104, 64, 101, 112, 33, 36, 141, 128, 126, 77, 113, 154, 216, 76, 241, 19}, 181},
	{{104, 64, 0, 180, 251, 87, 117, 124, 66, 222, 148, 163, 234, 217, 203, 185}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 92, 54, 88}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 130}, 181},
	{{104, 64, 0, 0, 0, 0, 163, 165, 50, 112, 76, 28, 208, 232, 33, 24}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 82, 103}, 181},
	{{104, 64, 0, 0, 133, 18, 0, 235, 217, 92, 248, 8, 107, 252, 0, 153}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 230}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 190, 78, 23, 205, 94, 206, 103, 244, 251}, 181},
	{{104, 64, 161, 2, 168, 151, 17, 158, 72, 103, 46, 57, 30, 200, 118, 123}, 181},
	{{104, 64, 0, 0, 217, 10, 18, 243, 172, 201, 207, 26, 12, 194, 143, 240}, 181},
	{{104, 64, 0, 0, 0, 0, 202, 147, 18, 145, 240, 95, 186, 35, 4, 212}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 141, 250, 248, 254, 3, 203, 118}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 149, 50, 36, 115, 27, 86, 241, 241}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 234, 111, 187, 86, 141, 198, 213, 94}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 221, 67}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 67, 24}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 153, 226, 162}, 181},
	{{104, 64, 0, 0, 0, 0, 0, 0, 0, 0, 202, 106, 38, 37, 169, 73}, 181},
	{{104, 64, 0, 0, 208, 245, 94, 247, 244, 145, 26, 254, 133, 201, 222, 132}, 181},
	{{104, 64, 0, 0, 116, 200, 104, 203, 236, 11, 141, 88, 85, 127, 129, 17}, 181},
	{{104, 64, 0, 0, 0, 0, 155, 163, 103, 75, 250, 78, 99, 57, 5, 41}, 181},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 184, 194, 86}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 84, 84}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 29, 0, 10, 101}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 204, 198, 2, 23, 151}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 148, 246}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 204, 39, 125}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 227}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 67, 123}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 110}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 237, 188, 244}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 95, 41, 170}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 153, 135, 173, 85}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 251, 175}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 217}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 126, 255, 242, 136}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 111, 65, 162}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 166, 48, 67}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 134, 91, 137, 222}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 242}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 114, 35, 238, 81, 187}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 173, 97, 20, 230, 112, 81}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 212, 84, 247}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 239, 148, 142, 83, 212}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 116, 6, 49}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 119, 145, 210, 108}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 29, 130, 10, 235}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 53, 154, 145, 227}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 56, 55, 33}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 62, 252}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 175, 142, 209, 137, 62}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 159, 207, 145, 225}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 118, 238, 172, 195, 183}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 170, 162}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 141, 104, 39}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 248}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 204, 69, 240, 125, 7}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 173, 165}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 79, 35, 38}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 53, 10, 199}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 224, 127}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 185, 154, 130, 93}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 189, 65, 176}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 73}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 247}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 40, 187, 53}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 152, 178, 21}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 253}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 246, 239, 71}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 158, 22}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 55, 182, 46, 58}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 100, 167, 150, 6}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 31, 185, 225, 53}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 250}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 63, 86, 76}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 176, 65}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 218, 138}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 229}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 118, 7}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 177, 131, 139, 123, 101}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 152}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 63}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 210, 90, 52, 203}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 69}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 173, 203, 83, 201}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 113, 82, 90, 170}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 64}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 77, 95, 209, 41, 61}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 31, 24, 190, 56}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 153}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 154, 68, 100, 180}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 231, 153}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 6, 61, 58, 223}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 144, 195, 224, 18}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 188, 39, 203, 55, 191}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 234, 185}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 173, 198}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 161, 68, 65, 198, 121}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 242}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 172, 124, 167}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 6, 69, 165, 173}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 0, 0, 0, 0}, 110},
	{{205, 35, 123, 178, 36, 64, 62, 153, 195, 250, 0, 0, 146, 201, 246, 118}, 110},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 124}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 231, 80, 84, 170}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 76, 25, 181}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 80, 29, 76, 147}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 57, 0, 84}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 79, 206, 190, 165}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 57, 171, 223}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 82, 203, 72}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 136, 32, 208, 36, 23}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 153, 54}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 4, 97, 180}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 144, 206, 132}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 67, 200, 31, 233}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 99, 24, 21, 82}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 229, 128, 208}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 29}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 130}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 81, 23}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 139}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 4}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 233, 228, 136}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 97, 212, 91}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 103}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 241, 130, 101}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 125, 84}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 86, 48, 4, 106}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 188}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 226, 229, 30}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 79, 121}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 7}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 107, 223, 231}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 127, 131, 101, 155}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 138, 74, 108}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 255}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 16, 18, 30, 249}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 100, 1, 230}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 121}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 11, 111}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 133, 179, 174, 177}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 96}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 233}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 163, 50, 85}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 253, 145, 37}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 137, 72}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 206, 210, 254}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 20, 134, 221, 159}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 37, 192, 228, 126}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 136, 158}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 68, 58}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 138, 228, 24}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 87, 53}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 23, 73, 106}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 27}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 118, 116}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 25, 147, 137, 32}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 182, 53, 34, 144}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 161, 194, 142}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 216}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 134, 170, 142, 83}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 187, 21, 6}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 1, 76, 74, 252}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 130}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 223, 201, 51, 80, 78}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 91}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 255, 202}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 52, 210}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 220, 23}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 215, 95, 84, 255}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 0}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 100}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 192, 179, 159}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 198}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 48, 23, 188, 92}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 0, 0, 251}, 103},
	{{117, 40, 57, 157, 138, 160, 223, 59, 155, 145, 64, 0, 0, 128, 226, 215}, 103},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{74, 166, 140, 146, 74, 72, 229, 99, 167, 124, 107, 117, 217, 14, 246, 64}, 218},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 64, 162, 120, 240, 225}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 136, 168, 27, 78, 29}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 213, 204, 155, 145, 135}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 188, 81}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 152, 153}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 194, 42, 73, 74}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 204, 224, 181, 33, 32, 59, 215, 151}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 125, 145, 16, 250, 194, 126}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 200, 152, 108, 178}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 76, 196, 217, 173, 104}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 74, 167, 48, 251}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 76, 146, 154, 131}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 93, 234, 196, 198}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 95, 115, 91, 36}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 180, 196, 134, 76, 158, 122}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 207, 156, 216}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 209, 41, 194, 73, 42, 208, 29, 80}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 51, 82, 8, 148}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 254, 179}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 223, 115, 25, 58, 232, 44}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 33, 214}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 218, 93}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 62, 201, 224, 23}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 89, 207, 106, 124, 142, 170, 245}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 101, 22, 165, 43, 21, 48, 132, 145}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 109, 157, 216}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 8}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 237, 229, 9}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 16, 122, 153}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 115, 117, 21, 73}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 200, 89, 27, 156, 103, 100, 12, 178}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 252, 247, 239, 215, 91, 171, 27}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 236, 131, 76}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 34}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 52, 130, 124, 100, 26, 44, 69, 226}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 76, 201, 123, 177, 63}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 9}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 211, 124, 53}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 22, 72, 104, 165}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 84, 26, 20, 151, 35, 113, 72, 83}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 177, 39}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 11, 127}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 141, 243, 66, 116, 27, 29}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 230, 145, 136, 147, 133, 57, 5, 224}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 207, 21, 31, 233, 181, 239, 59, 68}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 33, 118}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 238}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 222, 18}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 68, 138}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 12, 191, 129}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 93, 154, 254, 36, 231}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 138, 203, 50}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 43, 20, 231, 213}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 121, 143, 109, 120, 59, 192, 70}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 54, 98, 199, 246, 5, 253, 56, 193}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 216, 226, 233, 94, 254, 126}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 146, 93, 122, 89, 3, 116}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 104, 244, 37, 180, 252}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 242, 131, 203, 138, 112}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 23, 58, 120, 129, 61, 33, 31}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 48, 46, 106, 221, 109}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 206, 250}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 58, 25, 168, 236, 14, 163, 89}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 47, 123, 239, 55, 183, 129, 158}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 242, 22, 116, 104, 26}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 65, 2, 176, 9, 34}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 234, 6, 93, 11, 62, 92, 150}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 32, 169, 87, 46}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 239, 186, 55, 191, 84, 21}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 223, 224, 226, 179, 187, 191}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 242, 15, 93, 217, 244, 232, 211}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 79, 20, 35}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 239, 115, 185}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 213, 229, 111, 31, 166, 5, 118}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 95, 137}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 6, 242, 105, 93}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 252, 239, 156, 199, 9}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 0, 101, 124}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 101, 240, 222}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 4, 34, 216, 13}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 0, 49, 142, 218}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 123, 194, 219, 69, 48}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 154, 63, 82, 231, 52, 186, 135}, 146},
	{{12, 222, 244, 183, 83, 146, 42, 0, 0, 0, 0, 0, 7, 207, 20, 190}, 146},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 39, 188, 32, 199, 128, 156}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 151, 192, 247, 242, 97}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 129, 202}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 131, 167, 186, 70, 181}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 24}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 180, 80}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 235, 31, 1}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 165, 205, 218, 81, 26, 123}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 10, 188, 7}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 79, 63, 123}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 51, 6, 113, 71, 185, 25}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 97, 19, 122, 220}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 160}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 95, 248, 39, 249, 225}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 196, 245}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 151, 168}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 62, 176}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 138, 200, 170, 227, 181, 60}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 31, 118, 199, 182}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 228}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 54}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 6, 158, 31, 36, 114, 49}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 134, 97, 102, 45, 85, 149}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 222, 193, 65, 28}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 17, 101, 192, 145, 115, 210}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 166, 19, 224, 227, 185, 168}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 88, 149, 180, 20, 41}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 44, 250, 15}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 39, 46, 5, 82, 36, 156}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 1, 229}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 64, 226, 128, 11, 178, 175}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 184, 113}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 195, 144, 28, 66, 173, 241}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 48, 173, 140, 25}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 250, 90, 119, 185, 30, 26, 199}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 125, 140}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 61, 171, 123, 76, 164}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 141, 203, 67, 117, 75, 173, 27}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 59, 25, 253}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 42, 230, 32}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 171, 232, 2, 197}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 152}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 8, 183, 28, 88}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 123, 84, 122, 60}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 106, 180, 200, 219, 86}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 114, 63, 75, 21, 132, 226}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 242, 38, 82}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 114, 32, 117, 58, 148, 19}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 169, 20, 173}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 155, 17, 151, 147, 68, 151, 242}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 166}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 144, 53}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 24, 250, 23, 114, 188, 94, 130}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 7, 232, 210, 255, 218, 85}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 29}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 99, 19}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 235, 185, 247, 156}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 251, 150, 147, 22}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 111, 27}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 164, 233, 21, 190, 251, 34}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 204, 166, 204, 243, 79}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 135, 169, 158, 92}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 206, 26}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 105}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 230}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 251, 86, 93, 98, 137, 135}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 163, 179, 223}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 187, 23, 114, 165}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 219}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 49}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 245, 87}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 55, 130, 197, 81, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 142, 150, 209, 249, 107, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 174, 134, 152, 37, 241}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 239}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 181, 116, 18}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 202, 153}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 38, 237, 202, 11, 180, 115}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 107, 173}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 210, 231, 200}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 32, 17}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 94, 87, 63, 3, 216}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 97, 7, 212}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 39, 20, 57}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 0, 0}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 0, 0, 0, 113, 190}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 0, 0, 16, 192, 219, 160, 58}, 90},
	{{11, 98, 146, 110, 95, 96, 80, 142, 224, 62, 138, 243, 156, 201, 138, 79}, 90},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 159}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 91}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 136}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 198, 231}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 64, 153}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 50}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 251}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 168}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 19}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 43}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 26, 11}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 127, 84}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 68, 78}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 129}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 183}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 44, 214}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 134}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 215}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 174, 243}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 113}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 31}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 103}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 133, 181}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 153}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 13}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 159}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 204}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 113}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 231, 162}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 246, 234}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 73}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 67}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 135}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 124}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 7}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 215}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 6, 254}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 122}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 52}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 121}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 75}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 63, 10}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 164}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 90, 157}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 57}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 210, 153}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 20}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 242, 148}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 166}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 45}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 111}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 226}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 199}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 55}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 35}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 56}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 0}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 0, 29}, 197},
	{{235, 5, 187, 199, 30, 170, 82, 187, 228, 159, 22, 25, 204, 112, 109, 166}, 197},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 255, 105}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 121, 213}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 185, 95}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 194}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 35, 194}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 95, 195}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 246, 45}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 227}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 81, 117}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 58}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 68}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 231, 72}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 161, 63}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 39}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 127}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 37, 198}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 93}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 67, 50}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 252}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 230, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 230, 124}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 62, 213}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 249}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 155}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 38}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 135, 167}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 155}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 108, 228}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 204}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 48}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 202}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 242}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 153}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 7}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 118, 143}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 118, 244}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 186}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 131, 232}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 113, 173}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 167, 76}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 29, 187}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 33, 133}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 89}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 221, 42}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 109, 110}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 85, 30}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 87}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 126, 194}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 70}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 148}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 48}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 31, 135}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 131}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 79, 177, 170}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 74}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 56, 229, 251}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 28, 146}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 91}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 62, 254}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 219, 64}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 246, 146}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 98}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 77, 146}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 40}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 50}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 25, 199}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 35}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 88}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 246, 111}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 15, 225, 230}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{35, 96, 146, 145, 155, 116, 252, 181, 29, 205, 230, 246, 30, 0, 0, 0}, 158},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 196, 102}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 11, 142, 83}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 226, 124, 18}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 158, 28}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 67, 163, 84, 224}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 25, 242, 222, 21}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 27}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 152, 136, 119, 162, 51}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 181, 61}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 8, 95}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 59}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 143, 84, 244, 212}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 50, 238, 95, 246}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 111, 228}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 205, 84}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 50, 196, 80, 122}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 197, 125, 34}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 178, 178}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 21, 244, 174, 181}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 30, 116}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 109}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 158, 65, 25, 4}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 224}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 179, 254}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 246, 220, 36, 48, 254}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 149, 177, 63, 123}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 241, 178, 247}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 253, 193, 248, 82}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 21, 162}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 94, 226, 129, 115}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 6, 58, 231}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 36, 125, 9, 15, 74}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 146, 166, 236}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 221, 159, 164}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 208, 245, 219, 9}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 195, 35}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 70}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 160, 38, 231, 166}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 101, 22, 51, 158}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 16, 42, 154, 159, 170}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 22, 151}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 31, 222, 218, 111}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 218, 214, 157, 223, 33}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 105, 135}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 204, 251, 237, 186, 17}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 177, 182, 167, 243}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 226}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 122, 193, 225}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 207, 119, 102, 3, 248}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 63}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 134, 46}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 129, 196, 103}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 229, 201, 51}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 207, 114, 169, 8}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 200}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 188, 239, 86}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 229}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 178, 105}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 93, 164}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 116, 240, 201}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 255, 40}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 178, 58, 219}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 212, 120, 130, 253}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 189}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 204}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 155, 194, 145}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 254, 164}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 172, 255, 253, 12}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 243}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 137, 67, 57, 40, 50}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 121, 84, 25}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 160, 168}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 108, 207, 90}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 220, 51, 123, 135, 237}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 163, 252, 239}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 5, 178, 238}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 106, 247, 113, 71, 77}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 7, 91, 151, 192}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 90, 46, 172, 37}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 227, 186, 208, 255}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 0}, 118},
	{{174, 38, 56, 244, 227, 102, 252, 237, 128, 86, 0, 0, 0, 0, 0, 152}, 118},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 26, 184, 12, 216, 134, 71, 176}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 40, 95, 41, 194}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 202, 185, 218, 117, 46, 207}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 24, 69, 63, 186, 182}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 54, 247, 8, 244, 42, 148}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 136, 183, 101, 194, 249}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 88, 159, 106}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 39}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 108, 111, 78, 128, 53, 51, 218}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 79}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 48, 243, 191, 10, 118, 251, 164}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 199, 57, 145, 255, 34, 236}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 20, 108, 251}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 99, 200, 230, 3}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 74, 158, 50, 202, 15, 201}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 139, 16, 249, 121, 83, 0, 113}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 142, 165, 56, 60, 149, 203, 171}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 43, 170, 26, 90, 172, 251}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 142, 253, 27}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 109, 76, 215, 146}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 89, 76, 172, 212, 141, 80, 160}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 166, 7, 135, 75, 107, 52}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 127, 225, 106}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 52, 16, 56, 242, 130, 28, 41}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 222, 221, 178, 7, 0, 139, 79}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 26, 185, 151}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 241, 107, 21, 54, 67, 118, 234}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 144, 33, 51, 101}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 180, 199, 97, 146, 241}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 83, 150, 233}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 227, 16, 31, 254, 1, 234}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 65, 206, 1, 252, 207, 190}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 231, 5}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 13, 207}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 122, 193, 88, 219}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 42, 205, 193}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 70, 233, 220, 229, 39, 51}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 28, 42}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 152, 24, 108, 220, 155, 193, 134, 103}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 196, 123}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 13, 240, 60, 127, 71, 206, 193}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 187, 225, 95, 66, 27}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 243, 116, 219}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 220, 176, 25}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 138, 207, 185}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 110, 133, 207, 47, 225, 171}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 72, 235, 212, 47, 229}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 25, 40, 202, 4, 60}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 56, 209, 93, 157, 128, 255, 33, 68}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 48, 173, 244, 213, 182, 1}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 141, 183}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 100, 233, 147, 70, 129, 153, 218, 197}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 83}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 136, 200, 68, 188}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 9, 134, 221, 94, 211}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 195, 61, 58, 59}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 226, 156, 254, 108, 232}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 208, 84}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 244, 170}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 26, 35, 80, 99, 244, 245, 86}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 14, 220, 230, 107, 165, 59}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 244, 217, 252, 61}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 175, 124, 82, 143}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 213, 10, 92, 1}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 235, 27, 128, 39, 75}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 196, 83, 59, 229, 193}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 163}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 34, 153, 194, 14, 10, 115, 160}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 97, 132}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 95, 141, 38, 52, 85}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 205, 104, 93, 140, 121}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 198}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 86, 62, 34, 250, 163, 203, 50}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 55}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 180, 45, 210}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 169, 78}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 115, 97, 169, 13, 21}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 253, 135, 21, 13}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 150}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 100}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 30, 122, 189}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 233, 58, 241, 38, 87, 112}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 207, 85, 102}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 82, 92, 32, 158}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 207, 8, 164}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 0, 0, 0, 181, 140, 226}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 141, 31, 10, 102, 148, 32}, 95},
	{{65, 134, 37, 58, 90, 125, 60, 84, 0, 0, 80, 152, 172, 248, 206, 231}, 95},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 82, 166, 177}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 209, 53, 231, 16, 126, 110, 249, 179, 190}, 152},
	{{253, 117, 135, 98, 128, 1, 123, 168, 114, 207, 183, 76, 96, 255, 130, 118}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 130}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 50, 234, 0, 182, 213}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 212, 219, 83, 16, 206, 45}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 48, 49, 105, 7, 173, 212}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 104}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 156, 110, 43, 184, 248, 225, 5, 73}, 152},
	{{253, 117, 135, 98, 128, 151, 166, 193, 16, 92, 174, 32, 28, 237, 49, 235}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 200, 144, 4}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 171, 163, 26, 118}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 201, 41, 218, 152, 27}, 152},
	{{253, 117, 135, 98, 128, 0, 238, 106, 150, 82, 35, 73, 73, 91, 67, 198}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 109, 94, 220, 234}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 1, 237, 39, 138, 240, 97, 34}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 102, 32, 49, 75}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 151, 34, 102, 20, 2, 18, 149, 227, 148}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 110, 179, 119, 218, 177, 159, 52}, 152},
	{{253, 117, 135, 98, 128, 0, 202, 198, 246, 118, 175, 137, 77, 137, 88, 63}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 245, 219, 209, 198, 48, 15, 25, 123, 147}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{253, 117, 135, 98, 128, 0, 144, 229, 128, 62, 33, 124, 240, 235, 105, 198}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 172, 144, 57, 123, 7, 170, 174, 121, 241}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 48, 181, 93, 192, 59, 172, 34, 97}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 52}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 42, 127, 61, 46, 161, 119}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 181, 144, 7, 201}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 190, 36, 206, 116, 92, 210}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 229, 117, 180, 148, 65, 105, 25}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 78, 250, 106, 79}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 39, 22, 222, 251, 72, 239, 226}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 132, 80, 227, 45}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 157, 32, 184, 254, 73}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 126, 193, 113, 213, 169}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 108}, 152},
	{{253, 117, 135, 98, 128, 0, 19, 172, 48, 17, 176, 202, 44, 76, 199, 157}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 52, 191, 218}, 152},
	{{253, 117, 135, 98, 128, 0, 201, 180, 101, 168, 155, 49, 38, 30, 88, 27}, 152},
	{{253, 117, 135, 98, 128, 69, 130, 81, 248, 211, 22, 148, 113, 49, 143, 207}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 178, 91, 48}, 152},
	{{253, 117, 135, 98, 128, 69, 75, 185, 88, 221, 209, 39, 196, 40, 224, 11}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 128, 130, 142, 140, 12, 236, 66, 147}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 82, 196, 218, 172, 60}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{253, 117, 135, 98, 128, 156, 128, 234, 73, 168, 106, 8, 215, 95, 135, 208}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 137, 158, 30}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 232, 232, 239, 18, 32, 167, 172}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 162, 186, 113, 64, 164, 106}, 152},
	{{253, 117, 135, 98, 128, 205, 48, 4, 27, 90, 183, 116, 238, 193, 98, 220}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 15, 26, 254, 211}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 137, 227, 143, 58, 2, 136}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 138}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 20, 99, 163, 234}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 148, 212, 251, 108, 15, 200}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 211, 102, 112, 204, 91, 206, 211}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 48, 79, 185, 166, 26}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 133, 212, 175, 29}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 69, 48, 82, 112, 38}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 160}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 240}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 178, 148, 7}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 108, 83, 62, 183, 63, 108, 148, 139}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 221, 1, 182, 95, 89, 149, 185, 65}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 20, 115, 67, 245}, 152},
	{{253, 117, 135, 98, 128, 0, 208, 81, 213, 216, 86, 2, 59, 136, 52, 138}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 53, 48, 46, 227}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 210, 117, 30, 177, 87, 165, 30, 44, 40}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 248, 80, 217, 49, 37, 192}, 152},
	{{253, 117, 135, 98, 128, 107, 53, 76, 121, 68, 203, 0, 233, 40, 115, 114}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 109, 20, 114}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 63, 43, 75, 201, 1, 20, 167, 157, 120}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 170, 225, 172, 96, 155}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 215, 11, 250, 91, 87, 103, 140}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 130, 97, 170, 150}, 152},
	{{253, 117, 135, 98, 128, 39, 112, 78, 144, 51, 69, 53, 197, 76, 111, 208}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 168, 192, 191, 87, 36}, 152},
	{{253, 117, 135, 98, 128, 0, 22, 144, 253, 232, 138, 123, 70, 69, 145, 72}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 15, 205, 65, 101, 182}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 152},
	{{253, 117, 135, 98, 128, 58, 208, 25, 223, 43, 108, 226, 71, 147, 127, 44}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 203, 174, 177, 11}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 142, 202, 30, 236, 60}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 23, 73, 205}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 158, 128, 168}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 190}, 152},
	{{253, 117, 135, 98, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 152},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 117, 64, 104, 125, 123, 57}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 214, 213, 59, 30}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 222, 93, 30, 171, 224, 244, 166, 102, 135}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 234, 94, 251, 127, 247, 16, 100, 76}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 12, 173, 54, 190, 42}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 86, 84, 8, 94, 230, 198, 190, 120, 172}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 102, 176, 57, 141, 58, 238}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 76, 255, 230, 129, 96, 133, 11}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 247, 41, 201, 61}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 204, 177, 54, 9, 233, 38}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 115, 212, 235, 193, 35, 73, 235, 123}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 204}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 226, 16, 124, 38, 184, 32}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 166, 97, 137, 44, 70, 36, 100, 249, 159}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 175}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 143, 208, 195, 167, 6, 174, 157, 22}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 147, 122, 178, 184, 201, 229, 109, 14, 110}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 5, 132, 139}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 95, 193, 55, 254, 233, 225, 78, 10}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 17, 197, 40}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 250, 167, 198, 119, 162}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 161, 35, 183, 145, 98, 11, 154}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 233, 52, 163, 85, 168, 140}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 48, 171, 124, 197, 23, 73, 171, 18, 189}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 86, 111, 11, 231, 111, 210}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 142, 93, 195, 59, 201, 176}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 103}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 169, 241, 39}, 239},
	{{111, 115, 188, 184, 130, 0, 61, 237, 4, 54, 120, 77, 226, 86, 39, 128}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 79, 229, 152, 44, 75, 160, 20}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 152, 1, 9, 154}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 44, 27, 177, 63, 218, 161}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 138, 186, 227, 184, 128, 241, 129, 104, 120}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 162, 156, 14, 3, 214, 183}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 152, 86, 168}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 252, 244, 152, 212, 184, 222}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 237, 73, 12, 1, 219, 119}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 114, 186, 184, 88}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 134, 11, 97, 106}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 210, 203, 215, 26, 212, 239, 143, 103, 158}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 87, 62, 133, 101}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 45}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 118, 12, 20}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 184, 13, 207, 41, 154, 106, 39, 104, 108}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 249}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 2, 166, 66, 51, 235, 76, 118, 43}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 226, 241, 0}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 12, 23, 101}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 197, 238, 143, 232, 87}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 62, 85, 75, 153}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 36, 240, 55, 46, 156, 6, 246}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 236, 160, 75}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 69, 206, 34, 213, 49, 56, 95, 28, 190}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 10, 32, 235, 113, 239}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 133, 102, 168, 199, 89, 34, 31, 247, 52}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 128, 63, 254, 27, 203, 51, 242}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 172, 105, 80, 56}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 148}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 196}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 17, 25, 5, 6, 48}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 25}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 205, 0, 210, 116, 147, 49, 248}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 12, 135, 180, 100}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 99, 110, 147, 66, 181, 253, 72, 77}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 42}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 34, 217, 38, 58}, 239},
	{{111, 115, 188, 184, 130, 0, 208, 110, 186, 89, 45, 135, 192, 209, 118, 195}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 163, 238, 108, 125, 151, 48}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 229, 215, 73, 206, 134, 10}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 34, 44, 46, 162, 218, 112, 39, 96, 196}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 224, 155, 14}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 73, 86, 5, 103, 125}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 48, 70, 39, 85, 105}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 24, 38, 62, 4, 113, 162}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 239},
	{{111, 115, 188, 184, 130, 0, 0, 0, 150, 107, 213, 106, 166, 139, 224, 139}, 239},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 107, 152, 222, 117, 83, 224}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 2, 219, 254, 49, 116, 134}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 248, 81, 212, 94}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 184}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 60, 36, 246, 249}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 2, 137}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 58, 215, 162, 48, 128, 200, 134}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 85, 28}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 33, 194, 120, 177, 252, 111, 250, 26, 190}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 93, 63, 104, 227, 121, 100, 104}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 2, 158, 114, 41, 193, 252, 98}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 42, 71, 184, 85, 114}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 104, 193, 192, 45, 210, 223, 38}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 225, 105}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 230, 109, 255, 44, 223, 68, 244, 170}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 49, 218, 227}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 46, 244, 253, 222, 164, 110, 183, 20}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 131, 128, 202, 122, 227, 45}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 118, 91}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 203, 196, 149, 159, 23, 243}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 99, 174, 82, 248, 16, 215}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 109, 82, 246, 214, 226, 15, 25}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 85, 162, 66, 217}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 156, 237, 8, 215, 204}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 220, 223, 67, 239, 37, 217}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 25, 104, 34, 111}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 171, 94}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 67}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 68, 21, 248}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 245, 160, 80, 84}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 33, 38}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 190, 197, 137}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 174, 119}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 103, 1, 148, 146, 108, 164, 130, 127, 17}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 225, 39, 98}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 164, 72, 24, 87, 143, 22, 225, 13, 125}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 59, 213, 49, 88, 140, 2, 78, 212, 135}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 102, 88, 46}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 1, 24, 131, 121, 191, 22, 126, 54}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 48, 87}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 40, 229, 139, 184, 254, 182, 21, 92, 207}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 173, 247, 222, 143, 182, 67, 84, 222, 119}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 115, 232, 213, 133, 165, 60, 234}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 162, 67, 59}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 160, 191, 154, 93, 51, 29, 12, 58, 241}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 10, 254, 170, 229, 162, 54, 4, 14}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 165, 246, 14, 94}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 216, 122, 34, 161}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 155, 51, 170, 55, 30, 73, 227, 58}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 232}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 176, 181, 57, 169, 241, 10, 184}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 153, 171, 132, 133, 151, 33, 89}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 3, 38, 2, 251, 235, 67, 92, 99}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 75, 41, 15, 72, 104, 176}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 155, 130, 41, 48, 66, 70}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 120, 253, 24, 253}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 145, 26, 40, 76, 10}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 175, 115, 187, 102, 238}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 92, 205, 187, 189, 156, 142}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 23, 212, 47, 95}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 75, 2}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 60, 145, 214}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 255, 2}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 48, 77, 139, 100, 193, 5}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 117, 247, 142, 56, 113}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 102, 207, 33}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 202, 247, 172, 158, 218, 4}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 115, 38, 10, 97, 189, 35}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 143, 94, 14, 48, 114}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 84, 98, 169, 224, 31, 7, 169, 216}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 69, 237, 92, 66, 107, 34, 151, 171, 228}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 90, 169, 137, 252, 166, 32, 179, 250}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 174, 155, 212, 150, 221, 155, 182, 124, 41}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 210, 47, 57, 145, 205, 247, 107, 142}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 43, 20, 16, 222, 147, 145}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 119, 125, 120, 231, 196, 165}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 109, 50, 141, 173, 233, 172}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 31, 71, 84, 229, 199, 93, 83, 148, 65}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 137, 45, 155, 99, 221}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 103, 71, 0, 218, 169, 164}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 101, 50, 216, 144, 72, 108, 119, 54}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 15, 99, 133, 173, 248, 34}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 164, 232, 148, 25, 109, 211, 60, 171, 217}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 0, 0, 0, 0, 0, 0, 137, 12, 130}, 48},
	{{202, 24, 89, 9, 149, 45, 64, 191, 54, 230, 239, 1, 90, 40, 128, 199}, 48},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 182, 181, 90, 176, 145, 117}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 166, 133, 212, 4, 181, 170, 169, 120, 53}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 106, 126}, 61},
	{{0, 0, 89, 235, 254, 0, 4, 110, 97, 168, 51, 166, 54, 210, 11, 60}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 19, 131}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 28, 138, 248, 197, 158}, 61},
	{{0, 0, 6, 173, 6, 167, 179, 13, 181, 207, 224, 128, 36, 117, 21, 218}, 61},
	{{0, 0, 0, 0, 0, 178, 113, 92, 82, 76, 227, 60, 40, 206, 90, 52}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 9, 240, 165}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 61},
	{{0, 0, 0, 0, 8, 61, 130, 211, 122, 64, 123, 78, 244, 238, 241, 172}, 61},
	{{0, 0, 0, 187, 83, 173, 113, 104, 85, 25, 18, 87, 28, 144, 217, 87}, 61},
	{{0, 0, 0, 0, 0, 0, 104, 196, 231, 158, 144, 139, 186, 184, 209, 52}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 164}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 117, 229, 66, 174}, 61},
	{{0, 0, 0, 0, 24, 131, 44, 226, 10, 187, 36, 198, 254, 58, 203, 214}, 61},
	{{0, 0, 0, 0, 0, 0, 179, 113, 194, 134, 136, 38, 43, 9, 171, 119}, 61},
	{{0, 0, 0, 0, 0, 160, 106, 255, 7, 81, 123, 234, 147, 86, 74, 32}, 61},
	{{0, 0, 0, 0, 148, 164, 143, 90, 210, 178, 92, 150, 140, 1, 219, 238}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 61},
	{{0, 0, 0, 0, 233, 92, 97, 94, 76, 132, 35, 15, 231, 13, 81, 137}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 232, 49, 102, 48}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 97}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 10, 240, 95, 151, 63, 72, 62, 67}, 61},
	{{0, 0, 0, 0, 0, 47, 1, 25, 7, 146, 52, 146, 117, 196, 111, 238}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 228, 245, 197, 174, 233, 176}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 21, 249, 228}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 7, 168, 219, 239}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 131, 181, 242, 17, 189, 182, 67, 201}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 12}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 107, 192, 170, 99, 29}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 147, 139, 124, 50, 235}, 61},
	{{0, 0, 237, 209, 185, 171, 36, 247, 117, 250, 58, 129, 77, 7, 188, 254}, 61},
	{{0, 0, 0, 0, 0, 74, 198, 137, 179, 49, 27, 105, 120, 220, 18, 66}, 61},
	{{0, 0, 157, 189, 237, 162, 87, 216, 11, 92, 48, 182, 79, 101, 78, 49}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 230, 120}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 141}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 185, 28, 213}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 13, 178, 4, 45, 29}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 137, 184}, 61},
	{{0, 0, 0, 0, 0, 0, 222, 20, 51, 92, 245, 149, 75, 4, 254, 104}, 61},
	{{0, 0, 0, 0, 141, 70, 110, 173, 214, 23, 17, 92, 131, 254, 246, 136}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 206, 191, 147, 210}, 61},
	{{0, 0, 0, 0, 0, 147, 67, 72, 118, 58, 145, 69, 207, 103, 179, 218}, 61},
	{{0, 0, 0, 0, 235, 215, 53, 96, 148, 217, 78, 66, 41, 150, 60, 76}, 61},
	{{0, 0, 0, 0, 113, 30, 52, 243, 247, 142, 189, 125, 31, 194, 41, 150}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 78, 253, 138, 127, 130, 62}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 43, 184, 82, 6, 252, 65}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 246, 230, 214, 30, 205, 17, 91, 219}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 34, 132, 82, 218, 95, 77, 239, 3, 209}, 61},
	{{0, 201, 138, 114, 50, 0, 8, 219, 6, 34, 74, 11, 87, 114, 89, 232}, 61},
	{{0, 0, 230, 195, 78, 142, 143, 86, 192, 34, 168, 253, 37, 29, 53, 213}, 61},
	{{0, 0, 0, 139, 73, 229, 191, 127, 217, 113, 230, 237, 156, 8, 235, 129}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 61},
	{{0, 0, 0, 0, 33, 97, 174, 235, 50, 76, 12, 93, 72, 79, 216, 120}, 61},
	{{0, 23, 231, 43, 50, 86, 171, 71, 156, 107, 152, 140, 60, 109, 198, 182}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 6, 155}, 61},
	{{0, 0, 0, 0, 103, 13, 253, 250, 53, 118, 230, 192, 234, 110, 157, 48}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 107, 255, 178, 232, 247, 225, 119, 77, 76, 192, 77, 162}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 116, 207, 169, 205, 183, 60, 17, 250}, 61},
	{{0, 0, 0, 0, 0, 0, 11, 246, 224, 240, 130, 26, 249, 48, 111, 82}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 30, 57, 187, 22, 215, 149, 197, 109, 80}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 234, 200}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 240, 169, 115, 53, 155}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 61},
	{{0, 0, 0, 0, 0, 62, 182, 81, 239, 58, 184, 68, 223, 126, 68, 15}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 240, 73, 255, 46, 44}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 7, 169}, 61},
	{{0, 0, 0, 0, 97, 161, 198, 232, 78, 239, 34, 143, 232, 151, 47, 236}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 88, 228, 90, 240}, 61},
	{{0, 0, 0, 227, 28, 227, 219, 96, 150, 225, 52, 38, 194, 134, 231, 87}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 128, 42, 243, 179, 119, 40, 116, 124, 121}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 251, 123, 153, 183}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 24, 132, 178, 185, 187, 13}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 196, 119, 226, 232, 131}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 208, 160, 104, 52, 163, 222}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 9, 144, 24}, 61},
	{{0, 0, 189, 2, 168, 56, 236, 115, 156, 206, 17, 126, 94, 125, 86, 218}, 61},
	{{0, 0, 0, 0, 232, 216, 25, 46, 122, 147, 255, 72, 144, 56, 46, 240}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 61},
	{{0, 0, 0, 145, 126, 64, 15, 153, 195, 56, 60, 8, 106, 141, 169, 135}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 153, 163, 4, 237, 72, 140, 188, 30, 8}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 119, 62, 124}, 61},
	{{0, 0, 128, 46, 155, 236, 98, 164, 179, 59, 139, 53, 213, 18, 84, 106}, 61},
	{{0, 0, 0, 0, 0, 226, 140, 68, 43, 32, 212, 171, 36, 182, 244, 161}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 50, 50, 10}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 121, 188, 42, 128, 53, 170, 132, 98, 216}, 61},
	{{0, 0, 0, 0, 0, 196, 76, 5, 109, 191, 92, 13, 100, 131, 122, 206}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 169, 198, 154, 34, 187, 18}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 60, 48, 242, 238, 1, 49, 84, 78, 47}, 61},
	{{0, 0, 0, 0, 0, 0, 152, 191, 42, 94, 223, 112, 52, 53, 97, 42}, 61},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 253, 147, 83, 213, 96, 141, 41}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 50, 196, 234, 143}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 63}, 247},
	{{244, 98, 52, 140, 0, 17, 99, 71, 210, 83, 156, 167, 185, 94, 238, 73}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 232, 88, 125, 44}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 233, 12, 234, 224, 236, 224, 196, 45}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 237, 150, 149, 44}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 2, 20}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 44, 71, 172, 205, 97, 47}, 247},
	{{244, 98, 52, 140, 0, 0, 65, 216, 2, 77, 160, 5, 107, 187, 26, 245}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 183, 225, 34, 14, 68, 38, 46, 149}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 22, 213, 11, 34, 143, 117, 34}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 233, 70, 212, 196}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 109, 111, 175, 232, 251}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 92, 217, 245, 244, 153, 21, 58, 128, 254}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 131, 156, 103, 70}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 176, 201}, 247},
	{{244, 98, 52, 140, 0, 180, 79, 197, 24, 159, 58, 173, 137, 77, 119, 253}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 14, 185, 79, 143, 213}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 58, 143, 70, 117}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 244, 96, 115, 189}, 247},
	{{244, 98, 52, 140, 0, 235, 84, 137, 224, 163, 47, 20, 32, 220, 119, 152}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 91, 238}, 247},
	{{244, 98, 52, 140, 0, 0, 91, 125, 202, 217, 214, 93, 58, 234, 238, 43}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 29, 255, 28, 68, 179, 173, 88}, 247},
	{{244, 98, 52, 140, 248, 255, 170, 251, 198, 233, 247, 219, 42, 48, 30, 221}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 178, 70, 142, 230, 156, 159}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 52}, 247},
	{{244, 98, 52, 140, 0, 147, 232, 190, 58, 5, 146, 255, 30, 14, 124, 162}, 247},
	{{244, 98, 52, 140, 129, 69, 131, 33, 126, 240, 131, 2, 173, 188, 125, 217}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 73, 62, 177, 67}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 67, 218, 15, 254, 155, 83}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 55, 167, 61, 99}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 80}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 80, 252, 186, 189}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 235, 156, 65, 57, 32}, 247},
	{{244, 98, 52, 140, 0, 250, 65, 79, 33, 236, 180, 83, 86, 30, 220, 5}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 141, 165, 186, 177}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 210, 46, 193, 34, 69}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 77}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 107, 150, 161, 105, 130, 104, 112, 38}, 247},
	{{244, 98, 52, 140, 0, 106, 148, 151, 32, 4, 10, 216, 135, 66, 224, 152}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 198, 103, 139, 126, 40, 129}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 26, 1, 70, 246, 140, 108}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 204, 235, 36, 11, 12, 158, 128, 161}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 240, 167, 68, 224, 120, 208}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 232, 100}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 89}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 163, 175, 239, 122, 238, 104, 58}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 208, 169, 37, 143}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 217}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 127, 37, 50, 183, 174, 165, 227, 43, 0}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 123}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 53, 80, 252, 240, 69}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 228, 123, 188, 234, 147, 252, 69, 214, 9}, 247},
	{{244, 98, 52, 140, 0, 0, 244, 164, 92, 19, 116, 52, 181, 214, 104, 180}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 235, 191, 223, 178, 141, 184, 53, 151, 58}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 77, 31, 78, 90}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 4, 54, 56, 139, 77, 160, 59, 146, 246}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 163, 254}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 113, 205, 79, 100}, 247},
	{{244, 98, 52, 140, 0, 0, 180, 171, 58, 209, 223, 225, 127, 120, 109, 210}, 247},
	{{244, 98, 52, 140, 0, 0, 220, 243, 232, 153, 122, 177, 82, 147, 112, 224}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 243, 152, 233, 131, 185, 153}, 247},
	{{244, 98, 52, 140, 0, 0, 102, 242, 105, 42, 187, 205, 191, 82, 71, 32}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 88, 81, 105, 55, 78, 237, 115, 203}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 213, 173}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 2, 57}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 7, 94}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 183, 171}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 105, 98, 193, 74, 197}, 247},
	{{244, 98, 52, 140, 0, 142, 150, 88, 236, 182, 175, 132, 242, 45, 74, 253}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 246, 172, 113, 96, 12, 161, 11}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 181, 55, 116, 97, 247, 169, 24, 103}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 61, 175, 130, 225}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 57, 203}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 199, 215, 71, 230, 36, 227, 115, 59}, 247},
	{{244, 98, 52, 140, 58, 251, 10, 230, 249, 228, 63, 7, 67, 0, 74, 152}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 202}, 247},
	{{244, 98, 52, 140, 0, 116, 139, 45, 151, 137, 171, 93, 146, 226, 216, 80}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 110}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 52, 210, 100, 201, 161, 45, 101, 3, 79}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 60, 236, 174, 115}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 154, 27, 66, 227, 89, 223, 63, 133}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 253, 195, 201, 242, 103, 164, 251, 38}, 247},
	{{244, 98, 52, 140, 171, 129, 92, 216, 157, 85, 130, 4, 184, 100, 244, 44}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 164, 92, 255, 39, 103}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 17, 10, 123, 251, 56, 192}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 76, 19, 19, 41, 51}, 247},
	{{244, 98, 52, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 23}, 247},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 159, 48, 218}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 170}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 23, 143, 105, 53}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 67, 15, 235, 87}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 179, 207}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 18, 55, 219}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 114, 236, 34, 72}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 204, 55, 118}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 107, 60}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 128, 166, 30}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 202}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 102}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 113}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 239, 137, 192}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 61, 160, 31}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 111}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 111, 236, 6, 28, 132}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 225, 81, 192}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 98, 214, 56, 167, 246}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 57, 230, 84, 140}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 10}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 164, 199, 43}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 99, 142}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 86, 60}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 177, 193, 122, 127}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 13, 88, 200, 223}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 239, 122, 93, 47}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 204, 83}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 92, 126, 159}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 188, 194, 170, 108}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 169, 255, 25, 49}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 243, 81, 185, 142}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 62, 237, 200, 8, 250}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 235, 197, 69, 59, 219}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 153, 203, 210}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 18, 227}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 207}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 9, 186, 26, 175}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 207, 255, 163}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 172, 17, 239, 9, 107}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 34, 183, 40}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 97, 28, 29}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 18, 124, 99, 185}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 36, 244, 130}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 166, 87, 73, 175, 193}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 13}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 4, 48}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 113, 107, 166, 139, 34}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 4, 216}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 162, 162, 121, 125}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 127, 209}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 226, 231, 83, 138}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 55, 228, 241}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 169, 239, 38}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 97, 23}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 176}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 86}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 241, 41, 98, 136}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 250, 59, 134}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 250, 254, 8, 91}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 192, 59}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 146, 133, 118}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 96, 12, 245}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 81}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 153, 180}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 176, 83, 165, 138}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 147}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 124, 51, 101}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 235, 137, 103}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 66, 29, 9, 82}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 253, 3, 212, 56}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 58, 44, 84, 91, 92}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 89, 81}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 155, 5, 211}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 124, 235, 74, 250}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 0}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 233, 232, 186, 241}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 72, 209, 132, 114}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 43}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 60, 237}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 159, 16, 246, 161, 37}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 69, 90}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 109, 225, 204}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 240}, 12},
	{{151, 167, 43, 178, 116, 194, 173, 126, 236, 98, 40, 0, 0, 0, 0, 120}, 12},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 155, 149, 171, 90, 185, 132}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 67, 173, 8, 133, 144, 161, 130, 170, 21}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 129},
	{{60, 64, 180, 195, 22, 43, 167, 147, 55, 181, 135, 49, 181, 182, 58, 177}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 197, 114, 142, 38, 89, 154, 7, 235, 160}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 23, 246, 103, 167}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 194, 15, 159, 165, 51, 16, 20, 160, 11}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 104, 8, 105, 79, 180, 57, 150, 252}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 189, 101, 33, 161, 106, 123, 111, 141}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 129},
	{{60, 64, 0, 208, 111, 142, 188, 38, 100, 10, 13, 225, 78, 110, 87, 195}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 190, 2, 127, 49, 236, 237, 23}, 129},
	{{60, 64, 0, 0, 0, 51, 220, 163, 106, 196, 185, 153, 102, 47, 54, 148}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 4, 123, 107, 116, 28, 242}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 192, 219, 164, 243, 244, 50}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 49, 98}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 232, 100, 12, 181, 167, 111, 227, 197}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 220, 50, 199, 255, 193, 195, 96, 46, 31}, 129},
	{{60, 64, 0, 0, 0, 14, 126, 151, 46, 172, 237, 77, 172, 113, 199, 27}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 22}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 132, 11, 131, 234, 51, 200, 32}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 207, 223, 116, 20, 34, 140, 45}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 229, 209}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 116, 106, 152, 179, 100, 114, 90, 115, 33}, 129},
	{{60, 64, 0, 0, 0, 0, 9, 134, 16, 162, 195, 4, 181, 141, 172, 161}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 56}, 129},
	{{60, 64, 0, 0, 234, 73, 72, 119, 67, 182, 237, 77, 219, 208, 201, 44}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 29, 233, 233, 47, 238, 243, 75, 210}, 129},
	{{60, 64, 0, 184, 224, 12, 126, 188, 198, 109, 66, 208, 24, 216, 71, 40}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 57, 30, 204, 33, 56, 177, 57}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 214, 190, 24, 37}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 129},
	{{60, 64, 0, 0, 0, 117, 161, 102, 6, 40, 146, 122, 214, 183, 190, 11}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 155, 173, 150, 0}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 168, 160, 2, 229, 133, 194, 139, 138}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 22, 86, 59, 152}, 129},
	{{60, 64, 0, 0, 0, 0, 192, 177, 25, 74, 72, 114, 204, 248, 241, 181}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 251}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 54, 71}, 129},
	{{60, 64, 0, 47, 174, 227, 17, 206, 79, 141, 26, 118, 119, 54, 45, 178}, 129},
	{{60, 64, 0, 125, 196, 203, 30, 125, 212, 151, 212, 199, 4, 140, 128, 96}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 192}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 52, 17, 91}, 129},
	{{60, 64, 0, 0, 0, 0, 173, 162, 45, 14, 155, 54, 143, 114, 109, 95}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 201, 89, 37, 6}, 129},
	{{60, 64, 0, 122, 182, 173, 245, 112, 239, 62, 119, 136, 206, 101, 59, 48}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 72, 126, 209, 43, 140, 110}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 5, 98}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 67, 226, 135, 22, 85, 248, 48, 255}, 129},
	{{60, 64, 0, 228, 210, 13, 57, 215, 114, 163, 0, 95, 185, 82, 233, 255}, 129},
	{{60, 64, 0, 0, 102, 31, 193, 55, 72, 241, 30, 127, 102, 95, 146, 55}, 129},
	{{60, 64, 0, 0, 0, 0, 9, 2, 229, 180, 122, 46, 144, 219, 34, 55}, 129},
	{{60, 64, 0, 0, 167, 140, 141, 184, 23, 243, 211, 245, 176, 83, 126, 220}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 37, 98, 207}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 102, 232, 20, 98, 175, 169, 64}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 223, 178, 206, 115, 75, 199, 254, 145, 242}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 128}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 214, 124}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 38, 123, 22, 190, 110, 24, 61, 91, 207}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 55, 15, 88, 249, 166, 73, 124}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 11, 141, 246, 21, 220, 217, 37, 44}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 121}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 129}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 103, 38, 147, 21, 100, 31, 124, 238}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 99, 176, 225, 58, 147, 240, 162}, 129},
	{{60, 64, 0, 0, 0, 214, 132, 228, 51, 210, 23, 70, 120, 139, 176, 5}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 119}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 96, 154, 181, 163, 105, 64, 30, 100}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 83, 36, 41, 74, 142, 72, 18, 61}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 26, 2, 92, 204, 61, 5, 96}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 122, 81, 87, 64}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 122, 77, 12, 24, 17, 37, 70, 15, 245}, 129},
	{{60, 64, 0, 0, 11, 145, 28, 161, 98, 57, 10, 4, 169, 68, 44, 5}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 129},
	{{60, 64, 0, 26, 161, 122, 213, 213, 33, 235, 33, 26, 40, 233, 97, 178}, 129},
	{{60, 64, 0, 92, 239, 76, 108, 6, 220, 199, 30, 234, 250, 196, 213, 195}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 15, 236, 46, 178, 74, 83, 229, 28}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 41, 66}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 129},
	{{60, 64, 0, 0, 193, 100, 214, 161, 164, 130, 84, 68, 234, 108, 134, 34}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 165, 8, 219, 232, 86, 227, 162, 92}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 127}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 46, 34, 15, 198}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 161}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 30, 73, 67, 224, 223, 63, 60, 248}, 129},
	{{60, 64, 0, 0, 0, 30, 123, 136, 76, 187, 100, 68, 132, 110, 180, 14}, 129},
	{{60, 64, 0, 187, 119, 19, 117, 59, 22, 201, 206, 242, 67, 188, 223, 194}, 129},
	{{60, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 190, 128}, 129},
	{{60, 64, 109, 95, 139, 155, 85, 84, 7, 193, 67, 193, 238, 30, 210, 172}, 129},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 196, 204, 205}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 251, 112, 150, 174}, 50},
	{{208, 0, 0, 0, 0, 161, 171, 48, 177, 38, 53, 116, 206, 47, 249, 59}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 247, 160}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 155, 5, 185, 62, 218, 5, 41, 195}, 50},
	{{208, 0, 27, 239, 179, 206, 142, 150, 78, 41, 235, 114, 135, 106, 71, 205}, 50},
	{{208, 0, 0, 14, 124, 76, 159, 71, 182, 170, 107, 123, 40, 159, 40, 116}, 50},
	{{208, 0, 0, 0, 0, 78, 116, 138, 140, 58, 100, 73, 157, 10, 107, 95}, 50},
	{{208, 0, 0, 197, 219, 1, 248, 38, 124, 37, 15, 248, 6, 242, 12, 191}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 219, 192, 66, 145, 92}, 50},
	{{208, 0, 0, 0, 0, 0, 178, 136, 199, 34, 88, 237, 29, 251, 6, 203}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 59, 132, 216}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 210, 141, 53, 0, 70, 40, 40, 161, 247}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 100, 208, 196, 243, 191, 16, 73, 159, 8}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 153, 221, 75, 119, 239, 32, 40}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 248, 242}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 197, 233, 93, 210, 125}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 49, 121, 1, 111, 244}, 50},
	{{208, 0, 0, 0, 77, 19, 195, 141, 213, 29, 141, 120, 223, 222, 26, 174}, 50},
	{{208, 0, 0, 0, 226, 35, 254, 55, 251, 178, 7, 23, 26, 15, 161, 203}, 50},
	{{208, 0, 0, 0, 0, 156, 224, 152, 138, 59, 244, 224, 229, 210, 140, 104}, 50},
	{{208, 0, 0, 0, 0, 71, 33, 29, 15, 36, 113, 57, 58, 76, 135, 127}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 109, 92, 177, 243, 36}, 50},
	{{208, 0, 247, 151, 31, 193, 251, 43, 217, 214, 195, 2, 185, 204, 132, 35}, 50},
	{{208, 0, 62, 158, 139, 238, 149, 125, 92, 114, 131, 24, 163, 13, 242, 189}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 116}, 50},
	{{208, 0, 186, 230, 126, 134, 20, 12, 196, 45, 178, 126, 34, 15, 108, 210}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 28}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 208, 169}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 200}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 2, 44, 249, 18, 121}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 200, 214, 98}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 198, 46}, 50},
	{{208, 83, 185, 153, 233, 127, 167, 13, 0, 109, 210, 121, 208, 91, 119, 236}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 6, 128, 105, 214, 50, 111, 187, 101, 53}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 2, 2, 211, 15, 241, 22, 70, 204}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 196, 7, 241, 118, 1, 99, 223}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 32}, 50},
	{{208, 0, 0, 0, 0, 0, 123, 62, 237, 218, 186, 176, 34, 8, 76, 124}, 50},
	{{208, 0, 72, 250, 135, 189, 123, 16, 162, 37, 115, 140, 202, 70, 57, 18}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 222, 213, 231, 255, 37, 185, 172, 206}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 177, 47, 113, 55, 155, 106, 75, 82, 77}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 72, 196, 54, 208, 197, 197, 54, 126}, 50},
	{{208, 0, 0, 0, 32, 230, 47, 43, 180, 151, 102, 227, 36, 174, 38, 109}, 50},
	{{208, 0, 0, 0, 0, 0, 34, 159, 237, 148, 134, 78, 21, 97, 244, 89}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 59, 243}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 49, 194}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 145, 22}, 50},
	{{208, 0, 182, 42, 249, 156, 45, 174, 179, 244, 86, 46, 60, 186, 48, 181}, 50},
	{{208, 0, 0, 0, 0, 158, 40, 161, 129, 81, 227, 225, 27, 58, 134, 80}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 57, 176, 78}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 206, 160, 218, 66, 189, 110, 123}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 170, 17, 28, 191, 77, 81, 250, 42}, 50},
	{{208, 0, 0, 89, 3, 15, 54, 199, 44, 151, 20, 222, 246, 37, 106, 15}, 50},
	{{208, 0, 117, 58, 90, 211, 216, 193, 1, 140, 83, 34, 111, 116, 254, 228}, 50},
	{{208, 0, 0, 0, 105, 59, 228, 110, 184, 250, 37, 116, 61, 27, 199, 168}, 50},
	{{208, 0, 0, 0, 0, 27, 154, 161, 150, 17, 189, 117, 126, 209, 4, 86}, 50},
	{{208, 0, 0, 0, 0, 0, 107, 100, 8, 84, 82, 211, 54, 250, 26, 155}, 50},
	{{208, 0, 0, 0, 0, 0, 113, 122, 248, 204, 2, 8, 83, 243, 174, 137}, 50},
	{{208, 0, 0, 0, 0, 70, 21, 129, 236, 146, 64, 247, 18, 237, 156, 240}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 231, 241, 17, 14, 32, 223, 74, 49}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 223, 54, 220, 54, 232, 30, 5}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 81, 157, 208, 111, 27}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 165, 58, 125, 96, 33, 150, 127}, 50},
	{{208, 0, 0, 0, 0, 50, 119, 7, 201, 179, 148, 205, 14, 113, 220, 29}, 50},
	{{208, 0, 0, 0, 0, 0, 229, 38, 163, 13, 193, 53, 109, 47, 162, 107}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 237, 109, 191, 212}, 50},
	{{208, 0, 0, 232, 189, 93, 49, 32, 152, 106, 210, 237, 92, 89, 141, 206}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 6, 183, 88}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 24, 202}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 50},
	{{208, 0, 0, 0, 0, 172, 205, 137, 51, 35, 49, 6, 114, 107, 41, 223}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 221}, 50},
	{{208, 0, 0, 0, 0, 0, 243, 88, 182, 199, 110, 96, 17, 58, 109, 111}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 240, 13, 60, 16, 179, 74, 7, 32}, 50},
	{{208, 0, 0, 31, 91, 169, 203, 19, 109, 84, 80, 9, 208, 12, 227, 185}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 100, 29, 35}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 97, 26, 5}, 50},
	{{208, 0, 0, 17, 14, 155, 250, 109, 143, 18, 66, 20, 174, 213, 56, 155}, 50},
	{{208, 0, 0, 0, 0, 176, 24, 110, 244, 124, 186, 9, 16, 251, 30, 127}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 38, 215, 144, 149, 193}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 252, 231, 6, 131, 20, 65, 147}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 179, 131, 139, 1, 142, 157, 69}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 47, 100, 0, 127, 198}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 35, 54, 196, 91}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 253, 124}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 219, 77, 230}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 226, 141, 86, 147, 22, 4, 121, 0}, 50},
	{{208, 0, 0, 0, 0, 0, 0, 0, 0, 204, 173, 84, 178, 153, 231, 127}, 50},
	{{208, 0, 0, 0, 0, 53, 35, 125, 117, 135, 60, 238, 52, 225, 78, 118}, 50},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{126, 11, 216, 242, 7, 45, 121, 208, 110, 135, 210, 75, 59, 182, 228, 42}, 250},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 0}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 194, 226}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 137, 164, 229, 41, 25}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 187, 183, 1, 167, 204}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 243}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 186, 37, 240, 205, 181}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 155, 163, 14, 47, 233}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 223, 37, 226, 134, 27}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 3}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 58, 39}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 60, 152}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 177, 189, 241, 180, 215, 109}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 167}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 238, 109, 230, 164, 43, 144}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 113, 157, 71, 12}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 242}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 172, 116, 32, 119}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 121, 227, 227}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 6, 101}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 168}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 105}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 0}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 27, 234, 41, 73}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 0}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 16}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 56, 69, 170}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 146, 216, 184}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 195, 0, 93}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 63, 2}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 51}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 127, 229, 207, 25, 176, 222}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 165, 85, 242, 144}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 237, 54, 111, 204, 207}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 87, 56, 232, 108, 67, 248}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 96, 235, 225, 164, 238}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 0}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 0}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 72, 3, 113, 145}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 110, 22, 84}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 190, 226, 119, 65}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 196, 152, 155}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 222, 232, 254, 130, 124, 1}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 129, 66, 56, 32}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 74, 104}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 13}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 189, 147, 126, 169}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 217}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 245, 37, 227, 241}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 216}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 0}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 217, 210, 208, 155, 155}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 226, 15, 165, 197, 1}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 0}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 0}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 226, 140}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 45, 119}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 169}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 108}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 17, 27, 109}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 196, 228, 206}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 177, 60, 180, 231, 197}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 253, 241}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 224, 47}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 46, 17}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 90, 224, 219, 129, 141}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 48, 39, 106, 22, 139}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 180, 241, 163, 119}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 82, 35, 64}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 198, 252}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 175, 39, 60, 176}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 107, 33, 45}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 153, 94}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 0}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 239, 122, 159, 186, 175}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 96, 131}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 132, 253, 87}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 54, 245, 176, 83}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 207, 96, 146, 173}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 79}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 190}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 0}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 242}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 23, 92}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 179, 36, 97, 52}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 250, 166, 196}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 187}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 17, 252, 128, 78}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 108}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 56, 23, 54, 211, 136}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 23, 155, 117, 195}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 166, 211}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 131, 112}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 114, 191, 53, 242, 201, 36}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 62, 198, 239}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 55, 18, 67}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 56}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 174, 170}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 127, 174, 120, 127, 223}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 0}, 249},
	{{217, 26, 184, 146, 3, 18, 240, 15, 135, 8, 0, 0, 0, 0, 0, 0}, 249},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 224, 185, 59, 177, 183, 151, 172, 213, 141, 230}, 218},
	{{128, 0, 84, 139, 26, 38, 16, 43, 227, 13, 247, 98, 118, 196, 96, 145}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 69, 23, 184, 117, 207, 236, 152}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 7, 130, 78, 121, 232, 143, 85, 112, 255}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 136, 93, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 29, 169, 252, 182, 201, 209, 159, 240, 129}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 240, 104, 175, 73, 144}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 122, 181}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 112, 185, 215, 101, 54, 219, 145, 178, 237}, 218},
	{{128, 0, 249, 40, 246, 184, 221, 92, 102, 76, 210, 181, 45, 19, 154, 81}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 165, 130}, 218},
	{{128, 0, 0, 181, 227, 148, 161, 244, 74, 159, 64, 101, 60, 240, 123, 229}, 218},
	{{128, 0, 0, 0, 0, 147, 210, 253, 232, 106, 84, 226, 70, 36, 197, 157}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 218, 14, 43, 110}, 218},
	{{128, 193, 5, 238, 21, 205, 91, 77, 50, 117, 94, 153, 249, 34, 197, 38}, 218},
	{{128, 0, 0, 0, 0, 0, 241, 158, 88, 210, 203, 75, 237, 159, 218, 12}, 218},
	{{128, 99, 215, 237, 150, 234, 166, 143, 88, 172, 114, 126, 17, 1, 1, 248}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 253, 200, 176, 86}, 218},
	{{128, 0, 0, 0, 155, 43, 129, 107, 135, 10, 38, 2, 244, 133, 213, 45}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 76, 175}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 243, 94, 222, 73, 116, 55, 100}, 218},
	{{128, 0, 0, 0, 122, 29, 34, 58, 77, 36, 182, 133, 21, 199, 28, 84}, 218},
	{{128, 0, 0, 0, 0, 166, 138, 145, 218, 177, 33, 160, 150, 192, 28, 212}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 37, 39}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 79, 189, 241, 244, 101, 246, 163, 219, 87}, 218},
	{{128, 223, 180, 73, 207, 248, 237, 83, 213, 37, 21, 31, 87, 136, 98, 167}, 218},
	{{128, 0, 0, 0, 19, 254, 1, 214, 105, 181, 140, 253, 255, 137, 130, 158}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 76, 171, 50, 68, 148}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 152, 26, 245}, 218},
	{{128, 0, 0, 0, 0, 0, 35, 6, 131, 9, 67, 57, 46, 191, 175, 63}, 218},
	{{128, 0, 0, 59, 18, 61, 12, 193, 146, 59, 96, 27, 144, 38, 114, 197}, 218},
	{{128, 48, 182, 53, 69, 115, 164, 16, 235, 160, 213, 209, 164, 175, 137, 135}, 218},
	{{128, 0, 189, 34, 226, 210, 166, 155, 6, 82, 43, 209, 92, 212, 62, 20}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 56, 89, 43, 182, 107, 121, 87, 236, 125}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 73, 58, 7, 73, 40, 108, 239}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 163, 11, 230, 99, 243, 38, 14, 252}, 218},
	{{128, 0, 52, 21, 111, 54, 147, 187, 202, 228, 132, 31, 49, 141, 218, 251}, 218},
	{{128, 0, 249, 25, 225, 181, 222, 135, 170, 127, 148, 178, 109, 74, 221, 61}, 218},
	{{128, 65, 181, 66, 215, 193, 105, 13, 218, 166, 128, 79, 16, 234, 55, 138}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 121, 81, 161, 161}, 218},
	{{128, 0, 0, 0, 0, 180, 123, 81, 88, 212, 155, 207, 57, 163, 79, 230}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 161, 221, 44, 196}, 218},
	{{128, 0, 0, 0, 9, 165, 151, 102, 81, 120, 107, 207, 218, 135, 56, 60}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 149, 190, 1, 107}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 235, 155, 133, 167}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 57}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 127, 56, 153, 219, 208, 138, 102, 81, 244, 94, 157, 42}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 227, 105, 64, 213}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 24, 87, 62, 137, 93, 164, 102, 158, 12, 10, 24, 188, 206}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 99, 10, 44, 218, 11}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 64, 2, 247, 27, 28, 212, 214, 177}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 83, 111, 96, 210, 23, 217, 26, 94, 111}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 214, 51, 206, 207, 190, 36, 16, 128, 132, 243}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 19}, 218},
	{{128, 0, 0, 190, 248, 238, 168, 41, 178, 30, 121, 241, 11, 190, 167, 13}, 218},
	{{128, 0, 0, 0, 225, 192, 109, 109, 24, 249, 110, 106, 176, 239, 14, 14}, 218},
	{{128, 0, 169, 0, 189, 132, 175, 127, 68, 11, 222, 247, 196, 142, 203, 71}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 68, 14, 206, 27, 65, 206, 87, 221}, 218},
	{{128, 0, 27, 137, 115, 82, 246, 90, 35, 102, 92, 32, 98, 244, 210, 39}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 231, 139, 79, 27}, 218},
	{{128, 0, 0, 0, 0, 0, 146, 69, 90, 85, 91, 123, 31, 206, 171, 29}, 218},
	{{128, 178, 167, 247, 16, 190, 6, 121, 58, 249, 205, 74, 61, 138, 182, 3}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 204, 173, 12, 232, 210}, 218},
	{{128, 0, 0, 193, 127, 159, 21, 136, 118, 244, 109, 136, 200, 235, 204, 72}, 218},
	{{128, 0, 0, 228, 156, 220, 213, 87, 241, 26, 205, 134, 57, 227, 219, 8}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 139, 244, 122, 211, 53, 226, 181, 216}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 63, 209, 222}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 143, 228, 60, 185, 134, 77, 243}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 108, 185, 173}, 218},
	{{128, 53, 0, 188, 6, 210, 64, 37, 122, 174, 43, 112, 99, 50, 107, 65}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 147, 154, 172, 88}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 108, 48, 250, 39, 17, 203, 88, 229, 99}, 218},
	{{128, 0, 0, 0, 0, 0, 31, 18, 28, 104, 244, 11, 87, 80, 205, 94}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 239, 27, 236, 207, 188, 195, 91}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 163, 208, 113}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 181}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 147, 93, 232, 42}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 179, 241, 255, 15, 61, 28, 122, 180, 34, 76, 170, 94}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 99, 127, 234, 129, 187, 55, 253, 183, 175, 120, 210, 6, 25, 111}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 41, 207, 101, 184, 60, 158, 177}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 236, 219, 134, 55, 63}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 204}, 218},
	{{128, 0, 0, 0, 37, 140, 177, 79, 210, 7, 14, 57, 32, 20, 65, 75}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 155, 252}, 218},
	{{128, 0, 0, 0, 115, 15, 204, 154, 64, 72, 12, 2, 138, 83, 66, 231}, 218},
	{{128, 0, 22, 135, 233, 209, 131, 217, 112, 16, 59, 131, 151, 84, 205, 212}, 218},
	{{128, 0, 0, 0, 0, 0, 184, 77, 35, 223, 216, 16, 144, 137, 9, 46}, 218},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 58}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 32}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 13, 170, 131}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 24, 165}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 143, 57, 60}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 143, 69}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 239, 58, 198}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 13}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 69}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 12, 127, 160}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 110, 1}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 103, 185, 86, 178}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 249, 150, 233}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 55, 225, 231}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 16, 104}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 201, 49, 8, 240}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 50, 56, 63}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 54, 28, 56, 184}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 167, 34}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 136}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 227, 78, 238}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 62}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 75, 232, 218, 177}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 7, 164, 58}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 74, 194, 126}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 68}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 146}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 6, 199, 211, 254}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 104, 97}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 109, 26, 209}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 45, 213, 153, 217}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 21}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 76, 169}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 12}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 130, 45}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 208, 43, 91}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 243, 89}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 213, 218, 24, 40}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 97, 177, 2, 18}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 57, 7, 107, 235}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 213, 218, 198}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 197}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 58}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 29, 118, 166}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 4, 194, 231}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 43}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 24, 205}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 77, 18}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 22, 103}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 35}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 245, 136}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 43}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 223, 177, 54, 205}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 86, 58}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 108, 249, 121}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 22, 239}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 219, 84, 2, 152}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 128}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 220}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 222, 139}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 215}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 122, 209, 179, 187}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 26, 137, 149, 234}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 76}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 108, 68, 67, 138}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 201, 130}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 155}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 142, 90}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 220, 243, 182, 113}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 181}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 128, 249, 209}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 100, 109}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 67, 145}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 44, 5}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 27, 179, 125}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 0}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 0, 16}, 228},
	{{145, 28, 29, 184, 2, 85, 234, 135, 98, 111, 136, 32, 0, 0, 236, 51}, 228},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 213}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 90}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 21, 56, 228, 91}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 7, 23, 86}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 237, 29, 22}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 112, 188}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 18, 217, 173, 174, 205, 189, 228}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 239, 168, 60}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 11, 160, 50}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 150, 87, 163, 135, 29}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 105, 161, 4, 239}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 31}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 95, 205}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 194, 189}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 184, 40}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 245, 238, 100, 166, 56, 187, 167}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 240}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 8}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 91}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 5, 236, 83}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 27, 137, 50, 122, 182, 210, 73}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 166, 65}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 152, 50, 63, 12, 99}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 30, 54}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 146, 177, 164}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 183}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 52, 169, 173, 237, 130, 250, 162}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 56}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 55, 65, 75, 119, 185, 238, 134}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 25, 235, 226}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 2, 93, 176}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 156, 39, 185, 140}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 32}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 168, 217, 211, 162, 46}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 103, 173, 27, 134, 111, 111, 17}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 136, 114, 109}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 244}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 110, 226, 188, 153, 255, 134}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 38, 132}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 252}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 10, 86, 72, 190}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 90, 254}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 145, 176, 246}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 131}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 26, 205, 125}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 28, 129}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 187, 28, 243}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 96, 194}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 71, 255}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 249, 79, 193, 58, 62}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 124, 115, 130}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 189}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 85, 198, 140, 188, 143, 2}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 240}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 22, 100, 188, 155, 108}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 68}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 198, 48, 201, 176, 73}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 181, 224}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 252, 100, 168, 131, 115, 123}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 28, 185, 74, 53}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 98, 99}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 104, 165, 12}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 120, 155, 81, 232, 238, 234, 168}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 103, 121, 95, 71, 60}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 94}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 246, 191, 149, 245}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 188, 105, 194, 188, 30}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 200}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 40, 53, 183, 63, 197, 116}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 122, 234, 61, 21, 14}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 16, 98, 48}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 135, 59, 80, 154, 40}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 105}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 127, 25, 58, 226}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 49, 62, 33, 137, 112, 92, 179}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 204, 130, 250, 193, 203, 114}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 151, 137, 10, 183, 149, 137}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 164, 155, 199}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 189, 253, 15, 12, 240, 155, 208}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 139, 72}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 55}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 170, 117, 145, 168, 159, 134}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 197, 240}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 228}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 0}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 138}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 46}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 95, 141, 87, 185, 155, 134}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 61, 101, 139, 186, 218, 133, 75}, 181},
	{{108, 104, 255, 254, 34, 95, 72, 157, 0, 0, 0, 0, 0, 0, 0, 104}, 181},
	{{153, 61, 0, 0, 0, 0, 0, 136, 99, 223, 130, 129, 163, 49, 213, 49}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 17, 147}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 109, 105, 189, 107, 221, 49, 92, 119}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 171, 39, 189, 79, 143, 100}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 137, 94}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 116, 56, 147, 194}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 208, 101, 40, 169, 45, 225, 237, 219, 75}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 255, 89, 203, 58, 89, 161, 227, 26}, 206},
	{{153, 61, 0, 0, 0, 0, 132, 16, 121, 255, 174, 65, 23, 172, 251, 212}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 2, 150, 80, 110}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 251, 186, 110, 177, 72, 191, 226}, 206},
	{{153, 61, 0, 0, 0, 195, 200, 69, 96, 41, 121, 119, 75, 237, 228, 227}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 206},
	{{153, 61, 0, 0, 0, 42, 171, 91, 195, 21, 241, 191, 114, 185, 206, 79}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 35, 23, 13}, 206},
	{{153, 61, 0, 0, 102, 127, 111, 16, 25, 204, 107, 235, 41, 110, 21, 84}, 206},
	{{153, 61, 0, 0, 80, 151, 242, 195, 110, 165, 230, 241, 55, 95, 160, 179}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 218, 221, 210}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 164, 16, 225, 37, 240, 185, 182, 41}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 101, 239, 85, 82, 174, 68, 229}, 206},
	{{153, 61, 0, 0, 0, 0, 39, 242, 202, 169, 31, 230, 140, 223, 132, 190}, 206},
	{{153, 61, 0, 0, 0, 175, 10, 196, 124, 181, 39, 10, 90, 191, 196, 4}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 72, 207, 189, 89}, 206},
	{{153, 61, 0, 0, 0, 0, 250, 61, 195, 221, 147, 81, 229, 176, 69, 1}, 206},
	{{153, 61, 0, 92, 186, 194, 177, 141, 56, 73, 123, 133, 79, 25, 175, 12}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 219, 229, 202, 198}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 219, 79, 32, 105, 56, 119, 158}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 211, 219, 53, 69}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 225, 70, 83, 110, 181, 120, 20, 172, 231}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 123, 27}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 66, 46, 86, 116, 244, 230, 6}, 206},
	{{153, 61, 0, 0, 93, 115, 125, 125, 183, 94, 183, 16, 15, 192, 63, 182}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 214, 95, 126, 79}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 71, 237, 161, 71, 45, 18, 74}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 164, 202, 192}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 206}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 167, 141, 185, 207, 11, 138, 179, 212}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 26, 33}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 145}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 206},
	{{153, 61, 0, 214, 3, 158, 196, 5, 23, 211, 78, 90, 80, 157, 197, 205}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 231, 176, 220, 192}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 21, 115, 37}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 225, 200, 29, 96, 14, 65, 110, 116, 42}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 206},
	{{153, 61, 0, 0, 0, 0, 200, 111, 93, 232, 22, 203, 5, 81, 244, 193}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 45, 70}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 143, 210, 208, 103}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 247, 28, 193, 238, 98, 15}, 206},
	{{153, 61, 0, 0, 120, 89, 82, 229, 108, 191, 171, 142, 62, 232, 132, 6}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 6}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 206},
	{{153, 61, 0, 0, 222, 234, 181, 72, 2, 7, 76, 56, 80, 31, 244, 149}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 226, 72, 115, 82}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 161, 99}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 189, 2, 145, 99}, 206},
	{{153, 61, 0, 0, 0, 68, 218, 31, 126, 2, 125, 146, 152, 170, 180, 209}, 206},
	{{153, 61, 0, 0, 0, 184, 46, 203, 67, 112, 73, 220, 158, 168, 245, 152}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 222, 204, 117}, 206},
	{{153, 61, 0, 0, 0, 83, 56, 178, 196, 211, 92, 33, 98, 220, 45, 96}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 25, 237}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 137}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 235, 208, 142, 64, 200, 218, 71, 184, 66}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 155, 59, 38}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 51, 23, 118, 67, 76, 177, 61, 94}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 167, 47, 21, 188, 33, 47}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 185, 176, 216, 247, 182, 24, 42, 244}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 24, 232, 167, 35, 241, 104}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 58, 89, 183, 72, 5, 36, 9, 136}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 91, 233, 232, 89}, 206},
	{{153, 61, 0, 0, 0, 0, 68, 47, 70, 133, 247, 92, 201, 168, 91, 149}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 250, 13}, 206},
	{{153, 61, 0, 0, 46, 2, 226, 157, 137, 51, 215, 247, 113, 110, 197, 185}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 123, 122, 236, 185, 228, 209, 176}, 206},
	{{153, 61, 0, 0, 196, 105, 243, 109, 208, 202, 75, 51, 179, 204, 73, 160}, 206},
	{{153, 61, 0, 0, 0, 160, 7, 205, 120, 251, 27, 221, 176, 105, 64, 208}, 206},
	{{153, 61, 0, 0, 181, 58, 77, 18, 110, 210, 252, 48, 85, 179, 226, 183}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 163, 70, 189, 113, 80, 140, 247}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 172, 177}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 202, 50, 53, 51, 129, 148, 220, 21, 57}, 206},
	{{153, 61, 0, 0, 0, 0, 111, 203, 213, 202, 95, 91, 91, 149, 51, 175}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 219, 108, 106, 148}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 90, 229}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 19, 185}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 42, 74, 56, 38}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 84, 178, 197}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 129, 37, 82, 179, 255, 5, 77, 118}, 206},
	{{153, 61, 0, 0, 0, 0, 0, 0, 0, 126, 240, 115, 23, 46, 74, 160}, 206},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 253, 31}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 8, 9, 252, 248, 250, 197}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 202, 97}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 249, 75, 229, 154, 54, 49, 222, 58}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 241, 90, 73, 162, 158}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 68, 252}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 5, 25, 159, 129, 199, 211, 63}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 76, 225}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 91, 247, 252, 192}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 115, 61, 30, 62, 164, 200}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 138, 21}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 242, 222, 13, 75, 236, 253, 169}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 245, 74}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 136, 231, 158, 80}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 84, 24}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 75, 77, 190, 126, 237, 38, 224}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 244, 168, 133}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 40, 46, 68, 145, 199, 241}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 242, 80}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 172, 37, 22, 204, 4}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 158, 175, 138}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 143, 88, 166}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 8, 185, 253, 39, 190, 38, 24, 137}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 81, 139, 77}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 59, 227, 145, 95, 254, 169, 198, 135}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 17}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 137, 124, 117, 65, 39, 225}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 151}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 142}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 192, 198, 155, 122}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 51, 77, 30}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 148, 36, 243, 207, 105, 185}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 254}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 115, 61, 199, 178, 112}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 111, 207, 69}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 196, 172, 231}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 65, 15, 131, 185}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 33}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 171}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 57, 239, 4, 220, 208, 146, 38}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 79, 42, 173}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 229, 50, 139, 50}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 88, 49, 138, 143}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 197, 166, 26, 155}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 255, 251, 60, 213, 190}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 230, 111, 27}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 224, 122}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 144, 103, 176, 141, 154, 104}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 125, 178, 60, 113, 158}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 110, 45, 107, 185, 164}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 188}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 1, 53, 188, 22, 193, 138, 146}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 192, 176}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 16}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 96, 60, 3, 185}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 2, 180, 238}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 4, 233, 30, 36, 87, 122}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 141, 32, 193, 222, 153, 204, 17}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 134, 235, 49, 25, 218, 29, 111}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 183}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 89, 184, 249}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 162, 3}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 125, 142, 99, 93}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 73, 26}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 83, 209, 10, 209, 219}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 10, 131, 228, 116}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 5}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 37, 3, 137, 125, 124}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 129, 212, 76}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 74, 245}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 180, 129}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 82, 245}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 23, 39, 162, 179}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 215}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 206, 85, 144, 6, 89, 72}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 213, 192, 98, 228, 221}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 203, 178, 66}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 93, 45, 249, 181, 176, 204, 39}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 43}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 112, 192}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 217, 3, 134, 157, 243}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 67, 81, 160}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 12, 95, 86, 205, 35, 5, 95}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 83, 152, 99, 175, 185, 131}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 0, 0, 0, 0, 179}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 142, 9, 168, 81, 192, 229}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 91, 251, 211, 203, 246}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 0, 127, 99, 188, 1, 57}, 122},
	{{22, 250, 130, 201, 132, 248, 189, 108, 0, 0, 211, 75, 201, 107, 211, 235}, 122},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 84, 172, 138, 165, 142, 245}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 113}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 51, 115}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 245, 2, 159}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 138, 96, 125}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 85, 212, 15}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 188, 89}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 220}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 1, 236, 251, 92, 72}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 75, 37, 205}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 50, 195, 46}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 237, 125}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 91, 12, 126, 32}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 45, 222}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 220, 234, 156, 235, 171}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 154, 99, 174, 211, 136}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 230, 43}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 175, 240, 253, 191, 118}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 212, 111, 92, 230, 208}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 11, 2, 40}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 175, 152, 89, 27}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 69, 183, 198, 104, 239, 134}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 42}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 93, 197, 219, 235, 38}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 247, 89, 91}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 195}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 55, 37}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 170, 104, 16}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 122, 50}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 31, 144, 110, 112}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 147, 81, 173, 42, 11, 226}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 231}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 20, 177, 92, 159}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 18, 203, 84, 254}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 102, 13}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 197, 131}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 248, 198}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 101, 58}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 146, 76, 171, 187, 38}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 128, 152}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 80}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 209, 6}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 206, 63, 88, 180}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 203, 51, 164, 50}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 53, 119, 6, 205, 50, 231}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 253, 135, 19, 15, 40, 250}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 18, 206, 13, 221, 186}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 161, 57, 166}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 220, 206}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 31}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 94, 3}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 9, 118, 209, 112, 207, 110}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 72, 224, 174}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 89, 50, 251, 52, 227, 46}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 157, 250, 181, 53}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 134, 217, 217, 229, 159}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 253, 169, 35, 168, 19}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 87, 153}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 172}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 53, 8}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 14}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 115, 97, 115, 41}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 92, 201, 248, 108}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 11, 57, 154, 254, 70}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 62, 243, 64, 48, 221, 216}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 230, 62, 145, 35, 253}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 58, 37, 89, 10}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 76, 227, 136, 153, 229, 149}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 123, 35, 83, 188, 187}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 93, 103}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 228}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 138, 181, 30, 111, 124, 30}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 19, 161, 19, 75}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 252, 204}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 197, 228, 248, 123, 78, 209}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 239, 75, 164, 140, 203, 121}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 83}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 149, 253, 183}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 61, 184}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 6}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 0, 0, 0, 0}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 201, 229, 94, 163}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 242, 234, 81, 117}, 81},
	{{158, 165, 234, 18, 44, 61, 82, 61, 235, 0, 0, 0, 39, 86, 209, 64}, 81},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 196, 71}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 93}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 56, 135, 55}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 219, 143, 228}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 69, 48}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 241}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 66, 187}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 72, 200, 113}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 36}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 36}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 116}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 235, 235}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 178, 116, 242}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 223, 32, 46}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 209, 240, 154}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 94, 178, 82}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 255, 251}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 163, 192}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 215, 211}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 83, 236, 186}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 214, 90, 169}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 102}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 140, 28}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 6}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 207}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 225}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 40, 122}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 139, 150, 38}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 176, 165}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 7, 183}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 72, 218, 211}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 57, 170, 29}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 245, 38}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 219}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 7, 105}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 32}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 93, 29}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 230, 165, 56}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 60}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 55, 241}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 106, 240, 189}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 221, 124}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 112, 226, 1}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 115, 41}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 1, 26, 145}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 53}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 176, 242}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 155}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 202, 155}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 140}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 193, 52, 250}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 177, 231}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 60}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 226}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 98, 15, 236}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 194, 128}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 34, 150}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 249, 219, 206}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 189, 38}, 175},
	{{236, 57, 124, 110, 124, 218, 82, 70, 142, 78, 18, 128, 0, 0, 0, 0}, 175},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 152}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 161}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 50}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 150}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 117}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 159}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 246}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 115}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 249}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 248}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 164}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 151}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 135}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 176}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 208}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 1}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 15}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 74}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 212}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 31}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 181}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 57}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 10}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 100}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 169}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 132}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 175}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{94, 209, 200, 201, 149, 162, 248, 134, 239, 226, 1, 237, 16, 134, 56, 0}, 170},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 144, 113, 109}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 84, 156, 248, 138, 222}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 165, 164, 23, 252, 36, 152, 46}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 99, 251, 61}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 196, 162}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 94, 40}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 241, 255, 47, 109, 24, 59, 71}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 36, 140, 124, 16, 31, 25}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 4, 231, 72, 205, 225, 156, 36}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 74, 210}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 101, 200, 226, 198, 60, 88, 95, 177}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 209, 44, 200, 27, 209, 89, 50, 71, 135}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 74, 72, 201, 58, 205, 217, 24, 100, 126}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 220, 25, 199, 47, 142, 230, 48, 210}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 7, 135, 34, 241, 132, 219, 166}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 38, 216, 154, 44, 172}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 74, 151, 254, 83, 252, 63}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 98, 127, 94, 189, 97, 20, 178, 65, 119}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 188, 23, 69, 80, 78, 2, 222, 86}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 25, 31, 121, 110, 34, 39, 52, 219, 24}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 45, 127, 198}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 142, 45, 38, 242, 195, 133, 202}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 43, 169, 71, 206, 177, 41}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 18, 33, 129, 242, 230, 195}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 28, 93, 100, 219, 213, 5, 8}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 214, 103, 208}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 217, 58, 171, 57, 65, 228, 152, 41, 225}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 198, 1, 93, 245, 232, 100, 133, 50}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 14, 43, 98, 45, 84, 24, 115}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 178, 117, 129, 254, 220, 205}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 213, 149, 5}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 233, 94, 45, 101, 70}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 146, 164, 178}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 105, 34, 234, 131, 121}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 202, 158}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 150, 23, 84, 22}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 203, 38, 135, 192, 136, 244, 227}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 150, 33, 245, 193}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 150, 253}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 222, 172, 188, 122, 178, 86, 21, 58}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 209, 146, 47, 244, 144, 207, 110}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 159, 79, 48, 150}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 35, 63, 114, 226, 227, 130, 125, 50}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 61, 224, 139, 156}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 192, 94, 22}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 137, 28, 65, 215, 180, 210, 36}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 178, 196, 90, 29, 71, 27, 212, 119}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 129, 40, 185, 47, 66, 122, 39}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 49, 133, 134, 171, 114}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 94, 212, 217, 125, 223, 145, 126}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 30, 120, 155, 134, 67}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 243, 85, 197}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 197, 184, 117, 104, 158, 151, 125, 125, 186}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 189, 204, 69}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 3, 53, 89, 141, 180, 52, 161}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 235, 166, 24, 64, 157, 246, 33, 191, 142}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 138, 46, 39, 195, 36, 207, 47}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 63, 39, 110, 164, 8, 230, 165}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 135, 162, 226, 217, 125, 218}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 154, 227, 77, 153, 113, 82, 23, 212}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 105, 9, 142, 93}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 114, 100}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 124, 233, 188, 137}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 16, 124, 70, 81, 181}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 129, 87, 241, 178, 68}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 222, 197, 78, 143, 248}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 66, 255, 144, 178, 147, 153, 210}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 212, 206, 247, 250, 206, 154, 95, 52}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 73, 199, 158, 94, 229, 117, 144, 55, 60}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 43, 251}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 225, 36, 201, 15, 3, 181, 21, 126}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 172, 156, 196, 178, 174, 68, 213}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 250, 207, 74, 226, 219, 67}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 74, 44}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 53, 153, 109, 190, 127}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 155, 179, 66}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 64, 179, 242, 156, 77, 103, 178, 99}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 107, 253, 132, 83}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 62, 204, 11, 204, 108, 144}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 231, 61, 233, 32, 29}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 0, 0, 0, 0, 199, 196}, 174},
	{{187, 42, 31, 144, 236, 70, 0, 0, 0, 0, 198, 214, 90, 24, 37, 240}, 174},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 100, 243, 97, 180, 73, 226, 149}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 64, 140, 159, 97}, 104},
	{{90, 214, 185, 128, 0, 0, 224, 28, 106, 189, 216, 213, 186, 195, 126, 243}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 104},
	{{90, 214, 185, 128, 0, 0, 40, 100, 48, 55, 198, 101, 152, 183, 33, 237}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 248, 85, 170, 210, 231}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 239, 149, 112, 246, 212, 187}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 42, 115, 13, 21}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 6, 12, 122, 140}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 215, 227, 122, 197, 42, 192, 105, 22}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 118, 26, 96, 238, 70, 11, 90}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 32}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 155, 107, 99, 211, 145, 15, 176, 186}, 104},
	{{90, 214, 185, 128, 0, 85, 31, 31, 7, 252, 77, 61, 254, 189, 61, 20}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 74}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 142, 243}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 104},
	{{90, 214, 185, 128, 0, 0, 167, 71, 190, 70, 145, 169, 190, 143, 147, 43}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 231, 82, 18, 235}, 104},
	{{90, 214, 185, 128, 0, 0, 162, 26, 63, 242, 172, 71, 117, 227, 45, 81}, 104},
	{{90, 214, 185, 128, 178, 194, 181, 89, 224, 101, 67, 238, 225, 122, 62, 254}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 219, 64, 248, 189, 221}, 104},
	{{90, 214, 185, 128, 0, 254, 44, 73, 127, 23, 226, 40, 126, 42, 170, 236}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 103, 207, 38, 180, 39, 237, 171}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 137}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 89, 75}, 104},
	{{90, 214, 185, 128, 0, 161, 213, 172, 157, 132, 120, 10, 122, 0, 9, 218}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 179, 91, 54, 161, 147, 228, 226, 12}, 104},
	{{90, 214, 185, 128, 0, 84, 228, 146, 211, 139, 74, 151, 44, 225, 14, 85}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 164, 248, 4, 90, 180, 26, 1}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{90, 214, 185, 128, 0, 0, 229, 122, 184, 38, 188, 131, 153, 56, 119, 167}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 177, 212}, 104},
	{{90, 214, 185, 128, 0, 76, 158, 185, 88, 148, 2, 189, 78, 5, 123, 109}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 251, 228}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 40, 25, 88, 94, 70, 69}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 217}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 39, 160, 239, 103, 23, 149, 139, 97}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 136, 40, 126, 9, 213, 20, 53, 248, 67}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 188, 160, 195, 187, 228}, 104},
	{{90, 214, 185, 128, 68, 226, 194, 24, 92, 131, 45, 208, 49, 57, 64, 221}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 171}, 104},
	{{90, 214, 185, 128, 0, 41, 100, 22, 136, 69, 227, 43, 66, 67, 216, 199}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 88, 170, 14, 33, 102}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 65, 68, 221, 117, 90, 180, 187, 158, 54}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 83, 200, 36, 193, 213, 236, 12}, 104},
	{{90, 214, 185, 128, 0, 160, 70, 126, 108, 182, 175, 197, 214, 109, 12, 236}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 193, 23}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 148, 230}, 104},
	{{90, 214, 185, 128, 241, 122, 9, 138, 154, 50, 152, 83, 77, 78, 41, 114}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 206, 159, 141, 135}, 104},
	{{90, 214, 185, 128, 0, 215, 122, 103, 38, 172, 10, 138, 92, 154, 69, 120}, 104},
	{{90, 214, 185, 128, 129, 23, 161, 72, 168, 125, 170, 69, 241, 206, 87, 80}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 101}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 57, 233, 73, 2, 30, 160, 77, 163, 179}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 104},
	{{90, 214, 185, 128, 0, 62, 12, 55, 148, 247, 52, 36, 15, 206, 126, 31}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{90, 214, 185, 128, 0, 0, 198, 250, 98, 16, 168, 6, 114, 145, 123, 97}, 104},
	{{90, 214, 185, 128, 0, 0, 143, 204, 246, 100, 4, 199, 0, 249, 126, 133}, 104},
	{{90, 214, 185, 128, 0, 0, 18, 74, 123, 57, 97, 70, 188, 226, 43, 214}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 214, 8}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 216, 16, 161, 97}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 80, 103, 214, 240}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 110, 168, 205, 228, 16, 1, 231, 92}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 226, 199}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 126, 156, 105, 82, 246, 204}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 181, 250, 253, 36, 32, 218, 217, 192, 172}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 164, 197, 101, 24}, 104},
	{{90, 214, 185, 128, 0, 0, 184, 173, 218, 85, 141, 243, 173, 239, 83, 220}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 104},
	{{90, 214, 185, 128, 0, 0, 200, 100, 182, 64, 85, 183, 71, 172, 21, 154}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 140, 212, 42, 254, 82, 31}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 231}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 3, 191, 242, 224, 195, 57, 6, 212, 242}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 158, 161, 158, 177, 197, 23}, 104},
	{{90, 214, 185, 128, 0, 0, 206, 31, 171, 188, 238, 33, 81, 58, 108, 32}, 104},
	{{90, 214, 185, 128, 0, 0, 113, 163, 228, 220, 191, 32, 121, 98, 129, 174}, 104},
	{{90, 214, 185, 128, 115, 160, 230, 151, 0, 33, 87, 179, 1, 14, 80, 168}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 142, 4}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{90, 214, 185, 128, 0, 0, 218, 132, 230, 46, 67, 108, 157, 162, 64, 247}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 192, 20, 66, 80, 93}, 104},
	{{90, 214, 185, 128, 0, 0, 72, 130, 187, 119, 54, 187, 47, 92, 237, 5}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 126}, 104},
	{{90, 214, 185, 128, 0, 0, 5, 41, 159, 164, 51, 213, 124, 76, 249, 250}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{90, 214, 185, 128, 0, 0, 236, 29, 58, 231, 131, 32, 132, 210, 72, 158}, 104},
	{{90, 214, 185, 128, 0, 0, 16, 192, 132, 9, 14, 6, 118, 252, 109, 89}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 128, 166, 61, 190}, 104},
	{{90, 214, 185, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 104},
	{{90, 214, 185, 128, 0, 0, 222, 213, 77, 113, 41, 141, 34, 60, 198, 60}, 104},
	{{90, 214, 185, 128, 0, 0, 191, 160, 92, 166, 146, 9, 153, 37, 158, 179}, 104},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 255}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 181}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 169}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 206}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 80}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 125}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 207}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 188}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 14}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 76}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 206}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 244}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 201}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 47}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 64}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 44}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 117}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 60}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 53}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 180}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 207}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 155}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 250}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 70}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 177}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 216}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 142}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 163}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 2}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 250}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 116}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 244}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 137}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 54}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 33}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 229}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 245}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 23}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 14}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 50}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 0}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 75}, 113},
	{{194, 220, 211, 212, 211, 32, 196, 98, 71, 62, 153, 103, 80, 35, 128, 137}, 113},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 73, 105}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 55, 192, 203, 193, 187}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 153, 160, 31, 76, 132}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 191}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 236, 131, 240}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 219, 154, 105, 169, 155}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 234, 28}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 120, 135, 178}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 186, 254}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 57, 238, 100}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 198, 156, 56, 8, 123}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 135}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 49, 239, 68, 73, 46}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 200, 241, 135, 62}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 80, 122, 242, 121}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 42, 171}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 150, 255}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 93, 230, 120, 35}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 45, 186, 142, 213}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 219}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 210, 218, 54}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 92, 216}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 100, 158, 148, 38}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 4, 187, 67}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 52, 234, 46, 187, 138}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 2}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 4, 58, 206}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 172, 61, 148}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 122, 3, 93}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 120, 127}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 54, 24, 137, 51, 51}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 94, 80, 142, 139}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 61, 56, 139}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 176, 28, 244, 253}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 133, 150, 47}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 241, 133, 33, 125, 72}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 176, 146, 169, 236, 110}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 222, 144, 82, 8}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 249}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 157, 103, 112, 49}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 123, 251, 173}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 20}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 25, 40, 160, 231}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 24, 58, 158, 74, 152}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 78, 47, 33, 115, 232}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 112, 206, 51, 49}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 34, 36}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 189, 140, 133, 224, 31}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 249, 215}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 111, 27, 239, 139}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 102, 5, 226, 144, 80}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 51, 197, 119}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 193, 67, 34}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 85, 100}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 96, 199, 132, 58, 86}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 63, 216, 190}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 136, 2, 249}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 23}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 103, 74}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 138}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 166}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 155, 3, 210}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 45, 179, 107, 73, 36}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 45, 216, 168, 24, 81}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 170, 195, 76, 241, 209}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 228, 69}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 160, 128, 76, 128}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 113, 49, 58, 124, 178}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 16, 210}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 125, 165, 56}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 34, 253, 171, 141, 145}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 0, 0}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 15, 195, 163, 117, 207}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 44, 221, 114}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 0, 0, 0, 159, 52}, 89},
	{{24, 255, 158, 64, 180, 148, 10, 81, 243, 247, 0, 214, 140, 78, 113, 42}, 89},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 182}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 127}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 43}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 174}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 106}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 125}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 218}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 149}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 127}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 118}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 136}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 130}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 83}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 178}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 104}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 89}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 149}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 112}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 193}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 188}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 186}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 160}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 142}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 77}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 169}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 36}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 34}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 110}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 172}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 16}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 250}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 163}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 253}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 135}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 213}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 229}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 103}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 77}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 55}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 113}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 0}, 151},
	{{231, 155, 100, 242, 112, 160, 160, 95, 98, 253, 219, 21, 239, 90, 0, 69}, 151},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 114, 88, 188}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 86, 118, 38, 88, 62, 47, 187, 202, 168}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{225, 96, 0, 0, 83, 210, 241, 233, 22, 183, 123, 89, 197, 111, 199, 31}, 108},
	{{225, 96, 239, 10, 17, 7, 60, 92, 175, 224, 192, 20, 197, 222, 213, 76}, 108},
	{{225, 96, 0, 0, 0, 0, 125, 207, 23, 9, 88, 72, 229, 126, 91, 107}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 39}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 139, 220, 100, 133, 112, 204, 226, 103}, 108},
	{{225, 96, 0, 0, 172, 120, 200, 159, 210, 106, 202, 203, 219, 78, 225, 249}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 244, 7, 180, 150, 57, 239, 88}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 202, 28, 154, 125, 100, 246}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 122, 154, 116, 56, 164, 242, 176, 142}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 12, 204, 82, 14, 183, 35, 174, 240, 113}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 56, 252, 37, 234, 97, 184}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 17, 188, 218, 37, 38, 37, 33, 131}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 239, 47, 62, 174, 132, 252, 151, 174, 15}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 125, 116, 220, 189, 204, 67, 195, 154, 108}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132}, 108},
	{{225, 96, 0, 37, 212, 164, 46, 137, 250, 143, 103, 181, 252, 29, 89, 247}, 108},
	{{225, 96, 46, 56, 27, 179, 87, 21, 58, 111, 80, 127, 43, 183, 153, 10}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 6, 42, 213, 216, 68, 9, 115, 158}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 240, 234, 158}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 252, 7, 83, 11, 21, 203, 139}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 16, 191}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 24, 223, 222, 47, 206, 118}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 0, 25, 5, 227}, 108},
	{{225, 96, 0, 0, 0, 8, 176, 152, 67, 97, 174, 131, 9, 179, 43, 41}, 108},
	{{225, 96, 0, 0, 0, 145, 110, 67, 89, 144, 96, 135, 120, 146, 144, 131}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 115, 84, 86, 29, 62, 43, 245, 39, 255}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 232, 73}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 54, 212}, 108},
	{{225, 96, 0, 0, 0, 58, 143, 208, 91, 255, 204, 31, 253, 148, 169, 23}, 108},
	{{225, 96, 0, 0, 0, 240, 112, 150, 249, 125, 34, 13, 152, 214, 113, 124}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 108},
	{{225, 96, 0, 9, 144, 112, 111, 105, 168, 161, 47, 124, 126, 187, 113, 150}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 115, 207, 4, 60, 219, 236, 62}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 41, 105, 193, 54, 122, 225, 144, 122, 183}, 108},
	{{225, 96, 115, 139, 240, 166, 251, 206, 191, 96, 115, 120, 211, 51, 121, 148}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 56, 132, 125}, 108},
	{{225, 96, 0, 36, 61, 48, 173, 155, 31, 66, 52, 6, 255, 87, 169, 176}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 33, 55, 155, 55, 210, 218, 46, 202, 120}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 131, 171, 114, 252, 1, 226, 69, 235, 249}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 61}, 108},
	{{225, 96, 0, 0, 0, 0, 116, 11, 77, 229, 69, 83, 149, 164, 24, 1}, 108},
	{{225, 96, 0, 0, 125, 78, 166, 126, 57, 23, 95, 14, 99, 169, 18, 219}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 105}, 108},
	{{225, 96, 0, 0, 0, 119, 148, 6, 101, 188, 193, 176, 98, 160, 82, 188}, 108},
	{{225, 96, 0, 6, 38, 51, 176, 250, 115, 196, 88, 248, 52, 227, 97, 63}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 89, 24, 134}, 108},
	{{225, 96, 0, 186, 32, 137, 128, 242, 143, 118, 255, 61, 127, 147, 41, 6}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 60, 221, 144}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 174, 113, 221}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 222, 51, 190, 207, 17, 155, 12}, 108},
	{{225, 96, 97, 222, 76, 196, 162, 197, 175, 18, 133, 201, 64, 219, 13, 55}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 173, 148}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 152}, 108},
	{{225, 96, 0, 0, 0, 207, 189, 193, 193, 158, 27, 60, 170, 220, 129, 56}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 25, 35}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 172, 67, 218, 202, 124, 190, 250, 115}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 221}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 194, 62, 62}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 12, 113, 51, 149}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 19, 253}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 249, 25, 124, 70, 114, 204, 208, 19, 200}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 126, 97, 73, 72, 50, 237}, 108},
	{{225, 96, 0, 0, 209, 123, 143, 182, 163, 210, 63, 69, 228, 144, 41, 163}, 108},
	{{225, 96, 0, 171, 203, 240, 145, 17, 122, 236, 226, 96, 198, 132, 95, 110}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 164, 179, 185, 251, 226, 141}, 108},
	{{225, 96, 0, 0, 0, 0, 139, 160, 97, 17, 85, 55, 146, 75, 193, 95}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 40, 200, 200}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 172}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 56, 61, 95, 12, 97, 229}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 108},
	{{225, 96, 132, 110, 236, 77, 20, 232, 163, 89, 224, 188, 24, 204, 148, 112}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 108},
	{{225, 96, 14, 167, 95, 123, 93, 168, 70, 244, 118, 178, 158, 37, 216, 192}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 108},
	{{225, 96, 207, 110, 31, 243, 204, 129, 16, 67, 98, 32, 11, 164, 165, 42}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 108},
	{{225, 96, 0, 0, 0, 173, 210, 45, 188, 98, 63, 181, 247, 218, 87, 99}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 103, 249, 4, 101}, 108},
	{{225, 96, 0, 14, 179, 86, 51, 92, 39, 88, 191, 82, 217, 64, 68, 44}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 161, 60, 127}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 124, 29, 125, 28, 130, 22, 158, 94}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 240, 124, 54}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 101, 18, 82, 56}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 147, 201}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{225, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 206, 17}, 108},
	{{225, 96, 0, 0, 0, 84, 151, 42, 49, 18, 50, 126, 246, 23, 128, 109}, 108},
	{{225, 96, 0, 0, 0, 96, 134, 116, 188, 250, 178, 106, 249, 41, 13, 184}, 108},
	{{136, 0, 0, 0, 0, 0, 0, 0, 91, 39, 51, 15, 229, 169, 5, 37}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 244, 138, 61, 254}, 224},
	{{136, 0, 0, 0, 0, 153, 159, 180, 131, 190, 34, 166, 186, 217, 238, 149}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 230, 148, 178, 114, 44}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 125, 209}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 253, 103, 81, 107, 197, 15, 169, 49}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 60, 168, 42, 192, 43}, 224},
	{{136, 0, 0, 78, 142, 242, 168, 70, 28, 137, 250, 74, 136, 32, 7, 168}, 224},
	{{136, 0, 0, 0, 0, 191, 44, 188, 27, 187, 187, 35, 130, 157, 60, 124}, 224},
	{{136, 0, 0, 0, 0, 0, 89, 87, 44, 224, 203, 32, 29, 103, 11, 125}, 224},
	{{136, 0, 0, 0, 0, 66, 144, 237, 26, 117, 171, 60, 145, 14, 195, 57}, 224},
	{{136, 0, 0, 0, 0, 244, 157, 85, 117, 20, 82, 173, 36, 76, 238, 218}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 231, 138, 136, 123, 23, 127, 240}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 16, 40, 151}, 224},
	{{136, 0, 0, 63, 59, 157, 174, 55, 82, 205, 214, 162, 160, 221, 77, 77}, 224},
	{{136, 0, 0, 36, 189, 67, 204, 191, 177, 236, 21, 30, 22, 233, 199, 148}, 224},
	{{136, 0, 0, 0, 0, 119, 235, 10, 21, 2, 244, 61, 88, 215, 248, 46}, 224},
	{{136, 0, 0, 0, 46, 209, 156, 16, 103, 77, 136, 29, 220, 85, 48, 210}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 194}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{136, 0, 0, 0, 0, 47, 37, 195, 239, 120, 215, 130, 162, 245, 55, 105}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 224},
	{{136, 0, 0, 57, 68, 223, 147, 29, 196, 7, 9, 45, 210, 179, 176, 6}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 36, 107, 69, 128, 18, 221, 97}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 201}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 113, 163, 103, 179, 195, 99, 129, 72}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 45, 240, 177, 175, 86, 63, 214, 151}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58}, 224},
	{{136, 0, 177, 137, 255, 180, 231, 247, 217, 185, 184, 56, 175, 178, 143, 98}, 224},
	{{136, 0, 0, 0, 2, 34, 7, 10, 214, 73, 229, 63, 212, 151, 65, 216}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 229, 68, 149, 56, 155, 162, 160, 1}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 121, 242}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 84, 45}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 88, 2, 120, 185}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{136, 0, 247, 226, 143, 50, 237, 201, 146, 208, 184, 103, 11, 226, 38, 125}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137}, 224},
	{{136, 0, 0, 0, 0, 160, 162, 144, 64, 53, 14, 71, 177, 248, 18, 214}, 224},
	{{136, 0, 0, 0, 113, 29, 244, 132, 135, 117, 136, 72, 94, 207, 73, 181}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 247, 212, 250}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 176, 91, 97, 37, 77, 201, 154, 65}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 226}, 224},
	{{136, 0, 0, 0, 171, 101, 23, 71, 254, 138, 142, 73, 85, 172, 145, 48}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 62, 143, 180, 173}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 5, 63, 159, 252, 181, 122, 17}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 77, 174, 163, 129, 51, 215, 35, 211, 104}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 255}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 247}, 224},
	{{136, 0, 0, 0, 0, 0, 38, 233, 102, 234, 43, 94, 139, 100, 211, 174}, 224},
	{{136, 0, 0, 167, 173, 148, 157, 16, 114, 193, 105, 24, 121, 124, 247, 47}, 224},
	{{136, 0, 201, 130, 90, 208, 48, 120, 62, 120, 176, 249, 53, 176, 7, 193}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 100, 81, 214, 134, 224, 247, 229, 195}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 161, 34, 98, 113, 161, 233, 221}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 100}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 66, 129, 178}, 224},
	{{136, 0, 0, 247, 37, 129, 7, 9, 255, 244, 40, 177, 99, 8, 186, 161}, 224},
	{{136, 0, 0, 0, 0, 203, 46, 214, 94, 157, 116, 225, 31, 6, 157, 64}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 10, 97, 236, 127, 38, 232, 235}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 94, 75, 213, 85, 187, 73, 95}, 224},
	{{136, 0, 0, 0, 0, 58, 188, 21, 49, 214, 47, 86, 157, 76, 101, 144}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 73, 137}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 226, 161, 151, 234, 161, 133, 31, 184, 221}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 213, 226, 0, 21, 255, 223, 38, 216}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 50, 100, 83, 142, 84, 5, 238, 34}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 75, 223, 33, 233, 12, 147, 50, 210, 145}, 224},
	{{136, 0, 0, 0, 0, 165, 25, 145, 91, 144, 182, 237, 69, 21, 59, 199}, 224},
	{{136, 0, 0, 152, 219, 100, 192, 11, 202, 90, 161, 14, 22, 60, 160, 161}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 31, 175, 168, 88, 181, 104, 143}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 121, 76, 103, 7, 207}, 224},
	{{136, 0, 120, 218, 86, 184, 36, 155, 110, 190, 231, 144, 106, 34, 119, 208}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 208}, 224},
	{{136, 0, 0, 175, 45, 104, 217, 158, 84, 248, 24, 121, 146, 198, 97, 71}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 158, 208, 225, 250}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 76, 215, 71, 69, 113, 252, 4, 93, 33}, 224},
	{{136, 0, 0, 0, 0, 155, 188, 148, 13, 247, 169, 176, 156, 228, 149, 172}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 165, 117, 75}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 211, 155, 223}, 224},
	{{136, 0, 0, 0, 0, 0, 132, 46, 225, 184, 212, 165, 186, 238, 176, 62}, 224},
	{{136, 0, 0, 208, 80, 217, 58, 202, 83, 37, 202, 102, 191, 217, 98, 106}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 4, 99}, 224},
	{{136, 0, 0, 0, 122, 31, 1, 39, 246, 161, 202, 227, 125, 149, 105, 57}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 248, 39, 254, 239, 15}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 207, 111, 115, 67, 244, 80, 36}, 224},
	{{136, 0, 0, 0, 0, 0, 101, 51, 55, 11, 7, 238, 86, 76, 188, 221}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 97, 186, 74, 4, 149, 104, 198}, 224},
	{{136, 0, 78, 21, 233, 94, 143, 239, 47, 61, 172, 80, 76, 109, 122, 155}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 243, 101, 236, 5, 5, 47, 105, 219, 228}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 70, 173, 212, 166, 191, 178, 130, 103, 37}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 149, 12, 249, 131, 131, 84, 177, 187}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 248, 142, 209, 110, 229, 66, 184}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 237, 118, 68, 58, 199}, 224},
	{{136, 38, 35, 218, 136, 15, 137, 170, 56, 218, 86, 49, 16, 158, 114, 219}, 224},
	{{250, 128, 0, 0, 0, 0, 40, 87, 237, 227, 167, 139, 9, 38, 42, 55}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 146},
	{{250, 128, 78, 90, 214, 208, 20, 211, 26, 166, 51, 253, 223, 159, 255, 3}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 237, 232}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{250, 128, 100, 154, 199, 36, 113, 214, 57, 72, 99, 70, 203, 20, 191, 128}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 64, 59, 44, 56, 7, 109, 107}, 146},
	{{250, 128, 0, 0, 205, 179, 148, 245, 248, 230, 152, 66, 211, 82, 72, 35}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 126, 227, 105, 186, 64, 82, 135, 107, 46}, 146},
	{{250, 128, 0, 0, 232, 232, 101, 76, 90, 31, 72, 91, 203, 123, 33, 105}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 90, 40, 66, 47, 93, 7, 160}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 20, 12}, 146},
	{{250, 128, 0, 0, 0, 0, 255, 155, 170, 132, 239, 125, 185, 120, 129, 148}, 146},
	{{250, 128, 0, 133, 93, 9, 194, 162, 1, 225, 13, 13, 248, 179, 203, 72}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 66, 42, 195, 114, 36, 204}, 146},
	{{250, 128, 103, 201, 231, 191, 0, 203, 204, 24, 69, 167, 94, 129, 96, 155}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 64, 25, 49, 212}, 146},
	{{250, 128, 0, 0, 0, 122, 190, 118, 83, 224, 80, 17, 15, 137, 186, 73}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 21, 200, 143, 1, 192, 50}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 146},
	{{250, 128, 198, 232, 169, 71, 128, 231, 175, 151, 69, 198, 52, 236, 240, 38}, 146},
	{{250, 128, 0, 0, 39, 214, 59, 197, 45, 69, 209, 240, 3, 75, 53, 82}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{250, 128, 0, 166, 165, 38, 120, 118, 232, 162, 254, 146, 244, 240, 168, 177}, 146},
	{{250, 128, 0, 0, 0, 0, 221, 121, 238, 96, 27, 11, 84, 231, 3, 174}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 146},
	{{250, 128, 0, 0, 242, 208, 175, 113, 232, 32, 60, 132, 165, 30, 145, 198}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 254, 179, 120, 53, 5, 178, 251, 160}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 167, 30}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 136, 80, 21}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 128, 20}, 146},
	{{250, 128, 0, 0, 168, 15, 55, 186, 118, 254, 133, 53, 2, 148, 79, 149}, 146},
	{{250, 128, 0, 0, 0, 51, 165, 248, 235, 3, 173, 219, 248, 102, 26, 247}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 146},
	{{250, 128, 0, 0, 0, 0, 242, 12, 116, 185, 35, 149, 186, 37, 220, 249}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 3, 123, 6, 113, 99, 231}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 49, 221, 20, 148, 216, 242}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 16, 145, 123, 188, 99, 150, 81}, 146},
	{{250, 128, 0, 0, 0, 0, 230, 44, 167, 126, 148, 148, 82, 106, 62, 38}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 231, 14, 102, 135, 25, 227, 24}, 146},
	{{250, 128, 0, 0, 10, 214, 184, 61, 240, 85, 81, 148, 209, 213, 67, 39}, 146},
	{{250, 128, 0, 0, 0, 0, 211, 70, 34, 154, 99, 241, 85, 145, 171, 201}, 146},
	{{250, 128, 182, 85, 197, 212, 118, 229, 12, 183, 174, 213, 23, 197, 7, 186}, 146},
	{{250, 128, 0, 167, 190, 243, 173, 129, 106, 91, 0, 244, 31, 188, 153, 38}, 146},
	{{250, 128, 0, 0, 109, 160, 183, 219, 241, 17, 166, 46, 113, 27, 137, 38}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 162, 78}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 91, 76, 199, 18, 193, 28, 226, 233, 41}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 182}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 196, 49, 47, 188, 242, 81, 252, 102}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 210, 189, 127, 80, 228, 19, 136, 235}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 54}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 51, 57, 91}, 146},
	{{250, 128, 0, 0, 41, 8, 151, 163, 20, 144, 82, 81, 144, 100, 212, 35}, 146},
	{{250, 128, 0, 0, 0, 0, 17, 191, 150, 208, 191, 19, 119, 41, 122, 218}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 41, 115, 59, 74, 112, 12, 150, 157, 122}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 124, 1, 136, 162, 140, 211, 201}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 122, 14, 191, 11}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 224, 101, 156, 45}, 146},
	{{250, 128, 0, 0, 0, 225, 122, 213, 136, 240, 3, 130, 184, 13, 7, 254}, 146},
	{{250, 128, 0, 0, 0, 230, 18, 204, 158, 143, 16, 160, 233, 127, 58, 122}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 244, 53, 8, 39}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 197, 40, 87, 202, 57, 109, 77}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 25, 49, 45, 139}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 101}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 96, 241, 32, 178, 203, 200, 106, 190, 105}, 146},
	{{250, 128, 0, 180, 73, 249, 172, 122, 176, 128, 175, 98, 54, 17, 30, 193}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 206, 249}, 146},
	{{250, 128, 0, 144, 211, 153, 53, 231, 195, 79, 142, 115, 138, 199, 132, 222}, 146},
	{{250, 128, 0, 0, 0, 82, 65, 179, 249, 149, 60, 136, 129, 134, 23, 200}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 15, 242, 232, 169, 4, 6, 204, 121}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 97, 222, 3}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 184, 210}, 146},
	{{250, 128, 0, 0, 157, 188, 207, 220, 114, 193, 130, 97, 208, 201, 4, 147}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 121, 39, 138}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 85, 115, 100, 31, 112, 79, 156}, 146},
	{{250, 128, 0, 0, 0, 0, 44, 250, 85, 86, 141, 87, 96, 251, 24, 26}, 146},
	{{250, 128, 0, 0, 0, 0, 190, 137, 169, 69, 86, 187, 26, 15, 186, 124}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 116, 174, 47, 49, 63, 18, 107, 173, 80}, 146},
	{{250, 128, 0, 26, 111, 189, 74, 186, 189, 210, 58, 1, 130, 84, 117, 135}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 251, 39, 225}, 146},
	{{250, 128, 0, 0, 232, 169, 215, 0, 24, 47, 188, 23, 152, 197, 34, 209}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 230, 40, 165, 189, 171, 74, 222}, 146},
	{{250, 128, 0, 0, 0, 0, 198, 64, 55, 39, 195, 117, 155, 226, 194, 165}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 77, 211, 184, 185, 242, 1}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 25, 205, 213, 76, 16, 143}, 146},
	{{250, 128, 0, 0, 0, 0, 79, 19, 6, 117, 156, 93, 170, 171, 234, 83}, 146},
	{{250, 128, 40, 107, 111, 97, 183, 11, 130, 207, 55, 235, 45, 33, 65, 126}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 214, 253, 164, 53, 0, 107, 170, 118, 18}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 96, 30, 97, 14, 163, 131, 38, 100}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 136, 59, 254, 199, 184, 129, 46, 102, 230}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 225}, 146},
	{{72, 168, 0, 0, 0, 0, 0, 0, 125, 24, 199, 174, 39, 41, 213, 39}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 45, 64, 229}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 146}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 210}, 173},
	{{72, 168, 0, 0, 55, 28, 218, 189, 205, 234, 131, 108, 194, 253, 227, 251}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 12, 100, 245, 208}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 167, 105}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{72, 168, 0, 0, 67, 145, 251, 233, 123, 85, 251, 29, 243, 95, 172, 182}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 68, 155, 202, 0, 104, 239, 40}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 216, 218, 82, 70, 92, 142, 238, 198}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 41, 78}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{72, 168, 0, 73, 9, 135, 85, 150, 125, 191, 26, 118, 136, 46, 14, 217}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 91, 177, 151}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 111, 175, 62, 17, 38, 76, 55, 174}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 201, 3, 93}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 132, 234, 33}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 204, 91, 190}, 173},
	{{72, 168, 0, 76, 63, 188, 13, 37, 129, 49, 158, 213, 220, 82, 59, 86}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{72, 168, 0, 0, 0, 0, 220, 190, 82, 171, 215, 52, 129, 218, 177, 239}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 57, 112, 136, 128}, 173},
	{{72, 168, 0, 200, 204, 118, 174, 249, 217, 145, 200, 139, 35, 40, 161, 44}, 173},
	{{72, 168, 0, 0, 0, 0, 247, 119, 205, 168, 150, 35, 59, 84, 159, 23}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 8}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 173},
	{{72, 168, 0, 0, 196, 13, 178, 108, 226, 227, 14, 104, 210, 27, 184, 199}, 173},
	{{72, 168, 0, 0, 0, 0, 54, 79, 232, 9, 192, 113, 190, 92, 102, 164}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 206, 179, 129}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 117, 32, 60, 56, 141, 248}, 173},
	{{72, 168, 0, 0, 0, 0, 100, 237, 206, 187, 214, 114, 190, 160, 2, 145}, 173},
	{{72, 168, 0, 150, 153, 155, 171, 130, 84, 41, 143, 253, 41, 223, 154, 199}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 6, 206}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 76, 92, 19, 38, 228, 129, 243, 217, 61}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 145, 59, 243, 173, 236, 26, 3, 132}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 31, 160, 128, 39, 31, 200, 97, 39, 183}, 173},
	{{72, 168, 0, 0, 45, 180, 121, 177, 124, 237, 249, 95, 108, 143, 178, 27}, 173},
	{{72, 168, 0, 183, 184, 156, 28, 212, 64, 111, 124, 247, 168, 79, 178, 101}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 224, 72, 111, 222, 211, 248, 69}, 173},
	{{72, 168, 0, 0, 0, 0, 63, 64, 9, 96, 19, 235, 168, 21, 34, 10}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 38, 128, 140}, 173},
	{{72, 168, 0, 0, 0, 0, 101, 179, 163, 148, 148, 37, 163, 36, 147, 134}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 109, 129, 195, 78, 244, 22, 171, 70, 152}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 253, 160}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 173},
	{{72, 168, 0, 0, 166, 8, 40, 21, 91, 214, 195, 113, 152, 157, 251, 144}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 174, 22, 44, 77, 28, 121, 1, 106}, 173},
	{{72, 168, 0, 109, 248, 193, 255, 252, 227, 154, 218, 172, 26, 75, 42, 142}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 193, 15, 159}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 185}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 133, 232}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 173, 22, 242, 173}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 41}, 173},
	{{72, 168, 0, 0, 79, 77, 211, 244, 188, 194, 64, 16, 43, 219, 226, 247}, 173},
	{{72, 168, 0, 215, 110, 46, 45, 19, 227, 5, 126, 144, 153, 146, 177, 232}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 37}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 160, 208, 140, 178, 130, 168, 130, 43}, 173},
	{{72, 168, 0, 0, 0, 251, 179, 96, 114, 49, 254, 248, 18, 186, 139, 225}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 11, 147, 196, 123, 118, 76, 8}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 151, 249, 94, 57}, 173},
	{{72, 168, 0, 0, 0, 221, 200, 114, 122, 233, 229, 18, 165, 55, 162, 217}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 240, 45, 231}, 173},
	{{72, 168, 55, 232, 93, 125, 177, 62, 183, 54, 195, 189, 92, 208, 231, 226}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 186}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 1, 166, 145, 241, 30, 122, 132, 208, 4}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 109, 4, 113, 154, 110, 6, 65, 37}, 173},
	{{72, 168, 0, 0, 0, 102, 80, 166, 189, 171, 152, 52, 148, 120, 61, 217}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 184, 189, 101, 105, 105, 225, 185}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 160, 240}, 173},
	{{72, 168, 0, 0, 0, 254, 141, 185, 145, 165, 223, 254, 96, 161, 106, 204}, 173},
	{{72, 168, 0, 194, 21, 192, 39, 150, 139, 197, 175, 75, 135, 171, 73, 178}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 26}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 124, 3, 157, 86, 49, 129}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 69, 77, 88, 220, 35, 236}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 47}, 173},
	{{72, 168, 56, 73, 165, 96, 101, 238, 234, 134, 228, 217, 40, 28, 118, 181}, 173},
	{{72, 168, 0, 0, 10, 254, 100, 153, 225, 161, 39, 23, 214, 81, 244, 62}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 79, 28, 98, 107, 248, 47}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 169, 51, 190, 9, 35, 33, 220, 145}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 111, 155, 243, 240, 244, 33, 126, 141}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 213, 200, 97, 37, 235, 146, 154, 132}, 173},
	{{72, 168, 0, 0, 0, 0, 203, 59, 118, 239, 181, 5, 15, 80, 40, 217}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 108}, 173},
	{{72, 168, 0, 0, 168, 169, 50, 90, 166, 64, 215, 136, 99, 54, 221, 116}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 100, 219, 113, 65, 188, 179}, 173},
	{{72, 168, 0, 226, 81, 36, 44, 138, 161, 7, 253, 242, 129, 113, 83, 150}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{72, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 17, 103}, 173},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 184}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 44, 120, 29, 46}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 138}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 253, 221}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 123, 230, 65}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 7, 144}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 176, 233}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 28}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 14, 81, 118, 85}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 138, 105}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 27}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 171, 161, 42}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 16, 18}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 201, 109}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 30}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 226, 164}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 140, 184, 70}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 240}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 32, 209, 91}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 32, 111, 164, 76}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 171, 2}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 149, 89, 237, 22}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 164}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 3, 255, 66}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 35, 35, 254}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 65, 195, 95, 150}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 124, 244, 126}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 44}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 19, 229}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 84, 6}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 253}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 138, 5}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 205, 194, 201}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 122, 38}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 13, 61}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 205, 155, 69, 207}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 93, 21}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 193, 218, 83}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 20, 135}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 84}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 31, 161, 248}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 204}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 239}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 10, 90, 5}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 178, 244}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 19}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 123, 184}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 39, 237, 154}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 113, 101, 163}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 158}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 241, 218, 224, 130}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 223}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 45}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 77}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 34, 252, 56}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 213, 80, 201}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 105}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 130, 106}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 198}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 100, 176, 222}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 223, 245, 232}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 70, 8}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 33}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 209, 237, 27, 7}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 176, 130, 105, 235}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 180, 0, 233}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 168, 136, 252}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 30, 130}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 152, 225}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 219, 176, 86}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 177, 128, 140, 123}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 25, 235}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 167, 161}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 176, 65, 162, 61}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 124}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 59}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 107, 132}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 102}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 78, 139}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 88}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 0, 0, 0}, 176},
	{{185, 51, 51, 167, 18, 44, 36, 59, 35, 135, 20, 104, 0, 94, 63, 59}, 176},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 23}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 45}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 113}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 148}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 59}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 30}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 181}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{57, 146, 252, 60, 197, 68, 39, 162, 80, 198, 137, 50, 97, 92, 124, 0}, 84},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 95, 175, 90, 36, 72, 195}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 196, 150, 244}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 99, 15, 213, 73, 44}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 104}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 36, 135, 214, 147}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 181, 61, 241, 56, 101, 72}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 168, 34, 197, 63, 8, 155}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 184, 24, 21, 179}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 33, 8, 153, 187}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 5, 57, 190}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 148, 128, 140, 186}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 157, 82}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 198}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 210}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 63, 65, 27, 176}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 57, 216}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 227, 95, 103, 112}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 118, 250, 214, 235}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 152, 230, 147, 12}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 197, 30, 198}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 153, 237, 186, 253, 243}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 238, 253, 236, 150}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 52}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 37, 104, 137, 103, 73}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 122, 23, 166, 233, 212, 247}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 6, 241, 44, 56, 150, 42}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 68, 213, 233}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 102, 61, 45, 181}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 241, 49}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 235, 28}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 112, 67}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 186}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 198, 89, 131, 24}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 232, 17}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 226, 80}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 32}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 60, 140, 243, 179}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 24, 180}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 190, 19, 21, 9}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 100}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 186, 202, 92, 30}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 177, 156}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 155, 106, 198}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 4, 28, 39, 7, 212}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 43, 225, 45}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 183, 136, 113, 156}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 208, 153, 162, 26, 86}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 12, 229}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 149}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 156, 192, 196, 76, 60}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 141, 129, 16, 51, 120}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 183, 88, 242, 240}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 170, 227, 3, 88, 9}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 14, 99, 255}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 138, 163, 49, 154, 96}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 151}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 97, 220, 14}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 32, 185, 136}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 150, 210, 63}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 123, 62}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 142, 245, 83, 216, 108}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 246, 163}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 125, 83}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 136, 30}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 243, 23, 200}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 29, 217, 246}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 228, 201, 232, 201}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 116, 211, 208, 74}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 187, 82}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 214}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 253, 194}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 237}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 50}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 15, 25, 104, 157}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 105, 202, 32, 52}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 0, 0, 0}, 104},
	{{254, 46, 242, 105, 86, 94, 96, 14, 130, 176, 0, 0, 0, 93, 189, 195}, 104},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 87, 56, 87, 189, 92, 208, 143}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 215, 74, 248, 160, 174, 43}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 37, 97, 55, 129, 35}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 249, 168, 85, 226}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 72, 92}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 189, 143, 204, 91, 40, 213, 175, 161}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 167, 230, 166, 45, 111, 100, 95}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 144, 98, 112, 90}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 9, 27, 203, 11, 157, 1, 48}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 75, 10, 209}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 15, 72, 223}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 65, 118, 145, 71, 144, 126}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 196, 56, 38, 236}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 129, 76, 25, 215, 32, 227, 5}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 252, 215, 218, 94, 134, 135, 71, 67, 233}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 85, 94, 113, 25, 240, 76, 125, 89}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 71, 12, 47, 252, 188, 113, 42, 111, 231}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 193, 113, 112, 13, 0}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 119, 244, 11}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 148, 241, 37, 185, 98, 15, 253, 117}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 6, 79, 20, 184, 35, 159, 127}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 160, 108, 159, 68, 162, 103, 84, 255}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 53, 211, 84, 208, 7, 36, 50}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 218, 121, 15, 44, 139, 229, 64, 3, 218}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 27, 170, 205, 64}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 152, 226, 216, 136, 122, 23, 61, 93, 108}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 44, 202, 203, 173, 249, 192, 126}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 44, 208}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 88, 250, 6, 20, 63}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 70, 27, 203, 124, 86, 81, 84, 69, 51}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 76, 199, 2, 78}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 147, 124, 192, 80, 159, 132, 209, 181, 8}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 251, 135, 85, 93, 138}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 164, 104, 155, 54, 110, 117, 181, 113}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 165, 81}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 126, 172, 170, 202, 179, 88, 16, 163, 157}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 140, 43, 106, 44, 126, 196, 215, 17, 193}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 32, 176, 248, 135, 198, 182, 61, 59, 159}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 226, 60, 144, 32, 101, 98, 183, 210}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 10, 232, 29, 89}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 151, 117, 214, 122, 233, 225, 1, 92, 224}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 237, 126, 215}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 14, 217, 90, 116, 200}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 194, 40, 124}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 197, 196, 105, 213, 192}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 115, 208, 132, 95, 173, 46, 129, 48}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 193, 166, 137, 134, 159}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 202, 4, 58, 248, 153}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 92, 204, 224, 24, 15, 144, 88, 55, 55}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 248, 12}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 53, 243, 230, 61, 187, 95, 225}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 127, 55, 2, 36, 93, 76}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 227, 216, 55, 203, 38}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 211, 105, 61, 224, 118, 88}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 245, 240, 177, 251, 33, 214}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 55, 170, 197, 16}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 159, 40, 189, 225, 20, 23, 20, 153, 236}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 60, 191, 85, 146, 197}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 123, 221, 90}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 131, 49, 227, 220}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 63, 230, 163, 55, 53}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 170, 29, 100, 18, 168, 15, 129, 213}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 10, 113, 232, 163, 193, 119}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 67, 137, 251, 84, 230}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 164, 81, 127, 215, 198, 170, 189, 53}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 36, 62, 98}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 246, 253, 163, 71, 4, 126, 37}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 241, 147, 80, 126, 35}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 255, 15}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 91, 181, 44, 76}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 151, 250, 126, 183, 156, 202, 46}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 236, 134, 40, 87, 198, 42}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 164, 229, 198, 235, 233, 39, 4, 195}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 152, 147, 205, 74, 236}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 198, 177, 87, 35}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 0, 0, 0, 98, 146, 81}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 0, 128, 57, 115, 185, 25, 193}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 235, 167, 235, 138, 187, 220, 25, 81, 36}, 236},
	{{247, 202, 176, 76, 69, 40, 0, 0, 0, 231, 215, 166, 88, 27, 14, 55}, 236},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 86}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 156}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 124}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 145}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 78}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 49}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 195}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 138}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 165}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 76}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 17}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 103}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 72}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 53}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 99}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 59}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 157}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 120}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 104}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 64}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 109}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 229}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 161}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 126}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 6}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 220}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{50, 233, 203, 77, 42, 21, 115, 163, 166, 138, 192, 52, 178, 37, 112, 0}, 153},
	{{62, 192, 160, 24, 235, 189, 233, 137, 34, 20, 38, 148, 229, 171, 156, 138}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 92, 118, 17, 5}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 91, 185, 168}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 204, 203, 223, 181}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 40, 17}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 151, 200, 116}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 220, 240, 76, 145}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 147, 87}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 107, 160, 29, 242, 23, 50, 253}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 172, 114, 223, 114, 146, 46, 240, 3, 85}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 210, 225, 242}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 0, 120, 94}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 99, 224, 189}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 92, 145, 80, 252, 35, 47}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 83, 163, 214, 40, 102, 199}, 190},
	{{62, 192, 0, 0, 0, 123, 77, 24, 144, 64, 4, 176, 87, 87, 72, 168}, 190},
	{{62, 192, 0, 107, 80, 221, 21, 253, 116, 253, 223, 91, 187, 196, 157, 90}, 190},
	{{62, 192, 0, 0, 175, 103, 140, 103, 45, 218, 146, 54, 218, 58, 180, 48}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 65, 82, 72, 85, 39, 42, 242, 130}, 190},
	{{62, 192, 0, 0, 0, 205, 85, 81, 124, 85, 52, 86, 48, 161, 17, 212}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 174, 7, 104, 123, 153, 127, 85, 244}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 222, 188, 205}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 2, 90}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 54, 121, 235, 206, 118, 254}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 112, 184, 254, 119, 96, 30, 128, 203, 198}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 219, 8, 216, 115, 1, 126, 148, 234}, 190},
	{{62, 192, 57, 232, 18, 215, 217, 109, 245, 158, 244, 210, 191, 216, 175, 249}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 211, 48}, 190},
	{{62, 192, 0, 0, 0, 0, 175, 185, 70, 129, 157, 12, 121, 63, 120, 141}, 190},
	{{62, 192, 0, 0, 0, 0, 151, 156, 249, 242, 67, 236, 204, 19, 20, 112}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 100, 181, 252, 13, 15, 190, 241}, 190},
	{{62, 192, 0, 154, 2, 5, 51, 122, 234, 19, 88, 131, 41, 67, 26, 127}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 190},
	{{62, 192, 0, 0, 0, 73, 12, 139, 61, 215, 126, 11, 39, 30, 14, 212}, 190},
	{{62, 192, 0, 0, 0, 167, 230, 168, 62, 148, 10, 156, 233, 212, 191, 135}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 99, 42, 254, 208, 144, 38, 50, 135, 34}, 190},
	{{62, 192, 0, 0, 61, 242, 30, 204, 202, 107, 178, 48, 9, 158, 171, 113}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 136, 23, 153, 148, 174, 14, 67}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 147, 229, 181, 14, 35, 120}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 124, 234, 113, 158}, 190},
	{{62, 192, 0, 0, 0, 0, 157, 152, 109, 114, 112, 181, 205, 142, 20, 90}, 190},
	{{62, 192, 0, 0, 75, 24, 90, 57, 68, 177, 141, 138, 223, 247, 153, 57}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 207, 126, 11, 14, 165, 172, 102}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 120, 241, 223, 1, 179, 116, 216, 149, 190}, 190},
	{{62, 192, 172, 68, 18, 157, 227, 172, 78, 115, 29, 248, 122, 62, 5, 86}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 27, 56, 92, 9, 89, 59}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 183}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 196, 119, 29, 15, 247, 94, 81}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 185, 109, 141}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 77, 108, 120, 95, 9, 186, 18, 98, 118}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 213, 185, 240, 137, 234, 143, 174, 164, 66}, 190},
	{{62, 192, 0, 127, 0, 133, 55, 126, 95, 149, 200, 94, 222, 14, 221, 42}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 206, 73, 197, 104, 164, 109}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 101, 8, 99, 106, 127, 100, 216, 220}, 190},
	{{62, 192, 0, 0, 0, 0, 166, 201, 250, 9, 128, 91, 188, 161, 47, 83}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 145, 175, 217, 73, 45, 240, 208}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 190},
	{{62, 192, 0, 0, 151, 248, 48, 232, 17, 207, 51, 128, 241, 0, 110, 23}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 150, 55, 200, 110, 186, 180, 191}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 160, 102, 215}, 190},
	{{62, 192, 0, 0, 17, 73, 34, 38, 41, 35, 66, 230, 180, 92, 146, 46}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{62, 192, 0, 0, 0, 0, 173, 59, 33, 240, 80, 0, 176, 116, 49, 173}, 190},
	{{62, 192, 0, 0, 18, 152, 173, 219, 24, 150, 17, 144, 6, 225, 67, 15}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 206, 68}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 243, 158, 5}, 190},
	{{62, 192, 0, 0, 135, 155, 2, 254, 180, 94, 255, 242, 159, 135, 123, 126}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 124, 252, 18, 9, 160, 243, 47, 24, 165}, 190},
	{{62, 192, 0, 50, 224, 199, 57, 113, 217, 167, 187, 203, 166, 125, 239, 1}, 190},
	{{62, 192, 36, 209, 175, 156, 40, 111, 183, 191, 136, 194, 167, 115, 92, 91}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 125, 38, 240}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 228, 138, 49, 154}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 11, 12, 243, 206, 105, 61, 197, 116}, 190},
	{{62, 192, 0, 0, 0, 0, 220, 141, 48, 151, 181, 7, 216, 137, 32, 107}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 223, 152, 77, 126, 132, 183, 159, 26, 90}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 190, 131, 222}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 244, 134, 88, 40}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 53, 171, 75, 1, 134, 164}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 227, 132}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 169}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 190},
	{{62, 192, 0, 0, 15, 50, 248, 71, 56, 101, 147, 32, 207, 78, 207, 234}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 16, 224}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 116, 123, 205, 150, 246, 117, 51}, 190},
	{{62, 192, 0, 0, 0, 0, 103, 127, 244, 207, 182, 77, 229, 24, 14, 61}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 74, 93, 57, 252}, 190},
	{{62, 192, 0, 0, 0, 12, 83, 6, 149, 154, 87, 131, 167, 224, 255, 124}, 190},
	{{62, 192, 0, 0, 0, 0, 12, 235, 20, 247, 158, 250, 141, 215, 222, 64}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 52, 174}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 6, 221, 36, 192, 165, 54, 53, 2, 0}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 74, 134, 135, 179}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 165, 65, 169, 209, 118, 207, 38}, 190},
	{{62, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 153, 152, 94}, 190},
	{{53, 96, 0, 0, 0, 0, 0, 136, 57, 205, 136, 88, 195, 126, 29, 78}, 202},
	{{53, 96, 0, 0, 86, 81, 13, 202, 240, 175, 152, 23, 205, 84, 46, 120}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 93, 177, 30, 136, 113, 200}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 58, 234, 132, 200, 80, 102}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 85, 255, 242, 167, 145, 7}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 86, 61, 229, 220, 52, 87, 239, 108, 253}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 94, 184, 210, 167, 177, 219, 68, 197, 92}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 161, 216, 72, 147, 82, 249, 211, 67, 15}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 73}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 118, 119, 121, 215, 222, 240, 245}, 202},
	{{53, 96, 0, 63, 247, 63, 127, 80, 233, 212, 167, 104, 255, 218, 80, 166}, 202},
	{{53, 96, 0, 0, 0, 211, 157, 27, 28, 88, 167, 95, 112, 135, 237, 18}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 232, 173, 95, 189}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 224, 254, 145, 139, 132, 134}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 181, 31, 15}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 131, 139, 213, 234, 24, 252}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 33, 24, 176, 55, 5, 24, 49, 32, 183}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 220, 50, 96, 36, 102, 131, 198}, 202},
	{{53, 96, 0, 0, 0, 0, 111, 106, 248, 124, 239, 243, 190, 178, 64, 73}, 202},
	{{53, 96, 0, 91, 138, 53, 203, 214, 73, 220, 232, 87, 158, 226, 184, 213}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 163, 98, 24, 149, 251, 32}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 160, 18, 87, 91, 248, 149, 179, 183}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 74}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 250, 93, 5, 110, 173, 105, 103}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 9}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 130, 167, 220, 58, 78, 25, 177, 235}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 163, 108, 213, 230, 127, 156, 169, 90, 29}, 202},
	{{53, 96, 0, 0, 0, 0, 85, 155, 237, 5, 244, 184, 156, 155, 60, 97}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 160, 240}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 29, 209, 70, 129, 77, 164, 133, 6, 135}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 87, 96, 120, 63, 149, 255}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 189, 252, 221, 193, 60, 59}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 84, 104, 242, 66, 216, 113}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 218, 165, 180, 175, 163, 34, 128, 161, 154}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 17, 253}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 77, 131, 184, 230, 221, 97, 67}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 18, 17, 51, 157, 229, 214, 176}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 56, 82, 149, 204, 235, 18, 236, 103, 129}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 185, 163, 159}, 202},
	{{53, 96, 0, 0, 0, 170, 44, 147, 121, 118, 183, 3, 178, 69, 53, 43}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 222, 12, 204, 209}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 20, 170, 107, 214, 78, 196, 15, 67, 43}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 141, 209, 185, 37, 226, 124, 162, 32, 118}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 100}, 202},
	{{53, 96, 0, 0, 0, 39, 102, 184, 46, 103, 118, 83, 29, 43, 71, 9}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 53, 11, 95, 100, 203, 84, 5, 152, 70}, 202},
	{{53, 96, 0, 0, 0, 0, 85, 203, 145, 110, 126, 48, 159, 133, 182, 159}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 32, 253, 95, 128, 30, 64, 179, 64, 191}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 44, 72, 103, 172, 136, 137, 95, 201, 186}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 136, 172, 16, 217}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 128, 61}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{53, 96, 0, 0, 59, 85, 152, 97, 129, 233, 253, 20, 116, 57, 154, 183}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 82, 63}, 202},
	{{53, 96, 0, 0, 193, 105, 162, 139, 103, 175, 198, 143, 33, 14, 245, 24}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 187, 29, 44, 136, 19, 163, 147, 194, 45}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 171, 75, 137, 71, 25, 102, 4, 231, 178}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 5, 83, 133, 95}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 42, 40, 74, 219, 56, 157}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{53, 96, 0, 0, 0, 127, 226, 162, 136, 156, 178, 204, 33, 121, 11, 132}, 202},
	{{53, 96, 0, 0, 0, 0, 144, 7, 233, 218, 220, 250, 112, 246, 175, 18}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 189, 9, 233, 53}, 202},
	{{53, 96, 0, 0, 0, 0, 181, 241, 12, 99, 89, 144, 111, 102, 14, 179}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 221, 251, 86, 69, 0, 226}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{53, 96, 0, 0, 0, 206, 132, 6, 250, 56, 89, 37, 102, 128, 139, 72}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 226, 51}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 181, 180, 201, 240}, 202},
	{{53, 96, 145, 186, 179, 37, 71, 55, 148, 34, 181, 10, 223, 81, 13, 125}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 117, 151}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 47, 110, 200, 232}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 196, 188, 0, 36, 79, 151}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 93, 207, 112, 6}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 231, 145, 192, 43, 91, 134, 75}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 252, 17, 105, 73, 178, 17, 27, 144, 13}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 80}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 30, 84, 11, 30, 237, 71, 190, 160}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 235, 254, 94, 118, 231, 129, 52, 79, 98}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 117, 211, 225, 251, 250, 123, 63}, 202},
	{{53, 96, 0, 0, 0, 0, 26, 4, 209, 108, 72, 5, 248, 39, 22, 108}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{53, 96, 0, 0, 0, 0, 87, 192, 200, 119, 95, 133, 81, 97, 14, 89}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 49, 187}, 202},
	{{53, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 229, 39, 170}, 202},
	{{53, 96, 0, 0, 36, 157, 86, 212, 254, 125, 250, 2, 12, 148, 175, 50}, 202},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 138, 218, 203, 109, 237, 130, 139}, 54},
	{{198, 0, 159, 248, 224, 165, 74, 65, 249, 101, 117, 73, 57, 212, 3, 34}, 54},
	{{198, 0, 0, 0, 0, 213, 119, 229, 248, 186, 80, 187, 180, 20, 135, 182}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 34, 202, 100}, 54},
	{{198, 0, 0, 16, 134, 137, 159, 172, 35, 168, 164, 3, 197, 24, 181, 213}, 54},
	{{198, 0, 4, 202, 134, 201, 224, 129, 165, 56, 79, 103, 14, 9, 176, 121}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 121, 108, 165}, 54},
	{{198, 0, 126, 75, 135, 194, 80, 62, 246, 111, 206, 244, 66, 222, 94, 186}, 54},
	{{198, 0, 0, 0, 0, 0, 226, 234, 241, 125, 27, 9, 228, 124, 153, 42}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 91, 99, 0, 36, 99, 49, 252, 108, 73}, 54},
	{{198, 0, 0, 233, 134, 145, 27, 250, 193, 167, 47, 179, 176, 222, 137, 166}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 238, 92, 51, 208, 52, 118, 116}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 126, 56}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 54},
	{{198, 0, 0, 0, 122, 62, 240, 197, 163, 101, 39, 180, 69, 9, 125, 124}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 175, 55, 163, 249, 249, 121, 83, 79, 108}, 54},
	{{198, 0, 0, 0, 0, 0, 102, 22, 163, 6, 71, 72, 157, 14, 89, 181}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 6, 143, 119, 101, 34, 106, 95, 194}, 54},
	{{198, 0, 0, 0, 45, 226, 115, 109, 23, 187, 19, 24, 53, 183, 190, 35}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 187, 216, 33, 30}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 107}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 228, 112}, 54},
	{{198, 0, 0, 0, 0, 78, 19, 2, 73, 89, 6, 54, 166, 197, 153, 212}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 205, 75, 23, 12, 251, 138, 79}, 54},
	{{198, 0, 0, 0, 0, 0, 249, 99, 40, 67, 161, 95, 243, 85, 141, 234}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 255, 95, 158}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{198, 0, 0, 0, 150, 204, 161, 46, 25, 117, 7, 122, 240, 18, 60, 145}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 213, 85, 114, 137}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 4, 195}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 184, 225, 191}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 1, 59}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 89, 178, 34, 118, 169, 81, 147}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 202, 23, 163, 210, 182, 182, 220, 45}, 54},
	{{198, 0, 0, 208, 24, 195, 50, 63, 189, 236, 8, 40, 153, 91, 182, 109}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 238, 246, 122, 164, 2, 109, 52, 123, 56}, 54},
	{{198, 0, 0, 1, 173, 156, 65, 213, 177, 36, 167, 10, 245, 112, 34, 32}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 103, 149, 193, 18, 124}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 217, 207, 145, 12, 195, 120, 229}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 137, 251, 72}, 54},
	{{198, 0, 0, 0, 0, 0, 188, 159, 165, 19, 34, 10, 173, 232, 40, 251}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 216}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 227, 89, 203, 32}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 24}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 119, 118, 2}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 45, 15, 208}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15}, 54},
	{{198, 0, 0, 0, 204, 193, 253, 212, 25, 92, 190, 156, 141, 2, 84, 254}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{198, 0, 0, 0, 0, 0, 212, 128, 23, 169, 60, 166, 225, 50, 20, 36}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 123, 104, 242, 202, 81, 78, 232, 95}, 54},
	{{198, 0, 0, 0, 161, 16, 114, 52, 166, 156, 101, 117, 163, 224, 152, 77}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 174, 202}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 54},
	{{198, 0, 0, 0, 227, 90, 33, 224, 26, 104, 212, 177, 91, 3, 179, 223}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{198, 0, 0, 146, 238, 167, 61, 48, 53, 178, 163, 249, 18, 105, 237, 36}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 161, 113, 200, 190}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 232}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 5, 52, 65, 141, 139, 207, 235, 227}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 143, 169}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 210, 46, 12, 11, 75, 86, 155}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 7, 147, 68, 20, 114, 61, 165, 170}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 190, 30, 5, 190, 235, 171, 146, 11}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 11, 21, 19, 7, 12, 247, 174, 227}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 54},
	{{198, 0, 0, 0, 63, 95, 86, 182, 41, 248, 3, 140, 129, 70, 230, 156}, 54},
	{{198, 0, 0, 161, 201, 70, 91, 237, 86, 219, 51, 20, 228, 181, 56, 231}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 54},
	{{198, 0, 0, 0, 0, 62, 220, 202, 225, 48, 186, 19, 79, 2, 244, 121}, 54},
	{{198, 0, 121, 105, 199, 242, 50, 136, 101, 2, 157, 110, 171, 138, 17, 103}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 227, 145, 216, 206}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 252}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 117}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 40, 54, 244, 138, 115, 174, 133, 25}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 144, 178, 88, 78, 230}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 152, 147, 104, 172, 245, 25, 252, 8, 71}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 209, 238, 191, 250, 97, 178, 122}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 121, 168, 50, 6, 222, 122, 242}, 54},
	{{198, 0, 0, 0, 0, 0, 150, 156, 155, 56, 230, 232, 148, 179, 186, 162}, 54},
	{{198, 0, 0, 0, 0, 0, 110, 157, 110, 201, 11, 22, 43, 86, 17, 14}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 1, 80, 248}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 14, 220, 40, 43}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 6, 13, 213, 42, 248, 132, 84, 197}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 92, 194, 182, 123, 20, 239, 206, 187, 148}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 43, 154, 99, 147, 193, 200, 117, 62}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 138, 222, 105, 116}, 54},
	{{198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 54},
	{{189, 234, 106, 247, 64, 0, 0, 0, 46, 9, 169, 126, 125, 175, 121, 177}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 47, 227, 86, 242, 210, 126, 225, 83, 233}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 91, 0, 104, 26, 172, 193, 183}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{189, 234, 106, 247, 64, 0, 56, 2, 6, 54, 72, 102, 57, 155, 3, 39}, 156},
	{{189, 234, 106, 247, 64, 0, 232, 53, 234, 231, 87, 65, 238, 163, 213, 47}, 156},
	{{189, 234, 106, 247, 64, 80, 209, 163, 27, 248, 58, 39, 23, 194, 86, 254}, 156},
	{{189, 234, 106, 247, 64, 196, 219, 111, 214, 79, 26, 14, 159, 13, 50, 33}, 156},
	{{189, 234, 106, 247, 64, 0, 248, 81, 120, 36, 62, 33, 178, 234, 79, 42}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 19, 46, 254, 208, 178, 220, 130, 140}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 156},
	{{189, 234, 106, 247, 64, 0, 102, 75, 60, 20, 45, 196, 106, 231, 223, 185}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 26, 110, 200, 149, 55}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 223, 178, 83, 173, 131, 86, 234}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 110, 202, 131}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 22, 141, 164, 17, 219, 207}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 190, 93, 56, 112, 245, 164, 52}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 252, 158, 57, 182, 21, 201, 235, 176, 9}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 179}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 213, 139, 221, 135, 251, 208, 51, 242, 192}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 118, 125, 6, 42, 5, 63, 188, 123, 23}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 125}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 118, 229, 47}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 42, 219, 45}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 146}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 35, 192, 126, 7, 117}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 242, 62, 105}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 10}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 146, 122, 39, 133, 199, 188, 205, 6, 27}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 243, 120, 13, 56, 85, 253}, 156},
	{{189, 234, 106, 247, 64, 151, 154, 230, 23, 86, 126, 92, 190, 64, 235, 169}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 253, 119, 51}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 74, 204, 225, 168, 117, 45, 138, 106}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 95, 208, 105, 17, 92, 109, 111}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 20, 3, 112, 237, 182, 231}, 156},
	{{189, 234, 106, 247, 64, 0, 169, 206, 84, 237, 44, 230, 177, 177, 111, 233}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 73, 146, 157, 224, 237, 23}, 156},
	{{189, 234, 106, 247, 64, 130, 60, 142, 125, 152, 40, 152, 241, 148, 95, 226}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 25, 134, 218, 160, 35, 203, 255}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 201, 97, 155, 132, 148, 177, 16}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 159, 225, 175, 229}, 156},
	{{189, 234, 106, 247, 64, 0, 127, 219, 77, 112, 178, 158, 200, 181, 68, 9}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 23}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 124, 138, 242, 204, 178}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 162, 61, 210, 153, 160, 205, 42, 97, 100}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 252, 210, 31, 161, 61, 177, 238, 230}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 109, 165, 248, 2, 150, 223, 214, 159, 78}, 156},
	{{189, 234, 106, 247, 64, 60, 231, 145, 141, 36, 156, 96, 217, 196, 201, 165}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 90, 28, 254, 151, 181, 228, 219, 120, 112}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 163, 187, 172, 165, 194, 123, 121, 91}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 100, 203, 150, 254, 53, 99, 110, 121, 167}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 32, 142, 72, 245}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 186, 88, 249, 124, 247, 176, 106}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 174, 188, 189, 143, 15}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 70, 2, 109, 212, 107}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 148, 195, 219}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 152, 206, 153, 111, 21}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 79, 254, 111}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 118, 170, 17, 87}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 196, 50, 117, 242, 113, 69}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 141, 203, 114, 38, 142, 116}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 56, 249, 2, 74, 137, 114, 198, 144, 167}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 149, 30, 200, 98, 132, 80, 237}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 94}, 156},
	{{189, 234, 106, 247, 64, 0, 168, 214, 107, 236, 53, 237, 134, 112, 196, 139}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 82, 118, 159, 63, 126}, 156},
	{{189, 234, 106, 247, 64, 0, 191, 203, 246, 206, 36, 139, 12, 59, 45, 43}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 24, 211, 31, 156, 10, 108, 180}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 134, 7, 132, 184, 148}, 156},
	{{189, 234, 106, 247, 64, 142, 164, 30, 26, 128, 68, 99, 60, 80, 48, 142}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 91, 221, 143, 175, 223, 186}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 205, 13, 180, 61}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 195, 88, 232}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 97}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 138, 21, 237, 215, 214, 110, 6}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 214}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 242, 166, 30, 249, 8, 103}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 104, 18, 164}, 156},
	{{189, 234, 106, 247, 64, 0, 146, 140, 148, 235, 40, 104, 39, 58, 22, 72}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 93, 43, 144, 144}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{189, 234, 106, 247, 64, 0, 159, 3, 191, 110, 255, 87, 61, 245, 78, 17}, 156},
	{{189, 234, 106, 247, 64, 0, 65, 85, 1, 93, 246, 111, 187, 178, 218, 153}, 156},
	{{189, 234, 106, 247, 64, 0, 0, 0, 0, 0, 0, 0, 170, 146, 31, 226}, 156},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{110, 24, 228, 65, 216, 147, 9, 48, 60, 179, 172, 91, 115, 185, 227, 96}, 245},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 122, 131, 134, 95, 127, 72, 245}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 176, 184, 8, 34, 133, 129, 7, 24, 152}, 218},
	{{128, 94, 54, 22, 224, 122, 97, 99, 124, 127, 234, 158, 47, 171, 144, 185}, 218},
	{{128, 0, 0, 0, 0, 36, 63, 208, 141, 24, 171, 119, 204, 7, 13, 214}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 40, 144, 99, 45, 235, 159, 237, 68}, 218},
	{{128, 0, 0, 0, 0, 0, 34, 58, 16, 117, 9, 46, 44, 139, 75, 119}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 152, 12, 15, 233, 88}, 218},
	{{128, 0, 0, 0, 0, 0, 142, 166, 193, 38, 246, 116, 31, 26, 107, 8}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 213, 168, 181, 145}, 218},
	{{128, 0, 0, 0, 0, 0, 192, 189, 18, 34, 119, 76, 160, 220, 183, 234}, 218},
	{{128, 0, 0, 95, 90, 21, 204, 217, 100, 159, 246, 155, 101, 52, 209, 211}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 221, 3, 114, 151, 255, 181, 145, 92}, 218},
	{{128, 0, 0, 59, 246, 175, 78, 189, 9, 57, 112, 215, 121, 199, 43, 168}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 58, 47, 162, 48, 244, 165, 220}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 101, 245, 209, 163, 34, 166, 101, 234, 56, 146, 124, 70, 125}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 202, 60, 149}, 218},
	{{128, 0, 115, 161, 18, 101, 51, 169, 60, 61, 62, 133, 201, 25, 130, 99}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 94, 217, 233, 49}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 46, 42}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 174, 33, 219, 155, 7, 50, 211, 128, 18}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 241, 144}, 218},
	{{128, 0, 0, 0, 111, 226, 160, 120, 180, 141, 229, 165, 121, 217, 114, 179}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 41, 208, 231, 81, 122, 35, 104}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 21}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 57, 35, 224, 244, 176, 240, 211, 15}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 219}, 218},
	{{128, 0, 19, 65, 223, 170, 14, 136, 255, 175, 98, 246, 159, 49, 82, 63}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 211, 115, 158, 135, 52, 123, 118, 58}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 169, 234, 143, 216, 69, 197, 153, 175}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 74, 127}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 113, 220, 98, 102, 154, 237, 28, 116}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 255}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 103, 144}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 21}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 215, 215, 63}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 77}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 112, 127, 135, 42, 99, 28, 74, 125, 217}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 199, 245, 189, 223, 35}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 141}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 138, 219, 18, 110, 19, 31, 153}, 218},
	{{128, 0, 0, 0, 0, 83, 38, 60, 223, 73, 205, 4, 109, 136, 253, 174}, 218},
	{{128, 0, 0, 0, 209, 220, 35, 7, 55, 206, 25, 251, 139, 195, 51, 57}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 144, 53, 143, 213, 49, 104, 125}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 42, 36, 99, 74, 199}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 93, 124, 192, 248, 163}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 7, 210, 227, 39, 151, 119, 53, 106}, 218},
	{{128, 0, 0, 0, 102, 38, 254, 128, 206, 244, 166, 253, 149, 46, 70, 74}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 220, 57, 72, 202, 214, 165, 5, 172}, 218},
	{{128, 0, 0, 0, 0, 0, 51, 56, 55, 51, 129, 185, 215, 111, 25, 172}, 218},
	{{128, 0, 132, 215, 38, 118, 36, 111, 152, 193, 177, 254, 182, 159, 173, 168}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 8, 177, 88, 227, 247}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 49, 196, 105, 23, 222}, 218},
	{{128, 0, 0, 99, 202, 255, 200, 127, 205, 240, 205, 16, 33, 213, 132, 233}, 218},
	{{128, 0, 0, 0, 0, 35, 183, 201, 212, 129, 83, 100, 10, 92, 48, 221}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 171}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 112}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 190, 84, 11, 76, 186}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 185, 154, 117, 230}, 218},
	{{128, 0, 0, 0, 196, 59, 86, 187, 47, 20, 125, 249, 149, 144, 144, 223}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 248, 77, 175, 0, 232}, 218},
	{{128, 0, 214, 22, 76, 187, 207, 194, 75, 1, 87, 135, 236, 166, 144, 142}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 46, 210, 138, 61}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 59}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 24, 163, 68, 43, 44, 180, 254, 143, 88}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 197}, 218},
	{{128, 0, 0, 83, 239, 28, 204, 184, 136, 8, 102, 161, 157, 31, 4, 168}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 235, 206, 69, 241, 66, 126, 167, 88, 203}, 218},
	{{128, 0, 0, 0, 0, 0, 109, 168, 216, 128, 110, 126, 245, 54, 125, 198}, 218},
	{{128, 0, 0, 0, 0, 201, 18, 187, 168, 172, 228, 57, 249, 127, 171, 76}, 218},
	{{128, 0, 0, 0, 67, 242, 206, 131, 167, 241, 42, 29, 29, 253, 101, 49}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 116, 7, 8, 159, 179, 219, 35, 83, 77}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 113, 107, 83, 140, 59, 136, 45}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 119}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 179, 18}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 66, 9, 188, 170, 134, 53, 49, 250, 95}, 218},
	{{128, 0, 0, 0, 0, 0, 122, 63, 13, 177, 197, 239, 51, 52, 208, 193}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 85, 249}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 72, 206, 13, 24, 74, 243, 197, 194, 85}, 218},
	{{128, 0, 0, 0, 0, 0, 60, 228, 184, 139, 60, 95, 21, 140, 99, 109}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 109, 20, 207, 110, 68}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 115, 23, 242, 9, 98}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 186, 77, 110, 201}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 67, 219, 34, 13, 228, 173, 11}, 218},
	{{128, 0, 0, 0, 0, 0, 58, 222, 233, 60, 184, 86, 96, 36, 5, 103}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 122}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 155, 39, 50, 119}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 48, 113, 220, 132, 115, 16, 206}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 226, 140, 5, 246, 142, 125, 120}, 218},
	{{128, 0, 0, 0, 0, 120, 222, 31, 10, 212, 176, 9, 122, 177, 208, 249}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 69, 161, 178, 205, 203, 19, 132, 181, 90}, 218},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 192, 245}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 163, 104, 52}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 106, 216}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 73, 206}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 155, 36}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 88, 14, 190, 13}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 67, 106, 64}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 112, 230}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 125}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 41}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 221, 59, 134}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 233, 179, 129}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 14}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 186}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 191, 231, 224}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 107, 135, 151}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 165, 250}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 38, 116, 88}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 5, 109}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 61, 182, 102}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 214, 78, 72}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 16, 122, 123}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 116}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 15, 126, 165}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 154, 21, 49}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 210, 123}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 233, 93}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 151, 189}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 98, 99, 104}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 74, 72, 25}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 178}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 32}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 6, 199}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 109, 80, 89}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 22, 32, 194}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 210, 162, 215}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 90}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 24, 30, 213, 91}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 19}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 133, 178, 50}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 11}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 108, 115}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 62, 208, 154}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 227, 255, 137}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 60, 162, 44}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 57, 78, 67}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 248}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 136}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 248}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 144, 161, 42}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 95, 144, 186}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 205, 176}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 23, 31, 167, 1}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 158, 103, 192, 93}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 64, 42}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 160, 250, 156}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 246, 97, 114}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 222}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 102, 45, 42}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 15, 43, 75}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 30, 27}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 118, 15, 82}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 200, 221, 192}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 42}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 152}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 210, 58}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 207, 137, 21}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 222, 207, 76, 190}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 146}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 0}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 59}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 201, 230}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 114}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 177, 213, 102, 180}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 216, 57}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 106, 173, 116}, 72},
	{{74, 177, 89, 218, 248, 18, 176, 39, 118, 173, 201, 152, 0, 0, 0, 10}, 72},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 157}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 27}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 243}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 167}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 58}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 178}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 81}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 221}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 87}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 194}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 7}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 18}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 65}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 169}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 174}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 28}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 91}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 28}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 200}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 178}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 21}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 222}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 60}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 70}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 28}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 51}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 11}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 252}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 150}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 225}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 103}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 137}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 179}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 71}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 180}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 10}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 32}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 200}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 182}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 200}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 129}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 217}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 0}, 183},
	{{31, 13, 153, 92, 27, 122, 150, 232, 88, 95, 202, 171, 208, 158, 0, 76}, 183},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 118, 94, 38}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 61, 29, 105, 157, 200, 222, 99}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 25, 153, 151, 57, 127}, 218},
	{{128, 0, 0, 0, 0, 0, 201, 161, 59, 50, 30, 114, 125, 59, 158, 94}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 115, 168, 169, 84, 122, 180, 106, 84}, 218},
	{{128, 0, 0, 0, 0, 0, 181, 42, 145, 179, 15, 130, 99, 150, 237, 169}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 135, 66, 216, 172, 4, 92, 95}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 171, 127, 124, 57, 80, 160, 170, 230}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 122, 111, 109, 197, 151, 110, 197, 23, 189}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 197, 27, 83, 183}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 245, 197, 15, 95, 188, 16, 208}, 218},
	{{128, 174, 88, 169, 71, 224, 110, 64, 234, 26, 133, 178, 184, 125, 121, 41}, 218},
	{{128, 81, 221, 218, 172, 57, 199, 73, 128, 138, 74, 103, 169, 163, 116, 42}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 49, 98, 209, 39}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 178, 130, 180}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 116, 96, 221, 69, 241}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 85, 168, 216, 116}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 203, 94}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 33, 48, 174, 87, 248, 166, 241, 128, 165, 29, 39, 146}, 218},
	{{128, 0, 0, 0, 155, 11, 137, 84, 52, 41, 32, 130, 195, 201, 62, 55}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 124}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 111, 97, 196, 159, 255, 156, 198, 82}, 218},
	{{128, 0, 0, 0, 0, 255, 222, 42, 195, 230, 221, 3, 212, 233, 10, 121}, 218},
	{{128, 0, 0, 0, 0, 0, 117, 180, 115, 163, 124, 32, 17, 189, 34, 157}, 218},
	{{128, 0, 0, 0, 0, 0, 112, 204, 17, 139, 198, 35, 196, 36, 111, 123}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 164, 229, 132, 117, 25}, 218},
	{{128, 0, 0, 0, 230, 201, 68, 159, 205, 8, 188, 98, 165, 19, 7, 14}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 72, 249, 23, 150, 199, 225, 125, 88}, 218},
	{{128, 0, 0, 0, 152, 159, 201, 165, 94, 86, 144, 167, 47, 60, 179, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 100, 148, 146, 196}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 169, 124, 97, 224, 4, 213, 34}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 85, 238}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 174, 252, 108, 59, 94, 153, 164}, 218},
	{{128, 0, 0, 0, 0, 176, 133, 71, 75, 66, 255, 2, 245, 154, 128, 114}, 218},
	{{128, 0, 246, 56, 76, 85, 62, 192, 16, 141, 65, 188, 73, 102, 201, 72}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 91}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 201}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 218},
	{{128, 0, 0, 0, 0, 0, 230, 134, 152, 101, 92, 80, 107, 122, 240, 56}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 204}, 218},
	{{128, 0, 0, 0, 42, 42, 145, 79, 210, 142, 40, 214, 176, 72, 115, 34}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 68}, 218},
	{{128, 102, 249, 138, 108, 245, 93, 25, 169, 228, 32, 44, 190, 140, 92, 166}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 93, 142, 46, 131, 192}, 218},
	{{128, 0, 0, 0, 0, 175, 80, 197, 159, 212, 202, 148, 238, 71, 17, 30}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 139, 194, 146, 9, 175, 225, 228, 69, 37}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 245, 103, 221, 216, 142, 237, 173, 77}, 218},
	{{128, 201, 105, 7, 68, 30, 114, 217, 157, 166, 179, 220, 72, 125, 112, 13}, 218},
	{{128, 0, 212, 236, 145, 215, 83, 182, 116, 46, 177, 204, 122, 33, 196, 18}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 107, 161}, 218},
	{{128, 0, 45, 158, 139, 28, 167, 6, 91, 232, 58, 215, 216, 36, 187, 126}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 16, 198, 109}, 218},
	{{128, 0, 0, 0, 59, 166, 6, 48, 210, 111, 114, 214, 28, 69, 115, 58}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 11}, 218},
	{{128, 0, 0, 0, 0, 57, 198, 71, 234, 131, 10, 38, 71, 154, 1, 89}, 218},
	{{128, 121, 133, 61, 105, 86, 156, 130, 208, 178, 75, 237, 113, 60, 138, 54}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 218},
	{{128, 38, 184, 222, 235, 112, 115, 138, 211, 21, 77, 124, 107, 131, 13, 66}, 218},
	{{128, 0, 224, 175, 241, 74, 98, 203, 215, 94, 14, 143, 106, 5, 133, 169}, 218},
	{{128, 82, 28, 60, 175, 255, 167, 190, 6, 73, 119, 229, 195, 97, 62, 108}, 218},
	{{128, 0, 0, 0, 236, 144, 103, 72, 160, 223, 165, 130, 240, 232, 110, 226}, 218},
	{{128, 0, 0, 0, 0, 0, 134, 16, 44, 116, 87, 142, 200, 98, 38, 22}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 181, 153, 206, 113}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 192, 28, 80, 49, 138}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 84, 32, 68, 231, 143, 21, 26}, 218},
	{{128, 0, 0, 45, 237, 158, 44, 224, 228, 237, 134, 89, 17, 103, 202, 134}, 218},
	{{128, 0, 0, 37, 157, 227, 134, 202, 69, 245, 152, 137, 231, 90, 141, 209}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 218},
	{{128, 0, 190, 77, 255, 127, 147, 109, 93, 164, 233, 186, 65, 73, 137, 131}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 58, 10, 32, 243, 198, 76, 201, 105}, 218},
	{{128, 0, 0, 0, 0, 171, 167, 91, 121, 140, 134, 232, 27, 113, 230, 182}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 147, 188}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 180, 154, 106, 111, 208, 140, 13, 124}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 37, 6, 48, 85, 146, 157, 233, 238}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 1, 143, 169, 169, 182, 81, 75}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 111, 165, 30, 246, 183, 142, 42, 209}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 193, 72, 184, 224, 68, 110, 181}, 218},
	{{128, 125, 78, 153, 231, 79, 104, 58, 121, 205, 131, 223, 222, 129, 19, 234}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 46, 10, 232, 46, 30, 116, 72}, 218},
	{{128, 0, 0, 229, 18, 145, 116, 137, 184, 193, 62, 212, 243, 135, 101, 7}, 218},
	{{128, 0, 0, 0, 226, 7, 93, 146, 75, 202, 131, 35, 131, 122, 150, 157}, 218},
	{{128, 0, 137, 242, 112, 206, 41, 150, 2, 251, 2, 164, 65, 178, 78, 220}, 218},
	{{128, 0, 204, 64, 249, 95, 19, 154, 191, 9, 134, 46, 81, 51, 56, 115}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 152, 209}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 141, 67, 41, 96}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 41, 249, 95, 234, 187, 176, 57, 129, 15, 99}, 218},
	{{63, 37, 46, 158, 139, 128, 220, 38, 100, 58, 79, 45, 20, 140, 44, 43}, 241},
	{{63, 37, 46, 158, 139, 128, 119, 200, 232, 167, 21, 139, 157, 93, 150, 109}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 67, 74, 231, 35, 214, 229, 65}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 72, 197, 14, 39, 219, 217}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 2, 230, 195, 144, 165, 242}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 167, 158, 38, 158, 137, 75, 230, 234, 84}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 31, 155, 113, 54, 25}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 99, 233, 23, 50, 109, 216, 112, 212}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 229, 145}, 241},
	{{63, 37, 46, 158, 139, 128, 64, 108, 221, 18, 213, 38, 113, 29, 110, 71}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 249, 215, 249, 180, 36, 139, 131, 127, 121}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 85, 175, 248, 183, 109, 52}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 105, 70}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 175, 113, 111, 133}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 98, 231, 6, 76, 219}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 222, 185, 62, 54}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 43, 174}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 83, 99, 70}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 84, 110, 231, 33, 193, 22, 24, 251, 107}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 16, 98, 56}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 72, 147, 66, 220, 172, 100, 77}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 184, 0, 53, 71}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 100, 107}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 184, 141, 155, 194, 55, 32, 232, 244, 173}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 196, 114}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 136, 14, 193, 67, 30}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 72, 23}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 236, 194, 173, 240, 177, 115, 111, 207}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 147, 250, 123, 34, 60, 99, 125, 120}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 136, 5, 244, 106, 137, 32, 206, 236}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 208, 101, 142, 67}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 123, 51}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 180, 55, 202, 49}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 130, 34, 93, 91, 100, 72, 66}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 100, 76, 17, 23, 160, 10}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 79, 118, 229}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 141, 99, 26, 40, 99, 129, 42, 175, 253, 18}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 42, 164, 99}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 163, 93, 185, 237, 93, 184, 47, 71}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 176, 187, 19, 207, 18, 74, 173}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 137, 98, 132, 208, 143, 109, 20, 64}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 14, 103, 50, 47, 148}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 82, 221}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 124, 106, 154, 41, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 251, 251}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 40, 144, 63, 206, 186, 110, 241}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 36, 173, 166}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 123, 129, 240, 189, 91, 84, 81, 135}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 56, 227}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 176, 185, 98}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 10, 10}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 128, 222, 243, 161}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 26, 54, 231, 142, 24, 66, 82}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 206, 85, 240, 204}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 162, 245, 93, 220}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 204, 255, 194, 191, 217}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 183, 73, 196, 89, 193, 2, 226, 31, 99}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 199, 83, 78, 10}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 7, 2, 213, 216}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 71, 201, 126}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 67, 138, 99}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 16, 50, 237, 85, 38, 7, 4, 193}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 181, 27, 130, 214, 58, 20, 200, 192, 118}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 232, 57, 19, 166, 21, 139}, 241},
	{{63, 37, 46, 158, 139, 128, 65, 67, 200, 137, 43, 92, 245, 118, 80, 234}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 17, 237, 96, 182, 69, 46, 189, 217, 254}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 62, 224, 41}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 241, 118, 69, 109, 130, 150, 83, 121}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 165, 73}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 57, 195, 107, 102, 4}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 121, 159, 37}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 6, 221, 32}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 58, 200, 12, 167}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 199, 12, 237, 71, 128, 167}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 241},
	{{63, 37, 46, 158, 139, 128, 0, 0, 0, 0, 83, 26, 60, 244, 20, 153}, 241},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 169, 186}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 235, 72, 254, 63, 77, 4}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 79, 101}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 150, 98, 212, 139, 245, 62, 168, 249, 129}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 36, 186}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 10, 197, 18, 72, 129}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 11, 39, 174, 150, 207, 95, 10, 197}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 202, 107, 113, 3, 145, 94, 116, 219}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 160, 132}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 237, 186, 229, 226}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 143, 60, 35}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 210, 53, 9, 135, 160, 116}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 25, 127}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 242, 253, 111, 55}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 188, 129, 29, 150, 1, 251, 218, 86, 82}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 123, 149, 203, 51, 59, 10, 8, 94, 98}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 130, 3, 154, 236, 139}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 163, 32, 166}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 18, 76, 168, 225, 202, 65, 26, 92}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 122, 168, 239, 45, 158}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 15, 227, 133, 240, 166, 213, 250, 28}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 19, 254}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 222, 88, 154, 205}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 117, 125, 32, 250}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 17, 14, 44, 221, 243}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 69, 229, 32, 161}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{53, 209, 59, 13, 202, 70, 246, 2, 99, 61, 23, 126, 156, 13, 217, 20}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 179, 129, 18, 20, 90, 218, 34, 179, 110}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 203, 98, 175, 181, 249, 10, 87, 243}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 196, 187}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 82, 244, 156, 10}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 22, 213, 190, 240, 167, 80, 234}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 98, 139, 180}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 185, 152, 233, 140, 225, 74, 200}, 106},
	{{53, 209, 59, 13, 202, 70, 15, 81, 230, 52, 169, 56, 97, 32, 96, 65}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 107, 155, 193, 161, 108}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 62, 31, 96}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 30, 246, 225, 192, 94}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 97, 36, 248, 76, 46, 173, 174, 124}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 148, 31}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 202, 211, 129, 92}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 81, 151, 45, 17, 197, 126, 69}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 172, 58, 134, 110, 146, 174, 9, 90, 81}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 116, 107, 128}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 34, 99, 156, 35, 189, 240}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 170, 182, 253, 102, 247}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 79, 227, 142}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 250, 38, 104, 253}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 235, 149, 182, 61, 161, 112}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 200, 204, 154}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 128, 88}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 208, 48, 90, 219, 9}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 155, 181, 210, 129, 192}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 246, 185, 44, 180, 114, 251, 47, 146}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 187, 245, 183, 158, 189}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 37, 15, 82}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 119, 231}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 226, 160, 65, 114, 54}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 234, 193, 145, 19, 149}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 254, 228, 73, 249, 158, 197, 103, 40, 197}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 11, 58, 201, 175, 36, 183}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 159, 61, 10, 108, 199}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 71, 72}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 20, 115, 143, 31, 66, 110, 198}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 76, 146, 129, 161, 179}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 37, 205, 246, 183, 175, 1, 175}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 233, 168, 147}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 139, 186, 13, 202, 105, 85, 67, 49, 222}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 152, 56}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 149, 75, 85, 171, 152, 56, 28}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 78, 19, 105, 130, 52, 149}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 152, 76, 230, 163, 111, 42, 240}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 170, 34, 201, 142, 163, 234}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 175, 13, 131, 16, 189}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 224, 38, 91, 222}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 216, 224}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 178, 11, 126, 250, 233, 36}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 222, 85}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 72, 52, 196, 160, 98, 243}, 106},
	{{53, 209, 59, 13, 202, 70, 0, 0, 0, 0, 0, 0, 188, 161, 138, 148}, 106},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 60, 232, 160, 153}, 180},
	{{184, 44, 149, 221, 180, 0, 103, 185, 180, 16, 204, 106, 131, 201, 47, 35}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 46, 39, 181, 45}, 180},
	{{184, 44, 149, 221, 180, 0, 163, 71, 119, 100, 206, 14, 47, 216, 2, 173}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 184, 5, 77, 247, 167}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 209, 159, 55, 34, 224, 133}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 229, 203, 184, 107, 119, 113, 60, 106, 48}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 245, 183, 88, 121, 191}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 187, 233, 208, 119, 156, 122}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 184}, 180},
	{{184, 44, 149, 221, 180, 0, 202, 124, 61, 104, 194, 56, 132, 47, 1, 64}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 63, 174, 137, 148, 123, 85}, 180},
	{{184, 44, 149, 221, 180, 0, 194, 41, 10, 132, 202, 234, 0, 230, 70, 109}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 230, 116, 100, 42, 202, 180, 109, 215}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 154, 67, 15, 54, 60, 46}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 243, 242, 186, 219, 204, 82, 177}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 214, 177, 92, 223, 142, 112}, 180},
	{{184, 44, 149, 221, 180, 0, 146, 15, 17, 38, 220, 52, 198, 14, 165, 133}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 142, 10, 230}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 9, 102, 195}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 215}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 109, 24, 23, 61}, 180},
	{{184, 44, 149, 221, 180, 0, 73, 71, 199, 40, 251, 189, 44, 243, 136, 203}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 82, 49, 135, 178, 200, 224, 126, 242}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 167, 232, 69, 205, 42}, 180},
	{{184, 44, 149, 221, 180, 0, 105, 209, 185, 21, 112, 147, 26, 113, 220, 20}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 181, 99, 98, 64, 65, 90, 207, 63, 204}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 27, 171, 105, 177}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 128, 129, 122, 54, 0, 249, 154, 1}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 152, 8, 29, 109, 163, 183, 178}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 58, 242, 11, 161, 32, 87, 241, 130}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 206, 167, 141, 167}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 245}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 91, 121, 240, 108, 105, 52, 191}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 72, 241, 170, 39, 104, 72}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 132, 170, 33}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 238}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 21, 214, 230, 158, 151, 253, 131, 163}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 214, 195, 82, 98, 60, 190, 148}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 206, 23, 17}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 51}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 73, 6, 117, 167, 83}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 245}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 24}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 77, 44, 116, 236, 254, 63, 70, 46, 81}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 149, 159, 252, 234, 224, 150, 147, 253}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 114, 45, 103, 200, 139, 118, 70, 91}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 202, 200, 44, 77, 47, 74}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 136, 242, 20, 190, 58, 197, 3, 76, 86}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 230, 198, 222, 189, 33, 243, 108, 62, 239}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 117, 43, 222, 75}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 196, 10, 244, 28, 219, 55, 207, 254, 191}, 180},
	{{184, 44, 149, 221, 180, 0, 160, 148, 111, 94, 171, 11, 59, 159, 78, 100}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 148, 246, 161, 82, 244, 49, 53}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 233, 41, 59, 244, 224}, 180},
	{{184, 44, 149, 221, 180, 0, 248, 101, 34, 173, 95, 217, 199, 241, 44, 220}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 126, 186, 142, 223, 235}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 212, 72, 203, 113, 133, 36}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 231, 77, 44, 220}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 125, 174, 240, 43, 171, 169, 89, 46}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 43, 8, 106, 53, 126}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 4, 82, 210, 71, 49, 186, 239, 106}, 180},
	{{184, 44, 149, 221, 180, 0, 81, 250, 171, 22, 84, 66, 7, 42, 60, 170}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 115, 81, 157, 250, 100, 79, 240}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 94, 204, 133, 19, 242, 141}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 133, 70, 138}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 172, 70, 224, 193, 36}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 69, 162, 68, 112, 249}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 126, 250, 169}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 76}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 163, 115, 103}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 161, 73, 16, 100}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 194, 163, 95, 72, 167, 99, 131}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 164, 248, 221}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 122, 192, 85, 81, 249, 186, 39, 244}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 0, 0, 0, 0, 0, 46, 204, 193}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 217, 148, 198, 175, 131, 20, 140, 251, 226}, 180},
	{{184, 44, 149, 221, 180, 0, 0, 0, 37, 77, 168, 207, 55, 18, 159, 134}, 180},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 200}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 227, 177, 21}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 7, 175}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 232, 33}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 112, 146}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 181, 43}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 106, 146}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 80, 68, 159}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 45, 174}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 234, 184}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 158, 187}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 196}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 140}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 94, 66, 177}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 23, 127, 39}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 168, 208}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 52, 118}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 9, 133, 115}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 66, 43, 160}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 11}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 90, 3}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 198, 7, 154}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 77}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 230}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 14, 32}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 135, 87}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 53, 64, 209}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 83}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 135, 200, 47}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 114, 253, 74}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 91, 15}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 55, 146, 243}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 98, 215}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 251}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 26, 217}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 235, 212}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 205, 189}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 33}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 51}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 168}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 251, 216, 158}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 225}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 235}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 188, 217}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 88, 5, 226}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 143}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 104, 214, 27}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 52, 119}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 7, 146}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 164}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 94}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 46}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 136}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 217, 201, 190}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 174, 229, 238}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 57, 240, 35}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 226, 58}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 229, 54, 19}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 166, 235, 115}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 68, 136}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 28, 77}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 59}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 109, 249}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 233, 11, 176}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 126}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 186}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 163, 86}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 203}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 41, 45}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 74, 97, 18}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 58, 109, 45}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 15, 24, 14}, 142},
	{{222, 134, 37, 62, 223, 193, 39, 246, 15, 151, 200, 146, 0, 0, 0, 0}, 142},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 108}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 184}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 45, 222, 12}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 2, 163}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 29}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 70, 249}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 57}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 135, 99}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 62, 143}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 231, 59, 46}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 25, 161}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 195}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 139, 223}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 227, 15, 126}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 6, 66}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 218}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 145, 135}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 136}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 39, 152}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 24, 210, 82}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 163, 210}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 199, 147}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 105}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 70, 32}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 49}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 192}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 135}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 63, 120}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 163, 167}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 68, 173}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 2, 154}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 117}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 225}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 250, 254}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 178}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 143}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 68, 255, 77}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 102, 53, 24}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 215}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 86}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 55, 44, 234}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 73}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 35}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 40}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 136, 190, 23}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 103, 38}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 47}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 176, 135}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 57, 169, 98}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 108, 123}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 199}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 242, 98}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 54, 206}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 67, 148}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 41, 178}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 6}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 138, 216, 200}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 197, 8, 93}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 101}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 176}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 42, 232}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 11, 186}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 191, 94}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 205, 34, 232}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 63}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 106, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 40, 229}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 44, 60}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 138, 109}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 3}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 193}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{199, 176, 189, 37, 233, 177, 252, 216, 94, 175, 253, 119, 96, 0, 0, 0}, 6},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 210}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 12}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 123}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 5}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 24}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 130}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 58}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 80}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 54}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 68}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 11}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 113}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 16}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 88}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 9}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{44, 195, 201, 106, 209, 120, 122, 38, 43, 30, 142, 22, 196, 175, 100, 0}, 33},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 42}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 73, 130, 154, 189, 201, 113, 27}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 6}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 152, 62, 122, 208, 200, 148, 104, 81}, 224},
	{{33, 166, 10, 174, 64, 26, 179, 216, 56, 81, 50, 31, 127, 11, 77, 39}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 148, 20, 90, 127, 25, 197, 99, 15, 248}, 224},
	{{33, 166, 10, 174, 64, 0, 22, 128, 202, 234, 63, 74, 201, 64, 50, 65}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 223, 195, 238, 37, 238, 55, 24, 217, 17}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 60, 131, 220, 166, 213, 1, 246, 240, 176}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 154, 152, 151, 159, 232, 34, 30}, 224},
	{{33, 166, 10, 174, 64, 0, 86, 100, 28, 62, 242, 117, 110, 123, 17, 199}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 197, 0, 231, 207}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 24, 253, 65}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 39}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 86, 61, 246, 145, 77, 244}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 232, 179, 11, 9}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 43, 93, 213}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 157, 137, 143, 248, 53, 53, 169, 93, 122}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 203, 35, 134, 99}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 94, 58, 192, 145, 0, 255, 107, 13}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 249, 84, 32}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 252, 10, 118, 229}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 139, 231, 7, 50}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 23}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 91, 123, 129, 205, 117}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 92, 103, 30, 96, 93}, 224},
	{{33, 166, 10, 174, 64, 102, 48, 150, 62, 42, 85, 57, 169, 121, 113, 133}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 35, 51, 201, 81}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 58, 181, 192, 155, 175, 201, 102}, 224},
	{{33, 166, 10, 174, 64, 221, 249, 70, 87, 196, 20, 102, 170, 145, 33, 24}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 143, 78, 178, 14, 134, 43, 123}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 174, 155, 223, 98, 142}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 187, 105, 16, 126, 254, 90, 245, 101, 147}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 223, 17, 190, 186, 240, 182, 88, 140}, 224},
	{{33, 166, 10, 174, 64, 0, 77, 81, 228, 11, 23, 50, 90, 110, 154, 148}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 156, 96, 189, 10, 205, 132, 176, 2}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 119, 56, 203, 197, 10, 213, 30}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 251, 195, 176, 232, 23, 226}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 141, 125, 52, 151, 152, 220, 18}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 198}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 141}, 224},
	{{33, 166, 10, 174, 64, 13, 99, 181, 32, 62, 62, 21, 186, 154, 237, 16}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 86, 44, 92, 86, 194}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 141, 38, 177, 117, 179, 16}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 128, 81, 128, 121}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 185, 42, 152, 246, 60, 182}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 220, 238, 110, 60}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 127, 250, 157, 158, 18, 70, 28, 157, 76}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 137, 30, 12, 232, 247}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 2, 63, 144, 251, 13, 80, 185, 230, 209}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 212, 50, 6, 167, 167, 71, 202, 89}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 95, 228, 185}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 136}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 16, 170, 133, 78, 209, 219}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 77, 184, 102}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 8, 214, 75, 37, 82, 42, 134, 144}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 176}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 80}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 13, 100, 189}, 224},
	{{33, 166, 10, 174, 64, 167, 184, 48, 132, 108, 209, 167, 6, 223, 220, 85}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 244, 241, 237, 17, 4, 214}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 121, 40, 232, 249}, 224},
	{{33, 166, 10, 174, 64, 20, 117, 102, 55, 238, 138, 67, 66, 234, 6, 95}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 189, 197, 143}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 195, 31, 210}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 131, 236, 66}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 217, 110, 73, 228}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 233, 221, 14, 30, 112, 186}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 207, 87, 98, 115, 83}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 56, 161, 244}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 213, 137, 135, 71}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 218, 11, 199, 162, 2, 159, 0}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 161, 202, 208, 236, 151}, 224},
	{{33, 166, 10, 174, 64, 222, 76, 24, 6, 90, 193, 120, 45, 224, 132, 115}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 52}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 167, 34, 112, 83, 172, 7, 22}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 105}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 191, 46, 108, 254}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 205, 108, 23, 150, 200}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 200}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 77, 194, 163}, 224},
	{{33, 166, 10, 174, 64, 225, 20, 70, 214, 27, 111, 67, 81, 215, 173, 199}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 31, 97, 240, 182, 21, 4, 166, 124, 222}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 145, 203, 201, 119, 95, 185, 196, 47}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 31, 17, 16, 36}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 70}, 224},
	{{33, 166, 10, 174, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111}, 224},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 113}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 159, 147, 211, 210, 37, 99}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 28, 78, 21}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 44, 19, 141, 158}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 172}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 204, 181}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 77, 1, 43}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 187, 227}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 99, 90, 70}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 143, 86, 106, 202}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 229, 13}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 129, 129, 97, 225}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 71, 95}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 227, 83, 102, 237, 141}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 201}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 128, 162, 245, 234, 233}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 227}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 160, 72, 134, 173, 40, 159}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 180, 21, 123, 225}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 183}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 60}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 88, 147, 119}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 27, 125}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 158, 148, 77}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 43, 31, 142}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 165, 179}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 171, 253, 65}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 200, 26, 67, 103, 124}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 246, 134, 78, 231, 188}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 43, 213}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 202, 187, 215, 55, 14}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 133, 186}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 204, 107, 137}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 172, 149}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 104, 216, 29, 191}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 174, 17}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 37, 230, 24, 155}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 57, 144}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 173, 116}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 1}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 48, 97, 194, 204, 211}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 232, 214, 5}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 210}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 151, 105, 255}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 214, 150, 118}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 131}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 215, 214, 11, 92, 10}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 145, 226, 162}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 38, 196}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 244, 37, 65, 39}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 155, 84}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 44, 86, 17, 74}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 222, 57}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 216, 233, 28, 29, 56, 141}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 116, 143}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 65}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 214, 105, 5}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 187, 37, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 71}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 169, 230}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 224, 114}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 205, 226}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 82, 228, 19, 106, 155}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 233, 74}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 177, 64}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 221}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 96, 121, 167, 10}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 76, 106}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 0}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 139, 148, 68, 87}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 252, 57, 84, 131}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 194}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 30}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 158, 188, 72}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 52, 5, 215, 223, 79}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 243}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 109}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 0, 0, 140}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 182, 207, 218}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 161, 195, 104}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 3, 118, 228, 238, 189}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 11, 18, 111, 221, 23}, 14},
	{{54, 1, 189, 195, 133, 49, 36, 80, 138, 200, 0, 0, 0, 43, 246, 209}, 14},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 16, 15, 243, 91}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 145, 151, 51, 26}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 165, 49, 130, 40, 36}, 149},
	{{241, 0, 0, 84, 211, 229, 8, 91, 47, 174, 63, 122, 102, 116, 121, 174}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 96, 99}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 243, 106, 234, 144, 120}, 149},
	{{241, 0, 0, 118, 62, 242, 180, 190, 32, 193, 2, 67, 15, 233, 37, 251}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 188, 153, 18, 251, 156}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 24, 13}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 161, 204}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 146, 42, 65, 20, 171, 120, 38, 150}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 78, 126, 5, 87}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 169, 163, 128, 3, 75, 2, 99, 18}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 156, 93, 232, 88, 180, 134, 250}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 85, 6, 164, 150, 138, 44, 63}, 149},
	{{241, 0, 0, 0, 123, 225, 141, 130, 64, 20, 71, 187, 17, 222, 152, 231}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 43, 63, 81, 167, 244, 95, 223}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 196, 133, 246, 251, 10, 16, 245, 62, 57}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 150, 47}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 149},
	{{241, 0, 0, 0, 0, 0, 206, 136, 152, 218, 179, 222, 109, 201, 139, 79}, 149},
	{{241, 0, 152, 248, 103, 155, 161, 29, 50, 220, 146, 65, 13, 194, 21, 67}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 135, 221, 176, 163, 7, 218, 14, 121}, 149},
	{{241, 0, 0, 0, 93, 15, 37, 171, 185, 118, 114, 178, 202, 254, 242, 139}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 37, 71, 157, 190, 48}, 149},
	{{241, 0, 128, 139, 74, 15, 250, 96, 211, 96, 188, 106, 211, 4, 34, 52}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 105, 237, 222, 163, 239}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 66, 17, 208, 25, 214, 44, 76, 3, 137}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 48, 185, 235, 44}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 126, 58, 215, 217, 73}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 58, 119}, 149},
	{{241, 0, 0, 0, 0, 0, 207, 186, 190, 245, 23, 135, 141, 133, 115, 21}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 137, 206, 73, 91, 38, 84, 113, 55}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 171, 119, 55, 73, 211}, 149},
	{{241, 0, 0, 86, 72, 159, 199, 162, 169, 197, 36, 216, 88, 77, 203, 104}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 94}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 154, 32, 175}, 149},
	{{241, 0, 0, 0, 0, 212, 175, 35, 61, 212, 233, 70, 9, 189, 48, 128}, 149},
	{{241, 0, 183, 49, 78, 251, 96, 71, 128, 43, 90, 228, 152, 116, 101, 33}, 149},
	{{241, 0, 0, 0, 0, 245, 119, 115, 47, 53, 102, 210, 169, 229, 232, 34}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 163, 199}, 149},
	{{241, 0, 0, 0, 0, 92, 44, 219, 91, 67, 174, 82, 59, 25, 127, 82}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 154, 242, 89, 54, 111, 226, 80, 37, 87, 112, 82, 133, 62, 235}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 223, 66, 10}, 149},
	{{241, 0, 0, 0, 123, 238, 112, 144, 160, 145, 230, 46, 143, 231, 56, 51}, 149},
	{{241, 0, 0, 0, 0, 88, 18, 145, 53, 89, 219, 196, 223, 176, 253, 149}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 239, 157, 5}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 143, 23, 118, 23, 244, 178, 87, 53, 38}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{241, 0, 0, 0, 150, 123, 202, 56, 208, 73, 110, 225, 69, 138, 252, 2}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 124, 142, 7, 193, 126, 121, 127}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 156, 12, 78, 40, 172}, 149},
	{{241, 0, 246, 121, 146, 29, 214, 197, 235, 50, 45, 103, 162, 98, 138, 222}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 185, 54, 86, 170, 226, 97, 141, 134}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 64, 81, 239, 72}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 160, 231, 39}, 149},
	{{241, 0, 0, 0, 0, 73, 44, 23, 202, 235, 120, 32, 67, 179, 82, 132}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 38, 28}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 123, 95, 59, 35, 11, 190, 89, 60}, 149},
	{{241, 0, 0, 0, 0, 0, 23, 122, 211, 31, 46, 24, 158, 171, 91, 146}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 254, 86}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 119, 18, 183, 49, 116, 199, 109, 191, 226}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 3, 12, 65}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 71, 177, 167, 130, 101, 118, 27, 188, 105}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 141, 31, 76, 194, 117, 168, 135, 10}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 82, 139, 207, 183, 207, 170, 251, 8, 190}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 5}, 149},
	{{241, 0, 0, 0, 235, 198, 225, 198, 184, 114, 124, 44, 108, 32, 128, 106}, 149},
	{{241, 0, 0, 0, 2, 227, 148, 45, 22, 171, 14, 37, 142, 60, 209, 248}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 91, 9, 39, 250}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 23, 223, 197, 147, 219, 123, 170, 85}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 117, 161, 229, 41}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 128, 37, 213, 254}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 24}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 124, 173, 118, 212, 217, 108, 9, 48}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21}, 149},
	{{241, 0, 0, 0, 0, 0, 253, 170, 172, 198, 167, 98, 233, 94, 133, 148}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 74, 161, 65}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 38, 42}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 4, 249, 81, 126, 117, 43, 145, 128, 30}, 149},
	{{241, 0, 0, 140, 136, 100, 109, 189, 20, 236, 244, 72, 246, 217, 244, 98}, 149},
	{{241, 0, 0, 0, 0, 0, 36, 193, 87, 92, 54, 67, 110, 58, 98, 86}, 149},
	{{241, 0, 0, 0, 0, 0, 69, 10, 64, 247, 207, 68, 57, 31, 129, 94}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 52, 47, 191, 223, 194, 185, 84, 255, 51}, 149},
	{{241, 0, 0, 0, 0, 0, 91, 115, 80, 72, 124, 184, 163, 35, 247, 74}, 149},
	{{241, 0, 0, 0, 0, 208, 191, 170, 218, 186, 35, 2, 244, 117, 137, 48}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 247}, 149},
	{{241, 0, 0, 0, 0, 0, 0, 97, 211, 121, 217, 183, 66, 62, 216, 36}, 149},
	{{241, 0, 0, 0, 0, 0, 207, 253, 150, 58, 80, 126, 74, 158, 218, 224}, 149},
	{{241, 0, 0, 0, 0, 0, 123, 187, 197, 220, 236, 210, 193, 87, 182, 97}, 149},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 16}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 90, 24}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 152}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 77}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 245}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 62}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 245}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 175}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 142, 72}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 73, 37}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 145}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 220}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 31, 155}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 133, 177}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 188}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 33}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 67, 117}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 6}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 115}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 13, 9}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 112}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 251}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 235}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 31}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 242, 33}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 159}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 122}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 205}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 66}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 150, 195}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 218}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 61}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 66}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 148}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 191}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 76}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 206}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 87}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 84}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 159, 91}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 132, 56}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 61}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 155, 250}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 204}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 229}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 165}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 43}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 113, 221}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 235, 216}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 188}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 199}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 184, 201}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 162}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 142, 19}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 144, 132}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 43}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 181}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 95, 199}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 38}, 131},
	{{221, 131, 4, 247, 112, 89, 187, 119, 219, 80, 122, 156, 216, 160, 0, 0}, 131},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{102, 20, 46, 129, 202, 247, 129, 1, 237, 71, 103, 58, 217, 44, 4, 0}, 133},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 95}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 115, 93}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 245}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 167, 190, 11, 14}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 66, 115}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 10, 184, 246}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 112}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 18, 77, 199}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 173, 186, 24}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 115, 136, 100}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 32}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 41, 103, 30, 202}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 228, 113, 161}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 144}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 102, 224, 224}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 187, 178, 115}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 155, 69}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 197, 145, 47, 5}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 6}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 78}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 48, 73, 38, 7}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 91, 101, 198}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 134}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 121, 23, 218, 128}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 10, 161, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 198}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 80, 60}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 144, 18, 144, 119}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 189, 225, 154, 140}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 21}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 133}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 6, 192, 191, 38}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 75, 12, 138}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 36, 231}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 106}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 232, 79, 76}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 228, 90, 253, 5}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 121, 40, 248}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 131}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 182}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 20, 48}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 73}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 134, 102, 239}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 244, 72, 234, 221}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 229, 176}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 195, 5, 134, 11}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 160}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 104, 85, 65, 190}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 227, 205, 61}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 67}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 248, 152, 85, 218}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 246}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 89, 173, 152}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 40, 185, 152, 78}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 201, 59, 126, 30}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 25, 184, 16}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 62}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 103, 150, 239, 88}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 73, 201, 241}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 215}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 88}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 219, 222}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 11, 79}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 231, 245, 231}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 99, 43, 121, 74}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 110}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 129, 196, 230}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 100, 200}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 91, 45, 247, 116}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 84, 176, 134, 181}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 4, 82, 9, 31}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 207, 228, 180, 38}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 159, 201, 117}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 222, 147, 50}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 43, 196, 116, 62}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 0}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 0, 0, 0, 201}, 33},
	{{107, 156, 151, 44, 215, 98, 171, 126, 85, 32, 42, 128, 188, 209, 122, 115}, 33},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 77, 136}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 107, 161, 131, 67, 173, 190}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 131}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 182, 14, 203, 253}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 7, 87, 46, 87, 236, 93, 32}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 108, 105, 188, 75, 65, 11, 133, 56}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 3}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 71, 61}, 204},
	{{54, 25, 70, 80, 0, 0, 148, 255, 240, 160, 182, 39, 228, 228, 138, 134}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49}, 204},
	{{54, 25, 70, 80, 0, 15, 146, 207, 14, 243, 210, 239, 106, 234, 199, 178}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 198, 119, 125, 58, 11, 114, 205, 154, 148}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 7, 57, 69, 115, 27, 63}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 16}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 232, 137, 49, 36, 97, 70, 220, 173}, 204},
	{{54, 25, 70, 80, 0, 0, 85, 94, 214, 229, 46, 138, 7, 24, 244, 77}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 171, 199, 15, 194, 135, 127, 156, 205}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 124, 184, 4, 245, 53, 60, 21, 110}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 40, 98, 26, 226, 4, 75, 61, 65, 57}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 230, 127, 105, 181, 216, 217, 116}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 69, 124, 81, 209, 35, 229, 90}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 19, 199}, 204},
	{{54, 25, 70, 80, 0, 0, 25, 56, 106, 36, 172, 53, 9, 250, 157, 143}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 243, 186, 77, 240, 17, 234, 145, 126, 52}, 204},
	{{54, 25, 70, 80, 0, 54, 24, 50, 176, 138, 113, 247, 227, 181, 147, 73}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 12, 115, 38, 230, 20}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 155, 30, 22, 57, 96, 168, 49, 25}, 204},
	{{54, 25, 70, 80, 0, 0, 53, 53, 96, 45, 46, 161, 222, 185, 211, 90}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 224, 174}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 204},
	{{54, 25, 70, 80, 0, 0, 147, 105, 11, 180, 63, 114, 150, 150, 114, 99}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 90, 23, 144, 163}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 136, 108, 161, 39, 17, 201, 197, 70}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 169}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 127, 114, 42, 61, 122}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 230, 172, 140, 19, 208, 207, 132, 97, 196}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 179, 163, 31, 212}, 204},
	{{54, 25, 70, 80, 157, 187, 90, 236, 226, 105, 167, 86, 35, 179, 131, 75}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 77, 132}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 54, 122}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 177, 203, 40, 187, 138, 216, 207}, 204},
	{{54, 25, 70, 80, 0, 0, 103, 40, 161, 228, 33, 97, 9, 242, 201, 38}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 69, 202, 104, 90, 158, 122, 71, 90, 39}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 144, 30, 126, 77, 95, 162, 6, 197, 95}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 21, 157, 188, 89, 231, 184, 112}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 52, 203, 132, 133, 225}, 204},
	{{54, 25, 70, 80, 0, 181, 90, 148, 142, 215, 198, 95, 97, 240, 212, 179}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 106, 67, 207, 89}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 48, 145}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 210}, 204},
	{{54, 25, 70, 80, 0, 0, 72, 144, 231, 104, 45, 71, 109, 207, 179, 90}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 39}, 204},
	{{54, 25, 70, 80, 0, 0, 190, 87, 21, 76, 214, 12, 116, 103, 153, 151}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 240, 26, 148, 142, 136, 225, 63, 113}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 130, 95, 129, 138, 70, 24, 25, 101, 233}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 86, 180, 133, 60, 69}, 204},
	{{54, 25, 70, 80, 0, 0, 5, 162, 238, 28, 199, 0, 134, 85, 239, 36}, 204},
	{{54, 25, 70, 80, 0, 34, 186, 48, 185, 226, 91, 84, 157, 196, 3, 151}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 217, 79, 132, 129}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 75, 89, 55, 134, 71, 201, 139, 218}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 125, 64, 210, 148}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 221, 62, 79, 243, 12, 135, 64, 217, 113}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 70, 229, 12, 174, 206, 180, 250, 75}, 204},
	{{54, 25, 70, 80, 173, 21, 156, 215, 109, 147, 13, 1, 74, 155, 179, 81}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 215, 18, 70, 150, 215, 40, 35}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 224, 254, 116, 240, 188}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 222, 210, 22, 219, 235, 77, 159, 188}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 150, 2, 7, 201, 104, 121, 127, 79}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 207, 233, 233, 48, 232, 179}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 204},
	{{54, 25, 70, 80, 0, 157, 225, 142, 240, 112, 14, 203, 208, 55, 182, 177}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 167, 2, 86, 202, 245, 21}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 9, 231, 168, 196, 57, 45, 245}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 241, 194}, 204},
	{{54, 25, 70, 80, 0, 0, 5, 5, 208, 91, 17, 23, 0, 91, 11, 156}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 200, 23, 42, 20}, 204},
	{{54, 25, 70, 80, 67, 85, 94, 138, 45, 57, 246, 200, 8, 100, 26, 106}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 207, 39}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 142, 58, 204, 150, 196, 28, 217, 248, 104}, 204},
	{{54, 25, 70, 80, 0, 0, 223, 66, 244, 121, 82, 52, 10, 170, 234, 177}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 129, 111, 254, 111, 218, 54, 110}, 204},
	{{54, 25, 70, 80, 0, 0, 55, 167, 21, 195, 106, 87, 166, 242, 66, 204}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 138, 161, 6, 152, 59, 16, 24, 100, 22}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 173, 161, 155, 103, 47, 61}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 184, 222, 202, 132, 188, 46, 146, 179, 77}, 204},
	{{54, 25, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 128}, 204},
	{{54, 25, 70, 80, 50, 71, 241, 226, 23, 197, 211, 11, 52, 145, 48, 233}, 204},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 124, 141, 227, 93}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 220, 3, 147, 46, 185, 212, 176, 67}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 26, 125, 118, 123, 37, 201}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 25, 180, 130, 87, 198, 198}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 248, 140}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 56, 44, 196, 211}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 66, 236, 137}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 129, 114}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 153}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 252, 84, 89, 97, 91, 47}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 13, 56, 242, 100, 198, 83}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 100, 203, 238, 81, 188}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 29, 180, 97, 47, 153, 110, 102, 6, 0}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 133, 190, 239, 28}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 248, 222, 233, 13}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 183, 229, 214, 210, 45, 203, 10}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 242, 223, 249, 117, 221, 211}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 119, 219, 163, 193, 174, 92, 42, 160}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 67, 220, 214, 92, 167, 219}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 183, 48, 231}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 70, 159, 91, 26, 110, 172, 231, 190}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 125, 234, 200, 134, 239, 42}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 116}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 46, 120}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 118, 9, 17, 197, 35, 4, 189, 115, 96}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 110, 140, 198, 201, 211, 226, 128, 90}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 83, 56, 194, 76, 116, 191}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 157, 183, 110, 156, 64, 255, 97, 131, 67}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 237, 174, 189, 165, 41, 32, 8, 209}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 111, 164, 152, 10, 215, 204, 14, 252, 85}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 173, 161, 46, 210, 67, 90, 71, 152}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 28, 168, 74, 156, 240}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 165, 115, 158, 166, 171, 43, 37, 124}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 161, 217, 27}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 40, 113, 196}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 160, 139}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 160, 136, 168, 0, 35, 223, 24, 54}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 70, 14, 20, 234, 200}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 135, 143, 57}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 5, 210, 228, 136, 180, 238, 45, 182, 207}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 179, 225, 200, 99, 229}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 126, 17, 221, 111}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 107, 10, 28, 218, 206}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 61, 89, 203}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 226, 90, 188, 98, 241, 95, 83, 135}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 234, 152, 155}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 84, 58, 241, 72, 125, 147, 242}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 41, 8, 125, 196, 106, 131, 146, 7}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 150, 105, 75, 245, 57, 181, 86, 203, 202}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 56, 154, 143, 235}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 89, 93, 224, 248, 156, 183, 79, 73, 214}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 99, 6, 61, 144, 90, 99}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 60, 70, 142, 61, 26, 6, 17}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 45, 132}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 137, 255, 99, 112}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 194, 155, 216, 233, 88}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 156, 18, 104, 173, 174}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 71, 94, 231, 112, 206, 131, 36}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 127, 40, 191, 60}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 104, 135, 141, 108, 219, 187, 168}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 1, 226, 216, 94, 244, 70, 179, 39}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 199, 18}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 17, 65, 46, 222, 167, 26, 96}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 61, 15, 173}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 80, 237}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 225, 206, 125, 124, 15, 144}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 121, 158, 241, 159, 93, 125}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 175, 143, 80, 152}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 95, 250, 132, 169, 233, 68}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 67, 144, 161, 204, 92, 255}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 234, 46, 47, 236, 239, 41, 121}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 176, 165, 191, 41, 143, 253}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 52, 65, 100, 133, 60, 255, 183}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 31, 176, 71, 49, 175, 96, 241, 70, 164}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 101, 99, 150}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 190, 4, 10, 160, 144}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 39, 146, 3, 84, 17, 46}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 59, 41, 132, 44}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 152, 46, 62, 230, 133, 48, 12, 215}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 76, 181, 75, 1, 147, 155, 190}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 192, 112, 110}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 198, 252}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 89, 98, 88, 193}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 215, 180, 218, 77}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 220, 145, 192, 55, 144, 32, 100}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 242, 5, 234}, 43},
	{{149, 211, 242, 14, 112, 219, 176, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 43},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 200, 10, 128, 254, 173, 200, 4, 12}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 100, 210, 248, 243, 8}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 65, 98, 20}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 38, 13, 79, 183, 22, 44}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 153, 128, 175, 2, 189, 140, 99, 45}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 196, 41, 116, 161}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 80, 183, 139, 102, 252, 119}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 222, 85, 87, 34, 196, 70, 37, 129}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 78, 25, 46, 67, 222, 229, 123}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 23, 243, 34}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 91, 165, 168, 117, 247, 62, 171, 21, 131}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 176, 176, 44, 167}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 94, 8, 176, 15, 209, 9, 157}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 143, 53, 250, 43, 16}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 107, 108, 90, 58, 185, 8, 105}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 75, 227, 225, 21, 79}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 51, 14, 57}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 24, 18, 54, 23, 30, 81, 110}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 120, 96, 153, 120}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 232, 33, 159, 66, 82, 6, 66, 28}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 157, 117}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 79, 232, 90, 186}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 124, 34, 222, 150, 52, 238}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 229, 65, 215, 38, 16, 232, 95}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 234, 161, 44, 42, 169, 126, 181, 230, 200}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 89, 209, 29}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 207, 203, 125, 92}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 46, 165, 27, 150}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 73, 252, 21, 240, 84}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 3, 242, 202, 88, 138, 189, 153, 228}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 114, 29, 98, 117, 254, 242, 244}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 59}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 224, 111, 51, 171}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 168, 31}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 218, 186, 198, 173, 27}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 59, 156, 211, 201, 83, 140}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 89, 248, 120, 225}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 162, 1, 112, 37}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 132, 48, 148, 149, 238, 228}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 121, 219, 254, 166, 44, 142, 28}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 206, 235, 26, 41, 191, 111, 93, 7}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 251, 92, 216, 78, 203, 44}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 60, 152, 77, 12, 138, 88}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 119, 43, 82, 195, 9, 1, 216, 48}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 63, 40}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 159, 211, 108}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 145, 86, 72, 235}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 209, 239, 3, 80, 231, 115}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 179, 221, 83}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 243, 81, 158}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 90, 121, 11, 176, 104}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 169, 159, 220, 20, 24, 128, 227, 45}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 250, 149, 180, 184, 207, 251, 64}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 26, 173, 211, 57, 82, 230, 109}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 99, 84, 160, 246, 144, 43, 7, 200, 55}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 90, 52, 10, 89, 76, 245, 93, 138}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 234, 234}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 86, 222}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 184, 58, 45, 8}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 238}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 122, 178, 172, 248, 16, 226, 193, 163}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 206, 150}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 145, 229, 246, 2}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 136, 113, 199, 233, 195, 79}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 19, 81, 70, 111, 254, 171, 22}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 188, 165, 207, 194, 115, 135, 119}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 49, 177, 58, 64}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 106, 202, 14, 10}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 79, 169, 167, 92, 168, 122, 79, 193}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 83, 209, 87, 64, 217, 147, 45, 174, 26}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 203, 145}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 66, 67, 211, 104, 236, 175}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 148, 236, 41, 112, 94, 4, 143, 218}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 84, 66, 117, 183, 248, 94, 198, 141, 46}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 65, 167, 121, 221, 96, 146, 242, 135}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 234}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 34}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 189, 18, 12, 24, 4, 51, 104, 225, 145}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 143, 102, 187, 243, 228, 124, 97}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 0, 0, 212, 93, 145, 202, 132}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 24, 123, 196, 113, 128, 197, 65, 90, 29}, 168},
	{{95, 26, 143, 193, 8, 76, 64, 0, 0, 1, 249, 64, 169, 130, 35, 198}, 168},
	{{63, 102, 244, 176, 0, 0, 0, 0, 166, 192, 32, 214, 117, 193, 138, 56}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 214, 170, 167, 90}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 246, 244, 171, 191, 186, 84}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 54, 77, 138, 236}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 77}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 180},
	{{63, 102, 244, 176, 0, 175, 159, 46, 198, 83, 63, 11, 17, 105, 94, 46}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 18, 79}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 81, 43, 103, 160}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 211, 35}, 180},
	{{63, 102, 244, 176, 0, 0, 233, 22, 81, 70, 11, 69, 132, 28, 139, 182}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 52, 68, 247, 221, 179, 121, 100}, 180},
	{{63, 102, 244, 176, 207, 220, 242, 22, 179, 184, 166, 41, 106, 136, 175, 93}, 180},
	{{63, 102, 244, 176, 0, 147, 193, 229, 149, 13, 0, 251, 21, 45, 45, 82}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 57, 99, 112, 248, 244, 141}, 180},
	{{63, 102, 244, 176, 2, 233, 220, 134, 198, 130, 9, 95, 75, 115, 186, 151}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 8}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 180},
	{{63, 102, 244, 176, 235, 255, 241, 131, 142, 173, 57, 102, 160, 69, 35, 119}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 161, 212, 94, 82, 62, 72, 151, 249}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 70, 135, 162, 222, 64}, 180},
	{{63, 102, 244, 176, 0, 0, 225, 59, 65, 216, 197, 18, 115, 74, 126, 38}, 180},
	{{63, 102, 244, 176, 0, 0, 22, 160, 116, 85, 146, 81, 78, 142, 176, 33}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 81}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 100, 182}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 202, 213, 232, 229, 47, 20, 29, 8, 188}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 185, 19, 96, 165, 119, 43, 165}, 180},
	{{63, 102, 244, 176, 0, 0, 108, 96, 170, 243, 160, 26, 242, 242, 226, 228}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 175, 106}, 180},
	{{63, 102, 244, 176, 131, 110, 109, 207, 169, 76, 92, 122, 123, 183, 237, 98}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 18, 45, 197, 251, 221, 3}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 14}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 5, 206}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 163, 114, 87, 251, 160, 36, 101}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 146, 43, 176, 188}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 93, 201}, 180},
	{{63, 102, 244, 176, 0, 102, 23, 154, 157, 181, 162, 146, 236, 60, 154, 161}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 83, 126, 174, 140, 211}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 216}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 119, 82, 155, 54, 155, 239, 247, 243}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 204}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 141, 250, 251, 236, 76, 162, 78, 57}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 143, 34, 255, 158, 213, 208}, 180},
	{{63, 102, 244, 176, 0, 0, 98, 155, 62, 94, 42, 100, 200, 65, 12, 155}, 180},
	{{63, 102, 244, 176, 0, 0, 77, 163, 216, 200, 79, 242, 188, 138, 152, 167}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 153, 21, 26, 0, 202, 123}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 87, 105, 184, 240, 195, 107, 153}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 16, 7, 27, 130}, 180},
	{{63, 102, 244, 176, 0, 0, 203, 180, 222, 112, 134, 160, 138, 159, 68, 122}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 223, 117, 65, 213}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 40, 16, 21, 242, 131, 252}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 192, 22, 68, 227, 125, 37, 207, 156, 7}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 148, 137, 175, 165, 138, 90}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 85, 252, 66, 38, 201, 128}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 106, 122, 221, 112, 176, 149}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 24}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 14, 193, 246, 72, 243, 144, 178, 88}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 82, 242, 218, 50, 221, 92}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 147, 89, 2, 181}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 219, 143, 110, 253, 170, 1, 27}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81}, 180},
	{{63, 102, 244, 176, 34, 117, 166, 57, 54, 89, 134, 248, 62, 214, 232, 105}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 233, 223, 146, 204, 51, 99}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 91}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 18, 87, 244, 41, 197, 179, 57, 198, 251}, 180},
	{{63, 102, 244, 176, 0, 195, 177, 117, 96, 69, 7, 202, 9, 249, 177, 255}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 144, 113, 5, 195}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{63, 102, 244, 176, 0, 0, 106, 155, 158, 134, 192, 10, 45, 244, 63, 67}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 205, 81, 223, 216, 239}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 94}, 180},
	{{63, 102, 244, 176, 248, 128, 176, 121, 93, 74, 85, 30, 9, 157, 191, 107}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 32, 52, 50, 208}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 74, 190, 115, 120, 47, 54, 19}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 88, 20, 17, 170, 11, 50, 9, 10, 154}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 180},
	{{63, 102, 244, 176, 135, 187, 1, 60, 215, 93, 237, 131, 98, 59, 179, 180}, 180},
	{{63, 102, 244, 176, 0, 175, 22, 94, 172, 99, 48, 54, 150, 131, 164, 107}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 135, 228, 184, 99, 138}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 114, 250, 197, 113, 206, 203, 103}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 4, 42}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 38}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 193, 9, 164, 16, 232, 123, 150}, 180},
	{{63, 102, 244, 176, 0, 0, 73, 118, 230, 15, 116, 202, 8, 45, 120, 57}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 244, 27, 132, 76, 92}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 2, 93, 177, 64}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 183, 90, 194, 236, 170}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 183, 110, 162, 36, 175, 49, 147}, 180},
	{{63, 102, 244, 176, 12, 137, 176, 217, 37, 4, 174, 222, 115, 169, 36, 90}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21}, 180},
	{{63, 102, 244, 176, 0, 0, 0, 0, 0, 0, 86, 251, 53, 69, 206, 120}, 180},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 39}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 78}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 252}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 19}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 207}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 158}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 145}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 12}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 12}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 220}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 47}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 51}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 105}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 117}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 143}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 169}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 60}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 112}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 48}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 173}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 32}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 56}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 46}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 78}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 116}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 119}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 224}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 68}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 7}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 107}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 223}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 204}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 42}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 77}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 249}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 220}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 77}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 139}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 215}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 126}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 136}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 73}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 173}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 221}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 12}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 194}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 30}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 28}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{64, 85, 124, 226, 59, 239, 64, 130, 68, 122, 93, 74, 32, 37, 0, 0}, 208},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 205, 138, 56}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 68, 16}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 113, 125}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 244, 99, 140, 227}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 67, 237}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 241, 26, 196, 80}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 7, 81, 50}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 10, 59, 36, 70}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 223, 229}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 83, 22}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 204, 233, 162}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 125}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 94, 249, 114}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 246, 69, 126}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 12, 5, 23}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 13, 15, 83}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 254, 201}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 175, 139, 215, 250}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 162, 213, 80}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 126, 120}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 84}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 174, 58}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 53, 163}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 78, 227, 120, 209}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 17, 23, 50, 52}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 130}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 147}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 188}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 247}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 193, 142, 198, 47}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 135, 193}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 116, 48, 59, 130}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 9}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 133, 9}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 142, 130}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 7, 236, 146}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 150, 239, 250, 248}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 249, 233}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 170, 73}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 183, 251, 208, 250}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 88}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 59, 62}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 144, 151, 227}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 159, 248, 67, 218}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 121, 92}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 63, 174, 38}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 185, 238, 204, 41}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 87, 80, 162, 82}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 194, 83, 116, 199}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 110, 76, 31, 192}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 211}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 87, 108}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 173}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 203}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 176, 98, 103, 8}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 124, 18, 155, 109}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 11, 27, 26}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 199}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 221, 63, 97}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 152, 244, 131}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 52, 120, 211}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 234}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 160}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 142, 169}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 2, 229, 189, 105}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 8}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 114, 26, 186}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 95, 60}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 50}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 182}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 24, 55, 6}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 227, 146, 181}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 120}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 124}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 253, 78, 72}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 90, 135, 127, 25}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 111, 128}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 0, 0}, 25},
	{{113, 90, 253, 149, 3, 218, 34, 215, 3, 143, 192, 64, 0, 0, 147, 168}, 25},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 103}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 22}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 143}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 164}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 202}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 62}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 152}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 150, 14}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 39}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 47}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 44, 240}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 200}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 183}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 150}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 105}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 164}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 61}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 72}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 26}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 187}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 203, 113}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 193}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 18}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 251}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 247}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 166}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 233}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 22}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 159}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 78}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 117}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 168}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 192}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 87}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 153}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 35}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 190}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 19}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 187}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 153}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 7}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 49, 242}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 135}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 210}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 96}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 141}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 12}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 5}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 106}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 88}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 0}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 124}, 50},
	{{75, 231, 33, 5, 11, 94, 117, 104, 150, 60, 72, 161, 96, 38, 0, 88}, 50},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 70}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 249}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 175, 227}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 201}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 201}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 143, 180}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 99}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 44}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 214}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 24, 99}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 231}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 234, 121}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 150}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 53, 127}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 210}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 242}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 59}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 94}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 92, 230}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 134}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 140}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 13}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 225}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 142}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 57}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 71}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 92, 221}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 243}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 200}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 136}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 13}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 181, 210}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 104}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 91}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 246}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 168, 145}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 86}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 9}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 27}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 88}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 15, 138}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 24, 233}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 55}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 117}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 192}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 106}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 239}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 146}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 225}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 71}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 94}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 72}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 250, 13}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 230, 96}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 62}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 158}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 113}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 222}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 0}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 0, 156}, 110},
	{{52, 13, 248, 1, 251, 14, 50, 29, 212, 123, 130, 177, 101, 96, 76, 18}, 110},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 115}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 4, 182}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 156}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 171}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 104}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 56, 247}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 31}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 234}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 98}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 47, 249}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 31}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 204}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 31, 197}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 137, 95}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 118}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 179, 10}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 201}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 200}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 186, 141}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 203}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 118, 167}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 4}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 214}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 168, 6}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 202}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 234}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 131}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 52}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 254}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 135, 49}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 194, 252}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 11}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 143, 155}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 81}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 184, 71}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 79}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 49}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 228}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 52, 228}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 104}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 103}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 107}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 186}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 225}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 30}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 79, 192}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 54}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 235}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 126, 141}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 179}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 55}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 176}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 95}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 61}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 108}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 206}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 85}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 17}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 235}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 0}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 78}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 45, 86}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 225}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 128, 196}, 21},
	{{248, 221, 150, 132, 252, 82, 96, 2, 80, 232, 97, 239, 253, 64, 0, 23}, 21},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 84}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 223, 121, 251, 66, 221, 38, 205, 25}, 147},
	{{136, 77, 164, 161, 192, 0, 101, 128, 233, 130, 108, 39, 124, 123, 131, 43}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 9, 96, 41, 71, 54, 6, 230, 85, 170}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 187, 211, 30, 121, 155}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 185, 90, 39, 26, 252, 222, 78, 139}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 47, 56, 134, 48, 175, 159, 178}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 81, 23, 49, 99, 206, 148, 255, 84}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 193, 248, 247}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 175, 18, 108, 55, 45}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 68, 247, 164, 138, 110}, 147},
	{{136, 77, 164, 161, 192, 77, 209, 147, 245, 129, 114, 28, 10, 253, 170, 8}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 183}, 147},
	{{136, 77, 164, 161, 192, 0, 233, 100, 135, 197, 159, 236, 83, 65, 191, 226}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 242, 251, 254, 198}, 147},
	{{136, 77, 164, 161, 192, 0, 219, 211, 251, 93, 65, 146, 116, 219, 146, 220}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 200, 229, 153, 151, 153}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 14, 90, 232, 15, 173, 255}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 208, 92, 233, 248, 156, 249}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 141, 114, 138, 104}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 185, 125, 16, 151, 210, 159}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 119, 255, 81, 14, 200, 61, 255, 155, 138}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 69, 231, 203, 132, 78, 173}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 124}, 147},
	{{136, 77, 164, 161, 192, 0, 175, 76, 48, 129, 123, 121, 44, 127, 190, 230}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 35, 207, 217}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 42, 179, 116, 231}, 147},
	{{136, 77, 164, 161, 192, 36, 228, 79, 129, 55, 27, 77, 113, 15, 179, 142}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 186, 187, 86, 151, 122, 187, 195, 112, 172}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 176, 27, 130, 228, 15, 67}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 22, 131, 48, 213, 107}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 94, 158, 145}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 174, 198, 251, 181, 68, 232, 217}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 164, 106, 82, 1}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 130, 24, 124, 243, 170, 236}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 151, 79, 10, 48, 140, 213, 134, 69, 196}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 147},
	{{136, 77, 164, 161, 192, 216, 231, 185, 60, 157, 196, 232, 153, 65, 153, 130}, 147},
	{{136, 77, 164, 161, 192, 196, 2, 43, 108, 203, 108, 151, 123, 87, 91, 73}, 147},
	{{136, 77, 164, 161, 192, 0, 65, 146, 168, 130, 4, 128, 54, 167, 63, 60}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 222, 138, 149, 168, 205}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 171}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 167, 246, 189, 131}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 155, 92, 68, 185}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 122, 155, 70, 223, 163, 200}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 85, 224, 36, 166, 10}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 71, 19, 191}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 116, 187, 3, 233, 61, 153, 236, 128}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 95, 136, 167, 197, 225, 215, 129}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 59, 10, 234}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 40, 168, 37, 113, 182}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 60, 39, 27, 147}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 46}, 147},
	{{136, 77, 164, 161, 192, 0, 207, 61, 153, 122, 10, 89, 243, 213, 54, 187}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 59, 96, 176, 75}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 99, 38, 115, 8, 7, 20, 179}, 147},
	{{136, 77, 164, 161, 192, 18, 20, 19, 217, 237, 126, 131, 91, 227, 151, 185}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 180, 117, 22, 21, 79, 253}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 69, 81, 34, 239}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 136, 152, 191, 65, 132, 123, 113, 215, 121}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 22, 175, 28, 135, 252}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 33}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 220, 171, 117, 46, 127, 195, 223, 197}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 61, 249, 218, 61, 132, 108, 14}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 183, 171, 204, 69, 223, 87, 82}, 147},
	{{136, 77, 164, 161, 192, 164, 232, 123, 150, 114, 196, 92, 21, 14, 168, 183}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 89, 186, 182}, 147},
	{{136, 77, 164, 161, 192, 0, 134, 118, 121, 74, 70, 40, 116, 7, 191, 112}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 68, 235, 84}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 210, 242, 103, 156, 210}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 196, 1, 11}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 220, 252, 226}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 93, 87, 157, 195, 6, 56, 7, 64}, 147},
	{{136, 77, 164, 161, 192, 0, 193, 116, 100, 140, 207, 153, 160, 176, 198, 167}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 97, 229, 75}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 211}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 47, 88, 166, 101}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 174, 124, 134, 151, 127, 203, 24, 190, 89}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 41, 93, 29, 97, 56, 146}, 147},
	{{136, 77, 164, 161, 192, 0, 82, 34, 176, 91, 250, 201, 160, 180, 54, 86}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 147},
	{{136, 77, 164, 161, 192, 173, 15, 127, 15, 10, 167, 243, 42, 138, 75, 219}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 85, 61, 54, 162, 165, 32, 48, 6}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 0, 0, 0, 0, 190, 21, 114}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 0, 208, 60, 149, 231, 244, 135, 232}, 147},
	{{136, 77, 164, 161, 192, 0, 0, 0, 179, 8, 29, 254, 213, 176, 100, 134}, 147},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 44, 101, 237}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 255, 140, 232, 250, 171, 181, 116}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 105, 188, 130}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 157, 80, 190, 125, 42, 96}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 140, 177, 141, 70, 106, 47, 110, 147, 138}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 45, 133, 240, 181, 15, 80}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 231, 57, 172, 16, 23, 170}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 117, 140}, 56},
	{{1, 33, 66, 254, 144, 128, 126, 186, 131, 174, 177, 181, 254, 170, 135, 159}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 207, 62, 158, 2}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 237, 90, 70, 134}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 195, 37, 49}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 129, 209, 35, 234, 251, 216, 148}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 127, 110, 255, 14}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 108, 53, 74, 2}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 234, 143, 8, 49, 236, 27, 139}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 201, 165, 205, 199, 220}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 243, 7, 215, 151, 197, 17}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 82, 78}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 32, 40, 166, 166, 84, 10, 170, 54}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 29, 222, 193, 147, 22, 170, 241, 10, 212}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 106, 54, 2, 255, 117, 18, 204, 21, 78}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 26, 131, 156}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 214, 224}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 189, 134, 206, 229}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56},
	{{1, 33, 66, 254, 144, 128, 231, 122, 9, 108, 216, 146, 155, 90, 52, 104}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 93, 223, 175, 47, 41, 104, 104}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 59, 207, 127, 64, 85, 159, 247, 226, 218}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 176, 196, 236, 219, 141, 29, 165}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 85, 177, 15, 40, 80, 114, 227, 195}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 41, 231, 0, 255, 118, 87, 123, 140}, 56},
	{{1, 33, 66, 254, 144, 128, 243, 118, 8, 131, 136, 253, 109, 59, 213, 136}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 142, 202, 26}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 76, 99}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 129, 177}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 180, 170, 236, 8}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 89, 96, 246, 33}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 128, 245, 122, 73, 175, 110}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 251, 15, 13, 176, 49, 249, 176}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 51, 62, 113, 38}, 56},
	{{1, 33, 66, 254, 144, 128, 15, 248, 103, 247, 90, 138, 114, 185, 243, 79}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 147, 15, 71}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 50, 179, 254, 173, 10}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 56, 220, 136, 50, 1, 124, 63, 20, 48}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120}, 56},
	{{1, 33, 66, 254, 144, 128, 20, 169, 120, 72, 64, 172, 184, 3, 8, 109}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 76, 228}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 44, 63}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 13, 90, 190, 159, 41, 65, 37}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 93, 117, 191, 32, 169, 103, 219}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 242, 184, 123, 181, 173}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 115, 179, 184, 158, 71, 71}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 27, 227, 55, 35, 108, 233, 155}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 38, 45, 3, 211, 125, 40, 240, 180}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 14, 10, 117, 222, 250, 225, 112}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 243, 218, 115}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 40, 174, 165, 163, 163, 170, 16}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 41, 200, 141, 23}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 136, 34, 12, 92, 180, 35, 214, 188}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 184, 75}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 252, 205, 107}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 37, 4, 54, 29, 169, 200, 181, 203, 185}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 208, 112, 129}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 42, 213, 94, 231, 64, 178, 18, 63}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 193, 96, 35, 204}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 25, 85, 201}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 232, 129}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 164, 220, 115, 154}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 114, 105, 77, 156, 183}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 13, 135, 203}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 80, 237, 4, 159, 134, 157, 124}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 30, 146, 169}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 236, 137, 115, 137, 151, 218, 101, 247}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 191, 135, 28, 89, 56, 185, 47, 6}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 8, 11, 82, 23, 137, 247}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 1, 159, 235, 67, 120, 16, 116, 183, 73}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 60, 60, 180, 140, 213, 187}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 206, 99, 12}, 56},
	{{1, 33, 66, 254, 144, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 56},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 22}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 174}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 15}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 180}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 221}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 250}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 53}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 10}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 184}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 47}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 211}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 99}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 107}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 222}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 245}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 251}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 186}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 76}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 57}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 80}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 21}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 184}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 184}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 121}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 82}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 190}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 124}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 92}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{181, 25, 186, 225, 109, 190, 76, 158, 118, 122, 20, 64, 125, 55, 8, 0}, 144},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 50}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 211, 22}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 21, 68, 210}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 118}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 113, 192}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 180, 245}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 108, 148, 163}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 205}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 66, 75}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 197}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 120, 153}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 15, 73, 208}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 248, 194, 95}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 112, 158}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 80, 177, 112}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 128}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 92, 207}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 76, 182}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 250, 47}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 167}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 232, 117}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 187, 116}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 137, 161}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 251, 1, 66}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 84}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 38}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 169}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 4, 24, 26}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 173}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 173, 1}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 158}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 164, 3, 151}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 226, 203}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 83}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 116, 156}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 108, 32}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 68, 36}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 134, 16}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 250}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 88}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 247}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 152, 48, 14}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 131, 240, 32}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 136, 202, 16}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 136, 182, 47}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 247}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 242, 157}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 91}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 224, 118}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 135, 37}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 100}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 187}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 80, 135, 47}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 111, 69}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 45, 78}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 72}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 116}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 72, 252, 166}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 6, 207}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 143, 72, 127}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 109}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 59}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 178}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 6}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 37, 203}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 100}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 70, 71}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 50, 37}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 31, 202}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 116}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 68}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 0, 0}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 50, 73}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 201, 64}, 198},
	{{191, 187, 160, 140, 17, 6, 80, 120, 236, 212, 104, 144, 128, 0, 52, 1}, 198},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 63, 10, 255, 78}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 66, 231}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 120, 73, 132}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 176, 76, 86}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 183, 73, 246, 118}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 13, 92, 164}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 94, 103}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 76}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 81, 91, 77}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 68, 70, 51, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 95}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 183}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 125}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 109, 130}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 24}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 167, 99}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 111, 180, 26, 5}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 131, 195, 137, 215}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 101, 185}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 128, 97, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 207}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 44, 237}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 17, 103, 18}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 9, 63}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 149, 101, 60}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 185, 146, 177}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 173, 28}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 1, 29, 39, 1}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 16, 116}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 103, 125}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 192, 215, 53}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 19}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 214, 94, 22}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 165, 183}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 15, 55, 33, 67}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 138, 247, 85}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 99, 183, 120}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 59, 116}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 66, 185, 10, 4}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 245, 200, 204}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 224, 237}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 8, 135, 227, 115}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 116, 50, 87, 161}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 37, 91}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 94, 215, 237, 83}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 100}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 111, 135}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 178}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 143, 184}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 12}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 206, 57, 203, 35}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 68, 78}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 253, 162}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 121}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 45}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 42, 74, 66}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 126, 112}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 142, 217, 123}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 213, 208}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 181, 228, 235}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 216}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 156, 163, 104}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 82, 78, 218}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 174, 201, 19, 145}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 173, 113, 127, 33}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 209, 253}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 39, 73}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 196, 253}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 161, 20, 112, 109}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 241, 201, 69, 12}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 0}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 7, 164}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 39}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 0, 68}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 250, 141, 145, 81}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 112, 227, 224}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 228, 169, 196}, 235},
	{{201, 61, 150, 254, 70, 77, 214, 211, 171, 163, 245, 64, 0, 0, 167, 5}, 235},
	{{143, 226, 190, 50, 252, 0, 0, 223, 184, 242, 11, 163, 170, 154, 244, 46}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 72, 209, 22, 245, 198, 107, 197, 190, 141}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 252, 78, 134, 131, 156, 245}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 58, 162, 248, 110, 32, 113}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 41, 209, 132, 105}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 72, 112, 13, 104, 1, 57}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 30, 143, 60, 148}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 108, 227, 248, 96, 220, 76, 32, 233, 36}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 51}, 105},
	{{143, 226, 190, 50, 252, 0, 136, 150, 242, 6, 65, 225, 64, 158, 111, 235}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 186, 34, 232, 111, 134, 164}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 10}, 105},
	{{143, 226, 190, 50, 252, 52, 60, 211, 214, 139, 102, 198, 78, 20, 53, 124}, 105},
	{{143, 226, 190, 50, 252, 28, 155, 227, 2, 129, 50, 82, 183, 226, 233, 207}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 141, 86, 237, 214, 77, 149}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 2, 151, 196, 179, 136, 239}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 195, 181, 136, 57, 72, 221, 241, 72, 13}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 54, 69, 153, 227, 143, 187}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 110, 234, 149, 230, 230}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 220, 65, 196, 135, 138, 71}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 155, 73, 204}, 105},
	{{143, 226, 190, 50, 252, 191, 242, 101, 122, 230, 58, 249, 73, 39, 188, 161}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 198, 19, 156, 78}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 17, 138, 115, 27, 49, 88, 99}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 123}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 62, 198, 120}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157}, 105},
	{{143, 226, 190, 50, 252, 0, 98, 159, 47, 174, 39, 251, 98, 96, 213, 18}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 58, 166, 200, 178, 108, 164, 121, 67}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 204, 115, 82, 191, 55, 149, 173}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 20, 26, 252, 125, 10, 144}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 235, 147, 150, 76, 195}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 238, 40, 15}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 75, 189, 70, 208, 102, 142, 238, 96}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 48, 76, 230, 174, 43, 129}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 176, 232, 189, 182}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 60}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 144, 68, 159}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 176}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 214}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 175, 162, 103, 28}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 118, 143, 69, 81, 50}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 42, 244, 159, 38, 41, 29, 214, 47, 99}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 242, 139, 61, 27}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 176, 120, 68}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 63, 41, 160}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 150}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 193}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 252, 212, 30, 159, 213}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 47, 2, 1, 16, 210, 180, 183, 42}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 53, 5, 57, 89, 70, 62, 236}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 91, 28, 204, 42}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 239, 189, 186, 92}, 105},
	{{143, 226, 190, 50, 252, 0, 160, 128, 19, 24, 30, 200, 25, 179, 101, 123}, 105},
	{{143, 226, 190, 50, 252, 0, 210, 226, 178, 131, 181, 209, 141, 92, 175, 125}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 30, 63, 199, 140, 243, 92, 101}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 172, 140, 188, 218, 69, 120, 24, 24, 185}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 10, 51, 68, 174, 186, 242, 52, 239, 154}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 84, 121, 18}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 85, 237, 244}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 7, 33, 68, 36, 102, 0, 161, 249}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 35, 133, 172}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 56, 187, 95, 85, 23}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 52, 165, 138, 220, 226, 81, 149, 61, 97}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 191, 143, 119, 197, 109, 183, 154, 46, 89}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 98, 76, 206, 17, 38, 199}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 200, 245, 21}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 65, 127, 72, 215, 98, 31}, 105},
	{{143, 226, 190, 50, 252, 0, 51, 14, 46, 227, 250, 3, 195, 168, 230, 243}, 105},
	{{143, 226, 190, 50, 252, 26, 237, 34, 53, 239, 250, 241, 86, 187, 141, 60}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 61, 200, 236, 137, 111, 156, 37}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 16, 240, 56}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 113, 85, 168, 162, 53, 181}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 67, 239, 215}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 143, 7, 44, 178, 199, 69, 113, 140}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 21, 91, 118, 166, 224}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 105, 72, 226, 155, 81}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 38, 21, 65, 226, 7}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 146, 71, 31, 3}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 126, 84, 193, 35, 163, 36}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 131, 81, 125, 100, 28, 47, 80, 102}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 105},
	{{143, 226, 190, 50, 252, 0, 0, 0, 30, 154, 64, 0, 54, 8, 128, 77}, 105},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 77, 44, 102, 224, 175}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 174, 71, 167, 121, 29}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 205, 181, 141, 71, 196, 242}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 129, 228, 87, 153, 70, 212, 5, 73, 95}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 56, 87, 248, 226}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 70, 236, 214}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 104, 84, 11}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 90, 203, 161}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 99, 157, 181, 166, 205, 83, 29, 164}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 129, 250, 118, 243}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 79, 18, 25, 36}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 186, 254, 167, 178, 206, 4, 239, 82}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 15, 197, 117}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 106, 233, 161, 141, 246, 20, 125, 216}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 17, 146, 114, 33, 166}, 138},
	{{65, 168, 226, 36, 201, 80, 124, 224, 178, 67, 118, 237, 138, 93, 191, 105}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 195, 78, 240, 176, 34, 53, 136, 138, 209}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 120, 40, 39}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 142, 192, 44, 61, 78, 195, 226}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 116, 126, 162, 165}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 135, 155, 63, 246}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 128, 111, 213, 113}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 94, 199, 138, 125, 113, 10, 38, 93, 60}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 71, 139, 107}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 218, 209, 61, 125, 224, 106}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 250, 55, 204, 90, 149, 188, 71, 250}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 41, 216, 57, 44, 151, 93, 98, 53}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 225, 116, 188, 15, 33, 118, 107}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 213, 219, 170, 111}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 167, 215}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 238, 15, 161, 133, 190, 209, 76, 202}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 59, 61, 31, 176}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 30, 115, 131, 109}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 130, 246}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 52, 45, 186, 181, 188, 119, 208, 87, 20}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 80, 244, 19}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 117, 48, 25, 229, 167, 89}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 96, 155, 223, 16, 117, 131, 77, 92}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 224, 157, 219, 40, 152, 201, 109}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 227, 183, 111}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 26, 152, 107, 141, 193, 114, 1, 169}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 23, 151, 188, 63}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 107, 165, 102, 22}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 25, 212, 183, 185, 213}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 19, 209, 15, 227, 191, 109, 203, 225}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 166, 84}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 193, 214, 197, 197}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 225, 210}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 75, 175, 150, 146, 63, 107, 200, 13}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 86, 142, 106, 183, 23, 238, 203, 81}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 182, 40, 208, 154}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 154, 181, 195, 156, 213, 65, 224}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 17, 86}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 72, 12, 253, 108, 238, 128, 76, 0, 182}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 35, 248, 238}, 138},
	{{65, 168, 226, 36, 201, 80, 145, 32, 132, 9, 66, 158, 60, 215, 82, 38}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 218, 231, 130, 134, 85, 181, 126, 162, 196}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 159, 192, 168, 37, 247}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 70, 139, 18, 110}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 236, 136, 124, 174, 233, 96, 192, 233, 95}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 142, 210, 179, 63, 172, 221, 8, 161, 226}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 24, 30}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 132, 94, 171, 79, 18, 3, 63, 111}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 253, 202, 202, 161, 160, 40}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 62, 2}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 230, 249}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 205, 244, 169, 91, 254, 95, 129, 254, 95}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 246, 235}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 43, 133, 94, 57, 82, 35, 17, 242, 79}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 26, 166, 208, 146, 241, 44, 197}, 138},
	{{65, 168, 226, 36, 201, 80, 159, 47, 193, 69, 57, 124, 90, 117, 215, 172}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 158, 202, 98, 171, 209}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 172, 203, 29, 208, 188, 143, 204, 255, 170}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 234, 155, 157, 39, 52, 238, 67, 28, 193}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 159, 39}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 49, 107}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 5, 34, 68, 228, 97, 20, 57, 69}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 207, 39, 104, 164, 210, 249, 41}, 138},
	{{65, 168, 226, 36, 201, 80, 0, 0, 0, 152, 41, 147, 135, 224, 20, 30}, 138},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 24, 238, 223, 237, 246, 55}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 106, 44, 183, 152}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 2, 42}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 242, 169, 117, 156, 71, 23, 36, 89, 38}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 196, 152, 97, 149, 111}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 248, 1, 88, 243, 108, 39, 112}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 255, 126, 52, 96, 185, 233, 251}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 97, 167, 115, 161}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 91, 3, 30, 233, 100, 188}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 200, 40, 158, 86}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 161, 231, 169, 153, 64, 125, 255}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 195, 160, 237}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 55, 9, 158, 65, 246, 106, 203, 27, 187}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 87, 28, 252, 13, 203, 162}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 102, 35, 56, 213, 22, 71, 53, 209}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 98, 63, 161, 72, 70}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 51, 203, 215, 225, 125}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 82, 110}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 188, 142, 88}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 195, 98, 132}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 170, 155, 130}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 28, 233, 200, 166, 150, 88, 170, 216}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 27, 145, 240, 109}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 35, 156, 93, 4, 141, 175, 82, 211}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 106, 155, 156, 84, 121, 196, 3, 170, 140}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 243, 246, 166, 45}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 248, 40}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 209, 34, 161, 158, 219, 72, 245, 225}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 255, 48, 174, 241, 121}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 178, 131, 45, 217, 201, 59, 53, 190}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 161, 43, 245, 71, 174, 183, 4, 23}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 2, 38}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 142, 36, 126}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 212, 219, 169, 195}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 224, 245, 140, 176, 9, 76, 243, 68}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 149, 11, 181, 222, 136}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 134, 147, 161, 134, 57, 23, 144}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 62, 140, 72, 4, 165, 105, 222}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 200, 33, 66, 114}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 104, 116, 21, 140, 218, 181, 190, 244}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 173, 85, 223, 76, 72}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 70, 57, 89, 55}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 64, 210, 83, 142, 251, 242}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 241, 128, 125, 52, 211, 179, 15, 171, 29}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 52, 73, 126, 39, 199, 176, 87, 185, 140}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 140, 63, 97, 79, 196}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 195, 136, 171}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 196, 157, 69, 212, 121}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 96, 78, 185, 181}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 191, 124, 195, 91, 38, 124}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 60, 43, 184, 103, 133, 113, 96}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 156, 140, 227, 177}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 1, 192, 233, 155, 89}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 150, 135, 37, 134, 230, 27, 140, 96}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 82, 7, 203, 76, 171, 51, 186, 198, 86}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 102, 86}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 4, 77, 71, 148, 129, 131}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 165, 138}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 202, 14, 75, 111, 255, 69, 185}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 30, 239, 112, 192, 196, 32, 26, 235, 135}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 67, 242}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 43, 248, 172, 77, 29, 209}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 54, 3, 59, 64, 46, 76, 57, 168, 96}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 181}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 74, 7, 175, 237, 140, 11, 32, 101, 121}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 221, 221, 246, 31, 216, 137, 39}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 56, 59, 115, 160, 191, 239, 209, 29, 87}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 51, 64, 210}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 173, 196}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 99, 67, 180, 203, 182}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 48, 76, 54, 45, 61, 86, 141, 26}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 41, 146}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 45, 193, 173, 99, 229, 10}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 217, 40, 144, 141, 116}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 222, 240, 212, 47, 71, 57}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 129, 20, 124, 242}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 16, 249, 221, 167, 199, 150, 89}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 185}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 140, 130, 161, 131}, 122},
	{{136, 40, 65, 90, 47, 16, 128, 0, 0, 0, 0, 0, 239, 244, 38, 127}, 122},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 51, 199, 230, 146, 13}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 34, 228, 3}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 38, 85, 93, 233, 26, 174, 103}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 70, 200}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 21, 245}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 195, 218, 73, 143}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 55, 153}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 241, 173, 22}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 254, 14, 187, 196, 114}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 44, 227, 236, 69, 110}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 229, 246}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 157, 132, 254, 25, 132}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 125}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 5, 186}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 176, 143, 28, 173, 190}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 241, 88, 248, 116, 221, 20}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 236, 34, 100, 242, 234}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 185, 224, 69, 78}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 78, 198, 84, 62}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 240, 255, 93, 218}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 60, 37, 122}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 169, 5, 162, 133, 14, 104}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 120}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 155, 176, 236, 170}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 109, 56, 97, 56, 238, 160, 220}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 223, 191, 207, 13, 129}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 83, 173, 72, 177, 116}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 149, 23, 69, 228, 240, 20, 87}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 26, 104, 81}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 3, 138, 219, 84, 144, 86}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 252, 111, 170, 106, 147, 31}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 112, 67, 248, 137, 52}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 57, 17, 6, 22, 126}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 193, 25, 124}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 100, 202}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 150, 86, 47, 132}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 49, 17, 71, 96, 87, 210, 185}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 144, 80}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 26}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 4, 181, 32, 138, 6}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 121, 115}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 121, 205, 87, 254, 107, 81, 239}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 252, 230}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 251, 167, 153, 13}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 39}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 22, 5, 78, 140, 89, 237}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 34, 126}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 146, 223, 62, 65, 102, 43}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 233, 197}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 104}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 67, 233, 200, 170, 137}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 31, 94, 12, 117, 130, 234}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 245}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 20, 2, 191, 20, 139, 236}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 203, 34, 185, 23, 134}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 106, 154, 245, 152, 10, 105, 28}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 125, 195, 167, 209, 54}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 23, 226, 154, 48}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 35}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 198, 134, 208, 19, 70, 118, 7}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 135, 17, 157, 87, 65}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 225, 221, 237, 250, 159}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 78, 0}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 145, 157, 214}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 189, 238, 6, 46, 139, 97}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 24, 109, 156, 118}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 81, 173, 80}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 159, 78, 183}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 124, 209, 255, 144, 39, 29}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 32, 90, 135}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 38, 66, 162, 15, 210, 211, 125}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 227, 124, 61, 228}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 63, 171, 166, 197, 40}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 64, 31, 109, 128, 196, 220, 128}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 102, 43, 186, 197, 97, 140, 61}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 21, 185, 169, 231, 89, 69, 78}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 128, 138, 12}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 121, 68, 108, 17, 32, 76, 217}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 222, 57, 149, 198, 48, 87, 150}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 0, 236}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 94, 103}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 155, 16, 160}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 249, 216, 197, 164, 6, 222, 201}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 110, 113, 72, 75, 138, 128, 197}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 15, 82, 220}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 19, 77, 95, 105, 123, 39, 188}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 0, 0, 169, 0}, 193},
	{{94, 189, 224, 200, 170, 11, 79, 172, 0, 0, 0, 0, 134, 64, 47, 228}, 193},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 122, 75, 124, 233, 20, 81, 93, 40}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 44, 74, 37, 151, 98, 145, 53, 173}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 150, 228, 107, 64, 165, 51, 40, 146, 236}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 146, 45, 217, 101, 37, 49}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 207, 40, 35, 175, 158, 231}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 231, 132, 83, 62, 216, 74, 77, 4}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 214, 142, 206, 72, 75, 174, 61, 191}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 156, 69, 105, 220, 203, 84, 19, 179}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 35, 107, 247, 145}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 206, 104, 45, 29}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 237, 16, 231, 241, 32, 123, 122}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 250, 66, 37, 82, 109, 40, 137, 56}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 6, 190, 240}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 223, 82, 214, 1, 156, 57, 30, 118, 194}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 64, 42, 98, 91, 154, 197, 134, 234, 46}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 246, 132, 39, 197, 125, 6}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 142, 107, 151, 171, 114, 112}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 125, 204, 22}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 48, 67, 49, 212, 119, 50, 7, 97}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 112, 175, 108, 209}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 227, 187, 16, 144, 100, 127}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 128, 49, 206, 202}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 141, 56, 244, 174, 155, 45, 252}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 134, 56, 247}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 229, 146, 186, 210, 23, 71, 235}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 125, 78, 194}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 82, 185, 47, 41, 143}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 215, 84, 134, 235, 44, 3, 159}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 238, 71, 228, 191, 77}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 132, 198}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 8, 197, 49, 22, 31, 9, 154, 5}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 224, 206, 98, 26, 2, 57}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 109, 110, 60, 139, 44}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 249, 234, 100, 93, 156, 72, 154, 9}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 135, 99, 143, 166, 21, 71, 18}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 198, 135, 119, 18, 125}, 231},
	{{236, 41, 169, 234, 14, 128, 191, 2, 117, 93, 169, 80, 95, 182, 134, 159}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 72, 158, 178, 41, 104}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 190, 25, 40, 254, 246, 134}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 30, 160, 199, 91, 217, 97}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 167, 254, 25, 166, 232, 202, 180}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 143, 175, 183, 196, 81, 104, 8}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 84, 196, 75, 243, 153, 56, 53, 59, 124}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 96, 187, 7, 76, 248, 129}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 42, 10, 231, 150, 110, 249, 161, 138, 131}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 101, 14, 22, 187, 127, 197, 89, 32, 184}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 16, 94, 220, 46, 242, 224, 175, 246, 22}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 17, 94, 17, 255, 109, 42, 186, 118}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 119, 31, 139, 89, 219, 63, 6, 184, 23}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 90, 160}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 99, 201}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 186, 242, 35, 76}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 90, 54, 137, 168, 75}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 131, 57, 179, 69, 172}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 30, 46, 191, 158, 71, 231, 181, 0}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 74, 50, 21}, 231},
	{{236, 41, 169, 234, 14, 128, 19, 5, 100, 29, 112, 121, 146, 90, 64, 243}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 253, 115, 76, 25, 91, 208, 5, 79}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 202, 23}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 197, 75, 225, 33, 22, 112}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 66, 42, 106, 140, 144, 148, 106}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 41, 143, 91}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 76, 198, 197, 149}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 119, 44, 93, 114}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 25, 125, 96, 250, 28}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 90, 48}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 190, 87, 251, 170, 136, 79, 61, 224}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 158, 28, 17, 225, 134}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 243, 67, 94, 250, 117, 213, 173}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 124, 175, 119, 163, 97, 191, 123, 213, 128}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 238, 163, 45, 95, 209}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 126, 232}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 154, 145, 239, 89, 167, 78}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 196, 154, 35}, 231},
	{{236, 41, 169, 234, 14, 128, 2, 157, 116, 244, 136, 115, 45, 156, 216, 32}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 24, 29, 43, 147, 115}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 2, 109}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 25, 78, 225, 24, 223}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 247, 95, 240, 12, 171, 72, 145}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 230, 130, 235, 78, 43, 11, 33, 2, 100}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 118, 87, 26, 251}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 81, 136, 113, 29, 183, 188, 181}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 20, 136, 84, 35, 45, 220}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 41, 174, 159, 212, 88, 141, 143, 132}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 66, 172, 104}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 226, 180, 16, 139, 120, 55}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 0, 42, 75}, 231},
	{{236, 41, 169, 234, 14, 128, 0, 0, 0, 0, 0, 0, 0, 141, 196, 101}, 231},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 247, 119, 232, 102}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 40, 233, 86, 116, 140, 139}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 42, 8, 4, 110, 159, 229, 253}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 248}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 231, 137, 138}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 100, 48, 108, 205, 53, 171, 107}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 102, 140, 123, 141, 164, 59, 196}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 56, 223, 58, 103, 243, 149}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 76, 107, 111, 33, 105, 214, 252}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 165, 229, 86}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 228, 87, 97, 81}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 129, 160}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 164, 107, 232, 122, 35, 86, 222}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 147, 254}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 138, 10, 16, 146}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 97, 223, 210, 52}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 169, 210, 72}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 192, 208, 195}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 142, 114, 155, 86, 69}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 35, 78, 187}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 174, 124, 43, 80, 211}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 178, 164, 250, 168}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 76, 19, 234, 145, 12}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 21, 138, 245, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 132, 229, 98, 121, 196}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 2, 174}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 233, 178, 96, 90, 12, 155, 230}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 37, 180, 84, 205}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 62, 146, 223, 148}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 233}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 41, 149, 137, 232, 114, 174, 18}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 95, 70, 147, 225}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 79, 249, 60, 5, 239}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 194, 149, 184}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 197, 73, 50, 37, 219}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 166, 99, 137, 52, 8}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 173}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 120, 39, 157, 150, 155, 248}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 140, 222}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 7, 149, 55}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 170, 218, 125, 127, 20}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 136, 80, 17}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 59}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 50, 151, 61, 86, 178}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 71}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 58, 70, 18, 45, 54, 212}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 225, 132, 158, 59}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 14, 210, 178}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 117, 170, 104, 58, 64, 211}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 171}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 98, 16, 39, 45}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 73, 186, 39, 175}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 212, 204}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 25, 147}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 203, 102, 250, 29, 155}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 51, 138, 163, 242}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 93, 206, 160, 165, 36}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 190, 84, 11, 81}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 72, 220}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 243, 58, 129, 15, 223}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 95, 195, 115, 13, 128, 23, 85}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 79, 82, 46, 175, 3, 233, 223}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 18}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 140}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 131, 162, 107, 92, 50}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 200, 152}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 36, 248, 110, 46}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 188, 156, 152, 73, 215, 163, 182}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 161, 228, 25, 2, 7}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 199, 160, 198, 150, 8, 12}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 129, 112, 2, 41, 191, 180}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 23, 92}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 9}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 237, 149}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 121, 30, 215}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 28}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 113, 23, 111}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 63, 52}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 159, 57, 174, 225, 197}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 47, 149, 67}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 0, 0, 0, 0, 0, 234}, 250},
	{{1, 40, 140, 95, 81, 173, 250, 248, 0, 0, 138, 199, 108, 66, 222, 101}, 250},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 187, 167, 126, 179}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 240, 222, 160}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 170, 183}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 116, 108, 245, 208}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 190, 182}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 96, 150, 246, 243}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 37, 227}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 163, 126, 117}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 153, 131}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 2}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 248, 97}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 136}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 123, 10, 94, 102, 187}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 81, 140, 123}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 174, 122, 207}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 22}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 235, 105, 7}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 51, 210, 81}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 223, 12, 68}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 197, 67, 28}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 176}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 103, 138, 134, 11}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 29, 130, 83}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 117, 43}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 58, 5, 127}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 219}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 108}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 43, 46, 53, 56, 201}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 57, 50}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 99}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 32, 251, 219}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 191}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 112, 253, 38}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 29, 201, 90, 145}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 100}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 36, 80, 203}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 54, 193, 1, 141, 214}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 104}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 104, 133, 81, 70}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 63}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 242, 14, 228, 118}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 246, 41, 149, 24, 249}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 17, 156, 89, 48, 34}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 27}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 202, 142, 147, 72}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 207}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 218}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 208, 247, 106}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 60, 69, 39}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 232, 125, 122, 222, 216}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 105, 86, 30}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 44, 51, 32}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 130, 112, 72, 206}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 97, 10}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 47, 176, 2}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 53, 126, 3}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 42, 32}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 157, 123, 22}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 175, 172, 205}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 43, 37}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 91, 176, 11, 181}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 53, 122, 147, 227}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 24}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 78, 220}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 4}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 165, 241, 63}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 206, 193, 28}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 154}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 77, 183}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 26, 100, 185}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 89, 51, 158, 184, 217}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 129, 159, 203}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 0, 0}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 0, 0, 229, 222}, 24},
	{{83, 176, 146, 112, 89, 156, 57, 220, 125, 48, 44, 0, 14, 239, 147, 2}, 24},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 94, 55, 101, 148, 218, 171, 43}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 151}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 123, 169, 200, 247, 174, 73, 89}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 119, 94, 42, 58, 44, 0}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 106, 181}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 241, 241, 110, 236, 83, 55}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 205, 137, 19, 159, 174}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 211, 162, 77}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 174, 93, 229}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 170, 207, 141, 243, 143, 50}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 70, 234, 144, 81}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 220, 156, 101, 150, 113}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 12, 99, 230, 150, 172, 163, 238}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 122, 164, 39, 169, 244, 160, 8, 12, 249}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 186, 14, 43, 171, 144, 181}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 199, 55, 123, 180, 28, 7, 92}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 102, 233, 237}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 179, 153}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 225, 37}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 158, 113, 78, 63, 180, 131, 25, 76}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 97, 241, 107, 154, 1, 171, 24, 39}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 2, 191, 9, 54}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 153, 152, 24, 15, 40}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 251, 12, 76, 56, 47, 246, 131}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 221, 212, 155, 144, 157}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 190, 80, 93, 183, 51, 126, 8, 72}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 16, 113}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 179, 252, 61, 143, 190, 140}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 16, 53, 148}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 251, 228}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 125, 193, 226}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 203, 234, 190, 11, 198, 228, 18}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 9, 60, 19, 102, 135, 225, 227, 157}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 35, 225, 66, 103}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 39, 76}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 39, 113, 227, 63, 48, 114, 212, 135}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 234}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 254, 146, 70, 37}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 100, 161, 28, 164, 163, 116, 78}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 40, 5, 178}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 97, 1, 221, 124, 75}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 137, 87, 90, 238}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 37, 10, 21}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 236}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 50, 18, 205, 170, 173, 209, 139}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 187, 241, 31, 18, 232, 238, 0}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 223, 195, 156, 51, 177, 9, 129}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 43, 203, 246, 221, 36, 149}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 153, 4, 17, 38, 144, 61}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 150, 5, 57, 247, 34, 252}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 86, 187, 23, 134, 218, 17}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 222, 76, 66, 247, 156}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 248, 163, 82, 9, 185, 59}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 197, 22, 169, 84}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 34, 45, 59, 193, 222, 4, 216, 23}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 201, 26}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 148}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 50, 77, 42, 0, 27}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 161, 106, 162, 40, 235, 86, 213}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 23, 90, 237, 172, 181}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 102, 91, 88, 160}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 228, 100, 174, 78, 45, 150}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 89}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 217, 155, 84, 212, 119}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 52, 202, 191, 195, 70, 52}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 235, 48, 187, 17}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 105, 11}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 245, 54}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 191, 189, 6, 170, 124, 97, 251, 220}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 45, 107, 125, 245, 29}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 88, 6, 78, 189, 162}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 171, 252, 253}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 123, 22, 244, 227, 192}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 39}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 213, 61}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 42, 222, 212, 104, 233}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 242, 43, 19, 122, 229, 102, 29, 152, 67}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 80, 85, 139, 70, 83, 102, 229, 229}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 69, 158, 243, 67, 236}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 176, 207, 80, 76}, 191},
	{{76, 125, 228, 249, 243, 160, 106, 0, 0, 0, 0, 0, 0, 26, 240, 7}, 191},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 85}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 102}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 171}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 208}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 171}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 49}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 239}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 195}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 39}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 204}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 22}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 215}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 99}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 36}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 213}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 153}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 129}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 96}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 134}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 132}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 4}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{10, 203, 204, 49, 212, 115, 125, 4, 239, 122, 81, 34, 1, 198, 216, 0}, 111},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 238}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 82}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 125}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 112}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 190}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 207}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 235}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 16}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 17}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 227}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 250}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 85}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 131}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 135, 134}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 159}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 218}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 194}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 162}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 119}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 39}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 161}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 129}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 149}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 100}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 69}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 175}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 80, 165}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 116}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 52}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 93}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 133}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 147}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 126}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 115, 149}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 246}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 175, 76}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 107}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 21}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 243}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 184}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 163}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 169}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 52}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 4}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 230}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 152}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 138}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 45}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 194}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 216}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 61}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{74, 214, 23, 44, 211, 40, 161, 61, 237, 190, 155, 59, 173, 42, 0, 0}, 205},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 214, 32, 147, 127, 196}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 121, 134, 244, 30, 247, 23}, 61},
	{{0, 0, 0, 0, 0, 173, 241, 237, 28, 138, 98, 52, 255, 184, 131, 2}, 61},
	{{0, 0, 0, 0, 0, 0, 208, 52, 194, 226, 62, 231, 12, 251, 181, 102}, 61},
	{{0, 218, 210, 5, 32, 204, 175, 200, 35, 15, 212, 240, 35, 207, 19, 94}, 61},
	{{0, 0, 0, 0, 0, 0, 1, 92, 52, 68, 238, 45, 247, 172, 80, 149}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 19, 117, 145, 255, 111, 84, 142, 37}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 209, 244, 19, 139, 227, 15, 142, 124, 9}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 86, 12, 83, 90, 176, 235}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 212, 254, 199, 240}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 125, 208}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 132, 179, 124, 138}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 105, 148, 74}, 61},
	{{0, 0, 0, 134, 129, 174, 213, 143, 199, 114, 177, 244, 186, 253, 96, 163}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 9, 84, 44, 69, 85, 194, 60, 100, 194, 11, 14}, 61},
	{{0, 0, 0, 0, 0, 70, 94, 72, 19, 219, 1, 181, 18, 150, 246, 254}, 61},
	{{0, 0, 0, 0, 39, 189, 148, 235, 76, 129, 228, 6, 49, 42, 21, 193}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 210, 106}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 185, 31, 205, 108, 144, 134, 72, 43, 83}, 61},
	{{0, 0, 114, 146, 151, 242, 44, 151, 91, 210, 16, 6, 25, 158, 241, 33}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223}, 61},
	{{0, 0, 0, 0, 0, 192, 73, 110, 204, 4, 134, 167, 42, 225, 203, 214}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 219, 164, 48, 149, 216, 47, 48, 21, 162}, 61},
	{{0, 0, 130, 52, 17, 163, 221, 39, 162, 79, 203, 107, 219, 163, 210, 156}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 21, 66, 127, 85, 79, 55, 124, 196}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 229, 57, 129, 123, 119}, 61},
	{{0, 10, 139, 44, 224, 12, 135, 125, 223, 170, 95, 224, 208, 207, 229, 47}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 199, 86, 111, 25, 8}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 60, 85}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 208, 27, 49}, 61},
	{{0, 0, 0, 149, 115, 187, 92, 18, 223, 49, 36, 199, 12, 77, 167, 198}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 160, 215, 68, 99, 155, 126, 103, 255, 38}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 135, 41}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 33, 162, 20, 133, 158}, 61},
	{{0, 0, 0, 0, 0, 56, 136, 244, 225, 40, 164, 242, 158, 99, 214, 193}, 61},
	{{0, 0, 0, 0, 28, 147, 208, 238, 164, 176, 181, 203, 185, 34, 115, 19}, 61},
	{{0, 0, 224, 115, 221, 149, 159, 197, 111, 178, 158, 136, 176, 16, 155, 84}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 52, 243, 73, 68, 125, 151, 229, 90}, 61},
	{{0, 0, 0, 0, 0, 239, 221, 27, 188, 100, 174, 183, 89, 36, 112, 157}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211}, 61},
	{{0, 0, 0, 0, 0, 0, 211, 154, 178, 67, 31, 79, 99, 223, 24, 164}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 117, 114, 58, 68, 41}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 47}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 61, 143}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 225, 159, 191, 80, 176, 219}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 139, 169, 118, 102}, 61},
	{{0, 0, 0, 0, 0, 0, 249, 217, 23, 253, 216, 217, 211, 44, 153, 250}, 61},
	{{0, 0, 138, 52, 133, 49, 150, 254, 39, 157, 127, 81, 199, 241, 50, 62}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 255, 166, 226, 214, 242, 186, 43, 184, 77}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 1, 117, 250, 216, 81}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 161, 213, 142, 90, 120}, 61},
	{{0, 0, 0, 0, 226, 193, 123, 15, 45, 20, 106, 235, 107, 98, 134, 9}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 227, 146}, 61},
	{{0, 0, 0, 0, 3, 225, 242, 143, 178, 29, 28, 44, 125, 101, 192, 39}, 61},
	{{0, 0, 0, 0, 92, 210, 83, 90, 62, 104, 88, 76, 183, 54, 60, 247}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 111, 177}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 79, 42, 65, 113, 15, 115}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 31, 142}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 171, 134, 80, 236, 137, 145}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 164, 108}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 78, 108, 9, 125}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 52}, 61},
	{{0, 0, 0, 0, 0, 0, 77, 127, 164, 172, 138, 222, 168, 38, 109, 94}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 61},
	{{0, 0, 0, 0, 159, 100, 175, 250, 115, 35, 45, 185, 166, 148, 105, 251}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 235, 30, 73, 215, 12}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 253, 96, 59, 213, 88, 118}, 61},
	{{0, 0, 0, 0, 0, 88, 137, 52, 17, 51, 107, 10, 117, 132, 218, 13}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 230, 255, 160, 18}, 61},
	{{0, 0, 42, 81, 229, 126, 141, 31, 115, 173, 156, 102, 44, 30, 69, 155}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 120, 107, 165, 242, 162}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 196}, 61},
	{{0, 0, 12, 152, 245, 8, 136, 131, 157, 171, 48, 237, 214, 210, 97, 211}, 61},
	{{0, 0, 0, 220, 129, 89, 11, 21, 63, 246, 52, 5, 248, 83, 196, 146}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 226, 183, 175, 185, 130, 120}, 61},
	{{0, 0, 0, 0, 0, 201, 160, 41, 145, 161, 245, 193, 162, 188, 243, 226}, 61},
	{{0, 0, 0, 0, 25, 237, 57, 182, 57, 123, 238, 255, 102, 105, 67, 37}, 61},
	{{0, 91, 66, 227, 225, 15, 156, 134, 137, 33, 6, 47, 49, 255, 103, 223}, 61},
	{{0, 0, 0, 94, 241, 73, 194, 145, 65, 86, 165, 149, 36, 168, 63, 204}, 61},
	{{0, 0, 117, 22, 6, 94, 7, 85, 245, 38, 247, 5, 233, 210, 7, 243}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 61},
	{{0, 180, 11, 165, 201, 190, 234, 114, 165, 9, 6, 125, 248, 55, 198, 171}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 200, 78, 1, 123}, 61},
	{{0, 239, 101, 98, 55, 248, 195, 157, 179, 105, 187, 30, 76, 75, 89, 70}, 61},
	{{0, 0, 0, 0, 178, 9, 239, 82, 0, 159, 1, 3, 157, 84, 125, 63}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 128, 3, 23, 155, 239, 24, 238, 6, 251}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 212, 54, 200, 217, 62, 71, 72, 116, 44}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 254, 50, 253}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 85, 240, 220, 47, 13}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 104, 239, 98, 248, 51, 165, 99, 187, 136}, 61},
	{{0, 0, 0, 0, 100, 12, 220, 6, 68, 58, 130, 155, 74, 21, 95, 238}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 158, 191}, 61},
	{{0, 0, 245, 217, 18, 218, 168, 168, 64, 181, 111, 254, 119, 126, 59, 98}, 61},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{127, 0, 130, 61, 209, 5, 232, 35, 35, 42, 114, 52, 169, 234, 191, 0}, 122},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 76, 88, 105}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 162, 235}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 33, 230, 219}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 46, 94, 30, 107}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 38}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 2, 220, 84}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 17, 110, 31, 147}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 144, 19, 171}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 252}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 36, 10, 92}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 137}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 202}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 235, 112}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 183}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 49, 78, 31}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 89, 2, 176, 165}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 196}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 121, 41}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 134}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 221, 248}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 66, 223}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 242, 0, 222, 112}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 2, 189}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 239, 157, 222, 217}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 1}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 215, 62, 102, 51}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 184, 168}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 231}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 228}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 114, 82, 129}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 93, 166}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 14, 249}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 243, 174, 181, 50}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 145, 66}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 106}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 113, 193}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 122, 98}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 89}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 209, 228, 220}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 199}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 198}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 177, 244, 99}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 157, 243, 24, 81}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 81}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 73, 155}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 200, 252, 102, 11}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 31, 124}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 249, 117, 83, 24}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 244, 143, 243}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 93}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 187, 18, 131, 81}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 210, 252, 103, 2}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 233, 245, 28, 11}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 168}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 228}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 159, 18}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 244, 42}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 204}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 93}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 34, 122, 247, 192}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 96, 249}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 103, 102, 41}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 74}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 127, 33}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 166, 186, 29}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 12, 145}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 239}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 109}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 12, 151, 81}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 47, 133, 98, 243}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 206, 112, 118}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 0}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 88, 190, 230}, 227},
	{{201, 107, 210, 13, 187, 62, 145, 28, 31, 189, 56, 0, 0, 0, 0, 179}, 227},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 106, 239, 63, 180, 93, 198, 38}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 162, 130}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 120, 106}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 199, 66, 151, 92, 16, 155, 225, 27}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 145, 98, 163, 63, 217, 43, 53}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 134, 13, 87, 188}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 234, 128, 243}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 15, 188, 146, 188, 139, 105}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 61, 232, 87, 140, 191, 145, 178}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 147, 79, 201, 110, 45, 206, 128}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 222, 203, 24, 75, 174, 144, 99, 103, 21}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 27, 120, 122, 88, 128, 56, 245}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 145, 207, 241}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 251, 228, 198}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 85, 235, 9, 246, 252}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 189, 134, 66, 208}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 162, 100}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 9, 98, 194, 123, 63, 208}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 55, 149, 121, 8, 20}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 223, 162, 89}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 156, 24, 76, 238, 133}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 59, 27, 0, 172, 165, 225, 48}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 177, 73, 55}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 155, 35}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 180, 44}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 115, 148, 157, 182, 45, 37, 33, 207, 201}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 171, 194, 129, 21, 238, 176, 64, 92}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 44, 29, 66, 147, 157, 181, 99, 175}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 234, 190, 74, 72, 203, 241}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 252, 95, 38, 206}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 241, 239, 127}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 197, 229, 139, 21, 202}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 248, 119, 107, 65, 99, 204, 143, 65}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 74, 60, 168, 178, 239, 252, 144, 44}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 85, 5, 34, 25, 148, 150, 167}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 48, 58, 226, 35, 124, 221, 225, 223, 87}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 184, 176, 17, 140}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 78, 124, 10, 66, 63, 223, 212}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 43, 56, 181, 28, 240, 0, 39}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 49, 23}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 143, 139, 18, 176}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 148, 120, 242, 153, 56, 255, 241}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 57, 118, 108, 103, 185}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 82, 249, 253, 39, 172, 105, 27, 71}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 207, 219, 200, 142, 223, 216, 205}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 52, 189, 31, 1}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 224, 91}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 140, 19, 234, 116}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 154, 15, 12, 99, 77, 140, 237}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 254, 40, 16, 111, 161, 46, 160, 11}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 110, 214, 128, 200, 137}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 131, 100, 149}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 214, 241, 78, 227, 27, 212, 144}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 93, 87, 1, 74, 95, 133}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 117, 206, 49, 83, 251, 26}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 118, 189, 82, 187, 7, 170, 159}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 44, 22, 212, 27, 208, 224}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 189, 171}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 224, 162, 106, 214, 68, 163, 23, 190, 43}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 128, 44, 31, 91, 165, 95}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 190, 158, 148, 8}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 56, 172, 13, 92}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 242, 111, 30, 148, 254}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 151, 15, 200, 118, 203, 207, 163, 230}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 247, 150}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 77, 154}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 189, 171, 85, 232}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 70, 45, 164, 15, 25, 194, 205, 238}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 8, 76, 56, 64, 193, 43, 157, 51}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 63, 118, 138, 59, 215, 174, 174}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 231, 176, 42, 8, 54, 225}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 33, 162, 87, 112, 213, 194, 5}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 119, 23, 189}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 211, 120, 136, 241}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 125, 92, 215, 89, 204, 194}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 30, 138, 66, 12, 176, 148, 23, 193}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 212, 213}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 53, 211, 49, 184}, 53},
	{{147, 171, 63, 145, 47, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 53},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 92}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 14}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 228, 135, 166}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 85, 222, 249, 179}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 91, 21}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 233, 0, 161, 143, 41}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 112}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 239, 31, 186, 179}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 19, 230, 21, 51}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 22, 232, 22, 99, 143}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 215, 127, 198, 146, 146}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 75, 163, 150, 168, 43}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 105, 213, 48, 91, 137}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 131}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 69, 157, 112, 55, 115, 196}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 137, 94, 15}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 201, 183, 90, 6, 200}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 33, 165, 91, 245}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 209, 89, 4, 9, 200, 51}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 192, 255, 115}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 197, 186, 27, 19, 60, 119}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 51, 115, 137, 6, 125}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 12, 9, 65, 76, 119, 25}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 117, 46, 241, 26, 203}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 143, 195}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 1, 192}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 45, 231}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 49, 219, 35, 124, 147, 187}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 32, 10, 187, 200, 252}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 59, 102, 146, 86, 87, 70}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 7}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 126}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 196, 22, 194}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 15, 18}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 82, 19, 212, 215}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 96, 156, 126, 117, 186, 241}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 189, 43, 50, 74, 60}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 5, 2, 215}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 171, 2}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 23, 5, 169, 85}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 44, 80, 206, 137, 74, 240}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 154, 212, 202, 90}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 170, 14}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 223, 12}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 133, 185, 43, 16, 251}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 157, 130, 35, 101, 119}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 77}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 198, 126}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 29, 201}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 167}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 196, 180, 41, 208, 236}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 217, 175, 214, 190, 182, 113}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 28, 145, 238, 40}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 168, 127, 30}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 44, 143, 126}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 226}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 133, 229, 182, 69, 220, 237}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 84}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 122}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 217}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 24, 228, 125}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 114, 185, 208, 109}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 17}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 83}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 22, 147, 7, 222}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 241, 43, 225, 86}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 4, 215, 55}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 227, 158, 35}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 190, 35}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 89, 219, 146, 157, 2, 78}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 52, 123, 2, 40, 67}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 125, 94, 242, 136, 78}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 224, 212, 42, 105, 253, 232}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 34}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 175, 241, 142, 61}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 109, 254, 244, 62, 194}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 236, 26}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 172}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 229, 36, 52}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 215, 174}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 109, 91, 141, 249}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 224, 152, 147, 162, 30}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 220, 119, 23, 236, 32, 142}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 50, 91, 132, 50}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 85, 97, 169, 133}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 122}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 191, 117, 138, 180, 178}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 0, 249}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 105, 9, 222, 238, 186, 172}, 224},
	{{93, 232, 10, 97, 21, 243, 213, 135, 200, 0, 0, 0, 0, 0, 190, 117}, 224},
	{{144, 121, 41, 64, 0, 97, 217, 212, 135, 55, 12, 91, 147, 253, 123, 227}, 199},
	{{144, 121, 41, 64, 0, 0, 245, 219, 186, 48, 151, 27, 238, 165, 169, 161}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 161}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 85}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 115, 98, 72, 81, 213, 22, 202}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 76, 15, 238, 175, 228, 222, 225}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 98, 45, 74, 120, 175, 130}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 253, 48, 157, 155, 131, 72}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 12, 231, 162, 192, 202, 0, 250, 190, 120}, 199},
	{{144, 121, 41, 64, 0, 17, 183, 100, 151, 225, 3, 160, 192, 152, 73, 184}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 33, 180}, 199},
	{{144, 121, 41, 64, 0, 0, 198, 230, 49, 250, 232, 22, 207, 69, 122, 114}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 236, 131, 57, 255, 5}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 48, 148}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 63, 193}, 199},
	{{144, 121, 41, 64, 0, 0, 113, 146, 31, 38, 243, 61, 39, 7, 63, 165}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 130, 32, 120, 238, 246, 31, 53, 12}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 127, 110, 176, 12, 156, 249, 187, 185, 69}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 115, 21, 227, 51, 149}, 199},
	{{144, 121, 41, 64, 0, 0, 229, 29, 172, 36, 197, 13, 203, 237, 177, 14}, 199},
	{{144, 121, 41, 64, 0, 179, 62, 102, 212, 28, 43, 233, 83, 197, 80, 153}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 155, 243, 224, 116, 113, 137, 68}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 50, 52, 106, 36, 16, 20, 204, 174}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 165, 89, 146, 205, 161, 227}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 236, 246, 26, 5, 186}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 230, 151, 208, 73}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 49, 129}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 19, 204, 55, 148, 2, 20, 51}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 206, 41, 74, 22, 49, 43, 165}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 140, 52, 41, 212, 205, 106, 148}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 227, 200}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 123, 12, 70, 85, 65, 174}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 40, 239, 148, 195, 218}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 117, 24, 232, 167, 151, 222, 146, 213}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 121, 25, 164, 214}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89}, 199},
	{{144, 121, 41, 64, 0, 0, 4, 95, 94, 159, 163, 139, 45, 94, 50, 12}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 247, 41}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 117, 72, 186, 53}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{144, 121, 41, 64, 0, 0, 15, 200, 194, 82, 207, 110, 182, 95, 116, 153}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 195, 9, 50, 227, 141, 117, 82, 2, 236}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 255, 130, 125, 108, 133, 169}, 199},
	{{144, 121, 41, 64, 239, 39, 120, 212, 174, 11, 199, 37, 243, 42, 184, 187}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 17, 19}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 81, 247, 66, 164, 235}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 175}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{144, 121, 41, 64, 184, 89, 236, 243, 251, 13, 49, 136, 246, 162, 140, 72}, 199},
	{{144, 121, 41, 64, 0, 0, 192, 84, 30, 113, 119, 205, 162, 88, 88, 226}, 199},
	{{144, 121, 41, 64, 0, 0, 49, 239, 237, 233, 108, 240, 64, 148, 133, 152}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 42, 70, 17, 229, 196, 126, 212}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 66, 162, 53, 153, 148, 127, 227, 111}, 199},
	{{144, 121, 41, 64, 0, 0, 243, 206, 135, 135, 195, 37, 186, 212, 75, 100}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 18, 188}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 20}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 60, 4, 214, 213}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{144, 121, 41, 64, 0, 45, 52, 173, 169, 209, 106, 123, 121, 123, 150, 61}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 77, 87, 213, 174, 165, 187}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 227}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 51, 27, 58, 135, 217, 133, 31}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 129, 123, 140, 193, 185, 77, 45, 125}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 29, 15, 249, 236, 13}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 58, 155, 197, 200, 90, 180, 23}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 116, 180, 60, 202, 88, 9}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 248, 158, 5, 254, 51, 243, 246, 31}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 123}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 170, 221, 122, 187, 48, 95}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 156, 250, 10, 79, 179, 128}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 165}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 27, 11, 74, 94, 48, 154, 49}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 212, 62, 158, 46, 134, 202, 120, 91}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 7, 247, 19, 38, 46}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 191, 7, 142, 106, 84, 218}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 9, 252, 159, 205, 185, 171, 65}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 120, 64, 50, 184, 170, 156}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 1, 234, 93, 77, 105, 207, 208, 97}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 212}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 190, 27, 68, 186, 132}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 220, 212, 145, 67, 206, 144}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 201, 110, 54, 183, 37, 88, 103, 253}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 62, 253, 181, 6}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 39, 110}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 129, 212, 213, 107, 196, 214, 106, 64, 100}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 0, 0, 0, 98, 169, 124, 87, 124}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 0, 175, 65, 145, 140, 59, 93, 68, 247}, 199},
	{{144, 121, 41, 64, 0, 0, 0, 174, 61, 30, 188, 27, 35, 231, 217, 131}, 199},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 109}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 184, 231, 197, 168, 33, 250}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 181, 166, 38}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 111, 10, 227, 108, 147, 12}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 54, 124, 217, 134, 94, 246, 203, 198, 136}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 133, 22}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 40, 188, 151}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 207, 164, 245, 24, 135, 184, 231, 216, 18}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 3, 16, 195, 131, 80, 141, 234, 238, 155}, 79},
	{{116, 105, 128, 0, 0, 173, 168, 201, 131, 110, 198, 163, 87, 190, 36, 34}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 188, 174, 46, 97, 38, 187, 11, 64, 4}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 253, 121, 167, 163, 185, 84, 215}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 49}, 79},
	{{116, 105, 128, 0, 140, 6, 220, 112, 140, 15, 45, 247, 138, 178, 46, 156}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 168, 0, 248, 160, 86, 2}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 22, 49, 126, 62, 97}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 102, 89}, 79},
	{{116, 105, 128, 48, 136, 103, 132, 212, 37, 215, 186, 30, 109, 52, 54, 177}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 2, 18, 89, 228, 200, 64, 170, 139, 71}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 155, 75, 9, 122, 139, 24, 148, 235, 19}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 239, 132, 66}, 79},
	{{116, 105, 128, 191, 89, 228, 46, 210, 66, 250, 28, 34, 29, 206, 188, 33}, 79},
	{{116, 105, 128, 0, 0, 0, 121, 101, 172, 108, 161, 24, 92, 35, 133, 104}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 32, 31, 125, 26, 33, 240}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 53, 114, 223, 248, 191, 70, 205}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 133, 12, 138, 79, 137, 12}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 194, 45, 110, 237, 83, 241, 247, 254}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 183, 47, 198, 77, 150, 226, 109, 94}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 217, 85, 225, 13, 208, 98, 225, 227}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 79},
	{{116, 105, 128, 0, 0, 135, 58, 146, 169, 33, 52, 152, 122, 104, 163, 48}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 73, 137, 139}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 51, 133, 197, 201, 147, 157, 234}, 79},
	{{116, 105, 128, 0, 0, 0, 214, 85, 157, 145, 224, 31, 245, 253, 188, 239}, 79},
	{{116, 105, 128, 0, 0, 167, 89, 249, 143, 80, 236, 70, 152, 247, 133, 183}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 181}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 219, 113}, 79},
	{{116, 105, 128, 0, 244, 167, 127, 146, 39, 208, 103, 99, 38, 232, 20, 17}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 11, 77, 184}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 81}, 79},
	{{116, 105, 128, 0, 34, 71, 81, 200, 37, 152, 26, 128, 237, 30, 51, 128}, 79},
	{{116, 105, 128, 0, 70, 67, 216, 111, 182, 129, 248, 208, 34, 215, 241, 189}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 242, 211, 82, 66, 20}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 38}, 79},
	{{116, 105, 128, 0, 0, 218, 208, 227, 180, 137, 213, 174, 66, 208, 255, 9}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 91, 163, 189, 40, 139, 160, 156, 81}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 92, 41, 251, 150, 192, 123, 138, 136}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 61, 81, 10, 239, 155, 156, 152}, 79},
	{{116, 105, 128, 0, 0, 0, 91, 18, 160, 245, 196, 121, 191, 46, 166, 251}, 79},
	{{116, 105, 128, 87, 167, 107, 125, 192, 14, 101, 50, 89, 144, 250, 180, 151}, 79},
	{{116, 105, 128, 111, 169, 119, 32, 82, 31, 65, 197, 49, 237, 27, 64, 207}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 1, 141, 188, 44, 147, 177, 184}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 47, 193, 72, 226, 96, 72}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 58}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 57, 190, 90}, 79},
	{{116, 105, 128, 211, 23, 57, 193, 195, 171, 127, 44, 126, 127, 142, 189, 221}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 148}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 253}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 127}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 77, 157, 149, 221, 31, 45, 10, 52, 37}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 126, 224, 121, 206, 170, 25, 208, 6, 23}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 92, 166, 158, 229, 27, 46, 212, 18, 230}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{116, 105, 128, 174, 132, 43, 165, 96, 82, 190, 100, 189, 132, 150, 194, 206}, 79},
	{{116, 105, 128, 0, 0, 0, 12, 11, 251, 124, 201, 143, 56, 100, 17, 204}, 79},
	{{116, 105, 128, 0, 0, 106, 150, 13, 117, 226, 57, 192, 99, 61, 49, 5}, 79},
	{{116, 105, 128, 0, 0, 160, 77, 85, 221, 130, 174, 104, 132, 162, 216, 48}, 79},
	{{116, 105, 128, 0, 0, 104, 19, 200, 91, 229, 24, 183, 111, 119, 254, 100}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 102, 57, 99, 101, 122, 57, 64}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 96, 230, 209, 232, 35, 245, 6}, 79},
	{{116, 105, 128, 0, 254, 28, 102, 22, 130, 13, 2, 232, 175, 4, 89, 59}, 79},
	{{116, 105, 128, 0, 0, 125, 53, 100, 83, 16, 18, 115, 66, 243, 173, 12}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 237}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 101, 87, 200, 122, 209, 56, 228, 169}, 79},
	{{116, 105, 128, 0, 103, 232, 222, 112, 86, 42, 43, 212, 105, 29, 248, 78}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 56, 42, 124, 132, 115}, 79},
	{{116, 105, 128, 0, 0, 0, 49, 72, 115, 117, 34, 113, 238, 201, 194, 29}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 141, 127, 80, 221, 151, 18, 38, 140, 181}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 122, 142, 254, 85, 31, 12, 39, 129}, 79},
	{{116, 105, 128, 0, 0, 0, 153, 149, 164, 241, 124, 120, 179, 168, 217, 195}, 79},
	{{116, 105, 128, 0, 0, 0, 25, 245, 73, 143, 171, 185, 112, 249, 11, 214}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 31}, 79},
	{{116, 105, 128, 138, 249, 206, 66, 202, 40, 7, 51, 241, 64, 204, 72, 226}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 252, 75, 16, 112, 250}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 5, 48, 191}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 50, 199, 207, 84, 199}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 181, 48, 39}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 63, 89, 82, 158, 0, 88}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 159, 166, 182, 14, 197, 8, 30, 3, 122}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 76, 192, 35, 123, 119, 30, 127, 54}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218}, 79},
	{{116, 105, 128, 0, 237, 145, 204, 118, 163, 83, 180, 87, 195, 48, 6, 102}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 79, 52, 35, 118, 28, 176, 55}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 206, 225, 167, 77, 122, 229, 115, 253}, 79},
	{{116, 105, 128, 0, 0, 0, 0, 0, 0, 0, 40, 14, 129, 228, 30, 242}, 79},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 66, 84, 107}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 34, 5, 214}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 22, 84}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 47, 128, 85, 220, 135}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 162, 45}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 20}, 19},
	{{142, 149, 24, 0, 0, 0, 204, 173, 216, 43, 242, 254, 192, 156, 252, 149}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 195, 145, 144, 17, 176, 130, 32, 197}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 233, 184, 227, 170, 213, 143, 36, 153, 71}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 117, 182, 240, 126, 184, 69, 116, 201, 28}, 19},
	{{142, 149, 24, 0, 0, 0, 147, 67, 50, 235, 226, 113, 126, 125, 131, 6}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 124, 123}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 167}, 19},
	{{142, 149, 24, 0, 0, 92, 213, 181, 180, 33, 4, 3, 73, 230, 227, 84}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 224, 11, 53}, 19},
	{{142, 149, 24, 0, 50, 66, 71, 210, 79, 83, 191, 5, 17, 222, 216, 99}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 250, 28, 27, 78, 15}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 150, 144, 36}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 79, 93, 146}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 97, 92, 101, 91, 207, 224, 46}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 182, 245, 161, 51, 227, 120, 118, 26}, 19},
	{{142, 149, 24, 0, 0, 0, 85, 178, 26, 21, 199, 171, 226, 103, 53, 156}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 19},
	{{142, 149, 24, 0, 0, 0, 142, 190, 107, 192, 145, 198, 139, 31, 88, 116}, 19},
	{{142, 149, 24, 0, 87, 202, 19, 11, 12, 120, 79, 229, 20, 138, 158, 3}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 150, 103}, 19},
	{{142, 149, 24, 0, 0, 0, 74, 159, 45, 197, 82, 254, 204, 24, 247, 129}, 19},
	{{142, 149, 24, 0, 0, 218, 2, 228, 215, 33, 109, 164, 211, 74, 125, 196}, 19},
	{{142, 149, 24, 0, 0, 97, 32, 207, 233, 20, 154, 204, 136, 49, 196, 175}, 19},
	{{142, 149, 24, 0, 0, 0, 173, 79, 42, 232, 244, 16, 1, 217, 242, 80}, 19},
	{{142, 149, 24, 0, 0, 221, 136, 230, 255, 169, 147, 144, 205, 97, 9, 16}, 19},
	{{142, 149, 24, 0, 14, 60, 64, 214, 118, 62, 13, 168, 163, 49, 143, 180}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 56, 68, 65, 171, 175, 212, 21, 77}, 19},
	{{142, 149, 24, 0, 0, 203, 225, 177, 131, 100, 162, 25, 86, 244, 10, 180}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{142, 149, 24, 0, 0, 0, 118, 177, 168, 106, 6, 201, 122, 240, 122, 48}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 81, 80, 173}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 184, 72}, 19},
	{{142, 149, 24, 0, 0, 0, 62, 31, 226, 23, 47, 76, 113, 11, 145, 187}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 150}, 19},
	{{142, 149, 24, 161, 251, 194, 223, 183, 153, 49, 170, 143, 182, 76, 86, 98}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 116, 107, 79, 189, 202, 154, 184, 215}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 153, 228, 244, 204, 250, 244, 4}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 106, 13, 154, 177, 254, 173, 236}, 19},
	{{142, 149, 24, 0, 181, 170, 99, 122, 242, 25, 67, 7, 41, 52, 42, 112}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 21, 17, 107, 81, 98, 232, 65, 70, 99}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 11}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 9, 112, 67}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 221, 219, 182}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 107, 6, 40, 236, 68, 176, 221, 127}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{142, 149, 24, 0, 0, 68, 130, 84, 2, 198, 19, 164, 12, 87, 215, 237}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 129, 191, 143, 198, 178}, 19},
	{{142, 149, 24, 0, 0, 231, 28, 90, 24, 2, 27, 208, 94, 219, 37, 252}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 6, 212}, 19},
	{{142, 149, 24, 0, 150, 234, 114, 236, 207, 223, 19, 186, 5, 182, 83, 186}, 19},
	{{142, 149, 24, 0, 0, 12, 238, 0, 29, 189, 84, 112, 141, 190, 176, 217}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 238, 220, 50, 34, 110, 173, 214}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 207, 205, 4, 61, 88, 75, 192, 93}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 8, 193, 101, 34, 115, 151, 198, 113}, 19},
	{{142, 149, 24, 0, 0, 112, 207, 255, 115, 112, 40, 166, 105, 72, 160, 60}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 32, 219, 234, 255, 46, 148, 4}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 59, 1, 209, 174, 250}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 153, 148, 241, 242, 7}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 106, 45}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 1, 14, 10, 225, 40, 158, 115, 232, 29}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 141, 246, 127, 57, 163}, 19},
	{{142, 149, 24, 0, 59, 197, 99, 37, 194, 201, 202, 124, 81, 153, 73, 3}, 19},
	{{142, 149, 24, 0, 0, 207, 223, 104, 44, 5, 254, 76, 14, 77, 234, 121}, 19},
	{{142, 149, 24, 0, 0, 43, 78, 68, 241, 103, 220, 72, 151, 32, 90, 69}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 216, 16, 162, 1, 113, 163, 62, 128, 179}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 90, 140, 113}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 108, 50, 168, 181, 10}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 79, 2, 21, 84, 216, 25}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 29, 18, 78, 160, 249, 53}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 57, 137, 197, 202, 99, 18, 118, 244}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 177, 94, 87, 169, 255, 195, 48, 199}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 86, 128, 123, 225, 111, 231, 191, 235, 156}, 19},
	{{142, 149, 24, 0, 146, 143, 227, 6, 198, 194, 3, 171, 89, 245, 158, 62}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 30, 36, 106, 45, 15, 58, 101, 47, 84}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 202, 116, 254, 115, 192, 145, 169}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 60, 248, 25, 191, 239}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 178, 80, 67, 119, 216, 89}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 178}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 226}, 19},
	{{142, 149, 24, 147, 99, 239, 230, 152, 189, 135, 108, 224, 4, 146, 66, 36}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 34, 193, 226, 40, 0, 110, 104}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 0, 17, 97, 64, 211, 18, 255}, 19},
	{{142, 149, 24, 0, 0, 0, 0, 0, 0, 152, 214, 51, 32, 131, 26, 254}, 19},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 87, 156, 137}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 154, 184}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 234, 194, 205}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 7, 42, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 135, 41, 54}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 1, 230, 231}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 148}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 174, 50}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 67, 56}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 68, 48}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 17, 27, 174}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 178, 42}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 147, 47, 4}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 17, 71}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 55}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 78, 115}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 114}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 187, 118}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 11, 63, 106}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 63, 69}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 203, 8, 110}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 73, 175}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 192}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 188, 134, 117}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 141}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 67, 223, 209}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 79, 96, 132}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 68}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 157, 121}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 103}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 145}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 229, 119}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 141, 124, 211}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 159}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 96, 147, 160}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 55, 205}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 159, 29}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 60, 36}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 95}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 177}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 174, 39}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 255}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 35, 77}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 177}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 46}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 81, 98}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 40, 239}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 183, 167, 61}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 148, 132}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 41, 198, 179}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 226, 13}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 1, 175}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 74, 71}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 54, 150, 36}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 20, 133, 14}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 62, 14}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 160, 207}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 37}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 121, 180, 23}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 160}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 213}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 101, 177}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 97, 123, 106}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 218, 79, 210}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 241, 86, 46}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 39}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 185}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 151}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 65}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 121}, 211},
	{{97, 0, 228, 158, 50, 233, 251, 249, 0, 66, 197, 226, 0, 0, 0, 0}, 211},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{114, 228, 199, 155, 175, 104, 26, 213, 66, 249, 120, 218, 164, 252, 212, 0}, 6},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{224, 166, 76, 200, 121, 60, 110, 65, 60, 95, 137, 190, 92, 218, 218, 0}, 143},
	{{139, 219, 92, 224, 0, 0, 0, 11, 9, 223, 26, 195, 115, 186, 59, 133}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 93, 182, 61, 28, 206}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 222, 133, 237, 107, 242}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 88, 213, 112, 59, 45, 77, 133, 211, 112}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 198, 164, 98, 42}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 121, 193, 34, 165, 190, 25, 201, 137}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 21}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 96, 214}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 81, 170, 217, 127, 80, 140, 104}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 146, 65, 225, 38}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 240, 145, 253, 179, 112, 211}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 33}, 135},
	{{139, 219, 92, 224, 0, 0, 136, 248, 120, 17, 164, 47, 240, 8, 53, 193}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 79, 174, 190, 127, 72, 54}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 243, 152, 106, 241, 20}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 135},
	{{139, 219, 92, 224, 0, 79, 133, 126, 221, 69, 63, 184, 168, 45, 4, 80}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 227}, 135},
	{{139, 219, 92, 224, 0, 91, 78, 190, 190, 13, 17, 74, 3, 203, 172, 7}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 203, 194, 127, 252}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 230, 97, 43, 168, 150, 208, 45}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 210, 18, 100, 247}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 45, 0, 164, 240, 163, 225}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 72, 55, 85, 68, 239}, 135},
	{{139, 219, 92, 224, 0, 159, 86, 206, 193, 1, 198, 111, 12, 18, 178, 153}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 140, 92, 164, 150, 47, 211, 135, 171, 198}, 135},
	{{139, 219, 92, 224, 0, 105, 210, 114, 83, 158, 144, 216, 10, 109, 190, 36}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 232, 210}, 135},
	{{139, 219, 92, 224, 0, 19, 135, 108, 50, 137, 203, 109, 153, 174, 98, 169}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 79, 76, 111, 12, 71, 89, 75, 152, 203}, 135},
	{{139, 219, 92, 224, 0, 8, 131, 194, 99, 64, 61, 68, 15, 219, 37, 242}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 105, 255, 246, 253, 118, 217, 133, 122}, 135},
	{{139, 219, 92, 224, 0, 0, 185, 44, 104, 89, 232, 7, 117, 30, 68, 147}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 179, 149}, 135},
	{{139, 219, 92, 224, 0, 0, 194, 147, 50, 148, 18, 184, 192, 79, 130, 160}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 250, 32, 125, 180, 168}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 92, 214, 6, 228, 112}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 155, 243, 254, 145}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 102, 249, 7, 227, 223, 221, 144, 41, 210}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 17, 160, 116, 147, 210, 150, 45, 129, 162}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 175, 73, 191, 72, 230, 34, 92}, 135},
	{{139, 219, 92, 224, 0, 88, 187, 76, 136, 38, 77, 0, 232, 114, 28, 228}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{139, 219, 92, 224, 0, 65, 96, 21, 64, 73, 93, 146, 23, 53, 40, 1}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 130, 79, 169, 191, 138, 234, 38, 3, 216}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 98, 155, 110, 6, 26, 4, 49}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 144}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 104, 243}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 214, 36, 99, 65}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 212, 106, 48, 60, 122, 58}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 90, 22, 171, 49, 150, 149, 147}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 84, 212, 50, 171, 84, 35, 245, 138, 250}, 135},
	{{139, 219, 92, 224, 0, 132, 127, 92, 11, 157, 148, 30, 11, 194, 251, 6}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 43, 222, 39, 82, 83, 159, 203}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 163, 123, 215, 94, 29, 124}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{139, 219, 92, 224, 0, 0, 53, 180, 133, 48, 208, 47, 97, 159, 240, 100}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 7, 32, 174, 23, 23, 75, 172, 228}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 3}, 135},
	{{139, 219, 92, 224, 0, 0, 77, 37, 238, 14, 245, 112, 99, 241, 158, 166}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 5, 126}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 4, 150, 250, 76, 145, 92, 33}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 187, 26, 161, 26, 67, 117, 248, 1, 116}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 124, 32, 163, 37, 155, 177, 238}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 163, 114, 109, 85, 73, 228}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 71, 152, 36, 235, 238, 14, 247}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 151, 102}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 156, 125, 206, 26, 135, 200}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 224, 224, 16, 29, 49, 132}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 197, 169, 253, 207}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 49, 201, 189, 246}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 138, 26}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212}, 135},
	{{139, 219, 92, 224, 116, 14, 253, 130, 147, 159, 247, 128, 137, 167, 253, 95}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 206, 250, 84, 52, 56}, 135},
	{{139, 219, 92, 224, 0, 208, 2, 180, 161, 159, 254, 93, 16, 97, 26, 250}, 135},
	{{139, 219, 92, 224, 0, 0, 232, 124, 235, 250, 245, 66, 79, 118, 68, 234}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 60, 5, 33, 117, 65, 138}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 92, 2, 20, 21, 84, 104, 54, 151}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 150, 210, 228, 216, 55, 201, 249, 145}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 237, 30, 192, 94, 38, 62, 53, 254, 207}, 135},
	{{139, 219, 92, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 101}, 135},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 53, 206}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 115}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 236, 131}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 221}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 167}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 110}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 231, 247}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 88}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 83, 183}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 99}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 138}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 134, 49}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 226}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 139}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 179, 54}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 120}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 213, 153}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 63, 34}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 186}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 156}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 79, 186}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 98, 204}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 126}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 179}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 11}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 217}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 38}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 249}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 119, 93}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 166}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 249, 241}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 34}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 149}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 44, 86}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 131}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 71}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 218}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 220}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 225, 106}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 96, 137}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 167}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 111}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 15}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 92, 62}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 106}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 169, 223}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 1}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 233}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 123}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 187}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 195}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 68}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 156, 207}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 92}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 52}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 223}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 93}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 253, 81}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 159}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{203, 237, 64, 189, 28, 13, 75, 197, 219, 243, 172, 3, 142, 32, 0, 0}, 21},
	{{237, 186, 88, 254, 124, 0, 0, 0, 234, 109, 226, 180, 17, 42, 163, 95}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 89}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 215, 103, 145, 40, 80}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 80}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 101}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 101}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 241, 53, 68, 167, 184, 197}, 220},
	{{237, 186, 88, 254, 124, 0, 222, 164, 176, 80, 215, 244, 89, 53, 110, 173}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 59, 11, 78, 145, 171, 151, 111}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 21, 129, 90, 10, 64, 147, 248}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 152, 248, 213, 254}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 238, 52, 181, 250, 246, 153, 88}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 179, 186, 134, 64}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 71, 107, 147, 209, 229, 200}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 12, 31, 154, 72, 249}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 132}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 160, 179, 130, 109}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 189, 141, 181, 114, 233, 186, 249}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 14, 148, 246, 112}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 249, 56, 177, 8}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155}, 220},
	{{237, 186, 88, 254, 124, 0, 164, 11, 119, 215, 41, 96, 200, 61, 51, 93}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 225, 38, 2, 151, 2, 240, 145, 107, 68}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 73}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 146, 183, 170}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 67, 20, 136}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 82, 199, 76, 190, 19, 57, 35}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 112, 137, 120, 215}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 146, 167, 168}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 178, 119, 222, 61}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 49, 63, 252, 254, 184}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 231, 233, 209}, 220},
	{{237, 186, 88, 254, 124, 25, 157, 128, 215, 64, 199, 200, 129, 134, 177, 163}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 12, 248, 220, 134, 231, 66}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 81, 46, 165}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 181, 234, 148, 210, 172, 243, 183, 197, 67}, 220},
	{{237, 186, 88, 254, 124, 0, 214, 253, 96, 112, 85, 169, 167, 185, 74, 228}, 220},
	{{237, 186, 88, 254, 124, 0, 202, 169, 32, 164, 9, 144, 173, 158, 111, 42}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 116, 68, 116}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 9, 21, 184, 162, 205, 236, 25, 251}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 52, 189, 205, 36, 233, 103}, 220},
	{{237, 186, 88, 254, 124, 0, 63, 6, 87, 50, 247, 93, 189, 161, 43, 170}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 93, 182, 198, 190, 58, 244, 177, 168, 243}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 108, 165, 168}, 220},
	{{237, 186, 88, 254, 124, 0, 182, 142, 72, 13, 79, 220, 167, 239, 189, 241}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{237, 186, 88, 254, 124, 0, 254, 187, 123, 171, 2, 8, 235, 85, 134, 243}, 220},
	{{237, 186, 88, 254, 124, 0, 27, 233, 61, 128, 136, 228, 17, 105, 236, 108}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 246, 101, 193, 53, 90, 28}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 28, 237, 11, 24, 255, 34, 79, 252, 92}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 141, 33, 71, 90}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 245, 252, 182, 21}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 55, 129, 172, 189, 163, 56, 197, 119}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 52, 166, 46, 35, 31, 193, 9, 0, 101}, 220},
	{{237, 186, 88, 254, 124, 0, 136, 248, 33, 131, 40, 64, 48, 90, 89, 147}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 103, 235, 13, 146, 18, 233, 39}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 32}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 63, 22, 98, 74, 156, 128, 207, 120}, 220},
	{{237, 186, 88, 254, 124, 0, 72, 39, 215, 101, 238, 222, 88, 225, 80, 126}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 200}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 169, 36, 77, 234, 30}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 188, 202, 102, 58}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 129, 210, 123, 149, 152}, 220},
	{{237, 186, 88, 254, 124, 0, 30, 1, 83, 230, 131, 245, 89, 57, 195, 29}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 131, 209, 128, 242}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 153, 77, 206, 248, 245}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 116, 22, 158, 37, 19, 19, 144}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 175, 225, 68, 58, 93}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 23}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 187, 197, 103, 90}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 58, 153, 4, 143, 86}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 112, 110, 50, 190, 231}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 108, 24, 51, 54, 204, 141, 205}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 28, 97, 173, 246, 46, 219}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 157, 192, 81, 166, 109}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 220},
	{{237, 186, 88, 254, 124, 214, 124, 106, 41, 101, 142, 242, 249, 242, 18, 240}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 87, 184, 191, 212}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 18, 114, 17}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 61, 8, 236, 131, 198, 40, 182, 170}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 14, 9, 212}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{237, 186, 88, 254, 124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 103, 69, 208, 59, 130, 76}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 21}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 78, 255}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 174, 248, 187, 24}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 171, 119}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 205, 212}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 44, 119, 43, 193, 29, 189}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 125, 149}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 186, 229}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 251, 48, 52, 224, 43}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 223, 20, 208, 191, 31, 51, 195}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 170, 101, 230, 213, 190, 236, 42}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 2, 211, 218, 237, 141}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 50, 179}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 19, 202, 242, 79}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 205, 180, 209, 41, 10}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 54, 251, 90, 211}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 181, 26, 230, 64, 27}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 19, 91, 81}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 40, 209, 70}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 23, 229, 84}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 242, 212, 206, 162, 5}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 101}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 20, 104}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 164, 75, 173, 188, 145}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 191, 189, 6, 53}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 102, 233, 203, 177}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 135, 162}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 99, 96}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 9, 167}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 87, 170, 48, 64, 248, 69, 211}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 144, 215, 232, 163, 29, 27}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 170}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 206, 157, 12, 157, 90, 48}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 173, 142, 176, 23, 130}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 179}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 196, 31, 170, 239, 142, 34, 114}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 83, 30, 117, 92, 73}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 76, 172, 245}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 32, 34, 211, 108, 251, 49}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 64}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 151, 88, 148, 14, 24}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 137, 65, 220, 165}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 192}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 223, 242, 242, 182, 126, 101, 99}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 112}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 29, 174, 231, 196, 176}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 163, 145, 216, 71}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 53, 96, 45, 150}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 124, 209, 84}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 8}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 198, 207, 163, 127, 162, 207}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 19, 152, 147, 218}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 171, 252, 148, 202, 222}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 178, 91, 71, 179, 166, 126, 178}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 212}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 21, 64, 22, 149}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 114}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 128, 3, 232}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 70}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 109, 16, 81, 216, 157, 242}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 137, 34, 233, 148, 234}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 21, 43}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 209, 71, 163}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 12, 148, 159, 40, 229}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 229, 187, 72, 10, 100, 211, 130}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 11, 171, 11, 85}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 142, 33}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 203, 106, 25, 154, 45, 169, 85}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 52, 124}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 53, 224}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 206, 136, 147, 205, 63}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 87, 143}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 46, 79}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 128, 112, 52, 112, 249, 38, 83}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 237, 51}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 33, 8, 28, 180}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 68, 188, 116, 246}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 0, 0, 0}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 166, 103, 196, 245, 90, 198}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 157, 179, 69, 89, 70, 182}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 32, 182, 95}, 151},
	{{182, 230, 93, 162, 129, 25, 56, 196, 112, 0, 0, 0, 0, 104, 33, 12}, 151},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 119, 191, 215, 86, 228, 181}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 99, 106, 1, 73, 184, 240, 138}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 73, 55, 69, 209}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 151, 34, 178, 11, 56, 56}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 34, 250}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 178, 223, 186}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 180, 83}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 9, 231, 82}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 45, 120, 150, 62}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 193}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 130, 163}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 98, 73, 38}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 171, 136, 182, 242, 200, 211, 19}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 34, 7, 97, 25, 28}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 241, 74, 111, 114}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 127, 54, 7, 47, 188, 96, 67, 35}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 18}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 155, 231, 253, 117, 48}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 129, 175, 8, 241, 29, 56, 136}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 113, 28, 50, 249, 228, 198}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 88, 242, 132, 195}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 146, 12, 122, 91, 220, 169, 0, 134}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 182, 57, 148, 139, 207, 190}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 225, 175, 139, 13, 90, 36, 175}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 48, 227, 183, 72, 159}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 77, 132}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 198, 184, 235, 10}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 113, 113, 2, 236}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 194, 189, 113, 113}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 184, 253, 172, 82, 74, 144}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 63, 195, 199, 23, 20, 253, 255}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 205, 76, 201, 14, 61, 119, 120}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 11, 197, 234}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 178, 28, 14, 59, 134, 74, 38, 147}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 53, 47, 12, 176, 14, 169}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 217, 49, 6, 184, 230, 166, 134}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 200, 250, 99, 32, 201}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 178, 40, 172, 183, 175, 78, 93}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 62, 9, 27, 148, 78, 8}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 171, 221, 189, 17}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 124, 45, 8}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 223}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 121}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 22, 12, 149, 78, 164, 106, 124}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 251, 72, 163, 100, 107}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 167, 9, 98, 39, 157, 2, 8, 70}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 209, 47, 5}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 169, 132, 60, 28, 28, 98, 47}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 231, 102, 212, 21, 144, 32, 143}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 113, 68}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 122, 168}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 59}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 67, 249, 69, 47, 128, 109}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 90}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 70, 133, 205}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 174, 128, 194, 184}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 208, 26, 218, 138}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 10, 57, 20, 45, 226, 56, 244}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 23, 84, 189, 196}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 214, 26, 174}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 243, 43, 72, 204, 48, 250, 36}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 48}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 10, 182, 16, 112, 69, 127, 229, 170}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 121, 229, 69, 231, 40, 197}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 194, 87, 142}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 173, 61, 139, 75, 115, 165}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 159, 53, 64, 180}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 210, 136, 52, 210, 43, 120, 208}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 82, 27, 14, 112, 246}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 88, 131, 126, 216, 11}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 71, 6, 0, 95, 215}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 20, 105, 17, 122, 161, 54, 222}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 10}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 128, 184, 69}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 7, 34, 215, 194, 231}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 78, 52, 103, 45, 116, 201}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 45, 185}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 5, 52, 152, 81}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 52}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 245, 176}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 173, 203, 251, 100, 202, 203, 90}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 91, 65, 118, 43}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 199, 64, 77, 13, 229}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 163, 76, 13, 73, 241, 81}, 111},
	{{245, 45, 69, 226, 90, 212, 254, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 51, 204, 0, 91, 252, 22, 216}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 243, 180, 118, 79, 174, 237}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 242, 140, 215, 196, 240}, 63},
	{{107, 229, 240, 160, 247, 145, 29, 48, 1, 69, 180, 70, 133, 164, 98, 136}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 175, 95, 160, 169, 129, 34}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{107, 229, 240, 0, 0, 152, 122, 193, 104, 35, 111, 152, 154, 176, 118, 172}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 9}, 63},
	{{107, 229, 240, 100, 52, 183, 48, 159, 145, 209, 188, 63, 49, 0, 216, 156}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 153, 175, 89}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 143, 101, 61}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 57, 110, 187, 34, 31, 88}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 48, 233, 7, 110, 160, 171}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 173}, 63},
	{{107, 229, 240, 0, 71, 185, 152, 112, 164, 34, 24, 126, 251, 172, 27, 114}, 63},
	{{107, 229, 240, 0, 0, 0, 141, 10, 197, 9, 25, 251, 160, 125, 30, 203}, 63},
	{{107, 229, 240, 0, 0, 31, 3, 83, 15, 199, 138, 195, 40, 218, 173, 133}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 220, 161, 151}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 229, 125, 29}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 194, 210, 104, 222, 120, 109, 179}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 54, 248, 47, 196, 67}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 145, 111, 45}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 152, 254, 234, 139, 109, 48}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 213, 15, 232}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 8, 59, 24, 197, 54, 23, 15, 179}, 63},
	{{107, 229, 240, 0, 0, 104, 147, 165, 20, 68, 188, 145, 3, 46, 235, 230}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 109}, 63},
	{{107, 229, 240, 121, 68, 61, 35, 167, 57, 163, 192, 30, 64, 71, 228, 45}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 29, 61}, 63},
	{{107, 229, 240, 157, 219, 245, 189, 79, 191, 141, 62, 141, 107, 34, 80, 138}, 63},
	{{107, 229, 240, 0, 0, 201, 47, 7, 219, 133, 99, 238, 195, 43, 71, 82}, 63},
	{{107, 229, 240, 0, 0, 0, 79, 21, 203, 240, 36, 243, 3, 138, 101, 47}, 63},
	{{107, 229, 240, 0, 0, 66, 115, 115, 117, 112, 51, 123, 103, 157, 183, 207}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 73, 49, 60, 3, 91, 19, 245, 58}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 42, 226}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 34, 227, 156, 47, 16, 156}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 17}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 195, 100, 97, 11, 8, 110, 17, 50}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 121}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 158, 103, 166}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 82, 247, 139, 74, 164, 205, 249}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 32}, 63},
	{{107, 229, 240, 0, 112, 90, 83, 95, 234, 94, 162, 143, 135, 33, 111, 9}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 94, 187, 97, 152, 163, 134, 36, 210, 179}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 127}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 107, 90, 180, 174, 251, 109, 254}, 63},
	{{107, 229, 240, 0, 0, 0, 175, 203, 119, 151, 220, 188, 153, 201, 3, 44}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 22}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 182, 22, 96}, 63},
	{{107, 229, 240, 86, 199, 2, 200, 167, 248, 54, 174, 115, 37, 111, 144, 52}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 70, 139, 123, 68, 74, 237}, 63},
	{{107, 229, 240, 0, 0, 0, 22, 216, 93, 150, 248, 251, 156, 158, 81, 227}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 63},
	{{107, 229, 240, 0, 0, 233, 208, 165, 150, 59, 2, 221, 18, 113, 209, 234}, 63},
	{{107, 229, 240, 0, 0, 191, 174, 107, 109, 42, 123, 103, 25, 120, 73, 83}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{107, 229, 240, 0, 0, 26, 152, 84, 1, 236, 188, 219, 9, 251, 217, 176}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 47, 212, 170}, 63},
	{{107, 229, 240, 0, 0, 53, 139, 180, 182, 42, 55, 138, 31, 68, 51, 121}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{107, 229, 240, 0, 131, 9, 246, 8, 25, 215, 125, 83, 112, 114, 169, 192}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 185, 42, 88, 28, 14, 217, 246, 137}, 63},
	{{107, 229, 240, 0, 0, 176, 198, 152, 135, 252, 44, 221, 4, 232, 212, 119}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 108, 69, 228, 196, 224, 232, 66, 215, 217}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 103, 226, 34, 17, 83}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 176}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 197, 77, 4, 55, 216, 155, 128, 155}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 237, 49, 75, 95, 227, 204, 73, 185, 255}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 233}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 124, 207}, 63},
	{{107, 229, 240, 0, 0, 169, 40, 206, 189, 149, 149, 6, 214, 149, 112, 73}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 84}, 63},
	{{107, 229, 240, 217, 21, 187, 154, 196, 153, 94, 112, 124, 83, 57, 223, 37}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{107, 229, 240, 0, 0, 0, 75, 195, 208, 176, 207, 223, 206, 112, 231, 26}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 66, 182, 14, 80, 16}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 210, 138, 85, 42, 84, 35, 44, 30, 88}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 236, 11, 127, 132, 10, 198, 109}, 63},
	{{107, 229, 240, 0, 0, 139, 110, 217, 168, 21, 255, 108, 9, 76, 207, 143}, 63},
	{{107, 229, 240, 0, 0, 0, 87, 166, 161, 158, 221, 61, 52, 209, 151, 113}, 63},
	{{107, 229, 240, 135, 130, 107, 61, 204, 54, 160, 119, 93, 10, 137, 136, 95}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 96, 145, 16}, 63},
	{{107, 229, 240, 0, 0, 0, 49, 105, 186, 85, 51, 97, 26, 14, 96, 60}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 157, 59, 122, 236, 47, 59, 93, 127}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 168, 67, 83, 16, 78, 64}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 0, 67, 243, 218, 83, 32}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 149, 187, 95, 33, 84, 197, 208, 96}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 243, 254, 76, 39, 33, 183}, 63},
	{{107, 229, 240, 0, 0, 218, 67, 159, 69, 119, 46, 164, 127, 41, 170, 205}, 63},
	{{107, 229, 240, 0, 0, 0, 0, 0, 0, 0, 8, 247, 137, 35, 105, 42}, 63},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 5, 126, 226, 207, 196, 193}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 153, 106, 142, 119, 232}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 234, 248, 105, 74}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 31, 67}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 205, 227, 138, 118, 167, 228}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 38, 179, 175, 103, 175, 163}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 160, 131, 12, 128, 237, 99, 163, 194}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 114, 209, 175, 220, 132}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 7, 24, 55, 61}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 23, 77, 163, 22, 196, 109}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 250}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 21, 167, 176, 111, 202}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 250, 239}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 235, 25, 215, 53, 105}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 244, 180, 229, 95, 74}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 53, 59, 156, 177}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 242, 176}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 205, 83, 206, 130, 244}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 164, 201, 232, 208, 171, 223, 111}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 160, 156, 227, 140, 104, 190, 228, 107}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 77, 177, 180, 137, 9, 63}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 163, 152, 174, 36, 131, 227}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 36, 68, 95}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 185, 6}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 117, 110, 162, 209, 159, 28}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 9, 78, 221, 242, 200, 216, 93, 42}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 41, 144}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 9}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 45, 230, 135, 107, 121}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 249, 135, 94, 217}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 209, 208, 107, 42, 120, 239, 189, 126}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 201, 170, 43, 232, 119}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 183, 56}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 113, 48, 154, 161, 234, 49}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 70, 152, 136, 110, 174, 15, 86}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 218, 193, 128, 207, 25, 85}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 183, 139, 239, 64}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 116, 168, 3}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 106, 98, 197, 218, 11}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 190, 51, 119, 173, 59, 141}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 28, 229, 64, 200, 171, 42}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 143, 97, 169, 62, 186, 134}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 3, 135}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 117, 86, 243, 53, 66, 65}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 187, 33, 0, 169, 104, 215, 98, 233}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 60, 161, 5, 34, 228, 102}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 129, 250, 201, 145, 146, 75, 146}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 108, 72, 93, 115, 122, 114, 222, 32}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 44, 89, 113, 197, 115, 29}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 50}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 39, 123, 154, 215, 215, 79, 226}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 92, 82, 71, 252}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 36, 72, 19}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 45, 114, 178, 160, 22}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 199, 137, 74, 191}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 48, 157}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 104, 176, 233, 138, 214, 125, 78, 229}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 139, 30, 156}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 55, 80, 106, 247, 207, 26, 247}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 8, 0, 152, 154, 54, 31}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 94, 32}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 103, 131, 210, 9, 224, 19, 239}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 50, 40, 66, 210, 62, 12}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 81, 155, 103}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 188, 210}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 1, 45, 47, 220, 129, 87, 132}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 251, 254, 18}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 59, 197}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 172, 49, 240}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 20, 203, 138, 167, 154, 4}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 29, 88, 105, 61, 229, 217, 15}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 206, 217, 48, 55, 65}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 112},
	{{119, 208, 177, 235, 222, 252, 219, 0, 39, 160, 89, 170, 195, 89, 16, 163}, 112},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 235, 96, 166, 81}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 50, 131, 78, 153, 140, 134, 211}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 35, 106, 148, 78, 38, 187, 232}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 47, 16}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 147, 33, 37, 208, 154, 16, 129, 195}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 87, 98, 45}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 63, 11, 215, 14, 204, 254}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{178, 151, 220, 162, 120, 128, 148, 86, 140, 204, 235, 75, 174, 78, 114, 88}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 239, 152, 179, 190, 25}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 175, 195, 166, 92, 235}, 48},
	{{178, 151, 220, 162, 120, 128, 209, 241, 55, 150, 73, 31, 255, 138, 63, 73}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 28, 185, 94, 193, 165, 138, 37, 136}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 243, 53}, 48},
	{{178, 151, 220, 162, 120, 128, 242, 142, 212, 5, 205, 99, 6, 138, 113, 82}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 232, 225, 150, 55, 177, 229, 121, 36}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 163, 138, 27, 159, 176, 175, 175, 208}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 19, 5, 114, 162}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 94, 143}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 211, 223}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 35, 84, 139, 86, 72, 181}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 139, 100, 175, 101}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 251, 35, 231, 123, 122}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 176, 17, 57, 54, 20, 10, 85}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 62, 76}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 184, 156, 253, 198, 220}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 132, 193, 237, 68, 129, 190, 217}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 178, 105, 235, 103, 188, 51, 172}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 75, 134}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 88, 244, 32, 144, 157}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 13, 70, 188}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 244, 98, 210, 251, 70, 143, 56, 11}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 95, 68, 36, 122, 128, 221}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 190, 93, 153, 133, 162, 207, 88, 214, 8}, 48},
	{{178, 151, 220, 162, 120, 128, 35, 206, 179, 254, 198, 87, 155, 231, 109, 65}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 45, 90, 176, 107, 61, 250}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 24, 207, 253, 63, 133, 71, 89, 215}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 243, 43, 240, 198, 51, 160, 16}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 6, 222, 210, 79}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 184, 80, 64, 162, 244, 171, 85, 36, 22}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 163, 197, 85}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 191, 192, 226}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 102, 18, 122, 176, 227}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 33, 32, 173, 215, 150}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 219, 76, 88, 211}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 156, 148, 4, 200, 225, 1, 67, 49}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 133, 105, 54, 127, 102}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 204, 201, 201, 18}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 5, 39, 215, 136, 186, 138, 238, 96}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 60, 69, 185, 37, 174, 95, 56}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 68, 227, 54, 92, 78}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 114, 99}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 111, 248, 99, 52, 138, 200, 119, 81}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 118, 111, 221, 20, 233, 178, 214}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 222, 154, 194, 74, 13, 245, 47, 44}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 232, 107, 81, 68, 252}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 72, 87, 140, 211}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 197, 0, 230, 232, 51, 3, 252}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 60, 163, 157, 69, 191, 80}, 48},
	{{178, 151, 220, 162, 120, 128, 29, 166, 251, 217, 239, 218, 117, 8, 239, 178}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 60, 63}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 111, 238, 18, 171}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 91, 249, 69, 17, 197}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 237, 70, 156, 176, 197, 239, 175}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 201, 124, 137, 33, 124, 90, 35, 93}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 211, 64, 17, 2, 50, 235, 25, 151, 27}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 40, 109, 54, 152}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 83, 67, 151, 101}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 100, 151, 122, 183, 18, 112, 28}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 131, 113, 224}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 102, 86, 253, 103, 30, 243, 131, 208, 33}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 114, 21, 153, 152, 169, 181, 145, 145}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 171, 109, 6, 181, 56, 153, 206}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 67, 223, 28}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 100, 243, 43, 233, 123, 21, 235, 199, 248}, 48},
	{{178, 151, 220, 162, 120, 128, 0, 0, 0, 0, 0, 0, 0, 123, 131, 197}, 48},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{109, 26, 95, 170, 166, 151, 137, 83, 226, 82, 5, 114, 253, 210, 18, 12}, 100},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 45, 96, 129, 30, 181}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 120, 167, 31}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 218}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 155}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 168, 160, 77}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 226}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 30, 22, 175}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 174, 242, 52, 229}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 219, 95}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 105, 153, 114}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 187, 52, 179, 159, 230, 189, 24}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 231, 144, 198, 189, 130, 38, 108, 127}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 108, 70, 44, 73}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 207, 1, 150, 58, 242}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 195, 12, 187, 104}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 129, 30, 101, 34}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 214, 44}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 177}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 198, 165, 152, 107, 20, 23, 176}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 130, 34, 216, 15}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 195, 180, 11}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 11, 1, 213, 140, 226, 59}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 224, 30, 127, 138}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 70}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 83, 198, 197, 150, 251, 214, 9}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 180, 159, 247, 155, 95, 189}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 123, 38}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 58}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 118, 68, 19, 218}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 13, 174, 172, 214, 97, 225, 32, 169}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 67, 71, 86, 148, 49, 138, 255}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 53, 232, 113, 9, 47, 128, 177, 96}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 113, 122}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 69}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 79, 170, 14, 194}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 238, 164, 212}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 5, 127, 4, 12, 156, 194, 35, 125}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 244, 146, 95, 198, 143}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 21, 176}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 103}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 170, 187, 70, 30, 10}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 139}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 48, 228}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 7, 195}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 149, 249, 111, 235, 28, 68, 85}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 180, 171, 221, 186}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 96, 136, 44, 195, 177}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 169, 144, 128}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 114, 9, 56, 85, 166}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 43, 98, 48, 214, 118, 98}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 44, 111, 9}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 178, 45, 80, 105, 250}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 136, 198, 14, 60, 255}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 184, 11, 169, 198, 205, 242}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 82, 22, 255, 24, 58, 111, 217}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 83, 100, 113, 228, 240}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 94, 35, 58, 93, 241, 50}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 252, 239, 66, 155, 79, 85, 76}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 84, 20, 204, 180, 121}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 132, 49, 237, 68}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 179, 32, 130, 187, 199, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 58, 44, 11, 170, 245}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 165, 207, 219}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 23, 142, 3, 126, 215}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 91, 121, 87, 33}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 137}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 30, 2, 97, 5, 244, 162, 84}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 135, 91, 6}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 247, 210, 125, 69, 217, 166, 221}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 126, 32}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 193, 144, 151, 42}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 119}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 120}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 72, 83, 100}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 249, 24, 72}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 154, 109, 94, 137, 225, 85, 48, 201}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 197, 101, 225, 220, 159, 6}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 72, 140, 101}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 154, 145, 155, 230, 140, 51}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 126, 160}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 180, 83, 180}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 52, 233, 165}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 202, 112, 151, 153, 102, 1}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 26, 40, 17, 63, 119, 34, 173, 227}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 141, 111, 61, 177, 49}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 0, 0, 0, 0, 0, 0, 0}, 156},
	{{126, 27, 252, 19, 219, 129, 121, 48, 0, 198, 39, 204, 2, 7, 200, 229}, 156},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 229, 18, 229}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 193, 72}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 15, 106, 50}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 173, 165, 113}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 103}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 206, 5}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 72, 222}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 228, 105}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 16, 207, 248}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 128}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 173, 65}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 144, 174, 82}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 217, 130, 63}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 228}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 228}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 201, 34, 196}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 89, 165, 43}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 99, 48, 124, 12}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 194}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 88, 217, 82, 253}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 107, 132, 93}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 24, 217, 98}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 148}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 228}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 32, 134, 252}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 182}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 79}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 224, 236}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 79}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 190}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 95, 202}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 122, 150, 120}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 59, 44, 206}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 17, 51, 13}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 132, 78, 217}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 224}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 128, 63, 137}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 202, 237, 199}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 149}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 210, 159}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 53, 234, 217}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 173, 240, 190}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 23, 99, 46}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 111, 14}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 245, 242, 244}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 69}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 221, 150}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 137, 107, 135}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 145, 91, 70}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 134, 43}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 170}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 20, 36}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 169, 110}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 190, 25, 50}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 88}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 196, 61, 226}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 5}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 115, 246}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 38}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 30}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 73, 199, 51}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 245}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 0}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 105, 103}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 158}, 120},
	{{211, 195, 152, 145, 154, 93, 228, 215, 135, 101, 28, 82, 0, 0, 0, 67}, 120},
	{{252, 107, 0, 0, 0, 0, 0, 216, 122, 18, 58, 178, 28, 181, 112, 71}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 160, 153, 91, 5, 67, 184, 35}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 126}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 137, 218}, 5},
	{{252, 107, 0, 0, 0, 0, 57, 210, 122, 253, 195, 26, 110, 26, 100, 181}, 5},
	{{252, 107, 0, 0, 0, 6, 37, 226, 122, 7, 245, 60, 171, 59, 27, 196}, 5},
	{{252, 107, 0, 0, 0, 112, 39, 154, 174, 218, 137, 225, 175, 149, 38, 91}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 201}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 180, 85}, 5},
	{{252, 107, 0, 0, 0, 65, 1, 20, 52, 239, 171, 233, 15, 144, 116, 217}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 228, 44, 70, 233, 55, 125, 198}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 131}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 50, 196, 19, 3, 163, 52, 252}, 5},
	{{252, 107, 0, 0, 0, 0, 159, 31, 51, 180, 113, 129, 145, 116, 117, 42}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 133}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 89, 108, 85, 194}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 255, 143, 125, 115, 90, 77, 236, 182, 145}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 158, 241, 221}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 210, 191, 71, 117}, 5},
	{{252, 107, 0, 0, 0, 230, 177, 134, 114, 194, 85, 113, 65, 224, 167, 194}, 5},
	{{252, 107, 0, 0, 0, 203, 46, 253, 192, 157, 234, 4, 29, 41, 133, 236}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 87, 157}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 83}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 12, 30, 199, 130}, 5},
	{{252, 107, 0, 50, 219, 12, 41, 249, 158, 142, 178, 190, 206, 154, 224, 141}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 167, 120}, 5},
	{{252, 107, 0, 0, 0, 0, 80, 124, 228, 171, 122, 35, 60, 57, 107, 249}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 216, 191, 29, 62, 198, 111}, 5},
	{{252, 107, 0, 0, 0, 160, 85, 165, 39, 236, 37, 31, 151, 113, 175, 156}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 183}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 215, 153, 2, 196, 11, 94, 174}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 62, 6, 236, 236, 50, 176}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 52, 47, 48}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 243, 43, 20, 67, 56, 171, 95, 170, 70}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 195, 233, 239, 68, 239, 45, 80}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 245, 106, 252, 119, 173, 238, 113}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 95, 84, 128, 77, 182, 164, 62, 171, 68}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 205, 173, 4}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 227, 116, 66, 94}, 5},
	{{252, 107, 0, 130, 5, 235, 183, 194, 92, 24, 29, 238, 42, 207, 196, 122}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 241, 181, 24}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 61, 105, 190}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 229, 25, 145, 192, 180, 71}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 134, 121, 8, 96, 2, 204}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 67, 205, 65, 202}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{252, 107, 0, 0, 15, 166, 149, 253, 250, 131, 7, 169, 245, 6, 137, 183}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 103}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 5, 48, 56}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 192, 166, 71}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{252, 107, 0, 0, 0, 0, 153, 209, 239, 127, 49, 236, 108, 32, 141, 243}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 5},
	{{252, 107, 0, 150, 74, 239, 22, 30, 219, 249, 102, 60, 24, 197, 251, 249}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 75}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 187, 200}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 30, 181, 92, 155, 239, 133}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 100, 19, 86}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 37, 91, 28, 111, 141, 82}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 231}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 100, 9, 65}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 65, 154, 97, 213, 164, 252, 252, 43}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 11, 88, 111}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 219, 241, 112, 21, 194, 106, 51}, 5},
	{{252, 107, 0, 0, 0, 147, 232, 108, 63, 187, 124, 222, 46, 1, 117, 243}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 77, 139, 193}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 167, 141, 90, 128, 64, 21}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 39, 255, 46, 243, 32, 17}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 154}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 57, 253, 24, 152, 193, 122, 18, 240, 211}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 202, 4}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 25, 132}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 242, 192, 188, 2, 225, 12, 1, 194, 219}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 59, 72}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 250, 231, 0, 29, 173, 149, 5, 220}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83}, 5},
	{{252, 107, 0, 63, 146, 119, 228, 239, 230, 152, 207, 58, 191, 0, 187, 140}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 101, 44, 193}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 183, 130, 72, 218, 120, 201, 167, 248, 34}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 119, 21}, 5},
	{{252, 107, 0, 203, 44, 89, 154, 46, 129, 95, 84, 74, 117, 206, 223, 176}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 9, 33}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 88, 173, 57, 101, 203, 95, 241}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 5},
	{{252, 107, 0, 0, 0, 0, 139, 117, 75, 42, 91, 135, 224, 8, 246, 83}, 5},
	{{252, 107, 0, 0, 0, 12, 254, 253, 81, 17, 232, 198, 11, 250, 242, 56}, 5},
	{{252, 107, 0, 0, 0, 0, 56, 202, 81, 173, 137, 238, 40, 249, 152, 126}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 128}, 5},
	{{252, 107, 0, 0, 0, 0, 165, 147, 123, 186, 187, 10, 48, 53, 23, 222}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{252, 107, 0, 0, 0, 0, 0, 0, 0, 150, 61, 22, 209, 19, 233, 245}, 5},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 30, 188, 62}, 64},
	{{192, 0, 0, 0, 0, 0, 42, 235, 53, 132, 128, 99, 169, 223, 191, 28}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 145, 243, 131, 193, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 220, 233, 54, 2, 191}, 64},
	{{192, 0, 0, 87, 160, 126, 152, 66, 38, 181, 9, 143, 128, 183, 97, 134}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 82, 21, 91, 158, 70, 247, 229}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 188}, 64},
	{{192, 0, 0, 0, 0, 0, 136, 21, 34, 253, 13, 127, 182, 161, 7, 25}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 211, 139, 221}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 140, 135, 248, 27}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 81, 236, 88, 118, 133, 218, 85}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 171}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 162, 100, 223, 126, 236, 51, 7, 171, 176}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 64, 139, 15, 68, 52, 22, 170}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 199, 41, 98, 196, 243, 33, 101}, 64},
	{{192, 0, 0, 118, 227, 149, 23, 53, 69, 54, 131, 58, 94, 81, 44, 189}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 131, 56, 203, 23, 119, 212, 253}, 64},
	{{192, 0, 0, 0, 0, 0, 127, 181, 10, 227, 56, 235, 212, 26, 60, 56}, 64},
	{{192, 0, 0, 131, 88, 13, 92, 24, 186, 46, 130, 125, 92, 138, 64, 25}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 234, 181}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 50, 255, 96, 111, 82, 108, 42}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 244, 33, 159, 46}, 64},
	{{192, 0, 0, 0, 0, 0, 93, 96, 161, 117, 52, 166, 82, 165, 47, 106}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 175}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 241, 177, 75, 103, 57, 232, 121, 244, 21}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 165, 117, 119, 35}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 244, 200, 29, 179, 224}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 181, 78, 112, 85, 134, 11, 149}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 247, 68, 255, 54, 194, 148, 224}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 240, 110, 25, 87, 140}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 170, 33, 94, 180, 206, 64, 250}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 224, 193, 112, 142, 121, 147, 89, 246}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 76, 14, 203, 133, 62, 20, 58, 134, 226}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 208, 62}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 8, 174, 159, 17, 150, 50, 73}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 213, 99, 180, 133, 167, 224, 157, 68}, 64},
	{{192, 0, 92, 244, 223, 25, 23, 59, 172, 124, 76, 121, 198, 136, 229, 112}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 223, 49}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 173, 68, 213}, 64},
	{{192, 0, 0, 0, 144, 121, 105, 106, 66, 163, 12, 22, 125, 219, 49, 158}, 64},
	{{192, 0, 0, 0, 67, 8, 124, 151, 181, 32, 42, 209, 30, 238, 98, 59}, 64},
	{{192, 0, 0, 0, 0, 114, 3, 89, 205, 33, 114, 200, 182, 117, 52, 234}, 64},
	{{192, 0, 0, 0, 0, 28, 97, 238, 98, 130, 66, 65, 184, 31, 148, 28}, 64},
	{{192, 0, 0, 0, 0, 26, 40, 14, 85, 157, 92, 144, 181, 135, 63, 176}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 112, 50, 254, 104, 48, 127, 86, 33}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 204, 249}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 210, 10, 0, 162, 248, 198, 134, 114}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 2, 135, 23, 180, 249}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 93, 237, 43, 195}, 64},
	{{192, 0, 0, 0, 190, 35, 64, 2, 209, 102, 202, 65, 25, 97, 120, 108}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 175}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 64},
	{{192, 0, 0, 0, 0, 0, 172, 108, 198, 114, 111, 207, 135, 255, 61, 114}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 243, 105, 190}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 22, 163, 121, 192, 246, 113, 137}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 64},
	{{192, 0, 0, 0, 0, 116, 107, 84, 48, 87, 243, 45, 29, 124, 60, 232}, 64},
	{{192, 0, 0, 134, 51, 222, 83, 201, 76, 215, 148, 209, 71, 88, 130, 76}, 64},
	{{192, 0, 0, 0, 0, 0, 14, 214, 123, 56, 82, 62, 60, 200, 111, 83}, 64},
	{{192, 1, 88, 149, 84, 141, 104, 88, 170, 198, 106, 183, 67, 165, 52, 188}, 64},
	{{192, 0, 224, 235, 113, 177, 158, 9, 195, 35, 206, 125, 204, 181, 40, 45}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 52, 58, 193, 234, 52, 74, 115, 171}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 145, 3}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 171, 6}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 62, 85}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 31, 89, 229, 69, 95}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 68}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 169, 65, 85, 95, 119}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 225, 71, 107, 56, 239, 217, 248, 142}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 72, 190, 214, 236, 215, 119, 54, 70}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 43, 212, 4, 96}, 64},
	{{192, 0, 0, 0, 189, 22, 39, 164, 230, 232, 147, 73, 176, 133, 151, 128}, 64},
	{{192, 0, 0, 0, 0, 0, 14, 201, 24, 200, 84, 166, 12, 255, 86, 139}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 56, 47, 58, 0, 227, 114, 224, 11}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 223, 131}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 202, 24, 230}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 53, 25, 234, 41, 197, 200, 235}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 144, 8, 113}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 24, 105}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 106, 72, 14, 114, 167, 54, 59, 89, 73, 3, 144, 41, 27}, 64},
	{{192, 0, 93, 206, 25, 165, 120, 250, 125, 151, 215, 45, 163, 138, 70, 82}, 64},
	{{192, 0, 0, 0, 42, 218, 149, 25, 39, 117, 125, 6, 154, 230, 96, 127}, 64},
	{{192, 0, 0, 0, 14, 32, 30, 221, 47, 205, 30, 56, 70, 95, 128, 176}, 64},
	{{192, 0, 0, 0, 137, 148, 160, 0, 151, 53, 243, 33, 53, 25, 127, 122}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 201, 92, 156, 67, 135, 3, 170, 52, 117, 156, 83, 109, 151, 240}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{64, 0, 0, 0, 0, 0, 69, 244, 146, 54, 122, 96, 46, 102, 47, 233}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 243, 218, 102}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 114, 225, 44}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 220, 213, 172, 175, 55, 216, 196, 96, 191, 92, 110, 10}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 76, 4}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 3, 238, 135, 228}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 247, 78}, 84},
	{{64, 8, 10, 47, 228, 96, 102, 212, 168, 18, 56, 77, 27, 92, 183, 66}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 146, 222, 80, 210, 110, 22, 229}, 84},
	{{64, 0, 0, 0, 0, 179, 152, 169, 61, 208, 74, 162, 77, 38, 242, 93}, 84},
	{{64, 0, 0, 0, 0, 0, 118, 227, 60, 191, 38, 204, 37, 28, 22, 89}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129}, 84},
	{{64, 0, 0, 0, 0, 0, 10, 75, 114, 202, 143, 54, 54, 198, 170, 217}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 200}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 169, 1, 7, 26, 79, 63, 75, 98, 105}, 84},
	{{64, 0, 0, 0, 205, 241, 64, 135, 134, 92, 222, 143, 172, 6, 232, 197}, 84},
	{{64, 0, 0, 0, 0, 0, 65, 46, 1, 206, 164, 30, 89, 169, 218, 58}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 172, 253, 174, 135, 64, 107, 135, 45, 138}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 52, 131}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 55}, 84},
	{{64, 0, 0, 75, 155, 247, 23, 74, 224, 243, 249, 164, 242, 104, 83, 227}, 84},
	{{64, 0, 54, 13, 118, 45, 190, 114, 139, 33, 174, 122, 254, 1, 144, 64}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 48, 48}, 84},
	{{64, 0, 0, 0, 0, 149, 26, 161, 29, 13, 127, 191, 52, 102, 250, 213}, 84},
	{{64, 0, 0, 0, 0, 19, 159, 161, 175, 169, 10, 137, 90, 55, 84, 187}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 181, 175, 186, 186, 119, 166, 224, 31}, 84},
	{{64, 0, 0, 0, 0, 47, 141, 54, 229, 219, 55, 177, 40, 235, 160, 144}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 13, 65, 134, 171, 103, 84, 82}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 185, 198, 56, 93, 124, 153, 189, 74}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 117, 122, 160, 46, 156, 119, 194, 251}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 103}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 247}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 49, 171, 233}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 109, 120, 43, 75, 85, 169, 192}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 11, 186, 94, 77, 193, 105, 215, 246, 201}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 230, 244, 142, 168, 55, 196, 94, 23, 94}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 40, 203, 176}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 246, 173, 227, 138, 180, 202, 34}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 44, 190, 28, 167, 231, 34, 155}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 23, 221, 85, 74, 166, 109, 193, 177, 174}, 84},
	{{64, 0, 0, 70, 117, 186, 91, 15, 20, 141, 35, 234, 240, 3, 63, 59}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 224, 11}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 198, 9, 33, 228, 115, 187, 232}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 184, 122}, 84},
	{{64, 0, 0, 240, 214, 154, 180, 252, 31, 124, 97, 182, 131, 4, 48, 101}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 168, 148, 188, 13, 8, 164, 150, 73, 2}, 84},
	{{64, 0, 0, 0, 0, 0, 91, 105, 96, 177, 79, 70, 214, 246, 113, 188}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 28, 197, 115, 219, 52, 46, 63, 1, 232}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 144, 120, 1, 211, 98, 154, 185}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 251}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 182, 116, 14, 116, 137, 207, 8}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 52}, 84},
	{{64, 0, 0, 0, 0, 71, 22, 118, 89, 91, 174, 102, 177, 68, 11, 197}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 54, 35}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 148, 243, 61, 22, 94, 98, 50}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 123, 85, 245, 166, 170, 65, 23}, 84},
	{{64, 0, 53, 146, 214, 254, 143, 68, 210, 102, 91, 228, 205, 29, 219, 180}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 231, 0, 159}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 190, 109, 211, 31, 165}, 84},
	{{64, 0, 0, 0, 82, 153, 247, 15, 39, 13, 107, 210, 163, 231, 123, 0}, 84},
	{{64, 0, 15, 172, 111, 34, 2, 157, 176, 166, 58, 43, 128, 225, 8, 223}, 84},
	{{64, 77, 232, 16, 196, 218, 247, 195, 19, 75, 248, 233, 1, 126, 119, 126}, 84},
	{{64, 0, 0, 0, 204, 230, 182, 249, 21, 14, 180, 251, 72, 198, 255, 25}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 197, 225, 189, 233, 191, 74, 202, 165, 246}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 5, 255}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 196}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 252, 83, 244}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 214, 180, 165, 117, 172}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 158, 127, 52, 159, 222}, 84},
	{{64, 0, 159, 159, 217, 248, 215, 134, 73, 76, 104, 241, 227, 83, 88, 69}, 84},
	{{64, 0, 0, 0, 0, 0, 224, 69, 231, 235, 27, 133, 111, 102, 22, 209}, 84},
	{{64, 0, 0, 0, 155, 120, 105, 68, 39, 92, 202, 78, 14, 130, 201, 34}, 84},
	{{64, 0, 0, 165, 190, 100, 212, 46, 250, 136, 169, 22, 1, 195, 148, 78}, 84},
	{{64, 0, 8, 100, 183, 166, 243, 227, 234, 151, 139, 76, 203, 10, 124, 100}, 84},
	{{64, 0, 0, 0, 170, 103, 197, 108, 253, 198, 254, 131, 101, 166, 254, 126}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 142, 79, 156, 20, 224}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 250}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147}, 84},
	{{64, 182, 89, 43, 93, 4, 239, 27, 57, 14, 70, 231, 246, 73, 163, 151}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 70, 1, 220, 103}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 76, 186, 202}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 139, 235, 153, 107, 143, 80, 35, 120}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 198, 168, 0, 220, 58}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 161, 46, 34, 178, 28, 72, 31, 163, 232}, 84},
	{{64, 42, 130, 132, 90, 221, 202, 67, 58, 153, 136, 126, 31, 255, 3, 30}, 84},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 158, 156, 222}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 109}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 140}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 109, 43}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 35, 206}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 12, 39}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 129}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 182, 16}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 125, 90}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 222}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 144}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 110, 69}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 243, 101}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 65}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 242, 145, 178}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 143}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 7, 166, 247}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 44, 199}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 225, 19}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 124, 95}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 189}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 241}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 35}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 17}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 245, 78}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 169}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 33, 209}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 137}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 179}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 103, 192}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 191, 235}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 9, 171}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 232, 245}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 176, 80}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 249, 69}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 101, 204}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 137, 12, 120}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 16, 25}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 150, 34}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 214}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 226}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 197, 182}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 124}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 6}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 56}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 166, 246}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 104, 192}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 82, 88, 101}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 195}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 70, 106}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 156}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 88}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 196, 148, 155}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 42}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 222, 158}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 235, 172}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 183, 44, 148}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 251, 47}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 86, 156, 140}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 33}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 142}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 179, 192, 139}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 111}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 67}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 219, 172}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{225, 179, 43, 43, 222, 145, 205, 238, 164, 158, 147, 229, 56, 0, 0, 0}, 24},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 231}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 52}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 93, 22, 75}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 232, 100}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 222}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 118, 182, 111, 229}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 109, 59}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 87, 46, 215, 113}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 144, 84, 37}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 236, 112, 237, 33}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 148}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 206, 206}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 49, 134, 41}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 19, 101}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 114, 142}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 65}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 23, 23, 182, 106}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 5, 6}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 140}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 180}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 156, 150}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 90, 170, 195, 127}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 17}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 94, 37, 183}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 60, 39, 251, 135}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 167, 154, 98}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 47, 73, 148, 238}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 114, 23, 63}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 253, 231}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 57, 249}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 82}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 43}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 154, 178, 142}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 45}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 35, 204}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 226, 54}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 104, 158, 66}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 37}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 43, 1, 63}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 15, 75, 61, 187}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 184, 241, 192, 190}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 73}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 9, 86, 20, 220}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 163, 243}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 91, 203, 35}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 44, 187}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 182, 176, 245}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 178, 49}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 117}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 7, 148}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 238, 115}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 216}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 208}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 223, 114, 162}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 69, 230, 190}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 119, 130, 203}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 88}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 75, 11}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 228}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 252, 246, 167, 80}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 170, 181, 84, 56}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 92, 152}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 228, 218}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 7, 20, 226, 240, 11}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 174}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 80, 10, 135, 92}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 124, 152, 9}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 10, 31, 98, 194}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 52, 193, 50}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 93, 61, 214, 161}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 88, 110}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 35, 93, 228, 202, 203}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 136, 154, 84, 19}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 231}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 76, 24}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 208, 251}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 109}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 97}, 81},
	{{208, 127, 151, 24, 64, 113, 47, 85, 209, 79, 144, 0, 0, 0, 0, 0}, 81},
	{{178, 144, 203, 104, 0, 0, 38, 104, 139, 202, 1, 163, 174, 7, 20, 57}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 188, 38}, 96},
	{{178, 144, 203, 104, 0, 0, 135, 36, 242, 97, 100, 6, 185, 196, 150, 209}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 167, 190, 194, 114, 25, 197, 133, 191, 180}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 250}, 96},
	{{178, 144, 203, 104, 0, 0, 33, 39, 172, 73, 77, 223, 146, 127, 240, 147}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 242, 215, 232, 22, 202, 165, 219}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 116, 162, 81, 36, 153}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 199, 17, 172, 91, 74, 27, 0}, 96},
	{{178, 144, 203, 104, 0, 81, 240, 46, 15, 223, 112, 211, 108, 218, 16, 206}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 206, 3}, 96},
	{{178, 144, 203, 104, 168, 186, 57, 239, 254, 93, 128, 254, 37, 0, 254, 141}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 120, 176, 95, 213, 37, 116, 224, 182, 82}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 18, 255, 42, 135, 49}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 74, 37, 152, 30, 177, 195, 252}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 172, 13, 64, 178, 164}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 128, 63, 34, 59, 82, 140, 60}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 42, 75, 126, 235, 91, 2, 142}, 96},
	{{178, 144, 203, 104, 0, 0, 111, 61, 42, 89, 129, 42, 7, 153, 220, 152}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 61, 129, 182, 175}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 102, 12}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 146, 29, 141, 155, 160, 255, 230}, 96},
	{{178, 144, 203, 104, 0, 35, 17, 135, 97, 152, 32, 3, 132, 57, 58, 232}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 120}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 181, 8}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 33, 22, 33, 26, 126, 151, 22}, 96},
	{{178, 144, 203, 104, 0, 0, 193, 97, 16, 127, 187, 50, 106, 6, 235, 111}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 88, 168}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{178, 144, 203, 104, 0, 0, 155, 53, 91, 246, 5, 33, 198, 224, 189, 85}, 96},
	{{178, 144, 203, 104, 0, 0, 160, 86, 27, 93, 236, 54, 184, 13, 55, 100}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 131, 191, 96, 26, 237, 39}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 37, 208}, 96},
	{{178, 144, 203, 104, 0, 0, 9, 192, 161, 247, 103, 202, 132, 249, 115, 175}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 176, 136, 102, 123}, 96},
	{{178, 144, 203, 104, 0, 0, 64, 7, 150, 88, 157, 54, 13, 110, 0, 56}, 96},
	{{178, 144, 203, 104, 0, 253, 71, 181, 6, 254, 123, 232, 219, 88, 94, 78}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 93, 146, 181, 67, 22, 19}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 64, 8, 87, 66, 226, 197, 139}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 96},
	{{178, 144, 203, 104, 85, 18, 172, 243, 155, 201, 211, 158, 97, 114, 187, 164}, 96},
	{{178, 144, 203, 104, 0, 0, 148, 0, 249, 87, 127, 128, 12, 44, 85, 162}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 60, 118, 63, 138, 97}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 223, 136, 156, 144, 97, 236}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 50, 147, 14, 43, 83, 235, 243, 11, 213}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 208, 254, 81, 204, 240, 172, 174, 170}, 96},
	{{178, 144, 203, 104, 0, 22, 233, 186, 45, 135, 209, 140, 23, 136, 114, 76}, 96},
	{{178, 144, 203, 104, 0, 150, 108, 156, 1, 230, 193, 37, 159, 214, 140, 222}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 67, 66}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 208, 233, 229, 147, 58, 110, 11, 79, 128}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 31, 49, 9, 79, 194}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 74}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 118, 224}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 162, 27, 14, 167}, 96},
	{{178, 144, 203, 104, 0, 0, 238, 41, 250, 48, 173, 119, 159, 131, 215, 135}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 145, 56, 226, 142, 112, 151, 37}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 171, 107}, 96},
	{{178, 144, 203, 104, 170, 105, 98, 34, 122, 64, 198, 149, 188, 78, 254, 141}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 160, 201, 231, 174, 148}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 42, 216, 230, 164}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 69, 190, 77, 46, 60, 228, 52, 231}, 96},
	{{178, 144, 203, 104, 0, 0, 1, 148, 36, 59, 193, 16, 140, 73, 125, 79}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 157}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 32, 129, 12, 185, 100, 89, 57, 223}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 46, 210, 236, 151, 122, 54}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 96, 18, 36, 26, 170, 227, 12, 16, 102}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 252}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 151, 106, 17, 85, 22, 210, 145, 169, 152}, 96},
	{{178, 144, 203, 104, 0, 0, 233, 106, 192, 141, 140, 204, 229, 243, 231, 239}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 43}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 98, 1, 20, 58, 217}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 129}, 96},
	{{178, 144, 203, 104, 160, 184, 181, 251, 166, 108, 151, 86, 200, 241, 241, 15}, 96},
	{{178, 144, 203, 104, 0, 0, 182, 50, 4, 114, 247, 161, 177, 6, 111, 144}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 122, 136}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 83, 104}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 173}, 96},
	{{178, 144, 203, 104, 0, 0, 84, 240, 89, 143, 247, 116, 80, 137, 52, 23}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 158, 19, 207, 89}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 24, 183, 31, 113}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 226, 163, 211, 235, 60}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 194, 82}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 22, 177, 35, 244, 136, 7}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{178, 144, 203, 104, 0, 120, 71, 203, 197, 179, 97, 25, 168, 164, 143, 238}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 125, 49}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 18}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 92, 193, 153, 133, 88, 65, 40, 154}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 92, 0, 169, 44, 227, 221, 220, 252}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 96},
	{{178, 144, 203, 104, 0, 0, 63, 53, 227, 61, 45, 44, 183, 153, 98, 190}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{178, 144, 203, 104, 0, 0, 243, 117, 106, 246, 243, 0, 58, 84, 1, 161}, 96},
	{{178, 144, 203, 104, 0, 0, 0, 0, 0, 0, 0, 0, 214, 67, 152, 33}, 96},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{56, 227, 139, 4, 86, 87, 180, 1, 215, 167, 237, 156, 111, 64, 47, 0}, 6},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 115}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 127}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 135}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 125}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 210}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 82}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 212}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 219}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 226}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 123}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 41}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 102}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{80, 76, 204, 119, 172, 169, 254, 81, 104, 166, 219, 44, 173, 161, 212, 0}, 40},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 203, 232, 155, 94}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 190, 163, 119}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 57}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 228}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 204, 100, 45, 139, 101, 82, 20}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 6, 196, 239, 159, 241, 226, 49}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 134, 69, 166, 47, 91}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 138, 199, 97, 52, 238, 40, 249}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 183, 172, 156, 237, 213, 184, 83}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 88}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 118, 101, 130, 91}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 5, 104, 182}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 77, 102, 115, 116, 169, 219}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 211, 15, 213}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 140, 175, 214, 163, 45}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 4, 144, 231, 190, 192}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 85, 164, 97, 125, 101, 46}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 148}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 240, 143}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 193, 2, 209, 122, 179, 245}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 149, 167, 219, 225, 243}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 221, 207, 105, 215, 155, 51}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 26, 85}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 100}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 242, 63, 142, 78, 155, 67}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 170, 188, 83, 185, 209, 115, 32, 144}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 149, 146, 5, 47}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 13, 60, 203, 46, 237}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 246, 188, 107, 54, 11}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 79, 195, 205, 221, 119, 196}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 155, 80, 87, 79}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 145, 21, 48, 106, 225, 118}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 237}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 217, 92, 173, 2, 222, 71}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 213, 117, 229, 140}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 43, 76}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 87, 44, 29, 114, 214, 31}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 142, 58, 165, 184, 127, 79, 252}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 39, 242, 101, 225, 233, 150, 149}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 71, 78, 91, 170, 76, 165}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 113, 229, 41}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 241, 21, 171, 217}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 163}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 222, 209, 216, 79}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 177, 25, 15, 141, 188}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 73, 37, 246, 180, 247, 56, 201}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 150}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 177, 128, 69, 39}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 96, 114, 59, 150, 223, 251, 20, 170}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 121}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 198, 211}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 101, 170, 34, 133, 4}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 132}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 138, 202}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 64, 161, 222, 42, 219}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 116}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 198, 241, 62, 194}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 13, 19, 51, 108, 121, 108, 125}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 247, 119, 239}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 100, 56, 0}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 50, 170, 72}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 201, 24, 217, 41, 79, 172, 126}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 149, 124, 76}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 202, 141, 111, 204, 16, 6}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 24, 222, 211}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 246}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 22}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 23, 99}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 76, 61}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 28, 216, 48, 20, 83, 224, 164, 178}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 96}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 149, 90, 166, 204, 42}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 59, 93, 60, 149, 154, 77, 105, 0}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 34}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 235, 210, 177, 26, 245}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 151, 114}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 45, 204, 1, 112, 66, 182, 227}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 102, 197, 124, 43, 21, 239, 84}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 6, 212, 192}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 217, 204, 136, 136}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 183, 112}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 21, 229, 171, 200, 72, 209, 226}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 190, 207}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 212, 201, 39}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 0, 161}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 205, 232, 6}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 0, 132, 28}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 191, 113, 123, 167, 118}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 0, 9, 33, 202}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 0, 0, 74, 238, 179, 90}, 143},
	{{129, 141, 139, 34, 241, 101, 223, 144, 0, 0, 4, 152, 63, 158, 254, 212}, 143},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 130, 127}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 228, 160, 177, 99, 177, 180}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 218}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 234, 109, 70, 78, 195}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 98, 85}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 84, 207, 95, 2}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 188, 17, 230, 61, 94, 10}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 151}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 46, 208, 60, 76, 211, 157}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 175, 166, 106, 47, 71, 112}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 64, 232, 24, 74, 173}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 61}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 185, 104}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 43, 51, 188, 243, 102, 74, 212}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 137, 93}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 98, 34, 210, 103, 124, 121, 249}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 8, 70, 151}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 127, 67, 3}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 2, 159}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 17, 105, 98, 207}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 254}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 88, 141, 154, 79, 153}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 142, 45, 171, 126, 73, 74}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 74, 147, 211}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 127, 131}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 62, 154, 153, 186, 200, 155}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 45, 137, 8, 208}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 160, 40, 194, 190, 53}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 181, 101}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 254, 72, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 28, 236, 210, 234, 93}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 46, 235, 4, 252}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 232}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 4, 170, 150, 101, 144, 31, 243}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 35, 112, 96, 154, 177}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 116}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 105, 226, 166, 175, 223}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 160}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 243}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 19, 9, 197, 173}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 194, 118, 94}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 191}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 246, 55, 0, 69, 45, 82}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 28, 50, 66, 33}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 157, 68, 14, 151, 38}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 117, 67, 199, 37, 98, 40}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 116, 19, 176, 149, 220}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 254, 80, 20, 5, 162, 132}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 132, 20, 190, 47}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 4, 93, 133, 34}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 236, 122, 46}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 7, 103, 209}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 157, 234, 90}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 157, 25}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 245}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 33, 58, 213, 100}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 39, 255, 252, 37}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 2, 255, 4}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 102}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 47, 72, 159, 209, 56}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 126, 235, 221, 217}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 219, 194, 14, 231}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 222, 146, 252, 116, 210}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 173, 38}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 73, 43, 5, 86, 132, 77, 250}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 168, 49, 183, 144, 77}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 49, 70, 139, 38, 168, 41}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 32, 72, 30, 103, 173}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 16, 35, 99, 237, 118}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 70, 14, 228, 191}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 157, 171, 177, 164}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 147, 228, 198, 76, 150}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 242, 241, 27}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 229, 13}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 148}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 20, 140, 33, 227, 208, 29}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 119, 21, 215, 73}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 189}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 0, 0}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 110, 95, 252}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 233, 152, 189, 131, 145}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 213, 26, 154}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 0, 0, 119, 116}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 0, 0, 13, 70, 224, 199}, 69},
	{{85, 102, 137, 98, 65, 103, 54, 142, 144, 0, 52, 39, 102, 31, 20, 241}, 69},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 197}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 255, 148, 206, 117}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 145, 75}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 225}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 194, 161, 87, 133}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 38, 206, 239}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 146}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 127}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 197, 218, 98}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 220, 126}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 13}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 142, 142}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 106}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 133, 142}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 105, 62, 118, 131}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 53, 96, 206}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 117, 190}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 79, 156, 189}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 235}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 240, 242, 59}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 229}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 69, 66, 149}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 148}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 149, 119}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 233, 153, 50}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 183}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 7}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 74, 57, 26}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 174}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 41}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 51, 94}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 207, 137}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 206, 38, 183}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 4, 121, 35}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 229, 136}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 226, 227}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 104, 137}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 252, 107, 107}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 52, 102}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 130, 249, 122, 51}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 217, 209}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 138, 201}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 167, 143}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 162, 218, 20, 11}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 107, 68, 187, 47}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 236, 175}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 185, 204}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 15, 152, 138}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 39, 65}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 71, 203}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 186, 10}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 140, 182}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 99, 129}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 137, 156, 69}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 53}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 8, 92}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 213, 198, 94, 153}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 110, 1}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 20, 21, 190}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 5, 125, 240, 88}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 216, 228, 59}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 163, 218, 158}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 224, 253}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 117}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 203, 208, 73, 57}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 174}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 217}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 172, 53, 68, 141}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 87, 157, 231, 92}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 4, 43, 164}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 93}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 182, 159}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 50, 88, 106}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 34, 181, 28}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 53, 111, 242, 18}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 89, 181}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 167, 136}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 221, 6, 68}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{56, 31, 159, 13, 201, 139, 161, 31, 89, 137, 4, 0, 0, 0, 0, 0}, 48},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 147, 109, 12, 51, 247}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 71, 109, 183, 180}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 107, 90, 48, 226, 19}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 253, 142}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 124, 100, 92, 174, 85, 39, 181}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 80}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 193, 131, 4, 102, 119, 223}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 31, 192, 1, 80, 38}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 129, 96, 24, 146, 30, 226, 32}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 4}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 57, 97}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 242, 107, 165, 103, 179}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 244, 214, 21, 80}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 238, 139, 157}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 207}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 213, 141, 173}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 135, 24, 213, 108, 156}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 115, 132, 85, 190, 20, 181, 242}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 174, 17, 24, 32, 91, 195}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 255, 118, 205, 81}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 29, 165, 201, 183, 132, 152}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 175, 48, 204, 87, 220, 52, 41}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 189, 141, 232}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 153, 254, 147, 59, 62, 160, 184}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 33, 56, 39}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 27, 5, 229, 237, 137, 199}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 148, 18, 23, 44, 76, 111}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 134, 241, 51, 157}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 158, 95, 91, 158, 253}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 127, 253, 1, 104, 118, 195}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 118, 32, 10, 253}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 218, 79, 5, 44}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 196, 118, 105, 50}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 239, 78, 100, 12, 249}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 174}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 5, 15, 204, 29}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 116, 169, 7, 54, 179, 182}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 151, 90, 52, 4, 50}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 120, 35}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 59, 210, 148}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 225}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 137, 45, 46, 93, 104, 214, 65}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 212, 102, 4, 66, 158, 181}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 129}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 154, 189, 216, 93}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 57, 210, 220, 187, 45, 213}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 109, 143, 238, 200}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 155, 87, 159, 198, 231}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 112, 145, 63}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 243, 3, 182, 213, 163}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 42, 233, 109, 170}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 230, 55}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 66, 42, 206, 104}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 49, 109, 248, 113}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 193, 79}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 123, 77, 40, 175, 10, 252}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 27, 136, 243, 126, 213}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 122, 163, 43, 49, 207}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 127, 250, 163, 174}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 58, 51, 203}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 35, 26, 237, 77, 157, 147, 8}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 57, 141, 234, 110, 62, 119}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 12, 216, 187, 101, 228}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 173, 55}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 152, 159, 113, 8}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 143}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 56, 110, 102}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 107, 85, 36}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 185, 126, 93, 90}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 113, 115, 71, 246}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 55, 89}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 29, 67, 240, 166, 11, 27}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 7, 84, 36, 12, 89, 253, 151}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 148, 112, 161}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 98}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 58, 157, 181, 159, 153}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 129, 34, 150, 150, 74}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 227, 36, 241}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 72, 95, 178, 225}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 75, 187, 14, 207}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 88, 157, 250, 28, 139}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 42, 11, 171, 77}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 145, 84, 218}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 80, 65, 80}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 180, 145, 39, 118, 158, 252}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 4, 209, 135}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 35}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 178, 98, 142, 121, 87, 94, 156}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 155, 249, 223}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 127, 229, 163}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 75, 103, 32, 217, 7, 224, 231}, 115},
	{{229, 221, 54, 216, 223, 27, 196, 1, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 161}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 140}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 50}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 224}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 253}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 52}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 120}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 83}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 59}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 112}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 75}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 207}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 245}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 254}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 20}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 113}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 55}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 19}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 203}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 252}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 174}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 8}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 204}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 101}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 178}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 79}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 132}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 169}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 67}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 250}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 123}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 29}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 178}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 208}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 0}, 130},
	{{5, 144, 176, 43, 180, 187, 20, 49, 59, 73, 108, 34, 83, 32, 192, 81}, 130},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 242, 248, 135, 248}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 149, 140, 189, 151, 112}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 87, 174, 161, 255}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 80}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 230}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 184}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 196, 104, 240, 245}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 242, 169, 27, 211}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 196}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 207, 243}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 112, 253, 91, 98}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 177}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 84, 108}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 236}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 125, 88, 163}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 29, 85, 122, 142}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 59, 54, 31}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 81, 252, 203, 235}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 107, 188, 89}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 62, 140, 110}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 82}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 249, 84, 138}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 40, 64, 67, 209}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 211, 230}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 238, 202, 117, 224}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 231, 149, 124}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 3, 142, 164}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 213, 152, 226}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 192}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 222}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 5}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 247, 173, 17, 60}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 213, 146}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 251}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 108, 52}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 122, 43, 154, 71, 239}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 161, 48, 251}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 159, 200, 163, 235}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 104, 91, 71}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 92, 34, 26, 255}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 94, 20, 63}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 91, 137, 249, 190}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 244}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 246, 19, 155}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 57, 164, 131, 72}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 106, 219}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 42, 227, 189, 53}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 31, 124}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 194, 18}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 139}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 230}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 11}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 95, 209, 20}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 91, 138}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 251, 242, 194}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 255}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 46, 233, 249}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 222, 173, 190}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 184, 106, 60, 209}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 208, 153}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 165, 192}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 25, 183, 40, 202}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 230, 177, 162}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 138, 139, 252}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 145, 206, 222, 109, 38}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 56, 106, 4}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 12, 176, 138, 54, 24}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 242, 15, 183}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 255}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 0, 0, 0}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 205, 4, 204, 134}, 57},
	{{24, 217, 205, 193, 74, 123, 160, 106, 103, 74, 200, 0, 0, 177, 61, 158}, 57},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 140, 214, 237, 123, 190, 46, 59}, 97},
	{{247, 0, 0, 0, 0, 43, 51, 191, 144, 161, 81, 224, 168, 217, 141, 102}, 97},
	{{247, 0, 0, 0, 21, 178, 93, 193, 183, 26, 232, 93, 206, 187, 207, 169}, 97},
	{{247, 0, 0, 0, 0, 0, 162, 28, 121, 30, 202, 206, 95, 233, 141, 208}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 167, 132, 156, 33, 149, 234, 236, 90}, 97},
	{{247, 0, 214, 103, 36, 163, 177, 175, 202, 21, 230, 114, 239, 41, 79, 216}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 114, 52, 86, 85}, 97},
	{{247, 0, 0, 0, 0, 27, 58, 22, 3, 75, 108, 38, 223, 20, 241, 55}, 97},
	{{247, 0, 0, 186, 39, 235, 78, 44, 255, 103, 227, 151, 129, 120, 219, 114}, 97},
	{{247, 0, 0, 0, 253, 153, 174, 114, 174, 36, 87, 149, 255, 139, 243, 193}, 97},
	{{247, 0, 0, 0, 239, 209, 174, 7, 125, 94, 172, 168, 80, 79, 198, 137}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 94, 248, 233, 159, 58, 107, 112, 191}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 33, 140, 128}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 27, 198, 247, 54, 42, 67, 245, 151, 101}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 103, 35}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 102, 30, 131, 151, 25, 99, 3, 120, 106}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 19, 5, 212}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 129, 200, 138, 213}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 33, 185, 54, 108, 103}, 97},
	{{247, 0, 0, 0, 0, 213, 104, 176, 75, 168, 39, 206, 70, 246, 23, 111}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 14, 56, 50, 32, 161}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 97},
	{{247, 0, 0, 0, 0, 0, 20, 34, 34, 50, 236, 227, 62, 38, 40, 19}, 97},
	{{247, 0, 0, 0, 219, 85, 32, 91, 171, 195, 116, 6, 247, 9, 54, 228}, 97},
	{{247, 0, 0, 0, 0, 0, 7, 244, 212, 216, 114, 139, 127, 222, 164, 224}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 139, 161, 19, 186, 129, 246, 254}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 25, 15, 188, 241, 244, 128, 26, 223, 93}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 236, 222, 35, 235}, 97},
	{{247, 0, 0, 0, 0, 0, 24, 120, 176, 18, 74, 82, 5, 25, 205, 181}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 116, 36, 148, 12}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 234, 244, 125}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 183, 53}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 163, 188, 234}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 21, 119, 55, 143, 96}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 128, 137, 154, 156, 58, 13, 66, 249}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 96, 202, 91, 176, 231}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 151, 150, 9, 87, 247, 46, 10, 150}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 197, 220}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 63, 231, 80}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 200, 255, 18, 82, 172, 15, 205, 219}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 231, 183}, 97},
	{{247, 0, 0, 0, 0, 0, 194, 32, 99, 203, 247, 240, 38, 121, 111, 223}, 97},
	{{247, 0, 0, 0, 0, 159, 95, 113, 133, 241, 43, 182, 112, 14, 150, 47}, 97},
	{{247, 0, 0, 0, 0, 0, 106, 19, 17, 183, 127, 17, 161, 74, 2, 227}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 108, 223, 28, 237, 6, 135, 130, 150, 116}, 97},
	{{247, 0, 143, 159, 71, 35, 125, 194, 27, 52, 39, 94, 57, 68, 44, 210}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 198, 251, 181, 231}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 143}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 173, 28, 135, 38, 29, 211, 242, 86}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 31, 242, 213, 9, 177, 51, 70, 207, 143}, 97},
	{{247, 0, 0, 153, 30, 48, 216, 95, 213, 107, 226, 198, 81, 117, 171, 32}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 160, 62, 151, 7, 235, 123, 142, 227, 100}, 97},
	{{247, 0, 0, 0, 220, 179, 16, 25, 54, 119, 203, 175, 113, 62, 72, 60}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 203, 93, 151, 171, 235}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 255}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 239, 41, 223}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 169, 63, 20}, 97},
	{{247, 0, 0, 65, 230, 51, 249, 222, 153, 198, 49, 143, 227, 168, 54, 245}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{247, 0, 0, 230, 5, 218, 162, 144, 53, 112, 101, 36, 58, 11, 24, 168}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 176, 0, 23, 255, 236, 148, 64, 93, 230}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 136}, 97},
	{{247, 0, 195, 64, 44, 89, 14, 229, 213, 33, 77, 61, 183, 62, 110, 37}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 19, 1, 205, 150, 202, 155, 52, 110}, 97},
	{{247, 0, 0, 159, 167, 18, 250, 25, 54, 147, 168, 161, 165, 226, 95, 135}, 97},
	{{247, 0, 0, 0, 0, 0, 146, 105, 228, 98, 221, 181, 168, 51, 226, 102}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 29, 248, 152, 123, 50, 169, 109}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 79, 25, 252, 200, 186}, 97},
	{{247, 0, 0, 221, 14, 191, 70, 151, 207, 97, 54, 125, 230, 217, 177, 43}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 32, 182, 208}, 97},
	{{247, 0, 211, 68, 211, 53, 175, 168, 133, 60, 138, 138, 109, 244, 53, 188}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 190, 192, 39, 246, 13}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 174, 183, 155, 231, 33, 224, 90, 106}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 172}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 157, 110, 72, 103, 86, 46, 29, 169}, 97},
	{{247, 0, 0, 0, 0, 0, 246, 29, 225, 212, 104, 16, 127, 164, 137, 233}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 211, 168, 239, 117, 51}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 183, 61, 17, 27}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 57, 172, 50}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 137, 239, 155}, 97},
	{{247, 0, 0, 0, 123, 136, 141, 238, 171, 117, 215, 106, 40, 153, 9, 248}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 97},
	{{247, 0, 0, 0, 0, 22, 166, 145, 72, 107, 161, 89, 153, 91, 124, 48}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 3, 120, 224, 76, 135}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 97},
	{{247, 0, 0, 0, 0, 0, 121, 112, 97, 172, 75, 166, 0, 150, 183, 96}, 97},
	{{247, 0, 0, 0, 0, 0, 195, 220, 125, 197, 222, 187, 82, 23, 189, 255}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 69, 73}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 81, 34, 120, 230}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 209, 180, 73, 106, 224, 40, 231, 64}, 97},
	{{247, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 97},
	{{247, 0, 0, 21, 98, 42, 111, 122, 101, 53, 58, 182, 78, 90, 211, 104}, 97},
	{{247, 0, 0, 0, 0, 90, 118, 180, 194, 132, 221, 212, 119, 253, 65, 120}, 97},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 114, 77, 210, 1, 122, 119, 207}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 193, 13, 88, 15, 230, 112, 28, 52, 181}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 16, 13, 103, 190, 9, 221, 2}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 245}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 49, 117, 63, 27, 94, 235, 79, 120, 211}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 237, 60, 53}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 7, 17, 178}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 152, 212, 34, 248, 49, 52, 127}, 146},
	{{12, 128, 0, 0, 0, 0, 87, 35, 202, 28, 103, 182, 173, 216, 44, 236}, 146},
	{{12, 128, 0, 202, 8, 222, 199, 68, 30, 214, 250, 190, 73, 86, 137, 58}, 146},
	{{12, 128, 0, 0, 224, 1, 72, 109, 211, 212, 10, 77, 27, 48, 28, 91}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 214, 212, 71}, 146},
	{{12, 128, 36, 205, 3, 18, 190, 123, 170, 240, 221, 223, 15, 26, 138, 31}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 114, 38, 77, 238, 18, 222, 124, 7}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 190, 226, 224, 192}, 146},
	{{12, 128, 0, 0, 65, 165, 189, 119, 181, 36, 34, 174, 230, 10, 131, 215}, 146},
	{{12, 128, 0, 93, 79, 24, 186, 252, 146, 6, 156, 186, 241, 233, 117, 156}, 146},
	{{12, 128, 0, 0, 235, 13, 90, 96, 73, 192, 47, 95, 66, 79, 57, 34}, 146},
	{{12, 128, 0, 0, 0, 55, 45, 224, 139, 220, 228, 132, 95, 6, 238, 170}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 56, 89, 136, 50, 133, 196, 220, 196}, 146},
	{{12, 128, 0, 0, 0, 0, 100, 207, 206, 11, 51, 206, 144, 54, 12, 210}, 146},
	{{12, 128, 0, 0, 0, 0, 133, 158, 183, 66, 42, 125, 60, 9, 77, 42}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 241}, 146},
	{{12, 128, 0, 0, 0, 0, 124, 123, 138, 147, 167, 222, 215, 63, 5, 35}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 31, 171, 253, 55, 220, 145}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 128, 0, 254, 91, 60, 223, 57, 163, 94, 38, 64, 22, 4, 149, 105}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 60, 216, 45, 224, 131, 187, 207}, 146},
	{{12, 128, 0, 0, 184, 171, 23, 249, 86, 182, 136, 89, 44, 163, 167, 33}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 237, 81, 27, 30, 211, 145, 211, 27}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 31, 151, 214, 93, 134, 94}, 146},
	{{12, 128, 0, 0, 9, 70, 6, 148, 172, 85, 107, 254, 75, 180, 186, 107}, 146},
	{{12, 128, 0, 0, 0, 151, 156, 203, 248, 59, 80, 147, 8, 17, 107, 53}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 62, 234}, 146},
	{{12, 128, 41, 117, 158, 189, 86, 92, 230, 141, 208, 93, 80, 4, 33, 201}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 97, 170, 155, 19, 20, 47, 96, 33}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 1, 241, 14, 49, 182, 144, 141, 149}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 235, 116, 53, 67, 63, 160, 2, 96, 234}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 62, 173, 175, 177, 179, 154, 91}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 221, 21, 97, 230, 127, 187, 148, 118}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 77, 150, 8, 104, 46, 125}, 146},
	{{12, 128, 0, 127, 192, 86, 63, 221, 63, 66, 149, 51, 248, 153, 71, 100}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 61}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 24, 84, 131, 17, 129, 213}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 194, 6, 25}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 162, 186, 122, 252}, 146},
	{{12, 128, 0, 0, 44, 218, 198, 187, 57, 192, 70, 31, 71, 13, 158, 126}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 171, 41, 217}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 128, 0, 29, 36, 252, 102, 138, 47, 165, 44, 218, 232, 213, 229, 158}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 165, 47, 79, 211, 169, 184, 12, 88, 192}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 116, 78, 95, 193}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 209}, 146},
	{{12, 128, 0, 0, 0, 0, 234, 77, 226, 255, 212, 22, 234, 219, 167, 240}, 146},
	{{12, 128, 0, 0, 0, 0, 122, 129, 157, 104, 81, 31, 120, 213, 248, 118}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 24, 58}, 146},
	{{12, 128, 0, 124, 131, 114, 245, 45, 220, 30, 83, 84, 149, 188, 178, 247}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 208, 75, 214, 186, 186, 74, 139}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 91, 155, 188, 237, 56, 196, 60, 211, 77}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 100, 2, 169, 238, 145, 112, 221, 13}, 146},
	{{12, 128, 0, 248, 246, 62, 44, 87, 255, 187, 181, 89, 200, 95, 105, 21}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 91, 80, 100, 14, 26, 171}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 120, 93, 226, 189, 59, 59, 134, 214, 147}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 137}, 146},
	{{12, 128, 0, 59, 93, 173, 9, 131, 37, 43, 30, 117, 159, 181, 227, 65}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 120, 67}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 187}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{12, 128, 0, 0, 26, 55, 121, 169, 193, 142, 92, 207, 212, 204, 136, 61}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 56, 132, 89, 222}, 146},
	{{12, 128, 252, 155, 188, 6, 106, 157, 112, 31, 20, 201, 137, 235, 152, 68}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 115}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 212, 0}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 160, 82, 92, 134, 94, 209, 4, 41}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 210, 252}, 146},
	{{12, 128, 9, 28, 199, 107, 27, 19, 59, 32, 113, 149, 52, 103, 71, 207}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 98, 126, 243, 109}, 146},
	{{12, 128, 0, 0, 0, 72, 11, 234, 142, 13, 218, 223, 98, 89, 28, 251}, 146},
	{{12, 128, 0, 0, 0, 0, 28, 166, 163, 173, 31, 234, 142, 71, 224, 111}, 146},
	{{12, 128, 230, 232, 213, 21, 255, 92, 87, 232, 234, 43, 64, 118, 87, 121}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 149, 112, 39, 160, 24, 219, 80}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 52, 22, 175, 13, 209, 79}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 172, 184, 251, 172, 111, 34, 228}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 68, 114, 207, 236, 23, 101, 52}, 146},
	{{12, 128, 0, 238, 61, 200, 237, 108, 152, 174, 119, 68, 206, 37, 154, 140}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 109, 51, 250, 171}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 214, 126, 71, 84, 240, 244, 188, 74, 55}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 58, 87, 185, 232, 60, 163, 175, 5, 29}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 141, 88}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 90, 57, 129}, 146},
	{{12, 128, 0, 0, 24, 197, 182, 234, 187, 104, 195, 102, 158, 153, 115, 21}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 182}, 146},
	{{12, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 7, 125}, 146},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 249}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 18}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 117}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 144}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 174}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 116}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 142}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 137}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 14}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 128}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 253}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 101}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 231}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 183}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 57}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 142}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 52}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 218}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 182}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 9}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 153}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 249}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 93}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 52}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 5}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{160, 28, 201, 119, 148, 93, 251, 118, 28, 179, 123, 52, 71, 232, 48, 0}, 194},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 29}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 19}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 136}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 7}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 17}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 99}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 231}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 3}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 195}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 148}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 53}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 46}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 70}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 242}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 75}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 66}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 142}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 134}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 204}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 133}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 35}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 87}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 196}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 239}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 33}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 229}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 84}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 166}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 1}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 74}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 87}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 196}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 60}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 84}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 177}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 249}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 33}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 154}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 126}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 184}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 0}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 83}, 129},
	{{152, 126, 17, 54, 101, 56, 130, 1, 205, 41, 207, 90, 151, 123, 128, 76}, 129},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 179, 99, 251}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 102, 130, 229}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 66, 32}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 114, 211}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 215, 190, 205}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 31, 165, 86}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 96, 91}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 182}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 52, 91}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 238, 105}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 144, 85}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 227, 109}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 81, 132}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 207}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 182, 59, 65}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 198, 224, 87}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 31}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 162, 88}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 150, 245, 147}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 177}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 94}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 138, 162}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 2, 250}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 241, 87}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 138, 180}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 82, 133, 147}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 42}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 193, 24, 43}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 4, 93}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 121, 101}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 91, 176}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 206}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 161, 126}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 76, 131}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 21, 225}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 130, 207, 210}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 70}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 7}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 129}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 45}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 173, 251}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 215, 6, 203}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 112, 10}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 25}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 162, 131}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 252, 205}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 132, 53}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 12}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 235, 223, 30}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 116, 147, 76}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 189, 253, 107}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 29, 5}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 19, 216, 31}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 226, 217}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 92, 76}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 175, 128, 57}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 53, 66}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 160}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 135, 130}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 253, 13, 9}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 25, 31}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 206, 65, 211}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 56}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 119, 11, 206}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 134, 40, 125}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 16, 38}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 160, 56}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 192, 164}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 116}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 252}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 30}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 197, 207, 184}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 13, 190}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 168, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 23, 133}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 117, 20, 129}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 0}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 249}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 0, 230}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 232, 207}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 116, 61}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 230, 69}, 159},
	{{77, 165, 29, 239, 95, 242, 34, 1, 11, 204, 135, 239, 128, 0, 252, 86}, 159},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 175}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 202}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 226}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 161}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 80}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 123}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 207}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 223}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 196}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 169}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 198}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 181}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 185}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 11}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 185}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 33}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 204}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 134}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 188}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 232}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 34}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 37}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 81}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 72}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 234}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 239}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 82}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 188}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 255}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 166}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{183, 108, 146, 118, 74, 190, 7, 141, 9, 92, 2, 2, 8, 218, 120, 0}, 242},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 116, 8}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 40, 231}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 234, 213}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 75, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 179, 86}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 241, 144}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 16}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 159}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 14, 61}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 25, 238}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 126, 228}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 158}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 103}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 194, 162}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 200}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 184, 132}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 116, 110}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 193}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 144}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 68, 157}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 164, 13}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 165}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 207, 246}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 34}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 176}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 247, 155}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 132}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 11, 176}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 234, 234}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 82}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 236}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 8, 85}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 65}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 143}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 182, 156}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 117, 164}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 104}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 19, 128}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 20}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 217, 60}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 88}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 183}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 73, 187}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 62, 69}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 182}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 196, 186}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 106}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 203, 2}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 140}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 136, 87}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 28}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 154}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 132}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 186}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 179, 191}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 20, 72}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 93, 78}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 206, 88}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 101, 159}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 197}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 53}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 136}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 59, 57}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 233}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{37, 152, 29, 239, 242, 53, 56, 143, 219, 22, 14, 158, 49, 0, 0, 0}, 162},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 207}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 2, 228}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 190, 14}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 76}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 64}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 166}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 36, 38}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 158}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 216}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 60, 85}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 141, 145}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 14, 97}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 119}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 13, 41}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 240, 72, 68}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 211, 75}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 28, 216}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 44}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 53, 139}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 108}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 186}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 231, 21, 49}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 92, 222}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 160, 46}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 174, 13}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 172}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 1}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 3}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 209}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 173, 8, 110}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 199, 68}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 227, 113, 183}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 216, 133}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 27}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 133}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 155}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 235}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 132}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 22, 184}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 189}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 188, 165, 104}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 23, 134}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 28, 138}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 56, 220}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 204, 96}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 183, 133}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 34, 94}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 171, 82}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 223}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 221}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 97, 225}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 116, 114}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 127, 12}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 153}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 23, 139}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 56}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 251, 240, 120}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 197}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 23}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 153, 102}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 88, 236, 3}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 29}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 188}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 61, 39}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 122, 64, 218}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 152, 207}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 1}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 215}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{198, 53, 241, 102, 240, 244, 97, 203, 62, 128, 213, 214, 220, 0, 0, 0}, 140},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 100}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 128}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 232}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 78}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 186}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 199}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 208}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 180}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 210}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 150}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 200}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 107}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 236}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 54}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 1}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 137}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 175}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 89}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 118}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 27}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 148}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 161}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 62}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 234}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 153}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 184}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 225}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 20}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 25}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 146}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 14}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 224}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 43}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 140}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 255}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 18}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 26}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 236}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 147}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 148}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 239}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 0}, 77},
	{{144, 89, 48, 42, 249, 231, 189, 178, 232, 199, 30, 58, 63, 57, 0, 177}, 77},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 99, 188, 217, 142, 90}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 212}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 18, 164, 148}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 18, 117, 244, 36, 69}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 134, 120, 47}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 125}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 24, 220}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 181, 167}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 48, 183}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 238}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 71, 253, 161}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 103, 26, 193, 26}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 119, 203, 215, 11, 1}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 82}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 113, 199}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 165, 67}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 160, 161, 88, 188, 244}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 201, 164, 62, 21}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 130, 249, 57}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 26, 136, 185, 81}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 247}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 31, 77}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 123}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 28, 154, 197, 215, 3}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 156, 244, 216, 131, 247}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 131, 147}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 25, 50, 127}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 21, 44, 134, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 201, 146, 77}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 49, 218, 136, 176, 30}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 26, 109, 253, 127, 222}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 169, 69, 254}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 109, 39, 9, 178}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 240, 73, 16, 129}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 113, 53, 56, 254}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 188, 214, 113}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 170, 142, 166, 13}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 175, 121, 231}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 37, 63, 91, 130}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 145, 194, 64, 178, 130}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 132, 175}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 62, 102, 203}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 64, 71, 223, 142}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 199, 58}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 160, 154, 176, 180, 167}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 94, 162, 212, 57, 54}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 94, 75}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 76, 22, 136, 163}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 153, 78, 199}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 79}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 24, 177, 233, 29, 172}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 39, 151, 91, 228}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 24, 42}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 143}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 14, 25, 86}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 235, 245, 31}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 50, 13}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 138, 128, 114, 204}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 181}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 191, 156, 155, 218}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 6, 173, 176}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 128, 204, 231, 138, 129}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 78, 239, 140, 179, 106}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 115, 24, 16}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 18}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 100, 73, 7, 135}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 51, 108, 218}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 253}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 174, 89}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 195, 2, 140, 92}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 182}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 117, 128, 205, 157}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 189, 162, 107, 133}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 136}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 33, 220, 55}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 230, 153, 247, 232, 166}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 209}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 64}, 121},
	{{68, 212, 177, 123, 44, 224, 19, 172, 89, 87, 192, 0, 0, 0, 0, 0}, 121},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 221}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 241, 188, 162, 22}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 142}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 239, 159, 96, 139, 52, 250}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 38}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 217, 17, 45, 229, 40}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 194, 176, 74, 35, 244}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 12, 202, 239, 14, 96, 10}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 172, 101, 133, 255, 95, 68, 95}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 39, 55, 245, 212, 229, 47}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 201, 213}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 20, 85}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 166}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 8}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 14, 225, 61}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 77, 139, 196}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 132, 10}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 137}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 29, 225, 17, 127, 121, 12}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 20, 8, 80, 241}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 38, 50}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 164, 193, 111, 136, 232, 117}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 173, 56, 26, 143, 69}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 247, 240}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 151, 159, 45}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 194}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 187, 157, 83}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 206}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 56, 155}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 88}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 223, 160, 158}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 45, 145, 28}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 84, 3, 134, 63}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 29, 53, 64, 111, 206}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 227, 44}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 154, 112, 29, 38, 147}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 77, 50, 91, 2}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 37, 183, 67, 213, 240, 78}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 229, 230, 201}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 178, 151, 125}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 23, 197}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 99, 180, 229, 225}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 210}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 55, 32, 8, 177}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 238, 230, 160, 33, 22, 218}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 197, 119}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 84, 224, 181}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 26, 125, 189, 150}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 85, 230, 229, 8}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 27, 16}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 202, 188, 154, 154, 69, 109}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 131, 7, 136, 164, 225}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 72, 201}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 232}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 59, 198, 43}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 92, 102}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 133, 228, 50}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 103, 196, 21, 3, 104, 47, 80}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 42}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 48, 11, 124, 217}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 166, 47}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 233, 13}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 254, 248, 79, 214}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 228}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 61, 194, 133, 252}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 135}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 202, 137, 157, 179}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 86, 72, 191, 188, 82, 116}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 132, 177, 53, 120}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 219, 88, 127, 249, 21, 247}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 168}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 254, 63, 192, 216, 162}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 72, 171, 197, 125}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 231, 100}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 174, 244, 145}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 241}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 6, 63, 157}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 63, 189, 44}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 37, 125, 123, 142}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 188, 173}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 115, 208, 183, 55}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 115, 103, 135, 198, 33}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 190, 102}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 193, 57, 87, 248, 204, 218}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 138, 251, 119, 84, 209, 204}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{252, 29, 179, 224, 4, 121, 205, 67, 152, 0, 0, 0, 0, 0, 231, 29}, 102},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 133, 10, 116, 99, 253, 26}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 88, 215, 199, 64, 54, 218, 82}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 87, 76, 237}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 2, 47}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 122, 224, 153, 133, 20, 254, 131}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 65, 136, 97, 110, 139}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 68, 4, 46, 173, 110, 192, 255}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 54, 30}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 38, 7, 187, 7, 98, 247, 142, 32, 51}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{28, 110, 164, 0, 39, 63, 227, 52, 84, 111, 114, 214, 77, 178, 78, 165}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 209}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 138, 236, 30, 207, 151, 109}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 25, 190, 141}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 109, 129, 7}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 139, 155, 19, 16, 188, 248}, 28},
	{{28, 110, 164, 0, 0, 0, 226, 134, 36, 49, 145, 252, 198, 133, 55, 62}, 28},
	{{28, 110, 164, 0, 1, 102, 49, 43, 143, 126, 208, 23, 153, 110, 247, 136}, 28},
	{{28, 110, 164, 0, 250, 122, 133, 65, 226, 193, 2, 46, 231, 91, 180, 166}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 252, 153, 210}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 168, 58, 95, 112, 121}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67}, 28},
	{{28, 110, 164, 0, 0, 109, 201, 164, 213, 9, 93, 246, 14, 107, 112, 252}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 5, 220, 73, 157, 32, 216, 132, 117}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 238, 212, 118, 139, 255, 170, 222, 207, 123}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 213}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 41, 151, 224, 123, 158, 182, 95, 85, 229}, 28},
	{{28, 110, 164, 0, 0, 0, 123, 120, 45, 229, 21, 218, 6, 168, 111, 174}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 84, 183, 157, 127, 44, 254, 220}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 105, 10, 189, 121, 151, 228}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 118, 132, 176, 223, 87, 120}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 192, 130}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 35, 134, 249, 120, 183, 62}, 28},
	{{28, 110, 164, 0, 168, 54, 195, 13, 211, 68, 241, 124, 226, 182, 88, 150}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 233, 227, 5, 10, 136}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 235, 251, 156, 47, 222, 103}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 108}, 28},
	{{28, 110, 164, 0, 0, 0, 163, 26, 241, 46, 8, 209, 41, 251, 163, 107}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 180, 75}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 192, 245}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 116, 55, 172, 69, 156, 160, 245, 207, 77}, 28},
	{{28, 110, 164, 0, 160, 252, 46, 237, 117, 38, 106, 184, 16, 121, 209, 64}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 241, 62, 40, 175, 139, 43, 98, 245}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 30, 98, 216, 174, 150, 89, 192, 76, 63}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 160, 9, 39}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 180, 144}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 225}, 28},
	{{28, 110, 164, 0, 0, 0, 83, 32, 15, 141, 15, 136, 93, 15, 151, 27}, 28},
	{{28, 110, 164, 0, 0, 207, 78, 43, 89, 150, 59, 2, 130, 152, 87, 22}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 191, 1, 68, 79, 165, 138}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 213, 228, 131, 240, 170}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 106, 192, 76, 103, 193}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 198, 52, 18, 186, 137}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 189, 254, 246, 65, 127}, 28},
	{{28, 110, 164, 0, 0, 110, 43, 100, 6, 133, 20, 252, 75, 50, 189, 227}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 126, 164, 183, 218, 66, 190, 185, 206, 34}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 211, 168, 39, 254, 134, 210, 85}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 238, 88, 74, 35, 94, 172, 200, 243, 154}, 28},
	{{28, 110, 164, 0, 0, 0, 139, 247, 118, 141, 171, 225, 41, 147, 203, 173}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 235, 85, 207, 172, 3, 89, 49}, 28},
	{{28, 110, 164, 0, 0, 146, 130, 5, 149, 2, 10, 235, 111, 66, 76, 93}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 17, 175, 220, 30, 39, 63}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 105, 221, 50}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 54, 57, 201, 175, 77}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 121, 142, 249}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 65, 81, 26, 97, 150}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 7, 45, 23}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 243, 79, 166, 64, 91, 19}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 120, 133, 103, 165, 183, 76, 184}, 28},
	{{28, 110, 164, 0, 108, 168, 159, 237, 225, 8, 196, 139, 193, 54, 74, 131}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 193, 149, 122, 251, 117, 168}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 62, 134, 27, 25, 163, 106, 214}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 16, 183}, 28},
	{{28, 110, 164, 0, 0, 0, 191, 96, 54, 113, 61, 155, 212, 206, 124, 154}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 101, 54, 25}, 28},
	{{28, 110, 164, 0, 0, 0, 135, 118, 200, 67, 46, 113, 117, 135, 111, 39}, 28},
	{{28, 110, 164, 0, 85, 130, 30, 11, 152, 92, 203, 240, 49, 120, 144, 246}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 62, 234, 255, 68, 151, 120, 130, 205, 11}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 175, 244}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 236, 109, 182, 4, 182, 194, 223, 29, 154}, 28},
	{{28, 110, 164, 0, 0, 0, 148, 133, 252, 165, 59, 140, 222, 188, 238, 69}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 143, 213, 15}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 114, 101, 11, 24, 37, 19, 235, 107}, 28},
	{{28, 110, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 229, 0}, 28},
	{{28, 110, 164, 0, 148, 66, 17, 159, 163, 79, 15, 17, 132, 235, 43, 87}, 28},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 7, 155, 115}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 140}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 162, 167, 43}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 173, 120, 243, 97}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 106, 146, 234, 151}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 82, 64}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 78, 160}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 188}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 67, 168, 117, 90}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 154, 137, 139, 63}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 171}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 133}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 68, 208, 130, 112}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 102, 240, 162}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 221, 61, 77, 7}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 219, 90}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 37}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 201, 164}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 195, 232, 211}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 49}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 211}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 25}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 206, 111}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 196, 237}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 31, 210, 208, 113}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 247, 14, 12}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 139, 153, 121, 121}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 42}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 178, 82, 243}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 231, 253}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 155, 131, 147, 215}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 74, 177}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 103, 223}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 157, 45}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 146, 132}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 47, 58}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 191, 66}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 240, 211, 253}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 132}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 147, 29, 56}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 47, 213, 191}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 191, 21, 184, 15}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 42}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 159}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 28, 205, 14}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 198}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 207, 40, 27}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 78, 87, 147, 128}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 222, 210}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 241, 19, 114, 54}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 150, 132}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 110}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 84, 87, 144}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 102, 71, 119}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 254, 43, 193}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 88, 115, 174}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 59, 54, 98}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 216}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 108, 182, 17, 48}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 85, 69, 213}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 186, 113, 83}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 153, 58, 50}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 57}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 254, 127, 46}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 3, 203, 182, 252}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 0, 0}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 146, 116}, 154},
	{{24, 88, 231, 1, 4, 71, 71, 241, 252, 14, 197, 0, 0, 0, 15, 27}, 154},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 171, 213, 226}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 248, 228, 194, 7, 212}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 191}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 70, 77, 46, 114, 79, 224}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 19, 88, 133, 15, 145, 213}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 10}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 231, 97, 116}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 213, 204}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 120, 44, 18, 40}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 172, 132, 161, 93}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 68, 73}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 53, 210}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 134, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 107, 62, 175, 74, 3, 185}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 115, 144, 9, 152, 111}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 94, 2, 128}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 187}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 144}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 200, 79, 152, 47, 127}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 166, 170, 216, 137}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 230, 106, 183, 60, 48}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 25}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 154}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 47, 148}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 126, 156, 202}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 50, 121}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 208, 60, 106, 70, 123}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 73}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 115, 213}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 106, 105}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 7, 152, 170, 178}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 193, 249, 36}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 62, 91, 31, 27, 203, 37}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 176}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 123, 190, 111, 53, 157, 104}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 111, 6, 85, 52, 201}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 160, 44, 77, 12, 75, 104}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 106, 246, 72, 194, 222}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 136, 93}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 206, 149, 96}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 24, 36, 122, 19}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 191, 144, 136, 25}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 196}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 75, 203, 75, 25, 8, 75}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 225, 221, 72, 149}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 44, 117}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 202, 255, 73, 33}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 81, 38, 193, 205, 1}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 157, 210, 166, 105}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 176, 194, 33, 235, 59}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 62, 253, 50, 243, 74}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 109, 230, 34, 31, 226}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 31, 109}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 131, 180, 16, 100}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 217, 157, 38}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 255, 91}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 83}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 109, 149, 1, 251, 176, 167}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 154, 25, 29, 124, 150}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 163, 181, 63, 99}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 173}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 190}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 80, 52}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 119, 102, 197}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 107, 59, 130, 165, 120, 41}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 123, 96, 1}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 145}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 144, 103, 205, 102, 120, 186}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 29, 129, 158}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 231, 220, 247, 198}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 164, 79, 203}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 148, 192}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 4}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 38, 174}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 207, 76}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 153, 5, 185, 147}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 108, 110}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 0}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 101}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 43}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 138}, 39},
	{{63, 131, 43, 76, 58, 140, 163, 74, 158, 80, 0, 0, 0, 0, 0, 71}, 39},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 32, 41, 75, 100, 140}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 28, 127, 76, 101, 26}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 2, 223, 58, 128, 94}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 206, 40, 93, 65, 173}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 121, 154, 42, 100}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 170}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 38, 223, 87, 88}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 124, 91, 223, 241, 18}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 138, 4, 115, 186, 162}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 129, 161}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 178, 21}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 126, 254, 55}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 160, 105, 240, 108, 145}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 51, 199, 101}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 135, 244, 218}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 12, 132, 42}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 21, 245, 26, 127}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 106}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 215}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 95, 155, 244, 102}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 243}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 89, 195, 8, 252, 48}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 253, 63, 4, 15, 95, 50}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 4, 101}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 229, 96}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 189, 204}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 102, 253, 213, 150, 94, 120}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 68}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 129, 143, 206, 15}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 231, 229, 160, 147}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 40, 0, 148}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 212, 106}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 218, 44, 5, 115, 154}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 10, 190, 149, 102}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 135, 192}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 76, 218}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 237, 23, 52, 69}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 211, 221, 32, 206, 48}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 70, 9, 120, 119, 169}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 195, 167}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 145}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 34, 115}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 250, 144, 140, 154}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 8}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 151}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 255, 218}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 53, 73}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 87, 76, 56, 235, 64}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 38, 131, 55, 216, 237}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 24, 100, 23, 230, 52, 74}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 109, 209}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 228, 89, 238}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 224}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 153, 183, 6, 114}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 227, 10}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 198, 196, 72, 5}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 76, 215}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 48}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 244, 83}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 94, 8, 173}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 234, 224}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 123, 245, 188}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 31, 20, 249, 97, 49}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 240, 103, 250, 238}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 196, 228, 49}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 222, 77, 217, 26}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 155, 109, 183, 58}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 160, 103, 105}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 236, 96, 171, 53, 181}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 180, 42, 253, 170}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 71}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 5}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 9, 93, 249, 28, 142}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 192, 254}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 198, 112, 165, 118, 255}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 138}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 0}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 75, 240, 109}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 190, 254, 119, 105}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 18, 208, 235, 117}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 218, 211, 10}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 79, 72, 91}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 0, 92}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 36, 74}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 1, 129, 9}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 16, 211, 11, 62, 151, 98}, 163},
	{{56, 28, 147, 149, 98, 93, 216, 216, 203, 156, 0, 0, 0, 0, 19, 49}, 163},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 81}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 87}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 25, 89, 200, 188, 112, 245, 140}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 144, 115, 28, 226, 216, 216, 41}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 65, 11, 213, 5, 195, 105}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 149, 172, 96, 143, 20}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 163, 50, 65, 189, 207, 118, 228}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 132, 80, 200, 86, 101}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 250, 42, 98, 12, 26, 2}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 98, 248, 34, 199, 192}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 200, 25, 146, 138, 140, 217}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 57, 96, 19, 40}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 35, 103}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 195, 222, 16, 111, 20, 6, 138}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 169, 164, 225, 223}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 250, 52, 105, 240, 69, 247}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 43, 56, 126, 134, 159}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 183, 253, 172, 149}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 5}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 51, 110, 113, 222, 185, 105}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 169, 166, 212, 147, 122, 46}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 144, 58, 135, 153}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 99, 173}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 239, 242, 70, 165, 147}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 57}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 165, 219, 93, 57, 103}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 96, 250, 222}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 163, 74, 8, 107, 228, 56}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 40}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 72, 209, 43}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 105}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 22, 176, 100, 178, 34, 237}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 63, 175, 155, 8, 93, 187, 245}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 223, 149, 150, 158}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 199}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 61, 143, 163}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 163, 138, 19, 82, 159}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 55, 230, 54, 118}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 147, 63, 76}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 10, 104, 229, 11}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 189, 155, 15, 252}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 196, 134, 180, 115}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 103, 135, 159, 102, 5, 224, 194}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 210, 72, 121, 55, 58, 82}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 167}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 15, 199, 68, 236, 190, 143}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 129, 8, 253, 82}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 72, 58, 234, 43, 189}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 179, 93, 226, 143, 108}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 99, 146, 31, 28, 24, 207, 150}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 27, 84, 135, 0, 182, 138}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 97, 201, 16}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 12}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 230, 197, 54, 225}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 164, 63, 255, 127, 134}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 210, 77, 144, 97}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 189}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 147, 109, 39, 114}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 140, 16, 13, 112, 155, 83}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 206, 86, 165, 247, 23}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 172, 184, 42, 101, 164, 209, 111}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 142, 164, 22, 25, 74, 179}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 210, 203}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 118, 74, 160}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 138, 216, 118, 239}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 195, 120, 191}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 223, 112, 62, 52, 132}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 229, 140, 174, 222, 163, 111}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 167, 58, 86}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 42, 145, 14, 36, 205}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 201}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 126, 123, 69, 131}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 235, 117}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 6, 222, 143}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 222, 210}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 67, 125, 245}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 162, 154, 63, 3, 167}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 99, 243, 208, 107, 251}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 142, 101, 13, 201}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 177, 134, 174, 185, 13}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 62, 192, 42, 51}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 53, 112, 3}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 77, 217, 247, 29}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 125, 14, 38}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 220, 65, 92, 60, 86, 15, 14}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 0, 0, 101}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 93, 175, 200, 241}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 53, 54, 193, 200}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 0, 0, 0, 174, 217, 127}, 42},
	{{134, 169, 6, 103, 161, 244, 134, 117, 16, 0, 32, 226, 127, 174, 122, 230}, 42},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 114, 148, 187, 172}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 37, 101, 239}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 147, 141, 121}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 114, 222}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 131, 227, 68}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 57, 103, 237}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 13, 58, 131}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 231, 200, 44}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 49}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 30, 179, 217}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 49, 189, 103}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 17, 164, 241}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 27, 203}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 18, 75, 5, 198}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 246, 10, 63}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 31}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 11}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 109}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 118}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 134, 74, 172}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 248}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 108, 132, 88}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 114}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 82, 213, 208}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 222}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 136, 72, 153}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 205}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 142}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 149}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 89, 248, 196}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 57}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 193, 177, 132, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 54, 101}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 227, 223, 82, 158}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 82}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 15, 210, 153}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 104, 206, 183, 188}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 125, 22, 135}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 233, 174, 40}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 48, 238, 131}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 198, 129}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 95, 243, 32}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 117}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 190, 190}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 179, 8}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 4, 222, 247, 146}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 203}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 190, 92, 172}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 87, 12, 17, 123}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 39}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 55}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 146, 159, 183}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 101, 242, 76}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 66, 229, 206, 160}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 76}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 204}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 194, 141}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 201, 113, 141}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 152, 153}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 220, 179}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 116, 42}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 124, 218, 146}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 166, 29}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 207, 148, 43, 164}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 157}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 166, 107}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 237}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 162}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 119, 120, 35, 191}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 16, 172, 71}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 41, 241, 143, 5}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 0, 0}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 0, 26, 94}, 207},
	{{143, 247, 125, 190, 106, 50, 204, 98, 250, 151, 161, 96, 0, 185, 180, 213}, 207},
	{{235, 0, 0, 82, 225, 179, 154, 162, 0, 223, 178, 246, 219, 74, 150, 216}, 25},
	{{235, 0, 0, 0, 135, 33, 152, 139, 171, 36, 11, 89, 194, 150, 244, 241}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 134, 75, 45, 156, 2, 250, 28}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 172, 29, 92, 172, 5}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 1, 237, 199, 166, 74, 99, 186, 176, 89}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 104, 58, 98, 14, 81, 71, 114, 102}, 25},
	{{235, 0, 92, 137, 81, 46, 230, 84, 170, 24, 83, 119, 232, 199, 149, 240}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 132, 178, 138, 134}, 25},
	{{235, 0, 0, 0, 0, 0, 7, 241, 0, 156, 171, 177, 38, 237, 16, 252}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 106}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 14}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25},
	{{235, 0, 0, 0, 0, 105, 223, 19, 136, 208, 152, 26, 253, 208, 119, 137}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 52, 136, 236, 53, 55, 173, 225, 208, 15}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 120, 66, 110}, 25},
	{{235, 0, 0, 0, 0, 0, 155, 145, 211, 44, 130, 4, 142, 98, 7, 98}, 25},
	{{235, 0, 0, 0, 0, 1, 171, 214, 16, 61, 108, 82, 66, 84, 139, 43}, 25},
	{{235, 0, 0, 109, 96, 132, 28, 70, 185, 207, 41, 107, 88, 108, 11, 195}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 186, 92, 202, 206}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 126, 239, 179, 206, 60, 252, 73, 26}, 25},
	{{235, 0, 0, 0, 0, 243, 143, 12, 95, 82, 14, 113, 125, 84, 173, 5}, 25},
	{{235, 0, 185, 168, 181, 26, 123, 18, 194, 100, 200, 115, 97, 190, 4, 51}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 28, 40, 251}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 26, 44, 111, 100, 173, 171, 15}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 127, 126, 60, 165, 230, 175, 80, 220, 25}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 87}, 25},
	{{235, 0, 0, 0, 219, 73, 131, 51, 142, 86, 11, 173, 149, 222, 234, 55}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 141, 211, 31, 31, 13}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 234, 85, 96, 208, 202, 237, 227}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 56, 67, 95, 152, 37, 115, 160}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 221, 65}, 25},
	{{235, 0, 0, 127, 177, 209, 157, 21, 183, 129, 7, 137, 130, 172, 168, 214}, 25},
	{{235, 0, 0, 0, 0, 0, 103, 20, 51, 248, 248, 228, 36, 75, 81, 191}, 25},
	{{235, 0, 0, 0, 0, 0, 25, 227, 52, 5, 23, 71, 74, 127, 173, 114}, 25},
	{{235, 0, 73, 187, 8, 176, 138, 116, 108, 89, 93, 30, 179, 62, 7, 174}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 85, 217, 109, 80, 28, 33, 209}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 95, 38, 236, 45}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 81, 24, 57, 191, 37, 63, 234, 6, 20}, 25},
	{{235, 0, 0, 0, 214, 201, 120, 247, 104, 109, 170, 87, 205, 226, 174, 154}, 25},
	{{235, 0, 0, 0, 68, 191, 231, 236, 241, 255, 109, 21, 163, 214, 176, 105}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 249, 61, 243, 55, 102, 188, 66}, 25},
	{{235, 0, 0, 0, 0, 0, 70, 245, 213, 173, 30, 217, 23, 129, 100, 195}, 25},
	{{235, 0, 0, 0, 0, 201, 173, 87, 16, 125, 229, 59, 110, 237, 51, 80}, 25},
	{{235, 0, 0, 0, 0, 0, 102, 128, 0, 228, 124, 179, 193, 99, 178, 229}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 85, 190, 145, 60, 42}, 25},
	{{235, 0, 222, 70, 219, 193, 238, 214, 237, 198, 139, 138, 42, 28, 56, 188}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 182, 228, 58, 202, 126}, 25},
	{{235, 0, 0, 0, 183, 245, 2, 65, 225, 110, 117, 228, 140, 105, 69, 192}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 60}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 121, 107, 217}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 87, 164, 161, 191, 175, 197, 87, 230, 81}, 25},
	{{235, 0, 0, 0, 0, 74, 65, 53, 186, 231, 41, 96, 163, 24, 253, 115}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 31, 51, 234}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 191, 106, 80, 46, 139, 54, 7}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 189, 132}, 25},
	{{235, 0, 0, 0, 92, 212, 194, 204, 27, 234, 222, 221, 150, 45, 26, 248}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 164, 227, 189, 33, 133, 7, 199, 73}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 190, 132}, 25},
	{{235, 0, 36, 196, 13, 244, 156, 140, 143, 55, 207, 120, 4, 109, 69, 145}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 239, 148, 130, 139, 220, 89, 79}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 196, 137}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 75, 64, 59, 225, 241, 77, 76, 252, 65}, 25},
	{{235, 0, 0, 114, 39, 96, 58, 168, 123, 188, 55, 91, 185, 180, 128, 245}, 25},
	{{235, 0, 0, 0, 0, 41, 183, 43, 80, 219, 247, 27, 184, 41, 71, 147}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 78, 97, 230, 56, 26, 172, 15}, 25},
	{{235, 0, 0, 15, 209, 176, 145, 140, 39, 217, 194, 178, 77, 32, 8, 49}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 113, 51, 51, 233, 117, 16, 18}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 5}, 25},
	{{235, 0, 0, 0, 114, 237, 92, 49, 3, 238, 100, 139, 58, 16, 114, 70}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 163, 158, 18, 52, 40}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 62, 188, 186, 181, 21}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 144, 204, 150, 194, 85}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 166, 114}, 25},
	{{235, 0, 0, 136, 15, 191, 48, 168, 167, 4, 33, 41, 36, 135, 130, 3}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 32, 68, 149, 89, 88, 120, 91, 202, 120}, 25},
	{{235, 0, 0, 0, 200, 199, 232, 177, 211, 133, 158, 16, 152, 192, 217, 18}, 25},
	{{235, 0, 0, 102, 151, 172, 59, 128, 115, 173, 94, 252, 163, 182, 77, 221}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 218, 143, 46, 13, 70}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 146, 179, 248, 90}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 41, 137, 179, 174, 151, 182, 46}, 25},
	{{235, 0, 146, 11, 228, 16, 149, 136, 225, 74, 180, 86, 179, 96, 243, 54}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 117}, 25},
	{{235, 0, 0, 0, 0, 0, 234, 30, 125, 8, 46, 152, 119, 186, 106, 59}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 252, 98, 4, 72, 11, 121, 72, 199}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 93, 28, 154, 65, 221, 225, 88, 56}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 37, 144, 100, 156, 173}, 25},
	{{235, 0, 0, 0, 0, 0, 171, 96, 122, 107, 65, 144, 153, 169, 190, 84}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 121, 127}, 25},
	{{235, 0, 0, 0, 0, 0, 196, 136, 228, 18, 111, 225, 128, 195, 160, 113}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 105, 165, 7, 198, 4}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139}, 25},
	{{235, 0, 0, 165, 1, 189, 173, 61, 202, 56, 18, 12, 121, 141, 41, 238}, 25},
	{{235, 0, 0, 0, 0, 0, 221, 17, 208, 239, 136, 115, 176, 231, 226, 40}, 25},
	{{235, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 13, 154, 85, 166, 191}, 25},
	{{46, 72, 0, 0, 44, 142, 62, 57, 48, 116, 123, 24, 112, 147, 128, 83}, 150},
	{{46, 72, 0, 0, 244, 31, 180, 223, 230, 225, 105, 241, 215, 145, 62, 160}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 109, 7, 225, 164, 142, 147, 64, 73, 88}, 150},
	{{46, 72, 0, 169, 134, 194, 122, 171, 128, 63, 87, 206, 7, 79, 157, 8}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 176, 127, 99}, 150},
	{{46, 72, 0, 0, 67, 221, 175, 130, 76, 10, 133, 59, 172, 69, 225, 240}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 151, 110, 122, 108}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 199, 23}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 115, 221, 13, 199, 58, 171, 11}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 11, 208}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 131, 190, 102, 186}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 28}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 43, 51, 86, 229, 64, 211, 159, 60}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 143, 150, 143, 93, 119, 241, 168, 122, 16}, 150},
	{{46, 72, 0, 0, 127, 155, 210, 29, 189, 120, 54, 117, 102, 133, 206, 166}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 237, 225, 47, 35, 50, 215, 77}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 49, 190, 169, 72}, 150},
	{{46, 72, 0, 0, 248, 152, 72, 200, 240, 121, 108, 89, 76, 152, 37, 24}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 85, 189, 102, 97, 181, 213, 102}, 150},
	{{46, 72, 0, 0, 0, 51, 121, 243, 192, 248, 116, 119, 79, 244, 214, 22}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 161, 123, 88, 211, 29, 224, 98}, 150},
	{{46, 72, 0, 0, 0, 174, 101, 105, 94, 234, 13, 239, 237, 255, 249, 244}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 53, 85, 123}, 150},
	{{46, 72, 0, 64, 162, 228, 131, 153, 111, 47, 181, 20, 253, 245, 89, 131}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 107, 244, 108, 90}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 249, 77, 90, 220, 248, 75}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 116, 252, 226}, 150},
	{{46, 72, 0, 0, 0, 0, 40, 138, 175, 110, 60, 144, 187, 145, 82, 60}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 34, 166, 130}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 23, 78, 82, 135}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 254, 156, 90, 185, 232, 133, 226, 44, 48}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 150},
	{{46, 72, 0, 0, 22, 117, 50, 190, 57, 233, 126, 24, 36, 226, 147, 216}, 150},
	{{46, 72, 0, 0, 0, 0, 209, 31, 34, 58, 253, 242, 123, 191, 158, 106}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 150},
	{{46, 72, 0, 0, 0, 202, 243, 7, 107, 216, 206, 45, 146, 87, 237, 154}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 106, 149, 227}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 108}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 150},
	{{46, 72, 0, 0, 97, 68, 192, 56, 196, 111, 157, 57, 243, 24, 50, 230}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 137}, 150},
	{{46, 72, 0, 0, 0, 0, 252, 13, 49, 121, 166, 247, 164, 232, 239, 96}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 150},
	{{46, 72, 0, 0, 0, 0, 48, 13, 239, 168, 147, 193, 177, 244, 13, 130}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 4, 188, 48, 196, 145, 54, 22, 134}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 86, 237, 147, 111, 73, 236}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 76, 244}, 150},
	{{46, 72, 0, 0, 115, 61, 206, 92, 227, 69, 245, 170, 42, 242, 60, 58}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 146, 230, 52, 20, 75, 11, 23, 136}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 16, 104, 220, 224, 40, 182, 195}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 172, 85}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 107, 228, 185, 28, 211, 147}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 172}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 230, 237, 208}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 103, 209, 10, 173}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 46, 232}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 68}, 150},
	{{46, 72, 0, 18, 37, 180, 123, 214, 196, 82, 4, 219, 218, 214, 134, 186}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 92, 210, 162, 216, 192, 195}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 126, 80, 54, 104, 231, 21, 144}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 217, 99, 147, 45, 52, 237, 220}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 247}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 15, 87}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 150},
	{{46, 72, 0, 0, 116, 108, 13, 227, 72, 120, 248, 207, 180, 47, 36, 35}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 52, 141, 140, 144, 255, 32, 52, 84}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 236, 184, 237, 21, 164, 60, 159, 61, 174}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 204, 151, 4}, 150},
	{{46, 72, 0, 0, 0, 65, 3, 122, 126, 197, 162, 24, 73, 61, 21, 169}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 150},
	{{46, 72, 0, 178, 245, 76, 209, 120, 109, 52, 15, 75, 213, 43, 241, 174}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 66, 230, 25, 135, 191, 58, 51}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 39}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 150},
	{{46, 72, 0, 2, 204, 147, 125, 68, 64, 76, 212, 31, 33, 131, 127, 217}, 150},
	{{46, 72, 0, 0, 0, 0, 104, 47, 137, 160, 98, 9, 0, 172, 112, 13}, 150},
	{{46, 72, 0, 0, 0, 0, 175, 172, 215, 37, 71, 185, 192, 194, 197, 207}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 171, 62}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 159, 64, 137, 151, 203, 136, 178}, 150},
	{{46, 72, 0, 0, 0, 0, 190, 225, 17, 126, 243, 178, 251, 52, 255, 128}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 159, 82, 105, 201, 192, 48}, 150},
	{{46, 72, 0, 0, 77, 117, 149, 158, 183, 147, 238, 153, 49, 145, 47, 61}, 150},
	{{46, 72, 0, 0, 0, 0, 202, 239, 21, 235, 172, 57, 172, 95, 196, 120}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 117, 28, 122, 197, 62, 167}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 229, 192, 30, 5, 161, 100}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 211, 65}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 150},
	{{46, 72, 0, 0, 90, 151, 99, 139, 136, 0, 30, 154, 11, 179, 165, 226}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 150},
	{{46, 72, 0, 0, 0, 0, 0, 121, 65, 156, 32, 86, 131, 184, 87, 61}, 150},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 29}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 0}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 225, 45}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 12, 197, 89}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 113, 72}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 199, 63, 184}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 180, 193}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 0}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 118, 20, 253, 231, 239, 106}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 144}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 0}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 160, 248, 130}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 115, 226, 44, 83}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 226, 114}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 90, 76, 99, 240, 103, 239}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 248, 149, 158}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 95}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 144, 170, 127}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 148, 151}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 0}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 79}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 110}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 219, 26}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 236}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 10, 83, 108, 54, 14}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 35}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 160, 30, 38, 131}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 137}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 154, 81, 12, 6}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 80, 104}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 158, 10, 205, 208, 134}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 181, 114, 49, 119}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 24}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 240, 184}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 0}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 161, 8, 173, 208, 236}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 24, 87, 229, 220, 197, 29}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 63, 68, 2, 179}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 243, 35, 211, 251}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 79, 177, 100}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 143, 130}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 151, 197}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 35, 58, 62, 33, 247}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 68, 84, 90, 134, 27, 92}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 0}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 79}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 0}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 50, 145, 3}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 167}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 18, 148}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 170, 50, 163, 71, 27}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 81}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 0}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 116, 159, 68, 212, 242, 137}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 177, 138, 94, 43, 152}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 174, 122, 65, 216}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 215, 162, 63, 163, 225, 140}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 240}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 122, 250, 20, 229, 204}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 1, 166}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 0}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 8, 119, 184, 180, 155}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 46}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 0}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 57}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 94, 226, 148, 108, 123, 74}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 169, 209, 191, 254, 170, 200}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 0}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 92, 125, 252, 123, 236}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 255, 184, 14, 15, 78, 195}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 234, 222, 153, 105, 70}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 12, 90}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 36, 205, 231}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 167, 55, 75, 106, 166}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 186, 76, 23, 149}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 35, 206, 54, 74, 5}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 197}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 134, 236, 151, 219}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 56, 39, 34, 163}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 33}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 220, 44, 242}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 191}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 254, 60, 118, 6, 49}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 110, 147, 7, 138}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 0}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 169, 19, 8, 111}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 64}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 18, 164, 127, 29}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 97, 133, 97, 160, 63}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 0, 98}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 241, 122, 18, 141, 142}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 121, 64, 130}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 133, 236, 6, 185, 131, 45}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 173, 201}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 181, 45, 91, 117, 13, 100}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 0, 55, 219}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 7, 61, 21, 92}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 229, 249, 66}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 0, 0, 95, 114, 8}, 103},
	{{171, 35, 128, 117, 74, 29, 199, 67, 109, 176, 0, 132, 226, 57, 253, 40}, 103},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 102, 166, 203}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 41, 39}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 129, 176, 188, 207, 201, 154, 142}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 110, 186, 239, 231}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 45, 41, 29, 126, 255, 103}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 141, 15, 89, 122, 195, 119}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 171, 197, 49, 219}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 62, 230, 154, 200, 0, 194}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 82, 75, 200, 2, 253, 28}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 156, 129, 23, 68, 48}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 239, 6, 215, 50, 135, 197}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 112, 89, 56, 159}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 190, 11, 45, 194}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 148, 209, 136, 216}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 204, 149, 100, 69}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 43, 112, 122, 91, 28}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 161, 100, 240, 82, 101, 214}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 152, 73, 208, 85, 164}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 88, 52}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 126, 179, 127, 11, 50}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 187, 219, 218}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 188}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 97, 122, 110, 186, 104, 252}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 145, 24, 228}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 126, 210}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 25}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 211, 233}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 32, 15, 225}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 55, 248, 206, 204, 141, 119}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 52}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 56, 210, 149, 162, 39}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 59, 59}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 235, 125, 29, 100}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 18, 85, 94, 160}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 34, 203}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 127, 233, 167, 193, 62, 203}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 151, 9, 57, 73, 156, 204}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 238, 226, 52, 43}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 207}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 204, 155, 37, 118}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 159, 134, 18, 59, 242}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 72, 55, 88, 227, 142, 48}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 14, 162, 199, 117, 152, 173}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 9, 93, 131, 64, 190, 216}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 178, 133, 217}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 206, 185, 22, 113, 185, 240}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 23, 67, 186, 234}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 101, 0, 53, 96, 237, 119}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 168, 156, 79}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 138}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 209}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 136, 98, 151, 130, 135}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 44, 134, 223, 206, 147}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 107, 248, 87}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 79, 159, 30}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 38, 138}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 148, 243, 222}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 133, 44, 89, 129}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 218, 64, 6}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 207}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 86, 147, 105, 179, 6, 191}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 136, 225, 227}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 159}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 221, 144, 251}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 153, 52, 123, 179}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 237, 145, 170, 87, 235}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 245}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 133}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 61, 13, 130, 8, 74, 145}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 199, 159, 213}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 191, 116, 57, 140, 214}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 138, 77, 119, 110, 193, 80}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 64, 224}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 123, 66, 11}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 4, 32}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 170, 76, 53}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 53, 8, 143, 32, 98}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 11, 161, 8, 186, 83}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 149, 11, 200}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 15, 114, 252, 112, 175}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 69, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 179, 121, 242}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 184, 252, 228, 13}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 38}, 155},
	{{220, 233, 236, 112, 135, 136, 215, 43, 42, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 204}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 98, 191, 46}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 233}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 203, 93}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 163, 248, 118}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 215, 81, 169}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 48}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 6}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 17}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 4, 153, 146}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 122, 120}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 110}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 93}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 233, 66, 111}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 15, 106}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 192, 219}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 199, 31, 26}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 109, 110, 249}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 178}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 59, 158}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 63, 60}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 189, 122, 16}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 244, 48}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 81}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 176, 45}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 31, 73, 5}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 60}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 140, 49, 193}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 138, 106}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 189}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 186, 127}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 219}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 193}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 127, 133}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 221}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 123, 144, 205}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 33, 246, 43}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 242, 109}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 106}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 197, 53}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 84}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 212}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 255, 234}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 255}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 57, 134, 172}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 30}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 73, 40}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 132, 166, 221}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 164}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 6}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 17}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 173, 101, 100}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 160}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 230, 249, 25}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 99, 212, 118}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 131}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 5, 90}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 171, 47}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 26, 247}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 226, 172}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 60}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 65, 188}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 230, 227}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 236}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 176}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 218, 85, 62}, 142},
	{{228, 11, 144, 117, 206, 192, 118, 25, 141, 78, 4, 105, 0, 0, 0, 0}, 142},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 169}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 76}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 52}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 3}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 9}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 221}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 214}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 236}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 64}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 119}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 13}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 178}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 83}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 157}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 175}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 128}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 249}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 228}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 2}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 94}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 31}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 90}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 229}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 113}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 229}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 80}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 1}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 97}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 25}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 123}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 143}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 198}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 222}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 128}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 186}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 30}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 226}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 4}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 220}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 34}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 0}, 2},
	{{195, 67, 194, 229, 14, 53, 129, 7, 30, 208, 38, 100, 182, 59, 0, 36}, 2},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 154, 236, 87, 174}, 59},
	{{25, 76, 0, 0, 0, 28, 134, 28, 125, 242, 152, 35, 220, 232, 236, 247}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 4, 183, 198}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 252, 194, 54, 92, 218, 223}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 140, 50, 178, 140, 27, 104, 149, 4, 145}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 88, 95, 90, 87, 226, 101, 148, 242, 92}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 89, 161, 103, 193, 170, 201}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 42, 98}, 59},
	{{25, 76, 0, 0, 136, 220, 133, 121, 231, 240, 66, 170, 254, 143, 86, 233}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 78, 96, 154, 5, 6, 141, 0}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 77, 143, 165, 70, 65, 111, 9, 221, 183}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 8, 242, 107, 39, 115, 110, 116, 112, 19}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 244, 53, 15, 247}, 59},
	{{25, 76, 0, 0, 147, 143, 89, 62, 57, 118, 8, 161, 145, 168, 96, 46}, 59},
	{{25, 76, 0, 0, 168, 55, 88, 177, 107, 17, 32, 166, 209, 66, 159, 240}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 191, 49, 216, 13}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 131, 134, 43, 222, 249, 160, 163, 34, 17}, 59},
	{{25, 76, 0, 0, 0, 0, 154, 249, 197, 221, 126, 123, 105, 160, 179, 235}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 57}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{25, 76, 0, 0, 0, 0, 111, 166, 36, 117, 160, 73, 150, 126, 174, 49}, 59},
	{{25, 76, 0, 0, 0, 159, 77, 139, 139, 184, 165, 9, 208, 54, 188, 229}, 59},
	{{25, 76, 0, 39, 109, 7, 113, 153, 88, 107, 161, 11, 130, 111, 79, 176}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 166, 255}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 208}, 59},
	{{25, 76, 0, 0, 0, 0, 77, 242, 56, 99, 135, 28, 227, 219, 96, 180}, 59},
	{{25, 76, 0, 180, 230, 92, 203, 121, 125, 205, 250, 90, 78, 35, 42, 244}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 146, 153, 169, 57, 110, 111, 156, 135, 247}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 207, 241, 49}, 59},
	{{25, 76, 0, 186, 156, 211, 29, 235, 1, 174, 108, 75, 157, 168, 238, 55}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 113, 177, 159, 176, 128, 9, 161, 150, 219}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{25, 76, 0, 0, 209, 243, 209, 198, 166, 238, 129, 188, 75, 254, 70, 217}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 38, 82, 82, 76, 175, 162, 128, 21, 26}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 110, 108, 27, 155, 104, 182, 54, 252}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 21, 16, 192, 98, 148, 172, 97}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 165, 222, 46, 78, 8, 104, 33, 236, 12}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 241, 20, 219, 141, 134, 23, 53, 38, 234}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 103, 147, 116, 52}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 48, 98, 5, 33, 249, 51, 38}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 136, 121}, 59},
	{{25, 76, 0, 0, 0, 105, 12, 144, 151, 60, 220, 17, 205, 121, 29, 226}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 59},
	{{25, 76, 0, 218, 152, 90, 44, 155, 143, 229, 120, 236, 81, 197, 146, 188}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 244, 73, 167, 234, 92, 65, 242, 213}, 59},
	{{25, 76, 0, 0, 0, 0, 113, 12, 61, 158, 17, 251, 55, 50, 151, 195}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 106, 180, 146, 201, 130, 241}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{25, 76, 0, 0, 0, 0, 154, 170, 169, 74, 229, 105, 37, 152, 187, 237}, 59},
	{{25, 76, 0, 0, 0, 0, 200, 57, 219, 43, 139, 143, 27, 154, 249, 141}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 143, 1, 13, 181, 160, 39}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 236, 253, 41, 14, 102, 72}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 177, 240, 5, 97, 114, 84, 127, 206, 208}, 59},
	{{25, 76, 0, 0, 0, 230, 244, 23, 179, 8, 60, 173, 216, 148, 24, 179}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 17, 159, 143, 97}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 202, 142, 125, 177}, 59},
	{{25, 76, 0, 0, 0, 169, 89, 233, 12, 120, 107, 95, 23, 106, 245, 55}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 24}, 59},
	{{25, 76, 0, 0, 0, 26, 186, 87, 154, 120, 140, 172, 52, 188, 181, 229}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 131, 255, 255, 132, 86, 24, 215, 33}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 157, 139, 186, 50, 98, 57, 126, 160, 16}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 196, 130, 223, 139, 2, 140, 62, 151}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 238, 45}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 249, 82}, 59},
	{{25, 76, 0, 0, 0, 0, 59, 245, 163, 226, 30, 213, 41, 255, 126, 240}, 59},
	{{25, 76, 0, 244, 12, 180, 76, 32, 91, 174, 78, 87, 182, 240, 4, 5}, 59},
	{{25, 76, 0, 0, 80, 218, 50, 0, 126, 89, 36, 146, 43, 146, 82, 168}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 119, 35, 170, 94, 0, 245, 80, 28, 214}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 152, 81, 184, 191, 184, 67, 129, 201}, 59},
	{{25, 76, 0, 0, 235, 126, 249, 243, 235, 199, 123, 234, 109, 14, 29, 200}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 34, 174, 142, 12, 157, 41, 154, 227}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 57, 15, 107, 85, 75, 215, 183}, 59},
	{{25, 76, 0, 0, 0, 0, 250, 9, 53, 143, 119, 157, 44, 21, 75, 2}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 23, 203}, 59},
	{{25, 76, 0, 0, 21, 209, 188, 174, 69, 57, 4, 213, 171, 28, 74, 107}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 181, 63, 90, 231, 89, 240, 97, 222, 46}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 122, 84, 68, 194, 116, 207, 113, 239}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 160, 171, 78}, 59},
	{{25, 76, 0, 0, 0, 0, 140, 195, 53, 159, 248, 225, 179, 199, 247, 4}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 250, 86}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 101, 241, 141, 180, 5, 210, 149, 147, 132}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 129, 242, 198, 80, 249, 135, 66}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 66, 190}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 221, 117}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 109, 82, 206, 177, 67, 90, 113, 195, 118}, 59},
	{{25, 76, 0, 0, 0, 0, 41, 154, 180, 177, 177, 133, 166, 109, 61, 37}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 88, 87, 89, 121}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{25, 76, 0, 0, 0, 124, 173, 100, 38, 23, 7, 39, 25, 19, 199, 35}, 59},
	{{25, 76, 0, 0, 0, 0, 98, 10, 89, 186, 4, 231, 155, 66, 194, 144}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 59},
	{{25, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 59}, 59},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 33}, 208},
	{{160, 0, 0, 67, 245, 185, 38, 100, 142, 251, 21, 131, 149, 74, 142, 41}, 208},
	{{160, 0, 0, 0, 165, 17, 250, 208, 118, 63, 43, 143, 6, 108, 51, 251}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 67, 66, 56, 164, 193, 82, 219}, 208},
	{{160, 0, 0, 0, 0, 145, 207, 180, 228, 195, 66, 156, 20, 251, 159, 235}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 208, 85, 220, 174}, 208},
	{{160, 0, 0, 180, 117, 7, 30, 218, 131, 210, 38, 152, 66, 216, 39, 223}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 230, 90, 40, 233}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 220, 190, 7, 75, 19}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 124, 137, 203, 23}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 134, 213, 220, 70, 10, 216, 126}, 208},
	{{160, 0, 0, 22, 108, 139, 70, 1, 6, 67, 101, 88, 42, 148, 39, 231}, 208},
	{{160, 0, 0, 0, 0, 0, 157, 217, 27, 115, 58, 45, 24, 125, 24, 189}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 216}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 236, 248, 38, 223}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 194}, 208},
	{{160, 0, 160, 92, 53, 154, 160, 170, 200, 108, 205, 60, 217, 59, 70, 188}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 171, 6, 179, 228, 134, 153, 132, 142}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 31, 82, 233, 125, 60}, 208},
	{{160, 0, 0, 0, 141, 139, 81, 181, 108, 49, 8, 73, 156, 77, 90, 58}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 96, 183, 206, 15, 242, 86, 122, 117, 119}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 224, 156}, 208},
	{{160, 0, 0, 136, 41, 100, 166, 83, 70, 251, 250, 18, 113, 209, 50, 15}, 208},
	{{160, 113, 143, 204, 43, 201, 141, 42, 172, 225, 36, 171, 130, 236, 114, 214}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 47, 201, 209, 37, 245, 211, 105, 101, 149, 44, 144, 185}, 208},
	{{160, 0, 0, 166, 114, 159, 200, 198, 162, 170, 88, 30, 28, 111, 163, 60}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 208},
	{{160, 0, 0, 111, 224, 185, 120, 159, 56, 86, 84, 198, 204, 172, 131, 169}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 205, 62, 159, 116, 200, 128, 100, 160, 208}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 254, 143, 245, 61, 14, 129, 118, 179, 228}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 106, 87}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 43, 125}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 113, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 247, 255}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 142, 240, 206, 135, 221, 118, 229, 215, 113}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 130, 136, 104, 88, 77, 224, 107}, 208},
	{{160, 0, 123, 119, 253, 6, 153, 82, 129, 117, 7, 28, 38, 214, 108, 210}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 203, 250, 168, 7, 24}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 215, 29}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 93, 81, 39, 200}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 71, 26, 184, 105, 19, 239, 62, 75}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 137, 225, 249, 84, 178, 133, 35}, 208},
	{{160, 0, 0, 0, 0, 0, 140, 28, 142, 214, 150, 137, 32, 48, 173, 31}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 93, 108, 55, 3}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 205, 182, 226, 187, 99, 113, 178, 243}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 128, 85, 18, 243, 138, 16, 9}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 30, 32, 168, 101, 17, 220, 69, 229, 83, 197, 237, 157, 146}, 208},
	{{160, 244, 47, 196, 227, 91, 27, 130, 72, 2, 186, 213, 242, 187, 81, 187}, 208},
	{{160, 0, 253, 125, 140, 59, 179, 116, 59, 203, 176, 197, 6, 134, 223, 1}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 98, 40, 93}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 196, 253, 49, 65, 105, 18, 1}, 208},
	{{160, 0, 0, 112, 252, 76, 168, 183, 40, 41, 12, 42, 30, 82, 39, 185}, 208},
	{{160, 21, 0, 140, 46, 194, 167, 128, 51, 179, 187, 210, 186, 32, 53, 124}, 208},
	{{160, 0, 0, 128, 199, 149, 36, 28, 12, 102, 166, 211, 176, 1, 138, 154}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 149, 226, 205, 91, 235, 226, 93}, 208},
	{{160, 0, 142, 132, 200, 8, 29, 7, 171, 142, 224, 235, 10, 97, 74, 219}, 208},
	{{160, 0, 0, 0, 0, 108, 187, 204, 240, 201, 175, 140, 167, 105, 234, 221}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 106, 113}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 212, 148, 76, 144, 121, 158, 57}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 227, 41, 104, 236}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 223, 92, 159, 29, 251, 46, 52, 167, 245}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 210, 123, 38, 32, 175, 79, 19}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 12, 133, 39, 181, 217, 113, 29, 127, 66, 110, 90, 247, 198}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 73, 53, 58, 170}, 208},
	{{160, 0, 194, 198, 36, 215, 135, 213, 174, 207, 240, 224, 156, 152, 238, 97}, 208},
	{{160, 0, 0, 0, 0, 0, 109, 60, 189, 150, 129, 19, 220, 208, 32, 17}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 184, 118, 96, 92, 174}, 208},
	{{160, 89, 70, 70, 122, 20, 161, 29, 152, 225, 91, 91, 56, 17, 72, 145}, 208},
	{{160, 0, 0, 0, 0, 76, 97, 252, 34, 124, 99, 170, 30, 80, 96, 219}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 102, 236}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 73, 249}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 159, 167, 248, 235, 188}, 208},
	{{160, 0, 0, 0, 167, 174, 247, 76, 165, 81, 193, 48, 157, 144, 81, 34}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 91}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 132, 23}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 129}, 208},
	{{160, 0, 0, 0, 0, 227, 101, 27, 231, 8, 6, 12, 103, 157, 147, 243}, 208},
	{{160, 0, 140, 136, 94, 198, 125, 153, 145, 7, 254, 101, 36, 252, 50, 216}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 119, 65, 206, 66}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 208},
	{{160, 0, 0, 0, 211, 47, 83, 60, 221, 105, 4, 255, 86, 88, 145, 121}, 208},
	{{160, 0, 0, 0, 0, 0, 203, 103, 179, 172, 157, 87, 25, 40, 149, 33}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 207, 191}, 208},
	{{160, 0, 0, 0, 252, 157, 73, 25, 2, 152, 223, 6, 66, 180, 156, 34}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 128, 161, 220, 90, 54, 157, 75, 108, 141}, 208},
	{{160, 0, 0, 0, 0, 192, 68, 185, 233, 9, 149, 251, 139, 126, 190, 44}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 208},
	{{26, 203, 217, 152, 16, 187, 0, 166, 224, 181, 136, 14, 209, 202, 44, 124}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 187, 224, 239, 40}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 1, 41, 93, 11, 28, 231, 153}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 248, 85, 239, 137, 181, 154, 50, 234, 80}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 60, 149, 160, 198, 24, 39}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 172, 194, 42, 138, 93, 23, 23}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 34, 38}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 83, 151}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 245, 171, 251, 80, 211, 205, 84, 161}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 238, 141, 103, 221, 177, 137, 143, 249, 196}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 179, 9, 167, 77, 7, 163, 151}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 249, 214, 133, 175, 80, 38, 29, 122, 240}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 7, 73}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 220, 98}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 164, 12, 26, 47, 60, 167, 163}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 233, 187, 120, 21, 139}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 231, 169, 53, 176, 70}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 140, 30}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 124, 162}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 171, 30, 58, 229, 91, 179}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 186, 82, 171}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 54, 247, 40, 44, 141, 7, 213}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 163, 243, 179, 83, 62, 113, 252, 223}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 31, 50, 41, 74, 40, 6, 139}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 60, 149, 61, 181, 178, 87, 236, 11, 29}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 140, 95, 165, 127}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 118, 162, 55, 137, 84, 40, 203, 87, 205}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 191, 166, 147, 22, 22, 81, 254, 28, 14}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 254, 49, 27, 183}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 246, 212, 185, 72}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 55, 125, 60, 84, 119, 200}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 134, 227, 246, 228}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 82, 117, 14, 133, 200, 221, 93, 52, 253}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 217, 82, 135, 64, 201, 133, 55, 140}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 63, 135, 252, 30, 44, 186, 51, 148, 190}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 121, 177, 32, 11, 169, 0, 166, 124}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 140, 112, 79, 204, 242, 117, 208}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 4, 51, 253, 1, 85, 41, 114, 75}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 122, 180, 185, 47, 195, 198, 196, 251, 166}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 89, 100, 136}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 170, 70, 54, 11, 115, 108}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 225, 189, 144, 88, 198, 247, 18}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 169, 145, 44, 136}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 207, 92}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 54, 114, 190, 165, 166, 134}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 195, 8, 49, 16, 236, 245}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 103, 215, 249, 70, 218, 64}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 173, 80, 223, 147, 222, 7, 255}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 248, 97}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 189, 54, 199, 141, 216, 122, 189}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 142, 94, 219, 90, 238, 181}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 39, 8, 176, 100, 102}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 38, 45, 84}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 59, 139, 253, 160, 11, 183, 12, 176, 232}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 50, 236, 215, 206, 10, 158, 196, 88}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 245, 97, 99, 191, 57, 0}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 156, 103, 178, 16, 41, 220}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 159, 238, 69, 77}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 86, 191, 81, 62, 162, 191, 170, 30}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 25, 37}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 141, 117, 182, 229, 78, 159, 166, 199, 116}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 139, 23, 154, 56, 80}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 222, 250, 107, 138}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 11, 121, 81, 202, 34, 197}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 58, 219, 26, 191, 171, 242, 225}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 114, 186, 152, 18, 134, 44, 21}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 117, 233, 250, 87, 120, 239, 239, 30, 85}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 107, 100}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 170, 137, 204, 138, 228, 7, 162, 223}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 20, 116, 28, 193, 130, 182}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 68, 199, 175}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 54, 232, 140, 150, 53, 218}, 166},
	{{26, 203, 217, 152, 16, 187, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254}, 166},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 145, 240, 202}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 203, 67, 121, 231}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 134, 188}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 40, 74, 109, 140, 47}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 194, 192}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 54, 103, 104, 121, 226, 177}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 155, 95, 88, 17, 94, 255}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 60, 241, 253, 74, 13}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 255}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 110, 40, 112, 158, 41}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 123, 109, 227, 222}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 0}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 119, 65, 31}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 10, 133, 165}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 0}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 85}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 33, 79, 240}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 196, 62, 14, 166, 224, 237}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 230, 131, 86, 17, 57}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 159, 9, 168, 205, 182}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 101, 223}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 193, 75, 120}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 0}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 36}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 0}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 112, 248}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 107, 143, 16}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 93, 75, 180, 45}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 19, 96, 197, 166, 76, 103}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 0}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 68, 65, 119, 144, 15}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 44}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 47, 106, 46, 159, 253, 209}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 101, 215}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 78, 199}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 96, 237}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 76, 43, 190, 33}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 0}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 146, 23, 114, 15}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 57, 171}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 173, 76, 207}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 16, 67, 98, 151, 184}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 227}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 71}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 161, 96, 229, 15, 129}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 19}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 75, 245, 206, 3, 166}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 42, 29, 202}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 106, 117, 250, 54, 195, 141}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 181, 195, 255, 113}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 16, 30}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 148, 108, 244, 71, 186}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 160}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 0}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 176, 45, 213, 25, 91}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 0}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 182, 129}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 227, 217, 173}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 233, 134, 75, 185}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 39}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 77, 231, 68}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 77, 57, 253, 207}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 116, 32, 50}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 253}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 227, 2, 152, 229, 99}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 34, 191, 43, 82, 216}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 148, 49, 57, 48}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 95, 91, 129, 66, 28}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 21}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 27, 178, 189, 154, 23, 236}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 117, 165, 208}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 185, 11, 180}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 147, 239}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 196, 187, 173, 226, 230}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 89, 36, 36, 74, 86, 185}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 59, 4, 186, 0, 170, 86}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 152}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 177, 33, 62, 182}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 234, 121, 52, 124}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 178, 97, 248, 218}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 0}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 56, 84, 63}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 23, 38}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 22, 5}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 66, 162, 65, 85}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 27, 147, 91, 111, 36}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 235, 56, 17, 215}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 82, 214, 47, 195, 62, 66}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 140, 151, 252, 239, 138}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 0}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 179, 171}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 134, 181, 9, 186, 243, 244}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 0}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 0}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 18}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 205}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 102}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 237, 82, 194, 173}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 47, 240, 235}, 62},
	{{250, 213, 14, 235, 110, 171, 174, 23, 102, 128, 0, 0, 0, 0, 0, 0}, 62},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 88, 209, 151, 147, 234}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 147, 228}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 196, 100, 178}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 243, 10}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 165, 4, 34, 220, 122}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 53, 165, 227, 90, 101, 153, 69, 159}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 100, 203}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 10, 43, 179, 140}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 92, 189, 104, 43, 80, 240, 38, 63, 158}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 207, 78}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 9, 23, 94, 64, 73, 185, 160, 191}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 67, 117, 226, 132, 133, 224, 197, 148}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 30, 64, 13, 106, 146, 145, 158}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 247, 80}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 176, 57, 253}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 35, 229, 70, 203, 164, 106, 128, 87}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 109, 239, 21, 254, 119, 32, 135}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 45, 53, 65, 233, 1}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 26, 114, 156, 245, 211, 139, 220, 158, 108}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 36, 254, 250, 100, 48, 190, 9, 132}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 152, 219, 211, 204}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 212, 250, 58, 20, 75}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 234, 5, 179, 102, 191, 254, 245, 42}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 167, 2, 86, 219, 95, 209}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 230, 53, 163, 171, 239, 27, 200}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 209, 77, 220}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 136, 88, 148, 231, 39, 47, 193, 65}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 150, 184, 204, 111, 253, 252, 83, 114}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 142, 218, 147, 218, 176, 248}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 56, 117, 97, 50, 67}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 82, 243, 232, 44, 170}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 1, 137, 43, 202}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 227, 122, 51, 223}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 91, 57, 79, 117, 196, 136, 157}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 213, 49, 188, 121, 87, 141, 102, 204}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 203, 139, 189, 192, 107, 146, 207}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 172, 17}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 21, 8, 35, 10, 53}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 234, 180, 35, 74, 206, 223, 161, 207}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 175, 201, 154}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 154, 97, 151, 38, 173, 93, 171, 41, 45}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 16, 118, 32}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 229, 10, 190, 49, 43}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 186, 121}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 14, 199}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 244, 36, 110}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 79, 28}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 43, 59, 21, 58, 62}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 162, 171, 239, 204, 196, 97, 13, 11}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 21, 45, 203, 69, 81}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 207, 217, 66, 132, 117, 26}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 23, 224, 251, 194, 221, 207, 78}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 127, 132, 183}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 238, 132}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 141, 223}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 32, 192, 82, 18, 36, 191}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 230, 185, 51, 248, 153, 150, 52, 193, 240}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 125, 143, 245, 69, 23}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 37, 114, 192, 28, 133}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 249, 0, 254, 71, 247, 62}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 131, 28}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 13, 59, 171, 106, 81, 203, 76, 236}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 129, 67, 72, 32, 100, 48, 87, 251}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 132, 212, 14, 244, 63, 139}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 189, 131, 150, 224, 48, 128}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 61, 180, 150, 123, 115}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 179, 219, 209, 246, 191, 105, 36, 239, 191}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 15, 87, 162, 190, 172, 231, 30, 119, 175}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 110, 190, 136, 178}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 5, 201, 185, 207, 163}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 138, 243, 60}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 249, 133, 179, 155, 150, 203, 132, 184}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 181, 150, 212}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 0, 0, 0, 0, 55, 237}, 176},
	{{175, 230, 160, 13, 187, 17, 0, 0, 0, 0, 99, 60, 105, 200, 148, 24}, 176},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 141}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 3, 47, 130}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 228, 93}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 175, 49}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 147, 83}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 2}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 244, 243, 228}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 194}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 70}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 177, 2}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 181, 102}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 155, 89}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 81, 153}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 178, 7, 152}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 74, 11}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 32}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 66, 63}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 118}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 98, 47}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 96}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 213}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 169, 247}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 75, 200}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 102, 138}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 180, 45}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 18, 85}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 4, 89, 115}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 29}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 121, 24}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 198, 198}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 31}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 14, 139, 133}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 126}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 108}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 10, 77}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 131, 9, 53}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 80, 97}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 185}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 105, 234, 30}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 243}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 212, 201}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 251}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 7}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 53, 64}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 212, 167}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 119, 19, 17}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 19}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 69}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 161, 193}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 168}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 200, 174, 34}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 206}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 49, 222}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 167}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 150}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 124, 159}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 99}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 201}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 245}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 156}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 0}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 147, 37}, 6},
	{{92, 155, 156, 93, 191, 73, 28, 82, 187, 129, 57, 5, 16, 0, 0, 252}, 6},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 79, 3, 70, 224}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 130, 14, 222, 140, 15, 252}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 3, 149, 135, 46, 181, 133, 134, 143}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 210, 163, 254, 225, 1, 181, 167, 124, 36}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 216, 213}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 116, 53, 119, 16, 49, 203, 38, 134}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 32, 204, 58, 250, 223, 83, 121}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 229, 12, 69, 147, 236}, 26},
	{{45, 203, 3, 8, 5, 124, 133, 116, 254, 54, 40, 186, 240, 77, 143, 219}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 29, 193, 48, 220, 176, 177, 72, 53}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 19, 215, 66, 244}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 133, 56, 166, 208, 89}, 26},
	{{45, 203, 3, 8, 0, 105, 96, 29, 33, 0, 202, 47, 49, 85, 252, 191}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 49, 32, 91, 140, 73, 54, 108}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 28, 125, 140, 255, 155, 195, 69, 113, 0}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 30}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 91, 142, 172, 255}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 38, 82, 17, 61, 247, 182}, 26},
	{{45, 203, 3, 8, 240, 43, 231, 34, 5, 69, 204, 114, 211, 39, 120, 136}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 83}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 171, 236, 193, 106, 116, 94, 80}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 211, 208, 236, 42, 205, 140, 39}, 26},
	{{45, 203, 3, 8, 0, 30, 181, 10, 171, 8, 77, 133, 187, 202, 53, 84}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 35, 42, 12, 126, 171}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 238, 21, 187, 43}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 152, 141, 149, 141, 253, 70}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{45, 203, 3, 8, 0, 0, 27, 194, 180, 67, 99, 21, 132, 21, 162, 254}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 162, 88, 243, 246, 86, 188, 92}, 26},
	{{45, 203, 3, 8, 0, 248, 233, 6, 92, 172, 183, 109, 230, 35, 145, 164}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 216, 91, 72, 129}, 26},
	{{45, 203, 3, 8, 0, 54, 82, 197, 169, 229, 155, 31, 122, 69, 3, 237}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 22}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 190, 72, 76, 228, 207, 84, 87}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 116, 162, 242, 84, 13, 98, 63, 130, 10}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116}, 26},
	{{45, 203, 3, 8, 0, 0, 193, 247, 176, 74, 240, 1, 225, 90, 66, 91}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 89, 187, 25, 64, 28, 152, 159, 63}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 34, 156, 95, 212}, 26},
	{{45, 203, 3, 8, 0, 0, 202, 152, 49, 200, 127, 131, 208, 85, 191, 126}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 84, 194, 39, 45, 226, 122}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 47}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 82, 195}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 153, 231, 167, 106, 35, 4, 209, 109}, 26},
	{{45, 203, 3, 8, 0, 114, 104, 180, 22, 9, 137, 251, 44, 228, 152, 38}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 116, 179, 37, 59, 224, 194}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 225, 125, 130, 16, 142}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 198, 87, 28, 2, 156, 126}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 185, 63, 185, 158, 6}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 108, 77, 172, 106, 147}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 25, 69, 39, 199}, 26},
	{{45, 203, 3, 8, 0, 0, 187, 17, 237, 254, 32, 199, 235, 72, 45, 61}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 243, 217, 70, 71}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 94}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 73, 119}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 157, 146, 118, 24, 102, 190, 101}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 77}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 131, 241, 81, 130, 16, 223, 106, 45, 198}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 164, 126, 188, 6, 71, 140, 85, 60}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 107}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 30, 217}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 234, 1}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 220, 135, 254, 106}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 66, 172, 112, 225, 154, 146, 81, 224}, 26},
	{{45, 203, 3, 8, 0, 0, 183, 91, 82, 6, 14, 113, 239, 137, 231, 191}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 26},
	{{45, 203, 3, 8, 0, 0, 171, 202, 18, 14, 234, 2, 149, 101, 111, 138}, 26},
	{{45, 203, 3, 8, 0, 50, 236, 237, 96, 56, 250, 43, 37, 93, 23, 157}, 26},
	{{45, 203, 3, 8, 0, 0, 241, 94, 157, 62, 42, 146, 19, 165, 175, 239}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 56}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 24}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 193, 94, 194, 13, 161, 92}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 213, 150, 189, 87, 171, 131, 254, 217, 208}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 207, 181, 129, 103, 236}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 75, 39, 60, 103, 172}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 174, 125, 175, 113, 116, 133, 213, 38}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{45, 203, 3, 8, 0, 77, 135, 96, 223, 116, 216, 250, 175, 200, 255, 225}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 202, 31, 15, 98}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 175, 164, 144, 219, 84, 218, 103}, 26},
	{{45, 203, 3, 8, 0, 176, 76, 144, 23, 52, 0, 56, 203, 161, 160, 50}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 155, 6, 207, 91, 83, 50, 7, 91, 138}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 19, 103, 204, 215}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236}, 26},
	{{45, 203, 3, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{120, 0, 0, 0, 14, 73, 125, 105, 13, 90, 88, 212, 53, 116, 255, 34}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224}, 6},
	{{120, 0, 0, 0, 84, 124, 179, 198, 48, 128, 104, 97, 221, 193, 132, 218}, 6},
	{{120, 0, 0, 0, 0, 221, 156, 184, 215, 135, 62, 140, 17, 46, 114, 73}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 26, 36, 195, 236}, 6},
	{{120, 0, 0, 0, 0, 151, 184, 161, 129, 85, 124, 213, 237, 97, 10, 246}, 6},
	{{120, 0, 0, 0, 0, 148, 6, 240, 149, 175, 250, 103, 79, 104, 203, 5}, 6},
	{{120, 153, 197, 231, 76, 163, 31, 193, 175, 93, 99, 233, 53, 82, 70, 179}, 6},
	{{120, 0, 234, 195, 150, 13, 165, 135, 50, 66, 118, 208, 223, 73, 235, 138}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 186, 85}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 21, 130, 49, 106, 136}, 6},
	{{120, 0, 58, 200, 240, 175, 66, 197, 73, 86, 201, 28, 218, 160, 76, 89}, 6},
	{{120, 0, 0, 0, 0, 0, 32, 87, 230, 108, 101, 39, 102, 16, 49, 166}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 151, 7, 247, 254, 13}, 6},
	{{120, 0, 0, 154, 83, 89, 139, 6, 242, 98, 197, 132, 169, 44, 235, 127}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 119, 61, 173, 69, 70, 169, 17, 59, 154}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 135, 197, 155, 50, 232, 27, 79}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 41, 163, 28, 93, 199, 246, 112, 152, 152}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 165, 201, 101, 75, 3, 18, 150, 130}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 83, 207, 211, 57, 160, 251, 4, 86, 151}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 54}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 239, 155, 8, 175, 92, 109, 5, 226, 209}, 6},
	{{120, 0, 0, 169, 10, 214, 176, 175, 244, 166, 169, 64, 55, 35, 116, 225}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 28}, 6},
	{{120, 0, 0, 186, 139, 10, 97, 122, 214, 212, 148, 123, 248, 45, 95, 103}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 225, 152, 220}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 119, 102, 165, 78, 42, 156, 58, 27}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 90}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 6},
	{{120, 0, 0, 0, 220, 87, 109, 119, 146, 70, 2, 225, 97, 72, 117, 33}, 6},
	{{120, 0, 0, 0, 0, 199, 27, 73, 236, 122, 208, 14, 103, 122, 156, 156}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 2}, 6},
	{{120, 0, 0, 171, 162, 137, 2, 143, 30, 226, 231, 45, 230, 192, 136, 81}, 6},
	{{120, 0, 0, 0, 0, 157, 136, 221, 25, 4, 77, 184, 132, 137, 207, 128}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 68, 253}, 6},
	{{120, 0, 0, 0, 0, 48, 136, 139, 4, 17, 112, 100, 90, 38, 204, 125}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 81, 3, 210}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 20, 13, 192, 54, 39}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 20, 128, 21, 192, 1, 246, 223, 165}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 153, 203, 73, 216}, 6},
	{{120, 0, 0, 0, 0, 0, 172, 110, 113, 62, 51, 140, 234, 249, 118, 234}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 8, 11, 18, 166, 70, 1, 18, 35}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{120, 0, 0, 0, 133, 9, 133, 251, 178, 27, 111, 27, 42, 45, 120, 48}, 6},
	{{120, 0, 0, 0, 0, 0, 16, 15, 75, 180, 221, 144, 181, 183, 175, 111}, 6},
	{{120, 0, 0, 100, 143, 245, 138, 252, 22, 46, 162, 61, 189, 224, 2, 182}, 6},
	{{120, 0, 0, 0, 64, 14, 158, 180, 210, 157, 124, 226, 150, 161, 32, 99}, 6},
	{{120, 0, 93, 3, 252, 28, 29, 155, 203, 227, 239, 166, 54, 88, 198, 39}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 214, 36, 225, 3, 166}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 202, 224, 151, 219, 79, 148, 12, 1, 166}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 152, 27, 133, 215, 204, 80, 24, 106, 115}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 52, 164, 213}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190}, 6},
	{{120, 96, 65, 167, 69, 25, 121, 42, 138, 98, 53, 80, 177, 122, 86, 169}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123}, 6},
	{{120, 0, 113, 32, 15, 161, 239, 81, 154, 31, 191, 95, 243, 162, 6, 230}, 6},
	{{120, 0, 185, 122, 81, 249, 22, 197, 30, 75, 91, 129, 222, 19, 141, 248}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 141, 133, 49, 90, 35, 56, 62, 178}, 6},
	{{120, 111, 179, 85, 248, 90, 124, 35, 153, 255, 179, 128, 151, 236, 47, 109}, 6},
	{{120, 218, 7, 37, 233, 211, 106, 56, 188, 148, 96, 45, 208, 23, 160, 106}, 6},
	{{120, 0, 0, 242, 90, 91, 40, 91, 81, 19, 245, 25, 236, 108, 6, 122}, 6},
	{{120, 0, 0, 0, 0, 0, 81, 216, 176, 224, 183, 254, 124, 66, 24, 195}, 6},
	{{120, 0, 0, 0, 192, 155, 25, 184, 252, 34, 119, 19, 174, 236, 246, 83}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 36, 93, 73, 59, 131, 243, 134}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 113, 65, 66, 100, 87, 157, 34, 181}, 6},
	{{120, 0, 0, 0, 0, 57, 239, 92, 94, 11, 235, 48, 34, 66, 144, 70}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 35, 168, 31, 62, 195, 68, 77, 132}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 119, 112, 253, 194}, 6},
	{{120, 0, 176, 223, 122, 77, 75, 192, 28, 196, 149, 51, 67, 58, 59, 252}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 168, 28, 252}, 6},
	{{120, 199, 112, 6, 246, 77, 53, 237, 140, 180, 98, 134, 135, 143, 78, 49}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 211, 191, 108, 133, 176, 212, 173, 45}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 25}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 177, 248, 177, 179, 178}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 19, 157, 213, 255, 181, 57, 39, 138, 236}, 6},
	{{120, 192, 63, 9, 6, 57, 227, 145, 107, 92, 198, 24, 13, 209, 30, 214}, 6},
	{{120, 224, 214, 124, 65, 54, 4, 147, 81, 85, 214, 126, 44, 114, 7, 171}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 115, 187, 162, 180, 182, 148, 150, 204, 232}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 171, 202}, 6},
	{{120, 0, 0, 0, 0, 0, 232, 191, 95, 197, 7, 215, 229, 26, 193, 231}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 113}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 171, 249, 246}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 11, 88, 106, 28, 227, 172, 222, 174, 156}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 218, 158, 173, 65, 197, 248, 195, 199, 187}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 96, 194, 191, 140, 86}, 6},
	{{120, 0, 0, 0, 0, 0, 90, 139, 154, 158, 173, 255, 81, 9, 179, 175}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 122, 196, 45, 249, 103, 23, 27, 154}, 6},
	{{120, 0, 0, 0, 21, 231, 67, 100, 31, 105, 29, 153, 199, 160, 188, 103}, 6},
	{{120, 0, 0, 227, 223, 208, 89, 52, 132, 145, 81, 29, 96, 75, 93, 199}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 255, 106, 79, 253, 199}, 6},
	{{120, 0, 0, 0, 0, 0, 233, 178, 175, 120, 156, 230, 184, 78, 78, 176}, 6},
	{{120, 0, 0, 0, 0, 0, 0, 0, 202, 5, 199, 60, 69, 11, 242, 151}, 6},
	{{216, 0, 0, 0, 73, 191, 98, 134, 96, 202, 29, 96, 22, 86, 237, 192}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 25, 248}, 13},
	{{216, 0, 0, 0, 60, 117, 224, 32, 104, 15, 65, 123, 181, 200, 230, 196}, 13},
	{{216, 0, 0, 0, 0, 5, 222, 53, 94, 90, 178, 52, 36, 50, 88, 92}, 13},
	{{216, 0, 0, 0, 0, 0, 125, 127, 69, 235, 188, 106, 125, 65, 113, 180}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 55, 162, 164}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 50}, 13},
	{{216, 0, 0, 0, 49, 76, 241, 127, 57, 140, 155, 27, 92, 223, 126, 122}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 243}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 44, 76, 96}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 13},
	{{216, 0, 0, 0, 0, 11, 179, 89, 96, 24, 238, 99, 72, 82, 86, 15}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 102, 250, 250, 219, 238, 209, 213, 229}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 238, 46, 168, 244, 59, 154, 79}, 13},
	{{216, 0, 0, 0, 0, 0, 10, 11, 216, 229, 71, 236, 220, 238, 233, 65}, 13},
	{{216, 0, 223, 232, 46, 195, 189, 179, 167, 9, 36, 110, 0, 1, 16, 173}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 151, 69, 26, 195, 46, 165, 15, 51, 174}, 13},
	{{216, 0, 134, 52, 86, 235, 162, 169, 82, 0, 198, 92, 108, 28, 127, 248}, 13},
	{{216, 0, 0, 209, 100, 98, 15, 195, 244, 216, 103, 135, 40, 221, 209, 131}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 8, 102, 127, 11}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 240, 103, 135, 57, 244, 39, 251, 129, 78}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 10, 27}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 98}, 13},
	{{216, 0, 0, 0, 0, 0, 183, 166, 72, 103, 179, 199, 203, 112, 97, 159}, 13},
	{{216, 0, 0, 154, 246, 193, 84, 219, 24, 109, 169, 149, 251, 222, 186, 133}, 13},
	{{216, 0, 0, 0, 0, 221, 64, 158, 85, 150, 29, 249, 89, 222, 249, 209}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 94}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{216, 0, 0, 0, 0, 0, 221, 255, 141, 185, 19, 49, 167, 77, 31, 146}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 141}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234}, 13},
	{{216, 0, 0, 0, 209, 11, 1, 159, 159, 12, 202, 35, 158, 61, 160, 134}, 13},
	{{216, 0, 81, 175, 124, 60, 216, 83, 244, 78, 37, 245, 85, 17, 140, 222}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 200, 51, 119, 124, 194, 255, 220, 24}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 128, 116, 130}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{216, 0, 0, 0, 0, 0, 170, 176, 121, 13, 213, 17, 182, 30, 134, 244}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 7, 200, 209, 235, 132}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 217, 227, 120, 39}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 170}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 70, 71, 187, 59, 235}, 13},
	{{216, 0, 0, 0, 0, 78, 254, 194, 84, 251, 228, 134, 64, 179, 92, 98}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 152, 14, 250, 247, 169, 14, 121, 150, 106}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 174, 22, 62, 76}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 19, 206, 200, 213, 222, 12, 146, 99}, 13},
	{{216, 0, 0, 0, 0, 249, 106, 135, 65, 81, 190, 227, 18, 133, 204, 4}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 201, 194, 213, 12}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 201, 222}, 13},
	{{216, 0, 104, 180, 181, 227, 114, 137, 94, 220, 6, 216, 196, 216, 176, 166}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 69}, 13},
	{{216, 0, 0, 0, 227, 226, 158, 96, 106, 135, 211, 10, 32, 21, 163, 40}, 13},
	{{216, 0, 0, 0, 0, 0, 119, 222, 122, 186, 231, 195, 13, 76, 75, 138}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 94, 61, 235, 104, 205, 201, 93, 166}, 13},
	{{216, 0, 0, 0, 198, 183, 145, 56, 61, 195, 252, 199, 63, 87, 102, 95}, 13},
	{{216, 0, 0, 0, 0, 0, 90, 153, 222, 217, 255, 27, 120, 34, 79, 233}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 172, 253, 218}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 128, 5, 241}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 0, 251, 231, 70}, 13},
	{{216, 0, 0, 0, 83, 27, 44, 56, 16, 101, 41, 34, 192, 152, 178, 237}, 13},
	{{216, 0, 0, 0, 0, 0, 206, 31, 108, 182, 109, 128, 153, 99, 236, 184}, 13},
	{{216, 0, 0, 0, 0, 13, 91, 199, 240, 99, 39, 24, 161, 71, 15, 93}, 13},
	{{216, 0, 157, 94, 226, 165, 236, 110, 104, 119, 34, 76, 36, 47, 217, 48}, 13},
	{{216, 0, 0, 0, 10, 242, 57, 13, 73, 25, 62, 33, 94, 241, 59, 127}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 221, 183, 34, 107, 106, 106, 41, 90, 24}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 145, 73}, 13},
	{{216, 0, 0, 0, 0, 0, 166, 219, 112, 18, 160, 67, 12, 126, 38, 62}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 233, 231, 55, 193}, 13},
	{{216, 0, 0, 0, 0, 158, 22, 234, 15, 28, 172, 15, 247, 188, 160, 45}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 189, 119, 162, 2, 250, 110, 152}, 13},
	{{216, 0, 0, 0, 12, 52, 132, 14, 102, 243, 132, 214, 134, 61, 226, 58}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 160}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 165}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 209, 54}, 13},
	{{216, 0, 0, 0, 0, 0, 74, 68, 216, 74, 129, 52, 47, 129, 153, 37}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 50, 87}, 13},
	{{216, 40, 202, 97, 31, 148, 77, 90, 50, 219, 243, 153, 247, 221, 196, 46}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 182, 189, 66, 44, 67, 125, 193, 77, 180}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{216, 0, 0, 0, 0, 37, 66, 172, 248, 198, 79, 230, 147, 66, 172, 43}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 68, 63, 173, 246, 206}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 158, 153, 106, 194, 66, 162, 169, 73}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 41, 89, 129, 163, 96, 219, 49, 133}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 131, 109, 244, 237, 181, 244, 14, 131}, 13},
	{{216, 0, 0, 0, 20, 13, 187, 201, 123, 208, 234, 119, 193, 106, 160, 236}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 112, 233, 217, 67}, 13},
	{{216, 0, 0, 0, 61, 156, 195, 9, 61, 186, 137, 165, 209, 178, 198, 251}, 13},
	{{216, 0, 220, 88, 137, 68, 20, 16, 5, 37, 240, 99, 155, 217, 85, 104}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 37, 135, 73, 136, 212, 234, 180}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{216, 0, 0, 0, 0, 162, 252, 76, 52, 173, 201, 224, 84, 156, 165, 162}, 13},
	{{216, 0, 0, 0, 0, 0, 0, 0, 0, 13, 32, 92, 197, 67, 166, 121}, 13},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 175, 151, 245, 177}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 62, 219, 119, 97, 152}, 41},
	{{135, 215, 0, 71, 24, 153, 23, 125, 232, 179, 15, 219, 152, 85, 87, 212}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 253}, 41},
	{{135, 215, 0, 71, 24, 0, 94, 51, 152, 1, 121, 14, 224, 42, 104, 251}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 12, 205, 140, 37, 251}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 247, 143, 157}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 242, 183, 166, 164, 161, 191, 240, 200}, 41},
	{{135, 215, 0, 71, 24, 0, 108, 59, 52, 195, 116, 168, 6, 74, 133, 253}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 170, 223, 71, 129, 167, 90, 78, 16, 238}, 41},
	{{135, 215, 0, 71, 24, 134, 94, 98, 68, 5, 165, 128, 22, 150, 136, 58}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 171, 135, 178, 104, 255, 16, 20}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 234, 200, 44, 162}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 16, 59, 133}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 41},
	{{135, 215, 0, 71, 24, 0, 154, 244, 193, 101, 190, 159, 94, 148, 246, 142}, 41},
	{{135, 215, 0, 71, 24, 0, 239, 214, 26, 80, 5, 242, 119, 95, 83, 234}, 41},
	{{135, 215, 0, 71, 24, 0, 6, 145, 87, 168, 72, 3, 65, 63, 31, 18}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 98, 102, 202, 238, 99, 126, 186, 222}, 41},
	{{135, 215, 0, 71, 24, 230, 120, 19, 162, 11, 194, 231, 234, 41, 3, 222}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 237, 53, 254, 22, 54, 46, 72, 76, 228}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 25}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 178, 141, 107}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 88, 185, 17, 25, 29}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 52, 204, 73, 172}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 248, 74, 230, 118, 28, 231}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 137, 128, 45, 223, 236, 119}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 175, 51, 225, 232, 80}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 44, 109, 80, 58, 174, 43, 249, 254}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 114, 235, 8, 101}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 158, 20, 176, 31, 252, 240, 175}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 42, 194, 61, 72}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 220, 94, 213, 106, 137, 117, 74, 156}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 57, 114, 131, 46}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 224, 169, 150, 86, 255, 41}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 132, 196, 141, 114, 195, 112, 138, 72}, 41},
	{{135, 215, 0, 71, 24, 51, 75, 219, 141, 55, 155, 81, 211, 126, 162, 0}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 254}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 229, 77, 202, 132, 70}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 41, 195, 79}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 63, 250, 241, 83}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 85, 57, 48, 235, 80, 83, 110, 20, 50}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 37, 196, 45, 15, 71, 154, 148}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 79, 100, 249}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 188, 20, 66, 31, 113, 5, 57, 238}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 248, 34, 120}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{135, 215, 0, 71, 24, 0, 94, 43, 116, 106, 33, 229, 175, 31, 216, 121}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 155, 240, 227, 203, 57, 246, 97, 123}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 246, 159, 207}, 41},
	{{135, 215, 0, 71, 24, 5, 189, 112, 92, 218, 61, 192, 79, 206, 135, 221}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 182, 147, 149, 131, 79, 160}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 255}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 229, 127, 46, 152, 101, 50, 210}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 130, 217, 46}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 104, 35, 223, 225, 131, 245, 147}, 41},
	{{135, 215, 0, 71, 24, 0, 156, 161, 93, 182, 64, 174, 103, 45, 177, 165}, 41},
	{{135, 215, 0, 71, 24, 144, 124, 23, 13, 125, 38, 2, 43, 224, 116, 138}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 41},
	{{135, 215, 0, 71, 24, 0, 122, 7, 200, 138, 229, 239, 169, 23, 232, 95}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39}, 41},
	{{135, 215, 0, 71, 24, 46, 220, 224, 238, 237, 248, 0, 119, 140, 139, 180}, 41},
	{{135, 215, 0, 71, 24, 0, 225, 15, 36, 76, 121, 78, 123, 58, 87, 142}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 48, 8, 161, 74, 111}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 164, 158, 173, 135, 124, 222, 53, 237}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 154, 72, 199, 147, 218, 58, 211, 112}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 212, 231, 180}, 41},
	{{135, 215, 0, 71, 24, 0, 49, 27, 91, 233, 217, 3, 15, 184, 172, 202}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 227, 20, 187, 161}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{135, 215, 0, 71, 24, 0, 11, 139, 80, 203, 110, 130, 162, 120, 135, 164}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 116, 92, 168}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 22, 49, 118, 1, 132, 189}, 41},
	{{135, 215, 0, 71, 24, 0, 41, 178, 232, 72, 58, 48, 39, 9, 5, 199}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 83, 104, 204, 132}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 228, 217, 49, 113, 51, 239, 223}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 154, 79, 236, 108}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 115, 154, 97, 203, 231, 248, 231, 158, 31}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 204, 227, 240, 175, 204}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{135, 215, 0, 71, 24, 0, 0, 0, 0, 0, 0, 0, 0, 88, 188, 127}, 41},
	{{135, 215, 0, 71, 24, 231, 217, 57, 102, 146, 208, 237, 85, 165, 144, 99}, 41},
	{{221, 149, 1, 40, 112, 0, 153, 248, 153, 114, 69, 87, 122, 218, 57, 202}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 99, 132, 243, 45, 80, 157}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 22, 169, 135, 93, 171, 223, 170, 32, 92}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 155, 235, 61, 193, 225}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 123, 16, 58, 109}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 113, 251, 192, 83, 27, 169, 246}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 5, 63, 181, 142}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 83, 108, 43, 168, 83, 113}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 5, 2, 17, 190, 106, 80}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 79, 79, 162, 20, 66, 188, 250, 117, 56}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 137, 164, 255, 17, 63, 103, 103, 122, 123}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 162, 246, 69, 108, 69}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 33, 46, 255, 33, 165}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 135},
	{{221, 149, 1, 40, 112, 168, 148, 93, 114, 46, 163, 30, 73, 127, 105, 217}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 163, 158, 226, 145}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 66, 15, 73, 21, 29, 85, 188, 72, 252}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 196}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 136, 158, 185, 108, 96, 184, 41}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 249, 194, 29, 39, 218, 174}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 68, 107, 30, 28, 47, 104}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 177, 89, 195, 84, 102}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 96}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 209, 164, 25, 188}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 87, 229, 217}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 122, 75, 67, 3, 96, 50}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 20}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 134, 115, 190, 140, 34, 27, 153}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 249, 18, 44, 174}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 27, 200, 116, 135, 191, 24, 83, 15, 52}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 252, 78, 20, 159, 17, 70}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 117}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 82, 253, 182, 109, 195, 166}, 135},
	{{221, 149, 1, 40, 112, 0, 210, 225, 8, 151, 100, 143, 2, 229, 158, 99}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{221, 149, 1, 40, 112, 0, 30, 51, 222, 170, 167, 207, 170, 118, 140, 60}, 135},
	{{221, 149, 1, 40, 112, 0, 50, 100, 21, 63, 34, 149, 14, 121, 83, 93}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 73, 55, 76, 214}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 209, 102, 151, 153}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{221, 149, 1, 40, 112, 0, 113, 10, 51, 144, 38, 115, 96, 193, 101, 118}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 161, 99, 55, 19}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 214, 211, 222, 26, 183, 92}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 202, 122, 167, 23, 69}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 240, 83, 138, 249}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 134, 26, 236, 92, 78}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 58, 46, 51, 145, 245, 27, 6, 139, 89}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 25, 199, 34, 144, 210, 186}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 207, 238, 231, 209, 169, 53, 242, 229, 239}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 81, 16, 229, 33, 144, 10, 34}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 253, 91, 128, 61, 205, 209, 186, 177, 181}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 160}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 172, 170, 252, 150, 84, 178}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 95, 222, 230, 174, 204}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 135},
	{{221, 149, 1, 40, 112, 0, 255, 89, 2, 44, 101, 137, 230, 179, 96, 144}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 165, 201, 118, 191, 29, 68, 91, 129, 55}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 47, 35, 90, 149}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 75, 47, 78}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 226, 155, 107, 191, 10, 21}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 50, 33, 200, 222, 80}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 11, 195, 160, 234, 103, 173}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 157, 159, 175, 91, 16, 92}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 177, 124, 169, 236}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 220, 197, 77}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 191, 249, 226, 117, 46, 142}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 59, 24, 140, 170, 196}, 135},
	{{221, 149, 1, 40, 112, 0, 160, 38, 46, 140, 0, 186, 15, 53, 13, 83}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 243, 103, 213, 108, 2, 53, 185, 227, 153}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 6, 101, 31, 227, 97, 164}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 11, 74, 178, 119}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 39, 53, 102, 156, 32, 155, 61}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 48, 58, 9, 52, 147, 133, 85, 94}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 113, 51, 172, 198, 250, 38, 203, 80, 195}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 106, 54, 16, 212, 7, 11, 215, 244}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 45, 157, 66, 25, 61, 176, 66}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 183}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 77, 20, 109, 75, 219}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 125, 215, 141, 41, 57, 192, 218}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 200, 202, 137, 223, 245}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 232, 251, 237, 159}, 135},
	{{221, 149, 1, 40, 112, 77, 199, 161, 4, 94, 231, 159, 216, 111, 44, 82}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 253, 148, 148, 83, 238, 194, 134}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 62, 230, 151, 113, 47, 130, 76, 155}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 204, 128, 189, 164, 38}, 135},
	{{221, 149, 1, 40, 112, 0, 6, 195, 213, 75, 199, 115, 66, 254, 163, 255}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 75, 165, 199, 192, 91}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 27}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 143, 32, 120, 102, 150, 206, 24, 27}, 135},
	{{221, 149, 1, 40, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 135},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 206, 21}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 240, 14}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 150, 240}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 31}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 246}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 97, 107, 98, 133}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 255}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 249}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 31}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 193, 107, 122}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 206, 107}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 17, 165, 218}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 46}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 182}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 183, 192, 1}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 134, 199, 11, 98}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 15, 214}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 134, 142}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 43}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 74, 78, 93}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 230, 148, 251}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 42}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 54}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 35}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 73}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 233, 216, 24}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 109}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 163}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 194, 114}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 163}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 127}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 176, 4}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 52, 92, 103}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 14}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 134}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 145, 22}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 200, 97, 244}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 217, 212}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 177, 143}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 119, 184, 139}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 244, 9}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 78, 60, 108}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 10, 187, 21}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 31, 148}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 12, 31}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 49, 168}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 183, 216}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 193}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 141}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 102, 114, 29, 91}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 224, 53}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 62}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 212, 76}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 76}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 167, 137, 213}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 90, 20, 137}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 72, 57}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 124, 179, 168}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 133, 172, 23}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 30, 243}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 164}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 106}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 216, 17, 30}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 184, 45, 33}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 156, 31, 51}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 175, 207}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 143, 234}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 203, 183, 244}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 167}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 149, 160}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 142, 139}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 204, 240, 21}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 64, 203}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 224}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 173}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 122, 156, 25, 94}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 82, 146, 117, 138}, 171},
	{{95, 143, 255, 194, 2, 157, 191, 113, 10, 229, 204, 56, 0, 0, 0, 0}, 171},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 193}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 184, 56, 30, 43, 107, 5, 203, 118, 254}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 129, 45, 227, 48, 70, 138, 211, 229, 228}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 83, 64, 226, 26, 68, 191}, 20},
	{{202, 212, 96, 127, 196, 154, 160, 103, 155, 5, 123, 207, 12, 96, 174, 52}, 20},
	{{202, 212, 96, 0, 0, 88, 122, 165, 225, 149, 64, 135, 10, 20, 121, 146}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 158, 178, 139, 23, 240}, 20},
	{{202, 212, 96, 0, 3, 60, 232, 9, 6, 79, 248, 249, 97, 143, 84, 111}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 27, 219, 185, 243, 88, 60, 212, 39, 108}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 131, 166, 111}, 20},
	{{202, 212, 96, 0, 0, 0, 50, 131, 59, 179, 139, 96, 69, 238, 99, 122}, 20},
	{{202, 212, 96, 0, 248, 38, 246, 79, 84, 30, 31, 79, 179, 192, 251, 99}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 185}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 77}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 35}, 20},
	{{202, 212, 96, 0, 0, 0, 27, 65, 62, 70, 247, 212, 15, 174, 134, 68}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 91, 75, 240, 176, 225}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20},
	{{202, 212, 96, 0, 0, 185, 27, 90, 179, 211, 74, 95, 55, 129, 88, 54}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 43, 209, 50, 195, 235, 76, 238, 198, 180}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 210, 74, 51, 69, 218, 93}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 18, 248, 107, 207, 61, 233, 4, 20, 179}, 20},
	{{202, 212, 96, 0, 0, 0, 74, 159, 65, 107, 74, 144, 225, 204, 62, 219}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 217, 52, 232, 194, 98, 11, 232}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 35, 250}, 20},
	{{202, 212, 96, 0, 0, 0, 96, 218, 78, 192, 167, 180, 106, 31, 69, 231}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 101, 46, 210, 119, 60, 26, 73, 43}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 169, 10, 164, 17, 217}, 20},
	{{202, 212, 96, 0, 0, 0, 81, 103, 117, 181, 25, 222, 236, 94, 6, 255}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 36, 0, 43, 107, 172, 231, 186, 208}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 235, 95, 77}, 20},
	{{202, 212, 96, 29, 155, 242, 162, 252, 232, 83, 38, 33, 174, 184, 254, 173}, 20},
	{{202, 212, 96, 0, 0, 28, 244, 154, 251, 209, 37, 210, 85, 207, 87, 239}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 5, 85, 219}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 205, 16, 18, 93, 223, 169, 188, 111, 194}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 202, 49, 177, 39, 234, 228}, 20},
	{{202, 212, 96, 187, 221, 158, 253, 110, 255, 165, 43, 138, 48, 146, 153, 141}, 20},
	{{202, 212, 96, 0, 174, 203, 132, 224, 150, 225, 98, 215, 200, 1, 73, 17}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 38, 135, 202, 27, 165}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 26, 227, 52, 248, 81}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 231, 36}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 146}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 250, 114, 86}, 20},
	{{202, 212, 96, 0, 0, 227, 106, 205, 80, 189, 175, 50, 104, 245, 85, 254}, 20},
	{{202, 212, 96, 0, 6, 198, 155, 202, 181, 152, 0, 94, 85, 188, 26, 82}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 234, 55, 211, 252, 135, 6, 245, 186}, 20},
	{{202, 212, 96, 0, 20, 157, 73, 59, 82, 94, 207, 156, 188, 254, 92, 254}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 120, 56, 191, 244, 125, 33, 230}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 203, 206, 151, 38, 2, 164, 177, 138, 219}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 127, 30, 95, 138, 126, 176, 64}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 166, 86}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 234, 38, 44, 215, 184, 28, 253, 1}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 221}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 176, 227, 159, 6, 188, 182, 191, 159, 250}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 60, 29, 44, 11, 250, 220, 115}, 20},
	{{202, 212, 96, 83, 224, 110, 111, 245, 160, 80, 21, 169, 155, 246, 90, 10}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 22, 135}, 20},
	{{202, 212, 96, 0, 0, 0, 19, 20, 62, 195, 115, 76, 29, 35, 166, 43}, 20},
	{{202, 212, 96, 40, 27, 248, 37, 93, 246, 3, 160, 212, 67, 215, 212, 225}, 20},
	{{202, 212, 96, 0, 0, 134, 34, 103, 9, 84, 201, 212, 86, 0, 167, 217}, 20},
	{{202, 212, 96, 0, 0, 0, 100, 224, 83, 228, 226, 168, 97, 95, 67, 96}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 27, 123, 186, 190, 80, 196}, 20},
	{{202, 212, 96, 0, 0, 0, 202, 240, 177, 23, 100, 8, 141, 187, 222, 36}, 20},
	{{202, 212, 96, 0, 0, 225, 68, 2, 90, 71, 52, 48, 30, 213, 23, 9}, 20},
	{{202, 212, 96, 0, 45, 48, 121, 209, 118, 183, 36, 114, 108, 23, 254, 93}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 253, 117}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20},
	{{202, 212, 96, 0, 201, 108, 47, 141, 33, 221, 93, 98, 22, 29, 20, 120}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 211, 14, 228, 234, 90, 43, 146, 196, 193}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 85}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 39}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 41, 32}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 247, 131, 219, 48, 54, 216, 248}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 4, 151, 3, 108, 88, 110, 58}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 100, 120}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 20},
	{{202, 212, 96, 0, 0, 25, 129, 167, 94, 67, 125, 160, 103, 7, 229, 231}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 171, 204, 146, 22, 31, 240, 151, 71}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 87, 100, 25}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 180, 129, 217, 61, 144, 202}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 132, 78}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 190, 144, 149, 29, 154, 147}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 90}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 97, 26, 105, 160, 216}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 112}, 20},
	{{202, 212, 96, 0, 228, 222, 228, 77, 86, 26, 246, 152, 201, 245, 82, 195}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15}, 20},
	{{202, 212, 96, 0, 11, 255, 91, 176, 15, 56, 47, 177, 122, 254, 141, 9}, 20},
	{{202, 212, 96, 0, 0, 0, 0, 0, 0, 0, 0, 130, 201, 189, 75, 181}, 20},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 226, 249, 186}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 46, 151}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 217, 244, 3}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 26, 124, 164, 243}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 106, 85, 49, 145}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 69, 116, 249}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 211, 234, 172, 165}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 3, 57}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 112, 124, 184}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 42}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 34, 226}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 96, 74, 180, 98}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 12, 111}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 9}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 56, 149}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 158, 123, 78, 106}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 221, 205, 190, 179}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 153, 35, 15}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 210, 58}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 98}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 34, 144, 49}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 160, 250, 51, 201}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 169}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 31, 215, 232, 21}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 93, 74, 30, 222}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 159, 55, 171, 138}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 71}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 191, 191, 146}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 114, 179, 194}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 62, 45, 85, 213}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 193, 129}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 198, 165}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 147, 189}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 232, 139, 6}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 131, 106, 139}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 65, 190}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 121, 149, 19}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 127}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 114, 16, 155}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 255, 63, 120, 136}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 9}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 86}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 108, 43}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 16, 63}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 142, 188, 255}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 195, 232, 212}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 211, 68, 63}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 231, 12, 181}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 5, 184}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 139, 234}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 106, 232}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 84, 2}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 117, 10, 196, 1}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 124, 201, 78, 58}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 150}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 143}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 104, 138}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 42, 234}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 102}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 100, 104, 195}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 122, 119, 35, 187}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 254}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 119, 120, 239}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 252, 41}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 170}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 6}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 16, 19, 76}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 215, 8, 77}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 203, 218}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 132, 183, 6, 77}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 134, 11}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 0}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 86, 95, 29, 45}, 119},
	{{147, 203, 238, 120, 194, 23, 25, 58, 208, 177, 169, 0, 0, 0, 0, 13}, 119},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 61}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 60}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 194}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 230}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 56}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 88}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 14}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 16}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 16}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 78}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 252}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 219}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 122}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 31}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 6}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 22}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 143}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 69}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 122}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 4}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 222}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 20}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 32}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 93}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 200}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 120}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 251}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 90}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 34}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 220}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 143}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 163}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 57}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 59}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 237}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 248}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 20}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 191}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 41}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 68}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 153}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 173}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 84}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 194}, 49},
	{{137, 170, 113, 252, 215, 194, 224, 146, 233, 87, 86, 192, 26, 46, 0, 0}, 49},
	{{224, 0, 0, 29, 241, 150, 36, 254, 175, 131, 74, 77, 95, 128, 13, 116}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 41, 29}, 141},
	{{224, 0, 195, 245, 162, 22, 234, 249, 66, 236, 130, 45, 103, 154, 21, 168}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 140, 22, 7}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 65, 51, 215, 61, 119, 14, 88, 92, 195}, 141},
	{{224, 0, 0, 129, 134, 243, 107, 84, 69, 95, 72, 206, 41, 42, 83, 229}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 141},
	{{224, 0, 0, 0, 0, 0, 62, 193, 174, 158, 45, 113, 147, 78, 82, 224}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{224, 0, 0, 0, 0, 215, 77, 37, 235, 171, 165, 38, 131, 183, 207, 2}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 204, 162}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 252, 116}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 17, 225, 93}, 141},
	{{224, 0, 0, 69, 133, 82, 85, 60, 200, 154, 78, 231, 87, 44, 65, 232}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 181, 23, 109, 143, 13, 191, 31, 172}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 111, 230, 136}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 141},
	{{224, 0, 0, 212, 43, 219, 102, 109, 117, 59, 18, 142, 125, 48, 117, 184}, 141},
	{{224, 0, 40, 192, 186, 59, 156, 201, 153, 225, 235, 55, 214, 243, 22, 51}, 141},
	{{224, 0, 58, 184, 133, 36, 199, 192, 79, 64, 238, 79, 210, 1, 93, 116}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 114, 65, 168, 67, 202, 15, 64, 142, 19}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 179, 8, 67, 149, 113}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 22, 141, 215}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 110, 30, 90}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 225}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 156, 70, 228}, 141},
	{{224, 0, 0, 0, 8, 48, 24, 172, 81, 225, 129, 132, 120, 237, 234, 135}, 141},
	{{224, 0, 0, 18, 35, 13, 64, 248, 129, 166, 61, 120, 138, 29, 7, 16}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 223, 131, 231, 0, 158, 178, 125}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 186, 13, 153, 7, 48, 99, 69, 84}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 252, 132, 84}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 226, 58, 193, 105, 174}, 141},
	{{224, 0, 0, 0, 81, 97, 177, 125, 206, 104, 228, 208, 255, 230, 43, 209}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 141},
	{{224, 0, 0, 46, 106, 1, 134, 31, 88, 126, 143, 182, 211, 219, 62, 122}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 186}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 191, 138, 79, 172, 81, 62, 61, 8, 81}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 43, 68}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 70, 64, 150, 252}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 232, 179, 235}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 141, 190, 49, 30, 217, 133, 101}, 141},
	{{224, 0, 0, 0, 0, 217, 114, 205, 127, 127, 224, 250, 2, 123, 84, 14}, 141},
	{{224, 0, 0, 0, 0, 0, 150, 13, 62, 158, 174, 216, 183, 146, 210, 157}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 160, 10, 178, 215, 157, 210, 150, 187, 158}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 237, 139, 126, 197, 73, 121, 55, 136}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 118}, 141},
	{{224, 0, 0, 129, 211, 67, 173, 130, 166, 40, 243, 46, 25, 189, 84, 85}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 91, 170, 201, 18, 24, 126, 13}, 141},
	{{224, 0, 0, 156, 182, 237, 131, 97, 247, 52, 12, 173, 204, 38, 86, 180}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 63}, 141},
	{{224, 0, 0, 0, 0, 0, 29, 243, 128, 1, 69, 135, 200, 31, 240, 4}, 141},
	{{224, 0, 0, 0, 0, 103, 141, 173, 228, 146, 215, 237, 98, 17, 186, 209}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 205, 135, 218, 179, 74, 213, 159, 207, 204}, 141},
	{{224, 0, 0, 218, 149, 111, 221, 79, 166, 217, 107, 165, 237, 229, 124, 171}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 97, 77}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 146, 61}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 114, 45}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 59, 66, 76, 150, 29, 64, 137, 61, 90}, 141},
	{{224, 0, 0, 0, 0, 0, 31, 95, 61, 129, 68, 230, 72, 0, 91, 206}, 141},
	{{224, 0, 0, 0, 0, 99, 37, 194, 9, 238, 152, 83, 188, 130, 181, 101}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 152, 12, 82, 196}, 141},
	{{224, 0, 0, 0, 0, 105, 56, 190, 140, 77, 41, 58, 85, 102, 206, 218}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 175, 73}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 93, 207, 17, 59, 14}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 61, 77, 69, 10, 60, 143, 228}, 141},
	{{224, 0, 0, 0, 0, 0, 171, 80, 72, 199, 57, 98, 23, 210, 6, 236}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 45, 102, 173, 35}, 141},
	{{224, 0, 0, 0, 0, 253, 25, 33, 30, 176, 91, 100, 25, 180, 209, 212}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{224, 0, 0, 0, 0, 234, 30, 188, 115, 205, 204, 170, 90, 127, 103, 20}, 141},
	{{224, 0, 0, 0, 0, 112, 119, 230, 52, 202, 25, 144, 232, 106, 137, 248}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 186, 220, 54, 200}, 141},
	{{224, 0, 0, 0, 0, 227, 10, 44, 206, 84, 220, 81, 50, 185, 127, 238}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 156}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 232, 226, 207}, 141},
	{{224, 0, 0, 0, 170, 141, 252, 238, 10, 50, 94, 134, 242, 41, 205, 157}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 137, 94}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 56, 163, 80}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 180, 236, 162, 37}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 152, 162}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 158}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 163, 234, 147, 173, 111, 66, 160, 107}, 141},
	{{224, 189, 104, 160, 178, 241, 25, 30, 59, 146, 31, 22, 225, 190, 3, 215}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 220, 41, 40, 95, 119, 240, 243}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 36, 103, 90, 35, 91}, 141},
	{{224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 108, 209}, 141},
	{{224, 0, 0, 0, 237, 0, 251, 205, 125, 10, 74, 107, 251, 132, 198, 219}, 141},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 249, 107, 8, 48, 37, 196}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 252, 206, 3, 57, 166, 107}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 134, 85, 67, 153}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 164, 189, 160, 226, 54, 86, 193, 100, 58}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 73, 90, 195, 76}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 161, 203, 241, 236, 36, 219, 207, 51, 14}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 189, 59, 26, 146, 139}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 122, 23, 148, 194, 124, 153, 134}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 162, 73, 164, 224}, 132},
	{{250, 90, 241, 174, 163, 72, 38, 251, 63, 82, 63, 116, 238, 179, 3, 182}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 242, 3, 137, 67}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 34, 180, 198, 21, 182, 151, 20, 210, 87}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 29, 86, 111, 173, 66, 154, 212}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 103, 207, 142, 34}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 189, 201, 13, 115, 128, 56, 128, 182}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 203, 229, 131, 239, 50, 92, 200}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 135, 189}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 116, 64, 48, 168, 45, 202}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 24, 223, 174, 154, 109, 42}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 32, 154, 151}, 132},
	{{250, 90, 241, 174, 163, 72, 130, 93, 208, 175, 146, 148, 119, 181, 230, 26}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 253, 193, 26, 91, 206, 85}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 117, 193, 176, 121, 27}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 37, 96, 113, 9}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 58, 216, 97, 132, 0, 224}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 49, 73, 70, 72, 1}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 68, 170, 188, 175, 203}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 201, 238}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 228, 226, 200, 112}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 122, 49, 251, 163, 5, 68, 40, 195, 250}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 24, 98, 241, 48, 111}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 110, 242, 67, 57, 121, 194, 19}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 12, 247, 233, 128, 199}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 44, 150, 39, 195, 94, 28, 65, 200}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 200, 71, 4}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 116, 173, 9, 181, 57, 176, 169, 15}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 14, 184, 194, 32}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 237, 33, 13, 37}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 205, 41, 95, 161, 219}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 205, 176, 106, 11, 91, 132, 25, 61}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 234, 239, 32, 16, 47, 182}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 240, 125, 246, 97, 47, 138}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 12, 87, 151, 228, 27, 127, 247}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 84, 27, 203, 250, 10, 0, 160, 60}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 68, 201, 113, 1, 185, 31, 64, 19, 4}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 151, 84}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 146, 186, 251}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 220, 218, 10, 201, 43}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 245, 142, 142, 185, 58, 215, 48, 114}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 229, 238, 254, 71, 213, 237, 85}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 75, 18, 206, 174, 245, 178, 36, 223, 3}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 186, 103, 111}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 171, 73, 87, 60, 244, 44, 109, 219, 10}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 239, 210, 6, 184, 229, 233, 61, 211, 108}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 201, 100, 51, 21, 90, 138, 79}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 80, 202, 159, 75, 76, 34, 230}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 33, 185, 195, 244, 2, 214, 87, 56}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 129, 66, 24, 204}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 198, 239, 8}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 18, 224, 153, 69, 83, 73}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 105, 83, 22}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 120, 209, 75, 4, 214, 118, 151}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 10, 2, 181, 147, 56}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 124, 148, 176, 21, 42, 230, 82, 221, 215}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 192, 156}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 215, 49, 32, 113, 126, 134, 148, 246}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 71, 176, 116, 169, 80}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 215, 32}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 74, 181, 141, 114, 92}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 124, 179, 141}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 143, 130, 220}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 24, 113, 103, 19, 247, 155, 148, 178, 100}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 61, 0, 152}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 106, 205, 220, 94, 141, 190}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 166, 233, 97, 161, 232}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{250, 90, 241, 174, 163, 72, 0, 0, 0, 0, 0, 0, 0, 0, 46, 117}, 132},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 27, 16}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 48}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 2}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 191}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 176, 188}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 21, 140}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 139}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 131, 207}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 72}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 151}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 116, 2}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 3}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 240, 86}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 44, 160}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 169, 50}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 4, 237}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 235, 30}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 67}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 53}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 61}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 104}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 83}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 167}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 252}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 50, 163}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 148}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 181, 154}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 159}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 62}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 40, 85}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 37, 141}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 74}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 43, 184}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 18}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 94, 201}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 62}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 27, 104}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 240}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 110, 208}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 123}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 89, 11}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 168}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 169, 36}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 74, 193}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 32, 139}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 150, 238}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 38, 238}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 201}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 198, 111}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 131}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 248}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 34, 150}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 46}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 27, 92}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 164, 210}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 21, 104}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 255}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 95, 151}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 110}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 0}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 218, 15}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 77, 99}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 229}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 214, 126}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 4}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 72}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 0, 128}, 176},
	{{66, 190, 202, 144, 122, 86, 22, 103, 107, 164, 57, 54, 228, 128, 105, 165}, 176},
	{{76, 64, 0, 0, 0, 0, 0, 0, 97, 175, 244, 244, 44, 194, 129, 116}, 186},
	{{76, 64, 0, 0, 0, 112, 18, 158, 14, 64, 64, 193, 42, 252, 5, 143}, 186},
	{{76, 64, 0, 0, 0, 27, 118, 98, 43, 18, 121, 10, 190, 224, 85, 85}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 29, 11, 156}, 186},
	{{76, 64, 242, 156, 105, 227, 81, 55, 246, 165, 197, 250, 177, 212, 37, 43}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 118, 12, 227, 178}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 129, 186, 77, 166, 252, 22, 114}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 240, 209, 114, 26}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 53, 60, 88, 146}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 70}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 114, 118, 154}, 186},
	{{76, 64, 0, 84, 229, 99, 87, 78, 229, 15, 198, 181, 105, 183, 0, 220}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 74, 28, 135, 127, 178, 8}, 186},
	{{76, 64, 0, 0, 0, 0, 176, 197, 64, 111, 91, 144, 9, 23, 237, 27}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 193, 214, 12, 158, 80, 129}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 244, 22, 77, 39, 54, 94, 82}, 186},
	{{76, 64, 0, 0, 0, 0, 122, 241, 106, 218, 33, 146, 117, 75, 42, 226}, 186},
	{{76, 64, 0, 0, 0, 0, 201, 53, 60, 200, 187, 120, 138, 20, 130, 74}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 25, 178, 111, 97}, 186},
	{{76, 64, 123, 138, 225, 215, 85, 190, 155, 156, 42, 51, 142, 58, 149, 186}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{76, 64, 0, 0, 200, 90, 46, 139, 215, 88, 56, 69, 99, 197, 95, 234}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 80, 21, 102, 25, 236, 242, 205, 180, 31}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 34, 117, 210, 129, 213, 137, 51, 30}, 186},
	{{76, 64, 0, 0, 0, 0, 120, 98, 34, 151, 35, 64, 202, 162, 220, 230}, 186},
	{{76, 64, 0, 0, 249, 150, 73, 54, 54, 249, 114, 190, 67, 163, 132, 59}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 161, 11, 243, 177, 51, 141}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 199, 201, 39, 91, 114, 19, 236}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 186},
	{{76, 64, 0, 0, 247, 197, 42, 177, 200, 26, 62, 117, 160, 42, 178, 193}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 209, 78, 70, 85, 20, 87, 26}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 56, 74, 223, 118, 233, 198}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 205, 125, 207, 85, 243, 82, 163, 215, 32}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 80, 194}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 63, 25, 254, 232}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 79, 155, 149, 90, 233, 17, 32}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 134, 204, 142, 227, 220, 238}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 186},
	{{76, 64, 0, 0, 0, 0, 245, 248, 203, 66, 43, 210, 60, 126, 252, 227}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{76, 64, 0, 0, 239, 156, 118, 186, 118, 198, 44, 141, 77, 214, 186, 87}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 213}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 175, 85, 244, 241}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{76, 64, 0, 34, 39, 178, 62, 150, 163, 12, 197, 56, 16, 128, 165, 161}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 166, 88, 61, 143, 161, 203, 206, 233, 216}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 243, 12, 177, 55, 8, 172, 63, 218, 185}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 42, 7}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{76, 64, 0, 0, 0, 0, 243, 23, 161, 143, 111, 107, 10, 39, 45, 123}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 15, 180, 157, 234, 173, 169}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 105, 215, 116, 188, 171, 75, 82}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 216, 255, 74, 46, 135, 9}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 186},
	{{76, 64, 0, 0, 0, 0, 78, 100, 138, 99, 196, 21, 203, 179, 47, 137}, 186},
	{{76, 64, 0, 0, 0, 0, 210, 148, 93, 130, 56, 159, 47, 147, 151, 53}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 207, 33, 112}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 208, 194, 248, 109, 240, 39, 188}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 195, 125, 177, 33, 174, 178}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 179, 16, 163}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 36, 161, 33}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 145, 138, 37, 76, 121, 181}, 186},
	{{76, 64, 0, 27, 43, 188, 250, 176, 0, 21, 9, 208, 123, 122, 66, 91}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 63}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 94, 9, 107, 102}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 253, 209, 255, 71}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 186},
	{{76, 64, 0, 0, 0, 0, 250, 170, 88, 38, 135, 150, 231, 144, 231, 50}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 41, 128, 132}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 11, 18, 232}, 186},
	{{76, 64, 0, 243, 82, 88, 172, 120, 223, 70, 64, 25, 59, 17, 137, 30}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 189, 231, 130, 232}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 57, 225, 223}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 122, 128}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 171, 84, 58, 33, 153, 148}, 186},
	{{76, 64, 0, 0, 0, 0, 133, 132, 161, 183, 159, 251, 114, 237, 242, 37}, 186},
	{{76, 64, 0, 7, 250, 25, 228, 155, 242, 55, 66, 107, 14, 83, 44, 34}, 186},
	{{76, 64, 0, 0, 241, 135, 245, 232, 189, 40, 81, 110, 53, 116, 5, 77}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 105, 244}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236}, 186},
	{{76, 64, 0, 0, 0, 0, 67, 64, 172, 52, 208, 100, 4, 135, 61, 165}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 56, 243, 167, 142, 213, 131}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 69, 222}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{76, 64, 0, 0, 0, 0, 102, 255, 233, 113, 86, 90, 250, 121, 19, 67}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 115, 28, 21}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 141}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 112, 195, 96, 213, 7, 188, 115, 131, 210}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 73, 245, 254, 18, 101, 207, 239, 35, 63}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 91, 174, 36, 211, 18, 119}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 186},
	{{76, 64, 222, 245, 184, 68, 235, 215, 112, 213, 238, 140, 102, 59, 251, 7}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 146, 30, 217, 196, 173, 230}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 64, 144, 227, 150, 215, 241}, 186},
	{{76, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223}, 186},
	{{76, 64, 0, 0, 0, 0, 119, 150, 173, 173, 93, 52, 105, 64, 130, 217}, 186},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 123, 243, 45, 187, 248, 232, 43}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 223, 234, 61, 127, 20}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 203, 250, 215, 194}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 229}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 9, 24, 119, 134}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 96, 47, 156, 141}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 29, 77, 149, 129, 99, 159, 223}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 63, 163, 20, 139, 181, 4}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 19, 206, 114}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 124, 62, 139, 249}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 202}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 192, 204, 65, 50, 132, 215}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 100, 206, 227, 166, 70}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 16, 135, 167, 72}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 188, 65, 116}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 88, 124, 251, 5}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 122, 247, 96, 87, 211, 24}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 87, 159, 58, 163}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 35, 25, 139, 242, 255, 254}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 7, 93, 124, 86, 92, 189}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 125}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 110, 160, 108, 207, 75, 133}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 221, 17, 47, 40, 157, 74}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 170, 124, 7, 227, 194}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 211, 57, 233, 179}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 132, 235}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 212, 73, 162}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 31, 246, 171, 234, 96}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 94, 182, 44}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 28, 117, 83, 132, 186}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 103, 140, 6, 235, 250, 165, 57}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 60, 153}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 165, 59, 129, 137}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 215, 102, 92, 137, 57, 124}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 96, 89, 202, 88, 93}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 82}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 72}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 176, 56}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 176}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 136, 17, 221, 21, 179, 107, 161}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 167, 226, 233, 228, 95}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 182, 49, 217, 111}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 181, 154}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 186, 251}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 240, 146, 208, 65}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 51, 4, 212, 203}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 77, 216, 153, 169, 15, 224}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 109, 10, 68, 168, 166, 59, 131}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 217, 220, 70, 158, 19}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 22, 170, 123, 10, 117}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 27, 148, 17, 24, 128}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 93}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 12, 236, 102}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 177, 44, 34, 182, 149, 252}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 157, 218, 81, 81, 142}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 140, 134, 154, 51, 1}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 49, 155, 5}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 199, 147, 251}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 230, 108}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 5, 200, 62, 18, 115}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 181, 20}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 127, 115, 126, 153, 145, 87, 10}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 176, 128, 20, 169, 54, 44, 65}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 117, 57, 156, 135, 3, 75, 91}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 109, 142}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 160, 189, 160, 74}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 112, 56, 231, 109, 167}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 111, 235, 33, 183, 241, 191}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 75, 65, 28, 103, 150, 44}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 54, 94, 100}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 220, 117, 101, 151, 31, 6}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 170}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 11}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 116, 254, 16, 71, 151, 110, 31}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 178, 136, 37, 216, 131, 165}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 152, 226, 29}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 174}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 27, 235, 10, 233}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 161}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 39}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 185, 168}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 115, 167, 121, 223}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 0, 195, 57, 219, 175, 188}, 93},
	{{120, 246, 1, 52, 187, 163, 78, 105, 224, 0, 178, 34, 24, 244, 35, 69}, 93},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 235}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 118}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 232}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 63}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 213}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 17}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 134}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 246}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 166, 113}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 251}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 253}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 29}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 84}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 237}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 187}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 89}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 134}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 203}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 180}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 78}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 7, 178}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 44}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 168}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 152}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 239}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 250}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 197}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 225}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 132}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 53}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 101}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 112}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 120}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 245}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 12, 192}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 142}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 201}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 55}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 180}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 158}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 31}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 116, 56}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 186}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 1}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 91}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 225}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 251}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 166}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 222}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 40, 60}, 242},
	{{137, 242, 136, 71, 98, 10, 53, 97, 160, 85, 132, 127, 185, 222, 0, 0}, 242},
	{{255, 133, 181, 0, 0, 0, 0, 52, 9, 193, 33, 163, 116, 190, 26, 24}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 252, 202, 174, 37, 69, 225, 247, 126}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 175, 98, 13}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 243, 32, 40, 210, 153, 103, 19, 159, 189}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 153, 81, 234, 100, 205, 244}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 10}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 39, 0, 17, 148, 162}, 163},
	{{255, 133, 181, 0, 0, 0, 80, 182, 21, 113, 228, 251, 21, 103, 30, 242}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 155, 88, 136, 246, 5, 175, 202}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 191, 234, 31, 57, 114, 186, 152, 136, 92}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 92, 178, 121}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 39, 37, 124, 149, 14}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 96}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 80, 235, 221}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 223, 237, 56, 21, 71, 25, 108, 100}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 209, 98, 133, 93, 177, 251, 11, 122, 225}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 118, 223, 47, 209, 119}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 21, 205, 46, 3, 75, 250}, 163},
	{{255, 133, 181, 0, 0, 88, 238, 159, 127, 131, 118, 171, 30, 21, 208, 226}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 210, 246, 26, 77, 117, 125, 33, 76}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 183, 88, 104, 126, 54, 228, 242}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 176, 249, 214, 191, 240, 238, 147, 20}, 163},
	{{255, 133, 181, 0, 172, 143, 56, 134, 206, 156, 96, 217, 241, 128, 26, 217}, 163},
	{{255, 133, 181, 0, 0, 121, 179, 190, 197, 149, 238, 135, 93, 141, 29, 195}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 73, 108, 62}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 150, 41, 250, 55, 159, 211}, 163},
	{{255, 133, 181, 0, 0, 0, 156, 189, 219, 107, 216, 90, 209, 131, 86, 109}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 105, 139, 153, 156, 4, 80}, 163},
	{{255, 133, 181, 0, 0, 0, 194, 84, 112, 185, 38, 233, 232, 239, 183, 205}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 235, 27, 208, 46, 31, 174, 156}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 66, 158}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 123, 161, 226, 50, 184, 195, 242, 218, 197}, 163},
	{{255, 133, 181, 0, 12, 167, 253, 239, 107, 5, 3, 166, 85, 7, 62, 36}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 131}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 220, 178, 154, 191, 112}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 111, 111, 58, 252, 38}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 227, 150}, 163},
	{{255, 133, 181, 0, 30, 74, 77, 132, 72, 75, 225, 77, 207, 172, 67, 221}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 10, 118, 144, 236, 41}, 163},
	{{255, 133, 181, 0, 0, 209, 98, 35, 207, 25, 121, 106, 255, 98, 142, 47}, 163},
	{{255, 133, 181, 0, 0, 0, 169, 121, 193, 18, 122, 217, 88, 143, 182, 250}, 163},
	{{255, 133, 181, 0, 231, 10, 9, 121, 219, 117, 139, 172, 104, 196, 125, 136}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 118}, 163},
	{{255, 133, 181, 0, 0, 0, 138, 123, 84, 40, 44, 155, 157, 101, 215, 69}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 110, 188, 58, 89, 94, 181, 96, 189}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 53, 166, 68, 38, 47, 145}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 29, 67, 37}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 10, 169, 71, 214, 44}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 93, 121, 32, 7, 114, 110, 206}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 251, 109, 78, 105, 90, 59, 69, 160}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 32, 72, 131}, 163},
	{{255, 133, 181, 0, 87, 255, 223, 164, 55, 180, 231, 238, 211, 216, 80, 29}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 90, 178, 197}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 95, 56, 181, 235, 123, 252}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 35, 145, 68, 164, 164}, 163},
	{{255, 133, 181, 0, 146, 5, 200, 12, 173, 45, 146, 215, 12, 69, 111, 214}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{255, 133, 181, 0, 184, 110, 33, 67, 58, 11, 249, 238, 22, 60, 214, 183}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 213, 89, 242, 139, 253, 162}, 163},
	{{255, 133, 181, 0, 0, 93, 78, 45, 98, 162, 97, 77, 44, 176, 170, 31}, 163},
	{{255, 133, 181, 0, 0, 0, 169, 225, 217, 82, 80, 83, 233, 181, 206, 70}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 113, 80, 51, 239, 5, 228, 92, 51, 107}, 163},
	{{255, 133, 181, 0, 0, 254, 80, 143, 192, 220, 188, 124, 253, 72, 171, 99}, 163},
	{{255, 133, 181, 0, 0, 0, 132, 87, 181, 250, 110, 244, 191, 95, 204, 141}, 163},
	{{255, 133, 181, 0, 136, 86, 57, 126, 197, 35, 190, 87, 120, 188, 122, 85}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 126, 105, 171, 132, 130, 91, 230}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 34, 23, 156, 69, 38, 125, 181, 180}, 163},
	{{255, 133, 181, 0, 180, 30, 67, 106, 74, 198, 228, 200, 209, 254, 100, 174}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 45, 55, 152, 205, 14, 50}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{255, 133, 181, 0, 255, 86, 163, 76, 135, 230, 179, 100, 162, 72, 41, 239}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 184, 106, 232, 96, 38, 125, 111, 126}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 147, 65, 159, 242, 187, 89, 251, 68}, 163},
	{{255, 133, 181, 0, 0, 107, 26, 49, 48, 237, 197, 49, 143, 135, 170, 138}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 60, 175, 7}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 69, 78, 174, 142, 200, 149, 51, 171}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 197, 172, 44, 178, 207, 123, 10, 117}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 30, 167, 174, 152, 159}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 167, 14, 109, 101, 25, 61, 122, 40, 79}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 91, 255, 89, 123, 221, 110}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 114, 112, 163, 23, 8}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 197, 248, 11, 41, 30}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 56, 225, 164}, 163},
	{{255, 133, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 218, 140}, 163},
	{{255, 133, 181, 0, 0, 0, 62, 60, 139, 251, 123, 86, 152, 155, 83, 61}, 163},
	{{128, 177, 92, 155, 91, 192, 0, 130, 90, 211, 180, 237, 5, 234, 218, 252}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 106, 123, 131, 219, 24, 44}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 119, 142, 206, 134}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 98, 194, 236, 14}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 78, 202, 251, 15, 6, 91, 60}, 184},
	{{128, 177, 92, 155, 91, 192, 221, 217, 94, 83, 231, 235, 248, 228, 78, 105}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 64, 196, 86, 218}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 86, 241}, 184},
	{{128, 177, 92, 155, 91, 192, 100, 36, 192, 106, 162, 48, 48, 169, 23, 147}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 32, 73, 151, 109, 113}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 224, 138, 168, 202, 132, 58, 208, 236}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 211, 65, 32, 146, 22, 65}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 127, 226, 121, 232, 77, 117, 156, 44}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 15, 73, 70, 185, 177, 45}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 188, 198, 58, 220, 205, 20, 118, 255, 219}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 91, 221}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 13, 132, 32, 85, 149, 153, 19, 217}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 210, 88, 223, 23, 207}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 127, 147, 123, 210, 159, 201, 47, 210, 251}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 95, 49, 52, 155, 28, 191, 182, 94, 149}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 184},
	{{128, 177, 92, 155, 91, 192, 227, 67, 60, 213, 241, 54, 161, 104, 70, 126}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 184},
	{{128, 177, 92, 155, 91, 192, 33, 108, 176, 128, 182, 151, 55, 231, 50, 123}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 246, 137, 255, 219, 178, 185, 252}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 16, 205, 45, 255, 69, 163, 226, 130}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 63, 21, 28, 148, 158, 10, 172, 75}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 215, 87, 226, 154, 125}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 214, 148, 118, 62, 156, 124}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 43, 122, 56, 34, 189, 254}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 92, 80, 151, 8, 209, 13}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 137, 104}, 184},
	{{128, 177, 92, 155, 91, 192, 18, 177, 253, 46, 228, 59, 132, 74, 190, 154}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 125, 239, 54, 10, 175, 97, 134, 200}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 70, 123, 189, 153, 99, 132, 39, 30}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 126, 34, 204, 81, 11, 94, 197, 183}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 4, 108, 172, 103, 184, 160, 135, 127, 221}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 101, 43, 223, 250}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 161, 212, 2}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 251, 144, 153, 184, 91, 69}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 66, 143, 217, 201, 3, 6}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 123, 103, 217, 50, 220, 25, 35, 28}, 184},
	{{128, 177, 92, 155, 91, 192, 177, 2, 212, 14, 226, 90, 100, 146, 41, 154}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 251, 219, 18, 16, 103}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 53, 210, 60, 247, 242, 44}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 252, 233}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 163, 29, 90, 31, 150, 249, 115, 90}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 221, 190, 118, 35, 91, 195, 191, 120, 181}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 4, 201, 137, 90}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 108, 7}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 232, 174, 215, 36, 191, 213}, 184},
	{{128, 177, 92, 155, 91, 192, 194, 92, 30, 24, 91, 189, 0, 205, 26, 43}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 125, 231, 242, 127, 237, 58, 9, 144}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 187, 249, 163, 88, 53, 64, 122, 212, 191}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 154, 250, 171, 83, 89, 222, 35, 44, 102}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 57, 104, 15, 42, 121}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 198, 40, 223, 204, 238, 3}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 164, 217, 63, 189, 47, 49, 97, 231, 64}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 18, 50, 29, 145, 138, 144, 229, 74, 27}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 163, 43, 95, 64, 126, 187}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 174, 242, 150, 6, 75, 244}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 242, 205, 229, 148, 157, 169, 237}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 68, 217, 45, 251, 59, 246, 142, 121, 247}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 75, 118, 217, 119}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 181, 110, 15}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 21, 4, 212, 178}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 233, 96, 223, 185, 154}, 184},
	{{128, 177, 92, 155, 91, 192, 190, 64, 13, 106, 28, 153, 110, 75, 151, 27}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 117, 65}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 43, 163, 42, 130, 144}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 100, 58, 159, 153}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 129, 153, 130, 26, 52, 39, 22, 77}, 184},
	{{128, 177, 92, 155, 91, 192, 97, 27, 107, 70, 253, 127, 76, 116, 11, 119}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 1, 250, 103}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 183, 3, 108, 184}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 105, 86, 143, 193, 189}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 94, 86, 143, 19, 1}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 65, 118, 180, 47, 110, 136, 200, 123, 221}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 83, 48, 187, 134, 183, 57, 71, 73, 146}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 128, 35, 101, 100, 60, 54, 118, 228, 224}, 184},
	{{128, 177, 92, 155, 91, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 194, 245}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 219, 130, 130, 104, 226}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 102, 51}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 124, 155, 159, 192}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 47, 65}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 211}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 105, 118}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 47, 182, 199, 52, 162}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 192, 21, 33, 118, 62}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 143, 169, 89}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 139, 25}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 79}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 204, 120, 222, 107, 222, 219}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 30, 29, 253}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 46, 228, 61, 46, 207, 58}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 163, 24, 190}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 0}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 132, 127, 30, 86, 66, 115, 140}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 126, 74, 203, 186}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 56, 58}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 49, 71, 118}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 181, 30, 138, 240, 20, 63}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 107}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 47, 153, 36, 150, 5, 170, 79}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 189, 77, 227, 223, 216}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 195, 139, 29, 70, 38}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 88}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 91}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 0}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 237, 247, 185, 22, 197, 202, 18}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 163, 72, 101, 94, 96, 144}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 9, 140, 112, 74, 96, 11}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 131, 69, 241, 97, 47, 220}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 0}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 155, 43}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 0}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 46, 227, 71, 73, 135}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 179, 52, 237, 128, 101, 4}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 74, 198, 29}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 113, 220, 95, 246, 42}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 244, 167, 159, 11}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 255, 185}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 125, 22, 125, 1}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 26, 58, 2, 114}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 223, 96, 65, 77}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 86, 235, 113, 11, 171}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 20, 9}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 189, 24, 42, 126}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 56}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 0}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 233, 112, 185, 163, 1, 132, 183}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 255, 43}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 65, 81, 129, 132, 195}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 243, 190}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 27, 160, 105, 7, 133, 149}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 231, 104, 247, 155, 249, 142}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 122, 31}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 12, 242}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 202, 71, 48, 79, 70}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 245, 113, 127}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 244, 5, 82, 75, 227, 230, 142}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 75, 154}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 113}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 46}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 255, 220, 239, 212, 1, 146}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 150, 85, 22, 15, 118, 226}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 212, 89, 77, 76, 17, 76}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 22, 234}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 98}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 190}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 58, 36, 217, 225, 143, 201}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 196, 140, 124, 191, 118, 235}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 133, 135, 205}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 11, 164}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 93, 112, 81, 143, 255, 180}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 100, 243, 9}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 0}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 0}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 211, 178, 128, 102, 175, 24, 175}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 0}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 130, 38, 100, 15, 242, 65, 81}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 8, 105}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 0}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 85}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 231, 228, 28, 77, 55, 204}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 184, 119}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 90, 57, 97, 108}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 175, 114, 218, 75, 221}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 115}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 85, 108, 243, 26, 169, 1}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 83, 50}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 83, 45, 163, 118, 143, 241}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 0}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 202, 56, 200, 205, 37}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 0, 0}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 174, 196, 38, 149}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 241, 167, 31, 215}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 0, 0, 0, 158, 6}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 0, 154, 121, 204, 179, 182}, 188},
	{{45, 120, 186, 192, 240, 199, 178, 95, 32, 0, 198, 139, 25, 62, 226, 154}, 188},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{151, 98, 103, 254, 90, 6, 10, 109, 14, 158, 69, 29, 140, 237, 40, 232}, 193},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 35, 50, 81}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 50, 115}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 229, 27, 132, 149}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 107, 8, 107}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 104, 25, 99, 185, 119, 189}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 45, 24, 102}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 114, 160, 229, 63, 226}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 221, 52}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 218, 214, 80, 78, 66, 155}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 121, 4, 71, 210}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 157, 230, 31}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 24, 87, 13, 72, 216}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 140, 37, 35}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 94}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 106, 51}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 138, 87, 58}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 25, 230, 107, 59, 49}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 133, 169, 187, 93}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 84, 218, 188}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 226, 228, 36, 249}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 219}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 55, 154}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 84, 41}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 241}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 214, 32, 48}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 169, 149, 53, 212, 212}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 124, 140, 46, 149}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 185}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 184, 171, 12, 208, 97}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 118, 247, 88, 241, 78}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 62, 84, 11}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 253}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 203, 169, 81, 84, 211, 145}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 253, 4, 94}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 218}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 184, 116, 116}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 86}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 41, 212, 97, 35, 190, 43}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 237, 240, 177, 251, 128}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 57}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 201, 194, 112, 60, 198, 67}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 152, 28, 7, 170}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 27, 209}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 198, 224}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 61, 13}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 14, 33, 31}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 97, 30, 134}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 160, 247, 100, 6}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 30, 21}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 87, 85, 65, 129}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 22, 144}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 240, 61, 139, 204, 30}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 69, 118}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 226, 152, 254}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 96, 247, 93, 10, 76}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 247, 2, 51, 72, 245}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 223}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 28, 161, 9}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 14, 154, 129, 163, 128}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 82, 95, 82, 153}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 151, 127, 214, 81, 47}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 177, 130, 100, 249}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 233, 111}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 0}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 16}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 112, 43, 6, 198}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 75, 246, 126, 147, 74}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 122, 50, 199, 78, 255}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 177}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 254, 220, 140}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 0, 176}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 33, 79}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 45, 66, 239}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 166, 241, 120, 184}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 93, 222, 87}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 244, 0, 96}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 15, 181, 236, 95, 209}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 61, 36, 200}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 251, 171, 191}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 246, 10}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 232, 84}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 102, 94}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 36, 25, 68}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 145, 218, 2, 29}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 0, 0, 12, 217}, 63},
	{{148, 164, 81, 85, 76, 14, 84, 64, 89, 176, 0, 0, 32, 116, 9, 176}, 63},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 200}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 12}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 95}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 48}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 30}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 1}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 17}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 249}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 113}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 201}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 110}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 207}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 138}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 187}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 209}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 60}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 132}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 214}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 32}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 103}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 42}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 252}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 144}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 95}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 116}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 221}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 101}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 49}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 31}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 100}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 84}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 16}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 163}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 77}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 232}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{145, 187, 165, 136, 88, 30, 107, 191, 205, 120, 119, 216, 158, 123, 64, 0}, 160},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 233}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 153}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 26}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 237}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 197}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 92}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 186}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 172}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 248}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 8}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 150}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 80}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 119}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 177}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 60}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 243}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 237}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 92}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 113}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 219}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 202}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 239}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 76}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 70}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 72}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 242}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 69}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 175}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 240}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 57}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 39}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{78, 120, 28, 243, 216, 180, 87, 19, 253, 16, 110, 33, 228, 24, 232, 0}, 251},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 164}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 90, 114, 115, 246}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 225, 177}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 253}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 183, 0}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 153, 37}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 217, 6, 109}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 122, 203, 46, 16, 27, 156}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 173, 143}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 77, 200, 134, 152, 167}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 177, 216, 164}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 118, 127, 91}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 166, 246, 221, 26, 162}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 33, 42, 201, 84, 232}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 75, 209, 157}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 32, 127, 82, 56}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 242, 174, 102}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 64, 200, 44, 242, 143}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 127, 170, 18}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 251, 71, 13, 187}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 183}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 203, 154, 241}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 44, 82, 187, 252, 164}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 148, 83, 53, 139, 105, 155}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 42}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 213, 6, 34, 158, 86}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 54}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 128, 163, 232, 125}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 140, 249, 55, 193}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 74, 72, 30}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 255}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 28, 229}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 161, 35, 21, 122, 128, 4}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 222, 137, 51, 158}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 96, 92}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 229, 102, 220}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 147, 250, 34, 43}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 23, 52}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 38, 8, 143, 187, 115, 168}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 202, 29, 33}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 115}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 179, 174, 20, 103, 210, 53}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 116, 247, 41}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 62, 243, 199, 201}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 51, 89}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 165, 133, 42, 21, 255, 35}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 191}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 131, 177, 205, 105, 223, 125}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 190, 105}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 97, 217, 37}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 230, 81, 166}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 192, 254, 255, 165}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 74, 62, 222}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 2, 164, 28, 64}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 74, 23, 94, 171}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 81, 46, 154, 20}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 123, 15, 47, 242, 44, 77}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 72, 52, 116}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 55, 220, 193, 38, 203, 120}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 248, 177, 91, 164, 104, 251}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 114, 187}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 128, 47, 80, 168, 70, 167}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 175, 65, 113, 48, 122, 19}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 63, 90, 223, 50, 164, 17}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 212, 238, 8, 33, 27, 17}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 167, 19}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 203, 11, 87, 125, 54}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 204, 189, 54, 151, 232, 130}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 44, 72, 158, 236, 22, 18}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 227, 230, 68, 97, 24, 216}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 98}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 47, 146, 109}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 57, 95}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 67, 74, 175, 83}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 141, 189, 103, 126, 157}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 175}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 42}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 2, 113}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 89, 149, 190, 35, 223}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 92, 186, 202, 225}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 244, 57}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 146, 189, 4, 186}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 141, 194, 105, 36, 82}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 136, 127, 241, 253}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 149, 201}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 249, 245, 247, 214, 241, 152}, 228},
	{{74, 6, 166, 166, 183, 157, 96, 84, 151, 0, 0, 0, 0, 0, 157, 196}, 228},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 102, 25, 70, 201, 235, 183}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 228}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 114, 244, 140, 5}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 204, 82}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 133}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 77, 218, 231}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 43, 173, 198, 116, 229, 219}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 150, 170, 77, 46, 147, 165}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 245, 169, 242, 103}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 39, 149, 29}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 1, 137, 172, 250}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 221, 58, 12}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 2}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 128, 233, 206, 137}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 12, 32, 105, 185, 242, 199}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 3, 52, 247, 30, 196, 172}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 55, 91}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 191, 185, 118, 202, 112, 144}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 92, 16, 151}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 110}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 70, 154, 25, 211, 91}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 53, 230, 220, 177, 13}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 166, 77}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 91, 116, 73, 252, 73, 73}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 151, 17, 239}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 193, 146, 61, 192, 10}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 244, 30, 80}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 47, 243}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 11, 30, 214, 160, 189, 134}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 75}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 111, 118}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 136, 203, 57, 46}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 111, 90, 127, 115, 147}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 53}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 176}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 148, 190, 55}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 150, 119, 220, 166, 94, 12}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 41, 31, 69}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 53, 22, 84}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 73, 88, 183, 54, 201, 210}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 4, 138, 148}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 156, 5, 167, 27, 173, 90}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 113, 47, 76}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 5, 151, 244}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 135}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 46, 248}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 114, 107, 81, 26}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 85, 128, 112, 122, 71}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 236, 111, 182, 176, 211, 131}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 23, 132, 246}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 161, 141, 156, 76}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 215, 163, 80, 92, 84}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 222}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 174, 48, 63, 89, 34}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 181, 105, 54, 166, 108, 146}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 197, 15}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 148, 65, 38, 107, 188, 121}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 246, 102, 9, 55}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 190, 73, 247, 163, 148}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 152, 97, 250, 111, 202}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 149, 182, 52, 226}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 56, 54, 237, 226}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 239, 7, 71, 144}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 195, 101, 170, 81}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 125, 112, 130, 186, 56}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 248, 145}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 218, 115, 223, 47}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 141, 7, 47, 224}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 218}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 163}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 245, 34}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 224, 231, 247, 39}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 241, 192, 130}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 54, 107, 203, 103, 126, 102}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 178, 90, 72, 173}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 176, 163, 96, 14, 159}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 137, 118, 83}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 181, 141, 147, 184}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 155, 78, 172}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 180, 71, 125, 193, 28, 199}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 88, 205, 214, 70, 32}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 243, 102, 89, 153, 89, 241}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 78, 88, 163}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 205, 132, 53}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 228, 220, 251, 255}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 203, 7, 150, 19, 23, 244}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 197, 88, 7}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 118, 11, 9, 123, 17, 125}, 168},
	{{89, 96, 4, 221, 214, 253, 58, 49, 9, 0, 0, 0, 0, 0, 0, 0}, 168},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 35}, 194},
	{{97, 9, 64, 0, 0, 0, 192, 135, 50, 212, 49, 59, 146, 72, 224, 139}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 176, 227, 71, 28, 246, 156, 30}, 194},
	{{97, 9, 64, 0, 0, 0, 252, 122, 57, 237, 97, 84, 114, 46, 244, 54}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 83, 213, 172, 36, 184, 192}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 166, 147, 109}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 163, 197, 121, 27, 6, 33, 227, 255}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 255}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 88, 112, 172, 14, 246, 82, 57, 105, 213}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 10, 213, 168, 125, 103, 152, 51, 194}, 194},
	{{97, 9, 64, 187, 118, 236, 174, 172, 229, 23, 7, 20, 64, 115, 233, 255}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{97, 9, 64, 0, 132, 0, 253, 33, 42, 22, 89, 134, 242, 129, 106, 230}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 151, 214, 114, 1, 185, 165, 189, 93, 3}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 211, 2, 40, 105, 32, 99, 218, 220}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 209, 137, 69, 216, 84, 153, 210, 8, 62}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 144, 229, 90}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 101, 66, 17, 189, 94}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 115, 189, 77}, 194},
	{{97, 9, 64, 0, 68, 24, 209, 79, 17, 171, 251, 19, 80, 141, 228, 126}, 194},
	{{97, 9, 64, 0, 17, 120, 172, 226, 37, 60, 233, 193, 188, 230, 210, 112}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 210, 76}, 194},
	{{97, 9, 64, 0, 0, 43, 177, 98, 143, 228, 64, 185, 211, 226, 35, 197}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 94, 189}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 171, 70, 243, 183, 89, 132, 10}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 144, 59, 148, 177, 220, 85, 235, 105, 122}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 13, 173, 226}, 194},
	{{97, 9, 64, 35, 171, 157, 203, 218, 123, 13, 161, 71, 165, 171, 97, 60}, 194},
	{{97, 9, 64, 126, 178, 80, 7, 2, 76, 212, 186, 211, 193, 78, 25, 23}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 44, 105, 136, 194, 99, 170}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 68, 197, 175, 85, 69, 137, 167, 25}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 236, 236, 237, 164, 229}, 194},
	{{97, 9, 64, 82, 70, 83, 149, 51, 222, 33, 77, 50, 6, 51, 2, 54}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 131}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 215, 12, 132, 212, 66, 155, 182, 168}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 250, 197, 119}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 54, 83, 225, 249, 224, 145}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 142, 10, 90, 220, 193, 205, 45}, 194},
	{{97, 9, 64, 0, 0, 0, 78, 74, 203, 0, 127, 215, 234, 77, 105, 149}, 194},
	{{97, 9, 64, 144, 166, 163, 96, 73, 132, 209, 208, 194, 69, 31, 153, 141}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 115, 144, 116}, 194},
	{{97, 9, 64, 0, 0, 0, 152, 55, 85, 252, 99, 187, 145, 48, 151, 204}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 59, 197, 202, 11, 80, 172, 117, 212}, 194},
	{{97, 9, 64, 0, 0, 0, 191, 244, 125, 86, 112, 232, 141, 242, 160, 72}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 240, 117, 109, 44, 131, 254, 58, 139, 22}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 141, 172, 180, 233, 131, 238, 112, 192}, 194},
	{{97, 9, 64, 0, 73, 210, 8, 209, 24, 130, 71, 55, 66, 76, 206, 145}, 194},
	{{97, 9, 64, 0, 197, 62, 111, 189, 255, 142, 78, 181, 94, 182, 186, 73}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 26, 77, 35, 252, 196, 133, 186}, 194},
	{{97, 9, 64, 0, 0, 68, 117, 205, 51, 247, 243, 242, 166, 218, 63, 111}, 194},
	{{97, 9, 64, 0, 0, 0, 89, 237, 9, 186, 181, 126, 143, 33, 201, 255}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 191, 239, 65, 56, 143, 11, 59, 88}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 188, 254}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 114, 161}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 16, 164}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 67, 250, 111, 228, 80}, 194},
	{{97, 9, 64, 0, 3, 6, 252, 174, 40, 168, 11, 192, 67, 29, 181, 94}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 226, 35, 7, 139, 95, 165}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 83, 76, 199, 200, 182, 133, 81, 170, 252}, 194},
	{{97, 9, 64, 0, 0, 4, 217, 8, 100, 133, 249, 134, 247, 200, 209, 148}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 143}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 193, 70, 59}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 176}, 194},
	{{97, 9, 64, 0, 115, 156, 188, 155, 165, 220, 70, 250, 93, 10, 22, 143}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 90}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 190, 153, 19, 159, 180, 213}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 153, 36, 110, 126, 25}, 194},
	{{97, 9, 64, 50, 102, 204, 2, 232, 242, 228, 156, 219, 107, 226, 151, 249}, 194},
	{{97, 9, 64, 0, 71, 166, 242, 140, 162, 14, 198, 198, 108, 83, 155, 240}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 55}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 211, 229, 92, 142, 254, 247, 105}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 200, 122}, 194},
	{{97, 9, 64, 0, 0, 0, 214, 53, 217, 227, 103, 210, 78, 219, 13, 189}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 105, 140, 133, 199, 175, 193}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 24, 198, 17, 189, 115, 191, 84}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 102, 240, 230}, 194},
	{{97, 9, 64, 0, 0, 0, 9, 122, 184, 81, 63, 39, 106, 113, 171, 234}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 223}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 50, 246, 221, 87, 229, 93, 16}, 194},
	{{97, 9, 64, 0, 0, 0, 171, 227, 188, 13, 110, 32, 37, 149, 92, 234}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 81, 160, 156, 55, 44}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{97, 9, 64, 0, 2, 89, 63, 162, 183, 73, 170, 199, 211, 118, 230, 71}, 194},
	{{97, 9, 64, 0, 0, 0, 59, 164, 29, 97, 192, 64, 159, 224, 80, 44}, 194},
	{{97, 9, 64, 0, 92, 40, 216, 12, 85, 69, 127, 115, 72, 147, 181, 129}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 122, 65, 128, 166, 147}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 194},
	{{97, 9, 64, 0, 0, 0, 0, 0, 0, 0, 0, 133, 247, 195, 248, 74}, 194},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 162, 51, 14, 198, 180}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 54, 13}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 236, 155, 227, 66, 79, 247, 123, 21}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 213, 218}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 106, 173, 54, 139, 85, 57}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 183, 127}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 92, 250, 108, 109}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 152, 35, 221}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 6, 102, 3, 176, 201, 39, 139, 85, 199}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 242, 248, 141}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 109, 217, 72, 228, 251, 182, 15, 131, 22}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 167, 195, 224, 181}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 79, 174, 59, 61}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 39, 103}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 162, 4}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 152, 210, 112, 68, 182, 218, 66, 204}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 160, 85, 153, 33, 35, 52, 87}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 20, 21, 123, 147, 61, 62, 17, 230}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 163, 248, 177}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 138, 3, 172, 251, 149}, 166},
	{{213, 215, 45, 200, 170, 120, 37, 45, 190, 122, 134, 245, 96, 100, 53, 108}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 154, 39, 229, 22, 153, 126, 91, 43, 44}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 68, 202, 93, 59, 162, 235, 144, 128}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 31, 254, 99, 166, 77}, 166},
	{{213, 215, 45, 200, 170, 120, 79, 200, 32, 24, 20, 16, 110, 30, 145, 168}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 175, 164, 0}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 63, 5}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 74, 225, 16, 122, 183, 1, 17, 176}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 137, 49, 143, 179, 223}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 175, 231, 177, 161, 83, 131, 142}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 55, 76, 47, 127, 122, 180, 73, 62}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 228, 156, 95, 28, 80, 41, 193}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 107, 202, 27, 154, 163, 76, 6}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 242, 107, 148, 193, 76, 129, 145}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 140, 32, 135, 40, 59, 51, 225, 27}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 242, 206, 127, 222, 57, 123, 132, 192}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 80, 1, 239, 52, 157, 247, 48, 20, 93}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 157, 171, 27, 127, 101}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 151, 8, 98}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 68, 159, 199, 210, 59, 220, 160, 238}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 208, 213, 110, 230, 139}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 120, 223, 36, 216, 50, 166, 64, 137}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 80, 98, 204, 162, 59, 81}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 212, 186, 186, 30, 140, 38, 42, 36, 13}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 243, 211}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 119, 5, 249, 67, 241}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 91, 198, 169, 147, 103, 181, 224, 171, 21}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 87, 133, 117, 250, 136}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 181, 160, 55, 194, 12, 89, 158, 161}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 215, 58, 228}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 94, 136, 236, 107, 152, 19, 103, 35}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 76, 138, 113, 234, 67}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 168, 49, 136, 215, 205, 177, 111, 132, 43}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 153, 14, 86}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 224, 233, 17, 51, 137, 58, 210, 59, 233}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 194, 31, 105, 1, 71, 0, 12, 160}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 213, 141, 209}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 136, 140, 147, 247, 132, 66, 29}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 199, 49, 63, 198, 125}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 199, 211, 40, 11}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 85, 41}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 63, 28, 79}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 190, 27, 198, 233, 51, 134, 94, 90}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 241, 216, 105, 52, 254, 129, 68}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 210, 75, 213, 55}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 1, 236, 59, 7, 50, 105, 184, 138}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 82, 31, 16}, 166},
	{{213, 215, 45, 200, 170, 120, 131, 216, 176, 80, 69, 181, 145, 142, 223, 36}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 254, 43, 241, 207}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 248, 215, 50, 215}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 95, 190, 126}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 246, 145}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 183, 169, 61, 230}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 213, 49, 54, 141, 95}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 34, 225, 207, 191, 18, 120, 78, 243}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 31, 61, 193}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 233, 97, 165, 139, 145}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 166},
	{{213, 215, 45, 200, 170, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{5, 14, 92, 0, 28, 245, 130, 202, 32, 40, 207, 77, 166, 170, 246, 64}, 210},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 13}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 65}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 35, 119, 49}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 245, 213, 65, 141}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 160, 244}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 164, 16, 171, 46}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 191, 77}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 107, 91}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 6, 21, 205}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 25}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 235}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 168, 50, 111, 93}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 92, 243}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 61}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 208, 82, 4, 214}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 205, 119}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 199, 125, 91, 50}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 229, 98, 115, 102}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 63, 9}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 181}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 233, 50, 170}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 235, 16}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 126}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 75, 125, 214}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 185}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 129, 175, 118, 86}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 25}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 210}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 215}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 176, 7, 65}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 249, 168, 113, 133}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 82, 193}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 16, 30, 155}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 19, 43, 176}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 64}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 9, 61}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 235, 3, 238}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 228}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 112, 58}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 145, 252}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 42, 184}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 235, 182, 72}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 215, 4}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 153, 62, 243}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 14}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 77, 3, 7}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 37, 14, 98}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 7, 135, 53}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 149, 16}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 228, 157}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 189, 234, 188, 221}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 3, 204, 202}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 164}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 108, 69, 114}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 162, 47}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 127}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 137}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 238, 21}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 131, 79, 163}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 101, 49, 132}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 10, 26}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 132, 201}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 129}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 181, 94}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 38, 50, 123, 225}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 123, 201}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 33}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 147}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 96, 214, 60, 202}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 123}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 60}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 51, 165}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 141, 56, 31, 45}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 140, 101, 125, 253}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 0, 0, 0, 0}, 254},
	{{77, 45, 43, 71, 202, 0, 157, 146, 59, 91, 225, 0, 159, 164, 134, 15}, 254},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 250, 55, 161, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 47, 63}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 138, 196, 76}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 172, 35, 221, 214, 141}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 36, 152}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 238}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 228, 185}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 150, 132, 42, 96, 191}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 168, 174, 134, 170}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 167, 226}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 229, 111}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 13}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 5}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 164}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 82, 251, 227, 199}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 229, 138}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 254, 195, 236, 188, 242}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 161}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 205, 22}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 167, 55}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 106, 228, 57, 124, 50}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 107, 35, 71, 124, 123}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 172, 189, 184}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 47, 105, 48, 172, 218}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 227, 206, 204, 251, 182, 23}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 201}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 28, 157, 72, 44}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 55, 237, 126, 166}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 74, 18, 144}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 15}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 102}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 27}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 131, 228}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 171}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 134, 110, 15, 94, 53, 107}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 152, 63, 132}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 212, 130, 186, 56}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 139, 249, 189, 226}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 51, 154, 75, 69, 238}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 96, 223, 255, 134, 75}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 76, 192}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 104, 27, 18}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 233, 209, 232, 86}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 181, 203, 11, 122}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 41, 184, 211, 79, 114}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 211, 12, 108}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 242, 65, 132}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 213, 118, 87, 19, 173}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 175, 181}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 244, 143, 174, 225, 238}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 14}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 75, 250, 6, 52, 201}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 175, 123}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 122, 156, 8, 168}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 19, 139, 192, 175}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 126, 59, 226, 14, 202}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 161, 13, 41, 8, 105, 25}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 96, 202, 17, 168, 159}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 192, 68, 180, 150}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 79, 143, 159, 94}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 168, 84, 118, 78}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 194}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 214}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 117, 195, 181, 130}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 27, 135}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 4, 83, 152, 186}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 91}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 212, 1, 106, 18, 135, 245}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 100, 170}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 149, 160}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 233, 227, 219, 25}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 205}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 75, 132, 130, 27}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 243}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 0}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 186}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 33, 96, 220, 180, 243}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 207}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 110}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 104, 251, 30, 245}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 0, 250}, 49},
	{{101, 174, 94, 168, 162, 171, 71, 12, 16, 224, 0, 0, 0, 0, 16, 125}, 49},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 62, 109}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 254, 197, 188}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 15}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 195, 30, 175}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 138}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 186, 22}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 81, 70, 122}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 23, 125, 149}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 186}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 40, 159, 209}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 28, 12, 140}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 1}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 66, 49}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 238, 132}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 252, 202, 74}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 217, 196}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 209, 71}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 144}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 23, 180, 143}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 165, 14}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 225, 85, 141}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 125, 144}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 35, 81}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 26}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 95, 21}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 229, 184, 192}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 182, 98}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 143, 103, 226}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 131, 161, 79}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 52}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 148, 103}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 10}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 111}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 26, 56}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 253, 196}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 245, 117}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 66, 102}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 29, 255}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 215, 229}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 167, 20, 206}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 136, 150, 6}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 245}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 64, 193, 178}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 23}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 87, 20, 128}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 242, 195}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 228, 148}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 166, 112, 115}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 36, 31}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 105}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 142, 171, 81}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 94, 172, 227}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 164}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 78, 131}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 54, 180, 190}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 97}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 158}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 171, 10, 85}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 0}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 0, 178}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 0, 202, 72}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 167, 5, 54}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 54, 7, 61}, 95},
	{{58, 17, 187, 194, 87, 73, 215, 103, 180, 12, 40, 66, 0, 245, 189, 33}, 95},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 106, 117, 64, 94, 230, 153, 109}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 58, 109, 224, 172, 12, 9, 155}, 193},
	{{160, 91, 68, 81, 128, 68, 148, 184, 181, 236, 117, 175, 120, 172, 223, 77}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 83, 247, 75, 5}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 211, 8, 217, 235, 142}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 27, 109, 134, 116}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 180, 100, 226, 205, 75, 177}, 193},
	{{160, 91, 68, 81, 128, 145, 30, 247, 69, 12, 71, 42, 41, 41, 44, 239}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 158, 240, 92, 2, 170, 37}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 154, 26, 47, 105}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 90, 124, 211, 141, 153, 203, 152}, 193},
	{{160, 91, 68, 81, 128, 108, 94, 192, 170, 95, 186, 245, 146, 48, 93, 204}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 247, 179, 144}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 218, 198, 237, 238, 65, 144, 191, 82}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 37, 176, 189, 116}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 116}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 106, 249, 96, 213, 115}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 33, 84, 158, 94, 135}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 66, 202, 145, 193, 215, 215}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 174, 176, 206, 142}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 182, 22, 32, 62, 253, 110, 254, 12}, 193},
	{{160, 91, 68, 81, 128, 0, 131, 111, 215, 91, 148, 174, 113, 149, 39, 56}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 158, 233, 184, 158, 119, 248}, 193},
	{{160, 91, 68, 81, 128, 0, 57, 18, 241, 97, 239, 253, 72, 146, 61, 115}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 42, 226, 238, 38, 213}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 113, 17, 69, 39, 233, 246, 196, 64, 254}, 193},
	{{160, 91, 68, 81, 128, 60, 96, 211, 79, 41, 99, 193, 247, 208, 13, 92}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 191, 156, 157, 182, 130, 8, 32, 147}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 176, 12, 103, 217}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 103, 73, 3, 166}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 207, 212, 108, 223, 126, 88, 105, 109}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 112, 48, 62, 209, 164, 163}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{160, 91, 68, 81, 128, 0, 47, 235, 194, 204, 225, 9, 170, 113, 160, 217}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 193, 50, 168, 88, 40, 93, 83}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 230, 62, 16, 151}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 54, 195, 138}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 129, 167, 99, 31, 94, 190, 206, 204}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 31, 209, 4, 134, 166}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 227, 156, 129}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 98, 56, 131, 202, 36}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 88, 22, 207, 59, 235, 3, 4}, 193},
	{{160, 91, 68, 81, 128, 0, 128, 92, 107, 117, 238, 54, 244, 182, 131, 222}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 67, 191, 243, 58}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 223, 147, 241}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 84, 148, 150, 18, 117, 205}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 169, 15, 214, 202, 100, 14, 103, 182}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 157, 34, 56, 148}, 193},
	{{160, 91, 68, 81, 128, 0, 195, 4, 35, 171, 18, 231, 247, 157, 241, 93}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 191, 40, 221, 227, 106, 7}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 160, 192, 134, 228}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 218, 248, 198, 172, 78, 103, 144, 41, 175}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 104, 165, 195}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 99, 59, 79, 95, 110, 21}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 33, 86, 0}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 116, 83, 132, 210, 80, 3, 255, 161, 199}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 86, 221, 23, 118}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 130, 218, 238}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 243, 130, 92, 253, 142, 9, 211}, 193},
	{{160, 91, 68, 81, 128, 9, 37, 28, 163, 105, 108, 16, 154, 185, 116, 240}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 229, 31, 119, 1, 55, 190, 128, 217}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 225, 244, 154}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 212, 48, 55, 24, 106}, 193},
	{{160, 91, 68, 81, 128, 111, 9, 100, 86, 38, 205, 183, 234, 201, 15, 111}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 242, 80, 158, 53, 215, 238, 165, 11}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 67, 185, 5, 135, 135}, 193},
	{{160, 91, 68, 81, 128, 245, 165, 116, 166, 57, 136, 117, 37, 98, 213, 250}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 41, 89, 152, 15, 66, 6, 205}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 236, 244, 164, 117, 29, 152, 168}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 236, 189, 111, 117}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 245, 232, 196}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 142, 66, 194, 81}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 90, 224, 82, 26, 35, 77, 210, 47, 90}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 202, 68, 80, 177, 94, 31, 46}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 127, 127, 166, 238, 15, 143}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 102, 73, 218, 30, 188, 41, 12, 121}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 73, 138, 142, 25, 111, 240, 49, 238}, 193},
	{{160, 91, 68, 81, 128, 0, 35, 80, 171, 171, 11, 203, 253, 203, 255, 231}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 93}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 234, 80, 224, 226, 11, 77, 241, 144, 53}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 132, 0, 250, 33}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 227, 163, 207, 224, 52, 202, 12}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 142, 109, 58, 57, 82, 174, 117, 185}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 43, 252, 70, 31, 48, 194, 141}, 193},
	{{160, 91, 68, 81, 128, 0, 121, 124, 43, 59, 47, 153, 154, 76, 168, 0}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 112, 51, 217, 85, 150, 12, 159, 36}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 161, 110, 179, 103, 123}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 0, 136, 132, 106, 94, 164}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 0, 0, 0, 214, 137, 244, 167, 12, 11}, 193},
	{{160, 91, 68, 81, 128, 0, 0, 30, 255, 52, 255, 204, 221, 75, 206, 99}, 193},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 193, 123, 253}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 66, 244}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 112, 54}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 77, 225, 151}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 98, 234, 236, 187, 190}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 29, 37, 154, 253, 108}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 218, 167, 166, 113, 184, 127, 120}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 196, 170, 32}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 236}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 85, 36, 49}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 176, 91, 210, 98, 200, 210, 119}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 200, 123, 8, 202, 163, 177}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 72, 110, 220, 175, 115, 194, 177}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 224}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 105}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 149, 3}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 201, 11, 50, 73, 179}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 116, 228, 88}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 45, 108, 11, 61, 17}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 84, 22}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 166, 145, 22, 13, 37, 210}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 189, 96, 220, 193, 225}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 171, 123, 214, 47, 186}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 242, 243, 226, 233, 124}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 31, 204, 33, 36, 121, 27}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 231}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 67}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 101, 11, 38, 74, 141}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 54}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 108, 86, 139, 164, 194, 71, 61}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 222, 96, 31}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 195, 239, 79, 230, 35}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 154, 246, 163, 83, 210}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 123, 45, 219}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 101, 51, 64, 204, 159, 178}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 195, 139, 227, 125}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 134, 60, 103, 208}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 123, 99, 99}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 140, 84, 123, 192, 205}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 25, 7, 246, 196, 214, 129, 170, 1}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 43, 15}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 212, 155, 228, 127, 198, 176}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 159}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 235, 94, 13, 17, 164, 61, 142, 35}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 29}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 232, 171, 43, 114}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 19, 99, 71, 205, 110}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 160, 15, 55, 136, 113, 35, 118}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 38}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 197, 25, 186, 1, 60, 249, 90}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 186, 206, 180}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 107, 56, 29, 236}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 83, 151, 51}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 244, 8, 100, 251}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 81, 213, 99, 122, 98}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 240, 32, 121}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 132, 116, 147, 53, 51}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 132, 69, 50, 219}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 206, 148, 17, 114, 45, 241, 104, 187}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 16, 16, 229, 241, 188, 129, 90}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 167, 37, 243, 46, 25}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 77, 133, 149, 199, 241, 59, 129, 246}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 44, 76, 119, 237, 197, 171, 149}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 201, 229, 132, 63}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 185, 178, 95, 38, 239}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 226, 58, 237}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 225, 113, 8, 133, 125}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 114, 146, 234, 222, 242, 153, 179, 24}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 157, 183, 125, 215}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 71, 81, 223, 50, 72, 223, 65, 46}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 171, 181, 60, 33, 41, 35}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 17, 28}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 85, 148, 158, 180}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 130}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 97, 36, 35, 93, 69, 146}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 241}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 136, 110, 5}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 158}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 190, 91, 147, 92, 79, 187}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 102, 106, 151, 255, 49, 177, 198, 48}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 23, 19, 91, 199}, 155},
	{{94, 112, 249, 13, 167, 245, 101, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 155},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 206, 141, 10, 203, 217, 92, 254}, 133},
	{{236, 194, 0, 0, 195, 151, 89, 221, 1, 236, 138, 215, 88, 5, 97, 193}, 133},
	{{236, 194, 0, 0, 0, 101, 184, 161, 208, 199, 35, 33, 185, 75, 189, 190}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 194, 43}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 160, 53, 105, 195, 229, 236}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 123, 182, 99, 224, 137, 147}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 178}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 124}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 133},
	{{236, 194, 0, 0, 19, 203, 207, 160, 70, 157, 169, 2, 83, 210, 76, 58}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 144, 228, 159, 140, 98, 255, 49}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 188, 12}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 224, 61, 204, 119, 253, 23, 212, 37}, 133},
	{{236, 194, 0, 144, 130, 16, 27, 90, 118, 77, 128, 89, 67, 26, 4, 122}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 51, 251}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 147, 181, 79}, 133},
	{{236, 194, 0, 0, 79, 57, 175, 126, 203, 215, 124, 188, 246, 55, 106, 191}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 78, 129, 137, 187}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 33, 201, 87, 140, 87, 61, 140, 188, 58}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 134}, 133},
	{{236, 194, 0, 0, 28, 155, 60, 36, 55, 106, 21, 237, 18, 187, 238, 32}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 31, 134, 66, 130, 208, 117}, 133},
	{{236, 194, 0, 0, 97, 33, 71, 189, 253, 128, 191, 126, 62, 63, 181, 50}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 73, 245, 145, 14}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 72, 154, 128, 196}, 133},
	{{236, 194, 0, 0, 0, 112, 93, 36, 90, 213, 255, 166, 197, 62, 195, 80}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 162, 158, 12, 148, 251, 122, 101, 57, 245}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 30, 40, 213, 2, 50, 86}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 64, 72, 16, 76, 208, 83, 153}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 252, 78, 252}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 4, 167, 86, 148, 12, 128}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 117, 39, 178}, 133},
	{{236, 194, 0, 0, 0, 137, 92, 193, 25, 23, 165, 195, 47, 45, 6, 238}, 133},
	{{236, 194, 0, 0, 0, 32, 157, 52, 65, 159, 226, 111, 61, 11, 149, 242}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 142, 52, 17, 199, 143, 45, 151}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 159, 22, 16, 116}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 120, 68, 80, 108, 97, 58, 35, 65, 220}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 44, 6, 206, 131, 167, 154, 224}, 133},
	{{236, 194, 0, 0, 0, 0, 38, 251, 222, 252, 25, 252, 107, 187, 94, 104}, 133},
	{{236, 194, 0, 0, 145, 195, 112, 234, 105, 231, 123, 121, 125, 193, 10, 155}, 133},
	{{236, 194, 0, 0, 0, 0, 101, 172, 244, 109, 147, 195, 110, 254, 75, 120}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 136, 102, 184, 54}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 194, 231, 163, 76, 239, 86, 126, 94, 119}, 133},
	{{236, 194, 0, 0, 0, 0, 143, 131, 132, 188, 38, 141, 105, 138, 172, 47}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 2, 229, 74, 75, 62, 72, 145, 57}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 202, 160, 25}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 59, 222, 31, 20, 217, 167, 180, 227}, 133},
	{{236, 194, 0, 0, 0, 23, 113, 27, 183, 25, 244, 101, 162, 92, 15, 154}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 254, 100, 11}, 133},
	{{236, 194, 0, 228, 249, 224, 114, 4, 205, 139, 98, 218, 245, 160, 26, 70}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 180, 229, 232, 27, 60, 74, 209, 200}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 141, 200, 134, 52, 75, 37}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 185}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 89, 118, 42, 41, 250, 80, 4, 10, 126}, 133},
	{{236, 194, 0, 149, 240, 122, 39, 86, 203, 200, 178, 223, 56, 19, 64, 230}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 149, 29, 58, 198, 24, 137}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 178, 202, 144}, 133},
	{{236, 194, 0, 0, 0, 25, 249, 9, 153, 77, 159, 208, 193, 125, 23, 143}, 133},
	{{236, 194, 0, 0, 0, 167, 83, 194, 118, 204, 252, 0, 97, 106, 143, 201}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 189, 108, 15, 155, 103, 131, 237}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 250, 119, 238, 107, 90, 255, 59, 116, 200}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 130, 10, 234, 112, 37, 246, 138, 226, 167}, 133},
	{{236, 194, 0, 0, 0, 50, 96, 254, 163, 31, 68, 161, 169, 127, 84, 94}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 38, 204, 147, 174}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 210, 98, 116, 91, 137, 212, 115}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 118, 4, 157, 222, 19, 138, 110}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 56, 122}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 208, 90, 80, 244, 241, 139}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 196, 163, 211, 60, 153, 163}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 253, 175, 132, 103}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 237, 44, 7, 177, 30, 114, 76}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 148, 138, 151}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 16, 153}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 27, 137, 108, 168}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 160, 177, 214, 75, 127, 38, 25, 137}, 133},
	{{236, 194, 0, 48, 149, 175, 225, 171, 252, 100, 27, 191, 42, 177, 74, 77}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 164, 110, 25, 34, 212, 90, 20}, 133},
	{{236, 194, 0, 184, 34, 251, 182, 48, 62, 181, 218, 197, 48, 252, 179, 151}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 183, 50, 132, 128}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 255, 103, 40}, 133},
	{{236, 194, 0, 0, 0, 0, 106, 228, 10, 13, 207, 36, 125, 172, 234, 218}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 15}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 125, 221, 61, 232, 154, 134, 211}, 133},
	{{236, 194, 0, 0, 0, 0, 22, 77, 214, 50, 113, 25, 84, 127, 5, 113}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 254, 167, 1, 238, 111, 154, 47, 183, 138}, 133},
	{{236, 194, 0, 0, 0, 123, 231, 207, 11, 49, 215, 64, 193, 199, 28, 226}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 199, 3, 220, 219}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 0, 0, 209, 45, 196, 37, 38, 31}, 133},
	{{236, 194, 0, 0, 0, 0, 0, 0, 91, 99, 26, 74, 90, 238, 144, 115}, 133},
	{{236, 194, 0, 237, 127, 86, 114, 135, 39, 175, 227, 178, 150, 3, 58, 174}, 133},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 125, 194, 232}, 10},
	{{168, 243, 103, 221, 120, 106, 168, 35, 250, 13, 152, 109, 179, 164, 96, 248}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 5, 34, 227, 146, 113, 219, 171, 7, 252}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 251, 150, 218, 107}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 135, 83, 63, 251, 177}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 155, 93, 246, 221, 196, 168, 71}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 134, 6, 183, 17, 7, 73, 188, 61, 168}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 235, 201, 43, 157, 88}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 165, 95, 222, 159, 155, 88, 9, 94}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 216, 86, 68, 4}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 255, 241, 145, 240}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 143, 195, 217, 212}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 97, 217, 147, 101, 10, 253, 103, 148}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 149, 102, 79, 197, 74, 128, 215, 196}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 155, 203, 7, 4}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 45, 154, 208}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 255, 102, 77, 211, 30, 9, 217, 39}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 200, 20, 238, 143, 239, 123, 208, 161}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 79, 126, 148, 199, 34}, 10},
	{{168, 243, 103, 221, 120, 0, 223, 8, 213, 214, 245, 103, 78, 15, 56, 244}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 99, 6, 181, 24, 190, 121, 47, 160}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 197, 114, 118, 253, 180}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 150, 103, 8, 130, 39, 116, 250}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 202, 19, 235, 202, 228, 31, 53, 131}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 78, 93, 18, 35, 177, 248, 218, 97, 238}, 10},
	{{168, 243, 103, 221, 120, 223, 142, 172, 141, 213, 48, 112, 166, 228, 4, 26}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 213, 45, 140, 114, 229, 11, 42, 44, 106}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 1, 216, 108, 150, 178, 5, 208, 187, 112}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{168, 243, 103, 221, 120, 0, 121, 150, 18, 6, 31, 108, 51, 138, 47, 14}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 7, 116, 239, 124, 147, 180, 157, 157, 153}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 213}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 217, 184, 243}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 108, 72, 64, 235, 180, 219, 200}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 170, 10, 58, 197}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 10},
	{{168, 243, 103, 221, 120, 225, 130, 32, 234, 213, 209, 39, 250, 82, 178, 165}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 145, 44, 234, 232}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 110, 174, 145, 112, 195, 81}, 10},
	{{168, 243, 103, 221, 120, 0, 131, 53, 213, 249, 152, 229, 212, 8, 37, 22}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 106, 206, 195, 185, 197, 1}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 252, 59, 130, 7, 97, 152, 97, 4}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 10, 73, 93, 170, 252, 220}, 10},
	{{168, 243, 103, 221, 120, 0, 236, 133, 106, 230, 3, 12, 219, 129, 174, 143}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 197}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 95, 136, 104, 79, 134, 243, 99, 195, 250}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 202, 203, 1, 84}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 197, 242, 184, 97, 231, 233}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 97, 60, 149, 217, 89, 225, 140, 170, 69}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 170, 250, 57, 147, 207, 154, 160, 233}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 241}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 200, 24, 106}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 235, 127, 24, 81, 45, 177, 67}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 123}, 10},
	{{168, 243, 103, 221, 120, 0, 229, 197, 128, 86, 55, 158, 238, 207, 115, 48}, 10},
	{{168, 243, 103, 221, 120, 0, 174, 49, 210, 206, 103, 54, 253, 173, 191, 149}, 10},
	{{168, 243, 103, 221, 120, 0, 65, 208, 137, 193, 78, 218, 4, 162, 1, 36}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 46, 17, 138}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 216, 226, 55, 152, 113, 190, 39, 14}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 54, 43, 70, 74, 35, 127}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 50, 8, 126, 246}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 39, 215, 137, 158, 95}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 137, 189, 16, 154, 193, 69, 251}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 133, 122, 169, 159, 135, 234}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 198, 245, 95, 198, 175, 122, 167, 43}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 123, 198, 147, 142, 212, 176, 113, 224, 242}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 164, 48, 163}, 10},
	{{168, 243, 103, 221, 120, 0, 78, 231, 61, 65, 129, 126, 3, 30, 49, 64}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 23}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 146, 186, 76, 64, 114, 3, 42, 112, 41}, 10},
	{{168, 243, 103, 221, 120, 0, 82, 163, 96, 200, 166, 164, 255, 16, 88, 107}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 178}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 77, 110, 161, 140, 150}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 240, 168, 110, 219, 119, 228, 190, 50}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 102, 222, 65, 250, 108, 28, 63, 25}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 191, 84, 155, 176, 110, 85}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 186, 164, 107, 250}, 10},
	{{168, 243, 103, 221, 120, 125, 194, 131, 18, 32, 199, 232, 169, 139, 52, 238}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 26, 15, 144}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 111, 236, 118, 80, 238, 76}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 141, 163, 197, 17, 22, 106, 48, 236}, 10},
	{{168, 243, 103, 221, 120, 0, 0, 0, 0, 0, 0, 0, 0, 71, 77, 8}, 10},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 98, 182, 12}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 82}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 62, 178, 242, 138, 38, 119, 222}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 7, 242, 33, 42, 242, 181, 41}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 209, 100, 247, 102, 44, 187}, 31},
	{{86, 194, 218, 188, 128, 0, 215, 77, 134, 68, 198, 68, 152, 15, 100, 113}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 61, 146, 156, 154, 8, 95, 242, 74}, 31},
	{{86, 194, 218, 188, 128, 0, 138, 14, 157, 213, 64, 129, 192, 23, 64, 232}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 34, 188, 89}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 106, 215, 54, 186, 209, 220, 92}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 104, 18, 154}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 175, 64, 130, 52, 129, 173}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 254, 190, 48, 14, 125, 99, 25, 187, 236}, 31},
	{{86, 194, 218, 188, 128, 0, 217, 142, 231, 129, 56, 232, 170, 103, 168, 227}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 75, 131, 25, 90, 211, 89, 75, 182}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 1, 207, 9}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 91, 99, 88, 242, 165, 8, 148}, 31},
	{{86, 194, 218, 188, 128, 0, 35, 71, 117, 223, 212, 37, 128, 14, 161, 102}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 207, 74, 235, 0}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 176, 241, 214, 67, 73, 251}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 249, 219, 84, 195, 213}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 35, 179, 107, 102}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 251, 173, 95, 54, 18, 76, 222}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 155}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 225, 130, 131, 136, 131, 89, 139, 73}, 31},
	{{86, 194, 218, 188, 128, 0, 69, 199, 226, 138, 76, 81, 227, 126, 6, 179}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 32, 210, 106, 165}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 80, 175, 214, 144, 59}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 196, 158, 117}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 89, 112, 139}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 239}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 74, 252, 108, 223}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 115, 76, 115, 37, 49, 12, 207, 234, 226}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 198, 46, 58, 117, 37, 163, 119, 90}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 232}, 31},
	{{86, 194, 218, 188, 128, 0, 236, 154, 179, 10, 171, 140, 13, 79, 166, 140}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 55, 145, 111, 125, 138, 71, 124, 33, 105}, 31},
	{{86, 194, 218, 188, 128, 192, 122, 242, 163, 203, 54, 136, 36, 3, 249, 217}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 177}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 154, 30, 128}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 116, 20, 91, 189, 216}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 179, 96, 33, 36, 149, 14, 59, 86, 49}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 234, 159, 98, 112, 110, 166, 159}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 185, 113, 206, 135, 62, 63}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 243, 106, 6, 115, 21, 119, 1, 11, 88}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 90, 219, 42, 86}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 155, 159, 122, 5, 110, 30, 120, 109}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 8}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 69, 109, 140, 66, 49}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 113, 54, 250, 59, 11, 225, 26, 24}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 203, 71, 251, 52, 153}, 31},
	{{86, 194, 218, 188, 128, 128, 43, 69, 68, 159, 185, 106, 140, 218, 24, 64}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 197}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 173, 17, 115, 76, 223, 236, 233}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 24, 93, 130, 143, 118, 92, 108, 15, 230}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 221, 199, 187, 114, 9, 40, 80}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 244, 83, 211, 203, 34, 108, 26, 14}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 164, 119, 101, 246, 215}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 16, 149, 149}, 31},
	{{86, 194, 218, 188, 128, 171, 212, 79, 185, 117, 243, 107, 137, 237, 151, 7}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 210, 208, 139, 26, 3, 73}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 82, 148, 253, 26, 20, 205}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 100, 40, 243, 110, 24, 242, 177, 119}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 98, 142, 144, 185, 122, 181, 226, 188, 85}, 31},
	{{86, 194, 218, 188, 128, 0, 184, 234, 44, 105, 124, 187, 98, 91, 80, 201}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 184, 34, 66, 63}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 202, 32, 240, 37}, 31},
	{{86, 194, 218, 188, 128, 0, 193, 213, 117, 103, 63, 251, 116, 132, 73, 82}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 235, 203, 179, 156}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 195, 155, 228, 206, 44, 182}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 1, 205, 155, 213, 67, 136}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 51, 82, 133, 222}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 47, 168, 105, 24, 117, 247}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 160, 68, 56, 81, 168}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 62, 27, 124}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 206, 219, 171, 183, 232, 129, 87, 48}, 31},
	{{86, 194, 218, 188, 128, 0, 133, 112, 205, 106, 6, 28, 93, 222, 22, 183}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 16}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 224, 199, 211}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 225, 82, 254, 67}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{86, 194, 218, 188, 128, 0, 135, 43, 202, 78, 248, 182, 151, 99, 221, 68}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 195, 121, 180, 136, 7, 27}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 38, 107, 10, 45, 190}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 136, 86, 135, 76, 11, 1, 131, 19, 6}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 237, 135, 248, 152, 141, 106, 164, 78, 239}, 31},
	{{86, 194, 218, 188, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{232, 3, 134, 67, 63, 196, 86, 14, 170, 243, 77, 134, 187, 140, 72, 18}, 98},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 138, 192}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 171, 129}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 113, 161}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 184, 36}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 154, 78}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 109}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 18, 11}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 61, 129}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 180, 209, 214}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 90}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 59}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 26, 96}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 83, 119}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 196, 213, 186}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 87}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 170}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 68, 54, 242}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 159, 107, 97}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 132}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 7, 161, 11}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 146, 65}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 208, 90}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 67, 63}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 16}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 23, 224}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 58, 197}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 154}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 200, 10, 90}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 88, 85}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 225, 176, 85}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 17}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 218}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 197, 85, 68}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 61}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 223, 207}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 246, 13}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 222, 185, 11}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 38, 202}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 170, 207, 165}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 250, 216, 65}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 172, 41}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 156, 12}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 148}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 70}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 118}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 42}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 115, 84, 138}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 55}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 231}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 10, 195, 12}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 113, 130}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 66, 96}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 71, 229, 220}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 60}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 177}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 157, 3, 142}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 52}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 143, 204, 15}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 152, 176}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 1}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 11}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 137, 40, 202}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 244, 154, 25}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 160}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 115, 189}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 233}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 107}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 130, 112, 87}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 63}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 22, 172, 206}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 53, 74, 75}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 90, 184, 123}, 22},
	{{55, 253, 19, 201, 199, 71, 229, 218, 54, 64, 12, 162, 0, 0, 0, 0}, 22},
	{{142, 34, 32, 0, 0, 0, 0, 0, 207, 168, 73, 46, 28, 38, 41, 207}, 214},
	{{142, 34, 32, 73, 96, 60, 228, 215, 146, 243, 145, 173, 69, 70, 142, 96}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 103, 5, 147, 219, 215, 13, 254, 78, 79}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 200, 24, 117, 215, 203, 118, 203, 235}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 121, 110, 62, 68, 241, 60, 254, 99, 119}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 110, 26, 175, 121, 50, 123, 83}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 251, 241}, 214},
	{{142, 34, 32, 0, 0, 0, 205, 46, 34, 184, 52, 12, 46, 246, 230, 238}, 214},
	{{142, 34, 32, 249, 214, 73, 128, 236, 177, 79, 229, 224, 15, 124, 127, 6}, 214},
	{{142, 34, 32, 0, 0, 0, 136, 244, 13, 162, 81, 38, 60, 152, 87, 170}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 8, 85, 108, 21, 16, 55}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 76}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 95, 173, 208, 47, 45}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 178, 53}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 0, 127}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 214},
	{{142, 34, 32, 0, 0, 0, 134, 36, 56, 200, 137, 177, 14, 107, 112, 179}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 76}, 214},
	{{142, 34, 32, 0, 0, 0, 11, 111, 119, 181, 211, 18, 51, 140, 202, 101}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 175, 247, 50, 77, 188, 227, 22, 95}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 117, 64, 201, 155, 217, 111, 244, 250}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 110}, 214},
	{{142, 34, 32, 0, 0, 233, 251, 156, 246, 145, 86, 205, 142, 2, 4, 37}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 8, 22, 67, 14, 18, 9}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 135, 222, 60, 150, 150, 183, 226, 142}, 214},
	{{142, 34, 32, 124, 219, 241, 240, 201, 75, 8, 177, 65, 77, 124, 242, 157}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 212, 150, 66, 92, 57, 174}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 60, 248, 98, 177, 209, 207, 107, 138}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 214},
	{{142, 34, 32, 0, 0, 204, 61, 194, 209, 34, 15, 197, 85, 236, 1, 169}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 183, 52, 214}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 77, 238, 188, 133, 254, 84, 150, 165}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 126, 15, 205}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 205, 54, 212, 4, 223, 167}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 65}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 182, 119, 155, 33, 117, 130, 196}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{142, 34, 32, 0, 0, 0, 57, 36, 252, 23, 144, 211, 153, 44, 43, 180}, 214},
	{{142, 34, 32, 0, 30, 204, 162, 168, 136, 122, 219, 56, 10, 46, 240, 43}, 214},
	{{142, 34, 32, 0, 0, 19, 246, 203, 12, 14, 141, 210, 237, 183, 183, 178}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 177, 95, 192, 20, 107, 200}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 127, 156, 129, 56, 124, 145}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 52, 150}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 129, 44, 188, 251, 129}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 27, 6, 254}, 214},
	{{142, 34, 32, 175, 118, 239, 180, 175, 149, 222, 167, 213, 211, 205, 114, 225}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 62, 13, 9, 164, 200, 144}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 9, 64, 73, 43, 182, 148}, 214},
	{{142, 34, 32, 0, 0, 0, 17, 203, 51, 126, 174, 241, 97, 146, 167, 42}, 214},
	{{142, 34, 32, 213, 213, 235, 92, 102, 212, 132, 181, 200, 34, 96, 253, 76}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{142, 34, 32, 0, 152, 140, 138, 213, 171, 79, 17, 123, 80, 239, 245, 86}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 93, 254, 81, 194, 194, 239, 195}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 137, 175, 231, 51, 129, 200}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 63, 209, 192, 227, 149, 239}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 84}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 26, 222, 19, 132, 153, 23, 163, 139}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 200, 225, 103, 51, 116, 32, 100}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 84, 151, 80}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 84, 198, 195, 63, 109, 254, 34, 197, 251}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 114, 29, 59, 93, 140}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 184, 39, 12, 71, 138, 53, 104, 13, 189}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 253, 214, 194, 178, 115, 118, 230}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 24, 133, 92, 93, 150, 39, 79}, 214},
	{{142, 34, 32, 0, 238, 104, 82, 191, 57, 231, 129, 191, 219, 75, 96, 117}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 217, 154, 27, 223, 156}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 223}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{142, 34, 32, 0, 127, 152, 63, 168, 174, 7, 123, 233, 149, 238, 137, 231}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 63}, 214},
	{{142, 34, 32, 0, 0, 126, 84, 149, 114, 229, 173, 169, 110, 169, 51, 148}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 164, 99, 73, 180, 248, 105, 151, 175}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 67, 171, 104, 144, 174, 99, 2}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 153, 51, 115, 44, 117}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 41, 107, 111}, 214},
	{{142, 34, 32, 0, 0, 63, 97, 64, 126, 142, 42, 79, 212, 224, 233, 156}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 254, 50, 79, 88, 84}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 188, 218}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 5, 168}, 214},
	{{142, 34, 32, 0, 0, 0, 150, 105, 231, 130, 209, 213, 135, 169, 14, 188}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 13, 130, 193, 70, 175, 55, 140, 98}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 130, 65}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 70, 106, 198, 238, 177, 136}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 160}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 86, 225, 198, 81, 114, 28}, 214},
	{{142, 34, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{142, 34, 32, 0, 0, 140, 12, 238, 153, 128, 111, 168, 161, 163, 62, 25}, 214},
	{{142, 34, 32, 0, 11, 220, 213, 107, 215, 159, 250, 11, 138, 113, 189, 133}, 214},
	{{142, 34, 32, 0, 241, 45, 14, 244, 57, 193, 228, 69, 26, 181, 220, 11}, 214},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 184, 35, 207}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 114, 218, 197, 22, 233, 50, 167}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 126, 90, 174, 27, 10, 145, 114}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 188, 126, 85, 86, 210, 68, 12}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 70, 23, 102, 174, 220, 155, 238, 131, 212}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 105, 83, 193, 226, 111, 168, 23}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 98, 243, 216, 201, 127}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 53}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 111, 228, 134, 90, 22, 158, 86, 183, 225}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 220, 190, 158, 162, 244, 121, 189, 140, 57}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 16, 26, 195, 237, 220, 191, 97}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 94, 43, 216, 201, 9, 241, 233}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 86, 38, 183, 19, 145}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 149, 85, 249, 122, 225}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 51, 99, 121}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 169, 68, 40, 54, 31, 132, 109, 25}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 104, 3, 22, 74, 228}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 166, 75, 108, 116, 39, 112, 44, 197}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 104, 103, 229, 135, 140, 44, 102, 118}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 103, 226, 74, 172, 180, 113, 95}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 15}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 53, 226, 250, 81, 30}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 111}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 54, 225, 148, 146}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 255, 80, 133, 134}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 91, 194, 175, 83, 19, 179, 15, 239, 124}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 45, 125, 144, 85, 212}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 235, 205}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 3, 119, 91, 39, 220, 205, 117, 165, 47}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 170, 47, 232, 11, 169, 106, 119}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 223, 197, 92, 20}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 29, 232, 77, 43, 137, 121, 44, 72, 132}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 145, 37}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 252, 18, 229, 130, 162, 218, 200, 145}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 194, 145, 106, 173, 79, 165, 150}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 100, 204}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 60, 62, 179}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 181}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 63, 175, 15, 142, 2, 238, 130}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 38, 146, 134}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 89, 130, 219, 110, 226}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 30}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 250, 156, 255, 29, 124, 100}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 56, 92}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 114, 8}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 13, 182, 218, 226}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 219, 240, 202, 35, 95}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 216, 49, 179, 63, 104, 201, 179, 98, 45}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 250, 231}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 7, 234, 223, 150, 171, 166, 57, 191}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 107, 151, 122, 189, 115}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 51, 222, 83, 246, 26}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 135, 55, 11}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 108, 104, 195, 6, 57}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 114, 27, 3}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 117, 234, 83}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 245, 32, 197, 184, 180, 189, 52}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 198, 231, 147}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 76, 62}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 205, 84, 160, 134}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 148, 61}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 196, 49, 13, 12, 107}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 204, 76, 194, 12}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 138, 193, 134}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 28, 185}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 212, 136, 67, 154, 162, 159}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 198, 195, 138}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 155, 221, 88, 234, 184, 216}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 106, 85, 139, 72, 16, 246, 138, 73}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 187, 184, 157, 153}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 35, 239, 185, 205}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 71, 144, 138, 251}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 201}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 187, 46}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 30}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 171, 155}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 128, 245, 46, 148, 209, 28, 244, 109}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 138, 254, 55, 188, 227, 39, 9}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 71, 93, 218, 74}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 131, 23, 92, 39}, 217},
	{{213, 16, 208, 50, 100, 33, 192, 0, 0, 0, 0, 0, 0, 0, 72, 75}, 217},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 244, 46}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 219, 113, 68}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 97, 164}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 202}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 136, 61}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 250, 99}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 202, 15}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 206}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 74, 203, 198}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 166}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 46, 30}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 2}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 164}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 106, 164}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 243}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 52}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 16}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 141, 137, 234}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 82, 32, 81}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 97}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 118, 16}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 198, 149, 163}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 36, 167, 103}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 253}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 164}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 140}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 103, 137}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 53}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 206, 242}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 190}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 190}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 149, 2}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 149}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 149, 56}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 141, 4}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 163, 37}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 146, 62, 54}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 73, 239, 88}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 45}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 100, 54}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 32}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 30, 165, 205}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 249, 156, 34}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 29, 180, 58}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 140, 72}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 12, 194}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 74, 62, 50}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 46}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 9, 42, 144}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 51}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 75, 101, 231}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 125, 13}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 159, 238}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 18, 114, 97}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 90, 62}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 77}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 34, 17}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 161}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 171, 212, 197}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 198, 255, 187}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 45}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 67, 59}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 93, 89, 242}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 58}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 201}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 66, 143}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 72, 164, 26}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 144, 11}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 211, 32, 199}, 102},
	{{117, 237, 132, 185, 184, 246, 79, 42, 103, 98, 162, 243, 128, 0, 0, 0}, 102},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 79, 136}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 169, 106, 196}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 15, 235, 188}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 254, 172}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 120, 131, 157, 85}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 212, 110, 7}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 212, 118, 78, 134, 16}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 46, 184}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 180, 52, 98}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 220}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 143, 246, 58, 12, 145}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 135, 17, 39}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 109, 34, 99}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 9, 23, 99, 162, 29}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 78, 213, 213, 112}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 157, 128, 70}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 175}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 53, 144}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 154, 94, 114, 69}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 205, 115, 216, 81, 213}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 116, 213, 116, 14}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 249}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 230, 7, 242, 79}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 116, 60, 206, 169}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 82, 111, 42}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 45, 106, 100, 97}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 98, 75}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 192}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 197, 103}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 164, 155, 217, 213}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 87, 88, 69, 1, 75}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 80, 253}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 68, 208, 116, 176}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 225, 250, 111, 50, 193}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 34}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 16, 165, 155, 153}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 112, 7, 254, 1}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 17, 145, 192, 172, 126}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 36, 60}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 67, 238, 187, 133, 215}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 20}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 6, 185, 187, 176, 34}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 45, 250}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 148, 139}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 31, 250, 69, 235, 232}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 130}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 120, 225, 52, 76}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 42, 203}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 78, 12, 21, 90, 175}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 49, 11}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 92}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 119, 128}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 162}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 93, 30}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 153, 53, 89, 165}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 134, 95, 211, 111, 119}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 163, 1}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 69, 172}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 79, 204, 18, 160, 252}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 255, 118, 180}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 99, 163, 229, 233, 49}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 23, 128, 104, 160}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 134, 250, 16}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 99, 76, 101, 129, 142}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 1, 210}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 166}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 200, 12, 117}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 208, 107, 127, 30}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 152, 19}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 235, 127, 28, 165}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 182, 124, 51, 9, 229}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 166, 233}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 84, 247, 61, 212, 2}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 250, 29, 123}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 139}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 185, 22, 229, 177}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 160, 176, 31, 201}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 252, 95, 43, 89}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 111}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 134, 181}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 53}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 141}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 0}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 126, 194}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 52, 18, 16}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 0, 0, 0, 0, 152}, 169},
	{{120, 25, 214, 222, 61, 157, 203, 102, 3, 146, 192, 243, 144, 145, 190, 217}, 169},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 209, 212, 240, 124, 177, 78, 209}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 139, 66, 11, 66}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 63, 52, 119, 255, 61, 124, 95, 122}, 152},
	{{222, 46, 254, 64, 200, 97, 164, 132, 37, 97, 30, 215, 223, 21, 143, 3}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 37, 86, 251, 37, 128}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{222, 46, 254, 64, 114, 23, 242, 54, 135, 55, 182, 143, 177, 185, 96, 150}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 22, 205, 208, 76, 12, 210}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 216, 194, 107, 6, 184, 5, 249, 183, 54}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 240, 46, 194, 248}, 152},
	{{222, 46, 254, 64, 210, 7, 71, 46, 39, 15, 249, 50, 4, 148, 70, 58}, 152},
	{{222, 46, 254, 64, 0, 0, 139, 178, 206, 50, 124, 226, 189, 139, 71, 35}, 152},
	{{222, 46, 254, 64, 0, 61, 131, 13, 121, 189, 1, 69, 48, 137, 24, 78}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 19}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 64, 47, 123, 216, 194, 14}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 139, 49, 130, 247, 137}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 28, 208, 197, 179, 58, 130}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 181, 179}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 135, 132, 254, 143}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 140, 217, 171, 14, 233, 149, 166}, 152},
	{{222, 46, 254, 64, 0, 0, 207, 226, 57, 189, 218, 37, 75, 227, 145, 211}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 74, 32, 187, 255, 221, 124, 39}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 26, 224, 26, 140, 61, 245, 68, 117, 186}, 152},
	{{222, 46, 254, 64, 0, 0, 148, 24, 112, 116, 40, 95, 97, 148, 77, 184}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 151, 50, 189, 183, 181, 142, 211, 7}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 184, 239, 203, 210}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 212, 152, 29, 27}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 150, 19, 250, 208, 150, 121, 238}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 112, 81, 105, 43, 37, 194, 246, 101, 93}, 152},
	{{222, 46, 254, 64, 241, 57, 22, 127, 214, 149, 51, 150, 7, 57, 192, 44}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 206, 157, 129, 137}, 152},
	{{222, 46, 254, 64, 0, 0, 252, 193, 44, 58, 41, 20, 174, 38, 2, 86}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 85, 113, 59, 37, 202, 104, 252, 174, 190}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 186, 235, 223, 245, 35, 251, 85, 94}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 10, 98, 169, 54, 53, 152, 191, 155}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{222, 46, 254, 64, 0, 0, 198, 144, 190, 87, 246, 68, 168, 176, 52, 1}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 69, 218, 171, 112, 141, 171, 122, 33, 255}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 65, 114, 54, 218, 167}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 218, 20, 167, 206, 44, 187, 16, 116, 63}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 202, 126, 244, 180, 188, 215}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 58, 28, 207, 246}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{222, 46, 254, 64, 0, 0, 244, 192, 167, 51, 12, 243, 161, 93, 235, 206}, 152},
	{{222, 46, 254, 64, 0, 0, 18, 85, 157, 71, 152, 215, 212, 231, 212, 1}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 190, 126, 9, 62}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 223}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 44, 247, 173, 112, 130, 169, 200}, 152},
	{{222, 46, 254, 64, 0, 27, 194, 24, 183, 123, 79, 228, 165, 151, 200, 229}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 125, 54, 213, 126, 67, 100, 59, 196, 108}, 152},
	{{222, 46, 254, 64, 0, 0, 204, 117, 148, 217, 182, 224, 155, 72, 204, 188}, 152},
	{{222, 46, 254, 64, 93, 30, 188, 242, 111, 55, 110, 175, 121, 153, 47, 145}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 135, 61}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 228, 204, 188, 190, 194, 6}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 59}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 49, 182, 108, 233, 2, 206}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 146, 176, 135, 1, 124, 21, 48, 34}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 233, 175, 64, 73, 161}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 146, 74}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 226, 201, 44, 49, 231}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 147, 150, 245, 216, 41}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 141}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 251, 4, 22, 200, 156, 91, 32}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 35, 239, 93, 7, 127, 143, 43, 149}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 49, 54, 185, 126, 212, 232, 70, 171}, 152},
	{{222, 46, 254, 64, 210, 127, 78, 89, 198, 206, 69, 23, 114, 122, 143, 91}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 122, 56}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 198, 61, 201, 58, 223}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 214}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 61, 183, 230, 113, 35, 203, 112}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 219, 43, 36, 138, 198, 165}, 152},
	{{222, 46, 254, 64, 0, 59, 185, 77, 141, 198, 53, 30, 200, 164, 79, 76}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 49, 165, 78, 208, 167, 92, 237, 74, 155}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 141}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{222, 46, 254, 64, 0, 0, 10, 186, 76, 139, 207, 223, 60, 120, 35, 206}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 163, 247, 128, 252, 49, 212, 139, 246, 187}, 152},
	{{222, 46, 254, 64, 0, 0, 82, 205, 242, 8, 187, 41, 154, 68, 237, 47}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49}, 152},
	{{222, 46, 254, 64, 0, 0, 173, 66, 107, 169, 188, 94, 214, 208, 182, 64}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 36, 153, 231, 253}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 5, 210, 92, 121, 212, 153, 233, 124}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 116, 31, 33, 126, 62, 230, 76, 5}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 225, 215, 110, 32}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 203, 15, 62, 78, 236, 75, 174, 4}, 152},
	{{222, 46, 254, 64, 0, 247, 102, 109, 175, 138, 228, 134, 65, 157, 151, 103}, 152},
	{{222, 46, 254, 64, 46, 213, 65, 66, 149, 122, 250, 203, 197, 100, 179, 255}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 96, 239, 227, 57, 5, 89}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 61, 136, 132, 37}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 71, 30, 241, 229, 99, 122, 172}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 157, 67, 174, 0, 38, 130, 247, 94}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 166}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 152},
	{{222, 46, 254, 64, 0, 0, 0, 0, 0, 0, 0, 0, 242, 176, 154, 97}, 152},
	{{222, 46, 254, 64, 0, 0, 122, 154, 222, 140, 197, 139, 33, 96, 67, 250}, 152},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 34, 246}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 155, 64}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 179}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 210, 194}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 1}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 237, 40}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 14, 219}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 4, 239}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 80}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 227, 227}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 53, 235}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 217, 120}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 9}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 123}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 32}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 21}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 148, 30}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 80, 22}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 119, 170}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 238}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 255}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 237, 239}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 149, 115}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 81}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 145, 56}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 167}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 58}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 212, 209}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 88}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 122, 144}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 116, 127}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 56, 199}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 61, 193}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 241}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 177}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 98}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 15, 227}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 112, 84}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 94}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 153}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 167, 181}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 187}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 232, 22}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 89}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 238, 39}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 39}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 39, 215, 42}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 153, 107}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 219, 112}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 166}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 206, 103}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 54, 26}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 137}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 24, 79}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 193, 75}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 111}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 57}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 132, 29}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 220, 94, 133}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 119, 252}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 18}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 0}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 50, 31}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 0, 79}, 214},
	{{254, 70, 158, 171, 11, 245, 223, 97, 70, 17, 27, 192, 186, 0, 43, 30}, 214},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 33, 188}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 11, 147, 140}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 204, 20, 251}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 178, 191, 97}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 18}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 211, 177}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 173}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 27}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 152}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 181}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 79, 71}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 22}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 197, 197}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 12}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 173, 152}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 122, 239, 80}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 243, 80, 35}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 106}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 211, 122}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 174, 196}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 156}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 145}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 210}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 15}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 250, 11, 246}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 31, 64}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 106, 123}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 18, 164, 150}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 168}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 168, 216}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 209, 45, 112}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 31, 171}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 137, 173}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 107, 250, 184}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 142, 252, 102}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 68, 146}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 115}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 29}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 20}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 128}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 64}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 238, 77, 7}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 72, 43}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 83, 233, 145}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 103}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 56}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 27, 35, 86}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 72}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 47}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 150}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 249}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 52, 217}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 253, 82, 192}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 103}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 39}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 95, 110}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 76, 214}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 13, 16}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 134}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 205}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 115, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 58, 24}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 26}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 95}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 181}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 70, 238}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 64, 98, 254}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 227, 7}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 93, 52, 43}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 110, 92}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 223, 129, 80}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 180}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 77, 233}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 0}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 27, 182}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 242}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 59}, 178},
	{{192, 128, 228, 17, 68, 20, 44, 31, 52, 34, 212, 1, 224, 0, 0, 44}, 178},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 67, 238, 159, 134, 155}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51}, 164},
	{{237, 229, 203, 8, 121, 176, 200, 148, 11, 242, 251, 175, 199, 82, 127, 212}, 164},
	{{237, 229, 203, 8, 121, 176, 161, 193, 217, 194, 152, 57, 135, 21, 165, 166}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 88, 241, 192, 1, 191, 211, 22}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 255, 86, 141, 174, 6}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 10, 168, 83, 151, 44, 243, 238, 33}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 83, 69, 68}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 158, 170, 90}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 112, 51, 48, 118, 127, 88, 39, 116}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 27, 252, 158, 177, 204}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 22, 252, 84, 130, 48, 70, 7, 82}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 79, 141, 250, 106}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 188, 0}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 226, 168, 134, 231, 6, 179, 95}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 168, 251, 67, 179, 193, 89, 59, 192, 44}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 39, 94, 139, 254, 1, 64, 90, 214, 144}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 144, 199, 125, 58, 203, 116}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 238, 190}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 203, 101, 169, 174, 138, 50, 26}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 154, 60, 66, 40, 187, 31, 0, 79, 85}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 132, 13, 189, 248, 194}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 53, 251, 238}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 60, 244, 84, 41, 165, 137}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 86, 221, 251, 213, 159, 202}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 127, 74, 211, 23, 135}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 75, 123, 154, 173, 19}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 204, 140, 57, 21, 113}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 36, 163, 121, 105, 254, 57, 70, 208, 92}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 191, 29, 87, 253, 208, 50, 237}, 164},
	{{237, 229, 203, 8, 121, 176, 168, 126, 7, 48, 141, 217, 125, 165, 189, 142}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 13, 15}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 204, 125}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 34, 173, 30, 164, 110, 52, 247, 118}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 225, 224, 240}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 171, 245, 44, 151, 217, 253, 237, 157, 91}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 246, 151, 126, 20, 171, 83}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 16, 7, 251, 183, 28, 2, 63}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 127, 18, 209, 193, 188}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 187, 246, 27, 24, 114}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 245, 49, 91, 34, 9, 132, 17}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 15, 80, 9, 88, 187, 97, 125, 156}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 193, 131, 127, 231, 135}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 212, 105, 190}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 128, 206, 100, 84, 138, 219, 32, 104}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 54, 93, 171}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 50, 116, 26, 239, 163, 192, 198}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 67, 15, 123, 236, 48, 219}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 43, 14, 57, 153, 208}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 26, 178, 53, 63}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 81, 66, 34, 168, 182}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 232, 241, 187, 16}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 211, 138, 81, 138, 99, 52, 219, 207}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 38, 214, 47, 80, 133}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 165, 33, 49, 234}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 129, 68}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 204, 251}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 59, 179, 251, 184, 60, 95}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 225, 233, 238, 210, 183}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 1, 106, 7, 61, 27, 230, 67, 250}, 164},
	{{237, 229, 203, 8, 121, 176, 93, 79, 192, 62, 82, 44, 129, 208, 126, 209}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 28, 160, 255, 97, 143, 82, 66, 109, 133}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 174, 172, 89, 137, 8, 161}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 60, 84}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 52, 204, 27, 193, 131, 76}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 87, 251, 94, 98, 78, 245}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 231, 35, 185, 43, 244, 186, 114, 53, 190}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 13, 69, 247, 172}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 190, 226, 55, 180, 204, 156}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 37, 68, 29, 130, 127, 242, 145}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 218, 189, 87, 48}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 138, 96, 231}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 24, 112, 44, 37}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 255, 83, 209, 48, 159, 31, 72, 140}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 160, 74, 254}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 153, 77, 247, 236, 133, 191}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 71, 202}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 117, 244, 205}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 0, 0, 0, 0, 138, 209}, 164},
	{{237, 229, 203, 8, 121, 176, 0, 0, 0, 0, 98, 251, 132, 67, 80, 255}, 164},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 158, 37}, 15},
	{{6, 0, 0, 0, 118, 167, 78, 14, 135, 101, 167, 53, 222, 134, 171, 4}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 74, 24}, 15},
	{{6, 0, 0, 0, 212, 221, 215, 109, 53, 178, 80, 166, 152, 137, 146, 37}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 145, 176}, 15},
	{{6, 0, 207, 144, 236, 75, 134, 246, 210, 81, 41, 67, 110, 201, 153, 75}, 15},
	{{6, 0, 0, 0, 94, 102, 103, 171, 114, 160, 214, 1, 74, 49, 154, 250}, 15},
	{{6, 0, 0, 0, 177, 198, 162, 40, 91, 114, 130, 167, 75, 109, 107, 151}, 15},
	{{6, 0, 0, 0, 0, 246, 68, 162, 94, 21, 113, 168, 62, 242, 44, 43}, 15},
	{{6, 0, 0, 0, 0, 97, 68, 147, 2, 227, 93, 37, 48, 192, 132, 135}, 15},
	{{6, 0, 0, 0, 0, 36, 1, 71, 6, 79, 133, 215, 158, 164, 169, 132}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 177, 243, 119, 214, 95, 146, 130, 220}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 5, 28, 11, 174, 147, 115, 186, 132}, 15},
	{{6, 0, 0, 0, 0, 0, 98, 182, 50, 15, 16, 132, 32, 181, 177, 98}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 8, 170, 192, 38, 212, 56, 28, 253}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 216, 187, 138, 147, 100, 16, 22, 11}, 15},
	{{6, 0, 0, 0, 231, 4, 69, 14, 130, 176, 163, 124, 72, 9, 75, 48}, 15},
	{{6, 0, 0, 0, 0, 253, 169, 7, 4, 11, 204, 191, 147, 191, 233, 88}, 15},
	{{6, 0, 196, 204, 165, 0, 215, 241, 154, 209, 214, 243, 14, 137, 122, 247}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 195, 32, 175, 68, 151, 129, 31, 13}, 15},
	{{6, 0, 0, 141, 59, 133, 251, 120, 71, 61, 46, 133, 10, 212, 194, 77}, 15},
	{{6, 0, 0, 0, 247, 1, 197, 69, 66, 151, 40, 195, 93, 209, 72, 94}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 245, 174}, 15},
	{{6, 0, 0, 0, 0, 159, 160, 85, 140, 112, 107, 62, 102, 57, 245, 213}, 15},
	{{6, 0, 0, 0, 0, 81, 235, 60, 75, 40, 108, 37, 7, 93, 32, 60}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 253}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 92, 188, 115, 101, 152, 135, 173, 240, 92}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 66, 94, 0, 39, 246, 90, 52, 130}, 15},
	{{6, 0, 0, 0, 0, 124, 144, 168, 32, 23, 137, 44, 15, 137, 171, 194}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 176, 13, 153, 34, 50, 123, 13}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 156, 232, 194, 46, 127, 121, 14, 121, 11}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 110, 108}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 215, 119}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 10, 209, 129, 134, 209, 212, 122}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 190}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 203, 67, 86, 96, 229}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 214, 80, 127, 145, 163, 109, 70, 98}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 150, 42, 106, 79}, 15},
	{{6, 249, 240, 72, 177, 60, 74, 188, 186, 66, 116, 183, 169, 197, 9, 124}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 237, 229, 210, 49, 37}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 64, 113, 95, 102, 216, 89, 216}, 15},
	{{6, 0, 222, 144, 72, 64, 24, 219, 139, 76, 71, 106, 14, 181, 13, 80}, 15},
	{{6, 0, 0, 0, 51, 168, 25, 255, 196, 217, 123, 66, 93, 92, 60, 193}, 15},
	{{6, 0, 0, 0, 134, 44, 158, 67, 208, 125, 151, 228, 21, 66, 229, 97}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 184, 159, 255, 148}, 15},
	{{6, 0, 36, 57, 106, 115, 209, 114, 43, 181, 0, 114, 192, 166, 175, 152}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 225, 194}, 15},
	{{6, 0, 0, 181, 250, 210, 199, 42, 33, 53, 149, 217, 206, 8, 215, 45}, 15},
	{{6, 0, 0, 0, 0, 0, 115, 168, 243, 119, 125, 111, 199, 177, 80, 13}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 77, 40, 40, 49}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 230}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 3, 3, 64, 87, 175}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 250, 40, 199, 46, 123, 122, 228}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{6, 0, 0, 164, 127, 164, 247, 21, 178, 162, 233, 50, 150, 220, 49, 228}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 100}, 15},
	{{6, 0, 0, 0, 0, 0, 86, 37, 131, 140, 219, 12, 195, 142, 224, 106}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 15},
	{{6, 0, 208, 138, 255, 243, 30, 15, 33, 10, 119, 224, 3, 186, 144, 161}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 20, 150, 207, 152}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 48, 242, 163, 170, 209, 163, 161, 113}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 61}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 133, 233, 1, 252, 206}, 15},
	{{6, 0, 0, 85, 121, 175, 59, 41, 51, 21, 206, 156, 18, 86, 174, 69}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 44}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 4, 81, 216, 11, 160, 144, 213, 182, 25}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 130}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 217}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 163, 125}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 53}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 226, 65, 115, 224, 158}, 15},
	{{6, 0, 0, 0, 0, 0, 48, 251, 62, 82, 216, 0, 111, 244, 19, 68}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 191, 110, 36, 163}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 172}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 169}, 15},
	{{6, 0, 0, 0, 242, 216, 54, 253, 66, 242, 236, 236, 104, 23, 246, 9}, 15},
	{{6, 0, 0, 0, 0, 164, 220, 86, 39, 202, 223, 219, 90, 102, 185, 247}, 15},
	{{6, 150, 171, 110, 109, 29, 120, 170, 168, 208, 98, 127, 177, 64, 38, 159}, 15},
	{{6, 0, 0, 0, 0, 46, 105, 130, 13, 124, 105, 146, 172, 73, 112, 102}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 119, 12, 21, 254, 193}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 20, 239, 97, 218, 113, 46, 111}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 191, 89, 124, 143, 5, 99, 36, 168}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 106, 92, 19, 48}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 100, 11, 179, 81, 50, 30, 168, 139, 183}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 236, 63, 109, 150, 197, 172, 186, 85, 49}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 177, 101, 132, 13, 34, 171, 105, 215}, 15},
	{{6, 0, 0, 0, 0, 35, 232, 137, 254, 26, 82, 146, 101, 95, 98, 152}, 15},
	{{6, 0, 0, 141, 11, 82, 167, 167, 24, 115, 137, 54, 128, 81, 190, 106}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 58, 182, 145, 216, 230, 62, 210}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 197}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 132}, 15},
	{{6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 195}, 15},
	{{6, 0, 0, 0, 0, 0, 88, 190, 219, 226, 52, 84, 244, 137, 104, 200}, 15},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 10, 21}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 205, 151, 218}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 220, 101}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 153, 108, 44, 80, 26, 205}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 182, 102, 87}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 240}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 199, 183, 98}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 69, 139, 203, 254, 19}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 122}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 198, 44, 135}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 207, 90, 146, 187, 234}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 121, 125, 112}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 128, 108, 210, 87}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 15, 190, 224, 64, 218, 5}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 35, 33, 148}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 61, 170, 115, 210}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 140, 83, 189, 84, 41, 114}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 192}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 114, 119}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 152, 251}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 29, 26, 189, 149}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 90, 230, 86, 188, 59, 244}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 223, 230, 93, 147}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 35, 183, 156}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 17, 13, 177}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 76}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 178, 167, 68, 183, 149}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 54, 237, 149, 137}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 19, 197, 233}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 94, 155}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 250, 97, 232, 103, 192}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 74, 199, 146, 18, 110}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 76, 228, 93, 213, 16}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 237, 136}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 223, 167, 195}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 41, 123}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 222}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 22}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 235, 236}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 150, 222, 70, 136}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 79}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 218, 226, 17, 29, 121}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 116, 251, 225, 44, 54, 205}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 46, 169, 92, 99}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 123}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 104, 34, 190, 221}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 201, 125}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 131, 194, 3, 21, 207}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 75, 232}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 69, 232, 228}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 102, 197}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 1, 26, 226, 80, 93, 138}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 144, 13, 12, 111, 89, 147}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 146, 163, 204}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 102, 236}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 119, 63}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 29, 235, 240, 136, 100, 29}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 73}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 219, 24, 124, 90}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 139, 90, 156, 170, 170, 51}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 58, 253, 146, 87, 85}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 226}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 166, 31, 216, 16, 227}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 137}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 43, 236, 249, 81}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 245, 214, 122, 57}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 181, 205, 36, 132, 148}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 82, 127, 177, 157}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 51}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 104, 123, 108, 122}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 89, 175, 109, 52, 123}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 82}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 228, 223, 71, 55, 149, 202}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 111, 132, 173}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 102, 141, 20, 8, 167, 96}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 51, 148, 80, 129}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 128, 161, 34, 237}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 23, 66}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 128, 5, 207, 254}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 0, 0}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 138, 220}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 0, 159, 86}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 0, 246, 11, 195}, 94},
	{{71, 197, 251, 122, 138, 232, 12, 241, 116, 240, 0, 0, 245, 97, 203, 244}, 94},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 66, 16, 139}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 186, 57, 13, 50, 172, 151}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 182, 55, 94, 20}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 239, 173}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 13, 206, 213, 189}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 7, 37, 135, 174, 162}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 149, 226, 177, 164, 28}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 119, 107, 83, 117, 111, 234}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 12, 22, 95, 127}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 55, 62, 136, 116, 90, 114, 128}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 39, 119, 130, 5, 91}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 3, 93, 155, 205, 13, 100}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 77, 144, 214, 5, 81, 91}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 41}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 16, 143}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 233, 115, 65, 38}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 137, 141, 123, 233, 194}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 119, 215, 87}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 130, 41, 35, 101, 181, 78}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 235, 20, 104}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 41, 33, 57}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 20, 168}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 80}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 127, 190}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 142}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 180, 112}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 209, 164}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 178, 34, 169, 18, 38}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 157, 119, 176, 255, 0, 154}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 47, 160, 47, 217, 104, 201}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 200, 243}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 117, 254, 203, 200, 116, 44}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 84}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 172, 112, 16}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 44, 42, 73, 67}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 131, 2, 6, 68, 36}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 255, 30}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 236, 189}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 64, 172, 235}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 196, 26, 255, 246, 46, 22}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 189, 41, 202, 138}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 139, 14}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 161, 233}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 231, 252}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 31, 96, 237, 152, 67}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 195}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 9, 171, 181}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 111, 96, 168, 152}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 211, 71, 62, 123, 91, 76}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 97, 60, 169, 109, 4, 159}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 53, 68, 42}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 34, 236, 143, 199, 153}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 242, 208, 121, 218, 102}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 215, 54, 241, 7}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 110, 91, 172, 19, 24, 26, 254}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 165}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 56, 182, 15, 24}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 142, 144}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 127, 134, 71, 12, 133}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 68, 78, 108, 107, 180}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 90, 82, 115}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 21}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 125, 43}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 109, 200, 30, 10}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 52, 237}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 133, 62, 55, 135, 234, 208}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 76, 74, 82, 46, 13, 165, 255}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 196, 163, 98, 209}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 240, 102, 97, 129, 106, 228}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 122, 164, 101, 183, 94}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 173, 207}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 119, 163}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 162}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 72, 104, 192, 165, 96}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 219, 101, 222, 70, 213}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 24, 219}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 252, 64, 158, 59, 88}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 251, 75, 204, 234}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 192, 12, 223}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 157, 222, 45, 232}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 0, 0, 0, 41, 126, 25}, 239},
	{{18, 241, 135, 210, 233, 54, 121, 185, 4, 0, 31, 10, 80, 196, 68, 103}, 239},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 0}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 0}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 231, 119, 69, 100, 96}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 63, 0, 66, 223, 68}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 223, 66, 3}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 149, 71, 43, 72}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 217, 206, 103}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 23, 172, 141}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 9}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 238, 111, 166, 60, 242}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 185, 149}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 0}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 40, 59, 71}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 243, 188, 185, 21}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 199}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 44}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 248, 113, 45, 83, 251}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 156, 118, 158, 251}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 175, 155, 248, 209}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 157, 89, 162, 198, 70}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 126, 84, 100, 134, 254}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 0}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 253, 94}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 0}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 135, 198, 179, 243}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 44}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 141, 174, 42, 113}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 250, 228, 120, 223, 153, 0}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 153, 9, 30, 156, 21}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 191, 207, 4, 223, 253}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 1}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 243, 4, 153, 75, 250}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 245, 134, 166}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 149}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 237}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 54, 47, 221, 194, 114}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 0}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 115, 251, 172, 72}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 131}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 76, 104, 249, 87}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 11, 219, 85, 37}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 224, 85, 151}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 220, 104, 161}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 123, 10}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 0}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 0}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 31, 95}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 171, 147, 150, 244, 143, 13}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 103, 231, 223}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 193, 121, 120, 145, 81, 118}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 21, 210}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 113, 73, 70, 35}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 0}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 182, 75, 86}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 65, 32, 37, 152}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 127, 25, 132, 78, 247}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 161, 230, 31, 49, 153}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 141, 167, 207}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 131, 93}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 60, 250, 69}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 9, 163, 36}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 137}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 125, 14}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 26, 40, 234, 205, 215}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 202, 110}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 186, 144, 253, 191, 87}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 208}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 76, 233}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 27}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 226, 76, 146}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 6, 141, 207, 239, 81, 24}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 102, 110, 202, 94}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 0}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 12, 81, 206}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 22, 99, 176, 215}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 10}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 0}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 212, 103, 128, 94, 92, 196}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 118, 212, 250, 250, 140}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 33, 82}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 140, 196, 5, 185}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 203, 109, 226, 133, 53, 85}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 91, 51, 237, 29, 136}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 0}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 206, 202, 54, 144}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 167, 185, 92, 246}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 128, 114, 75}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 125, 68, 82, 46, 49}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 19, 47, 49, 39, 133, 110}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 136, 191, 59, 200}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 70, 94, 33, 25}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 98, 4, 196}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 195, 219}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 71, 28, 103, 12, 241}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 122}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 178, 28, 197, 38, 115}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 0}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 248, 205, 189, 182, 121}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 12, 85, 21, 100}, 82},
	{{32, 50, 213, 63, 73, 217, 180, 21, 187, 128, 0, 0, 0, 0, 0, 11}, 82},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 79, 242}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 218, 152, 12, 12, 251, 5, 186}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 45, 90, 26, 111, 105, 109, 143, 27}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 70, 160, 32, 170}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 205, 75, 152, 208}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 58, 66, 142, 72, 129, 145}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 206, 70, 182, 69, 144, 147, 118, 7}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 69, 229, 99, 160}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 26, 136, 233}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 117, 28, 179, 162}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 48, 193, 183}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 175}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 172, 112, 160, 153, 100, 44}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 19, 226, 90, 170, 210, 156}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 170, 42, 200}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 155, 62, 240, 8}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 155, 215, 170, 113, 109, 236}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 202, 18, 248, 91, 53}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 179, 215, 100, 176, 10, 50}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 233, 58, 187, 48, 45, 50, 61}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 212, 162}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 121, 27}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 86, 27, 83}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 129, 213, 88}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 210, 32, 21, 50, 118, 62, 213}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 61, 85, 172, 193, 166, 236, 236}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 252, 114, 146}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 234, 21, 95}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 145, 242, 37, 230, 89, 98}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 42, 98, 238, 78, 253, 192}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 63, 78, 59, 104, 194, 234, 41, 14}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 72, 153}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 144}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 250}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 193, 162, 226, 81, 63, 94}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 71, 90, 66}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 229, 109}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 247, 6}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 3, 204, 85, 30, 168, 24, 190, 44}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 180, 158, 119, 25, 160, 211}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 181, 240, 85, 26, 123}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 174, 27, 231, 35, 253}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 119, 135, 66, 153, 125, 232, 158, 60}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 199, 12, 91}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 23, 89, 56, 47, 45, 125}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 251, 240, 83}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 232, 160, 124}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 94, 154}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 128, 8, 155, 66, 136}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 235, 33, 25, 102}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 97, 152, 4, 145, 216, 59, 196, 87}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 68, 229, 176, 153, 136, 243, 59, 242}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 127, 83, 5, 251, 139}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 69, 189, 26, 93, 206}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 21, 224, 164, 61, 107, 58}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 62, 14, 176, 97, 89, 174, 87}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 1, 41, 121, 207, 77, 92, 38}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 67, 16, 36, 104, 254, 181}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 192, 86}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 203, 245, 151}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 26, 111, 219, 48}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 156, 208, 46}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 60, 52, 82, 54, 32, 214}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 244, 55, 217}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 112, 127, 169, 17}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 196, 113, 8, 120, 106, 214, 209}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 20, 252, 156, 142, 214}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 175, 115, 102, 117, 168, 171}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 227, 9, 140}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 204, 173}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 206, 70}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 189, 4, 150, 190, 1, 215}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 19, 250, 58, 109, 50, 17}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 214, 13, 214}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 26, 140}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 48, 251, 151, 45}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 0, 0, 0, 0, 229, 146}, 54},
	{{203, 166, 233, 73, 92, 182, 212, 0, 0, 0, 125, 34, 166, 191, 145, 163}, 54},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 235, 182, 162}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 23}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 122, 33}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 65}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 85}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 156, 135, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 228}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 249}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 101, 136}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 231}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 220, 66, 203}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 64}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 229, 86}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 107}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 49, 228}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 134}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 81}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 197}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 24}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 225, 241}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 60, 136}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 137}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 92, 172}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 194, 58}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 149, 174}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 17, 141}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 11, 146}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 91}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 201, 231, 143}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 216, 106}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 18}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 113}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 19}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 218}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 138, 234}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 205, 196}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 6}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 219}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 191, 80}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 207}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 71, 148}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 11, 122}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 46, 172, 168}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 189}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 163, 9, 92}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 100, 223, 145}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 243}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 77}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 190, 207, 222}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 228, 49}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 186, 159, 247}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 249, 54, 85}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 130, 221, 98}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 221, 153, 250}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 199, 84}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 230, 72, 148}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 254, 238}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 187, 59}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 213, 153}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 48, 15, 155}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 52, 123}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 252, 39, 8}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 176, 18}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 230}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 140}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 197, 24}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 185, 69}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 0, 0}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 233, 101, 38}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 169, 150, 233}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 97, 255}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 67, 67, 229}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 46, 108}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 31, 242}, 47},
	{{56, 162, 126, 4, 18, 195, 192, 64, 164, 156, 119, 196, 64, 0, 99, 136}, 47},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 133, 176}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 69, 243, 70}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 145, 52, 191, 240, 251}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 213, 183, 44, 240}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 245}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 159}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 191}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 116, 55, 2}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 156}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 83, 157}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 134, 195, 97, 255}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 100, 100, 214, 196, 47}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 240, 184, 250, 166, 43}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 90, 185, 65}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 97, 59, 193}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 226, 81, 205, 144}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 209, 136, 72}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 143, 91, 107, 186}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 89}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 226, 205, 224}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 164, 128}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 151}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 214, 123, 218, 15}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 117, 175}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 170, 113, 172, 11}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 216, 163}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 199, 196}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 110, 94, 230}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 14, 116, 58}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 142}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 229, 112, 166, 130}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 173, 68, 35, 127, 10}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 95, 213, 20}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 138, 22, 58}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 4, 178}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 136, 3, 128}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 6, 211}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 183}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 1, 24, 20}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 249, 15}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 26, 68, 114, 1, 4}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 15, 55}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 144}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 62, 46, 77}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 39}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 151, 202}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 78, 72}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 96}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 52, 160, 210, 90}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 65, 64}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 247, 143, 207}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 81, 131}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 1, 29, 146, 230}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 5, 43, 34, 173, 179}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 43, 110}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 154, 22, 152}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 65, 65}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 172, 246}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 205}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 20}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 116, 145, 173, 43}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 55, 148, 189}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 251, 102}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 83}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 141}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 158, 228, 65, 229}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 84, 62, 166, 88}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 58}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 169, 28, 185, 194, 195}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 61, 32, 113, 154, 99}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 60, 5, 26, 3}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 144, 198, 55, 45}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 180}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 185, 189, 190, 79}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 3, 255, 86}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 195, 60, 183, 222}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 45, 238, 230}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 0}, 214},
	{{120, 87, 81, 136, 180, 179, 68, 148, 243, 38, 80, 0, 0, 0, 0, 247}, 214},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 41, 21, 116}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 154, 59, 63, 169, 85, 153}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 28, 211, 121, 2, 5, 112, 44, 175, 64}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 4, 60, 161, 3, 72, 151}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 193, 133, 56}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 120, 8, 21, 16, 5, 159, 238}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 204, 251, 17}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 119, 29, 50, 147, 248, 115, 196, 220}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 105, 41, 221, 102, 234, 100}, 215},
	{{64, 244, 193, 50, 48, 84, 192, 86, 25, 142, 154, 248, 217, 83, 229, 166}, 215},
	{{64, 244, 193, 50, 48, 0, 65, 128, 167, 156, 171, 201, 253, 63, 14, 105}, 215},
	{{64, 244, 193, 50, 48, 0, 231, 234, 140, 186, 75, 40, 202, 94, 173, 32}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 186, 106, 131, 32}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 212, 248, 207, 110}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 76, 199, 30, 87, 118}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 233, 53, 36, 79, 212, 229, 52}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 228, 26, 90, 217, 215, 19}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 121, 171, 44, 187}, 215},
	{{64, 244, 193, 50, 48, 0, 33, 106, 237, 218, 131, 84, 119, 19, 113, 53}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 128, 50, 94, 112, 224, 94, 65}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 197, 80, 148, 90, 237, 11, 40, 85}, 215},
	{{64, 244, 193, 50, 48, 0, 237, 20, 97, 38, 248, 79, 232, 85, 96, 196}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 103}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 122}, 215},
	{{64, 244, 193, 50, 48, 0, 189, 107, 10, 172, 24, 4, 124, 73, 246, 66}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 238, 231, 152, 122, 218, 24, 145, 152}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{64, 244, 193, 50, 48, 44, 81, 246, 104, 2, 127, 255, 167, 46, 188, 163}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 168, 29, 62, 50, 222, 220, 29}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 43, 225, 183}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 28, 133, 79, 250}, 215},
	{{64, 244, 193, 50, 48, 56, 238, 199, 173, 2, 7, 91, 133, 12, 157, 93}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 96, 116, 153, 68, 39, 84, 173}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 23, 113, 112, 215, 141}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 80, 120, 96}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 111, 29, 75, 25}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 215, 167, 100, 188, 179, 130}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 66, 222, 93, 34, 110, 194, 25, 16}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 100, 102, 81, 164, 245, 18, 132, 120, 29}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 168, 114, 48, 105, 41, 148, 246}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 209, 69, 206, 14, 105}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 106, 98, 43, 23, 156, 189, 188}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 161, 91, 83}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 229}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 54, 246, 176, 166, 254, 30, 227}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 229, 127, 10, 51}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 43, 212, 77, 143}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 174, 239, 235, 98, 31, 255, 223}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 24}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 96, 24, 94, 194, 114, 194, 147}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 3, 104, 56, 61, 88, 141}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 104, 117, 49}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 52, 87, 133}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 92, 141, 202, 111, 64}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 63, 141, 211, 148, 181, 109, 110}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 81, 9, 212, 180, 219}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 0}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 51, 116, 164}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 250, 202, 40, 150, 24, 54}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 123, 65, 63, 132}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 192, 117, 92, 227, 11, 232}, 215},
	{{64, 244, 193, 50, 48, 0, 78, 132, 18, 34, 28, 140, 29, 10, 57, 232}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 143}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 82, 36, 35, 190, 97, 149}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 150, 68, 172, 0, 77, 25, 91, 14, 47}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 71, 228, 1, 107, 237, 240}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 187, 188, 49, 65, 40, 90, 31, 115, 30}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 83, 25, 2, 145, 192}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 220, 19, 220, 4, 222, 94}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 95, 146, 85, 156, 197, 139}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 16, 236, 5}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 164}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 191, 198, 189, 242, 145}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 104, 100, 233, 155, 36, 123, 182, 109}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 151, 180, 167, 41, 113, 99, 139, 77, 200}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 140}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 155, 172, 205, 103, 5}, 215},
	{{64, 244, 193, 50, 48, 0, 82, 138, 205, 218, 113, 217, 11, 64, 131, 159}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 15, 78, 156, 35}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 117, 166, 23, 95, 6, 136}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 0, 0, 0, 0, 122, 91, 222, 9, 38}, 215},
	{{64, 244, 193, 50, 48, 0, 0, 37, 100, 143, 35, 154, 49, 19, 166, 205}, 215},
	{{64, 244, 193, 50, 48, 0, 103, 68, 191, 70, 53, 21, 253, 169, 144, 12}, 215},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 93, 229, 110, 101}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 126, 206, 45}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 45, 165}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 91, 204, 203, 232, 40}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 70, 234}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 109, 185}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 194, 41}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 134}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 169, 88, 75}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 233, 135}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 23, 82}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 57, 111, 242, 114}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 61, 16}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 48}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 12, 17, 123, 111}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 97, 39}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 237, 27}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 31}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 192}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 233, 217, 32, 160}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 158}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 24, 134, 0, 229}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 123, 91, 139}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 112, 221}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 17, 249, 207}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 232, 11, 243}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 174, 129, 130, 236, 64}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 205, 67}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 191}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 130, 228, 247}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 9}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 220, 222}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 62, 20, 190, 218}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 162, 24, 198, 117, 116}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 204}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 172, 88, 253, 166}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 9, 121, 157, 24}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 51, 49}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 148, 193, 82, 92}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 66, 139, 40, 124, 180}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 207, 148, 95, 208}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 58, 63}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 222, 210, 73, 103}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 170}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 67, 236}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 202}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 197}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 199, 31}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 41}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 37, 23}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 110, 86, 85, 53}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 183, 121, 205, 84, 173}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 95}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 192, 135}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 185, 33}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 214, 210, 206}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 154, 136, 222, 81}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 84, 186, 64}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 188, 37}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 89}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 64, 162, 145}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 238}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 93, 167}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 158, 88, 30}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 86, 77, 94, 115, 183}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 208}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 248, 200, 250}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 253, 70, 90, 222}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 203, 148, 245}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 63, 141}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 155, 124}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 20, 211, 126, 111}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 101, 108, 16, 103}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 83, 209}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 100, 112, 114}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 253, 2, 144, 234}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 231, 28}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 184, 96, 166}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 223, 104, 194, 18, 232}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 173, 229, 173}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 146, 45, 205, 240}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 0}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 163, 170}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 32, 63, 21, 81}, 153},
	{{91, 168, 253, 158, 131, 83, 159, 163, 113, 169, 112, 0, 0, 0, 0, 219}, 153},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{159, 103, 102, 132, 111, 46, 18, 77, 36, 15, 137, 33, 177, 31, 243, 192}, 245},
	{{123, 0, 0, 175, 170, 33, 157, 187, 53, 230, 158, 98, 177, 174, 41, 184}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 46, 94}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 146, 70, 106, 155, 207}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 2, 236, 35, 14, 249, 38, 30}, 118},
	{{123, 0, 0, 0, 0, 160, 42, 99, 143, 132, 230, 22, 187, 158, 130, 166}, 118},
	{{123, 0, 183, 187, 50, 187, 168, 121, 170, 109, 211, 142, 36, 84, 203, 179}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 151}, 118},
	{{123, 0, 0, 0, 0, 2, 252, 87, 101, 79, 63, 184, 76, 126, 239, 197}, 118},
	{{123, 0, 65, 113, 88, 131, 93, 29, 82, 148, 238, 122, 240, 59, 77, 22}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 254, 210, 26, 188, 63, 67, 24}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 56, 154, 67, 141, 145, 130, 88, 45}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 31, 90, 30, 192, 142, 22, 64, 165, 185}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 129, 29, 48, 184, 103, 74, 230, 41, 32}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 118},
	{{123, 0, 0, 0, 0, 0, 238, 239, 109, 204, 252, 167, 206, 16, 213, 95}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 118},
	{{123, 0, 0, 0, 0, 159, 136, 251, 24, 240, 183, 80, 214, 80, 82, 180}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 145, 213}, 118},
	{{123, 0, 0, 0, 0, 173, 211, 47, 13, 163, 113, 149, 82, 12, 10, 253}, 118},
	{{123, 0, 0, 0, 40, 19, 119, 161, 229, 166, 241, 104, 109, 178, 56, 139}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 197, 22, 202, 83}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 51, 157, 94}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 103, 186, 30, 124, 148, 177, 73}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 14, 183, 236, 22, 45, 166, 40, 142}, 118},
	{{123, 0, 0, 84, 86, 191, 75, 121, 179, 16, 164, 242, 27, 200, 71, 148}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 113, 43, 96, 185, 158, 145, 22, 89, 59}, 118},
	{{123, 0, 0, 2, 59, 78, 81, 238, 213, 14, 71, 96, 30, 214, 166, 84}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 129, 10, 255, 59, 245, 147, 17}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 15, 42, 213, 131, 250, 5, 133, 19, 166}, 118},
	{{123, 0, 0, 0, 0, 204, 7, 106, 35, 194, 44, 170, 130, 185, 71, 231}, 118},
	{{123, 0, 0, 0, 0, 43, 243, 230, 234, 237, 150, 244, 31, 205, 243, 237}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 12, 123, 161, 234}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 150, 35, 79, 78, 80, 19, 20, 0}, 118},
	{{123, 0, 0, 0, 0, 0, 93, 37, 24, 228, 11, 226, 101, 0, 84, 144}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 95, 247, 208}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 45, 30}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 62, 115, 175, 37, 41, 90, 197, 6}, 118},
	{{123, 0, 0, 0, 0, 0, 61, 175, 129, 97, 131, 5, 186, 176, 3, 221}, 118},
	{{123, 0, 0, 125, 33, 134, 21, 84, 7, 8, 133, 169, 189, 64, 121, 240}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 217, 144, 194, 179, 152, 162, 241, 27}, 118},
	{{123, 0, 0, 0, 0, 0, 203, 161, 239, 53, 69, 29, 113, 24, 148, 98}, 118},
	{{123, 0, 0, 0, 0, 140, 39, 208, 79, 237, 123, 37, 230, 201, 212, 190}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 142}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 116, 54, 250}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 203, 219, 131, 171, 177, 93, 44, 246, 181}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 16, 6}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 77, 88, 235, 31, 195, 243, 162, 118, 34}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 85, 83, 118, 254, 69, 15, 207, 14, 208}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 35, 204, 247, 33}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 238, 109, 241, 220, 11, 151, 154, 146, 34}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 27, 133, 164, 173, 229, 60, 169}, 118},
	{{123, 0, 0, 114, 88, 86, 6, 158, 60, 34, 59, 77, 144, 222, 188, 84}, 118},
	{{123, 0, 0, 0, 194, 152, 172, 23, 5, 211, 89, 156, 185, 158, 252, 167}, 118},
	{{123, 0, 0, 0, 93, 49, 98, 106, 26, 233, 154, 78, 45, 104, 172, 126}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 97, 238, 251, 116, 81}, 118},
	{{123, 0, 0, 0, 235, 238, 18, 38, 156, 245, 15, 68, 199, 205, 125, 230}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 216, 247, 233, 30, 240, 250, 222, 24, 135}, 118},
	{{123, 0, 0, 151, 211, 254, 149, 209, 93, 142, 175, 190, 129, 251, 121, 11}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 148}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 218, 12, 76, 198, 89, 40, 48, 154, 19}, 118},
	{{123, 0, 0, 0, 0, 165, 172, 122, 180, 137, 69, 137, 76, 65, 149, 187}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 118},
	{{123, 0, 0, 0, 0, 191, 188, 93, 223, 91, 234, 23, 48, 6, 199, 220}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{123, 0, 47, 215, 194, 36, 213, 251, 57, 66, 81, 73, 185, 193, 120, 191}, 118},
	{{123, 0, 0, 0, 0, 191, 45, 141, 7, 243, 213, 52, 199, 110, 122, 37}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 181, 228, 71, 48, 162, 106, 36, 106, 34}, 118},
	{{123, 0, 0, 0, 0, 48, 79, 184, 183, 138, 230, 206, 187, 131, 32, 46}, 118},
	{{123, 0, 0, 135, 178, 219, 149, 207, 235, 222, 159, 232, 36, 245, 197, 96}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 223, 99}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 246}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 122}, 118},
	{{123, 0, 0, 0, 91, 117, 102, 126, 46, 199, 164, 67, 211, 130, 90, 29}, 118},
	{{123, 0, 0, 0, 0, 0, 11, 61, 62, 199, 178, 233, 2, 153, 183, 79}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 160, 188, 136, 26}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 174, 110, 188}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 141, 31}, 118},
	{{123, 0, 0, 0, 116, 168, 237, 10, 39, 77, 155, 202, 45, 149, 35, 142}, 118},
	{{123, 0, 0, 0, 10, 30, 104, 64, 53, 213, 236, 91, 99, 170, 105, 220}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 126, 245, 128, 41, 181, 58, 90, 161, 136}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 227, 34, 196, 62, 78}, 118},
	{{123, 0, 0, 200, 145, 201, 34, 126, 17, 148, 176, 121, 223, 45, 231, 55}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 74, 224, 18, 0, 126, 178, 219}, 118},
	{{123, 0, 0, 0, 177, 39, 148, 195, 228, 248, 26, 205, 138, 204, 248, 106}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 220}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 215, 125}, 118},
	{{123, 0, 0, 0, 245, 67, 13, 104, 163, 206, 79, 200, 161, 156, 114, 37}, 118},
	{{123, 0, 0, 0, 150, 157, 223, 13, 251, 188, 108, 120, 113, 225, 109, 27}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 214, 211, 0}, 118},
	{{123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 100, 97}, 118},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{67, 81, 226, 190, 7, 79, 71, 250, 155, 245, 44, 81, 215, 213, 171, 224}, 128},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 2, 239}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 98, 185}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 107, 189, 230}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 175, 59, 71}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 22, 109, 9, 235}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 161, 143, 92, 142, 3, 192, 33}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 231}, 7},
	{{103, 0, 0, 247, 82, 112, 88, 182, 107, 78, 254, 14, 155, 255, 133, 83}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 119, 134, 93}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 55, 67, 229}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 62, 96, 3}, 7},
	{{103, 0, 0, 0, 0, 25, 114, 85, 223, 140, 164, 239, 204, 230, 72, 29}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 150, 128, 114, 6, 53, 74, 70, 128}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 126, 240, 70, 195}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 252, 91, 165, 10, 88, 212, 3, 242, 104}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 1, 110, 107}, 7},
	{{103, 0, 0, 0, 0, 198, 10, 139, 81, 170, 176, 106, 82, 101, 252, 147}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 159, 130, 88, 35, 153, 118, 4}, 7},
	{{103, 0, 0, 179, 53, 214, 204, 179, 244, 143, 64, 242, 59, 121, 234, 2}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 108, 200, 212, 70, 140, 134, 227}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 20, 17}, 7},
	{{103, 0, 0, 0, 0, 0, 138, 223, 59, 74, 72, 205, 250, 210, 120, 251}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 7},
	{{103, 0, 0, 0, 0, 168, 38, 131, 177, 18, 112, 213, 169, 183, 116, 90}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 14, 254, 96, 148}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 84, 138}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 182, 232, 176, 210, 240, 7, 14}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 225, 112, 38, 244, 228, 113, 215}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 105, 165, 28}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 88, 202, 133, 253, 81, 53, 244}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 229, 172, 64, 75, 53, 113, 211}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 144, 35, 176, 237, 240, 174, 67, 154}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 159, 220, 141, 148, 73}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 171, 22, 43, 108}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 40, 154, 242, 19}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 44, 60, 249, 245, 28, 146, 181}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 11, 172, 156, 251, 45}, 7},
	{{103, 0, 0, 0, 0, 0, 43, 4, 181, 62, 39, 116, 160, 134, 22, 123}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 220, 241, 95, 100, 119}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 75, 127, 251, 177, 97, 163, 142, 156}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 150, 138, 61, 4, 36, 219, 73, 194, 141}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 149}, 7},
	{{103, 0, 0, 0, 0, 183, 90, 252, 118, 73, 170, 25, 243, 39, 157, 33}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 34}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 224, 15}, 7},
	{{103, 0, 0, 0, 0, 0, 127, 147, 148, 98, 107, 106, 129, 209, 227, 80}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 72, 66, 114, 128, 73}, 7},
	{{103, 0, 0, 196, 45, 113, 233, 7, 41, 199, 64, 85, 249, 157, 244, 192}, 7},
	{{103, 0, 0, 100, 203, 64, 105, 247, 178, 200, 137, 162, 158, 189, 14, 220}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 27, 221, 129, 161, 187, 39, 48, 85, 97}, 7},
	{{103, 0, 0, 0, 153, 58, 169, 5, 33, 227, 205, 128, 37, 240, 119, 17}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 194, 56, 251, 154, 172, 200, 249, 120, 51}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 7},
	{{103, 0, 91, 12, 236, 142, 197, 56, 124, 20, 20, 236, 8, 140, 87, 123}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 109, 168, 0, 161, 158, 227, 221, 225}, 7},
	{{103, 0, 0, 207, 118, 122, 58, 101, 150, 86, 220, 77, 223, 32, 238, 51}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 23, 125, 170}, 7},
	{{103, 0, 0, 0, 149, 218, 91, 195, 188, 57, 74, 98, 71, 31, 106, 195}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 171, 168, 31, 8}, 7},
	{{103, 0, 17, 165, 87, 125, 69, 70, 72, 239, 59, 6, 55, 193, 66, 128}, 7},
	{{103, 0, 0, 0, 199, 148, 67, 200, 151, 44, 128, 94, 107, 43, 48, 32}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 16, 4, 74, 243}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 244, 216, 35, 250, 156, 138, 215}, 7},
	{{103, 0, 9, 94, 155, 46, 3, 240, 224, 186, 42, 167, 204, 27, 134, 1}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 116, 99, 24, 107, 207, 187, 26, 187}, 7},
	{{103, 0, 61, 78, 26, 169, 209, 0, 48, 17, 2, 249, 65, 125, 26, 106}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 84, 163, 63}, 7},
	{{103, 0, 0, 237, 11, 11, 168, 161, 179, 45, 92, 45, 167, 48, 1, 50}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 250, 111, 119, 86, 6, 187, 118}, 7},
	{{103, 0, 0, 0, 141, 148, 239, 145, 6, 10, 131, 213, 69, 245, 31, 7}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 26}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 41, 93, 90, 4, 23, 208, 57, 19}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 185, 82, 205}, 7},
	{{103, 0, 0, 0, 198, 235, 179, 60, 31, 117, 34, 68, 226, 63, 54, 247}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 67, 126, 177}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 7},
	{{103, 0, 0, 191, 53, 69, 127, 28, 27, 39, 22, 194, 60, 80, 202, 45}, 7},
	{{103, 0, 0, 0, 0, 0, 79, 0, 178, 243, 91, 103, 204, 255, 86, 188}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 204, 36, 14}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 45}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 152, 182, 86, 239}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 19, 91, 55, 69, 87, 234, 149}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 1, 197, 30, 147, 26, 178, 201, 89}, 7},
	{{103, 0, 0, 0, 0, 65, 64, 81, 59, 20, 132, 173, 71, 113, 220, 29}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 109, 234, 92}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 185, 21}, 7},
	{{103, 0, 0, 0, 0, 190, 43, 205, 170, 119, 249, 167, 122, 249, 150, 50}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 230, 100, 168, 196}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 24, 215, 53, 250, 114, 45, 108}, 7},
	{{103, 0, 0, 200, 89, 253, 14, 224, 61, 105, 225, 228, 52, 68, 89, 164}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 111, 158, 21}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 7},
	{{103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 3, 102, 201}, 7},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 222, 109, 243, 172, 173}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 158, 11, 113}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 215, 150, 158, 195, 23}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 72, 166}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 48, 160, 98}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 8, 193, 113, 61, 178}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 224, 251, 12}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 37, 221, 33, 52}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 120, 62, 120}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 76, 196, 80, 255}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 29, 56, 220, 233}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 136}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 78, 36, 74}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 224, 192, 119}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 255, 116, 171, 36}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 189, 1}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 134, 82, 74}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 122, 96}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 152, 33, 149, 137, 235}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 11, 191}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 218, 68}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 43, 197}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 26, 75, 79, 163, 69}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 133, 61, 58, 116}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 176, 230}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 170}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 231, 208}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 222, 160, 251, 157}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 231}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 252, 74, 218, 164}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 19, 16, 107}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 52, 209, 188, 109, 134}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 78, 96}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 75, 47, 116, 240}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 5, 46, 123}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 79}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 235}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 95, 169}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 185, 247}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 215}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 250, 86, 200, 130, 7}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 149, 128, 54}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 206, 89, 218}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 135, 156, 210, 145, 253}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 168}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 71, 116, 92}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 116, 237, 48, 165, 203}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 213, 174, 26, 163, 115}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 21, 80, 1, 240}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 12, 71, 61}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 171, 85, 40}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 84, 161}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 152, 39, 208, 200}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 153}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 146, 198, 32, 248, 120}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 16, 35, 131, 107}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 65}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 200, 222, 26, 28}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 229}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 91, 114}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 238, 87, 144, 14}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 104, 59, 123, 185}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 228, 163, 147, 243, 38}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 21}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 200, 68, 188, 124}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 139, 107, 244, 55}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 87}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 121}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 195, 254, 76}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 117, 161, 115}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 66, 162, 55, 35, 157}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 215, 19, 230, 219, 237}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 78, 168, 180, 218}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 197, 113, 39, 130}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 237, 210, 82, 8, 159}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 1, 183}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 0}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 35, 194, 153, 146}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 202, 42, 173, 8, 151}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 178, 1, 100, 28, 232}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 35, 223, 211, 241}, 152},
	{{246, 44, 168, 200, 198, 238, 52, 196, 125, 115, 0, 0, 0, 0, 0, 152}, 152},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 38}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 44}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 8}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 216}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 61}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 136}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 112}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 52}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 124}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 27}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 42}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 215}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 50}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 255}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 250}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 6}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 140}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 83}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 44}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 181}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 201}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 219}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 145}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 57}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 139}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 235}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 17}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 118}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 8}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 129}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 87}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 85}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 16}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 108}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 43}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 94}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 171}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 198}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 67}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 140}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 166}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 34}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 170}, 248},
	{{205, 14, 186, 252, 239, 213, 59, 119, 105, 37, 140, 209, 4, 231, 0, 0}, 248},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 244, 156, 211, 116, 234}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 100}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 108, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 209, 134, 227}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 1, 31, 49, 135}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 165, 157, 211}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 11, 181, 238, 175}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 24, 173, 82, 20}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 228, 147, 160, 148}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 135, 35, 233, 79}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 166, 41, 182}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 246, 50}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 49, 166, 202, 133}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 161}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 147}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 236, 86, 162, 16}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 152, 106}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 211, 183, 163}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 84, 63, 255, 10}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 139, 196, 190}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 227, 86, 162}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 16, 154, 84}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 49}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 155}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 124}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 144}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 144}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 235, 37}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 117, 73, 43, 125}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 34}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 101, 191, 108, 159}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 239, 25}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 206, 83, 148, 38, 240}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 248}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 255}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 219, 90, 36}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 112, 136, 124, 141, 2}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 251, 23, 122, 249}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 226, 122, 212}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 62, 113}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 159}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 142, 246, 152, 105}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 210, 30, 31, 169}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 229}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 36}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 165}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 222, 228}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 187, 162}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 104, 229, 187}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 149, 69, 204}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 122, 69, 12, 252}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 5, 26, 103, 12}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 234}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 199, 233, 216, 20}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 152}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 106, 16, 244, 166}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 197, 90, 189}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 153, 24, 105}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 100, 169, 174}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 159, 15, 80, 243, 241}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 187}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 221}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 214, 89, 88, 202}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 120, 178, 71, 163}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 34}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 40, 201, 55, 169}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 173, 229}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 33}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 37, 230}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 248, 163, 74, 234}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 18}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 153, 79, 170}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 0, 0, 0, 0}, 143},
	{{70, 91, 254, 106, 94, 71, 170, 19, 158, 242, 192, 0, 128, 119, 181, 120}, 143},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 27, 184, 104, 162, 218, 54, 20}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 233, 244}, 159},
	{{250, 86, 233, 184, 0, 0, 88, 85, 45, 158, 227, 9, 134, 111, 137, 16}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 51, 157}, 159},
	{{250, 86, 233, 184, 0, 0, 120, 93, 89, 98, 186, 171, 222, 199, 105, 154}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 18, 228}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 144, 121, 22, 135, 86}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 236, 71, 178, 206, 32}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 240, 69}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 159},
	{{250, 86, 233, 184, 0, 0, 52, 54, 45, 76, 100, 152, 85, 139, 50, 212}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 205, 29, 99, 50, 225, 38, 245}, 159},
	{{250, 86, 233, 184, 0, 0, 48, 63, 43, 203, 54, 150, 141, 59, 103, 23}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 129, 25, 172, 44, 236, 83}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 96, 171, 121, 122}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 119, 64, 6, 241, 78, 69}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 234, 33, 113, 227, 199}, 159},
	{{250, 86, 233, 184, 0, 0, 153, 241, 89, 49, 189, 102, 110, 2, 48, 144}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 39, 99, 47, 189, 44, 153}, 159},
	{{250, 86, 233, 184, 0, 0, 156, 28, 28, 84, 95, 23, 40, 244, 123, 171}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 199, 91, 97, 115, 245, 166, 188, 85, 122}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 228, 57, 6, 136, 248, 67, 167, 222, 19}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 223, 223, 91, 209, 212, 182}, 159},
	{{250, 86, 233, 184, 0, 0, 46, 120, 194, 187, 200, 6, 250, 189, 202, 43}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 250}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 253, 4, 59, 0, 67, 248, 5, 146}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 47, 20, 52, 242, 246, 95, 204, 250, 173}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 198, 188}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 215, 217, 131, 24}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 104, 244, 11, 144}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 251, 57}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 94}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 254, 20}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 239, 197, 156, 185, 104, 209, 245}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 33, 45}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 198, 217, 237, 141, 105}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 194, 26, 48, 0, 159, 143, 6, 240, 92}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 156, 188, 104, 43, 163}, 159},
	{{250, 86, 233, 184, 0, 99, 185, 127, 125, 192, 75, 87, 143, 228, 71, 92}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 96}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 191, 175, 111, 77, 161, 90, 146, 3, 141}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 19}, 159},
	{{250, 86, 233, 184, 0, 167, 91, 252, 134, 239, 101, 128, 45, 216, 201, 68}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 235, 184, 107, 82, 192, 198}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 102, 130, 42, 4}, 159},
	{{250, 86, 233, 184, 56, 94, 171, 115, 22, 135, 112, 194, 236, 98, 189, 163}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 71, 88, 192, 78, 182, 20, 17, 214}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 56, 172, 23, 128, 254, 14, 224}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 66}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 90, 135}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 119, 114, 29, 98, 222, 11, 122, 83, 230}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 222, 219, 0, 112, 243, 93}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 14, 74}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 62, 184, 137, 75, 151, 199, 51}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 152, 70, 26, 50, 182, 158, 252, 15}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 199}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 119, 199, 163, 26, 15, 99, 245, 189}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 34, 58, 170, 151, 230}, 159},
	{{250, 86, 233, 184, 98, 129, 219, 240, 118, 22, 167, 154, 198, 104, 5, 86}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 244, 147, 207, 90, 61}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 221}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 163, 108, 65, 249}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 84, 86, 219, 15, 206, 120}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 97, 88, 24, 59, 37, 101, 109, 9, 52}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 72, 98, 220, 223, 226, 113, 134, 7, 220}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 150, 101, 44, 20, 205, 207}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 208, 156, 114, 52, 125, 195}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 23, 239, 200, 119}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 232, 79}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 114, 84}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 242, 38, 133, 64, 198}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 249, 187}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 29, 48, 210, 59, 94, 48, 196, 55, 103}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 232}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 139, 199, 161, 72, 147}, 159},
	{{250, 86, 233, 184, 0, 85, 228, 170, 111, 1, 174, 57, 25, 0, 227, 145}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 73, 180, 176, 173}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 98}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 12, 230, 175, 11}, 159},
	{{250, 86, 233, 184, 0, 140, 1, 75, 105, 23, 209, 5, 197, 19, 34, 239}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 57, 10, 243, 88, 140, 158, 67, 12, 125}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 32, 86, 25, 178}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 225, 205, 188, 242}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 159},
	{{250, 86, 233, 184, 0, 0, 0, 0, 0, 0, 0, 15, 255, 136, 197, 14}, 159},
	{{122, 222, 2, 0, 0, 0, 251, 40, 77, 38, 137, 10, 190, 11, 211, 250}, 11},
	{{122, 222, 2, 0, 0, 56, 59, 230, 5, 135, 216, 120, 19, 231, 69, 18}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 174, 25, 135, 155, 206, 13, 39, 248}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 66, 239, 29, 240, 15, 226, 138, 77}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 172, 228}, 11},
	{{122, 222, 2, 0, 0, 0, 199, 57, 30, 217, 74, 128, 87, 237, 4, 139}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 104, 86}, 11},
	{{122, 222, 2, 0, 125, 180, 128, 201, 193, 16, 44, 118, 34, 175, 151, 182}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 161, 155, 187, 43, 36, 170, 14, 8}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 48, 111, 210, 204, 168, 137}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 37, 96}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 213, 194, 110}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 73}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 235, 241, 16, 161, 92}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 11},
	{{122, 222, 2, 0, 0, 149, 58, 148, 250, 242, 20, 105, 118, 160, 234, 26}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 181, 44, 5, 110, 211, 221, 250, 216, 99}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 58, 78, 11}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 80}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 237, 184, 216, 229, 129, 193}, 11},
	{{122, 222, 2, 0, 197, 10, 167, 22, 111, 163, 163, 227, 185, 133, 145, 205}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 233, 87, 238, 214, 19, 150, 36, 182}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 40, 146, 145, 13, 7, 167}, 11},
	{{122, 222, 2, 0, 15, 151, 197, 101, 108, 94, 173, 30, 244, 239, 195, 160}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 69, 27}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 166, 132}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 33, 132, 17, 58, 191, 251}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 106}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 147, 171, 225, 26, 38, 243, 243}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 237, 147}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 181, 95, 48, 161, 137, 99}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 181, 235, 242, 170, 211, 246}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 132, 86, 101, 195, 3, 187, 12}, 11},
	{{122, 222, 2, 0, 0, 17, 3, 195, 126, 115, 112, 145, 102, 245, 144, 249}, 11},
	{{122, 222, 2, 0, 0, 188, 115, 68, 114, 164, 76, 110, 153, 121, 249, 236}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 113, 167, 149, 82, 183, 0, 240, 182}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 229, 63, 85, 220, 211, 232, 116, 113}, 11},
	{{122, 222, 2, 0, 0, 244, 173, 5, 152, 135, 194, 61, 32, 202, 122, 228}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 116, 93, 81, 207, 66, 113, 45, 7, 7}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 177, 224, 191, 142, 28, 242, 90}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 177, 109, 34, 12, 196, 126, 96, 204}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 193, 153, 171, 47, 239}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 180, 181, 23, 81, 226, 160}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 179, 206, 191}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 82, 71, 121}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 55, 125, 51, 226, 125, 168}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 122, 254, 50}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 107, 243, 149, 225, 215, 249}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 136, 232}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 179, 230, 124, 49, 33, 247}, 11},
	{{122, 222, 2, 0, 221, 223, 254, 38, 185, 192, 168, 21, 59, 247, 50, 33}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 121}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 6, 158, 195, 207, 138, 187}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 189, 156, 6, 144, 214, 49, 56, 180}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130}, 11},
	{{122, 222, 2, 0, 0, 0, 59, 76, 82, 37, 61, 146, 119, 253, 233, 114}, 11},
	{{122, 222, 2, 0, 0, 0, 99, 128, 211, 138, 35, 190, 229, 183, 79, 45}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 135}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 22, 211}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 39, 229, 11}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 58, 38}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{122, 222, 2, 0, 0, 0, 29, 148, 161, 128, 69, 203, 242, 178, 62, 117}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 64}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 214, 0, 177}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 110, 8, 234, 111, 172}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 16, 147, 215, 231, 131, 64, 234}, 11},
	{{122, 222, 2, 0, 0, 133, 37, 19, 14, 140, 48, 179, 7, 161, 85, 101}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 216, 184, 135, 199, 88}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 148, 143, 116, 216, 167, 190, 204, 171, 25}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 219, 162, 31, 137, 151, 202, 0, 106}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 178, 206, 245, 38, 7, 72, 58, 227}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 55, 123, 4, 185, 79, 38, 237, 132}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 143, 93, 198, 238, 9, 167}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 182, 143}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 173, 94, 167, 154, 225, 249, 53, 20}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 192}, 11},
	{{122, 222, 2, 0, 0, 109, 120, 24, 28, 154, 150, 189, 120, 246, 204, 251}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 196, 16, 94, 21, 245, 211}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 146}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 11},
	{{122, 222, 2, 0, 158, 190, 137, 242, 12, 254, 56, 56, 147, 40, 223, 159}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 127, 207, 63}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184}, 11},
	{{122, 222, 2, 0, 0, 0, 0, 178, 21, 15, 17, 126, 206, 185, 6, 133}, 11},
	{{122, 222, 2, 0, 0, 124, 192, 172, 86, 15, 184, 162, 92, 102, 4, 240}, 11},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 42, 27, 234, 162, 122}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 78, 226, 226, 164, 43, 206, 175, 65, 59}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 134, 147, 168, 187, 12, 28, 52, 22}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 144, 39, 203, 245, 19}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 164, 253, 47, 239, 29}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 73, 155}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 225}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 2, 33, 185, 235, 211}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 29, 133, 21, 91, 94, 82, 229}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 107, 240, 199, 239, 234}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 22, 237, 123, 133, 141}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 218, 152, 253, 249}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 88, 146, 198, 181, 244, 132, 97, 26, 237}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 136}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 97, 236, 174, 249}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 36, 117}, 110},
	{{27, 224, 235, 70, 0, 0, 187, 214, 101, 229, 38, 72, 165, 144, 98, 185}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 117, 239}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 110},
	{{27, 224, 235, 70, 0, 0, 202, 33, 169, 99, 40, 199, 242, 248, 194, 124}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 148, 100, 116, 233}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 68, 172, 135, 2, 218, 63}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 139, 187, 241, 58, 233, 92, 205}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 110, 47, 36, 134, 81}, 110},
	{{27, 224, 235, 70, 0, 0, 210, 234, 66, 30, 111, 65, 3, 44, 11, 88}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 233, 157, 211, 113, 153, 56, 53, 93}, 110},
	{{27, 224, 235, 70, 0, 0, 127, 93, 244, 194, 104, 63, 74, 27, 207, 237}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 192, 105, 144, 15, 8, 56, 43, 58}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 30, 121}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 202, 109}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 4, 156, 72, 74, 163, 67}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 111}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 213, 63, 74, 49, 128, 178, 86, 202}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 132, 33, 139, 83, 208, 176, 91, 121, 146}, 110},
	{{27, 224, 235, 70, 0, 0, 246, 228, 43, 82, 52, 190, 245, 64, 194, 209}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 94, 27, 231, 62, 241, 198, 41, 199}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 89, 182}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 135, 230, 241, 143, 101, 65, 94}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 250, 245, 19, 40, 84, 8, 188, 64}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 221, 1, 40, 169, 0, 158, 220, 246}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 54, 30, 37, 138}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 126}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 110},
	{{27, 224, 235, 70, 0, 251, 199, 156, 137, 34, 205, 238, 119, 27, 143, 110}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 205, 20, 189, 18, 223, 214, 255, 177}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 168}, 110},
	{{27, 224, 235, 70, 92, 173, 226, 96, 62, 142, 129, 86, 10, 100, 46, 199}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 180, 97, 92, 79, 167, 226, 90, 205}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 96, 154, 28, 7, 30, 3, 35, 179, 255}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 80, 178, 161, 31, 136, 252, 46, 137}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 183, 97, 120, 253}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 222}, 110},
	{{27, 224, 235, 70, 0, 0, 56, 50, 51, 73, 1, 238, 50, 87, 0, 245}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 16, 41}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 84, 227, 131, 87, 73, 26}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 27, 122, 197, 120, 42, 158, 108, 155}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 157, 172}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 19, 126, 175, 122, 145}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 15, 121, 195, 76, 179, 0}, 110},
	{{27, 224, 235, 70, 0, 172, 177, 233, 39, 213, 78, 74, 189, 170, 201, 0}, 110},
	{{27, 224, 235, 70, 0, 0, 225, 227, 104, 206, 34, 22, 183, 29, 200, 52}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 17, 51, 201, 138}, 110},
	{{27, 224, 235, 70, 0, 0, 208, 66, 95, 243, 246, 215, 118, 203, 227, 58}, 110},
	{{27, 224, 235, 70, 0, 0, 202, 226, 44, 234, 180, 254, 140, 160, 104, 240}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 97, 13, 207, 196, 40, 138, 209, 44, 194}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 56, 73, 81, 110, 60}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 25, 160, 214, 217, 219, 200, 75, 212}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 229, 20, 146, 23, 255}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 110},
	{{27, 224, 235, 70, 0, 0, 225, 14, 18, 185, 114, 216, 143, 8, 131, 95}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 14}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 229, 105}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 4, 146, 86, 148, 239, 100, 28, 47}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 51, 78, 148, 3}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 215, 96, 67, 39, 57}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 126, 181, 189, 200, 226, 111}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 114, 198, 191, 214, 45, 197, 215, 9, 131}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 150, 190, 217, 250, 209, 216, 62}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 182, 179}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 99, 191, 235, 78}, 110},
	{{27, 224, 235, 70, 0, 253, 7, 80, 142, 94, 96, 84, 244, 199, 243, 169}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 234, 29, 130, 65, 55, 96, 78, 201, 24}, 110},
	{{27, 224, 235, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 110},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 52, 39}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 99, 63}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 120}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 242, 127}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 218}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 132, 215}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 113, 111}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 66, 130, 241}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 54, 157}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 139, 90, 84}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 109, 8, 108}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 34}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 255, 188}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 122, 26}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 137, 99}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 28, 129, 112}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 9, 184, 243}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 33, 177, 180}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 156}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 94}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 32, 234, 249}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 210}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 161, 223}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 116, 4, 182}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 176}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 231, 90}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 21, 72, 91}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 61, 130, 206}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 12}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 43, 50, 158}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 153, 222, 209}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 141, 213, 206}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 236, 156}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 109}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 21, 196, 163}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 83, 145}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 98, 198}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 111}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 12}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 204, 161, 75}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 72, 103, 211}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 21, 149, 197}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 208}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 193, 43}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 217, 75}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 87, 175}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 141}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 245}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 51, 113, 66}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 1, 21}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 198, 72}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 240, 18}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 212, 37}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 176, 1}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 185, 194}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 207, 146}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 196, 79}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 23, 204, 127}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 28, 172}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 218, 49, 126}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 228}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 102}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 197, 7}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 151, 26, 184}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 156, 234, 19}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 80, 128}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 49, 204, 78}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 213, 37, 251}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{239, 100, 224, 3, 46, 127, 150, 251, 204, 120, 228, 64, 0, 0, 0, 0}, 181},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{144, 115, 182, 206, 146, 13, 21, 111, 37, 70, 179, 129, 173, 82, 93, 128}, 4},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 128, 100, 148, 44, 8, 10, 194}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 64, 163, 170, 53, 94, 88, 138}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 103, 10, 55, 190, 125, 7}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 12, 168}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 241, 142, 186, 108, 9}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 146, 97, 191, 203, 4, 98}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 8, 27, 13, 21, 108, 100, 129}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 95, 19, 152, 88, 69, 252, 195}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 15, 164}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 97, 171, 212, 148, 92}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 30, 25}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 124, 232}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 196}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 71, 182}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 67, 204, 211, 199, 62}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 60, 78, 244}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 179, 117, 98, 170, 233, 193, 145}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 216, 214}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 99}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 55, 133}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 141, 194, 113, 159, 157, 88, 178}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 243, 226}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 170, 201}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 166, 145}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 158, 183}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 230, 252, 229, 66, 21}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 178, 140}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 133, 12, 165, 238, 185, 158}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 202, 143, 94}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 22, 216, 57, 100, 186, 230, 175}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 178, 214, 119}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 191}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 23, 100}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 218, 92, 52}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 206, 153, 5}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 107, 67, 59}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 110, 86, 59, 167}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 46, 115, 111, 245, 49, 114}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 223, 53, 1, 67, 95}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 177}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 69, 220, 183, 206, 75}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 139, 121, 57, 17}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 244, 156}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 120}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 242, 226, 241, 101, 250, 229, 85}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 234, 55, 165, 24, 176, 134, 50}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 80, 8, 82, 231, 211, 202}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 152, 81, 150, 197, 140, 204}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 198, 131}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 142, 91, 98}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 72, 229}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 6, 100, 199, 246, 39, 218}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 38, 117}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 86, 4}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 24}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 12}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 178, 168, 140}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 66, 29, 201, 46, 186}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 27, 206, 225, 76, 91, 58}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 2, 44, 131}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 132, 81, 44, 94}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 39, 160, 166, 129, 235, 141}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 124, 184, 116, 132}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 57, 86}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 108, 247, 215, 222, 220, 68}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 34, 20, 35, 183}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 210, 235, 155, 135}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 190, 160, 106, 181, 19, 47}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 76, 73, 216, 15, 68, 166}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 234, 193, 190}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 103, 158, 171, 152}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 144, 178, 19, 169, 34}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 187, 247}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 11, 94, 209}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 46, 112, 165}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 249, 9, 115, 206, 66, 125}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 45}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 106, 154, 110, 62, 10}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 248, 58, 29, 199}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 92, 181, 147}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 236}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 59, 187, 72, 104}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 0, 0, 67}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 87, 179, 52, 9}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 0, 86, 44, 134}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 0, 0, 0, 50, 254, 133, 100}, 101},
	{{73, 190, 57, 243, 49, 51, 15, 209, 0, 216, 127, 10, 55, 69, 110, 106}, 101},
	{{18, 64, 0, 0, 0, 0, 0, 224, 138, 165, 73, 19, 105, 142, 156, 133}, 38},
	{{18, 64, 0, 0, 19, 134, 130, 210, 1, 251, 21, 18, 217, 62, 235, 136}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 124, 253, 232, 10, 138, 205, 136}, 38},
	{{18, 64, 0, 0, 0, 0, 113, 194, 173, 189, 96, 163, 44, 169, 139, 64}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 187, 197, 198}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 194, 150, 118, 37, 39, 117}, 38},
	{{18, 64, 0, 0, 0, 0, 22, 135, 27, 32, 228, 214, 3, 163, 40, 231}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 186, 37, 222, 71}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 12}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 231, 161, 132, 55, 228, 35, 16}, 38},
	{{18, 64, 212, 52, 25, 22, 224, 216, 27, 112, 254, 117, 201, 223, 140, 210}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 7, 48, 250, 155, 223, 216, 22, 129}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 74, 47}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 14, 139, 115, 243, 76, 58, 149}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 38},
	{{18, 64, 144, 122, 41, 193, 154, 32, 165, 35, 10, 157, 108, 241, 56, 79}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 94, 151, 107, 252, 191, 245, 132}, 38},
	{{18, 64, 0, 48, 195, 137, 24, 244, 26, 140, 23, 176, 199, 159, 54, 206}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 72}, 38},
	{{18, 64, 0, 0, 0, 202, 211, 53, 43, 181, 80, 5, 6, 26, 169, 119}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 11, 187, 31, 38, 211, 26, 130, 159}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 169, 227, 229, 95, 125, 219, 22, 108}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 30, 58, 166, 76, 229, 232, 216, 30}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 102, 41, 33, 92, 236, 65}, 38},
	{{18, 64, 0, 0, 156, 112, 42, 164, 137, 132, 177, 198, 206, 83, 44, 220}, 38},
	{{18, 64, 0, 101, 45, 195, 51, 33, 184, 154, 196, 12, 138, 122, 103, 5}, 38},
	{{18, 64, 0, 221, 179, 133, 211, 196, 179, 212, 4, 155, 179, 145, 102, 20}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 71, 89, 165, 240, 120, 231}, 38},
	{{18, 64, 0, 0, 19, 230, 224, 94, 193, 203, 199, 46, 199, 251, 90, 197}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 43, 38, 102, 81, 19, 227}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 164, 107, 170, 41, 130, 47, 40}, 38},
	{{18, 64, 0, 0, 0, 253, 105, 233, 222, 159, 188, 236, 63, 115, 183, 54}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 141, 181, 60}, 38},
	{{18, 64, 0, 0, 0, 215, 197, 0, 90, 147, 178, 255, 119, 146, 124, 168}, 38},
	{{18, 64, 94, 235, 165, 193, 253, 45, 173, 70, 125, 167, 115, 150, 228, 232}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 184, 190, 59, 122, 2, 111, 47, 91}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 125}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 70, 215, 119, 190, 182, 67, 128}, 38},
	{{18, 64, 0, 0, 0, 0, 188, 111, 37, 56, 147, 180, 23, 52, 107, 62}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 200, 246, 32, 135, 150, 202, 71, 120}, 38},
	{{18, 64, 0, 0, 231, 54, 143, 198, 187, 25, 215, 20, 188, 136, 147, 115}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 52, 32, 49, 255, 49, 236}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 254, 227}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 83, 255, 66, 148, 158, 223, 130, 246, 31}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 135, 103, 16, 177}, 38},
	{{18, 64, 0, 0, 141, 254, 3, 50, 212, 184, 17, 79, 121, 6, 182, 0}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 107, 204, 192, 111, 201, 148}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 229, 36, 165, 32, 113, 187, 53, 232, 35}, 38},
	{{18, 64, 0, 54, 122, 26, 28, 41, 96, 5, 128, 13, 36, 119, 34, 48}, 38},
	{{18, 64, 0, 0, 0, 0, 16, 100, 98, 222, 56, 251, 229, 17, 79, 217}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 149, 6, 160, 86, 203, 12, 44}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 149, 201, 121, 48}, 38},
	{{18, 64, 140, 135, 167, 165, 191, 205, 192, 99, 11, 227, 251, 16, 81, 89}, 38},
	{{18, 64, 61, 45, 75, 43, 19, 142, 127, 175, 30, 246, 21, 200, 175, 74}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 229, 105, 115, 196, 232, 142, 39, 126, 33}, 38},
	{{18, 64, 0, 0, 0, 0, 202, 180, 99, 223, 224, 30, 9, 165, 103, 43}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 250, 103, 25, 238, 87, 170, 85}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 85, 154, 238}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 50, 161, 248, 105, 173, 245, 51, 243, 1}, 38},
	{{18, 64, 213, 8, 1, 197, 54, 171, 117, 253, 197, 141, 180, 195, 241, 73}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 236}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 105, 106}, 38},
	{{18, 64, 0, 0, 164, 44, 38, 104, 2, 204, 118, 248, 158, 104, 138, 97}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 67, 33, 99, 76}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 251, 190, 232, 132}, 38},
	{{18, 64, 90, 218, 108, 3, 159, 186, 129, 33, 60, 62, 145, 80, 163, 208}, 38},
	{{18, 64, 0, 0, 0, 189, 223, 31, 63, 33, 53, 128, 65, 235, 51, 33}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 147, 14, 79}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 3, 141}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 67, 239, 18, 68, 131, 199, 132, 142, 222}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 99, 133, 30, 163, 160, 199, 57, 17, 204}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 92, 57}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 120, 103, 38}, 38},
	{{18, 64, 0, 11, 152, 164, 142, 124, 253, 69, 181, 253, 83, 222, 76, 225}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 54, 201, 241}, 38},
	{{18, 64, 0, 12, 152, 249, 89, 120, 160, 104, 143, 164, 236, 12, 142, 186}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 74, 191, 100, 236, 119, 50, 90, 232}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 132, 111, 123, 10, 130, 225, 72, 220}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 38},
	{{18, 64, 0, 0, 0, 207, 211, 225, 142, 24, 199, 93, 31, 108, 173, 152}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 187, 40}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 38},
	{{18, 64, 0, 42, 76, 57, 237, 234, 84, 0, 80, 182, 195, 250, 227, 156}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 206, 229, 239}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 163, 214, 123, 188, 160, 243, 40}, 38},
	{{18, 64, 0, 0, 0, 185, 131, 35, 96, 204, 174, 78, 231, 197, 94, 82}, 38},
	{{18, 64, 0, 0, 0, 0, 19, 4, 12, 22, 26, 206, 237, 22, 97, 26}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 61}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 223, 246, 40, 158, 201, 180}, 38},
	{{18, 64, 0, 0, 0, 0, 77, 21, 38, 68, 45, 81, 213, 20, 173, 186}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 79, 43, 177}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 15, 127, 59, 46, 182, 200, 10}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 162, 253, 23, 48, 124, 223, 248}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 40}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 213, 112}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 38},
	{{18, 64, 0, 0, 0, 0, 0, 0, 160, 226, 160, 80, 46, 140, 169, 113}, 38},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 4, 234, 89}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 16, 76, 172}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 95, 221, 93}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 136, 168, 118, 23, 65}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 108, 27, 157, 235, 105}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 155, 116}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 77, 251, 99}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 242, 120, 134, 41}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 214, 18, 44, 70}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 242}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 223, 76, 22, 38}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 104, 136}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 46, 166, 43, 132}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 250, 160}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 116, 229, 220, 158, 44}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 225, 77}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 98}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 192, 38, 225, 160, 12}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 21}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 120, 130, 193}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 181}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 200}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 162, 111}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 10, 100}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 207}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 46, 214, 212, 149}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 177, 70, 205}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 188, 202, 69}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 16, 153, 185, 121, 61}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 160, 79, 52, 162, 208}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 1, 224, 149}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 139, 184, 180}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 94, 166, 19, 139, 52, 34}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 12, 135}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 24, 215, 184}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 121, 10, 98, 91, 57}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 72, 91, 181}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 44}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 205}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 170, 87, 208}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 181, 166, 153, 184}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 252, 190, 10, 217, 19}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 68, 83, 149, 71, 130, 91}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 196, 168}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 32, 140, 135, 99}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 54, 198, 4}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 234, 159, 77}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 160, 186}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 41}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 38, 42, 93, 207, 27}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 219, 69}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 17, 226, 150, 237, 84}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 105, 19}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 128, 253, 206, 188}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 139, 67, 37}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 172, 152, 195, 115, 225}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 91}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 239}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 134}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 81}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 175}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 98, 228, 224, 219}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 61, 195, 168}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 250, 14, 214}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 97, 27}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 37, 115, 74, 249}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 142, 219, 60, 34, 59}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 10, 240, 115}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 185, 86, 181, 165, 24, 218}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 245}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 57}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 88}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 37, 246}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 74, 226, 181}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 56}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 38, 87, 167, 121, 211}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 86, 14, 156, 161, 174}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 157, 49, 12, 9, 188}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 166, 142, 167, 107, 102, 205}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{23, 37, 236, 177, 186, 7, 209, 135, 114, 44, 0, 0, 0, 0, 0, 0}, 57},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 177, 160, 101}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 76, 147}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 93, 47}, 142},
	{{200, 48, 0, 215, 60, 135, 167, 30, 10, 245, 60, 223, 78, 32, 184, 210}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 239, 217, 164, 45, 164, 46, 131, 147, 150}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 220, 113, 160, 134, 164, 141}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 124, 207, 220, 195}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 255, 123, 73, 152, 36, 85, 206, 217, 188}, 142},
	{{200, 48, 0, 0, 0, 0, 40, 134, 163, 196, 49, 217, 3, 121, 67, 189}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 154, 121, 109, 199, 58, 95}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 130, 107, 210, 100, 71, 149}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 240, 107, 226, 195}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 16}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 158, 26, 195, 175}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 130, 89, 57, 123, 18, 112}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 70, 53}, 142},
	{{200, 48, 0, 0, 161, 167, 46, 154, 107, 14, 227, 85, 18, 8, 31, 31}, 142},
	{{200, 48, 0, 80, 146, 39, 160, 176, 118, 98, 151, 88, 131, 108, 160, 91}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 167, 66, 2, 14, 154, 139, 92, 154, 254}, 142},
	{{200, 48, 0, 33, 237, 138, 154, 26, 224, 198, 157, 101, 190, 17, 10, 72}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 82, 29, 239}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 229, 157, 175, 252}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 136, 18, 198, 8, 24, 94}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 77, 141, 87, 46, 213, 141}, 142},
	{{200, 48, 0, 0, 0, 201, 78, 167, 126, 178, 71, 179, 75, 214, 44, 220}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{200, 48, 0, 0, 0, 9, 37, 213, 28, 34, 54, 193, 114, 182, 57, 151}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 101, 175, 129, 196, 157, 81, 85}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 129, 71, 249, 115, 155, 194, 128}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 184, 90, 60, 92, 100, 109}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 122}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 239, 171, 193, 192, 97, 248}, 142},
	{{200, 48, 0, 0, 0, 0, 153, 202, 174, 234, 21, 33, 95, 244, 100, 77}, 142},
	{{200, 48, 0, 0, 0, 98, 252, 11, 243, 187, 11, 168, 87, 170, 185, 171}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 34, 146}, 142},
	{{200, 48, 0, 0, 0, 0, 253, 145, 213, 9, 231, 103, 166, 70, 27, 110}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 86, 165, 204}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 175, 21, 139, 150, 66, 148, 167, 212, 25}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 150, 138, 7, 123}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 188}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 18, 103, 163, 127, 40, 169, 118, 116}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 77, 162, 78, 204, 53, 5, 50}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 147, 26, 77, 221, 124, 25}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 211, 8, 26, 209, 13, 114, 205}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 137, 156, 61, 157, 49, 102}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 165, 16, 30, 235, 158, 178, 45}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 107, 198, 111, 102, 137, 201}, 142},
	{{200, 48, 0, 0, 210, 57, 143, 243, 17, 209, 101, 173, 248, 196, 47, 49}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 115, 254}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{200, 48, 0, 0, 0, 0, 75, 251, 70, 234, 92, 56, 132, 184, 131, 175}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 52, 221, 111, 12, 115, 22, 216, 7, 201}, 142},
	{{200, 48, 0, 67, 222, 178, 22, 228, 100, 75, 234, 209, 130, 26, 253, 110}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 101, 218, 102, 180, 39, 139, 25, 122, 181}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 208, 59, 59, 59, 180, 116, 86, 100, 170}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 104, 221, 131, 81, 133, 77}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 193, 106, 99, 128, 94, 192, 234, 41, 35}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 47, 53}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 131, 7, 113, 80, 219, 122, 19, 231, 158}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 12, 191, 142, 2, 104, 138}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 142},
	{{200, 48, 0, 0, 255, 169, 112, 122, 27, 152, 243, 63, 203, 213, 92, 249}, 142},
	{{200, 48, 0, 0, 82, 89, 157, 167, 49, 170, 14, 243, 191, 191, 205, 190}, 142},
	{{200, 48, 0, 160, 99, 62, 207, 123, 9, 248, 143, 239, 47, 188, 245, 25}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{200, 48, 0, 0, 24, 52, 36, 172, 25, 85, 164, 11, 184, 145, 88, 89}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 53, 16, 42, 63, 233, 223}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 58, 234, 20, 150, 115, 38, 116}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 9, 219}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 218, 26}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 26, 167, 205, 17, 225, 220, 7, 121}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 170, 41, 246, 207, 247, 36, 5, 62}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 99}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 66}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 28, 170, 12, 251, 52, 31, 66, 155}, 142},
	{{200, 48, 0, 225, 241, 151, 213, 220, 113, 248, 197, 121, 145, 58, 0, 133}, 142},
	{{200, 48, 0, 52, 251, 88, 88, 31, 167, 244, 208, 123, 173, 44, 39, 31}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{200, 48, 0, 0, 0, 118, 146, 139, 130, 240, 12, 253, 89, 105, 101, 192}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 142},
	{{200, 48, 0, 0, 221, 117, 150, 221, 124, 157, 44, 87, 92, 213, 157, 101}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 218, 59, 149, 139, 150, 144, 127, 21}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 71, 144, 9, 243, 47, 195}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 131}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 89}, 142},
	{{200, 48, 0, 0, 244, 182, 253, 102, 109, 245, 31, 19, 70, 104, 209, 246}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 226, 185}, 142},
	{{200, 48, 0, 0, 20, 33, 159, 241, 109, 97, 230, 37, 23, 31, 123, 227}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 62, 203, 149, 99, 88, 167, 82, 177, 13}, 142},
	{{200, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 56}, 142},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 180, 194, 73, 99, 128, 235}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 63, 87, 53}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 111, 171, 157, 33, 35, 36, 39, 99}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 27, 183, 174}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 227, 129, 67}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 240, 154, 203, 225, 117, 100, 247, 142}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 53}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 225, 74, 6, 251, 39, 131}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 230, 38, 215, 5, 209, 226, 183, 141, 18}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 184},
	{{181, 255, 153, 0, 0, 247, 172, 197, 129, 74, 205, 2, 111, 167, 119, 26}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 185, 254, 184, 131, 252, 159}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 192, 29}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 108, 195, 113, 155, 228}, 184},
	{{181, 255, 153, 0, 0, 9, 153, 223, 173, 248, 168, 129, 44, 149, 250, 77}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 180, 7, 141, 77, 196, 24}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 219, 133, 167, 14, 139, 119, 30, 42}, 184},
	{{181, 255, 153, 0, 0, 216, 135, 143, 191, 65, 182, 92, 185, 151, 135, 129}, 184},
	{{181, 255, 153, 0, 0, 112, 38, 63, 151, 7, 176, 147, 65, 159, 154, 235}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 65, 224, 105, 200, 187, 31, 187, 99}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 205}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 101, 243}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 182, 112, 197, 20, 159, 144}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 65, 146, 2, 139, 53, 79, 69, 2, 102}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 171, 167, 203}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 8, 77}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 102, 150, 171, 148, 150, 238, 68, 58, 205}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 183}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 162, 120, 29, 216, 105}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 148, 255, 198, 129, 182, 217, 154, 54, 126}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 29, 119, 116, 69, 210, 204, 58, 141, 133}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 110, 91, 210, 67, 88, 240, 67}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 162, 145, 55, 208, 30, 223, 12, 59, 173}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 110, 221}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 192}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 149, 12, 117, 28, 185, 207}, 184},
	{{181, 255, 153, 0, 0, 154, 114, 110, 103, 43, 87, 166, 120, 161, 76, 184}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 1, 154, 161}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 163, 30}, 184},
	{{181, 255, 153, 0, 0, 0, 45, 149, 184, 107, 104, 214, 62, 144, 118, 125}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{181, 255, 153, 0, 0, 0, 239, 43, 209, 189, 77, 160, 136, 141, 0, 198}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 158, 232, 111, 156, 112, 196, 8, 13}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 118, 136, 197}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 73, 179, 43}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 96, 63, 45, 66, 189}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 74, 201, 225, 162, 239, 68, 6, 177, 217}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 58, 204, 198, 43, 162, 186, 112}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 124, 208, 194}, 184},
	{{181, 255, 153, 0, 60, 155, 171, 86, 157, 63, 209, 87, 227, 200, 180, 157}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 134, 100, 52, 229, 3, 4}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 186, 186, 203, 148, 15, 63, 214, 199}, 184},
	{{181, 255, 153, 0, 0, 243, 74, 121, 223, 46, 92, 215, 125, 223, 164, 49}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 170, 149, 210, 80, 106, 5, 37, 62}, 184},
	{{181, 255, 153, 0, 0, 168, 113, 119, 129, 75, 66, 187, 141, 188, 158, 250}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 118, 74, 128}, 184},
	{{181, 255, 153, 0, 0, 0, 187, 96, 166, 108, 53, 155, 157, 139, 19, 243}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 184},
	{{181, 255, 153, 0, 0, 16, 65, 189, 248, 154, 251, 101, 152, 19, 144, 39}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 243}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 39, 219, 74, 178, 11}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 241, 32, 22, 1, 177, 46, 96}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 199}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 38}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 243, 11, 224}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 212}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 165, 149}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 253}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 143}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 194, 129, 74, 255, 241, 60, 75}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 58, 22, 223, 167, 87}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 208}, 184},
	{{181, 255, 153, 0, 247, 140, 121, 231, 16, 34, 255, 83, 223, 69, 156, 170}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 241, 175}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 184},
	{{181, 255, 153, 0, 0, 71, 7, 201, 214, 102, 147, 66, 76, 12, 0, 134}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 147, 115, 249, 208, 164}, 184},
	{{181, 255, 153, 0, 0, 222, 207, 39, 121, 66, 111, 5, 26, 236, 133, 14}, 184},
	{{181, 255, 153, 0, 40, 50, 125, 219, 182, 245, 22, 119, 136, 39, 38, 172}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 95, 242}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 125, 144, 205}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 149, 203, 214, 255, 134, 148, 210, 218, 211}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 0, 126, 56, 216, 56, 2}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 249, 106, 51, 218, 37, 3}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 168, 37, 61, 10, 110, 141}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 101, 136, 13, 52, 156, 63, 187, 218, 197}, 184},
	{{181, 255, 153, 0, 0, 0, 240, 101, 151, 208, 128, 237, 30, 49, 250, 166}, 184},
	{{181, 255, 153, 0, 0, 0, 0, 0, 0, 0, 244, 74, 106, 137, 174, 196}, 184},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 25}, 91},
	{{135, 168, 6, 128, 0, 0, 227, 63, 73, 238, 231, 79, 109, 139, 36, 134}, 91},
	{{135, 168, 6, 128, 0, 213, 215, 254, 202, 4, 94, 82, 213, 156, 64, 199}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 227, 172}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 113, 17, 193, 60, 189, 141, 45}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 138, 248, 242, 147, 60}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 3, 103}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 155, 144, 35, 92}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 131, 83, 231, 86, 108, 48}, 91},
	{{135, 168, 6, 128, 0, 3, 60, 5, 231, 43, 154, 74, 220, 93, 24, 177}, 91},
	{{135, 168, 6, 128, 0, 99, 55, 101, 143, 41, 78, 152, 225, 226, 189, 44}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 202, 163, 67, 167, 201, 253}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 206, 41}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 47, 90, 89, 62, 83}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 196}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 100, 234, 28, 125, 29}, 91},
	{{135, 168, 6, 128, 236, 176, 150, 185, 157, 145, 197, 127, 232, 176, 181, 162}, 91},
	{{135, 168, 6, 128, 139, 67, 121, 129, 26, 221, 79, 220, 161, 115, 23, 253}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 91},
	{{135, 168, 6, 128, 39, 228, 145, 123, 93, 181, 157, 190, 29, 122, 232, 14}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 33, 110, 84, 40, 52}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 241, 62, 129, 255, 47, 166, 250, 227}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 190, 235}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 87, 61, 247, 200, 4}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 196}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 140}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 62, 128}, 91},
	{{135, 168, 6, 128, 24, 63, 83, 8, 22, 52, 223, 24, 1, 163, 211, 250}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 145}, 91},
	{{135, 168, 6, 128, 0, 255, 29, 46, 150, 176, 172, 133, 187, 92, 8, 193}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 212}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 91},
	{{135, 168, 6, 128, 0, 0, 171, 230, 186, 215, 87, 65, 138, 138, 245, 222}, 91},
	{{135, 168, 6, 128, 155, 88, 184, 62, 152, 11, 58, 52, 160, 125, 188, 99}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 34}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 129, 55, 220, 241, 220, 61, 3, 41, 47}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 28, 230, 49, 25, 114}, 91},
	{{135, 168, 6, 128, 0, 227, 182, 232, 28, 240, 194, 181, 51, 188, 36, 62}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 246, 200}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 109, 225, 63, 228, 169, 120, 158, 151, 189}, 91},
	{{135, 168, 6, 128, 0, 0, 188, 37, 215, 170, 35, 198, 200, 113, 162, 175}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 207}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 253, 6, 97, 125, 82, 11, 239, 252, 8}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{135, 168, 6, 128, 0, 0, 160, 111, 103, 164, 226, 158, 7, 41, 226, 120}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 255, 244, 123, 20, 247, 65}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 46, 9, 229, 185, 48, 118, 45, 146, 167}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 14, 235, 168, 220, 152, 212, 124, 241}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 248, 221, 3, 56, 138, 116, 203}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 113, 25, 129, 53}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 93, 67, 48, 152}, 91},
	{{135, 168, 6, 128, 0, 0, 254, 151, 176, 122, 246, 9, 163, 232, 9, 106}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 187, 2, 110, 227}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 173, 106, 254, 221, 198, 56, 102, 163}, 91},
	{{135, 168, 6, 128, 0, 94, 154, 245, 38, 34, 172, 82, 41, 28, 59, 75}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 41, 68, 143, 219, 194}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 85, 119, 128, 141, 113, 118}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 208, 167, 120, 34, 195}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 68, 79, 104, 195, 103}, 91},
	{{135, 168, 6, 128, 0, 78, 18, 68, 161, 141, 24, 123, 154, 93, 125, 149}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 209, 64, 15, 208, 81, 86, 236, 169}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 91},
	{{135, 168, 6, 128, 0, 34, 18, 67, 14, 202, 46, 159, 156, 234, 42, 97}, 91},
	{{135, 168, 6, 128, 68, 70, 208, 115, 52, 246, 252, 171, 241, 237, 52, 41}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 224}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 118, 26, 210, 62, 251, 7, 14, 114, 73}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 236, 132, 72, 204, 240, 85, 157, 49}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 134, 218, 97, 228, 143, 52, 199, 81, 149}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 171, 250, 137, 160, 8}, 91},
	{{135, 168, 6, 128, 0, 0, 61, 152, 111, 193, 121, 0, 134, 114, 251, 49}, 91},
	{{135, 168, 6, 128, 0, 0, 121, 134, 164, 155, 138, 250, 161, 184, 148, 237}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 84, 94, 144, 247, 75, 22}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 223, 26, 52, 23, 42, 80, 84, 6, 160}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 23}, 91},
	{{135, 168, 6, 128, 0, 72, 25, 46, 135, 213, 227, 223, 186, 114, 162, 24}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 246}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 144, 125, 204, 92, 230, 226, 50, 169}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 66, 31, 107, 226, 52, 112, 206, 39, 133}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 50}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 154, 222, 26, 96, 237, 83, 144, 114}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 154}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 19, 158, 5, 246, 132}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 172, 113}, 91},
	{{135, 168, 6, 128, 0, 0, 0, 94, 156, 34, 238, 139, 235, 237, 164, 242}, 91},
	{{200, 224, 33, 245, 120, 0, 0, 103, 118, 21, 84, 233, 195, 1, 161, 148}, 224},
	{{200, 224, 33, 245, 120, 0, 178, 0, 108, 241, 20, 97, 42, 48, 5, 83}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 250, 215, 5, 246, 239}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 152, 12, 202, 45, 211, 120, 66}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 29, 147, 47}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 177, 250, 132, 117, 10, 229}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 7, 125, 104, 162, 46}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 143, 63, 23, 162, 245, 57, 20, 65}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 231, 90, 131, 176, 232, 18, 28, 49, 8}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 90, 92, 214, 2, 233, 220, 196, 156}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 25, 40, 161, 93, 228}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 162, 26, 86, 243}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 152, 106, 182, 104, 43, 249, 198, 6}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 157, 11, 217, 40, 21, 119, 122}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 43, 49, 164, 157, 99, 241, 28, 105}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 59}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 8, 141, 118, 228, 49, 229, 31, 58, 148}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 98, 238, 4, 31, 243, 132, 10, 238, 95}, 224},
	{{200, 224, 33, 245, 120, 0, 242, 95, 200, 112, 127, 112, 70, 186, 49, 88}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 184, 14, 222, 195, 76, 49, 29}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 76, 61, 174, 102}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 136, 240, 73, 65, 97, 211, 211, 69, 203}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 10, 116, 47, 16, 224, 127}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 15, 28, 74}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 117, 55, 162, 191, 198, 0, 207, 75, 239}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 209, 237, 214, 105}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 244, 35, 22, 12, 161}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 31, 210, 166, 11, 85, 236, 69, 114, 15}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 4, 114, 45, 79, 93, 208, 56}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 210, 199, 57, 192}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 197, 223, 153, 22, 246}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 179}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 40, 155, 82, 41}, 224},
	{{200, 224, 33, 245, 120, 0, 33, 128, 133, 81, 66, 38, 193, 168, 26, 33}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 39}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 254, 32, 73, 31, 90, 9}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 174, 101, 227}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 215, 54, 9, 182, 102, 45}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 251, 190, 251, 176, 251, 79, 25, 60, 93}, 224},
	{{200, 224, 33, 245, 120, 0, 239, 7, 155, 8, 43, 230, 225, 46, 139, 63}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 166, 202, 116, 84, 29, 52, 96}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 163, 158, 205, 93, 42}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 168, 166, 187, 75, 197, 29, 2}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 30, 119, 208, 128}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 50, 253, 138, 58, 219, 60, 75, 235}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 39, 154, 239, 250, 139, 219, 97, 244}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 176, 156, 121, 207, 84, 48, 0, 200}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 33, 183, 22}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 112, 139, 61, 24, 148, 30, 69, 144}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 66, 83, 197, 97, 161}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 143, 112, 68, 133, 154, 43}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 37}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 188, 5, 29, 226, 96, 232, 176}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 134, 93, 108, 187, 107, 84, 1, 6, 208}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 143, 129, 195}, 224},
	{{200, 224, 33, 245, 120, 0, 233, 73, 51, 98, 173, 219, 178, 121, 52, 43}, 224},
	{{200, 224, 33, 245, 120, 0, 219, 89, 130, 39, 154, 223, 132, 171, 236, 74}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 210, 166, 243}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 20, 214, 216, 234, 129, 158, 88}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 15, 109, 52, 0}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 220, 244, 186}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{200, 224, 33, 245, 120, 0, 49, 68, 182, 193, 146, 197, 195, 51, 57, 42}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 17, 144, 177, 164}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 218}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 204, 249, 173, 175}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 36, 170, 132, 26}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 202, 235, 234, 28, 128, 52, 138, 105}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 153, 125, 228, 30, 7, 203}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 181, 183, 114, 113, 4}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 45, 30, 14}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 84, 1, 38, 143, 160}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 250, 141, 60, 6, 140, 111, 120, 7}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 109, 160, 164, 29, 204, 87, 53, 249}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 127, 87, 141, 236}, 224},
	{{200, 224, 33, 245, 120, 0, 210, 90, 201, 58, 103, 108, 161, 169, 254, 0}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 225, 47, 30, 109}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 210, 121, 128, 75, 20, 129, 11, 210, 189}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 0, 75, 21, 136}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 198, 223, 37, 168, 182, 201}, 224},
	{{200, 224, 33, 245, 120, 0, 0, 0, 0, 0, 0, 0, 166, 2, 201, 251}, 224},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 239, 137, 189, 245}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 22, 243, 126, 155, 221}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 190, 208}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 221}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 194, 87, 232, 214, 88}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 192, 14}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 49, 118, 43}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 107, 169, 154, 100, 169}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 188, 45, 235, 44, 5, 85}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 132, 38}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 110, 223, 63}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 196, 132, 235, 25, 242}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 129, 241}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 90, 248, 140, 237}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 46}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 247, 161, 199, 70}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 24, 86, 77}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 124, 143, 223, 21, 185, 186}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 100, 190, 232, 16, 128}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 168}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 59, 94, 227}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 77, 184, 45, 206}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 247, 81}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 252, 44, 56, 54, 208}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 243, 133, 214}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 243}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 17, 244, 96}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 79, 14, 132, 34, 72, 122}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 162, 46, 227, 181}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 193}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 252}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 213, 222, 193, 214, 47, 2}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 126, 93, 26, 157, 25}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 197, 157}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 85, 79, 57}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 147}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 138, 101}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 111, 227, 107}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 228}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 191, 210, 98, 173, 212}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 30, 230, 206, 71, 77}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 175, 167, 204}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 38}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 234, 119, 144, 240, 49}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 26, 242, 229}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 57}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 239}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 3, 58, 248, 52, 143}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 41, 99, 8, 227, 154}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 224, 40}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 126}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 132, 235, 6, 26, 94}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 198, 192}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 13, 65}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 102}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 34, 214, 49, 173, 54}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 160, 45, 49, 192, 96}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 222, 172, 197, 21, 219}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 182, 239, 227, 64}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 31, 199, 124}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 18}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 23}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 192, 91, 187}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 79, 137, 184, 119, 103}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 8, 136, 75, 60, 208}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 113, 154, 191, 208, 136}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 186, 72, 60, 37, 52}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 53, 80}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 153, 79, 187, 201, 254}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 32, 11, 235, 102}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 65}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 5, 71, 244, 113, 169}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 188, 216, 139}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 135}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 213, 60, 227, 227, 58}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 64, 102, 140, 111}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 17, 92, 209}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 208}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 201}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 249}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 107}, 114},
	{{70, 111, 10, 62, 200, 224, 38, 204, 14, 164, 0, 0, 0, 0, 0, 0}, 114},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 98}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 94}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 153}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 89}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 183}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 115}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 125}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 248}, 184},
	{{158, 133, 252, 18, 242, 12, 16, 60, 5, 52, 251, 179, 38, 235, 12, 0}, 184},
	{{2, 23, 116, 48, 0, 0, 0, 55, 170, 112, 64, 191, 130, 249, 222, 155}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 97, 152, 35, 67, 92, 14}, 215},
	{{2, 23, 116, 48, 0, 0, 191, 235, 175, 130, 135, 94, 111, 136, 206, 50}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 116, 15, 9, 8, 196}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 122}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 215},
	{{2, 23, 116, 48, 0, 220, 241, 145, 140, 20, 243, 114, 165, 19, 141, 117}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 54, 133, 187, 24, 141, 181, 86, 52, 229}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 130, 171, 34, 51, 11, 56, 133, 9}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 126, 55, 216, 125, 100}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 50, 14, 134, 170, 171, 21}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 97, 114, 217, 238}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 180, 83, 101, 193}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 53, 221, 25, 219, 55}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 61, 95, 53, 105, 6, 119, 195}, 215},
	{{2, 23, 116, 48, 0, 0, 198, 117, 218, 236, 24, 183, 15, 18, 166, 194}, 215},
	{{2, 23, 116, 48, 0, 16, 63, 41, 94, 223, 216, 192, 205, 174, 205, 209}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 75, 71, 180, 222, 202, 164, 27, 253}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 85, 108}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 187, 41}, 215},
	{{2, 23, 116, 48, 0, 47, 195, 242, 35, 137, 185, 203, 109, 229, 112, 105}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 176, 253, 150, 227, 151}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 14, 99, 0, 82, 28, 97}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 79, 149, 135, 98, 57, 129}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 181, 90, 253, 104, 116, 132, 155, 12, 147}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 71, 107, 78, 185, 61, 5, 124, 107, 166}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 147, 125, 62, 20, 226, 175}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 118, 207, 149, 177, 244, 195, 104}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 103, 239}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 17, 157, 194, 19}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83}, 215},
	{{2, 23, 116, 48, 0, 0, 29, 224, 116, 247, 141, 46, 199, 80, 205, 1}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 160, 255, 209, 98}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 15, 224, 213, 235, 1, 191, 208, 157}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{2, 23, 116, 48, 0, 73, 202, 121, 174, 185, 6, 134, 100, 132, 188, 238}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 122, 238, 184, 2, 30, 4, 141}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 62}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 248, 14, 126, 234}, 215},
	{{2, 23, 116, 48, 0, 180, 235, 0, 120, 167, 157, 8, 53, 149, 109, 12}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 66, 89, 197, 139, 178}, 215},
	{{2, 23, 116, 48, 0, 77, 67, 244, 95, 198, 25, 82, 173, 215, 79, 230}, 215},
	{{2, 23, 116, 48, 39, 209, 204, 231, 19, 207, 249, 16, 93, 13, 111, 12}, 215},
	{{2, 23, 116, 48, 0, 0, 107, 19, 78, 65, 152, 55, 32, 97, 21, 233}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 97, 210, 171, 86}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 20, 28}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 146, 227, 63, 218, 202, 134}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 176, 19, 164, 201, 102, 156}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 225, 130, 45, 45}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 215},
	{{2, 23, 116, 48, 0, 0, 143, 141, 182, 132, 228, 46, 187, 101, 203, 172}, 215},
	{{2, 23, 116, 48, 0, 0, 178, 114, 128, 82, 181, 118, 147, 211, 225, 241}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 12, 148, 99, 29, 96, 37, 29}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{2, 23, 116, 48, 0, 0, 213, 250, 203, 104, 40, 168, 42, 135, 18, 43}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 215},
	{{2, 23, 116, 48, 0, 0, 206, 251, 222, 135, 205, 165, 107, 113, 36, 52}, 215},
	{{2, 23, 116, 48, 0, 0, 81, 236, 152, 198, 79, 164, 144, 135, 243, 106}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15}, 215},
	{{2, 23, 116, 48, 0, 8, 229, 237, 78, 6, 174, 147, 217, 17, 215, 115}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 157, 110, 245, 62, 16, 133}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 254, 202}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 243, 133}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 93}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 11, 224, 59, 153, 105, 124, 7}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144}, 215},
	{{2, 23, 116, 48, 0, 73, 97, 254, 222, 148, 110, 42, 49, 170, 172, 97}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 222, 189, 236, 27, 136, 237, 35}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 83, 105}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 236, 240, 187, 29, 1, 27, 151, 65}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 83, 240, 160, 181, 187}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 18, 101, 198, 220, 23, 21}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 197, 25}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 82}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 178, 155, 42, 186}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 206, 81, 24, 181}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 38, 24, 111, 230, 239, 31, 125}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 141, 207, 111, 161, 127, 122, 68, 33}, 215},
	{{2, 23, 116, 48, 0, 0, 171, 219, 147, 45, 80, 73, 12, 117, 123, 184}, 215},
	{{2, 23, 116, 48, 0, 0, 65, 36, 147, 128, 40, 35, 241, 54, 113, 146}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 250, 99, 151, 124, 88, 11, 10, 115}, 215},
	{{2, 23, 116, 48, 103, 89, 173, 44, 204, 250, 6, 25, 225, 43, 73, 127}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 29}, 215},
	{{2, 23, 116, 48, 0, 82, 248, 72, 147, 48, 187, 132, 53, 159, 204, 80}, 215},
	{{2, 23, 116, 48, 0, 0, 109, 136, 147, 47, 45, 101, 17, 16, 244, 3}, 215},
	{{2, 23, 116, 48, 0, 0, 74, 18, 100, 210, 149, 234, 200, 179, 29, 9}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 134, 162, 242, 248, 241, 188, 66, 35, 239}, 215},
	{{2, 23, 116, 48, 0, 41, 148, 74, 110, 74, 22, 31, 18, 253, 176, 222}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 36}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 0, 0, 0, 0, 235, 187, 131, 15}, 215},
	{{2, 23, 116, 48, 0, 0, 0, 0, 47, 242, 235, 174, 71, 167, 42, 241}, 215},
	{{2, 23, 116, 48, 117, 3, 51, 252, 131, 8, 207, 145, 238, 242, 107, 121}, 215},
	{{2, 23, 116, 48, 0, 0, 219, 121, 171, 122, 67, 123, 26, 160, 233, 65}, 215},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{33, 25, 170, 74, 215, 134, 151, 181, 175, 232, 20, 155, 189, 242, 13, 0}, 167},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 74, 193, 218, 68}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 163, 194}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 43, 83, 127}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 105}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 231, 43}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 218, 131}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 56, 37, 62}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 27, 152, 112}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 154, 220, 18}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 33, 183, 104}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 196, 210, 17}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 43, 211}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 187, 30, 168}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 113, 77, 3}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 223, 63, 234, 73}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 179, 176, 166, 153}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 22}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 8, 108, 124, 163}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 205, 171, 244}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 34, 125, 80, 220}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 134, 73}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 207, 236, 2, 85}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 66, 95, 182}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 217, 253, 59, 200}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 4, 141, 13}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 200}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 42, 233}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 227}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 40}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 165, 61, 30, 241}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 72, 63}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 240, 49}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 112, 163, 166}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 141}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 44}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 201}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 102, 131}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 94}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 233, 247, 70, 211}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 228, 90, 62, 108}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 49, 98, 125}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 22, 144, 171, 152}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 228}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 177}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 98, 54, 224}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 247, 120, 75}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 5, 235, 4, 75}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 20, 194}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 108, 84, 52}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 34, 51}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 6, 238, 190}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 211, 69, 5}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 131, 222}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 201, 177}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 249, 230, 107}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 155, 139, 104}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 53, 191, 249, 31}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 154}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 180, 125, 151, 245}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 14, 144, 197, 253}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 245, 149}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 23, 161, 157}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 59}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 126, 38}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 8, 184, 116, 123}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 100, 168, 72}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 156, 245}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 59, 21, 164}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 75, 158, 161, 117}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 81, 105, 167}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 0}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 0, 235}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 218, 161}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 0, 0, 23, 208}, 233},
	{{160, 186, 218, 183, 167, 84, 59, 152, 13, 137, 80, 128, 155, 125, 98, 228}, 233},
	{{32, 141, 196, 0, 0, 0, 0, 0, 107, 237, 98, 205, 234, 133, 205, 102}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81}, 101},
	{{32, 141, 196, 0, 0, 0, 204, 106, 95, 54, 41, 13, 228, 108, 191, 233}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 119, 37, 6, 106, 28, 84}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 185, 203, 64, 220, 188, 80, 136}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 232}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 29, 199, 85, 110, 243, 79, 137}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 30, 50, 234, 53, 104, 137, 13}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 221, 192, 217, 87, 223, 79, 51, 253}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 184, 250, 79, 245, 183}, 101},
	{{32, 141, 196, 0, 54, 35, 60, 152, 131, 208, 143, 120, 41, 0, 22, 44}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 91, 32}, 101},
	{{32, 141, 196, 0, 0, 86, 247, 210, 230, 94, 77, 251, 188, 180, 129, 181}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 220, 152, 24, 192, 51, 204, 161, 58}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 240, 42, 32, 108, 165, 236, 253, 232, 199}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 135, 137, 16, 237, 176, 232, 181}, 101},
	{{32, 141, 196, 0, 0, 164, 45, 127, 159, 4, 99, 223, 246, 199, 43, 208}, 101},
	{{32, 141, 196, 0, 0, 0, 160, 102, 255, 30, 130, 15, 5, 177, 215, 141}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 47}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 88, 88, 43}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 229, 76}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 231, 254, 73, 89, 167}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 22, 16, 55, 111, 25}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 72, 10, 158, 240, 26, 96, 206}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 63, 149, 43, 33, 240, 154, 19, 232}, 101},
	{{32, 141, 196, 0, 0, 35, 125, 106, 80, 102, 12, 18, 15, 221, 60, 79}, 101},
	{{32, 141, 196, 0, 0, 0, 4, 104, 136, 156, 101, 250, 141, 231, 196, 185}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 222, 230, 175, 138, 202, 227, 117}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 157, 132, 58, 238, 241, 42}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 168}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 35, 15}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 227, 10, 161, 123, 227, 105, 178, 151}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 139, 11, 193, 34, 130, 92, 53}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 205, 214, 95, 172, 238, 79, 200, 179, 111}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 2, 244}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 232, 91, 12, 61, 237, 244, 168, 146}, 101},
	{{32, 141, 196, 0, 0, 0, 211, 196, 143, 233, 41, 19, 104, 20, 158, 4}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 121, 144, 94, 86, 167, 174}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 24, 200, 240, 202, 115, 95, 140, 142}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 222, 187, 234, 90, 137, 73, 91, 254, 48}, 101},
	{{32, 141, 196, 0, 0, 0, 229, 199, 33, 12, 112, 232, 127, 224, 243, 38}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{32, 141, 196, 0, 0, 0, 190, 224, 227, 13, 206, 168, 5, 43, 132, 215}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 61, 243}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 98, 23, 236, 181, 49, 202, 212, 121}, 101},
	{{32, 141, 196, 0, 0, 50, 221, 203, 148, 219, 21, 126, 170, 117, 107, 213}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 129, 220, 131, 39, 96, 79, 98}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 138}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 110, 217, 183}, 101},
	{{32, 141, 196, 0, 0, 92, 150, 179, 213, 204, 206, 142, 65, 7, 19, 110}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 111, 125, 4, 222, 248, 113}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 38, 26, 48, 193, 67, 246, 51, 20}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 224, 60, 125, 39, 136, 122}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 76, 248}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 8, 219, 164, 223, 211, 176, 241, 0, 213}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 172, 222, 59, 125, 223, 2, 142, 104}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 9}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 250, 225, 72}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 168}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 194, 233, 79, 1, 83, 131, 5}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 15, 131, 205}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 195, 91, 247, 51, 32, 136}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 24, 53, 19, 216, 219, 29, 109, 25, 18}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 56, 159, 221, 162, 107, 66, 62, 91}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 175, 133, 190, 48, 148, 161, 239, 151}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 118, 8, 148, 38, 81, 123, 30}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175}, 101},
	{{32, 141, 196, 0, 180, 223, 63, 74, 164, 168, 198, 162, 122, 189, 207, 75}, 101},
	{{32, 141, 196, 0, 0, 163, 58, 157, 82, 179, 141, 105, 191, 220, 76, 125}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 93, 4, 93, 19, 91}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 101},
	{{32, 141, 196, 0, 0, 0, 100, 8, 55, 51, 247, 218, 243, 103, 204, 34}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 141, 154, 150, 195, 202, 192, 109, 63}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 1}, 101},
	{{32, 141, 196, 0, 0, 0, 72, 224, 10, 193, 224, 198, 92, 32, 43, 116}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 165, 255, 120, 184, 89, 46, 249}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217}, 101},
	{{32, 141, 196, 0, 0, 0, 124, 162, 223, 48, 122, 68, 72, 73, 8, 144}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 68, 234}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 106, 199, 162, 101, 181}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 182, 88, 49, 211, 55, 92, 123}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 230}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 188, 36, 123, 61, 190, 248, 180}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 207, 228, 125, 46, 104}, 101},
	{{32, 141, 196, 0, 0, 0, 94, 119, 47, 43, 225, 38, 186, 247, 92, 248}, 101},
	{{32, 141, 196, 0, 0, 36, 40, 153, 10, 173, 68, 105, 201, 97, 198, 117}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 44}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 116, 5, 172, 93, 240, 116, 48, 70, 63}, 101},
	{{32, 141, 196, 0, 0, 0, 0, 66, 140, 155, 230, 147, 240, 15, 196, 107}, 101},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 133, 31, 83, 132, 96}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 142, 63, 3, 227, 242, 238}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 46, 116}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 215}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 64, 15, 46}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 51, 120, 172}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 126, 108, 93, 55, 131, 250, 209}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 25, 133, 253, 59, 23, 210, 7}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 14, 38, 36, 197, 102}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 198, 171}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 6, 199, 48, 103, 211, 78}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 74, 152}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 165}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 17, 221, 205, 103, 204, 227}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 19, 29, 208, 6, 147, 145}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 132, 30, 222, 48}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 238, 33, 80, 106, 70}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 255, 119}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 174, 133, 143, 166, 152, 81}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 254, 75, 94, 17, 57, 52}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 85, 62, 186}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 125, 170, 162, 190, 166, 158, 224}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 151, 154, 199}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 34, 135, 76}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 215, 97, 156, 178}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 204, 7, 81, 226, 81}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 1, 196, 142, 36, 97, 58, 179}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 232}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 205, 81, 161, 160}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 148, 229, 157, 92, 24}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 225, 94, 60, 106, 99, 154}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 86, 159, 179, 189}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 16, 123, 232, 127, 249}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 129, 135, 226, 164, 151}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 128, 14, 113, 61, 134}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 237}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 194, 9, 111, 189, 247}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 53, 65}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 191, 124, 175, 149}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 235, 249, 138, 55, 30, 198}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 35}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 231, 28, 18, 198, 246, 131, 100}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 52}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 248, 99, 159, 4}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 223, 63}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 133, 207}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 43, 244}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 201}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 5, 102, 73, 118}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 160, 99, 157, 84}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 197, 158, 187, 119, 36}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 250, 52, 51, 73}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 108, 32, 187, 132, 9, 137}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 114, 207, 110, 56, 193}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 86}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 156, 239}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 109}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 216, 82, 138, 78, 47}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 210, 75, 59}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 65, 232, 88, 70}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 220, 57, 94, 142}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 206, 4, 111, 77, 145}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 130}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 111, 166, 77, 94, 58}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 215, 128}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 242, 253, 59, 28}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 14}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 201, 195, 47, 197, 235}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 176}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 217, 84}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 170, 20, 211, 230, 66, 200, 110}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 70, 200, 146, 198, 72}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 172, 185, 194}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 8, 203}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 129, 39, 78, 173}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 67, 177, 163}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 203, 85}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 60}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 156, 71, 4, 158}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 105, 171, 162, 179, 237}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 159, 43}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 216}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 54, 47, 228, 98, 241, 146, 227}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 161, 30, 100, 124}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{207, 24, 202, 226, 191, 136, 78, 124, 160, 0, 0, 0, 0, 0, 181, 104}, 139},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 4}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 192, 249, 239}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 226, 45}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 194}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 124}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 49, 137, 83, 165}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 76, 244, 39, 41}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 69}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 56, 30, 46}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 84}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 78, 76, 186}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 173}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 183, 10, 141, 172}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 250, 32, 231, 88}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 162, 78, 25}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 113}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 101}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 11, 112, 144, 107, 205}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 201}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 165}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 129, 13}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 48, 48, 235, 238}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 134, 149}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 121, 0, 255, 166}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 179, 147}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 227, 104, 23}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 220, 181, 82, 234}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 6, 177, 253, 174, 247}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 108}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 230, 197}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 250, 77}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 198, 245}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 220, 187, 7, 6}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 79}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 41, 56, 180}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 168, 187, 249, 254, 3}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 110, 109, 53, 239}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 230, 135, 248, 142, 38}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 98, 201, 228, 132}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 250, 43}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 155, 160, 24, 214, 146}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 135, 105}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 102, 201, 58, 1}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 100, 93, 37}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 30, 156, 130}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 236, 179, 20, 155}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 205, 21}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 224, 122, 153, 151}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 202}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 227}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 69, 244}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 106, 226, 254}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 101, 211}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 3, 184, 245, 223}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 252, 228, 48, 116}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 44, 71, 53, 39, 163, 92}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 222}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 248, 124, 208, 72}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 149}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 93, 23}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 110, 29, 60}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 108, 144, 215, 120}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 90, 133}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 111, 50, 52, 34, 15}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 14, 215, 194, 151, 157}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 0}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 0, 41}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 245, 215, 185, 156, 216}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 185, 192, 1}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 11, 199}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 211, 78, 109}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 33, 235, 65, 122}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 238, 29}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 70, 87, 242, 96, 188}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 0, 0, 151, 133}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 73, 69, 80, 78}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 0, 250, 34, 205, 74}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 220, 67, 220, 97, 225, 209}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 44, 54, 77, 216, 153}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 53, 216, 171, 177, 198}, 32},
	{{210, 173, 172, 27, 197, 57, 114, 146, 169, 32, 0, 58, 38, 195, 44, 172}, 32},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 207, 163, 232, 144, 118}, 57},
	{{95, 113, 12, 123, 0, 0, 219, 26, 214, 53, 168, 170, 157, 244, 24, 77}, 57},
	{{95, 113, 12, 123, 0, 74, 177, 72, 87, 104, 179, 254, 242, 202, 102, 179}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 135, 192}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 57},
	{{95, 113, 12, 123, 0, 0, 78, 146, 135, 234, 40, 183, 33, 158, 41, 139}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 58, 146}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 143, 41, 191, 189, 79, 98, 205, 38, 19}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 143, 0, 82, 187, 118, 135, 2, 3, 209}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 157, 204, 229, 239, 24}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 163, 152, 222, 20}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 48, 56, 11, 135, 200, 89, 81}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 255, 71, 254, 179}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 217, 152, 17, 23, 237}, 57},
	{{95, 113, 12, 123, 0, 7, 83, 175, 78, 107, 183, 184, 128, 17, 25, 53}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 203, 88, 128, 110, 53}, 57},
	{{95, 113, 12, 123, 0, 0, 4, 63, 248, 36, 138, 221, 179, 11, 189, 97}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 211, 212, 205, 110, 155, 248, 166, 157, 252}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 202, 35, 132, 192, 61}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 167, 9, 229, 56, 166, 70, 129, 253, 66}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 65, 150, 143, 149, 31, 208, 3, 236, 157}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 140, 91, 113, 167, 93, 159}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 215, 182, 195, 198, 58, 108, 181}, 57},
	{{95, 113, 12, 123, 0, 0, 157, 87, 109, 240, 120, 221, 30, 134, 210, 44}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 11, 67, 126, 136, 206, 53, 199}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 46, 154, 38, 204, 131, 71, 215}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 55, 179, 110, 238, 228, 20, 97, 23}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 47, 187, 79, 49, 22, 42}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 34, 210, 239, 82, 217, 130, 91}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 167, 240, 59, 197, 166}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 66, 55, 96, 224, 190, 94, 165}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 205, 85, 244, 198, 192, 51, 68, 20, 232}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 202}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 3, 68, 3, 49, 151, 13, 165}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 190, 223, 147, 21, 255, 145, 149, 114}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 101, 20, 81, 192}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 71, 9, 16, 237, 31, 198, 168, 136, 216}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 222, 170, 123, 7, 64, 8, 43, 29}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 88, 45, 12, 193, 203, 54, 181}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 135, 33, 174, 192, 204, 103, 223}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 229}, 57},
	{{95, 113, 12, 123, 0, 62, 157, 164, 234, 153, 90, 241, 131, 135, 29, 134}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 176, 60, 187, 122, 167, 91, 46, 242, 136}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 136, 92, 21, 176}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 202, 174, 43, 63, 14, 204}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 29}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 57},
	{{95, 113, 12, 123, 0, 46, 33, 63, 64, 170, 68, 245, 104, 70, 163, 130}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 69, 134, 68, 191, 138}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 142, 221}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 83, 89}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 81, 222, 56, 37, 159, 156, 14, 3}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 210, 170}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 154, 249, 248, 50, 202}, 57},
	{{95, 113, 12, 123, 0, 50, 198, 129, 238, 14, 61, 68, 98, 236, 38, 60}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 87, 182, 106, 98}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 79, 91}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 163}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 174, 9}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 61, 221, 248, 156, 60}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 252, 194, 235, 19, 240}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 235, 209, 6, 243, 251}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 159, 178, 181, 36, 172, 168}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 226, 131, 16, 124, 210}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 122, 104, 134, 98, 250, 193, 168, 193, 89}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 91, 110}, 57},
	{{95, 113, 12, 123, 0, 187, 107, 237, 221, 172, 162, 55, 72, 253, 195, 38}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 140, 32, 2, 57, 90, 130, 170, 211, 36}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 79, 218}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 143, 67, 221, 122, 121, 233, 1, 25}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 96, 137, 93, 172, 124, 57, 176, 53}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 189, 97, 127, 129, 41, 102, 159}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 192, 137, 115, 158, 136, 30, 198, 156}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 255, 137, 84, 3}, 57},
	{{95, 113, 12, 123, 0, 0, 228, 46, 208, 49, 120, 154, 132, 169, 82, 62}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 228, 64, 21, 62, 198}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 7, 243, 71, 4, 167, 104, 202}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 134, 53, 22, 221, 146, 2, 216, 72}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 91, 75, 215, 175, 169, 216, 160, 173}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 232}, 57},
	{{95, 113, 12, 123, 0, 188, 91, 40, 233, 69, 207, 23, 152, 153, 68, 105}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 78, 51, 14, 204, 181, 42, 104, 136}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 127}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 187, 23, 154, 17, 246}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 112, 234, 200, 38, 29}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{95, 113, 12, 123, 0, 173, 86, 199, 175, 252, 89, 125, 142, 110, 238, 129}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 214, 74, 180, 166, 78}, 57},
	{{95, 113, 12, 123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99}, 57},
	{{95, 113, 12, 123, 0, 100, 244, 226, 212, 37, 110, 84, 240, 110, 59, 193}, 57},
	{{95, 113, 12, 123, 0, 223, 243, 193, 254, 126, 255, 214, 49, 46, 145, 61}, 57},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 142}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 223, 135, 141}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 115}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 155, 24, 170, 14}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 26, 218, 148, 87}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 124, 73, 15}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 10, 0, 206}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 142, 232, 203}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 103}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 232}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 216}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 56, 251}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 227, 254}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 85, 244, 91}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 42}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 179, 240}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 125, 108}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 52, 44, 83}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 22, 66}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 80, 161, 49, 139}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 49}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 65, 137}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 244, 140, 34, 219}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 218, 43, 84}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 136, 168}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 27, 84}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 240, 237, 54, 151}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 3, 60, 175, 27}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 199, 208, 139, 202}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 163, 201}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 14, 112}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 23}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 65}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 13, 25}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 217, 69}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 127, 211, 245, 214}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 211, 220}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 200}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 44}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 24}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 195}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 84}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 202, 154, 53}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 209, 47}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 95, 113, 69}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 233, 5, 186}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 245, 171}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 230}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 230, 71, 218, 33}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 67}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 170, 43, 140, 139}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 196, 189, 60}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 212, 2, 48}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 192, 18}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 61, 118, 24, 87}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 248}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 177, 179, 153}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 107, 185}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 192}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 192}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 203, 20, 218}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 237, 28, 229, 216}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 214, 194, 226, 103}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 145, 144}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 114, 141, 35}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 35}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 22, 48, 239}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 129, 69, 34}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 197, 133, 94}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 116, 141}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 143, 115}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 72}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 195, 239, 106, 98}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 100}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 0}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 44, 158, 17, 175}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 188, 71, 132}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 26, 176}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 0, 46}, 151},
	{{129, 108, 186, 28, 19, 229, 96, 134, 199, 254, 199, 64, 0, 0, 185, 51}, 151},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 179, 17, 210, 189, 192, 210, 197}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 176, 105, 246, 48, 92, 80, 53, 111, 233}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 46, 153, 34}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 208, 104}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 91, 15}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 191, 229}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 213, 102, 136, 124, 13, 232}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 169, 47, 147}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 235, 100, 31, 231, 84}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 222, 92, 35, 198, 131, 177, 166, 228}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 86, 88}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 24, 220, 24}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 55, 238, 113, 147, 80, 125}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 1, 80}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 149, 239, 20, 103, 168, 129, 153}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 83, 222, 6, 143, 252, 193, 111, 23}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 91, 135, 4, 165}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 164, 160, 210, 23, 184, 6, 138}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 73, 97, 140, 8, 0}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 133, 51, 73, 98, 99, 57, 238}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 120, 141, 148}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 64, 36, 117, 182, 87, 119, 162, 56, 88}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 125, 70, 96, 150, 152, 129, 85, 201, 182}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 183, 179, 149, 211, 125, 5, 132, 36}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 244, 251, 197, 32, 239}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 206, 178, 47, 163, 99, 196, 126, 171, 114}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 162, 105, 177, 176, 69, 23, 127}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 244, 169, 158}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 77, 55, 8, 156, 216, 44, 48, 85}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 172, 46}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 216, 59, 18, 26, 138}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 228, 207, 90, 13, 220, 57, 7, 15}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 88, 54, 192, 85, 160, 92, 22, 235}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 94, 136, 43, 221, 233, 57}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 2, 69, 140, 191, 154, 3, 232}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 107, 120, 162, 130, 211, 85, 201, 199}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 249, 17, 215, 122, 85, 120, 34, 216, 136}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 172, 68, 224}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 199, 248}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 35, 207, 85, 5, 168, 62, 157, 65, 149}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 58, 132, 120, 145, 44, 8, 241}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 68, 11}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 125, 208, 228}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 223, 74, 180, 144, 18, 173, 151}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 65, 206, 164, 0, 45}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 91, 193, 253, 98, 47, 247}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 12, 171, 92, 165, 239, 15, 51, 55}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 130, 145, 242, 190, 127, 72, 42, 85}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 103, 178, 77, 137, 167, 223, 136}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 45, 247, 231, 156, 153}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 175, 126, 179, 220, 190, 74, 76, 149}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 135, 77, 243, 150, 23, 144, 128, 194}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 122, 28, 51, 31, 4, 232, 97}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 110, 179, 109, 79, 224, 152}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 162, 188, 65, 244, 125, 24}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 6, 104, 226, 45, 108, 98, 89}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 27, 103}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 29, 160, 22}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 23, 23, 45, 210}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 170, 37, 193, 215}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 210, 198, 109, 23}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 243, 17, 133, 61, 5, 56, 162, 61}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 85, 150, 27}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 114, 83, 209, 142, 216}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 229, 12, 11, 126}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 101, 104}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 153, 123, 61, 74, 157, 155, 227, 167, 173}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 76, 184, 145}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 101, 144, 65, 47, 10, 124, 237}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 203, 149, 19, 244, 110, 61, 200, 116, 77}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 47, 190, 113, 238, 211}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 159, 28, 20, 145, 52, 135, 197, 32}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 158, 54, 63, 106}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 70, 25, 63, 29, 115, 206, 16, 77, 160}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 230, 188, 139, 80, 237, 224}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 83, 19, 33, 56, 233, 249, 22, 19}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 109, 73, 195, 105, 76, 186, 138}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 113, 188, 173, 192, 74, 146, 154, 138, 184}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 242, 184, 2}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 172, 28, 160}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 220, 99, 149, 22}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 51, 255}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 13, 2, 198, 178, 238, 137, 57, 171, 196}, 0},
	{{103, 226, 38, 123, 35, 199, 0, 0, 0, 0, 0, 234, 38, 152, 166, 27}, 0},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 154, 165, 55, 120, 224}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 61, 212, 162, 20}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 43, 0, 41}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 38, 169, 24}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 129, 160, 111, 77, 255, 121}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 105, 77, 210, 206, 213, 180, 40}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 87, 18, 103, 115, 8, 67, 247}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 95, 171}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 86, 115, 41, 50, 201, 48, 190, 161}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 146, 231, 137, 103}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 130}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 223, 82}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 208, 171, 76, 175, 151, 80, 47}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 221, 79}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 76, 248, 152, 100}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 86}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 94, 235, 203, 5, 80, 4, 104}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 31, 160, 32, 21, 253, 176}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 35, 227, 240, 21}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 78, 239, 95, 179, 251, 197}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 248, 152, 200, 220, 182}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 158, 27, 79, 230, 204}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 252, 250, 42, 13}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 255, 67, 95}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 101, 231, 151, 51, 32}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 105, 184}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 247, 247, 252, 196, 73}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 238, 9, 225, 132}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 184, 251, 193, 70, 137}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 167, 111, 42, 123, 255, 151, 145}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 58, 140, 139}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 11, 88, 116, 46, 112, 105, 221}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 45, 68, 58, 88, 19, 171}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 16, 216, 154, 110, 46}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 207, 4, 86, 36}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 233, 242, 235, 52, 38, 145}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 124}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 100, 26, 17, 15}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 184, 99}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 245}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 67, 104, 50, 252}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 213, 131}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 6, 79, 93, 30, 27, 137}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 109, 123, 27, 204, 196, 241, 241}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 96, 49, 75, 147, 40, 207, 55}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 228}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 91, 148, 82}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 137}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 35, 166, 190}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 225, 71, 97, 154, 94}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 195, 227, 30, 224}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 27, 37, 14, 235, 9, 157}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 73, 96, 42}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 164}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 211}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 92, 108, 83, 220, 115, 148, 105}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 87, 131, 177, 234, 10}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 184, 243, 254, 50}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 18}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 184, 188, 217, 15}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 19}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 147, 102, 191, 57, 46}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 238, 206, 75, 121, 5}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 30, 77, 245, 197, 213, 203, 58}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 236}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 184, 78}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 4, 51}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 26}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 155, 123, 222, 182, 183, 199, 111}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 208, 187, 40, 36}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 159, 228}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 209, 123, 238, 59, 226}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 124}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 59, 220, 19, 48}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 42, 65, 152, 65, 242, 118}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 45, 238, 194, 55}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 120, 18, 207}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 114, 175}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 149, 130, 18, 130, 231}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 198, 250, 173, 205, 57, 125, 14}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 155, 135, 89}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 110, 140, 133, 79, 194}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 3, 86}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 16, 71}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{41, 117, 43, 35, 208, 115, 73, 64, 0, 0, 27, 1, 113, 144, 108, 211}, 227},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 113}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 51}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 52}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 166}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 9}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 59}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 124}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 55}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 187}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 8}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 241}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 103}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 114}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 200}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 175}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 204}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 118}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{42, 220, 61, 34, 199, 183, 42, 16, 223, 135, 0, 135, 213, 150, 100, 0}, 124},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 20}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 169, 6}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 177}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 208, 201}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 73}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 23}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 48}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 255, 91}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 219}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 88}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 33}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 49, 66}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 95, 84}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 154, 11}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 88}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 176}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 74, 254}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 196}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 165}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 218}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 125, 132}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 60, 54}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 236}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 15, 153}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 215}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 216}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 84}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 231}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 52}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 138}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 140}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 75, 89}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 131, 232}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 103}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 168, 185}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 50}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 245, 212}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 144}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 227, 31}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 130}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 156, 91}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 159}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 173, 116}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 120}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 199}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 44, 252}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 213, 44}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 124}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 149, 39}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 56}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 159}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 235, 128}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 225, 2}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 158}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 140}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 178, 70}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 41, 113}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 214, 40}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 250, 146}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 140, 18}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 175, 26}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 0, 0}, 228},
	{{165, 227, 96, 243, 112, 171, 117, 106, 50, 37, 82, 60, 80, 0, 72, 197}, 228},
	{{158, 60, 111, 96, 0, 244, 121, 162, 211, 215, 70, 177, 197, 142, 187, 92}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 127, 156}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 69, 218, 14, 226, 60, 121}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 120, 125, 9, 134, 135, 76}, 64},
	{{158, 60, 111, 96, 0, 0, 241, 238, 246, 97, 20, 57, 124, 6, 171, 7}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 27, 55}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 228}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 171, 16, 228, 117, 113, 5}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 112, 17, 97, 181, 34, 18, 75, 30, 130}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 96}, 64},
	{{158, 60, 111, 96, 0, 0, 216, 53, 176, 78, 208, 241, 55, 1, 227, 114}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 146}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 121, 215, 71, 168}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 235, 5, 67, 184, 195, 181, 182, 234, 0}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 206, 109, 64, 83}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 237}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 132, 173, 169, 134, 165}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 143, 58}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 93, 96}, 64},
	{{158, 60, 111, 96, 0, 145, 157, 110, 64, 247, 220, 178, 93, 220, 126, 205}, 64},
	{{158, 60, 111, 96, 0, 13, 62, 192, 165, 177, 9, 169, 151, 78, 187, 114}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 130, 81}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 186, 155, 167, 15, 189, 11, 117, 207}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 92}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 64},
	{{158, 60, 111, 96, 0, 187, 127, 113, 227, 98, 95, 116, 11, 33, 207, 100}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 250, 70, 168, 203, 131, 77, 249, 131}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 184}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 40, 101, 100, 39, 210, 219, 15}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 115, 161, 73, 109, 170, 7, 55, 212, 231}, 64},
	{{158, 60, 111, 96, 12, 173, 247, 119, 240, 106, 73, 1, 182, 83, 134, 192}, 64},
	{{158, 60, 111, 96, 0, 0, 216, 7, 232, 239, 63, 32, 231, 135, 119, 131}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 36, 168, 248, 191, 11, 82}, 64},
	{{158, 60, 111, 96, 158, 171, 78, 18, 199, 235, 206, 112, 221, 252, 120, 105}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 181, 121, 229, 102, 107, 252, 33, 180}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 211}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 154, 118}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 248, 199, 250, 236, 233, 110, 112, 76}, 64},
	{{158, 60, 111, 96, 204, 217, 120, 192, 2, 24, 234, 194, 91, 244, 43, 162}, 64},
	{{158, 60, 111, 96, 121, 207, 154, 219, 176, 110, 77, 33, 34, 250, 137, 155}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 163}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 199}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 144, 205, 32, 164, 219, 137, 239}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 62, 5, 213, 13, 96, 230, 251}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 240, 146, 110, 37, 249, 161, 134}, 64},
	{{158, 60, 111, 96, 187, 188, 111, 17, 125, 52, 76, 167, 144, 124, 250, 114}, 64},
	{{158, 60, 111, 96, 0, 54, 206, 201, 151, 212, 167, 33, 51, 32, 14, 227}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 183, 126, 151, 247, 35, 174, 81, 138, 176}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 228, 244, 139, 197, 47, 242, 119, 209, 220}, 64},
	{{158, 60, 111, 96, 36, 253, 165, 22, 105, 41, 129, 219, 49, 72, 154, 175}, 64},
	{{158, 60, 111, 96, 188, 98, 237, 194, 128, 207, 103, 59, 159, 65, 193, 54}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 203, 3, 193, 157, 48, 70, 48, 37}, 64},
	{{158, 60, 111, 96, 128, 114, 224, 84, 230, 9, 25, 122, 119, 219, 200, 88}, 64},
	{{158, 60, 111, 96, 0, 0, 113, 1, 137, 148, 174, 214, 25, 105, 35, 25}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 24, 76}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 5, 128}, 64},
	{{158, 60, 111, 96, 0, 0, 230, 83, 238, 174, 223, 185, 71, 34, 73, 147}, 64},
	{{158, 60, 111, 96, 0, 0, 241, 90, 104, 17, 156, 105, 22, 20, 42, 57}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 52, 12, 46, 119, 115}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 109, 166, 46, 144, 163, 12, 74}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 68}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 165, 122, 151, 207, 167, 212, 134}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 23, 51, 53, 230, 96, 24, 245, 49}, 64},
	{{158, 60, 111, 96, 0, 0, 170, 170, 91, 73, 128, 234, 63, 150, 100, 170}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 191, 221}, 64},
	{{158, 60, 111, 96, 0, 41, 79, 182, 187, 115, 85, 158, 121, 86, 90, 69}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 64},
	{{158, 60, 111, 96, 0, 27, 136, 124, 220, 250, 36, 140, 0, 6, 111, 12}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 110, 163, 165, 57, 5}, 64},
	{{158, 60, 111, 96, 0, 73, 114, 77, 214, 61, 106, 196, 78, 220, 139, 120}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 192, 201, 215, 186}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 234, 142, 124, 25, 217, 111, 202, 192, 75}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 186, 226, 164, 196, 71, 10}, 64},
	{{158, 60, 111, 96, 0, 0, 142, 49, 47, 160, 188, 59, 158, 235, 163, 113}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 107}, 64},
	{{158, 60, 111, 96, 0, 39, 37, 56, 158, 215, 43, 161, 216, 71, 127, 154}, 64},
	{{158, 60, 111, 96, 104, 77, 77, 138, 210, 38, 108, 94, 27, 140, 253, 72}, 64},
	{{158, 60, 111, 96, 0, 0, 173, 15, 56, 13, 107, 87, 131, 192, 245, 241}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 183, 92, 158, 213, 238, 176, 220, 131}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 180, 89, 194, 212}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 91, 246, 230, 235, 24, 218, 214, 64, 107}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 50, 23, 148, 122, 202}, 64},
	{{158, 60, 111, 96, 18, 117, 198, 223, 52, 150, 68, 34, 157, 146, 133, 25}, 64},
	{{158, 60, 111, 96, 0, 0, 86, 44, 150, 68, 4, 255, 86, 96, 247, 98}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 175, 6, 110, 146, 56, 132, 235}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 28, 213, 132, 162, 235, 133, 3, 241, 12}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 63, 94, 68, 187}, 64},
	{{158, 60, 111, 96, 46, 212, 18, 33, 39, 152, 140, 79, 146, 197, 156, 195}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 129, 158, 178, 163, 20, 39, 144, 221}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 23, 108, 144, 208}, 64},
	{{158, 60, 111, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 220}, 64},
	{{124, 108, 88, 0, 0, 245, 5, 216, 236, 63, 183, 102, 150, 188, 103, 162}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 89, 179, 160, 197, 253, 206, 186, 21, 242}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 115}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 243, 181, 240, 201, 186, 239, 19}, 179},
	{{124, 108, 88, 0, 0, 0, 115, 27, 216, 27, 189, 147, 22, 67, 247, 121}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 74, 213, 91, 40, 88, 180}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{124, 108, 88, 0, 0, 0, 11, 126, 244, 231, 131, 143, 114, 83, 17, 33}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 236}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 133, 24, 48, 179, 15, 134, 161, 29}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 218, 41, 48}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 100, 229, 234, 72, 186, 79, 69, 225}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 171, 189, 195, 33, 1, 90, 82, 116}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{124, 108, 88, 0, 53, 178, 196, 180, 23, 165, 14, 116, 174, 142, 47, 108}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 40, 42, 244, 122, 17, 121}, 179},
	{{124, 108, 88, 0, 0, 118, 89, 159, 218, 150, 141, 175, 147, 150, 238, 31}, 179},
	{{124, 108, 88, 0, 0, 91, 38, 112, 83, 57, 38, 239, 35, 127, 199, 18}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 42, 176, 249, 25, 66, 218, 237, 153}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 47, 194, 181, 1, 166, 155, 65}, 179},
	{{124, 108, 88, 0, 0, 38, 171, 46, 184, 34, 5, 80, 184, 107, 54, 88}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 124}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 14, 3, 242, 133, 225, 149, 211}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 98, 6}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 179},
	{{124, 108, 88, 0, 0, 0, 57, 147, 239, 29, 104, 203, 212, 37, 70, 121}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 118, 64, 5}, 179},
	{{124, 108, 88, 0, 0, 0, 223, 44, 247, 113, 175, 2, 187, 208, 12, 147}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 54, 203, 40}, 179},
	{{124, 108, 88, 0, 0, 168, 203, 17, 242, 218, 130, 109, 244, 28, 105, 33}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 141}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 179},
	{{124, 108, 88, 0, 23, 98, 117, 155, 22, 131, 153, 248, 161, 22, 14, 18}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 165, 159}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 179},
	{{124, 108, 88, 0, 0, 59, 130, 161, 205, 206, 131, 67, 198, 57, 230, 248}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 79, 236, 185}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 143, 74, 242, 180, 120}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 6, 107, 152, 197, 0, 80, 120, 17}, 179},
	{{124, 108, 88, 0, 0, 0, 89, 170, 190, 201, 253, 137, 194, 141, 242, 62}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 13, 241, 253, 109, 14, 34}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 122, 172, 117, 44, 72, 161}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 94}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 252, 176, 219, 41, 46}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 201, 31}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 209}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 226, 17, 195, 34, 5, 218, 77, 60}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 174, 24, 128, 226, 52, 57, 151, 108}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 83}, 179},
	{{124, 108, 88, 0, 20, 135, 205, 22, 25, 241, 22, 158, 206, 3, 51, 175}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 223, 132, 79, 131, 209, 98, 207, 189}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 15, 182, 123, 159, 97, 132, 25}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 79, 247, 35, 188, 111, 195}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 150, 191, 69}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 190, 95, 68, 212, 138, 113, 214, 229, 40}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 119, 233, 209, 163, 169, 17}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 135, 6}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237}, 179},
	{{124, 108, 88, 0, 0, 0, 122, 218, 220, 209, 91, 221, 8, 42, 108, 234}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{124, 108, 88, 0, 0, 0, 21, 78, 145, 21, 207, 167, 190, 39, 89, 81}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 190, 62, 165, 95, 27, 164, 162, 214}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 85, 217}, 179},
	{{124, 108, 88, 0, 0, 32, 80, 161, 87, 211, 75, 250, 64, 230, 136, 234}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 135, 195, 57, 95, 134}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 19, 177, 106, 7, 151}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 157, 104, 97, 108, 19}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 226, 189, 64, 153, 200, 40, 230}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 126}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 247, 20, 101, 214, 62, 198, 107, 164, 163}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 246, 129, 110, 175, 51}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 198, 30, 210, 156, 13, 61, 62, 190}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 176, 58, 1, 195, 11}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 172, 6, 69, 91, 145, 1, 72, 138}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 77, 24, 166, 212, 240, 58}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 44, 155, 201, 101, 22}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 213}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123}, 179},
	{{124, 108, 88, 0, 0, 0, 13, 31, 81, 250, 247, 252, 71, 89, 113, 23}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 135, 92, 175}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 4, 95, 82}, 179},
	{{124, 108, 88, 0, 0, 131, 243, 91, 43, 153, 2, 252, 125, 16, 0, 168}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 97, 126, 170, 89, 5, 212, 40, 227, 27}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 14, 39}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 75, 160}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 179},
	{{124, 108, 88, 0, 119, 125, 30, 71, 204, 255, 144, 216, 147, 101, 178, 198}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 26, 76, 178, 184, 192, 91, 117, 179}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 61, 96}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 72}, 179},
	{{124, 108, 88, 0, 0, 0, 0, 137, 170, 66, 98, 124, 247, 251, 64, 113}, 179},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 91, 222, 111, 81, 6, 132}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 225, 124, 236}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 36, 113, 95, 178, 212, 20}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 69}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 30}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 170, 105}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 84, 215}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 101}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 241, 189, 144, 142, 181}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 220, 122, 57, 187, 139}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 3, 178, 98, 53, 69, 248}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 52, 28, 173}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 254, 154, 224, 247, 205, 110}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 86, 254, 31}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 245}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 117, 192, 150, 183, 247, 215}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 155, 233, 201, 47, 115, 175}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 208, 245, 149}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 140, 53, 214, 170, 37, 113}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 163, 2, 154}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 105, 36, 220, 239, 252}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 129, 110, 20, 24, 73, 240}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 44, 224, 213, 245, 186, 104}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 143}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 67, 193, 119, 40, 95}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 162, 17, 84, 203, 174}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 149}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 145, 240}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 208, 0, 93, 114, 201, 249}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 185, 11, 102}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 224, 75, 141, 19, 50}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 117, 187, 16, 1, 105, 227}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 242}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 100, 66, 16, 102, 222}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 204}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 227, 110}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 105, 100, 23, 132}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 91}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 85, 68, 221, 242, 84}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 24, 46, 114, 104, 54}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 124, 41, 59, 221, 250, 131}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 4, 90, 29, 219}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 169, 115, 3, 123}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 209, 237, 108, 99}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 140, 215, 146, 31}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 158}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 189, 194}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 59, 38}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 212}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 1, 3, 111}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 235}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 161, 12}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 7, 11, 232, 136, 245}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 6, 29, 201, 49, 15, 49}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 158, 60, 33, 151, 160}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 79, 171, 25, 183, 165, 245}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 20, 250, 166, 151, 5}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 126, 56}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 130, 20, 125, 234, 74}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 9, 61, 157, 126, 14}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 208, 177, 238, 121}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 193}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 142}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 52, 244, 238, 171, 176, 70}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 80}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 240, 230}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 55, 192, 105, 186, 90, 46, 167}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 36, 39, 174}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 221, 212, 37}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 141, 87}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 33, 11, 141, 51}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 121, 64, 211, 247, 107}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 237, 117, 73, 77, 222}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 80, 47, 153, 106}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 46}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 158, 236, 242, 179}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 38}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 18, 29, 82, 9}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 17, 77}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 229, 163}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 179, 43, 26, 90, 146}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 157, 212, 142, 75, 85, 106}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 39, 140, 85}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 115, 80, 207, 66, 83}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 83}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 67, 230, 112, 14}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 77, 90, 28, 20}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 228, 186, 47, 180, 100, 161}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 21, 106, 220}, 107},
	{{232, 68, 132, 159, 156, 103, 95, 190, 76, 0, 0, 0, 0, 0, 21, 26}, 107},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 119, 32}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 76}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 135}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 186, 98}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 223, 211}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 137}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 224, 80}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 148}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 16, 182}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 2}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 129}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 61}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 64, 252}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 43}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 50}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 129, 170}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 195}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 168}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 87}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 136}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 164}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 30, 243}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 79}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 84, 95}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 59}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 23}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 168, 144}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 74}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 236, 90}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 147}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 139}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 120}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 157}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 128}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 33, 196}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 62, 206}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 21}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 122, 10}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 158, 103}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 166, 176}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 149}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 214, 221}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 25}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 230, 54}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 38}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 184, 76}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 156, 73}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 166}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 145}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 64, 136}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 59}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 26, 134}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 66, 209}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 199, 95}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 15, 250}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 11}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 126}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 136, 194}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 225, 77}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 60, 137}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 89}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 129, 158}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 119, 112}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 165, 174}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 39}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 215}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 186, 120}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 0}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 160}, 206},
	{{70, 77, 240, 209, 72, 63, 63, 45, 125, 79, 77, 41, 13, 0, 0, 93}, 206},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 88, 186, 54}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 34, 31, 230, 237, 165, 181}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 161}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 126, 200}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 144, 103, 250}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 65, 62, 125, 219, 159, 24}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 229, 81, 239, 113, 120, 148, 162}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 64, 132, 143}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 31, 70, 103, 248, 150}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 100}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 126, 12}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 193, 170, 19, 251, 82, 9}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 13, 250, 194}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 252, 173, 202, 143, 185, 198, 107}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 23, 11, 202, 68}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 184, 136, 241, 158}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 182, 102, 182, 25}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 99, 242, 85, 143}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 74, 124}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 231}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 149, 101, 38, 244, 32, 206}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 102, 235, 231, 33}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 255}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 212, 159, 152}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 45, 213, 133}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 228, 172}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 7}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 126, 177, 150}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 163, 14, 106}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 12, 124}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 87}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 93, 185, 224}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 201, 66, 186, 244, 125, 23}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 167, 117, 238, 164, 210}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 213, 6}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 131, 247, 79, 254, 138, 156}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 146, 17}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 149, 113, 146}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 216, 236, 55, 228, 221}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 239, 35, 31}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 17, 34, 124, 78, 206}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 5, 218, 192, 203, 134, 45, 54}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 162, 181, 229, 227, 111, 249}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 103, 250, 157, 112}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 115}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 251}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 189, 221, 34, 238, 194, 159}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 239}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 46, 178, 238, 231, 65, 151}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 31}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 131, 246}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 141, 161, 93, 0}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 63, 155, 72}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 241, 48, 252, 163}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 93, 101, 237, 244}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 13}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 249, 112, 124, 196, 241, 194}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 232}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 104, 171, 55, 132}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 253, 101, 55, 58, 29}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 28, 0, 34}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 26}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 245, 228, 21}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 187, 130, 72, 204, 252, 5}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 90}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 219, 184, 144}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 40}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 150, 25, 94, 222}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 55, 123, 230}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 160, 245, 47}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 179}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 72, 210}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 199, 206, 177, 43}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 12, 241, 176, 240, 175}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 156, 115, 152, 126, 158}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 245}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 58, 167}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 134}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 228, 42}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 65, 59, 84}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 114, 5, 247, 139, 165, 96}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 237, 162, 103}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 20, 145, 115, 182, 46, 204, 160}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 11, 113, 255, 79}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 225, 160, 118, 3}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 112}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 166, 77, 124, 154, 94}, 95},
	{{146, 254, 7, 5, 68, 240, 67, 237, 112, 0, 0, 0, 0, 182, 214, 231}, 95},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 80}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 132, 105}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 140, 243, 64}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 109}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 19, 65, 249}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 3}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 118, 220}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 203}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 120, 169}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 154}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 13, 203, 50}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 170, 166, 183}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 135, 70, 141}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 202, 229, 82}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 48}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 62, 134}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 222}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 91, 50}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 229, 90, 233}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 159}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 1, 243, 220}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 228, 5, 4}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 108}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 134, 116}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 5, 121}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 192, 55, 165}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 252}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 234, 12, 52}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 230, 8, 47}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 187}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 158}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 253, 1}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 25, 128, 68}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 131}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 220, 245}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 23, 67}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 216, 46}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 152, 148, 248}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 49, 158, 96}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 249, 161, 226}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 97, 162, 159}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 136}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 112, 68}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 85, 239}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 184, 240}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 197, 57, 171}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 63, 82}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 104, 179, 90}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 175, 252, 192}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 64, 74, 255}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 145}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 210}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 55, 7}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 192, 72}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 23, 223}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 78, 119}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 17, 175, 167}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 106}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 162, 190}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 181, 50}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 211, 73, 221}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 240, 120, 24}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 244}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 214, 4}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 15, 51, 142}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 229, 185, 43}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 157, 96, 172}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 0}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 246, 138}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 92, 211, 30}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 194, 53, 72}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 39}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 243, 53, 68}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 8}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 25}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 0, 0, 121}, 219},
	{{162, 223, 117, 27, 2, 156, 94, 170, 157, 114, 162, 50, 0, 5, 98, 226}, 219},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 173}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 92}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 174}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 220}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 141}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 156}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 221}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{161, 62, 191, 68, 239, 73, 100, 37, 168, 254, 139, 202, 252, 65, 74, 0}, 138},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 218, 56, 124, 227, 37, 171, 212}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 92, 150, 45, 49, 69, 164}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 72, 99}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 76, 117, 236, 56, 153, 150, 15, 136}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 242, 23, 46, 36, 225, 34}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 119, 71, 112, 218}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 60, 34, 186, 131}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 201, 110}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 59, 167}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 59, 4, 102, 64, 130, 111}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 109, 94, 133, 212, 62, 188, 179, 236}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 140, 210}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 213, 254, 104, 171, 245, 55, 11}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 107, 61, 66, 151, 145, 248}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 188, 167, 222, 252, 110}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 169, 10, 171, 166, 139, 89, 242}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 69, 166, 98, 85, 75, 85, 144}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 153, 26, 74, 153, 191, 227, 229}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 25, 123, 143, 194, 42, 47}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 39, 31, 144, 208, 153}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 82, 18, 146, 49, 161, 78, 55, 164}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 158, 128, 255}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 224, 112, 155, 172, 230, 233, 184}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 14, 44, 14}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 22, 168, 39, 195, 194, 28}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 237, 243, 201, 16, 88, 67}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 21, 73, 42, 138, 35, 173, 197}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 246, 87, 4, 161}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 220, 142, 147}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 160, 124, 177}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 20, 243, 105, 236, 23, 217, 82, 138, 19}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 129, 97}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 96, 186, 246, 182, 92, 77, 29, 242}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 15, 89, 209, 240}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 197, 215}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 255, 82}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 218, 115, 59, 250, 217, 84, 214, 181, 89}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 193, 229, 214, 170}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 128, 237, 96, 110, 132, 2, 203}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 57, 170}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 99, 5, 232, 196}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 124, 13, 228, 167, 170, 139, 134, 41}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 193, 178, 40}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 226, 20}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 46, 60, 203, 237, 91}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 157, 177, 205, 155, 75, 194, 7}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 73, 46, 219, 178, 142, 193, 66, 85}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 235, 196, 27, 166, 91, 61, 174, 69}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 149, 114, 126, 170, 93, 98, 10}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 130, 205, 182, 230, 93, 151, 69}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 172, 20, 12, 145, 31, 18, 66, 82, 214}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 185, 74}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 61, 7, 34}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 50, 183, 14, 45, 85, 201, 152}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 168, 147, 23, 60, 107, 108, 37, 185}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 41, 16, 218, 150, 108, 205}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 90, 208, 237, 63, 170, 182, 128, 159}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 40, 156, 198, 22}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 173}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 162, 110, 246, 185, 221, 16, 229}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 67, 26}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 190, 177, 114, 143, 25, 230, 158}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 155}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 86, 202, 36, 188, 160, 227}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 133}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 191, 167, 166, 132, 141, 9}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 252, 59, 151, 7, 154}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 53, 49}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 135, 136, 147, 50}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 41, 21, 127, 13, 132, 26}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 36, 226, 65, 172, 197, 129, 244}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 95, 169, 144, 59, 252, 217, 60, 130, 164}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 147, 47, 24, 19}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 211, 21, 15, 136, 53, 220}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 158}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 15, 23}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 130, 155, 107, 244}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 0, 0, 10}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 0, 0, 0, 142, 254, 230}, 84},
	{{248, 122, 115, 81, 15, 158, 136, 0, 0, 0, 221, 169, 131, 222, 78, 190}, 84},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 15, 63}, 161},
	{{8, 128, 0, 205, 84, 254, 26, 144, 226, 65, 116, 253, 7, 133, 127, 159}, 161},
	{{8, 128, 0, 0, 0, 0, 96, 187, 2, 174, 249, 97, 194, 156, 133, 201}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 144, 25, 193, 172}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 5, 85, 32}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 230}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 183, 39, 49, 56, 203, 223, 71, 179}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 226, 153, 226, 121, 145, 90, 102, 134}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 71}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 173, 55, 86}, 161},
	{{8, 128, 0, 46, 183, 105, 170, 33, 96, 194, 182, 131, 161, 117, 182, 25}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 252, 158, 114, 81, 209, 112, 57, 242, 64}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 17, 176, 79, 151, 76, 109, 255, 58}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 61, 161, 163, 110, 95, 167, 246, 95, 201}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 110, 243, 41, 190, 176, 213, 150}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 212, 41, 202}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 61, 188, 3, 82, 139, 130, 32}, 161},
	{{8, 128, 0, 0, 18, 165, 116, 138, 118, 229, 215, 98, 197, 118, 105, 61}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 129, 55}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 117, 75, 69, 163, 13, 38, 156, 61, 70}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 149, 1, 24, 202, 71, 190, 181, 133, 45}, 161},
	{{8, 128, 0, 5, 219, 117, 216, 166, 150, 124, 84, 199, 173, 61, 29, 2}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 42}, 161},
	{{8, 128, 0, 0, 0, 0, 154, 174, 72, 246, 171, 99, 191, 132, 32, 53}, 161},
	{{8, 128, 0, 0, 0, 32, 245, 84, 216, 63, 123, 58, 47, 98, 84, 166}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 6, 51, 174, 85, 78, 173, 160, 95, 24}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 61, 234, 144, 21}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 223, 49}, 161},
	{{8, 128, 0, 22, 137, 252, 40, 102, 216, 88, 131, 65, 241, 240, 253, 252}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 236, 110, 239}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 129, 67, 60}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 206, 210, 187, 205}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 235, 102, 236}, 161},
	{{8, 128, 0, 0, 0, 0, 140, 175, 0, 62, 46, 62, 8, 156, 66, 177}, 161},
	{{8, 128, 0, 0, 111, 144, 249, 113, 33, 134, 104, 26, 10, 20, 44, 190}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 20, 151, 233, 232}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 244, 47}, 161},
	{{8, 128, 0, 0, 71, 38, 5, 32, 138, 227, 167, 134, 193, 110, 61, 221}, 161},
	{{8, 128, 179, 151, 187, 164, 88, 58, 79, 61, 109, 34, 102, 153, 151, 141}, 161},
	{{8, 128, 0, 0, 0, 170, 219, 71, 109, 205, 213, 139, 144, 86, 113, 64}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 102, 202, 119, 18, 67, 87, 99, 224, 189}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 226, 102, 80, 41, 13, 244, 52, 249, 91}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 160, 240, 57, 99, 40, 4}, 161},
	{{8, 128, 0, 0, 53, 223, 9, 163, 237, 196, 169, 122, 210, 244, 69, 186}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 19, 56, 201, 252, 234, 6, 254, 168}, 161},
	{{8, 128, 0, 0, 0, 0, 159, 116, 174, 180, 3, 18, 235, 109, 13, 168}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 120, 104, 251, 179, 173, 20, 224, 48, 124}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 113, 241, 193, 102, 250, 166, 77, 94}, 161},
	{{8, 128, 0, 0, 0, 194, 46, 10, 121, 57, 237, 2, 161, 38, 216, 40}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 40, 122}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 37, 169, 58, 254}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 161},
	{{8, 128, 0, 118, 65, 223, 183, 195, 156, 105, 79, 195, 34, 148, 106, 115}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 33, 116, 39, 123}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 41}, 161},
	{{8, 128, 0, 0, 78, 164, 0, 20, 60, 1, 0, 199, 45, 146, 65, 152}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 88}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 62, 195, 50, 62, 83, 79, 98, 102, 159}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 47, 125, 157, 44, 76, 80}, 161},
	{{8, 128, 0, 0, 0, 0, 184, 173, 170, 24, 247, 62, 156, 132, 177, 83}, 161},
	{{8, 128, 0, 0, 0, 0, 70, 183, 139, 156, 155, 196, 95, 127, 207, 27}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 167, 255, 227, 145, 219, 207}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 161},
	{{8, 128, 0, 102, 63, 18, 119, 34, 76, 120, 2, 74, 93, 204, 228, 21}, 161},
	{{8, 128, 0, 0, 0, 0, 246, 91, 240, 137, 36, 230, 182, 158, 67, 1}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 174, 214, 25, 160, 198, 60, 251, 213, 177}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 125, 203}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 92, 79, 97}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 173, 125, 123, 164, 115, 187, 240}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 94, 1, 196}, 161},
	{{8, 128, 40, 183, 43, 84, 66, 199, 194, 195, 35, 253, 220, 232, 126, 78}, 161},
	{{8, 128, 0, 151, 24, 253, 174, 2, 62, 26, 138, 20, 180, 80, 171, 236}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 87, 180, 48, 213, 168, 68, 93, 245, 58}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 160}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 252, 129, 168, 105, 225, 144, 123, 148}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 250, 143}, 161},
	{{8, 128, 194, 36, 36, 27, 80, 175, 109, 165, 235, 247, 34, 110, 82, 66}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 161},
	{{8, 128, 0, 0, 0, 221, 238, 149, 34, 109, 176, 119, 159, 215, 130, 18}, 161},
	{{8, 128, 0, 0, 6, 194, 193, 236, 111, 7, 92, 135, 163, 206, 251, 64}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 191, 173, 109}, 161},
	{{8, 128, 0, 0, 0, 40, 123, 63, 234, 123, 114, 176, 149, 5, 95, 49}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 182, 15, 38, 255, 95, 108}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 120, 130, 78, 145, 208, 120, 32}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 189, 118, 214, 226}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 197, 184, 39, 180, 90, 250, 88}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 156, 209}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 162, 86}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 47, 145, 2, 0, 111, 120, 160, 64}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 161},
	{{8, 128, 13, 161, 40, 46, 38, 234, 80, 79, 178, 57, 170, 121, 100, 152}, 161},
	{{8, 128, 0, 0, 0, 0, 0, 0, 0, 157, 188, 26, 201, 51, 243, 124}, 161},
	{{8, 128, 221, 218, 245, 44, 125, 154, 153, 95, 147, 31, 91, 57, 67, 178}, 161},
	{{8, 128, 0, 0, 0, 0, 253, 56, 206, 159, 15, 81, 39, 215, 32, 182}, 161},
	{{8, 128, 0, 0, 84, 173, 185, 219, 75, 142, 50, 220, 82, 138, 151, 176}, 161},
	{{142, 96, 105, 133, 251, 57, 128, 0, 102, 14, 52, 126, 153, 204, 39, 151}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 249, 153, 4, 252, 144}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 145, 75}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 197, 204, 48}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 67}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 181, 109, 21, 182}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 255, 104}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 198, 213, 79, 123, 215, 192, 145, 27}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 176, 115, 78, 69, 21}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 227, 74, 67, 231, 27, 90}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 79, 45, 238, 136, 207}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 29, 115, 86, 74, 171, 152, 183, 138, 91}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 38, 93, 141, 115}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 119, 246, 73, 68}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 3, 226, 34, 143, 156, 214, 206, 28, 183}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 76, 50, 129, 74, 150, 76}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 4, 236, 149, 254}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 61, 14, 125, 128, 37, 57, 239}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 54, 80, 22, 102, 35, 254, 164, 76, 49}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 129, 1}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 184}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 143, 252, 99, 190, 100, 42, 193, 237}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 196, 46, 36, 175, 171}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 133, 213, 138, 20, 64, 249, 136}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 247, 72, 202, 183, 31, 175}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 142, 62, 228}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 26, 35, 70, 14, 52}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 14, 65}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 232, 144, 186, 82, 134, 216}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 29, 24, 132}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 23, 183, 9, 228, 154, 79, 195, 177}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 229, 179, 165, 35, 78, 174, 44, 7}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 31, 50, 75, 237, 150, 137, 101, 110}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 173, 38, 62, 193, 168, 239, 93, 252}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 73, 223, 76, 99}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 174, 32, 228}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 61, 150, 143, 224}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 114, 153, 124, 29, 156, 163}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 168, 95, 152, 242, 223, 156, 227, 236}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 132, 130, 210, 74, 240, 247, 218}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 19, 252, 70, 106, 73, 55, 5}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 131, 225, 242, 251, 209, 108}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 136, 212, 30}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 55, 53, 182, 219, 124, 9}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 40, 240, 227}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 178, 193, 184, 173, 189, 82, 165, 222, 2}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 231, 148, 20, 139, 22, 213}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 39, 61, 232}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 47, 11, 220, 96, 232, 54, 15, 15}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 116, 39, 75, 214}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 86, 15, 4, 255, 112, 102, 136}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 246, 78, 118}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 227, 193, 154, 246, 200, 195, 7}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 160, 170, 8, 158}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 36, 183, 44, 81, 4, 184, 226}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 177, 141, 69, 102}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 187, 20}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 78, 247, 178, 100, 83, 195, 21}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 153, 181, 86, 208, 252, 183, 183}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 18, 12, 130, 160, 101, 19}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 43, 193, 200, 80, 188, 39, 97}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 143, 196, 32, 74, 38, 241, 172, 16}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 25, 205, 17, 6, 98, 176, 142, 157}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 37, 84}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 27, 138}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 185, 254}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 207, 150, 203, 149, 197}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 43, 100, 54, 37, 12, 113, 26, 49}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 79, 25, 243, 85}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 117, 60}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 104, 247, 71, 96}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 227, 241, 211, 82, 16, 196, 245}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 150, 237, 65, 207, 230, 177, 35}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 146, 74, 80, 172, 224, 93, 196, 119, 34}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 152, 29, 116, 170, 59}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 124, 64, 8}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 231, 26, 74, 115}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 75, 223, 4, 185, 220}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 208, 167, 213, 229, 176, 98}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 117, 14, 65, 36, 169, 154, 180, 88, 182}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 229, 14, 12, 173, 9, 15, 155, 30}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 138, 130, 229, 129, 163, 52}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 227, 52, 77, 3, 111, 173, 2}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 124, 144, 145, 180, 212, 70, 247}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 0, 0, 0, 0, 38, 250, 154}, 25},
	{{142, 96, 105, 133, 251, 57, 128, 0, 0, 174, 212, 67, 45, 40, 189, 240}, 25},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 137}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 77}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 177, 99}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 208}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 2}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 161}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 182}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 146}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 72, 222}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 255}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 114}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 187}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 65}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 164, 71}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 48}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 45}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 42}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 228, 148}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 190}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 214, 244}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 71}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 84}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 133, 41}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 228}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 61}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 123}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 165, 31}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 71}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 158}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 188, 149}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 132}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 106}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 137}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 21}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 86, 51}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 217}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 72}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 240, 88}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 109, 142}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 192}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 41}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 69}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 176}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 184, 167}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 128}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 241}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 144, 155}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 92}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 55, 242}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 254}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 251, 108}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 149}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 47}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 149}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 216, 108}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 208, 130}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 172}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 150}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 0}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 243, 43}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 75, 55}, 113},
	{{138, 196, 139, 131, 233, 93, 65, 242, 86, 169, 7, 72, 82, 128, 0, 105}, 113},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 27, 238}, 61},
	{{0, 238, 80, 85, 166, 205, 68, 159, 171, 140, 224, 205, 30, 203, 85, 8}, 61},
	{{0, 0, 0, 0, 200, 62, 231, 236, 148, 192, 221, 124, 138, 158, 159, 90}, 61},
	{{0, 0, 218, 187, 192, 23, 152, 1, 51, 14, 153, 30, 134, 24, 46, 156}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 140, 205, 184, 193, 180, 4, 51, 45, 134, 65}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 3, 217, 205, 138, 181, 172, 191, 50, 112}, 61},
	{{0, 0, 0, 192, 55, 26, 248, 134, 155, 210, 63, 104, 72, 159, 77, 232}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 231, 194, 101}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 175, 208, 47, 106}, 61},
	{{0, 0, 0, 0, 0, 0, 114, 163, 245, 190, 30, 59, 228, 179, 215, 18}, 61},
	{{0, 0, 0, 0, 0, 63, 80, 8, 241, 159, 105, 249, 9, 127, 215, 89}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 124, 233, 8}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 163, 83, 150, 115, 138, 88, 87, 106, 37}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 188, 113, 82, 235, 73, 138}, 61},
	{{0, 0, 0, 161, 183, 103, 28, 194, 215, 78, 232, 71, 195, 90, 235, 247}, 61},
	{{0, 0, 0, 0, 0, 122, 195, 161, 26, 22, 177, 174, 104, 78, 184, 141}, 61},
	{{0, 0, 136, 93, 181, 244, 64, 6, 239, 238, 247, 147, 187, 149, 63, 80}, 61},
	{{0, 0, 0, 0, 175, 91, 176, 31, 155, 239, 144, 240, 94, 213, 206, 155}, 61},
	{{0, 0, 0, 157, 181, 8, 144, 79, 244, 153, 151, 86, 127, 87, 123, 254}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 57}, 61},
	{{0, 0, 0, 0, 50, 185, 126, 15, 92, 116, 60, 172, 114, 253, 201, 145}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 169, 172, 142, 243, 156, 69, 238, 119}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 194, 168}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 119, 87, 152, 63, 18}, 61},
	{{0, 0, 0, 0, 0, 60, 198, 22, 251, 217, 101, 182, 9, 38, 203, 143}, 61},
	{{0, 0, 0, 0, 18, 35, 26, 251, 209, 38, 107, 241, 59, 253, 81, 134}, 61},
	{{0, 6, 91, 242, 213, 218, 145, 137, 2, 44, 171, 45, 149, 212, 228, 214}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 106, 100, 187, 72, 82}, 61},
	{{0, 0, 0, 0, 0, 0, 29, 249, 18, 141, 68, 170, 9, 93, 240, 53}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 174, 53, 31}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120}, 61},
	{{0, 245, 161, 116, 74, 213, 184, 79, 19, 141, 247, 178, 64, 83, 211, 43}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 234, 92, 224, 250, 28, 162, 99, 50}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 208, 166, 193, 104, 17, 31, 27, 16, 180, 39}, 61},
	{{0, 0, 81, 83, 93, 180, 25, 1, 123, 220, 90, 238, 132, 235, 10, 214}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 142}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 208, 190, 58, 172, 7}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 8, 220}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 145, 42, 102, 36, 77, 107, 73, 163, 21, 126, 155, 226, 10, 147}, 61},
	{{0, 0, 0, 0, 0, 0, 125, 170, 199, 139, 140, 105, 109, 198, 59, 252}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 37, 251, 159, 197}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 215}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 197, 19, 102, 56, 87, 160, 147, 53}, 61},
	{{0, 0, 71, 129, 122, 15, 64, 156, 13, 146, 86, 147, 158, 186, 185, 151}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 144}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 48, 8}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 104, 141}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 171, 18, 237, 10, 241, 182, 199, 35, 103}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 15, 186, 56, 161}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 63, 35, 149, 153, 122, 26, 78, 87}, 61},
	{{0, 0, 0, 30, 100, 217, 59, 27, 230, 160, 16, 6, 105, 183, 42, 10}, 61},
	{{0, 0, 0, 0, 0, 48, 1, 230, 104, 27, 123, 128, 8, 211, 193, 133}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 110, 198, 144}, 61},
	{{0, 0, 0, 0, 0, 145, 35, 208, 206, 51, 23, 83, 240, 147, 247, 196}, 61},
	{{0, 0, 0, 44, 89, 134, 196, 25, 227, 187, 157, 104, 211, 231, 83, 193}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 164, 154, 159, 198, 37, 132, 32, 96}, 61},
	{{0, 0, 0, 0, 0, 0, 205, 5, 238, 159, 65, 244, 168, 66, 137, 119}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 131, 69, 56, 192, 55, 96, 229, 134}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 173, 60, 135}, 61},
	{{0, 0, 0, 222, 5, 95, 83, 54, 247, 113, 134, 187, 189, 57, 150, 220}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 240, 222, 204, 203, 104, 255, 232, 151, 169}, 61},
	{{0, 0, 0, 0, 0, 0, 114, 64, 114, 2, 167, 193, 106, 119, 164, 223}, 61},
	{{0, 0, 0, 0, 196, 88, 163, 253, 171, 82, 9, 156, 196, 105, 43, 248}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 75, 181}, 61},
	{{0, 0, 0, 0, 0, 0, 98, 234, 225, 232, 129, 249, 67, 25, 86, 179}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 61},
	{{0, 0, 245, 127, 197, 97, 126, 126, 73, 153, 205, 234, 169, 117, 180, 0}, 61},
	{{0, 0, 0, 0, 0, 51, 104, 237, 140, 211, 129, 205, 248, 187, 191, 58}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 92, 69, 178, 142, 57, 101, 50, 177, 55}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 48}, 61},
	{{0, 0, 0, 0, 0, 51, 169, 8, 252, 99, 52, 55, 34, 150, 30, 93}, 61},
	{{0, 0, 0, 0, 1, 96, 167, 173, 192, 160, 106, 92, 5, 216, 162, 80}, 61},
	{{0, 0, 0, 0, 238, 210, 65, 133, 254, 241, 247, 183, 131, 54, 20, 214}, 61},
	{{0, 0, 0, 0, 0, 0, 48, 27, 88, 63, 127, 161, 159, 107, 160, 129}, 61},
	{{0, 0, 0, 0, 251, 238, 72, 169, 168, 152, 228, 56, 55, 222, 132, 33}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 175, 82, 98, 255, 29, 194}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 66, 164}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 137, 12, 55, 155, 189, 16, 83, 180, 252, 131, 140, 20}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 95}, 61},
	{{0, 0, 0, 0, 0, 0, 85, 38, 239, 63, 101, 17, 41, 5, 162, 44}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 46, 156, 186, 25, 187, 89}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 238}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 135}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 27, 203, 99, 13, 79, 211, 188, 237}, 61},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 29, 219, 31}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 233}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 38, 240, 217, 101, 189, 39}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 247, 197}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 152, 49}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 205, 208}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 222}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 202}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 217, 178, 54, 64, 47, 47, 62}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 217, 20, 134, 150}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 105, 117}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 29, 113, 105, 7, 85, 186, 26, 217}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 153, 72, 251, 193, 117}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 135, 203, 42}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 222, 50, 151, 237, 214, 48, 10}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 93}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 141, 204}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 11, 71, 111, 17, 105, 75}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 84}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 12, 86, 203, 76, 53}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 141, 160, 2}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 47, 4}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 178, 23, 150, 86, 178, 251}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 231}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 190, 178, 236, 40, 93, 250, 201}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 240, 158, 182, 222, 124, 196, 130}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 209, 40, 133, 251}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 255, 119, 199, 247}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 45, 90, 72, 52, 178, 196, 156}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 165, 9, 53, 182, 58, 214}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 224, 161, 149, 228, 34, 99, 52}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 7, 76, 240, 169, 231}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 22, 197, 135}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 98, 102, 77}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 184}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 237, 249}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 38, 239, 196, 211}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 194, 66, 20, 88, 1, 226}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 124}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 95, 213}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 33, 142, 53, 177}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 238, 147, 100, 198, 238}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 204, 28, 128}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 199, 117}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 59, 253, 133, 146, 164}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 70, 193, 66, 101, 171}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 84, 107, 59}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 46, 132, 105, 67}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 216, 132, 25, 180, 177}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 96, 50, 149, 165}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 222, 100, 132, 57}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 92, 101, 160, 180, 208, 96}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 151, 245, 69, 70}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 164, 52, 6, 166, 211}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 251}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 75, 181, 46, 133, 30}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 216, 227, 196, 138, 151, 26}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 230}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 158}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 193, 3, 6, 152, 154, 111}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 78, 128, 196, 50}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 160, 85}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 79, 198, 255, 194, 164, 48}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 25, 255, 94, 108}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 217, 251, 146, 167, 38, 25}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 119, 94, 156, 188, 39, 67, 140}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 138, 140, 214, 247, 80, 238, 232}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 134, 106, 80, 222, 120, 82, 57}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 110, 45, 107}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 139, 126, 148, 13, 40, 25}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 55}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 64, 227, 41, 44, 34, 251, 187}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 114, 81, 93, 94}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 19, 113, 82, 157, 125, 33, 252}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 79, 221, 120, 45, 253, 105, 32, 75}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 232, 28, 197, 242, 245, 30, 168, 96}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 109, 93, 219, 17, 101, 225}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 221, 212, 246, 40}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 226, 19, 94}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 51, 200, 52, 86}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 7, 159, 84, 170, 102, 117}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 0, 250, 32}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 0, 0, 0, 0, 98, 204, 39}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 35, 234, 188, 235, 185, 102, 124}, 72},
	{{175, 151, 75, 238, 26, 12, 100, 186, 0, 247, 168, 24, 204, 179, 199, 116}, 72},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 72, 34, 147}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 90, 242, 90}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 246, 237, 49, 179}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 126}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 194, 230}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 77}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 164, 53, 56}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 145}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 254, 78, 160}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 185}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 87, 84, 253}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 63, 41}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 63, 6, 220}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 31, 39}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 36, 95, 216}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 67, 122, 29}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 6, 241, 26}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 2, 182, 174}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 159}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 115, 254, 83}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 16, 255, 102}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 150, 78, 235}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 34}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 172}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 160}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 119, 111}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 137, 53}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 130, 169}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 205, 141}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 254, 250}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 162, 20}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 103}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 16, 53, 42}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 127, 63, 116}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 95}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 45, 109, 97}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 15, 70}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 207, 177, 62}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 179}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 213, 198, 172}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 200, 193, 168}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 14, 87, 79}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 160, 12, 77}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 235}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 143}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 187}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 251, 25}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 65}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 210, 89}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 229}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 16, 75}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 44, 106}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 218}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 91, 73}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 21, 216, 128}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 186}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 154, 19, 108, 26}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 119}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 80, 19}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 60, 47}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 144}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 222, 238, 224, 41}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 98, 143, 159, 56}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 45}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 138, 239, 109}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 206, 69, 47}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 164}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 199, 247}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 141}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 101}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 0, 0}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 111, 250, 120}, 230},
	{{82, 205, 211, 176, 170, 79, 57, 153, 161, 218, 32, 48, 0, 0, 219, 125}, 230},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 102}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 213}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 75}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 146}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 16}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 231}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 237}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 153}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 32}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 174}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 127}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 120}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 105}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 154}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 139}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 34}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 31}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 124}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 231}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 231}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 75}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 49}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{227, 123, 232, 74, 236, 202, 211, 121, 200, 8, 59, 189, 81, 219, 144, 0}, 142},
	{{205, 196, 89, 90, 103, 128, 253, 173, 234, 100, 7, 30, 206, 199, 43, 82}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 164, 246, 205, 164, 200, 52}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 234, 11, 28, 48}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 238, 164, 76, 253}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 135, 249, 16, 215, 99, 197, 144, 77, 35}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 158, 84, 37, 15, 41, 158, 202, 109, 203}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 3, 207, 25, 117, 12, 1, 182}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 195, 161, 205, 109, 0, 2, 95}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 134},
	{{205, 196, 89, 90, 103, 128, 55, 80, 124, 44, 125, 18, 47, 118, 27, 194}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 223, 116, 222, 70, 42}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 86, 6, 96, 204, 134, 140, 183, 49}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 146, 130, 179, 142, 215}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 209, 110, 41, 222, 52, 55, 14, 112, 92}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 244, 22, 211}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 223, 236}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 116, 248, 207, 109, 82}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 73, 20, 28, 202, 40, 181}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 102, 234, 75, 143, 160, 37, 178, 93}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 243, 69, 35, 214, 216, 10, 84, 158, 21}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 13, 16, 103, 185, 90, 40, 67, 217}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 117, 89, 89, 189, 43, 13, 218, 255}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 57, 234, 108, 69}, 134},
	{{205, 196, 89, 90, 103, 128, 140, 65, 56, 101, 146, 215, 202, 38, 151, 192}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 5, 11}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 132, 133, 152, 164, 153, 24, 6, 140}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 231, 203}, 134},
	{{205, 196, 89, 90, 103, 128, 80, 31, 98, 14, 211, 5, 173, 217, 81, 43}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 127, 179}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 109, 218, 101, 26, 74, 219, 83, 227}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 134},
	{{205, 196, 89, 90, 103, 128, 3, 167, 0, 213, 161, 158, 51, 148, 226, 107}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 45, 33, 204, 180, 94, 80, 244, 81, 55}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 199, 6, 16, 47, 97, 39, 172, 67}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 230, 39, 39, 162, 253, 0, 48}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 217, 82, 4, 105, 152, 39}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 133, 166}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 215, 186, 37, 235}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 144, 109}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 43, 225}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 18, 88, 12, 43, 175, 180, 80, 132, 209}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 136, 195, 58}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 90, 172, 234, 157, 177, 128, 134}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 84, 65, 174}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 184, 145, 39, 215, 201, 167, 50, 117, 227}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 195, 180, 4, 190, 24, 159, 69, 238, 78}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 85, 26, 49, 157, 157, 195, 126}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 185, 189, 229, 215, 145, 221, 208}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 34, 141, 188, 246, 70, 4, 59, 254, 80}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 139, 32, 222, 209, 193, 38}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 133, 89, 254, 3, 110}, 134},
	{{205, 196, 89, 90, 103, 128, 132, 123, 53, 233, 134, 81, 35, 234, 243, 239}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 201, 250, 25, 159, 160, 151, 33}, 134},
	{{205, 196, 89, 90, 103, 128, 27, 228, 72, 52, 95, 165, 97, 22, 219, 210}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 141, 161, 13, 147, 70, 4, 23, 86, 235}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 255, 236, 45, 244, 44, 127, 163, 131}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 157, 129, 69, 247, 65, 199}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 90, 211, 146, 177, 221, 251, 94, 234}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 64, 16}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 219, 148, 63, 182, 51}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 25, 33, 44, 10}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 106, 11, 66}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 21, 110}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 18, 24, 62, 250, 166}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 139, 27}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 175, 83, 137}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 197, 81, 156, 19, 66, 219, 218, 249}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 248, 103, 135, 244, 218}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 122, 166, 91, 99, 138}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 187, 214, 36, 222, 14, 30, 83, 3}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 91, 207, 103, 170, 68, 158}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 179, 175, 172, 150}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 141, 217, 7, 179, 135, 161, 20}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 89, 25, 83, 226, 0, 80, 2, 182, 21}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 254, 142, 61, 164, 190}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 172, 31, 247, 240, 26, 190}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 85, 152, 20, 3, 214, 11}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 214, 75, 165, 45, 191, 241, 108}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 115, 81, 127, 239, 187, 94, 172}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 122, 223}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 243, 13, 157, 138, 28, 85, 109}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 9, 116, 244, 202, 90, 164, 22, 206, 10}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 41, 37, 254}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 118, 108, 60, 118, 56, 41, 158, 24}, 134},
	{{205, 196, 89, 90, 103, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 134},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 64}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 16}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 48}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 139}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 2}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 71}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 106}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 75}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 243}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 31}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 255}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 162}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 201}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 56}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 25}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 67}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 107}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 142}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 180}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 176}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 12}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 165}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 108}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 161}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 57}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 44}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 132}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 176}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 195}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 253}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 200}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 131}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 76}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 174}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 21}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 252}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 26}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 168}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 214}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 109}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 60}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 54}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 196}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 177}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 133}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 0}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 188}, 100},
	{{63, 145, 23, 127, 102, 216, 49, 36, 168, 164, 59, 133, 18, 146, 0, 204}, 100},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 245}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 209}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 51}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 161}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 4, 237}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 87}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 77}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 195}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 123, 79}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 131}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 148}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 247, 220}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 107}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 96}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 110}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 75}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 124}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 252}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 111}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 249, 121}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 252, 115}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 137}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 122, 47}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 188, 103}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 84}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 123, 119}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 19}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 78}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 189}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 91, 206}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 64}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 109}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 114}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 121}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 10, 85}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 208, 50}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 84}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 28}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 86}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 172, 197}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 166}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 49}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 52, 73}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 189}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 213}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 219}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 247}, 45},
	{{213, 72, 154, 16, 230, 236, 218, 203, 223, 51, 31, 251, 103, 64, 0, 0}, 45},
	{{126, 148, 232, 152, 0, 0, 41, 126, 253, 112, 37, 146, 182, 49, 71, 146}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 26, 240, 101, 210, 252, 96, 0, 243, 236}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 74, 229, 61, 93, 228, 68, 166, 106, 146}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 174, 18, 83, 203, 102}, 219},
	{{126, 148, 232, 152, 0, 117, 48, 190, 51, 148, 73, 216, 128, 204, 1, 13}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 190, 76, 249, 221, 60, 239}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 83, 232, 74, 251, 147, 108, 156, 17}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 145, 135, 130, 47, 206, 43, 112, 66}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 54, 41, 225, 124, 22, 70, 166}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 250, 113}, 219},
	{{126, 148, 232, 152, 0, 0, 177, 34, 187, 118, 54, 107, 230, 184, 97, 230}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 40, 90, 23, 69, 30}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 191, 150, 80, 100, 115, 66, 229}, 219},
	{{126, 148, 232, 152, 0, 94, 207, 180, 130, 103, 230, 46, 11, 115, 116, 229}, 219},
	{{126, 148, 232, 152, 184, 161, 106, 148, 196, 168, 198, 153, 47, 106, 234, 198}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 38}, 219},
	{{126, 148, 232, 152, 2, 223, 239, 164, 202, 164, 1, 250, 250, 158, 27, 36}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 98, 19, 152, 122}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 128, 123, 90, 56}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 197, 28, 45, 104}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 173, 181, 6, 171, 136, 169, 135, 178}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 137, 134, 190, 130, 193, 137, 111}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 67, 20, 90, 209, 249, 253, 85, 247}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 135, 38, 117, 167, 245, 128, 100}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 33, 229, 144, 101, 17}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 111, 142, 85, 181, 244}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 84, 173, 62, 205}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 248, 85, 159, 118, 28, 77, 148, 236}, 219},
	{{126, 148, 232, 152, 0, 0, 111, 54, 202, 120, 162, 132, 108, 3, 166, 191}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 86, 255}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 23}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 1, 167}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 168, 82, 52, 74, 135, 190, 85}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 59, 8, 198, 177, 182, 227}, 219},
	{{126, 148, 232, 152, 0, 0, 136, 87, 164, 183, 93, 155, 36, 158, 99, 77}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 214, 76, 147, 54}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 236, 70, 100, 54, 101, 7}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 61, 168, 202, 124, 100, 134, 120, 201, 5}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 253}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 87, 100, 4, 179}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 142, 66, 55, 112, 197, 83}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 150, 163}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 166, 239, 206, 155, 152, 224, 16}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 100, 74, 39, 116, 87, 203}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 71, 218, 21, 205, 147, 221, 171, 131, 152}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 25, 139, 81, 176, 218, 11, 244, 33, 194}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 62, 214, 172, 114, 156, 16}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 127, 25, 232, 93, 3}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 95, 175, 209, 207, 173, 46}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 182, 164, 195, 145, 160, 249, 137, 109, 222}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 30, 69, 119, 95, 27}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 127, 23, 250, 187, 225, 111, 203}, 219},
	{{126, 148, 232, 152, 108, 251, 162, 76, 58, 181, 145, 159, 120, 43, 254, 250}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 219},
	{{126, 148, 232, 152, 0, 0, 105, 149, 217, 206, 68, 25, 13, 225, 129, 196}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 102, 110, 156, 145, 125, 172, 199}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 115}, 219},
	{{126, 148, 232, 152, 0, 0, 117, 152, 201, 208, 123, 217, 54, 15, 243, 238}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 193, 61, 107, 136}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 81}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 58, 100, 249, 241, 44, 60, 44}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 159, 139}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 81, 172, 51, 150, 240}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 1, 72, 136, 18}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 207, 86, 70, 156, 48, 69, 240}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 236, 43, 131, 116, 154}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 231, 210, 35, 37, 219, 151}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 32, 199, 43, 140, 244}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 224, 224, 65, 5, 75, 137, 123, 7, 92}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 200, 238, 179, 239, 80, 27, 250, 20}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 47, 222, 205, 206, 4, 188, 106, 111, 81}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 221, 244, 196, 109, 208, 148, 38, 137}, 219},
	{{126, 148, 232, 152, 0, 0, 123, 135, 125, 217, 251, 205, 106, 33, 166, 171}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 207, 54, 180, 243, 113, 82, 149}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 98, 181, 107, 204}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 153, 8, 101, 91}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 251, 135, 235, 73, 217}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 0, 0, 56, 252, 192, 212, 235}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 208, 214, 229, 1, 100, 50, 161, 226, 188}, 219},
	{{126, 148, 232, 152, 0, 177, 106, 213, 212, 17, 216, 61, 28, 15, 37, 220}, 219},
	{{126, 148, 232, 152, 14, 116, 164, 26, 104, 253, 105, 184, 18, 224, 27, 209}, 219},
	{{126, 148, 232, 152, 0, 0, 0, 0, 0, 21, 115, 235, 189, 85, 245, 49}, 219},
	{{160, 72, 0, 0, 254, 47, 229, 43, 133, 153, 194, 146, 133, 187, 44, 226}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 56, 25, 77, 74}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 13, 82, 87, 120, 120, 61, 226, 54}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 43, 107, 169, 142, 177, 86}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 115, 114, 87}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 216, 59, 95, 131, 54, 33}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 232}, 52},
	{{160, 72, 0, 0, 36, 183, 79, 237, 119, 39, 176, 161, 198, 15, 2, 51}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 48, 83, 186, 11, 16, 170, 96, 52}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 137, 239, 121, 243, 188, 89, 121}, 52},
	{{160, 72, 0, 0, 0, 53, 63, 158, 148, 191, 150, 56, 239, 87, 239, 183}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 207, 66, 203, 186, 84, 197}, 52},
	{{160, 72, 0, 8, 18, 165, 186, 70, 153, 85, 43, 192, 49, 155, 158, 226}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 206, 54, 45, 242, 205, 179, 219}, 52},
	{{160, 72, 0, 0, 0, 0, 253, 36, 196, 248, 238, 160, 189, 14, 70, 190}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 145, 245, 98, 110, 50, 24, 91, 200, 247}, 52},
	{{160, 72, 0, 0, 0, 226, 32, 116, 136, 141, 208, 67, 194, 60, 16, 29}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 52},
	{{160, 72, 0, 0, 63, 168, 18, 73, 112, 12, 228, 180, 55, 197, 235, 95}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 136, 16, 120}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 235, 100}, 52},
	{{160, 72, 0, 0, 0, 0, 214, 113, 30, 24, 93, 28, 216, 88, 206, 204}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 1}, 52},
	{{160, 72, 0, 0, 0, 0, 250, 222, 15, 119, 24, 154, 123, 236, 109, 232}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 132, 128}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 189, 108, 39, 231, 245, 192, 129, 114}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 26, 39, 46, 142, 213, 8, 169, 83}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 129, 197, 254, 251, 93, 101}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 185, 107, 31}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 123, 68, 142, 199}, 52},
	{{160, 72, 0, 0, 0, 0, 107, 245, 130, 138, 1, 66, 166, 37, 194, 168}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{160, 72, 0, 0, 74, 74, 40, 70, 74, 166, 23, 157, 3, 10, 173, 102}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 80, 165, 152, 172}, 52},
	{{160, 72, 0, 0, 0, 124, 211, 160, 45, 124, 205, 140, 24, 23, 159, 239}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 165, 89, 56, 87}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 131, 186, 156, 30, 238, 120, 108, 46}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{160, 72, 0, 0, 80, 130, 162, 133, 225, 24, 127, 255, 195, 4, 1, 233}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 243, 53, 164, 102, 150, 74, 92}, 52},
	{{160, 72, 0, 55, 53, 5, 205, 31, 10, 35, 115, 110, 95, 135, 34, 170}, 52},
	{{160, 72, 0, 0, 0, 140, 85, 170, 71, 43, 125, 79, 112, 233, 224, 146}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 166, 143, 112, 12}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 143, 69, 11, 207, 58, 132, 92, 37}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 107, 103, 96, 41}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 134, 73, 89, 110, 137, 161}, 52},
	{{160, 72, 0, 0, 26, 177, 16, 122, 119, 2, 144, 140, 183, 25, 196, 219}, 52},
	{{160, 72, 0, 0, 34, 34, 75, 236, 26, 137, 126, 73, 93, 87, 204, 49}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 163, 205, 193, 124, 107, 131, 76, 97, 18}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 24, 158, 24, 109, 223, 24}, 52},
	{{160, 72, 0, 0, 106, 181, 120, 45, 184, 203, 15, 212, 252, 90, 126, 226}, 52},
	{{160, 72, 0, 0, 0, 122, 237, 146, 104, 13, 234, 54, 225, 185, 105, 217}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 212, 255}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 13, 149, 118, 230, 120, 203, 132}, 52},
	{{160, 72, 0, 0, 230, 82, 85, 211, 50, 29, 109, 203, 96, 216, 173, 154}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124}, 52},
	{{160, 72, 0, 0, 0, 0, 64, 205, 46, 187, 161, 237, 229, 90, 252, 243}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 177, 240, 48, 30}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 184, 1, 4, 153, 27, 210, 168, 39}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 201, 162, 111, 50, 52, 67, 128, 59}, 52},
	{{160, 72, 0, 240, 121, 218, 167, 10, 221, 219, 157, 173, 216, 36, 16, 250}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 198, 212, 112, 181}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 42, 61}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 128}, 52},
	{{160, 72, 0, 0, 0, 57, 198, 211, 90, 183, 165, 118, 38, 152, 200, 88}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 199}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 37, 113, 255, 142, 201, 67, 12}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 20, 236, 45}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 239, 217, 34, 140, 174, 189, 165}, 52},
	{{160, 72, 0, 0, 161, 205, 126, 61, 21, 171, 102, 66, 110, 141, 54, 10}, 52},
	{{160, 72, 0, 0, 0, 0, 127, 133, 127, 45, 182, 198, 31, 125, 223, 18}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 229, 233, 216}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 129, 221, 41, 65, 130, 211, 53, 153}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 202, 128, 186}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 224, 48, 21, 75}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 203, 248, 12, 206, 3, 148, 233, 164, 97}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 45, 73, 191}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 158, 113, 231, 123, 203, 8, 174}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 49, 138}, 52},
	{{160, 72, 0, 0, 0, 0, 127, 243, 199, 208, 33, 28, 190, 119, 68, 122}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 1, 215, 4, 239, 102, 126}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 137}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 147, 152, 163, 177, 209, 174, 239}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 136, 44, 89, 140, 112, 195}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 248, 230, 89, 167, 76, 66, 163, 114}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 174}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 78, 210}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 51, 167}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 8, 140, 157, 32, 15, 85, 42}, 52},
	{{160, 72, 0, 0, 112, 115, 203, 117, 219, 37, 58, 179, 123, 170, 239, 224}, 52},
	{{160, 72, 0, 0, 0, 0, 126, 77, 45, 160, 62, 157, 169, 202, 150, 217}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 38, 63, 127, 54, 25, 200, 32}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 78, 221, 250, 41, 79, 10, 4}, 52},
	{{160, 72, 0, 0, 0, 68, 47, 165, 52, 252, 242, 120, 108, 54, 145, 154}, 52},
	{{160, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 27, 12}, 52},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 199, 9, 56}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 204}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 219}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 166, 16, 95, 15, 53}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 86, 236}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 194, 86, 106}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 202, 69, 213, 34, 188}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 94}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 125}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 152, 127, 226, 8, 22}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 33, 193, 165, 38, 130}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 120, 10, 84}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 235}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 66, 243, 245, 47}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 239, 63, 243}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 197, 96, 189}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 124}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 22, 188}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 143, 54, 208, 101}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 113, 125}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 83, 132}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 155}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 94, 118}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 254, 188, 245, 108}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 190, 211, 142, 123}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 157, 105, 197}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 240}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 203, 177, 93, 108}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 12, 243, 165, 153, 125}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 61, 164, 40, 97}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 49}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 105, 176, 216}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 74, 159, 129}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 112, 240, 189}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 209}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 219, 4}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 90, 162}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 36, 254, 56}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 107, 243, 97, 215}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 49, 50}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 166, 240, 233, 18}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 134, 94, 83, 34, 148}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 77}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 239, 5}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 86}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 199, 12, 167}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 51, 90, 244, 188}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 155, 63}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 66}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 156, 53, 2, 217, 204}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 67, 197, 137}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 108, 137, 193}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 153, 192, 98, 58, 118}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 174, 57, 203}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 243}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 67, 69, 230, 204}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 67, 142, 153}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 128, 98, 79, 85, 133}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 218, 42, 125}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 179, 73, 103}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 159, 213}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 205, 29, 96, 8}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 86}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 207, 10}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 177, 192, 157, 48, 22}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 175}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 100, 140, 187}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 254, 174}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 22, 8, 26}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 201, 51, 140, 212, 21}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 89, 17}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 119, 167, 41}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 241}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 19, 143, 158, 74}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 88}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 15}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 58, 154, 66, 203, 63}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 167, 62, 107, 148, 5}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 161}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 58}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 227, 214, 215}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 68, 243, 73, 74}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 0, 0}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 46, 38, 95}, 240},
	{{137, 38, 146, 20, 99, 188, 83, 123, 159, 159, 64, 0, 0, 0, 100, 58}, 240},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 209, 239, 43}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 54, 76}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 249, 52, 111}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 174, 151, 205}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 100, 171, 169}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 217}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 76}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 88, 199}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 100, 203, 68, 146}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 143}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 63, 83, 74}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 249, 42, 136, 42}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 138, 62, 174}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 141, 75}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 129, 40, 249}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 17, 225, 118}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 204, 205, 197, 135}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 87, 40}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 7, 72, 86, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 209}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 200, 225, 37, 229}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 181, 129}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 221}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 105, 128}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 124, 123}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 131, 88, 19}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 34}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 144, 243, 208, 45}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 63, 228, 252, 68}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 178}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 29}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 91}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 40}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 37}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 131, 27, 80, 168}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 82}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 191}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 69}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 15}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 254, 70}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 22, 227, 170}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 143, 18}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 184, 123, 232, 112}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 27}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 111, 212, 120, 152}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 67, 137}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 168, 125, 10, 78}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 158}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 166, 69, 154, 215}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 151, 51, 186, 132}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 116, 176}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 60}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 162}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 19, 91, 236, 142}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 240, 110}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 104}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 118, 242}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 144, 188, 224}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 131}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 57, 25, 203}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 5, 115}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 74, 59}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 141, 223, 141}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 24}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 208}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 136, 99}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 102, 199, 166}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 183, 101, 58, 205}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 203}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 131, 245, 86, 12}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 42}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 34}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 0}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 189, 43, 135}, 13},
	{{123, 228, 36, 44, 242, 29, 51, 228, 140, 60, 237, 0, 0, 0, 0, 62}, 13},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 217, 164, 18}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 204}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 57, 212}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 161, 43, 226, 199, 178}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 160, 234, 229, 168}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 168, 11, 189, 42}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 93}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 51, 225, 183, 207}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 185, 202}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 182, 251, 137}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 223, 70, 207, 93}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 131, 82}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 244, 236, 97}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 49}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 190, 181}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 201, 249, 101, 1}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 184, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 246, 129, 82, 230, 215}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 88, 241, 227}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 202, 239, 102}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 207, 188}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 229, 245}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 236, 75, 234}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 122}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 25, 177}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 153, 152, 150, 22, 109}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 3}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 126, 145}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 228, 220}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 120, 191, 78}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 45}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 250, 3, 182, 65}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 196, 123, 234}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 31}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 124, 212}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 250, 71, 243, 13, 99}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 78, 129, 193, 142}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 239, 58, 136, 245, 223}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 33}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 187}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 147, 232, 160, 20}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 255, 219}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 57}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 182, 137, 161, 190}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 181, 160}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 214}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 178, 65, 46}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 127, 17, 155, 200}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 103}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 70, 13, 71}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 157, 18, 252}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 86, 80, 184, 159}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 147}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 250, 175, 2, 54, 3}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 111}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 31, 48}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 49, 169}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 121, 108, 131}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 109, 127, 24}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 174, 211}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 225, 91, 148, 44}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 94}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 220}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 127}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 21, 108, 205}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 48, 8}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 251}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 163, 125, 7, 98}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 242}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 90, 23}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 67, 54, 50, 146}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 84, 247, 66}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 137, 147, 194, 137}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 0}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 20, 41}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 147, 229, 197, 47, 6}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 157, 203, 185, 107}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 27, 61, 91, 172}, 191},
	{{163, 169, 25, 89, 190, 114, 165, 158, 140, 210, 192, 0, 0, 0, 0, 187}, 191},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 184}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 9}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 131, 241}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 213}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 255, 182}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 83}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 128, 25}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 51}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 194}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 20, 44}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 211}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 128, 113}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 211}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 221}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 82, 158}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 255}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 63, 15}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 85}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 136}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 219}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 107}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 97}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 201}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 52}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 255}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 245}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 192, 170}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 225}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 188}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 84}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 138, 69}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 227, 174}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 115, 98}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 52}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 194}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 60, 132}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 184}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 44, 42}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 131}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 181}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 184}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 17, 29}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 14}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 69, 214}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 195}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 155}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 159, 43}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 113}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 131, 203}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 40}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 127}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 178}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 82}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 48}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 252, 255}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 95}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 186}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 230}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 232}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 154, 12}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 11}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 0, 0}, 95},
	{{225, 38, 70, 89, 218, 236, 60, 5, 69, 163, 248, 50, 163, 64, 193, 253}, 95},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 78, 72, 139, 48, 254}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 29}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 93, 221, 241, 10, 168, 159, 237}, 65},
	{{91, 94, 36, 48, 0, 0, 97, 47, 110, 107, 39, 123, 166, 236, 165, 142}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 52, 177, 128, 209}, 65},
	{{91, 94, 36, 48, 0, 0, 61, 1, 121, 245, 104, 161, 56, 219, 129, 162}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 186, 166, 194, 1}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 217, 59, 57, 74}, 65},
	{{91, 94, 36, 48, 0, 173, 123, 155, 74, 182, 127, 155, 151, 112, 226, 66}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 209, 81}, 65},
	{{91, 94, 36, 48, 0, 0, 116, 8, 15, 157, 220, 254, 4, 176, 82, 205}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 70}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 27, 237, 220, 236, 192}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 107, 70, 91, 229, 167, 236, 51, 190}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 104, 38}, 65},
	{{91, 94, 36, 48, 0, 16, 193, 103, 66, 111, 157, 255, 13, 184, 138, 155}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 9, 161, 39, 70, 208, 129, 151, 130}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 31, 68, 39, 130}, 65},
	{{91, 94, 36, 48, 0, 147, 53, 169, 187, 104, 121, 103, 112, 213, 211, 11}, 65},
	{{91, 94, 36, 48, 0, 0, 141, 19, 90, 238, 136, 240, 58, 237, 94, 140}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 222, 175, 233, 67, 50, 74, 159, 197}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 196, 206, 225, 33, 180, 212, 159, 136}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 116, 47, 194, 5, 175, 202, 16}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 124, 12, 254, 48}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 96, 223}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{91, 94, 36, 48, 0, 78, 106, 48, 205, 184, 75, 74, 70, 220, 65, 12}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 47, 95}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 165}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 162, 76, 246, 200}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 95, 228, 122, 63, 21, 104}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 157, 93, 70, 53, 90, 209}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 171, 132, 88, 104, 186, 45, 222}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 108, 140, 226, 91, 38}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 68, 110, 7, 87, 126}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 59}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 81, 146, 5, 194, 0, 205, 243}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 76, 83, 191, 250, 187, 23}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 48}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 247, 89}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 75, 73, 8, 52, 7, 18, 70}, 65},
	{{91, 94, 36, 48, 0, 0, 140, 15, 121, 70, 99, 50, 121, 58, 44, 219}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 214, 164, 217, 47, 148, 14, 89}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 17, 133, 243, 160, 55, 98, 17, 124, 136}, 65},
	{{91, 94, 36, 48, 0, 9, 44, 23, 190, 43, 43, 214, 133, 141, 220, 1}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 146, 189, 14, 196, 110, 166, 17, 138, 227}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 18, 26, 139, 141, 205, 30}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 211, 62}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 184, 170, 194, 78, 9, 210, 106, 219, 194}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 212, 167, 223, 185, 171, 37, 94}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 57, 126, 11, 117, 170, 185, 9, 154}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 202, 172, 80, 229, 42, 57, 151, 113}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 84, 195}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 204, 182, 29, 157, 253, 107, 49}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 3, 201, 148, 65, 99, 31, 246, 57}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 90, 187}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 244, 214, 10, 31, 46, 206}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 176, 143, 95, 115, 101, 168}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 186, 10}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 94, 30, 51, 220}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 11, 132, 177, 89, 126, 102}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{91, 94, 36, 48, 242, 81, 9, 125, 126, 103, 127, 228, 64, 59, 183, 216}, 65},
	{{91, 94, 36, 48, 90, 116, 79, 9, 120, 134, 169, 174, 28, 176, 236, 249}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 245, 234, 10, 196, 37, 167, 150, 191}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 28, 233, 85, 42, 53, 175}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 166}, 65},
	{{91, 94, 36, 48, 0, 0, 104, 6, 12, 30, 7, 35, 72, 14, 2, 11}, 65},
	{{91, 94, 36, 48, 0, 0, 92, 87, 242, 132, 38, 55, 195, 183, 232, 121}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 252, 238, 9, 45}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 127, 87, 184, 252}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 106, 221, 245, 122}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 155, 190, 112, 25, 134}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 8, 42, 229, 54}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 254, 71, 50, 185, 63, 35, 222}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 211, 76}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 191, 66, 155, 100, 128, 73, 32}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 226, 35, 255, 171, 136, 170, 29}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 134, 177, 224, 229, 204}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 49, 43, 115, 209, 186, 176, 189, 38, 220}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 218, 178}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 29, 242, 241, 60, 241, 18, 220}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 57, 26}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{91, 94, 36, 48, 0, 0, 0, 0, 0, 0, 0, 224, 33, 62, 220, 246}, 65},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 99, 190, 155, 109, 98, 146}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 138, 52, 79, 215, 231, 222, 80, 71}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 41, 252, 25, 46, 84, 102}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 101, 195, 186, 18, 207, 131, 47}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 202, 135, 247, 129, 202, 15}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 252, 247, 9, 41, 133, 40, 231}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 248, 158, 149, 94, 155, 5}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 120, 135, 167, 33}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 245, 173, 33, 74, 208, 142, 77, 236}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 119, 28, 147, 216}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 127, 43, 114, 182, 102}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 92, 32, 193, 42, 134, 227, 159, 35}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 164, 5}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 246, 156}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 214, 80, 143, 133, 128, 113, 125, 44, 207}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 211, 38}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 47, 125}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 114, 196, 62, 97, 218, 240, 146}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 160, 155, 206, 134, 222, 37}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 110, 21, 162}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 71, 109}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 75, 189, 41, 11}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 157, 167, 194, 206}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 87, 50, 167}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 180, 46, 23, 96, 148, 217, 144, 63}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 188, 41, 244, 128, 92, 242, 148, 195}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 210, 78, 136, 10, 130, 137}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 17, 110}, 195},
	{{209, 238, 110, 0, 2, 152, 130, 165, 44, 100, 45, 3, 81, 34, 166, 184}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 45, 226, 37, 26, 123, 249, 241, 125}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 118, 220, 219}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 130, 90, 112, 218, 120, 44}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 199, 24, 142, 71}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 50, 106, 154, 190, 48, 220}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 196, 38}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 118, 146, 111, 189}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 140, 155, 188}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 50, 181, 156, 253, 75, 127}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 50, 117, 174, 51}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 140, 67, 226, 38, 205, 88, 56}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 184, 103, 211}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 218, 19, 68, 130, 82, 34, 215, 155}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 174, 44, 77, 215, 143}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 51, 77, 27}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 67, 18, 153}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 230, 157}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 66, 168, 227, 147, 134}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 209, 170, 206, 231}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 117, 220, 127, 79, 82, 206, 228}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 178, 142, 192, 153, 36, 131, 58, 254, 202}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 103, 106, 204, 56, 164}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 166, 189, 187, 88}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 10, 253, 245, 52, 42, 29}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 249, 65, 90, 169, 19, 147, 71, 12}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 124, 133, 137, 7, 143}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 161, 1, 18, 179, 178, 91, 90, 107, 61}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 91, 179, 231, 101, 204, 181, 195, 20, 202}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 160, 216, 13, 246, 132, 195, 168}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 146, 91, 209, 115, 199, 181, 23, 233}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 66, 133, 219, 78}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 217, 232, 244, 204, 243, 230, 6, 35}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 37, 199, 202, 111, 248, 170, 55, 36, 17}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 183, 26, 137}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 60, 169, 61, 194}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 57, 34, 165}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 70, 138, 80, 54, 9, 214}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 106, 246}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 166, 40, 140, 65, 14}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 122, 161, 11, 15, 158, 213}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 129, 53, 97}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 93, 209, 19, 138, 116, 115, 43}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 248, 171, 108, 3, 95}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 75, 228, 105, 61, 27}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 99, 37}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 0, 20, 105}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 0, 109, 131, 143}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 130, 182, 186, 43, 2, 131, 182, 45, 240}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 116, 84, 182, 107}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 201, 55, 9, 191}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 164, 9, 239, 106, 88, 220}, 195},
	{{209, 238, 110, 0, 2, 152, 0, 0, 0, 0, 0, 0, 22, 87, 53, 47}, 195},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 118, 77}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 98, 181}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 174}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 217}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 240, 78, 161}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 16, 129}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 252}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 247}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 145, 143}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 219, 188}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 86, 33}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 209}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 54, 212, 248}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 47}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 187}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 104, 253}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 24, 106}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 30, 174, 68}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 231}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 147}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 156}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 156, 32}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 160}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 72, 247, 35}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 141}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 192, 110}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 113, 226}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 45}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 112}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 17, 208}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 75, 19, 111}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 121, 177}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 34, 182}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 49}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 123, 134}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 177, 248}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 130}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 1, 247}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 77}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 146, 222}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 195}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 251, 176}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 123, 255}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 101, 129}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 1}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 179, 124}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 51, 218}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 136, 152}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 246, 195}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 192, 242}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 108, 220}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 57}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 234, 216}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 234, 124, 180}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 189}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 125}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 187, 27}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 155, 221}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 50, 121}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 235, 145}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 211}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 24}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 136, 241}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 64}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 23, 253}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 70, 139}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 0, 0}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 151, 210, 172}, 21},
	{{57, 17, 224, 164, 69, 95, 138, 172, 111, 55, 239, 167, 160, 0, 181, 219}, 21},
	{{112, 0, 0, 0, 0, 0, 190, 134, 227, 32, 46, 156, 96, 176, 252, 27}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 226}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 199, 203, 104, 84, 26, 43, 137, 163, 69}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 115, 193, 47, 150, 129}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 170, 152, 46}, 3},
	{{112, 0, 0, 0, 0, 0, 12, 185, 94, 156, 183, 14, 43, 180, 65, 187}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 168, 164, 169, 244, 20, 137, 252, 152}, 3},
	{{112, 0, 0, 0, 188, 130, 151, 92, 208, 13, 221, 100, 80, 39, 6, 223}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 163, 53}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 108, 132, 94}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 174, 93, 222, 30, 137, 176, 218}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 30, 156, 182}, 3},
	{{112, 0, 0, 0, 16, 16, 134, 20, 4, 30, 0, 19, 73, 172, 207, 182}, 3},
	{{112, 0, 117, 33, 27, 15, 14, 93, 82, 139, 26, 227, 162, 26, 107, 198}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 186, 49, 12, 243}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103}, 3},
	{{112, 0, 0, 0, 0, 0, 254, 96, 138, 194, 8, 96, 129, 45, 86, 121}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 26, 89, 99, 175, 6, 150, 188, 141}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 72, 198}, 3},
	{{112, 0, 0, 0, 0, 32, 249, 207, 211, 39, 199, 58, 237, 255, 207, 199}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 230, 94, 113, 219}, 3},
	{{112, 0, 0, 184, 60, 121, 20, 56, 109, 243, 22, 0, 192, 204, 220, 30}, 3},
	{{112, 0, 0, 0, 0, 0, 189, 15, 102, 109, 212, 34, 97, 53, 92, 12}, 3},
	{{112, 204, 148, 236, 106, 207, 1, 51, 18, 219, 201, 55, 53, 119, 116, 234}, 3},
	{{112, 0, 0, 0, 0, 62, 93, 143, 136, 176, 164, 253, 88, 67, 171, 95}, 3},
	{{112, 0, 0, 0, 169, 149, 19, 213, 100, 172, 147, 181, 139, 216, 158, 2}, 3},
	{{112, 0, 0, 197, 212, 149, 209, 173, 147, 0, 157, 129, 38, 91, 212, 142}, 3},
	{{112, 0, 0, 57, 173, 79, 161, 87, 58, 91, 29, 87, 27, 122, 194, 79}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 5, 73}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 139}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 55, 147, 51, 87}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 205, 148, 184, 18, 227}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 178}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 9}, 3},
	{{112, 0, 9, 14, 217, 34, 212, 2, 46, 133, 86, 74, 195, 42, 69, 20}, 3},
	{{112, 0, 0, 225, 40, 29, 103, 157, 240, 105, 91, 139, 250, 95, 153, 109}, 3},
	{{112, 0, 0, 0, 0, 250, 182, 251, 21, 184, 94, 195, 247, 59, 190, 119}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 201, 99, 236, 28}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 248, 104, 159, 59, 159, 155, 215, 222, 199}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 62, 234, 245}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 124}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 224, 175, 228, 229, 172, 230, 134, 137, 114}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 109, 117, 71, 106, 225}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 244, 180, 239, 70, 120, 110, 186, 71, 45}, 3},
	{{112, 0, 0, 100, 203, 250, 74, 171, 68, 123, 172, 116, 73, 8, 164, 103}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 197}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 65, 244, 7, 227, 236}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 84, 41, 118, 227, 160, 172, 249, 169, 188}, 3},
	{{112, 0, 0, 27, 227, 130, 99, 235, 235, 71, 28, 112, 146, 178, 144, 93}, 3},
	{{112, 0, 0, 0, 0, 29, 218, 157, 207, 27, 30, 78, 22, 7, 192, 144}, 3},
	{{112, 0, 0, 0, 0, 0, 226, 202, 228, 73, 90, 60, 124, 180, 253, 155}, 3},
	{{112, 0, 0, 0, 0, 0, 245, 183, 164, 112, 88, 251, 121, 137, 212, 157}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 90, 179, 49, 64, 5, 72, 128, 194, 26, 4, 96, 9}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 42, 200, 255}, 3},
	{{112, 0, 0, 0, 0, 237, 224, 67, 28, 68, 122, 150, 142, 124, 47, 70}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 117, 4}, 3},
	{{112, 0, 83, 126, 216, 152, 197, 7, 60, 79, 73, 157, 179, 49, 188, 107}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 168, 46, 72, 124, 161, 216, 34, 52, 48}, 3},
	{{112, 0, 0, 0, 0, 0, 140, 21, 182, 253, 92, 2, 186, 27, 247, 233}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 190, 220, 117, 101, 240}, 3},
	{{112, 0, 0, 8, 170, 101, 80, 47, 50, 22, 29, 152, 78, 105, 212, 197}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 147, 54, 150, 39}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 3},
	{{112, 0, 0, 0, 0, 30, 185, 163, 41, 213, 25, 210, 241, 83, 241, 60}, 3},
	{{112, 0, 0, 0, 0, 0, 216, 119, 79, 226, 111, 249, 123, 215, 185, 248}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 137, 72, 255, 178, 93, 37, 186, 161, 114, 55, 35, 190, 57, 160}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 238, 53, 206, 238, 23, 210, 190, 21}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 77, 25, 115, 127, 50, 97, 0, 222}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 141, 9, 236, 121}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 77, 204, 181, 228, 178}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 52, 84, 150, 201, 83, 210, 251, 66}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 68, 230, 59, 22, 68, 40, 172, 200, 54}, 3},
	{{112, 0, 217, 110, 15, 243, 50, 13, 229, 207, 120, 221, 169, 210, 196, 28}, 3},
	{{112, 0, 0, 0, 0, 0, 216, 194, 192, 67, 227, 14, 226, 166, 79, 7}, 3},
	{{112, 0, 0, 0, 0, 0, 218, 237, 201, 157, 200, 112, 224, 51, 76, 115}, 3},
	{{112, 0, 0, 124, 85, 150, 31, 195, 4, 9, 71, 52, 74, 50, 38, 243}, 3},
	{{112, 0, 0, 145, 177, 175, 3, 35, 151, 249, 144, 101, 155, 224, 216, 175}, 3},
	{{112, 0, 0, 52, 248, 181, 48, 88, 204, 209, 212, 165, 218, 148, 242, 123}, 3},
	{{112, 0, 0, 214, 85, 120, 6, 67, 49, 12, 19, 4, 217, 101, 253, 125}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 134, 104, 124, 194, 76, 158, 50, 50, 153}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 226, 213, 149, 102, 99, 180, 15, 182}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 183, 217, 159, 48, 205, 255, 167, 139, 200, 53, 183, 175, 32}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 175, 39, 0, 66, 187, 255, 54, 33, 250}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 154, 31, 241, 8}, 3},
	{{112, 0, 33, 104, 204, 67, 4, 250, 81, 90, 84, 185, 101, 73, 51, 253}, 3},
	{{102, 96, 223, 28, 0, 0, 186, 40, 75, 221, 240, 73, 154, 223, 127, 45}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 106}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 120, 119, 141, 41, 166, 10, 201, 18, 123}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 84, 82, 165, 132, 184}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 92},
	{{102, 96, 223, 28, 0, 0, 181, 179, 207, 149, 11, 174, 31, 149, 55, 194}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 101, 52}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 160, 198, 91, 217, 213}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 120}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 218, 217, 153, 106, 245, 112}, 92},
	{{102, 96, 223, 28, 0, 38, 40, 121, 95, 80, 95, 110, 59, 226, 205, 236}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 43, 91}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 179, 9, 226, 26, 163, 167, 63, 82, 33}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{102, 96, 223, 28, 0, 214, 197, 91, 21, 19, 255, 185, 92, 91, 28, 104}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 247, 46, 231, 21}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 60}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 26, 159, 207, 173, 152, 148}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 202}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 19, 120, 26, 137, 152, 41}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 37, 49}, 92},
	{{102, 96, 223, 28, 0, 91, 84, 106, 187, 193, 122, 123, 60, 251, 117, 63}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 246, 198, 134, 116, 36, 143, 72, 153, 60}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 216, 152, 133, 152, 1, 81}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 180, 35, 213, 204, 219, 94, 248, 39}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 236, 244, 201, 183, 165, 184, 32, 143}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 132, 52, 46, 211, 107, 170, 49}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 190, 144}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 164, 182, 104, 149, 16, 150, 156, 227, 155}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 218, 206, 19, 139, 184, 126, 133, 39}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 91, 118, 10, 232, 106}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 176, 34, 193, 222, 233, 44}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 223, 165}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 60, 40}, 92},
	{{102, 96, 223, 28, 0, 85, 236, 92, 214, 57, 51, 119, 173, 147, 105, 91}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 57, 197, 93, 122, 233, 30, 41, 61}, 92},
	{{102, 96, 223, 28, 0, 99, 80, 243, 160, 114, 73, 207, 95, 161, 247, 61}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 165, 21, 44, 114, 155, 153, 224, 133}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 116, 212, 205, 238, 141}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 90}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 43, 3}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 129}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 230, 41, 14, 189, 36, 28, 170, 57, 27}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 108, 136, 10, 88, 203, 227, 94}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 190, 59, 208, 177, 202, 153}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 15, 61}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 122, 64, 4, 207, 58, 19, 1, 58, 57}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 0, 80}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 234, 169, 133, 53, 138, 88, 25, 77}, 92},
	{{102, 96, 223, 28, 202, 191, 68, 223, 75, 184, 238, 182, 119, 120, 144, 166}, 92},
	{{102, 96, 223, 28, 0, 0, 211, 176, 238, 132, 170, 237, 23, 201, 46, 56}, 92},
	{{102, 96, 223, 28, 0, 29, 139, 101, 156, 21, 197, 178, 25, 95, 18, 5}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 243}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 147, 242, 74, 34, 195, 12}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 218, 179, 143, 85, 237, 225, 136, 215, 159}, 92},
	{{102, 96, 223, 28, 0, 0, 147, 7, 210, 42, 19, 240, 75, 243, 93, 91}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 105, 212, 88, 164, 171, 94, 176, 114, 130}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 178, 119}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 64}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 244, 98, 139, 213, 21, 64}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 125, 252, 108, 70}, 92},
	{{102, 96, 223, 28, 0, 132, 228, 243, 188, 166, 216, 69, 13, 103, 70, 5}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 121, 83, 173, 239, 150, 177, 15, 94}, 92},
	{{102, 96, 223, 28, 0, 55, 160, 76, 69, 145, 220, 90, 134, 127, 26, 79}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 116, 66, 210, 207, 222}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 48, 254}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 206, 40}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 170, 242, 136, 73, 12, 70, 190}, 92},
	{{102, 96, 223, 28, 0, 0, 176, 161, 88, 178, 148, 158, 236, 236, 12, 108}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 224, 152, 103, 16, 199, 126, 149, 237}, 92},
	{{102, 96, 223, 28, 0, 0, 176, 255, 249, 119, 196, 104, 90, 125, 164, 113}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 196, 255, 74, 12, 146, 90, 46, 122, 100}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 253, 107, 239, 201}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 190, 54}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 182, 194, 228, 76, 205, 8}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 224, 212, 116, 14, 15, 98, 177, 35, 154}, 92},
	{{102, 96, 223, 28, 0, 202, 212, 175, 170, 52, 137, 126, 240, 220, 39, 172}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 118, 135, 10, 192, 44, 142, 94}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 60, 52}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 110, 11, 137, 81, 52, 62, 241, 122}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 0, 0, 0, 0, 43, 251, 110, 230}, 92},
	{{102, 96, 223, 28, 0, 0, 0, 0, 58, 216, 39, 113, 31, 79, 94, 126}, 92},
	{{137, 204, 150, 75, 193, 0, 0, 28, 28, 55, 90, 194, 118, 27, 215, 72}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 201, 69, 246}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 76, 60, 33, 109}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 53}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 123, 50, 224, 120, 211}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 72, 104, 42, 48, 0, 89, 246, 231, 15}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 114, 163, 107, 65, 201, 251, 244, 38, 7}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 56, 249, 187, 44, 157}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 221, 153, 26, 173, 127, 83}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 176, 156, 212, 250, 21, 163}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 207, 202, 186, 115, 251}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 135, 60, 55, 75, 127}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 37}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 219, 171, 135, 95, 82, 158}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 199, 194, 254, 220, 16, 56, 50, 56, 119}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 8, 198, 112, 98, 109, 249, 19}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 229, 135, 11, 28, 145}, 237},
	{{137, 204, 150, 75, 193, 0, 142, 209, 168, 122, 168, 174, 170, 153, 254, 213}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 115, 233, 142, 97, 87, 41, 115, 165, 235}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 102, 7, 127, 182, 37, 155, 51}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 162, 140, 226, 160, 56, 37, 130, 124}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 161, 109, 51}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 237},
	{{137, 204, 150, 75, 193, 0, 109, 247, 92, 55, 46, 210, 209, 202, 34, 58}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 53, 228, 46, 253, 44, 105, 131, 221}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 216, 99, 50}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 96, 38, 217, 116, 77, 118, 161, 171, 3}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 137, 252, 130, 204, 230, 170, 215, 222}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 237},
	{{137, 204, 150, 75, 193, 0, 150, 152, 158, 77, 45, 119, 220, 4, 5, 62}, 237},
	{{137, 204, 150, 75, 193, 0, 120, 185, 16, 221, 202, 127, 195, 87, 220, 147}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 254, 243, 167, 235, 50, 202, 56, 225}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{137, 204, 150, 75, 193, 0, 242, 233, 46, 93, 157, 39, 140, 98, 247, 172}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 105, 172, 143, 9, 22, 115, 20, 71, 151}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 156, 77, 218, 238, 44, 254}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 37, 177, 251}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 1, 252, 124, 61, 240, 159, 1, 199}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 206, 105, 178, 135, 247, 147}, 237},
	{{137, 204, 150, 75, 193, 0, 33, 25, 74, 25, 194, 202, 52, 191, 102, 78}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 40, 15, 121, 203}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 153, 252, 139, 238, 29, 128, 82, 15}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 242, 154, 83}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 1, 39, 69, 7, 229, 156}, 237},
	{{137, 204, 150, 75, 193, 0, 95, 29, 122, 180, 142, 105, 179, 120, 82, 200}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 148, 34, 174, 59}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 218}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 133}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 5, 108, 38, 42, 125, 233, 102}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 104, 204, 69, 176, 27, 128, 31, 187}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 228, 18, 86}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 43, 156, 178, 233}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 103, 102, 179, 150}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 113, 64, 226}, 237},
	{{137, 204, 150, 75, 193, 0, 110, 57, 236, 63, 126, 141, 166, 104, 242, 105}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 235, 245, 33}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 27, 152, 151, 201, 191, 45, 129}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 158, 71, 27, 17, 108, 40, 242, 140, 173}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 175, 113, 26, 230, 62, 48, 78}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 248, 155, 145, 66, 153, 30, 84, 150}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 100, 232, 122, 205, 147, 184, 215, 142}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{137, 204, 150, 75, 193, 0, 135, 140, 73, 100, 175, 134, 68, 167, 194, 134}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 82, 106, 229, 106}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 166}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 100, 159, 163, 149, 74}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 24, 178, 77, 72, 72, 18, 208, 222, 209}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 52, 144, 192, 23, 237, 185}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 6, 176, 69, 131}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 35, 166, 200}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 89, 39, 109, 33, 105, 224, 183}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 210, 33, 135, 187, 96}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 162, 234, 116, 20, 227, 137}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 141, 99, 27, 135, 82, 73, 240, 138, 232}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 107, 16, 34}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 151, 247, 137, 168, 210, 136}, 237},
	{{137, 204, 150, 75, 193, 0, 173, 176, 128, 67, 191, 176, 196, 237, 31, 146}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 250, 15, 172, 137, 158}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 106, 164, 174, 94, 253}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 71, 68, 200, 84, 226, 138}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 0, 0, 0, 0, 0, 163, 169, 217}, 237},
	{{137, 204, 150, 75, 193, 0, 0, 0, 126, 104, 152, 255, 161, 187, 167, 45}, 237},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{136, 56, 252, 240, 85, 48, 248, 231, 17, 49, 47, 238, 15, 233, 159, 184}, 172},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 72, 70}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 136, 29}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 171, 201, 3}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 94, 30}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 173, 93}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 192}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 73, 155}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 62, 201, 89}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 175, 17, 85}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 116}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 52, 202}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 49, 92}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 66}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 4, 210, 160}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 237}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 45, 229}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 223, 167}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 157, 73, 225}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 26, 138}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 71}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 170, 28, 18}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 43, 186, 200}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 80}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 86, 204}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 94, 120}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 100, 135}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 60}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 89, 45}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 196}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 251}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 93, 110, 103}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 96}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 37, 85, 228}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 77, 255}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 217, 77}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 76, 109}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 90, 91}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 55}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 7}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 24, 214, 108}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 96, 92}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 112, 159}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 189, 216}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 46, 17}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 217, 163, 215}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 98}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 118, 144, 247}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 177, 140}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 207}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 151, 255}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 175, 3}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 205, 200}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 244, 11}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 116}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 64, 22, 111}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 200}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 128}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 137, 197}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 80, 175}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 17}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 231, 250}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 229}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 51, 248, 6}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 178}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 237, 148}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 122}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 197, 119, 217}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 89, 73}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 111, 19, 104}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 60, 25}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 152}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 234}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 75, 219, 188}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 188}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 0, 0}, 116},
	{{57, 31, 132, 123, 234, 255, 37, 82, 167, 204, 37, 158, 128, 0, 70, 169}, 116},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 232, 85, 133, 239}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 242, 248}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 19, 160, 20, 143, 254, 121, 225, 249}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 15, 146, 32, 243}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 2}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 116, 210, 50, 206, 1}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 246, 53}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 197, 6, 37, 9}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 97, 119, 243, 145}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 107, 136, 155, 244}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 217, 68, 119, 94, 4, 77}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 160, 101, 137, 83, 41, 186, 216, 245}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 232, 202, 101, 237, 67, 167, 219}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 172, 162, 168, 200}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 97, 63, 60, 132, 214, 255}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 222, 66, 233, 243}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 158, 224, 6, 161, 103}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 168, 96, 177, 217, 3, 8, 104, 15}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 219, 49, 36, 26, 250, 172, 199, 114}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 245, 113, 76, 114}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 248, 27, 29}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 231, 66, 159}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 4, 200, 250}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 74, 216, 11, 117, 69, 200}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 166, 170, 106, 231, 44, 234, 33}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 175, 69}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 149, 159, 188, 133}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 23, 41, 218, 218}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 154, 95, 60, 189}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 179, 219, 241, 216, 79, 8}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 124}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 145, 85, 120}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 251, 20}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 248, 236, 117, 239}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 243, 217, 91}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 2, 49, 103}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 233, 69}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 130, 246, 59, 242, 49, 48, 63, 172}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 172, 137}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 39, 219, 206, 65, 234, 231, 159}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 52, 144, 226, 214}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 26, 121}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 74, 205, 116, 254}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 83, 44, 17, 156, 70, 168, 8}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 125, 168, 137, 192}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 239, 35, 47, 158, 217}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 230}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 108, 244}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 238, 15}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 6, 202, 43, 161, 73, 231, 148}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 79, 73}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 39, 50, 21, 196, 169, 99, 206, 104}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 14, 148, 105, 210, 124, 66, 188}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 61, 115}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 37, 202, 46, 68, 248, 187, 55, 48}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 159, 237, 73, 57}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 89, 242, 137, 81, 0, 8, 83, 98}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 140, 153, 80}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 16, 77, 54, 172}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 199, 128, 42, 97, 200, 81}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 179, 134, 65}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 156, 16, 216, 7, 81, 130, 3, 80, 208}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 219, 108, 228, 195, 46}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 189}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 208, 158, 26, 186, 203}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 122, 218, 174, 125, 113}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 176, 143, 162, 151, 45, 237, 28}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 99, 88, 60}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 195, 150, 248}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 135, 36, 229, 63, 36}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 47, 206, 90, 192, 127}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 214, 78, 11, 163, 130, 80, 214, 9}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 218}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 118, 69, 49, 35, 128}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 226, 116, 139, 85, 129, 19, 201, 159}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 54},
	{{55, 198, 139, 219, 161, 156, 140, 0, 0, 0, 0, 167, 172, 6, 121, 160}, 54},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 82, 211, 166, 16, 37}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 161}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 176, 156, 127, 166, 162, 151, 210}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 50, 31, 39, 56}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 133, 21, 136, 102, 252, 217, 172}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 58, 79, 245, 164, 85, 30, 63, 26, 121}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 180, 163, 218, 213, 94, 9, 249}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 144, 5, 10, 35, 131, 231, 241, 46}, 203},
	{{44, 0, 105, 161, 235, 41, 121, 117, 195, 90, 217, 110, 147, 13, 172, 59}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 69, 23, 5, 55, 221, 169, 199}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 203},
	{{44, 0, 0, 0, 0, 0, 109, 255, 128, 122, 168, 248, 244, 77, 135, 0}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 244, 139, 111}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 249, 162, 5, 221}, 203},
	{{44, 0, 0, 243, 147, 130, 92, 201, 240, 184, 255, 3, 160, 7, 161, 87}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 203},
	{{44, 0, 0, 0, 0, 0, 134, 15, 4, 153, 30, 13, 22, 105, 246, 151}, 203},
	{{44, 0, 0, 0, 0, 200, 106, 211, 160, 148, 230, 244, 102, 77, 176, 120}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 252, 9, 103}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 222, 229, 48, 128}, 203},
	{{44, 0, 0, 217, 73, 232, 82, 252, 244, 179, 218, 5, 215, 98, 225, 163}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 229, 219, 171, 102, 152}, 203},
	{{44, 0, 0, 0, 0, 0, 152, 249, 95, 128, 214, 107, 238, 105, 180, 132}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 142, 119, 231, 107}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 203},
	{{44, 0, 0, 0, 0, 3, 50, 130, 88, 172, 76, 147, 77, 95, 1, 97}, 203},
	{{44, 0, 0, 71, 127, 143, 3, 0, 136, 164, 242, 168, 151, 129, 244, 248}, 203},
	{{44, 0, 0, 0, 203, 18, 3, 96, 250, 83, 22, 27, 37, 183, 168, 7}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 209, 218}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 172, 219, 191, 45, 114, 220, 216, 155, 77}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 68, 150, 23, 33, 204, 135, 130, 103, 152}, 203},
	{{44, 0, 22, 183, 168, 222, 23, 125, 235, 248, 101, 175, 30, 55, 30, 244}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 137}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 87, 89, 32, 0}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 142, 10, 231, 13, 175, 46, 122}, 203},
	{{44, 0, 0, 0, 225, 184, 148, 130, 250, 189, 5, 48, 142, 248, 217, 29}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 148, 153, 133, 148, 196, 208, 65, 175}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 241, 47, 62, 206}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 231}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 121, 31, 49, 173, 59, 100, 0, 169, 136}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 93, 184, 142, 49, 71, 115, 93, 9, 158}, 203},
	{{44, 0, 0, 0, 0, 34, 223, 30, 121, 187, 80, 55, 212, 254, 109, 235}, 203},
	{{44, 0, 51, 15, 38, 245, 251, 202, 168, 122, 21, 94, 43, 239, 208, 152}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 235, 226, 190, 44}, 203},
	{{44, 0, 0, 0, 0, 6, 61, 250, 26, 112, 232, 153, 209, 210, 253, 197}, 203},
	{{44, 0, 0, 90, 204, 179, 45, 137, 205, 130, 109, 60, 210, 179, 166, 24}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 193, 139, 254, 76, 201, 76, 196, 20, 174}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 205, 58, 196, 20}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 35, 204, 120, 93}, 203},
	{{44, 0, 0, 187, 97, 82, 114, 148, 247, 81, 137, 4, 23, 191, 10, 172}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 39, 71, 226, 22, 245, 104, 121, 48}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 89, 248, 193, 7}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 8, 242}, 203},
	{{44, 0, 0, 0, 158, 37, 49, 84, 136, 126, 7, 162, 80, 12, 29, 178}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 27, 151, 85}, 203},
	{{44, 0, 97, 8, 176, 127, 92, 124, 124, 58, 155, 89, 223, 221, 71, 204}, 203},
	{{44, 0, 0, 239, 119, 158, 183, 107, 8, 155, 103, 235, 180, 29, 193, 34}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 173, 252, 23, 179}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 145, 151, 100, 113}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 178, 110}, 203},
	{{44, 0, 0, 0, 0, 201, 151, 172, 75, 188, 131, 124, 124, 12, 179, 215}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 90}, 203},
	{{44, 0, 0, 0, 0, 0, 230, 211, 16, 233, 29, 153, 237, 47, 53, 148}, 203},
	{{44, 0, 0, 0, 0, 30, 179, 117, 94, 29, 79, 26, 151, 190, 232, 71}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 97, 94}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 207, 24, 236, 253, 87, 195, 112}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 203},
	{{44, 0, 89, 168, 127, 167, 78, 254, 18, 47, 174, 73, 43, 15, 160, 112}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 203},
	{{44, 0, 0, 0, 0, 106, 172, 234, 74, 45, 240, 133, 221, 57, 67, 7}, 203},
	{{44, 0, 0, 0, 0, 0, 122, 214, 247, 38, 48, 177, 202, 99, 87, 160}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 209, 226}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 157, 201, 135, 229, 194, 180, 228}, 203},
	{{44, 0, 152, 55, 234, 249, 251, 106, 216, 184, 140, 130, 94, 238, 161, 101}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 8, 241, 9, 200, 15, 152, 198}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 107, 93, 154, 148, 122, 172, 100, 247, 136}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 91}, 203},
	{{44, 0, 0, 117, 56, 20, 132, 216, 7, 9, 83, 226, 15, 74, 55, 190}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 155}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 169, 195, 84, 30}, 203},
	{{44, 0, 0, 0, 117, 34, 7, 121, 187, 13, 132, 38, 155, 140, 91, 111}, 203},
	{{44, 0, 0, 0, 0, 0, 88, 109, 21, 118, 195, 95, 199, 34, 54, 71}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 66, 133, 137, 228, 249}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 20}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 203},
	{{44, 0, 0, 0, 0, 30, 26, 119, 49, 143, 66, 35, 148, 128, 189, 120}, 203},
	{{44, 0, 0, 0, 0, 197, 175, 84, 205, 90, 90, 134, 69, 254, 23, 194}, 203},
	{{44, 0, 0, 43, 122, 33, 215, 250, 80, 102, 178, 233, 73, 215, 25, 103}, 203},
	{{44, 0, 0, 0, 0, 139, 137, 15, 137, 47, 162, 55, 210, 12, 175, 79}, 203},
	{{44, 0, 227, 237, 188, 45, 192, 32, 39, 77, 31, 51, 179, 192, 58, 105}, 203},
	{{44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 9, 207, 219, 192}, 203},
	{{53, 38, 0, 0, 0, 0, 0, 0, 219, 57, 8, 157, 147, 15, 109, 227}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 194, 68, 56, 63, 144, 202, 182}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 231, 238, 72, 230, 198, 180, 167}, 74},
	{{53, 38, 0, 0, 0, 0, 215, 211, 61, 181, 223, 107, 173, 177, 180, 154}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 74},
	{{53, 38, 0, 0, 0, 31, 222, 246, 122, 200, 75, 46, 70, 29, 218, 138}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 37, 147, 55, 37, 33, 101, 69, 215}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 241, 221}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 74},
	{{53, 38, 0, 0, 245, 235, 4, 35, 112, 140, 93, 153, 25, 0, 248, 179}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 240, 169, 95, 234, 39, 66}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 5, 41, 128}, 74},
	{{53, 38, 0, 0, 0, 145, 145, 187, 221, 92, 254, 6, 183, 21, 185, 216}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 217, 86, 18, 63}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 19, 177, 175}, 74},
	{{53, 38, 0, 170, 93, 241, 24, 229, 17, 249, 69, 31, 6, 29, 134, 125}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 24, 100, 37}, 74},
	{{53, 38, 0, 226, 33, 135, 109, 154, 112, 110, 188, 207, 65, 68, 13, 141}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 129, 36, 111}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 153}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 135, 188, 107, 91, 235, 237, 155, 151, 180}, 74},
	{{53, 38, 0, 0, 12, 223, 220, 113, 17, 1, 128, 100, 127, 198, 71, 161}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 165, 34, 88, 91}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 109, 94, 34, 89, 243, 154}, 74},
	{{53, 38, 0, 139, 243, 248, 245, 97, 43, 225, 90, 233, 93, 25, 57, 20}, 74},
	{{53, 38, 0, 0, 247, 92, 35, 180, 4, 198, 21, 107, 95, 63, 190, 108}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 76, 179, 199, 6, 96, 230, 136, 209, 246}, 74},
	{{53, 38, 0, 0, 157, 11, 82, 137, 72, 210, 192, 222, 77, 150, 228, 0}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 169, 122, 11, 99, 84, 212, 134, 75, 103}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 82, 76, 126, 237, 27, 50, 246}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 235, 240, 180, 23, 5, 49, 91, 53}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 52, 19, 219, 164, 176, 170, 248, 226, 15}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 175, 93, 77, 250, 111, 117, 13}, 74},
	{{53, 38, 0, 0, 0, 0, 17, 72, 197, 0, 197, 44, 6, 145, 71, 254}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 197, 14, 35, 46, 172, 4, 155}, 74},
	{{53, 38, 0, 0, 0, 88, 157, 108, 94, 39, 229, 81, 4, 95, 95, 175}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 155, 111, 65, 112, 227, 19, 195, 102, 82}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 67, 203, 100, 123, 79, 22, 95, 238}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 78, 202, 80, 74, 144, 249, 87, 137}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 190}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 254, 28, 155, 243}, 74},
	{{53, 38, 0, 17, 137, 174, 223, 156, 15, 251, 40, 60, 29, 1, 166, 219}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{53, 38, 0, 0, 163, 144, 192, 238, 36, 76, 227, 179, 29, 183, 45, 112}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 174, 100, 43, 149, 205, 147, 28, 45, 191}, 74},
	{{53, 38, 0, 0, 0, 4, 23, 21, 76, 162, 130, 244, 183, 124, 197, 235}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 80, 239, 249, 22, 63, 115, 183, 183}, 74},
	{{53, 38, 0, 0, 151, 119, 28, 200, 140, 129, 247, 29, 35, 0, 195, 199}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 131, 205, 49}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 9, 236}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 166, 140, 214, 247, 223, 87, 19, 93, 42}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 237}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 97, 220}, 74},
	{{53, 38, 0, 0, 121, 1, 80, 173, 32, 224, 86, 19, 211, 138, 4, 40}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 149, 222, 213, 221, 16, 100, 126, 251, 113}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 119, 180, 96, 89, 99, 85, 196}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 169, 229, 66, 131}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 111}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 222, 116, 156}, 74},
	{{53, 38, 0, 38, 49, 121, 108, 95, 254, 114, 152, 101, 243, 82, 151, 34}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 48, 191, 20, 254, 120, 212, 50}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 116, 106, 239, 147, 5, 156, 9, 250}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 236, 228, 104, 220, 97, 103}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 11, 142, 71, 168, 109, 44, 64, 87}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{53, 38, 0, 0, 0, 87, 39, 54, 154, 6, 9, 248, 106, 149, 5, 201}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 144, 57, 146, 124, 151, 134}, 74},
	{{53, 38, 0, 0, 0, 0, 56, 26, 30, 121, 144, 163, 212, 219, 181, 135}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 232, 198}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 172, 60, 212, 54, 12, 105, 71, 170, 159}, 74},
	{{53, 38, 0, 0, 0, 0, 85, 235, 140, 89, 222, 172, 208, 89, 123, 74}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 31, 202, 45, 81, 168, 94}, 74},
	{{53, 38, 0, 0, 0, 215, 122, 187, 190, 161, 99, 217, 213, 151, 56, 37}, 74},
	{{53, 38, 0, 0, 0, 0, 19, 135, 199, 160, 71, 7, 44, 175, 79, 192}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 102, 204, 45, 77, 197, 147, 175, 172, 77}, 74},
	{{53, 38, 0, 0, 0, 0, 6, 230, 240, 121, 217, 81, 223, 239, 222, 233}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 190, 161, 101, 245, 208, 57}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 74},
	{{53, 38, 0, 41, 220, 38, 170, 82, 138, 17, 154, 18, 151, 96, 155, 184}, 74},
	{{53, 38, 0, 0, 15, 188, 110, 113, 217, 252, 248, 107, 73, 41, 104, 183}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 173, 158, 215, 167}, 74},
	{{53, 38, 0, 0, 177, 78, 199, 137, 164, 128, 16, 242, 78, 167, 42, 124}, 74},
	{{53, 38, 0, 96, 102, 242, 145, 177, 246, 28, 118, 247, 159, 243, 201, 200}, 74},
	{{53, 38, 0, 0, 0, 136, 229, 149, 93, 33, 183, 173, 99, 86, 48, 183}, 74},
	{{53, 38, 0, 0, 0, 0, 109, 115, 219, 84, 126, 26, 3, 58, 157, 167}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 8, 192}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 233, 146, 82, 247, 96, 244, 8, 66, 97}, 74},
	{{53, 38, 0, 0, 0, 0, 0, 0, 0, 254, 201, 132, 105, 7, 95, 148}, 74},
	{{53, 38, 0, 0, 0, 164, 7, 254, 33, 80, 247, 3, 178, 174, 17, 13}, 74},
	{{53, 38, 0, 0, 101, 213, 99, 19, 238, 128, 237, 43, 40, 239, 213, 72}, 74},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 97}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 45, 103, 106}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 91, 13, 131}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 87}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 70}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 94}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 40}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 182}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 229}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 40, 116}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 33, 51}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 167}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 204, 46, 62}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 205, 118}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 252}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 227, 57}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 222, 72, 228}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 95, 71}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 36}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 187, 215}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 71}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 37}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 186}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 242}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 225, 188, 241}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 27, 235, 219}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 204, 34, 2}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 200}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 166, 76, 119}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 164, 161}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 216}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 115, 153, 7}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 65}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 219}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 80, 245, 156}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 123}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 99, 132}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 205, 11, 9}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 180, 65}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 212}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 209, 170, 228}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 215}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 4}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 24}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 225, 86}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 28, 99, 108}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 94}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 182}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 34, 164, 125}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 126, 250, 196}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 110, 167}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 100}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 181, 239}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 89}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 132, 32}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 194, 178, 10}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 90}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 228}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 96, 45}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 180, 104, 79}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 59}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 75}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 117, 13, 236}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 240}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 175, 207, 44}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 15, 196}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 136, 149}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 190}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 108, 208, 6}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 210, 221}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 191, 9, 74}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 227, 15}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 185}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 0}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 160, 206, 6}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 175, 2, 194}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 0, 92}, 220},
	{{227, 62, 107, 236, 118, 156, 60, 34, 31, 179, 76, 221, 0, 0, 82, 94}, 220},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 58, 165, 191, 166}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 52, 58, 139, 172, 210, 126, 58}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 157}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 134}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 145, 91, 77, 226}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 96, 70, 147}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 58, 97, 178, 186}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 112, 38, 176, 114, 141, 144}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 83}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 21, 170, 217, 105}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 220}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 1, 116, 68}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 82, 5, 135}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 178, 107, 206, 173, 142}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 3}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 231, 119, 218, 57, 77, 23, 168}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 11, 161, 242, 146}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 146, 128, 148}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 245, 37, 29, 78, 136, 255, 242}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 159, 184, 47}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 109, 25, 62, 26}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 43}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 224, 122}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 143, 185, 102, 214, 136, 36}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 13, 102, 180, 135, 115}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 78, 199, 200}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 10, 181}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 91, 163}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 241, 242, 204, 55}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 185, 128, 136, 45, 255}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 126, 52, 202, 107, 97, 120}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 254, 60, 162, 81, 3}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 165}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 212}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 168, 111, 143, 163}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 238}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 22}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 61, 150, 218, 91, 168, 76, 182}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 99, 96, 158, 126, 83}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 192, 117, 89, 21}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 160}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 12, 65, 39, 57, 143, 7, 8}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 17, 59, 182, 207}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 200, 127, 33, 162}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 21, 237, 231}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 30, 132, 95}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 106, 48}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 58, 241, 220}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 211, 89, 29}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 59, 215, 147}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 147, 224, 235, 188, 106, 44, 106}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 146, 186, 244, 79, 25, 1, 59}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 35, 235, 119, 233, 135, 154, 74}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 52, 165, 185, 185}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 80, 83, 29, 102}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 100, 179, 103, 210, 1, 89, 41}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 225, 106, 249}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 70}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 232, 193, 185}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 140}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 233, 236, 137, 245, 58, 233, 198}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 165}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 47, 217, 4, 156}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 98, 172}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 216}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 22, 248}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 111, 53}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 184, 199, 122, 149, 9, 69}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 144, 158}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 80, 21, 7, 140, 99}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 85}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 76, 1, 56, 41, 114, 171}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 42, 221}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 207, 41, 76, 214, 103, 182}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 182, 140, 30}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 82, 175, 112, 233}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 177, 88}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 210, 168, 215}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 243, 57, 223, 79, 208, 136}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 93, 113, 138}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 196, 11, 205, 244}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 33, 227, 151, 206, 253}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 145, 125, 242, 139}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 185, 86, 241, 230, 68, 14}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 166, 80, 156, 171, 8, 130}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 244, 19}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 53, 150, 131, 63}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 55, 180, 109, 4, 110, 61, 228}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 219, 234}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 194, 6, 109, 82}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 42, 97}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 23, 22, 13, 14, 183, 99}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 72}, 219},
	{{105, 40, 240, 216, 91, 61, 19, 128, 224, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 111, 91}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 200, 163, 78, 52}, 109},
	{{96, 170, 52, 189, 221, 20, 161, 237, 97, 86, 82, 68, 251, 26, 166, 243}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{96, 0, 0, 0, 18, 221, 9, 173, 210, 220, 230, 171, 131, 226, 157, 41}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 151, 33, 15, 160, 193, 191, 122, 46, 161}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 42, 183, 67, 7, 227, 112, 222}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 159, 97, 171, 151, 110, 66, 33, 235}, 109},
	{{96, 0, 0, 209, 32, 3, 192, 103, 196, 59, 85, 173, 121, 12, 15, 118}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 109},
	{{96, 0, 250, 185, 47, 250, 33, 94, 100, 109, 11, 246, 135, 159, 228, 72}, 109},
	{{96, 0, 0, 0, 0, 0, 90, 5, 162, 207, 125, 31, 203, 109, 139, 91}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 23, 22}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{96, 14, 148, 187, 56, 188, 58, 85, 135, 42, 153, 169, 222, 183, 24, 29}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 208}, 109},
	{{96, 182, 191, 192, 149, 16, 44, 139, 70, 80, 193, 8, 194, 24, 112, 107}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 174, 79, 67, 82, 88, 235, 226}, 109},
	{{96, 0, 0, 0, 67, 141, 95, 237, 122, 128, 13, 114, 222, 173, 149, 144}, 109},
	{{96, 0, 0, 0, 85, 159, 120, 167, 131, 72, 81, 233, 57, 33, 175, 179}, 109},
	{{96, 177, 194, 76, 63, 57, 62, 126, 213, 240, 72, 229, 133, 46, 125, 76}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 253, 180, 11, 127, 238, 228, 187, 211}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 174, 10}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 235}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 25, 208, 221, 97, 70}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 239}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 44, 129, 18, 230}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 195, 59, 130, 36, 159, 47, 56}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 143, 80, 176}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 207}, 109},
	{{96, 0, 0, 0, 0, 169, 208, 115, 118, 10, 108, 237, 183, 117, 202, 135}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 204, 37, 198}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 57, 68, 195, 250, 108, 39, 207, 21}, 109},
	{{96, 0, 0, 0, 69, 207, 186, 36, 255, 137, 12, 87, 175, 177, 148, 158}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 108, 239}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 193, 80, 213, 106}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 10, 217, 54}, 109},
	{{96, 0, 0, 0, 0, 0, 243, 149, 107, 220, 132, 83, 134, 48, 168, 43}, 109},
	{{96, 0, 0, 0, 0, 0, 67, 7, 156, 21, 215, 116, 152, 37, 238, 101}, 109},
	{{96, 0, 50, 0, 154, 160, 44, 207, 107, 243, 189, 193, 10, 33, 133, 143}, 109},
	{{96, 0, 0, 66, 241, 147, 114, 45, 7, 46, 85, 90, 50, 139, 12, 235}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 52, 164, 48, 175, 236, 113, 65}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 246}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 236, 211, 149, 230, 57, 29, 240, 124}, 109},
	{{96, 0, 0, 0, 0, 142, 231, 119, 183, 211, 31, 58, 245, 135, 41, 5}, 109},
	{{96, 0, 0, 0, 0, 55, 19, 249, 10, 82, 49, 212, 84, 81, 77, 223}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 161, 241, 215, 114, 246, 97, 183, 76}, 109},
	{{96, 0, 0, 0, 96, 96, 169, 228, 70, 197, 42, 103, 37, 91, 161, 133}, 109},
	{{96, 0, 0, 152, 160, 202, 246, 38, 25, 215, 255, 48, 197, 94, 12, 49}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 17}, 109},
	{{96, 0, 174, 28, 169, 231, 82, 228, 127, 220, 116, 46, 147, 12, 65, 201}, 109},
	{{96, 0, 0, 0, 0, 45, 12, 72, 227, 106, 47, 122, 39, 150, 44, 109}, 109},
	{{96, 0, 0, 0, 174, 124, 202, 31, 171, 238, 56, 127, 254, 63, 33, 17}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 77, 231, 161, 32, 82, 78, 124, 178, 182}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 224, 150, 215, 246, 164}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 121, 174, 98, 154, 204, 170, 57}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 20}, 109},
	{{96, 0, 0, 0, 219, 6, 142, 135, 36, 85, 42, 102, 49, 4, 240, 92}, 109},
	{{96, 0, 0, 0, 0, 0, 71, 181, 76, 125, 199, 134, 88, 210, 90, 178}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 141, 139, 217, 234}, 109},
	{{96, 0, 0, 188, 237, 176, 135, 9, 207, 64, 139, 235, 238, 20, 116, 17}, 109},
	{{96, 0, 0, 236, 233, 115, 8, 40, 113, 67, 17, 246, 12, 116, 9, 164}, 109},
	{{96, 0, 169, 251, 112, 35, 159, 18, 247, 13, 142, 232, 142, 158, 51, 162}, 109},
	{{96, 0, 0, 0, 222, 158, 203, 114, 134, 221, 220, 7, 78, 64, 147, 156}, 109},
	{{96, 0, 0, 64, 185, 142, 87, 98, 66, 25, 227, 94, 160, 180, 102, 201}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 19, 221, 225, 155, 129, 163, 144, 96, 95}, 109},
	{{96, 0, 0, 0, 0, 165, 13, 239, 154, 55, 255, 170, 8, 84, 154, 168}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 79, 69, 56}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 109},
	{{96, 157, 33, 239, 187, 236, 222, 229, 176, 199, 231, 122, 40, 33, 224, 47}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 46, 104, 245, 72, 2, 183, 152, 19, 189}, 109},
	{{96, 0, 0, 0, 85, 217, 140, 143, 74, 164, 11, 229, 61, 64, 179, 137}, 109},
	{{96, 0, 0, 0, 0, 0, 246, 25, 217, 228, 218, 192, 171, 35, 251, 235}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 107, 119, 29}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 226, 154, 209, 124, 128, 151, 94, 77}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 232, 237, 20, 177, 117, 182, 87, 66}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 97}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 31, 185, 90}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 187, 155, 167, 126, 70, 29, 150, 96, 97}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 205, 60, 152, 131, 215, 220, 14, 204, 112}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 109},
	{{96, 0, 0, 0, 0, 0, 243, 183, 15, 83, 40, 156, 29, 186, 179, 137}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 168}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 78, 88, 152, 171, 176, 176, 155}, 109},
	{{96, 0, 0, 0, 0, 49, 34, 211, 19, 242, 238, 191, 26, 168, 61, 235}, 109},
	{{96, 0, 0, 0, 0, 0, 25, 1, 0, 99, 109, 130, 209, 230, 143, 61}, 109},
	{{96, 0, 0, 0, 0, 46, 57, 46, 193, 156, 116, 255, 247, 64, 31, 195}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 218, 139, 144, 209}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 70, 134, 172, 22, 246, 254, 207, 107, 57}, 109},
	{{96, 0, 199, 218, 133, 197, 202, 132, 241, 89, 80, 232, 122, 226, 250, 215}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 222, 227, 99, 101, 239, 169, 181}, 109},
	{{96, 0, 28, 49, 152, 24, 226, 239, 229, 163, 214, 58, 230, 124, 129, 236}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 107}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 175, 65, 133, 224, 146}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 212, 1, 16, 240, 138}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 78, 219, 126, 124, 89, 136, 126, 49}, 109},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 212, 69, 242, 66, 239, 250, 195}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 22, 95, 60, 79, 18}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 11, 150, 201, 137}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 5}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 229, 110, 111}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 17, 244}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 122}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 15}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 64, 136, 10, 231, 201}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 36, 146, 162, 231, 42}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 175, 155, 59, 49, 76, 68, 85}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 90, 30}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 13, 0, 87, 173}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 195, 163, 177, 41, 5, 174}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 210, 191, 93}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 136, 121, 177}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 31, 119, 140, 97, 217}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 108, 159}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 132, 89, 192, 218, 166, 92, 163}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 82, 155, 193, 42, 113}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 46, 245}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 80, 99, 241, 143, 168}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 195, 159, 68, 68, 216, 78, 248}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 17, 217, 193, 129, 111, 97, 230, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 152, 161, 82, 196, 240, 52}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 48, 122}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 194, 68, 73, 174}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 155, 246}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 179, 104, 94, 166}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 134, 223}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 124, 204, 52}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 230, 191, 114, 42, 212, 213, 48, 28}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 63, 205}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 50, 135}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 109, 135, 48, 98, 200, 168, 142}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 133, 145, 149, 126}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 93, 184, 215, 207}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 201}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 187, 106, 84, 204, 133, 42, 207, 62}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 57, 220, 134}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 247, 14, 220}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 223, 198, 73, 99, 14, 62, 7}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 207}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 237, 66}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 181, 111, 154}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 220, 43, 1, 31, 17, 190}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 86, 194}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 143, 35}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 199, 25, 138, 180, 218, 129}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 29, 238}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 39, 166, 115, 20, 102, 83, 150}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 255, 196, 88, 117, 77, 142}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 248, 157, 9, 226}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 138, 171, 226, 162, 241, 43}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 100, 73, 193, 173, 59, 144, 95}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 76, 116, 96}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 147, 195}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 139, 3, 208}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 13}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 170, 203}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 193, 36}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 132, 28, 213}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 225, 170, 230}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 74, 135, 206, 227, 221, 207, 103}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 228, 70, 26, 255, 195, 20, 239}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 138, 36, 109, 53}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 67, 196, 195, 100, 73, 251, 155}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 99, 154, 182, 178, 59, 205, 69}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 197, 109, 48}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 109, 168, 7}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 220, 49, 128, 141, 83, 80, 160}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 238, 111, 187, 130, 11, 5, 145}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 107, 146, 101, 205}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 196}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 149, 199, 247, 248, 2, 101, 44}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 106, 166, 231, 113}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 201, 134, 6}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 52, 228, 32, 133, 79}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 78, 81, 162, 167, 40, 241}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 79, 153, 193}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 45}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 194, 67}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 0, 0, 0, 34}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 33, 70, 62, 97}, 194},
	{{118, 142, 251, 249, 128, 105, 113, 16, 0, 0, 0, 0, 33, 178, 52, 96}, 194},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 225, 198, 224, 61, 43, 156}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 155}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 139, 148, 110, 139, 255}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 155, 45, 147, 248, 7, 195, 185}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 213, 98}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 242, 86, 202, 126, 60}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 196, 96, 116, 19}, 187},
	{{101, 70, 196, 238, 0, 158, 21, 75, 64, 131, 47, 111, 61, 146, 88, 145}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 61, 36, 134, 228, 128}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 249}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 199, 130, 250, 149, 16, 59}, 187},
	{{101, 70, 196, 238, 0, 6, 222, 220, 14, 95, 145, 73, 140, 194, 45, 211}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 107, 154, 195, 118, 207, 75, 205, 131}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 210, 106, 137, 11, 173, 10, 252, 155}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 169, 69, 177, 185, 110}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 49, 228, 247, 217, 167, 106, 218, 68, 96}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 74, 164, 83, 151, 211, 36, 153, 24}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 241}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 56, 225, 253, 15, 41, 180, 163, 247, 236}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 201, 201}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 52, 230, 105, 163, 248, 210, 236}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 161, 249, 220, 233, 55, 50}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 244, 255, 160, 133, 11, 126}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 230, 65}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 90, 185, 94, 27, 128, 2, 45, 190, 126}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 162, 97, 132, 33, 141, 237}, 187},
	{{101, 70, 196, 238, 0, 0, 22, 22, 22, 150, 24, 41, 234, 130, 124, 23}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 175, 137, 71, 53}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 15, 220, 119, 226, 73, 169, 12}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 209, 38, 90, 158, 169}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 1, 185}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 196, 119, 235, 196, 177}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 62, 71, 14, 48}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 162, 220}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 192, 122, 47, 122}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 187},
	{{101, 70, 196, 238, 0, 0, 134, 193, 245, 239, 58, 2, 107, 82, 244, 214}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 172, 40}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 153, 4, 68, 58, 254, 6, 56, 97, 27}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 153, 147, 223, 82, 179}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 91, 220, 212, 130, 56, 131, 54, 32}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 132, 57, 32, 142}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 194, 148}, 187},
	{{101, 70, 196, 238, 0, 0, 82, 105, 64, 184, 10, 58, 210, 60, 206, 245}, 187},
	{{101, 70, 196, 238, 0, 0, 65, 172, 100, 185, 34, 40, 83, 172, 41, 224}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 187, 217, 164, 235, 198, 225}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 188, 244, 222, 53, 167, 46, 38, 161}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 176}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 90, 2, 124, 114, 26, 246}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{101, 70, 196, 238, 0, 0, 47, 225, 28, 204, 75, 103, 140, 124, 196, 122}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 176, 218}, 187},
	{{101, 70, 196, 238, 0, 0, 99, 26, 146, 89, 232, 183, 167, 182, 89, 159}, 187},
	{{101, 70, 196, 238, 0, 0, 152, 245, 101, 182, 62, 46, 139, 29, 151, 31}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 32, 98}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 37, 209}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 195, 0, 40, 75, 75, 131}, 187},
	{{101, 70, 196, 238, 0, 135, 178, 85, 13, 86, 190, 14, 33, 202, 241, 142}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 166, 13, 229, 71}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 60, 127, 239, 7}, 187},
	{{101, 70, 196, 238, 0, 0, 143, 174, 45, 240, 125, 84, 152, 58, 188, 85}, 187},
	{{101, 70, 196, 238, 0, 0, 80, 0, 68, 15, 249, 58, 52, 145, 99, 51}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 205, 34}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 252, 33, 2, 74, 73, 31}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 130, 5, 238, 12}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 23, 69, 109, 151, 104}, 187},
	{{101, 70, 196, 238, 0, 0, 227, 232, 105, 175, 171, 197, 177, 76, 132, 191}, 187},
	{{101, 70, 196, 238, 0, 145, 20, 66, 153, 147, 175, 65, 49, 124, 242, 50}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 168, 139, 202, 165}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 32, 145, 31, 100, 111, 95, 12, 151}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 182, 194, 189, 72}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 93, 222, 84, 200, 155, 179, 180}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 113, 227, 152, 103, 156, 141, 111, 98, 63}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 58, 196, 31, 38}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 10, 67, 57, 164, 239, 43, 174, 0, 167}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 1, 74, 244, 197, 177}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 117, 218, 231, 195, 131, 205, 155, 62}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207}, 187},
	{{101, 70, 196, 238, 0, 0, 120, 229, 235, 236, 39, 114, 119, 198, 122, 224}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 140, 249, 136, 0, 166}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 35, 201, 231, 238, 177, 194, 51}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 229}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 73, 119, 183, 71, 231, 245, 231}, 187},
	{{101, 70, 196, 238, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{245, 173, 165, 177, 200, 161, 64, 0, 106, 48, 213, 192, 253, 238, 45, 166}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 66, 136, 233, 196, 6, 112, 135, 39, 64}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 59, 24, 8, 133, 37, 112}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 164, 205, 146, 168}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 254, 95, 196, 23, 214}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 43, 149, 82, 204, 40, 70, 94, 153, 170}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 196, 75, 124}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 191, 42, 213, 53, 23}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 191, 38, 177, 112, 114, 171}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 218, 105, 178, 200, 4, 160, 228, 12, 209}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 130, 2, 169}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 119, 115, 239, 86, 192, 193, 152}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 212, 187, 244, 150}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 134, 7, 155, 97, 12, 42, 23, 1}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 253, 250, 28}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 23, 171, 139, 234, 17, 5, 251, 25}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 177, 57, 7, 131}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 158, 9, 253}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 15, 194}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 207, 131, 157, 219, 125, 107}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 59, 27, 218, 164, 164, 196, 177}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 60, 24, 231, 236, 169, 174}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 67, 149, 163, 5, 1, 58, 131}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 209, 29, 180, 31}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 176, 26, 231, 235, 163, 169}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 171, 84, 79}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 206, 16}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 5, 23, 148, 122, 146}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 190, 98, 91, 0, 217, 188, 60}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 53, 131, 66, 28, 192, 43, 17}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 18, 55, 69, 89, 159, 157, 125}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 46, 1, 60}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 37, 237, 183, 33, 1, 203, 43, 44, 117}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 113, 103, 162, 143, 97, 23, 78}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 193, 127, 204, 11}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 6, 139, 9, 255, 19, 171, 72, 211, 155}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 219, 229, 35, 133, 9, 37, 47, 102, 139}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 47, 63, 83, 174, 81, 224, 155, 181, 125}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 162, 185, 149, 193, 110}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 160, 5}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 205, 190, 42, 105, 52}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 100, 218, 0}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 196, 207, 149, 178, 91, 123, 7, 206}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 121, 137, 90, 90}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 111, 112}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 228, 105}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 112, 68, 112, 238, 20}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 131, 223, 251, 191, 229, 240, 214, 28}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 78, 246, 81, 89, 15, 174}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 15, 191, 81, 239, 205}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 248, 74, 100}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 172, 104, 222, 104, 130, 192, 34, 108, 52}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 84, 147, 229, 251, 180}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 20, 160, 15}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 23, 131, 151, 144, 149, 105, 225, 194, 46}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 151, 8, 148, 183, 228, 180, 93, 221, 66}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 206, 187, 213, 219}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 73, 61, 151, 131, 108}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 127}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 25, 56, 24, 135}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 53, 214, 75, 89}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 56, 197, 85, 225, 144, 215}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 140, 136, 6, 150, 113, 69, 31, 231, 127}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 46, 240, 82, 224, 238, 119}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 42, 68}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 171, 52, 98, 147, 183}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 0, 184, 80}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 27, 2, 194, 92, 160}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 216, 210, 52, 21, 94, 226}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 108, 12, 6, 101, 203, 236}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 145, 88, 230, 173, 82, 138}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 56, 133, 29, 111, 226, 106, 77}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 105, 140, 174, 216, 81, 2, 132}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 80, 58, 34, 77, 80}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 253, 123, 220}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 224, 61, 62, 99, 239, 143}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 0, 0, 0, 159, 59, 92}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 7, 67, 158, 114, 93, 201, 253, 45}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 0, 0, 156, 177, 147, 194, 5, 145}, 79},
	{{245, 173, 165, 177, 200, 161, 64, 0, 165, 187, 118, 109, 53, 16, 129, 238}, 79},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 80}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 75, 251, 112, 210}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 243}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 29, 57, 124, 209, 30, 234, 184, 235}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 112, 205}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 127, 244, 118, 36}, 87},
	{{0, 198, 0, 0, 0, 0, 122, 201, 87, 8, 250, 100, 204, 25, 8, 36}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 135, 116, 241, 1, 230, 155, 23}, 87},
	{{0, 198, 0, 0, 17, 58, 156, 194, 0, 99, 135, 241, 109, 240, 121, 96}, 87},
	{{0, 198, 0, 0, 39, 19, 6, 250, 75, 216, 169, 7, 15, 62, 80, 117}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 254, 226, 161, 132, 239, 156}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 173, 192}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 32, 81}, 87},
	{{0, 198, 0, 226, 172, 9, 225, 156, 116, 70, 242, 65, 13, 168, 184, 231}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 185, 81, 58, 3, 45, 80}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 140}, 87},
	{{0, 198, 0, 0, 13, 94, 80, 73, 242, 119, 99, 23, 111, 59, 231, 60}, 87},
	{{0, 198, 0, 0, 0, 0, 4, 43, 109, 29, 37, 164, 219, 0, 65, 148}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 253, 232, 233, 240, 52, 239, 0, 175, 224}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 192, 218, 185, 124, 104, 203, 151}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 130, 108, 237, 81, 9, 192, 63}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 176, 9}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 36, 35, 250, 42, 162, 35, 18, 211}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 254, 123, 54}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 88, 73, 57, 230, 77, 91, 225, 178, 213}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 136, 31, 140, 197, 152, 233}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 148, 116, 177, 11, 9, 176}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 210, 22, 243, 201, 176, 120, 247}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 136, 6}, 87},
	{{0, 198, 0, 0, 0, 140, 21, 180, 82, 243, 86, 149, 3, 109, 41, 129}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 45, 20, 144, 53, 72, 92, 24, 200}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 177, 173, 116, 10, 195, 238, 123}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 165, 198}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 230, 165, 196}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 61, 67, 219, 125, 59, 49, 125}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 224, 251, 243, 119, 241, 159, 246}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 174, 63, 175, 24, 223, 2, 162, 44}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 54, 178, 65}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 190, 72, 246, 43, 220, 60, 190}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 87},
	{{0, 198, 0, 0, 0, 0, 154, 58, 20, 99, 78, 139, 140, 59, 111, 166}, 87},
	{{0, 198, 0, 0, 0, 0, 8, 18, 164, 121, 205, 215, 235, 121, 70, 245}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 156, 204, 92, 83}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 218, 242, 188, 182}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 185, 123, 37, 116, 98, 132, 243, 246}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 34, 231}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 178, 230, 76, 204, 44, 144, 2, 177}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 5, 220, 188, 41, 116, 183}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 29, 235, 124, 16, 128, 182}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 191, 169, 155, 57}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 176}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 4, 118}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 161, 152, 122, 189, 12, 21, 166}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 111, 33, 112, 123, 57, 113, 214, 0, 39}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 243, 138, 172, 18, 176, 232, 106}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 112, 200, 128, 221, 143, 107, 12, 103}, 87},
	{{0, 198, 0, 0, 0, 0, 222, 15, 142, 248, 44, 147, 252, 106, 72, 119}, 87},
	{{0, 198, 0, 0, 0, 0, 80, 201, 81, 154, 83, 106, 174, 147, 30, 76}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 5, 182}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 93, 158, 85, 152, 159, 135, 248}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 195, 100, 250, 33, 135, 95}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 216, 3, 46, 229, 182, 251}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 74, 208, 198, 144, 35, 23}, 87},
	{{0, 198, 0, 204, 217, 173, 159, 183, 172, 219, 202, 72, 251, 85, 75, 208}, 87},
	{{0, 198, 0, 0, 0, 0, 196, 219, 103, 88, 102, 239, 114, 30, 64, 151}, 87},
	{{0, 198, 0, 0, 0, 221, 41, 253, 133, 61, 40, 118, 169, 135, 165, 135}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 1, 162, 162, 127, 71, 75, 162, 191, 165}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 29, 12, 221, 112, 94, 249}, 87},
	{{0, 198, 0, 80, 41, 112, 212, 11, 88, 250, 254, 152, 16, 177, 163, 156}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 84, 99, 102, 214, 88, 53}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 244, 197, 222, 178, 234, 39, 187, 179}, 87},
	{{0, 198, 0, 0, 0, 0, 101, 255, 93, 223, 137, 102, 147, 224, 66, 39}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 190, 46, 92, 199, 139, 122, 131}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 156, 248, 233, 43, 238, 130, 151, 208}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 179}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 193}, 87},
	{{0, 198, 0, 90, 152, 166, 250, 131, 249, 220, 81, 102, 100, 227, 102, 187}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 197, 168, 140, 25}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 63, 45}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 176, 185, 211, 84, 135, 196, 190, 157, 247}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 12, 207, 60}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 137, 19, 35}, 87},
	{{0, 198, 0, 221, 129, 30, 143, 192, 73, 225, 228, 160, 222, 152, 200, 255}, 87},
	{{0, 198, 0, 0, 0, 0, 0, 201, 188, 221, 135, 214, 198, 172, 131, 55}, 87},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 126},
	{{92, 0, 129, 238, 196, 150, 133, 138, 0, 39, 18, 211, 246, 20, 221, 42}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 244}, 126},
	{{92, 0, 56, 250, 51, 88, 152, 218, 172, 33, 36, 233, 84, 202, 127, 69}, 126},
	{{92, 0, 0, 0, 0, 0, 64, 243, 104, 202, 26, 181, 52, 168, 75, 253}, 126},
	{{92, 0, 0, 0, 0, 52, 137, 76, 128, 95, 25, 96, 102, 243, 9, 15}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 92, 232, 85, 113, 42, 118, 90}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 188, 192, 244}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 126},
	{{92, 0, 0, 0, 107, 173, 232, 94, 196, 195, 105, 187, 43, 119, 151, 133}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 217, 127}, 126},
	{{92, 0, 0, 0, 0, 0, 125, 30, 242, 76, 29, 146, 100, 173, 125, 234}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 107, 78, 156, 15}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 42, 156, 211}, 126},
	{{92, 0, 0, 0, 0, 92, 210, 11, 44, 166, 133, 192, 64, 4, 118, 205}, 126},
	{{92, 0, 0, 0, 0, 0, 186, 154, 64, 145, 76, 173, 126, 13, 203, 151}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 184, 5, 187, 91, 15, 156, 120, 174}, 126},
	{{92, 0, 0, 0, 192, 16, 142, 114, 230, 212, 95, 193, 142, 23, 99, 116}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 39, 229, 59, 85, 27, 107, 254, 23}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 26, 72, 110, 32, 242, 212, 57, 47, 80}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 118}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 135, 40, 239, 52, 61}, 126},
	{{92, 0, 0, 0, 36, 73, 252, 117, 121, 86, 1, 194, 105, 64, 56, 114}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 66, 16, 79}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 206, 83, 84, 204, 27, 161, 142, 180, 138}, 126},
	{{92, 0, 217, 87, 210, 75, 146, 141, 140, 99, 52, 141, 56, 89, 129, 186}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 35, 189, 98, 104}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 175, 106, 246}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 180, 92, 133, 102, 225}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 4, 17, 149, 230, 205, 249, 155, 191}, 126},
	{{92, 0, 0, 85, 215, 27, 228, 23, 188, 187, 251, 177, 248, 49, 51, 171}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 160, 5, 16, 209}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 127, 90, 167}, 126},
	{{92, 0, 0, 0, 0, 0, 20, 30, 41, 16, 191, 71, 117, 78, 30, 29}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 185, 176}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 89}, 126},
	{{92, 0, 0, 0, 20, 88, 181, 13, 103, 131, 134, 167, 180, 190, 103, 236}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 34, 48, 89, 180, 204, 96, 28, 224, 193}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 20, 98, 109, 33, 129, 49, 179, 47}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 253, 182, 80, 159, 153, 211, 37, 68, 20}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 183, 112, 81}, 126},
	{{92, 0, 44, 255, 229, 160, 1, 163, 159, 144, 169, 75, 31, 66, 254, 47}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 56, 1, 200, 173, 57, 67, 20}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 126},
	{{92, 0, 123, 67, 132, 31, 243, 153, 153, 38, 94, 28, 236, 1, 73, 199}, 126},
	{{92, 0, 0, 19, 17, 165, 45, 226, 106, 167, 15, 41, 112, 216, 149, 151}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 60, 113, 6, 181, 231, 17, 101}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 93, 142, 224}, 126},
	{{92, 0, 0, 0, 165, 227, 248, 43, 229, 83, 53, 145, 114, 204, 95, 215}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 115, 15}, 126},
	{{92, 0, 86, 176, 154, 0, 207, 190, 209, 132, 156, 246, 182, 165, 36, 95}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 126},
	{{92, 0, 0, 41, 35, 180, 52, 158, 129, 137, 255, 60, 154, 12, 56, 138}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 184, 61, 55, 107, 218, 239, 205, 23}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 145, 220, 173, 181, 25, 107, 186, 130}, 126},
	{{92, 0, 0, 0, 0, 52, 82, 145, 252, 103, 199, 220, 88, 154, 206, 189}, 126},
	{{92, 0, 0, 186, 131, 76, 81, 207, 252, 187, 172, 67, 150, 124, 114, 143}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 61}, 126},
	{{92, 0, 0, 0, 196, 249, 231, 8, 36, 207, 161, 54, 115, 177, 87, 226}, 126},
	{{92, 0, 0, 0, 0, 58, 250, 224, 231, 186, 153, 160, 213, 73, 182, 85}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 126},
	{{92, 0, 0, 39, 221, 6, 147, 121, 26, 223, 81, 16, 214, 215, 175, 111}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 136, 14, 126, 10, 83, 114, 75}, 126},
	{{92, 0, 0, 0, 21, 234, 18, 146, 180, 143, 57, 114, 87, 179, 56, 214}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 126},
	{{92, 0, 123, 17, 3, 225, 6, 41, 26, 231, 5, 104, 202, 96, 211, 210}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 157, 44, 254, 130, 216, 122, 106}, 126},
	{{92, 0, 0, 0, 226, 184, 182, 42, 221, 208, 227, 239, 225, 151, 171, 92}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 220, 143, 127, 208, 242, 30, 181}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 204, 223, 39}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 168, 34}, 126},
	{{92, 0, 0, 0, 0, 0, 148, 19, 62, 185, 36, 5, 144, 156, 17, 88}, 126},
	{{92, 0, 0, 245, 101, 169, 181, 79, 183, 170, 13, 74, 12, 53, 84, 249}, 126},
	{{92, 0, 0, 35, 92, 161, 89, 143, 36, 164, 145, 125, 8, 54, 46, 8}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 126},
	{{92, 0, 0, 0, 220, 102, 140, 99, 123, 127, 224, 70, 119, 47, 78, 119}, 126},
	{{92, 0, 0, 0, 0, 173, 48, 30, 162, 118, 68, 51, 121, 222, 110, 22}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 169, 149}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 168, 62, 133, 63, 50}, 126},
	{{92, 0, 217, 160, 137, 249, 155, 11, 186, 17, 146, 253, 254, 88, 178, 255}, 126},
	{{92, 0, 0, 239, 46, 108, 141, 100, 235, 125, 250, 177, 127, 173, 180, 49}, 126},
	{{92, 0, 0, 0, 161, 128, 137, 239, 135, 103, 51, 131, 95, 1, 162, 174}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 135, 149, 22, 135, 137, 65, 61}, 126},
	{{92, 0, 170, 165, 221, 19, 44, 255, 75, 185, 181, 149, 91, 153, 133, 67}, 126},
	{{92, 0, 178, 222, 60, 208, 229, 134, 114, 96, 171, 145, 221, 57, 176, 1}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 219, 75, 192, 181, 132, 72, 190, 174}, 126},
	{{92, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 123}, 126},
	{{92, 0, 0, 232, 124, 180, 72, 96, 82, 193, 241, 143, 144, 36, 53, 53}, 126},
	{{92, 0, 235, 102, 113, 197, 60, 95, 198, 162, 39, 82, 82, 171, 202, 198}, 126},
	{{92, 0, 0, 0, 213, 87, 118, 205, 232, 147, 231, 52, 192, 96, 97, 5}, 126},
	{{92, 0, 0, 0, 0, 0, 193, 13, 227, 8, 218, 195, 130, 0, 104, 39}, 126},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 56, 38}, 106},
	{{125, 0, 0, 0, 196, 145, 30, 87, 132, 146, 109, 223, 52, 69, 162, 102}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 146, 25}, 106},
	{{125, 0, 0, 0, 0, 0, 189, 31, 13, 253, 137, 17, 211, 3, 134, 121}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 150, 61, 60, 209, 105, 189, 201}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 132, 85, 72, 162, 123, 193, 6}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 193}, 106},
	{{125, 0, 0, 0, 0, 0, 147, 168, 52, 59, 230, 59, 164, 33, 69, 175}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 0, 43, 241, 76, 144, 213, 99, 161, 168, 34, 130, 10, 1}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 216, 28, 56, 204, 7}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 11, 55, 116, 147, 193, 135, 255}, 106},
	{{125, 0, 0, 0, 231, 31, 115, 68, 125, 151, 252, 95, 51, 239, 89, 247}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 24, 58}, 106},
	{{125, 0, 0, 37, 225, 134, 240, 151, 152, 17, 193, 172, 106, 53, 51, 114}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 139, 219, 253, 194, 251, 109, 38, 53}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 231, 98, 18, 78, 77, 188, 126, 200}, 106},
	{{125, 0, 0, 0, 0, 0, 221, 30, 63, 151, 191, 18, 119, 203, 115, 181}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 172, 63, 239, 154}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 0, 0, 232, 65, 13, 248, 52, 179, 30, 122, 125, 11, 48}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 122, 253, 116, 98, 162}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 41, 116}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 78, 20, 61}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 47, 160}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 163, 222, 46, 190}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 170, 247, 90, 233, 171, 98, 196, 24}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 177, 201, 203, 197, 89, 4, 216, 186, 165}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 166, 204}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 72, 112, 184, 20, 166, 142, 75, 55, 147, 77, 66, 29, 254}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 56, 16, 191, 216, 177}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 202, 198, 180, 35, 30, 160, 252, 155, 110}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 183, 61, 49, 161, 142, 16, 174, 44}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 174, 17, 175, 72, 47, 85, 222}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 106},
	{{125, 0, 0, 1, 186, 73, 169, 171, 96, 41, 203, 132, 52, 243, 82, 249}, 106},
	{{125, 0, 0, 34, 131, 252, 214, 237, 129, 57, 167, 229, 154, 200, 238, 146}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 245, 134, 12, 92, 96, 234, 20}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 255, 1, 170, 134, 76, 43, 112, 158}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 39, 114, 117, 154, 100, 218, 32, 204, 36}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 255, 252, 170}, 106},
	{{125, 0, 0, 0, 0, 241, 133, 239, 233, 75, 66, 42, 10, 130, 128, 11}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 86, 139, 56, 216, 83}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 62, 17, 43, 243}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 196}, 106},
	{{125, 0, 0, 95, 30, 93, 5, 242, 152, 79, 238, 179, 209, 99, 155, 165}, 106},
	{{125, 0, 0, 0, 0, 0, 19, 48, 70, 15, 110, 238, 94, 132, 244, 158}, 106},
	{{125, 0, 0, 0, 0, 206, 171, 241, 131, 245, 168, 234, 144, 35, 12, 215}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 18}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 220}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 233}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 185, 86, 227, 232, 129, 33, 62, 146}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 46}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 123, 161, 94, 53, 154}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 255}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 168, 139, 20, 113, 192, 57, 93}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 106},
	{{125, 0, 0, 0, 0, 0, 90, 2, 190, 172, 157, 187, 160, 204, 106, 167}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 0, 79, 246, 98, 227, 247, 77, 175, 16, 37, 206, 251, 159}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 93}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 65, 86, 112, 73, 163, 76, 81, 56}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 87, 130, 255, 24, 219, 84, 166}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 128, 133, 162, 127, 44, 223, 73}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192}, 106},
	{{125, 0, 0, 0, 0, 0, 89, 146, 199, 234, 171, 125, 53, 229, 219, 196}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 166, 240, 165, 16, 118, 82, 40}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 93, 54, 40, 202, 213}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 57, 132, 58, 97, 182, 196, 156, 111}, 106},
	{{125, 0, 0, 0, 26, 161, 59, 157, 149, 196, 144, 171, 24, 63, 68, 26}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 225, 52, 20, 245, 66, 177, 144, 187}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 216, 42, 166, 180, 84, 79, 93, 124}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 132, 108, 63, 159}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 201, 171, 188, 255, 21, 135, 238, 152, 39}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 216, 127}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 221}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 34, 76, 218, 40, 162, 61, 17, 92}, 106},
	{{125, 0, 0, 125, 225, 250, 188, 70, 8, 181, 11, 171, 209, 174, 196, 81}, 106},
	{{125, 0, 0, 0, 0, 34, 22, 152, 207, 15, 71, 195, 60, 203, 82, 156}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 51, 187, 54}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 179, 37, 197, 171, 156}, 106},
	{{125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 177, 103, 58, 112, 253}, 106},
	{{125, 0, 0, 0, 0, 36, 18, 72, 216, 128, 73, 244, 11, 223, 89, 163}, 106},
	{{56, 59, 35, 82, 101, 72, 0, 0, 17, 211, 116, 102, 8, 135, 202, 241}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 35, 117, 229, 112, 149, 176}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 31, 115, 167, 26, 244, 57, 117, 159, 197}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 29, 90, 94, 170}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 20, 56, 207, 69, 168, 247, 164}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 148, 41, 102, 77, 66}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 131, 25, 64, 87, 104, 127, 0}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 29, 247, 104, 2, 111, 193}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 246, 80, 227, 251, 49, 114, 210}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 134, 119, 188}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 68, 142}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 126, 121, 144}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 123, 137, 90}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 222, 72, 93}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 199, 127, 87, 39, 133}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 154, 84, 190, 171, 161, 226, 131, 238}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 80, 2}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 135, 118}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 80, 59, 110, 0, 30, 234, 142, 3}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 153, 5, 63, 244, 231}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 68, 76, 74, 234}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 57, 81, 220, 176, 168, 63, 44}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 181, 78, 81, 177, 36}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 146, 242, 24, 60, 50, 124, 23}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 206, 12, 19, 46}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 210, 95}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 37, 26}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 213, 94}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 52, 127, 108, 249, 137, 104, 103, 19, 33}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 184, 90, 54, 5, 239, 7}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 41, 66, 117}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 41, 26, 202, 25, 65, 68, 185, 193, 117}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 120, 225, 128}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 152, 79, 25, 53, 31, 183, 178, 249, 33}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 149, 95, 21, 202, 185, 175, 251, 116}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 90, 51, 130, 170, 231, 235}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 228, 6, 178, 206, 114, 166}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 53, 0, 173, 187, 233, 242}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 253, 224, 140, 89, 187, 216}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 75, 32, 199, 222, 45, 101}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 9, 12, 15, 7, 159, 221, 63, 196, 45}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 35, 180}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 140, 62, 161, 122, 18, 191, 163}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 217, 130, 255, 126, 137, 226}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 248, 42, 132, 94, 8}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 28, 9, 88, 147, 75, 51, 75}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 143, 118, 204, 227, 96, 176, 204, 165}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 14, 239, 254, 48}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 196, 26}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 118, 4, 1, 39}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 4, 25, 132, 11}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 199, 19, 243, 203, 230}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 137, 56, 250, 19, 5, 50, 21, 25, 51}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 220, 186, 69, 209, 59}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 144, 189, 198, 1}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 197, 190, 29, 97, 250, 141}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 41, 69, 86, 27, 82, 48}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 165, 58, 110, 173, 132, 30, 223, 15}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 72, 14}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 113, 74, 39, 206, 37, 63, 87, 111}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 124, 132, 106}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 66, 175, 137, 242, 45}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 118, 124, 213, 84, 135, 61, 186, 94}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 12, 15}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 35, 79, 66, 155, 88, 220, 41}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 170, 49, 137, 182, 238, 12, 130}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 225, 225, 104}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 21, 205, 185, 42, 47, 12, 242, 50}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 175, 136, 122, 56, 72, 176, 48, 151}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 13, 102}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 163, 49, 151, 18, 1, 60}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 109, 94, 251, 99, 157}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 16, 76, 233, 249, 61, 34, 45}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 174, 139, 65, 254, 145, 218, 87, 200}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 76, 73}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 119, 113}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 78, 57, 86, 5, 154, 126, 203, 212}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 195, 88, 2, 9, 202, 59, 10, 46}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 237, 181, 142, 203, 45, 191}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{56, 59, 35, 82, 101, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{184, 72, 77, 251, 8, 166, 0, 0, 69, 107, 0, 36, 130, 40, 222, 54}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 37, 110, 133, 25, 148, 221, 24}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 210, 11, 175, 222, 254, 113, 244}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 203, 196, 198, 213, 147, 110, 158, 75, 41}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 67, 199, 38, 220, 201, 229, 7, 228}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 191, 200, 56, 176, 241, 201, 95}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 175, 64, 64, 80}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 130, 77, 27, 163}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 200, 205, 179, 81, 96, 106, 86, 9}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 79, 141, 166, 186, 190, 188, 242, 70, 142}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 189, 32, 66}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 145, 128, 167, 183}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 170, 50, 23, 217, 3, 137, 253, 207, 171}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 73, 208, 8, 17, 219, 35, 249, 218}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 232, 45, 55, 169, 99, 177, 241}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 157, 126, 1, 250, 166, 59, 247, 162}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 54, 36, 245, 128, 153, 62, 155, 56, 137}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 25, 150, 227, 97, 191, 227}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 104, 25, 7, 66, 10, 144}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 197, 134, 218, 90, 48, 40, 207}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 91, 180, 88}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 201, 243, 74, 8, 170}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 90, 240, 213}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 86, 49, 110, 29}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 143, 94, 134, 116, 9, 48, 11, 200}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 46, 142, 122, 41}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 33, 226, 124, 50, 238}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 198, 206, 83}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 238, 20, 79, 214, 183}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 208, 91, 51, 139, 91}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 210, 214, 232, 87, 186}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 154, 92, 23, 115, 134, 99}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 132, 73, 196, 253, 218, 207, 194, 5}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 35, 61, 113, 66}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 196, 81, 184, 76, 187, 82, 6}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 171, 17, 26, 56, 184, 9, 215, 21, 203}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 136, 59, 115, 153, 71}, 45},
	{{184, 72, 77, 251, 8, 166, 18, 174, 66, 93, 113, 43, 140, 176, 57, 108}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 216, 119, 237, 107, 188, 104, 14, 199, 19}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 129, 195, 28, 80, 248, 49, 113, 159}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 8, 33, 188, 198, 72}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 95, 8}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 249, 210, 252, 74}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 216, 182}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 71, 232, 42, 13, 55}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 119, 142, 2, 143, 239, 211, 67, 52, 38}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 124, 9, 87, 82, 254}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 107, 188, 242, 103, 38, 0, 138}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 56, 207, 232, 56}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 131, 219, 20, 91, 100}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 86, 119}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 93, 232, 20, 125, 229, 114, 91, 138, 133}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 94, 29, 233, 67, 51, 63}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 142, 0}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 129, 73}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 101, 31}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 204, 200, 122, 191}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 57, 107, 240, 148, 130, 185, 5, 62, 216}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 185, 236}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 219, 252, 78, 179, 89, 219}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 216, 15, 225, 102, 177}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 253, 3, 125, 175, 95, 214, 217, 121, 66}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 224, 45, 36, 39}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 44, 26, 199, 102, 46, 126}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 63, 201}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 187, 72, 77, 225}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 162, 209, 205, 100, 150, 111, 215, 145}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 128, 67, 243, 40, 162, 203, 140, 71}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 106, 55, 13, 107, 86, 254, 137}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 167, 252, 141, 180, 93, 56, 42}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 17, 210, 18}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 42, 91, 85, 214, 210, 55, 229}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 91, 54, 94, 128, 251, 9, 60, 248, 106}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 177, 87, 131}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 123, 113, 204, 172, 59}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 236, 207, 221, 154, 37, 67}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 167, 166, 125}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 45, 14, 213, 15}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 131, 49, 224, 215, 59, 47, 18, 249, 238}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 31, 36, 7, 163, 68, 119}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 201, 78, 44, 75, 82, 215, 89}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 45},
	{{184, 72, 77, 251, 8, 166, 127, 125, 180, 66, 196, 230, 32, 205, 214, 214}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 0, 172, 141}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 0, 0, 87, 149, 106}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 33, 3, 95, 50, 174}, 45},
	{{184, 72, 77, 251, 8, 166, 0, 0, 0, 0, 0, 24, 185, 79, 211, 182}, 45},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 184}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 235}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 67}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 125}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 199}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 219, 31}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 189}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 110, 32}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 194, 190}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 177}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 200}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 64}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 71}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 122}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 127}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 229}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 161}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 252}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 119}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 47, 103}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 157}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 68}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 150}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 74}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 174}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 154}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 50}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 207}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 169}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 31}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 124}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 214}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 25}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 152, 106}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 11}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 79}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 148}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 129}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 130}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 39}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 48, 211}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 202}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 254}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 70}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 55}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 192}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 154}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 209}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 214}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 219, 248}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 103}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 0}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 224}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 52}, 8},
	{{143, 74, 132, 205, 218, 247, 30, 160, 145, 199, 138, 12, 89, 220, 0, 147}, 8},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 64, 249}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 41, 136}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 62, 84}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 159, 149, 168, 69, 62, 43, 124}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 12, 96, 214}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 6, 176, 30, 10, 30, 203, 0}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 108, 155, 218}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 52}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 126, 62, 251, 8, 35, 149}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 84, 104}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 153, 144, 33, 193, 125, 158, 233}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 104, 111, 4, 131, 246}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 252, 209, 250}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 92, 116, 74}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 111}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 72, 81, 9, 119, 133, 173, 147}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 148, 239}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 32, 208, 139, 43, 179}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 49, 23, 64, 255, 166, 157}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 252, 65, 164, 70, 104}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 114, 20}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 35, 122, 216, 123, 134, 87}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 125, 238, 118}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 135, 235, 167, 53, 238, 146, 19}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 212, 217}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 67, 135, 135, 35, 121, 3, 68}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 190, 122, 227, 196, 225}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 88, 48, 22, 211, 244, 224, 47}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 148, 47, 75, 126, 81, 236, 192}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 143, 1, 84, 181, 73, 38, 49}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 91, 66, 44, 106, 143}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 135, 56}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 156, 226, 124, 101, 149}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 186, 85, 243, 150, 36, 234}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 124, 238, 13, 60, 123, 97, 157, 53}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 114, 98, 150, 156}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 127, 169, 42, 45}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 179}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 207, 6, 127, 126, 33, 21, 66}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 154, 30, 239, 159}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 37}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 127, 143, 25, 220, 176}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 128, 174, 66, 45, 231}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 1, 94, 63, 87}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 226, 124, 136, 113, 120, 37}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 93, 150, 227, 61, 11, 83, 41}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 32}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 104, 1, 95, 198, 35, 1, 70}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 221, 110, 111, 35, 25, 202, 69}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 76, 238, 226, 101}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 188, 153, 149, 39}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 117, 98, 61, 182, 140, 66}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 224, 161, 44, 54, 197, 70, 159}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 199, 148, 187, 35}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 17, 75, 145, 161, 49, 48}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 17, 254, 119, 129, 232, 222}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 201, 143, 94}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 50, 190}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 78, 41, 5, 59, 253}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 184, 98, 191}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 180, 253, 170, 121}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 247, 124}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 190, 45, 248, 186, 65}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 129, 240, 154, 191}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 10, 170, 160}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 187, 134, 52, 79, 18}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 169, 249, 173, 167, 227}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 154, 94, 15, 135, 23, 46, 254}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 220, 20, 145, 92, 54, 10, 75}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 16, 148}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 105, 203, 139, 169, 248, 156}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 244, 145, 129, 26}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 202, 5, 217, 217, 146, 45, 170}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 131, 96, 145, 153, 123}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 204, 147, 189, 179}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 228, 54, 92, 159, 10, 51, 101}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 176, 1, 246, 102, 184}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 123, 152, 128}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 53, 217, 76}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 21}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 233, 138, 87, 216, 216, 198}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 91, 130, 3}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 174, 81, 212, 74, 35, 210}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 170, 190}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 16, 91, 166, 138, 120, 60, 121}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 202, 147, 219}, 226},
	{{30, 178, 111, 225, 73, 79, 173, 52, 0, 0, 0, 0, 0, 0, 0, 231}, 226},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 125}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 202, 101, 68, 255, 220, 130}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 56, 152, 173, 136, 207}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 207, 4, 46, 81, 89, 170, 201, 84}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 69, 42, 161, 78, 169, 3, 140}, 222},
	{{224, 48, 154, 231, 32, 0, 129, 3, 202, 180, 82, 205, 117, 77, 166, 53}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 156}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 93, 209, 127, 174, 133, 138, 174, 120}, 222},
	{{224, 48, 154, 231, 32, 0, 159, 14, 171, 222, 140, 205, 76, 109, 34, 34}, 222},
	{{224, 48, 154, 231, 32, 196, 51, 188, 95, 221, 167, 22, 69, 60, 214, 249}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 251, 175, 68, 101, 229, 230, 114, 140}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 31, 164, 16, 157}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 142, 113, 104}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 79, 91, 185, 134, 148, 10, 97, 157, 242}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 97, 26, 148, 33, 98, 145, 67}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 167, 20, 243, 200}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 169, 95, 16, 164, 103, 115, 94, 68, 153}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 20}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 102, 140, 102, 95, 217, 200}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 157, 72, 115, 97, 161}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 250, 71, 166, 45, 26, 247, 128, 49}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 245, 51, 222, 214, 30, 127}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 8, 84, 190}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 227, 197, 216, 138, 7, 141, 5, 153}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 222},
	{{224, 48, 154, 231, 32, 0, 206, 203, 37, 210, 198, 26, 93, 117, 58, 46}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 152, 64, 21, 147}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 209, 35, 115, 80, 178, 229, 6, 6, 116}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 205, 209, 122, 201, 192, 115, 114, 230, 81}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 59, 18, 187, 218, 215, 42}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 176, 171, 224, 94, 34}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{224, 48, 154, 231, 32, 0, 133, 219, 141, 57, 241, 190, 104, 153, 188, 122}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 158}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{224, 48, 154, 231, 32, 0, 5, 3, 199, 113, 194, 191, 151, 34, 108, 209}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 222},
	{{224, 48, 154, 231, 32, 0, 216, 176, 138, 77, 16, 62, 169, 103, 84, 8}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 4, 121, 100}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 174, 189, 139, 5, 20}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 222},
	{{224, 48, 154, 231, 32, 0, 221, 108, 186, 15, 246, 65, 123, 38, 114, 195}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 240, 36, 86, 241}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 22, 2, 73, 50, 189, 42, 20, 245}, 222},
	{{224, 48, 154, 231, 32, 148, 29, 128, 51, 227, 192, 166, 148, 222, 253, 177}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 37, 32, 75, 175, 58, 177, 147, 139}, 222},
	{{224, 48, 154, 231, 32, 0, 181, 157, 221, 35, 209, 187, 94, 220, 26, 37}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 223, 55, 24, 27, 2, 202, 111}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 237, 85, 194, 154, 81, 30}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 149, 203, 172, 18, 189, 174, 115, 111, 25}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 53, 47, 222}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 205, 60, 78, 93, 37, 2}, 222},
	{{224, 48, 154, 231, 32, 0, 235, 206, 229, 60, 106, 226, 210, 166, 73, 57}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 222},
	{{224, 48, 154, 231, 32, 249, 236, 169, 28, 11, 174, 104, 120, 147, 249, 6}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 28, 0, 45, 225}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 157, 154, 136, 241, 131, 187, 57, 215, 218}, 222},
	{{224, 48, 154, 231, 32, 0, 184, 56, 93, 230, 249, 156, 178, 188, 36, 244}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 162, 229, 112, 41, 11, 109, 37, 105}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 29}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 10, 163, 205, 192, 112}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 1, 27, 130, 27, 150, 222, 228, 15, 202}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 22, 233, 135, 243, 15, 178}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 154}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 189, 49, 209}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 140, 152, 245, 70, 35, 1}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 190, 231, 50, 38, 68, 39, 153, 20}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 90, 250, 169, 252, 92, 55, 27, 51, 248}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 230, 157, 58, 73}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 217, 64, 224, 190, 218, 27, 183, 86}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 177, 228, 235, 70}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 152, 149, 154}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 82, 61, 176, 82, 122, 108, 168, 8, 195}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 180, 25, 53, 124, 212, 134, 229, 144, 137}, 222},
	{{224, 48, 154, 231, 32, 0, 0, 0, 0, 0, 29, 43, 43, 110, 56, 210}, 222},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 247, 217, 204, 233}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 139, 10, 22, 5}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 165, 11}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 185, 248}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 234, 224, 241, 66, 24}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 207, 173}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 24, 45, 156, 85, 86}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 226, 216, 168, 244}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 70, 205, 85, 38}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 207, 88, 157}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 201, 69, 127, 2, 146, 228}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 127, 236}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 83, 21, 201, 90, 41, 56}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 158, 149, 32, 229, 46}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 20, 173, 5}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 90}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 153, 157, 131, 57, 140}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 129, 1, 175, 63, 139}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 114, 126, 217}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 220, 225, 74, 104, 104}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 247, 182, 29}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 223, 120, 229, 7, 108}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 102}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 89}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 177, 214, 33, 159, 119, 63, 41}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 192, 94, 16, 38, 223}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 62, 87, 255}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 27, 216, 118, 3, 43}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 6, 191, 66}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 190, 81, 112}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 206, 37, 125}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 226, 19, 91, 122, 230}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 170, 63}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 135, 249}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 150, 117, 217, 124}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 163}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 204, 52, 135, 241}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 189, 111, 162}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 87}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 245, 72}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 19, 214, 124, 23, 191, 1}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 171, 248, 54, 69, 131}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 140, 246}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 21, 179}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 206, 0, 247}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 103, 218}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 33, 31, 111, 120}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 156}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 181, 153, 183, 66}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 192, 148, 153}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 233, 32, 234, 115}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 26}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 17, 41}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 244, 126}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 64}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 132, 249}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 233, 213, 73, 145}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 114, 89, 95}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 100, 49, 177, 76}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 136}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 170, 37, 84, 148, 99}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 152}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 133}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 16, 67}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 235, 175, 73, 137, 131}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 119, 151, 148, 213, 199}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 251, 84, 165}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 239, 200, 177, 62}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 39, 201, 212, 97, 164}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 161, 76, 74}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 67, 238}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 138}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 248, 125}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 100, 11, 23}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 102, 11, 247, 43, 209}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 24, 111}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 66}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 216, 196, 51}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 30, 222, 183, 37, 162, 117}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 163}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 23, 205}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 165, 236, 137, 2, 217, 40}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 80, 154, 67, 57, 54, 154}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 7, 96, 102}, 218},
	{{123, 144, 170, 143, 85, 169, 130, 245, 214, 0, 0, 0, 0, 0, 0, 132}, 218},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 45}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 17}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 237}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 80}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 114}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 96}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 27}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 187}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 56}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 157}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 52}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 46}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 217}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 216}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 97}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 158}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 236}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 157}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 186}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 132}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 51}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 135}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 219}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 251}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 233}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 91}, 59},
	{{166, 224, 212, 100, 149, 55, 35, 210, 246, 108, 41, 245, 127, 174, 128, 0}, 59},
	{{75, 0, 0, 251, 39, 219, 167, 71, 92, 231, 250, 83, 252, 31, 23, 19}, 80},
	{{75, 0, 0, 0, 0, 17, 133, 240, 145, 47, 202, 1, 154, 124, 91, 251}, 80},
	{{75, 0, 0, 0, 0, 0, 18, 197, 182, 109, 176, 20, 115, 147, 195, 59}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 215, 110, 232, 184, 236}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 128}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 170, 72, 1, 250, 69, 16, 136, 216}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 3, 237, 30, 154, 58, 190, 203, 255, 140}, 80},
	{{75, 0, 0, 0, 135, 245, 201, 1, 92, 203, 120, 132, 99, 7, 10, 21}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 182, 66, 97}, 80},
	{{75, 0, 0, 0, 0, 26, 164, 5, 87, 74, 235, 121, 71, 197, 20, 129}, 80},
	{{75, 0, 0, 0, 0, 0, 195, 124, 168, 221, 33, 152, 252, 212, 228, 134}, 80},
	{{75, 0, 0, 240, 255, 31, 123, 31, 119, 89, 3, 165, 102, 98, 19, 27}, 80},
	{{75, 0, 0, 0, 0, 0, 58, 118, 178, 81, 5, 199, 249, 228, 116, 48}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 173, 136, 34, 12}, 80},
	{{75, 0, 0, 20, 196, 194, 211, 53, 146, 253, 37, 137, 135, 11, 238, 165}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 113, 74, 22}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 143, 62}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 221, 237, 183, 252, 119}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 141, 204}, 80},
	{{75, 0, 0, 0, 0, 0, 198, 127, 14, 225, 184, 246, 61, 204, 24, 157}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 198, 217}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 167, 55, 38, 185, 36, 221, 216}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 80},
	{{75, 0, 0, 232, 3, 242, 165, 132, 241, 57, 69, 95, 248, 213, 231, 219}, 80},
	{{75, 0, 0, 0, 0, 0, 20, 215, 94, 100, 69, 126, 51, 109, 169, 236}, 80},
	{{75, 0, 0, 56, 7, 5, 10, 228, 128, 103, 23, 120, 253, 135, 215, 184}, 80},
	{{75, 0, 0, 0, 0, 0, 16, 40, 165, 230, 68, 109, 56, 157, 88, 113}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 27, 132, 58, 102, 22, 238, 220, 148}, 80},
	{{75, 0, 0, 0, 75, 239, 219, 244, 35, 235, 133, 84, 18, 197, 135, 179}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 157, 130, 109, 14}, 80},
	{{75, 0, 0, 0, 5, 120, 203, 90, 62, 66, 127, 133, 105, 165, 75, 36}, 80},
	{{75, 0, 0, 0, 108, 227, 156, 203, 157, 141, 41, 68, 174, 48, 1, 186}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 143, 23, 32, 198, 9, 61, 188, 29}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 174, 72, 67, 93, 101, 217, 40}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 59, 4}, 80},
	{{75, 0, 0, 0, 0, 186, 81, 134, 254, 0, 255, 138, 202, 216, 151, 236}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 80, 196, 160, 24, 162, 72, 109}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 113, 129, 152, 36, 152, 82, 208, 142, 93}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 112, 65, 197}, 80},
	{{75, 0, 106, 57, 54, 168, 107, 122, 126, 50, 58, 133, 104, 250, 54, 171}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 99, 135, 198, 152, 28, 255, 67}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 136}, 80},
	{{75, 0, 0, 0, 0, 94, 177, 121, 88, 169, 129, 143, 131, 152, 188, 124}, 80},
	{{75, 0, 0, 0, 0, 0, 157, 118, 36, 31, 90, 30, 0, 193, 175, 106}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 16, 123, 167, 170, 133}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 162, 91, 155, 139, 127}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 123, 240, 253, 66, 99, 204, 111, 200}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 16, 248, 27, 248, 59}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 222, 70, 110, 27, 36, 130, 82, 19, 184}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 68, 142}, 80},
	{{75, 0, 0, 212, 101, 31, 132, 4, 170, 188, 229, 240, 14, 68, 104, 200}, 80},
	{{75, 0, 0, 0, 0, 81, 150, 90, 17, 18, 116, 149, 152, 55, 199, 235}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 236, 39, 192, 166, 89}, 80},
	{{75, 0, 0, 0, 0, 218, 71, 59, 11, 183, 127, 219, 194, 74, 215, 187}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 93, 152}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 155, 219, 161, 149, 8, 94, 5}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 76, 227, 64, 74}, 80},
	{{75, 0, 0, 0, 66, 166, 189, 125, 122, 58, 37, 28, 29, 31, 60, 195}, 80},
	{{75, 0, 0, 0, 143, 0, 52, 174, 247, 24, 36, 98, 235, 86, 239, 79}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 199, 183, 13, 108, 109}, 80},
	{{75, 0, 0, 0, 0, 0, 89, 197, 51, 117, 156, 140, 46, 147, 240, 70}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 209, 30}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 176, 174, 207, 221, 82, 31, 159}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 56, 185, 160, 68, 231, 208, 249, 109, 9}, 80},
	{{75, 0, 0, 0, 0, 137, 13, 101, 85, 108, 226, 87, 26, 228, 218, 144}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 137, 53, 176, 161, 182, 186, 56}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 245, 123, 46, 86, 176, 192, 139}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 9, 249, 6, 151, 210, 20, 233, 67}, 80},
	{{75, 0, 146, 250, 215, 207, 137, 19, 226, 124, 78, 90, 39, 208, 212, 94}, 80},
	{{75, 0, 0, 69, 62, 85, 224, 183, 202, 248, 61, 152, 205, 162, 124, 108}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 104, 42, 164, 233, 144}, 80},
	{{75, 0, 0, 0, 0, 185, 156, 8, 245, 199, 186, 206, 239, 29, 50, 119}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 61, 166, 159, 30, 30}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 44, 101, 254, 26}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 69, 36, 106, 165, 60, 207, 238, 168}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 32}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 164}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 81, 217}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 237, 83, 27, 66}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 135}, 80},
	{{75, 0, 0, 0, 0, 0, 146, 174, 192, 65, 71, 219, 199, 39, 86, 132}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 252, 48, 145, 114, 157, 120, 106}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 118}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 123, 206, 207, 165}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 215, 45, 41, 191, 134, 83, 14, 70, 127}, 80},
	{{75, 0, 0, 0, 123, 92, 6, 207, 4, 43, 190, 62, 76, 109, 251, 105}, 80},
	{{75, 0, 11, 166, 5, 71, 100, 99, 160, 202, 179, 125, 191, 18, 75, 177}, 80},
	{{75, 0, 0, 0, 0, 142, 85, 100, 211, 213, 27, 60, 102, 136, 14, 157}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{75, 0, 0, 0, 157, 143, 66, 190, 5, 58, 222, 28, 137, 142, 21, 188}, 80},
	{{75, 0, 0, 0, 0, 0, 201, 218, 43, 186, 160, 244, 158, 72, 69, 225}, 80},
	{{75, 0, 0, 0, 190, 101, 70, 127, 93, 69, 190, 246, 59, 83, 184, 214}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 210, 65, 184}, 80},
	{{75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 84, 15}, 80},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 181, 97, 12, 195, 209, 64, 44}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 176, 91, 75, 142, 157, 224}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 53, 13, 214, 236, 159, 167, 227, 82}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 97, 46, 22, 163, 79}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 96, 216, 242}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 18, 24, 166, 181, 143, 101, 243, 118}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 167, 230, 84}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 177, 99, 173, 108, 32, 116, 42}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 130, 177, 24, 119, 16, 214, 217}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 113}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 77, 160, 84, 75, 59}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 28, 206}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 47, 67, 123}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 64, 128, 105, 48, 86, 106, 18}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 64, 145, 247, 240, 139, 3, 26, 132}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 109, 190, 83, 179}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 113, 246, 248, 252, 198, 39, 167, 141}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 23}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 227, 30, 132, 49, 254}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 207, 199, 78, 83, 206, 128, 94}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 113, 65, 62}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 224, 204, 30, 120}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 55, 46, 218, 161, 60, 209, 255}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 135, 56, 163, 61}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 244, 230, 48, 136, 125, 16}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 69, 17, 2}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 93, 101, 77, 135, 80}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 83, 222, 112, 200, 218, 174}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 91, 0, 243, 4, 190, 225}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 54, 32, 236, 134, 218, 98, 246}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 211}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 188, 44, 225, 181, 165, 225}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 15, 94, 246, 40}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 89, 180, 29}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 226, 203, 124}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 201, 156, 38, 104, 2, 232}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 195}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 10, 141, 236, 91, 5, 238, 128, 218}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 77, 119, 191, 123, 241, 176}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 104, 16, 190, 112, 27, 249, 142, 173}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 226}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 39, 171, 227, 28, 172}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 61, 188, 108, 240, 144, 186, 236, 4}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 4, 177, 19, 43, 208, 19, 38}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 1, 1, 153, 161, 177, 114, 62, 102}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 53, 84, 203, 233}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 36, 71, 32}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 13, 52, 74, 188, 68, 108}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 161, 204, 82, 30, 88, 216, 245}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 21, 225, 166, 37, 90}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 149, 104}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 73, 37, 25}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 59, 21, 80, 255, 154, 59, 61}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 110, 254, 63}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 99, 60}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 234, 172, 195, 51}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 164, 109, 242, 125, 177, 79, 222, 130}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 125, 26, 87, 171, 21}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 80, 120, 46, 153, 243, 177, 130, 135}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 139, 36, 108, 12, 48, 55, 49, 229}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 241, 178, 173, 56, 131, 205, 216}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 241, 61, 144, 25, 50, 173, 155, 170}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 205}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 40, 113}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 62}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 199, 161, 66, 139, 172, 210, 56}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 150, 116, 134}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 107, 49, 184, 174, 40}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 251}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 78, 193, 249, 186, 52}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 141, 113, 111, 173, 223, 234, 25, 11}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 189, 184}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 23, 209, 84}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 23, 38, 136, 130, 70, 231, 6, 216}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 200, 231, 183, 236, 154}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 125, 95, 46}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 140, 135, 6, 118, 230, 94, 195}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 118, 131, 133, 186, 134, 221, 95}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 183}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 254, 221, 240, 154, 140}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 102, 253, 4, 159, 70}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 59, 30, 111, 85, 180}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 203, 182, 130, 194, 155, 151, 204}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 101, 75, 248, 106}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 200, 26, 34}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 191, 222, 230, 1, 247, 158}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 131, 14, 162, 117, 65, 193, 204}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 177},
	{{197, 128, 190, 87, 47, 53, 92, 64, 0, 0, 0, 0, 0, 0, 194, 211}, 177},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 27, 240}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 63, 40, 105}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 63, 207, 26}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 114, 106}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 109, 170, 18}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 75}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 145, 126}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 125, 252}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 240, 255}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 230, 251, 172}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 67, 19, 189}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 34, 187}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 88}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 141}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 234, 171}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 104, 73}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 3, 98}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 46}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 176, 157}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 101, 202}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 48}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 103, 190, 48}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 169}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 139}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 21}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 239, 230, 239}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 171, 142}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 155}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 160, 225}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 149}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 89}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 80, 235, 33}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 129, 74}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 205}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 45}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 87}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 197}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 216}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 52, 190}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 26}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 76, 109}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 98, 78}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 160}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 103, 31}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 204}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 203, 161}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 157, 251}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 215, 157, 101}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 56}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 154, 41, 158}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 141, 230, 86}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 182, 131}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 145}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 254, 68}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 238, 49, 33}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 89, 219, 143}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 230, 73, 112}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 181, 193, 41}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 130, 27, 227}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 242, 147}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 94, 242}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 235, 251, 131}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 43}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 42}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 125, 101}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 93, 84}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 134, 109, 124}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 0}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 106, 151}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 207}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 197, 173}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 0, 209}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 199, 165}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 249, 140, 60}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 90, 42, 29}, 44},
	{{249, 10, 76, 217, 225, 20, 124, 205, 44, 159, 190, 8, 0, 0, 199, 156}, 44},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 5, 225}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 4}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 191, 23}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 61}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 68}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 45, 167, 238}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 52, 200, 252, 21}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 26, 33, 117}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 155}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 133}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 206, 251, 91}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 22, 22, 3, 221}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 190, 181, 140}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 108, 24, 189}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 28}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 101, 194, 90}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 51, 95}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 19, 241, 173, 160}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 108, 249, 8}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 135}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 101, 253, 168, 116}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 198, 175}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 106, 16, 47}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 16}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 67, 227, 58}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 244}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 69}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 175}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 114, 205}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 143, 190}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 176}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 181, 3, 240}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 131, 255, 94}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 104, 60}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 100, 153}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 212, 182}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 122, 59, 181}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 190}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 206, 127, 70}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 227, 247, 248}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 63}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 4, 119}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 252, 106}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 30, 189}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 217}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 218, 171, 192, 190}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 193, 45, 165}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 148, 15}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 127, 179}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 234}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 156, 181, 251}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 168, 13}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 40, 113, 71}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 222, 33, 98, 232}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 33}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 119}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 152, 233, 70, 67}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 228, 114}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 179, 217, 17}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 17, 238, 150}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 236}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 230, 106}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 187, 251, 219}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 234}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 120, 204, 255}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 63, 18}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 63, 187, 254, 105}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 151, 254, 91}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 15, 18}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 214, 28, 131, 145}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 149}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 83, 19, 164}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 0, 0, 0}, 206},
	{{180, 226, 0, 167, 137, 232, 174, 120, 113, 95, 22, 184, 0, 234, 138, 105}, 206},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 213, 62, 184, 187, 254, 122}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 223, 65, 124, 96, 88}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 17, 166}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 152, 191, 75, 168}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 221, 242, 44, 105, 239, 134, 9}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 22, 194, 159, 112, 237}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189}, 64},
	{{123, 153, 102, 192, 0, 224, 170, 2, 155, 68, 93, 48, 237, 199, 223, 92}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 40, 176}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 117, 215, 21, 184, 77}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 19, 44, 80, 181, 144, 206, 82}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 233}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 59, 248}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 100, 129, 107, 191, 181, 185, 130}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 193, 164, 131, 48, 114}, 64},
	{{123, 153, 102, 192, 0, 148, 9, 173, 215, 157, 165, 120, 211, 206, 114, 105}, 64},
	{{123, 153, 102, 192, 0, 0, 37, 71, 88, 184, 122, 49, 136, 198, 20, 146}, 64},
	{{123, 153, 102, 192, 0, 201, 113, 138, 148, 80, 26, 103, 246, 137, 222, 128}, 64},
	{{123, 153, 102, 192, 0, 0, 103, 7, 35, 107, 80, 19, 40, 140, 122, 199}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 175, 55, 52, 95, 63}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 136}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 134, 243, 174, 128, 135, 190}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 4, 97, 200, 169, 169, 224, 194, 12}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 66}, 64},
	{{123, 153, 102, 192, 0, 0, 250, 126, 118, 34, 255, 237, 107, 231, 119, 189}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 82, 12, 73, 105, 173, 100, 40, 253}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 64},
	{{123, 153, 102, 192, 0, 0, 255, 135, 148, 133, 209, 132, 216, 208, 81, 3}, 64},
	{{123, 153, 102, 192, 0, 0, 205, 185, 121, 11, 204, 91, 142, 81, 3, 6}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 90, 109, 177, 207, 34, 242}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 143, 241}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 40, 253, 236, 232, 222, 236, 45}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 186, 149}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 103, 99, 123, 255, 130}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 250, 107, 237, 247, 198}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 80}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 236, 136, 48, 8, 137, 229, 159, 82, 18}, 64},
	{{123, 153, 102, 192, 0, 89, 150, 116, 184, 84, 44, 111, 172, 188, 239, 111}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 77}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 81, 126, 37, 146}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 207, 54, 62, 255, 10, 116, 32, 233}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 45, 95, 22, 86, 165, 12}, 64},
	{{123, 153, 102, 192, 0, 0, 2, 82, 14, 79, 169, 150, 180, 89, 89, 171}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 124, 112}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 10, 249, 81, 18, 238, 110, 165}, 64},
	{{123, 153, 102, 192, 0, 34, 72, 125, 178, 199, 199, 65, 165, 112, 106, 99}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 196, 170}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 156, 54, 16, 48, 150, 115, 62, 78}, 64},
	{{123, 153, 102, 192, 0, 0, 4, 252, 161, 103, 123, 241, 204, 68, 182, 147}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 73, 195, 206, 69, 235, 41, 175}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 50}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 191, 132, 245, 118, 155, 158, 112, 142}, 64},
	{{123, 153, 102, 192, 0, 33, 252, 84, 55, 183, 193, 63, 18, 178, 152, 86}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 237, 161, 70, 195, 65, 10}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 241, 43, 29, 14, 218, 165, 246, 111}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 239}, 64},
	{{123, 153, 102, 192, 92, 97, 246, 5, 116, 155, 151, 163, 46, 188, 97, 81}, 64},
	{{123, 153, 102, 192, 0, 0, 198, 229, 119, 2, 115, 124, 218, 88, 16, 126}, 64},
	{{123, 153, 102, 192, 0, 0, 127, 186, 160, 128, 231, 30, 16, 19, 227, 190}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 216, 95, 38, 158, 196, 146, 63}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 85, 207, 20, 213}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 145, 39, 44, 195, 50, 99, 184, 219, 196}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 166, 106, 158, 4, 6, 74}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 155}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 188, 211, 77, 49, 195}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 152, 83, 214, 47}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 12, 252, 105, 120, 42, 78, 127}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 150, 49, 116, 99, 7, 155}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 79, 69, 87, 198, 114, 4, 250, 107}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 17, 218, 95, 218, 141, 8, 35}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 227, 62, 247, 209, 250}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{123, 153, 102, 192, 0, 238, 230, 4, 93, 121, 245, 216, 58, 41, 224, 123}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 78, 62, 98, 146, 47, 142, 2, 52, 122}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 249, 221}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 74, 150, 7, 4, 78, 116, 141}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 215, 104}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 145}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 97, 97, 56, 113, 120, 199}, 64},
	{{123, 153, 102, 192, 0, 0, 168, 141, 223, 213, 168, 42, 90, 201, 226, 41}, 64},
	{{123, 153, 102, 192, 0, 248, 164, 125, 228, 99, 100, 166, 79, 37, 236, 225}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 255, 139, 54, 107, 179, 233, 243, 205, 51}, 64},
	{{123, 153, 102, 192, 0, 0, 66, 160, 213, 99, 208, 107, 65, 72, 89, 254}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 167, 158, 17, 107, 225, 92}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 134, 223, 150, 252}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 148, 156, 11, 42, 194, 59, 107}, 64},
	{{123, 153, 102, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 49, 88}, 64},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 217, 36, 46}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 239, 100}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 61}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 29, 32, 90}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 17}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 214, 139}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 162, 47}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 131, 120, 105}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 96}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 43}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 91}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 152}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 164, 100, 55}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 56}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 78, 56}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 23}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 25}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 187, 164, 77}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 77, 30, 188}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 249, 224}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 86, 82, 159}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 127}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 26, 184, 28}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 161, 32, 124}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 20, 10}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 111, 212}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 235}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 206}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 212}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 241}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 230, 76}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 135, 38, 22}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 252, 231, 90}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 6, 253, 92}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 63}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 216, 78, 249}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 146, 108, 109}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 27, 126}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 73}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 127}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 12, 249, 176}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 157}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 93}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 161}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 176, 229}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 48, 11, 194}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 100, 173, 93}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 137, 107, 118}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 194, 71, 147}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 1}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 96, 179, 88}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 224}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 90, 53, 17}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 39, 146, 144}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 35, 229, 146}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 213}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 173, 195}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 31, 117}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 18, 8, 163}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 4, 195, 192}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 249, 29, 165}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 106}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 231}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 223}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 109}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 166, 155, 222}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 184}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 90}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 57, 195}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 0}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 163, 108, 139}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 0, 52}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 22, 105, 61}, 236},
	{{5, 144, 206, 158, 239, 189, 171, 120, 69, 46, 128, 237, 0, 0, 185, 194}, 236},
	{{159, 235, 60, 0, 0, 0, 194, 179, 49, 185, 29, 220, 139, 63, 234, 220}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 250, 11, 10}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{159, 235, 60, 0, 0, 0, 87, 15, 213, 144, 243, 48, 216, 208, 217, 182}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 234, 135, 119, 79, 99, 116, 10, 92, 70}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 128, 99, 20, 166, 118, 197, 251, 185, 96}, 101},
	{{159, 235, 60, 0, 4, 194, 101, 91, 155, 148, 253, 243, 103, 179, 45, 149}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 159, 180}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 240, 88, 118, 102, 188, 77}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 85, 209, 102}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 164, 218, 0}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{159, 235, 60, 0, 0, 0, 76, 15, 117, 154, 248, 249, 36, 192, 15, 88}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 195}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 191, 119, 42, 179, 221, 142, 178, 50, 173}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 99, 142}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 228, 237, 200}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 91, 148, 148, 14, 180}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 238, 188, 157, 109, 198, 37, 196, 245}, 101},
	{{159, 235, 60, 0, 0, 251, 152, 18, 233, 164, 236, 174, 177, 180, 52, 160}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 117, 81, 111, 200, 92, 164, 224, 214}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 198, 10, 249, 241, 164, 6}, 101},
	{{159, 235, 60, 236, 2, 83, 99, 73, 234, 78, 210, 198, 214, 46, 85, 120}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 197, 131, 59, 91, 208, 102, 210, 96}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 227, 193, 113, 153, 94, 90, 202, 190, 50}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 208, 35, 77, 186, 45, 25, 153, 151, 6}, 101},
	{{159, 235, 60, 0, 66, 97, 167, 164, 239, 224, 227, 118, 140, 167, 69, 52}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 107, 45, 163, 142, 106, 106, 87, 106, 222}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 89, 132, 255, 29, 103, 12, 86, 228}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 77, 195}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 176, 170, 30}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 42, 207, 223, 136, 53, 179, 84}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 22, 19, 1, 74, 55, 241}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 58, 137, 218, 94, 61, 229, 222}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 48, 171, 162, 191, 134, 114, 157}, 101},
	{{159, 235, 60, 0, 0, 0, 128, 91, 45, 40, 115, 29, 78, 89, 123, 158}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 85, 51, 178, 189, 247}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 29, 53, 134, 73, 60, 237, 251, 44}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 139, 98, 242, 40, 197, 98, 62, 109, 213}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 171, 122, 150, 57, 167, 183}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 180, 4, 207, 184, 79}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 80, 88, 58, 128, 181, 82, 57, 11}, 101},
	{{159, 235, 60, 0, 0, 2, 191, 82, 105, 98, 95, 230, 232, 131, 183, 104}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 93, 64, 228, 57, 239, 43, 122}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 145, 81}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 237, 56}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 242, 110, 125, 227, 221, 119}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 131, 103, 252, 62, 244}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 172, 113}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 63, 59, 140, 135, 154, 95, 44, 167, 172}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 181, 52}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 65, 180, 4, 168, 88}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 238, 68, 249}, 101},
	{{159, 235, 60, 0, 96, 76, 229, 200, 156, 28, 148, 50, 104, 103, 45, 155}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 102, 14, 55, 135, 219, 189, 34}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 24, 53, 13, 174, 75, 192}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{159, 235, 60, 0, 0, 0, 184, 68, 114, 75, 119, 107, 230, 247, 244, 117}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 249, 60}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 229, 142, 203}, 101},
	{{159, 235, 60, 0, 0, 34, 216, 58, 107, 230, 205, 185, 83, 19, 180, 112}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 51, 223, 247, 128, 140, 74, 130, 2, 39}, 101},
	{{159, 235, 60, 0, 0, 27, 230, 25, 147, 172, 36, 56, 218, 83, 15, 174}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 183}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 79, 233, 18}, 101},
	{{159, 235, 60, 0, 0, 244, 246, 247, 67, 184, 0, 222, 237, 190, 214, 254}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 84, 46, 177, 45, 28, 101, 7}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 42, 41, 58}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 143, 85, 108, 239, 138, 135, 88}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 107, 111, 53, 109, 32}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 230, 95, 211, 199, 191}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 50, 188}, 101},
	{{159, 235, 60, 0, 0, 0, 87, 39, 103, 10, 239, 194, 246, 175, 238, 37}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 178, 139, 146, 151, 115, 58, 25, 96}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 63, 18, 151, 15, 196, 95, 155}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 237, 53, 114, 121, 207, 130}, 101},
	{{159, 235, 60, 0, 198, 151, 36, 254, 177, 60, 42, 93, 44, 19, 89, 231}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 226}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 112, 224, 242, 122, 94, 98}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 12, 113, 44, 60, 168, 103}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 55, 98, 100, 239, 201, 221, 50, 28, 178}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 29, 48, 70, 137, 185, 199}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 149, 13, 0, 37, 65, 104, 138, 183, 0}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 99}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 149, 16, 13, 200, 123, 252}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 101},
	{{159, 235, 60, 0, 0, 0, 99, 19, 161, 190, 138, 60, 178, 153, 73, 57}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 41, 152, 146, 180, 144}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 137, 216, 248}, 101},
	{{159, 235, 60, 0, 0, 76, 94, 3, 45, 217, 61, 102, 68, 177, 107, 168}, 101},
	{{159, 235, 60, 0, 0, 51, 89, 73, 119, 66, 164, 145, 31, 201, 57, 190}, 101},
	{{159, 235, 60, 0, 0, 0, 0, 0, 19, 5, 156, 250, 47, 243, 227, 194}, 101},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 52}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 120, 153, 35, 74, 33, 60, 188, 232, 184}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 22, 208, 6, 62, 128, 60, 165, 157, 247}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 90, 192, 250, 60, 49, 248, 85, 37, 120}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 237, 23, 144, 192, 2, 84, 154, 182}, 49},
	{{42, 194, 150, 0, 0, 57, 230, 216, 12, 105, 222, 59, 45, 25, 2, 130}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 49},
	{{42, 194, 150, 0, 0, 22, 146, 143, 214, 39, 220, 140, 253, 13, 228, 119}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 222}, 49},
	{{42, 194, 150, 0, 0, 139, 189, 55, 247, 206, 199, 33, 122, 254, 90, 245}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 160, 201, 181, 187, 164, 147, 73, 221}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 225, 30, 152, 251, 159}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 121, 75}, 49},
	{{42, 194, 150, 0, 0, 0, 161, 94, 161, 248, 250, 28, 13, 83, 52, 182}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 91, 8, 73, 255, 147, 23, 164, 58, 175}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 98, 146, 142, 242, 49}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 2, 143, 0, 91, 124, 152, 15, 140, 1}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 69, 41, 225, 183, 52, 4, 209, 208}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 229, 124, 123, 85, 122, 126, 183}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 117, 60, 6, 24, 132, 228}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 116, 82, 233, 109, 26}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 156}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49},
	{{42, 194, 150, 0, 0, 75, 201, 39, 138, 92, 245, 133, 180, 221, 179, 41}, 49},
	{{42, 194, 150, 0, 0, 79, 244, 137, 183, 206, 211, 7, 59, 73, 26, 229}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 73}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 175, 57, 96}, 49},
	{{42, 194, 150, 0, 0, 0, 77, 154, 179, 228, 107, 1, 194, 190, 31, 195}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 170, 32, 119, 177, 53, 209, 123, 255}, 49},
	{{42, 194, 150, 0, 0, 0, 108, 242, 206, 211, 63, 141, 24, 103, 44, 106}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 16, 145, 252}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 91, 106, 62, 100, 147}, 49},
	{{42, 194, 150, 0, 0, 0, 21, 201, 211, 53, 201, 244, 15, 149, 121, 241}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 231, 245, 208, 171, 124}, 49},
	{{42, 194, 150, 0, 0, 0, 222, 245, 223, 28, 28, 131, 32, 9, 102, 181}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 215, 126, 29, 26, 45, 77, 240, 194}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50}, 49},
	{{42, 194, 150, 0, 0, 0, 90, 170, 250, 198, 220, 116, 206, 56, 35, 225}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 83, 124}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 209, 16}, 49},
	{{42, 194, 150, 0, 0, 0, 178, 50, 175, 41, 121, 64, 28, 212, 93, 230}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 210, 30, 141, 238, 196, 57}, 49},
	{{42, 194, 150, 0, 0, 0, 176, 51, 118, 230, 37, 198, 6, 71, 171, 254}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 58, 65, 169, 207, 210, 11}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 254, 182, 254, 194, 36, 120, 199, 116, 25}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49},
	{{42, 194, 150, 0, 0, 206, 89, 213, 154, 125, 113, 156, 131, 135, 221, 187}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 49},
	{{42, 194, 150, 0, 0, 128, 44, 249, 112, 3, 74, 178, 31, 93, 69, 154}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 219, 228, 244, 149, 43, 81, 234, 155}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 110}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 193, 152, 101, 119, 87, 217, 197, 26}, 49},
	{{42, 194, 150, 0, 0, 137, 99, 164, 25, 224, 79, 213, 185, 18, 250, 227}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 51, 38, 66, 152, 221}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 83}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 75, 216, 176, 52, 198, 229}, 49},
	{{42, 194, 150, 0, 170, 202, 146, 88, 8, 23, 20, 82, 66, 108, 225, 52}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 174, 138, 111, 24, 207, 207, 25, 37}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 99, 59, 200, 251, 87, 92, 1, 191}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 175, 31}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 41, 104}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 87, 108, 156, 23, 131, 174}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 185, 6, 180, 174, 75, 169, 48, 165}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 236, 221, 134}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 59, 211, 26, 221, 162}, 49},
	{{42, 194, 150, 0, 0, 255, 196, 183, 119, 88, 113, 8, 76, 168, 41, 254}, 49},
	{{42, 194, 150, 0, 0, 214, 36, 239, 126, 132, 36, 223, 34, 48, 15, 118}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 87, 143, 197, 167, 11, 110, 25}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 29, 144, 230, 101, 43}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 66, 118, 50, 28, 201}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 64, 169}, 49},
	{{42, 194, 150, 0, 57, 123, 21, 240, 7, 180, 248, 233, 119, 55, 103, 56}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 134, 129, 24, 133, 165, 171}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 58, 90, 70, 2, 248, 191, 92, 139, 157}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 71, 208, 55, 7, 107, 73, 154}, 49},
	{{42, 194, 150, 0, 0, 99, 98, 111, 160, 203, 112, 147, 225, 203, 26, 205}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 108, 130, 248, 221, 155, 83}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49},
	{{42, 194, 150, 0, 225, 203, 251, 115, 45, 170, 143, 74, 32, 156, 185, 120}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 100, 206, 7, 61, 41, 235}, 49},
	{{42, 194, 150, 0, 0, 0, 155, 33, 203, 231, 22, 2, 114, 154, 220, 6}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 161}, 49},
	{{42, 194, 150, 0, 0, 0, 130, 224, 230, 208, 198, 183, 226, 167, 206, 150}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 49},
	{{42, 194, 150, 0, 255, 213, 117, 72, 23, 116, 220, 142, 167, 163, 11, 159}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 2, 164, 50, 131, 147, 243, 205, 202}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 85, 255}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 214, 176, 233, 168, 121, 31}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 203, 97, 67, 58, 25, 61}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 45, 109, 106, 160, 111}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 38, 145, 20, 63, 231, 80, 140, 194}, 49},
	{{42, 194, 150, 0, 0, 0, 4, 57, 107, 138, 253, 95, 7, 105, 190, 235}, 49},
	{{42, 194, 150, 0, 0, 0, 72, 63, 94, 100, 22, 138, 41, 102, 101, 9}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 198, 91, 200, 86, 146, 188, 62}, 49},
	{{42, 194, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 49},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 124, 22, 42, 90, 160, 97}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 182}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 184, 56, 24, 141, 240, 38, 60, 6}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 138, 23, 104, 39, 57, 97}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 100, 208}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 97}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 201, 84, 139, 96, 136, 232, 247}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 54, 239, 255, 10, 120, 190, 26, 120, 121}, 179},
	{{205, 96, 0, 0, 0, 142, 191, 156, 47, 61, 78, 195, 55, 158, 119, 162}, 179},
	{{205, 96, 0, 0, 0, 223, 18, 100, 172, 137, 202, 77, 65, 36, 151, 211}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 155, 75, 48, 23, 212, 113}, 179},
	{{205, 96, 0, 0, 0, 0, 158, 154, 61, 179, 79, 69, 132, 0, 146, 167}, 179},
	{{205, 96, 0, 0, 0, 0, 125, 6, 237, 207, 136, 0, 137, 113, 229, 250}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 48, 235, 11}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116}, 179},
	{{205, 96, 0, 190, 240, 177, 238, 94, 119, 76, 13, 172, 16, 53, 92, 243}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 218}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 230, 54}, 179},
	{{205, 96, 0, 0, 0, 253, 68, 173, 119, 64, 39, 183, 57, 172, 132, 224}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 84, 113, 65, 86, 44, 144}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 0}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 29, 107}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 176, 248, 242, 46, 52, 209, 23}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 27, 62, 76, 34, 62, 46}, 179},
	{{205, 96, 0, 0, 95, 182, 87, 13, 30, 252, 242, 56, 186, 154, 30, 69}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 105, 124, 122, 167, 69, 143}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 169, 175, 234, 86, 62, 56, 205, 154, 134}, 179},
	{{205, 96, 184, 183, 178, 88, 37, 22, 198, 230, 249, 15, 142, 227, 99, 238}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 56, 233, 68, 243, 225, 195, 86}, 179},
	{{205, 96, 76, 254, 157, 6, 192, 117, 36, 34, 102, 6, 97, 116, 142, 97}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 81}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 171}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 76, 207}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 226, 49, 240, 125, 255, 40, 20}, 179},
	{{205, 96, 0, 0, 0, 134, 244, 227, 166, 101, 8, 64, 89, 200, 165, 65}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 232, 15, 81}, 179},
	{{205, 96, 0, 0, 0, 138, 215, 174, 100, 107, 19, 239, 139, 6, 208, 12}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 230, 100}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 187, 39, 246, 100, 191, 207, 206}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 134, 226, 110, 17, 196, 80}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 47, 78}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 135, 209, 251, 17, 90, 166, 167}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 166, 1}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 245}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 137, 112, 218, 90, 245, 34}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 64, 156, 119, 124, 60, 155, 25}, 179},
	{{205, 96, 0, 77, 167, 197, 1, 139, 190, 194, 197, 145, 154, 216, 148, 67}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 99, 140, 67, 150, 4, 85, 234, 61}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 165, 20, 140, 101, 184, 163, 15, 242, 7}, 179},
	{{205, 96, 0, 235, 107, 35, 85, 119, 6, 116, 51, 40, 165, 170, 62, 22}, 179},
	{{205, 96, 37, 83, 170, 36, 148, 95, 110, 210, 10, 217, 38, 160, 93, 149}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{205, 96, 0, 32, 238, 15, 129, 156, 151, 158, 23, 182, 197, 109, 216, 66}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 24, 162, 72, 243, 241, 48, 214}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 199, 17, 236, 88}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 161, 146}, 179},
	{{205, 96, 0, 0, 0, 20, 54, 211, 93, 237, 56, 45, 190, 112, 40, 193}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 146, 122, 184, 78, 186, 129, 152, 24}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 192, 51, 212, 165, 74, 229, 54, 251}, 179},
	{{205, 96, 0, 157, 235, 149, 77, 177, 130, 166, 150, 20, 51, 82, 163, 76}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 204, 75, 107}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 31, 84, 247, 36, 106, 232}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 2, 52, 218, 190, 243, 80}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 36, 83, 247, 31, 202, 248, 185, 121}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 121, 59, 215, 186, 36, 177, 139}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 92, 57, 37, 165, 205, 64, 157, 19}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 190, 255, 202, 145}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 230, 133}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 227, 136, 225, 97, 163, 174, 253, 66, 192}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 64, 23, 78}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 229, 113, 63, 186, 14, 197, 243}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 71, 127, 22, 71, 200, 3, 83}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 114, 193, 91, 186, 229, 124}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 136, 88, 0}, 179},
	{{205, 96, 0, 0, 172, 48, 98, 75, 212, 229, 46, 97, 139, 42, 100, 22}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 172, 44, 121, 9}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 108}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 48, 166, 83, 183, 61, 162, 96, 177}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 191}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{205, 96, 155, 175, 183, 50, 174, 102, 61, 110, 73, 92, 195, 135, 112, 115}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 161}, 179},
	{{205, 96, 0, 22, 110, 98, 221, 237, 248, 106, 15, 114, 89, 219, 141, 13}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 208, 35, 238, 37, 174, 236}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 159, 176, 31, 39, 17, 18, 162}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 91, 246, 155, 180, 131, 87, 152, 22}, 179},
	{{205, 96, 0, 0, 0, 78, 85, 94, 67, 10, 23, 205, 122, 11, 224, 229}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 57, 124}, 179},
	{{205, 96, 0, 0, 0, 238, 191, 105, 154, 225, 42, 37, 172, 167, 80, 32}, 179},
	{{205, 96, 0, 0, 0, 0, 151, 59, 194, 103, 175, 159, 65, 46, 75, 240}, 179},
	{{205, 96, 0, 0, 0, 0, 0, 0, 0, 86, 59, 86, 12, 100, 117, 184}, 179},
	{{205, 96, 0, 0, 0, 65, 89, 225, 221, 242, 122, 32, 213, 185, 128, 51}, 179},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 76}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 226}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 184}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 75, 229}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 125}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 70, 118}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 188}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 74}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 111}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 4, 243}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 254, 216}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 163, 225}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 115}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 163}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 14, 46}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 96}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 88}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 48}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 191}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 21, 78}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 242, 49}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 44}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 222}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 45}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 220}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 133}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 69}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 160, 95}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 118}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 198, 149}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 211}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 174}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 199}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 67}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 3, 61}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 103}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 73, 189}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 28}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 119, 43}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 135}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 119}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 116}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 166}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 115, 63}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 108, 96}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 6}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 5}, 112},
	{{19, 65, 141, 20, 127, 77, 70, 205, 151, 115, 157, 23, 118, 128, 0, 0}, 112},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 122, 62}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 153, 231, 168}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 43, 179, 118}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 203, 166}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 168, 195}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 65, 74, 174}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 173, 226, 9}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 4}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 192, 196, 35}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 82, 45}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 127, 224}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 174}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 68, 131}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 136}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 215, 208, 230}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 54, 105, 126}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 202, 58, 234}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 185, 177}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 184, 228, 238}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 183, 90, 82}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 63}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 187, 51, 207}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 187, 99, 235}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 8, 82, 46}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 32}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 219, 193}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 33}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 146, 40, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 80}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 90}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 250, 69, 196}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 177}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 171, 215, 138}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 73, 110, 178}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 170}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 142, 222, 247}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 5, 148}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 92, 224, 71}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 242, 1, 162}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 190, 58, 89}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 203, 151}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 223, 132}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 6, 236, 129}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 22, 57}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 104, 15, 149}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 111, 230}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 15, 255}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 191}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 172, 179, 126}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 167, 66, 241}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 76, 193, 66}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 204, 186}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 37, 86, 223}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 255, 242, 228}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 121, 232, 221}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 84}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 112, 31}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 148, 183}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 119, 132, 246}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 12, 199}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 122, 95, 212}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 241}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 14, 68, 140}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 161, 248}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 167}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 193}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 1}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 82, 142, 221}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 241, 81, 184}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 117, 58, 8}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 71}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 25}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 149, 210}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 169}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 93}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 232, 140}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 32}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 0, 0}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 47, 237}, 31},
	{{96, 11, 214, 40, 245, 251, 61, 64, 128, 241, 183, 183, 0, 0, 217, 27}, 31},
	{{120, 4, 235, 112, 34, 128, 0, 227, 179, 152, 240, 152, 197, 92, 129, 160}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 205, 247, 196}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 42, 170, 106}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 77, 188, 147, 102, 119, 114, 28, 170, 167}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 131, 65, 221, 72, 158, 226, 200, 215}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 47, 190, 101, 159, 90, 214}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 181, 69, 17, 49, 21, 3, 249, 113}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 217, 31, 195, 205, 28, 180, 10, 152}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 145, 24, 247}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 85, 203, 220, 188, 244, 42, 102}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 148, 238, 233, 187, 38, 54}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 191, 1, 215}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 238, 209, 89, 144, 135, 166, 164}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 118, 51, 109, 171, 129, 213, 97, 37, 79}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 144, 100, 167, 173, 133, 10, 102, 72, 154}, 111},
	{{120, 4, 235, 112, 34, 128, 110, 221, 66, 96, 42, 165, 13, 147, 126, 214}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 21, 40, 33, 26, 199}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 254, 49, 239, 21, 52}, 111},
	{{120, 4, 235, 112, 34, 128, 240, 15, 129, 54, 117, 154, 68, 60, 161, 183}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 232, 165, 248, 194, 247, 21, 248, 68}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 52, 43, 126, 107, 117, 236, 94, 10, 244}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 78, 172, 33}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 245, 130, 162, 238, 88}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 111, 16, 123, 85, 92, 185}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 103, 7, 224}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 57, 100, 51, 188, 13}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 234, 101, 131, 81}, 111},
	{{120, 4, 235, 112, 34, 128, 223, 214, 82, 107, 255, 215, 129, 11, 152, 50}, 111},
	{{120, 4, 235, 112, 34, 128, 164, 53, 164, 176, 4, 83, 144, 130, 119, 7}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 253, 251, 198}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 72, 51}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 127, 246, 247, 117, 121, 137, 219, 174}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 59, 103, 121, 130, 211}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 232, 54, 55, 42, 79, 254, 25}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 248, 185, 206}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 153, 49, 52, 40}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 4, 184, 241, 27, 26}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 50, 138, 209, 68, 233}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 151, 95, 52}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 211, 221, 28, 128, 152, 254, 26}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 1, 120, 177, 56, 238, 239, 78}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 224, 236, 55, 31, 160, 211}, 111},
	{{120, 4, 235, 112, 34, 128, 210, 136, 24, 155, 240, 187, 121, 179, 171, 137}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 136, 194, 42, 53}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 240, 34, 213, 55, 83, 168, 165, 96, 174}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 89, 185}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 35, 175}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 165, 111, 29, 150, 64, 178}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 77, 5, 243, 15, 53, 185, 84}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 111, 224, 58, 212, 228, 98, 159}, 111},
	{{120, 4, 235, 112, 34, 128, 110, 251, 160, 6, 190, 4, 239, 76, 26, 35}, 111},
	{{120, 4, 235, 112, 34, 128, 204, 138, 114, 144, 10, 185, 1, 86, 232, 229}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 209, 245, 148, 127}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 205, 46, 64, 251}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 147, 219, 27}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 238, 100, 183}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 117, 6, 38, 64, 189, 234, 7}, 111},
	{{120, 4, 235, 112, 34, 128, 19, 99, 189, 138, 60, 159, 86, 178, 122, 46}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 51, 142, 107, 234, 195, 105, 178, 156, 153}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 31, 71, 33, 57, 38, 248, 148, 218}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 19, 60, 243, 23, 97}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 132, 44, 8, 226, 163, 142, 91}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 110, 31, 67, 9, 253, 67, 119}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 195, 43, 133, 159}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 162, 120}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182}, 111},
	{{120, 4, 235, 112, 34, 128, 174, 170, 251, 74, 236, 136, 194, 23, 97, 40}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 230, 119, 131, 241, 8, 251, 191}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 19, 151, 39, 16, 226}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 33, 247, 149, 84, 221, 250, 34, 95, 205}, 111},
	{{120, 4, 235, 112, 34, 128, 188, 195, 27, 116, 250, 158, 213, 124, 209, 168}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 229, 124, 177, 2, 58, 86}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 107, 186, 84, 161, 180, 20, 181, 252, 201}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 31, 251, 177}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 183, 211}, 111},
	{{120, 4, 235, 112, 34, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 111},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 98, 26}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 237, 206, 89}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 40, 189, 40}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 177}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 24, 23, 20}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 192}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 110, 117, 133, 242, 25}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 239, 229, 93}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 4, 173, 136}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 68, 232, 100, 187}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 117}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 42, 225, 122, 169}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 223, 185, 18, 219}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 105, 90, 212, 75}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 86, 85, 108, 26}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 103, 192}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 251, 33, 22, 63}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 166, 120}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 71, 181, 192}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 218, 252, 56, 242}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 1, 184}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 135}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 66, 101}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 49, 203, 47, 79}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 142, 72, 92}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 43}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 239, 201, 86, 146}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 8, 255, 110, 103}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 52, 99}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 226, 109}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 76, 212}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 96, 7, 133}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 169, 243, 167, 229}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 42, 17, 251, 219}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 83}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 164, 186, 8, 149}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 96}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 129, 220}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 45, 205, 77}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 70}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 171}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 151, 221, 71, 84}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 239, 150}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 104, 88, 184}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 81}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 160, 121}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 125, 55, 222}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 92, 28}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 127, 49, 135}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 56, 167}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 19, 209, 119, 215, 143}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 66, 219, 140, 133}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 114, 58}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 175, 140}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 239, 212, 60}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 7, 15, 38}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 174}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 98, 133, 190}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 14, 29, 71, 65}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 99, 228, 243}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 68}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 77, 179, 94, 255, 95}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 248}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 29}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 72, 233}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 22, 21, 8}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 148, 26}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 197, 201, 245, 2}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 56}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 113}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 205}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 92}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 177, 23, 36, 236}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 195, 226}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 72, 11, 196}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 131, 18, 33}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 141, 217, 250, 202, 36}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 223}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 50, 62, 90, 181}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 54, 37}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 102}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 198, 60, 237, 167}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 231, 155, 112, 239}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 182}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 0, 0}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 19, 39}, 65},
	{{110, 127, 207, 76, 100, 148, 130, 206, 249, 2, 104, 0, 0, 0, 113, 111}, 65},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 2, 232, 229, 20}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 227, 223, 194, 249}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 125}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 218, 187, 159, 225}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 192, 171}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 82, 214, 146, 221, 245}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 249, 113, 228, 24}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 2, 24, 154}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 84, 255, 139, 1, 200}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 84, 180}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 166, 194, 153, 253}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 80, 80, 142, 70}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 101, 146, 36, 136}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 31, 69, 80, 87, 27}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 122, 162, 6, 3}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 130, 154, 102}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 175}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 36, 101, 11}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 146}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 125, 196, 155}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 158}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 55}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 255, 213, 226}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 22, 42, 62, 7}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 230, 193, 31}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 234, 60, 121, 0, 150}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 111, 165, 16, 85, 36, 148}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 254, 151, 156, 195, 246}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 126, 234, 116, 243}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 181, 34, 26, 32}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 156, 200}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 186, 60, 119, 120, 192}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 9, 224, 20}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 183}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 196, 239, 157, 12, 139}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 87, 13}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 37, 26, 96, 188}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 159, 56, 117, 103, 84}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 180, 175}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 59}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 173, 35, 227, 236}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 240, 195}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 33, 244}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 74}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 46, 78, 227}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 12, 194, 243, 33}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 250, 73, 20}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 3, 216, 145, 147, 211}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 52}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 100, 122, 9, 155, 14}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 188, 41, 43, 142, 129, 7}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 173, 34}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 80, 237}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 4, 164}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 248, 220, 76, 19}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 88, 6, 233, 157}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 43, 74, 160}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 253, 252}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 52, 79, 161, 250}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 212, 96}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 176, 103}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 85, 190, 90, 144, 175}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 143}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 52, 161}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 66}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 152, 152, 191, 176}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 37}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 36}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 120, 124}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 54}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 144, 122}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 254, 76, 136, 29, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 85, 15, 90}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 17, 44, 128, 8, 160}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 205}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 12, 9}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 0, 0, 0, 0, 0}, 222},
	{{226, 190, 191, 249, 173, 96, 127, 200, 62, 20, 0, 143, 169, 39, 89, 118}, 222},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 190, 58, 235, 167, 215, 191}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 167, 37, 14, 59, 183, 193, 125}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 156, 77}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 191, 178, 164}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 249}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 47, 98, 71}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 185, 133, 158, 172}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 137, 187, 52, 247, 104, 129, 154, 131}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 74, 176, 16, 150, 59, 225}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 230}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 37, 121}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 222, 141}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 94}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 103, 116, 176}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 6, 168, 160, 192, 48, 31, 81}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 217, 194, 245, 141, 129, 96}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 89, 175}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 88, 100, 253, 156, 27, 198, 218}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 81, 224, 100}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 63, 246, 73, 215, 108, 62, 6}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 40, 185}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 52, 68, 83, 79, 78, 82, 235}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 31, 189, 18, 183, 158, 61}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 133, 20}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 132, 127, 58, 123, 20}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 144, 79, 91, 56, 217}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 200, 1, 24, 225}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 217, 92, 222}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 115, 165, 181, 169}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 92, 72, 142, 5}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 49, 23, 234, 235, 186, 100, 202}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 121, 204, 7}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 83, 231, 82, 6, 183, 85, 195}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 147, 43, 156}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 151, 211, 209}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 39, 174, 94, 176}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 156}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 74, 11, 186, 114}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 6, 74, 166, 206, 62, 24, 77}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 143, 124, 90, 179}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 83, 8, 155, 98, 88}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 128, 131, 9}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 44, 118, 104, 135, 154, 142, 205, 228}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 162, 9}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 76, 23, 130, 185, 248, 7, 54, 65}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 235, 192, 49, 100, 188, 218, 22, 164}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 59, 69, 209, 16, 9}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 62, 163, 171, 75, 232, 186, 113, 245}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 7, 42}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 26, 207, 73}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 130, 159, 213, 12, 178, 180, 183}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 160}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 205, 104, 252, 212, 238}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 136, 189, 115, 159, 149, 42, 27, 38}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 94}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 163, 244}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 111, 205, 110}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 132, 90, 108}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 185, 202, 143, 19, 6, 122}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 1, 165, 193, 187}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 95, 172, 5, 193, 51, 39}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 136}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 115, 171, 174, 138, 78, 98}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 102, 76, 206, 153, 241, 173, 251, 246}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 9, 248, 254, 120, 27, 159}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 159, 194, 71, 162, 178, 193}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 230, 198}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 221, 118, 146, 202}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 203, 219, 81, 62}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 220, 28, 176, 176, 157, 158, 191}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 217, 26, 38, 30}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 120, 251, 76, 87, 243, 202, 66}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 41, 81}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 141, 106, 168, 58, 209, 177}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 46, 227, 213, 218, 85, 246, 187, 126}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 81, 42, 205}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 193, 128, 29, 189, 128, 197, 253, 124}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 221, 118, 26, 10, 117, 34, 81, 164}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 64, 120, 141, 126, 236, 106}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 87, 83, 100, 222}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 166, 169, 201, 116, 60, 168, 205, 58}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 218, 46, 86, 44, 85, 152, 13, 149}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 123, 175, 229, 85}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 228, 108, 40}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 196, 157, 24, 71, 123, 240, 96, 192}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 0, 0, 0, 98, 146, 94}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 223, 186, 126, 200, 198, 36, 158}, 4},
	{{89, 88, 182, 14, 78, 122, 213, 192, 0, 0, 191, 145, 106, 110, 6, 102}, 4},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 22, 97, 199, 105}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 9, 22}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 180}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 43, 206, 219, 13, 189}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 196, 152, 134, 84, 246}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 225}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 196, 52, 72, 13, 198}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 99, 147, 74, 98, 111}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 75, 192, 212, 39, 116, 140, 47}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 88, 122, 243, 96, 22, 195}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 219}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 225, 59}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 136, 28, 250, 253, 51, 171}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 118, 35, 225, 152, 184}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 198, 224, 203}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 182, 50, 106, 31, 117, 157}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 109}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 216, 75, 246}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 30, 244, 49, 136, 227, 155, 188}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 100, 148}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 224, 158}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 167, 75, 23, 31}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 226, 201, 229}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 93, 23, 32, 213, 52, 74, 26}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 11, 224, 249, 195, 115, 20}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 168, 253, 32, 165}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 180}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 7}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 206, 224, 145, 219}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 154, 157, 52}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 18, 79, 168}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 188, 96, 165, 128, 224}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 76}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 27, 184}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 230, 42, 213, 169, 199, 209}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 3, 181}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 123}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 84, 166, 246, 107}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 151, 28}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 153, 29, 67, 112}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 236, 15}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 106, 141, 202, 22, 197, 219}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 137, 120, 9}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 147, 232, 0}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 130, 77, 191}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 226}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 23, 15, 209, 234}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 133, 98, 198, 225, 175, 22}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 191, 148, 224, 120, 53, 126}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 201, 183, 147, 130, 204, 95, 123}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 63, 108, 177, 143}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 2, 11, 104, 47, 83, 26, 12}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 103, 42, 187, 175, 190}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 93, 153, 65, 218}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 159, 14, 116}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 27, 188, 201, 15}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 189, 81, 192, 156}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 94, 191, 33, 164, 63}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 31, 26, 70, 64}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 92, 182, 135, 123, 129, 84}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 233, 135}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 175, 219, 1, 203}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 211, 224, 39, 42, 110, 29}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 209, 87, 208, 190, 8}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 18, 101, 75}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 36, 106, 8, 202, 158, 82, 128}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 63, 177, 5}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 237, 214}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 254, 38, 101}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 32, 88, 46, 40, 190, 162}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 16, 57, 154, 26, 22}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 43, 68, 12}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 30, 128, 61, 205, 220, 96}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 166, 102, 96}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 246, 149, 249, 22, 216}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 141, 222}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 88, 27, 147, 17, 111, 114}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 175, 73, 140}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 18, 102, 24, 41, 18}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 246, 201}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 244, 125}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 48, 112, 131, 227}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 255, 178, 205, 182, 248}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 36, 181}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 36, 182, 124}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 76, 19, 35, 200}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 206, 197}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 122}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 0, 231, 176}, 67},
	{{167, 94, 163, 227, 28, 111, 117, 103, 224, 0, 0, 0, 0, 236, 103, 111}, 67},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 12}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 22}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 224}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 46}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 217}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 201}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 16}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 153}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 222}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 103}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 50}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 212, 129}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 136}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 238}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 51}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 95}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 25, 64}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 116}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 238}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 8}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 73, 232}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 184}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 140}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 122}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 86, 165}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 142}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 104}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 114}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 60}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 75, 30}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 198}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 35}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 218, 164}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 39}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 8}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 5}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 22}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 64}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 51}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 71, 178}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 106, 156}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 98}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 172}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 117, 223}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 110, 61}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 31}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 131}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 26}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 104, 132}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 47}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 189, 163}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 56}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 210, 230}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 34, 211}, 197},
	{{57, 220, 53, 116, 243, 184, 242, 134, 16, 70, 83, 61, 161, 128, 0, 0}, 197},
	{{63, 235, 20, 0, 0, 0, 138, 151, 158, 131, 233, 159, 10, 248, 169, 43}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 18}, 121},
	{{63, 235, 20, 0, 98, 72, 213, 72, 228, 129, 22, 26, 203, 128, 183, 254}, 121},
	{{63, 235, 20, 0, 136, 241, 198, 249, 158, 109, 102, 91, 153, 118, 2, 112}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 82, 156, 225, 5, 222, 95}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 148, 111, 112, 88, 113, 135, 74, 100}, 121},
	{{63, 235, 20, 0, 0, 0, 171, 14, 21, 201, 10, 108, 241, 51, 61, 178}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 138}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 233, 9, 137, 70, 206}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 49, 212, 180, 30, 207, 219, 149}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 4, 76, 54, 36, 244, 205, 35, 41}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 81, 220, 73, 118, 227, 71}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 48, 140, 115, 221, 222, 58, 62}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 197}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 11, 156, 93, 81, 57, 15}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 92, 79, 60}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 195, 97, 43, 89, 54, 181, 202, 82}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 228, 64, 39, 111, 236, 126, 33}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 90, 129, 47, 226, 194, 87}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 133, 41, 115, 176, 31, 224, 18, 237}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 40}, 121},
	{{63, 235, 20, 0, 0, 34, 181, 141, 20, 228, 188, 132, 0, 217, 98, 84}, 121},
	{{63, 235, 20, 0, 163, 30, 39, 231, 35, 183, 179, 65, 9, 218, 156, 184}, 121},
	{{63, 235, 20, 0, 0, 0, 239, 157, 34, 237, 211, 137, 175, 233, 185, 53}, 121},
	{{63, 235, 20, 0, 0, 0, 52, 2, 0, 73, 67, 56, 202, 147, 90, 120}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 19, 108, 123, 88, 194, 164, 72}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 39, 16, 77, 125, 1, 9}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 233, 73, 241, 245, 129}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 64, 87, 15}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 204, 31}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 187, 162, 107, 241, 127, 68, 119}, 121},
	{{63, 235, 20, 0, 77, 32, 119, 251, 217, 82, 243, 49, 4, 56, 246, 16}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 130, 188, 198, 113, 140, 191, 173, 134, 143}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 110, 66, 119, 248, 56, 71, 43, 23, 105}, 121},
	{{63, 235, 20, 0, 0, 0, 33, 238, 177, 32, 248, 18, 75, 144, 74, 87}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 9, 41}, 121},
	{{63, 235, 20, 0, 0, 113, 77, 238, 28, 187, 61, 235, 219, 237, 71, 164}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{63, 235, 20, 0, 186, 215, 206, 221, 115, 170, 85, 201, 170, 44, 251, 82}, 121},
	{{63, 235, 20, 0, 0, 6, 236, 151, 0, 68, 56, 220, 111, 135, 134, 57}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 121, 96, 94, 14, 18, 74, 249, 127}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 212, 114, 10, 135, 143, 155, 215}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 163, 144, 119, 69, 196, 207}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 194, 32}, 121},
	{{63, 235, 20, 0, 0, 52, 107, 195, 84, 126, 116, 232, 15, 7, 157, 144}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 195, 20, 15, 239, 98, 108, 24, 124, 11}, 121},
	{{63, 235, 20, 0, 146, 186, 190, 112, 36, 195, 200, 90, 12, 154, 138, 5}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 108, 40, 122, 19, 101, 50, 158, 20, 203}, 121},
	{{63, 235, 20, 0, 0, 167, 170, 127, 38, 167, 250, 211, 6, 123, 148, 107}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 19, 129, 8, 114, 150, 233, 113}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 152, 38, 65, 166, 75, 250, 252, 115, 16}, 121},
	{{63, 235, 20, 0, 0, 0, 90, 100, 254, 45, 207, 119, 242, 35, 161, 24}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 59, 170, 166, 130, 71, 238, 254, 219}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 7, 233, 32, 67, 14, 196, 146, 194}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 235, 34}, 121},
	{{63, 235, 20, 0, 13, 113, 254, 49, 4, 55, 113, 21, 60, 248, 133, 61}, 121},
	{{63, 235, 20, 0, 212, 167, 150, 240, 253, 22, 6, 72, 110, 75, 89, 237}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 43, 44}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 230, 197, 52, 66, 122, 120}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 230, 42, 136, 42, 215, 65, 254, 186}, 121},
	{{63, 235, 20, 0, 0, 252, 20, 235, 64, 84, 133, 88, 51, 178, 167, 144}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 236, 159, 65, 222, 245, 163}, 121},
	{{63, 235, 20, 0, 0, 0, 200, 128, 179, 104, 106, 128, 89, 59, 149, 52}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 53, 215, 84, 77, 134}, 121},
	{{63, 235, 20, 0, 189, 98, 40, 240, 18, 131, 13, 224, 228, 108, 106, 67}, 121},
	{{63, 235, 20, 26, 79, 246, 34, 186, 163, 160, 244, 255, 93, 241, 100, 140}, 121},
	{{63, 235, 20, 0, 0, 0, 211, 178, 135, 106, 58, 235, 254, 152, 32, 17}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 111, 139, 204, 0, 95, 89}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 229, 234, 119, 253, 60, 59, 100, 20, 36}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 190, 170, 46, 164, 143, 49}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 145, 197, 127, 138, 47, 191, 48, 159}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{63, 235, 20, 0, 236, 148, 0, 167, 80, 86, 12, 43, 105, 75, 218, 122}, 121},
	{{63, 235, 20, 0, 0, 0, 240, 163, 91, 59, 90, 216, 70, 145, 65, 90}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 187, 21, 168, 158, 152, 3, 41}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 93, 122, 52, 243, 54, 91, 90, 200}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 12, 139, 75, 113, 110, 88, 120, 238}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 225, 248, 142}, 121},
	{{63, 235, 20, 0, 0, 0, 152, 163, 46, 203, 182, 37, 108, 23, 201, 53}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 85, 215, 74}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147}, 121},
	{{63, 235, 20, 0, 0, 0, 131, 122, 193, 231, 234, 97, 36, 85, 38, 95}, 121},
	{{63, 235, 20, 0, 37, 92, 34, 136, 146, 170, 152, 105, 87, 201, 213, 44}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 205, 214, 181}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 93, 149, 94, 85, 143, 24, 41}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 190}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 0, 0, 73, 179, 255, 62, 70}, 121},
	{{63, 235, 20, 0, 0, 101, 249, 79, 41, 26, 220, 60, 46, 101, 176, 54}, 121},
	{{63, 235, 20, 0, 0, 0, 0, 0, 0, 149, 144, 176, 28, 3, 55, 143}, 121},
	{{128, 0, 0, 0, 64, 247, 91, 122, 178, 14, 147, 254, 76, 182, 78, 229}, 218},
	{{128, 0, 0, 0, 168, 167, 181, 99, 55, 242, 182, 83, 247, 96, 140, 212}, 218},
	{{128, 0, 0, 0, 168, 235, 255, 78, 12, 174, 152, 33, 123, 75, 110, 152}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 116, 31, 37}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 170, 57, 253, 17, 29, 46, 219, 156, 149}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 97, 64, 190, 153, 40, 10, 113, 243}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 196, 15, 164, 160}, 218},
	{{128, 0, 0, 0, 0, 26, 216, 166, 245, 64, 156, 130, 219, 80, 5, 135}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 166, 20, 180, 112, 120}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 64, 167, 42, 254, 244, 167, 74, 244}, 218},
	{{128, 145, 64, 195, 55, 137, 74, 120, 252, 150, 199, 239, 163, 16, 206, 19}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 139}, 218},
	{{128, 0, 38, 69, 162, 6, 78, 147, 83, 75, 18, 17, 218, 109, 239, 160}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 120, 160, 231, 123}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 236}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 126, 139, 164}, 218},
	{{128, 0, 0, 192, 183, 201, 66, 169, 0, 154, 95, 90, 33, 84, 62, 255}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 74, 237, 42, 206, 2, 62, 26}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 121, 141, 104, 121}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 245, 6, 204}, 218},
	{{128, 0, 0, 0, 0, 156, 129, 221, 145, 168, 65, 244, 203, 150, 217, 247}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 151}, 218},
	{{128, 0, 0, 0, 84, 201, 192, 19, 221, 208, 235, 14, 48, 130, 29, 173}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 84, 160, 18, 174}, 218},
	{{128, 0, 0, 0, 0, 191, 250, 56, 231, 251, 235, 170, 85, 92, 220, 179}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 155, 202, 216}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 19, 201, 84, 34, 16, 198, 92}, 218},
	{{128, 0, 0, 0, 0, 0, 26, 60, 239, 105, 126, 48, 229, 39, 161, 159}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 50, 49, 106, 250, 20, 2, 239}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 122, 154, 200, 38}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 46, 110, 71, 96, 2, 214, 185, 61, 26, 206}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 138}, 218},
	{{128, 0, 0, 16, 61, 147, 236, 12, 161, 28, 231, 139, 113, 126, 235, 146}, 218},
	{{128, 0, 246, 97, 30, 14, 106, 172, 194, 222, 102, 251, 6, 73, 85, 79}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 15, 230}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 226, 14, 247, 180, 202, 223, 88, 50, 34, 199, 187, 233}, 218},
	{{128, 0, 0, 174, 147, 154, 102, 193, 210, 243, 23, 242, 210, 213, 170, 226}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 42, 250, 16, 100, 159, 30, 76}, 218},
	{{128, 0, 0, 0, 0, 239, 197, 142, 18, 124, 194, 32, 108, 190, 137, 213}, 218},
	{{128, 0, 0, 0, 0, 20, 255, 46, 43, 83, 116, 195, 118, 238, 222, 183}, 218},
	{{128, 0, 0, 0, 197, 171, 143, 223, 40, 66, 234, 22, 237, 225, 245, 50}, 218},
	{{128, 0, 210, 240, 154, 107, 179, 149, 18, 115, 72, 47, 127, 121, 156, 7}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 69, 139, 205}, 218},
	{{128, 0, 0, 0, 145, 26, 151, 222, 63, 95, 67, 116, 198, 216, 240, 193}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 137, 179, 232, 6, 11, 27, 50, 245, 230}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 203, 105}, 218},
	{{128, 198, 55, 92, 45, 108, 56, 6, 243, 87, 96, 52, 117, 147, 177, 254}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 93, 172}, 218},
	{{128, 0, 0, 0, 0, 80, 5, 208, 110, 136, 246, 70, 130, 227, 204, 68}, 218},
	{{128, 0, 0, 0, 139, 189, 9, 107, 111, 77, 210, 6, 86, 17, 55, 2}, 218},
	{{128, 0, 0, 0, 0, 82, 169, 98, 243, 41, 73, 23, 138, 138, 57, 243}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 96}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 76, 83}, 218},
	{{128, 0, 0, 158, 245, 161, 116, 193, 109, 210, 233, 207, 204, 63, 89, 28}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 208, 179, 79}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 231, 0, 224, 219}, 218},
	{{128, 0, 0, 0, 34, 251, 243, 199, 86, 226, 22, 170, 198, 179, 132, 240}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 33, 116}, 218},
	{{128, 0, 0, 0, 0, 0, 87, 127, 74, 43, 122, 142, 157, 236, 128, 186}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 195, 163, 165}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 236, 253, 7, 252, 95, 156, 95}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 176}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 70, 104, 173, 192, 13, 79, 94, 171, 243}, 218},
	{{128, 0, 0, 0, 0, 173, 18, 1, 71, 233, 223, 135, 189, 89, 2, 114}, 218},
	{{128, 0, 0, 159, 211, 64, 82, 253, 234, 130, 238, 108, 59, 154, 153, 118}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 54, 75, 36, 180, 138, 103, 74, 20, 220}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 102}, 218},
	{{128, 0, 0, 0, 245, 255, 56, 162, 189, 56, 32, 31, 121, 218, 95, 131}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 255, 93, 188, 116, 1, 89, 35}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 51}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 44, 240, 185, 97, 230}, 218},
	{{128, 0, 0, 0, 0, 106, 202, 213, 159, 100, 202, 78, 185, 97, 28, 128}, 218},
	{{128, 63, 144, 191, 143, 190, 164, 129, 240, 81, 145, 143, 61, 148, 32, 104}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 209, 14, 24, 119, 250, 211, 242, 135, 201, 91}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 247, 110, 211, 15, 154}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 248, 205, 222, 86}, 218},
	{{128, 0, 0, 0, 90, 104, 126, 198, 113, 255, 56, 27, 34, 75, 45, 93}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 45, 123, 2, 47, 137, 71, 50}, 218},
	{{128, 0, 0, 0, 0, 20, 13, 60, 55, 102, 47, 115, 215, 170, 71, 1}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 197, 254, 124, 252, 11, 233, 142, 242, 73}, 218},
	{{128, 0, 0, 0, 23, 190, 125, 92, 194, 68, 48, 240, 52, 119, 62, 126}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 147, 236, 176, 28}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 109, 186, 169}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 30, 89, 252, 226, 45, 79, 240}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 72, 239, 1, 46, 177, 119, 12, 129}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 247, 12, 46, 128, 29, 91, 33, 49}, 218},
	{{128, 247, 4, 188, 200, 68, 249, 253, 9, 175, 247, 220, 105, 179, 136, 48}, 218},
	{{128, 0, 235, 104, 234, 29, 49, 128, 221, 222, 197, 121, 35, 47, 88, 19}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 133, 76, 248, 191, 198, 96, 76, 216}, 218},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 61, 130, 120, 76, 223, 204, 188, 187}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 23, 241, 184, 203}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 180}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 142, 114, 116, 234}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 78, 148, 74, 156, 19, 146, 124}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 46, 65, 28}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 115, 237, 0, 18}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 111, 160, 168, 49, 51, 104, 14}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 70, 124, 69, 65}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 171, 223, 44}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 16, 108, 165, 41, 117, 89, 112, 102, 178, 79}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 136, 83, 75, 121, 85, 56, 27, 52}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 138, 75, 219, 238}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 12, 62, 158, 97}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 114, 9, 43}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 6, 63, 143, 241}, 140},
	{{15, 159, 42, 167, 76, 0, 70, 79, 194, 218, 222, 27, 90, 229, 202, 6}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 253, 1, 7, 75, 96, 66}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 29, 132, 190, 153, 129, 245}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 77, 126, 76}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 192}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 136}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 94, 148, 96, 43, 8}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 96, 16, 176, 187, 214, 19}, 140},
	{{15, 159, 42, 167, 76, 0, 183, 9, 9, 176, 154, 1, 131, 55, 199, 104}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 233, 145, 216, 241, 61, 132}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 203, 96, 154, 64, 80, 65, 61, 20, 156}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 252, 63, 131, 45, 99, 113}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 228, 247, 218, 195, 195}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 11, 220, 100}, 140},
	{{15, 159, 42, 167, 76, 0, 29, 5, 66, 137, 139, 196, 7, 248, 78, 53}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 133, 115, 186, 213, 52}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 48, 2, 13, 140, 50}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 62, 198, 72}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 244, 71, 123, 43, 158, 51}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 187}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 163, 90, 58, 8}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 114, 170, 75}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 189, 77, 151, 108, 200, 173, 184, 169, 135}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 221, 229, 137, 22, 101, 199, 190}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 209, 252, 108, 236, 168, 140}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 34, 209, 246, 254, 82, 10, 113, 231, 19}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 45, 132, 183, 98}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 126, 53, 212, 157, 90}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 212, 166, 50, 25, 94, 78, 87, 88, 92, 74}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 112}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 111, 51, 79, 41, 162, 100, 27, 3}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 185, 200, 39, 87, 128, 83, 198}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 248, 183, 145, 120, 52, 200, 24}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 140},
	{{15, 159, 42, 167, 76, 0, 140, 192, 223, 9, 134, 28, 65, 140, 131, 6}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 53, 6, 203, 173, 67}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 7, 241, 132, 111, 147, 202, 98, 68}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 246, 125, 15}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 19, 55, 62}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 213, 74, 172, 129, 90, 48, 136, 150}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 227, 110, 140, 77, 229, 12, 64}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 189, 236, 114, 161, 111}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 25, 217, 229, 127, 29, 89, 70, 189}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 48}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 152, 5, 120}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 237}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 241, 158, 195, 210, 215}, 140},
	{{15, 159, 42, 167, 76, 0, 134, 178, 231, 61, 188, 81, 138, 94, 177, 55}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 126, 125, 80, 145, 202, 116, 74, 78}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 125, 72, 202, 129, 100}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 229, 217, 48}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 197, 252, 66, 80, 183, 127, 123, 126}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 106, 94, 168, 130}, 140},
	{{15, 159, 42, 167, 76, 0, 239, 23, 40, 102, 17, 240, 103, 161, 120, 147}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 7, 128, 63, 246, 190, 23, 157}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 227, 193, 201, 120, 99, 151, 18, 185, 129}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 41}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 86, 195, 115}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 148, 147, 227, 115, 18, 118, 182, 40, 48}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 195}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{15, 159, 42, 167, 76, 0, 0, 0, 183, 56, 112, 65, 128, 205, 83, 105}, 140},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 92}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 143, 67}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 173}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 97}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 5}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 155, 67}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 178, 114}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 181}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 253}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 207}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 253, 204}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 66}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 40, 212}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 201}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 106}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 165}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 17}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 155}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 145}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 195, 151}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 79}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 220, 8}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 47}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 55, 83}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 110, 30}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 173, 54}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 252, 175}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 127, 65}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 34}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 11, 108}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 100}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 68}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 45, 241}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 192}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 230, 119}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 199}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 168}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 99}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 7}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 231}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 3, 9}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 170, 110}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 27}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 8}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 182, 249}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 199}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 226, 21}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 98, 226}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 162}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 210, 232}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 160}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 95}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 192, 180}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 44}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 77, 68}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 35}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 148}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 215}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 146}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 32, 139}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 128, 176}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 0, 0}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 164, 143}, 193},
	{{216, 252, 113, 40, 239, 46, 172, 48, 103, 250, 82, 179, 136, 64, 57, 95}, 193},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 47, 135}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 126, 228}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 22}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 2, 135, 4}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 201, 121, 147}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 12}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 233, 107, 161}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 66}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 64}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 134, 72, 249}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 187}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 246}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 236, 28}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 206, 124, 219}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 60, 74, 4, 171}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 236, 165, 239}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 130, 74, 6}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 230}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 250, 218, 166}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 210}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 142, 27, 210, 25}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 155, 45}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 36, 162, 221}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 134, 6, 147, 127}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 87}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 165}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 203}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 5, 54, 153, 20}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 90, 237, 32, 200}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 151, 183}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 4, 57}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 19, 7, 16, 42}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 55, 161}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 140, 158, 166}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 178}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 179}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 164, 144, 209}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 77}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 180, 238}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 75, 31}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 9, 155}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 130, 158}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 194, 174}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 238}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 3}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 136, 116, 255}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 94, 155, 126, 132}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 161, 85, 254}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 49, 247}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 62, 218, 244, 229}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 76, 137, 59, 121}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 170, 116, 14}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 59, 28}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 79, 136, 176}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 142, 215}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 52, 252}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 61, 84, 238, 213}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 53, 63, 173}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 35, 20, 150, 2}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 104, 87, 241}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 63, 61, 130, 238}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 76, 121, 39, 210}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 201, 193, 119}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 224, 81, 126, 228}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 203, 217, 182, 206}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 103}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 173, 223}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 201}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 71, 61}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 154, 118, 204, 101}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 224, 48, 65}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 238, 232}, 47},
	{{158, 147, 16, 44, 124, 56, 44, 48, 138, 64, 169, 0, 0, 0, 0, 0}, 47},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 61, 13, 183, 120, 26}, 187},
	{{238, 238, 96, 0, 0, 203, 67, 48, 85, 109, 196, 35, 156, 0, 172, 232}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 54, 210, 221, 108, 119}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 85, 136, 227, 197, 92, 198, 98, 41, 90}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 21, 156, 146, 21, 241, 138, 207, 100, 180}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 187},
	{{238, 238, 96, 0, 2, 82, 24, 255, 236, 0, 213, 186, 179, 220, 183, 181}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 25, 171, 180, 215, 191, 16, 223}, 187},
	{{238, 238, 96, 0, 0, 0, 164, 3, 40, 28, 161, 106, 101, 72, 9, 89}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 183, 103, 163, 88, 64, 165, 126, 147}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 216}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 46, 78, 193, 142, 74}, 187},
	{{238, 238, 96, 0, 0, 94, 30, 156, 213, 220, 142, 216, 192, 140, 128, 77}, 187},
	{{238, 238, 96, 0, 180, 67, 17, 15, 166, 200, 17, 3, 58, 182, 74, 36}, 187},
	{{238, 238, 96, 0, 0, 0, 76, 186, 35, 47, 60, 71, 81, 154, 169, 224}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 180, 215, 127, 76, 80, 40, 176, 35, 185}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 158, 121, 122, 233, 31, 20, 242}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 44, 169, 36, 112, 169, 132, 186}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 101, 177, 134, 239, 145, 17}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 69, 240, 81, 49, 73, 38, 221, 33, 143}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 161, 236, 204, 6, 220, 243, 132, 38, 132}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 180, 164}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 186, 237, 66, 161, 188, 4, 193, 134, 138}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 221}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 218}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 169, 126, 74, 54, 14, 215, 173}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 66, 190, 220}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 84, 119, 144, 198, 210, 13, 39, 163, 3}, 187},
	{{238, 238, 96, 0, 0, 86, 49, 34, 21, 75, 15, 146, 49, 18, 58, 112}, 187},
	{{238, 238, 96, 0, 0, 116, 242, 135, 237, 204, 55, 102, 220, 113, 156, 37}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{238, 238, 96, 0, 70, 196, 3, 70, 249, 144, 245, 89, 67, 109, 110, 153}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 197, 172}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 172, 193, 80}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 191, 101, 166}, 187},
	{{238, 238, 96, 0, 0, 0, 177, 159, 143, 54, 253, 145, 134, 37, 0, 139}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 202, 25, 190, 150, 162, 200}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 101}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 14, 80, 207, 47, 141, 41, 43}, 187},
	{{238, 238, 96, 0, 0, 0, 172, 36, 12, 19, 175, 100, 216, 50, 197, 147}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 130, 116, 56, 241, 25}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 94, 147, 122, 166, 195}, 187},
	{{238, 238, 96, 0, 0, 0, 42, 39, 48, 134, 61, 159, 46, 226, 116, 228}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 168, 174, 178, 78, 68}, 187},
	{{238, 238, 96, 0, 157, 177, 105, 27, 11, 210, 253, 95, 23, 26, 235, 120}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 187},
	{{238, 238, 96, 0, 0, 236, 68, 59, 125, 162, 35, 85, 130, 203, 127, 170}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 204, 28}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 66, 84, 182}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 93, 113, 242}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 111, 210, 103, 137, 255, 210, 195}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 219, 18, 76, 223, 173, 181, 88, 27}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 161, 65, 58, 28, 198, 130, 151, 74}, 187},
	{{238, 238, 96, 0, 136, 10, 56, 215, 30, 75, 98, 93, 68, 125, 85, 84}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 138, 115, 129, 25, 132, 146, 242, 253}, 187},
	{{238, 238, 96, 195, 69, 41, 40, 209, 36, 8, 58, 243, 180, 101, 253, 18}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 199, 29, 8, 197, 140, 173}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 252, 245}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 87, 236, 137}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 103}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 17, 142, 104, 142, 120}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 213, 120, 235, 195, 178, 99, 208}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 22, 232, 179, 51, 114, 84, 190, 30}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 140, 85, 29, 21, 181, 152}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 52, 129, 160, 211, 227, 127, 216, 138}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 141, 210, 2, 154, 133, 22}, 187},
	{{238, 238, 96, 0, 0, 0, 71, 199, 77, 210, 15, 34, 221, 173, 240, 253}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 89}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 235, 103, 240}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 6, 234, 190, 191, 132}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 88, 63, 247}, 187},
	{{238, 238, 96, 0, 0, 0, 78, 92, 122, 180, 221, 156, 50, 197, 114, 72}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 35, 86, 155}, 187},
	{{238, 238, 96, 0, 0, 0, 247, 183, 160, 213, 205, 102, 38, 232, 201, 236}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 237, 119, 51, 233, 157}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{238, 238, 96, 0, 153, 245, 37, 79, 238, 240, 204, 76, 209, 102, 69, 64}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 142, 54, 174, 176, 129, 99}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 155, 251}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 241, 255, 234, 190, 84, 133, 136, 81, 253}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 109, 55}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 183, 26, 126, 235, 236}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 227, 124, 83, 209, 191, 136, 166, 19}, 187},
	{{238, 238, 96, 0, 102, 212, 69, 14, 149, 110, 93, 20, 238, 182, 122, 251}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 147, 251, 128, 97, 96, 194, 94}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 34, 71, 21, 132, 252, 243, 2, 91}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 0, 0, 28, 50, 75, 69, 112, 217, 184}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 92, 99, 93, 187, 229, 116, 147, 180, 227}, 187},
	{{238, 238, 96, 0, 0, 0, 0, 33, 134, 213, 58, 91, 93, 19, 138, 168}, 187},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 83, 126, 67, 227, 76}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 47, 134, 255, 80, 92, 110}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 231, 224, 45, 201}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 99, 14, 92, 116, 103}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 178, 149}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 5, 170, 130, 166, 189}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 124, 33, 40, 223, 233, 225}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 12, 214, 25, 149, 140, 21}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 199, 199, 7, 111, 88}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 63, 1, 114}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 41, 72, 180, 100}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 49, 233}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 73, 81, 210, 201, 24, 136, 97, 244}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 36, 152, 211, 30, 232, 234, 77}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 80, 200, 228, 149, 125, 165}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 169, 232, 30, 202}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 133, 22, 44, 211}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 162, 112, 157, 178, 181, 159}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 240, 114, 29, 36, 5}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 196, 190, 173, 58}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 217, 15, 112, 225, 191, 130, 187}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 208, 68, 239}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 187, 31, 241, 55}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 66, 152, 201, 201, 215, 178, 128, 145}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 221, 129, 167, 204, 229, 5, 50}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 245, 244, 236, 212, 111}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 117, 162, 98, 47, 249}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 133, 39, 107}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 155, 25, 161, 219, 200, 112, 204}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 114, 127, 120, 182, 134, 148, 23, 36}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 49, 81, 165, 85, 8}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 239, 87, 41, 84, 102}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 170, 51, 197, 153}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 29, 73, 172, 45, 93}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 236}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 254, 107, 211, 63}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 250, 179, 63, 70, 235, 121, 94, 32}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 139}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 174, 120, 36, 43, 96, 52}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 226, 68, 164, 48, 59, 183}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 170, 108, 240, 66, 148}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 58, 154, 222, 140, 223, 35, 195}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 62, 251, 193, 15}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 68, 68, 198}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 115, 128, 27, 44, 160, 55, 230}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 24, 4, 201}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 103, 96}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 5, 19, 98, 218, 18, 94, 160}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 110, 9, 246}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 59, 20, 186, 7, 65}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 54, 218, 153, 36, 6, 254, 193, 225}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 203, 115, 40}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 226, 123, 98, 149}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 45, 113, 5}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 255, 110, 83, 129, 181}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 31, 155, 73, 7}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 165, 187, 233}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 65}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 116, 82}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 30, 121, 84, 189, 218}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 110, 82, 216, 3, 66, 30, 253, 178}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 42, 116, 20, 230, 234, 108}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 238, 149, 254, 49, 32, 163, 54, 41}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 61, 36, 238, 182}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 58, 22, 1, 156, 53}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 80, 56, 36, 146, 153, 117, 200}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 125, 190}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 49}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 173, 44, 228, 160, 118}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 246, 161, 50, 247, 200, 223, 104, 25}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 130, 165, 253, 108, 240, 127, 167}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 0, 194, 102, 234, 133}, 102},
	{{63, 159, 177, 162, 106, 212, 172, 0, 0, 0, 0, 24, 174, 207, 134, 129}, 102},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 23, 55}, 237},
	{{59, 40, 252, 185, 187, 216, 168, 234, 69, 204, 65, 47, 70, 14, 250, 30}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 190, 58, 62}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 245, 88, 202, 49, 47, 13, 120, 151}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 136, 187, 26, 9, 171, 85, 5, 41}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 80, 86, 74, 145, 228, 141, 55, 163}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 80, 1, 230, 91, 37, 118}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 116, 158}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 76, 54, 172, 96, 79, 138, 163, 104, 112}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 19, 214, 131}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 156, 174, 93, 5}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 50, 102}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 38, 194, 120}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 237, 204, 178}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 75, 100, 28}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 194, 30, 188, 214, 231, 251, 139}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 135, 66, 28, 127, 252, 37, 222, 75}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 127, 65, 46, 92}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 94, 159, 149, 210, 86}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 153, 42, 158, 160, 25, 111, 88, 176, 118}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 99, 72, 221, 138, 139}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 143, 186, 211, 110, 44, 97, 11, 169}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 78, 220, 23, 179, 32}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 183, 193, 87}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 107, 10}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 129, 188, 36}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 45, 95, 230, 108, 38}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 103, 27, 1, 255, 153, 77}, 237},
	{{59, 40, 252, 185, 187, 216, 160, 164, 45, 201, 232, 209, 44, 161, 231, 198}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 167, 240, 69, 54, 158, 38}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 248, 99, 0, 40, 231}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 112, 24, 102}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 161, 242}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 57, 99, 217, 248, 178, 160, 165, 170}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 146, 42, 59, 33}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 30, 212, 10, 175, 138, 150, 153, 47}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 87, 39, 26, 164, 142, 142, 233, 95}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 103, 67, 110, 100, 53, 147, 204}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 30, 26, 198}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 183, 67}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 254, 130, 110}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 126, 182, 14, 25, 198, 199, 102, 207}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 255, 95, 75, 169}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 254, 222, 203, 104, 153, 242, 93}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 169, 20, 94, 9, 189, 250, 192}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 171, 20, 171}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 210, 127, 219, 82, 45, 9, 203, 14, 28}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 178, 188, 142, 156, 77, 103, 171}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 225, 120}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 114, 128, 241, 168}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 38, 211, 221, 177, 225}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 50, 240, 179, 176}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 14, 32, 40, 131, 246, 234}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 111, 45, 227, 161, 255, 133, 122, 56, 130}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 214, 250, 25, 93, 180, 220, 7}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 232, 122, 16}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 184, 87, 24, 142}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 71, 128, 63, 138}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 14, 194, 194, 108, 238, 57, 243, 119, 15}, 237},
	{{59, 40, 252, 185, 187, 216, 133, 96, 167, 158, 72, 96, 41, 47, 43, 187}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 223, 227, 30, 68, 243, 22}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 51, 249, 83, 227, 33, 117, 220, 235, 249}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 126, 173, 241, 173, 122}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 175, 71}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 41, 159, 125, 49, 159, 1, 202}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 121, 117, 130, 20}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 77, 176, 231, 181}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 162, 241, 227}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 96, 30, 248, 59}, 237},
	{{59, 40, 252, 185, 187, 216, 238, 164, 15, 156, 136, 219, 6, 149, 17, 113}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 91, 20, 163, 236, 24, 55}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 25, 163}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 190, 215, 113, 105, 127}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 235, 139, 251, 223, 75}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 81, 174, 79, 184, 248, 205}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 73, 15, 242, 229, 184, 177, 108, 194}, 237},
	{{59, 40, 252, 185, 187, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 33, 240}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 116}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 188, 173}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 83, 110}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 139, 70}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 35}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 150, 203}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 33, 105}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 18, 138}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 218}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 2, 82}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 199}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 231, 77}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 71, 210}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 83}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 99, 220}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 41}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 163, 222, 48}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 195}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 124}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 227}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 61}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 46, 75}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 131}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 171}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 39, 43}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 22, 129}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 47, 224}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 175}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 167}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 202}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 38}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 53, 43}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 26, 166}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 145}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 79}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 142}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 230}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 75}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 139}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 228}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 97}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 192, 93}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 154, 29}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 21, 4}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 100, 114, 147}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 39}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 9, 175}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 11, 6}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 3, 81}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 207}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 117, 245}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 107}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 237}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 127}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 163}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 179, 138}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 64, 42}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 245}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 28, 217, 250}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 191, 213}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 73, 52}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 138}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 222, 17}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 221}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 25}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 108}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 0}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 210}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 194}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 159}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 142}, 237},
	{{2, 218, 11, 68, 173, 196, 16, 223, 2, 18, 122, 215, 154, 0, 0, 222}, 237},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 83}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 25}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 89}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 238}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 200}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 136}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 169, 244}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 111, 184}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 85}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 238}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 126}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 220}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 235}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 113, 163}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 215, 251}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 146}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 27}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 196}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 65}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 59}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 128}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 40}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 153}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 122}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 124, 138}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 187}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 13, 87}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 167, 154}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 196}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 168}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 214}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 45}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 206, 204}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 60}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 204}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 226}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 176, 47}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 176, 177}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 210, 183}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 18, 151}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 139}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 83, 29}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 62}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 236}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 152}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 237}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 151, 30}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 137}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 166}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 179}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 205, 100}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 17}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 146}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 214}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 124, 239}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 249}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 193, 63}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 10}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 233, 235}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 198, 136}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 164}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 153}, 115},
	{{3, 9, 206, 73, 108, 196, 183, 119, 141, 162, 10, 180, 115, 32, 0, 0}, 115},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 36, 17, 187, 129}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 252, 36, 177, 30, 112}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 234}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 220, 219, 184}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 129, 56, 8}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 171, 51, 27}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 136, 44, 176}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 201, 215, 221, 70}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 118, 88, 5, 151}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 89}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 117}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 208, 137, 238, 238, 131}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 164}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 128, 100, 70}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 234}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 20, 181, 216}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 250, 66, 21}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 255}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 12, 205, 12}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 176, 79, 163, 100, 19}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 190, 194, 78, 110, 179}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 42}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 73, 134, 198, 81}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 169, 156}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 69, 190}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 153, 75, 226, 209}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 102, 173, 178}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 150, 51}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 167, 225, 255, 207, 178}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 138, 222, 11, 50}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 16, 223}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 8, 167}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 67, 133, 159, 255}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 13, 44, 1, 107}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 196, 128, 125}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 224, 160}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 194, 85, 80, 252}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 224, 69}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 181, 145, 205}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 95, 215, 154, 233, 142}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 255}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 119, 84, 241, 157, 53}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 125, 39}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 207}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 67, 79, 32}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 156, 76, 26, 83}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 115}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 42, 45, 37, 179, 137}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 186}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 241}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 232, 66, 15, 30, 14}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 125, 4, 50, 81}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 62, 177, 229}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 203, 172}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 221, 35, 252, 25, 154}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 53, 240, 123}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 42}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 31, 96, 74, 207}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 178}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 193, 76, 188}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 117, 229, 32}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 40, 221, 150}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 137, 211, 117, 235}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 9, 254, 3, 235, 234}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 205, 254}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 162}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 240}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 189, 73, 75}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 10, 54, 173}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 196, 234}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 90, 83}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 184, 81, 241, 58}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 9, 138}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 22, 60, 91, 220}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 17, 154}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 147, 152, 88, 229, 133}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 0}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 183, 9, 157}, 217},
	{{17, 227, 208, 146, 63, 201, 73, 239, 29, 79, 80, 0, 0, 0, 0, 92}, 217},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 157, 168, 230, 16}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 116, 73}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 92, 206, 41, 109}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 201, 142, 105}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 4, 250, 36}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 88, 229, 27, 49}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 24, 122, 130}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 195, 84, 97, 172}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 191, 148}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 156, 128, 56}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 195, 53}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 9}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 176}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 208, 48}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 236, 167, 170}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 133, 53, 229, 244}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 136}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 5}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 11}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 56, 176, 249, 30, 174}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 26, 58, 38, 230, 252}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 116, 246, 3}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 14, 239, 20, 144}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 75, 51}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 21, 239, 109}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 242}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 61, 209}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 240}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 210, 168, 165, 55}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 79, 178, 129, 169, 2}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 95, 92, 232, 155}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 22, 160, 130}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 235, 39, 214}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 149, 18, 105}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 27, 148, 44}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 25, 200}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 238, 203}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 172}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 87, 21, 59, 11, 90}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 97, 27, 190, 168, 129}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 220, 7, 213, 9, 58}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 231, 151, 140}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 14, 182, 150, 122, 110}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 166}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 114, 206, 134, 51, 127}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 168, 79, 126, 70, 148}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 211, 173}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 154}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 238, 157, 80, 98}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 125, 184, 221, 15, 227}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 98, 247, 99}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 114, 58, 53, 76, 58}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 14, 223, 90, 96, 200}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 253, 95, 121, 244}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 121, 205, 123, 152}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 193, 157, 34, 112, 95}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 129, 176, 93, 30, 209}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 86, 19, 5, 218, 74}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 37, 46, 203, 0, 204}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 42, 87, 5}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 92, 224, 151, 104}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 55, 177}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 123, 87, 26}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 245, 181}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 43, 226, 227, 129, 154, 147}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 151, 144, 228, 195}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 199, 65, 12}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 193}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 255, 246, 199, 100}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 157, 174, 162}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 100, 70}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 26, 222, 189}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 202, 203, 199, 156}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 1, 21, 10, 85}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 0}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 230, 231, 152, 146, 24}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 216, 89}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 176, 116, 236, 223, 103}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 104}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 123, 9}, 21},
	{{115, 180, 176, 241, 52, 209, 6, 64, 189, 76, 0, 0, 0, 0, 0, 252}, 21},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 182}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 175}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 166}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 120}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 117}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 183}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 194}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 174}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 252}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 201}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 86}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 57}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 153}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 68}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 110}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 13}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 79}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 68}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 25}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 22}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 180}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 8}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 73}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 199}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 231}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 248}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 98}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 199}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 72}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 172}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 164}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 117}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 10}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 170}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 233}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 10}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 147}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 143}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 56}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 223}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 81}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 2}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 63}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 67}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 127}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 233}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 0}, 3},
	{{191, 88, 98, 245, 91, 46, 137, 254, 170, 80, 11, 55, 212, 28, 128, 252}, 3},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 67, 203, 77, 205}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 110, 73, 21, 170, 182, 22, 21, 122}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 51, 0, 13, 238, 207, 173, 155, 89}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 179, 196, 169, 13, 186, 252, 180, 59}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 249, 98, 223, 173, 89, 63, 88, 164}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 65, 150}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 85, 158, 39, 128, 68}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 79, 236, 130}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 112, 45, 17, 49, 78, 9, 2}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 245, 61, 24}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 100, 194, 56, 169, 167, 123, 30, 144, 170}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 252, 85, 69, 166, 203}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 111, 42, 77, 225}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 29, 83, 24, 128, 0}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 177, 210, 107, 181, 204, 71, 21}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 66, 14, 243, 39, 179, 16, 143, 82}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 120, 56, 159, 126, 104, 16, 7, 13, 15}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 97, 182, 0}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 241, 202, 98, 1, 48, 135, 84, 94}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 92, 206, 138, 161, 50, 83, 97}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 238, 38}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 32, 68, 196, 255, 35, 212}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 59, 76, 192, 238, 227}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 39, 23, 227, 89, 238, 114, 154, 67, 94}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 95, 122, 104, 204, 207, 64, 177, 5}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 186, 180, 187, 220, 41, 161}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 62, 12}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 246, 117}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 248, 252, 144, 234, 153, 95}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 243, 166, 189}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 220, 157, 224, 124}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 83, 97, 0, 137, 242, 208}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 33, 27, 213, 154, 88}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 29, 245, 158}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 176, 89, 200, 20, 65, 150, 199, 99}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 6, 233, 64, 215, 142}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 80, 204, 78, 52, 160, 158, 206, 33, 146}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 48, 38, 146, 225, 90, 171, 148}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 124, 129, 162, 77}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 97, 160, 12, 238, 143, 149, 145}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 141, 25}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 121, 144, 218}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 94, 253, 233, 66, 173, 246, 107}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 12, 80, 236}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 168, 147, 43}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 98, 44, 139}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 154, 156}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 240, 186, 143}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 150, 22, 9, 34, 88, 7, 23, 129, 205}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 55, 126, 254, 236, 112, 0, 133}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 220, 150, 200, 216, 215, 131, 208, 96}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 206, 197, 157, 160, 110, 205, 214, 27, 189}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 80, 104, 28, 235, 64, 220, 40, 79, 40}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 70, 142, 19, 67, 207, 100, 21, 0, 131}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 68, 12, 231}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 242, 25, 197, 253, 32}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 46, 144, 152, 104}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 18, 44, 32, 29, 143}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 83, 40, 155, 253, 166}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 196, 82, 199, 229, 23}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 195, 146, 38, 173, 149, 72, 165}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 76, 62, 36, 16, 67, 13}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 24, 32, 140, 10, 170, 77, 156, 21}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 181, 3}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 53, 152, 122, 147, 199}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 183, 176, 58, 68, 232}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 162, 123, 134, 25}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 60, 42}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 172, 2, 217, 120, 252, 228}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 161, 203, 13, 108, 11, 22, 92}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 124, 217, 203, 181, 81, 20, 190}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 152, 132, 202, 117, 207, 44, 135}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 49, 46, 208}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 71, 204, 183, 187}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 36, 178, 176, 93, 57, 58, 115, 245, 144}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 97, 230, 241, 240}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 171, 196, 195}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 84, 112}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 176, 182, 210}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 23, 122}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 112, 82, 190, 163, 251, 8, 181}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 230, 73, 153, 25, 134, 199, 233, 220, 237}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 62},
	{{97, 141, 171, 175, 22, 233, 0, 0, 0, 0, 33, 41, 240, 125, 179, 213}, 62},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 45, 244, 117, 182, 56, 15}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 186, 205, 242, 191}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{32, 204, 102, 191, 164, 242, 121, 135, 226, 230, 150, 6, 161, 43, 214, 228}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 33, 237, 200, 134, 94, 250, 163, 114}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 96, 90, 180, 162, 79, 146}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 198, 118, 148, 162, 26, 145, 76, 7, 175}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 55, 120}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 213, 121, 245, 229}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 60, 242, 7, 184, 237, 209, 25}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 19, 228, 93, 64, 182}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 95, 153, 170}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 57, 82, 79, 203, 6, 63}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 30, 113, 56, 74, 225, 172, 202, 160}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 72, 161, 169}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 148, 102, 235, 139, 148, 40, 219, 171}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 30, 42, 126, 132, 150, 13}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 5, 150}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 67, 67, 134, 66, 75, 253, 123}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 194, 67, 14, 167, 151, 44, 161}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 15, 201, 113, 82, 179, 171, 167, 112}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 139, 20, 57, 4, 168, 22, 154, 60, 192}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 78, 224, 73, 201, 116, 23, 204, 7, 230}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 81, 188, 191, 19, 150, 153, 130}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 177, 176, 17, 141, 216, 23, 125, 111, 192}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 79, 169, 20, 209, 93, 53, 157, 246}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 209, 166, 124, 63, 206, 254, 36}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 51, 169}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 166, 66}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 56, 46, 10, 171}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 63, 44}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 207, 17}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 136, 184, 223}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 248, 47, 0, 31}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 51, 223, 170}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 102, 62, 110, 188, 217}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 119, 37, 249}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 190, 210, 205, 113, 105, 110}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 102, 190, 177, 153, 245}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 163, 230, 69, 27, 142}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 142, 76, 215, 137, 19, 132, 104}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 35, 237, 93, 188, 143, 24, 97, 96, 124}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 7, 231}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 110, 22, 127, 196, 77, 18, 47, 47}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 13, 150}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 96, 28, 242, 64, 154, 233, 203, 193, 254}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 46, 177}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 61, 15, 166, 214, 107, 42, 48}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 156, 216, 18, 206}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 191, 184, 80, 156, 252, 197}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 63, 129, 66, 9, 142, 219}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 103, 51, 242}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 120, 111, 16, 39, 196, 51, 56, 176, 238}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 232, 188, 87, 103, 176, 53}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 31, 156, 176, 164, 107, 10, 202, 32}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 119, 12, 143}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 171, 237, 202, 226, 102, 114, 19, 192}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 106, 204, 83, 50, 168, 65}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 138, 41, 59, 45, 55, 170, 84, 97}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 198, 100, 241, 187, 122, 145, 254, 17}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 202, 156, 181, 82}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 106, 84}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 2, 108, 151, 94, 107}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 93, 180, 226, 163, 80, 32, 171}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 214, 193, 238, 215, 30, 146}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 211, 150, 75}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 81, 193, 128, 49, 221, 156}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 108, 230, 155, 172, 226}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 211, 91, 242, 179, 83, 111}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 118, 140, 24, 134, 126, 152, 126, 231, 220}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 227, 75, 68, 166, 236, 157}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 239, 159}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 51, 217, 60}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 74, 230, 78, 26, 195, 255, 153, 37}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 42, 67, 146, 104, 179}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 31, 10, 179}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 0, 0, 0, 55, 39}, 80},
	{{32, 204, 102, 191, 164, 242, 0, 0, 0, 0, 0, 179, 14, 244, 165, 190}, 80},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 207}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 175, 246, 90, 70, 93, 166, 197, 36}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 212}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 194, 201}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 12, 1, 51, 80, 27, 179, 178}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 89, 197}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 238}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 246, 183}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 104, 87}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 95, 18, 172, 180, 20, 30}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 155, 1, 199, 108, 130, 32, 191, 43}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 101, 112, 32, 100, 191, 77, 30, 51, 198}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 177, 9, 116, 73, 46, 115}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 54}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 61, 77, 203, 94, 197, 177, 173}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 201, 42, 13, 139, 78, 224}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 172, 136, 174, 244, 140, 249}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 238, 57, 27, 160}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 158, 128, 89, 182}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 150, 56, 38}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 25, 230, 122, 175, 200, 141, 61}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 180, 154, 71, 97, 20}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 26, 89, 241, 100, 253, 139}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 169, 21, 158, 233}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 223, 94, 122, 63, 169, 148, 82, 167}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 178, 253, 20, 59, 83}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 47, 218, 223, 153, 77, 143}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 127, 51, 221, 46, 216, 30}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 245, 56, 224, 240, 160, 65, 90, 49, 27}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 180}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 217, 0, 137}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 106, 103, 18, 238, 95, 240}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 22, 98, 144, 196, 195, 236, 71, 77, 216}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 253, 204, 19, 140, 166}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 171, 183, 104, 213, 224, 158, 189}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 201, 190}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 146, 139, 63, 154}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 57, 126, 39, 75, 212, 246}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 149, 9, 186, 177, 198, 229}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 224, 106}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 129, 90}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 53, 231, 72, 49, 247, 241}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 221, 81, 231, 254, 65, 198, 30}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 209, 28, 20, 217, 17, 49, 117}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 203, 54, 71, 11, 140}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 195, 103, 60, 189}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 212, 166, 49, 195, 50, 24, 92, 44}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 56, 109, 116, 82}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 220, 114, 203, 33, 126, 32}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 49, 148, 168, 80, 196, 144, 104}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 188, 0, 90, 202, 39, 14, 182, 10, 254}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 82, 137, 188, 150, 149, 143, 204}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 16, 210, 108, 92, 214, 115}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 107, 142, 226, 129, 131, 203}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 130, 119, 66}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 255, 233, 138, 0, 18}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 120, 238, 190}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 30, 60, 37, 181, 60, 227, 56, 135}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 203, 189, 111, 224, 95, 29, 83, 144, 71}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 155, 11, 169, 191, 101}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 10, 84}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 109, 145, 240, 45, 158}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 219, 63, 27, 70}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 249, 137, 14, 229, 209, 125, 195}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 81, 224, 114, 67, 83, 117, 151, 149}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 41, 15, 120, 14, 147, 167, 170}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 15, 100, 108, 172, 106}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 165, 169, 132, 161, 213, 51, 88, 25, 142}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 13, 208, 160, 22, 88, 165, 239, 179, 84}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 235, 216, 11}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 50, 243, 182, 180, 219, 43}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 125, 30}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 162, 231, 173, 236}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 193, 53}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 26, 45, 116, 69}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 90, 129, 205, 36, 94}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 156, 123, 134, 183, 71, 9, 27}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 232, 166, 74, 188, 242, 4, 40, 188}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 0, 53}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 216, 65, 97, 191, 237, 148, 131, 78, 208}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 255, 242, 141, 163, 74, 2}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 0, 0, 107, 200}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 242, 230, 215, 132, 187}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 73, 247, 212, 163, 110}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 154, 209, 14, 208, 137, 137, 118}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 0, 0, 6, 105, 99, 42}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 31, 29, 234, 162, 136, 173, 248, 162}, 184},
	{{29, 133, 210, 252, 124, 66, 160, 0, 0, 0, 146, 89, 241, 222, 44, 63}, 184},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 229}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 182, 71, 221, 144}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 225}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 171, 134, 160, 19, 96}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 252, 26}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 130, 183}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 68, 114, 117, 249, 116}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 0}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 124, 24}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 39, 79}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 136}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 7, 16}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 127}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 128, 24, 54, 171}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 109}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 230, 165, 80}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 48, 198, 47, 137}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 133, 44}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 89}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 214, 40}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 144, 203, 140}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 220, 120, 162, 225}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 178, 23, 61, 58, 249}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 113, 251}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 59}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 182, 172, 254}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 0}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 212, 123, 147, 169, 36}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 215}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 209, 165, 115}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 183, 179}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 223, 180, 185}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 0}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 61, 112}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 8, 189}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 99}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 0}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 212, 180}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 252, 135}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 115, 17, 93, 174, 95}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 94, 167, 246}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 98, 147, 119, 176}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 216, 28, 69}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 250, 54, 253}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 32, 8, 242}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 15, 132, 74, 159, 138}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 103, 224, 45}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 140}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 83, 126, 142}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 191, 53, 44}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 241, 89, 98}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 31, 52, 13, 117, 105}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 29, 106}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 175, 160}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 70, 113}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 55, 112, 74, 151, 63}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 0}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 145}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 147, 136, 199}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 133, 214}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 89}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 82, 238, 98, 172}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 123, 253, 53}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 139, 193, 74, 90}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 252, 137, 228, 15, 40}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 0}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 132}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 0}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 78}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 136, 245, 185}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 0}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 122, 228}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 4, 55, 108, 162}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 140, 160, 45}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 0}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 158, 55, 12, 229}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 0}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 223, 95, 9}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 147, 189, 86, 154}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 0}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 0}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 250, 249, 229, 238, 236}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 31, 20, 140}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 53, 5, 176, 72}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 35, 4}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 45, 230, 229, 66, 59}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 130, 119, 143, 23}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 117, 128}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 27, 38, 45}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 164, 208, 107, 17}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 214}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 21, 86, 12, 164, 59}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 176, 134, 25, 189, 32}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 24, 242, 148, 48, 224}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 0, 212}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 42, 139, 94}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 170, 102, 117, 214}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 0, 243, 209}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 81, 9, 255, 47}, 197},
	{{207, 179, 54, 144, 116, 67, 29, 64, 13, 199, 0, 0, 0, 16, 121, 4}, 197},
	{{129, 216, 0, 0, 0, 228, 255, 185, 203, 71, 170, 124, 128, 94, 153, 0}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 252, 179, 255, 2, 24, 111, 134, 143, 99}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 40, 182, 132, 77, 107, 84, 147}, 63},
	{{129, 216, 0, 210, 172, 229, 141, 24, 101, 196, 231, 223, 105, 4, 201, 131}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 113}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 180, 148, 58, 104, 104, 20, 136, 0, 211}, 63},
	{{129, 216, 0, 0, 0, 0, 77, 5, 76, 125, 184, 103, 236, 164, 73, 47}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 153, 8, 234, 213}, 63},
	{{129, 216, 0, 0, 0, 61, 161, 175, 205, 44, 119, 199, 11, 212, 110, 196}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 6, 1}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 157, 173, 108, 3, 89, 251, 220}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 218}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 73, 229, 109, 187, 201, 246, 187, 149}, 63},
	{{129, 216, 0, 0, 0, 0, 78, 43, 248, 160, 246, 53, 204, 238, 59, 75}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 250, 199, 218, 131, 24, 239}, 63},
	{{129, 216, 0, 129, 137, 21, 186, 241, 31, 234, 44, 121, 53, 40, 182, 194}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 14}, 63},
	{{129, 216, 190, 165, 2, 91, 78, 250, 78, 251, 154, 155, 192, 185, 138, 160}, 63},
	{{129, 216, 0, 0, 0, 0, 101, 33, 141, 22, 124, 183, 63, 35, 126, 134}, 63},
	{{129, 216, 0, 0, 0, 0, 127, 53, 172, 161, 194, 72, 252, 70, 36, 103}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 163, 217, 217, 215, 241, 61}, 63},
	{{129, 216, 0, 0, 245, 252, 237, 173, 123, 107, 175, 5, 187, 217, 207, 228}, 63},
	{{129, 216, 23, 182, 63, 83, 11, 89, 221, 118, 105, 54, 103, 204, 37, 127}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 63},
	{{129, 216, 234, 241, 78, 45, 216, 50, 235, 233, 41, 106, 31, 32, 181, 246}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 224, 83, 159}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 184, 29, 64, 176, 114, 32, 14}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 137, 123, 205, 58, 203, 67, 92, 185, 83}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 204, 73, 78, 134, 150, 178, 235, 87, 77}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 53, 51, 38, 106}, 63},
	{{129, 216, 0, 0, 0, 0, 3, 56, 45, 7, 8, 55, 191, 149, 11, 90}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 93, 38, 58, 221, 73, 142, 134, 236}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 47, 215}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 88, 122, 1, 241, 5, 201, 212}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 176, 33}, 63},
	{{129, 216, 0, 191, 248, 66, 248, 79, 218, 185, 130, 150, 70, 210, 213, 115}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 52, 248, 51, 217, 146, 23}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 193, 78, 97}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 63},
	{{129, 216, 0, 0, 109, 2, 143, 44, 7, 237, 60, 249, 227, 69, 20, 170}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 249}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 253, 47, 250, 28, 113, 123}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 122, 87, 103, 155, 187, 161, 108, 54, 21}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 226, 137, 243, 81, 45, 18, 104, 80, 173}, 63},
	{{129, 216, 0, 0, 0, 44, 126, 14, 220, 35, 248, 223, 17, 8, 204, 228}, 63},
	{{129, 216, 0, 187, 178, 161, 87, 183, 30, 62, 126, 6, 237, 90, 70, 14}, 63},
	{{129, 216, 0, 0, 0, 144, 155, 106, 67, 237, 170, 211, 222, 107, 222, 128}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 23, 22}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 177, 207, 175, 232, 29, 98, 169, 184}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 17, 103, 255, 217}, 63},
	{{129, 216, 0, 0, 99, 210, 192, 149, 96, 48, 98, 202, 69, 50, 89, 169}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 247, 27, 0}, 63},
	{{129, 216, 0, 0, 0, 43, 91, 229, 0, 180, 94, 96, 101, 186, 70, 129}, 63},
	{{129, 216, 0, 0, 37, 113, 16, 151, 5, 112, 108, 160, 224, 63, 221, 81}, 63},
	{{129, 216, 0, 0, 0, 201, 60, 251, 72, 251, 238, 6, 18, 56, 57, 47}, 63},
	{{129, 216, 0, 0, 0, 0, 167, 205, 102, 145, 104, 15, 116, 7, 157, 95}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 184, 152}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 218, 124, 253, 69, 40, 255}, 63},
	{{129, 216, 0, 18, 130, 133, 159, 127, 57, 167, 235, 196, 228, 43, 3, 249}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 111, 68, 204, 248, 254, 38, 48}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 63},
	{{129, 216, 0, 0, 0, 11, 126, 29, 50, 109, 46, 89, 135, 114, 237, 85}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 199, 181, 128, 186, 58, 142}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 127, 185, 180, 40, 202, 123, 235, 65, 43}, 63},
	{{129, 216, 0, 0, 0, 227, 99, 213, 244, 27, 165, 226, 99, 156, 8, 5}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 253}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 70, 138, 169}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 1, 71, 105, 223, 221, 38, 194, 170, 108}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 155, 95, 101, 186}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 18, 107}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 106, 140, 89, 193, 235, 206, 51, 186}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 187, 94, 184, 140, 118, 238, 67, 18}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 127, 124, 7, 194, 59, 168, 8, 188, 104}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 193, 143, 14, 207, 243, 15, 134, 116}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 220}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 228, 144, 239, 102, 171, 90, 67}, 63},
	{{129, 216, 0, 0, 0, 211, 25, 254, 156, 203, 84, 84, 202, 29, 35, 79}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 216, 246, 147, 120, 224, 66, 49}, 63},
	{{129, 216, 0, 0, 99, 12, 33, 45, 5, 116, 20, 86, 208, 108, 205, 249}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 197, 28, 57, 123, 63, 219}, 63},
	{{129, 216, 0, 0, 0, 153, 199, 180, 37, 2, 228, 102, 156, 116, 253, 152}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 199}, 63},
	{{129, 216, 0, 0, 0, 185, 63, 61, 251, 248, 58, 154, 124, 223, 107, 245}, 63},
	{{129, 216, 0, 58, 190, 206, 254, 189, 16, 188, 38, 120, 69, 1, 202, 121}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 91, 238, 248, 26, 123, 237, 163, 178}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 239, 201, 123, 232, 63, 0, 35, 222}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 66, 14, 157, 6, 188, 49, 29, 32}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 215, 170, 66, 215, 237, 73}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 33, 214, 166, 203, 132, 236, 126}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 63},
	{{129, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 219, 213, 118}, 63},
	{{129, 216, 0, 83, 57, 89, 27, 198, 91, 151, 212, 23, 201, 6, 165, 2}, 63},
	{{129, 216, 0, 0, 0, 0, 42, 94, 31, 13, 101, 108, 3, 68, 60, 213}, 63},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 186, 40}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 34, 73}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 108, 19, 141}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 44, 103}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 160, 222, 119}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 103, 124, 174}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 57, 227, 125}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 175, 15}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 86, 170, 101}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 157, 99}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 15}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 206, 146, 135}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 155, 242}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 99, 155}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 233}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 73, 81}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 59}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 108, 96}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 75}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 24, 99, 110}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 179, 2}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 169, 127, 40}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 97}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 151, 217}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 63}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 6, 31}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 8, 192, 48}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 24, 34}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 213}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 173}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 50}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 156, 108}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 127, 187, 108}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 64}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 44, 182}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 39}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 135, 24, 205}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 132, 23}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 201, 94}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 163, 67, 32}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 53}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 85, 32, 222}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 150, 10}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 196}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 139}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 78, 96}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 133}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 226}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 26, 53}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 147, 115}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 24, 134, 238}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 135, 16}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 95, 177, 211}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 12, 134}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 210}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 7, 194}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 171}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 17, 64}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 100}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 50, 58}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 52, 116, 236}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 224}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 239}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 83, 119}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 212, 175}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 100, 251}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 74, 169}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 146, 178, 94}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 172}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 37}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 96, 104, 193}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 146, 110}, 62},
	{{50, 152, 249, 143, 174, 234, 240, 48, 158, 255, 80, 105, 0, 0, 0, 0}, 62},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 138}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 254}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 151}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 103}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 214}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 221}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 172}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 117}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 195}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 25}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 90}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 158}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 48}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 99}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 64}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 104}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 238}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 161}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 66}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 240}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 63}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 236}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 124}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 185}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 121}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 79}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 77}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 89}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 147}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 215}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 166}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 33}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 183}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 160}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 0}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 147}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 26}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 136}, 231},
	{{105, 208, 95, 218, 44, 11, 87, 134, 109, 18, 138, 66, 17, 69, 128, 225}, 231},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 69}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 15, 118, 196}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 13, 162, 155, 77}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 81, 30, 65, 29, 255}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 6, 238, 192, 57, 131, 97, 197}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 129}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 159}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 232, 220, 147, 93, 129, 220}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 139}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 133, 143, 222, 176}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 17, 82, 60}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 208, 138, 174, 91, 93}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 2, 167, 7, 204, 181, 207}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 143, 45, 162, 121, 104}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 238, 64, 33, 98, 221}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 55}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 37, 0, 8, 55, 12, 27, 191}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 121}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 226, 232, 141}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 149, 148, 236, 245, 250, 168}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 251}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 152, 95, 103}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 1, 18, 249, 19, 98, 18}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 46, 5, 94, 80, 189, 7, 215}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 76, 210}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 213, 99, 245}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 155, 33, 211, 35, 56, 27}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 27, 220, 87, 199, 113, 212, 231}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 223}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 91, 216, 204}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 22, 204, 72, 226}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 250, 20, 72, 90}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 220, 14, 247, 221, 204}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 218, 118, 161}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 234, 23, 228, 232}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 16, 119, 251, 123, 2, 180, 199}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 69, 170, 220, 239, 66}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 185, 219, 229}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 7, 50, 97, 35}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 233, 16, 146, 251}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 37, 85, 236, 148}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 43, 248, 94}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 158, 5, 0, 215, 83, 51, 185}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 253, 35, 109}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 32, 46, 104, 152, 94}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 102}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 137}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 86, 230, 25, 205}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 27}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 212, 4, 141, 137, 213, 222}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 119, 116, 233, 89, 39, 241, 115}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 161, 67, 16, 103, 132, 89}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 219, 157}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 24}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 132, 225}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 181, 116, 172}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 78, 142, 118, 206, 84, 196}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 117, 8, 103, 94, 15, 235}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 99, 170}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 94, 203}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 185, 4, 30, 102, 111}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 39, 244, 235}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 211, 170}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 37, 240, 186}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 19, 212}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 2, 72, 74, 201, 104, 19, 244}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 124, 94, 102}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 243, 174, 187, 235, 176, 219}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 233, 141, 195, 187, 213, 98}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 123, 221, 184, 207, 39}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 244, 199, 61, 247, 127}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 76, 226, 254}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 250, 246, 78, 17, 224, 142}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 166, 215, 235, 226, 206, 164, 182}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 158}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 204, 158}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 92}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 54}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 208, 177}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 162, 152}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 0}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 47, 191, 93, 117, 77, 144, 186}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 156}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 47, 34, 200, 45, 163, 55, 152}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 0, 0, 0, 0, 226}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 150, 243, 133, 4, 128, 250}, 158},
	{{151, 79, 158, 220, 122, 101, 210, 164, 64, 0, 0, 163, 216, 3, 0, 5}, 158},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 68, 175}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 243}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 243, 188}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 72, 198}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 138, 121}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 133}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 107, 106}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 155}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 93}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 194, 29}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 164}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 58}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 244}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 92}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 235, 205, 51}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 26}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 50}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 208}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 54}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 97}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 233}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 44, 159}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 48, 22, 167}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 188}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 44}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 75, 121, 17}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 82}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 217}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 250, 91}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 210}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 229, 138}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 141, 143}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 68, 41}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 142, 119, 200}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 118}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 184, 131}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 163, 107, 22}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 51, 179}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 66, 179}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 138, 193, 127}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 143, 108}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 191, 129}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 108, 207, 62}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 184, 180}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 244, 111, 243}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 53, 101}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 237, 71}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 91, 189}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 8}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 69, 4}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 16}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 167}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 212}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 80, 22}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 152}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 25}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 213, 14}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 30, 100}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 51, 86}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 99, 230}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 51, 199}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 179}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 80, 24, 132}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 10, 254}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 228}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{236, 97, 87, 155, 254, 137, 122, 208, 168, 201, 194, 118, 224, 0, 0, 0}, 118},
	{{14, 229, 193, 248, 0, 0, 0, 71, 180, 92, 3, 88, 140, 197, 237, 160}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 232, 127, 43, 110, 151, 77, 114, 214, 218}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 119, 246, 247, 101, 153, 17, 128}, 237},
	{{14, 229, 193, 248, 0, 0, 91, 67, 196, 25, 129, 31, 144, 172, 12, 15}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 222, 102, 126, 129, 160, 161}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 44, 36, 78, 85, 190, 130, 126}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 6, 154, 165, 98, 245, 53, 76, 58}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 84, 6, 83, 134, 124}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 172, 132, 138, 180, 203, 120}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 138, 18, 254, 228}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 103, 76, 149, 15, 98}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 109, 22}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 19, 9, 196, 241, 117, 97, 117, 229, 143}, 237},
	{{14, 229, 193, 248, 0, 32, 209, 53, 70, 4, 77, 119, 195, 29, 168, 229}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 207, 139, 141, 33, 71, 85, 119, 207, 205}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 19}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 185, 55, 120, 75, 222, 87, 201, 226, 177}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 43, 23, 2, 20, 4, 78, 78, 6, 166}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 210, 23, 245, 234, 154, 237}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 216}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 194, 189, 227, 67}, 237},
	{{14, 229, 193, 248, 0, 0, 160, 161, 46, 14, 184, 48, 225, 168, 228, 128}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 71, 158, 25, 105, 55, 241, 121, 136, 171}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 62, 255, 194, 221}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 61, 187, 24, 248, 84, 5, 141, 249, 233}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 201}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 227, 4, 196, 37}, 237},
	{{14, 229, 193, 248, 0, 0, 80, 242, 196, 116, 110, 123, 35, 203, 191, 9}, 237},
	{{14, 229, 193, 248, 0, 74, 52, 101, 183, 12, 197, 181, 241, 99, 3, 132}, 237},
	{{14, 229, 193, 248, 0, 0, 123, 47, 14, 226, 32, 155, 154, 77, 40, 235}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 249}, 237},
	{{14, 229, 193, 248, 0, 0, 234, 83, 137, 201, 93, 46, 254, 50, 54, 35}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 76, 127, 106, 83, 63, 114, 254, 240, 98, 242}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 206, 213, 121, 245, 239, 138, 178, 234, 115}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 53, 41, 104, 203, 5, 70, 219, 3}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110}, 237},
	{{14, 229, 193, 248, 0, 212, 219, 253, 29, 133, 52, 187, 171, 163, 117, 19}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 90, 148, 68, 195}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 49, 204, 217, 136, 3, 134}, 237},
	{{14, 229, 193, 248, 0, 0, 60, 44, 122, 126, 192, 171, 185, 8, 139, 161}, 237},
	{{14, 229, 193, 248, 0, 248, 210, 222, 117, 53, 55, 51, 54, 69, 187, 126}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 66, 107, 218, 56, 34, 235, 210}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 101, 54, 66, 100}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 81, 117, 48, 171, 192, 72, 109, 6}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 233, 61, 83, 44, 113, 9}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 179, 211, 12, 88, 227}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 175, 167, 134, 59, 255, 179, 60, 126, 147}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 247}, 237},
	{{14, 229, 193, 248, 0, 127, 128, 0, 160, 57, 145, 8, 32, 35, 255, 134}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 130, 16, 125, 231, 187, 85}, 237},
	{{14, 229, 193, 248, 0, 227, 250, 157, 20, 240, 202, 118, 61, 33, 26, 11}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 128, 10}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 41}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 106, 149, 55, 166, 131, 21, 168, 187}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 237},
	{{14, 229, 193, 248, 0, 0, 62, 179, 16, 130, 29, 49, 180, 155, 97, 2}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 79, 164, 32, 229, 242}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 163, 48, 98, 235, 177, 145, 94}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 217, 148, 250, 55, 103, 229, 16, 225}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 88, 59, 61, 21, 171}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 2, 208, 247, 113, 216, 138}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 104, 12, 214, 164, 45, 248, 233, 68, 14}, 237},
	{{14, 229, 193, 248, 0, 235, 212, 176, 187, 172, 38, 125, 242, 194, 254, 99}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 188}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 59, 11, 178, 40, 168, 129, 139}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 180, 184, 9, 23}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 253}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 33, 111}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 24}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 211, 231, 22, 33, 89, 10, 154, 168}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 45, 181, 145, 217, 55, 147}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 183, 156, 197, 188, 4, 231, 106, 152, 24}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 237},
	{{14, 229, 193, 248, 0, 0, 110, 134, 235, 197, 41, 103, 226, 78, 43, 117}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 206}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 226}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 101, 101}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 93, 161, 96, 212}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{14, 229, 193, 248, 0, 0, 96, 62, 34, 209, 49, 123, 14, 39, 236, 174}, 237},
	{{14, 229, 193, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 237}, 237},
	{{14, 229, 193, 248, 154, 85, 101, 21, 7, 153, 94, 56, 57, 177, 184, 228}, 237},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 95, 70, 247}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 217, 228, 245, 39}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 25, 84, 55}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 234}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 94, 122, 62, 64, 234}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 29, 124, 148, 210, 205}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 58, 186, 217, 42, 77}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 3, 251, 230}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 159, 162}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 253, 210, 231}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 75, 70, 170, 212, 107}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 15, 189, 241, 130, 125}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 89, 39, 31, 10, 247}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 236, 85, 148, 242, 40}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 10}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 65, 140, 222, 110}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 235, 21, 118, 254}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 114, 46, 32, 7, 57}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 42, 219, 237, 236, 184}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 177, 100, 38, 217}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 118, 223, 57, 113}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 187, 162, 19, 118}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 41, 150, 189}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 70, 251, 45, 105, 57}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 214}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 254, 117, 200, 137, 97}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 1, 230, 144, 225, 59}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 209, 170, 22}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 3, 206}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 78}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 118, 140, 214, 65}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 65, 49, 36}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 146, 60, 55, 148}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 230, 12, 212, 19, 154}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 105, 91, 43, 152, 231}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 196, 75, 191, 177}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 168, 70, 76, 35}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 53, 110, 144, 186}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 192, 14}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 204, 185}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 13, 100}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 173, 87, 31, 174, 201}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 150}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 222, 210, 75, 177, 95}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 249, 87}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 10, 92, 6, 89}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 127, 224, 53}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 161, 34, 228, 156, 145}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 125}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 125, 73, 112}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 82, 159, 161, 125}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 57}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 182, 210, 53}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 221}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 210, 235, 160, 112, 187}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 133, 204}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 222, 84, 230, 170, 214}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 31, 247}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 100, 141, 58, 1, 12}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 75, 34}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 151, 49, 103, 62, 61}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 95, 31, 70}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 231}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 236}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 119, 12, 113}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 6}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 200, 120}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 159}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 247, 215, 251, 164}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 57, 207, 167, 117, 196}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 59, 181, 85, 150}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 24, 47, 42}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 45}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 243, 240}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 229, 69, 246, 160, 236}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 28, 31}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 191, 243, 91, 197}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 43, 207, 219, 173}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 31, 75, 31, 20}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 0, 0, 0}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 245, 188, 198, 84, 227}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 55, 117, 131}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 184, 44, 66, 209}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 11, 85, 193}, 15},
	{{46, 154, 50, 80, 92, 147, 158, 86, 1, 112, 0, 0, 0, 97, 239, 154}, 15},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{88, 131, 21, 84, 62, 86, 7, 110, 142, 251, 242, 110, 194, 175, 247, 0}, 84},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 239}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 79}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 96}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 65}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 122}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 104}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 201}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 216}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 68}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{229, 216, 111, 92, 173, 32, 63, 70, 36, 84, 6, 74, 136, 166, 38, 0}, 205},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 168, 147}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 21, 221, 221, 50}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 45, 5, 43}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 66, 233, 254}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 72, 217, 172, 62, 187}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 189}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 144, 124, 83, 80, 17}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 89, 29, 155, 27, 166}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 28, 157}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 166, 87, 208}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 50}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 133, 139, 17, 131, 66}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 239}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 54, 171, 242, 225, 176}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 148, 137}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 218, 94}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 144, 92}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 118, 26, 76, 72, 132}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 251, 96, 160, 44}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 228, 237, 191, 1}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 146, 133, 232, 6}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 154, 123, 174, 38}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 188, 37}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 34, 1}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 80}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 219, 37, 134, 205}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 157, 117, 145, 150, 226}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 78, 179, 162, 69}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 216, 70, 103, 195, 177}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 143, 129, 241, 222}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 236, 93}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 176, 234, 184}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 169, 121}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 216, 129, 114, 24}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 61, 126, 236, 154}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 254, 155, 231, 195, 196}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 178, 15, 146, 156}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 97, 147, 73}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 130}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 159, 190, 139, 166, 166}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 114, 40}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 173, 136, 52}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 226, 18, 186}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 9, 175}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 109, 48, 11, 65}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 130, 190, 110, 174}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 177, 249}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 110, 242, 235, 117, 128}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 72, 21}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 165}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 113, 61}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 76}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 89, 221, 236, 18}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 205, 225, 147, 193}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 243, 117}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 237, 125, 73}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 16, 248, 240, 51}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 195}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 15}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 42, 78, 138, 205}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 135, 133}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 29}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 52, 38}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 57, 222, 44}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 167, 141, 164}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 73, 215, 146, 71, 204}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 187, 44, 161, 238}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 60, 178}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 65, 248, 128, 7, 79}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 198, 55, 41}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 108, 249}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 193}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 221, 19, 216, 102}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 219}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 210, 51, 196, 27}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 40}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 76}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 0}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 0, 0, 128}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 0, 0, 132, 230, 126}, 220},
	{{121, 147, 216, 245, 37, 189, 146, 63, 145, 74, 128, 21, 9, 126, 150, 196}, 220},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 9, 203, 66}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 58, 132, 230}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{44, 26, 254, 11, 181, 0, 245, 100, 251, 55, 126, 215, 129, 237, 230, 107}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 187, 59, 185, 156, 89}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 201, 10, 204, 71, 188}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 156, 23, 120, 141, 186, 105, 18, 199, 185}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 188, 181, 34, 253, 20, 195, 228, 0}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 72, 241, 130, 106, 11, 250, 250}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 208, 36, 157, 166, 12, 9}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 68, 69, 11, 82, 212}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 141, 249, 54, 121, 176, 148, 140, 182, 112}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 162, 54, 177, 38, 75, 203, 197, 255, 179}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 79, 64, 96, 223, 20}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 180, 199, 222, 111}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 95, 55, 215, 2, 76, 59, 37}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{44, 26, 254, 11, 181, 0, 96, 147, 221, 106, 20, 208, 83, 253, 147, 72}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 79, 223, 84, 3, 133, 95}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 165, 136, 164, 167, 209, 192, 130, 25}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 244, 91, 216, 155, 148, 234, 165, 207, 51}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 169, 11, 167, 113}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 164, 251, 3, 15}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 71, 30, 1}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 132, 14, 21, 169, 239, 239, 99}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 76, 0, 82, 149, 178, 255}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 92, 237, 220, 154, 229, 26, 205, 229, 127}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 11, 104, 221, 20, 150, 222, 97}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 137}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 34, 245, 36}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 250, 71, 8, 103, 43, 192, 49}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 146, 9, 228, 103, 39, 24}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 136, 219, 68, 32, 30, 172, 163}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 107, 185, 35, 20, 66, 199, 25}, 42},
	{{44, 26, 254, 11, 181, 0, 163, 65, 123, 117, 48, 57, 22, 211, 13, 150}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 49, 159, 57, 186}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 57, 105, 0, 0, 9, 120, 42}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 177, 203, 118, 97, 119, 218, 179, 200}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 113, 43, 125, 175, 48, 234, 93, 152}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 27, 229, 101, 139, 241, 210, 77, 25}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 144, 176, 250, 155}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 124}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 57, 238, 124, 73, 50, 102, 204, 184}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 53}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 212, 152, 88, 83, 62, 194, 177, 174, 50}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{44, 26, 254, 11, 181, 0, 86, 113, 163, 70, 227, 63, 67, 130, 147, 225}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 193, 251, 69, 183, 160, 215}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 207, 162, 28, 110}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 166, 226, 93}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 126, 45, 240, 121, 149, 132, 238}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 84}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 13, 245, 225, 209, 148, 169, 161}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 179, 134, 164, 40, 126}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 7, 44, 158, 14, 63}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 197, 22, 85, 249, 244}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 134, 30, 164}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 64, 213, 97, 16}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 198, 182, 13}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 186, 120, 120, 53, 31, 226, 17, 199, 151}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 116, 84, 126, 1}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 107, 184, 125, 160, 2, 76}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 215, 39, 62, 237, 65}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 109, 127, 79, 97, 58, 91, 98, 33, 18}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 107, 75, 223, 5, 80, 227}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 120, 173, 212, 106, 218, 168, 41, 128, 199}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 109, 170, 21, 16, 189, 136, 54}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 50}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 71, 112, 99, 79, 227}, 42},
	{{44, 26, 254, 11, 181, 0, 74, 20, 117, 242, 118, 221, 184, 182, 57, 141}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 250, 146, 131, 40, 176}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 114, 110, 198, 248, 5, 139, 39, 78, 222}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 245, 198, 199, 235, 224, 8, 115, 155, 179}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 229, 189, 199, 160, 83, 14, 242, 226}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 5, 55, 65, 238}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 69, 201, 12, 48, 165, 112, 33}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 208}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 83, 226, 77, 215, 194, 5}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 126, 28, 153, 180, 143}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 249, 197, 156, 145, 72, 236, 74}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 103, 173, 210, 245, 142, 235, 78}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 21, 14, 133}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 95, 193, 204, 124, 159, 82, 191, 189}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 196}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 228, 173, 19, 234, 87, 50, 41}, 42},
	{{44, 26, 254, 11, 181, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 31}, 42},
	{{209, 114, 97, 249, 227, 159, 224, 0, 191, 73, 73, 231, 244, 27, 202, 126}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 70, 164, 126, 68, 159}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 23, 152, 125, 140, 78}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 79, 112, 51, 16, 158, 97, 84, 121}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 129, 195, 20, 71, 254}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 177, 192, 25, 191, 99, 21}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 115, 3, 155, 212, 239, 252, 132, 50}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 93, 115, 160, 54, 36, 171, 216}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 251, 168}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 176, 157, 1, 203, 178, 157, 33, 224, 89}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 200}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 52, 178, 140, 220, 71, 254, 247, 109, 160}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 118, 183}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 10, 221, 251, 80, 230, 161, 128, 16, 137}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 57, 175, 225, 119}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 190, 57}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 25, 248, 13, 143, 205, 96, 45}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 87, 192}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 106, 124, 162, 25}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 201, 91, 150, 225, 236, 179, 81}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 68, 109, 221, 255}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 49, 122, 120, 55, 230, 74, 236}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 248, 76, 16, 193, 95, 25}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 46, 44, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 4, 254, 99, 204}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 226, 45, 152, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 135, 45}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 106, 176, 184, 193, 63, 29, 168, 196}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 101, 172, 11, 229, 237, 121, 177, 178, 161}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 223, 10, 88, 76}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 229, 219, 232, 194, 64, 209}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 186, 115, 253, 165, 34}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 186, 39, 233, 148}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 69, 224}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 20, 197, 190}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 136, 124, 182, 4, 202}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 17, 110, 143, 82, 68, 215, 255}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 104, 124, 14, 237}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 251, 213, 92, 177, 165}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 176, 32}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 212, 136, 139, 35, 203, 22, 241, 73}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 4, 109}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 38, 0, 34}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 71, 4, 104, 194}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 43, 155, 231, 35, 136, 217, 5, 108, 161}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 54, 51, 8, 223, 94, 196, 1, 21, 111}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 24, 3, 231}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 10, 210, 48, 86, 174, 177, 134}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 51, 23, 251, 141, 5, 211}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 226, 246, 168, 238, 167, 183}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 184, 14, 45, 83, 105, 50, 114}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 81, 130, 91, 26}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 62, 75, 4, 127, 25, 27}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 136}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 79, 68, 122, 69, 120, 169, 94, 112}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 176, 239, 62, 169}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 196, 223, 81}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 26, 220, 151, 90, 38, 4}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 130, 233}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 103, 206, 225}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 140, 147, 240}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 91, 12, 225, 65}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 196, 97, 252, 107, 197, 13, 22, 166}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 107, 0, 70, 101, 91, 60, 230}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 106, 26, 37}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 90, 4, 185, 192, 7}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 160, 126, 204, 192, 135}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 7, 22, 116, 61, 61, 195, 251, 60, 133}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 34, 183, 61, 83, 150}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 204, 170, 250, 116, 51, 13, 245, 36, 57}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 75, 222, 128, 164, 153}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 110, 97, 228, 101, 196, 245, 4, 99, 243}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 173, 98, 59, 102, 154, 234}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 72, 3}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 175, 143, 13, 103, 245}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 109, 65}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 5, 34, 124, 221, 78}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 163, 179}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 40, 132}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 205, 209, 125, 43, 251, 178}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 207, 201, 79, 94, 63, 100, 179}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 162, 90}, 144},
	{{209, 114, 97, 249, 227, 159, 224, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 144},
	{{184, 244, 43, 117, 56, 0, 0, 191, 87, 113, 169, 247, 20, 203, 105, 49}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 55, 82, 246}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 229, 37, 8, 79}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 203, 17, 130, 249, 19, 146, 125, 4}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 81, 211, 2, 49, 207}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 199, 240, 87, 224, 151, 31}, 74},
	{{184, 244, 43, 117, 56, 0, 201, 228, 246, 15, 139, 59, 149, 134, 79, 191}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 92, 124, 254, 17, 23, 80, 183, 86}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 52, 187, 156, 115, 229, 201, 41}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 72, 189, 56, 215, 170, 122, 34, 52}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 100, 217, 32, 30, 150}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 38}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 197, 67, 132, 139, 122, 251, 180, 4, 243}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 37, 17, 162, 225, 148, 117, 62}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 72, 132, 86, 120, 7, 128, 27, 179, 225}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 101, 158, 16, 182, 53, 173, 130}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 69}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 253, 224, 8, 224, 223}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 241, 16, 46, 68, 203, 170}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 185}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 198, 68, 136, 55, 245, 1, 252, 98}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 97, 147, 157, 79, 43, 159}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 149}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 55}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 28, 174, 70, 195, 9}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 43, 160, 166, 218, 122, 188, 25}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 110, 40, 26, 62, 223}, 74},
	{{184, 244, 43, 117, 56, 0, 124, 25, 71, 202, 57, 235, 54, 144, 125, 191}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 130, 142, 91, 235, 193, 233, 33}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 69, 18, 7, 70, 209, 235}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 83, 9, 223, 39, 0, 34, 245, 78, 45}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 41, 249, 128, 149, 80, 240, 105, 44, 96}, 74},
	{{184, 244, 43, 117, 56, 0, 125, 200, 18, 17, 246, 91, 190, 153, 68, 127}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 78, 51, 160}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 117, 82, 129}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 198, 187, 166, 38}, 74},
	{{184, 244, 43, 117, 56, 252, 97, 53, 143, 123, 185, 254, 163, 213, 92, 155}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 109, 59, 0, 171, 238, 68, 207, 163}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 180, 213, 50, 234, 58, 171}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 144, 228, 189, 172, 233, 211, 43, 57}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 142, 194, 27, 58}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 43, 99, 37, 21, 63}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 64}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 229, 75, 174, 112}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 84, 56, 162, 6, 225}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 156, 31, 133, 135, 253, 168}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 107, 146, 173, 40, 171}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 67, 5, 90}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 49, 234, 108}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 107, 25, 199, 180, 7, 51}, 74},
	{{184, 244, 43, 117, 56, 0, 250, 135, 144, 126, 113, 174, 15, 187, 223, 81}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 90, 98, 59, 180, 55, 207, 3, 196, 1}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 192, 66, 173, 158, 74, 231, 169, 70}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 50, 35, 70, 231, 237}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 29, 117, 174, 63}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 143, 193, 95, 71}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 144}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 72, 138, 219, 219}, 74},
	{{184, 244, 43, 117, 56, 0, 45, 168, 67, 30, 159, 200, 76, 121, 105, 130}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 56, 137, 150, 245, 73}, 74},
	{{184, 244, 43, 117, 56, 0, 144, 121, 253, 38, 245, 14, 23, 236, 167, 15}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 122, 192, 223, 189, 78, 188, 133}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 80, 202, 117, 126, 147}, 74},
	{{184, 244, 43, 117, 56, 0, 125, 182, 253, 178, 208, 189, 102, 39, 61, 100}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 93, 9, 90, 222, 230}, 74},
	{{184, 244, 43, 117, 56, 0, 69, 221, 167, 149, 242, 92, 184, 233, 23, 57}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 100, 77, 226, 150, 192, 194}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 90, 246, 233}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 107}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 95, 126, 20, 254, 165, 87, 65, 35, 26}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 78, 194, 162}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 246, 74, 245, 136, 122, 225, 118, 156}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 38}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 231, 171, 189}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 138, 168, 178, 149, 88}, 74},
	{{184, 244, 43, 117, 56, 0, 44, 126, 185, 77, 21, 187, 57, 230, 70, 48}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 66, 12, 85, 36}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 120, 69, 139, 15}, 74},
	{{184, 244, 43, 117, 56, 103, 153, 41, 254, 223, 223, 126, 232, 125, 137, 157}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 213, 188, 25, 28, 115, 13, 169}, 74},
	{{184, 244, 43, 117, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211}, 74},
	{{60, 81, 128, 0, 0, 188, 160, 4, 117, 240, 20, 24, 151, 183, 211, 175}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 219, 112}, 89},
	{{60, 81, 128, 0, 145, 106, 155, 194, 30, 177, 105, 15, 89, 51, 95, 235}, 89},
	{{60, 81, 128, 0, 8, 107, 121, 22, 108, 94, 121, 109, 84, 116, 204, 204}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 73, 0, 152, 129, 91, 167, 40}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 68, 82, 115, 116, 18, 101, 150}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 43, 66, 109, 65, 130}, 89},
	{{60, 81, 128, 0, 80, 229, 177, 102, 182, 172, 78, 227, 245, 57, 90, 154}, 89},
	{{60, 81, 128, 0, 0, 0, 140, 206, 44, 197, 238, 8, 196, 117, 255, 217}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 127, 238, 110, 136, 144, 102, 110}, 89},
	{{60, 81, 128, 0, 0, 26, 191, 184, 115, 61, 97, 213, 84, 251, 194, 56}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 77, 211, 54}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 152}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 130, 150}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 144, 196, 254, 178, 251}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 81, 135, 231, 48, 190, 109, 121, 192}, 89},
	{{60, 81, 128, 133, 219, 23, 149, 51, 40, 154, 211, 77, 49, 126, 191, 66}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 84, 224}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 43, 221, 68}, 89},
	{{60, 81, 128, 0, 110, 164, 136, 180, 131, 231, 148, 226, 165, 121, 245, 172}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 115, 53, 94, 178, 90}, 89},
	{{60, 81, 128, 0, 131, 27, 99, 33, 216, 165, 38, 14, 167, 3, 118, 154}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 204, 249, 169, 233, 110, 28}, 89},
	{{60, 81, 128, 0, 0, 61, 213, 96, 214, 201, 128, 53, 246, 249, 35, 49}, 89},
	{{60, 81, 128, 0, 0, 198, 203, 101, 126, 76, 77, 31, 150, 173, 25, 65}, 89},
	{{60, 81, 128, 0, 19, 162, 15, 163, 222, 157, 240, 54, 89, 248, 31, 231}, 89},
	{{60, 81, 128, 0, 0, 217, 193, 54, 176, 1, 8, 75, 248, 39, 68, 81}, 89},
	{{60, 81, 128, 0, 25, 153, 80, 26, 162, 71, 6, 110, 234, 194, 59, 157}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 39, 174, 49, 77, 219, 176, 76, 217}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 69, 208, 49, 224, 211}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 246, 215}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 229, 228, 47, 247, 16, 117, 39}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 239}, 89},
	{{60, 81, 128, 0, 199, 69, 175, 113, 0, 194, 124, 3, 177, 174, 180, 27}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 121, 13, 178, 162, 34, 21, 135, 100}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 89},
	{{60, 81, 128, 0, 0, 151, 213, 89, 170, 227, 42, 148, 226, 93, 62, 245}, 89},
	{{60, 81, 128, 71, 236, 226, 155, 102, 252, 195, 226, 119, 165, 181, 158, 54}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 155, 201, 75, 164, 187, 245, 211, 204, 2}, 89},
	{{60, 81, 128, 0, 94, 176, 105, 212, 27, 70, 75, 164, 228, 128, 199, 189}, 89},
	{{60, 81, 128, 0, 0, 11, 73, 37, 59, 209, 130, 160, 90, 162, 232, 37}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 89},
	{{60, 81, 128, 0, 0, 0, 12, 250, 18, 170, 208, 114, 196, 96, 128, 43}, 89},
	{{60, 81, 128, 16, 219, 144, 223, 153, 151, 88, 72, 146, 205, 251, 117, 131}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 190, 108}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 32, 28}, 89},
	{{60, 81, 128, 0, 0, 25, 69, 207, 51, 6, 181, 189, 133, 58, 176, 91}, 89},
	{{60, 81, 128, 0, 0, 0, 148, 186, 23, 85, 170, 82, 12, 8, 142, 68}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 125, 193, 171, 115, 236}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 209}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 124, 53, 140, 104, 199}, 89},
	{{60, 81, 128, 0, 0, 235, 67, 53, 79, 56, 58, 63, 121, 112, 86, 122}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 138}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 206, 88, 152}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 167}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 173}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 177}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 143, 253}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 245, 102, 213, 248, 233, 240, 8, 186, 136}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 229, 27, 36, 199, 110, 40}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 60}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 45, 79, 175, 144, 19, 98, 71, 70, 41}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 27, 55, 10, 136, 126}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 123, 192, 71, 238, 201, 245}, 89},
	{{60, 81, 128, 0, 26, 51, 17, 231, 43, 226, 58, 70, 50, 121, 105, 29}, 89},
	{{60, 81, 128, 246, 51, 237, 121, 180, 146, 83, 145, 85, 230, 99, 145, 121}, 89},
	{{60, 81, 128, 0, 0, 0, 242, 248, 194, 26, 158, 81, 12, 45, 179, 244}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 18}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96}, 89},
	{{60, 81, 128, 0, 89, 129, 3, 198, 86, 209, 232, 18, 64, 80, 235, 179}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 58}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 229, 35}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 198}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 14, 124, 39, 46, 86, 131, 137, 26}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 148, 191}, 89},
	{{60, 81, 128, 0, 0, 0, 180, 217, 134, 23, 238, 58, 73, 188, 196, 16}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 134, 238, 45, 8, 148, 131, 41, 155}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 30, 229, 85}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 108, 182}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 254, 6}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 68, 200, 131, 76, 227, 61, 76, 241, 28}, 89},
	{{60, 81, 128, 0, 0, 127, 157, 190, 187, 113, 28, 47, 140, 215, 31, 28}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 150, 34, 72, 96, 99, 202, 175, 99, 234}, 89},
	{{60, 81, 128, 0, 0, 183, 5, 148, 12, 193, 156, 101, 130, 233, 177, 19}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 16}, 89},
	{{60, 81, 128, 0, 221, 162, 61, 61, 153, 172, 228, 166, 149, 205, 0, 108}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 125, 214, 209, 106, 127, 137, 108, 80}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 33, 229, 104, 127, 208, 209, 115, 93, 2}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 89},
	{{60, 81, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 226, 101}, 89},
	{{60, 81, 128, 0, 0, 231, 61, 247, 2, 174, 61, 227, 178, 131, 237, 155}, 89},
	{{60, 81, 128, 0, 0, 0, 20, 214, 128, 45, 124, 154, 138, 139, 53, 33}, 89},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 171, 36}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 132}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 193, 206, 156}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 76, 19}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 199}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 233, 66, 14, 176}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 231, 198}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 149, 194, 209, 17}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 240, 66, 158}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 78}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 31, 20, 103, 159}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 87, 223}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 126, 226}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 95, 55, 151}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 92, 86, 51}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 118}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 132, 85}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 154, 213, 104, 169}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 93, 192}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 6}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 185}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 248, 126, 82}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 193, 235, 181, 176}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 250, 166, 246}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 236, 254, 153, 140}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 255, 180, 81}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 132, 249, 96}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 117, 148, 247, 137}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 233, 19, 179}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 208, 172, 167}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 179, 197, 193, 21}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 249}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 117}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 101, 247}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 122}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 245}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 246}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 157, 162}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 199}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 3, 199, 238, 206}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 183, 66, 227}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 123, 101, 101, 11}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 250, 23, 252}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 174, 196, 250, 237}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 133, 86}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 253, 180}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 16, 125, 112, 11}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 249, 235, 96, 47}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 88, 239}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 2, 220, 149, 238}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 35, 1, 132}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 22, 161, 91}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 170, 63, 1, 231}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 164, 66}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 109, 152}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 232, 148, 85}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 135, 153}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 19, 168, 147}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 61, 182, 160, 106}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 82, 43}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 151, 154}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 188, 138, 84, 92}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 72}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 180, 47}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 231}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 222, 133, 160}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 173}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 129, 212, 136}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 249}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 150, 101, 49, 145}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 67}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 117, 148}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 7, 155}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 120}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 62, 17, 104}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 137, 236}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 0}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 228, 10, 183, 70}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 168, 221, 231, 139}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 220, 123}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 55, 86, 246}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 248, 72, 247}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 22, 169, 132, 55}, 77},
	{{18, 40, 21, 113, 226, 91, 195, 88, 161, 19, 142, 0, 0, 0, 0, 235}, 77},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 61}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 214, 228, 177}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 21}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 87, 9, 114}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 21, 230}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 110, 56}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 210}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 14}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 148}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 141, 192, 112}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 178, 128}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 247}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 156, 148, 48}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 227, 185}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 227, 220, 53, 140}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 125, 91, 87}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 147, 19}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 175}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 131, 168}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 42, 164}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 22, 177}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 107, 2, 92}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 199, 79}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 3, 198, 3}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 165, 118, 232}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 144, 253}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 114}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 112, 3, 72, 184}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 127, 62, 206}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 46, 94}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 128, 167, 189, 228}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 134}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 123, 204}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 52, 110}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 17, 147, 176, 96}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 139, 133, 144}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 176}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 94, 145, 55}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 100, 216, 199}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 196}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 55, 173}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 55, 249, 54}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 233}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 81, 81}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 141}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 170, 130}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 28, 245}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 13}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 216, 247, 232}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 200, 17, 39}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 116, 9, 170}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 247, 2, 40}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 97, 188, 77}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 35, 248}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 214, 172}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 74, 63, 145}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 80, 171}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 87}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 242, 239}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 123}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 123, 141, 96}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 226}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 201, 128}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 139, 64, 115, 167}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 34}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 0}, 2},
	{{57, 0, 212, 158, 56, 51, 108, 198, 59, 5, 137, 196, 0, 0, 0, 139}, 2},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 83, 150, 244, 190, 43, 65}, 75},
	{{168, 252, 0, 0, 0, 46, 247, 233, 32, 224, 124, 0, 250, 138, 7, 31}, 75},
	{{168, 252, 0, 0, 0, 0, 46, 232, 152, 58, 54, 16, 138, 43, 106, 105}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 122}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 234, 50}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 70, 131}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 194}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 191, 139, 56, 151, 93, 80, 224}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 220}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 238}, 75},
	{{168, 252, 0, 0, 0, 183, 226, 74, 109, 13, 131, 180, 151, 69, 164, 51}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 120, 5, 75, 198, 26, 211, 73, 24}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 203, 133}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 149, 147, 28, 227}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 49, 99, 92, 231, 160, 52, 15}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 154, 81, 207, 203, 140, 216, 72, 28, 157}, 75},
	{{168, 252, 0, 0, 0, 0, 194, 30, 94, 52, 78, 4, 128, 245, 239, 31}, 75},
	{{168, 252, 0, 0, 154, 126, 232, 145, 155, 6, 10, 185, 101, 233, 209, 252}, 75},
	{{168, 252, 0, 0, 0, 8, 6, 13, 3, 59, 230, 140, 73, 65, 240, 196}, 75},
	{{168, 252, 22, 193, 157, 101, 109, 140, 92, 4, 66, 129, 132, 134, 15, 53}, 75},
	{{168, 252, 0, 0, 223, 42, 229, 158, 1, 170, 82, 235, 174, 30, 200, 71}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 74, 105, 239, 81, 134, 6, 213, 72, 147}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 130}, 75},
	{{168, 252, 0, 219, 146, 40, 69, 227, 136, 73, 140, 104, 230, 65, 60, 46}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 243, 134}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 231, 30, 216, 92, 129, 122, 219, 135, 134}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 30, 41, 135, 92, 156, 92, 69, 71}, 75},
	{{168, 252, 0, 0, 0, 241, 60, 125, 167, 173, 142, 142, 193, 193, 62, 201}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 124, 28, 39}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 203, 15, 201, 137, 149, 240, 179, 98}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 37, 18, 139, 160, 133, 5, 183, 35, 39}, 75},
	{{168, 252, 0, 250, 79, 119, 64, 108, 164, 159, 102, 6, 77, 219, 126, 128}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 194, 20, 156, 192, 161, 85, 91, 102, 90}, 75},
	{{168, 252, 0, 0, 0, 0, 40, 1, 191, 21, 241, 117, 48, 212, 253, 190}, 75},
	{{168, 252, 0, 92, 248, 220, 83, 93, 66, 14, 94, 69, 207, 10, 146, 24}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 132, 57, 109, 13, 8, 101, 20, 139, 41}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 126, 41, 162}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 168, 150, 96}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 82, 102, 19, 234}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 6, 218, 23}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 19, 196, 182, 152, 169, 236, 136, 43}, 75},
	{{168, 252, 0, 0, 0, 0, 138, 170, 88, 41, 237, 203, 43, 148, 220, 215}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 150, 104, 134}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 186, 227, 109, 10, 254, 205, 85, 252}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 25, 152, 197, 199, 243, 52, 206}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 201, 156, 106}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 76}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 192, 101, 164, 12}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 61, 115, 194, 127, 115, 188, 139}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 124, 126, 91, 57, 62, 177, 245, 103, 207}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 84}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 94, 148, 211}, 75},
	{{168, 252, 0, 0, 0, 0, 129, 44, 54, 125, 245, 71, 122, 33, 112, 8}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 145}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 21, 211, 142, 189, 1, 175, 181}, 75},
	{{168, 252, 0, 0, 253, 33, 164, 54, 40, 227, 41, 63, 38, 122, 80, 190}, 75},
	{{168, 252, 0, 0, 0, 0, 26, 249, 216, 63, 229, 231, 143, 231, 104, 187}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 159, 83, 144, 27, 72, 141, 113, 59, 19}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 118, 130, 80}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 193, 85, 220, 94, 176, 86, 40, 184}, 75},
	{{168, 252, 0, 0, 45, 221, 116, 170, 5, 146, 34, 170, 145, 49, 183, 23}, 75},
	{{168, 252, 0, 0, 0, 0, 90, 183, 171, 182, 175, 221, 154, 82, 115, 21}, 75},
	{{168, 252, 0, 0, 0, 72, 97, 84, 1, 41, 245, 117, 222, 179, 179, 11}, 75},
	{{168, 252, 0, 0, 0, 49, 41, 227, 248, 25, 160, 91, 225, 114, 30, 163}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 105, 34, 40, 103, 150, 173}, 75},
	{{168, 252, 4, 230, 19, 14, 206, 182, 243, 3, 110, 217, 235, 10, 152, 84}, 75},
	{{168, 252, 0, 0, 0, 246, 49, 143, 103, 108, 90, 12, 38, 224, 40, 164}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 45, 130, 248, 122, 129, 145, 194, 91, 23}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 184, 118, 201, 36, 248, 194, 208}, 75},
	{{168, 252, 0, 0, 183, 1, 122, 220, 175, 187, 141, 196, 95, 1, 83, 50}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 152, 234, 16, 188, 1, 156, 60}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 95, 130, 140, 34, 211, 12, 142, 121}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 204, 125, 231, 227, 24, 76}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 90, 11, 172, 65, 243, 95, 43, 62, 221}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 138, 128, 26, 147, 253, 17, 115}, 75},
	{{168, 252, 0, 0, 0, 0, 152, 30, 232, 204, 112, 123, 46, 156, 230, 77}, 75},
	{{168, 252, 0, 0, 64, 249, 147, 161, 49, 176, 215, 134, 176, 50, 141, 147}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 179, 235}, 75},
	{{168, 252, 0, 0, 0, 0, 57, 90, 22, 187, 194, 87, 133, 233, 127, 105}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 109, 64}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 75},
	{{168, 252, 0, 227, 15, 43, 59, 193, 137, 217, 39, 189, 96, 151, 177, 157}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 12, 80, 108}, 75},
	{{168, 252, 0, 0, 0, 175, 63, 169, 241, 160, 220, 219, 96, 140, 167, 87}, 75},
	{{168, 252, 0, 0, 170, 107, 255, 204, 219, 79, 120, 189, 237, 18, 63, 96}, 75},
	{{168, 252, 0, 0, 0, 101, 227, 149, 232, 69, 189, 137, 106, 182, 252, 63}, 75},
	{{168, 252, 0, 0, 0, 0, 229, 174, 231, 107, 177, 165, 129, 129, 58, 53}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 54, 150, 23, 137, 143, 26}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 58, 115, 240, 12, 110, 179, 39, 160}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 88, 249}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 41, 209}, 75},
	{{168, 252, 0, 0, 44, 111, 186, 89, 255, 165, 161, 197, 11, 145, 34, 1}, 75},
	{{168, 252, 0, 0, 0, 0, 0, 0, 0, 197, 45, 196, 9, 223, 175, 96}, 75},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 58, 182, 90, 229, 173, 203}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 188}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 185, 123, 163, 219, 195}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 103, 167, 104, 203, 254}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 8}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 120, 160}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 103, 48, 42, 94}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 189, 78, 33, 103, 107}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 183, 226}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 48, 93}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 38, 105, 24, 241}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 124, 41, 246, 204, 104, 199, 80}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 237, 178, 31, 123}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 41, 15, 247, 126, 160, 20, 204}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 150, 166, 156}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 47, 193, 33, 167, 254, 233, 152}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 94, 3, 70}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 111}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 118}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 156, 100, 164}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 70, 182, 166, 98, 251, 63, 40}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 174, 112, 57, 127, 144}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 198, 250, 41, 95}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 209, 181, 205, 245, 213, 166}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 72, 82, 241, 132, 109, 83, 17}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 137, 213, 172, 142}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 244, 225, 95}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 183}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 203}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 132, 171, 94, 179, 69}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 224, 52, 101}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 16, 151, 121}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 58, 103, 129, 250, 43, 74, 91}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 153}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 232, 54, 208, 226, 167, 208, 88}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 44, 46, 186}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 125, 175, 154, 166, 110, 28, 229}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 12, 7}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 153, 203, 76, 112, 252, 11}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 37, 153, 6}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 124, 205, 81, 197, 128, 91, 249}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 101, 18, 5}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 46, 214}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 115, 153, 159, 199, 111, 28}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 22, 73, 68, 18, 196}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 114}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 242, 59, 163, 229}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 190, 150, 13}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 219}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 51, 198, 116}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 106}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 131, 67, 99, 182, 218, 119, 124}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 41, 147, 164, 98, 60, 13}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 176, 198, 141, 162, 191, 63, 87}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 76, 197, 18, 151, 57, 25}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 46, 228, 72, 86, 71}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 212, 85, 214, 161, 103, 226}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 70, 244, 243, 25, 218, 123, 22}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 129, 124, 213}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 123, 2, 43}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 181, 99, 166, 214}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 46}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 208, 177, 123, 115}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 115, 168}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 196, 100}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 97, 100, 234, 120, 24, 122, 194}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 178}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 216}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 66, 92, 210, 208, 116, 137}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 238}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 11}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 75, 51, 11, 19, 104}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 77, 166, 165, 173, 198, 136}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 62, 20, 69, 145, 145}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 39, 156, 94, 251, 46, 33}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 189, 197}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 64, 99, 58, 146, 91, 139}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 3, 194, 176, 238, 209}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 180}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 244, 69, 107, 30, 45}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 238}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 126, 66, 32, 22, 98, 99, 234}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 34, 87, 136, 235}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 181, 233, 86, 23, 187, 251}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 162, 199}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 84, 190, 115, 173, 23}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 0, 0, 60, 186}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 90, 170, 183, 128, 204}, 18},
	{{64, 181, 254, 103, 1, 230, 117, 199, 128, 0, 0, 0, 35, 221, 178, 68}, 18},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 110, 60, 22, 234}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 136, 25, 79, 133}, 246},
	{{212, 48, 214, 127, 78, 176, 142, 89, 144, 214, 230, 121, 146, 223, 59, 14}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 251, 162, 238, 192, 236, 200, 59}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 186, 40, 68, 212, 27, 231, 217, 171, 27}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 114, 93, 98, 244, 249}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 162, 165, 144}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 166, 52, 3}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 137, 64, 21, 145, 155, 199, 67, 214, 92}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 246},
	{{212, 48, 214, 127, 78, 176, 29, 0, 29, 31, 228, 13, 5, 238, 194, 251}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 6, 142, 13, 167, 121, 151, 126}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 12, 171, 206, 243, 239, 16, 53, 79, 28}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 153, 46}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 194, 217, 172}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 110, 18, 3, 67, 47, 36}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 99, 175, 84}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 85, 54, 67, 98, 209}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 110, 0}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 170, 225}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 6, 208, 176, 146, 44, 117, 101, 6, 118}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 30, 233, 95}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 133, 216, 254, 107, 244}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 222, 45, 41, 170, 10}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 203, 86, 122, 150, 192}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 127, 25, 43}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 176, 8, 56}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 209, 45, 122, 160, 250, 110}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 15, 86, 55}, 246},
	{{212, 48, 214, 127, 78, 176, 14, 107, 125, 101, 233, 83, 249, 137, 196, 183}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 30, 76}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 14, 175, 31, 207, 250, 114, 167}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 232, 180, 141, 158, 127, 196}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 216, 106, 32, 172, 173, 41, 106, 156}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 194, 22, 250}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 43, 72, 55, 174, 144, 93, 74, 230}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 23, 10, 210, 46, 172, 248, 121, 56, 78}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 225, 22, 43, 115, 68, 239, 235}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 186, 150, 100, 85, 246}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 40, 75, 61, 27, 242, 202}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 162, 48, 190, 34}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 217, 29, 176, 176, 36, 160}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 194, 167, 99, 158, 127}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 36, 212, 18, 219, 127, 254, 251}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 50, 190, 183, 65, 141, 48, 200, 242, 68}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 1, 202, 211, 246, 191, 162}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 240, 81, 30, 32, 39}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 233, 224}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 195, 45, 217}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 35, 218}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 41, 79, 224, 242, 127}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 31, 72, 255, 45, 78}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 2, 53, 43, 13, 196, 1}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 232, 96}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 54, 137, 167}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 93, 95}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 89, 178, 228, 3}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 141, 173, 84}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 179, 128}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 112, 169, 144, 128, 230, 186, 71, 22}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 183, 255, 132, 99}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 38, 6, 54}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 146, 82, 0, 75, 203}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 99, 187, 59, 11, 139, 148, 245, 38, 59}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 138, 189}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 68, 137, 78, 227, 45}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 99, 211, 183, 67}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 206, 196, 169, 132, 85, 179}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 24, 253}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 193, 95, 80, 131, 255, 62, 185, 93}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 169, 251, 191, 226, 99, 154}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 157, 184, 167}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 188, 209, 161, 250, 81, 28, 54, 240, 81}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 100, 118}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 226, 186, 181, 17, 38}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 77, 8, 52, 229, 28, 176, 160, 211, 119}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 120, 63, 203, 101, 186, 4, 107, 63, 93}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 142, 116}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{212, 48, 214, 127, 78, 176, 0, 0, 0, 0, 0, 0, 0, 65, 222, 120}, 246},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 213}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 11}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 160}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 134}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 242}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 164}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 109}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 3}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 119}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 230}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 31}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 14}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 185}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 51}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 108}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 111}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 197}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 175}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 75}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 102}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 62}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 101}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 3}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 47}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 69}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 57}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 184}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 116}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 117}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 93}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 170}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 0}, 10},
	{{155, 185, 236, 163, 204, 49, 129, 120, 183, 47, 10, 243, 65, 92, 192, 112}, 10},
	{{94, 200, 0, 0, 0, 0, 0, 214, 146, 92, 71, 1, 57, 211, 189, 39}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 98, 130, 92, 5}, 207},
	{{94, 200, 0, 0, 0, 0, 209, 46, 69, 227, 136, 179, 120, 96, 179, 66}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 130, 4, 129, 36, 152, 219, 93}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{94, 200, 0, 0, 0, 201, 52, 135, 186, 76, 59, 14, 122, 248, 21, 83}, 207},
	{{94, 200, 0, 0, 61, 223, 131, 56, 242, 111, 159, 167, 235, 210, 146, 137}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 121, 9, 37, 102, 133, 137, 36, 113}, 207},
	{{94, 200, 0, 0, 0, 223, 150, 227, 157, 247, 193, 119, 44, 12, 133, 181}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 213, 85, 64, 63}, 207},
	{{94, 200, 78, 181, 60, 41, 84, 212, 218, 62, 112, 61, 247, 100, 194, 227}, 207},
	{{94, 200, 0, 0, 0, 64, 78, 115, 244, 179, 144, 201, 15, 32, 44, 124}, 207},
	{{94, 200, 0, 0, 168, 239, 126, 205, 135, 40, 11, 22, 89, 29, 194, 184}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 22, 252, 184}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 207},
	{{94, 200, 0, 0, 0, 0, 106, 223, 121, 134, 49, 245, 8, 119, 2, 55}, 207},
	{{94, 200, 251, 157, 94, 191, 57, 2, 8, 145, 78, 6, 158, 233, 153, 126}, 207},
	{{94, 200, 0, 0, 211, 220, 223, 10, 138, 154, 195, 124, 79, 79, 110, 155}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 197, 182, 79, 199, 74, 214, 165}, 207},
	{{94, 200, 0, 0, 0, 0, 12, 156, 137, 6, 96, 47, 213, 121, 111, 235}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 231, 141, 104, 225}, 207},
	{{94, 200, 0, 89, 7, 103, 240, 237, 118, 190, 170, 41, 31, 233, 236, 100}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 192, 4}, 207},
	{{94, 200, 0, 0, 66, 31, 187, 191, 118, 137, 171, 213, 152, 98, 213, 248}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 195}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 138, 187, 38, 198, 73, 163, 85, 28}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 115, 6}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 166, 204, 19, 1, 180, 178, 142, 100, 61}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 186, 91, 180, 195, 20, 101, 100}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 238, 52, 210, 83, 154, 151}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 112, 5, 175}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 136, 220, 135, 235, 8, 4}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 222, 23, 44, 177}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 17, 119, 17, 58, 1, 28, 146, 155}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 22, 218}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 135, 215, 156, 87, 126, 25, 181, 136}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 0, 25}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 82, 197, 237, 0}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 245, 153, 48, 5, 94, 61}, 207},
	{{94, 200, 0, 184, 172, 89, 52, 150, 167, 177, 138, 81, 82, 189, 210, 57}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 126}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 152, 135, 133, 14, 214, 40, 85}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 231, 21, 25, 155, 44, 9, 172, 206}, 207},
	{{94, 200, 0, 0, 0, 0, 253, 209, 53, 81, 47, 183, 142, 207, 199, 248}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 102, 240, 86}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 196, 83, 236}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 62, 5, 47, 14, 184, 103, 35, 24}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 94, 107, 218, 150, 120, 109, 47}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 64, 226, 205, 204, 73, 202, 63}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 52, 9, 211, 30, 37, 74, 122, 76}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 75, 192, 130, 57}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 191, 108, 40, 92, 161, 24}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 125, 119, 71, 236, 54, 117}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 15, 119, 36, 244}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 162}, 207},
	{{94, 200, 0, 0, 82, 43, 30, 104, 134, 247, 4, 248, 162, 174, 203, 43}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 47, 84, 86, 88, 100, 243, 11}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 70, 41, 14, 118}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 110, 56, 149, 162, 112, 129}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 123, 39}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 242, 248, 43, 248, 190, 227, 21, 240, 198}, 207},
	{{94, 200, 0, 0, 179, 122, 203, 4, 10, 18, 61, 182, 42, 15, 234, 54}, 207},
	{{94, 200, 0, 0, 0, 164, 210, 117, 90, 37, 237, 131, 222, 145, 132, 218}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 121, 63, 60, 98, 160, 94, 153, 162}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 204, 112, 194, 190}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 211, 250, 17, 188, 205, 234, 153, 63}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 105, 123, 246}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 18, 115, 109, 23, 166, 31, 58, 22}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 67, 70, 149}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 155, 232, 59, 199, 145, 44}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 58, 124, 88, 1, 169, 166}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 82, 194, 58, 161, 162, 150, 37, 164}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 231, 56, 47, 250, 186, 240}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 121, 121, 30, 90, 31, 188, 20, 129, 12}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 128}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 47, 194}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 183, 103, 168, 8, 90, 32, 204}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 69, 60, 21}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 216, 250}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 78, 118, 9, 35}, 207},
	{{94, 200, 226, 227, 223, 54, 65, 41, 177, 136, 149, 173, 97, 160, 226, 201}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 250}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 215, 162, 210, 207, 53, 148}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 6, 221, 55}, 207},
	{{94, 200, 0, 0, 0, 0, 0, 0, 0, 0, 40, 200, 69, 185, 133, 145}, 207},
	{{94, 200, 0, 0, 0, 75, 110, 73, 200, 35, 50, 170, 161, 190, 218, 108}, 207},
	{{94, 200, 0, 0, 0, 0, 148, 114, 247, 113, 119, 20, 198, 219, 108, 126}, 207},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 213}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 77, 204, 213, 128}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 79}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 14, 36}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 187, 119, 155, 110, 95}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 237, 121, 13, 84, 145}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 116, 76, 164}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 218, 104, 190, 71, 219}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 25, 185, 66, 126}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 180}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 144, 117, 3}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 196, 109, 54, 176}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 50, 135, 132, 127, 150, 70}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 146, 26, 143, 137}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 155, 190, 78, 197, 20}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 70, 24, 71, 213, 240, 69, 191}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 112, 242}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 50, 162, 188, 131}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 90, 194, 126, 183, 108, 152}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 45, 184, 151, 110, 218, 177, 19}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 106, 5}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 57, 82}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 44, 141, 98, 230, 98, 56}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 125}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 88, 16, 2, 196, 60, 131}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 23, 191, 247, 98, 169, 214}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 102}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 46, 35, 173, 91, 111, 122}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 50, 55, 201}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 106, 42, 113, 139}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 26, 226, 120, 24, 179}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 250, 43, 223, 218}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 214, 207, 208}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 149, 151, 25, 176}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 45, 163, 54, 23, 219, 226}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 52, 182, 112}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 82, 215, 77}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 165}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 191, 89}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 247, 128, 238, 240, 123}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 145, 239, 140, 187, 40}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 254, 186, 127, 6, 225}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 176, 168, 142, 239}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 90, 101, 236}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 90, 226, 32}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 247}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 27}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 50, 214}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 139, 119}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 173, 223, 158, 224, 106, 117}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 233}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 165, 187}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 243, 111, 134, 173, 4, 58}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 48, 37}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 90}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 194, 60}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 37, 85, 244}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 178, 175, 115, 28, 174}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 152, 233, 255, 130, 195}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 16, 69, 45, 87}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 219, 245, 231, 227, 250}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 94}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 181, 7, 246}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 12, 207, 239, 77, 70, 38}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 221, 200}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 197, 10, 220, 10, 253, 207}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 122, 123, 162, 129}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 121, 211}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 44, 157, 173, 166, 46}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 14, 216, 251, 102}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 61, 231, 97, 54, 45}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 135, 141, 42, 90, 250, 118}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 163, 20, 214, 115}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 99, 95, 51, 51, 20, 17}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 108, 154}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 141, 193, 194}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 142, 185, 78, 218, 178}, 41},
	{{19, 210, 136, 113, 73, 79, 132, 196, 224, 0, 0, 0, 0, 0, 0, 174}, 41},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 250, 209}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 52, 199, 207, 95}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 43, 97, 19, 229}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 60, 198, 205, 41}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 222, 134, 14}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 19, 254, 143, 46}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 199, 50}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 207, 37, 113, 142}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 55, 56}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 62, 38}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 72, 174}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 85}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 200, 159}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 219, 218, 139, 12}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 93, 40, 253}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 165}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 220, 46, 141}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 200, 140}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 28, 57, 239, 13}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 213, 230, 181}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 211}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 71, 195}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 86, 225}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 198, 189}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 177}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 237, 192, 135, 229}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 241}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 245}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 6, 189}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 68}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 197, 113, 76}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 102}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 92, 153, 177, 114}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 162, 84}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 249}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 222, 95, 76, 92}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 93, 6}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 234, 158}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 39, 181}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 130, 10}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 98}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 105}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 229}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 255}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 129, 23}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 219, 20}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 125}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 102, 165, 200, 107}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 231}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 226, 26}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 40, 112, 2}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 156, 223, 159}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 217}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 234, 7, 219, 19}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 176, 38}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 203, 177}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 60, 5}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 232, 76}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 32, 191, 97}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 142, 96, 202, 86}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 184, 108, 204, 62}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 33, 92}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 165, 65, 204, 195}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 122, 236}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 247, 161}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 187}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 0}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 222, 21, 231, 32}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 193, 113, 59, 233}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 86, 142, 160, 154}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 210, 83}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 177, 110, 240}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 235, 199, 13}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 202, 193}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 117}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 132, 44, 207, 35}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 255, 241}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 39, 136, 80}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 52, 124, 152, 252}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 88, 110, 24}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 31}, 102},
	{{24, 203, 246, 242, 241, 223, 150, 237, 213, 202, 11, 128, 0, 0, 0, 199}, 102},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 204}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 154}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 171}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 94}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 238}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 1}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 222}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 129}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 77}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 77}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{115, 59, 171, 221, 172, 181, 170, 67, 115, 205, 44, 107, 162, 67, 56, 0}, 118},
	{{250, 128, 0, 0, 0, 0, 0, 131, 131, 146, 230, 141, 29, 232, 106, 32}, 146},
	{{250, 128, 0, 0, 0, 0, 58, 5, 222, 97, 74, 196, 5, 132, 15, 82}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 246, 93, 98, 90}, 146},
	{{250, 128, 170, 218, 217, 243, 215, 48, 149, 56, 192, 139, 195, 80, 235, 137}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 146},
	{{250, 128, 185, 223, 12, 112, 172, 92, 188, 207, 36, 12, 230, 32, 208, 113}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 231, 28, 40, 200, 18, 248}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 226}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 193, 97, 188, 240, 213, 41, 50, 130, 55}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 203, 56, 221, 98, 145, 230, 128, 23, 125}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 69, 183, 111, 92, 174, 252, 143}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 64, 87, 212, 223, 19, 126, 76}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 123, 124, 103, 20, 83, 25, 102}, 146},
	{{250, 128, 0, 0, 0, 0, 83, 195, 41, 254, 246, 183, 126, 201, 101, 7}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 203, 212, 144, 54, 12, 12, 12, 187}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 250, 114, 120, 60, 84, 226, 181}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 173, 215, 28, 102}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 119, 40, 207, 80, 59, 98}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 3, 54, 135, 110, 1, 237, 211, 138}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 241, 181, 197, 41, 132, 48}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 53}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 64, 131, 147, 0, 144, 140, 46, 141, 98}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 52, 78, 54, 248, 231, 34, 82}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 164, 41, 46, 253}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 247, 146, 197, 32, 135, 243, 133, 30, 107}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 62, 101, 235, 141, 113, 183, 210, 75}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 92, 8}, 146},
	{{250, 128, 0, 0, 0, 0, 202, 149, 249, 204, 46, 132, 241, 142, 237, 6}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 105, 139, 10, 94, 24, 39}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{250, 128, 0, 0, 36, 5, 143, 126, 116, 178, 127, 152, 217, 144, 20, 40}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 158, 129, 169, 92}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 227, 243, 60, 244, 87, 55, 218}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 36, 220, 187, 93, 98, 191, 146, 77, 94}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 125, 168, 121, 205, 101, 170, 172, 72}, 146},
	{{250, 128, 200, 61, 149, 102, 232, 174, 108, 157, 220, 9, 165, 154, 81, 19}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 194}, 146},
	{{250, 128, 0, 143, 55, 121, 195, 118, 36, 223, 231, 233, 237, 7, 48, 67}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 77, 139, 38, 37, 33, 74, 99, 217}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 172, 208, 25, 28, 248, 254, 248, 92}, 146},
	{{250, 128, 0, 0, 0, 248, 152, 55, 162, 3, 178, 124, 217, 81, 166, 126}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 250, 220, 149}, 146},
	{{250, 128, 123, 185, 26, 168, 75, 199, 210, 130, 131, 166, 121, 230, 90, 46}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 215, 129, 162, 172, 141, 163, 148, 34, 159}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 15, 9}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 14, 207, 233, 167, 101, 73, 137, 126, 253}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 20, 246, 219, 124, 49, 78}, 146},
	{{250, 128, 0, 0, 0, 0, 79, 7, 165, 213, 81, 167, 9, 142, 24, 227}, 146},
	{{250, 128, 0, 0, 0, 58, 160, 20, 149, 73, 131, 167, 191, 255, 19, 48}, 146},
	{{250, 128, 0, 232, 185, 37, 244, 132, 122, 115, 85, 80, 124, 24, 157, 250}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 215, 178, 155, 255, 17, 224, 169}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 245, 82, 236, 63, 107, 98}, 146},
	{{250, 128, 0, 199, 92, 88, 38, 192, 62, 41, 142, 132, 21, 63, 54, 4}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 218, 173, 65, 235, 186, 179}, 146},
	{{250, 128, 0, 0, 233, 249, 217, 103, 145, 134, 38, 130, 104, 183, 216, 78}, 146},
	{{250, 128, 0, 0, 0, 250, 155, 133, 127, 189, 99, 6, 120, 133, 170, 54}, 146},
	{{250, 128, 0, 0, 194, 179, 55, 130, 247, 77, 132, 236, 81, 101, 94, 151}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 139, 136, 69}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 105, 203, 171, 97, 26, 44, 101}, 146},
	{{250, 128, 0, 0, 0, 119, 50, 27, 139, 154, 97, 95, 18, 12, 190, 190}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 209, 0, 190, 162, 237, 202, 175, 11}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 211, 251, 142, 160, 209, 20, 39}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 38, 191}, 146},
	{{250, 128, 0, 0, 210, 245, 108, 55, 70, 250, 184, 86, 133, 122, 246, 99}, 146},
	{{250, 128, 0, 78, 69, 33, 66, 104, 91, 118, 36, 45, 115, 8, 142, 87}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 88, 67, 239, 35}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 118, 199, 34, 189, 13, 154, 157}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 10, 58, 46, 133, 120, 200, 39, 3}, 146},
	{{250, 128, 198, 91, 152, 86, 153, 102, 54, 111, 163, 3, 140, 31, 221, 230}, 146},
	{{250, 128, 0, 0, 199, 82, 251, 83, 55, 56, 112, 221, 18, 69, 124, 75}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 126, 145}, 146},
	{{250, 128, 0, 0, 0, 194, 22, 27, 184, 229, 70, 5, 19, 134, 118, 219}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 6, 61, 16, 33, 220, 128}, 146},
	{{250, 128, 0, 92, 203, 93, 187, 148, 116, 1, 147, 81, 52, 114, 165, 61}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 39, 14, 138, 233}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 16, 164, 254, 163}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 139, 25, 212}, 146},
	{{250, 128, 0, 69, 52, 155, 33, 67, 235, 95, 101, 191, 83, 188, 237, 140}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 197, 136, 21, 11, 9, 49, 253}, 146},
	{{250, 128, 0, 0, 239, 230, 34, 83, 241, 39, 195, 72, 201, 195, 195, 106}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 62, 151, 198, 103}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 13, 170, 115, 80}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 212, 11, 46}, 146},
	{{250, 128, 0, 0, 0, 0, 13, 124, 133, 145, 211, 163, 40, 186, 192, 217}, 146},
	{{250, 128, 0, 0, 0, 149, 205, 227, 55, 130, 174, 103, 166, 39, 191, 31}, 146},
	{{250, 128, 138, 153, 179, 210, 102, 1, 205, 208, 86, 226, 87, 45, 91, 78}, 146},
	{{250, 128, 0, 246, 90, 82, 55, 137, 191, 116, 215, 4, 70, 190, 8, 195}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 235}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 251, 120}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 156, 118, 228, 66, 240, 199}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 12, 34, 246, 209}, 146},
	{{250, 128, 0, 120, 54, 124, 183, 22, 77, 194, 140, 187, 223, 2, 185, 137}, 146},
	{{250, 128, 0, 0, 0, 0, 0, 0, 0, 0, 19, 57, 224, 30, 208, 114}, 146},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 50, 12}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 239, 236}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 190}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 195, 111}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 40}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 68, 61}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 162, 147}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 27}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 130, 32}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 233}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 60, 104}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 155}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 29, 102}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 42}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 47}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 81, 4}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 29, 175}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 253}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 213}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 212}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 218, 89}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 64, 239}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 13}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 36}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 222}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 117, 35}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 213, 84}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 52}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 196}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 191}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 121, 2}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 183}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 123}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 63, 198}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 248}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 72}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 6}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 184}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 147, 141}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 104, 92}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 119, 231}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 208}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 206}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 141}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 239}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 223, 67}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 203, 22}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 75, 232}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 20, 221}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 73, 243}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 42, 194}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 46}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 155}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 26, 166}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 191}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 200}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 155, 236}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 38}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{203, 240, 28, 158, 182, 12, 86, 182, 142, 47, 143, 57, 239, 0, 0, 0}, 122},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 66, 224}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 135, 11}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 161}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 145}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 79, 242}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 50}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 182}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 169}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 234}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 41, 68}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 213, 99}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 85, 250}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 19, 30}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 244}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 16}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 129}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 13}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 118}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 126, 58}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 189}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 74}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 26, 229}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 20}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 141, 45}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 110, 40}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 218, 171}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 184, 19}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 204}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 31}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 118, 192}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 27}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 165}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 54, 145}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 156}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 20}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 174}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 169, 141}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 169}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 192}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 13}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 142, 21}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 5}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 191}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 237}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 174}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 152}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 243, 97}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 11}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 159, 106}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 133}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 71, 128}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 185}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 181}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 56, 222}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 185}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 231}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 5}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 96}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 82}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 0, 0}, 6},
	{{196, 218, 109, 52, 2, 0, 64, 153, 34, 250, 240, 185, 117, 0, 31, 22}, 6},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 214}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 189, 9, 168, 108, 145, 117, 79, 25}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 146, 85, 110, 107, 118, 211, 242}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 128, 29, 97, 200, 36, 207, 167, 177}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 106, 82, 2, 224, 118, 7}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 115, 222, 108, 91}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 6, 37, 237, 202, 20, 9}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 129, 240}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 174}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 154, 121, 94, 106, 95}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 203, 105, 14, 20, 112, 79}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 184, 10, 96, 83, 254}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 45, 86, 151, 118, 230, 124}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 243, 130, 239, 147, 7, 158}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 19, 227, 176, 195, 101}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 254, 211}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 123, 1, 102, 45, 189, 105, 1}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 5, 59}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 22, 33}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 194, 104, 67}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 231, 0}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 180, 207, 128, 242, 132}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 146, 233, 147, 185, 86, 82, 67, 76}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 15, 76, 176, 12, 94, 178}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 229, 132}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 106, 37, 156, 145, 110}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 74, 94, 134}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 109, 1, 13, 246, 91, 181}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 194}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 78}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 41}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 128, 208, 102, 216, 168}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 139, 213, 98, 170, 2}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 195, 236, 119, 8}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 163, 143, 183, 54, 173}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 127}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 132}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 220}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 106, 8, 228, 176, 118}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 215}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 151, 152, 241, 57, 20, 229}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 218, 63}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 120, 58, 37, 21, 154, 111}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 197, 83, 16}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 18, 112, 92, 46, 243, 103, 147}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 59, 179, 19}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 197, 92, 21}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 32, 221, 241, 97, 67, 9}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 216, 2, 65, 101, 49, 154, 6, 74}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 198, 154, 14, 136, 57}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 133, 130, 202, 104}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 195, 168, 252, 87, 91, 167, 204, 53}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 84, 168, 12, 130, 252, 74, 61, 242}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 2, 121, 203, 170}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 227, 51, 154, 93, 101, 69, 201, 112}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 121, 111}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 159, 127, 61, 17, 131}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 65, 187, 116, 73}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 59, 214, 6, 152, 212, 254, 196}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 183, 60}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 69}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 89, 209, 147, 232, 23, 254, 153}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 1, 162, 137}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 99, 108, 175, 170, 138}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 75, 216, 27, 1, 112}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 113, 253, 90, 181, 227, 53, 152, 156}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 242}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 67, 128}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 53}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 20, 72, 183, 35, 16, 43, 15}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 12, 160, 216}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 242, 75, 200, 58, 143, 255}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 175, 254, 140, 131, 148, 188, 188}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 217, 117, 220, 126, 231, 70}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 199, 244, 55, 170}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 135, 60, 4, 245, 206, 27}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 203, 195, 134, 21, 242, 148}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 246}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 95, 12}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 59, 215, 21, 197, 253, 225}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 58, 241, 143, 213, 108, 29, 141}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 24, 38, 239, 100, 41, 156, 175}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 74, 227, 42, 13}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 55, 244, 116, 33, 78, 150, 66}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 158}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 231, 152, 120, 221, 109}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 35, 189}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 0, 0, 0, 0, 0, 0, 0, 133}, 18},
	{{137, 131, 191, 40, 72, 209, 74, 64, 34, 239, 8, 97, 72, 62, 214, 107}, 18},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 31, 46, 166}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 55, 192, 9}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 46, 120, 232, 112, 226, 181}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 2}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 37, 81, 235, 30, 106}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 91, 32, 190}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 117, 8, 24}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 52, 212, 62, 72, 163, 249, 148}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 64, 137, 28, 233, 122, 88, 224}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 197, 73, 22, 239}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 235, 105, 161, 169, 84}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 193, 213, 50, 36}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 63, 124}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 226, 176}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 66, 41}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 114, 16, 210, 224, 79}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 57, 241, 182, 85, 73}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 204}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 254, 246}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 186, 54, 227}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 55}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 149, 179, 68, 182, 222, 214, 36}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 6, 236}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 249, 235, 6}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 58, 75, 0, 193}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 68, 163, 234}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 209, 43, 72, 102, 247, 237}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 164, 104, 198, 18, 8, 66}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 62, 33, 251, 78}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 148, 118, 147}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 188, 67}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 229, 46}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 173, 161, 0, 140, 197}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 65, 52, 108, 179}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 38, 106, 123, 170}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 98, 109}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 169}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 236}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 21, 184, 114}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 37, 131, 222, 58, 27, 198, 159}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 23, 75, 224, 225, 204, 6, 72}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 111, 7, 215}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 222}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 242}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 41, 251, 73, 114}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 55, 6, 104, 172, 69}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 227, 171, 51}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 4, 33, 61}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 119, 24, 147, 50}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 2, 158, 154, 152, 93, 51, 123}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 91, 175, 159}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 195, 64}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 117, 223, 37}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 157, 6, 132, 116, 46}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 191, 201, 73, 226, 97}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 148, 145, 221, 242, 20}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 147}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 158, 97, 95, 77, 39}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 178, 54}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 73, 174}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 201, 210, 121}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 174, 24}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 144}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 202, 144}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 59, 104, 236, 199}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 228}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 184, 137, 62, 59, 162, 143}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 67, 116, 160, 83, 170}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 218, 229, 5}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 141}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 18}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 147, 184, 68, 19, 174}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 163, 136, 15}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 12, 196, 192, 77, 157, 92}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 241, 190, 186, 232, 85}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 73}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 146, 98, 74}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 188, 159, 127, 134, 88, 73, 187}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 151}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 0, 0, 0, 112}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 0, 188, 48, 130, 232}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 0, 37, 101, 67, 24, 143}, 83},
	{{236, 126, 167, 37, 185, 20, 34, 207, 76, 0, 187, 16, 25, 88, 224, 110}, 83},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 52, 166, 212}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 159}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 253, 234, 109}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 37, 67}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 20}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 205}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 173, 86, 232}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 221}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 121}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 43, 69}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 112, 73}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 135}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 86, 216, 93}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 141, 71, 171}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 150, 23}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 66, 90, 199}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 197}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 3}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 181}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 182, 191}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 68, 238, 155}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 208, 79}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 59, 111}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 11, 45}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 67}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 79, 54, 92}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 30}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 19, 60, 226}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 168}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 78, 219, 90}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 91, 161, 189}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 136}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 174, 32, 212}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 175, 153}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 248}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 20, 223}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 21, 94, 232}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 26, 172, 39}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 237, 115, 9}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 201, 29, 236}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 171, 3}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 172, 123, 6}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 245}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 161}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 73, 203}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 4}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 123, 174}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 173, 206, 195}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 251, 13}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 119, 168}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 208}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 163}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 218, 156}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 235, 210}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 208, 248, 152}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 246, 37}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 13}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 106}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 214, 244, 74}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 254}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 107, 26}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 124, 234}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 145, 239}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 117}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 234}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 178, 209}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 17, 92}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 196, 133}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 135, 38}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 129}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 177}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 31}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 105, 67, 190}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 146, 22, 119}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 128, 144}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 177}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 56, 244, 253}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 165, 149}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{129, 192, 245, 137, 251, 52, 75, 68, 81, 112, 146, 133, 64, 0, 0, 0}, 90},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 103}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 28, 248, 28, 145, 196}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 207, 201, 128, 138, 247, 76, 16}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 81, 160, 93, 122, 138, 213, 182, 249, 107}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 231, 58, 123, 141}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 172}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 150, 26}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 196, 93, 243, 50, 76, 146, 57, 0, 33}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 145, 9, 149, 195, 110, 26, 210, 0}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 229, 235, 195, 146, 107, 117, 175}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 76, 190, 220, 85}, 140},
	{{7, 31, 148, 19, 0, 131, 25, 103, 13, 232, 25, 204, 14, 236, 241, 67}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 213, 75, 78, 136}, 140},
	{{7, 31, 148, 19, 0, 0, 204, 32, 220, 84, 255, 12, 237, 66, 188, 40}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 139, 201}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 108, 58, 3, 87, 64, 78, 92}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 112, 248, 100, 223, 144, 63}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 36, 48, 228, 26, 70, 64, 45, 61, 144}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 85}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 225, 222}, 140},
	{{7, 31, 148, 19, 0, 14, 233, 247, 0, 105, 153, 238, 174, 28, 53, 11}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 235, 24, 182, 78, 140, 4, 112, 152}, 140},
	{{7, 31, 148, 19, 0, 14, 21, 150, 91, 205, 205, 205, 92, 167, 144, 197}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 87, 186, 20, 167, 255, 163, 243}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 186, 128, 66, 50, 191, 164}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 210, 19, 71, 87}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 101, 48, 14, 139}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 84, 194, 42, 142, 8, 235}, 140},
	{{7, 31, 148, 19, 0, 0, 168, 182, 139, 24, 231, 102, 217, 51, 175, 177}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 42, 241}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 77, 169, 27, 172, 22, 133}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 167, 2, 212, 169, 87, 217}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 210, 110, 87, 14, 232, 56, 23, 169, 196}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 29, 86}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 35, 92, 54, 141, 166}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 220, 30, 46, 233, 126, 210, 72, 238}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 33, 139, 141, 47, 8, 35, 203}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 101, 104, 86, 242, 57, 155}, 140},
	{{7, 31, 148, 19, 0, 120, 253, 187, 47, 23, 100, 29, 28, 201, 191, 26}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 252}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 92, 187}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 222, 92, 135, 89, 246, 55}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 46, 227, 132, 219, 205}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 166, 3, 131, 128, 168}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 115, 231, 86, 170, 5, 23, 193, 246}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 4, 242}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 114, 173}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 74, 220, 93, 177}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 47, 231, 105, 155}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 185, 4, 173, 105}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 112, 34, 97, 8}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 223, 253, 131, 25, 180}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 207, 36, 140, 114, 67}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 13, 239, 7, 49, 218, 150, 4}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 210, 232}, 140},
	{{7, 31, 148, 19, 0, 0, 115, 80, 102, 91, 188, 141, 182, 229, 8, 63}, 140},
	{{7, 31, 148, 19, 0, 156, 131, 71, 164, 52, 111, 26, 165, 162, 93, 34}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 69, 189}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 175, 226, 252, 122, 177, 45, 66, 105, 217}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 7}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 162, 207}, 140},
	{{7, 31, 148, 19, 0, 149, 193, 134, 14, 76, 3, 189, 66, 35, 241, 148}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 105}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 140},
	{{7, 31, 148, 19, 0, 1, 115, 70, 193, 231, 239, 191, 255, 246, 184, 88}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 13, 204, 150, 251, 98, 101, 203, 12, 85}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 192, 104, 184, 93, 212}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 151}, 140},
	{{7, 31, 148, 19, 0, 0, 203, 23, 44, 233, 25, 34, 127, 210, 213, 249}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 111}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 77, 82}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 15, 61, 166, 190, 123, 238}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 89, 62, 85, 188, 161, 48, 217, 98, 118}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 65, 157, 72, 49, 85, 60, 44, 82}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 183, 220, 30, 90, 108, 130, 178}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 184, 13, 32, 231, 100}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 94, 81, 254, 66, 143, 209, 104, 130, 0}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 34, 22, 29, 228}, 140},
	{{7, 31, 148, 19, 0, 22, 67, 204, 167, 226, 229, 214, 219, 4, 92, 130}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 174}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 13, 226, 219, 102, 190, 103}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 234, 200, 188, 199, 135}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 208, 104, 244, 253}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 249, 169}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 164, 191, 230, 189, 144}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 178, 252, 151, 164, 78}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 127, 160, 218, 90, 220, 8, 66, 162, 186}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 129, 228, 173, 73, 140, 126}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 160, 149}, 140},
	{{7, 31, 148, 19, 0, 0, 156, 111, 45, 4, 134, 243, 67, 178, 2, 116}, 140},
	{{7, 31, 148, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 189}, 140},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 139, 38, 230, 242, 227, 140, 228, 158, 186, 71, 102}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 138, 84, 82, 37, 195, 177, 90}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 73}, 3},
	{{112, 0, 0, 123, 227, 90, 245, 151, 250, 43, 21, 91, 163, 56, 163, 57}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 160, 133, 78, 136, 253}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 215, 204}, 3},
	{{112, 0, 57, 202, 145, 87, 209, 163, 93, 11, 82, 59, 95, 101, 1, 90}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 183, 63, 218, 68}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 210, 49, 106, 68, 194, 250, 178, 216, 48, 240, 208}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 187}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 38, 209}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 36, 114, 225, 197, 220, 78, 140, 231}, 3},
	{{112, 0, 163, 116, 104, 86, 121, 184, 154, 13, 249, 225, 163, 89, 133, 10}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 28, 200, 123, 230, 114, 144, 141, 218, 226}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 30}, 3},
	{{112, 0, 0, 165, 221, 91, 110, 197, 105, 50, 7, 165, 56, 138, 235, 98}, 3},
	{{112, 0, 37, 6, 122, 62, 179, 111, 29, 248, 223, 62, 101, 165, 154, 55}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 213, 168}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 87, 66, 169}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 142, 19, 179}, 3},
	{{112, 123, 147, 4, 110, 231, 73, 55, 124, 159, 120, 148, 23, 110, 188, 117}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 225, 21, 213, 68, 74, 198, 135, 41}, 3},
	{{112, 0, 0, 0, 0, 250, 189, 45, 216, 237, 244, 187, 145, 28, 16, 27}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 235, 137, 136}, 3},
	{{112, 0, 0, 24, 141, 105, 167, 47, 117, 234, 150, 46, 99, 91, 184, 226}, 3},
	{{112, 0, 0, 0, 0, 0, 52, 66, 4, 142, 55, 250, 69, 88, 177, 202}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 48, 102, 198, 139, 127, 86, 105}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 205, 104, 9, 116, 133}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 88, 28, 57, 209}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 131, 165, 10, 98}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 194}, 3},
	{{112, 0, 0, 0, 192, 171, 40, 106, 35, 68, 116, 201, 128, 8, 139, 126}, 3},
	{{112, 0, 213, 220, 27, 138, 186, 97, 34, 86, 166, 26, 62, 32, 24, 149}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 245, 106, 101, 254}, 3},
	{{112, 0, 0, 194, 150, 118, 78, 75, 233, 107, 246, 198, 59, 205, 147, 167}, 3},
	{{112, 0, 0, 112, 20, 95, 205, 186, 182, 217, 171, 26, 201, 73, 105, 35}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 196, 151, 226, 87, 217, 77, 34, 84}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 141, 169, 219, 250}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 203, 28, 103, 7, 210}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 88}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 139, 233, 212, 63}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 48, 84, 126, 248, 73, 211, 77}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 90, 1}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 1, 86, 231, 27}, 3},
	{{112, 0, 0, 0, 0, 134, 28, 162, 125, 24, 13, 247, 155, 171, 5, 244}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 3},
	{{112, 0, 0, 0, 0, 0, 81, 91, 108, 252, 156, 176, 227, 18, 27, 253}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 220, 68, 217, 107, 31, 89, 18, 83, 17, 26, 89, 5, 78, 223}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 252}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 98, 141, 162, 233, 218, 115, 135, 211, 136, 30}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 78, 169, 59, 141, 42, 30, 189, 97}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 42, 238, 123, 177, 81, 96, 10, 202, 178}, 3},
	{{112, 27, 153, 64, 81, 250, 240, 230, 93, 187, 33, 35, 249, 206, 220, 207}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 111, 32, 127, 203, 136}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 73, 195, 190, 139}, 3},
	{{112, 0, 97, 99, 112, 163, 6, 157, 181, 54, 109, 78, 45, 18, 49, 4}, 3},
	{{112, 0, 0, 0, 135, 130, 248, 235, 231, 51, 122, 100, 145, 62, 95, 22}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 140, 197, 101, 178, 137, 161, 69, 224}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 135, 118, 134, 217, 231, 2, 61}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 127, 228, 241, 1}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 172, 72, 69, 40, 64}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 107, 110, 69}, 3},
	{{112, 0, 114, 36, 251, 224, 173, 236, 134, 187, 72, 137, 251, 157, 103, 70}, 3},
	{{112, 0, 232, 202, 160, 153, 192, 33, 172, 195, 196, 79, 63, 80, 128, 167}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 195, 194, 211, 166, 96, 103, 64, 241}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 67, 146, 85, 90, 20, 202, 143}, 3},
	{{112, 0, 56, 95, 57, 212, 181, 7, 87, 92, 31, 130, 219, 57, 116, 86}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 18, 189, 119, 91}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 73, 142, 74, 25, 55, 87, 70}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 161, 110, 188}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 138, 37, 102, 142, 213, 46, 175, 107, 231}, 3},
	{{112, 0, 0, 0, 0, 0, 228, 114, 216, 163, 61, 67, 69, 62, 57, 164}, 3},
	{{112, 0, 0, 0, 0, 0, 130, 201, 215, 133, 186, 48, 151, 71, 159, 72}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 47}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 26, 187, 176}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 103, 241}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 89, 55, 217}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 141, 184}, 3},
	{{112, 0, 0, 133, 201, 150, 142, 106, 180, 227, 29, 169, 164, 12, 11, 115}, 3},
	{{112, 0, 221, 34, 87, 158, 34, 161, 58, 151, 106, 167, 187, 16, 60, 214}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 156}, 3},
	{{112, 0, 210, 87, 187, 131, 53, 47, 126, 124, 211, 129, 172, 28, 252, 255}, 3},
	{{112, 0, 0, 104, 179, 16, 72, 119, 244, 116, 192, 227, 82, 214, 14, 61}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 70, 138, 84, 34, 60, 247, 89, 153, 96}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 24, 176, 15, 47}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 183, 149, 35, 217, 195, 60, 175, 39, 162}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 233}, 3},
	{{112, 0, 0, 69, 140, 243, 126, 100, 3, 40, 30, 9, 7, 127, 31, 163}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 66, 76, 243}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 26, 115, 124, 18, 111, 225, 159, 189}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 224, 169, 27, 44, 117, 149, 98, 96, 80}, 3},
	{{112, 0, 0, 100, 30, 171, 113, 32, 68, 93, 244, 169, 63, 164, 150, 121}, 3},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 181, 38, 243, 217}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 28, 90, 101, 89}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 179, 191, 198, 90}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 137, 48, 137, 218}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 148, 238, 245, 95, 163, 149}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 26, 68, 236}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 72, 122, 46, 255, 252, 161, 219, 213, 21}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 95, 166, 21}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 60, 194, 185, 209, 162}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 90, 160, 216, 32, 162, 0, 40, 245}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 181, 252, 27, 101, 145, 171, 240, 84, 52}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 96, 201, 183, 10, 40, 14}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 43, 100, 174, 164, 250, 39, 209}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 195, 56, 232}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 87, 17, 87, 100, 125, 3, 121, 83, 152}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 255, 17}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 145, 172, 198, 118, 134, 120, 63, 128}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 193, 54, 220, 0, 79}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 48, 244, 157, 212, 38, 29}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 48, 248, 230, 196, 199}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 146, 103, 64, 18, 157, 130, 111}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 2, 144, 163, 208}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 123, 138, 18}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 180, 138}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 73, 173, 76, 31, 22, 186}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 71, 1}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 34, 107, 77, 212, 77, 171}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 152, 212, 200, 101, 184, 68, 107, 124}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 11, 234, 20}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 64, 40, 252, 194, 62, 100, 208, 243}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 158, 54}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 140, 177, 54, 97, 220, 64, 34, 0, 130}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 145, 116, 149, 210, 231, 129, 78}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 223, 113, 145}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 11, 225, 181, 253, 127, 178, 242, 72}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 173, 176, 50, 227, 205, 250}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 15, 138, 199}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 147, 132}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 75, 130, 71, 246, 173, 119}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 243, 118, 173, 217, 157, 81, 8, 144}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 185, 82, 61, 165, 189, 183, 207}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 125, 134, 2, 206, 58, 238, 70, 190}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 147}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 43, 78, 56}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 55, 170, 245, 128}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 225, 23, 144, 78}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 52, 173, 128, 193}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 143, 52, 11, 169, 72, 125}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 95, 132, 161, 104, 123, 124, 93, 29}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 158}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 117, 137, 255}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 129, 122, 101, 126, 78}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 191, 49, 16, 81}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 116, 6}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 156, 113, 29, 23, 144, 181, 143}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 142, 90, 117, 122}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 210, 188, 191, 46, 173, 161}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 202, 121, 79, 43, 143, 198, 170}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 75, 176, 57, 152, 15, 220, 92}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 225, 153, 244, 214, 105, 249, 161, 246}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 68, 158, 143, 220, 63, 141}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 22, 73}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 201, 43, 164}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 141}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 152, 246, 23, 201, 0, 213, 41}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 101, 113, 46, 114, 95, 233, 53, 82}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 81}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 104, 24}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 83, 17, 78, 78, 21, 152, 70, 199, 171}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 61, 103, 224, 203, 24, 190, 59, 93}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 137, 100, 125, 191, 65}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 84, 168, 167, 75, 206, 186}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 255, 239, 138}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 232, 221, 105, 243, 51, 76}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 31, 235, 102, 230, 0, 195}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 81, 33, 48, 192}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 187, 222, 173, 102, 223, 219}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 124, 66, 177, 234, 187, 239}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 169}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 18, 233, 157, 76, 117, 8}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 0, 0, 96, 68, 192}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 15, 214, 240, 66, 169}, 31},
	{{167, 50, 202, 179, 74, 146, 192, 0, 0, 0, 0, 240, 44, 9, 63, 16}, 31},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 184}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 13}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 163}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 46}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 83}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 106}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 252}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 98}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 155}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 164}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 28}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 131}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 98}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 154}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 194}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 7}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 189}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 141}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 231}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 124}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 94}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 238}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 109}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 58}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 105}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 113}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 244}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 189}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 156}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 118, 114}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 102}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 77}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 242}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 34}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 83}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 3}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 251}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 101}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 184}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 221}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 204, 105}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 240}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 150}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 125}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 0}, 9},
	{{44, 188, 186, 250, 229, 71, 28, 118, 35, 253, 245, 191, 199, 18, 0, 45}, 9},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 194, 97, 51, 51, 137, 145, 37, 57, 128, 74}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232}, 218},
	{{128, 84, 145, 148, 213, 4, 38, 228, 7, 192, 158, 50, 42, 66, 61, 153}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 63, 40, 187, 145, 105}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 226, 159, 129}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 45, 1, 252, 97}, 218},
	{{128, 0, 0, 144, 248, 68, 87, 196, 44, 3, 220, 183, 46, 199, 152, 77}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 56}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 112, 2}, 218},
	{{128, 13, 144, 103, 103, 112, 96, 11, 72, 17, 83, 114, 192, 240, 152, 222}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211}, 218},
	{{128, 0, 0, 0, 194, 170, 23, 25, 178, 154, 163, 165, 24, 178, 156, 3}, 218},
	{{128, 0, 0, 251, 38, 222, 228, 131, 201, 175, 25, 23, 2, 9, 116, 108}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 58, 226, 169}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 229}, 218},
	{{128, 177, 41, 202, 55, 158, 47, 76, 194, 207, 73, 38, 27, 55, 33, 55}, 218},
	{{128, 0, 0, 0, 0, 0, 87, 246, 212, 226, 116, 14, 221, 12, 238, 124}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 88, 69, 100, 133}, 218},
	{{128, 0, 0, 195, 108, 92, 36, 51, 172, 1, 78, 101, 3, 27, 152, 241}, 218},
	{{128, 129, 22, 104, 25, 221, 157, 41, 238, 244, 1, 108, 116, 106, 137, 188}, 218},
	{{128, 0, 0, 0, 0, 94, 201, 18, 212, 242, 118, 97, 71, 213, 192, 19}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 60, 196, 84, 193}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 196, 23}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 167, 151, 38, 72}, 218},
	{{128, 0, 0, 0, 0, 33, 209, 36, 62, 19, 199, 70, 77, 45, 57, 215}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 224, 56, 226, 145, 164}, 218},
	{{128, 0, 0, 0, 156, 251, 233, 167, 4, 202, 204, 169, 212, 90, 131, 187}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 31, 90, 240, 45, 147, 246, 196, 241}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 44, 217}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 202, 39, 245, 1}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 91, 82, 109, 223, 180}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 8, 197, 186, 227, 64, 241, 122, 168}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 112, 154, 165, 60, 174, 142, 144, 119}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 107, 20, 44, 67, 37, 37, 1}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 41, 85, 17}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 59}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 228, 134, 79, 211, 255, 41, 229, 157, 202, 69, 59, 231, 28, 59, 41}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 158, 50, 56, 10, 14, 73, 48, 135}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 223}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 194, 77, 216}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 218},
	{{128, 0, 0, 0, 0, 80, 199, 111, 201, 91, 31, 204, 206, 68, 185, 65}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 227, 20, 147, 74, 198, 236, 248, 147}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 93, 132, 159, 152}, 218},
	{{128, 0, 0, 123, 228, 163, 28, 190, 99, 212, 103, 127, 43, 130, 220, 92}, 218},
	{{128, 0, 0, 0, 0, 37, 246, 219, 191, 73, 125, 212, 128, 253, 172, 176}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 92, 166, 158, 100, 23, 105, 169, 62, 14}, 218},
	{{128, 0, 0, 0, 0, 164, 145, 147, 188, 21, 78, 149, 35, 65, 130, 201}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 23, 198, 33, 200, 115, 48, 207, 54}, 218},
	{{128, 0, 0, 0, 0, 78, 208, 171, 80, 180, 248, 154, 57, 40, 48, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 60, 126, 249, 126, 164, 187, 98, 240, 228}, 218},
	{{128, 0, 69, 209, 89, 63, 145, 88, 58, 1, 218, 184, 38, 189, 207, 130}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 26, 252, 60, 57, 174, 167, 71}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 35, 181}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 146, 35, 71, 243, 10, 204, 120, 83, 238}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 23, 0, 73}, 218},
	{{128, 111, 39, 225, 71, 11, 243, 226, 116, 230, 60, 36, 244, 91, 126, 187}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 172, 112, 14, 10, 196, 181, 96, 113, 167, 23, 41, 249, 219, 194}, 218},
	{{128, 0, 82, 159, 61, 4, 145, 62, 175, 148, 83, 137, 157, 177, 1, 161}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 103, 25, 104, 222}, 218},
	{{128, 0, 36, 131, 44, 69, 142, 20, 104, 152, 152, 255, 203, 125, 188, 78}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 147}, 218},
	{{128, 0, 0, 157, 12, 79, 104, 199, 68, 160, 96, 216, 242, 43, 41, 154}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 181, 214, 115, 18}, 218},
	{{128, 241, 148, 101, 65, 143, 108, 60, 229, 16, 225, 53, 223, 251, 252, 110}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 77}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 122, 249, 150, 37, 152, 154, 165, 94, 229}, 218},
	{{128, 0, 96, 68, 41, 84, 95, 34, 228, 208, 108, 191, 87, 82, 197, 35}, 218},
	{{128, 0, 0, 0, 0, 212, 174, 195, 105, 250, 212, 97, 185, 129, 94, 40}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 32, 246, 169, 145, 224}, 218},
	{{128, 0, 0, 146, 114, 9, 184, 127, 121, 50, 45, 243, 136, 221, 232, 228}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 92, 196, 34, 209, 10, 112, 106}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 113}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 114, 20, 85, 161, 120, 137, 253, 158, 217, 98, 84, 116, 208}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 240, 186, 162, 80, 30}, 218},
	{{128, 93, 213, 130, 252, 201, 32, 172, 245, 150, 172, 168, 32, 16, 26, 153}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 236, 160, 214, 84, 106, 55, 230, 75}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 152, 21, 23, 76, 0, 24, 162, 43}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 93, 116, 212, 28, 231, 79, 27, 218}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 217, 51}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 75, 107, 238, 168, 180, 39, 16, 245}, 218},
	{{128, 0, 0, 0, 0, 0, 224, 199, 5, 170, 233, 92, 228, 13, 242, 141}, 218},
	{{128, 0, 0, 216, 68, 210, 100, 119, 249, 11, 188, 138, 68, 175, 3, 192}, 218},
	{{128, 208, 80, 68, 16, 28, 115, 64, 193, 164, 225, 186, 78, 234, 63, 24}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 84, 21}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 105, 85}, 218},
	{{128, 0, 0, 0, 0, 0, 26, 128, 76, 19, 165, 143, 170, 195, 79, 123}, 218},
	{{128, 0, 0, 0, 0, 0, 184, 246, 32, 247, 23, 1, 181, 93, 138, 10}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 109, 166, 189, 127}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 230, 90, 26, 188, 255, 180}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 82, 228, 165, 147, 104, 254, 252, 240, 130}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 148, 215, 219}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 118, 127, 203, 251, 241, 185, 228, 9}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 166, 174, 88, 56}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 91, 156, 21, 155, 120, 227, 89}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 156, 67}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 198, 57, 152}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 144, 215, 100, 75, 69, 179}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 216, 117, 29, 186, 5, 77, 5, 196, 84}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 9, 118, 143}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 85, 9, 237, 109, 111}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 118, 13, 189, 152, 109, 83, 18}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 137, 200, 220, 240, 242, 72, 47, 119}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 20, 169, 159}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 173, 46, 116}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 120, 5, 153, 194, 44, 74}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 36, 197, 232, 24, 32, 191, 81, 176}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 79, 194, 66, 156, 252, 87, 20, 161, 6}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 238, 117}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 99, 86, 77, 88, 144, 80, 191, 226, 93}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 180, 115, 241, 23, 196, 68, 252}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 131, 171, 69, 141}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 147, 250, 34}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 73, 124}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 177, 30, 182, 10, 194, 41, 70, 29}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 62, 14, 168, 154, 254}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 113, 74, 21, 126, 24}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 5, 222, 89, 251, 17, 90, 234, 201, 19}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 118, 254, 230, 179, 91, 251, 181}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 191, 104, 152, 3}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 2, 61, 237, 11, 184}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 227, 176, 252, 178, 147, 194, 136, 86, 217}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 126, 235}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 92, 113, 233}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 224, 95, 187, 40, 241, 209, 155, 196, 30}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 144, 236, 230, 9, 61, 45, 108}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 17, 16, 53, 73, 233, 59, 52}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 16, 90, 185, 81}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 197, 157, 52, 234, 126}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 142, 238}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 117, 25, 105, 209, 34}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 97, 76, 143, 77, 203, 93, 7, 193}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 140, 134, 90, 101, 193, 9, 203, 30}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 235, 245, 185}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 169, 39, 20, 183, 246}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 39, 117, 118, 137, 231}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 178, 114, 233, 190, 157, 150, 232}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 210, 159, 63, 65, 65, 125, 99, 7, 139}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 77, 252, 250, 91, 47, 85}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 56, 12, 159}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 219, 16, 30}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 38, 136, 179, 49, 203, 238}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 105, 243, 181, 71, 155, 59, 255, 32}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 66, 168, 187, 196, 25}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 74, 183}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 205, 52, 33, 169, 23, 132}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 234, 149, 86}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 203, 79, 94}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 152, 5, 184, 28, 3}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 33, 45}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 86, 113, 171, 57, 227, 26, 71, 226}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 69, 199, 108, 93, 194, 242}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 152, 136, 225}, 50},
	{{156, 163, 215, 175, 71, 80, 156, 203, 141, 3, 212, 143, 39, 101, 139, 243}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 28, 218, 133, 246}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 26, 77, 9}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 163, 119, 89, 13, 231}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 54, 249, 135, 133, 65, 132}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 18, 117, 95, 84, 194, 214, 78, 169, 122}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 204, 233, 182, 39, 94, 83, 60, 92}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 111, 123, 51}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 235, 144}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 115, 239, 135, 12, 56, 174, 52}, 50},
	{{156, 163, 215, 175, 71, 80, 0, 0, 0, 0, 0, 0, 0, 0, 76, 226}, 50},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 81, 241}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 129, 109, 174, 255, 19, 60, 48}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 209, 165, 243, 90, 76, 149, 231}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 7, 128, 173, 8}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 76, 3, 156, 78, 179}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 130, 167, 84, 200, 72}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 136, 209, 127, 169, 146, 1, 161}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 223, 47, 88, 240, 149, 215, 178}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 58, 52, 254, 39}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 39, 244}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 106, 95, 92, 133, 79, 64, 156}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 93, 108}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 4, 118, 207, 235, 214, 235}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 200, 55, 18, 13, 104, 94}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 212, 13, 192, 238, 115, 53, 148, 161}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 49, 30}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 224, 81}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 70, 40, 222, 91, 237, 194, 126, 11, 243}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 37, 83, 171, 112, 58}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 60, 115, 132, 240}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 158, 236, 211, 246, 144}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 141, 233, 143}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 44, 117, 55, 172}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 41, 70, 7, 156, 21, 170, 90, 107}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 158, 151, 175}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 153, 35, 117, 88, 140, 59, 197}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 226, 235, 235, 201, 191, 31, 214, 124, 224}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 112, 63, 60, 185, 128, 151, 222}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 27, 6, 222, 131, 40}, 34},
	{{67, 24, 151, 198, 242, 128, 166, 166, 231, 126, 29, 102, 0, 52, 107, 93}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 196, 50}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 67, 47}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 66, 180, 87, 24}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 9, 122, 9, 0, 52, 116}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 100, 82, 36, 114}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 221, 206}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 120, 43, 242, 145}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 19, 247, 160, 241, 98}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 202, 135, 25, 9}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 170, 75, 182}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 65, 239, 237, 163}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 246, 34, 115}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 97, 128}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 17, 182, 31, 45, 3, 102, 117, 187}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 12, 166, 225, 64, 13, 42, 2}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 23, 251, 96, 4, 124, 240, 212, 70}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 4, 228, 89}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 99, 86, 20, 235, 45}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 154, 220, 14, 43, 188, 149, 121}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 134, 136, 190, 226, 143, 135, 108, 7, 113}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 151, 45, 101, 106}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 195, 54}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 110, 218, 186}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 191, 30}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 74, 240, 183}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 190, 48, 198, 13, 125, 202, 30, 28}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 185, 24, 106, 57, 42}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 24, 83, 82, 138, 221}, 34},
	{{67, 24, 151, 198, 242, 128, 34, 116, 19, 4, 63, 207, 41, 181, 251, 17}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 202, 206, 5, 166, 201}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 105, 117, 158, 137, 140, 34, 45, 238, 143}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 79, 14, 20, 238, 246, 4, 45, 36}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 244, 149, 51, 207, 187, 86, 223, 137, 161}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 37, 194, 252, 119, 197, 24, 52, 150, 235}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 58, 183, 163, 92, 67, 246}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 253, 148, 185}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 18, 9, 83, 247}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 46, 143, 237, 218, 122}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 221, 217, 232, 112, 191, 61}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 171, 203, 208, 66, 216, 48, 213, 121}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 107, 114, 72, 28, 210, 110, 103, 221}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 138, 8, 192, 237}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 155, 38, 94, 122, 244, 86}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 63, 86, 93, 236, 137, 224, 157, 191}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 190, 137, 127, 56}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 59, 76, 19, 23, 34, 8}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 0, 59, 165, 222}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 140, 158, 76, 168, 75, 247, 112, 86, 150}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 85, 74, 70, 65}, 34},
	{{67, 24, 151, 198, 242, 128, 0, 0, 0, 0, 0, 0, 15, 238, 136, 8}, 34},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 214, 18, 208}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 74}, 11},
	{{134, 107, 128, 123, 127, 2, 151, 90, 250, 39, 185, 9, 195, 111, 244, 139}, 11},
	{{134, 107, 128, 0, 0, 0, 212, 106, 26, 21, 19, 242, 235, 95, 120, 141}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 11, 237, 174, 32, 185, 1, 66, 197, 135}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 99, 172, 36, 96, 224}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 207, 218, 179, 113, 122, 104, 123, 77}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 242, 133, 249, 37, 74, 158, 111, 199}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 13, 176, 155, 138, 52}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 45}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 4, 57, 108}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 224, 219, 85, 240, 71}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 255, 86, 183}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 240, 156, 62, 132, 177, 238, 34, 129, 116}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 210, 229, 12}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 212, 125, 1, 139, 137, 138, 209, 36, 222}, 11},
	{{134, 107, 128, 0, 0, 100, 26, 50, 220, 193, 109, 87, 241, 33, 251, 2}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 179, 225, 106, 239, 32, 163, 177, 177, 221}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 63, 46, 114, 84, 127, 200, 250, 149, 133}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 219, 113, 66}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 29, 47}, 11},
	{{134, 107, 128, 0, 0, 117, 192, 161, 225, 231, 205, 78, 248, 182, 193, 206}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 14, 112, 121, 21, 191, 108}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 244, 62, 54, 65, 160, 11, 204}, 11},
	{{134, 107, 128, 0, 22, 236, 20, 214, 48, 250, 249, 15, 13, 170, 202, 185}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 8, 151, 144, 154, 195}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 213, 244, 42, 42, 4, 47, 187}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 234, 208, 173, 35, 245}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 177, 185, 5, 10, 82, 6, 33, 156}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 241, 6, 0, 57, 230, 13, 142, 110, 207}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 113, 81}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 84, 143, 161, 149, 215, 236, 255}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 205, 57, 174, 71, 119, 21}, 11},
	{{134, 107, 128, 0, 0, 0, 10, 152, 254, 59, 221, 128, 77, 193, 7, 50}, 11},
	{{134, 107, 128, 0, 0, 0, 86, 229, 193, 95, 139, 147, 110, 140, 23, 24}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 224, 214, 160}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 87, 222}, 11},
	{{134, 107, 128, 87, 183, 213, 31, 131, 156, 241, 101, 126, 146, 129, 140, 241}, 11},
	{{134, 107, 128, 0, 118, 61, 199, 254, 94, 38, 95, 114, 240, 171, 182, 57}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 113, 127, 2, 231, 242, 127, 135, 45}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 28, 59}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 144, 199, 154}, 11},
	{{134, 107, 128, 74, 190, 135, 202, 41, 13, 44, 16, 105, 41, 131, 102, 203}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 227, 237, 185, 181, 234, 84, 223, 29, 124}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 241, 228, 240, 187, 144, 254, 138}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 103, 246, 173, 24, 184, 182, 53, 5, 121}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 27, 40, 156, 206, 112}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 33, 116, 254, 108, 217, 120, 158, 233, 158}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 86, 186, 150, 54, 203, 91, 211}, 11},
	{{134, 107, 128, 57, 129, 45, 122, 219, 76, 55, 112, 142, 134, 33, 128, 36}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 161, 176, 77, 198, 70, 42, 114, 150}, 11},
	{{134, 107, 128, 0, 0, 80, 251, 132, 1, 217, 64, 181, 191, 55, 245, 183}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 253, 16, 30, 46, 64, 164, 186}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 43, 223}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 139}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 243, 76, 245, 89, 233}, 11},
	{{134, 107, 128, 205, 210, 192, 172, 151, 170, 44, 225, 217, 5, 73, 127, 198}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 161, 5, 158}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 243, 30, 43, 218, 247}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 76, 202, 102}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 68, 52}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 34, 238, 169, 205, 161, 129}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 163, 84}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 246, 152, 85, 39, 236, 208, 47, 92}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 194, 238}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 237, 202, 236, 244, 103, 136}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 154, 76}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 33, 139, 97}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 112, 94}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 34, 215, 36, 251, 31}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 212, 153, 149, 72, 135, 197, 230, 240}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 152, 38, 196, 219, 86, 255}, 11},
	{{134, 107, 128, 0, 0, 182, 96, 74, 255, 133, 221, 211, 89, 52, 245, 155}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 11},
	{{134, 107, 128, 0, 207, 18, 229, 118, 78, 3, 170, 170, 186, 131, 132, 101}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 48, 119, 243, 83, 232, 38, 237, 92}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 36, 253, 99}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 51, 233}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 58, 216, 176, 246, 151, 11, 99, 89, 225}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 18, 24, 17, 246, 229, 248, 236, 109}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 158, 58, 71, 119, 143}, 11},
	{{134, 107, 128, 0, 0, 250, 126, 48, 120, 200, 78, 216, 169, 17, 54, 96}, 11},
	{{134, 107, 128, 0, 0, 0, 0, 0, 0, 0, 0, 47, 157, 177, 82, 166}, 11},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 178, 45, 24}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 201, 97, 13, 66, 166, 1, 30}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 205, 213}, 71},
	{{35, 0, 0, 0, 244, 103, 0, 185, 89, 138, 103, 236, 205, 72, 4, 90}, 71},
	{{35, 0, 150, 51, 29, 242, 78, 27, 32, 161, 151, 51, 113, 157, 178, 28}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 238, 173, 53, 116, 245, 37, 105, 95}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 189, 219, 154, 20, 13, 53, 164, 48}, 71},
	{{35, 0, 0, 0, 0, 113, 37, 92, 60, 123, 209, 255, 218, 140, 33, 140}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 119, 149, 39, 249, 218, 91, 138}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 14}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 13, 91}, 71},
	{{35, 0, 0, 0, 0, 0, 246, 123, 132, 121, 155, 91, 30, 239, 179, 247}, 71},
	{{35, 0, 0, 158, 241, 64, 247, 204, 123, 18, 227, 200, 34, 219, 101, 53}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 40, 85}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 6, 16, 60, 43, 60}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 240, 81, 47}, 71},
	{{35, 0, 0, 0, 210, 109, 65, 149, 101, 74, 30, 245, 131, 35, 181, 50}, 71},
	{{35, 0, 0, 0, 41, 207, 108, 230, 168, 45, 42, 220, 115, 237, 33, 179}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 126, 216, 203, 157}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{35, 0, 53, 208, 103, 4, 221, 66, 35, 152, 51, 100, 74, 70, 48, 213}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 59, 194, 19}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 34, 241}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 247, 37}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 150, 68, 81, 118, 229, 73, 4, 50, 88}, 71},
	{{35, 0, 0, 78, 164, 119, 57, 87, 243, 43, 246, 37, 161, 38, 191, 205}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 12, 33, 186, 39, 234, 113, 31}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 28, 148, 7, 86, 4, 90, 236, 40, 39}, 71},
	{{35, 0, 0, 242, 110, 186, 64, 21, 156, 110, 162, 121, 151, 161, 3, 200}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 168, 157, 223, 198}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{35, 0, 0, 0, 210, 142, 137, 80, 170, 199, 189, 70, 217, 225, 54, 88}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 141}, 71},
	{{35, 0, 0, 0, 0, 0, 140, 104, 107, 18, 95, 184, 161, 88, 213, 225}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{35, 0, 0, 102, 235, 98, 157, 115, 119, 180, 64, 187, 246, 53, 47, 20}, 71},
	{{35, 0, 144, 213, 126, 72, 132, 167, 167, 13, 98, 18, 99, 144, 76, 148}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 94, 184, 165, 146, 49, 63, 142, 1, 219}, 71},
	{{35, 0, 0, 0, 150, 194, 171, 15, 196, 68, 247, 164, 229, 49, 7, 241}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 158}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 94, 181, 168, 2, 126}, 71},
	{{35, 0, 0, 0, 0, 0, 137, 222, 202, 133, 160, 197, 4, 110, 90, 80}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 114, 204, 132, 22, 119, 56, 80, 164, 156}, 71},
	{{35, 0, 14, 108, 17, 139, 10, 59, 196, 102, 229, 134, 68, 113, 123, 169}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{35, 0, 0, 0, 172, 171, 26, 119, 135, 55, 197, 103, 126, 235, 169, 201}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 151, 30, 173, 172}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 65, 25, 32, 169, 217}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 225, 251, 72, 16, 34}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 13, 107}, 71},
	{{35, 0, 0, 0, 0, 0, 224, 37, 133, 101, 121, 86, 239, 76, 113, 100}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 55, 117, 186}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 36}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 140, 215}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 194}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 118, 66, 177, 66, 154, 119, 54, 78, 117}, 71},
	{{35, 0, 0, 0, 0, 0, 117, 78, 184, 54, 183, 224, 9, 63, 21, 76}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 89, 212, 160, 47, 246}, 71},
	{{35, 0, 0, 156, 83, 106, 129, 186, 65, 115, 84, 106, 1, 21, 68, 169}, 71},
	{{35, 0, 117, 75, 77, 252, 114, 207, 92, 255, 36, 14, 58, 218, 90, 215}, 71},
	{{35, 0, 109, 151, 234, 21, 100, 23, 136, 26, 107, 106, 164, 232, 162, 25}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 54}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 203, 84, 226, 67, 65}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 214, 90, 59, 174}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 213, 20, 86, 148, 220, 22, 139, 18}, 71},
	{{35, 0, 0, 0, 0, 0, 157, 228, 230, 60, 8, 105, 201, 178, 174, 50}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 173, 223, 177, 198, 242}, 71},
	{{35, 0, 0, 0, 250, 222, 49, 118, 188, 69, 250, 229, 244, 120, 103, 65}, 71},
	{{35, 0, 0, 232, 149, 239, 53, 162, 2, 163, 139, 123, 229, 19, 49, 129}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 133}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 71},
	{{35, 0, 0, 0, 0, 183, 8, 27, 42, 230, 30, 155, 34, 83, 25, 193}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 107, 41, 253, 11, 142, 183, 131, 212}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 107, 144, 240}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 81, 22, 180, 61}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 59, 118, 153, 96, 178}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 32, 108, 16}, 71},
	{{35, 0, 0, 0, 0, 211, 214, 100, 197, 196, 161, 202, 82, 54, 169, 188}, 71},
	{{35, 0, 0, 0, 111, 184, 200, 81, 151, 84, 218, 116, 111, 126, 6, 33}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 224}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 36, 189, 163, 185}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 39, 157}, 71},
	{{35, 0, 0, 0, 0, 0, 135, 88, 129, 134, 224, 205, 149, 204, 123, 240}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 39, 222, 70, 24, 39, 141, 202}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 24, 114, 244, 96, 122, 1, 76, 198}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 181, 229, 161, 161, 254, 49, 74}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 40, 0, 17, 218, 177, 46, 207}, 71},
	{{35, 0, 0, 0, 0, 0, 132, 113, 45, 227, 69, 79, 205, 46, 149, 78}, 71},
	{{35, 0, 0, 0, 0, 0, 109, 4, 8, 180, 61, 6, 210, 189, 149, 84}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 192, 68, 230}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 35, 249, 175, 120, 255, 161, 181, 215}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 153, 57, 81, 172, 219, 121, 16, 223, 204}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 242, 126}, 71},
	{{35, 0, 0, 0, 0, 0, 0, 0, 0, 218, 87, 62, 69, 44, 221, 183}, 71},
	{{46, 196, 84, 0, 135, 159, 223, 247, 215, 193, 99, 69, 227, 94, 228, 227}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 27, 154}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 104, 53, 44, 198, 180, 185, 211, 158}, 146},
	{{46, 196, 84, 0, 0, 0, 251, 247, 203, 216, 247, 74, 225, 43, 132, 66}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 244, 180, 43, 160, 39, 147, 164, 12}, 146},
	{{46, 196, 84, 0, 0, 167, 240, 140, 111, 118, 226, 90, 192, 246, 139, 190}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 35, 108, 177, 9, 187, 2}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 151, 236}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 75, 168, 166, 15, 235, 175, 186, 89, 218}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 46, 53, 224, 52, 145, 6, 180, 143}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 99, 67, 15, 159, 55, 109}, 146},
	{{46, 196, 84, 0, 0, 218, 252, 148, 56, 64, 155, 144, 216, 161, 10, 55}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 206, 76, 121, 89, 118, 164, 47, 224}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 237, 244, 114, 104, 171, 204}, 146},
	{{46, 196, 84, 0, 0, 0, 211, 37, 253, 174, 82, 153, 46, 16, 28, 96}, 146},
	{{46, 196, 84, 0, 0, 10, 219, 191, 119, 94, 206, 143, 130, 245, 21, 149}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 205, 36, 206, 180, 144, 85}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 87}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 92, 96, 92, 80, 210, 109, 180, 243, 120}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 155}, 146},
	{{46, 196, 84, 0, 0, 0, 81, 253, 85, 196, 11, 158, 71, 190, 150, 81}, 146},
	{{46, 196, 84, 0, 7, 246, 72, 251, 107, 13, 212, 226, 248, 134, 85, 88}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 7}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 27, 193, 175, 63, 37, 29, 69, 154, 210}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 21, 71, 113}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 51}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 181, 113, 185, 225, 57}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 106, 190, 100, 210, 170, 181}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 51}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 227, 94, 198, 221, 227, 177, 221, 74}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{46, 196, 84, 0, 44, 78, 131, 156, 190, 214, 180, 251, 116, 126, 101, 1}, 146},
	{{46, 196, 84, 0, 92, 35, 105, 212, 233, 145, 202, 124, 140, 9, 54, 211}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 105, 179}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 48, 128, 178, 216, 190, 5, 220}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 236, 6, 140, 205, 92, 108, 87}, 146},
	{{46, 196, 84, 0, 0, 0, 192, 146, 111, 108, 101, 63, 95, 103, 122, 54}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 103, 48, 236, 28, 110, 161}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 113, 149, 100, 162, 10, 200}, 146},
	{{46, 196, 84, 0, 245, 132, 158, 133, 22, 241, 11, 24, 252, 194, 84, 149}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 113, 212, 84}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 20}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 131, 119, 166, 31, 65, 107, 157, 32, 9}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{46, 196, 84, 0, 0, 34, 87, 195, 224, 232, 212, 255, 173, 13, 180, 169}, 146},
	{{46, 196, 84, 0, 0, 0, 206, 170, 200, 52, 143, 114, 63, 57, 58, 73}, 146},
	{{46, 196, 84, 0, 0, 0, 61, 174, 206, 141, 206, 11, 55, 116, 137, 40}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 207, 90, 127, 157, 98, 130}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 219, 60}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 35, 60}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 140, 133, 145, 237, 230, 151, 87, 237}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 67, 77, 109, 241, 26, 1}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 251, 75, 238, 3, 152, 17, 4, 132}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 92, 149, 252, 6, 154, 225, 167, 68}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 22, 9, 49}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 242, 209, 71, 206, 161, 26, 193, 59}, 146},
	{{46, 196, 84, 0, 0, 0, 228, 37, 2, 196, 115, 254, 92, 231, 157, 200}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 167, 88, 0, 92, 127, 175, 65, 86, 68}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130}, 146},
	{{46, 196, 84, 0, 0, 173, 11, 3, 102, 209, 119, 38, 65, 13, 60, 5}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 251, 169, 157, 222, 31, 215, 226}, 146},
	{{46, 196, 84, 0, 0, 111, 160, 149, 232, 3, 218, 254, 67, 186, 161, 179}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 6, 201, 157, 15, 183, 20}, 146},
	{{46, 196, 84, 0, 0, 0, 70, 230, 211, 147, 252, 201, 52, 118, 113, 201}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 248, 75, 5}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 219, 244, 81}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 218, 181, 50, 105, 153, 187, 255, 200, 156}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 228, 50, 59, 208, 98}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 57, 169, 143, 148, 21}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 98, 156, 235, 56, 214, 178, 127}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 214, 166, 230, 225, 10, 5}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 73, 68, 160, 246, 135, 108}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 143, 29, 81, 213, 255, 127, 254, 108, 154}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 53, 206, 48, 228, 192, 6, 192}, 146},
	{{46, 196, 84, 0, 0, 0, 233, 113, 70, 50, 224, 55, 244, 13, 152, 144}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 6, 195, 41, 190, 27}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 237, 81, 184, 15, 194, 155, 161, 208, 8}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{46, 196, 84, 0, 0, 0, 106, 225, 38, 203, 17, 128, 103, 248, 219, 45}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 142, 226, 222, 34, 121}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 146},
	{{46, 196, 84, 0, 0, 8, 76, 112, 87, 249, 43, 61, 242, 60, 199, 190}, 146},
	{{46, 196, 84, 0, 0, 0, 7, 130, 21, 159, 238, 144, 253, 77, 233, 0}, 146},
	{{46, 196, 84, 0, 0, 0, 251, 154, 172, 235, 213, 255, 213, 203, 0, 52}, 146},
	{{46, 196, 84, 0, 0, 0, 182, 227, 53, 140, 100, 76, 62, 116, 177, 27}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 219, 132, 42}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 41, 83, 232, 169, 185, 12, 156}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130}, 146},
	{{46, 196, 84, 0, 0, 248, 194, 156, 239, 21, 143, 129, 109, 189, 211, 25}, 146},
	{{46, 196, 84, 0, 176, 42, 171, 189, 31, 121, 61, 253, 46, 225, 121, 145}, 146},
	{{46, 196, 84, 0, 164, 223, 239, 10, 25, 160, 154, 99, 180, 215, 187, 208}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 149, 63, 152, 47, 82, 174, 80, 9}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 228, 55}, 146},
	{{46, 196, 84, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 13, 2}, 146},
	{{46, 196, 84, 0, 22, 84, 193, 180, 170, 32, 77, 238, 161, 24, 182, 115}, 146},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{82, 172, 8, 26, 154, 34, 125, 188, 5, 149, 159, 44, 78, 222, 236, 176}, 249},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 123, 202, 210, 32, 208, 47, 17}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 217, 162, 238, 98, 81, 222, 30}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 114, 167, 16, 196}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 89}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 253, 246, 249}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 184, 230, 137, 121, 184}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 87}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 98}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 230, 121, 82, 238, 32, 83, 144}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 124, 104, 123, 96, 15}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 242, 194, 30, 96}, 143},
	{{78, 157, 79, 70, 252, 0, 242, 140, 241, 200, 132, 136, 133, 16, 122, 234}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 197}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 101}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 10}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 150}, 143},
	{{78, 157, 79, 70, 252, 0, 226, 242, 197, 114, 196, 22, 150, 26, 250, 104}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 195}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 204, 58, 140, 61, 28, 116, 40, 222, 253}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 229, 82, 72, 146, 133, 126, 89, 29}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 4, 79, 247, 229, 94, 242, 2, 191}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 199, 80, 215, 159, 45, 151, 74, 126, 17}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 245}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{78, 157, 79, 70, 252, 0, 167, 247, 122, 113, 132, 84, 123, 56, 73, 111}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 197, 177, 62, 108, 189, 215, 247}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 104, 20, 78}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 43, 163, 175, 109, 189, 14, 202, 184, 18}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 40, 176, 63, 158, 50, 234, 150}, 143},
	{{78, 157, 79, 70, 252, 0, 226, 39, 25, 7, 9, 67, 220, 10, 46, 133}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 85, 232, 92, 222, 235}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 88, 212, 244, 122, 133}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 26, 228, 252, 187}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 91, 242, 27, 53, 244, 127, 226, 76, 227}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 137, 80, 40, 87, 197}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 139, 119, 141, 241}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 85, 63, 134}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 153, 32, 116, 61, 246, 225}, 143},
	{{78, 157, 79, 70, 252, 168, 169, 49, 6, 87, 62, 84, 112, 17, 60, 65}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 135, 75, 25, 199, 110, 35}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 41, 190, 248, 54, 122}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 245, 224, 211, 25, 135, 24, 2}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 167}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 133, 108, 41, 227, 96}, 143},
	{{78, 157, 79, 70, 252, 0, 185, 108, 31, 133, 240, 142, 68, 128, 178, 236}, 143},
	{{78, 157, 79, 70, 252, 0, 149, 80, 70, 122, 158, 132, 153, 74, 32, 127}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 14, 93, 168, 137, 62, 206}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 151, 248, 217, 138, 20, 116, 114, 246}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 65, 217, 227, 164}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 244}, 143},
	{{78, 157, 79, 70, 252, 0, 127, 55, 128, 215, 38, 79, 220, 5, 183, 106}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 95, 80, 112, 98, 222, 137, 229, 139, 138}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 105, 74, 81, 177, 49, 191, 156}, 143},
	{{78, 157, 79, 70, 252, 0, 231, 51, 84, 212, 229, 219, 84, 11, 140, 183}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 69, 2, 95, 235, 12, 250, 149, 38, 183}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 104, 176, 164, 198}, 143},
	{{78, 157, 79, 70, 252, 0, 20, 31, 162, 172, 98, 222, 110, 198, 59, 198}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 190, 116, 26, 57}, 143},
	{{78, 157, 79, 70, 252, 0, 243, 240, 5, 71, 129, 203, 47, 94, 163, 218}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 148, 163, 158}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 242}, 143},
	{{78, 157, 79, 70, 252, 0, 81, 47, 248, 163, 201, 242, 214, 22, 37, 123}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 136, 107, 72, 106, 76, 206, 3}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 191, 14, 247, 122, 179, 113, 141, 228, 5}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 93, 155, 241, 227, 197, 226, 17}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 158, 111, 234, 4, 218}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 89}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 209}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 64}, 143},
	{{78, 157, 79, 70, 252, 0, 5, 184, 76, 250, 88, 172, 250, 77, 71, 161}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 51, 133, 181, 119, 124, 206, 112, 60}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 80, 113, 91, 244, 17, 52}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 119, 116, 78, 228, 6, 38, 106, 250, 149}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 60}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 184, 217, 93, 230}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 217}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 40, 242, 90, 117, 21, 206, 89, 188}, 143},
	{{78, 157, 79, 70, 252, 0, 199, 136, 170, 71, 232, 180, 112, 158, 194, 167}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 148, 189, 161, 149}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 151}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 220, 139, 97, 218, 73, 135, 52}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{78, 157, 79, 70, 252, 0, 206, 177, 222, 214, 122, 180, 72, 40, 177, 229}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 165, 88, 28, 190, 141, 103, 170, 241}, 143},
	{{78, 157, 79, 70, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 12}, 143},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 12}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 42, 73}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 198, 51}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 156}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 29}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 87, 202}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 133}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 205}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 11}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 194}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 201}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 22}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 93, 70}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 56, 184}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 184}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 118}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 225}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 51}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 144}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 131}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 185}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 39}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 58}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 34}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 55}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 154}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 43}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 174}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 44}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 94}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 224}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 6}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 25, 99}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 85, 230}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 73}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 39}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 157, 108}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 50}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 227}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 219}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 209}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 173}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 153}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 67}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 30, 83}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 2, 144}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 39}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 196}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 128}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 105}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 182, 113}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 228}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 47}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 250}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 236}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 135}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 151}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 179}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 116}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 100}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 104, 92}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 195}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 0}, 17},
	{{231, 5, 210, 247, 198, 5, 157, 191, 206, 225, 149, 142, 207, 40, 0, 127}, 17},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 177}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 75}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 138}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 4}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 110}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 185}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 32}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{38, 254, 235, 199, 191, 60, 43, 159, 190, 243, 203, 185, 184, 218, 132, 0}, 60},
	{{128, 0, 0, 0, 0, 0, 119, 110, 98, 15, 242, 73, 95, 233, 118, 119}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 43, 172, 6}, 218},
	{{128, 0, 0, 0, 0, 0, 37, 206, 21, 69, 22, 216, 123, 30, 126, 72}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 168, 184, 143, 31, 89}, 218},
	{{128, 0, 0, 128, 199, 98, 2, 171, 87, 227, 116, 67, 187, 49, 192, 169}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 53, 155, 234, 227, 79}, 218},
	{{128, 0, 63, 74, 0, 202, 41, 166, 81, 73, 178, 220, 189, 47, 131, 74}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 201, 140, 247, 103, 84, 116, 9, 143, 51, 146, 14, 107, 2, 121, 205}, 218},
	{{128, 0, 0, 0, 0, 0, 61, 193, 251, 24, 172, 144, 64, 26, 245, 169}, 218},
	{{128, 148, 189, 154, 65, 75, 180, 107, 160, 121, 157, 144, 94, 210, 82, 251}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 234, 121, 57, 116}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 6, 34, 82, 39, 247}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 47, 182, 20, 84, 237, 50, 16, 79}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171}, 218},
	{{128, 0, 0, 0, 242, 43, 76, 11, 1, 172, 168, 27, 188, 10, 118, 32}, 218},
	{{128, 0, 0, 0, 31, 80, 154, 4, 27, 26, 43, 192, 235, 164, 210, 214}, 218},
	{{128, 0, 0, 159, 138, 137, 168, 90, 20, 150, 3, 238, 140, 236, 139, 65}, 218},
	{{128, 204, 49, 77, 185, 229, 182, 74, 161, 92, 250, 143, 163, 86, 173, 165}, 218},
	{{128, 0, 0, 0, 0, 189, 40, 41, 13, 236, 127, 115, 31, 163, 32, 187}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 93, 176}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 196, 83, 186, 92}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 252}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 184, 93, 178, 0, 20}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 223, 158, 101, 162}, 218},
	{{128, 0, 0, 145, 38, 179, 227, 114, 239, 72, 126, 184, 17, 57, 83, 221}, 218},
	{{128, 0, 0, 0, 0, 0, 248, 134, 83, 199, 37, 124, 178, 242, 204, 30}, 218},
	{{128, 0, 0, 0, 252, 11, 218, 106, 235, 44, 148, 85, 34, 232, 49, 232}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 84, 114, 94, 79, 12, 93, 153}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 85, 190, 65, 128, 237, 241, 199, 62, 227}, 218},
	{{128, 0, 0, 139, 250, 76, 64, 143, 251, 219, 80, 15, 252, 245, 134, 193}, 218},
	{{128, 0, 0, 0, 0, 0, 46, 234, 219, 146, 254, 229, 113, 251, 40, 35}, 218},
	{{128, 0, 0, 0, 0, 191, 92, 137, 242, 10, 26, 69, 63, 169, 6, 236}, 218},
	{{128, 0, 0, 0, 0, 0, 253, 203, 132, 241, 192, 85, 20, 35, 232, 208}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 35, 146, 73, 114, 52, 25, 93, 118, 94}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 44, 68, 56, 69, 57}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 201, 8, 48, 187, 19, 72, 151, 68}, 218},
	{{128, 0, 0, 0, 216, 153, 59, 141, 231, 19, 158, 224, 109, 31, 240, 62}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 37, 46, 194, 167}, 218},
	{{128, 0, 0, 0, 226, 250, 98, 212, 176, 17, 31, 91, 101, 15, 12, 200}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 163, 221, 175, 60, 34}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 20, 29}, 218},
	{{128, 49, 211, 244, 71, 23, 129, 72, 4, 252, 72, 222, 230, 96, 201, 50}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 15, 103, 1, 214}, 218},
	{{128, 0, 0, 31, 199, 54, 184, 45, 236, 238, 196, 57, 186, 212, 176, 85}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 195, 107, 19}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 98, 214}, 218},
	{{128, 112, 236, 182, 112, 50, 221, 82, 242, 69, 227, 86, 109, 220, 255, 128}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 83, 66, 39, 225, 143, 100, 210}, 218},
	{{128, 0, 90, 234, 231, 17, 111, 3, 236, 182, 252, 233, 131, 189, 199, 74}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 207, 223, 11, 33, 167, 12, 71, 119, 174, 18, 206, 186}, 218},
	{{128, 0, 0, 195, 83, 233, 53, 224, 219, 14, 225, 61, 17, 49, 61, 234}, 218},
	{{128, 0, 0, 74, 91, 38, 189, 113, 106, 216, 198, 29, 144, 110, 106, 78}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 249, 149, 207}, 218},
	{{128, 0, 229, 221, 202, 121, 95, 83, 27, 94, 151, 31, 129, 250, 227, 61}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 150, 77, 5, 228, 27, 243, 105}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 223, 93, 52, 61}, 218},
	{{128, 0, 0, 0, 214, 42, 103, 40, 199, 216, 167, 44, 200, 168, 72, 98}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 79, 105, 71, 222, 86}, 218},
	{{128, 0, 0, 0, 0, 0, 91, 5, 176, 234, 244, 48, 122, 23, 66, 104}, 218},
	{{128, 0, 115, 198, 250, 40, 65, 7, 39, 52, 29, 85, 172, 240, 32, 25}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 115, 220, 84}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 85, 141}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 133, 26, 41}, 218},
	{{128, 0, 0, 0, 0, 177, 159, 33, 1, 8, 94, 65, 98, 48, 125, 42}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 190}, 218},
	{{128, 0, 0, 0, 13, 27, 66, 158, 174, 21, 225, 13, 102, 251, 226, 54}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 229, 191, 206, 184, 199, 20, 156}, 218},
	{{128, 0, 0, 0, 28, 121, 165, 34, 91, 146, 26, 187, 36, 29, 77, 251}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 180, 201}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 41, 254, 57, 67, 198, 60, 254, 200, 174, 36}, 218},
	{{128, 0, 0, 0, 0, 192, 233, 84, 156, 29, 6, 129, 209, 133, 118, 40}, 218},
	{{128, 0, 91, 77, 125, 140, 178, 177, 22, 77, 255, 94, 62, 144, 124, 75}, 218},
	{{128, 86, 97, 250, 168, 244, 117, 193, 223, 127, 228, 53, 13, 219, 20, 35}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 18, 32, 3, 8, 60, 146, 54, 233, 186}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 30}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 82, 121, 216}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 173, 30, 230, 220, 30, 179, 182, 229}, 218},
	{{128, 0, 0, 0, 0, 0, 238, 218, 154, 181, 108, 83, 61, 208, 27, 12}, 218},
	{{128, 0, 62, 63, 92, 244, 237, 212, 45, 5, 56, 81, 38, 171, 78, 170}, 218},
	{{128, 0, 0, 120, 28, 48, 88, 250, 114, 153, 166, 61, 34, 127, 87, 193}, 218},
	{{128, 0, 0, 0, 151, 173, 246, 28, 19, 178, 203, 126, 224, 168, 50, 133}, 218},
	{{128, 0, 0, 0, 0, 0, 77, 42, 9, 48, 101, 24, 78, 142, 25, 60}, 218},
	{{128, 0, 0, 0, 41, 43, 104, 103, 7, 24, 11, 173, 154, 193, 215, 37}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 247, 130, 114, 209, 154, 52, 107}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 177, 52, 119, 9, 79, 126, 214, 129, 216, 0, 16, 118}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 76}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 245, 33}, 218},
	{{128, 126, 151, 203, 125, 219, 223, 118, 119, 174, 124, 30, 10, 70, 167, 217}, 218},
	{{128, 111, 220, 48, 100, 70, 164, 209, 29, 157, 100, 214, 191, 127, 130, 150}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 84, 40, 42, 69}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 69, 250, 242, 115, 14}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51}, 218},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 46}, 5},
	{{95, 240, 0, 0, 0, 0, 242, 136, 48, 193, 233, 131, 166, 175, 17, 147}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 78, 214, 128, 124, 87, 166, 149, 140, 170}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{95, 240, 0, 0, 0, 255, 16, 238, 54, 143, 196, 118, 78, 178, 156, 234}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 237, 103, 126, 130}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 105, 36, 57, 177, 71, 141}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{95, 240, 0, 0, 197, 223, 27, 213, 232, 101, 123, 21, 76, 11, 206, 46}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 178, 0, 100}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 90, 55, 214}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 174, 55, 53, 134, 202, 219}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 145}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 160, 106}, 5},
	{{95, 240, 0, 0, 0, 10, 170, 100, 79, 91, 93, 73, 155, 117, 22, 36}, 5},
	{{95, 240, 0, 0, 166, 75, 155, 205, 250, 185, 32, 184, 84, 52, 201, 60}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 41, 4, 58, 198, 7, 79, 241, 65, 138}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 15, 36, 64, 238, 236, 139}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 200, 184, 31, 255, 211, 109, 247}, 5},
	{{95, 240, 0, 0, 0, 0, 7, 225, 200, 59, 195, 60, 153, 38, 91, 214}, 5},
	{{95, 240, 0, 0, 0, 0, 194, 89, 225, 124, 40, 43, 23, 225, 210, 213}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 154, 108, 114, 51, 105, 222, 167, 153, 232}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 150, 81, 218, 221, 167, 121, 233, 249, 140}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 89, 13}, 5},
	{{95, 240, 0, 200, 210, 153, 56, 102, 228, 76, 246, 200, 173, 106, 5, 201}, 5},
	{{95, 240, 70, 99, 86, 248, 233, 162, 97, 14, 130, 115, 90, 14, 149, 170}, 5},
	{{95, 240, 63, 109, 29, 198, 162, 17, 188, 1, 140, 44, 138, 183, 25, 176}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 183, 20, 12, 112, 194, 39, 184, 237, 153}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 166, 107, 67, 164, 150, 245, 137, 230, 226}, 5},
	{{95, 240, 0, 37, 237, 130, 150, 104, 43, 221, 247, 129, 176, 102, 27, 177}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 54, 160, 153, 32, 223, 74, 187, 97}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 175, 58, 249, 152, 117, 4, 61}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 168, 238, 115, 204}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 68, 181, 215}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 75, 25, 45, 75, 84, 238, 236, 52}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 164, 25, 209, 122, 129, 39, 36}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 29, 201, 158}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 155, 170, 153, 68, 109, 105}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 208, 186, 140}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{95, 240, 0, 0, 0, 224, 150, 222, 37, 50, 101, 78, 145, 233, 97, 190}, 5},
	{{95, 240, 0, 0, 0, 0, 159, 187, 231, 8, 200, 172, 53, 101, 148, 150}, 5},
	{{95, 240, 49, 70, 199, 87, 182, 35, 21, 37, 189, 155, 200, 56, 93, 26}, 5},
	{{95, 240, 8, 68, 146, 150, 129, 161, 226, 67, 24, 34, 234, 35, 200, 12}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 162, 147, 238, 92, 78, 254, 37}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 5, 17, 90, 186}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 197}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 120}, 5},
	{{95, 240, 0, 0, 0, 0, 84, 89, 87, 79, 123, 136, 49, 127, 31, 86}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 130, 138, 71}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 151, 174}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 111, 189}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 8, 207, 255, 87}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 0}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 204, 69}, 5},
	{{95, 240, 0, 0, 158, 234, 53, 5, 214, 165, 44, 79, 185, 60, 50, 254}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 79, 107, 51}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 248, 7, 133}, 5},
	{{95, 240, 92, 122, 69, 224, 219, 124, 23, 28, 45, 151, 118, 37, 152, 28}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 22, 39, 61, 110, 70, 166, 231, 150}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 45, 50, 122, 148, 114, 191}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 254, 228, 175, 100, 44, 219, 174}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 25, 143, 52, 249, 205, 196, 248, 213}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 16, 230, 31, 34}, 5},
	{{95, 240, 0, 226, 166, 146, 252, 12, 239, 220, 117, 95, 93, 34, 201, 209}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 198, 12, 202, 92, 0, 86, 76}, 5},
	{{95, 240, 0, 0, 0, 240, 97, 98, 100, 141, 147, 192, 112, 61, 97, 145}, 5},
	{{95, 240, 249, 89, 166, 120, 51, 229, 115, 87, 55, 179, 229, 2, 41, 74}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 35, 92, 176, 218, 245, 35}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 243, 174, 213, 236, 36, 93, 123, 234, 135}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 121, 224, 161, 102, 224, 132, 144, 173, 252}, 5},
	{{95, 240, 0, 120, 53, 41, 116, 12, 150, 90, 139, 119, 207, 49, 18, 18}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 53, 188, 233, 52, 191, 83, 163}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 158, 96, 21, 72, 134, 125}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 116, 77, 177, 141}, 5},
	{{95, 240, 0, 0, 0, 69, 95, 92, 146, 63, 160, 27, 252, 179, 90, 209}, 5},
	{{95, 240, 0, 0, 0, 0, 123, 173, 198, 174, 161, 79, 190, 137, 123, 157}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 57, 132}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 211, 49}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 153, 55, 250, 243, 12, 210}, 5},
	{{95, 240, 0, 0, 0, 0, 63, 66, 218, 59, 124, 226, 104, 183, 39, 189}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 14, 123, 11, 229, 104, 233}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 171, 39, 207, 221, 120, 119, 13, 165}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 240, 25, 224}, 5},
	{{95, 240, 0, 0, 0, 0, 245, 142, 144, 180, 237, 145, 4, 113, 165, 63}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 5},
	{{95, 240, 0, 0, 230, 176, 204, 163, 202, 58, 70, 204, 238, 57, 176, 234}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 13, 30}, 5},
	{{95, 240, 0, 0, 171, 197, 96, 134, 86, 108, 22, 84, 118, 30, 183, 135}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 0, 0, 157, 94, 147, 3, 196, 234}, 5},
	{{95, 240, 0, 0, 0, 0, 0, 0, 159, 56, 31, 159, 113, 175, 225, 82}, 5},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 12, 195, 217, 60, 126, 169}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 38, 171, 83}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 135, 79, 243, 189, 223}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 76, 189, 183, 192, 220, 133, 76, 236}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 228, 53, 22, 159}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 216, 246, 188, 59, 105, 63}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 21, 23, 26, 13, 74, 79, 145}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 242, 132, 220, 102, 19, 144, 103, 87}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 166, 218, 188, 223}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 222}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 162, 130, 152, 119, 89, 36}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 146, 194, 194, 29, 3, 35}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 249, 52, 43, 67, 61, 129}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 44, 58, 124}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 93, 90, 121, 158}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 110, 76}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 140, 86, 147, 17, 13, 31, 200, 119}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 98, 45, 55}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 52, 74, 214, 67, 189, 4, 211}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 46, 141, 96}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 54, 233}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 225, 245, 248, 180, 213, 105}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 192, 37}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 95, 231, 214, 160, 151, 141}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 148, 238, 179, 20}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 45, 172, 168, 162, 71, 167}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 220, 243}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 107}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 162, 112, 204, 170}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 166, 152}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 113, 172}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 198, 252, 47, 152}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 214}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 1, 3, 64, 161, 172, 54, 224}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 240, 248, 88}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 24, 119, 33}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 233, 5, 15, 203}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 51, 189}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 205, 19, 180, 30, 172, 251}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 72, 57, 198}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 189, 89, 230}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 91, 126, 192}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 174, 105, 205, 101, 234}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 203, 23, 60, 187}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 111, 132, 30, 160, 225, 96, 197}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 174, 243}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 222}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 47, 118, 93, 204, 206, 17}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 243}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 230, 54, 160, 46, 59, 160, 156, 220}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 112, 82, 105, 22}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 162, 129, 241, 142, 237, 155}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 161, 108}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 39, 41, 117, 35, 86, 235, 47}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 112, 159, 17, 175, 50, 211, 33}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 92, 252, 77, 59, 255}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 169, 15, 11, 61, 94, 183, 237}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 168, 1, 223, 21, 124, 145, 147}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 147, 199, 137, 130, 136, 219}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 68, 84, 227, 207, 99, 41}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 11, 43, 66, 116, 120, 127}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 178, 132}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 96, 219}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 252, 193, 198, 18, 230, 135, 139}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 102, 103, 233, 10, 139, 113}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 152, 20, 168, 235}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 28, 186, 20, 155, 240}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 36}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 13, 138, 199, 167, 86, 139, 22}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 97, 84, 192, 142, 243, 186, 115}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 113, 15, 174, 252, 90, 155, 123, 236}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 78, 213}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 105, 112}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 165}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 88, 74, 212}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 27, 63, 16, 108}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 245, 118, 94, 62, 227, 11}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 218, 17}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 176, 173, 123, 225, 52, 174, 159}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 152}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 154, 103, 26, 2, 148, 45, 186, 19}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 59, 3}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 94, 165, 39, 61}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 155, 157, 67, 61, 146, 110, 0, 174}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 114, 227, 97, 47, 52, 113}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 13, 152, 198, 144, 16}, 139},
	{{17, 128, 244, 178, 160, 78, 83, 92, 0, 0, 0, 0, 0, 0, 0, 0}, 139},
	{{18, 102, 62, 251, 44, 0, 0, 77, 251, 247, 238, 176, 224, 139, 225, 202}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 231, 142, 254, 207, 174, 90, 92}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 214, 54, 61, 126, 112, 35, 165, 153}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 216, 106, 57, 17, 95, 100, 55, 150}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 91, 203, 198, 183, 121}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 164, 253, 80, 241, 241, 32, 141, 235}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 167}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 252, 251, 142, 201}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 55, 162, 168, 244}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 56, 78, 189, 16}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 85, 40, 62, 167, 184, 9}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 10, 241, 235, 115}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 42, 240, 129}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 135, 132, 233, 242, 105, 206, 41, 232, 210}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 191, 143, 168, 166}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 78, 181, 188, 2, 58, 61}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 246, 235, 121}, 8},
	{{18, 102, 62, 251, 44, 0, 60, 86, 237, 244, 206, 175, 43, 171, 213, 54}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 252, 172, 116}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 191, 44, 97, 50, 57, 65, 74, 146}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 149, 196, 49, 21, 60, 240}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 254, 52, 8, 201, 193, 90}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 170, 166, 227, 197, 25, 118, 223}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{18, 102, 62, 251, 44, 0, 21, 14, 242, 61, 127, 101, 37, 165, 12, 22}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 53, 13, 227, 154, 177, 209, 89, 81}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 223}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 190, 149, 235, 155, 169, 16}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 57, 14, 45, 72}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 168, 235, 73, 124}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 60, 65, 208, 189}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 40, 206, 99, 203, 136, 200, 244}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 109, 64, 25, 127, 43, 84, 2}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 49, 47, 114, 146, 49, 120, 10, 54}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 251, 221, 173}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 137, 22, 196, 164, 244, 70, 222}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 127, 96, 23, 135}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 48, 207, 142, 193, 176, 140, 70, 250}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 253, 246, 9, 108, 119, 18}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 207, 172, 74, 14}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 146, 172, 99, 79, 51, 230}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 245, 202, 227, 94, 111, 233, 77, 110, 183}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 226, 149, 125, 56}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 160, 247, 50, 157, 86, 112}, 8},
	{{18, 102, 62, 251, 44, 0, 207, 195, 127, 149, 83, 185, 11, 81, 235, 16}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 85}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 166, 25, 88, 195, 81, 52, 162, 69}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 233, 172, 86, 44, 90, 89, 228}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 22, 139, 246, 215, 117, 98, 108}, 8},
	{{18, 102, 62, 251, 44, 0, 88, 81, 193, 98, 159, 166, 44, 177, 38, 211}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 200}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 118, 104, 155, 113, 55, 63, 177}, 8},
	{{18, 102, 62, 251, 44, 0, 183, 77, 196, 167, 5, 100, 226, 71, 87, 81}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 246}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 133, 73, 15}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 107, 34, 3, 32}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 35, 168, 73, 127, 96, 133, 27, 135}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 227, 38, 71, 225, 5, 245, 207, 30}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 131, 154, 65, 200, 170, 126, 223}, 8},
	{{18, 102, 62, 251, 44, 0, 121, 29, 129, 45, 251, 30, 19, 221, 229, 27}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 43, 215, 44}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 106, 186, 106, 95, 54, 101, 131}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 153, 156, 4, 88, 116, 142, 44, 166, 85}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 124, 192, 247, 34}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 22, 231, 205, 125, 93}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 222, 41, 129}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 153, 253, 114, 7, 153, 49, 186, 200, 132}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 108, 102, 67, 10, 211}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 82, 185, 40, 168, 149, 20}, 8},
	{{18, 102, 62, 251, 44, 0, 128, 133, 169, 73, 133, 14, 147, 25, 218, 157}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 51, 73, 186, 121, 92, 197}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 2, 231, 175, 7, 205, 51, 129, 167, 237}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 167, 51, 215, 235, 26, 36}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 46, 157, 152, 10}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 0, 165, 7, 80}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 157, 154, 20, 142, 233, 241, 230}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 38, 224, 141, 27, 39, 223}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 252, 215, 165, 119, 97, 108, 12, 70}, 8},
	{{18, 102, 62, 251, 44, 0, 0, 0, 0, 0, 0, 0, 126, 226, 17, 37}, 8},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 47}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 91}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 46}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 247}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 126}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 245}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 85}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 106}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 209}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 45}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 136}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 124}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 97}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 199}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 180}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 27}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 134}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 239}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 51}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 27}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 43}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 159}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 51}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 198}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 245}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 61}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 74}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 194}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 171}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 113}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 209}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 67}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 83}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 52}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 229}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 142}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 162}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 255}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 254}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 206}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 124}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{30, 75, 108, 40, 231, 166, 233, 220, 163, 176, 252, 210, 60, 30, 128, 0}, 246},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 250, 226, 209, 27, 177, 36, 168}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 91, 167}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 249, 20, 186, 94}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 166, 230}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 93, 103, 19, 241, 132, 86}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 40, 189, 173, 229, 215, 161}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 94, 49, 244, 48, 7}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 241, 188, 37, 124}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 139, 204, 248, 227, 72, 91, 249, 46}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 254, 27, 113, 7}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 249, 79, 125, 20, 114, 207, 205}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 208, 214, 140, 184}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 171},
	{{18, 3, 207, 64, 25, 128, 11, 173, 146, 157, 208, 72, 60, 45, 209, 166}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 250, 62, 196, 129, 234, 134, 20}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 10, 6, 191, 72, 42, 94}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 12, 23, 35, 196, 204}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 148, 198, 135}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 146, 131, 38, 100, 90, 146, 74}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 76, 229, 146, 131, 189, 72}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 92, 149, 122, 165}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 85, 16}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 241, 160, 241, 50, 179, 131, 156, 31}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 64, 171, 219, 153, 36, 12, 49, 27, 215}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 241, 142, 11, 62, 92}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 206, 243, 154, 8, 20, 46, 51}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 106, 207, 34, 207, 57, 198, 215, 255, 138}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 251, 39, 27, 237, 113, 194, 233, 160}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 73, 138, 241, 245, 225, 55, 161}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 69, 14}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 95, 56, 156, 105, 16}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 99, 222, 92, 249}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 109, 214, 200, 95, 207, 157, 185, 108, 254}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 186, 121, 189, 10, 221}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 97, 250, 0, 250, 20, 41}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 5, 121, 120, 16, 250, 179}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 127, 239, 225}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 244, 227}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 170, 66, 119, 6, 248, 38, 241, 195}, 171},
	{{18, 3, 207, 64, 25, 128, 15, 151, 84, 109, 251, 154, 162, 6, 186, 77}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 10, 8, 54, 139, 125, 45}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 3, 189, 42, 33, 216, 152, 50, 100}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 90, 221, 253, 88, 125, 50, 69, 130}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 217, 113, 237, 226}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 165, 57, 45, 156, 129, 149, 253, 125, 237}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 8, 204, 66}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 226, 183, 31, 202, 223}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 141, 170, 167, 205, 81, 187}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 199, 250, 168, 129, 114, 225, 51}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 215, 36, 27}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 159, 253, 38, 66, 223}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 222, 219, 69, 47}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 115, 54, 206, 245, 216}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 84, 189, 52, 90, 109, 183, 83}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 224, 45, 39, 64, 59, 148, 60}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 45, 210, 174, 142, 53, 103, 210}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 129, 138, 235}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 166, 220, 212}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 18, 217, 146, 178, 107, 221, 100, 35}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 128, 55, 75, 169}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 34, 116, 129, 58, 39, 165, 148, 84, 52}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 229, 119, 74, 98, 79, 148, 124}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 89, 168, 94}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 202, 150, 136, 76, 220, 36}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 139, 152, 106, 195, 215, 89, 119, 234}, 171},
	{{18, 3, 207, 64, 25, 128, 252, 157, 99, 207, 209, 248, 81, 222, 176, 4}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 246, 207}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 101, 55}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 58, 248}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 138, 192, 205, 50, 69, 91}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 1, 9, 138}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 47, 175}, 171},
	{{18, 3, 207, 64, 25, 128, 254, 41, 112, 32, 180, 199, 157, 85, 176, 124}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 233, 185, 72, 67, 228, 241, 176, 93}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 26, 54, 13, 255, 252}, 171},
	{{18, 3, 207, 64, 25, 128, 155, 228, 253, 255, 241, 174, 197, 156, 247, 124}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 128, 66}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 146, 211, 234, 252, 171, 190, 4, 148, 193}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 235, 170, 217, 16, 6, 161}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 61, 140, 182}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 215, 58, 233, 193, 130, 249, 13, 109}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 173, 21, 4, 220, 14, 57, 234}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 157, 232, 94, 95, 195}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 175, 193}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 38, 206}, 171},
	{{18, 3, 207, 64, 25, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 101}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 17, 21}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 58, 198}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 231, 233, 140, 17}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 207, 186}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 106, 67}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 230}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 241, 228, 85, 66}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 75, 18}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 126, 29, 225, 165}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 114, 31, 148, 218}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 120}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 171}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 142, 217, 41, 238}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 122}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 15, 64, 195, 228}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 64, 190}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 103}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 8, 237, 172}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 108, 93, 125, 252}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 183, 161, 198, 31}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 233, 135, 185}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 120}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 79, 192}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 233, 125}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 65, 39, 9}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 255}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 155, 206, 128}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 73, 35}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 162, 3}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 32, 57, 123, 151}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 18, 229}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 123, 243, 253, 233}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 206, 176, 145}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 237, 197, 244}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 142, 171}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 100, 233}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 204}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 228, 149, 224, 154}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 18, 160, 11, 37}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 213, 226}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 221}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 101, 219, 68}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 157}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 69, 70, 170, 109}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 75}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 9, 100}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 68, 155}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 150, 167, 92}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 89}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 82, 255}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 142, 30, 182}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 78, 95, 68, 164}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 178, 22}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 20, 56}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 109}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 31, 46, 226}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 106, 237, 112, 45}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 81}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 67, 9}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 139}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 14, 101, 23}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 91, 226, 199, 135}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 158, 7, 186, 234}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 36, 227}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 89, 148}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 172, 47, 249}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 94, 239, 204, 12}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 192, 179, 37}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 96, 140, 2, 144}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 0}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 189, 109}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 31, 190}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 223}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 215, 207, 156, 234}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 243, 142}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 29, 105, 183, 133}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 210, 45, 107, 223}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 0, 31}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 169, 72, 226, 190}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 13, 99, 165}, 206},
	{{52, 83, 235, 61, 164, 236, 83, 173, 143, 105, 14, 0, 0, 0, 12, 7}, 206},
	{{166, 175, 186, 208, 0, 147, 114, 76, 34, 133, 113, 85, 94, 139, 85, 127}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 41, 200, 165, 164, 91, 22}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{166, 175, 186, 208, 117, 19, 205, 85, 19, 132, 96, 181, 215, 205, 252, 87}, 163},
	{{166, 175, 186, 208, 0, 186, 94, 164, 53, 252, 214, 142, 35, 227, 88, 72}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 128, 154, 154, 46, 217}, 163},
	{{166, 175, 186, 208, 0, 0, 21, 30, 177, 238, 8, 169, 144, 232, 136, 172}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 122, 38, 103, 3}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 34, 6}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{166, 175, 186, 208, 0, 135, 215, 74, 126, 162, 14, 145, 168, 190, 79, 88}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 115, 131, 113, 144, 22}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 228, 159, 194, 100, 236, 181, 60, 218}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 29, 10, 66, 164, 9, 187, 124, 109}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 183, 211, 56, 70, 243, 115, 7, 252}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 197, 30, 19, 138, 128}, 163},
	{{166, 175, 186, 208, 170, 242, 26, 239, 172, 246, 241, 20, 63, 55, 194, 179}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 159, 133, 23, 210, 143, 98, 195}, 163},
	{{166, 175, 186, 208, 0, 183, 84, 179, 81, 224, 202, 31, 173, 146, 255, 41}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 107, 221, 223, 42}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 136, 184, 68, 6, 14, 3}, 163},
	{{166, 175, 186, 208, 0, 0, 115, 111, 86, 98, 5, 180, 67, 97, 150, 216}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 65, 201, 90, 221, 42, 156, 109}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 155, 48, 40, 94, 154, 44}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 253, 122}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 216, 129, 146, 145, 153, 215, 167, 111}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 24}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 131, 53, 147, 173, 86, 226, 210, 39, 65}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 189, 152, 103, 191, 230, 178, 239, 162}, 163},
	{{166, 175, 186, 208, 0, 0, 83, 218, 97, 239, 8, 99, 251, 167, 96, 176}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 62, 147, 248, 239, 159, 105, 75, 242}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 225, 104, 2, 248}, 163},
	{{166, 175, 186, 208, 0, 102, 101, 194, 235, 2, 200, 221, 9, 195, 1, 25}, 163},
	{{166, 175, 186, 208, 0, 0, 249, 124, 90, 105, 129, 3, 189, 160, 52, 128}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 216, 80, 82, 36, 111, 211, 124, 249, 101}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 236, 9, 134, 102}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 94, 231, 40, 39, 41, 124, 79, 199}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 59, 121, 137, 8, 138, 60, 212, 226}, 163},
	{{166, 175, 186, 208, 146, 130, 41, 245, 86, 107, 63, 192, 148, 168, 228, 220}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 127, 59, 99, 229, 88, 111, 71}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 254}, 163},
	{{166, 175, 186, 208, 0, 187, 91, 200, 161, 128, 9, 86, 44, 120, 191, 173}, 163},
	{{166, 175, 186, 208, 0, 34, 84, 22, 147, 6, 63, 186, 74, 221, 40, 214}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 129, 182, 253, 17, 175, 188, 154}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 123, 147, 154, 0, 133, 57}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 169, 248}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 35, 207, 119, 165, 234, 254, 165, 108, 20}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 14, 53, 131, 199}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 237, 247, 1, 57, 246}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 98, 150, 114, 254}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 255, 168, 148, 47, 48, 116, 1}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 116, 130, 15, 50, 196, 116, 16, 195}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 187, 222}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 221, 240, 208, 5, 248}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 238, 188}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 35, 26, 60, 131, 27, 213, 202, 98}, 163},
	{{166, 175, 186, 208, 0, 0, 118, 213, 192, 76, 136, 13, 11, 166, 240, 131}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 161}, 163},
	{{166, 175, 186, 208, 0, 153, 31, 198, 94, 208, 109, 220, 221, 86, 150, 212}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 38, 18, 204, 121}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 154, 67, 197, 199, 28, 21, 162, 225}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 126, 9, 217, 106}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 162, 75, 110, 170, 47}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 138, 128, 132, 83, 233, 132, 28}, 163},
	{{166, 175, 186, 208, 24, 46, 242, 236, 102, 0, 3, 193, 17, 70, 254, 222}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 226}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 145, 140}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 163},
	{{166, 175, 186, 208, 0, 0, 180, 98, 92, 255, 222, 27, 16, 164, 69, 0}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 163},
	{{166, 175, 186, 208, 0, 15, 203, 107, 13, 204, 87, 207, 49, 156, 87, 255}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 255, 140, 251, 64, 136, 159, 177}, 163},
	{{166, 175, 186, 208, 199, 183, 193, 85, 185, 226, 196, 6, 230, 20, 97, 211}, 163},
	{{166, 175, 186, 208, 213, 34, 203, 11, 111, 148, 244, 162, 171, 203, 98, 249}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 18, 232}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 197}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 250, 64, 182, 236, 226}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 141, 224, 178, 50, 239, 104, 240}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 193, 241, 113, 87, 208, 252}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 22, 176, 158, 204, 88, 100}, 163},
	{{166, 175, 186, 208, 10, 230, 122, 34, 250, 231, 64, 123, 196, 41, 6, 180}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 129, 98, 26, 78, 111, 150, 56, 99}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 172, 120}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 247, 253, 28, 24}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 111, 149}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 248, 73}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 66, 183, 177, 252}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 40, 125, 39, 251, 150, 8, 169}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 99, 72, 242, 18}, 163},
	{{166, 175, 186, 208, 0, 0, 0, 0, 0, 0, 0, 0, 53, 11, 0, 208}, 163},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 196, 86, 64, 45, 240, 74, 31}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 247, 132, 6, 84, 176}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 229, 160, 58, 31, 83, 83}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 35, 113, 214, 68}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 207, 249}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 128, 179, 59, 161, 232, 172}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 209, 210}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 128, 73}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 204}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 74, 135, 28, 108, 33, 255, 6}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 32, 75, 35, 85, 15, 162, 230, 230}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 55, 11, 99, 162, 202, 84}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 135, 106, 117}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 165, 122, 95, 76, 239, 68, 149}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 220}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 148, 149, 216, 156}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 173, 31, 221}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 45, 245, 97, 1, 156}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 74, 173, 162, 167, 98, 121, 99, 226}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 5}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 128, 207, 205, 129}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 156, 169, 138}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 120, 200, 126, 122, 50, 98}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 97, 32, 158}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 219, 102, 239, 156}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 203, 237}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 8, 52}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 71}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 222, 147, 249, 49, 213, 173, 29}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 40, 114}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 38, 137, 185}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 230}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 165, 73, 209, 70, 232}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 46, 113, 221, 12, 157, 2, 57}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 238, 78, 156, 243}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 209, 130, 158}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 189, 193, 204}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 25, 237, 109, 65, 15, 221, 174, 222}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 35, 88, 147, 132, 26, 90, 245}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 65}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 253}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 220}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 4, 3, 114, 180, 183, 81, 64}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 180, 243, 235}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 201, 38, 141, 25}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 229, 86}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 135, 6, 145}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 156, 188}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 7, 8, 71, 27}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 68, 89, 81, 199, 243}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 183, 114, 27}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 69, 53}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 22, 228, 161, 55, 197, 221}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 32}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 146, 18, 36, 232, 68, 227}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 151}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 173, 20, 95, 172, 173}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 208, 140, 31, 100, 19, 164, 60}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 88, 208, 86}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 250, 152, 201, 137}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 112, 237, 99}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 132, 191, 219}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 228, 222}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 145, 82, 151}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 74, 5, 208, 165, 166, 84, 141}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 195}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 194}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 80, 16, 180, 202}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 51, 83, 217, 99, 93}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 253, 221, 106, 237}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 118, 183, 213, 33, 154}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 56, 182, 27, 164, 39, 99, 139}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 19, 97, 214, 248}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 89, 239}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 112, 201, 212, 185, 172, 230, 139, 230}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 102, 210, 211, 4}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 184, 6, 240, 10, 29, 141, 90}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 209, 158}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 229, 94}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 199, 83, 82, 45, 93, 182, 76}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 135, 181, 0}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 218, 180, 181, 78, 137, 179, 104, 79}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 238, 78, 148, 227, 169, 118, 34}, 166},
	{{221, 154, 82, 98, 41, 126, 85, 52, 0, 0, 0, 0, 0, 0, 0, 52}, 166},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 220, 177}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 185, 171, 33, 121, 32, 220, 217, 43}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 106, 45, 141, 69, 103, 107, 155}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 238, 137}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 109, 209, 155, 184, 159, 177}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 248, 70, 76, 229, 146, 6, 189, 0, 181}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 221, 22, 87, 76, 119}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 32, 43, 22}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 183, 162, 63, 128}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 247, 5, 152, 76}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 254, 186, 0}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 91, 87, 150, 193, 100}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 238, 133}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 252, 197}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 172, 50, 6, 136, 191}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 240, 6, 60}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 134, 92, 187, 144, 75}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 106, 158, 51, 44, 209, 246}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 56, 141, 15, 147, 58, 3, 43, 116}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 127, 219, 66, 190, 192, 185, 11, 84, 243}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 203, 200, 123, 246, 125}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 179, 194, 78, 179, 91}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 129, 15}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 112, 209, 82}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 50, 36, 132, 180, 221, 54, 173}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 254, 186, 25}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 167, 159, 225}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 164, 26, 137, 4, 122, 121, 137}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 179, 34}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 69, 5, 25, 234}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 157, 46, 116, 171, 71, 141, 174, 0, 243}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 61, 205}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 236, 210, 96, 42, 6, 170, 173, 122}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 155, 225}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 13, 92, 108}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 152}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 217, 210}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 173, 48, 123, 52, 55, 74, 233, 221, 139}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 47, 122, 47, 198, 21, 62, 109, 56}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 104, 221, 33, 137, 130, 93, 16}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 224, 252, 103, 197, 168}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 78}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 31, 240}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 188, 131, 16, 100, 216, 215}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 39, 230, 28, 199, 182, 229}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 124, 106, 12, 165}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 152, 37, 6, 156, 170, 88, 83, 1}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 206, 212, 236, 13, 157, 116, 249, 208}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 46, 141, 215, 116, 156, 37, 6, 222, 207}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 117, 18}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 122, 91, 60, 178, 82, 161}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 146, 102, 113, 181}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 28, 198, 17, 31}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 244, 82, 225, 34, 159}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 11, 217, 235, 175, 110, 112}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 30, 8, 60, 129, 9}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 54, 87, 85, 41}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 168}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 60, 168, 163, 0, 149, 52, 187}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 178, 163, 129, 52}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 46, 230, 24, 135}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 90, 253, 66, 122}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 95, 168, 237}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 48, 98, 254, 0, 235, 147, 103}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 218, 132, 30, 88}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 195, 94, 196, 53, 175, 114, 82, 96, 171}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 77, 26, 237, 110, 136, 87, 32}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 63, 52, 228, 213, 37, 7, 213, 244, 12}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 168, 139, 140, 137, 161, 104, 110, 221, 81}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 237, 203, 62, 143, 227, 212}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 27, 55, 146}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 40, 247, 75, 57, 160, 247, 189, 80, 80}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 217, 180, 174, 156, 104}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 115, 57, 195, 225, 226, 137}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 40, 204, 42, 19, 235, 249, 17, 125}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 179, 241, 113}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 218, 62, 76, 95, 117, 208, 152, 36}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 141, 13, 70, 30}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 49, 46, 97, 154, 132, 202, 194}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 57}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 137, 240, 178}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 157, 202, 179, 228, 109}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 252, 230, 29, 249}, 128},
	{{94, 84, 182, 120, 204, 232, 64, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 128},
	{{27, 174, 227, 228, 0, 0, 0, 0, 240, 214, 186, 154, 22, 101, 132, 132}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 167, 65, 117, 140, 253, 31}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 248, 205, 249, 94, 146, 133, 176}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 114, 105}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 53, 244, 82, 245, 157, 10}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{27, 174, 227, 228, 0, 0, 187, 45, 80, 226, 225, 222, 11, 176, 187, 140}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 95, 3, 111, 157, 96, 120, 138}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 65, 82, 47, 143, 70, 192, 79, 36, 106}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 78, 37, 192, 72}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 6, 119}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 6, 36, 90, 11, 159, 236, 5}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 183, 91, 100, 178}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 160, 35, 72, 134, 8, 92, 155, 115}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 87, 193, 97, 117}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 205, 224, 228, 230, 107, 201, 101, 25}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 20, 93, 140, 125}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 214, 87, 122, 185, 47, 181, 235, 153, 22}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 144, 125, 203, 247}, 59},
	{{27, 174, 227, 228, 0, 0, 91, 129, 183, 40, 3, 24, 185, 186, 217, 75}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 143, 116, 111, 63, 228, 64, 92}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 93, 153, 160, 6, 160, 140}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 236, 229}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 236, 83, 189, 190, 9, 137, 148}, 59},
	{{27, 174, 227, 228, 0, 0, 196, 87, 24, 51, 195, 135, 138, 177, 66, 226}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 75, 120, 197, 215}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 136}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 30, 198, 172, 96, 76}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 254, 211, 8, 203, 181, 72}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 4, 160}, 59},
	{{27, 174, 227, 228, 0, 0, 97, 64, 248, 13, 203, 83, 112, 12, 238, 28}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 171, 152, 174, 207, 0}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 134, 183}, 59},
	{{27, 174, 227, 228, 0, 207, 109, 169, 246, 190, 135, 132, 221, 135, 220, 207}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 11, 8, 50, 250, 182}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 239}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 236, 156, 184, 170, 99}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{27, 174, 227, 228, 0, 0, 215, 3, 150, 220, 86, 43, 190, 225, 198, 126}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 197, 227}, 59},
	{{27, 174, 227, 228, 0, 190, 41, 174, 55, 114, 127, 126, 48, 52, 28, 233}, 59},
	{{27, 174, 227, 228, 0, 0, 240, 171, 243, 35, 177, 149, 25, 116, 97, 134}, 59},
	{{27, 174, 227, 228, 0, 0, 158, 210, 87, 55, 60, 230, 225, 23, 246, 116}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 91, 173, 92, 141, 134, 34, 192, 253, 32}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 232, 216, 54, 247, 42, 99, 229, 22}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 179, 244}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 224, 224, 185, 11}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 167, 168, 62, 24, 144}, 59},
	{{27, 174, 227, 228, 0, 0, 205, 121, 26, 104, 97, 2, 133, 51, 192, 71}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 102, 235, 237, 185}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 163, 36, 77, 214}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 40}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 117}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 58}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 237, 56, 106, 9, 134, 159}, 59},
	{{27, 174, 227, 228, 0, 0, 250, 109, 63, 90, 57, 34, 38, 166, 86, 166}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 246, 109, 216, 177, 227}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 6, 81}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 216, 133, 225, 237}, 59},
	{{27, 174, 227, 228, 0, 226, 226, 184, 208, 57, 41, 146, 253, 25, 158, 241}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 17, 138, 2, 198, 75}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 197, 162, 17, 47, 238}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 253}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 142, 233, 137, 133, 35, 146, 24, 84, 52}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 84, 185, 147, 220, 187, 104, 96}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 201, 164, 130, 233, 73, 204}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 221}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 81, 237, 114, 74, 251, 122, 11, 87}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 165, 73}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 255, 183, 196, 36}, 59},
	{{27, 174, 227, 228, 0, 0, 197, 237, 29, 212, 195, 218, 0, 181, 36, 91}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 121, 131, 9, 123, 97, 124, 131, 78, 121}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 124}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 54, 198, 39, 225}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 120, 154, 213, 76, 22, 158, 105}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 155, 191, 62, 1, 222, 27, 237}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 236, 192, 251, 74, 117, 74, 229, 80}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 252, 171, 72, 225, 56}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 214}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 25, 190, 220, 243}, 59},
	{{27, 174, 227, 228, 0, 125, 153, 78, 52, 163, 89, 204, 104, 140, 142, 203}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 118, 13, 69, 131, 43}, 59},
	{{27, 174, 227, 228, 0, 0, 85, 137, 144, 25, 61, 167, 149, 194, 87, 135}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 228, 173, 226, 21, 244, 134, 18, 72, 94}, 59},
	{{27, 174, 227, 228, 0, 168, 189, 97, 26, 128, 246, 227, 55, 98, 126, 150}, 59},
	{{27, 174, 227, 228, 0, 0, 187, 165, 19, 199, 119, 18, 71, 66, 158, 158}, 59},
	{{27, 174, 227, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 231, 188}, 59},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 17, 225, 233, 180, 148, 183, 73}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 149, 201, 55, 119}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 161}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 159}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 130}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 22, 105, 33, 179, 110, 152, 93, 65}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 152}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 240, 201, 19, 45, 97}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 88, 127, 238, 117}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 45, 90, 59, 141, 199, 101, 228, 221, 172}, 179},
	{{218, 12, 4, 156, 0, 0, 82, 157, 165, 2, 28, 142, 229, 6, 112, 149}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 143, 65, 196, 34}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 92, 161, 140, 34, 55, 195}, 179},
	{{218, 12, 4, 156, 0, 97, 127, 80, 56, 18, 246, 218, 184, 249, 180, 39}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 212, 72, 130, 74}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 255, 54}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 223, 3, 145, 31, 231, 163}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 29, 191, 86, 77, 252}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 155, 118, 167, 169, 43, 8}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 233}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 124, 94, 174, 107, 44, 30, 254, 17, 178}, 179},
	{{218, 12, 4, 156, 0, 6, 61, 56, 197, 143, 147, 240, 229, 198, 166, 116}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 139, 70}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 252, 2, 194, 230, 185, 99, 185, 151}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 221, 95, 133, 187, 196, 4, 108}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 161, 65, 67, 199, 134, 112, 253}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 169, 182, 64, 186}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 245, 156, 76, 172, 189, 229, 243, 32}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 74, 106, 73, 62, 83, 219, 172, 116}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 168, 205, 160, 36, 12, 73}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 83, 224, 58, 103, 1, 49}, 179},
	{{218, 12, 4, 156, 0, 0, 47, 23, 109, 28, 148, 111, 34, 129, 98, 25}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 30, 118, 184, 25}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 70}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 82, 43}, 179},
	{{218, 12, 4, 156, 0, 134, 129, 23, 184, 237, 116, 102, 174, 77, 13, 14}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 208, 209, 34, 146, 73, 179}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 44, 6, 66, 50, 63, 121, 224, 137, 222}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 241, 54, 203, 45, 176}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 85, 201, 137, 233, 213, 55, 103}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 198, 217, 249, 210}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 218, 84, 249, 154, 21}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 77, 107, 209, 242, 225}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 70, 166, 26, 162, 182}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 143, 228, 157, 73, 168, 91}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 248, 29, 23, 198, 251, 62}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 26, 210, 105, 132, 217, 78, 122, 202}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 240, 250, 128, 195, 59, 148}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 58}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 201, 224}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 73, 181, 103, 55, 217, 248, 206, 252}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 218, 111, 158, 45}, 179},
	{{218, 12, 4, 156, 0, 229, 223, 139, 58, 166, 30, 87, 15, 220, 141, 0}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 234}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 88, 103, 100, 27, 214, 10, 147, 146, 224}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{218, 12, 4, 156, 0, 0, 148, 126, 108, 71, 232, 240, 192, 215, 175, 181}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 206, 149, 12, 54, 134, 60, 55, 212}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 127, 214, 138, 56, 244, 121}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 121}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 22, 76}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 212, 153}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 245, 89, 33, 228, 6}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 235, 36, 146, 135, 158, 138, 217, 17}, 179},
	{{218, 12, 4, 156, 0, 70, 47, 6, 75, 103, 15, 222, 90, 39, 170, 233}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 132, 146}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 229, 87, 192, 77}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 61, 113, 35, 34, 212}, 179},
	{{218, 12, 4, 156, 0, 3, 42, 129, 116, 78, 122, 140, 111, 217, 116, 14}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 26, 31}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 157, 163, 217, 55, 106, 93}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 3}, 179},
	{{218, 12, 4, 156, 0, 0, 227, 145, 150, 215, 214, 25, 108, 94, 109, 120}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 111, 19, 251, 65, 179, 60, 146, 203}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 184, 242, 121, 187, 146, 23, 25, 17}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 200, 44, 227, 36, 23, 175, 20}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 4}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 26, 228, 27, 98, 191, 210}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 249, 35}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 148, 10, 200, 185, 192, 133, 104, 204, 29}, 179},
	{{218, 12, 4, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 13, 137}, 179},
	{{218, 12, 4, 156, 0, 140, 162, 27, 204, 107, 180, 31, 188, 219, 142, 0}, 179},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{9, 5, 190, 195, 60, 216, 80, 150, 128, 117, 86, 128, 128, 112, 98, 208}, 87},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 98}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 36}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 160}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 198}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 230}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 38}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 243}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 222}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 176}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 26}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 238}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 125}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 28}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 180}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 223}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 254}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 147}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 198}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 94}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 146}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 100}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 99}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 122}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 212}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 106}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 208}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 88}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 42}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 2}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 96}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 22}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 180}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 156}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{7, 226, 104, 112, 212, 9, 172, 124, 209, 121, 170, 229, 44, 178, 128, 0}, 29},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 10, 162, 93, 96}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 131, 14, 103, 120}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 238}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 98, 147, 194, 79}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 180, 0, 120}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 190, 116, 251}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 13, 113}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 94, 217}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 105, 202, 157, 50}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 206, 169}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 227}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 221, 121, 88}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 251, 244}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 124}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 18, 34}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 91, 186, 79, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 99, 171}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 40}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 4}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 188, 124, 130}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 225, 17}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 195, 254, 110, 24}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 57, 192}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 249, 103}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 149, 48, 234}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 140, 184}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 72, 237}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 236}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 186}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 16, 192}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 255, 105}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 139, 208, 140, 26}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 77}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 141, 246}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 154, 226, 240}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 75, 91, 44, 195}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 183}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 47, 45, 132, 109}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 79, 144}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 207}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 100, 3}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 1, 236}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 88, 254}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 187, 155, 127}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 199}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 205, 18, 201}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 180, 9}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 105}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 165, 201}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 242}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 105, 242, 19, 88}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 242, 178, 129}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 48}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 31, 156, 91, 76}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 25, 25}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 104}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 63, 52, 111, 107}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 156, 61, 92, 39}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 175}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 139}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 68, 132}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 71}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 166, 139}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 60, 251, 198, 235}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 162, 149, 61}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 73, 193}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 45, 175, 89}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 40}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 33}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 123, 139}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 61, 54, 106}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 159}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 199}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 13, 98, 247}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 67}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 150, 84, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 106, 166}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 118, 195}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 0}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 14, 247}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 124, 69}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 57}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 232}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 139, 100, 80}, 184},
	{{47, 71, 174, 76, 52, 83, 23, 18, 106, 48, 56, 32, 0, 0, 0, 172}, 184},
	{{51, 168, 0, 0, 0, 129, 179, 12, 49, 199, 23, 118, 34, 147, 225, 73}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 25, 231, 239, 29, 230, 77, 138, 80}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 73, 226, 179}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 219, 205, 235, 134, 181, 78, 173, 136, 220}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 84, 48, 31, 103, 67, 212, 226}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 83}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 86, 36, 166, 15, 29, 53, 151}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 123, 176, 225, 104, 27, 127}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 32}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 156, 197, 112, 58, 217, 21, 179, 53}, 45},
	{{51, 168, 0, 0, 0, 3, 185, 41, 235, 225, 182, 70, 16, 241, 230, 36}, 45},
	{{51, 168, 0, 0, 0, 228, 170, 2, 102, 57, 198, 52, 59, 214, 34, 84}, 45},
	{{51, 168, 0, 0, 0, 0, 161, 173, 196, 224, 136, 28, 53, 179, 130, 53}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 148, 135, 245, 200, 91, 180}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{51, 168, 0, 7, 132, 226, 173, 111, 39, 218, 38, 231, 114, 218, 29, 136}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 58, 179, 112, 22, 181, 114, 169, 151, 114}, 45},
	{{51, 168, 0, 153, 28, 159, 42, 153, 116, 156, 214, 66, 182, 234, 160, 55}, 45},
	{{51, 168, 0, 222, 238, 217, 148, 31, 118, 178, 39, 245, 168, 8, 82, 117}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 3, 185, 66}, 45},
	{{51, 168, 152, 48, 137, 101, 148, 19, 104, 97, 116, 233, 153, 61, 79, 60}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 129}, 45},
	{{51, 168, 0, 212, 43, 237, 112, 241, 94, 64, 244, 230, 7, 169, 176, 223}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 126, 218, 30, 77, 76, 145, 137, 240, 47}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 34}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 7}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 232, 244, 250, 171, 72, 96, 187}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 107}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 212, 23, 89, 160, 114, 88, 192, 243, 155}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 42, 113}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 55, 125, 138, 41}, 45},
	{{51, 168, 0, 43, 14, 144, 79, 32, 194, 221, 98, 90, 239, 211, 255, 117}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 106, 142, 188, 150, 245, 9, 207, 76}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 152, 238, 201, 250, 21, 132, 55, 119, 64}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 208, 185}, 45},
	{{51, 168, 0, 0, 182, 62, 105, 50, 13, 103, 83, 88, 178, 155, 161, 250}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 68}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 22, 187, 250}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 214, 222, 58, 81, 35, 131, 4}, 45},
	{{51, 168, 0, 0, 0, 0, 209, 114, 21, 128, 203, 201, 28, 164, 152, 253}, 45},
	{{51, 168, 0, 0, 201, 210, 219, 57, 231, 239, 134, 236, 152, 190, 88, 89}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 224, 111, 234, 45, 213, 54, 93}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 46, 94, 91, 83, 92, 254, 73, 183}, 45},
	{{51, 168, 3, 193, 133, 98, 69, 255, 139, 237, 120, 116, 2, 125, 138, 230}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 27, 78, 47}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 140, 51, 196, 184, 212, 218, 19, 19, 165}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 147, 72, 242, 12, 9, 233}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 209, 131, 163, 108, 87, 101, 46, 2}, 45},
	{{51, 168, 0, 0, 0, 132, 188, 131, 199, 91, 96, 31, 44, 52, 39, 2}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 150, 201, 219, 165, 141, 122, 204, 108}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 215, 14}, 45},
	{{51, 168, 0, 187, 41, 102, 20, 13, 71, 224, 64, 133, 56, 112, 190, 71}, 45},
	{{51, 168, 0, 0, 0, 0, 13, 242, 83, 134, 87, 126, 222, 62, 102, 29}, 45},
	{{51, 168, 0, 0, 0, 0, 237, 232, 70, 8, 86, 67, 208, 118, 250, 249}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 121}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 6, 212, 131, 88, 199, 198, 228, 47, 95}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 45},
	{{51, 168, 0, 0, 0, 0, 138, 164, 217, 243, 60, 69, 170, 80, 144, 74}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 22, 162, 161, 225}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 235, 124, 211, 165, 134, 170, 184, 178}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 186}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 206, 78, 59}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 202, 134, 225}, 45},
	{{51, 168, 0, 117, 141, 236, 235, 83, 95, 208, 153, 27, 237, 157, 214, 5}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 51, 176}, 45},
	{{51, 168, 0, 0, 0, 16, 197, 206, 62, 111, 4, 216, 83, 76, 128, 39}, 45},
	{{51, 168, 0, 0, 115, 106, 196, 186, 147, 129, 231, 223, 90, 40, 234, 13}, 45},
	{{51, 168, 0, 0, 0, 206, 164, 216, 204, 130, 152, 49, 19, 226, 118, 13}, 45},
	{{51, 168, 0, 247, 98, 87, 154, 2, 204, 160, 7, 25, 99, 80, 26, 82}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 166, 73, 18, 88, 204, 42}, 45},
	{{51, 168, 0, 0, 45, 44, 170, 137, 131, 115, 176, 139, 181, 183, 81, 234}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 16, 253}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 47, 66, 213, 141, 119, 111, 74, 38, 59}, 45},
	{{51, 168, 0, 216, 17, 201, 159, 0, 93, 237, 98, 158, 238, 68, 162, 111}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 189, 238, 125, 212, 251, 131, 94, 14}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 124, 24, 234, 56, 188, 181, 203}, 45},
	{{51, 168, 0, 0, 23, 15, 64, 56, 21, 67, 207, 113, 166, 73, 94, 126}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 98, 223, 198, 164, 189, 73, 183}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 4, 121, 79}, 45},
	{{51, 168, 0, 0, 241, 22, 185, 224, 91, 216, 158, 36, 126, 67, 89, 160}, 45},
	{{51, 168, 0, 233, 240, 186, 144, 37, 112, 172, 68, 220, 228, 219, 234, 17}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 21, 57}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 216, 217, 7, 100}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{51, 168, 0, 0, 108, 62, 161, 11, 71, 107, 84, 6, 77, 92, 226, 7}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 96, 254, 26, 109, 230, 26, 141, 68}, 45},
	{{51, 168, 0, 0, 0, 0, 0, 0, 0, 79, 197, 195, 30, 7, 95, 244}, 45},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 209, 76, 64, 77, 208, 228, 163}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 138, 204, 175, 215, 41, 134, 138}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 221, 211, 23}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 129}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 200, 61, 130, 161, 35, 167, 208, 144}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 80, 87, 36, 133, 88}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 44, 51, 214, 188, 173, 58, 159, 192}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 5, 179, 150, 184, 74, 181, 164}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 21, 232, 201}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 8, 185, 12, 131}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 173, 231, 103, 33, 144, 213}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 188, 125, 161, 135}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 240, 97, 17, 112}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 196, 221, 39, 36, 74, 37}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 169, 217, 179}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 189, 116, 161, 69, 158, 149, 133}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 246, 114, 237, 195, 24, 144}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 214, 51, 249, 98, 199, 10}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 164}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 49, 134, 32, 142}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 68, 186, 220, 193, 35}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 92, 176, 128, 184, 238, 118}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 202, 125}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 117, 229, 70}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 218, 214}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 222, 171, 192, 30, 193, 92, 175, 153}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 131, 78, 28, 75, 51, 80, 159}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 46, 143, 174, 17, 124, 2, 160}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 8, 251, 35, 171, 32}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 73, 119}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 159, 219, 130, 185, 109, 97, 189, 122}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 19, 143, 159, 153, 234, 115, 46}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 116, 162, 146, 19, 140, 68, 37, 176}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 234, 27, 101}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 138, 212, 83, 153, 155, 65, 242, 231}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 159, 112, 56}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 227, 236, 210, 210, 179, 193, 99}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 160, 127, 33, 243, 220}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 188, 25, 181}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 6, 166, 174}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 105, 23, 114, 72, 1, 184, 247}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 1, 77, 86, 8, 115, 57}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 69, 39, 80, 36, 49}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 245, 60, 147, 114, 183, 138, 139, 59}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 13, 202, 241, 107, 240}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 208, 48, 144, 122, 99, 75, 12}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 154, 101}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 212, 164, 151, 91, 101, 11}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 47, 120, 107, 22, 174, 115, 73}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 237, 10, 78, 20, 73, 29, 105, 131}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 31, 219}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 116, 38, 27}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 252, 71, 77, 66, 246, 164, 236, 136}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 21, 80, 46, 177, 50, 131, 184, 228}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 151, 86, 6, 86, 124, 97, 178, 116}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 142, 170, 111, 148, 30}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 222, 11, 142, 238, 120, 209, 92}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 157, 172, 111, 240, 154, 179}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 14, 164, 38, 4, 166, 41}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 129, 115, 153, 73, 60, 56, 151, 99}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 143, 132, 141, 254, 174, 161, 127, 57}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 133, 170, 238, 32, 219}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 184, 101, 69, 4, 107, 60, 53}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 1, 111, 52, 79, 71}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 25, 217, 45, 43, 181, 164, 27}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 51}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 229, 191, 55, 18, 105, 249, 39}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 120, 241, 124, 59, 118, 201, 147}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 0, 99}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 254, 136, 66, 235, 193, 77}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 99, 78, 211}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 130, 141, 27, 160}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 34, 146, 152}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 169, 28, 65}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 20, 153, 166}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 188, 219, 222, 251, 249, 173}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 7, 33, 154, 178, 141, 173, 36, 51}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 144, 200, 24, 76, 162, 204, 211}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 59, 220, 253, 181}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 217, 196, 136, 34}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 0, 119, 141}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 223, 124, 28, 85, 29, 72, 179}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 22, 89, 224, 36, 75}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 227, 226, 210, 188, 2, 9, 232, 202, 143}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 215, 211, 147, 111, 76}, 144},
	{{28, 182, 167, 124, 28, 22, 80, 0, 0, 0, 0, 0, 0, 20, 185, 82}, 144},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 172}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 236}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 185}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 161}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 177}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 96}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 99}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 175}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 103}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 33}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 144}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 108}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 36}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 18}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 110}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 152}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 178}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 18}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 228}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 21}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 129}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 233}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 183}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 136}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 29}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 225}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 226}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 185}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 95}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 42}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 216}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 44}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 220}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 113}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 53}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 199}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 121}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 151}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 0}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 78}, 119},
	{{34, 61, 14, 51, 253, 17, 19, 170, 49, 206, 188, 207, 247, 167, 192, 111}, 119},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 78, 125, 37, 85, 193, 5}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 103, 119, 236, 54, 169, 118, 58}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 7, 43}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 62, 43}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 203}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 158, 174}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 89, 141, 34, 140, 128, 225}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 92, 95}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 26, 5, 204, 209, 4}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 172, 129, 108, 226, 149, 75, 138}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 229, 175, 40, 41, 19}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 112, 160, 101, 171, 54}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 244, 183}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 81, 123, 114, 223, 81, 135, 23}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 98, 26}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 58, 207, 26, 101}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 62, 29, 142, 213, 210}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 129, 167, 57, 152, 50}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 31, 182, 141, 159}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 51, 66}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 122, 70, 215, 49, 189, 220, 126}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 1, 189, 245, 237, 241, 120}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 53, 16, 23}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 104, 61}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 186, 2, 168, 146, 115, 26}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 208, 226, 86, 96, 170}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 71, 188}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 68, 218, 209, 250}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 119, 148, 142, 183}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 242, 77, 191, 112, 253}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 14, 134, 131, 210, 44}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 238, 152}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 179, 104, 16}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 16, 79, 5, 5}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 40, 87, 47, 9, 146, 96}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 212, 155, 245, 113, 180}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 106, 9, 84}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 88, 109, 186}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 57, 152, 200, 146, 129, 85}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 116, 48, 124, 248, 179}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 100, 82}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 173, 95, 92, 28}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 206, 197, 255, 102}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 159, 147, 243, 69, 92}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 125}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 240}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 60, 237, 8, 22, 200, 177, 117}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 136, 75, 78, 35, 144}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 252, 77}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 91, 16, 11, 127, 240}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 160}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 31}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 224, 197, 82, 75, 127}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 204}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 114, 236, 79, 55, 231, 41, 94}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 17, 103, 188}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 127, 122, 82, 4, 184}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 175, 106, 53}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 225}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 121, 233}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 240, 216, 176, 99, 150}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 14, 138, 44, 113, 123, 241, 254}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 189}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 156}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 113, 20, 170, 45, 207, 28}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 63, 107, 56, 243, 49, 134, 153}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 24, 106, 240, 160, 86, 107}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 53, 33, 152, 197, 97, 13}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 138}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 175, 71, 188}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 82}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 64, 67}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 117, 234, 66, 108}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 69, 15, 124, 20}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 162, 166, 181, 117, 95, 99}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 42}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 58, 188}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 41, 186, 14, 177, 247, 229}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 159, 193, 59, 37}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 25, 173}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 58, 150, 145, 67, 42}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 13, 254, 255}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 0, 170}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 12, 127, 2}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 0, 0, 9, 44}, 113},
	{{2, 235, 18, 14, 195, 66, 237, 30, 0, 0, 0, 0, 33, 158, 255, 150}, 113},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 27, 4, 175}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 64}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 129, 255, 175}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 218, 250}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 99, 236}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 115, 95}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 196, 20, 89, 230}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 32, 24, 247, 31}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 155, 119, 179, 19, 209}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 185, 161, 33, 219}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 55, 161}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 189, 122, 183}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 157, 5}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 128, 85, 163}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 105, 70, 143, 238, 50}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 252}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 65, 89}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 244, 205, 34}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 249, 139, 150}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 45, 248, 156, 205}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 20, 8}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 244, 171}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 199}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 162, 225, 214, 237}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 92, 28, 37}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 229, 255, 83, 48}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 126, 149, 71, 213, 171}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 20, 131, 176}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 191, 38}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 52, 252, 207, 164}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 107, 85}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 204, 163, 229}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 6, 132, 68}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 167, 1, 177, 126}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 177, 157, 223}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 150}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 18}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 85, 127}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 138, 65}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 159, 20, 15, 145}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 81, 43, 102, 29}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 126, 131}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 152, 155, 203}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 15, 114, 170, 171, 57}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 85, 22}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 171, 240, 199}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 123, 154, 240, 89}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 5, 104}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 252, 100}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 20, 196, 230, 85}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 94, 242}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 34, 181, 141, 66}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 242, 214, 27}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 109, 234, 215, 112}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 7, 223, 8, 105, 29}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 109, 39, 106, 8, 81}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 230, 5, 60}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 182, 197, 81, 85}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 148, 229}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 66, 224, 73}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 140, 250}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 20, 181}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 137, 141, 82, 212, 242}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 176, 115}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 223, 131}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 64, 35}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 21, 211, 84}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 2, 65, 209, 183}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 95, 201, 45}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 19, 169, 153, 235}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 3, 137, 19}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 145, 72, 141, 77, 130}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 28}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 126, 11, 163, 170, 209}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 188}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 34, 22, 113, 20, 14}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 22, 24, 236}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 37, 112, 84}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 84, 53}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 52, 119, 223, 4}, 50},
	{{51, 182, 142, 133, 127, 96, 159, 132, 99, 161, 64, 0, 0, 0, 0, 0}, 50},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 158, 81, 186}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 113, 216, 57, 43}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 105, 254, 201}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 120, 109, 210, 113, 174, 131}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 100, 188, 35, 210, 106}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 195, 178, 156, 234}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 50, 116, 68, 62}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 28, 62, 35, 178}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 101, 208, 240, 134}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 245, 161}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 9, 161, 193, 213, 246, 244}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 75}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 136, 12, 38, 104, 42, 33}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 148, 244, 188, 167, 18}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 199, 240, 163, 198, 159, 178, 220}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 13, 60, 3, 80}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 121, 11, 213, 230, 92, 27}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 16, 205, 171, 199, 75}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 42, 38, 220, 74, 25}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 42, 19, 122, 244, 115, 101}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 174, 121, 232, 159, 12, 178, 27, 47}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 149, 202, 88, 103, 44, 145, 214, 3}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 184, 15, 142, 88, 136, 134}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 204, 158, 250, 95, 68}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 178, 152, 1, 200, 213, 149, 183}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 82, 213, 149, 40}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 113, 58}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 218, 140, 108, 230, 140}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 151, 37}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 69, 171, 112, 67}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 36, 165, 160, 92, 158, 33, 180}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 48, 172, 165, 38, 84, 239, 134, 77}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 177, 178, 100, 72, 94, 5, 21}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 242, 70, 153, 28}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 36, 126, 74}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 244, 165, 217, 45, 202, 89}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 78}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 66, 220, 209, 91}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 218, 236}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 113, 197, 220, 30}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 34, 255, 185}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 124, 137, 134, 240, 36, 177, 44, 81}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 196, 172, 199}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 249, 206, 233}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 65}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 172, 29, 127, 72, 36, 147}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 89, 166, 209, 196, 238}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 216, 9, 189, 68, 225, 66}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 249, 83, 198, 174, 14, 152}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 222, 131}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 86, 205, 230, 197, 159}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 128, 32, 154, 25, 82, 4, 5}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 181, 220, 118, 216, 49, 211, 80}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 171, 230, 241, 198}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 129, 50}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 140}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 19, 75, 178, 254, 185, 235, 5}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 86}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 138, 43, 15}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 252, 147, 196}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 219, 29}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 9}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 181, 138, 198, 216, 120, 49}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 184, 133, 140, 141, 67, 94, 44, 244}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 152, 171, 243, 177, 125, 252, 82, 193}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 45, 11}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 103, 117, 90, 126}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 111, 187, 144, 208, 125, 213}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 184}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 33, 245, 18, 46}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 77, 122, 94, 109, 251, 141}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 51, 117, 116, 60, 49, 115, 70}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 48, 226}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 82}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 1, 227, 173, 236, 74, 166}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 107, 110, 221}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 178, 219, 119, 192}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 207},
	{{170, 145, 230, 123, 215, 189, 73, 0, 0, 227, 116, 157, 205, 149, 227, 206}, 207},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 200}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 148, 13, 199, 189, 165}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 210, 44, 224, 111, 198, 68, 45, 248, 32}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 189, 154}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 230, 197, 40, 89, 4}, 3},
	{{151, 166, 32, 0, 0, 159, 90, 175, 72, 61, 146, 102, 226, 253, 232, 222}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 32, 74, 5, 167, 216}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 149, 249, 53, 170, 63, 204}, 3},
	{{151, 166, 32, 0, 95, 196, 149, 213, 28, 76, 207, 19, 106, 146, 71, 120}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 165, 209, 122, 57, 134, 205, 158, 14, 112}, 3},
	{{151, 166, 32, 0, 245, 39, 188, 240, 42, 188, 71, 190, 181, 218, 144, 125}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 150}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 44, 133, 147}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 219, 132, 125, 69, 53, 92, 81}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 168, 143, 129, 81, 38, 241}, 3},
	{{151, 166, 32, 0, 0, 121, 185, 209, 129, 33, 166, 95, 56, 112, 210, 120}, 3},
	{{151, 166, 32, 0, 201, 84, 253, 83, 40, 223, 18, 172, 121, 240, 59, 163}, 3},
	{{151, 166, 32, 0, 0, 0, 30, 126, 163, 90, 209, 161, 216, 103, 201, 187}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 18, 8, 221}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 237, 194, 255, 178, 208, 115, 134, 18}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 253, 121, 210, 209, 113, 149, 43}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 26, 121, 175, 149, 179, 174, 179, 218}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 156, 192, 61, 6, 177, 107, 97, 33, 213}, 3},
	{{151, 166, 32, 0, 0, 205, 201, 242, 208, 153, 47, 8, 197, 232, 96, 172}, 3},
	{{151, 166, 32, 0, 0, 29, 113, 104, 51, 202, 9, 128, 79, 43, 59, 13}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 199, 250, 107, 62, 169, 130, 115, 3}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 238, 183, 254, 2, 182}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 112, 211, 31, 125, 22}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 140, 195, 94, 176, 210, 164, 205, 136}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 244, 182, 71}, 3},
	{{151, 166, 32, 8, 222, 188, 234, 48, 82, 21, 233, 44, 209, 209, 66, 233}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 200}, 3},
	{{151, 166, 32, 0, 175, 92, 138, 237, 12, 80, 143, 153, 153, 226, 35, 17}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 41, 57, 112, 182, 238, 243, 123, 133, 39}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 35, 48, 238}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 229, 80, 128, 132, 183}, 3},
	{{151, 166, 32, 0, 133, 246, 240, 101, 146, 129, 152, 237, 171, 113, 137, 149}, 3},
	{{151, 166, 32, 0, 0, 0, 88, 232, 153, 168, 238, 7, 152, 19, 255, 235}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 249, 208, 231, 206, 229, 167, 255, 59}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 34, 165, 211, 107, 209, 15, 125}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 161, 74}, 3},
	{{151, 166, 32, 0, 0, 118, 222, 237, 142, 152, 194, 209, 244, 46, 176, 128}, 3},
	{{151, 166, 32, 0, 0, 156, 82, 122, 209, 139, 48, 160, 51, 21, 71, 157}, 3},
	{{151, 166, 32, 0, 0, 22, 225, 114, 158, 149, 192, 146, 60, 40, 37, 131}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 35, 204, 165, 248, 51, 208, 7, 223}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 26, 66, 152}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 117, 210}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 106, 4, 168, 16, 114, 159, 124, 214}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 28, 45, 5, 178, 244, 71, 124, 14}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 137, 27, 97, 48, 128, 246, 91}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 137, 91, 50, 157, 47, 2, 21, 180}, 3},
	{{151, 166, 32, 0, 205, 3, 158, 45, 131, 210, 91, 32, 165, 188, 66, 115}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 59}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 220, 149, 95, 249, 201}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 159, 179, 216, 217, 10, 84}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 218, 252, 235, 43, 214, 8, 248, 180}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 185, 205, 7, 46, 69, 222, 109, 66}, 3},
	{{151, 166, 32, 0, 183, 125, 178, 118, 214, 62, 147, 238, 254, 214, 107, 248}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 114, 16}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 212, 108, 134, 152, 216, 177, 240, 42, 26}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 227, 76, 210}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 250, 54, 45, 78, 222}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 76, 119, 26, 113, 142, 74, 217, 120}, 3},
	{{151, 166, 32, 0, 66, 39, 86, 111, 241, 15, 123, 89, 184, 227, 50, 33}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 127, 103}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 249}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 186, 254, 30, 202, 128, 103, 192, 237}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 187, 135}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 213, 0, 224, 215, 87, 217, 241}, 3},
	{{151, 166, 32, 0, 0, 96, 148, 164, 90, 180, 250, 96, 233, 29, 221, 145}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 234, 31, 62, 230, 9, 7, 2, 161}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 255, 126, 108, 192, 189, 13, 164, 188, 202}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 138, 56, 201, 30, 196, 163}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 22, 187, 95, 17, 196, 3}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 14, 72, 109, 183, 31, 26, 43}, 3},
	{{151, 166, 32, 0, 0, 24, 67, 235, 47, 13, 42, 93, 27, 140, 218, 50}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 20, 174, 253, 212, 99, 165, 181, 5}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 201, 10, 66}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 94, 210, 105, 254, 225, 172}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 202, 109, 222, 44, 50, 80, 203, 30}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 253, 198, 40, 243, 107, 156, 182}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 143, 140}, 3},
	{{151, 166, 32, 0, 0, 0, 0, 0, 0, 0, 126, 233, 148, 122, 60, 24}, 3},
	{{151, 166, 32, 0, 0, 0, 179, 140, 80, 31, 221, 211, 232, 55, 221, 152}, 3},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 119, 32}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 40, 139, 202, 217, 170, 129}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 195, 162}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 208, 220, 111, 188}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 144}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 46, 220, 61, 22, 233, 100, 107}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 44, 235, 155, 245}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 221, 240, 219}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 68, 161, 171, 37}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 130, 190, 171, 96, 113, 69, 20, 238}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 25, 216, 230, 143, 1}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 159, 251, 253, 139, 210, 245}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 126, 103}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 22, 189, 79}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 235, 227}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 128, 194, 123, 138, 118, 113, 16, 54}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 79, 35, 34, 149, 16}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 112, 251, 4}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 242, 85}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 158, 118, 59}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 151, 46, 85}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 118, 227, 59, 152, 188, 194}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 178, 199}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 210, 10, 108}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 218, 144, 233, 9}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 252, 56, 243, 227, 252, 193}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 77, 199, 86, 196, 147}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 36, 29, 70, 199}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 248, 80, 159, 170, 20, 25, 180}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 74}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 140, 40, 195, 178, 57, 36, 41}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 215, 187}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 20, 172, 45, 180, 15}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 30, 98, 59, 163, 129, 33}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 126, 78, 165, 129}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 160, 54, 108, 95}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 143, 242}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 166, 134, 22, 219, 18, 33, 121, 3}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 232, 177, 196, 161, 192, 119}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 254}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 77, 175, 98, 239, 28, 113, 248, 32}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 45, 14, 87, 46}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 100, 14, 188, 213, 160}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 98, 124, 76, 199, 185}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 202, 74}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 115, 158, 197, 44, 153}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 11, 204}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 125, 169, 193}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 4, 9, 208, 163, 185, 41, 207}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 118, 190, 229, 102, 87, 189}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 128, 229, 5, 147, 52, 152}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 17, 225, 216}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 35, 117}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 15, 45}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 235, 125, 192, 60, 48, 218, 80, 125}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 251, 103}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 213, 29, 136, 4, 195, 64, 51, 221}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 93, 181, 196}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 166, 100}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 72, 230, 97, 247, 194, 143}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 143, 206}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 171, 207, 206, 120}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 75, 158, 86, 41, 202, 60, 126, 216}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 174, 167, 196, 23, 61, 192, 101}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 132, 26, 47, 174, 152, 85, 21, 193}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 136, 173, 0}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 51, 206}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 203, 151, 193, 128, 45, 147}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 133, 20, 213, 44, 87, 178, 89}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 138, 63, 13}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 180, 149}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 167, 225, 181, 224}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 217, 60, 145, 64, 241, 69, 155, 185}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 23, 11, 162, 242, 221, 98, 76}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 138, 166, 120, 212, 106, 222, 100}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 153, 42, 182, 190, 55, 166}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 140, 30, 90, 243, 188, 200}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 0, 237}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 123, 119, 141, 18, 93}, 13},
	{{16, 141, 196, 129, 132, 207, 7, 0, 0, 0, 0, 0, 0, 0, 154, 79}, 13},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 20, 10, 245, 92}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 99, 233, 236, 92, 224, 82, 23}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 30, 152, 162}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 166, 221, 78, 32, 160}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 211, 148, 184, 92, 87, 22, 166}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 167, 239, 125, 63, 127, 57, 58}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 150, 53, 147, 6}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 204, 104, 86, 157}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 97, 193, 170}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 24, 96, 8, 19, 97, 38, 92}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 236, 125, 130, 204, 88, 110}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 226, 248, 94, 152, 114, 137}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 81, 215, 142, 9, 155}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 141, 108, 67, 24, 207}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 209, 36, 47, 189, 7, 195, 143}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 176, 9}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 190, 212}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 39, 177, 107, 246, 71, 113, 138}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 82, 54}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 46}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 186, 196, 54, 243, 152, 226, 20, 228}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 114, 68, 224, 102, 26, 217, 19, 42}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 52, 214, 41, 157}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 95, 98, 16, 115, 149, 27, 204}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 217, 156, 27, 29}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 42, 122, 73, 237, 179, 230, 24}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 159, 111}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 118, 114, 168}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 175, 11, 42, 252, 138}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 21, 74, 54, 109}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 239}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 14, 253, 6, 50, 230, 147, 140, 143}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 236, 233, 199, 197, 108, 80, 202, 159}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 143, 104, 100, 19}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 210, 224, 80}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 94, 201, 14, 143, 57, 20}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 85, 64, 116, 1, 253, 205, 244}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 149, 244, 246, 61}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 117}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 220, 185, 8, 44, 197}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 214}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 254, 131, 93, 234, 211}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 146, 17, 74, 186, 171, 9}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 18, 4, 68, 117, 234, 28, 20, 185}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 239, 128, 246}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 235, 168, 94, 175, 202}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 65, 208, 37, 198, 105, 190, 193}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 109, 156, 21}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 73, 238, 18, 247, 60, 163, 91}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 78, 241, 233, 184, 97, 173, 213}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 244}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 35, 90, 250}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 233, 166, 84, 77, 93}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 102, 204, 112, 134, 82, 51, 238}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 96, 95, 143, 93, 178, 112, 93}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 202, 72, 166}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 102, 21, 202, 11}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 186, 47, 182, 108, 242, 174, 230}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 197, 84, 42}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 134, 110, 186, 93, 109}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 104, 19, 3, 144}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 124}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 179, 195}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 204, 76, 177}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 160, 86, 106, 149, 191, 106}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 163, 179, 242, 1, 45, 28, 111}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 52, 80, 105, 150, 57, 179, 89}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 178, 25, 94}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 46, 144}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 233, 62, 12, 65}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 180, 146, 248, 8, 63, 150, 133}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 201, 171, 7, 162, 18, 226, 219, 199}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 0}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 157, 1, 29, 93}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 117, 178, 24}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 87, 80, 81}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 234}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 127, 127, 33}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 94, 225, 176, 186, 20, 189}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 176, 233}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 79, 0, 245}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 130, 30, 125, 140, 177, 179, 250}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 140, 116, 56, 143, 171, 13}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 0, 0, 0, 0, 0, 61}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 183, 61, 113, 133, 47, 184, 247}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 92, 27, 124, 186, 85, 227, 47}, 42},
	{{205, 25, 184, 191, 201, 206, 109, 224, 0, 0, 64, 252, 214, 11, 251, 174}, 42},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 188, 48, 108, 63, 93, 226}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 201, 145, 152, 232}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 100, 241, 173, 170, 78, 129, 172}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 240, 149, 17, 197}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 173, 65, 219, 193, 79, 116, 232, 26}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 6, 47, 107}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 180}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 8, 222, 122, 9}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 127, 67}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 137, 147, 249, 116}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 234, 178}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 11, 87, 10, 216, 73, 37, 61, 37}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 156, 70}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 129, 46, 166, 101}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 81, 167, 254, 69, 12}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 1, 83, 215, 236}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 69}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 192, 197, 125, 44, 54, 35}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 13, 2, 137, 0, 18, 88, 157}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 120, 123}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 59, 215, 71, 168, 133, 214}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 146, 153, 125, 228, 40, 148, 54, 4, 57}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 36, 145, 63, 230, 197}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 153, 70, 194, 70, 203}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 60, 112, 129}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 28, 119, 168, 178}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 202, 13, 127}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 194, 238, 232, 230, 68}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 82, 195, 95, 50, 133}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 189, 62, 209, 212, 64, 38, 235, 42, 94}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 243, 5, 177, 16}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 140, 48, 54, 249, 12, 205, 71}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 72, 15, 230, 111, 210}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 30, 105, 68, 94, 247, 28, 124, 23, 92}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 202, 106, 188, 47, 252, 243}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 199, 2, 85}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 106, 23}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 40, 146, 49, 187, 236}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 171, 27, 214, 66, 174, 182, 113}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 168, 83}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 250, 207, 254, 211, 229, 114, 24, 187}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 155, 70, 91, 92, 29, 176, 83, 117, 125}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 97, 43, 151, 234, 162, 25, 249}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 85, 197}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 246, 75, 237, 59, 42, 95, 114, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 225, 154, 137, 38, 215, 141, 59, 185, 226}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 65, 194, 210, 103, 192, 213, 222}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 232, 231, 38, 124, 64}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 130, 30, 19, 42, 220, 104, 209}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 201, 91, 73, 95, 81, 120, 146, 84}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 86, 118, 78, 193}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 202, 47, 172, 81}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 141, 221}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 125, 216, 1, 167, 45, 80}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 133, 210, 197, 202}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 105, 84, 177, 231, 101}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 121, 88, 192}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 244, 245, 21, 109, 45, 182}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 210, 125, 66, 232, 169, 249}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 129, 112, 239, 65, 155, 240, 95}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 217}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 165, 81, 22, 129}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 253, 247, 24, 186, 190, 106, 28}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 70, 53, 42, 72, 41, 167, 197}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 87, 45, 135, 229, 140, 141, 126}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 28, 68, 216, 124, 108, 169, 10, 3, 81}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 18}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 187, 179, 24}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 85, 118, 52}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 148, 87, 3, 110}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 129, 83, 212, 219, 191, 46, 108, 213}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 12, 183}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 64, 224, 136, 21, 7, 112, 149, 199}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 70, 100, 10, 46, 84, 180}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 212, 222, 18, 48, 247}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 31},
	{{48, 114, 33, 103, 247, 255, 64, 0, 76, 33, 225, 141, 55, 90, 135, 204}, 31},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 219, 137, 120}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 31, 254, 76}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 19}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 71, 34}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 39, 24}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 222, 209}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 134, 206, 159, 191}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 246, 60}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 133}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 146}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 141, 238, 74}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 90}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 72, 25}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 237, 186, 99}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 195, 78}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 220, 106}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 120, 249, 107}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 3}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 167, 165, 175, 171}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 208}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 16}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 75, 13}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 210}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 164, 123, 251}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 21, 204, 133}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 107, 119, 181}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 95, 163}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 179, 40}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 65, 56, 40}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 56, 222, 216}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 242, 15, 104}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 46, 109}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 1, 56}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 91, 244}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 105}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 219}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 66, 221}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 168, 79, 108}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 18, 17, 193, 10}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 13}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 127}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 216, 118}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 231, 129}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 8, 199, 3, 85}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 53, 255}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 152, 136}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 146}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 195, 120}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 48, 196, 139}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 105, 53, 13}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 175, 156}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 103}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 232}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 7, 197, 155}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 121, 170}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 53, 27}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 181, 238}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 82, 219}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 115, 34, 222, 55}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 0}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 0, 27}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 152, 195, 28, 76}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 19, 188}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 252, 247}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 12, 253, 173}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 235, 26}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 217, 234, 241}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 0, 13, 61}, 30},
	{{179, 156, 119, 146, 125, 21, 42, 146, 237, 213, 191, 132, 0, 6, 84, 4}, 30},
	{{179, 129, 186, 144, 0, 0, 117, 204, 186, 157, 238, 62, 163, 36, 22, 148}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 178}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 151}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 178}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 90}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 239, 173, 202, 47, 38}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{179, 129, 186, 144, 0, 253, 126, 174, 185, 95, 89, 145, 41, 208, 100, 18}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 195, 245, 82, 186}, 94},
	{{179, 129, 186, 144, 0, 4, 95, 149, 48, 168, 247, 184, 34, 59, 189, 186}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 121, 99, 221, 249, 52, 87}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 207, 51, 238, 27, 94, 81}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 220, 132, 43, 78, 167, 22}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 119, 196, 69, 76, 167, 211, 184}, 94},
	{{179, 129, 186, 144, 214, 252, 186, 13, 253, 164, 40, 253, 88, 127, 153, 215}, 94},
	{{179, 129, 186, 144, 0, 0, 80, 186, 68, 185, 212, 216, 0, 182, 62, 107}, 94},
	{{179, 129, 186, 144, 0, 230, 84, 11, 194, 225, 30, 218, 84, 89, 11, 253}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 126, 127, 254, 244, 229, 84, 43}, 94},
	{{179, 129, 186, 144, 0, 0, 200, 248, 10, 34, 35, 214, 235, 228, 89, 149}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 109, 23, 166, 145, 187, 245}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 184, 178, 243, 116, 252, 203, 41, 92}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{179, 129, 186, 144, 0, 47, 32, 214, 214, 128, 160, 81, 169, 236, 39, 148}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 80, 45, 227, 201, 60, 75, 30, 134}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 198, 72}, 94},
	{{179, 129, 186, 144, 0, 0, 166, 227, 163, 169, 44, 70, 65, 228, 253, 184}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 13, 45, 28, 118, 174, 6, 221}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 83, 5}, 94},
	{{179, 129, 186, 144, 0, 232, 69, 85, 174, 118, 88, 135, 21, 81, 136, 138}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 206, 118, 65, 252, 145, 8, 54}, 94},
	{{179, 129, 186, 144, 0, 101, 152, 199, 101, 11, 208, 193, 58, 6, 42, 172}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 121, 198, 195, 222, 216, 67, 216, 54}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 101, 39}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 7, 235, 98, 128}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 221, 129, 115, 33}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 243, 54, 173, 87, 183, 251, 255, 144, 92}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 86, 218, 193, 41, 65, 196}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 243, 30, 33, 10}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 1, 187}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 81, 7, 7, 4, 149}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 81, 247, 87, 61, 159}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 221, 27, 240, 201}, 94},
	{{179, 129, 186, 144, 153, 87, 228, 209, 130, 134, 240, 69, 189, 253, 110, 74}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 218, 220, 163, 80}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 183, 245}, 94},
	{{179, 129, 186, 144, 0, 61, 227, 73, 12, 210, 155, 150, 48, 117, 83, 58}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 98, 24, 147, 95}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 175, 82, 162, 207, 43, 191, 43, 106, 68}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 239, 184, 40, 218, 13}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 220, 114}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 87, 13, 164, 123, 77, 53, 183, 13, 78}, 94},
	{{179, 129, 186, 144, 0, 163, 45, 211, 139, 54, 121, 153, 66, 171, 22, 34}, 94},
	{{179, 129, 186, 144, 0, 0, 154, 25, 24, 148, 155, 38, 112, 175, 83, 158}, 94},
	{{179, 129, 186, 144, 0, 0, 166, 213, 156, 28, 161, 214, 71, 41, 14, 96}, 94},
	{{179, 129, 186, 144, 0, 251, 89, 79, 29, 126, 90, 184, 94, 184, 75, 12}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 134, 3, 2, 21, 158, 103}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 103, 197, 22, 30, 16, 252, 46, 128, 112}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 209, 219, 96, 8}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 43, 241, 239, 35, 11, 172, 192, 226}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 104, 250, 66, 34, 210, 144, 47, 185, 192}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181}, 94},
	{{179, 129, 186, 144, 0, 101, 194, 117, 68, 128, 84, 183, 182, 218, 175, 107}, 94},
	{{179, 129, 186, 144, 0, 251, 137, 44, 125, 147, 61, 32, 60, 60, 162, 158}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 254, 52, 149, 108, 189, 247, 137, 254}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 63, 59, 65, 86, 153, 169, 139, 7}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 202, 195, 242, 18, 236, 51}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 219, 238, 211, 235, 152, 135, 248, 247, 126}, 94},
	{{179, 129, 186, 144, 0, 0, 87, 29, 108, 139, 180, 1, 0, 181, 56, 14}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 223, 27, 170, 34, 51, 160, 103, 226}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 35, 105, 211, 120, 13, 236, 6, 142, 143}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 124}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 226, 60, 167, 23, 139, 34}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 85}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 231, 199, 67, 54}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 152, 124}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 39, 191, 254, 15, 115}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 105}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 98, 183, 128, 183, 142, 23, 165}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 102, 189, 115, 246, 114, 1}, 94},
	{{179, 129, 186, 144, 0, 99, 18, 135, 254, 214, 63, 219, 178, 164, 157, 222}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 57, 32, 69, 167, 28, 254}, 94},
	{{179, 129, 186, 144, 0, 0, 185, 232, 171, 174, 80, 18, 53, 81, 214, 236}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 248, 247, 245, 212}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 254, 16, 125, 226, 206}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 63, 75}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 108, 38, 2, 103, 245, 127, 47, 47}, 94},
	{{179, 129, 186, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 143, 209}, 94},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 217, 114, 148, 136}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 54, 82, 196, 144, 229, 161}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 242}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 52}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 78, 86, 225, 133}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 69, 93, 51}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 56, 139, 170, 195, 169}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 219, 98}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 57, 80}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 169, 194, 13, 121, 172}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 1, 54}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 93, 202, 178, 174}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 18, 112, 93, 60}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 211, 199, 151, 124, 187, 183}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 99, 109, 0, 73, 213, 222}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 34, 223}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 220, 186, 219, 180, 3}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 24, 152, 172, 6, 55}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 227, 117}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 185, 24, 56}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 250, 73, 186, 231}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 184}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 80, 166, 196, 100, 87, 84}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 117, 183, 163, 7, 188, 90}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 20, 251, 68, 140}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 100, 10}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 66, 38, 201, 207, 48, 143}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 234, 7, 230, 219, 155, 117}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 168}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 108, 114, 151, 57, 98}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 20, 122, 46}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 82, 207}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 62, 132}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 19, 247}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 213, 7, 217, 8, 212, 5}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 39, 224, 212, 24, 116}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 178, 215, 195, 205, 136}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 83, 211, 101}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 139, 198, 83, 208, 113, 24}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 122, 186, 137, 161}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 189, 112, 140, 85, 246}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 110, 54, 163, 24, 60, 66}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 231, 86}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 7}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 201, 180, 239, 38, 186}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 107, 185, 124, 165, 210, 87}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 251}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 18, 242, 147, 232, 231}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 11, 62, 143, 14, 109}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 212, 41, 94}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 95}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 54, 101, 231, 34}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 94, 107}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 237, 74, 177, 27, 87, 70}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 19}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 18}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 43, 75, 61, 100, 6}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 175, 220}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 153, 87, 23, 58}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 160, 138}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 251, 5, 150}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 224, 225, 30, 126, 230}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 143, 170, 215, 83, 107, 92, 104}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 78, 48, 16, 220, 253, 193}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 123}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 196, 49, 136}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 22, 16}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 123, 234, 39, 228, 170}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 248, 43, 148, 246, 129}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 204, 46, 176, 82}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 244, 59, 115, 195, 25}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 242, 179, 129, 31}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 152, 4, 55, 11, 115}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 22, 177}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 195, 156, 243}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 47, 195, 86}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 6, 209, 190, 156}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 251, 234, 229, 171, 133, 43}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 13, 221, 177, 249, 39}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 97, 28, 34, 149, 10, 236}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 151, 32}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 7, 249, 165, 238, 7}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 186, 145, 58}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 0, 0, 170, 169}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 14, 253, 100, 141, 129}, 190},
	{{17, 179, 217, 188, 128, 212, 4, 4, 152, 0, 0, 0, 108, 209, 127, 142}, 190},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 90, 51, 212, 109, 52, 205, 77}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 254, 253, 140, 94}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 222, 206, 46, 43, 10}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 93}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 48, 6, 151, 70}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 233, 232, 248, 237, 153, 45, 92}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 174, 156, 239, 77, 0}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 244, 178, 149, 85, 89, 34}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 109, 159, 42, 88, 98, 5, 80}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 194, 95, 127, 243, 230, 53}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 177, 189}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 155, 238, 173, 239, 143, 245}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 76, 88, 74, 135, 109, 108, 158, 70}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 18, 49, 158, 24, 230}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 239, 72, 245, 175, 182, 208, 73}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 22}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 78, 24, 8, 5, 90}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 16, 233, 205}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 44, 167, 231, 147, 83}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 8, 17}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 200}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 79, 60, 202, 247, 65, 16, 109, 253}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 213, 124, 10}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 100, 100, 26}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 113, 39, 209, 161, 58}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 150, 3, 209, 85}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 83, 49, 54, 85}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 87, 205, 144, 167, 254}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 89}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 59, 132, 150, 247}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 28, 199, 5}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 185, 233, 2, 173}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 73, 99, 44, 169, 129, 255}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 35, 220, 194, 16}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 219, 168, 113}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 249, 97}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 51, 7, 60, 203}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 175, 49}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 198}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 68, 234, 156, 201, 8, 184, 241}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 1, 14, 193, 241, 224, 157, 213}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 80, 18, 254}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 81, 79, 129}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 229}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 37, 23, 233, 45}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 185, 125, 160, 20, 63}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 168, 51, 133, 241, 195, 151}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 27, 187, 193, 2}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 223, 220, 64, 145, 168, 121}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 165, 184, 7, 178, 210, 44}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 193, 108, 113, 98, 15, 162, 127}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 90, 243, 102, 37, 23, 161}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 18, 163, 82, 38, 116, 5, 72}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 120, 225, 80, 121, 39, 56, 238, 254}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 162, 197, 168, 187, 177, 244, 245, 150}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 133, 39, 224, 70}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 193, 170, 201, 227, 192, 73}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 2, 172, 203, 244, 172, 48}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 6, 115, 76, 68, 248, 230, 177}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 28, 119, 106}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 244}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 169, 228, 239, 15, 233}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 226, 92, 80, 99, 241, 68}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 193}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 227, 106, 96}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 229, 152, 125, 65, 37, 193}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 153, 107}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 168, 158, 133, 237}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 95, 118, 116, 157, 23}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 116, 166, 54, 214, 114, 22}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 236}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 236, 29, 238, 241, 92, 85}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 85, 246, 251, 126, 197, 191, 196}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 92, 233, 51, 213}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 129, 24, 252, 127}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 129}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 16, 41, 254}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 49, 215, 178}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 0, 229}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 88, 27, 150, 148, 148, 180, 97}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 241, 106, 6, 7, 71}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 72, 248}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 254, 164, 31, 134}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 150, 30, 111, 232}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 0, 0, 223, 217}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 69, 204, 49, 152, 110, 16, 87}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 135, 111, 37, 4}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 150, 128, 208, 33}, 238},
	{{132, 63, 74, 89, 209, 64, 63, 192, 0, 0, 0, 0, 65, 16, 19, 39}, 238},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 108, 244}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 44, 19, 49, 124, 28, 6, 181, 52, 124}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 48, 206, 194, 21, 181}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 237}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 122, 47, 196, 22, 133, 93, 120, 71}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 118, 149, 241, 145, 52}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 71, 124, 173, 151}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 156, 212, 85, 201, 54, 157, 208, 207, 72}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 227, 199}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 135, 240, 24, 154, 249, 251, 49, 123}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 79, 199, 63, 16, 226}, 20},
	{{16, 50, 248, 88, 0, 102, 65, 55, 183, 56, 110, 197, 113, 74, 200, 59}, 20},
	{{16, 50, 248, 88, 0, 0, 70, 130, 240, 94, 104, 211, 138, 103, 190, 85}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 254, 113, 144, 106, 74, 222, 155, 62}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 94, 191, 83, 131, 83, 246, 122, 254, 57}, 20},
	{{16, 50, 248, 88, 0, 0, 103, 114, 16, 29, 131, 21, 253, 251, 118, 33}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 206, 11, 31, 79, 174, 235, 137}, 20},
	{{16, 50, 248, 88, 0, 0, 249, 241, 106, 166, 200, 107, 208, 246, 222, 73}, 20},
	{{16, 50, 248, 88, 0, 0, 86, 99, 251, 194, 83, 106, 154, 192, 186, 53}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 8, 226, 70, 74, 114}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 42, 129}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 204, 169}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 112, 119, 85, 223}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 95, 34}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 235, 160}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 162, 67, 67, 74, 129}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 25, 197, 69, 96}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 68}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 20},
	{{16, 50, 248, 88, 61, 0, 161, 204, 96, 231, 190, 28, 35, 58, 56, 12}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 28, 0, 130, 1}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 164, 119, 86, 188, 236, 249, 14, 207, 90}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 115, 72, 63, 58, 2, 185, 247}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 253, 53, 1, 96, 63, 169, 87}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 109, 212, 168, 46, 75}, 20},
	{{16, 50, 248, 88, 0, 154, 60, 36, 6, 16, 31, 194, 173, 101, 63, 73}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 129, 197, 245, 163}, 20},
	{{16, 50, 248, 88, 0, 62, 58, 113, 217, 59, 126, 160, 154, 226, 110, 239}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 127, 95, 81, 147, 22, 212}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 75, 30, 170, 156, 222, 118, 81, 238}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155}, 20},
	{{16, 50, 248, 88, 0, 38, 99, 165, 61, 251, 236, 19, 189, 9, 186, 52}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 51, 107}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 240, 189, 184, 188, 209, 204}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 232, 27, 61, 64, 6, 255, 186}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 35, 58, 133, 87, 15, 200, 122, 49}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 157, 223, 221, 210, 206, 112, 84}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 107, 186, 40, 79, 26, 37, 74, 107, 180}, 20},
	{{16, 50, 248, 88, 0, 225, 128, 134, 118, 76, 2, 42, 53, 132, 6, 165}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 205, 78, 18, 116, 127, 112, 228}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 254, 232, 55, 146, 31, 170}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 221, 5, 233, 194, 109, 147, 159}, 20},
	{{16, 50, 248, 88, 0, 0, 36, 107, 45, 164, 166, 175, 85, 179, 232, 108}, 20},
	{{16, 50, 248, 88, 0, 0, 24, 159, 221, 235, 35, 179, 179, 53, 65, 31}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 45, 237, 108, 221, 217, 149}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 180, 137, 118, 205}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 30, 58, 108, 72}, 20},
	{{16, 50, 248, 88, 0, 0, 87, 252, 208, 207, 165, 249, 27, 246, 78, 122}, 20},
	{{16, 50, 248, 88, 0, 123, 46, 157, 32, 255, 89, 91, 19, 39, 23, 57}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 115, 42, 56, 240}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 66, 125, 181, 160, 155}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 77, 154, 223, 93}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 135, 234, 16, 135, 229, 145, 247, 113, 207}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 124, 47, 119, 137, 2, 24, 119, 77}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 125, 31, 134, 68, 22}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 165, 14}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 101}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 148, 67, 190, 133}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 134, 6, 227, 147, 243}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 211, 127, 209, 247, 22, 51, 103}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 136, 171, 80, 180, 12}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 20},
	{{16, 50, 248, 88, 0, 0, 138, 64, 98, 121, 53, 74, 184, 20, 240, 191}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 32, 101, 245, 88, 42, 120}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 125, 162, 236, 183}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 200, 78, 252, 20, 15, 203, 88, 251, 101}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 3, 101, 222, 148, 154, 147}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 137, 229}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 247, 5, 163, 154, 168}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 94, 170, 245, 147, 245, 74, 163}, 20},
	{{16, 50, 248, 88, 0, 0, 132, 157, 195, 221, 193, 138, 28, 201, 88, 48}, 20},
	{{16, 50, 248, 88, 0, 185, 110, 185, 174, 204, 240, 12, 174, 7, 12, 102}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 46, 44, 213, 97, 60}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 47, 171}, 20},
	{{16, 50, 248, 88, 0, 0, 0, 0, 0, 0, 0, 189, 221, 43, 121, 174}, 20},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 205, 167}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 39, 25, 82, 224}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 227, 224}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 166, 0, 242, 143, 242, 241}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 45, 118, 227, 129, 30, 82}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 250}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 181, 115, 119}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 228, 88, 85}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 67, 98, 196, 129}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 98, 77, 152}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 110, 25, 98, 15, 45, 7, 214, 200}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 53, 195, 206}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 208, 116, 64, 233, 61, 162}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 210, 91}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 148, 111, 101, 2, 41, 1, 67, 255}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 207}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 87, 227}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 170, 144, 217, 73, 140, 33, 238, 151, 83}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 237, 239, 230, 179}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 188}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 111, 108, 135}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 122, 2, 160, 83}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 12, 254, 211, 57, 189, 90}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 180, 72, 213}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 75, 191, 183, 102, 33, 47, 235}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 38, 132, 71, 188}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 129, 239, 157, 125, 93, 207, 208}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 202, 249}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 61, 239}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 20, 2, 107, 58, 70, 189, 225, 139}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 81}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 84, 49, 94, 109, 87, 141, 54, 23}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 60, 68, 131, 225}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 143, 253, 248, 104, 183, 23, 159, 210, 86}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 226, 153, 211, 67}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 186, 141, 58, 197, 106, 96}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 240, 122, 33, 144, 94, 124}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 132, 220}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 207, 2, 174, 180}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 58, 249}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 240, 199, 51, 53, 217, 242, 121}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 20, 48, 143, 181, 65, 43}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 135, 100, 134, 158, 219}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 187, 127, 144, 59, 196}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 98, 250, 237}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 218, 231}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 253, 204, 103, 157, 24, 224, 152, 142}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 191, 5}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 56, 27, 241, 167, 171, 205, 106, 227, 29}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 83, 182, 70, 166, 46}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 145, 9, 192}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 84, 207, 154}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 211, 158, 51, 16, 7, 185}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 42, 60, 247}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 92, 106, 76}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 27, 149, 125}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 52, 109}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 225, 86}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 205, 191, 137, 181, 208, 94, 117}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 200, 232}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 225, 215, 38}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 38, 231, 57, 39, 212, 40, 189, 26}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 129, 116, 192, 110, 91, 10, 82}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 53, 119, 203}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 218, 6}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 69}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 141, 116, 123, 242, 229}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 98, 82, 195}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 17, 166, 85, 235, 171, 178}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 127, 137, 212}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 149, 126, 14}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 96, 177, 136, 160, 135}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 219, 8, 153}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 101, 67, 208}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 36, 167, 11, 88, 28, 182, 127, 249, 149}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 22, 35, 189, 143, 227, 229}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 199, 80, 215, 246}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 15, 244}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 83, 127, 105, 9}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 45, 244, 160}, 84},
	{{189, 96, 58, 53, 191, 235, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 216, 70, 85}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 56, 131, 201, 68, 77}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 45, 101, 92, 224, 46, 40, 176, 110}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 180, 148, 51, 1, 53, 56, 84, 139}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 38, 252, 232, 112, 76, 50, 160, 236}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 138, 241, 71, 205, 173, 233, 64}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 120, 165}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 132, 100, 236, 72}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 55, 119, 3, 12, 3, 212, 93, 200}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 51, 104, 110, 82, 115, 112}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 49, 180, 121, 185, 67, 21, 97, 225, 82}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 242, 84, 122, 38, 90}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 134, 98, 113, 177, 21, 96, 45}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 78, 5, 148, 178, 57}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 29, 232}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 57, 3, 117, 105, 87}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 166, 120, 41}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 226, 168, 167}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 225, 92, 93, 238, 198}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 115, 232, 179, 127, 157, 40, 111}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 6, 47, 9, 83, 168}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 119, 238, 157, 15, 137, 91}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 101, 218}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 28, 215}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 187, 127, 197, 230, 167, 100, 213, 162, 17}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 1, 52}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 250, 150, 194, 194, 191, 76, 139}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 158, 98, 40, 9, 56, 254, 104, 221, 131}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 110, 210, 90, 211, 35, 227, 243, 145}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 16, 246, 22, 179, 129}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 103, 132, 45, 155, 245}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 235, 23, 19, 188, 171, 14, 142}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 67, 16}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 169, 15, 222}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 103, 37, 231, 232, 70, 255, 140, 234}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 44, 125, 139, 198}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 127, 113, 9, 7, 41, 200, 59, 177, 155}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 144, 215, 17, 238, 239, 10, 220, 131, 79}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 231, 108, 14}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 74, 108, 32, 82, 30}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 206, 20}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 236, 186, 216, 5, 174}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 241, 205, 34}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 177, 153, 93, 136, 144, 4, 66, 22}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 215, 217, 242, 32}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 212, 129, 76, 70, 170}, 108},
	{{111, 98, 6, 65, 35, 192, 120, 167, 94, 39, 119, 85, 7, 105, 87, 75}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 91, 33, 121, 226, 14}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 30, 51, 246}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 163, 233, 138, 55}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 123, 46}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 135, 171, 164, 50, 182, 254, 86}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 198, 175, 138, 162, 180, 147, 151, 72}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 88, 212}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 93, 63, 165, 240, 143}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 222, 58, 81}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 85, 9, 45, 132, 58}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 188, 134}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 109, 55, 31}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 226, 5, 201, 111, 118, 22, 9, 76}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 84, 65, 233}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 3, 36, 1, 176}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 108, 50}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 20, 85, 4, 39}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 209, 50, 225, 198}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 237, 16}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 227, 33}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 141, 155, 129, 10, 11, 49, 95}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 45, 197}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 90, 142, 12, 71, 220, 152}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 194, 87, 111, 21, 110, 241}, 108},
	{{111, 98, 6, 65, 35, 192, 146, 82, 110, 163, 221, 103, 73, 130, 245, 241}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 203, 237}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 158, 118}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 17, 251, 83, 73}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 195, 10, 102, 27, 230, 217}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 13, 225, 63, 130, 130, 174, 69, 86, 228}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 0, 69, 18}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 72, 15, 210, 73, 175, 240, 25, 47, 237}, 108},
	{{111, 98, 6, 65, 35, 192, 89, 49, 220, 236, 72, 3, 167, 83, 137, 101}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 0, 48, 198, 12}, 108},
	{{111, 98, 6, 65, 35, 192, 199, 31, 92, 231, 35, 204, 58, 53, 190, 219}, 108},
	{{111, 98, 6, 65, 35, 192, 0, 0, 0, 0, 0, 0, 98, 170, 100, 84}, 108},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 87, 120, 48}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 197, 217}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 98}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 127, 130, 95}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 224, 69, 26, 136}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 13, 63, 37}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 82}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 18, 123}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 159, 46}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 253}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 5, 154, 89}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 25, 198, 242}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 19, 9, 67, 223}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 97, 2}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 220, 246, 228, 78}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 186, 24}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 106}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 248}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 181, 171}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 79, 68}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 80, 246}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 64, 221, 174, 183}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 193}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 133, 19}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 161, 82}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 172}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 146, 177, 81, 116}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 35, 3, 40}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 200, 27}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 105, 192, 241}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 236, 251}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 95, 150, 117}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 233, 219, 52, 160}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 154, 55}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 153, 78, 143, 207}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 2, 59, 160}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 12, 129, 53, 87}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 193, 54, 220}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 189, 187, 233, 92}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 153}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 99}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 113}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 11, 183, 145, 210}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 115, 23}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 74, 210, 70, 193}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 89, 42, 62}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 138, 167, 175}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 141}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 109}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 163}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 202}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 65, 49}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 101, 147, 254}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 146}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 94, 92}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 243}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 237, 147, 53}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 198, 227, 197, 208}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 176, 206, 18, 244}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 143, 39, 137}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 141}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 107, 228}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 107, 29, 231, 57}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 50, 175}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 134}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 123, 26}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 149, 157, 18, 46}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 187, 41, 36}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 166}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 108}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 12, 109}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 0, 0, 0, 0}, 136},
	{{118, 223, 83, 220, 110, 122, 23, 112, 185, 155, 73, 0, 30, 240, 167, 56}, 136},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 217}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 223, 113, 237}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 67, 96, 73, 52}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 245, 194}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 255, 99, 110, 102}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 18}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 41, 5, 192}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 214, 45, 18}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 130, 186, 216}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 55}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 186, 213}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 95}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 64, 226, 251}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 110, 128}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 223, 106}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 161, 203, 234}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 107}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 182, 118, 162}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 203, 236, 8, 108}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 13}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 142}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 137}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 165, 179, 151}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 119, 22, 193}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 74, 9, 54}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 129, 247, 215}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 101, 106}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 203}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 149, 150}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 148}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 173, 8}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 30, 24, 102}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 227, 5, 37}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 141}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 179, 165}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 125}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 245, 66, 231}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 31, 30, 167, 88}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 46, 197}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 94}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 209}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 190}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 11, 255, 7, 105}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 244}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 242, 159, 59}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 55, 224, 91, 106}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 220, 242, 77}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 74}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 13, 167, 72, 254}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 202, 145, 79}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 119}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 129, 185}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 228, 202, 128}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 106, 123, 231, 4}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 10, 143}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 207}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 93, 59}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 99, 41, 121}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 30}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 122, 157}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 177, 54, 161, 190}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 223}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 135, 45, 90, 158}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 167}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 49}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 13}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 212, 129}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 101, 236, 57}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 7, 32, 242}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 86, 9, 105, 138}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 173}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 0}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 0, 44}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 26, 13}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 55, 143}, 196},
	{{173, 191, 150, 197, 204, 35, 169, 79, 31, 214, 251, 240, 0, 0, 77, 240}, 196},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 237, 255, 159, 117}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 252, 72, 216, 65, 15, 33, 49}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 139, 238, 78, 246, 6, 80, 15, 68, 189}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 175, 219, 235, 159, 60, 217, 65, 252}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 32, 60}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74}, 67},
	{{26, 76, 129, 48, 0, 0, 244, 21, 214, 149, 207, 197, 65, 19, 143, 184}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 198, 20}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 225}, 67},
	{{26, 76, 129, 48, 0, 0, 92, 134, 99, 254, 25, 171, 125, 3, 143, 133}, 67},
	{{26, 76, 129, 48, 0, 0, 109, 176, 33, 95, 138, 168, 88, 144, 150, 22}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 190, 173}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 181, 123, 213, 221, 39}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 49}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 201, 62, 193, 155, 162, 95, 252, 248}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 253, 93, 213, 122, 29, 203, 158, 229}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 214, 12}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 30, 166}, 67},
	{{26, 76, 129, 48, 0, 0, 110, 225, 2, 210, 50, 72, 212, 225, 48, 155}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 154, 96, 124, 138, 47, 55, 153, 191, 122}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 187, 175}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 143}, 67},
	{{26, 76, 129, 48, 0, 132, 130, 147, 50, 33, 76, 103, 10, 133, 60, 15}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 132, 50}, 67},
	{{26, 76, 129, 48, 0, 27, 180, 5, 95, 37, 88, 1, 66, 50, 30, 74}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 88, 98, 183, 179}, 67},
	{{26, 76, 129, 48, 0, 221, 158, 150, 146, 138, 216, 193, 230, 250, 80, 114}, 67},
	{{26, 76, 129, 48, 0, 95, 139, 33, 247, 104, 248, 124, 217, 210, 14, 81}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 11, 135, 103, 145, 31}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 102, 139}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 145, 17, 226, 106, 0, 190, 19, 181}, 67},
	{{26, 76, 129, 48, 0, 123, 122, 51, 131, 226, 139, 122, 142, 82, 122, 41}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 163, 121, 171, 126, 101, 157, 192}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 36, 58, 223, 141}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 84, 101, 254, 136, 105}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 11, 142, 137, 107, 48, 116}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 4, 53}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 196, 244, 90, 147, 48, 217, 11}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 73, 35, 59, 132, 253, 35, 56}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 232, 220, 189, 160, 137, 127, 182, 105}, 67},
	{{26, 76, 129, 48, 71, 223, 232, 25, 245, 209, 156, 170, 248, 230, 135, 9}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 126, 32, 63, 175}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 199, 68, 125, 204, 101, 43, 186, 142, 6}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 237, 246, 164, 224, 141, 94, 46}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 100}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 101, 195, 198, 160, 181, 163, 250, 100}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 220, 35}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 67},
	{{26, 76, 129, 48, 0, 77, 234, 134, 176, 134, 66, 12, 172, 116, 138, 134}, 67},
	{{26, 76, 129, 48, 0, 0, 239, 76, 88, 241, 135, 36, 48, 131, 144, 251}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 167}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 23, 100, 11, 234, 41, 129}, 67},
	{{26, 76, 129, 48, 0, 4, 58, 155, 26, 75, 32, 56, 110, 169, 157, 242}, 67},
	{{26, 76, 129, 48, 0, 0, 251, 90, 161, 168, 39, 63, 247, 229, 236, 12}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 123, 85, 19, 176, 89, 253, 244}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 120, 122, 66, 219, 228, 212, 201, 84}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 24, 83, 158, 138, 156, 26, 225}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 122, 191, 169, 55, 46}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 199, 171, 134, 10, 104, 228, 197, 137, 155}, 67},
	{{26, 76, 129, 48, 0, 0, 202, 129, 1, 138, 192, 248, 251, 114, 138, 1}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 204}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 168, 162}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 75, 247, 75, 211, 210, 150, 137, 181}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 64, 126, 205, 153, 249, 141, 205, 100}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153}, 67},
	{{26, 76, 129, 48, 68, 52, 12, 9, 73, 252, 237, 79, 191, 232, 233, 134}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 176, 98, 145, 129, 53, 34, 192}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 12, 138, 181, 244, 142, 24, 127, 150, 137}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 82, 241}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 141, 183, 185, 13}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 52, 214, 129, 130, 169, 16, 223, 44, 80}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 71, 2, 14, 247}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 63}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 181, 171, 72, 129, 198, 102, 56}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 79, 143, 213, 47, 1, 5, 187}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 207, 153}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 53, 167}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 186}, 67},
	{{26, 76, 129, 48, 0, 0, 109, 184, 68, 108, 227, 48, 55, 152, 30, 152}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 127, 139}, 67},
	{{26, 76, 129, 48, 180, 253, 179, 231, 157, 223, 80, 128, 20, 158, 47, 72}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 30, 109, 26, 5, 3, 193, 86}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 77, 95, 161, 235, 105, 192, 219, 147, 95}, 67},
	{{26, 76, 129, 48, 124, 206, 202, 183, 160, 230, 148, 229, 64, 178, 62, 202}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 220, 99}, 67},
	{{26, 76, 129, 48, 0, 0, 15, 122, 18, 51, 61, 14, 193, 160, 12, 227}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 192}, 67},
	{{26, 76, 129, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 198, 38}, 67},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 146, 146, 56, 2, 54, 13, 25}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 47, 58, 83, 63, 24, 224}, 104},
	{{231, 96, 0, 0, 0, 37, 68, 129, 10, 206, 22, 213, 57, 207, 62, 195}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 104},
	{{231, 96, 0, 0, 0, 0, 10, 240, 176, 45, 69, 52, 213, 162, 129, 154}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 124, 19, 159}, 104},
	{{231, 96, 0, 0, 170, 106, 13, 237, 156, 240, 54, 235, 14, 22, 172, 244}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 52, 157, 212, 210}, 104},
	{{231, 96, 0, 68, 19, 117, 190, 31, 157, 106, 86, 47, 143, 187, 143, 237}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 29}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 244, 199, 86, 153, 190, 144, 122, 161, 116}, 104},
	{{231, 96, 0, 68, 14, 223, 56, 77, 189, 52, 225, 108, 113, 55, 116, 53}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 246, 19, 236, 75, 126, 218, 254, 30}, 104},
	{{231, 96, 0, 82, 62, 217, 47, 93, 40, 46, 45, 110, 164, 209, 32, 167}, 104},
	{{231, 96, 144, 84, 202, 100, 223, 216, 8, 157, 151, 142, 195, 157, 44, 248}, 104},
	{{231, 96, 0, 127, 67, 228, 105, 190, 30, 106, 136, 19, 164, 3, 56, 48}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 66, 37, 80, 76}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{231, 96, 0, 0, 98, 250, 160, 153, 95, 178, 192, 215, 107, 233, 14, 197}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 188, 72, 253, 53}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 136, 177, 89, 140}, 104},
	{{231, 96, 0, 0, 0, 164, 205, 46, 127, 203, 36, 240, 104, 90, 33, 240}, 104},
	{{231, 96, 0, 0, 136, 129, 149, 116, 182, 156, 218, 187, 49, 253, 15, 97}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 142, 152, 38}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 150, 137, 177}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 104, 82, 33, 13, 111, 147, 219, 4}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 66, 77, 219, 239, 191, 105, 18, 173, 204}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 216, 57, 181, 151, 96, 180, 246}, 104},
	{{231, 96, 0, 0, 0, 0, 157, 75, 142, 6, 21, 51, 25, 211, 163, 93}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 56, 73, 49, 35, 57, 182}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 151, 31, 75, 57, 220, 252, 202, 230}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 90, 127, 81, 65, 243, 126, 233, 162, 123}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 175, 207}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 161, 165, 10, 42, 6, 180, 55}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 125, 64, 233, 86, 168, 138, 152, 24}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 249, 113, 137, 241, 230, 244, 49, 55}, 104},
	{{231, 96, 0, 0, 180, 63, 97, 118, 120, 80, 191, 67, 227, 173, 8, 23}, 104},
	{{231, 96, 0, 0, 0, 0, 121, 110, 137, 125, 42, 45, 71, 236, 195, 118}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 176}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 201}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 3, 193}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 210, 156, 97}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 251, 243}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 232, 111}, 104},
	{{231, 96, 0, 0, 110, 46, 87, 178, 58, 113, 14, 190, 209, 65, 17, 199}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 50, 148, 173, 41}, 104},
	{{231, 96, 0, 0, 78, 80, 35, 107, 65, 182, 83, 120, 54, 162, 37, 121}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 76, 239, 197, 112, 118, 111}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 41, 71, 157, 134, 2, 226, 101, 2, 9}, 104},
	{{231, 96, 0, 0, 17, 153, 237, 129, 67, 33, 136, 155, 47, 128, 188, 139}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 89, 50}, 104},
	{{231, 96, 0, 0, 0, 213, 229, 211, 199, 173, 60, 218, 178, 65, 65, 251}, 104},
	{{231, 96, 35, 145, 215, 24, 205, 24, 197, 156, 112, 187, 171, 204, 49, 213}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 210, 69, 165, 249, 204, 221}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 5, 94, 24, 140, 61, 142, 79, 229}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 250, 154, 146, 169, 111, 223, 198}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 252, 62, 41, 17, 230, 67, 125, 49}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 168, 236, 141, 182, 11, 181, 88}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 68, 186, 156, 244}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 171, 196, 49, 225, 171, 90, 229, 57, 229}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 56, 49, 214, 156, 147, 192, 80, 171, 194}, 104},
	{{231, 96, 0, 0, 221, 49, 117, 212, 243, 156, 86, 3, 17, 248, 117, 249}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 239, 15, 223, 22}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{231, 96, 0, 0, 0, 0, 107, 83, 46, 216, 157, 255, 80, 119, 25, 175}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 8, 214, 7, 41, 34, 254}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 16, 210, 173, 131, 106, 5, 247, 124}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 49, 155, 84}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 16, 86, 255}, 104},
	{{231, 96, 0, 0, 189, 26, 108, 107, 208, 152, 113, 11, 5, 68, 158, 98}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 250, 95, 83, 166, 119, 221}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 164, 53}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 50, 128}, 104},
	{{231, 96, 0, 0, 0, 227, 115, 182, 254, 204, 64, 143, 146, 216, 43, 129}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 5, 121, 246, 88, 24, 92}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 178, 39, 244, 120, 91, 50, 28, 15, 202}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 125, 4, 170, 156}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 187}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 75}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 107, 102, 188, 221, 128, 111, 236, 202, 7}, 104},
	{{231, 96, 0, 0, 0, 0, 61, 195, 150, 236, 204, 104, 46, 126, 144, 52}, 104},
	{{231, 96, 0, 254, 150, 207, 225, 16, 186, 55, 48, 209, 175, 193, 135, 140}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 91, 225, 186, 242, 231, 82, 140, 72, 34}, 104},
	{{231, 96, 0, 0, 0, 0, 246, 20, 222, 237, 101, 233, 125, 156, 33, 130}, 104},
	{{231, 96, 0, 0, 198, 185, 116, 207, 160, 152, 105, 94, 221, 9, 213, 197}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 12, 167, 83, 193, 153, 59, 20}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 104},
	{{231, 96, 0, 0, 0, 0, 0, 0, 0, 0, 254, 22, 95, 127, 116, 187}, 104},
	{{93, 172, 223, 252, 203, 0, 206, 0, 243, 148, 90, 38, 30, 244, 110, 162}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 92, 6, 189, 251, 230, 42, 194}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 219, 177, 218, 169, 66, 227, 240, 39}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 177, 68}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 57}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 193, 204, 234, 77}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 249, 174, 122, 18, 142, 120, 155}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 116, 145, 135, 53, 79}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 183, 55, 113, 191, 116, 111, 129}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 53, 136, 208}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 149, 165, 177, 39, 51, 106, 67, 220}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 150, 103, 114, 113, 54, 136}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 101, 140, 65, 47, 164}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 149, 156}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 76, 9, 28, 43, 80, 129}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 168, 187, 45, 219, 169, 247}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 140, 215, 181, 185, 206, 80, 191, 15}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 18, 162, 246, 60, 128, 146, 146, 2}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 143, 204}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 65, 227, 83}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 117, 216, 233}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 12, 135, 67, 195, 113}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 124, 74, 60, 60}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 189, 87, 70, 32, 42}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 104, 37, 20, 189, 12, 27, 255}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 213, 57, 87, 86, 173, 93, 108, 94}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 201}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 104, 236, 9, 127, 243, 222, 201}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 183, 181, 158, 172}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 80, 11, 138}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 254, 111, 26}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 80, 223, 113}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 211, 170, 228, 180, 209}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 191, 214, 178, 97, 129}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 16, 104, 205, 59, 23, 178}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 150, 67, 156, 3}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 147, 0, 244, 22}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 53, 188, 212, 122}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 188, 108}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 186, 226}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 218, 24, 232, 180, 97}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 124, 232, 62, 139, 245, 229, 28}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 35, 148, 152, 192, 154}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 76, 245, 98, 234, 242, 16}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 133, 49, 223, 150, 44, 113, 51}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 223, 17, 67}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 70, 72, 225, 76, 240, 191, 41}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 77, 176}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 3, 85, 128, 176, 137, 0, 203, 67}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 205, 52}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 61, 64, 41, 202, 228, 198}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 253, 138, 29, 103, 76, 11}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 167, 218, 181, 195, 44, 33}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 154, 1, 209, 96, 244, 54}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 64, 30, 102, 142, 148, 73}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 199, 163, 187, 144}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 240, 172}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 187, 115}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 36, 118, 193, 222, 157, 32}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 44, 131, 45, 191, 114}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 250}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 93, 130, 16}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 104, 95, 175, 246, 74, 25}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 147, 243, 145, 253, 232, 174}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 169, 242, 11, 32, 252, 94, 227}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 202, 141, 156}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 70, 166, 67, 11, 150, 44, 61, 45, 164}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 255, 73, 83, 170, 4}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 150, 139, 176, 220, 81, 249, 75}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 128, 142, 14, 0, 37, 181}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 118, 249, 195, 225, 94, 243, 225, 232}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 111, 81, 20, 170, 57}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 135, 231, 53, 64}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 136, 191, 254, 147}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 100, 44}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 27, 232, 108, 50, 161, 101, 14}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 17, 117, 118}, 15},
	{{93, 172, 223, 252, 203, 0, 206, 0, 0, 0, 0, 0, 0, 0, 173, 97}, 15},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{53, 142, 203, 124, 104, 51, 241, 12, 161, 17, 101, 245, 120, 110, 192, 199}, 237},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 140}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 143}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 109}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 246}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 241}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 238}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 8}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 79}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 130}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 221}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 106}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 129}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 168}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 31}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 122}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 43}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 226}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 16}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 110}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 165}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 157}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 218}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 104}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 73}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 223}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 183}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 66}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 1}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{9, 77, 120, 197, 193, 10, 237, 174, 233, 2, 165, 11, 229, 47, 144, 0}, 224},
	{{99, 161, 189, 88, 48, 0, 0, 242, 49, 217, 144, 171, 81, 51, 214, 247}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 238, 74, 64, 167, 133, 177, 66, 229}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 160, 231, 245, 84, 187, 147, 118, 106}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{99, 161, 189, 88, 48, 0, 39, 206, 9, 114, 192, 101, 82, 46, 204, 232}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 79, 146, 209, 32}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 231, 113, 155, 120, 42, 130, 222}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 167, 94, 204}, 179},
	{{99, 161, 189, 88, 48, 39, 104, 159, 15, 152, 244, 86, 239, 237, 6, 242}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 223, 186, 66, 18, 117, 225}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 142, 203, 190, 102, 86, 209}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 215, 69, 79, 56, 111}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 141}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 245, 127, 255, 248, 4}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 177, 70, 186, 87}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 187, 167, 145, 234, 38, 85, 180, 27}, 179},
	{{99, 161, 189, 88, 48, 0, 214, 71, 118, 29, 38, 197, 138, 12, 50, 242}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 113, 191, 153, 2, 54, 221, 127, 174}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 90, 88, 33, 113, 57, 65, 79, 23}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 69}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 132, 186, 242, 11, 229}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 102, 171, 127, 161, 226, 136}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 51, 62, 252, 13}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 235, 88, 94, 235, 131, 149, 16, 73}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{99, 161, 189, 88, 48, 0, 108, 235, 93, 152, 61, 170, 125, 168, 179, 126}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 242, 17, 240, 167, 242, 102, 141}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 203, 28, 53, 196, 182}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 71, 16, 136, 233, 83, 243, 211, 194, 128}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 117, 117, 58, 193, 39, 184, 114, 216}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 132, 81, 122, 237}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 3, 177, 55, 121, 28, 104, 191, 156, 72}, 179},
	{{99, 161, 189, 88, 48, 0, 165, 234, 55, 44, 148, 58, 3, 68, 167, 49}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 123, 69, 75, 164, 174, 49, 161, 220}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 8, 40, 253, 102, 224, 170, 97, 44}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 43, 204, 151, 4, 1, 106}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 234}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 127, 82, 231}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 28}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 20, 252, 137, 253, 2, 146, 193, 63, 175}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 92, 215, 95, 255}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 207, 54, 192, 193, 178}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 195, 172, 113, 154}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 38, 54, 105, 47}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 55}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 64, 47, 104, 67, 31}, 179},
	{{99, 161, 189, 88, 48, 25, 38, 85, 134, 43, 108, 207, 80, 186, 197, 110}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 107, 56, 137, 236}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 219, 21, 238, 225, 174, 105}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 243, 233, 195, 175}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{99, 161, 189, 88, 48, 13, 38, 74, 231, 219, 74, 232, 151, 156, 52, 100}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{99, 161, 189, 88, 48, 24, 235, 50, 202, 146, 16, 163, 1, 107, 37, 192}, 179},
	{{99, 161, 189, 88, 48, 0, 116, 107, 115, 58, 238, 26, 229, 33, 101, 54}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 96}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 62, 29, 115, 61, 171, 121, 135, 58, 3}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 178, 209, 105, 176, 194, 159, 170, 221}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 221}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 149, 65, 172, 153, 132, 169, 200, 38, 255}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 203, 103, 92}, 179},
	{{99, 161, 189, 88, 48, 0, 250, 212, 143, 253, 25, 129, 181, 63, 31, 245}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 147, 161, 248, 239}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 245}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 142, 193, 150, 145, 182}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 113, 212, 81, 98, 207}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 98, 152, 115, 0, 117, 52, 86, 48}, 179},
	{{99, 161, 189, 88, 48, 193, 1, 122, 86, 68, 67, 109, 84, 151, 71, 142}, 179},
	{{99, 161, 189, 88, 48, 62, 186, 221, 224, 71, 23, 135, 216, 239, 234, 146}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 230, 133, 58, 255, 60, 97, 64, 132, 78}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 229, 250, 2, 87, 246, 228, 50, 68}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 120, 129, 234, 10, 28, 220}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 126, 122, 139, 71, 109, 111}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 167, 245, 174, 109, 28}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 202, 245, 61}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 35, 66, 237, 76, 11}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 64, 207, 0, 66, 226, 119, 231, 19, 56}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 117, 239, 65, 214, 113, 172, 210, 208, 15}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 65, 96, 104}, 179},
	{{99, 161, 189, 88, 48, 0, 133, 7, 101, 27, 12, 181, 57, 18, 110, 156}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 60}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 50}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 185, 196, 189, 76, 216, 144}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 242, 204, 16, 158, 92}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 25, 155, 0, 28, 58, 198, 69}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 141, 60, 42}, 179},
	{{99, 161, 189, 88, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84}, 179},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 229, 123, 252, 187, 33, 163}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 132}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 83}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 187, 229}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 115, 147, 42, 133, 174, 222}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 172, 150}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 175}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 94, 165}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 231, 161, 197, 45, 130}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 18, 191, 161, 3, 17, 109, 224}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 202, 229, 21, 54, 177}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 212, 136, 13}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 111, 42, 148, 34, 74}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 197, 183, 165, 189, 74}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 92, 233, 212, 196, 214, 225}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 196, 83, 140}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 53, 224, 25}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 59, 228}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 10, 97, 152, 129, 42}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 238, 123, 99, 156, 80}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 205, 65, 209, 190}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 254, 37, 4}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 128, 150, 137, 40}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 123, 234, 7}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 89, 6}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 118, 73}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 49, 252, 167}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 195, 55, 14, 234, 143, 55}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 87}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 94, 175, 235, 101, 186}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 113, 27, 75, 190}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 30, 39, 25, 163, 197, 255, 117}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 45, 22, 229, 244, 18, 69}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 254, 162, 217}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 30, 216, 11}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 7, 132, 142, 177, 158, 165}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 117}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 149, 235, 67}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 17, 141, 48, 184, 220, 154}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 212, 173}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 255, 71, 46, 234, 63, 185}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 247, 192, 229}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 252}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 76, 165, 13, 65, 45}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 148, 88, 112, 162, 216, 252}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 110}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 36, 22, 82, 34, 128}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 175}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 35, 251, 172, 109, 69, 3}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 22, 84, 148, 161, 248, 126}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 220, 172, 135}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 251, 105}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 84}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 68, 71}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 105, 82, 197, 239, 102, 88}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 169, 109, 129}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 230, 63, 26, 182}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 159, 58, 151, 69}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 165, 144, 117, 104, 141}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 225, 153, 198}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 26, 47, 137}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 197, 182, 166, 141, 236}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 93}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 172, 92, 94}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 66, 34, 216, 224, 94, 170, 203}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 129, 68, 134}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 223, 11, 87, 144}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 100, 179, 187, 211, 99}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 195, 216, 103}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 226, 37, 73}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 221, 135}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 185, 24, 226}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 78, 112, 102, 161}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 252, 111, 246, 204}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 90, 238, 239}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 182, 250}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 107, 66}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 163, 242, 8, 75, 107, 229}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 158, 21, 180}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 161}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 124}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 176, 109}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 41, 236, 215, 84}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 135, 53}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 193, 155}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 136, 224, 61, 78, 116, 152, 181}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 201}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 206, 112, 210, 61, 46}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 237}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 0, 79, 151, 2}, 84},
	{{18, 8, 76, 66, 2, 185, 206, 132, 224, 0, 0, 0, 11, 92, 136, 160}, 84},
	{{169, 53, 32, 0, 109, 56, 125, 26, 38, 72, 195, 158, 220, 255, 197, 179}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 96}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 110, 11, 73, 171, 16}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 236, 241, 146, 254, 25, 132, 126, 42}, 65},
	{{169, 53, 32, 123, 55, 223, 140, 205, 106, 24, 74, 42, 255, 117, 206, 11}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 216}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 92}, 65},
	{{169, 53, 32, 0, 0, 0, 134, 144, 59, 127, 70, 105, 37, 89, 105, 131}, 65},
	{{169, 53, 32, 0, 183, 172, 113, 249, 246, 124, 10, 232, 145, 94, 155, 79}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 1, 91, 224, 36, 180, 75, 200}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 193, 102, 105}, 65},
	{{169, 53, 32, 0, 0, 0, 219, 108, 99, 59, 25, 228, 209, 205, 58, 213}, 65},
	{{169, 53, 32, 0, 0, 145, 67, 78, 238, 47, 61, 185, 156, 11, 195, 215}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 94, 90, 155, 98, 146, 87, 231, 1}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 250, 155, 147, 90, 206, 200, 241, 217}, 65},
	{{169, 53, 32, 0, 0, 0, 124, 148, 74, 162, 65, 183, 57, 129, 255, 161}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 50, 247, 135, 49, 92}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 78, 147}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{169, 53, 32, 0, 51, 115, 69, 24, 246, 245, 214, 235, 59, 67, 232, 96}, 65},
	{{169, 53, 32, 0, 0, 16, 143, 207, 87, 23, 115, 236, 175, 180, 237, 248}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 196, 224, 217, 47, 80, 48, 180, 188}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 9, 65, 206}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 41, 252, 78, 211, 11, 153}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 9, 20, 76, 98, 254, 203, 202}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 128, 132, 160, 95, 50, 157, 168, 120, 219}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 89, 38, 80, 199, 223}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 4, 91, 49, 67, 199, 113, 229, 118}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 62, 224, 216, 60, 155, 35}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 19, 16, 204, 120, 42, 249, 126}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 65},
	{{169, 53, 32, 0, 0, 167, 146, 121, 173, 220, 108, 153, 41, 253, 196, 29}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 70, 118, 44, 168, 32, 210}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 171, 247, 139, 20, 52}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 81, 68, 108, 227, 236, 129, 184, 104}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 93, 255, 97, 100, 239, 244, 89}, 65},
	{{169, 53, 32, 0, 0, 208, 15, 248, 147, 222, 33, 123, 74, 123, 175, 57}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 42, 225, 172, 83, 75, 180, 229, 84, 59}, 65},
	{{169, 53, 32, 0, 52, 117, 127, 243, 92, 106, 163, 6, 73, 165, 231, 120}, 65},
	{{169, 53, 32, 0, 0, 0, 174, 167, 112, 62, 229, 243, 82, 65, 72, 45}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{169, 53, 32, 0, 223, 54, 93, 137, 251, 186, 235, 18, 217, 166, 159, 235}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 73, 165, 88, 69, 65}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 144, 197}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 42, 247, 135, 17, 60}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 159, 29, 212, 204, 165, 185, 21, 190, 155}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 39, 8}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 156, 16, 64}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 134, 136, 78, 173, 144, 246, 15}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 181, 139, 57, 96, 122, 253}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 212, 29, 20, 203, 72, 253, 107}, 65},
	{{169, 53, 32, 0, 119, 124, 100, 130, 192, 116, 96, 72, 52, 59, 88, 135}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 191, 109, 146}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 132, 53, 96, 191, 124, 132, 109, 186, 35}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 19, 85, 14, 37, 78, 253, 23}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 54, 117, 203}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 122, 83, 29, 33, 154, 89}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 3, 119, 82, 239, 92, 5, 89}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 224, 91, 22}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 89, 198, 143, 226, 198}, 65},
	{{169, 53, 32, 0, 0, 0, 232, 54, 26, 55, 233, 177, 69, 9, 221, 86}, 65},
	{{169, 53, 32, 0, 254, 144, 250, 238, 27, 199, 188, 47, 18, 16, 111, 41}, 65},
	{{169, 53, 32, 85, 126, 8, 198, 119, 195, 55, 239, 31, 91, 79, 114, 168}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 44, 162}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 202, 44}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 65, 173, 141, 4, 53, 169, 15, 236}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 122, 248, 43, 149, 33, 31}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 168, 36}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 68, 106, 58, 63, 55}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 121, 33, 254, 157, 189, 12, 200, 27, 31}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 83, 213, 36, 212, 255}, 65},
	{{169, 53, 32, 0, 0, 0, 158, 88, 146, 110, 165, 144, 234, 146, 4, 113}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 11, 85, 84, 88, 22, 244, 27, 46}, 65},
	{{169, 53, 32, 0, 57, 121, 102, 156, 106, 113, 182, 155, 143, 175, 120, 237}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 83, 134, 6, 42, 71, 163, 61, 161}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 134, 137, 33, 84, 174, 162, 196}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 185, 249, 135, 56, 98, 42, 125, 36}, 65},
	{{169, 53, 32, 0, 0, 0, 247, 54, 64, 250, 173, 91, 102, 23, 87, 115}, 65},
	{{169, 53, 32, 0, 0, 0, 34, 100, 13, 147, 138, 105, 108, 219, 151, 57}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 232, 38, 93}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 25, 113, 78, 210, 225, 235, 213, 104}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 124, 255, 185, 186, 30, 247, 136}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 252, 164, 54, 182, 29, 142, 19}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 226}, 65},
	{{169, 53, 32, 0, 0, 0, 0, 199, 35, 181, 141, 2, 116, 41, 190, 79}, 65},
	{{169, 53, 32, 0, 117, 37, 127, 201, 116, 133, 175, 138, 222, 98, 213, 40}, 65},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 224},
	{{136, 0, 0, 0, 203, 122, 57, 113, 105, 31, 220, 236, 7, 36, 93, 96}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 76, 133, 219, 205, 46, 167, 25}, 224},
	{{136, 0, 53, 15, 24, 85, 63, 180, 187, 94, 228, 34, 106, 220, 61, 30}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 48, 59}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 250, 163, 158, 203, 95, 136, 52, 111, 235}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 55, 207, 138}, 224},
	{{136, 0, 18, 187, 215, 16, 72, 232, 141, 212, 214, 76, 192, 93, 119, 51}, 224},
	{{136, 0, 0, 0, 109, 149, 196, 43, 53, 62, 37, 209, 103, 236, 58, 214}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 116}, 224},
	{{136, 0, 0, 150, 183, 50, 99, 178, 70, 205, 74, 97, 185, 174, 150, 64}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 146, 93, 229, 246}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 31, 93, 139, 160}, 224},
	{{136, 0, 0, 0, 127, 192, 240, 228, 153, 210, 236, 220, 126, 52, 138, 24}, 224},
	{{136, 0, 0, 0, 0, 224, 60, 153, 96, 111, 7, 253, 134, 186, 75, 63}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 213, 92, 98, 55, 214, 98, 150, 147, 239}, 224},
	{{136, 37, 100, 4, 190, 227, 50, 210, 127, 118, 60, 203, 118, 81, 32, 203}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 135, 49}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 127, 171}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 73, 172, 237, 30}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 143}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 83, 177, 59}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 170, 109, 142, 38}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 59, 88, 57, 160, 193}, 224},
	{{136, 0, 0, 0, 0, 54, 76, 230, 147, 37, 81, 114, 249, 212, 51, 16}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 28}, 224},
	{{136, 0, 171, 11, 158, 142, 245, 138, 234, 117, 4, 244, 203, 177, 107, 109}, 224},
	{{136, 0, 31, 132, 61, 49, 87, 106, 243, 16, 219, 70, 89, 137, 119, 112}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 79, 92}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 244, 244, 19, 248}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 135}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 247, 14, 192, 156, 80, 157, 219, 64}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 118, 152, 254}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 185, 55, 7, 249, 202, 251, 179, 105}, 224},
	{{136, 0, 30, 9, 198, 66, 129, 172, 63, 233, 181, 160, 45, 132, 24, 92}, 224},
	{{136, 0, 0, 158, 17, 224, 67, 105, 122, 155, 117, 89, 77, 209, 230, 177}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 126}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 122, 185, 92, 84, 62, 1, 234, 175}, 224},
	{{136, 0, 0, 146, 189, 147, 15, 86, 183, 146, 50, 117, 130, 7, 194, 254}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 255, 60, 72}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 104, 107, 244, 138, 12, 78, 42, 103, 160}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 126, 215, 139}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 57, 51}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 243, 80}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 186}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 1, 233, 242, 71, 100, 0, 189, 208}, 224},
	{{136, 0, 0, 0, 0, 0, 158, 251, 176, 90, 144, 89, 112, 196, 49, 174}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168}, 224},
	{{136, 0, 0, 132, 20, 10, 163, 177, 67, 218, 61, 203, 96, 180, 58, 148}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 154, 227, 242, 77, 63, 40, 165}, 224},
	{{136, 0, 0, 213, 55, 3, 148, 114, 76, 27, 115, 0, 85, 21, 19, 115}, 224},
	{{136, 0, 0, 0, 195, 111, 234, 2, 67, 118, 30, 140, 234, 182, 250, 196}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 22, 109}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{136, 0, 0, 0, 0, 0, 173, 225, 183, 180, 230, 141, 34, 158, 59, 255}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 189, 227, 211, 177, 129, 142, 214, 208, 222}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 105, 41}, 224},
	{{136, 0, 161, 223, 255, 249, 149, 113, 33, 193, 62, 68, 10, 66, 22, 122}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 217, 183, 36, 188}, 224},
	{{136, 0, 0, 45, 81, 224, 75, 83, 136, 138, 218, 35, 8, 244, 133, 21}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 35, 255, 215, 4, 201, 67, 133, 252}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 83, 57, 176, 185, 206, 214, 137, 166, 72}, 224},
	{{136, 0, 0, 203, 248, 99, 10, 185, 227, 25, 49, 165, 123, 231, 157, 7}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{136, 0, 0, 0, 0, 0, 26, 235, 44, 1, 226, 165, 95, 132, 82, 225}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 202}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 185, 90, 136, 206}, 224},
	{{136, 0, 9, 144, 138, 31, 210, 1, 228, 218, 121, 20, 206, 5, 214, 46}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 28, 24}, 224},
	{{136, 0, 0, 0, 0, 15, 208, 92, 197, 224, 111, 254, 197, 215, 213, 25}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 249, 134, 118}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 224},
	{{136, 0, 0, 191, 116, 213, 199, 168, 209, 141, 22, 98, 9, 189, 133, 133}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 15, 205}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 182, 244, 65, 49}, 224},
	{{136, 0, 0, 0, 0, 0, 64, 120, 242, 50, 60, 185, 219, 55, 253, 213}, 224},
	{{136, 175, 7, 82, 254, 231, 5, 88, 36, 226, 188, 132, 141, 76, 190, 8}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 40, 5, 106, 115, 17, 177, 22, 36, 181}, 224},
	{{136, 0, 0, 144, 134, 184, 190, 195, 178, 23, 198, 88, 55, 251, 93, 112}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 31, 224, 221, 129, 241, 13, 245}, 224},
	{{136, 0, 0, 0, 0, 0, 4, 76, 6, 101, 206, 106, 215, 119, 100, 79}, 224},
	{{136, 0, 0, 0, 125, 247, 42, 234, 217, 37, 211, 67, 161, 38, 207, 223}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 81, 179, 116}, 224},
	{{136, 0, 0, 0, 0, 0, 111, 8, 47, 217, 160, 253, 32, 188, 242, 60}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 250}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 24, 16, 103, 174, 154, 226, 21, 126, 195}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 178, 245}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 176, 128, 197, 69, 229, 218, 149, 64}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 217, 221, 205}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 91, 128, 70}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 54}, 224},
	{{136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 73, 211, 247, 165, 233}, 224},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 225, 244, 17, 248, 77, 51, 221}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 202, 133, 209, 72, 65, 202}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 20, 200, 221, 37, 208}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 71}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 100, 111, 92, 1, 74, 10}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 243, 160, 59, 192, 4}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 255, 168, 177, 109, 18, 107, 228, 245}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 229, 180, 111, 150, 168, 223}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 28, 45}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 242, 113, 192, 179}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 244, 158}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 12, 114, 43, 225}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 250, 131, 229, 60, 122, 147, 21, 157}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 121, 182, 56, 180}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 79, 40}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 244, 111}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 87, 187}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 146, 194, 151, 102, 171, 28, 183}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 168, 26, 15, 81}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 244, 80, 80}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 218, 79, 47, 240, 31, 55}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 22}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 59, 182, 53, 81, 135, 242, 136, 69}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 111, 241, 106, 185, 14, 192}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 85, 142, 122, 202, 115, 53, 94}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 188, 2, 224, 38, 234, 224}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 86, 213, 53, 36, 2, 116}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 57, 79, 91}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 189, 24, 133, 204, 195}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 77, 220, 136, 252, 96}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 198, 151, 92, 191, 245}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 205, 176, 247, 170, 65, 29}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 37, 184, 15, 159, 130}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 124, 102, 229, 245}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 9, 218, 95, 200, 158}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 30, 112, 42, 76, 20, 55, 52}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 20, 0, 102, 217, 23, 89}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 51, 253}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 234, 46, 241, 10, 216}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 22, 200, 177, 126, 36}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 33, 132, 63, 204}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 42, 199, 238, 78, 221, 56, 47}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 253, 66, 127, 135, 237}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 138, 210, 203, 129}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 163, 154, 11}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 216, 83, 102, 212, 219, 111, 110, 185}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 191, 18, 91, 237, 88, 230, 41, 187}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 228, 38, 127, 178, 145, 102, 223, 173}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 66, 124, 161, 7, 82, 1, 63}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 175, 192, 227, 102, 30, 147, 107, 170}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 81, 206, 148}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 22, 237, 69, 228, 170, 95, 15, 65}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 54, 89, 149, 172, 162, 35, 185}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 71, 211, 23, 63}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 152}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 63, 9, 35, 111}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 110, 227}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 79, 220, 67, 255, 243, 69, 50}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 240, 112, 3, 205, 98, 179}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 40, 199, 144, 189, 2, 67, 171, 132}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 177, 172, 209, 13, 163, 233, 76}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 67}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 133}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 9, 64, 2}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 10}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 142, 250, 100}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 89, 208, 62, 59, 38, 169, 224, 119}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 252, 124, 32, 0, 154, 109, 205, 214, 91}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 110, 17, 205, 141}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 138, 115, 28, 99, 230, 240, 42, 82}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 123, 178, 33, 220}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 141, 146, 243}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 158, 43}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 137, 167, 34, 76}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 8, 10, 255, 47, 153, 147, 205}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 154},
	{{131, 162, 144, 124, 12, 98, 242, 0, 0, 0, 0, 0, 0, 16, 178, 226}, 154},
	{{75, 50, 129, 192, 0, 0, 0, 0, 60, 111, 72, 104, 158, 231, 67, 86}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 70, 4, 254, 46, 205, 29, 0, 14}, 106},
	{{75, 50, 129, 192, 250, 246, 85, 132, 202, 236, 56, 101, 192, 179, 166, 84}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 147, 8}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 75, 54, 146, 51, 56}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 246, 37, 6, 214, 17, 139}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 123}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 160}, 106},
	{{75, 50, 129, 192, 0, 0, 165, 55, 47, 126, 48, 136, 155, 183, 49, 0}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 195, 140}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 250, 95}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 87, 36, 44, 251, 145, 5}, 106},
	{{75, 50, 129, 192, 0, 73, 146, 71, 200, 176, 196, 229, 95, 100, 180, 18}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 129, 64, 183, 69, 107, 159}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 178, 179, 73, 59, 43, 76, 187}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 238, 123}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 53, 119, 152, 223, 196, 170, 215, 99}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 23, 33}, 106},
	{{75, 50, 129, 192, 0, 214, 21, 190, 7, 143, 114, 223, 56, 206, 237, 146}, 106},
	{{75, 50, 129, 192, 0, 0, 51, 74, 222, 136, 213, 137, 192, 18, 126, 55}, 106},
	{{75, 50, 129, 192, 0, 171, 230, 189, 43, 221, 142, 204, 46, 56, 239, 216}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 254, 159, 170, 102, 208, 185, 32, 224}, 106},
	{{75, 50, 129, 192, 0, 126, 48, 69, 189, 135, 18, 177, 216, 185, 93, 76}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 93, 152, 244, 179, 167, 189, 193}, 106},
	{{75, 50, 129, 192, 18, 178, 124, 5, 173, 144, 106, 30, 160, 231, 214, 191}, 106},
	{{75, 50, 129, 192, 0, 0, 17, 116, 22, 233, 198, 244, 63, 204, 78, 23}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 239, 242, 145, 237, 83, 101, 105}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 198, 51, 68, 2, 52, 120, 3, 27, 38}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132}, 106},
	{{75, 50, 129, 192, 0, 0, 23, 104, 126, 253, 119, 246, 29, 94, 147, 93}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 73, 233, 175, 17, 64, 219, 249, 14, 59}, 106},
	{{75, 50, 129, 192, 0, 212, 142, 38, 93, 194, 1, 56, 176, 203, 222, 198}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 88}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 21, 105, 68, 36, 89, 229, 171}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 186, 140, 88, 221}, 106},
	{{75, 50, 129, 192, 0, 0, 77, 198, 104, 207, 10, 25, 123, 223, 79, 22}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 208, 23}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 168, 125, 115, 77, 86}, 106},
	{{75, 50, 129, 192, 0, 0, 28, 214, 231, 249, 40, 252, 77, 251, 61, 237}, 106},
	{{75, 50, 129, 192, 0, 0, 84, 48, 81, 36, 82, 140, 127, 172, 72, 121}, 106},
	{{75, 50, 129, 192, 0, 95, 66, 206, 106, 118, 199, 73, 69, 194, 199, 97}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 241, 52, 88, 166, 255}, 106},
	{{75, 50, 129, 192, 0, 0, 214, 103, 130, 237, 241, 147, 180, 237, 134, 67}, 106},
	{{75, 50, 129, 192, 0, 0, 125, 87, 112, 246, 249, 184, 220, 167, 98, 112}, 106},
	{{75, 50, 129, 192, 0, 107, 181, 106, 34, 21, 3, 129, 22, 180, 27, 180}, 106},
	{{75, 50, 129, 192, 171, 246, 35, 109, 79, 217, 113, 2, 251, 50, 77, 43}, 106},
	{{75, 50, 129, 192, 61, 48, 207, 134, 77, 197, 254, 206, 171, 174, 93, 52}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 197, 167, 56, 179, 240, 62, 63, 231}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 217, 209}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 140, 49, 3, 98, 113, 4, 56, 111}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 166, 207, 159, 133, 44, 108, 121, 132, 106}, 106},
	{{75, 50, 129, 192, 51, 96, 218, 55, 164, 124, 235, 157, 186, 98, 222, 247}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 179, 63, 199, 4, 162}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 50, 78, 117, 12}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 63, 50, 119, 13, 115}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 183, 209, 222, 162, 125, 138}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 202, 37, 172, 209, 8, 1, 107, 148}, 106},
	{{75, 50, 129, 192, 0, 0, 193, 78, 167, 247, 175, 211, 41, 84, 82, 22}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 155, 93}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 209, 253, 100, 23, 169}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 61, 78, 142, 82, 185}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 246, 41, 138, 249, 140, 27}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 172, 244, 0, 206, 244, 84, 178}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 110, 82, 197, 147}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 132, 74, 211, 228, 155}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 29, 224, 246, 213, 138}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 138, 196, 89, 93, 55, 210}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 106},
	{{75, 50, 129, 192, 155, 181, 127, 96, 85, 191, 95, 57, 71, 75, 30, 205}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 37, 90, 236, 2, 190, 253, 89, 34, 65}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 23, 45, 187, 239, 181, 98, 255, 48, 7}, 106},
	{{75, 50, 129, 192, 0, 0, 20, 144, 21, 191, 193, 178, 44, 49, 166, 4}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 240, 242, 208, 25, 188, 134}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 3, 158, 129, 98, 153, 35, 160, 44}, 106},
	{{75, 50, 129, 192, 0, 35, 181, 202, 126, 48, 42, 90, 22, 133, 239, 86}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 50, 88, 45, 70}, 106},
	{{75, 50, 129, 192, 0, 0, 153, 187, 201, 29, 5, 90, 6, 208, 203, 183}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 49, 175, 245, 179, 160}, 106},
	{{75, 50, 129, 192, 0, 0, 202, 43, 133, 174, 206, 86, 235, 153, 218, 125}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 0, 215, 107, 234, 94}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 0, 192, 21, 84, 242, 252}, 106},
	{{75, 50, 129, 192, 0, 0, 0, 0, 0, 0, 32, 238, 62, 85, 173, 53}, 106},
	{{75, 50, 129, 192, 0, 0, 215, 28, 167, 62, 24, 11, 164, 4, 101, 7}, 106},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 53, 127, 36, 137}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 111, 221, 159, 16, 38}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 250, 217, 65, 43, 162, 174}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 21, 227}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 108}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 161}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 77, 25, 48, 61, 159, 136}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 168, 66, 134, 245}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 218, 181}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 125, 43, 229, 40, 99, 35}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 108, 235, 85, 73}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 52, 105, 214, 2, 21}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 114, 168, 175, 87}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 217, 176, 195, 170, 29, 115}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 43, 91, 34, 83, 31, 247}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 2, 22, 38, 160, 153, 243}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 67, 100}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 183, 55}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 119, 152, 146, 210, 11, 110}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 81, 200, 29, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 65, 175, 81, 28, 37, 192, 254}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 223, 227, 217, 192, 167, 211}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 173, 66, 168}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 87, 149, 156, 119, 103}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 253, 109, 198, 142}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 253, 29, 248, 230, 46, 235, 78}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 70, 216, 143, 100, 153}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 218, 111, 49, 34, 16, 132}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 116, 25, 18, 201, 165, 157}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 101, 101, 165, 22}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 212, 141, 105, 30}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 39, 45, 157, 235, 151, 136, 116}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 200, 120, 183, 232, 214}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 162}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 171, 250, 202, 204, 179}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 62, 237, 162, 18, 156}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 236, 120, 165}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 57, 187, 220, 182}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 107, 64, 102, 251, 92, 206, 190}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 154, 228, 126, 93, 140, 196}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 191, 88, 63, 230, 52}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 72, 251, 225, 49, 242, 12, 146}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 189, 140, 151, 76, 193, 217, 68}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 92, 55, 97, 9, 88}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 148, 116, 71, 244}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 228, 193, 16}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 162, 179, 73, 181}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 65, 232, 251, 71, 228, 164}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 124, 46, 126}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 65, 210}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 8, 130, 78, 165, 141, 253, 150}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 95}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 53, 138, 215, 180, 219}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 245, 136, 226, 39, 5, 60}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 234, 23, 91, 69, 3, 106, 18}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 2}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 106, 166, 84, 45, 47}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 32, 198}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 85, 52, 246, 38, 249}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 123, 154, 217, 38, 174, 157}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 35, 14, 48, 141, 146}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 10, 36, 127, 92, 12}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 152, 156}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 140, 70, 245, 83, 85}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 39, 19, 77, 192, 90, 196, 205}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 52, 112}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 60, 241, 145, 177}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 179, 133}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 190, 21}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 86, 188, 156, 201, 28, 159}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 25, 15, 80, 93}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 119, 12, 218, 105, 102, 79}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 33}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 109}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 5, 84, 184, 46, 129, 20}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 118, 142, 172, 30, 152, 22, 94}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 155, 197}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 235, 150, 142, 203}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 203}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{212, 183, 40, 225, 152, 136, 174, 91, 0, 0, 0, 0, 247, 35, 33, 73}, 125},
	{{158, 0, 65, 251, 100, 131, 56, 18, 203, 97, 25, 188, 124, 31, 215, 207}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 19, 238, 180, 144, 1}, 118},
	{{158, 0, 0, 0, 40, 37, 112, 118, 133, 114, 244, 178, 227, 202, 188, 253}, 118},
	{{158, 0, 0, 0, 0, 0, 216, 36, 59, 214, 46, 168, 145, 46, 61, 43}, 118},
	{{158, 0, 0, 0, 0, 0, 184, 245, 73, 188, 16, 169, 99, 226, 179, 169}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 63, 245, 207, 149, 2}, 118},
	{{158, 0, 0, 25, 85, 59, 201, 185, 0, 54, 232, 55, 77, 33, 240, 2}, 118},
	{{158, 0, 0, 0, 196, 169, 100, 134, 146, 187, 142, 146, 179, 13, 186, 184}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 205, 53, 22, 200}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{158, 0, 0, 0, 0, 0, 251, 36, 52, 20, 253, 153, 161, 28, 154, 56}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 196, 84, 82, 237, 77, 209, 168, 127}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 176, 171, 249, 53}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 33, 25, 196, 98, 70, 241, 245, 90, 169}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 1, 190, 160, 220}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 114, 74, 171, 213, 113, 249, 109, 139}, 118},
	{{158, 0, 8, 200, 19, 72, 82, 44, 245, 222, 24, 211, 161, 92, 177, 45}, 118},
	{{158, 0, 0, 0, 163, 153, 97, 211, 115, 182, 110, 170, 85, 192, 44, 214}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 118},
	{{158, 0, 0, 94, 51, 169, 251, 125, 185, 152, 123, 80, 238, 32, 30, 165}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 250, 40}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 212, 53, 55, 199, 153}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 34, 175, 200, 125, 241, 68, 105, 49, 123}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 172, 236, 220, 160, 212, 132, 229, 172}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 177, 135, 248, 196, 77, 57, 248, 110}, 118},
	{{158, 0, 0, 0, 20, 235, 187, 36, 175, 5, 152, 106, 221, 197, 136, 188}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 71}, 118},
	{{158, 0, 0, 0, 0, 0, 59, 238, 4, 183, 11, 185, 48, 144, 235, 63}, 118},
	{{158, 0, 0, 250, 2, 15, 150, 253, 164, 149, 253, 99, 177, 70, 29, 73}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 192, 139}, 118},
	{{158, 0, 0, 0, 232, 165, 35, 225, 236, 107, 98, 175, 102, 199, 147, 40}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 48, 153, 50, 202, 72, 47, 142}, 118},
	{{158, 0, 0, 0, 129, 158, 185, 217, 216, 150, 6, 249, 179, 171, 235, 138}, 118},
	{{158, 0, 0, 0, 0, 197, 94, 43, 94, 132, 201, 107, 161, 54, 236, 11}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 93, 144, 159}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 223, 167, 42, 251, 79, 79, 115, 223, 192}, 118},
	{{158, 0, 0, 0, 95, 153, 215, 25, 26, 255, 227, 136, 136, 55, 125, 163}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{158, 0, 0, 0, 214, 88, 129, 28, 85, 227, 30, 139, 117, 84, 11, 118}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 135, 234, 36, 254, 248}, 118},
	{{158, 0, 0, 0, 0, 143, 80, 164, 226, 74, 24, 72, 23, 240, 21, 134}, 118},
	{{158, 0, 80, 194, 195, 26, 4, 117, 68, 229, 19, 34, 181, 202, 198, 85}, 118},
	{{158, 0, 163, 166, 130, 164, 204, 86, 242, 195, 235, 214, 154, 150, 200, 140}, 118},
	{{158, 0, 0, 0, 57, 117, 219, 253, 138, 177, 207, 61, 193, 105, 93, 145}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 248, 30, 217, 142}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{158, 0, 0, 0, 0, 0, 127, 96, 195, 43, 17, 60, 38, 146, 112, 249}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 159, 78}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 225, 147, 134, 74, 76, 225, 165, 135}, 118},
	{{158, 0, 0, 0, 0, 77, 114, 155, 56, 155, 142, 164, 118, 67, 114, 29}, 118},
	{{158, 0, 0, 0, 0, 22, 55, 132, 246, 229, 63, 61, 20, 241, 80, 216}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 170, 27}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 209, 241, 154}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{158, 0, 0, 0, 50, 122, 169, 181, 146, 205, 153, 116, 201, 188, 199, 178}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 96, 254, 27}, 118},
	{{158, 0, 0, 0, 229, 113, 231, 41, 198, 150, 59, 209, 60, 40, 81, 12}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 173, 2}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 79, 28, 172}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 51, 93, 236}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 229, 178, 109, 219}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 38, 231, 67, 3, 201, 242, 98, 12}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 240, 118, 62, 118}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 215, 204, 19, 165, 155, 238, 101, 176}, 118},
	{{158, 0, 0, 0, 0, 180, 226, 31, 147, 97, 104, 243, 164, 253, 241, 45}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 103}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 147, 89}, 118},
	{{158, 0, 0, 0, 0, 0, 231, 244, 212, 150, 239, 247, 166, 144, 5, 252}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 115, 171, 82, 64, 6, 210, 137}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 225, 222, 75, 224, 10}, 118},
	{{158, 0, 0, 53, 182, 227, 230, 0, 105, 84, 96, 54, 44, 192, 138, 218}, 118},
	{{158, 0, 140, 181, 55, 216, 245, 209, 47, 121, 54, 58, 48, 97, 245, 166}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 144}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 191, 140, 62, 2, 165, 73, 36, 119, 44}, 118},
	{{158, 0, 30, 169, 84, 84, 115, 248, 58, 71, 230, 27, 134, 192, 185, 134}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 165, 162, 231, 209, 158}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 175, 180, 94, 175}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 118},
	{{158, 0, 0, 181, 63, 110, 198, 98, 225, 97, 170, 192, 211, 207, 225, 78}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 173, 88, 232, 217, 73, 237, 94, 104}, 118},
	{{158, 0, 0, 219, 172, 155, 139, 172, 92, 115, 164, 214, 248, 212, 80, 93}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 206}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 68, 2, 22, 196, 159, 104, 154}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{158, 0, 0, 145, 5, 80, 139, 177, 13, 58, 137, 169, 144, 107, 8, 63}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 115, 162, 23, 25, 90, 51, 156, 76, 115}, 118},
	{{158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 110, 75, 46}, 118},
	{{158, 0, 236, 238, 49, 89, 65, 163, 161, 25, 218, 239, 70, 197, 139, 72}, 118},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 113, 100, 145, 215}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 64, 207, 46, 120}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 40, 226, 89, 179, 65}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 30, 195, 83, 175}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 143, 183, 46, 246, 65}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 106, 100, 230, 188, 213, 241}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 6, 217, 207}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 108, 73, 30, 232}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 141, 69, 146, 204, 185}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 7}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 209, 110, 2}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 22, 218, 198, 194, 217, 35}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 137, 228, 242, 120, 88}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 187}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 128}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 95}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 113, 113, 23, 129, 121}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 117}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 41, 134}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 224}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 69}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 72, 200, 85}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 222, 241, 60, 122}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 78, 22, 255, 41, 121, 141}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 50, 26, 34, 189, 189}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 234, 5, 136, 211, 8}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 59}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 236, 90, 88, 150, 38, 108}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 187, 216, 0, 106, 158, 199}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 241}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 10, 217}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 39}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 224, 143}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 156, 237, 16, 138, 199}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 220, 100, 58, 179, 192}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 113, 186, 118}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 98, 33, 75, 73, 191, 213}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 17, 33}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 98, 16, 237, 156}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 133}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 247}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 47, 255}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 244, 62, 163, 167, 144}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 26, 198, 216, 223, 60}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 202, 47, 0}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 160, 146, 40, 162, 85}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 101, 170}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 156, 124, 39, 186, 18}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 220, 121}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 150, 192}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 151, 56, 65, 212, 132, 53}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 79, 190, 197, 71, 70}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 195, 66}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 227}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 56, 175, 89, 15, 56}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 237, 60, 153, 108, 165}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 243}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 66}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 127, 23}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 138}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 88, 65, 3}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 23, 95, 35, 91, 102}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 169, 114, 70, 238, 25, 210}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 44, 77, 93, 131}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 36, 155, 182}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 51}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 88, 44, 123, 81, 242}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 24, 136, 11, 154, 80, 86}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 78, 92}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 27, 243, 202, 216, 235}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 110, 142, 5, 186, 233}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 125}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 43, 13, 196}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 159, 196, 235, 122}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 98, 184, 98}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 252, 15, 101, 226, 134, 198}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 8, 116, 198, 204, 16, 155}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 92, 7, 213, 98}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 21, 194, 239, 169, 214}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 75, 210, 11, 66}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 210, 89, 247, 10}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 110}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 185, 238, 188}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 94, 161}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 19, 32, 54, 87, 246, 156}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 0, 0, 182}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 204, 30, 235, 133, 225}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 255, 55, 165}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 33, 11, 251, 24, 186}, 52},
	{{7, 48, 132, 149, 169, 212, 198, 137, 202, 0, 0, 0, 0, 191, 38, 214}, 52},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 124, 185}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 1, 80, 181, 211, 151}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 194, 238, 28, 174}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 99, 206, 195}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 210}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 55, 197}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 214, 209, 85, 69, 20, 92, 208, 160}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 230, 165, 138, 33, 78, 159, 43, 223}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 177, 175, 221, 208, 86, 157, 190}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 169, 9, 151, 247, 194, 236, 110}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 142, 164, 36, 137, 224, 51}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 88, 168, 62, 21, 156, 242}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 170, 136}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 75, 109, 205, 165, 25, 121, 9}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 61}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 217, 35, 155, 158, 155, 73}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 24}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 46, 72}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 116, 77, 187}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 112, 6, 36}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 239, 213, 178, 60, 161, 180}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 15, 64, 60, 151, 24}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 242, 247, 157, 149}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 65}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 243, 92, 210, 217, 46, 200}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 155}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 226, 1, 195, 195, 11, 86, 112}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 214, 44, 41, 55, 121}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 21}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 13, 106, 14}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 19, 69, 156, 23, 184}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 94, 7, 33, 160, 188, 195, 121}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 214, 234, 135, 193}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 53, 255, 7, 139, 214, 96}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 111, 255}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 251, 237, 201, 46}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 204}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 30, 97, 13}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 27, 54, 64, 23, 8, 187}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 209, 22, 170}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 6, 149}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 144, 172, 170, 23, 157, 224, 58}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 40, 83}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 112, 89, 229, 151, 206, 127, 92}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 155, 78, 190, 157, 140}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 239, 88, 190, 23, 82, 203, 120}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 195, 12, 117, 228, 30, 104}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 129, 208, 24}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 87, 79, 190, 108}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 236, 180, 87}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 36, 85}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 222, 155, 72, 227, 196, 43, 86}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 169, 57, 21, 152, 112, 250}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 79, 57, 210, 246, 135}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 34, 230, 3, 241, 136}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 87, 93, 200, 194}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 46, 144, 15}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 168, 58, 88, 164, 162, 240, 175}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 105, 185, 90, 150, 174, 220, 83}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 88, 207, 198, 93}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 116, 125, 122, 101, 108}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 58, 246, 84}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 29, 223, 13, 64, 224}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 166, 100, 171}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 247, 59, 84, 148, 32, 98}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 204, 206, 252, 183, 234}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 224, 25, 66, 11, 67}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 92, 4, 118}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 21, 60, 110, 111, 45, 220}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 74, 139, 100}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 4, 124, 44, 46, 167, 200}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 67, 13}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 129, 251, 167, 109, 2, 46}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 66, 31, 165, 77, 126, 111, 17, 207}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 112, 107, 85, 64}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 36, 207, 24, 235, 103, 64, 21, 235}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 183, 195, 177, 179}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 85, 220}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 189, 152, 171, 182}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 127, 59, 145, 216, 169, 174}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 232, 245, 80, 149, 103}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 46, 203}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 253, 223, 218, 253, 165, 203}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 184, 49, 149, 214, 6, 0}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 205}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 189, 80}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 133, 41}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 28, 165, 214, 160}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 164, 255}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 187, 216, 182}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 45, 116, 250, 180, 235, 143, 158}, 173},
	{{173, 195, 129, 163, 141, 249, 40, 64, 0, 0, 0, 209, 165, 84, 116, 51}, 173},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 7}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 94}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 5}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 201}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 58}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 86}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 59}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 228}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 31}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 130}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 175}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 5}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 92}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 196}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 165}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 212}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 149}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 138}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 178}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 152}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 70}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 216}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 132}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 99}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 177}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 143}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 133}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 29}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 106}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 120}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 78}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 88}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 48}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 55}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 247}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 130}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 178}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 11}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 238}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 89}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 105}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 195}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 49}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 231}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 132}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 196}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 201}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 42}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 199}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 248}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 114}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 101}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 196}, 8},
	{{109, 79, 75, 219, 205, 182, 22, 245, 223, 17, 146, 78, 109, 119, 128, 0}, 8},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 26, 3, 134, 104, 190}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 100, 97, 194, 4, 140}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 80}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 155, 71, 128, 183, 229, 84}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 183}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 77, 161, 2, 135, 5}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 94, 233}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 253, 6}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 50, 234, 175, 121, 208, 55}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 64, 9}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 236}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 14, 209, 62, 86}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 76, 197, 232, 206}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 50, 128, 178, 36, 228}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 8, 191, 46, 73}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 243, 134}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 102, 174, 199, 78}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 231, 243, 231, 199, 130}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 17, 251, 143, 5, 165}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 180, 78}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 215, 167, 41}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 228, 239, 219, 180, 50, 223}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 111, 41, 37}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 161}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 231, 7, 211}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 56, 125, 252, 10}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 37}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 18, 115}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 207, 229, 236}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 229, 178}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 241}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 34, 141}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 175, 94}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 207, 20, 219, 139}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 141, 4}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 108, 175, 171, 196}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 87, 45}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 245}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 1, 188, 158, 165}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 166, 29, 98, 139, 127}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 102, 155, 66}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 190}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 180, 73}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 250, 105, 201, 141}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 33}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 34, 176}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 145, 224, 211, 176, 188}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 144, 74, 36, 233, 133}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 33, 75, 47, 128, 58}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 208, 130, 224}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 151, 12, 253}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 194, 211}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 44, 69, 17, 193, 110}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 124, 230, 170, 126, 161}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 23, 199}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 188, 150, 172, 196, 139, 33}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 146, 243, 37}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 250, 185, 154}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 138, 169, 93, 214, 134}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 116, 136}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 114}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 199, 196, 99, 114}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 24, 40}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 73, 80}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 21, 171, 161, 126, 94}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 198, 153, 128, 93, 233, 216}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 127, 219, 168, 254, 206}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 135, 236, 220, 63}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 70, 58}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 94, 42}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 91, 18, 16, 195, 25, 149}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 5, 155, 112}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 6, 64, 117, 164, 53}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 100, 187}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 8, 99, 206}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 223, 62}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 141, 107, 121, 120, 0}, 211},
	{{174, 195, 24, 182, 215, 198, 214, 86, 34, 128, 0, 0, 0, 0, 0, 0}, 211},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 203, 254, 167, 115, 233, 92}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 220, 48, 109, 136, 158}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 0}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 62, 95, 201, 253, 178, 191, 26}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 232, 116, 142, 111, 40, 212, 99}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 218}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 250, 228, 163, 9, 47}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 201, 90, 201, 83, 185}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 240, 215, 244, 9, 10, 32}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 0}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 116, 120, 218, 240, 172}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 188, 203, 183, 101, 128, 227, 216}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 4, 138, 27, 67, 162, 206}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 160, 115, 221, 127, 216, 149}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 0}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 221, 106, 35}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 224, 97, 46, 4, 241, 12}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 225, 138, 30, 199, 217, 220}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 247}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 214, 180, 170, 187, 105, 217, 68, 200}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 153, 227}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 117, 163, 180, 59, 216, 119, 162}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 0}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 0}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 44, 90, 81, 231, 149, 100, 17}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 148, 237, 159, 76, 67}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 249, 123, 212, 249, 139, 147, 13}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 145}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 103}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 89, 210, 143, 82}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 0}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 38, 3}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 176, 39, 232, 121, 23, 235, 103}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 217, 154, 93, 72, 42, 8}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 102, 116, 184}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 216, 142, 60}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 150, 25, 168, 175}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 239, 237, 17, 231, 33, 153}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 194, 136, 26, 111, 245, 75, 204, 19}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 114}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 126, 113, 131, 141}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 110, 233, 167}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 127, 44, 210, 227, 224, 80}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 196}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 255, 107}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 50, 28, 89, 218, 168, 74, 142, 212}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 0}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 100, 98, 202, 126, 62, 59, 52}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 0}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 181, 74, 118, 98, 207, 76}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 0}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 194}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 75}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 146, 76, 194, 213, 29}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 18, 59, 1, 53}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 228, 86, 29}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 108, 8, 63}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 41, 167, 56}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 93, 149, 158, 216, 200}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 215, 159, 110, 141, 106}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 244, 35, 127, 85}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 66, 139}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 228, 251}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 59}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 49}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 132, 176}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 188}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 65, 184, 159, 239, 199}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 163, 248, 245, 115}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 199, 81}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 252, 124, 142, 58, 235}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 112, 57, 196, 132, 151, 51}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 30, 17, 117, 150, 121, 77, 174}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 90, 217, 156, 12, 199}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 188, 102, 244, 236, 142}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 213, 65, 224}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 97, 79, 220, 174}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 63, 214, 180, 170}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 116}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 225, 68}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 7, 44, 118, 201, 48, 224, 4}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 0}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 60, 86, 241}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 0}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 114, 213, 173, 7, 115, 80, 1}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 104}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 253, 190, 231, 108}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 102, 66, 223, 116, 121, 210}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 133, 12, 67, 246, 174, 161}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 99, 210, 133, 4}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 138, 20, 233, 56, 237, 64, 62, 172}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 109, 253, 255, 55, 74}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 112, 214}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 0}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 97, 177, 11, 22, 69, 110, 82}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 40, 179, 21, 248, 180, 90, 28, 60}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 249, 225, 246}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 176, 105, 161, 37, 243, 215, 148, 187}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 0}, 253},
	{{22, 40, 51, 109, 70, 91, 152, 56, 0, 0, 0, 0, 0, 0, 0, 154}, 253},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 64, 18, 249, 104, 188}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 214}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 50, 38, 111, 26}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 239, 152}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 157, 215, 106}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 79, 58, 76, 145}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 245, 32, 122, 2, 167, 96, 50, 239}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 162, 30, 84}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 224, 193, 227, 203, 200}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 201, 202, 82, 137}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 126, 182, 15}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 101, 96, 23, 20}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 66, 191, 87, 19, 85, 255, 25}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 241, 103, 162}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 141, 138, 13, 60, 243, 146, 152, 177}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 65, 221, 142, 226, 217, 191, 190}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 214, 195}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 63}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 49, 33, 180, 26, 219, 124, 115}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 86}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 176}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 77, 33, 98, 244, 242, 67}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 81, 103}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 161, 125, 19, 72}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 37, 154, 22}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 170, 242, 137, 240, 144, 28, 124}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 134, 100, 200, 242, 136, 44, 202}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 60, 108}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 197, 95, 59}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 84, 78, 186, 195, 185}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 194, 246, 7, 109, 142, 67, 189}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 244}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 65}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 111, 156}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 218, 249, 209}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 172, 138, 43, 80, 122}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 38}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 74, 181, 237, 158, 119, 220, 132}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 108, 221, 100, 54}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 248, 84}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 199, 245, 5, 69}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 236, 43, 183, 56, 13, 211}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 251, 92, 29}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 195, 227, 125, 216, 132, 134}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 120, 9, 170}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 161, 154}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 66, 99, 177, 166, 67, 118}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 96, 216, 96, 163, 170}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 17, 64, 241}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 253, 33, 191}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 219, 208, 154, 49, 130, 196, 121}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 1, 95, 217, 77, 28, 56, 254}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 164, 174, 190, 73, 197, 135, 39}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 31, 191, 81, 209, 152, 229}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 71, 166, 54, 84}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 191, 117, 209, 156, 148, 72, 24}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 81, 184, 81, 222}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 138, 3, 219, 50, 201, 147}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 34, 48, 192, 152, 92, 165}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 241, 183, 2, 187, 83, 2, 229}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 248, 142, 108, 159, 192}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 20, 16, 36, 66, 226, 100}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 164, 225, 81}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 79, 35}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 48}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 109, 80, 20, 91, 103}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 230, 149, 139}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 155, 213, 233, 83, 101, 239}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 75, 8, 6}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 160, 203}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 122, 151, 164, 212, 247, 152, 110, 152}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 173, 76, 160, 198, 174}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 115, 124, 214, 21, 132}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 237, 221, 114}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 179, 190, 175}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 153, 14}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 175, 204, 101}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 6, 47, 122, 178}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 228, 229}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 59, 152, 150}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 254, 114, 127, 235, 146, 255, 49, 83}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 186, 117, 53, 134}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 141}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 234, 171, 53}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 190, 166}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 91, 255, 56, 31, 208, 166, 137}, 47},
	{{169, 115, 246, 126, 65, 118, 219, 192, 0, 0, 0, 0, 0, 0, 215, 201}, 47},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 25}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 242}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 210}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 133}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 176}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 20}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 17}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 119}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 245}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 50}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 97}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 249}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 140}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 20}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 140}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 163}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 56}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 177}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 215}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 129}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 79}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 162}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 85}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 132}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 191}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 202}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 114}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 130}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 11}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 121}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 74}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 157}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 78}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 211}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 144}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 208}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 21}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 218}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 57}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 46}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 176}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 227}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 201}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 214}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 79}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 165}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 44}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 101}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 12}, 73},
	{{154, 37, 70, 124, 107, 123, 232, 241, 164, 142, 71, 226, 182, 126, 0, 0}, 73},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 5, 248, 114}, 192},
	{{6, 108, 0, 0, 90, 88, 87, 37, 56, 207, 95, 246, 41, 183, 22, 106}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 47, 11, 23, 26, 208, 219, 34, 107, 124}, 192},
	{{6, 108, 0, 0, 0, 0, 41, 178, 214, 194, 167, 95, 78, 180, 127, 129}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{6, 108, 0, 0, 0, 14, 156, 182, 59, 39, 42, 4, 105, 167, 108, 223}, 192},
	{{6, 108, 0, 0, 0, 173, 126, 178, 216, 108, 215, 237, 144, 151, 36, 69}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 21, 164}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{6, 108, 0, 0, 0, 0, 64, 132, 133, 147, 87, 60, 200, 132, 254, 164}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 195, 114, 160, 215, 123, 222}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 117, 205, 163, 41}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 73, 134, 127}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 24, 30, 217, 253, 189, 153, 34}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 6, 119, 223}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 186}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 13, 154, 186, 140, 78, 217, 242, 62, 199}, 192},
	{{6, 108, 0, 181, 60, 188, 130, 80, 197, 234, 104, 28, 202, 56, 158, 78}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 54, 216}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 76, 8, 239, 73, 218, 76}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 87, 122, 220}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 102, 99, 52, 78, 114, 10}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 192},
	{{6, 108, 0, 0, 27, 243, 57, 134, 139, 23, 29, 155, 20, 230, 140, 44}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 208, 146, 69}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 232, 140, 249, 192, 135, 68, 167, 127, 51}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 112, 218, 86, 122}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 6, 136}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 74, 225, 69, 207, 250, 230, 71}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 51, 72, 12, 165, 104, 217, 95}, 192},
	{{6, 108, 0, 0, 246, 35, 7, 46, 20, 134, 56, 81, 119, 202, 43, 199}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 245, 70, 5, 45, 148, 216, 48, 231, 121}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 85, 92, 235, 189, 164, 16, 129, 56}, 192},
	{{6, 108, 0, 0, 0, 134, 189, 90, 142, 203, 73, 130, 193, 211, 205, 62}, 192},
	{{6, 108, 0, 0, 0, 85, 47, 179, 32, 254, 98, 176, 202, 68, 252, 235}, 192},
	{{6, 108, 0, 0, 0, 0, 7, 159, 167, 132, 73, 211, 247, 132, 123, 122}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 243, 141, 15, 94, 46, 196, 200}, 192},
	{{6, 108, 0, 0, 0, 197, 213, 8, 104, 76, 247, 6, 131, 242, 31, 177}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 228, 253, 133, 82, 95, 32}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 163, 139, 233, 45, 90, 74, 228, 152, 182}, 192},
	{{6, 108, 0, 0, 0, 203, 237, 163, 115, 247, 15, 235, 174, 185, 14, 107}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 49}, 192},
	{{6, 108, 0, 18, 177, 105, 38, 25, 62, 121, 38, 71, 139, 39, 120, 159}, 192},
	{{6, 108, 0, 178, 49, 65, 126, 230, 69, 203, 43, 40, 143, 9, 25, 53}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 171, 224, 191, 28, 193, 34, 230}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 34, 185, 249, 19}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 115, 138, 58, 154, 37, 171, 23, 244}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 163, 85, 200, 237, 176, 10}, 192},
	{{6, 108, 0, 6, 185, 229, 23, 119, 186, 254, 129, 179, 222, 27, 255, 88}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 91}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 189, 32, 103, 64, 81, 251}, 192},
	{{6, 108, 0, 0, 95, 29, 186, 114, 153, 207, 0, 129, 44, 110, 109, 45}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 241, 201, 221, 21, 201, 214}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 185, 102, 2, 158, 174, 29}, 192},
	{{6, 108, 0, 0, 0, 113, 200, 67, 132, 46, 158, 241, 118, 43, 200, 31}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 22, 115, 141, 62, 223, 220, 207, 91}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 31, 149, 90, 164, 184, 33, 181, 217}, 192},
	{{6, 108, 0, 0, 123, 124, 83, 148, 139, 49, 255, 109, 171, 204, 86, 225}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 42, 239, 127, 84, 48, 106, 202, 32}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 65, 178, 198, 183}, 192},
	{{6, 108, 0, 0, 0, 0, 242, 118, 215, 100, 166, 96, 99, 234, 21, 137}, 192},
	{{6, 108, 0, 18, 217, 50, 97, 184, 17, 184, 167, 161, 89, 40, 203, 202}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 79}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 123, 35, 37, 153, 152, 50}, 192},
	{{6, 108, 0, 0, 0, 0, 135, 147, 161, 141, 44, 111, 202, 175, 132, 63}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 128}, 192},
	{{6, 108, 0, 0, 0, 36, 196, 45, 207, 37, 3, 32, 239, 126, 148, 80}, 192},
	{{6, 108, 0, 0, 0, 211, 74, 105, 123, 41, 204, 36, 147, 173, 141, 198}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 146, 164}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 142, 139, 164, 92, 98, 113, 146, 93}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 202, 94}, 192},
	{{6, 108, 0, 186, 185, 251, 24, 88, 200, 228, 152, 89, 98, 203, 6, 56}, 192},
	{{6, 108, 0, 0, 0, 0, 96, 167, 16, 7, 68, 204, 45, 154, 22, 25}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 174, 131, 104, 154}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 157, 80, 195, 36}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 25, 88, 181, 208, 89, 24}, 192},
	{{6, 108, 0, 0, 0, 0, 224, 186, 93, 241, 76, 78, 183, 27, 56, 102}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 240, 207, 125}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 233, 155, 151}, 192},
	{{6, 108, 0, 0, 0, 0, 94, 224, 249, 8, 23, 89, 89, 107, 117, 90}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 162, 172, 123, 25}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 135, 201, 246, 55, 77, 55, 19, 213}, 192},
	{{6, 108, 0, 126, 49, 185, 98, 243, 246, 117, 26, 161, 177, 26, 208, 102}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 167, 21, 39, 227, 249, 244, 114, 124}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 204, 254, 110, 204, 90, 165}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 192, 110, 6, 176, 48, 190, 210}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 244, 250, 33}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 134}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 105}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 169}, 192},
	{{6, 108, 0, 0, 0, 144, 231, 247, 29, 129, 132, 114, 142, 118, 243, 218}, 192},
	{{6, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 74, 246, 35, 90}, 192},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{216, 167, 158, 158, 222, 19, 96, 28, 40, 6, 70, 12, 147, 27, 85, 240}, 55},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 198}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 74}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 234, 114}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 244, 143, 219}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 35, 163}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 206}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 151, 247, 110}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 179, 4, 88}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 104, 40}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 13}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 56, 227, 223}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 42}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 113}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 225, 233}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 233, 242, 135, 151}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 208, 85}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 76, 138}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 111}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 74, 81}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 220, 54}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 200}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 69, 19, 210}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 100, 227}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 194}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 140, 112, 137}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 64, 91, 27, 16}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 83, 142}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 115}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 186, 179}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 181}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 52}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 193, 1}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 74, 114, 181}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 156, 20}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 72, 242}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 119, 200, 87}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 245}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 187, 162, 70, 89}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 125, 159, 161}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 138}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 150, 100}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 66, 207, 110}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 23, 47}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 206}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 127, 218}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 100, 207}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 213, 87, 97}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 208}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 187, 146, 76, 3}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 17, 41}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 119, 204, 63}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 85, 207, 183}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 193, 20, 51}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 110}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 108, 71}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 214, 193, 12, 115}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 67}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 105, 66, 75}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 69, 10, 88, 150}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 235}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 9}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 16}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 119, 154, 18, 92}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 39, 224, 219, 96}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 110, 144}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 22, 217}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 159}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 0, 0}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 0, 30, 220}, 147},
	{{72, 222, 52, 69, 69, 206, 163, 106, 235, 206, 80, 128, 0, 89, 72, 159}, 147},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{150, 112, 106, 56, 15, 243, 154, 97, 134, 110, 160, 20, 183, 144, 234, 8}, 86},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 77, 224, 248, 253, 192}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 22, 57, 4, 198}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 219, 247, 240}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 151}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 18, 182, 193, 31}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 29, 215, 9, 232, 93}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 201}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 103, 46, 17, 76}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 44, 127, 224, 128}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 2, 60, 75, 85, 184}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 32, 17, 190}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 154, 6, 103, 220}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 2, 171}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 141, 57}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 254}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 171}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 226, 24}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 45}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 149, 20}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 80, 201}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 99, 229, 202}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 223, 145}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 50, 88}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 145, 115}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 195, 170, 160, 153, 24}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 133, 82, 87, 61, 199}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 151, 176, 95, 124}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 161, 210, 155}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 26, 222, 142}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 156, 224, 187, 88, 218}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 165, 175, 69, 121}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 221, 223}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 140, 143, 232}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 218, 31}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 31}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 90, 146, 154}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 134}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 238, 7, 163, 153, 214}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 47, 12, 162, 155, 219}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 121, 55}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 30, 151, 249, 186}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 203}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 59, 172, 175}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 100, 181}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 243, 174}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 41, 194, 226}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 110, 94, 59}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 187, 160, 156, 146}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 53, 178}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 241, 78, 166}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 69, 147, 1, 55, 190}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 5, 242}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 65, 18}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 232, 184, 6, 66}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 131, 160, 247, 47}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 225, 177, 52}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 92, 255}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 60, 22}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 121, 45, 34}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 248, 241, 16, 29, 34}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 46, 177, 221, 2}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 147, 150}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 209}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 11, 84, 132, 22, 173}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 158, 180}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 169, 171, 254, 244}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 90, 144}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 76, 208, 177, 174, 240}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 138}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 121}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 22, 69, 139, 185}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 229}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 73, 66, 195, 126}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 106, 213, 199}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 130}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 7, 122}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 70}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 89}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 95}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 129, 55, 82, 179, 110}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 190}, 16},
	{{58, 186, 106, 58, 124, 171, 53, 85, 33, 100, 64, 0, 0, 0, 0, 0}, 16},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 27}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 35}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 83}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 149}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 26}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 118}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 4}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 180, 32}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 117}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 122}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 214, 195}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 69}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 47}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 132}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 182}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 162}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 45}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 211}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 17}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 124}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 35}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 168}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 71}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 5, 39}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 144}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 105, 121}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 111}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 199}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 156}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 142}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 126}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 200}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 156}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 112}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 162}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 216}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 247}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 2}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 83}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 170}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 23}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 231, 150}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 52}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 187}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 197}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 15}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 179}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 75}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 99}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 0}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 109}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 172}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 247}, 167},
	{{7, 195, 22, 31, 62, 217, 209, 46, 90, 49, 189, 50, 168, 126, 0, 185}, 167},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 154, 85, 221, 28, 120, 143, 55}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 90, 40, 123, 95, 133}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 154, 107, 188, 99, 38, 60}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 236, 252}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 155, 34, 21, 4, 166}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 213, 14}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 164}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 229, 91, 123, 101, 177, 119, 121}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 218, 50, 150, 152, 3, 235}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 250, 177, 192, 195, 156, 144}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 138, 152, 116}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 245, 79, 188}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 46, 75}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 96, 188, 123, 6}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 189, 242, 186, 212, 160, 44}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 52}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 44, 255, 149}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 9, 49, 207, 122, 73, 29, 196}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 91, 107, 33, 136, 215, 13}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 95}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 238, 114, 122, 167, 29}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 147, 33, 43}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 2, 177, 16, 95, 7}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 142, 22, 88}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 82, 74, 10, 113}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 215, 218, 16, 155}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 88, 252, 163, 125, 102, 44}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 126}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 117}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 35, 12, 227}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 171, 82, 123, 51, 155, 203}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 122, 212}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 86}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 188, 90, 180, 17}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 103}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 81, 225, 252, 116, 87}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 254, 53, 234, 183, 213, 83}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 207, 58, 159, 142, 62, 43, 225}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 104, 186}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 106, 55, 122, 137, 72, 187, 179}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 162, 91, 118, 216, 137, 145, 132}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 97, 195, 206, 66, 46, 114}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 222, 13, 226, 45, 246}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 127, 170, 41}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 244, 76, 201, 10, 200, 86}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 222, 225, 109, 35, 2}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 197, 29, 234}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 10, 186, 76, 238, 48}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 89}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 130, 0, 5, 122}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 248, 126, 14, 104}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 234, 165}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 181, 82, 186}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 50, 110}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 179, 250, 238, 253}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 78, 46, 171, 104, 249, 143}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 175, 209, 80}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 42, 164, 149}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 38, 69, 106}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 225, 208, 248, 244}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 62, 203, 15, 184}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 179, 68, 84, 112}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 198, 81, 215, 243, 33, 122}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 247, 25}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 198, 142, 75, 137, 3}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 205, 17, 106, 33}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 185, 217}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 41, 79}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 219, 222, 63, 229, 50, 23, 231}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 36, 201, 242, 231, 80, 12}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 137, 116}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 235, 132, 94}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 116, 62, 92}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 203, 92, 84, 225}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 99, 122, 40, 122, 38, 20}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 253, 63}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 163, 74, 91, 102}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 171, 110, 2, 32, 155, 86, 71}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 137, 107, 139, 99, 102, 220}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 71, 242, 190, 242, 149, 163}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 68, 107, 129, 128}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 115, 114, 210, 117, 228, 82}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 190, 169, 102, 72}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 33, 82, 129}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 192}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 124, 95}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 139, 188, 120, 11, 161}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 91, 103, 18}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 247, 30, 66, 115}, 148},
	{{92, 44, 159, 198, 185, 94, 231, 177, 64, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{169, 108, 190, 162, 23, 39, 140, 0, 15, 226, 229, 13, 173, 237, 137, 52}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 102, 208}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 126, 137, 58, 86, 80, 117, 196, 227}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 131, 189}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 146, 203}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 228, 78, 150}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 119, 221, 180, 203, 179, 49}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 64, 88, 21, 148, 201}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 35, 177, 142, 140, 196, 81, 13, 237}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 201, 27}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 103, 192, 13, 155, 67, 10, 55}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 68, 165, 143, 248}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 51, 150, 81, 105}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 26, 66, 52, 75, 110, 73, 152}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 100, 240, 195, 230}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 44, 231, 109, 85, 234, 125}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 223, 105, 21, 170}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 208, 74, 191, 107, 116, 149, 52, 232}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 102, 241, 223, 72, 85, 98, 18, 194}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 119, 219, 235, 99, 253}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 85, 39, 73, 50, 136, 23, 84}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 54}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 236}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 91, 163, 81, 172, 28, 111}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 37, 168, 155, 210, 70, 254, 42}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 142, 40, 126, 140, 217, 139}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 10, 125, 215, 67, 200}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 86, 99, 106, 162, 182}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 10, 190, 50, 60, 245}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 140}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 236, 14}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 8, 161}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 219, 236, 127, 22, 157, 143, 219}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 252, 247, 13, 74, 48}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 43, 61, 43, 127, 88, 227, 4, 34, 202}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 219, 114}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 97, 182, 56, 87, 84}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 20, 199, 101, 78, 230, 129, 154}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 13, 89, 162, 177, 175, 92, 197, 14}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 249, 13, 63, 90, 221}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 225, 187}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 210, 93, 243, 76, 228, 186, 193}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 36, 175, 13, 221, 5, 68, 92}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 125, 211, 62, 132, 210, 88, 140, 125}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 81, 107, 112, 111, 242, 47, 147}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 65, 119, 202, 211}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 139, 65, 232, 61, 210, 246, 41, 27}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 243, 203}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 210, 184, 117, 156, 18}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 246, 10, 81, 19, 221, 28}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 207, 100, 9, 131, 206, 85, 135, 246, 7}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 127}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 90, 39, 227, 239}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 125, 2, 248, 113, 149, 196}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 154, 185, 221, 173, 247}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 208, 54, 189, 235}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 63, 108, 55, 70, 93, 138, 194, 235}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 1, 53, 8, 239, 179}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 3, 128, 201}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 133, 232, 108, 27, 171}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 140, 173}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 55, 82, 112, 47, 99, 145, 175}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 66, 80, 26, 219, 37, 219, 15, 205}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 155, 73, 93}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 80, 159, 154, 159}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 14, 97, 134, 235}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 186, 111, 155, 56, 235, 111, 194, 10}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 245, 89, 35, 88}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 20, 147}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 221, 18, 238}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 60, 117, 216, 109, 62}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 203, 34, 48, 104, 223}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 75, 39, 55, 233, 164}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 214, 94, 2, 57, 11}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 159, 223, 77}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 73, 23, 236, 176, 147}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 233, 145}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 106, 235, 162}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 52, 198, 101, 39, 249, 245, 39}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 0, 0, 145, 196, 141}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 237, 235, 42, 171, 190, 90}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 9, 14, 175, 67, 91}, 66},
	{{169, 108, 190, 162, 23, 39, 140, 0, 0, 0, 0, 161, 59, 37, 87, 106}, 66},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 81}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 51}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 176}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 228, 196}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 111}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 140, 140}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 130}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 84}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 128, 212}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 10}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 252, 233}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 76, 104}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 209}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 197}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 204, 92}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 116}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 109}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 76}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 42}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 70}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 63}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 248, 54}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 41, 204}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 97, 250}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 4, 191}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 227}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 46, 249}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 32}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 180}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 249, 80}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 126}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 97, 82}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 203, 149}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 39}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 78, 131}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 165}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 68}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 68, 45}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 23, 5}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 138, 72}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 230, 108}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 145}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 49, 129}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 109}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 189}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 54, 72}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 38, 146}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 74}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 49, 80}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 245, 160}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 19}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 239}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 89, 95}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 89, 183}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 68, 126}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 216, 72}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 32, 213}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 169}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 243, 202}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 145}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 57, 120}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 114, 177}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 187, 202}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 235}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 244}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 250}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 193}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 164, 87}, 70},
	{{161, 5, 3, 11, 158, 157, 166, 212, 246, 22, 140, 101, 92, 0, 0, 0}, 70},
	{{71, 191, 0, 0, 0, 0, 0, 20, 45, 115, 229, 107, 54, 22, 139, 140}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 57, 230, 44, 198, 62, 8}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{71, 191, 0, 0, 140, 136, 4, 228, 22, 207, 248, 21, 68, 96, 66, 196}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 33, 180, 166, 72}, 166},
	{{71, 191, 0, 11, 123, 197, 97, 182, 125, 179, 20, 223, 223, 170, 219, 105}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 51, 131, 148}, 166},
	{{71, 191, 0, 185, 193, 33, 75, 168, 121, 123, 112, 60, 144, 236, 143, 190}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 150, 122, 192}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 102, 149, 233, 170, 225, 166, 161, 31, 6}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 106, 227, 184, 14, 131, 46, 57, 19}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 161, 4}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 213, 227, 45, 55, 55, 30}, 166},
	{{71, 191, 0, 0, 0, 0, 168, 212, 122, 93, 6, 152, 236, 238, 11, 193}, 166},
	{{71, 191, 0, 0, 0, 22, 41, 38, 168, 151, 160, 18, 49, 169, 184, 189}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 197, 6, 87, 253, 2, 85}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 3, 61, 156, 84, 5, 51, 60}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 20, 91, 166, 95}, 166},
	{{71, 191, 0, 0, 0, 0, 64, 51, 213, 170, 122, 92, 158, 133, 73, 7}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{71, 191, 0, 0, 0, 28, 149, 20, 167, 9, 12, 22, 113, 50, 218, 153}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 177, 137, 150, 241, 240, 153}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 166},
	{{71, 191, 0, 0, 0, 0, 213, 215, 173, 149, 23, 93, 9, 243, 186, 98}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 247}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 176, 179, 9}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 53, 162, 204, 59, 53, 61, 216, 39, 225}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 69, 187, 144, 199, 230, 82}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 175, 25, 246, 134, 116, 206}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 1, 11, 199}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 84, 27, 32, 79, 171, 99}, 166},
	{{71, 191, 0, 130, 72, 183, 3, 26, 67, 244, 115, 40, 6, 173, 142, 145}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 253, 236, 162, 41}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 90, 84, 12, 1, 170, 47, 215}, 166},
	{{71, 191, 0, 227, 139, 29, 2, 44, 233, 150, 72, 247, 27, 121, 57, 96}, 166},
	{{71, 191, 0, 188, 97, 149, 63, 162, 145, 242, 173, 173, 55, 148, 30, 101}, 166},
	{{71, 191, 0, 0, 62, 246, 183, 31, 106, 7, 227, 89, 39, 107, 218, 129}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 107, 216}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 43, 182}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 236, 125, 136, 53, 49, 24, 108}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 118, 209, 114, 119}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 190, 132, 76, 108, 112, 136, 7, 170, 15}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 247, 61, 40, 151, 82, 20}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 252, 228, 124, 80, 209, 54}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 228, 34}, 166},
	{{71, 191, 0, 0, 41, 111, 81, 1, 191, 81, 174, 209, 213, 79, 188, 205}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 79, 226, 113, 6}, 166},
	{{71, 191, 0, 195, 153, 178, 208, 209, 208, 127, 222, 76, 33, 149, 155, 117}, 166},
	{{71, 191, 0, 0, 0, 27, 99, 114, 42, 119, 152, 168, 120, 102, 28, 31}, 166},
	{{71, 191, 0, 210, 201, 210, 204, 59, 238, 181, 142, 238, 110, 158, 175, 200}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 231, 77, 161, 120, 198, 92, 159, 135, 58}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 133, 76, 36, 233, 101, 227}, 166},
	{{71, 191, 0, 0, 0, 0, 155, 139, 129, 142, 61, 27, 27, 204, 215, 223}, 166},
	{{71, 191, 0, 0, 192, 16, 233, 176, 65, 197, 232, 46, 46, 237, 138, 144}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 5, 93, 91, 43, 235, 66, 49}, 166},
	{{71, 191, 0, 115, 56, 42, 183, 79, 105, 225, 177, 229, 206, 154, 137, 53}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 198, 144, 151, 106, 153, 0, 192}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 88, 4}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 105}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 26, 91, 119, 150, 104, 199, 220, 175}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 203, 162}, 166},
	{{71, 191, 0, 0, 0, 21, 209, 23, 115, 141, 159, 57, 48, 254, 148, 13}, 166},
	{{71, 191, 0, 0, 0, 104, 229, 215, 25, 110, 103, 149, 76, 101, 216, 231}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 149, 27}, 166},
	{{71, 191, 0, 0, 0, 0, 247, 50, 30, 33, 28, 53, 233, 53, 37, 87}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 178, 36, 239, 31}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 118, 83, 207, 158}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 13, 171, 255, 68}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 21, 241, 134, 145}, 166},
	{{71, 191, 0, 48, 249, 252, 152, 78, 59, 255, 123, 168, 179, 108, 172, 79}, 166},
	{{71, 191, 0, 0, 203, 229, 130, 93, 22, 214, 237, 110, 42, 61, 110, 12}, 166},
	{{71, 191, 0, 0, 0, 220, 251, 232, 162, 56, 36, 51, 64, 69, 192, 183}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 142, 125, 203, 22, 78, 46, 245, 118, 68}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 137, 137, 209, 179, 69, 96, 76, 53}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 212, 202, 66, 131, 83, 35, 127, 33, 154}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 175}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 34, 148, 228}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 49, 94, 103, 167, 235, 64}, 166},
	{{71, 191, 0, 0, 0, 86, 153, 210, 61, 9, 112, 124, 40, 119, 22, 218}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 111, 155}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 134, 82}, 166},
	{{71, 191, 0, 176, 212, 100, 225, 118, 155, 171, 66, 111, 235, 145, 166, 71}, 166},
	{{71, 191, 0, 0, 0, 22, 44, 228, 45, 40, 48, 44, 85, 60, 232, 53}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 8}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 108, 163, 42, 122, 34, 36, 2}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 30, 190, 163, 81, 178, 245, 204, 161, 16}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 49, 139}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 37, 146, 14, 154, 129, 22, 100, 153}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 115}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 240, 191}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 26}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 197, 26, 229, 12, 245, 178, 137, 23, 155}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 191, 11, 197, 51, 226, 54, 162, 78, 63}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 34, 158, 136, 220}, 166},
	{{71, 191, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 177}, 166},
	{{48, 136, 194, 145, 57, 96, 80, 19, 231, 36, 35, 106, 118, 10, 202, 104}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 159, 27, 201, 183, 66, 143, 98}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 212, 155, 214, 237, 49, 226, 83}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 191, 27, 138, 201, 239}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 129, 225, 143, 240, 64, 144, 50, 243}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 207, 7, 254, 155, 110, 46}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 111, 53, 58}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 87, 116, 140, 79, 93, 196, 88, 111}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 5, 32, 153}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 75, 150, 204, 195, 224, 223, 20}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 99, 232, 122, 126, 34, 190, 217, 24, 206}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 124, 171, 74, 127, 77, 210, 181, 16, 153}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 40, 32, 49, 26, 27, 81}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 99, 100, 154, 85}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 68, 148, 3, 84}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 224, 141, 21, 82}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 107, 84, 85, 27, 155, 48, 196}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 177, 25, 249, 134, 99}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 42, 87, 21, 244, 166, 242, 116, 10}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 239, 121, 230, 166, 226, 7, 199, 63}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 151, 18, 239, 46, 32, 145, 197}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 43, 95, 45, 227}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 177, 178, 118, 236}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 149, 22, 101, 147, 206, 43, 140, 13, 189}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 40, 161}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 86, 193}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 202, 227, 2, 10, 70, 62, 154, 212, 106}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 207, 7, 162}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 250, 161, 92, 89, 80, 35, 82}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 194, 237, 72, 31, 234, 0, 211, 213}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 163, 4, 152, 0, 99, 204, 14, 183, 191}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 159, 124, 239, 153, 109, 214}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 135, 143, 232}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 178, 177, 213, 1, 203, 113, 90, 250, 109}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 138, 205, 250, 243, 245}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 205, 25, 71}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 163, 222, 123, 255, 36, 44, 111}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 147, 158, 183, 220, 2, 114}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 1, 225, 15, 42, 196, 57, 175}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 94, 183}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 46, 158, 53, 66, 160, 253, 135}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 170, 16, 98, 184, 183, 187, 112}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 226, 56, 255, 108, 159, 225}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 99, 63, 117, 251, 204, 254, 251}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 189, 14, 133, 72, 173, 156, 26, 171}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 214, 197}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 236, 174}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 12, 227, 191, 131, 120, 67}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 218, 6, 176, 166, 59, 0}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 50, 67, 35, 253, 41, 215, 114, 239}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 199, 143, 116}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 209, 140, 32, 192, 12}, 109},
	{{48, 136, 194, 145, 57, 96, 131, 29, 225, 88, 220, 83, 241, 38, 135, 15}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 75, 157, 201, 113, 63, 236, 43, 143}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 169, 116, 213, 180, 65}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 57, 239, 164, 127, 122, 109, 196, 166, 147}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 243, 102, 195, 1, 2, 149, 167}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 72, 10, 235, 153, 129}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 210, 90}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 99, 75, 6, 134, 8, 67}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 236, 231, 203}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 41, 53, 179, 141, 90, 163, 223}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 154, 114, 74, 106, 89, 90}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 21, 2}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 169, 210, 247, 21, 110, 2}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 132, 87}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 154, 124, 132, 74, 204, 192}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 2, 48, 168, 7, 145}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 82, 105}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 38, 30, 157}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 124, 148, 77}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 124, 143, 46, 34, 241, 153, 133}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 108, 241}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 175, 181, 16, 27, 44, 194, 150, 252, 167}, 109},
	{{48, 136, 194, 145, 57, 96, 161, 167, 101, 29, 184, 69, 31, 90, 243, 84}, 109},
	{{48, 136, 194, 145, 57, 96, 69, 235, 255, 186, 86, 54, 175, 187, 119, 191}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 160, 116, 214, 222, 143}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 199, 41, 201, 32, 5, 254}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 153, 33, 153}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{48, 136, 194, 145, 57, 96, 0, 0, 0, 0, 0, 0, 0, 0, 29, 73}, 109},
	{{48, 136, 194, 145, 57, 96, 194, 214, 187, 191, 81, 106, 166, 148, 159, 179}, 109},
	{{144, 0, 0, 0, 0, 0, 0, 0, 9, 28, 221, 7, 65, 147, 59, 215}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 40, 75, 178}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 226},
	{{144, 243, 39, 36, 13, 248, 104, 36, 190, 176, 9, 44, 53, 242, 88, 177}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 142, 54, 3, 254, 29}, 226},
	{{144, 0, 0, 54, 117, 170, 217, 171, 252, 59, 133, 105, 217, 122, 54, 52}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 13, 85, 27}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 92, 175, 41, 45, 136, 61, 239, 41, 113}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 199, 44, 234}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 43, 142}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 197, 21, 172, 50, 30, 237, 79}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 197, 137, 125, 240}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 165, 74, 235, 71, 244, 45, 202, 197, 189}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 181}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 87, 191, 51, 226, 237, 89, 13}, 226},
	{{144, 0, 0, 0, 0, 112, 93, 153, 246, 255, 163, 4, 37, 118, 237, 21}, 226},
	{{144, 0, 0, 166, 237, 67, 93, 64, 186, 1, 196, 170, 253, 144, 175, 48}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 68, 236, 248, 152, 251, 139, 63, 134, 27}, 226},
	{{144, 0, 0, 0, 21, 217, 220, 179, 173, 234, 141, 92, 248, 55, 250, 198}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 197, 154, 246, 182, 11, 50, 87, 211, 170}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 112, 212, 97, 16, 146}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 230, 44, 218, 87}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 218, 8, 179, 188, 57, 77, 214}, 226},
	{{144, 16, 176, 102, 189, 18, 112, 0, 37, 231, 59, 93, 96, 128, 49, 45}, 226},
	{{144, 0, 0, 0, 0, 151, 254, 198, 89, 222, 24, 132, 108, 131, 138, 1}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 54, 86, 30}, 226},
	{{144, 0, 0, 93, 181, 152, 191, 133, 120, 137, 183, 166, 19, 225, 132, 89}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 47, 84, 124, 30}, 226},
	{{144, 213, 73, 22, 137, 91, 78, 5, 53, 35, 77, 122, 41, 91, 254, 228}, 226},
	{{144, 0, 0, 0, 0, 0, 253, 203, 110, 65, 167, 161, 23, 40, 181, 120}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 232, 77}, 226},
	{{144, 0, 0, 0, 212, 67, 138, 142, 52, 68, 14, 32, 81, 71, 20, 86}, 226},
	{{144, 0, 0, 0, 44, 36, 248, 50, 68, 38, 243, 152, 84, 197, 136, 106}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 156, 237, 53, 159}, 226},
	{{144, 0, 0, 0, 0, 66, 239, 66, 41, 232, 1, 229, 95, 105, 207, 218}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 214, 229}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 27, 143}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 177}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 170}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 151}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 238, 87, 106, 40, 182, 61, 150, 140}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 200}, 226},
	{{144, 0, 0, 0, 184, 142, 54, 107, 194, 29, 206, 96, 214, 14, 67, 74}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 114, 230, 95, 35, 142, 93, 54}, 226},
	{{144, 0, 0, 0, 20, 135, 17, 118, 18, 8, 40, 242, 169, 80, 220, 16}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{144, 0, 0, 188, 156, 210, 253, 165, 30, 113, 49, 146, 138, 189, 247, 9}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 213}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 171, 131}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 191}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 167}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 230, 181}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 49, 254, 234, 100, 150}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 40, 49, 97, 157, 160, 244, 67, 255}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 122, 72, 21, 196}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 24, 39, 206, 89, 212, 219, 214, 211}, 226},
	{{144, 0, 0, 0, 164, 167, 32, 15, 82, 131, 54, 66, 241, 95, 22, 19}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 157}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{144, 0, 0, 0, 12, 192, 136, 150, 128, 253, 12, 236, 209, 217, 12, 4}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 146, 161, 106, 37}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 242, 224, 21}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 255, 132}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 184, 154, 232, 227}, 226},
	{{144, 0, 0, 0, 0, 0, 45, 187, 97, 46, 161, 80, 166, 212, 10, 145}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 11, 244, 188, 176, 222}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 247, 82, 113, 150, 63, 123, 164}, 226},
	{{144, 0, 0, 0, 0, 191, 246, 161, 81, 166, 87, 160, 137, 149, 214, 111}, 226},
	{{144, 0, 0, 0, 60, 80, 21, 82, 223, 6, 241, 194, 93, 156, 194, 183}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 236, 70, 190, 11, 52}, 226},
	{{144, 212, 49, 208, 189, 121, 131, 232, 35, 77, 161, 213, 81, 247, 17, 112}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{144, 0, 0, 0, 0, 0, 159, 80, 43, 115, 39, 225, 213, 233, 162, 115}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 128, 83, 176, 62, 234}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 17, 87}, 226},
	{{144, 0, 0, 0, 0, 202, 132, 248, 237, 149, 181, 204, 80, 138, 151, 105}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 67, 96, 42, 53, 157, 63, 183, 203, 109}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 223}, 226},
	{{144, 0, 0, 241, 35, 160, 119, 11, 163, 189, 111, 2, 5, 113, 187, 179}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 198, 216, 65, 123, 121}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 252, 244, 157, 244, 164}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 118, 137}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 210, 0, 37, 105, 5}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 213, 230}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 54, 143, 43, 0, 148, 53, 215, 124}, 226},
	{{144, 0, 19, 185, 7, 1, 95, 237, 60, 187, 13, 178, 150, 147, 228, 61}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 244, 39, 122, 39, 134, 227, 113}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 107, 119}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 120, 205}, 226},
	{{144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 226, 72, 81, 51}, 226},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 255, 154, 172, 151}, 8},
	{{223, 209, 10, 57, 0, 0, 59, 245, 4, 99, 191, 121, 108, 184, 222, 175}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 120, 9, 86, 90, 93, 198, 150}, 8},
	{{223, 209, 10, 57, 0, 0, 223, 46, 81, 158, 53, 242, 142, 105, 31, 16}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 33, 124, 93, 198, 125, 72}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 16, 187, 159, 197, 219, 231, 214}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 32, 117, 174, 0, 137, 188, 186, 122, 15}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 165, 151, 204, 207, 29, 86, 117, 122}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 158, 92, 100, 162, 81, 227}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 239, 167, 158, 6, 128}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 64, 15, 132, 220, 159, 255, 219, 22}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 194, 194}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{223, 209, 10, 57, 0, 237, 231, 168, 199, 216, 160, 229, 149, 9, 199, 128}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 47, 252, 64, 112, 255, 92, 38}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 5, 83}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 22, 20, 8, 87}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 126, 101, 63, 40, 200, 203, 232, 122}, 8},
	{{223, 209, 10, 57, 0, 0, 111, 209, 66, 216, 217, 221, 225, 123, 202, 58}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 140, 212}, 8},
	{{223, 209, 10, 57, 0, 101, 3, 189, 241, 59, 249, 140, 67, 123, 108, 247}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 100, 234, 188, 23, 234, 104}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 16, 62}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 56, 125, 208, 67, 130, 148}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 62, 231, 7, 58}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 71, 252}, 8},
	{{223, 209, 10, 57, 0, 19, 110, 27, 74, 236, 95, 46, 38, 97, 11, 43}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82}, 8},
	{{223, 209, 10, 57, 0, 0, 74, 26, 205, 137, 215, 177, 109, 103, 145, 34}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120}, 8},
	{{223, 209, 10, 57, 0, 119, 134, 45, 150, 122, 219, 32, 135, 28, 63, 51}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 8},
	{{223, 209, 10, 57, 0, 0, 37, 247, 139, 87, 126, 131, 33, 240, 230, 170}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 200, 125, 183, 222, 48}, 8},
	{{223, 209, 10, 57, 0, 24, 43, 171, 85, 158, 240, 213, 150, 92, 206, 123}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 85, 137, 112, 159, 31, 132, 233, 13, 194}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 194, 218, 68, 124}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 92, 101, 218, 107, 38, 8, 224, 54}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 50, 4}, 8},
	{{223, 209, 10, 57, 0, 34, 125, 199, 102, 161, 190, 186, 14, 52, 70, 180}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 152, 200, 69, 0, 107, 166}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{223, 209, 10, 57, 0, 58, 133, 138, 29, 160, 2, 57, 131, 88, 192, 105}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 146, 254, 94, 42, 87, 54, 175, 4, 125}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 14, 20, 206, 3, 210, 111}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 131, 154, 195, 60, 249, 124, 254}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250}, 8},
	{{223, 209, 10, 57, 0, 0, 227, 41, 114, 126, 46, 86, 178, 218, 161, 37}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 160, 164, 200, 13, 206, 21, 139}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 32, 183, 20, 150, 78}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 108, 132, 48, 161, 245}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 131, 111}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 157, 102, 106, 196}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 205, 174, 92, 249, 204, 48}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 94, 198, 83, 219, 164, 52}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 84, 234, 129, 233, 194, 93}, 8},
	{{223, 209, 10, 57, 0, 0, 142, 172, 57, 66, 81, 147, 41, 53, 163, 179}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 110, 68, 173, 254, 199, 102, 111}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 254, 168, 129, 50, 11, 118, 79, 191, 73}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 248, 190, 149, 237, 76, 195, 171}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 196}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 118, 146}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 236, 116, 38, 71, 204}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{223, 209, 10, 57, 0, 0, 219, 46, 8, 25, 242, 64, 43, 211, 141, 101}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 118, 172, 72, 49, 2}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 49, 157, 221, 207}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 94, 100, 228, 202, 97, 70, 229, 216, 193}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 36, 125, 235, 199, 184, 66}, 8},
	{{223, 209, 10, 57, 0, 139, 14, 208, 115, 221, 252, 64, 55, 107, 221, 176}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 242, 244, 235, 218, 109, 175, 96, 19, 72}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 195}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 210, 14, 62, 71, 237}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 151, 8, 105, 204, 115, 202}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 240, 250}, 8},
	{{223, 209, 10, 57, 0, 113, 10, 217, 0, 91, 18, 82, 139, 47, 246, 225}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 237, 127, 204, 228}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 220, 203, 175, 25}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 48, 216, 11, 132, 254, 108, 70, 171}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 50, 118, 226, 144, 231}, 8},
	{{223, 209, 10, 57, 0, 0, 149, 17, 57, 50, 24, 87, 40, 139, 110, 105}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 187, 103, 115, 127, 231, 236, 48, 225}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 63, 139, 217, 201}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 115}, 8},
	{{223, 209, 10, 57, 0, 0, 0, 0, 0, 0, 0, 3, 99, 141, 125, 182}, 8},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 39, 120, 138}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 251, 82}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 47, 230}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 134, 98, 207, 73}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 228, 7}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 83}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 81, 41, 43, 96}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 217, 227, 70, 201}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 113, 191, 102}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 45, 221, 212}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 157, 167, 41}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 47, 235, 207, 27}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 123}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 166}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 130, 96, 104}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 105, 161, 47}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 72, 155, 11}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 109, 84}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 175, 71}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 136, 86, 30}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 126, 78, 74, 73, 174}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 11, 10, 65}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 89, 115, 90, 38}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 170}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 169, 119}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 177, 23, 53, 96}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 14, 31, 6}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 142, 142, 168, 124}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 53, 141, 232}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 2, 137}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 74, 165, 195}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 35, 207, 153}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 185, 98, 17}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 152, 79, 180}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 14, 238, 6, 224}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 167, 123}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 109, 82}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 159, 100, 126}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 83, 6, 118, 37}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 149, 210, 55, 52}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 24}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 58}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 246, 245, 50}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 23, 60}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 232}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 60, 123, 175, 203, 254}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 175, 100, 101}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 138, 229, 166}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 62}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 159, 102}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 227, 102, 22, 147}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 23, 90}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 111, 20, 67, 3, 57}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 140, 104, 85, 245}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 161, 68}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 12, 62, 164, 148, 16}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 102, 14, 91, 119}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 189, 228, 229}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 8, 8, 95}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 148, 219}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 116, 22}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 15, 68}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 196, 195}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 187}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 200, 10}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 110, 4, 16, 64, 51}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 130}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 71, 6, 83}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 170, 114, 29, 152}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 136, 223}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 205, 242, 39, 149}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 96, 192, 194, 167}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 173, 128, 95, 216}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 97, 244, 73, 210}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 116}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 1, 51, 30, 70}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 82}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 167, 17, 96}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 22}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 212}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 0}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 180, 124, 232}, 218},
	{{154, 79, 170, 9, 43, 139, 249, 176, 186, 72, 216, 0, 0, 0, 0, 40}, 218},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 195}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 100, 211}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 236, 109, 40, 70, 152}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 58, 114}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 103, 76, 116, 76, 41}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 86, 146}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 54, 181}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 148, 40, 40, 235, 154}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 62, 255, 255, 39, 26}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 177, 162, 17}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 54, 56}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 223, 86}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 234, 86, 190, 104}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 191, 23, 181, 54}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 104, 167, 220, 88}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 161, 17, 123, 170}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 1, 131}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 244, 89}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 123, 55, 205, 105}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 132, 138, 220, 41}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 216, 18}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 168, 114}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 187, 190, 7, 97, 174}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 35}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 19, 84, 199}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 107, 132, 142, 203, 136}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 199, 148, 121}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 222, 125}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 154, 141}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 230, 211, 180, 144}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 211, 46, 229, 57, 13, 250}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 196, 129}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 174, 76}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 154, 219, 70}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 1}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 19}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 36, 185, 230, 28}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 132, 95, 109}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 214, 229, 192, 120, 37, 216}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 234}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 37, 77, 225, 207}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 99, 11, 135}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 119, 53, 192, 175, 153}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 40, 26, 118, 45}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 75, 18, 29, 135}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 85, 160, 121, 242}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 180}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 240, 117, 20}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 243}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 77, 133, 98, 46}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 83, 47, 253}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 70, 59, 191}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 72, 94}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 81, 155, 219, 144}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 177, 199, 201, 137, 156}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 78, 4, 91}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 166, 151, 214}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 208, 130, 230, 188}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 226, 209}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 140, 248, 227}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 199, 130, 139, 121, 80}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 230, 183, 151}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 191, 93, 129}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 163, 218, 173, 243, 216}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 42, 155}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 163, 188}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 140, 111, 187, 236, 149}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 222, 30, 123}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 145, 83}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 35, 169}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 128}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 157, 124}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 47, 170, 249, 188}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 4, 245, 239, 177, 24, 201}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 167, 48}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 146, 210, 58, 55, 224}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 158}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 0}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 122, 132, 137, 39, 19}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 84}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 224, 27, 37, 1, 26}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 12, 73}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 103, 241, 87, 214, 172}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 126, 41, 214}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 0, 0, 0, 0, 203}, 54},
	{{1, 8, 123, 205, 167, 134, 128, 102, 10, 72, 0, 86, 68, 178, 166, 13}, 54},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 33, 126, 190}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 137, 78, 4, 164, 17}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 21, 27, 106}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 106, 217}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 97, 42, 225}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 30, 89, 131, 80, 52, 225, 57}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 178}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 214, 104, 1, 254, 194}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 66, 203}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 216, 79}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 152, 178}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 178, 173, 94, 34, 77, 74}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 114, 9, 178, 64, 190, 202}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 222, 129, 47, 52}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 2, 217, 65, 113, 219, 185, 126}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 151, 164, 212, 249, 127, 126}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 216}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 30, 167, 216, 200}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 63, 58}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 237, 178, 159, 38, 3, 44}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 163, 177, 162, 62}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 168, 91, 197, 71, 249}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 223, 135, 143, 89, 87, 168, 143}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 86, 197, 42, 194}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 241, 187, 56}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 48, 229, 78, 87, 67, 219}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 79, 214, 118, 210, 149, 136}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 245, 73, 166, 151, 171, 31}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 147, 155, 118, 185, 13}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 142, 104, 70, 109}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 151, 211, 240}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 202, 182, 50, 60}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 177, 211, 197, 145, 65, 204}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 116, 233, 10, 97}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 16, 98, 180}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 220, 228, 182, 125, 244, 176}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 188}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 99, 122, 47, 31, 68, 5, 136}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 50, 74, 73, 61, 81, 96, 208}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 8, 86, 114}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 102, 223, 135}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 146, 201, 191}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 149, 106, 223, 40, 62}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 149, 51, 57, 124, 26}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 95, 56, 255}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 200, 83, 225, 245, 138, 231}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 152}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 29}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 240}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 138, 105, 57, 105}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 213, 154, 152, 251, 129, 91}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 142, 250, 236, 177, 133}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 144, 23, 3, 139, 113, 149, 56}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 145}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 166, 227, 95, 242, 208}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 134}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 20, 57, 134, 112, 211, 76}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 57, 244, 255, 15, 223}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 16, 52, 85}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 187}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 40}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 94, 207, 106}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 196}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 237, 162, 125, 8}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 21, 18, 120, 11, 169}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 71, 211, 45}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 161, 212}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 124, 205, 132, 185, 234, 237, 234}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 148, 231, 204, 27, 170, 33, 161}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 114, 57, 146, 39, 16, 70}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 147, 101, 149, 169}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 181, 158, 19, 2, 171, 245, 94}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 140, 162, 199}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 162, 70, 239, 14, 245}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 241, 205}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 161, 240, 49, 142, 7}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 235, 195, 3}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 243, 156, 251, 199, 187, 24}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 120, 217, 0, 51}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 70, 114, 88, 176, 135}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 196, 167, 144}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 175, 229, 121, 81, 212}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 10}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 250}, 48},
	{{31, 105, 48, 77, 103, 187, 99, 67, 96, 0, 0, 0, 0, 0, 0, 51}, 48},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 128, 190, 47, 239}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 199, 222, 23, 216, 10, 34}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 53, 208, 239, 65, 22}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 120, 254, 194, 92}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 133, 76}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 25, 60, 32}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 254, 5, 26, 27, 145, 119, 191, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 53, 80, 71, 211, 48, 96, 131}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 236, 210, 97, 60, 56, 237, 21}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 205, 196, 147, 101, 5, 28, 2, 149}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 142, 146, 232, 218, 152, 222, 56, 67}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 230, 166, 96}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 59, 129, 158, 204, 142, 121, 221}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 177, 220, 24, 100, 31, 99}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 52, 85, 68}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 45, 211, 9}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 248, 55, 131, 59, 24, 152, 45}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 17, 254, 90, 225, 46}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 186, 215, 236}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 77, 181, 217, 218, 159}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 41, 97}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 226, 251, 74, 37, 91, 171, 3}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 244, 173, 51, 116, 190, 40, 197}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 191, 177, 223, 134}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 132, 166, 95, 74}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 127, 115, 249, 8, 193, 128, 10}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 65, 26}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 145, 156}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 88, 2}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 118, 89, 14}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 207, 112, 82, 79, 221, 123, 2}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 255, 231, 220, 44}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 26, 31, 3, 232, 89, 30, 21, 242}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 239, 72, 49}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 200, 73, 245, 25, 240, 76}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 242, 124, 250}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 105, 169, 23}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 159, 105, 253, 127, 248, 21, 198}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 213, 186, 100}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 110, 141, 2, 75, 81, 140, 79, 149}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 224, 150, 19, 221, 135, 119, 121}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 199, 145, 98, 75, 158, 193, 111, 13}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 155, 128, 166, 198, 29, 136}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 113, 9, 18}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 234, 213, 240, 110, 64}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 77, 42}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 87, 244, 204, 50, 91}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 73, 21, 223, 154, 56, 81, 142, 223}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 45, 99, 198, 128, 214, 145, 90}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 65, 18, 233, 170, 239, 207, 162, 157}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 181, 176, 179, 82, 181, 174, 7, 121, 131}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 25, 167, 151}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 73, 181, 23, 206, 83}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 198, 199, 199, 119, 37, 155, 16, 80}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 238, 100, 60, 28, 122}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 64, 9, 132, 203, 22, 105, 241, 185, 212}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 78, 189}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 172, 0, 119, 219, 22, 110}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 215, 178}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 210, 150, 131, 189, 167, 64, 168}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 183, 209, 213}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 167, 189}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 167, 206, 43}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 22, 28, 72, 70, 150, 170}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 105, 109, 3}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 148, 203, 223, 99, 191, 220}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 100}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 30, 241, 188, 143, 185, 213, 124, 69}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 124, 225, 207}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 105, 15, 246, 149, 253}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 111, 121}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 62, 129, 220, 61, 188}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 110, 43, 197}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 226, 87, 78, 126, 64, 197, 13, 44}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 167, 234}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 116, 133}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 166, 184, 126, 164, 96, 11, 169, 150, 0}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 192, 200, 126, 132, 48}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 11, 37, 51}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 243, 190, 5}, 244},
	{{14, 73, 54, 76, 232, 35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 103, 168, 149, 126, 121, 170}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 241}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 62, 12, 231}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 63, 39, 163, 123, 10, 142}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 66, 86, 127}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 113, 75, 28, 170, 128, 234}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 235, 241, 85, 122, 19}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 8, 61, 252, 64}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 74, 109, 127}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 35, 100, 52, 240}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 47, 85, 44, 112}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 142, 21, 252, 175, 242}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 60}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 25}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 38, 73, 222, 167}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 92, 129}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 75, 248, 199, 198, 113}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 18, 64}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 104}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 69, 135, 146, 180, 212, 24}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 148, 75, 114, 52, 206}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 117}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 219, 244, 7}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 106, 143}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 132, 80, 39}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 55, 184, 236, 173, 176}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 248, 110}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 150, 91, 104}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 10, 226, 101, 132, 115}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 42, 65, 133, 216, 181, 140}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 52, 242, 111}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 167, 93, 203, 140, 242, 180}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 132, 137}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 169, 150, 25}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 72, 225, 42, 167}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 222, 154, 123}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 46, 100}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 169, 164, 233, 204, 84}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 37, 227, 171}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 168, 142, 40, 236, 56, 241}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 60, 229, 152, 151, 216, 211}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 176, 17, 217, 180, 124}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 150}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 26, 196, 69, 44}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 142, 55, 2, 144, 113}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 137, 2, 50}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 181, 42}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 115, 50, 122, 213, 197, 152}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 253, 163}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 182, 80, 227, 251, 215, 250}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 24}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 6, 210, 87, 101, 142}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 108, 227}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 195, 253, 84}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 1, 76, 65, 98, 222}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 105, 185, 43}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 210, 154, 229, 215}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 93, 222, 172}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 28, 17, 187}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 173, 230, 180, 3}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 23, 69}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 35, 140}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 122, 34, 61, 125, 55}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 88}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 78, 239, 182, 14}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 126}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 134, 27, 225, 13}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 113, 192, 56, 26}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 232, 251, 8, 64}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 107, 20, 127}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 80, 89, 197, 173, 243}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 244, 131, 10}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 140, 248}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 82}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 31, 184}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 190, 98, 86, 129, 231, 121}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 114, 128, 229, 147, 126, 172}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 93, 167}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 107, 141, 13}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 26, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 204}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 95, 108, 182}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 161, 182}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 191, 191, 183, 43, 180, 130}, 50},
	{{14, 109, 251, 190, 36, 253, 99, 120, 94, 64, 0, 0, 0, 0, 0, 0}, 50},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 27, 9, 221, 203, 82, 45}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 209, 123, 117, 144, 31, 182, 111, 236, 228}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 59, 183, 23}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 118, 49, 86, 27, 39}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 121, 71, 121, 61}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 221, 80, 28, 183, 196}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 189, 179, 165, 171, 215, 99, 222}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 43, 203, 224, 27, 78}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 52, 69, 90, 250, 116, 73, 164, 227}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 150, 215, 162}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 205, 255, 142, 69, 255, 126}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 126, 214, 29, 255, 154, 160, 248, 214}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 122, 87, 96, 130, 206, 141, 199, 202}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 119, 185, 97, 35, 90, 252, 16, 7}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 242, 12, 14, 94, 191, 156, 166, 10}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 136, 95, 187, 164}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 26, 253, 251, 249}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 246, 121, 244, 78, 211, 131, 98}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 226, 205, 137, 210, 184, 9}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 57, 151, 221, 15, 43, 78, 17}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 236}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 51, 166, 212}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 145, 109, 4}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 196, 192, 81, 177, 66}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 222, 106, 12, 235, 161, 122, 109, 192, 187}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 88, 26}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 102, 28, 249, 63}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 251, 159, 228, 145, 10, 152, 218}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 67, 110}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 155, 243, 73, 99, 110}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 57, 6, 99, 30}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 132, 30, 137, 134, 99, 204}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 20, 232, 91}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 107, 107, 253, 141}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 175, 41, 168, 226, 45, 119, 193}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 71, 236, 54, 162}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 168, 127}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 166, 192}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 100, 229, 158, 146, 211, 9}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 253, 44, 140, 36, 139, 174, 238, 8}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 238, 75, 128, 90, 192, 68, 192}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 93, 40, 194, 140, 152, 213}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 169, 89}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 205, 154, 121, 152}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 37, 127, 33, 175}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 168, 139, 255, 67, 7, 58, 11}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 115, 61, 128, 105, 42, 230, 75, 80}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 238, 51, 172, 129, 211, 225, 55}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 178, 133, 182, 80, 72, 233, 25}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 161, 114, 225, 116, 120, 170}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 71, 181, 86, 238, 165, 222, 130}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 50, 75, 95, 22}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 58, 254, 85, 213, 136, 1, 57, 199}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 59, 149, 125, 220, 138, 225, 21}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 59, 60, 3, 177, 187, 141, 203, 68}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 169, 8, 234}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 144, 104, 97, 63, 207}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 109, 167, 32, 94, 208, 1}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 36, 148, 32, 30, 155, 230, 101}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 38, 52, 158, 180}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 182, 157, 228, 190, 211, 217, 97}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 123, 93, 206, 79}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 252, 228}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 173, 59, 131, 92, 203, 166}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 26, 130, 44}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 182, 71, 253, 149, 166}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 111, 184}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 244, 72, 68, 47, 38, 110, 77, 228}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 90, 214, 61}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 49, 166, 223, 92, 54, 228, 122}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 203, 3, 202}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 126, 161, 209, 250, 80}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 46, 217, 171, 155, 148, 147, 165, 218}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 231, 226, 138, 57, 97, 152, 39}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 63, 18}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 126, 196, 162, 83}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 189, 177, 191, 156, 170, 152, 131}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 212, 179, 209, 80}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 100, 62, 78, 86}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 46, 21}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 158, 190, 174, 178}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 55, 221, 67, 130, 197, 35}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 162, 107, 58, 132, 253, 126, 36, 244}, 173},
	{{122, 170, 9, 134, 124, 91, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 173},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 44}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 111, 22}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 216, 26}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 194, 106}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 18, 115, 119}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 230}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 29}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 125, 35}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 129, 132, 129}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 86, 58}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 244, 85, 63}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 158}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 151}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 124}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 174, 203}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 29, 2, 9, 184}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 41}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 240}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 161}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 29, 100}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 113, 12, 253, 75}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 233}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 12, 5, 225, 12, 45}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 63, 60, 142, 242}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 157, 148, 146}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 58, 173}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 247, 166, 97}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 164, 236, 254}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 205, 227, 71}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 82, 170, 18}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 111, 116, 112}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 56, 18, 24, 185}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 97, 95, 64}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 242, 203, 147, 145}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 60}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 4, 206, 218, 180}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 239, 229, 143, 11}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 46}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 78, 228, 36}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 90, 165}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 241, 227, 160, 254}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 189, 124}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 27}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 143, 81, 18, 238}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 219, 0, 186, 76, 208}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 115, 127}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 66, 229, 213, 186, 10}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 139}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 125, 94, 147, 162, 173}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 30, 170, 87, 183}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 6, 152}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 174, 160, 204, 211, 51}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 190, 121, 122}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 148, 100, 10, 39}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 109, 67}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 254, 176}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 179, 163, 84}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 142}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 115, 32, 135}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 212}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 156, 247}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 228, 248}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 197, 92, 92}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 180, 174, 94, 161}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 55, 244, 228}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 67}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 152}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 158, 45, 121}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 27}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 185, 133}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 130}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 141, 192}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 70}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 192, 159, 228, 220}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 90, 201, 126, 121}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 67, 150}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 155, 236}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 94, 87, 140}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 220, 20, 91}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 247, 119}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 212}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 0, 0}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 0, 246, 214}, 245},
	{{246, 10, 85, 88, 82, 217, 95, 56, 216, 203, 160, 0, 0, 112, 174, 231}, 245},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{77, 100, 114, 207, 150, 177, 69, 134, 74, 131, 147, 117, 177, 64, 210, 128}, 54},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 204}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 76}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 25}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 193}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 132}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 16}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 6}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 27}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 181}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 147}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 26}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 12}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 96}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 153}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 214}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 140}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 140}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 78}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 29}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 39}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 77}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 71}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 189}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 25}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 161}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 149}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 215}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 168}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 136}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 110}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 226}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 129}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 99}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 32}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 236}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 228}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 48}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 17}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 135}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 45}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 43}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 101}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 26}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 229}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 131}, 86},
	{{171, 123, 22, 138, 132, 229, 250, 81, 186, 227, 146, 27, 170, 205, 128, 0}, 86},
	{{128, 0, 0, 0, 239, 161, 128, 123, 93, 240, 48, 188, 107, 60, 208, 212}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 85, 20}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 84, 3, 131, 155, 89, 48, 130, 104, 185, 209, 129}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 147, 203, 31, 58, 25}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 188, 120, 20, 215, 141, 21, 187}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 252, 108, 2, 193}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 138, 255, 88, 150, 251, 209, 37, 77, 39}, 218},
	{{128, 0, 231, 154, 212, 207, 68, 85, 53, 36, 197, 6, 196, 195, 103, 49}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 72, 88, 90}, 218},
	{{128, 0, 0, 0, 0, 40, 115, 142, 194, 69, 110, 206, 175, 114, 155, 253}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 68, 157, 78, 40, 8, 57, 167, 140, 190}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223}, 218},
	{{128, 0, 0, 0, 0, 0, 85, 238, 248, 106, 130, 47, 202, 145, 145, 98}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 143, 247, 186, 217, 113}, 218},
	{{128, 0, 0, 50, 178, 135, 103, 3, 221, 247, 198, 13, 29, 78, 84, 246}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 145, 80, 10}, 218},
	{{128, 0, 0, 0, 0, 0, 32, 171, 101, 111, 0, 88, 192, 177, 42, 160}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 187, 77, 229, 2, 202, 190, 77, 106}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 250, 189, 236}, 218},
	{{128, 0, 0, 0, 171, 104, 251, 57, 50, 61, 160, 190, 158, 142, 136, 190}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 99}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 218, 90, 211, 63, 65, 248, 183}, 218},
	{{128, 0, 155, 8, 127, 58, 133, 5, 230, 56, 175, 204, 168, 162, 173, 28}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 220, 132, 93, 82}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 185, 37}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 1, 82, 15, 3, 4, 27, 191, 230, 21}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 26}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 161, 131, 58, 77, 233, 202, 168, 144, 2, 250, 157, 251, 95}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 118}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 86, 187, 27, 145, 100, 176, 35, 93, 166}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 59, 71, 70, 114, 218, 152, 145, 239, 54}, 218},
	{{128, 0, 0, 0, 91, 179, 170, 79, 103, 75, 49, 41, 125, 225, 170, 232}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 219, 190, 180, 82, 162, 32, 173, 99, 230, 222, 113, 43, 77, 84, 123}, 218},
	{{128, 0, 0, 0, 0, 0, 40, 253, 98, 34, 235, 152, 72, 30, 112, 239}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 22, 23, 161, 107}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 253, 151, 147, 116, 32, 30, 243}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 135, 176, 43, 14, 72}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 190, 192, 196, 157, 223, 181, 215}, 218},
	{{128, 0, 61, 140, 86, 48, 90, 174, 6, 123, 250, 225, 46, 13, 166, 99}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 21}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 245, 25, 238, 88, 134, 202, 137, 76, 126}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 249, 150, 16, 80, 110, 201, 34, 170, 255}, 218},
	{{128, 0, 0, 0, 98, 221, 39, 218, 250, 83, 177, 78, 124, 250, 146, 25}, 218},
	{{128, 0, 0, 0, 0, 28, 94, 155, 99, 220, 88, 106, 54, 188, 39, 157}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 81, 62}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 59, 50, 158, 13, 195, 175, 218}, 218},
	{{128, 0, 0, 0, 0, 0, 195, 163, 63, 208, 56, 136, 223, 157, 2, 74}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 157}, 218},
	{{128, 0, 167, 134, 176, 67, 72, 111, 140, 19, 87, 210, 95, 117, 49, 197}, 218},
	{{128, 0, 0, 245, 43, 227, 192, 208, 233, 223, 142, 56, 65, 249, 204, 11}, 218},
	{{128, 0, 0, 0, 0, 0, 24, 125, 242, 36, 39, 12, 33, 161, 189, 154}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 156, 228, 189, 133, 32}, 218},
	{{128, 0, 0, 170, 140, 43, 73, 240, 179, 236, 56, 25, 125, 95, 34, 29}, 218},
	{{128, 0, 0, 0, 0, 180, 128, 89, 230, 241, 156, 51, 214, 232, 160, 52}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 170, 149, 193, 152, 202}, 218},
	{{128, 0, 74, 131, 160, 141, 245, 247, 219, 228, 81, 164, 45, 163, 118, 71}, 218},
	{{128, 0, 0, 27, 88, 118, 3, 241, 174, 242, 81, 34, 209, 210, 244, 100}, 218},
	{{128, 0, 0, 113, 38, 180, 88, 79, 246, 45, 121, 254, 240, 223, 119, 37}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 38, 38, 191, 80}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 7, 182, 196, 242, 186, 252, 148}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 119, 96, 2, 83, 69, 96, 43}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 145, 24, 237, 181, 54, 162, 217, 62}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 177, 41, 104, 63, 18, 83, 65, 42}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 169, 181, 44, 9}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 70, 169}, 218},
	{{128, 0, 4, 123, 218, 148, 53, 183, 143, 48, 160, 238, 133, 198, 55, 225}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 218},
	{{128, 0, 0, 0, 0, 65, 33, 97, 58, 61, 100, 18, 55, 91, 107, 93}, 218},
	{{128, 88, 22, 112, 150, 32, 115, 251, 60, 236, 198, 231, 110, 29, 3, 217}, 218},
	{{128, 0, 251, 238, 160, 35, 73, 100, 129, 186, 233, 222, 186, 15, 235, 239}, 218},
	{{128, 0, 0, 74, 2, 171, 230, 38, 16, 51, 162, 117, 69, 217, 150, 125}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 131, 18, 40, 12, 48, 232, 105, 207}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 115, 71, 66}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 149}, 218},
	{{128, 0, 37, 67, 149, 176, 111, 172, 201, 62, 185, 211, 4, 33, 66, 70}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 24}, 218},
	{{128, 0, 0, 0, 0, 135, 172, 232, 204, 234, 171, 145, 213, 15, 17, 221}, 218},
	{{128, 0, 0, 0, 0, 0, 113, 94, 1, 89, 102, 28, 189, 160, 168, 100}, 218},
	{{128, 0, 0, 0, 198, 95, 32, 26, 154, 20, 213, 201, 37, 40, 132, 2}, 218},
	{{128, 0, 0, 0, 0, 0, 118, 58, 225, 127, 72, 85, 109, 44, 254, 109}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 232, 240, 6, 46, 210, 51, 240, 37}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 180, 113, 186}, 218},
	{{128, 34, 148, 28, 127, 57, 217, 168, 243, 70, 127, 91, 124, 91, 168, 178}, 218},
	{{128, 0, 17, 6, 63, 110, 255, 16, 200, 107, 9, 118, 200, 232, 130, 127}, 218},
	{{128, 0, 0, 91, 47, 124, 25, 175, 79, 41, 253, 254, 134, 26, 76, 200}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 8, 43, 242}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 55, 92}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 248, 251, 1, 31, 113, 177, 30, 216, 185}, 218},
	{{128, 0, 0, 0, 0, 0, 255, 246, 67, 236, 254, 13, 2, 244, 85, 76}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 51, 194}, 218},
	{{128, 253, 190, 35, 108, 62, 135, 124, 177, 238, 85, 80, 255, 235, 11, 247}, 218},
	{{128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184}, 218},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 233, 188}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 101, 231, 72, 228, 230, 92, 174, 111, 237}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 184, 141, 35, 151, 117, 29, 155}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 25, 166, 138, 231, 125}, 144},
	{{12, 35, 50, 0, 0, 0, 78, 183, 122, 246, 51, 111, 2, 215, 177, 215}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 23, 223}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 249, 94}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 133, 17, 92}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 254, 97, 114, 97, 216, 190, 79, 145, 190}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 144},
	{{12, 35, 50, 0, 0, 0, 240, 171, 114, 80, 143, 20, 27, 147, 222, 65}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 205, 203, 7, 228, 133, 116, 202, 247}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 33, 254, 124}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 13, 164, 118, 17, 165}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{12, 35, 50, 0, 0, 34, 154, 12, 28, 219, 255, 155, 62, 63, 116, 80}, 144},
	{{12, 35, 50, 0, 0, 0, 201, 244, 116, 12, 211, 77, 196, 70, 194, 14}, 144},
	{{12, 35, 50, 0, 67, 64, 233, 26, 63, 103, 71, 43, 168, 62, 184, 102}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 145, 84, 128, 212, 106, 95, 144}, 144},
	{{12, 35, 50, 0, 0, 160, 99, 166, 78, 148, 239, 122, 42, 136, 3, 10}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 27, 90, 227, 242, 18, 165, 11}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 234, 238, 58, 114, 218, 174, 167}, 144},
	{{12, 35, 50, 0, 0, 241, 47, 233, 25, 205, 200, 202, 212, 10, 37, 35}, 144},
	{{12, 35, 50, 0, 0, 5, 117, 106, 126, 187, 101, 112, 91, 83, 5, 247}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 144},
	{{12, 35, 50, 0, 0, 0, 120, 247, 34, 207, 8, 10, 77, 228, 77, 132}, 144},
	{{12, 35, 50, 0, 0, 103, 199, 67, 5, 142, 195, 154, 228, 39, 105, 38}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 164, 117, 21}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 2, 43, 44, 221, 117, 104}, 144},
	{{12, 35, 50, 0, 0, 117, 43, 71, 186, 38, 220, 1, 32, 239, 171, 207}, 144},
	{{12, 35, 50, 0, 0, 0, 172, 77, 22, 210, 141, 140, 55, 155, 94, 175}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 86}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 114, 248, 40, 107, 53, 28}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 195, 153, 98, 225, 34, 144, 188, 190}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 200, 224, 166}, 144},
	{{12, 35, 50, 0, 48, 167, 122, 68, 20, 71, 17, 113, 181, 177, 221, 204}, 144},
	{{12, 35, 50, 0, 0, 182, 181, 26, 145, 169, 22, 39, 212, 228, 151, 167}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 161, 52, 72, 113, 207}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 84}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 88, 165, 51, 21, 235, 167, 215, 233, 31}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 223}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 188, 33, 85, 219, 36, 233, 146, 118, 63}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 195, 63, 217, 47, 20, 135, 53}, 144},
	{{12, 35, 50, 0, 0, 235, 6, 122, 88, 146, 138, 237, 151, 194, 173, 250}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 169, 53, 168}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 174}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 69, 1, 123}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 154, 88, 138, 66, 167, 102, 23, 124}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 60}, 144},
	{{12, 35, 50, 0, 0, 0, 34, 153, 39, 239, 226, 189, 90, 52, 53, 88}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 45}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 77, 173, 158, 76, 228, 59, 159, 141, 6}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 40, 152, 187, 133, 204, 157}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 51, 100, 94, 241, 251, 36, 149, 179}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 178, 36}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 34, 138, 227, 115, 227, 248, 226, 167}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 38}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 1, 110, 15, 38, 130, 66}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 165}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 163, 135}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 180, 6, 255, 230, 148, 39, 247, 107, 167}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 207, 32, 115, 244, 248, 185, 48, 7}, 144},
	{{12, 35, 50, 0, 0, 0, 255, 255, 126, 252, 141, 80, 51, 250, 248, 141}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 104}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 85, 154, 217, 189, 173, 225, 189, 204, 254}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 41, 50, 166}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 82, 65, 190, 207, 76}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 64, 149, 185, 170, 46, 70, 218, 193, 46}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 114, 106, 138, 138, 39, 118, 230}, 144},
	{{12, 35, 50, 0, 0, 0, 12, 39, 224, 141, 177, 104, 94, 152, 183, 133}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 61, 238}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 55}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 138, 62}, 144},
	{{12, 35, 50, 0, 0, 96, 246, 32, 41, 30, 199, 254, 93, 127, 11, 237}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 103, 94, 42, 241, 184, 217, 145}, 144},
	{{12, 35, 50, 0, 0, 74, 138, 183, 204, 140, 22, 68, 246, 83, 52, 23}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 178, 89, 41, 94, 74, 132, 74}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 244, 172}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 129, 124}, 144},
	{{12, 35, 50, 0, 0, 0, 12, 34, 250, 242, 104, 55, 115, 37, 77, 193}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 171, 161, 90}, 144},
	{{12, 35, 50, 0, 0, 0, 196, 203, 44, 156, 255, 92, 17, 11, 38, 249}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 169, 122, 138, 196, 221, 217, 253, 228}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 7, 131, 30, 238, 188}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 48, 146, 255}, 144},
	{{12, 35, 50, 0, 0, 111, 107, 43, 217, 49, 207, 1, 43, 55, 51, 84}, 144},
	{{12, 35, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{12, 35, 50, 0, 5, 141, 17, 224, 65, 0, 218, 89, 194, 156, 144, 70}, 144},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 238}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 186, 29}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 228, 217, 172, 138}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 98}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 134}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 239, 29, 89, 219}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 205}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 86, 246, 44}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 51, 162}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 229, 69, 92, 166}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 97, 45, 216}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 238, 115, 235, 127}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 168, 24}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 247, 13, 34, 175}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 197}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 13}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 3, 10}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 255, 247, 221}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 128, 74, 145}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 249, 208, 167}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 153}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 81, 195}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 227}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 226, 99, 27, 4}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 63, 43, 190, 123}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 99}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 150, 207, 237, 33}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 62, 210, 163, 76}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 238, 68, 254}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 90, 184}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 230, 36}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 38, 177, 140, 29}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 246, 41}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 249, 53}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 220, 49, 249, 98}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 157, 142}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 124}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 10, 101}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 162}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 163, 132}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 31}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 70, 1, 50}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 53, 21, 207}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 30}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 200, 29, 70, 37}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 49, 86, 84}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 124, 214, 28}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 59}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 239, 17, 112, 139}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 146, 128, 160, 104}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 81, 235, 227}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 239, 67, 212, 131}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 21, 64}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 199, 28}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 229, 44, 78}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 44, 92, 131}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 120}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 95, 255}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 202, 132, 103}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 60, 85, 245}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 158, 130, 33, 66}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 242, 97, 51}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 54}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 235}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 220, 203, 37, 162}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 159}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 204, 156, 239, 103}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 80, 218}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 98, 109, 117}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 22, 27, 15}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 244}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 137, 49}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 167, 96, 5}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 191, 137, 137}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 0}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 0, 53}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 147, 248, 253}, 171},
	{{255, 124, 179, 165, 169, 250, 66, 171, 223, 125, 247, 0, 0, 0, 188, 228}, 171},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 144, 127, 152, 35}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 231, 201}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 67, 2, 8}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 156, 41, 252}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 11, 211, 254, 34}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 189, 252, 123, 6}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 240}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 111, 3, 66}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 65, 144}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 12, 241}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 211}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 62, 28, 33}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 147}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 240}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 146, 31}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 234, 23, 175}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 5, 130, 112, 50}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 83, 82}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 121, 57, 188}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 202, 29}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 140}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 150, 199, 131}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 9, 23, 189}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 177, 190, 191}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 93, 110, 212}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 236, 63}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 53, 165, 197}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 192, 66}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 4, 14, 232}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 12}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 51, 43, 79}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 242, 122, 228}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 33, 136, 76}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 52}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 100}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 114, 25, 155}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 154, 108}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 229, 191}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 15, 232}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 149, 90, 242}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 76, 40, 54}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 217, 128, 251}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 111, 84}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 56, 224, 187}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 248, 65, 175}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 78}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 117}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 162, 243}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 200, 29, 27}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 208, 95, 245}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 67}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 254, 162}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 22}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 37, 160}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 214}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 78, 44}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 129, 164, 190}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 186}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 64, 247, 138}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 211}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 251, 105}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 249, 120, 78}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 164, 223}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 215, 99}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 157, 118, 171}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 144, 9}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 242, 185, 229}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 32}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 13}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 175, 180}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 225, 220, 4}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 72, 219}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 34, 17, 251}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 211}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 68}, 231},
	{{244, 235, 211, 10, 251, 255, 206, 6, 198, 12, 50, 136, 0, 0, 0, 0}, 231},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 145, 108, 91}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 242, 107}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 200}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 234, 95, 196}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 211}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 72, 137, 176}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 208, 34, 25}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 226, 43, 142}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 180, 75, 74, 194}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 127, 211, 144, 99}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 20, 222, 165}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 120, 10, 231, 70}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 189, 10, 129, 68}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 6, 54, 80, 8}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 179}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 220, 111}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 104, 202, 103, 83}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 158, 104, 195}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 100}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 41, 46, 144}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 59, 174, 83, 201}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 90, 113}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 32, 100, 145, 65}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 86, 218}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 83, 41}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 9, 105, 215}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 137}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 87, 24}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 181, 215}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 110, 181, 134}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 54}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 19, 89, 162, 117}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 8, 165, 90}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 94, 121, 48, 245}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 161, 74, 143}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 22}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 55, 64, 86, 119}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 162}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 41, 160, 90, 11}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 35, 173}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 185, 91}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 67, 210, 204}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 167, 10, 19, 76}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 155, 88, 27}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 184, 255, 118, 14}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 255, 85, 181, 14}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 234}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 176, 36, 218}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 230, 36}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 131, 66, 222, 197}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 42, 61, 201}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 22}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 73, 166, 4}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 183, 215, 121, 20}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 186, 153}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 175, 219, 31}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 90, 149}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 149, 103, 30, 67}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 160}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 45, 138, 7}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 31, 215}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 108, 62}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 122}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 71}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 20, 236, 15}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 246, 125, 131, 21}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 135}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 46, 206, 213, 62}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 163, 97, 182}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 45}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 246, 11, 8, 245}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 223, 244, 39}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 187}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 0}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 0, 216}, 34},
	{{221, 77, 237, 41, 50, 33, 103, 24, 25, 127, 208, 0, 0, 0, 181, 183}, 34},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 74, 87, 104, 42}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 56, 57, 66}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 207, 199, 18, 51, 93, 22}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 82, 144, 100}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 147, 72, 11, 28, 139, 23, 250}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 51, 163, 132, 222, 71, 189, 128, 175}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 192, 135, 22}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 193, 103, 48, 118, 238, 8}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 150, 191, 166, 215, 16, 122, 239, 146}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 252, 165, 128, 211, 196, 218, 32, 104}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 149, 64, 144, 15, 44, 81, 79, 193}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 16}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 176, 142, 179, 212, 121, 219}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 167, 58, 200, 134, 242, 27, 75, 147}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 132, 163, 64, 144, 118, 116, 236, 24, 106}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 66, 154, 90, 120, 130}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 32, 26, 102, 216, 150, 235, 20, 229}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 156, 154, 106, 80, 235, 32, 26}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 58, 118, 197, 234, 126, 193, 8, 205}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 198, 35, 66, 160, 255, 199, 119, 47, 112}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 14, 165}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 190, 253, 80, 6, 63, 105, 225, 179}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 181, 208, 194, 34, 120, 151}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 232, 171}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 144, 48, 239, 232, 175, 181}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 121, 2, 126, 4, 31, 122, 176}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 253, 230, 253, 247}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 94, 2, 41, 211, 82, 158}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 161, 192}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 107, 149}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 38, 106, 43, 65, 113}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 64, 36, 26, 23, 149, 252}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 159, 76, 200, 245, 179, 150}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 107, 27}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 153, 64, 164, 129, 159, 182}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 44, 63}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 51, 136, 97, 9, 62, 18, 52}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 19, 99, 116, 131, 34}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 84, 138, 114}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 1, 157, 188, 165, 150, 72, 174}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 220, 148, 174, 207, 204, 18, 11}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 201, 236, 138}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 177, 82, 82, 77}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 194, 180, 241, 73, 158, 99}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 97, 123, 230, 55, 42}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 87, 68, 112, 42}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 206, 242, 249}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 46, 28, 65, 121, 148, 72}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 7, 104, 220}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 199, 158, 83}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 174, 166, 174, 237, 206, 123, 77}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 48, 63, 49, 107, 88}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 60, 106, 67, 109, 242, 161}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 181, 220, 115, 119, 202, 38, 68}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 130, 98, 207, 29, 161, 200, 228}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 97, 200, 212, 134, 175}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 180, 137}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 208, 246, 41, 21, 230, 174, 0, 139}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 41, 191, 242, 225, 20, 159, 69, 175}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 132, 225, 154, 111, 196, 238, 173}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 202, 147, 130}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 239, 228, 80, 13, 189, 92, 127}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 185, 127}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 10}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 171, 179, 39, 170, 95, 8, 114, 111}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 193, 115, 67, 210, 53, 199}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 243, 8}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 96, 214, 227, 6, 81, 77, 242}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 121, 7, 206, 71, 79, 113}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 161, 173}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 233, 84}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 217, 8, 215, 221, 147, 138}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 146, 198, 7, 44, 131, 228, 149, 209, 120}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 30, 133, 150, 112, 87, 213}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 26, 218, 246, 46, 246, 84, 183}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 236, 145, 90}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 33, 121, 215}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 125, 23, 125, 153, 37, 1}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 36, 226}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 99, 213}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 123, 105, 109, 174, 165, 182}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 53, 175, 127, 10, 151}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 59, 161, 88, 12, 206, 244, 49, 138, 148}, 225},
	{{216, 69, 47, 53, 117, 24, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 179}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 102, 96, 212, 59, 219, 212}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 217, 56, 251}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 207, 156, 228, 99}, 174},
	{{180, 87, 25, 236, 56, 0, 18, 115, 125, 237, 78, 194, 235, 179, 214, 216}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 66, 18, 74, 131, 71}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 213, 105, 152}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 42, 33, 67}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 61, 180, 49}, 174},
	{{180, 87, 25, 236, 56, 0, 47, 114, 234, 13, 165, 99, 9, 221, 167, 217}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 126, 99, 14, 226, 191, 185}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 143, 17, 204, 30, 68, 245, 109}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 19, 156, 239, 194, 6}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 75, 174, 171}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 142, 201, 55, 5, 69, 236, 251}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 53}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 90, 192, 86, 73, 85, 216, 15, 235, 142}, 174},
	{{180, 87, 25, 236, 56, 0, 144, 204, 40, 157, 36, 192, 246, 91, 20, 63}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 12, 81, 42, 7}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 210}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 217, 228, 230, 248, 184, 196}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 38, 254, 204, 3, 41, 13}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 246, 56, 20, 28, 225}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 79, 62, 60, 210, 196, 195, 246, 198, 165}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 247, 43, 153, 86, 47, 33, 63, 76}, 174},
	{{180, 87, 25, 236, 56, 0, 169, 253, 162, 215, 242, 131, 40, 231, 226, 190}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 27, 195, 142, 172, 196, 149, 26, 30}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 103}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 246, 165, 15, 95, 156, 41, 33}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 117, 178, 84, 48, 141, 110, 247}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 43}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 174},
	{{180, 87, 25, 236, 56, 0, 226, 25, 87, 251, 101, 231, 226, 201, 189, 148}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 98, 112, 189, 200, 162, 96, 78, 153}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 112, 175, 191, 193}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 174},
	{{180, 87, 25, 236, 56, 0, 103, 118, 132, 246, 121, 238, 243, 231, 147, 51}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 55}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 108, 113, 12, 36, 12, 208, 62, 191, 85}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 55, 241, 2, 210, 60, 131, 2, 218, 26}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 151, 254, 60, 46, 89, 23}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 188, 134, 109, 11, 155, 227, 115}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 61, 0, 57, 113, 247, 117, 221, 16, 248}, 174},
	{{180, 87, 25, 236, 56, 0, 137, 41, 41, 22, 213, 105, 97, 46, 133, 254}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 168, 227, 104}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 81, 6, 208, 132, 248, 37, 147, 150, 97}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 148, 116, 16, 235, 209, 9, 89, 247}, 174},
	{{180, 87, 25, 236, 56, 0, 115, 83, 87, 220, 138, 173, 88, 122, 224, 45}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 252, 59, 2, 241, 162}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 63, 169, 151, 132, 137, 123, 94}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 201}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 103, 107, 144, 203, 121, 135, 69}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 10, 148, 167, 40, 226, 14}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 176, 120, 116}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 21, 70, 241, 139, 18, 246, 161, 34, 16}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 34}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 231, 170, 202, 232, 27, 81}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 248}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 169, 248, 175, 236, 97, 24, 137}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 202}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 174, 220, 76, 2, 82, 100, 165, 121}, 174},
	{{180, 87, 25, 236, 56, 0, 255, 95, 149, 19, 206, 184, 200, 159, 13, 132}, 174},
	{{180, 87, 25, 236, 56, 0, 120, 30, 11, 94, 248, 135, 250, 253, 190, 167}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 95, 7, 157, 188, 172, 58, 144, 214, 219}, 174},
	{{180, 87, 25, 236, 56, 0, 22, 117, 204, 61, 130, 43, 47, 87, 59, 210}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 0}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 101, 248, 248, 132, 4, 232, 192, 216}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 111, 78, 35, 165}, 174},
	{{180, 87, 25, 236, 56, 219, 110, 147, 171, 134, 33, 61, 45, 68, 189, 105}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 97, 208, 147, 7, 153, 40, 50, 202}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 56, 3, 172, 255, 30, 210, 6}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 78, 2, 53, 162, 253, 75, 95}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 88}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 61, 228, 3, 194, 33, 214, 137}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 250, 158, 130}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 54}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 211, 242, 253, 107, 182, 179}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 168, 140, 196, 205}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 63, 235, 225, 72, 162, 102, 111, 63}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 214, 111, 7, 36, 228, 193, 179}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 70, 56, 200, 87, 60, 119, 198, 63}, 174},
	{{180, 87, 25, 236, 56, 0, 99, 76, 38, 21, 76, 187, 15, 39, 231, 48}, 174},
	{{180, 87, 25, 236, 56, 0, 0, 0, 0, 0, 0, 0, 0, 124, 187, 201}, 174},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 233}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 205}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 111}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 119}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 206}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 21}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 84}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 12}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 92}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 219}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 44}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 166}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 183}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 76}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 69}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 93}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 213}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 77}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 2}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 66}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 181}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 149}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 129}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 184}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 157}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 22}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 71}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 79}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 205}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 251}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 76}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 121}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 36}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 92}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 64}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 83}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 55}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 123}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 196}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 13}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 104}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 210}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 46}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 112}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{110, 32, 24, 34, 116, 133, 245, 128, 123, 95, 125, 122, 100, 129, 128, 0}, 37},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{27, 117, 179, 112, 133, 137, 110, 193, 246, 201, 219, 65, 56, 234, 106, 128}, 39},
	{{186, 117, 252, 0, 11, 243, 204, 70, 166, 125, 173, 167, 183, 26, 71, 116}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 206, 65, 147}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 53, 145, 184, 155, 104, 247, 40, 115, 221}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 5, 204, 40, 58, 254, 194, 185}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 193, 19, 167, 84, 214}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 63, 179, 183, 206, 253}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 162, 109, 174, 217, 54, 58, 124, 99, 94}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 59},
	{{186, 117, 252, 0, 0, 0, 56, 205, 146, 20, 190, 38, 41, 57, 22, 46}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 246, 223, 94, 17, 186, 106}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 59},
	{{186, 117, 252, 0, 5, 7, 6, 80, 35, 60, 160, 8, 223, 173, 157, 201}, 59},
	{{186, 117, 252, 0, 0, 141, 39, 237, 53, 135, 158, 5, 246, 248, 49, 36}, 59},
	{{186, 117, 252, 0, 0, 0, 212, 158, 165, 52, 232, 56, 168, 31, 22, 103}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 179, 98, 70}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34}, 59},
	{{186, 117, 252, 0, 0, 68, 89, 4, 246, 31, 136, 137, 250, 186, 182, 99}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 239, 39, 240, 187, 238, 172}, 59},
	{{186, 117, 252, 0, 0, 0, 151, 33, 116, 98, 173, 248, 170, 177, 208, 126}, 59},
	{{186, 117, 252, 0, 0, 118, 148, 168, 208, 5, 106, 16, 32, 148, 96, 158}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 97, 114, 58}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 100, 117, 102}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 118, 125, 14, 119, 0, 218}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 179, 225, 180, 131, 213, 151, 6, 153, 125}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 47, 129, 63, 71, 248, 34, 77, 30}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 53, 176, 187, 4, 89, 168}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 177, 213, 19, 97, 123, 179, 242}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 112, 109, 237, 225, 66, 229, 12, 248, 108}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 62, 71, 249}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 21, 36, 55, 73, 141, 129, 209, 199, 158}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 85, 244, 103, 201, 50}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 212, 155}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 105, 43, 150, 69, 254, 132}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 154, 165}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 97, 83, 127, 255, 104}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 71, 112, 218}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 29}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 78, 64, 187, 68, 211}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 210, 155, 176, 24, 126, 124, 151, 227, 122}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 231, 183, 80, 192, 208, 155, 168}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 220, 79, 142, 10, 197, 35, 226, 229, 104}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 182, 170, 157, 177, 60, 60, 104}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 210, 88, 149, 152, 195, 16, 206, 185}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 100, 187}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 78, 232, 49, 20, 0, 236, 100, 52, 111}, 59},
	{{186, 117, 252, 0, 0, 0, 238, 226, 165, 250, 46, 159, 20, 189, 95, 7}, 59},
	{{186, 117, 252, 0, 0, 10, 222, 190, 231, 45, 242, 97, 10, 130, 224, 13}, 59},
	{{186, 117, 252, 0, 0, 89, 247, 38, 245, 211, 26, 180, 201, 253, 199, 209}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 31}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 54}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 186, 208, 225}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 34, 96, 49, 62, 133, 248}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 241, 252, 13, 142, 63, 16, 55, 168, 32}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 59},
	{{186, 117, 252, 0, 0, 0, 26, 161, 73, 75, 128, 236, 89, 219, 236, 236}, 59},
	{{186, 117, 252, 0, 0, 0, 94, 222, 78, 85, 99, 94, 121, 57, 116, 128}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 126, 254, 227, 38, 14, 35, 109, 255, 66}, 59},
	{{186, 117, 252, 104, 139, 40, 86, 65, 28, 147, 177, 195, 240, 1, 231, 162}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 61, 223, 254, 119, 75}, 59},
	{{186, 117, 252, 0, 138, 124, 42, 11, 92, 216, 230, 234, 88, 105, 168, 179}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 236, 117, 239}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 204, 131, 76, 181, 111, 2}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 77, 47}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 200, 62, 116, 179, 241, 84, 118, 9}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 168, 191, 159}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 19, 204}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{186, 117, 252, 0, 214, 208, 6, 116, 60, 255, 94, 120, 255, 95, 150, 20}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 94, 182, 213, 29, 45, 45, 46}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 42, 113}, 59},
	{{186, 117, 252, 0, 185, 152, 29, 172, 173, 82, 249, 122, 139, 229, 222, 252}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 4, 129, 29, 215, 146, 103, 100, 177}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 98, 49}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 83, 190, 188, 236, 73, 174, 180, 40, 18}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{186, 117, 252, 62, 200, 95, 187, 102, 20, 122, 243, 53, 206, 141, 153, 76}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 120, 37, 228, 154, 234, 128}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 245, 171, 170, 195, 7, 29, 161, 142}, 59},
	{{186, 117, 252, 0, 222, 50, 211, 171, 44, 217, 145, 181, 189, 243, 242, 65}, 59},
	{{186, 117, 252, 0, 0, 131, 161, 158, 47, 253, 108, 231, 7, 1, 225, 251}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 213, 181, 67}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 137, 213}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 205, 172, 56, 92, 244}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 58, 186}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 58, 201, 104, 191, 136, 65, 124, 188}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 236, 141, 109, 146, 95, 4, 73, 253}, 59},
	{{186, 117, 252, 0, 0, 120, 245, 52, 188, 75, 145, 156, 223, 154, 165, 175}, 59},
	{{186, 117, 252, 0, 149, 52, 175, 43, 55, 97, 34, 126, 46, 238, 199, 230}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 198, 233}, 59},
	{{186, 117, 252, 0, 0, 0, 0, 0, 216, 180, 141, 13, 128, 70, 3, 196}, 59},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 15, 210, 150, 85}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 70, 189, 50, 237, 0, 250}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 146, 133, 232}, 96},
	{{243, 119, 54, 16, 128, 0, 180, 164, 131, 31, 32, 7, 124, 108, 225, 201}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 98, 143, 211, 87, 203, 213, 237, 118, 57}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 253, 18, 235, 58, 93}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 248, 197, 191, 60, 6}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 247, 211, 247, 231, 138}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 162, 42, 202}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{243, 119, 54, 16, 128, 0, 75, 62, 109, 228, 194, 56, 15, 233, 242, 118}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 75}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 24, 117, 238, 115, 186, 58, 8}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 234}, 96},
	{{243, 119, 54, 16, 128, 18, 238, 60, 166, 229, 162, 45, 184, 75, 98, 21}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 217, 155, 163, 46, 23}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 213, 216, 87, 142, 239, 254}, 96},
	{{243, 119, 54, 16, 128, 235, 184, 189, 251, 117, 165, 160, 243, 142, 253, 25}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 86}, 96},
	{{243, 119, 54, 16, 128, 0, 30, 4, 17, 39, 169, 142, 134, 138, 105, 0}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 163, 184, 117, 34, 137}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 7, 173, 76, 109, 23, 192, 83}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 101}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 162}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 254, 26, 119, 23, 189, 79}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 188, 56, 229, 190, 32}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 237, 231, 145, 14, 248, 223, 91}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 117, 182, 163}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 231, 37, 182, 97, 145, 232, 2}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 148}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 185, 209, 217, 2}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 85, 61, 222}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 1, 58, 195, 107, 78}, 96},
	{{243, 119, 54, 16, 128, 87, 173, 42, 183, 119, 51, 41, 167, 231, 151, 192}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 52, 11, 117}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 29, 242, 65, 174, 208, 165, 204, 156, 47}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 144, 69, 1}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 65, 192, 40, 120, 194, 126, 86, 138, 133}, 96},
	{{243, 119, 54, 16, 128, 0, 229, 228, 73, 191, 147, 235, 222, 212, 187, 24}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 227, 214, 78, 119, 30, 126, 213}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 159, 100, 64, 199, 151, 167, 122, 235}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 5, 188, 218, 30}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 32, 152, 75, 95, 150, 98, 118}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 137, 38, 206, 126, 238, 115}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 176, 45, 51, 216, 211}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 206, 195, 139, 196, 119, 73, 152, 244}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 25, 138, 232, 21, 214, 186, 194}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 179, 16, 236, 51, 17}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 173, 214, 99, 162, 58, 168}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 199, 206, 250, 179, 183, 104, 1, 75, 8}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 198, 125, 168}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 49, 75, 133, 68, 237}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 150, 172, 119, 158, 41}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 108}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 180, 92, 26, 134}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 130, 219, 155, 176, 76, 203}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 101, 206, 148, 150}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 240, 59, 73, 190, 188, 228}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 131, 60, 155, 254, 105}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 115, 137, 178, 101, 114, 191, 128, 151}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 31, 228, 56, 237, 153, 9, 37, 48, 209}, 96},
	{{243, 119, 54, 16, 128, 0, 16, 112, 14, 83, 106, 221, 244, 101, 201, 10}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 227, 203, 128, 103, 139, 60}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 233, 126, 86}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 120, 213, 208}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 236, 211, 94, 1, 20, 0, 225, 40, 227}, 96},
	{{243, 119, 54, 16, 128, 244, 21, 185, 213, 113, 30, 10, 69, 140, 214, 253}, 96},
	{{243, 119, 54, 16, 128, 0, 146, 58, 244, 220, 9, 29, 189, 64, 83, 160}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 16}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 168, 9, 164, 152, 234, 204, 94, 60, 69}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 249, 183, 76, 55, 222, 176, 76, 75, 95}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 166, 87, 31, 188}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 127, 178, 213, 3, 182}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 151, 61, 238, 206}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 135, 240, 157, 44, 141, 233}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 203, 209, 255, 99, 107, 173, 195, 110, 223}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 255, 42, 217, 117, 112, 97, 113, 78}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 223, 13, 255, 27, 52}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 151, 81, 223, 99, 159, 120, 118, 198}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 151, 232, 213, 66, 51}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 158, 21, 64}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 183, 25, 80, 13, 71, 82, 214, 157, 171}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 171, 169, 32, 77, 48, 132, 119, 75, 111}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 133, 188, 80}, 96},
	{{243, 119, 54, 16, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 96},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 40, 189, 197}, 208},
	{{160, 0, 0, 146, 167, 224, 164, 218, 36, 84, 87, 132, 67, 117, 208, 71}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 230, 39, 21, 15, 10, 109, 239}, 208},
	{{160, 0, 0, 0, 0, 0, 108, 20, 239, 212, 207, 157, 229, 34, 181, 112}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 2, 83, 189, 59, 140}, 208},
	{{160, 0, 0, 12, 11, 113, 74, 81, 132, 36, 193, 165, 193, 51, 19, 150}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 70, 110, 196, 166, 234}, 208},
	{{160, 0, 252, 140, 210, 46, 14, 140, 184, 97, 238, 48, 66, 11, 70, 111}, 208},
	{{160, 0, 0, 0, 0, 8, 124, 142, 238, 26, 141, 200, 222, 175, 100, 226}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 2}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 85, 48, 216, 25, 55, 206, 62, 243, 85, 123, 50, 148}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 112, 96}, 208},
	{{160, 0, 79, 252, 45, 203, 188, 249, 56, 165, 218, 41, 43, 12, 233, 223}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 78}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 38, 103}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 171, 222}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 203}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 137}, 208},
	{{160, 0, 150, 214, 39, 86, 145, 128, 6, 175, 94, 143, 6, 129, 122, 180}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 137, 5, 120}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 208},
	{{160, 0, 0, 0, 98, 10, 205, 207, 86, 209, 85, 61, 17, 216, 228, 189}, 208},
	{{160, 0, 0, 0, 0, 0, 82, 179, 34, 161, 103, 250, 229, 13, 160, 11}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 98, 196, 181, 87, 1}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 170, 109, 182, 21}, 208},
	{{160, 0, 41, 10, 58, 242, 99, 193, 158, 216, 23, 152, 243, 64, 24, 172}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 226, 246, 233, 68, 3}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 215, 36}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 117, 63, 170}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 252, 243, 116, 162}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 51, 101, 34, 227, 248, 203, 115, 162}, 208},
	{{160, 0, 0, 140, 235, 68, 134, 105, 53, 88, 120, 158, 171, 148, 43, 109}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 87, 196, 250, 157, 153, 216, 155, 109, 176}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 171, 184, 240, 70}, 208},
	{{160, 0, 0, 97, 130, 0, 0, 198, 66, 63, 23, 18, 99, 69, 36, 102}, 208},
	{{160, 0, 0, 0, 222, 71, 64, 92, 62, 217, 161, 86, 121, 151, 169, 179}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 208},
	{{160, 121, 80, 190, 218, 105, 88, 65, 211, 1, 136, 74, 83, 89, 52, 209}, 208},
	{{160, 0, 0, 144, 179, 125, 231, 55, 102, 177, 35, 201, 211, 186, 23, 138}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 111, 51, 75, 123}, 208},
	{{160, 0, 0, 0, 202, 63, 84, 158, 112, 135, 5, 119, 213, 188, 157, 117}, 208},
	{{160, 0, 0, 0, 0, 0, 177, 129, 76, 144, 25, 164, 226, 120, 159, 233}, 208},
	{{160, 0, 0, 172, 0, 181, 166, 38, 96, 252, 53, 145, 102, 213, 226, 174}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 28, 169, 50, 248, 54, 162, 81, 125, 36, 52}, 208},
	{{160, 0, 0, 222, 160, 207, 163, 193, 83, 153, 149, 230, 83, 64, 110, 231}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 9}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 28, 142, 160, 153, 224, 67, 215}, 208},
	{{160, 0, 0, 0, 210, 237, 74, 239, 223, 192, 253, 60, 40, 14, 76, 88}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 83, 114, 105, 55, 74, 47, 236, 6}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 98, 119, 236, 18, 199, 168, 179, 147, 209}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 7}, 208},
	{{160, 0, 0, 0, 0, 0, 93, 71, 43, 190, 111, 2, 111, 113, 150, 105}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 148}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 214, 182, 232, 195, 158, 87, 203}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 123, 163, 251, 1, 9}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 50, 86}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 62, 4, 165, 113, 205, 117, 187}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 99, 222, 105, 32, 57, 5, 203}, 208},
	{{160, 0, 0, 0, 0, 0, 76, 135, 231, 149, 42, 28, 69, 192, 200, 14}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 189, 133, 165, 88, 41, 207, 226}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 248, 122, 249, 70, 42, 246, 255, 43, 87, 89, 154, 7}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 33, 83, 143, 170}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 61, 124, 222, 28, 159, 107, 246, 217}, 208},
	{{160, 0, 0, 0, 0, 0, 253, 1, 189, 63, 249, 51, 197, 209, 98, 202}, 208},
	{{160, 0, 0, 203, 45, 178, 47, 45, 205, 109, 165, 24, 113, 117, 152, 13}, 208},
	{{160, 0, 0, 255, 129, 161, 103, 36, 186, 71, 211, 251, 7, 118, 78, 147}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 164, 117}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 218, 227}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 118, 47, 223, 197}, 208},
	{{160, 0, 0, 0, 182, 36, 36, 92, 131, 129, 92, 65, 84, 188, 229, 213}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 184, 168, 199, 195, 58, 215, 144, 70}, 208},
	{{160, 0, 0, 0, 0, 247, 94, 197, 47, 221, 74, 181, 64, 196, 184, 49}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 18, 196}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 9}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 76, 161, 144, 127, 160, 193, 203, 28, 142}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 140, 181, 214, 242, 68}, 208},
	{{160, 0, 18, 27, 142, 162, 159, 202, 176, 79, 44, 228, 37, 101, 78, 128}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 38, 32}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 79, 31}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123}, 208},
	{{160, 0, 0, 0, 191, 133, 43, 188, 193, 255, 192, 156, 195, 61, 132, 163}, 208},
	{{160, 0, 0, 0, 0, 0, 41, 167, 45, 179, 105, 137, 158, 16, 188, 2}, 208},
	{{160, 0, 0, 72, 120, 26, 39, 77, 60, 206, 109, 150, 4, 222, 163, 52}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 109}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 237, 97, 14, 121, 60}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 59, 1, 128}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 87, 33, 144, 131, 95}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 157}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 44}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 119}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 51}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 122}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 225}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 131}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 67}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 43, 108}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 117, 41}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 237}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 4, 142}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 223}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 71}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 225}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 241}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 76}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 53}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 133}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 18}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 67}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 244}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 200}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 135}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 216}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 237, 246}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 113}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 44}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 154}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 181}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 40}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 200}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 34}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 173}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 68, 109}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 250}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 2}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 43}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 226}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 245}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 46}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 192}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 35}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 174, 57}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 160}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 243, 116}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 207}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 147}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 57, 235}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 197}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 194}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 137}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{78, 48, 117, 200, 245, 118, 115, 240, 170, 125, 84, 103, 33, 168, 0, 0}, 56},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 116}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 218}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 66, 90}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 112}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 19}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 160}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 226}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 97}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 168}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 92}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 226}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 104}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 122}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 30}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 140}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 126}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 178}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 35}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 176}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 6}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 165}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 79}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 16}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 58}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 44, 126}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 200}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 230}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 34}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 185}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 68}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 104}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 33}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 162, 1}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 6}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 83, 55}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 135}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 144}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 27}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 21, 1}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 121}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 119, 148}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 19}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 108}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 118}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 139, 132}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 138}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 146}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 213}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 218}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 245}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 98}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 148}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 214}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{201, 253, 184, 254, 143, 81, 95, 42, 243, 147, 96, 145, 23, 26, 0, 0}, 234},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 180, 64, 162}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 145, 78, 255, 180}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 248, 223, 82}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 75, 161, 84}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 29, 190, 210, 44, 91}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 147, 134, 169, 119, 195, 134, 97}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 107, 149, 86, 65, 237, 243}, 199},
	{{41, 215, 84, 136, 234, 0, 229, 3, 208, 15, 166, 31, 66, 130, 188, 115}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 217, 1, 75, 22}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 114, 97, 244, 171, 183, 137, 199, 195}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 77, 201, 24, 3, 132, 148, 227}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 87, 91, 167, 242, 51, 175, 254, 245, 134}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 233, 216, 229, 107, 137, 114, 72}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 109, 124, 214, 237, 4, 191}, 199},
	{{41, 215, 84, 136, 234, 0, 11, 38, 255, 197, 252, 92, 251, 44, 142, 32}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 168, 1, 137, 174, 67, 125, 15, 156, 224}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 166, 174, 207, 238}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 116, 184, 32, 226, 90, 118}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 208}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 64, 157, 57, 3, 103, 164, 236, 118}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 52, 37, 67, 8}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 207, 211, 47, 177, 209, 56, 69, 154}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 126, 77, 93, 152, 168, 196, 17, 13, 214}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 10, 35, 235, 152, 126, 73, 33, 186}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 182, 139, 208, 240, 162, 21, 230, 235}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 142}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 69, 90, 161, 112, 135, 247, 8}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 124, 217, 99, 246, 58, 169, 116, 152, 112}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 220, 115, 30, 64, 19, 104, 10}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 157, 9, 127, 167, 238, 37, 244, 51, 99}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 37, 48, 215}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 100, 188, 129, 157, 226, 168, 173}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 48, 171, 251, 57, 164}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 94, 138, 170, 205, 131}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 104, 171, 165, 160, 211}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 103, 26, 112, 65, 54}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 2, 48, 220, 51, 169, 40, 89}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 30, 11, 10, 170, 110, 42, 195}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 241, 140, 140, 9, 160, 45, 236, 236, 53}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 189, 108, 53, 69, 245}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 234, 121, 160, 132, 26, 243, 192}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 253, 168, 109, 129, 215, 44, 65, 244}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 254, 199, 72, 236, 103, 85, 161}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 130, 138, 158, 7, 187, 194, 125, 204, 224}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 171}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 119, 133, 3}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 164, 185, 142, 139, 14}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 249}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 89, 29, 31}, 199},
	{{41, 215, 84, 136, 234, 0, 27, 178, 159, 137, 29, 24, 88, 153, 117, 67}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 158, 50, 166, 185, 64}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 83, 103, 186, 229, 189}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 101}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 109, 152, 152, 131, 109, 231}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 191, 199, 29, 101, 162, 106, 144}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 160, 233, 47, 71, 135, 24, 77}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 240}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 3, 2, 234, 189, 122, 246, 154, 38}, 199},
	{{41, 215, 84, 136, 234, 0, 4, 235, 162, 94, 172, 172, 67, 111, 181, 112}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 100, 203, 109, 67, 31, 172, 157, 197, 43}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 226, 12, 15, 172, 218, 155}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 55, 90, 117, 155, 245, 75, 22}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 93, 126, 108, 198, 208}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 239, 38, 28, 97, 227, 238}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 242, 227, 181, 130, 215, 20, 132}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 74, 166, 173, 56, 102, 231}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 249, 203, 167, 82, 100, 8, 15, 121, 126}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75}, 199},
	{{41, 215, 84, 136, 234, 0, 71, 84, 103, 227, 17, 124, 23, 220, 238, 117}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 109, 22, 168}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 221, 23, 43, 127, 90, 202}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 203, 110, 154, 218, 118, 139, 34, 68}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 22, 14, 58, 215, 218, 173, 65}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 9, 217, 150, 206, 172, 139, 121, 60, 8}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 123, 36, 149, 104, 205, 64, 19}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 3, 188, 24}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 197}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 99, 33, 193, 2}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 49}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 88, 66, 144, 23, 30, 30, 80, 58}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 243}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 9}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 0, 0, 0, 174, 62, 208, 92, 219}, 199},
	{{41, 215, 84, 136, 234, 0, 0, 0, 144, 200, 169, 20, 111, 63, 154, 28}, 199},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 195, 189}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 219, 6, 110, 119}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 62, 235, 142, 32, 221}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 34, 146, 146, 159}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 81, 25}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 8}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 183, 130, 200, 10}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 131, 232, 71, 55, 189, 109, 235}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 60, 154, 220, 233, 150, 127, 171}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 193, 214, 152, 241, 239}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 43, 186, 127, 165, 160}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 112, 111}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 77, 197, 17, 2, 226}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 115, 1, 105, 140, 53, 177}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 188, 94, 160, 224, 69, 84}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 162}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 127, 243, 194, 31, 205}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 197}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 199}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 141, 198, 146, 86}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 253, 80, 232, 14}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 213, 14}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 39, 242}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 77, 233, 3, 30}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 247, 229, 24, 239}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 166, 2}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 104, 117, 32}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 219, 10, 10}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 200, 187, 224, 99, 145}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 21, 69, 124, 17}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 91, 128, 165, 88}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 39, 155}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 154}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 98, 93, 4, 52, 160}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 211, 181, 219}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 84, 159, 67, 68, 210, 142}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 48, 177, 216, 245}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 186, 24, 185, 120}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 138, 10, 214, 131, 73, 247, 88}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 250, 142, 210, 220}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 121}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 188, 135}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 70, 203, 87, 33}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 128, 86, 175, 153}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 154, 7, 173, 74, 136, 139}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 167, 151, 18, 175, 17}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 90, 112, 227, 201, 12}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 6, 110, 98, 166, 3, 95}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 53, 244, 127, 88}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 98, 76, 190, 143, 160, 63}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 238, 128, 145, 142, 71, 148}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 219, 39, 199}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 226, 138, 211}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 222, 229, 58, 247}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 245, 190, 186, 77}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 17, 208, 163, 198, 182, 242, 22}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 43, 181, 212, 11}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 46}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 174}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 249, 0, 234}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 142, 248}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 126, 45}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 243, 30, 102, 248, 130, 46}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 200, 23, 14, 17}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 34, 111, 101, 117, 168, 252, 207}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 224, 171, 250, 118}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 218, 110}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 41}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 62, 34, 40, 82, 175}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 47, 70, 22, 13, 9}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 187, 88, 208, 29, 165}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 240, 51, 67, 170}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 65}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 125, 21, 206, 84}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 136, 7, 89}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 253, 129, 111, 98, 223, 180}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 249, 146}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 198, 53, 62, 21, 31}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 23}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 247, 119, 189, 155, 219}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 252, 102, 156, 118, 162}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 192, 66}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 246, 222, 168, 227, 26, 99}, 191},
	{{91, 244, 137, 184, 231, 95, 135, 10, 184, 0, 0, 0, 0, 0, 0, 241}, 191},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 115, 65, 180, 0, 142}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 212, 82, 133}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 57}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 89, 13, 230}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 39, 31, 174, 61, 25}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 81, 74, 221}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 116, 72, 13}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 12, 97, 17, 196, 29, 53}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 232}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 223, 114, 193, 33, 100, 25, 152, 194, 157}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 216, 23, 164, 110}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 196, 100, 4, 179, 57, 192}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 61, 149, 247, 165, 220, 242, 186}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 15, 135, 232, 200, 161, 119, 48, 51, 59}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 94, 56, 9, 106}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 238, 4, 117, 178, 99}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 85, 222, 198, 231, 122, 227, 39, 44}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 49, 51, 233, 224, 54}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 133, 190, 118, 96}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 108, 186, 2, 40, 71, 33, 146, 80, 147}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 135, 42, 37, 142, 207, 191, 16, 25}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 109, 21, 30, 23, 119, 205, 131}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 122, 56, 187, 215, 10, 5, 108, 181, 12, 133}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 183, 43, 100, 107}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 93, 222, 122, 77, 167, 11, 22, 71, 84}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 238, 217, 90, 130, 193, 37, 15, 52}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 233, 195, 235, 42, 206}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 4, 100, 115, 242, 242, 108, 134, 53, 142}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 94, 147, 103, 112}, 235},
	{{113, 31, 181, 245, 21, 0, 1, 128, 100, 29, 130, 62, 156, 18, 19, 91}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 76, 43, 244}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 192, 144, 175, 97, 124}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 151}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 10, 91, 248, 238, 190, 12, 43, 132}, 235},
	{{113, 31, 181, 245, 21, 0, 1, 227, 214, 13, 60, 144, 115, 179, 25, 114}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 63, 209, 230, 88, 128, 189}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 67, 194, 43, 27, 12, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 141, 75, 67, 213, 143, 230}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 51, 118, 146, 12}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 88}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 219, 255, 85, 237, 49, 209, 37, 150}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 117, 10, 70, 234, 33}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 8, 82, 161, 248}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 217, 245, 61, 65, 49}, 235},
	{{113, 31, 181, 245, 21, 0, 99, 132, 151, 248, 47, 157, 230, 182, 65, 26}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 29, 142, 133, 168, 22, 146, 150, 92}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 163, 40, 250}, 235},
	{{113, 31, 181, 245, 21, 0, 217, 19, 203, 59, 129, 106, 196, 209, 230, 42}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 214, 161, 173, 119, 163, 137, 244}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 154, 18, 85, 46, 92, 132}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 173, 244, 236}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 175, 24, 225, 49, 146}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 157, 121, 192}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 121, 185, 200, 131, 249, 208, 48, 56}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 19, 3, 213, 108, 32, 202, 118}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 30}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 107, 186, 213, 164, 6, 235}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 244}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 187, 210, 213, 72, 49, 237, 228, 32}, 235},
	{{113, 31, 181, 245, 21, 0, 195, 215, 243, 202, 211, 224, 35, 95, 69, 79}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 186, 26, 100, 69}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 58, 157, 64, 199, 88, 76, 229}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 106, 70, 241, 57}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 216, 201, 31, 86, 26, 75, 97}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 216, 214, 179}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 208, 154, 60, 68, 251, 251, 51, 228, 181}, 235},
	{{113, 31, 181, 245, 21, 0, 11, 112, 181, 201, 198, 142, 139, 159, 56, 38}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 172, 23, 194, 143, 124, 48, 243, 87}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 39, 142, 216, 33, 39}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 37, 121, 161}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 127, 48, 254, 61, 99}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 42, 56, 0, 112, 34, 216}, 235},
	{{113, 31, 181, 245, 21, 0, 163, 254, 178, 120, 92, 87, 204, 96, 74, 84}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 0, 0, 0, 0, 0, 0, 68, 4, 230}, 235},
	{{113, 31, 181, 245, 21, 0, 0, 9, 233, 233, 55, 132, 104, 8, 110, 238}, 235},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 164, 150, 224}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 15}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 103, 74, 141, 110, 166, 212, 147, 9}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 45},
	{{181, 216, 192, 248, 184, 220, 230, 6, 134, 208, 169, 127, 80, 209, 54, 138}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 156, 153, 161}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 162, 225, 70}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 54, 215, 226, 45, 200, 140, 252}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 242, 20, 53, 219, 45}, 45},
	{{181, 216, 192, 0, 0, 211, 100, 54, 208, 223, 212, 220, 111, 198, 55, 207}, 45},
	{{181, 216, 192, 0, 0, 0, 122, 44, 210, 225, 37, 55, 75, 62, 145, 200}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 53, 137, 203, 40, 200, 98, 191, 140, 70}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 205, 3, 46, 207, 51, 74}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 172, 128, 64}, 45},
	{{181, 216, 192, 88, 94, 243, 239, 15, 134, 84, 66, 93, 162, 237, 183, 105}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 162, 234, 249, 210, 133}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 200}, 45},
	{{181, 216, 192, 0, 0, 240, 166, 0, 152, 178, 16, 99, 219, 235, 251, 240}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 223, 252, 226, 114, 82, 237}, 45},
	{{181, 216, 192, 0, 125, 33, 100, 164, 218, 120, 186, 219, 64, 206, 209, 211}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 44}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 227, 149, 179}, 45},
	{{181, 216, 192, 0, 0, 4, 222, 29, 203, 189, 174, 55, 162, 27, 97, 34}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 9, 42, 77, 119, 202, 76}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 132, 102, 5, 37, 23, 150, 151}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 151, 22, 36, 126, 4, 102}, 45},
	{{181, 216, 192, 198, 81, 30, 90, 85, 22, 58, 211, 139, 95, 198, 103, 195}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{181, 216, 192, 0, 0, 0, 66, 230, 115, 6, 51, 48, 45, 123, 110, 12}, 45},
	{{181, 216, 192, 0, 0, 0, 144, 46, 79, 157, 131, 60, 252, 18, 41, 185}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 75, 104, 82}, 45},
	{{181, 216, 192, 0, 0, 0, 72, 161, 87, 115, 127, 27, 206, 12, 13, 56}, 45},
	{{181, 216, 192, 0, 183, 1, 100, 20, 144, 246, 161, 141, 121, 51, 148, 240}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 45},
	{{181, 216, 192, 0, 23, 253, 129, 91, 73, 210, 223, 167, 30, 227, 184, 193}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 17, 10, 13, 243, 156, 242}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 127, 52, 240, 35, 20, 238}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 153, 40, 241, 70, 136, 195, 144, 30}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 159, 172, 188, 48, 144}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 147, 36, 200, 29, 106, 53, 93, 218, 202}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 94, 161, 248, 111, 145}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 192, 139, 238, 103, 240, 164}, 45},
	{{181, 216, 192, 0, 0, 153, 15, 5, 221, 208, 85, 83, 66, 200, 159, 118}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 77, 18}, 45},
	{{181, 216, 192, 0, 0, 22, 141, 193, 84, 177, 145, 98, 131, 101, 82, 56}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 47, 209, 28, 220, 128, 223}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 164, 196, 22, 252, 146, 14, 82, 195}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 253, 183, 56, 98, 98, 167, 102}, 45},
	{{181, 216, 192, 0, 0, 0, 138, 72, 242, 24, 68, 34, 31, 202, 233, 53}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 110, 228, 108, 62, 6, 236, 130, 5, 243}, 45},
	{{181, 216, 192, 0, 0, 34, 232, 69, 123, 153, 241, 73, 238, 87, 112, 57}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 95, 226, 75, 238, 199, 200}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 245, 212, 115, 17, 139, 245}, 45},
	{{181, 216, 192, 0, 0, 0, 147, 191, 185, 70, 148, 63, 206, 25, 55, 14}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 29, 181}, 45},
	{{181, 216, 192, 0, 29, 30, 130, 204, 228, 129, 46, 142, 189, 199, 176, 233}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 35, 234, 48, 228, 94, 14}, 45},
	{{181, 216, 192, 0, 12, 137, 71, 98, 232, 237, 190, 123, 157, 130, 58, 175}, 45},
	{{181, 216, 192, 139, 138, 238, 128, 190, 27, 153, 36, 198, 206, 104, 183, 65}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 203, 242, 150, 192, 72, 109, 228}, 45},
	{{181, 216, 192, 0, 0, 128, 55, 181, 243, 253, 175, 32, 37, 152, 209, 151}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 88, 49, 9, 213, 67, 192, 69, 35}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 141, 224, 10, 128, 49, 113, 236, 58, 237}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 184, 149, 230}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 58}, 45},
	{{181, 216, 192, 0, 0, 63, 3, 128, 91, 107, 4, 212, 198, 19, 142, 224}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 245}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 30, 74}, 45},
	{{181, 216, 192, 0, 78, 204, 95, 31, 52, 222, 98, 30, 173, 177, 201, 208}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 253, 165, 60, 17, 255}, 45},
	{{181, 216, 192, 0, 0, 0, 118, 150, 229, 27, 17, 203, 39, 42, 221, 76}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 242, 84, 39, 67, 50, 201, 205}, 45},
	{{181, 216, 192, 0, 244, 96, 146, 111, 26, 19, 201, 79, 183, 243, 40, 179}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 135, 255}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 224, 36, 84, 52, 255}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 27, 38, 117, 108, 57, 133}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 237, 42, 225}, 45},
	{{181, 216, 192, 113, 213, 207, 3, 115, 234, 41, 97, 215, 144, 219, 49, 168}, 45},
	{{181, 216, 192, 0, 0, 20, 189, 34, 252, 108, 195, 106, 35, 145, 52, 150}, 45},
	{{181, 216, 192, 0, 210, 228, 192, 61, 237, 45, 38, 174, 38, 206, 176, 18}, 45},
	{{181, 216, 192, 0, 0, 0, 33, 1, 141, 90, 255, 222, 55, 122, 90, 151}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 199, 97, 125, 26, 193, 220, 79}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 55, 97}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 117, 2, 119, 143, 189, 163, 24, 104, 143}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 180, 43, 38, 76, 116, 133, 198}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 77, 102, 118, 214, 228, 113}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 148, 175}, 45},
	{{181, 216, 192, 0, 0, 0, 0, 0, 0, 0, 254, 36, 212, 80, 202, 163}, 45},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 255, 81, 222, 74, 93}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 89, 240, 139}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 152}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 151, 191}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 208, 32, 238, 244, 8, 194, 53}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 202, 155, 164, 70, 221}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 197, 47}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 231, 234, 232, 207, 86}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 40, 62, 235}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 237, 252, 107, 32}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 10, 54, 138, 236, 249, 42, 190}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 127, 177, 148, 180, 181}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 46}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 64, 54, 46, 166}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 8, 118, 63}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 28, 156, 99, 168, 5, 200, 172}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 52, 238}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 232, 136, 245, 76}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 210, 95, 94, 49, 4, 231}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 181, 224, 160, 182, 172}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 239, 52, 237, 46}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 208, 45, 236, 54, 209, 31}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 33, 63, 210}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 255, 137, 211}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 250}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 99, 24, 217, 5}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 184, 119, 226, 122}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 237, 24, 44, 36, 88}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 20, 181, 160, 147, 119, 249}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 99, 210, 205, 133, 54, 76, 225}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 194, 188, 42, 218, 94, 238, 246}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 70, 198, 51, 26, 237, 220}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 213, 127}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 116, 209, 255}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 204, 24, 87}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 181, 28, 247, 215, 101, 102, 243}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 181}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 247, 253, 70, 152}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 253}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 45, 228, 154, 48, 83, 172}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 88, 61, 15, 56, 241, 215}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 89}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 18, 83, 45}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 60}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 180, 56, 30, 183}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 37, 2, 140, 145, 240, 86}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 241, 144, 249}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 70, 95}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 238, 50, 5, 207, 215, 201, 128}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 138, 73, 223, 63, 241, 172, 221}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 33, 93, 207, 40, 87, 228}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 116, 115, 180, 172, 57, 40}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 57, 16, 75, 100, 120, 164}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 243, 108}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 50, 195, 118}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 192, 244, 1, 74}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 90, 180, 188, 225, 184, 233, 8}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 62, 99, 2}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 150, 234, 45, 89, 200, 124}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 156, 107, 84, 5, 192, 162}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 174, 43, 79, 211, 231, 170}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 61, 141, 78, 103, 1}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 21, 92, 86, 191, 58, 218}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 106}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 203, 152, 160}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 43, 105, 119, 203}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 159, 122, 225, 114, 5, 168}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 139, 45, 170, 110, 147, 16, 194}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 146, 247, 182}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 52}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 220, 188, 139, 231, 104}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 75, 132, 106, 60}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 13, 51, 210}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 107, 125}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 26, 220, 212, 137, 118, 24, 18}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 150, 104}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 53, 30, 74, 121, 240}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 244, 12, 217}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 15, 201, 138, 222, 180}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 129, 222}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 235, 107, 66, 0, 246, 177}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 0, 39, 77}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 144, 102, 47, 155, 196}, 164},
	{{87, 26, 119, 229, 97, 255, 9, 43, 32, 0, 0, 0, 0, 21, 94, 23}, 164},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{205, 112, 67, 163, 196, 148, 5, 105, 8, 138, 144, 3, 171, 213, 159, 128}, 130},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 246}, 166},
	{{136, 27, 192, 176, 53, 221, 221, 78, 179, 64, 73, 154, 146, 187, 238, 139}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 110, 132, 201, 54, 105, 159, 13, 51}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 249, 222, 13, 24, 165, 208, 237}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 166},
	{{136, 27, 192, 85, 244, 100, 57, 83, 237, 237, 7, 75, 170, 124, 189, 130}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 74, 0}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 170}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 237, 29, 223, 228, 0, 57, 8, 23}, 166},
	{{136, 27, 192, 0, 0, 88, 41, 6, 142, 178, 137, 45, 82, 131, 89, 50}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 213, 255, 139, 155, 253}, 166},
	{{136, 27, 192, 0, 0, 0, 141, 205, 8, 56, 20, 220, 132, 32, 247, 164}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 162, 151, 194, 216, 54, 228, 245, 43}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 218}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{136, 27, 192, 0, 83, 27, 35, 13, 215, 83, 45, 143, 183, 96, 173, 158}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 114, 83, 110, 177, 1}, 166},
	{{136, 27, 192, 179, 197, 130, 166, 40, 43, 58, 204, 25, 228, 10, 175, 103}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 31, 24, 169, 119, 87}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 42, 41, 221, 236, 31, 135, 90, 54}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 117, 176}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 44}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 161, 96}, 166},
	{{136, 27, 192, 0, 0, 139, 195, 177, 152, 219, 167, 145, 3, 114, 156, 65}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 177, 122}, 166},
	{{136, 27, 192, 2, 162, 238, 180, 85, 236, 236, 150, 253, 159, 245, 29, 222}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 166},
	{{136, 27, 192, 0, 0, 0, 131, 239, 38, 26, 134, 65, 36, 56, 208, 200}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 64, 154, 38, 63, 66}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 78, 188, 65, 7, 136, 254, 180, 224}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 192, 23, 177, 250, 158, 246, 152, 119, 121}, 166},
	{{136, 27, 192, 0, 0, 201, 137, 154, 220, 196, 178, 188, 211, 185, 223, 55}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 180, 26}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 112, 22, 45, 116, 106, 45, 215, 172}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 41, 225, 116, 44, 255, 80, 5, 236, 32}, 166},
	{{136, 27, 192, 0, 250, 117, 55, 6, 239, 78, 181, 110, 93, 52, 189, 247}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 85, 76, 54, 139, 25, 123, 163, 70}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 58, 27, 195}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 135, 131, 233, 223, 25, 254, 166, 248}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 137, 10, 83, 66, 35, 179}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 27, 177, 32, 254, 231, 79, 209}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{136, 27, 192, 0, 0, 195, 80, 229, 249, 253, 19, 20, 154, 183, 124, 176}, 166},
	{{136, 27, 192, 0, 0, 55, 173, 107, 15, 42, 238, 171, 192, 158, 34, 202}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 86, 153, 56, 137, 190, 45, 200, 55, 225}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 159}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 19, 127, 254, 24, 111, 222, 198, 58}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 108}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 56, 77, 213, 169, 12, 62, 29}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 56}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 206, 137}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 14, 57, 163, 49, 88}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 28, 110, 99, 159, 186, 149, 137, 119, 251}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 182, 169, 97, 88, 196}, 166},
	{{136, 27, 192, 44, 208, 52, 32, 169, 137, 244, 174, 37, 115, 164, 139, 15}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 37, 196}, 166},
	{{136, 27, 192, 190, 56, 244, 49, 64, 152, 105, 84, 29, 198, 32, 229, 36}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 18, 140}, 166},
	{{136, 27, 192, 0, 163, 9, 162, 21, 166, 180, 97, 111, 102, 192, 207, 155}, 166},
	{{136, 27, 192, 87, 0, 42, 6, 240, 185, 16, 54, 24, 201, 217, 62, 230}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 214, 196}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 200, 236, 25, 126, 243, 60}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 70}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 169, 246, 124, 151, 229, 23}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 190}, 166},
	{{136, 27, 192, 0, 171, 234, 36, 187, 94, 57, 191, 98, 200, 26, 149, 34}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 198, 3, 68, 110, 114, 252, 99, 69}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 147, 48, 10, 41, 243, 163, 122, 62, 217}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 31}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 134, 98, 196}, 166},
	{{136, 27, 192, 0, 0, 31, 220, 27, 216, 42, 66, 110, 230, 10, 246, 60}, 166},
	{{136, 27, 192, 122, 247, 112, 36, 111, 207, 197, 53, 235, 28, 144, 17, 120}, 166},
	{{136, 27, 192, 150, 118, 68, 186, 163, 208, 139, 173, 35, 153, 78, 56, 87}, 166},
	{{136, 27, 192, 41, 218, 84, 37, 139, 88, 190, 104, 89, 12, 141, 248, 243}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 88, 215, 123, 33, 97, 154, 145, 190, 204}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 31, 153, 87, 168, 38, 42, 251, 237}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 146, 197, 62, 172, 189, 183, 241}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 166},
	{{136, 27, 192, 0, 0, 156, 88, 177, 133, 49, 248, 189, 30, 61, 197, 81}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 108}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 166},
	{{136, 27, 192, 0, 252, 26, 187, 232, 239, 246, 184, 166, 242, 37, 100, 48}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 189, 241, 147, 223, 34, 1, 212, 243, 254}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 44}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 210, 28}, 166},
	{{136, 27, 192, 0, 0, 0, 0, 0, 0, 0, 0, 30, 29, 168, 97, 40}, 166},
	{{136, 27, 192, 0, 0, 111, 199, 25, 52, 55, 82, 158, 138, 135, 122, 74}, 166},
	{{136, 27, 192, 0, 0, 3, 139, 118, 163, 185, 22, 39, 14, 49, 7, 223}, 166},
	{{136, 27, 192, 0, 0, 0, 225, 222, 153, 12, 45, 113, 4, 94, 8, 122}, 166},
	{{2, 175, 111, 0, 147, 46, 33, 213, 255, 124, 54, 70, 248, 243, 187, 127}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 172, 195}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 45, 51}, 140},
	{{2, 175, 111, 0, 0, 142, 209, 248, 150, 156, 128, 180, 0, 54, 43, 50}, 140},
	{{2, 175, 111, 0, 0, 0, 194, 161, 162, 17, 66, 153, 156, 254, 75, 148}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 255}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 172, 36, 114, 173, 141, 230, 128, 50}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 218, 199, 129}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 176, 108, 203, 51, 25, 181, 249, 100, 135}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 0, 125}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 88, 68, 192, 84, 185}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 227, 52, 9}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 171}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 203, 157, 211, 122, 208, 5, 76, 216}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 221, 208, 176, 229, 49, 89, 7}, 140},
	{{2, 175, 111, 0, 0, 84, 25, 156, 163, 208, 51, 177, 166, 122, 227, 102}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 217}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 51, 237}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 216, 244, 124, 7, 19, 92, 209, 62}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 169}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 174, 91, 228, 45, 205, 127, 45, 170, 247}, 140},
	{{2, 175, 111, 0, 15, 6, 20, 223, 24, 122, 100, 127, 228, 95, 104, 199}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 103, 162, 236}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 103, 179, 12, 109, 122, 4, 13, 106}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{2, 175, 111, 0, 135, 174, 119, 33, 187, 138, 175, 233, 166, 22, 197, 130}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 23, 147, 8, 162, 131}, 140},
	{{2, 175, 111, 0, 59, 126, 55, 40, 180, 24, 159, 181, 235, 84, 91, 146}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 2, 93, 245, 197, 173, 70, 85, 107, 44}, 140},
	{{2, 175, 111, 0, 174, 242, 169, 145, 201, 41, 41, 193, 212, 74, 57, 44}, 140},
	{{2, 175, 111, 0, 0, 232, 101, 138, 176, 125, 156, 16, 63, 221, 179, 102}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 252, 255, 25, 12, 52, 196, 219, 65}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 99, 80, 66}, 140},
	{{2, 175, 111, 0, 229, 114, 186, 227, 191, 119, 141, 244, 153, 162, 205, 89}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 149, 143, 7}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 160, 80, 119, 3, 161, 146, 121, 22, 84}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 72, 237, 238, 222, 226, 233, 153}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 182, 82, 138}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 45}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 232, 33, 165}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 218, 197}, 140},
	{{2, 175, 111, 0, 0, 110, 154, 170, 9, 227, 166, 242, 147, 144, 185, 102}, 140},
	{{2, 175, 111, 0, 182, 96, 86, 117, 81, 223, 67, 67, 163, 195, 156, 4}, 140},
	{{2, 175, 111, 0, 0, 243, 19, 87, 160, 85, 226, 117, 135, 30, 200, 230}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 71}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 177, 153, 151, 92, 171}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 85}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 216, 128, 243, 129, 32, 97, 5, 23, 232}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 38, 47, 48, 88, 117, 108}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{2, 175, 111, 0, 0, 202, 206, 226, 8, 43, 97, 215, 253, 5, 10, 154}, 140},
	{{2, 175, 111, 0, 224, 41, 33, 223, 28, 177, 12, 114, 187, 131, 148, 169}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 233, 183, 50, 235, 80, 88, 227, 130, 133}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 154, 97}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 111}, 140},
	{{2, 175, 111, 0, 0, 0, 225, 239, 112, 237, 92, 196, 205, 175, 60, 130}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 211}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 68, 150}, 140},
	{{2, 175, 111, 0, 131, 18, 169, 12, 188, 226, 234, 202, 163, 183, 63, 160}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 31, 217, 153, 20, 160, 16, 27, 56}, 140},
	{{2, 175, 111, 0, 0, 0, 32, 74, 15, 194, 98, 61, 199, 112, 208, 69}, 140},
	{{2, 175, 111, 0, 0, 108, 9, 124, 109, 80, 204, 5, 222, 219, 170, 57}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 73, 114, 143, 100, 177, 196, 103, 46, 158}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 247, 199, 72, 49, 167, 136, 101, 122}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 213, 1, 86, 48, 24, 185, 129}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 100, 3, 136, 90, 12, 128}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 0}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 56, 125, 168, 60, 130, 35, 85, 153}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 236, 186, 73, 154, 69, 28, 253, 145}, 140},
	{{2, 175, 111, 0, 56, 51, 65, 207, 140, 15, 27, 150, 216, 4, 141, 83}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 121, 207, 15, 223, 148, 221, 4, 242}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 128, 195, 24, 130, 209}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 14, 127, 94, 57, 67, 35}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 29, 3, 233}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 71, 85, 79, 185, 224, 101, 58, 242}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 182, 16, 150, 131, 119, 73}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 15, 34, 88, 117, 66, 182, 52, 198}, 140},
	{{2, 175, 111, 0, 131, 227, 181, 187, 44, 40, 104, 229, 245, 17, 231, 147}, 140},
	{{2, 175, 111, 0, 0, 214, 78, 197, 61, 68, 67, 241, 202, 103, 241, 152}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 248, 6, 153, 155, 230}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 180}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 59, 194, 113}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 252, 167, 48, 58, 142, 162, 234}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 159, 131, 102, 79, 227, 115, 147}, 140},
	{{2, 175, 111, 0, 53, 145, 162, 83, 126, 21, 5, 221, 190, 68, 221, 140}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 2, 132, 37, 229, 77, 246, 100, 234, 8}, 140},
	{{2, 175, 111, 0, 0, 0, 0, 0, 0, 0, 207, 181, 20, 55, 96, 210}, 140},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 125}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 189}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 71}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 164}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 126}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 233}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 190}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 180}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 100}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 84}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 7}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 113}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 175}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 95}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 104}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 62}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 151}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 118}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 57}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{222, 131, 85, 218, 16, 229, 44, 230, 243, 76, 250, 139, 1, 203, 108, 0}, 47},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 152}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 211}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 24}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 215}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 187}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 33}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 48}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 96}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 214, 74}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 220}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 111}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 89}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 211}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 246}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 225}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 219}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 177}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 17}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 133}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 147}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 63}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 179}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 138}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 173}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 197, 20}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 66}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 210}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 154}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 148}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 66}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 112}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 2}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 242}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 46}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 18}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 210}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 42}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 217}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 160}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 65}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 170}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 7}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 166}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 108, 63}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 0, 0}, 148},
	{{101, 180, 77, 142, 194, 73, 196, 246, 107, 100, 194, 72, 204, 124, 181, 83}, 148},
	{{96, 0, 0, 0, 0, 0, 209, 235, 108, 138, 14, 97, 150, 139, 48, 252}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 109},
	{{96, 0, 230, 156, 18, 32, 218, 157, 116, 214, 33, 188, 227, 172, 73, 131}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 250, 183, 32, 152, 105, 147, 204, 18, 190}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 181, 172, 15}, 109},
	{{96, 0, 0, 8, 177, 147, 63, 58, 87, 216, 253, 7, 232, 58, 12, 114}, 109},
	{{96, 0, 0, 0, 0, 0, 211, 194, 238, 6, 0, 250, 102, 1, 193, 239}, 109},
	{{96, 0, 0, 0, 0, 173, 145, 26, 173, 222, 131, 138, 248, 82, 123, 9}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 189, 230, 30, 208, 84, 228, 31, 39}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 99, 149}, 109},
	{{96, 225, 244, 121, 150, 207, 40, 110, 236, 99, 136, 150, 241, 170, 26, 103}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 64, 255, 217}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 35, 162, 235, 234, 192, 110, 190, 27}, 109},
	{{96, 0, 0, 0, 0, 0, 172, 208, 61, 91, 35, 116, 16, 92, 211, 90}, 109},
	{{96, 0, 0, 26, 25, 100, 219, 46, 76, 2, 234, 250, 68, 101, 69, 102}, 109},
	{{96, 0, 0, 0, 0, 0, 135, 135, 164, 216, 250, 138, 167, 84, 82, 30}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 35, 60, 25, 17, 251, 157, 112, 233, 86}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 13, 216}, 109},
	{{96, 85, 229, 145, 53, 174, 6, 59, 251, 66, 116, 192, 77, 130, 213, 153}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 173, 195, 218, 207, 120, 144, 5}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 29}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 46, 74, 103, 68, 31}, 109},
	{{96, 0, 0, 0, 0, 2, 195, 138, 161, 27, 250, 143, 9, 153, 63, 233}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 207, 1, 81, 230, 246, 85, 24, 104, 185}, 109},
	{{96, 0, 18, 6, 0, 186, 78, 165, 131, 137, 21, 246, 45, 61, 174, 213}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 143, 36}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 50, 89, 39, 235, 175, 228, 139, 227, 246}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{96, 0, 0, 0, 0, 0, 25, 245, 121, 52, 53, 92, 186, 232, 246, 92}, 109},
	{{96, 0, 0, 0, 0, 185, 72, 136, 145, 22, 92, 99, 252, 32, 148, 60}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 27, 190, 232, 156, 8, 182, 157, 181}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 127, 133, 19, 187, 87, 231, 152}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 53, 58, 156, 99, 197, 173, 23, 109, 100}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 103, 175, 199, 252, 2, 219, 109, 225}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 109},
	{{96, 0, 0, 0, 0, 0, 90, 85, 157, 34, 177, 152, 75, 149, 33, 110}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 144, 185}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 50, 15, 128, 92, 222}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 103, 157, 157, 144}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 12, 43, 249, 238, 56, 193, 193, 115, 206}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 252, 87, 19, 234}, 109},
	{{96, 0, 0, 0, 0, 0, 37, 11, 110, 128, 37, 66, 184, 9, 179, 160}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{96, 0, 0, 0, 0, 36, 215, 126, 164, 179, 196, 61, 196, 242, 27, 248}, 109},
	{{96, 0, 0, 0, 0, 189, 245, 110, 123, 84, 137, 133, 163, 195, 165, 165}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 9, 201, 121, 158}, 109},
	{{96, 0, 0, 0, 0, 64, 205, 30, 50, 134, 101, 140, 2, 37, 76, 130}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 235, 46, 93, 211, 222, 41, 188}, 109},
	{{96, 0, 0, 138, 87, 183, 246, 87, 181, 147, 221, 136, 255, 41, 143, 120}, 109},
	{{96, 0, 0, 250, 13, 35, 255, 175, 116, 229, 219, 130, 186, 17, 225, 9}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 116, 118}, 109},
	{{96, 0, 0, 87, 41, 40, 97, 122, 5, 105, 3, 105, 12, 21, 41, 207}, 109},
	{{96, 0, 68, 153, 152, 55, 94, 169, 95, 231, 103, 245, 216, 105, 201, 190}, 109},
	{{96, 0, 0, 0, 147, 198, 198, 176, 180, 121, 236, 163, 233, 72, 254, 213}, 109},
	{{96, 0, 0, 0, 128, 160, 94, 205, 212, 1, 169, 225, 91, 52, 24, 146}, 109},
	{{96, 0, 0, 0, 0, 0, 208, 4, 7, 97, 29, 111, 140, 181, 75, 221}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 211, 223, 147, 136, 7, 47, 38, 103, 85}, 109},
	{{96, 242, 0, 74, 222, 44, 101, 219, 135, 191, 175, 226, 76, 64, 177, 127}, 109},
	{{96, 0, 0, 0, 0, 0, 99, 173, 205, 85, 226, 100, 130, 180, 115, 192}, 109},
	{{96, 0, 39, 254, 173, 216, 172, 220, 174, 128, 80, 83, 43, 48, 85, 27}, 109},
	{{96, 0, 61, 94, 242, 244, 116, 48, 32, 177, 221, 167, 163, 68, 149, 5}, 109},
	{{96, 0, 0, 0, 52, 131, 172, 68, 55, 28, 250, 74, 205, 231, 245, 148}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 203, 182, 33}, 109},
	{{96, 0, 0, 0, 0, 0, 74, 121, 146, 13, 94, 40, 40, 144, 106, 220}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 35}, 109},
	{{96, 0, 0, 51, 201, 90, 53, 237, 251, 208, 121, 120, 58, 64, 130, 43}, 109},
	{{96, 209, 173, 252, 138, 149, 241, 137, 161, 105, 116, 28, 155, 142, 3, 157}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 153, 127, 37, 157, 31, 18, 4}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 119, 250, 168, 120}, 109},
	{{96, 0, 64, 122, 177, 49, 76, 190, 197, 220, 220, 166, 142, 2, 167, 16}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 225, 75, 36, 210, 113, 76, 47}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157}, 109},
	{{96, 0, 161, 226, 13, 58, 32, 110, 222, 99, 31, 53, 172, 139, 170, 44}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 219, 211, 40}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 85, 57, 144}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 109},
	{{96, 0, 0, 0, 0, 0, 138, 10, 209, 54, 19, 177, 24, 112, 203, 99}, 109},
	{{96, 0, 62, 242, 23, 63, 129, 58, 140, 211, 200, 165, 2, 148, 33, 123}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 55, 229, 108, 210, 192, 244, 62}, 109},
	{{96, 0, 0, 0, 0, 59, 62, 199, 237, 74, 195, 249, 102, 23, 189, 177}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 65, 236, 14, 246, 229, 237, 240, 201}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 159, 23, 84}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 203, 218, 33, 154, 20, 127, 45, 126, 56}, 109},
	{{96, 0, 23, 120, 189, 36, 106, 39, 107, 218, 183, 214, 143, 160, 18, 68}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 236, 32, 166}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16}, 109},
	{{96, 0, 148, 207, 197, 91, 125, 222, 214, 217, 214, 78, 120, 191, 243, 243}, 109},
	{{96, 190, 137, 85, 42, 60, 10, 65, 123, 66, 168, 128, 154, 113, 86, 188}, 109},
	{{96, 0, 0, 214, 213, 153, 14, 211, 92, 4, 78, 82, 8, 177, 116, 211}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 11, 82, 243, 196, 65}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 101, 116}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 109},
	{{96, 0, 0, 0, 93, 127, 157, 184, 97, 85, 134, 154, 85, 192, 187, 133}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 216, 166, 131}, 109},
	{{96, 0, 0, 0, 0, 232, 145, 167, 246, 212, 131, 178, 50, 91, 188, 145}, 109},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 19}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 231}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 233}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 146}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 99}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 91}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 85}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 166}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 67}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 242}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 72}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 104}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 163}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 59}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 102}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 220}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 6}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 110}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 13}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 199}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 137}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 198}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 188}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 160}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 139}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 1}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 254}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 97}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 213}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 27}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 145}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 227}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{46, 62, 191, 130, 110, 128, 235, 62, 68, 39, 58, 152, 207, 204, 96, 0}, 94},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 79, 11, 95, 184, 83, 111}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 216}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 38, 245, 198}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 95, 2, 136, 203, 102}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 251, 143, 213, 229, 142, 13}, 85},
	{{111, 11, 96, 0, 0, 0, 203, 249, 70, 129, 43, 2, 248, 175, 60, 77}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 186, 173, 232, 217, 163, 117, 222, 252, 135}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 180, 245, 129}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 84, 174, 107}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 122, 228, 125, 204, 229, 177, 62}, 85},
	{{111, 11, 96, 0, 0, 78, 64, 139, 238, 196, 178, 56, 8, 87, 173, 37}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 206, 157}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 0, 138, 5}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 196, 196, 233, 148, 122, 67, 169}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 103}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 253, 147, 209, 25, 110, 169, 228, 122, 32}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 100, 27, 186, 61, 237, 187}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 132, 6, 141, 75, 178, 162, 53, 101, 158}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 181, 83, 52}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22}, 85},
	{{111, 11, 96, 199, 41, 45, 223, 226, 198, 202, 127, 163, 24, 206, 132, 95}, 85},
	{{111, 11, 96, 0, 0, 0, 1, 78, 229, 197, 20, 102, 22, 221, 71, 228}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 246, 60, 153, 114, 59, 242}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 251, 77, 226, 238, 128, 7, 81}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 12, 68, 3}, 85},
	{{111, 11, 96, 0, 0, 0, 93, 169, 239, 50, 50, 134, 110, 248, 193, 122}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 179, 61}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 234, 98, 214, 233, 108, 101, 61}, 85},
	{{111, 11, 96, 0, 0, 0, 227, 206, 18, 244, 152, 199, 66, 238, 111, 238}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 85},
	{{111, 11, 96, 0, 0, 0, 175, 132, 222, 37, 34, 172, 242, 15, 252, 61}, 85},
	{{111, 11, 96, 0, 3, 166, 153, 20, 40, 178, 176, 54, 193, 15, 51, 56}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215}, 85},
	{{111, 11, 96, 0, 232, 41, 73, 0, 104, 222, 229, 28, 65, 33, 0, 2}, 85},
	{{111, 11, 96, 186, 45, 198, 164, 36, 246, 81, 121, 251, 123, 23, 117, 27}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 126, 180, 36, 72, 9, 250}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 23, 136, 17, 155, 141, 14, 114}, 85},
	{{111, 11, 96, 0, 122, 57, 184, 180, 35, 67, 63, 80, 185, 227, 12, 228}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 9, 15, 201, 129, 34, 31, 23, 3}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 182, 63, 224, 127, 195, 162, 234, 28}, 85},
	{{111, 11, 96, 0, 105, 204, 243, 82, 57, 124, 23, 223, 167, 231, 106, 4}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137}, 85},
	{{111, 11, 96, 0, 0, 0, 242, 110, 253, 15, 221, 55, 108, 209, 93, 40}, 85},
	{{111, 11, 96, 0, 0, 0, 60, 84, 27, 225, 96, 19, 61, 158, 31, 139}, 85},
	{{111, 11, 96, 0, 24, 90, 39, 222, 195, 247, 39, 122, 184, 43, 114, 29}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 178, 10, 82, 124, 82, 18}, 85},
	{{111, 11, 96, 0, 0, 111, 118, 195, 185, 44, 219, 252, 203, 129, 117, 120}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 120, 167, 157, 172, 187, 232, 28}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 166, 5}, 85},
	{{111, 11, 96, 0, 0, 23, 101, 178, 87, 26, 218, 146, 122, 113, 186, 125}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 94, 53, 180}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 20, 153, 250, 200, 23, 132, 28, 75}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 188, 54, 113, 199, 110}, 85},
	{{111, 11, 96, 0, 53, 11, 46, 210, 221, 83, 186, 42, 196, 247, 52, 137}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 58, 167, 0, 141, 138, 150, 220}, 85},
	{{111, 11, 96, 52, 117, 233, 250, 60, 128, 106, 235, 114, 27, 84, 253, 242}, 85},
	{{111, 11, 96, 0, 0, 0, 55, 39, 14, 115, 84, 33, 233, 9, 93, 178}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 32, 161}, 85},
	{{111, 11, 96, 0, 31, 181, 65, 162, 62, 96, 139, 34, 203, 0, 231, 199}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 135, 233, 242}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 229, 189, 65, 36, 253}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 90, 168, 8}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 68}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 2, 5, 21, 198, 1, 46}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 149, 12, 17, 209, 197, 18}, 85},
	{{111, 11, 96, 255, 23, 69, 103, 181, 160, 145, 237, 101, 32, 218, 241, 151}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 250}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 176, 53, 34, 158, 105}, 85},
	{{111, 11, 96, 0, 0, 0, 38, 147, 169, 137, 165, 176, 176, 15, 238, 71}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 85},
	{{111, 11, 96, 0, 0, 0, 246, 94, 53, 5, 113, 72, 10, 71, 242, 182}, 85},
	{{111, 11, 96, 0, 242, 252, 146, 158, 144, 56, 59, 78, 130, 252, 69, 119}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 15, 74, 204, 69, 219, 168, 156, 246, 27}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 14}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 66, 74, 59, 95, 43, 62}, 85},
	{{111, 11, 96, 0, 0, 0, 182, 182, 124, 218, 253, 149, 247, 56, 162, 135}, 85},
	{{111, 11, 96, 0, 0, 82, 114, 201, 154, 240, 50, 11, 16, 90, 32, 100}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 53, 35, 153, 20, 3}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 155, 247, 226, 126, 80, 7, 52, 92, 4}, 85},
	{{111, 11, 96, 0, 0, 0, 0, 92, 208, 160, 231, 57, 114, 50, 31, 38}, 85},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 199, 86}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 72}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 190}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 25}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 24}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 197}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 197}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 214}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 99}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 55}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 142}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 105, 66}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 93}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 237, 72}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 130}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 223}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 178, 117}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 151}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 182, 175}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 164}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 185}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 100, 11}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 25, 119}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 40, 210}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 63}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 40, 246}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 95}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 254}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 148, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 25}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 129, 191}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 14, 73}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 222}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 137}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 221, 1}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 108}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 222}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 174, 175}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 155, 74}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 60}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 176}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 44}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 11}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 68}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 16, 218}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 173}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 19, 138}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 77, 137}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 104, 234}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 48}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 94}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 173}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 161}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{58, 43, 14, 93, 102, 210, 117, 208, 222, 171, 130, 41, 16, 16, 0, 0}, 250},
	{{141, 52, 0, 0, 130, 56, 229, 100, 36, 139, 152, 135, 49, 170, 173, 209}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 255, 91}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 172, 72, 230, 253, 65, 226}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 80, 41, 131, 56, 60, 43, 4, 223}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 87, 169}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 8, 28, 98, 248, 93, 158, 127, 235, 234}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 232, 97, 53, 115, 191, 4, 133, 36, 118}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 22}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 94, 93, 131, 238, 186, 80}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 248, 11, 60, 117, 64, 216, 30}, 153},
	{{141, 52, 0, 0, 0, 0, 174, 38, 14, 116, 123, 96, 44, 103, 228, 230}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 146, 150, 158, 233, 220, 76, 14, 158}, 153},
	{{141, 52, 0, 0, 0, 0, 121, 164, 54, 176, 88, 131, 132, 205, 61, 41}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 182, 232, 106, 176, 132, 117, 84}, 153},
	{{141, 52, 0, 0, 0, 0, 70, 126, 31, 79, 192, 209, 0, 217, 196, 55}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 143, 10, 235, 128, 202, 105, 248}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{141, 52, 0, 70, 32, 59, 15, 176, 139, 89, 207, 81, 148, 213, 78, 107}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 195, 86, 169, 56, 46, 184, 180, 137, 126}, 153},
	{{141, 52, 0, 0, 186, 72, 222, 151, 14, 211, 63, 170, 148, 6, 162, 11}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 58, 225, 8}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 193, 121}, 153},
	{{141, 52, 0, 0, 132, 33, 135, 13, 104, 222, 58, 88, 95, 149, 67, 133}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 217, 5}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 205, 233, 194, 93, 35, 47}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 137, 144, 116, 11, 28, 83, 124, 88, 238}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{141, 52, 0, 64, 130, 232, 48, 221, 81, 61, 220, 255, 120, 44, 164, 133}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 130, 161, 162, 83}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 227, 103, 61, 108, 190, 215, 7, 213}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 24, 65, 156, 9, 229, 18, 125, 204, 139}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 29, 255, 195}, 153},
	{{141, 52, 0, 0, 0, 143, 215, 56, 61, 155, 39, 27, 216, 226, 2, 135}, 153},
	{{141, 52, 0, 246, 27, 15, 205, 229, 172, 158, 187, 27, 232, 77, 154, 140}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 246}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 107, 34, 12, 116, 163, 85, 158}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 90, 99, 18, 137, 61, 182, 205}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 16, 2, 186}, 153},
	{{141, 52, 0, 0, 193, 136, 68, 198, 126, 63, 197, 77, 105, 102, 123, 233}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 186, 18, 32, 162, 88, 251, 172}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 232, 186, 73, 26, 111, 54, 30}, 153},
	{{141, 52, 0, 0, 158, 109, 3, 203, 49, 69, 0, 149, 240, 168, 222, 33}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 134, 248, 182, 20, 225, 34}, 153},
	{{141, 52, 0, 0, 34, 96, 105, 85, 54, 112, 139, 208, 166, 105, 97, 95}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 22, 126, 207}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 41, 62, 215, 188, 172, 216, 46, 194}, 153},
	{{141, 52, 0, 0, 85, 185, 120, 135, 225, 13, 74, 36, 42, 76, 212, 232}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 81, 212, 253, 80}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 177, 234, 83, 75}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 197, 137, 143}, 153},
	{{141, 52, 0, 146, 65, 197, 239, 62, 132, 210, 26, 193, 203, 42, 206, 153}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196}, 153},
	{{141, 52, 0, 0, 0, 0, 136, 238, 70, 93, 127, 1, 7, 232, 133, 149}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 245, 15, 65, 119}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 57, 126, 109, 157, 24, 74}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 214, 232}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 94, 127, 19, 161, 12, 117, 188, 109}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 179, 161, 239, 98, 195, 190, 40, 17, 67}, 153},
	{{141, 52, 0, 0, 0, 54, 138, 156, 70, 94, 10, 58, 127, 36, 125, 200}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 60}, 153},
	{{141, 52, 0, 0, 0, 148, 188, 254, 13, 64, 96, 155, 210, 144, 21, 43}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 29, 219, 69, 35}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 3}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 40, 109, 28, 117}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 157, 210, 90, 233, 134, 72, 136}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 201, 92, 6, 213, 166, 14, 24}, 153},
	{{141, 52, 0, 127, 137, 41, 52, 91, 4, 29, 166, 8, 207, 179, 247, 12}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 11, 101, 174, 195, 54, 123, 177, 56}, 153},
	{{141, 52, 0, 0, 0, 0, 137, 90, 240, 107, 254, 112, 183, 52, 19, 20}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 29, 1, 91, 80, 114, 30}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 208, 121, 176, 216, 236, 22, 174}, 153},
	{{141, 52, 0, 0, 0, 0, 106, 16, 93, 60, 84, 153, 31, 148, 13, 228}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 12, 164, 57}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 176}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 13, 124, 16, 170, 85, 103, 237, 222, 96}, 153},
	{{141, 52, 0, 129, 157, 3, 73, 160, 230, 66, 126, 119, 100, 98, 19, 137}, 153},
	{{141, 52, 0, 0, 239, 60, 93, 176, 187, 210, 90, 3, 219, 98, 67, 161}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 233, 7, 14, 55, 227, 157, 51, 76}, 153},
	{{141, 52, 0, 0, 0, 65, 19, 217, 72, 254, 250, 153, 17, 70, 20, 212}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 175, 163, 67, 115}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 80, 192, 1, 234, 230, 165, 120, 237}, 153},
	{{141, 52, 0, 42, 225, 125, 100, 177, 254, 225, 48, 56, 202, 193, 35, 121}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 212, 180, 202, 94, 119, 87, 41}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 32, 230, 119, 246, 150, 18, 245, 225, 77}, 153},
	{{141, 52, 0, 0, 0, 196, 244, 130, 177, 104, 5, 44, 52, 83, 29, 225}, 153},
	{{141, 52, 0, 99, 76, 98, 233, 218, 134, 110, 211, 236, 209, 233, 189, 71}, 153},
	{{141, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177}, 153},
	{{141, 52, 0, 0, 0, 0, 236, 152, 249, 0, 9, 177, 30, 30, 241, 10}, 153},
	{{141, 52, 0, 0, 0, 0, 128, 230, 184, 109, 152, 203, 19, 90, 154, 132}, 153},
	{{141, 52, 0, 0, 108, 212, 228, 34, 237, 248, 180, 142, 134, 0, 217, 59}, 153},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{170, 153, 160, 170, 144, 235, 122, 8, 106, 34, 24, 32, 102, 57, 12, 168}, 182},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 19, 156, 140}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 111}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 55}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 226, 125}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 156, 180, 101}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 232, 224}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 222, 56, 177}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 100, 165}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 126, 192}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 54, 30, 121}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 203, 172}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 235, 90, 203}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 63}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 219, 48}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 173, 125}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 168, 22}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 101, 244, 249}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 161}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 199, 59}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 120}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 8, 255}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 237}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 20, 117, 142}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 35, 9, 49, 189}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 140}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 69}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 119}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 99}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 38, 10}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 234}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 42, 95}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 58, 143}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 204}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 7, 30, 119}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 117, 29}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 49, 160, 95}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 247, 107, 164, 13}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 157, 144, 243, 241}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 62, 236, 27}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 100, 167}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 151, 62}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 53}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 253, 89, 224}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 78}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 136, 54}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 154, 154, 62}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 234, 194, 62, 188}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 105, 252, 176}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 235}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 121, 250}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 143, 118}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 76}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 60, 40, 194}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 70, 229}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 50}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 164, 188, 79}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 150, 235, 159}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 187, 251, 239, 113}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 64}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 113}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 66, 147, 47}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 245, 135, 214}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 78, 76, 243}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 204}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 14}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 227}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 2}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 57, 196, 74}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 197}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 98}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 253, 47, 85}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 25, 23, 183}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 160, 238}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 0, 0}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 252, 25, 113}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 0, 47, 146}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 71, 140, 205, 141}, 23},
	{{34, 113, 163, 107, 61, 177, 39, 172, 242, 2, 130, 0, 0, 25, 164, 141}, 23},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 129, 244}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 240, 183}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 209}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 123, 128}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 203, 208}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 5}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 130, 128}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 179}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 159}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 239}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 21, 142}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 47, 33}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 110, 93}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 255}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 36}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 185, 30}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 255, 14}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 138}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 120, 128}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 153, 55}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 234}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 235, 130}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 215}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 185, 224}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 119}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 66, 8}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 220}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 37, 94}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 234}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 61, 194}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 92}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 238, 241}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 202}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 177}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 155, 181}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 84, 130}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 62}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 153}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 153}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 86}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 235, 62}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 10, 40}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 174}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 95, 224}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 222, 153}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 75}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 143}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 187}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 238, 140}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 201, 58}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 19}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 119}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 143}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 169, 230}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 165}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 226}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 47, 151}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 120}, 38},
	{{222, 191, 239, 110, 162, 191, 195, 181, 80, 50, 85, 240, 88, 32, 0, 0}, 38},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 46, 69}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 249}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 249}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 136, 151}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 59}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 18}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 101}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 135, 150}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 115}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 213}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 30}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 45}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 217}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 159}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 98}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 33}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 130}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 120}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 143}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 151}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 206, 97}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 32}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 52}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 245}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 207}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 211}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 98}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 53}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 97}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 17}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 64, 163}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 177}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 223}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 241}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 203}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 168, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 78, 66}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 128}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 232}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 10}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 145}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 124, 207}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 166}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 217}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 104}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 14}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 158}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 129, 41}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 255}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 128}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 158, 95}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 121}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 193}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 79}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{179, 82, 253, 151, 212, 0, 72, 253, 175, 22, 34, 78, 53, 32, 0, 0}, 121},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 118, 165, 231, 105}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 40, 104, 109, 2}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 53, 213}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 124, 101, 105, 19}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 176, 124}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 106, 249, 162}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 181, 102, 83, 37}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 214}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 253, 121, 72, 25}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 76, 49, 75}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 222, 164}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 101}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 226}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 50, 2}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 250}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 197, 54, 250, 86}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 32, 4}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 107, 100}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 211, 195, 164, 3}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 71, 210, 44, 123}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 166}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 134, 87, 221}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 232}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 157, 167, 63, 141}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 171, 58}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 234}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 19, 160}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 185}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 231, 93}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 190}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 29}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 180, 188, 56, 76}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 84, 9}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 82, 161, 137}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 141, 108}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 168, 39}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 22, 132, 84}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 248, 105}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 250, 203}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 61, 227, 225, 67}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 66, 230, 4, 168}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 244, 164, 252, 150}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 18, 156, 241, 85}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 231, 240}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 169}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 198, 8}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 235, 85, 74, 105}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 48, 184, 188, 46}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 5, 63}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 14}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 215, 220, 205}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 193, 96}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 109, 118, 226}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 41}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 224, 81, 82, 115}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 157, 20, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 30, 165, 228}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 192}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 79}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 211, 93, 218, 82}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 31}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 109, 0, 216}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 138, 197}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 152, 135, 92}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 12}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 64, 204}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 159, 110, 171}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 85, 175, 176}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 6}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 228, 88, 88}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 0}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 181, 182, 151, 40, 37}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 4, 17, 25}, 146},
	{{10, 162, 20, 46, 164, 64, 88, 1, 202, 204, 124, 0, 0, 0, 0, 172}, 146},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{210, 99, 0, 240, 11, 103, 69, 74, 155, 201, 2, 105, 215, 199, 113, 210}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 32, 159, 16, 8}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 165, 19, 207}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 116, 72, 96, 246, 3, 75, 10}, 138},
	{{210, 99, 0, 0, 0, 164, 116, 233, 188, 37, 58, 240, 40, 185, 53, 151}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{210, 99, 0, 0, 121, 49, 241, 175, 108, 133, 135, 201, 47, 219, 196, 154}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 57}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 22}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 235, 164, 103, 90, 6, 232, 235}, 138},
	{{210, 99, 0, 29, 119, 210, 103, 66, 202, 246, 145, 26, 238, 208, 35, 113}, 138},
	{{210, 99, 0, 0, 0, 0, 17, 145, 225, 4, 245, 53, 234, 119, 219, 226}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 61, 140, 72}, 138},
	{{210, 99, 0, 0, 249, 219, 202, 223, 130, 176, 177, 210, 57, 10, 184, 89}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 216, 146, 165, 206, 84, 65, 210, 226}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 171, 80, 220, 56, 200, 203}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 154}, 138},
	{{210, 99, 0, 0, 0, 172, 130, 62, 77, 10, 175, 95, 51, 21, 218, 219}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74}, 138},
	{{210, 99, 0, 0, 0, 121, 229, 139, 176, 226, 126, 34, 79, 216, 227, 225}, 138},
	{{210, 99, 0, 0, 0, 16, 66, 3, 221, 100, 36, 129, 128, 168, 177, 150}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 215, 79, 150, 183, 56, 219, 11, 212, 166}, 138},
	{{210, 99, 0, 0, 0, 141, 233, 92, 56, 25, 56, 132, 144, 165, 173, 203}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 184, 203, 112, 1, 162, 233}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 218, 194, 187, 197, 120, 221}, 138},
	{{210, 99, 0, 0, 0, 57, 194, 119, 53, 250, 55, 32, 97, 31, 50, 3}, 138},
	{{210, 99, 0, 0, 0, 130, 52, 103, 171, 50, 223, 49, 20, 45, 214, 38}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 93, 94, 119, 178, 179, 2}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 40, 81, 186}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 25, 168}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 254}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 195, 192, 152, 200}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 89, 49, 148, 230}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 189, 151, 204, 108}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 226, 0, 25, 53, 20, 64, 119, 55, 2}, 138},
	{{210, 99, 0, 0, 102, 44, 14, 196, 104, 167, 162, 167, 62, 181, 170, 137}, 138},
	{{210, 99, 0, 143, 87, 40, 212, 31, 176, 210, 21, 9, 20, 74, 228, 105}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 138},
	{{210, 99, 0, 133, 252, 161, 106, 148, 63, 45, 109, 135, 187, 178, 34, 207}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 143}, 138},
	{{210, 99, 0, 61, 139, 180, 179, 196, 28, 145, 161, 18, 72, 41, 135, 215}, 138},
	{{210, 99, 0, 0, 0, 116, 51, 5, 189, 148, 179, 228, 212, 157, 64, 123}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 58, 163, 152, 132, 203, 35, 46}, 138},
	{{210, 99, 0, 0, 0, 0, 128, 78, 196, 144, 67, 14, 224, 255, 209, 50}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 171, 217, 244, 84, 184, 62, 113}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 224, 190}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 79, 243}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{210, 99, 0, 131, 153, 123, 152, 40, 137, 0, 157, 214, 177, 42, 74, 85}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 97}, 138},
	{{210, 99, 0, 0, 180, 171, 144, 32, 139, 190, 32, 73, 217, 214, 250, 153}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 169}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 139, 14, 232, 109, 141, 6, 59, 220, 210}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 184, 131, 71, 139, 59, 154}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 138},
	{{210, 99, 0, 0, 0, 0, 227, 107, 82, 182, 87, 231, 173, 127, 44, 39}, 138},
	{{210, 99, 0, 0, 0, 1, 24, 164, 47, 45, 219, 145, 229, 227, 211, 118}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 90, 4, 148, 180, 30, 199, 239, 85, 16}, 138},
	{{210, 99, 0, 0, 0, 0, 217, 206, 137, 102, 24, 213, 240, 210, 117, 125}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 60, 47, 253}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 167, 177, 170, 227, 10, 40, 113}, 138},
	{{210, 99, 0, 0, 0, 0, 192, 59, 152, 119, 76, 216, 230, 221, 202, 127}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 102, 22, 39}, 138},
	{{210, 99, 0, 0, 0, 198, 103, 207, 96, 248, 75, 135, 191, 186, 63, 14}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 125, 139, 39, 152, 72, 4, 114, 253}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 206, 26, 45}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 236, 202, 30, 159, 23, 156, 29, 228, 36}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 123, 175, 245, 67, 110, 72, 41}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{210, 99, 0, 0, 248, 73, 231, 96, 136, 148, 120, 46, 120, 13, 171, 0}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 129, 233, 192, 245}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 25}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 95}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 250, 52, 161, 159, 178, 194, 230}, 138},
	{{210, 99, 0, 0, 0, 0, 252, 185, 104, 205, 176, 49, 176, 30, 108, 134}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 76, 159, 104, 151, 220, 216, 41, 16, 128}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 211, 205, 230, 24, 227, 97, 13}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 178, 249, 155, 145, 92, 216, 200}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 138},
	{{210, 99, 0, 0, 44, 4, 32, 114, 7, 73, 199, 94, 27, 3, 81, 207}, 138},
	{{210, 99, 0, 0, 0, 190, 219, 210, 64, 197, 104, 173, 60, 133, 116, 151}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 198}, 138},
	{{210, 99, 0, 0, 166, 142, 54, 21, 150, 219, 148, 154, 14, 178, 172, 255}, 138},
	{{210, 99, 0, 201, 112, 5, 115, 115, 4, 191, 116, 76, 174, 144, 180, 53}, 138},
	{{210, 99, 0, 0, 0, 48, 237, 253, 109, 110, 212, 237, 104, 241, 174, 245}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 168, 84}, 138},
	{{210, 99, 0, 0, 0, 0, 115, 18, 212, 131, 46, 109, 232, 179, 33, 63}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 252, 77, 241, 213, 111, 138, 168, 138, 143}, 138},
	{{210, 99, 0, 0, 0, 0, 7, 58, 107, 103, 4, 139, 206, 181, 148, 161}, 138},
	{{210, 99, 0, 0, 65, 62, 209, 62, 74, 217, 57, 188, 121, 77, 26, 130}, 138},
	{{210, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 154, 0, 28, 120}, 138},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 29}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 186, 80}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 137, 34, 242}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 182}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 135, 210, 83}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 252, 76, 190}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 202}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 152, 35}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 205, 65}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 182}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 145}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 53, 229, 216, 206}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 40}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 254, 39}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 206, 4, 36}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 44, 96, 88}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 3, 155}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 200, 165}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 239, 125, 100}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 148, 143}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 49, 26}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 73, 16, 201, 177}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 120}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 138, 34, 95}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 220}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 210, 223}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 16, 23, 67}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 159, 186, 160}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 161, 59}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 153, 5, 255, 156}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 39}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 131, 176, 251}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 108, 153, 45}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 208, 77, 219, 158}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 5, 80}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 159, 116, 116}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 173, 180}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 232}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 88}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 72, 236}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 192, 32}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 133, 127, 232}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 200, 116}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 185, 110, 0, 30}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 143, 175, 125}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 129, 241}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 44}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 242, 1, 233, 201}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 247}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 202}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 161, 36, 233}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 25, 229, 189}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 228, 140}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 221, 29, 198}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 217, 106}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 189, 125}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 95}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 41, 34, 41}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 130, 190}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 79}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 29, 169, 50}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 42}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 5, 235, 148, 11}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 23, 57}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 229, 228}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 145, 111}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 109}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 54, 114, 248, 65}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 0, 0}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 85, 81, 79}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 100, 102}, 149},
	{{183, 200, 1, 2, 51, 6, 66, 142, 20, 77, 48, 244, 0, 0, 247, 137}, 149},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 86, 28, 76, 81}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 50, 217, 183, 64}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 35, 150}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 212, 83, 109}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 200, 254}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 178, 124}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 40}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 117, 165, 96}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 139}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 47, 60}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 83, 161, 63, 81}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 248, 92, 88, 64}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 153, 170, 246, 159}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 44}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 128, 182, 156}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 131}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 57, 187, 99, 173}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 119, 192, 163}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 94}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 134, 219, 145, 245}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 136, 67, 152}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 201}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 252, 120, 32}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 235}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 114}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 101, 51, 2}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 182, 46, 73}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 108}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 118}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 58, 78}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 10, 121}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 191}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 212}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 105, 172, 246, 51}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 255, 80}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 174, 165}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 43, 218}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 31}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 101, 17}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 98}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 91, 113, 11}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 52, 119, 71}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 154, 110, 99, 33}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 54, 51, 91}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 166, 236, 59, 161}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 247, 227, 91, 110}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 46, 225, 102, 188}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 205, 150}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 231, 238, 230}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 129, 142}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 153, 253}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 134}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 141, 100}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 251, 99, 235}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 194, 56, 87}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 242}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 125}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 22, 187, 212}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 235, 14, 144}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 79, 60, 123, 147}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 29, 61, 169}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 232}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 46, 55, 241}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 29, 94, 124, 166}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 41}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 187, 9, 53}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 62, 189, 182}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 171, 183, 44, 101}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 202, 245, 196}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 42, 71}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 0}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 31}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 93, 130, 72, 35}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 0, 59}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 0, 0, 178, 228}, 232},
	{{29, 20, 224, 57, 204, 161, 131, 254, 53, 133, 163, 0, 190, 36, 229, 235}, 232},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 99, 35, 166, 63, 207}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 98, 152, 184, 240, 79, 242}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 191, 47, 113, 34, 215, 159}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 79, 189, 213, 146, 86}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 185, 102, 23}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 133, 215}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 197, 10}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 6, 255, 57, 208, 248}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 33, 79}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 168, 145, 253, 118}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 110, 157, 70, 192, 17}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 58, 65, 56}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 95, 127, 21, 126, 229, 25}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 60, 196}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 14, 5}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 65, 27, 54, 124, 201, 82, 20, 249}, 255},
	{{75, 58, 170, 52, 146, 80, 146, 200, 137, 151, 79, 185, 143, 203, 17, 168}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 4, 110, 215, 34, 0, 44, 186, 66, 234}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 43, 248}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 81, 109, 18, 89, 192, 34, 147}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 253, 225, 175, 146}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 161, 96, 231, 83, 46, 66, 47}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 129, 81, 10}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 255, 205, 68}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 112, 247, 75, 219, 66}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 243, 21, 55, 201}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 98, 244, 193, 69, 54, 40, 145, 175}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 44, 30, 240}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 105, 201, 134, 176}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 196, 104, 47, 74, 90, 89, 3}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 213, 187, 233, 217}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 200, 144, 201, 203, 91, 27}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 220, 28, 195, 120, 192, 80, 170, 242}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 136, 176, 61, 177, 198, 42}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 67, 161, 239}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 207, 16, 45, 179, 123, 155}, 255},
	{{75, 58, 170, 52, 146, 80, 8, 175, 197, 32, 253, 35, 115, 84, 82, 151}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 238, 200}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 103, 10, 37, 55, 93}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 218, 70, 131, 206, 68}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 152, 25, 166, 205, 190, 12, 221}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 133, 175, 38, 123, 147, 28}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 20, 146, 112, 72, 140, 154, 215, 66}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 85, 101, 84, 0, 53, 242, 28, 7, 82}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 69, 13, 238}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 31, 233, 245, 202, 222, 159, 242, 154, 22}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 117, 195, 58, 153, 141, 3}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 32, 122, 217, 129, 176, 118, 245, 21, 92}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 197, 252, 236, 183}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 102, 201, 241, 230, 54, 34}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 29, 20, 199, 139, 158, 137, 56, 67}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 240, 10, 229, 36, 255, 227, 137, 24}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 229, 164, 0, 12, 93, 99, 169}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 100, 9}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 198, 151, 160, 31, 67, 112, 142}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 215, 22, 6, 83, 19, 66, 42, 27}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 121, 93, 91, 104, 101}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 252, 186, 135, 74, 38, 210, 194, 36}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 132, 234, 167, 72, 110, 144, 74, 7}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 45, 255, 187, 19, 10, 72, 240}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 77, 168, 15}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 35, 194, 244}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 37, 110, 199}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 82, 140, 251}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 28, 20, 152, 229}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 195, 130, 69, 172, 230, 14}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 175, 124, 89}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 20, 194, 208, 117, 49, 115, 222, 12, 205}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 16, 165}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 37, 135, 133}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 220, 241, 36, 226, 37, 222, 71}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 223, 35, 46}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 163, 180, 102, 103, 194, 58, 212, 199, 163}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 45, 255, 133, 219, 102, 141, 29, 138}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 77, 229, 68, 170, 182, 163, 51, 107, 84}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 228, 35, 95, 6, 191, 247, 62}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 124, 175}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 145, 255, 179, 229, 26, 43, 144}, 255},
	{{75, 58, 170, 52, 146, 80, 0, 0, 0, 0, 0, 0, 0, 0, 203, 25}, 255},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 123, 67, 247, 237}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 191, 101, 163, 191, 250}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 131, 173, 35, 175, 186}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 218, 21, 81, 245}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 168, 36, 139, 231, 226, 150, 152}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 62, 7}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 70, 84, 2, 80, 253, 238}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 22, 60}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 127, 29, 26, 109, 22, 214}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 230, 25, 75, 149, 202}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 26, 122}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 240, 240, 34}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 127, 74, 207, 212, 117}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 175, 7, 101, 62}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 48, 102, 62, 160, 172}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 208, 15, 196, 209, 171}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 198, 2, 183, 162, 222, 204, 183, 211}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 93, 229, 143, 222, 191, 170, 166, 109}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 101, 39, 1, 224, 207}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 97, 102, 78}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 95, 34, 129, 37, 98, 171, 2, 202}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 241, 32, 249, 194, 142}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 233, 73}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 227, 208, 231, 130, 39, 186, 222, 107, 138}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 68, 16, 237, 22, 221, 185, 154, 255, 49}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 203, 112, 17, 84, 157, 230, 56, 159}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 228, 176, 228, 230, 222}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 213, 143, 180, 197, 22, 54, 240}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 149, 47}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 69, 222, 69, 38, 131, 115, 99}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 96, 164, 134, 109, 76, 119}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 224, 39, 229, 202}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 100}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 198, 108, 79, 20, 185, 217, 98}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 220, 136, 185, 212, 13, 152, 132, 53}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 212, 75, 241}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 140, 22, 163, 197, 192, 253, 178, 239}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 161, 169, 232}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 239, 193}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 198}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 191, 211, 155, 50, 85}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 78, 88, 222, 139, 224, 183, 181, 69}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 125, 105, 185, 113, 8, 99}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 40, 169, 251, 120, 207, 126, 212, 212}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 19, 29, 134, 179, 69, 112, 73, 78, 160}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 223, 255, 145, 111, 89, 142, 154}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 138, 89, 25, 229, 214, 90, 84, 10, 178}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 84}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 45, 164, 127, 111, 143, 63, 93, 169}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 50, 105, 185, 137, 28, 212}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 3, 143, 220, 7, 224, 84, 169, 218, 94}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 121, 89}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 21, 47, 141}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 174, 2, 33}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 99, 86, 63}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 114, 115, 155, 203}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 85, 214, 6, 10}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 72, 231, 253, 81, 156, 82, 106}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 100}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 5, 55, 72, 112, 69, 68, 185}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 15, 41, 226, 60}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 138, 154, 101, 2, 190, 231, 226}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 139, 55}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 87, 249, 78, 244, 164, 187, 113}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 130, 151, 24, 57, 58, 39, 56}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 128, 150, 105, 191}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 64, 62, 27, 190, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 106, 108, 191, 84, 138, 101}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 239, 74}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 212, 58}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 244, 120, 216, 177, 148, 47, 140}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 240, 61, 64, 226, 64, 76, 73, 180}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 5, 105, 137}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 224, 105}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 35, 205, 167, 217, 28, 220, 72, 107, 18}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 29, 34, 43, 16, 166, 220, 24, 1}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 142, 22, 60, 84, 222, 97}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 160, 47}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 199, 202}, 148},
	{{92, 21, 1, 113, 185, 88, 160, 0, 0, 0, 0, 0, 0, 0, 72, 203}, 148},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 44, 53}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 41, 151, 225, 105}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 135, 132, 124}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 191, 223, 45, 252, 19}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 108, 234, 138, 195, 33, 161}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 118, 129, 116}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 84, 14, 158, 148, 2}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 215, 136, 133, 235, 62}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 115, 49, 110, 197, 196, 130}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 217, 149}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 63, 77, 123, 57, 93, 207, 87, 119}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 38, 126, 178, 114, 5}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 247, 166, 213, 102, 84, 63, 148, 175, 130}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 22, 252, 169, 90, 11, 55, 202, 22}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 94, 142, 172, 23, 176, 3, 191}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 123, 34, 144}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 47, 98, 157, 195, 218}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 20, 132, 24, 93, 73, 149, 80, 49, 211}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 130, 124, 231, 194}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 37, 4, 2, 175, 110, 216}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 66, 164}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 215, 50, 183, 143, 106, 191, 31, 210}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 194, 86, 188, 202, 77, 145, 56}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 48, 12, 16, 90, 182, 238, 100}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 42, 172, 64, 193, 235, 21, 108, 122, 129}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 228, 99, 57, 25}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 143, 64, 211, 27, 254}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 219, 164, 132, 80, 157, 154, 161}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 138, 31, 253, 24, 53, 39, 75, 164}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 225, 24, 210, 16, 24, 209, 139}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 238, 113, 196, 119}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 73, 59}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 143, 32, 10, 41, 220, 92, 161, 229, 135}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 22, 177, 203}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 39, 167, 233, 145, 250, 150, 53, 163}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 129, 156, 242, 219, 130, 191, 110, 71}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 203, 88, 122, 139, 236, 152, 11, 178, 118}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 81, 253, 66, 107}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 110, 221, 247, 206}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 147, 26}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 158, 21}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 84, 68, 71, 235}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 65, 130, 161, 109}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 105, 90, 31, 235, 57, 161}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 203, 174, 113}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 138, 157}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 8, 179, 181, 95}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 17, 113, 165}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 119, 164, 182}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 33, 197, 58, 199, 239}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 153, 50, 161, 124, 73, 27, 200, 9, 43}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 72, 213, 155}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 82, 33, 215, 227, 53, 81}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 165, 218, 15}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 93, 167, 162, 241, 219}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 252, 25, 59, 123, 46, 206, 205, 146, 233}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 14, 110, 56, 202, 60, 116}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 180, 30, 226, 156, 22, 60, 123, 67}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 155, 141, 65}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 78, 254, 55, 176, 32, 116, 46, 47}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 250, 15}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 191, 74, 64, 202, 73, 234}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 36, 96, 123, 128}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 44, 171, 86, 221, 76, 67, 60, 67}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 130, 160}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 147, 122, 246, 144, 19, 104, 208, 125, 23}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 203, 233, 243, 81}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 59, 19, 230, 92, 41, 19, 130, 142, 244}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 209, 207, 251, 12, 10, 211}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 142, 100, 167, 99, 179, 191}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 100, 24, 253, 15, 129}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 44, 85, 121, 86, 141}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 144, 78, 103, 154}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 195, 36, 91, 75, 114, 11}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 227, 245, 2, 127, 189, 71, 41, 185, 231}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 117},
	{{103, 180, 222, 187, 129, 117, 0, 0, 0, 0, 145, 240, 122, 107, 251, 115}, 117},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 70, 168, 175, 176}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 68, 240, 55, 103, 57, 83, 58}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 155, 19, 233, 3}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 48, 105, 23, 195, 33, 181, 98}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 248, 208, 156, 69}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 170, 217, 118, 110, 214, 188, 240, 195}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 96, 154, 96, 40, 105, 53, 133, 91}, 237},
	{{32, 76, 0, 132, 3, 103, 164, 147, 189, 89, 24, 246, 105, 186, 169, 35}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 45, 80, 114, 93}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 244, 0}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{32, 76, 0, 210, 96, 171, 74, 203, 26, 162, 107, 200, 253, 185, 225, 19}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 108}, 237},
	{{32, 76, 0, 0, 85, 70, 0, 175, 213, 224, 248, 227, 16, 49, 61, 178}, 237},
	{{32, 76, 0, 213, 122, 137, 1, 33, 199, 158, 9, 32, 29, 58, 199, 20}, 237},
	{{32, 76, 0, 0, 0, 225, 16, 117, 153, 240, 32, 78, 133, 201, 71, 110}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 234, 48, 44, 30, 161, 226, 38, 218}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 171, 218, 53, 32, 136, 147, 86}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 56, 44, 88, 115, 199, 187, 246, 160, 192}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 71, 245, 187, 29, 104, 255, 123, 144, 21}, 237},
	{{32, 76, 0, 78, 250, 165, 92, 34, 110, 121, 158, 90, 177, 224, 218, 217}, 237},
	{{32, 76, 0, 0, 0, 221, 248, 135, 172, 73, 107, 11, 25, 184, 128, 248}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 31, 9, 147, 240}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 225, 64}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 230, 235, 124, 17, 2, 116, 1}, 237},
	{{32, 76, 105, 147, 208, 129, 158, 152, 152, 8, 123, 21, 193, 198, 146, 248}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 235, 206, 156, 1, 141, 30, 139}, 237},
	{{32, 76, 0, 0, 189, 96, 237, 238, 143, 177, 187, 153, 252, 221, 71, 213}, 237},
	{{32, 76, 0, 84, 57, 120, 75, 225, 148, 223, 117, 8, 53, 31, 23, 45}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 228, 154}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 98, 175}, 237},
	{{32, 76, 0, 0, 0, 0, 21, 90, 152, 111, 75, 133, 87, 157, 176, 236}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 88, 194, 18, 192}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 131, 100}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 240, 130, 147, 142, 100, 84, 92, 127}, 237},
	{{32, 76, 0, 0, 83, 216, 87, 20, 71, 209, 81, 78, 55, 33, 78, 132}, 237},
	{{32, 76, 0, 96, 167, 183, 234, 9, 251, 190, 58, 24, 214, 209, 144, 143}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 209, 65, 211, 205}, 237},
	{{32, 76, 0, 0, 88, 105, 38, 25, 63, 10, 52, 114, 150, 145, 168, 27}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 101, 12, 126}, 237},
	{{32, 76, 0, 78, 194, 189, 169, 123, 218, 121, 220, 93, 254, 180, 162, 176}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 139, 30, 177}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 170, 254, 111, 255, 31, 34}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 207, 232, 107, 254, 220, 222, 0, 69}, 237},
	{{32, 76, 0, 0, 0, 0, 29, 108, 81, 79, 161, 18, 226, 160, 94, 23}, 237},
	{{32, 76, 163, 43, 148, 35, 207, 234, 95, 223, 51, 188, 139, 39, 6, 199}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 114, 183, 211, 102, 9, 89, 114, 229, 203}, 237},
	{{32, 76, 0, 0, 0, 0, 113, 134, 238, 235, 44, 153, 199, 55, 234, 244}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 220, 137, 166, 57, 102, 162}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 6, 91, 209}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 173}, 237},
	{{32, 76, 0, 0, 0, 0, 49, 44, 177, 124, 123, 97, 225, 180, 13, 3}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 116, 31, 211, 14, 39, 147, 69, 212, 141}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 82, 82, 253, 222}, 237},
	{{32, 76, 0, 0, 3, 88, 202, 89, 213, 100, 120, 202, 58, 255, 227, 136}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 42, 199, 7, 0, 4, 125}, 237},
	{{32, 76, 0, 17, 1, 61, 23, 75, 54, 113, 204, 72, 22, 186, 172, 154}, 237},
	{{32, 76, 0, 0, 0, 220, 231, 184, 91, 181, 88, 103, 190, 208, 182, 152}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 251, 235, 4, 81}, 237},
	{{32, 76, 0, 0, 0, 0, 48, 43, 52, 153, 82, 253, 140, 90, 77, 37}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 41, 247, 143, 7}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 41, 250, 128, 221, 56, 196}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 109, 20, 57}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 184, 203, 164, 174, 196, 8}, 237},
	{{32, 76, 0, 0, 0, 236, 179, 66, 38, 7, 155, 249, 56, 189, 32, 57}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 36, 84, 241, 206}, 237},
	{{32, 76, 98, 76, 24, 220, 152, 14, 95, 39, 42, 4, 35, 95, 210, 165}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 253, 86, 174}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 85}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 61, 127, 25}, 237},
	{{32, 76, 0, 49, 78, 211, 229, 74, 13, 123, 146, 105, 166, 214, 193, 127}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 186, 36, 87, 99, 187, 190, 65, 51, 248}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 141, 20, 54}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 72, 78, 30, 1, 194, 192, 4, 24}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 173, 136, 82, 3, 162, 134, 147, 29, 171}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 15, 194, 209}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 84, 191, 197, 239}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 200, 116, 213}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 10, 206, 36, 169, 13, 194}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 171}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 22, 244, 132, 173, 63, 170, 227}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 174, 234, 77}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 117, 252, 205, 45, 83, 85}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 131, 20}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 235, 208, 250}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74}, 237},
	{{32, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 146}, 237},
	{{32, 76, 0, 0, 0, 0, 126, 79, 27, 190, 111, 8, 59, 117, 236, 24}, 237},
	{{7, 60, 96, 0, 0, 255, 177, 114, 9, 109, 98, 166, 63, 4, 28, 173}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 253, 66, 193, 213, 249, 173, 184, 151}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 73, 78}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 48, 252, 53, 153, 6}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 141, 95, 165, 139, 170, 142}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 135, 143, 135, 128, 68}, 113},
	{{7, 60, 96, 0, 140, 180, 196, 185, 30, 71, 18, 44, 198, 170, 68, 252}, 113},
	{{7, 60, 96, 85, 66, 194, 245, 37, 188, 229, 63, 211, 139, 51, 215, 38}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 202, 99, 234, 123, 6, 69}, 113},
	{{7, 60, 96, 0, 0, 210, 219, 18, 13, 119, 166, 51, 238, 118, 191, 11}, 113},
	{{7, 60, 96, 0, 0, 0, 148, 26, 66, 94, 231, 147, 69, 218, 208, 9}, 113},
	{{7, 60, 96, 140, 77, 141, 48, 72, 104, 136, 129, 83, 94, 131, 101, 236}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 123, 55, 146, 217, 99}, 113},
	{{7, 60, 96, 0, 0, 112, 101, 27, 94, 154, 225, 179, 216, 207, 135, 87}, 113},
	{{7, 60, 96, 0, 0, 38, 57, 204, 19, 236, 251, 89, 192, 196, 78, 130}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 233, 247, 212}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 196, 2, 135, 87, 182}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 102, 102}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 235}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 4, 38}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 107, 33}, 113},
	{{7, 60, 96, 0, 0, 0, 39, 101, 245, 197, 239, 202, 169, 54, 44, 51}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 175, 136, 88, 85, 38, 105, 1, 128}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 229, 150, 143, 88, 34}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 200, 17, 43, 202, 62, 112}, 113},
	{{7, 60, 96, 0, 0, 140, 90, 222, 0, 136, 88, 246, 112, 31, 14, 143}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 58}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 252, 75, 121, 175, 222, 11, 124, 227}, 113},
	{{7, 60, 96, 0, 0, 107, 182, 136, 211, 217, 6, 26, 85, 215, 241, 238}, 113},
	{{7, 60, 96, 122, 127, 25, 5, 131, 135, 115, 8, 88, 170, 49, 34, 192}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 98, 196, 4, 88, 236, 16, 221, 18}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 141, 247, 88}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{7, 60, 96, 0, 0, 0, 225, 110, 50, 95, 31, 160, 219, 25, 44, 144}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 204, 10, 19, 194, 142, 151, 178, 235, 69}, 113},
	{{7, 60, 96, 0, 2, 2, 166, 150, 5, 118, 65, 167, 93, 116, 146, 189}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 50, 13, 51}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 190, 252}, 113},
	{{7, 60, 96, 0, 0, 109, 53, 145, 30, 144, 127, 31, 189, 45, 6, 182}, 113},
	{{7, 60, 96, 0, 68, 106, 69, 206, 239, 17, 74, 229, 52, 188, 178, 59}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 173}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 243, 134}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 235, 246}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 240, 10, 62}, 113},
	{{7, 60, 96, 25, 189, 73, 148, 187, 135, 233, 47, 194, 42, 63, 93, 108}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 113},
	{{7, 60, 96, 0, 178, 8, 168, 254, 43, 93, 231, 210, 76, 241, 108, 206}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 104, 230, 209, 38, 86, 180, 114, 52}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 195}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 94, 5, 65, 33, 82, 219}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 73, 138, 48, 232, 211, 199, 78, 50, 69}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 51, 199, 254, 75, 248, 218, 64}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 45, 15, 185, 135, 199}, 113},
	{{7, 60, 96, 0, 0, 0, 35, 146, 189, 138, 69, 198, 242, 112, 32, 71}, 113},
	{{7, 60, 96, 0, 0, 6, 193, 135, 80, 232, 224, 6, 89, 71, 238, 22}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 195, 147, 80, 53, 220, 15, 150, 182}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 134, 32, 181, 236, 224, 30, 113}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 88, 45}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 1}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 17, 240, 187, 210, 149, 4, 11}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 218}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 232, 49, 213, 44, 240}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 205, 161, 205}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 252, 222, 3, 78, 2}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 14, 52, 37, 2, 231}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 68, 125, 247, 0, 79, 248}, 113},
	{{7, 60, 96, 0, 0, 0, 243, 81, 81, 139, 238, 56, 62, 5, 0, 48}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 28, 32, 107, 53, 52, 217}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 214, 253, 6, 214, 106, 167, 213, 15, 146}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 4, 151, 103, 247, 198, 169, 103}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 132, 194, 196, 127, 88}, 113},
	{{7, 60, 96, 0, 0, 221, 120, 106, 217, 221, 152, 11, 147, 10, 244, 109}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 214, 238, 203, 44, 9, 59, 103, 147, 229}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 198, 53, 41, 188, 246}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 159, 6}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 16, 180, 181, 99, 248, 21, 183, 20, 0}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 7, 234, 96, 251, 47, 154, 58}, 113},
	{{7, 60, 96, 228, 87, 70, 62, 111, 39, 125, 213, 207, 90, 162, 45, 176}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 116, 20, 214, 159, 106, 163, 101}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 4, 116, 11}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 75, 0, 8, 155, 111, 53, 61, 242}, 113},
	{{7, 60, 96, 0, 207, 180, 230, 62, 154, 5, 156, 99, 65, 27, 100, 145}, 113},
	{{7, 60, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 169}, 113},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 25, 197}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 25, 93}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 116, 117, 114, 139, 44, 231}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 204, 24, 64, 58, 53, 209, 175}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 101, 25, 159, 124, 111, 112, 118}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 185, 119, 19, 59, 159, 104}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 242, 146, 54, 202, 241, 21, 47, 151}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 206, 179, 10}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 111, 211, 116, 114, 155, 97}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 73, 55, 89, 76, 192, 150, 41}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 18, 91, 120}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 73, 144, 248, 134, 10, 201}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 30, 34, 24}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 218, 107, 98, 250, 160}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 203, 6, 133, 108, 182, 137, 234, 35}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 175, 74, 86}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 215}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 219, 248}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 107, 4}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 174, 95, 255, 144, 167, 73, 94}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 245, 146, 19, 37, 24, 86}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 58, 211, 51, 249}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 159, 77, 113, 20}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 174, 158}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 139, 182, 143, 215}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 71, 192, 133}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 26, 130, 186, 86, 237, 55, 153, 143}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 19, 243, 224, 225, 51}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 129, 52}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 232, 104}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 89, 217, 121, 37, 33, 96, 178, 66}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 248, 103, 194, 189, 72, 212, 140, 202}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 70, 41, 250, 153, 215, 75, 114, 103}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 100, 179, 154, 134}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 160, 110}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 71}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 90, 100, 192}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 100, 223, 39}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 180}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 210, 121, 134, 50, 118, 8}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 245, 69, 18, 200, 145}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 28, 250, 252, 120, 192, 215}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 242, 61, 186, 43, 131, 117, 153}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 3, 233, 53, 191}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 63, 65, 127, 218, 114, 183, 47, 144}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 65}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 102, 46, 57}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 122, 134, 39}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 25, 172, 184, 91}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 64, 127, 231, 207, 152}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 252, 3, 248, 163, 170, 84, 2}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 155, 170, 31, 44, 246, 177}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 193, 201, 92, 254, 91, 94, 179, 212}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 192, 189, 235, 68, 197, 105}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 39}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 181}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 62, 101, 10}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 145}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 253, 61, 12, 135, 188, 126, 58, 147}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 189, 238, 63, 75, 91, 76}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 23, 165, 135, 209, 27, 47, 145, 122}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 37, 108, 158, 189}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 251, 112, 240, 24}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 245, 126, 90, 32, 137, 108, 246}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 171, 128, 249, 158, 67}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 113, 212, 250, 35, 82, 110, 247, 108}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 88, 237, 231}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 183, 36, 40}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 70, 141, 21, 153, 240}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 56, 125}, 162},
	{{167, 122, 205, 185, 21, 199, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 162},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 132}, 225},
	{{21, 78, 0, 210, 215, 27, 160, 64, 126, 246, 189, 149, 102, 88, 74, 61}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 166}, 225},
	{{21, 78, 0, 245, 15, 76, 71, 44, 94, 34, 48, 128, 119, 21, 171, 88}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 172, 22}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 210, 212, 95, 139}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 239, 195, 217}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 92, 80, 44, 105, 66, 173}, 225},
	{{21, 78, 0, 0, 0, 169, 206, 185, 237, 100, 37, 56, 2, 8, 137, 252}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 15, 203, 52, 202}, 225},
	{{21, 78, 0, 0, 0, 0, 126, 232, 187, 13, 34, 219, 163, 104, 13, 97}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 225}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 107, 150, 245}, 225},
	{{21, 78, 0, 0, 180, 9, 127, 222, 46, 77, 69, 212, 164, 7, 126, 17}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 234}, 225},
	{{21, 78, 0, 0, 0, 72, 14, 59, 210, 220, 64, 138, 83, 31, 188, 19}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 125, 149, 75}, 225},
	{{21, 78, 0, 0, 0, 0, 151, 230, 214, 145, 180, 12, 38, 212, 148, 32}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 199, 117, 236}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 211, 251, 110}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 202, 194}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 39}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 209, 238, 80, 218}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 90}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 225},
	{{21, 78, 0, 0, 0, 0, 146, 48, 53, 91, 9, 69, 239, 93, 107, 255}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 228, 51, 225, 208, 155, 28, 88, 139}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 35, 121, 5, 237, 112, 189, 26, 193}, 225},
	{{21, 78, 0, 0, 0, 47, 38, 140, 9, 82, 215, 150, 66, 164, 168, 104}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 248}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 170, 107, 118}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 124, 6, 227, 2, 250, 179, 190, 79, 29}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 100, 180, 13, 177, 24, 214, 181}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 159, 118, 175, 222}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 170, 219}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 75, 173, 116, 134, 104, 105, 7, 244, 251}, 225},
	{{21, 78, 0, 0, 0, 247, 19, 31, 13, 111, 246, 173, 96, 134, 99, 197}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 164, 50, 162, 238, 163, 142}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 223, 128, 131, 1}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 35, 30, 155, 156, 4, 204, 81, 172}, 225},
	{{21, 78, 0, 0, 0, 218, 27, 233, 83, 68, 28, 175, 57, 60, 13, 115}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 188, 166, 5, 236, 2, 123, 50}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 4}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 46, 80, 188, 237, 198, 245, 116, 143}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 225},
	{{21, 78, 0, 0, 0, 104, 45, 2, 214, 66, 71, 115, 155, 64, 32, 2}, 225},
	{{21, 78, 0, 0, 0, 182, 103, 141, 62, 109, 247, 150, 59, 232, 57, 174}, 225},
	{{21, 78, 0, 0, 54, 30, 119, 5, 200, 241, 1, 81, 220, 123, 60, 20}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 200, 152, 149}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 85, 61, 4, 239, 99, 26, 32, 52, 55}, 225},
	{{21, 78, 0, 0, 0, 255, 31, 98, 100, 39, 207, 69, 216, 83, 76, 55}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 171, 44, 92, 245, 12, 213, 71}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 168, 62}, 225},
	{{21, 78, 0, 0, 3, 176, 202, 225, 53, 185, 142, 230, 94, 189, 162, 76}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 128, 103, 9}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 171, 253}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 63}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 132, 58, 241, 30, 114, 53, 122, 7, 255}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{21, 78, 0, 0, 0, 0, 1, 104, 24, 39, 75, 202, 145, 137, 152, 66}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 86, 6}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 255, 151, 140, 151, 53, 172, 1, 59, 230}, 225},
	{{21, 78, 0, 0, 56, 15, 65, 112, 112, 194, 16, 218, 170, 117, 149, 99}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 89, 31}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 230}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 219, 225, 219, 202, 49, 203, 194}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 21, 32, 3, 78, 207, 145, 180, 163, 24}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 20, 128}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 161, 58, 243, 75, 215, 27, 132, 245, 229}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 138, 249, 5, 84, 187, 68, 148, 76}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 127, 251, 40}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 219, 101, 173, 1, 178, 125, 171, 131}, 225},
	{{21, 78, 0, 0, 0, 156, 101, 87, 131, 27, 227, 154, 89, 158, 251, 112}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 59, 31, 94, 226}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 30}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 225},
	{{21, 78, 0, 0, 0, 0, 5, 158, 222, 23, 74, 150, 230, 87, 89, 208}, 225},
	{{21, 78, 0, 0, 0, 98, 89, 140, 121, 171, 114, 91, 134, 13, 67, 183}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 217, 189, 21, 109, 139, 104}, 225},
	{{21, 78, 0, 0, 35, 243, 232, 205, 166, 141, 137, 198, 213, 100, 114, 193}, 225},
	{{21, 78, 0, 0, 0, 0, 142, 236, 39, 159, 157, 233, 121, 110, 66, 223}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 98, 112}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 12, 21, 5, 70, 129, 128, 167, 119, 207}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 14, 134, 140, 15, 8, 253}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 16, 159}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 68, 23, 72, 221, 36, 2, 27, 95}, 225},
	{{21, 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 53}, 225},
	{{21, 78, 0, 110, 12, 172, 13, 160, 208, 168, 44, 80, 111, 153, 10, 168}, 225},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 90, 166, 208, 127}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 228}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 210, 32, 144}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 61}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 220, 215, 129}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 86}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 160}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 202}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 105, 169}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 194, 236}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 242, 12, 96}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 157}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 116, 199}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 109, 64}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 149}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 6, 79, 69, 59}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 118, 205}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 120}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 105, 25}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 10}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 33}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 240, 35}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 224, 153, 105}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 211, 106, 19}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 6, 252, 159, 61}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 45, 231, 77}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 113}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 196}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 200, 191, 235, 142}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 46, 120}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 11, 108, 201}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 161, 18, 126}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 52, 106}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 219}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 121, 187, 38}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 26, 100}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 34, 168, 223}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 254, 168}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 228}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 161, 126, 83}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 44}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 106, 185, 223}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 79, 193}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 238, 227}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 244}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 243, 99, 73}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 170, 163, 15, 30}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 93}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 230}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 65, 214, 90, 70}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 125}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 186, 136, 64, 119}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 135}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 35}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 161, 125, 222, 71}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 76}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 255, 115, 52}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 170, 167, 201}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 14}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 73}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 229, 33, 90}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 17}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 118, 163}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 132, 144}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 176, 7}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 32, 97}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 155}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 104, 112}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 217, 77}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 8, 196}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 121}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 197}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 121}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 166, 166, 235}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 213, 76, 40}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 22, 72, 72}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 0, 0}, 210},
	{{92, 159, 167, 169, 136, 176, 95, 255, 87, 137, 112, 16, 0, 0, 23, 234}, 210},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 233, 51, 61}, 34},
	{{84, 120, 160, 0, 222, 176, 188, 166, 39, 62, 16, 17, 232, 64, 21, 221}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 33, 58, 139}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 83, 100, 167, 200, 245, 120}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 154}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 245, 127, 61, 109, 243, 17, 168}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 146}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 222, 152, 139, 160, 254, 231, 216, 140, 156}, 34},
	{{84, 120, 160, 0, 223, 116, 216, 122, 47, 1, 16, 246, 182, 230, 94, 73}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 143, 83, 154, 90, 136, 127}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 200, 44}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 238, 154, 156, 114, 106, 29}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 33, 145, 209}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 65, 100, 144}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 27}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 163, 84, 67, 57, 211, 186, 160, 127}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 192, 98, 226, 2, 71, 22, 162, 214, 2}, 34},
	{{84, 120, 160, 0, 0, 217, 255, 45, 80, 175, 25, 226, 79, 144, 112, 209}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 199, 26}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 73, 121, 45}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 168, 119, 193, 215, 94, 214, 216}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 21, 28}, 34},
	{{84, 120, 160, 0, 186, 171, 97, 125, 243, 209, 3, 50, 224, 37, 156, 4}, 34},
	{{84, 120, 160, 0, 0, 0, 247, 34, 242, 133, 196, 83, 123, 66, 158, 28}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 4, 157}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 156, 207, 3, 255, 16, 169, 19}, 34},
	{{84, 120, 160, 0, 0, 185, 211, 167, 26, 195, 30, 174, 8, 0, 46, 59}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 74}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 102, 100, 1, 212, 90, 152, 107, 167, 132, 115}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 236, 85, 184, 165, 38, 243}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 158, 142, 174, 54, 14, 200, 142, 171}, 34},
	{{84, 120, 160, 0, 0, 0, 15, 191, 228, 64, 197, 186, 116, 162, 174, 59}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 225, 143, 44}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 204, 90}, 34},
	{{84, 120, 160, 0, 0, 100, 203, 205, 51, 62, 63, 94, 227, 151, 224, 236}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 95, 213, 127, 174, 232, 227, 25, 42}, 34},
	{{84, 120, 160, 0, 0, 0, 197, 91, 114, 21, 184, 240, 22, 82, 154, 120}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 25, 49, 36, 197, 160}, 34},
	{{84, 120, 160, 0, 241, 96, 133, 69, 222, 216, 6, 249, 69, 239, 238, 254}, 34},
	{{84, 120, 160, 0, 0, 0, 98, 247, 159, 148, 16, 92, 164, 215, 186, 150}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 122, 146, 60}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 146}, 34},
	{{84, 120, 160, 0, 0, 99, 213, 59, 217, 75, 239, 23, 167, 186, 109, 147}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 167, 190, 46}, 34},
	{{84, 120, 160, 0, 0, 0, 116, 39, 192, 234, 126, 58, 188, 132, 150, 29}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 161, 123, 56, 241, 72, 53}, 34},
	{{84, 120, 160, 0, 0, 59, 41, 28, 143, 228, 98, 105, 26, 195, 231, 204}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 194, 229, 179}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 34},
	{{84, 120, 160, 0, 0, 0, 174, 129, 83, 107, 202, 65, 235, 83, 177, 210}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 214}, 34},
	{{84, 120, 160, 0, 73, 56, 229, 242, 164, 35, 160, 95, 165, 159, 8, 94}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 225, 125, 227, 165, 111}, 34},
	{{84, 120, 160, 0, 188, 91, 184, 148, 135, 151, 128, 186, 212, 236, 108, 62}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 68, 207, 197}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 236, 211, 207, 220, 179, 232, 195}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 4, 64, 179, 62, 139, 146, 106}, 34},
	{{84, 120, 160, 0, 25, 154, 153, 226, 11, 135, 191, 237, 244, 95, 5, 134}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 106, 172, 123, 25, 28}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 75, 13, 212, 73, 204, 43, 243, 74}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 216, 86, 21, 87, 117, 232, 166, 26, 157}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 99}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 97, 45, 242, 216, 194}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 218, 131, 223}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 94}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 234, 188, 234, 154, 80, 8, 0}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 248, 5, 221, 19, 131, 227, 11, 54, 160}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 67, 199, 66, 53, 149, 23, 46, 253, 92}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 121}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 248, 107, 101, 119, 227}, 34},
	{{84, 120, 160, 0, 247, 91, 33, 153, 153, 103, 182, 60, 74, 71, 253, 85}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 253, 129, 93}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 174, 253, 49, 190, 78, 230, 129, 159, 46}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{84, 120, 160, 121, 71, 42, 200, 20, 206, 51, 242, 165, 100, 246, 83, 83}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 182, 115, 85, 200, 124, 30, 0}, 34},
	{{84, 120, 160, 0, 188, 60, 118, 190, 198, 31, 3, 97, 206, 2, 161, 47}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 204, 86}, 34},
	{{84, 120, 160, 0, 0, 0, 249, 131, 199, 133, 44, 69, 242, 14, 4, 207}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 194, 22, 243}, 34},
	{{84, 120, 160, 0, 0, 0, 0, 0, 0, 0, 159, 224, 1, 180, 74, 187}, 34},
	{{126, 5, 126, 176, 0, 0, 0, 142, 165, 218, 100, 57, 83, 124, 84, 102}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 130, 212}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 110, 35, 62, 210, 98, 245, 216}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 253, 86, 104, 117, 49, 118, 126, 32, 53}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 249, 25, 69, 145, 151, 234, 116, 5}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 12, 185, 108, 239, 122, 147, 234, 85, 172}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 167, 111, 77, 81, 204}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 163, 253, 239, 251, 34}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 34, 172, 199, 242, 245, 99, 69, 190, 177}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 66, 10}, 224},
	{{126, 5, 126, 176, 0, 225, 79, 100, 175, 249, 100, 225, 173, 119, 172, 149}, 224},
	{{126, 5, 126, 176, 103, 214, 77, 186, 242, 65, 169, 100, 180, 18, 245, 7}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 179, 210, 4, 156}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 124, 229, 84, 25, 37, 44, 167, 53}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 157, 141, 68, 148, 225, 64, 143}, 224},
	{{126, 5, 126, 176, 0, 0, 127, 255, 21, 149, 61, 134, 215, 214, 233, 102}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 156}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 169, 234, 154, 117, 177}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 71, 55, 60, 52, 205, 132, 102, 111}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 202, 86, 98, 52, 143, 237}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 105, 229}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 244, 223}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 190, 126}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 233, 91, 51, 137}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 133, 31, 2, 16}, 224},
	{{126, 5, 126, 176, 0, 138, 157, 160, 123, 223, 72, 58, 115, 62, 216, 227}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 131, 93, 147, 203, 188, 171, 72, 243, 86}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 92, 142, 44, 128, 45, 119, 222}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 80, 4, 72, 19}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 100, 182, 127, 105}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 226, 201, 61, 195, 15, 234, 126}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 218, 145, 61, 41, 145}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 137, 27, 17, 99, 143, 81}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 184, 180, 244, 20}, 224},
	{{126, 5, 126, 176, 0, 221, 66, 184, 66, 211, 135, 16, 90, 94, 20, 116}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 168}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 36, 183, 206, 197, 214, 88}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 102, 97, 223, 157, 157}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180}, 224},
	{{126, 5, 126, 176, 0, 0, 142, 239, 237, 183, 203, 139, 87, 203, 71, 189}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 197, 232}, 224},
	{{126, 5, 126, 176, 0, 0, 94, 64, 156, 6, 117, 201, 224, 146, 165, 147}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 36, 205, 194, 71, 71, 169, 60}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 209, 201}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 88, 141, 1, 29}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 215, 165, 243, 1, 200, 146, 132}, 224},
	{{126, 5, 126, 176, 0, 0, 242, 230, 252, 105, 119, 136, 139, 136, 74, 206}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 224},
	{{126, 5, 126, 176, 0, 231, 14, 54, 39, 177, 30, 17, 226, 29, 79, 243}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 172, 103, 112, 177}, 224},
	{{126, 5, 126, 176, 0, 0, 113, 122, 180, 104, 87, 156, 174, 56, 37, 95}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 23, 233, 210, 142, 188}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 210, 137, 193, 182, 189}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 195}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 58, 117, 195, 132}, 224},
	{{126, 5, 126, 176, 0, 0, 186, 167, 86, 191, 112, 92, 231, 123, 107, 243}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 3}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 245, 46, 10, 254, 143}, 224},
	{{126, 5, 126, 176, 1, 1, 89, 73, 245, 75, 147, 205, 166, 229, 74, 48}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 88, 9, 225, 176, 105, 199, 80, 190, 64}, 224},
	{{126, 5, 126, 176, 0, 0, 29, 128, 178, 196, 122, 242, 18, 66, 26, 21}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 107, 175}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148}, 224},
	{{126, 5, 126, 176, 0, 249, 110, 160, 127, 65, 74, 196, 178, 49, 24, 240}, 224},
	{{126, 5, 126, 176, 0, 0, 203, 85, 162, 168, 211, 227, 107, 225, 202, 128}, 224},
	{{126, 5, 126, 176, 0, 0, 249, 21, 18, 88, 21, 102, 145, 219, 32, 197}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 240, 242, 125, 165}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 236, 191}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 221, 8, 242, 236, 18, 39, 128, 170}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 58}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 45, 60, 132, 66, 171, 104, 116, 133}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 103, 159, 8, 171, 71}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 70, 201, 212, 191, 200, 236, 109}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 192, 226, 24, 225, 122, 111}, 224},
	{{126, 5, 126, 176, 0, 151, 245, 171, 17, 75, 136, 111, 187, 211, 170, 28}, 224},
	{{126, 5, 126, 176, 0, 0, 64, 34, 8, 111, 28, 201, 29, 147, 185, 131}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 213, 2, 140, 40, 129, 162}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 50, 89, 188, 181, 148, 126, 227, 81}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 230, 90, 46, 17, 101, 166, 62, 104, 151}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 31}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 167, 140}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 97, 152, 216, 43, 38, 227, 84}, 224},
	{{126, 5, 126, 176, 0, 0, 92, 103, 54, 12, 241, 104, 217, 46, 120, 179}, 224},
	{{126, 5, 126, 176, 0, 198, 16, 61, 115, 41, 48, 53, 241, 60, 201, 193}, 224},
	{{126, 5, 126, 176, 0, 0, 0, 0, 0, 212, 166, 138, 237, 54, 163, 155}, 224},
	{{126, 5, 126, 176, 0, 0, 252, 109, 89, 136, 218, 34, 142, 187, 236, 12}, 224},
	{{126, 5, 126, 176, 0, 201, 51, 204, 152, 42, 17, 193, 20, 157, 161, 108}, 224},
	{{4, 58, 0, 0, 0, 0, 0, 99, 146, 249, 94, 217, 146, 74, 127, 222}, 143},
	{{4, 58, 0, 68, 95, 63, 240, 164, 207, 138, 183, 172, 236, 229, 250, 9}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 61, 215, 106, 137, 201, 27, 11}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 247, 118, 198, 189, 21, 89, 200, 209}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 101, 189, 220, 149, 227, 90}, 143},
	{{4, 58, 0, 0, 0, 124, 102, 222, 37, 44, 63, 239, 75, 244, 74, 119}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 47}, 143},
	{{4, 58, 0, 0, 47, 99, 169, 245, 253, 208, 223, 171, 147, 94, 150, 234}, 143},
	{{4, 58, 0, 0, 0, 34, 43, 227, 170, 6, 206, 227, 46, 155, 96, 67}, 143},
	{{4, 58, 0, 224, 97, 23, 234, 52, 98, 6, 27, 181, 67, 96, 138, 228}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 158, 245, 166}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 41, 254, 168}, 143},
	{{4, 58, 0, 0, 0, 0, 30, 34, 176, 28, 195, 9, 247, 215, 252, 170}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 119, 19, 52}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 100, 204}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 153, 172, 156, 45, 199, 86}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 247, 142, 192, 131, 137, 69, 205, 249}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 127, 54, 161, 169, 223, 46, 191, 166}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 211, 8, 112, 190, 91, 15, 29, 90, 32}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 137, 83, 149, 152, 243, 247}, 143},
	{{4, 58, 0, 0, 0, 0, 230, 123, 183, 177, 139, 195, 203, 163, 201, 76}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 189, 203, 209, 202, 91, 244, 102, 169}, 143},
	{{4, 58, 0, 166, 119, 59, 141, 157, 86, 133, 254, 201, 2, 144, 179, 243}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 78, 247, 90}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{4, 58, 0, 0, 0, 0, 118, 203, 108, 217, 98, 186, 11, 147, 6, 100}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 104, 115}, 143},
	{{4, 58, 0, 0, 149, 119, 21, 135, 141, 221, 69, 104, 108, 131, 220, 103}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 235, 103, 103}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 255, 143, 59, 195, 8, 184, 67}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 234, 219, 50, 138, 97, 220, 206, 187, 24}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 222, 211, 222, 217, 251, 66, 47, 239, 128}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 118, 40, 189, 4, 45, 176}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 146, 133, 44, 103, 109, 213, 153, 68, 80}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 241, 186, 118, 82}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 25, 144, 87, 139}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 242, 85, 177, 227, 148, 242, 135, 197}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 184, 172, 164, 226, 199, 237}, 143},
	{{4, 58, 0, 0, 0, 59, 57, 116, 11, 188, 89, 95, 126, 209, 47, 44}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 73, 236, 44, 124}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 208, 68, 43, 37, 72, 209, 82, 164}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 205, 83, 223, 23, 127, 61, 45}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 133, 198, 140, 121, 15, 80, 47}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 189, 183, 114, 253}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 17, 23}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 181, 50, 232, 236, 82, 218, 216, 160}, 143},
	{{4, 58, 0, 0, 211, 48, 182, 132, 121, 232, 125, 211, 201, 116, 46, 149}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 166}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 88, 146, 37, 28}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 226, 229, 40, 150}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{4, 58, 0, 0, 0, 0, 156, 254, 25, 64, 148, 134, 172, 179, 243, 212}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 179, 55, 206, 154, 8, 38, 132, 50}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 9, 225}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 165, 86}, 143},
	{{4, 58, 0, 0, 0, 198, 31, 24, 123, 97, 232, 179, 83, 126, 32, 187}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 171, 171, 147, 72, 59, 67, 46, 82}, 143},
	{{4, 58, 0, 0, 10, 52, 50, 224, 162, 57, 17, 233, 156, 211, 227, 156}, 143},
	{{4, 58, 0, 0, 49, 104, 207, 255, 251, 23, 60, 235, 167, 207, 121, 142}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 160, 94}, 143},
	{{4, 58, 0, 0, 239, 242, 45, 174, 41, 178, 62, 172, 189, 67, 67, 239}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 96, 17, 120, 131, 165, 123}, 143},
	{{4, 58, 0, 0, 0, 99, 38, 9, 160, 144, 129, 161, 5, 241, 126, 196}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 25, 147, 205, 96, 163, 138, 233, 43, 130}, 143},
	{{4, 58, 0, 169, 231, 62, 114, 198, 111, 228, 74, 106, 23, 239, 128, 169}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 82, 11}, 143},
	{{4, 58, 0, 0, 0, 0, 120, 74, 162, 25, 211, 80, 175, 129, 52, 83}, 143},
	{{4, 58, 0, 227, 215, 179, 209, 11, 217, 141, 171, 207, 82, 67, 221, 98}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 46, 241, 46, 149}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 33, 236, 180}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 22, 15, 77, 69, 238, 0, 90, 126}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 186, 82, 23}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 6, 66, 32, 39, 66, 156, 51, 113}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 143},
	{{4, 58, 0, 0, 8, 116, 197, 251, 151, 240, 75, 246, 0, 187, 92, 242}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 71, 203}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 12, 31, 228, 116, 90, 225}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 205}, 143},
	{{4, 58, 0, 23, 212, 142, 82, 235, 165, 209, 143, 168, 4, 48, 45, 46}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 76, 253, 203, 236, 32, 209}, 143},
	{{4, 58, 0, 0, 0, 0, 55, 222, 16, 66, 5, 7, 74, 250, 129, 245}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 143},
	{{4, 58, 0, 0, 0, 0, 93, 149, 30, 119, 187, 222, 42, 165, 146, 94}, 143},
	{{4, 58, 0, 0, 0, 191, 59, 88, 243, 161, 135, 146, 84, 198, 37, 154}, 143},
	{{4, 58, 0, 0, 8, 241, 233, 178, 226, 158, 248, 54, 61, 43, 157, 153}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 26, 15, 66, 93, 253, 243}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 29}, 143},
	{{4, 58, 0, 96, 41, 129, 99, 252, 210, 22, 167, 110, 130, 144, 113, 229}, 143},
	{{4, 58, 0, 248, 204, 103, 111, 142, 32, 190, 243, 231, 123, 30, 151, 46}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 0, 0, 0, 184, 88, 50, 22, 216, 187}, 143},
	{{4, 58, 0, 0, 0, 0, 0, 55, 227, 229, 165, 32, 170, 187, 122, 177}, 143},
	{{4, 58, 0, 0, 0, 0, 143, 160, 182, 115, 43, 85, 128, 169, 253, 239}, 143},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 176, 129, 10, 64}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 18, 182, 3}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 99, 202, 246, 145}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 91, 92, 205, 6, 21, 173}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 115, 177, 47, 250}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 65, 179, 234, 19, 127, 215}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 250, 221}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 180, 171, 40, 4}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 145, 197}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 79, 81, 64}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 8, 129, 152}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 198, 120, 171, 234, 32}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 96, 208, 86, 250, 64, 15, 188}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 92, 88, 145}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 235, 146, 45, 211}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 110, 146, 136, 153, 222, 185}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 55, 241, 217}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 170, 224}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 57, 118, 155, 25, 156, 250}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 114, 156, 39}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 244, 105}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 101, 0, 254}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 157}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 108, 208, 202}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 11, 246, 29, 242}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 224, 97, 39}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 153, 205, 101, 213, 177, 229}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 175, 18, 215}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 60, 180, 117, 191, 240}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 124, 13, 134}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 153, 156, 173, 234}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 25, 32, 111, 99, 30, 246}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 151, 234, 3, 42, 33, 173, 76}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 6}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 174, 121, 161, 100}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 178}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 16, 143}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 52, 25, 198, 1, 201}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 238}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 220, 52, 147, 79, 62, 116, 42}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 244, 11, 176, 47}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 40, 222, 106, 32, 99}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 37, 209, 181}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 190, 16, 86, 104}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 145, 9, 125}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 164, 69, 154, 229}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 74, 220, 230, 242, 77}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 109, 17}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 76, 241, 159, 230, 10}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 79, 69, 4, 109, 206, 9}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 195, 202, 47, 20}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 113}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 176, 77, 203, 210, 146}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 93, 71, 200, 209}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 116, 106, 23, 192, 91}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 1, 5, 177, 205, 29}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 22, 45, 15}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 212, 185, 63, 19}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 89, 208, 10, 159}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 49}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 71, 173, 12, 32, 123, 74}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 255, 60, 214, 32, 174, 49, 82}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 214, 55, 209}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 209, 173}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 25, 161, 227, 193, 166}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 157, 93, 211}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 81, 106, 62, 50, 245, 225}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 242, 208, 68, 181, 191, 247, 223}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 103, 78, 198}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 35}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 29, 180, 9, 152, 241, 120}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 207, 116, 217, 126}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 179}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 129}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 243, 76, 181, 168, 59, 4}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 30, 130, 128, 75, 246, 149}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 160, 194, 152, 12, 17, 24}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 7, 12}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 186, 205, 11}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 163, 152, 133, 219}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 215, 30}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 130}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 139}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 55, 100, 127, 116}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 0, 0, 0, 196}, 216},
	{{239, 154, 181, 182, 189, 211, 244, 53, 144, 0, 0, 0, 156, 79, 54, 53}, 216},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{254, 188, 139, 167, 135, 47, 147, 239, 187, 106, 228, 156, 234, 234, 102, 0}, 239},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 251}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 147}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 219}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 90}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 112}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 11}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 71}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 214}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 145}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 97}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 194, 116}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 162}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 28, 178}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 114}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 80}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 149}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 210}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 93}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 93}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 244}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 169}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 70}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 41}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 49}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 217}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 90}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 254}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 155}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 33}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 251, 135}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 84}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 103}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 7}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 35, 90}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 102, 79}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 58}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 116}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 178}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 119}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 165}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 112}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 86}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 206}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 51}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 220}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 0}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 126}, 54},
	{{225, 168, 138, 92, 193, 255, 47, 233, 11, 154, 205, 86, 209, 88, 0, 157}, 54},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 89, 153, 230}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 23, 170}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 223, 187, 10}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 177, 154, 135, 238, 109, 241, 88}, 35},
	{{223, 0, 0, 0, 0, 139, 207, 127, 12, 230, 155, 192, 108, 77, 232, 74}, 35},
	{{223, 0, 0, 0, 0, 0, 173, 206, 148, 12, 127, 244, 14, 198, 64, 188}, 35},
	{{223, 0, 0, 0, 0, 32, 145, 60, 230, 177, 191, 249, 42, 147, 207, 149}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 106, 132}, 35},
	{{223, 0, 0, 0, 136, 243, 66, 252, 36, 29, 85, 154, 164, 136, 249, 41}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 144}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 182}, 35},
	{{223, 0, 151, 27, 224, 23, 197, 224, 97, 7, 185, 82, 159, 204, 80, 7}, 35},
	{{223, 0, 148, 57, 106, 254, 53, 149, 40, 230, 28, 194, 219, 4, 99, 111}, 35},
	{{223, 0, 0, 0, 0, 0, 61, 126, 130, 230, 179, 155, 173, 171, 158, 83}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 34, 231, 36, 92, 111, 116, 46}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 181, 178, 6, 195, 244, 95, 22, 74}, 35},
	{{223, 0, 0, 0, 0, 0, 165, 216, 165, 207, 108, 4, 11, 237, 97, 7}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 44, 168, 218, 114, 115, 167, 69, 184, 25}, 35},
	{{223, 0, 0, 0, 0, 0, 228, 196, 150, 16, 96, 55, 116, 127, 174, 103}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 162, 219, 80}, 35},
	{{223, 0, 67, 21, 181, 147, 133, 46, 171, 23, 87, 140, 174, 89, 162, 77}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 248, 95, 208, 137}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 207, 200, 58, 154, 212, 207, 59, 69}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 212, 89, 125, 47, 111, 21, 89, 135}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 47, 179, 175}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 19, 158, 97, 152}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 41, 99, 15, 238, 93, 66, 41, 75}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 92, 44, 27, 95}, 35},
	{{223, 0, 0, 64, 171, 114, 13, 101, 178, 187, 76, 25, 81, 219, 36, 49}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 82, 212, 207, 255}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 80, 60}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 226, 219, 148, 82, 125, 220, 16, 223}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 66}, 35},
	{{223, 0, 92, 175, 102, 196, 241, 12, 103, 88, 179, 138, 84, 128, 22, 198}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 230, 219, 139}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 244, 58, 212, 239, 130, 17, 245, 175}, 35},
	{{223, 0, 0, 177, 175, 104, 69, 39, 155, 235, 2, 73, 168, 221, 213, 4}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 203, 58, 46, 198, 153, 255, 183, 93}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 10, 163, 24, 69, 99}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 142, 140, 129, 234, 70, 36, 128, 135}, 35},
	{{223, 0, 0, 0, 0, 0, 120, 106, 137, 119, 161, 82, 113, 180, 79, 55}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 135, 249, 88, 48, 26, 139, 45, 166, 174}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 16, 245, 195}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 177, 193, 222}, 35},
	{{223, 0, 0, 28, 238, 81, 118, 69, 119, 73, 219, 1, 118, 209, 223, 238}, 35},
	{{223, 0, 0, 0, 0, 88, 124, 187, 118, 99, 110, 65, 85, 201, 89, 129}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 157, 180, 6, 134}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 24, 8}, 35},
	{{223, 0, 0, 0, 224, 109, 137, 82, 162, 94, 114, 108, 242, 201, 104, 6}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 1, 6, 179, 225, 110}, 35},
	{{223, 0, 0, 0, 25, 98, 123, 34, 208, 103, 23, 5, 58, 74, 61, 191}, 35},
	{{223, 0, 0, 0, 236, 157, 134, 202, 119, 115, 215, 23, 146, 14, 85, 240}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 97, 83, 49, 124, 80, 222, 137, 65, 89}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 252, 21, 85, 158, 117, 30, 127, 36, 172}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 124, 50, 120, 95, 94}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 35},
	{{223, 0, 0, 49, 48, 140, 131, 9, 34, 200, 60, 212, 0, 67, 185, 92}, 35},
	{{223, 0, 0, 0, 93, 189, 128, 20, 53, 163, 149, 6, 131, 49, 0, 51}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 204, 11, 139, 14, 108, 90, 160}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 228, 40, 175}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 248, 49, 221, 236, 79}, 35},
	{{223, 0, 239, 255, 187, 241, 27, 155, 14, 222, 229, 63, 114, 6, 127, 6}, 35},
	{{223, 0, 0, 0, 0, 0, 165, 81, 48, 112, 116, 124, 91, 252, 250, 133}, 35},
	{{223, 0, 0, 115, 129, 183, 221, 219, 216, 145, 237, 77, 94, 94, 195, 17}, 35},
	{{223, 0, 0, 0, 105, 218, 82, 154, 60, 85, 1, 144, 253, 19, 174, 86}, 35},
	{{223, 0, 0, 0, 0, 0, 100, 220, 244, 111, 142, 196, 13, 157, 120, 227}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 34, 1, 221, 73, 47, 228, 5, 177}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 252, 229, 252}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 224, 223, 77, 217}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 205, 178}, 35},
	{{223, 0, 0, 144, 64, 234, 219, 141, 216, 4, 228, 147, 168, 235, 30, 187}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 63, 178, 46}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 73, 174, 133, 162, 47, 78, 134, 172, 160}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 20, 95, 60, 7}, 35},
	{{223, 0, 201, 70, 157, 38, 48, 100, 176, 124, 105, 97, 52, 125, 18, 91}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 131, 247, 174, 110, 97, 182, 188, 28}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 64, 153}, 35},
	{{223, 0, 0, 229, 231, 97, 222, 44, 60, 38, 4, 21, 199, 48, 34, 120}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 213}, 35},
	{{223, 0, 0, 101, 35, 182, 62, 68, 93, 244, 203, 211, 47, 167, 34, 95}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 38, 22, 172, 58, 246, 77, 227}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 102, 123, 105, 170, 208, 97, 218, 208, 133}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 174, 200}, 35},
	{{223, 0, 138, 13, 166, 190, 160, 83, 217, 90, 197, 196, 154, 1, 110, 12}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 7}, 35},
	{{223, 0, 241, 108, 116, 250, 112, 19, 145, 252, 250, 144, 192, 91, 168, 32}, 35},
	{{223, 0, 0, 0, 179, 136, 223, 119, 215, 199, 76, 21, 177, 11, 254, 81}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 242, 219, 96, 225, 224}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 126}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 177}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 90, 222, 176, 201, 6}, 35},
	{{223, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 151}, 35},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 211}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 83}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 194}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 199}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 144}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 138}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 79}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 79}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 54}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{235, 252, 115, 10, 151, 104, 193, 207, 38, 228, 229, 245, 42, 13, 108, 0}, 230},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 70, 100, 146, 61, 146, 46}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 212, 169}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 47, 213, 1}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 255, 121, 241, 116, 74, 38, 104, 138}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 178, 206, 135, 177, 100, 236, 60, 90, 171}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 13, 170, 43, 27, 13, 202}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 13, 43, 169, 109, 95, 217, 219, 149, 33}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 252, 39}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 144, 255}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 130, 163, 146, 223}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 148, 161, 0, 184, 120, 212, 226, 248}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 99, 252, 250, 134, 2, 181, 153}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 51, 91, 38, 79}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 219, 151, 157}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 66, 21, 69}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 196, 230, 79, 17}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 27, 77, 61, 230}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 82, 78, 69, 239, 54, 234, 179}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 57, 112, 251, 29, 247, 36, 38, 108, 8}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 255, 33, 33, 64, 255}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 158, 130, 193, 231, 18, 177}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 35, 228, 115, 118, 200, 144, 74, 22}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 82, 187, 55, 249, 154, 192, 118, 54, 172}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 234},
	{{1, 137, 53, 36, 210, 184, 22, 196, 109, 59, 71, 164, 100, 43, 126, 228}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 161, 154}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 236, 147, 128, 188, 206, 58, 231, 247, 22}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 119, 165, 180, 53, 57, 236}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 23, 11, 162, 112, 120, 58}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 45, 66, 50, 42, 203, 96, 203, 208, 78}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 95, 150, 50, 83, 89, 99, 198, 75, 61}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 170, 25, 149, 180, 62, 247, 158, 54, 90}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 210, 150, 44, 81, 38, 102, 61}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 209, 205, 215}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 200, 17, 131, 99}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 193, 201, 24, 94, 0}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 162, 150, 249, 8}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 97, 41, 67, 76, 145, 201, 144, 55}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 201, 7, 33, 199, 199, 110}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 192, 120, 190, 45, 143, 90, 229, 31}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 88, 20, 142, 247, 132}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 5, 40}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 10, 46, 118, 221, 217, 215}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 201, 124, 187, 23}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 148, 173}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 6, 18, 58, 243, 166}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 71, 238, 99, 241}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 101, 98, 70, 89, 48}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 80, 163, 24, 70, 166}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 69, 147, 34, 91, 217, 237, 104, 196}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 92, 81, 28, 140, 118, 124, 97, 55, 36}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 95, 186, 24}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 12, 172, 178, 129, 234, 50, 123, 216, 236}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 164, 248, 224, 210, 233, 248, 175, 39, 95}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 28, 237}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 20, 82, 157, 190, 113, 237}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 190, 223, 72, 0, 50, 65}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 125, 157, 51, 240}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 10, 140, 230, 240, 237}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 35, 34, 201, 154, 66, 249, 242}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 120, 127, 70, 116, 71, 46, 110}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 234},
	{{1, 137, 53, 36, 210, 184, 167, 89, 250, 109, 198, 227, 193, 77, 250, 202}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 82, 251, 132, 187, 20}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 225, 34, 131, 134}, 234},
	{{1, 137, 53, 36, 210, 184, 219, 217, 108, 133, 227, 32, 40, 192, 173, 252}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 24, 114, 134, 116, 16}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 135, 226, 93, 115, 244, 15, 130, 11}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 241, 178, 176, 144, 78}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 179, 97}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 255, 16, 89, 87, 100, 64, 151, 178}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 176, 250, 69, 107, 59}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 255, 23}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 79, 39, 175, 196, 238, 67, 30, 95}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 143, 244, 8, 144, 157, 0, 191, 247}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 117, 243, 3, 166, 74, 220, 63, 83}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 216, 28, 159, 48, 208, 121}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 195, 99, 253, 175, 63, 132, 109, 164, 7}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 1, 42, 35, 54, 212}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 187, 211, 188, 59, 144, 156}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 0, 51, 0, 102}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 0, 0, 0, 0, 203, 66, 162, 0}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 0, 196, 216, 136, 141, 33, 130, 230, 184}, 234},
	{{1, 137, 53, 36, 210, 184, 0, 153, 94, 70, 149, 97, 179, 240, 107, 252}, 234},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 160}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 22}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 168}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 152}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 204}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 70}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 71}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 32}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 154}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 62}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 124}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 153}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 184}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 143}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 199}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 163}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 47}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 232}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 160}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 89}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 4}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 144}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 238}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 110}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 19}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 243}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 237}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 225}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 144}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 198}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 30}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 223}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 27}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 5}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 165}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 33}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 212}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 180}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 197}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{149, 182, 72, 197, 92, 229, 9, 10, 220, 128, 72, 19, 4, 58, 192, 0}, 70},
	{{105, 73, 57, 108, 0, 86, 189, 37, 59, 121, 81, 225, 119, 248, 197, 15}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 243, 117, 191, 113, 159, 108}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 106}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 160, 122, 163, 38, 58, 69, 188, 198}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 36, 207, 231, 151, 171, 87, 227, 165, 41}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 140, 151, 244, 67}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 228}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 26, 240, 37, 3, 253, 228}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 144, 46, 10, 248, 71, 237, 122}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 33}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 97, 138, 199, 153, 172, 4, 218}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 81, 90, 223, 251}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 128, 1, 9, 121, 150}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 189, 120, 244, 36, 189, 218, 63, 122}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 222, 199, 205, 246, 10}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 108, 92, 159, 4, 230, 76}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 190, 178, 77, 191, 67, 36, 128}, 246},
	{{105, 73, 57, 108, 0, 0, 164, 172, 159, 232, 188, 238, 236, 135, 253, 124}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 232, 247, 37, 156, 201, 85}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{105, 73, 57, 108, 0, 230, 170, 125, 179, 32, 140, 107, 106, 148, 24, 103}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 212, 122, 222, 20, 31, 216, 156, 0, 89}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 94, 19, 73, 193, 153}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 64, 185, 62, 23, 110, 36, 217, 141}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 104, 126, 179, 142, 248, 35}, 246},
	{{105, 73, 57, 108, 0, 0, 238, 248, 62, 156, 198, 193, 199, 84, 246, 12}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 191, 35, 67, 199, 196, 95, 151, 146}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 147, 220, 236, 163, 207}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 248, 247}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 232, 161}, 246},
	{{105, 73, 57, 108, 0, 104, 84, 65, 190, 62, 137, 161, 213, 171, 173, 233}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 108, 74, 31, 40, 52}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 127}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 248, 170, 68, 218, 128}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 213, 107, 212, 24, 46}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 95, 106, 196, 76, 175}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 6, 197, 84, 22}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 59, 9}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 113, 184, 199, 54, 234, 89, 253, 167, 166}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 58, 1, 149, 125, 94, 92, 38, 94}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 17, 162, 95, 194, 38, 161, 43, 143, 3}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 165, 119, 67, 50, 218, 160, 170}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 157, 33}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 211, 33, 237, 220, 30, 242, 199}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 248, 215, 148, 110}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 193, 66, 237, 251, 151, 131, 125, 204, 164}, 246},
	{{105, 73, 57, 108, 0, 0, 75, 83, 51, 136, 248, 46, 67, 201, 166, 153}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 38, 222, 213, 30}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 44, 28}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 137}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 63, 161, 213, 72, 100, 68, 50, 188, 100}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 125, 144, 195, 25, 134, 16, 116, 21}, 246},
	{{105, 73, 57, 108, 0, 0, 235, 167, 70, 222, 71, 187, 241, 126, 66, 24}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 181, 2, 112, 54, 94, 130, 151}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 171, 26, 192, 88}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 218, 82, 202, 13, 5}, 246},
	{{105, 73, 57, 108, 0, 0, 114, 180, 67, 105, 25, 209, 149, 159, 89, 139}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 83, 31, 9, 197, 39, 141, 250}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 11, 100}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 200, 33, 18, 169, 85, 96}, 246},
	{{105, 73, 57, 108, 0, 0, 192, 189, 210, 223, 183, 177, 191, 58, 84, 64}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 232, 186, 103, 103, 221, 153, 157, 147}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 164, 82, 248, 56, 217}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 104, 173, 229, 59, 234, 117, 121}, 246},
	{{105, 73, 57, 108, 0, 0, 76, 214, 103, 138, 89, 139, 195, 90, 40, 197}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 142, 239, 4, 135, 219, 28, 25, 56, 137}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 70, 128}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 54, 138, 20, 12, 98, 252, 235, 8, 255}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 19, 70, 233, 62, 222, 38, 4, 226}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 254, 146, 92, 57, 235, 21, 90, 86}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 2}, 246},
	{{105, 73, 57, 108, 0, 85, 78, 151, 178, 97, 233, 138, 188, 166, 212, 109}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 202, 63, 114, 162}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 239, 103}, 246},
	{{105, 73, 57, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 246},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{189, 61, 230, 24, 235, 82, 58, 102, 97, 111, 121, 252, 156, 94, 191, 166}, 217},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{193, 108, 231, 86, 140, 14, 192, 4, 135, 80, 129, 166, 158, 61, 230, 20}, 201},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 56, 169, 140, 174, 82, 161, 141, 9, 155}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 250, 184, 160, 179, 5, 223, 231, 185, 241}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 163, 132, 19, 175, 251, 255, 249, 137, 126}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 240, 110}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 229, 185}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 48, 144, 112, 50, 17, 144, 166}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 22, 188, 202, 109, 69, 72, 242, 121, 212}, 49},
	{{110, 77, 0, 0, 0, 159, 45, 40, 37, 242, 122, 125, 162, 229, 207, 152}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 36}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 54, 184, 194, 89, 132, 55}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 137, 79, 194, 145, 36, 202}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 73, 109, 236}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 173, 254, 137, 54, 63, 164, 151, 13}, 49},
	{{110, 77, 0, 0, 5, 114, 131, 136, 33, 110, 111, 54, 35, 81, 230, 52}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 30, 133, 152, 226, 77, 244, 198, 107}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 185, 145, 20}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 53}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 147, 212, 195, 184, 129, 187}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 75, 183, 209, 32, 192, 198, 58}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 229, 191, 83, 176}, 49},
	{{110, 77, 0, 0, 0, 126, 7, 163, 179, 116, 166, 23, 228, 123, 207, 39}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 51, 126, 42, 99, 20, 227, 176, 193}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 206, 222, 10, 166, 177, 129, 161, 215, 93}, 49},
	{{110, 77, 0, 0, 0, 38, 49, 70, 90, 27, 120, 6, 150, 88, 3, 244}, 49},
	{{110, 77, 0, 0, 54, 166, 205, 20, 199, 62, 130, 68, 177, 19, 70, 3}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 57}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 23, 88}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 230, 75}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 253, 1, 82, 1, 179, 159, 49, 113, 169}, 49},
	{{110, 77, 0, 0, 0, 175, 39, 118, 217, 182, 80, 159, 43, 244, 104, 162}, 49},
	{{110, 77, 0, 0, 0, 0, 183, 152, 177, 184, 92, 171, 233, 94, 29, 96}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 185}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 140, 226, 206, 67, 106, 96, 151, 106, 106}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 201, 33, 135, 207, 202, 252, 216, 204, 233}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 48, 50}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 108, 226, 21, 91, 219, 127, 243}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 12}, 49},
	{{110, 77, 0, 160, 200, 101, 175, 139, 19, 68, 174, 125, 33, 220, 130, 89}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 9, 226, 191}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 68, 226}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 93, 250, 95}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 204, 20, 166}, 49},
	{{110, 77, 0, 9, 43, 250, 226, 44, 152, 132, 114, 230, 209, 220, 37, 236}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 217}, 49},
	{{110, 77, 0, 0, 0, 227, 85, 144, 20, 72, 66, 29, 50, 221, 194, 35}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 138, 15, 16, 22, 231, 98, 119, 86, 42}, 49},
	{{110, 77, 0, 0, 0, 13, 189, 11, 135, 238, 45, 225, 128, 15, 137, 164}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 196, 73, 222, 48, 120, 208}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 131, 181, 143, 237, 59, 229, 177, 166, 189}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 246, 128, 155}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 66, 242, 219, 21, 213, 218, 200, 238, 65}, 49},
	{{110, 77, 0, 0, 0, 0, 224, 234, 146, 149, 127, 185, 247, 109, 249, 6}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 178, 253, 19, 77, 243, 136, 139, 213, 212}, 49},
	{{110, 77, 0, 0, 0, 0, 156, 164, 114, 29, 234, 122, 194, 160, 247, 196}, 49},
	{{110, 77, 0, 11, 45, 142, 230, 246, 45, 228, 22, 148, 248, 245, 110, 80}, 49},
	{{110, 77, 0, 9, 227, 36, 239, 64, 155, 202, 2, 194, 10, 91, 155, 150}, 49},
	{{110, 77, 0, 7, 147, 22, 111, 176, 96, 221, 27, 128, 37, 206, 194, 234}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 208, 240, 76, 20, 25, 70, 245, 4, 196}, 49},
	{{110, 77, 0, 0, 0, 0, 34, 216, 84, 131, 243, 6, 143, 44, 23, 213}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 95, 222, 196}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 112}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49},
	{{110, 77, 0, 182, 159, 244, 216, 211, 145, 198, 203, 179, 174, 194, 154, 146}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 51, 207, 121, 47, 250, 200, 17}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 190, 137, 10}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 103, 13, 37, 37, 29, 170, 163}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 94, 118, 114, 169, 70, 143, 34}, 49},
	{{110, 77, 0, 0, 0, 0, 241, 97, 70, 128, 27, 10, 171, 140, 204, 236}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 59, 248}, 49},
	{{110, 77, 0, 0, 122, 123, 27, 225, 90, 189, 230, 246, 154, 158, 224, 178}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 2}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 156, 121, 44, 236, 152, 155, 242, 244, 12}, 49},
	{{110, 77, 0, 0, 0, 70, 89, 191, 69, 116, 225, 168, 220, 204, 70, 194}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 58, 180, 48}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 235, 61, 130, 96, 183, 20, 197, 181, 202}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 136, 189, 223}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 174, 5, 43}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 81}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49},
	{{110, 77, 0, 101, 114, 134, 246, 129, 183, 28, 67, 116, 10, 246, 163, 246}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 127, 238, 133, 98, 111, 71, 51, 183}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 55, 85, 13, 112}, 49},
	{{110, 77, 0, 174, 150, 162, 217, 20, 102, 40, 90, 130, 133, 30, 74, 90}, 49},
	{{110, 77, 0, 0, 0, 0, 40, 177, 27, 194, 57, 192, 24, 163, 106, 120}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 172, 15, 188}, 49},
	{{110, 77, 0, 74, 127, 85, 229, 89, 128, 218, 70, 81, 189, 53, 187, 164}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 93, 57, 159, 241, 239, 232, 79, 163}, 49},
	{{110, 77, 0, 0, 252, 121, 254, 40, 227, 111, 156, 27, 17, 237, 178, 109}, 49},
	{{110, 77, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0, 151, 39, 200, 113}, 49},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 22, 208, 181, 253, 62, 1, 217, 140}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 222, 158}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 83, 70, 245, 135}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 24, 62}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 88, 92, 179}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 76, 106, 217, 206}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 54}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 249, 249, 48, 33, 35, 251}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 205, 130, 89, 40, 89, 188, 75}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 136, 203, 119, 207}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 200, 13, 145, 183, 166, 105}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 186, 251}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 165, 90, 124, 76, 40}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 123, 129, 182, 232, 88}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 217, 209, 224, 57, 238, 72, 90}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 27, 185, 54, 229, 204}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 196, 154, 45, 83}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 129, 220, 206, 113, 117, 143, 101}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 255, 112}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 244, 149, 129, 227}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 143, 209, 8, 87, 161, 226, 229}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 115, 76, 46, 94, 182, 134}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 131, 232, 1, 133, 11, 52, 175, 98}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 164, 148, 12, 118, 155}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 4, 131, 75, 46, 71, 25, 191}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 114, 201, 193, 72, 63, 177, 184, 7}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 38, 180, 67, 49, 208, 188}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 208, 149, 172, 199, 242, 38, 18}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 70, 112}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 218, 142, 180, 144}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 70, 168, 235, 187, 159, 2, 22, 147}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 155, 175}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 215, 74}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 106, 246, 181, 247, 120}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 230, 17, 95, 203, 200, 247, 40}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 198, 160, 94, 154, 128, 222, 251}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 196, 168, 169, 79, 45, 150, 7, 242}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 163, 109, 148}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 234, 254, 41}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 101, 186, 157, 226, 155}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 47, 135, 66, 239, 133, 62}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 160, 129}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 179, 148, 244, 178, 162, 38, 238}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 131, 197, 165, 30, 179, 78}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 126, 44, 78, 229}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 77}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 2, 30, 170, 136}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 188, 57, 37, 186}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 50, 0, 85}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 204, 28, 136, 198}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 40, 127, 228}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 2, 72, 181, 0}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 41, 160, 144, 60, 214}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 99, 43, 209, 163, 237, 232, 68}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 114, 187, 188, 197}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 94, 36, 150}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 61, 86, 215, 109, 71}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 138, 132, 95, 251}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 150, 239, 101, 182}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 192, 9, 45}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 72, 83, 119}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 63, 108, 39, 162, 141, 129, 53, 77}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 79, 25, 159, 248, 121, 28}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 171, 98}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 176, 86, 212, 228, 216, 140, 114, 101}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 185, 241, 52, 175}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 91, 37, 56}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 245, 81, 16, 23, 186, 30, 250, 116}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 77, 9, 228, 232, 250}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 71, 106}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 20, 186, 178, 44, 185}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 219, 192, 162}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 74, 209, 123, 40, 252, 107, 246, 233}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 194, 138, 235, 100, 117, 170}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 245, 14, 190, 178, 114, 248, 70, 74}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 111, 176, 48, 155, 243, 212}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 84, 147, 171, 121, 42, 214, 15, 41}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 144, 181, 136, 200, 93}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 206, 189, 25}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{3, 102, 36, 231, 15, 242, 143, 0, 0, 0, 0, 0, 0, 0, 187, 102}, 2},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 26, 204, 96, 207, 129, 200, 101}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 66, 151, 48, 139}, 64},
	{{81, 189, 220, 168, 192, 0, 247, 58, 49, 34, 85, 100, 169, 81, 96, 83}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130}, 64},
	{{81, 189, 220, 168, 192, 254, 236, 18, 182, 5, 191, 173, 2, 125, 200, 214}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 148, 217, 163, 229, 153, 81, 252}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 245, 247, 195, 218, 154}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 47, 163, 155, 83, 194, 130, 136, 17}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 36, 203, 178, 147, 146, 249}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 69, 197, 20}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 222, 241, 153, 38, 245, 208, 184}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 5, 209, 209, 44, 216, 9, 29, 93, 138}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 162}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 50, 86, 125, 118, 107, 198, 244, 89, 163}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 138, 236, 65, 168, 187, 254, 173, 125, 107}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 43, 17, 111, 135, 58, 137}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 53, 203, 32, 181, 29, 220, 131, 110}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 7, 179, 90, 235, 8, 79}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 120, 137, 78, 181}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 154, 205, 17, 79, 80, 81, 165, 94}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 184, 81, 2}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 119, 83, 43, 202, 231, 191}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 51, 163, 103, 154, 60, 252, 39, 17}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 135, 201, 41, 143, 187}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 180, 138, 89, 48, 78, 218, 239, 134}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 224, 181, 242, 141, 85, 65, 18}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 1, 196, 145}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 103, 182, 180, 235, 75}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 104, 174, 116, 31, 138, 218, 176}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 160, 214, 69, 93, 226, 151, 249}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 9}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 217, 52, 4, 148, 2, 217}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 160}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 223, 66, 105, 110}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 138, 134, 134, 50, 203}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 32, 161, 48, 87, 118, 221, 203, 6, 245}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 183, 167, 208, 21, 155, 190, 91, 207, 179}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 134, 205, 92, 242}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 242}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 216, 210, 22, 195, 26, 78, 128}, 64},
	{{81, 189, 220, 168, 192, 0, 33, 15, 66, 249, 18, 90, 148, 68, 85, 181}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 19, 15, 59, 24, 247}, 64},
	{{81, 189, 220, 168, 192, 0, 27, 2, 92, 181, 5, 9, 148, 240, 4, 28}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 198, 132, 255, 100}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 44, 232, 186, 69, 139}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 64, 90, 51, 210, 152, 207, 180, 165}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 38, 78, 73, 248, 237, 250, 154}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 60, 25, 172}, 64},
	{{81, 189, 220, 168, 192, 0, 102, 160, 137, 55, 155, 216, 100, 7, 25, 104}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 26, 190, 162, 184, 162, 32, 127, 154}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 148, 103, 70, 85, 253, 7, 198, 244}, 64},
	{{81, 189, 220, 168, 192, 0, 133, 35, 17, 52, 210, 203, 205, 201, 216, 168}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 85, 92, 246, 10, 32, 156, 5}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 182, 140, 225, 85, 3, 18, 222, 23}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 178, 110, 230, 20, 64, 25}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 88, 138, 177, 233, 240, 152}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 217, 72, 158, 50, 27, 243, 152, 174}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 252, 216, 54, 122, 212, 228, 172, 61, 108}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 119, 82, 29, 75, 136, 58, 252}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 181, 83, 107}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 249, 248, 42}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 99, 122, 134, 216, 183, 249, 172}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 19, 40, 101, 154, 237, 65, 137, 251}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 249, 152, 65, 170, 84, 76, 53, 198}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 68}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 220, 255, 206}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 218, 32, 253, 209, 93}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 190, 242, 210, 43, 123, 6, 210, 76}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 183, 161, 88, 38, 162, 130}, 64},
	{{81, 189, 220, 168, 192, 0, 111, 231, 113, 250, 149, 178, 233, 52, 59, 156}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 9, 210, 83, 13, 79}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 82, 181, 65}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 13, 223, 199, 217, 176, 5, 82, 89, 249}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 53}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 156, 205, 61}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 248, 138, 221, 111}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 75, 24, 116, 144, 115, 95}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 92, 16, 32, 200, 39, 28}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9}, 64},
	{{81, 189, 220, 168, 192, 99, 143, 85, 226, 36, 210, 173, 21, 209, 114, 17}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 223, 114, 74, 229, 86}, 64},
	{{81, 189, 220, 168, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 117}, 64},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 44, 238, 61, 88, 209, 167}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 82, 70}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 150, 59, 10, 185, 98, 78, 191}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 30, 39}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 48, 60, 234, 217, 138, 113}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 77, 189, 244, 19, 148, 61, 115}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 119, 45, 149, 2}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 117, 121}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 239, 219, 31, 183, 67, 128}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 114, 148, 111}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 145, 166, 56, 149, 122}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 126, 191, 219, 164, 95, 114, 249}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 196, 67, 46, 211, 9, 95, 45}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 101, 50, 222}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 23, 163, 175, 130, 26, 204, 79, 205}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 19, 4}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 206}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 3, 92, 83, 27, 38, 14, 101, 253}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 255, 208}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 230, 146, 0, 16, 26, 40, 239}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 84, 111, 126, 6, 222, 88, 6}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 125}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 153, 112, 53, 195, 239}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 90, 164, 238, 27, 191, 22}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 63, 23}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 58, 140, 140, 183, 183, 106}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 98, 147, 20, 55, 148, 222}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 146, 176, 98, 4, 198, 187}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 79, 184, 44}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 128, 5, 206, 188, 153, 128}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 194, 247}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 225, 105, 230, 227, 146, 229, 239, 2}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 47, 213, 22, 228, 120, 41, 136}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 125}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 222, 37, 168, 245, 105}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 227}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 181, 40, 189, 201, 255, 60, 217}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 23}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 234, 148}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 210}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 227, 0, 38}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 49, 23, 56, 28}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 186, 110, 71}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 249}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 160, 32, 12, 226}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 164, 49, 181, 78}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 150, 115}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 100}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 165, 79, 42, 244, 61}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 238, 234, 118, 50, 228, 94, 11}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 93, 163, 223, 231, 22, 125}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 209, 56, 4, 165, 66, 180, 92}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 231}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 159, 85, 27}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 61, 181, 254, 61, 10}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 50, 15, 132}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 11, 168, 190, 149, 182, 208, 13}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 80, 209, 224, 44, 199}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 59, 105}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 89}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 45, 230, 241, 214, 161, 224, 176}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 15}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 126, 204, 230, 180}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 171, 147, 174}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 131, 46, 50, 163, 156, 31}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 86}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 98}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 164, 112, 231, 189, 91, 209, 102}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 240}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 69, 72, 42}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 55, 26, 16}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 30, 195, 73, 17, 114, 123, 206, 90}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 215, 9, 1}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 85, 198}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 44, 36, 117, 203, 189, 73, 27}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 151, 131, 97, 204}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 126, 178, 173}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 100, 212, 249, 198, 164, 153, 140}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 212, 207, 9, 190, 52, 63, 52, 143}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 44, 95, 75, 63, 189, 49}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 123, 101, 127}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 226, 191, 117, 120}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 156, 75, 145, 157, 11, 211}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 135, 123, 213, 191, 238, 131}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 118, 254}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 86, 180, 224, 152}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 183, 136, 17}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 0, 0, 0, 0, 0}, 239},
	{{168, 75, 133, 180, 91, 165, 77, 232, 0, 0, 0, 141, 165, 52, 79, 236}, 239},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 245}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 117}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 114}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 176}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 163}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 194}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 51}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 131}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 243}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 57}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 181}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 98}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 233}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 130}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 19}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 37}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 125}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 129}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 176}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 185}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 240}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 49}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 151}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 6}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 48}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{106, 179, 186, 109, 81, 234, 233, 167, 101, 160, 90, 102, 174, 234, 208, 0}, 47},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 79}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 42, 93, 183}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 164}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 158, 231}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 183}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 184, 174, 211, 135, 59}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 202, 63, 29}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 224}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 110, 236}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 109, 107}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 129, 69, 22, 189}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 154, 132}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 94}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 225}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 62, 139, 198, 235, 174}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 9, 123, 213}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 110, 169, 207}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 107, 223}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 32, 82, 130}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 108}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 159, 238}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 58, 39, 224, 139, 138}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 158, 168}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 67, 108, 244}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 60, 133, 10}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 37, 194, 81, 61, 199}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 55, 187}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 172, 81, 232, 246}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 125, 70, 2, 45}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 79, 222}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 162, 40}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 67, 108, 216, 1}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 140, 186, 104, 122}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 24, 128}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 69, 13, 195}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 153, 216, 12}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 64, 210, 234, 250}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 84, 175, 152}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 218, 93, 50, 169, 135}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 84}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 117, 67, 0, 252}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 16, 154, 194}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 149, 142, 129, 231, 211}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 92, 55, 208, 137}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 53, 223, 232, 225, 147}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 129, 40, 206, 107}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 77, 98, 249}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 158, 22, 77, 172}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 48, 84}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 238, 185, 99}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 180, 141, 193}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 238}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 235, 64, 85, 168}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 136}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 144, 124, 206, 32, 143}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 104, 104, 200, 61}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 138, 153, 59}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 52, 165}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 165}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 153, 237, 244}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 90, 253}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 225, 40, 126, 102}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 135, 116, 188, 201, 250}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 26, 57, 249, 197, 255}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 189, 182, 137, 91, 189}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 208, 16, 213}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 32}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 0}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 128}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 222}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 214, 168, 119}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 243, 98, 45}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 148, 138, 44, 138, 22}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 75, 42, 37}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 115, 162}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 146, 193, 87, 188, 27}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 132, 183}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 192, 227}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 0, 0, 104}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 0, 211, 138, 21}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 196, 203, 132, 113, 2}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 15, 50, 54, 240}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 11, 103, 125, 194}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 0, 15, 115, 207, 211}, 43},
	{{46, 105, 234, 21, 23, 247, 169, 33, 47, 5, 0, 150, 111, 27, 58, 46}, 43},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 17, 242}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 64, 245}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 137, 52}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 113, 186, 129}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 32, 191}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 213}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 17, 222, 215, 185}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 35, 254}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 199}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 16, 109}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 2}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 110}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 242}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 245, 64}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 86}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 145}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 154, 242, 45}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 191}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 240, 16, 84}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 86, 225}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 26}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 3, 0, 132}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 197, 57}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 186}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 128, 114, 96, 146}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 71, 157, 250}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 178, 28}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 246, 32}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 242, 212}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 185, 168, 254}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 104, 23, 126}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 220}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 98, 219, 160}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 130, 157, 214}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 110, 232}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 177, 124}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 119, 44, 100}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 148, 232, 233}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 83, 179, 201}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 162, 252, 237}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 44, 231, 207}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 129, 239, 41}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 187, 194, 240}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 222, 162}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 220}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 193, 23, 220}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 66, 53}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 241, 146}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 206, 252, 29}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 255, 221, 226}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 245, 162, 228}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 79, 16, 85}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 26}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 236, 97, 57}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 72, 42}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 230, 157, 214}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 7, 207, 213, 217}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 89, 248}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 230, 186, 125}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 221}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 104, 67, 205, 221}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 140, 51, 249}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 1, 89, 112}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 195}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 65, 226, 214, 177}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 216, 216, 245, 228}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 27}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 19, 197}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 160, 248, 120}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 163, 144, 116, 146}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 0, 0}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 73, 59, 71}, 17},
	{{152, 144, 100, 142, 129, 23, 227, 50, 67, 81, 249, 116, 0, 0, 40, 39}, 17},
	{{109, 74, 145, 192, 0, 0, 0, 0, 130, 174, 250, 240, 53, 136, 59, 233}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 170, 236, 152, 82}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 71, 44, 117, 1, 67, 17, 244}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 232, 121, 72, 215, 137}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 171, 88, 111, 89, 41}, 5},
	{{109, 74, 145, 192, 0, 63, 238, 23, 120, 222, 119, 92, 143, 209, 76, 136}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 229, 104, 243, 184, 255, 213, 41}, 5},
	{{109, 74, 145, 192, 0, 0, 24, 178, 136, 61, 250, 203, 128, 163, 252, 71}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 78, 83, 137, 19, 85, 89, 25, 208}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 44, 32, 221, 82, 56, 36, 124, 233}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 29, 87, 48, 194, 217, 59, 192, 110, 54}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{109, 74, 145, 192, 0, 0, 169, 228, 115, 151, 55, 238, 176, 141, 114, 125}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 23, 205, 213, 188, 159, 110}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 117, 157, 3, 140, 51, 217, 208, 148}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 168, 211, 38, 79}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 51, 155, 200, 59, 236, 44, 28}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 168, 165, 96, 242, 119, 28, 191, 81}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 233, 79, 43, 62, 52}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 52, 178, 216, 206, 43}, 5},
	{{109, 74, 145, 192, 0, 216, 155, 153, 38, 204, 101, 39, 245, 245, 111, 211}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 72, 37, 176, 79, 136, 131, 199, 226}, 5},
	{{109, 74, 145, 192, 0, 0, 136, 203, 109, 198, 162, 98, 97, 102, 36, 3}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 204, 169, 40, 210, 45, 212, 53, 126, 92}, 5},
	{{109, 74, 145, 192, 0, 0, 79, 241, 52, 49, 198, 158, 205, 14, 56, 119}, 5},
	{{109, 74, 145, 192, 1, 157, 74, 144, 88, 187, 115, 245, 94, 172, 72, 101}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 251, 42, 135, 219}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 169, 240, 99, 131, 89, 157}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 241, 103, 8, 29, 149, 9}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 69, 189, 169, 187, 249, 83, 44, 40, 135}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 234, 195, 82, 245, 183, 253}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 13, 223, 53, 53, 229}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 151, 182, 46, 160}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 163, 180, 197, 145, 216, 12, 54, 253, 220}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 32, 96}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 112, 22, 248, 228, 255, 193, 46}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 83, 142, 156, 238}, 5},
	{{109, 74, 145, 192, 0, 0, 97, 219, 54, 17, 104, 165, 224, 111, 105, 193}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 180, 252, 51, 103, 150, 248, 186, 40}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 179, 91, 114, 220}, 5},
	{{109, 74, 145, 192, 0, 67, 91, 179, 179, 171, 166, 112, 251, 91, 239, 184}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 198, 195, 249, 233, 46, 72}, 5},
	{{109, 74, 145, 192, 235, 148, 185, 239, 37, 149, 239, 110, 218, 152, 64, 83}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 206, 27}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 222, 111}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 158, 33, 226, 60, 123}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 64, 31, 74, 104, 17, 174, 222}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 8, 168, 207, 249, 11, 246, 149}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 123, 163, 137, 80, 164, 52, 77, 18, 1}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 226, 188}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 17, 42, 218, 124, 69, 176, 71, 124}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 6, 43, 75, 139, 135, 91, 202, 101, 196}, 5},
	{{109, 74, 145, 192, 0, 0, 86, 12, 113, 85, 7, 3, 253, 81, 213, 52}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 38, 36, 236, 72, 11, 41, 152}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 191, 46, 74, 11, 53, 222, 208}, 5},
	{{109, 74, 145, 192, 0, 213, 59, 61, 57, 195, 209, 36, 75, 71, 210, 33}, 5},
	{{109, 74, 145, 192, 131, 90, 138, 228, 128, 229, 91, 38, 104, 109, 124, 74}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 161, 229, 248, 122, 101, 59}, 5},
	{{109, 74, 145, 192, 0, 0, 147, 87, 77, 221, 200, 232, 187, 223, 102, 121}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 199}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 182, 40, 88, 162}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 157, 243}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 51, 146}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 225, 81, 148, 29}, 5},
	{{109, 74, 145, 192, 0, 0, 81, 158, 113, 81, 70, 16, 9, 76, 143, 230}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 4, 190}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 42, 48}, 5},
	{{109, 74, 145, 192, 0, 0, 200, 154, 175, 140, 201, 12, 105, 60, 87, 179}, 5},
	{{109, 74, 145, 192, 0, 165, 76, 6, 123, 43, 123, 115, 83, 133, 238, 140}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 102, 205, 111, 248, 242, 20, 244, 148, 202}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 190, 154, 232, 106, 156}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 173, 25, 125, 88, 28}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223}, 5},
	{{109, 74, 145, 192, 0, 169, 139, 155, 191, 139, 209, 81, 169, 111, 160, 236}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{109, 74, 145, 192, 0, 146, 12, 81, 69, 29, 167, 193, 102, 178, 111, 15}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 134, 21, 25, 159, 223, 10}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 102, 163}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 152, 190, 15, 41, 34, 122}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 5},
	{{109, 74, 145, 192, 0, 56, 159, 89, 252, 50, 28, 213, 51, 127, 77, 251}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 97, 56}, 5},
	{{109, 74, 145, 192, 179, 198, 161, 15, 103, 19, 19, 197, 29, 31, 19, 73}, 5},
	{{109, 74, 145, 192, 0, 0, 0, 59, 51, 43, 210, 40, 208, 254, 54, 100}, 5},
	{{109, 74, 145, 192, 0, 0, 174, 155, 137, 227, 127, 118, 240, 157, 229, 34}, 5},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 175, 14}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 26, 123}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 82}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 254, 93, 147, 180, 96}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 156, 206, 144}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 143, 3, 166}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 132, 166, 4, 23}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 142}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 162, 36, 76}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 143}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 211, 60}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 41, 152, 167, 89}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 36, 50}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 125, 131, 174, 33}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 39, 27}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 239}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 91, 46, 38, 27, 67}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 115, 206, 135}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 165, 154, 12, 2}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 177, 236, 186, 155}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 185, 251, 9, 233}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 107, 211, 192, 25, 249}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 220}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 47, 216, 55, 224, 207}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 3, 213}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 89, 169, 111}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 14, 83, 181, 105}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 166, 249, 163}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 9, 244}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 13, 234, 54, 5, 38}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 121}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 160}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 65, 86}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 249, 242, 170}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 132, 254, 37}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 139, 129, 74, 247}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 215, 23, 195, 207}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 50, 128}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 246, 126}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 242, 186, 11, 64}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 3, 91}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 134}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 221, 245}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 65}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 4, 42, 28, 231, 34}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 67, 41, 72}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 208}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 131, 237, 25, 227}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 10}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 10, 135, 103, 22, 124}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 78, 77, 76}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 219, 93, 157}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 180}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 15, 132, 221, 251}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 80, 50}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 247}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 102}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 211, 3}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 252, 64}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 109, 242}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 117, 127}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 89, 159, 106, 251, 201}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 47, 252}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 100, 33, 214}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 168, 25}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 120, 77, 6, 238}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 48, 79, 78, 170, 219}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 196, 58, 98}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 80}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 68, 74}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 169, 129, 100, 30, 107}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 167, 22, 10}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 191}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 225}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 170}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 16, 91, 96, 37}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 181, 88, 131}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{100, 243, 22, 230, 38, 44, 128, 86, 132, 57, 0, 0, 0, 0, 0, 0}, 240},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 134, 66, 14, 193}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 114, 129, 26, 215, 78, 61, 38, 67}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 175, 176, 254, 138, 170, 245}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 111, 100, 213, 32, 203, 152, 104, 45, 212}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 233, 155, 84, 72, 73}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 143, 26, 188, 177, 200, 149, 227}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 87, 192, 249, 170, 55, 9, 21, 24}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 122, 216, 84, 206, 7, 176}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 190, 118}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 27, 254, 226, 241, 245}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 110, 85, 159, 136}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 111, 230, 9, 190, 45, 230}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 76, 195, 172, 60, 254, 230}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 96, 235, 229, 64, 47, 132, 89, 196, 249}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 49, 217, 131, 92, 81, 41, 102, 179}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 143, 249, 2, 66, 180, 40, 210, 162}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 67, 86, 185, 250, 149, 126, 144, 68, 37}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 248, 47}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 235, 228, 6, 179}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 102, 155, 88, 214}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 61, 90, 126, 44}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 245, 218, 205}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 186, 180, 45, 167, 33, 147}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 249, 150, 11, 248, 111, 24, 221, 217}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 184, 173, 242, 18, 95, 113, 250}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 182, 221, 194, 104, 122, 185, 21}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 101, 164, 108, 51, 154, 88, 144, 188}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 236, 109, 235, 229, 203}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 88, 200, 236}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 141, 23, 203, 147, 35, 219, 23, 36}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 252, 196, 71, 183, 177, 250, 116, 184, 124}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 21, 71}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 188, 50}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 100, 131, 104, 28, 137, 182, 94}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 192, 85, 121, 114}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 65, 214, 32, 176, 169, 159}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 162, 207, 23, 250, 20, 132}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 12, 248, 232, 187, 197}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 34, 172, 27, 27, 189, 134}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 131, 185, 205, 145, 41, 107, 47, 7}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 83, 213, 193, 199, 255, 158}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 199, 70}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 108, 35, 178, 234, 183, 130, 152}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 55, 146, 138, 111, 248, 168, 176, 17}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 60, 5, 251, 44, 46, 210, 246}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 183, 27, 164}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 144, 211, 97, 71}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 59, 208, 101, 7, 116, 91, 233}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 164, 128, 252, 110}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 152, 165, 135, 235, 118, 2, 172, 216}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 55, 112, 191}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 171, 167, 44, 73, 185, 238, 195}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 110, 47, 15, 253, 80, 79, 103, 208}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 37, 192, 225, 40, 86}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 67, 66, 26, 251}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 48, 250, 82}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 240, 223}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 219, 190, 100, 76}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 152, 155, 132, 28, 186, 160}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 149, 50, 225, 221, 117, 103}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 221, 28, 240, 150, 189}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 38, 83, 82, 240, 181, 19, 33, 19}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 204, 201}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 86, 69, 250}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 1, 103, 65, 24, 102, 172}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 53, 64, 178, 5, 33, 93, 239, 95}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 51, 253}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 198, 225, 123, 29}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 123, 42, 118, 135, 176}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 17, 79, 39, 70, 222, 156, 103}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 181, 132, 172, 53, 66, 57, 123, 231, 79}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 60, 249, 107, 15, 105, 208, 208, 40}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 65, 13, 45, 34}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 174, 147, 126}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 93, 8, 148, 67, 134}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{153, 251, 115, 65, 104, 179, 0, 0, 0, 0, 0, 0, 10, 28, 72, 173}, 197},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 31, 119, 203, 127, 63}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 88, 64, 13, 165}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 200, 214}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 255, 247, 184, 11, 244}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 135}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 87, 207, 90}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 241}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 205, 217, 42, 45}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 50, 167, 119}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 212}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 142, 65, 248, 80}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 148}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 113, 113, 237}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 116, 74, 11, 43}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 50, 64, 188}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 206, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 243, 111, 203, 104}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 26, 85, 131, 220}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 150, 193, 53, 64}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 216}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 31, 8, 146, 40}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 132, 253, 181, 71, 217}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 230, 118, 252}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 23, 113, 92, 50, 223}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 205, 185, 110}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 47, 253, 172, 71}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 159, 224}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 153, 199, 176, 198}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 131, 239, 150, 66}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 61, 226, 176}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 216, 130, 113}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 103}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 161, 89, 36, 28}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 228, 57, 24, 169}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 207, 103, 100}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 222, 231, 21, 52}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 226}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 209}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 110, 230, 47, 226, 55}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 178, 21, 107}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 197, 158, 132, 55}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 166, 164, 153, 69}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 192}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 109, 213}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 18}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 78, 136, 65}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 179, 222}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 121, 66, 116, 238}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 145, 218}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 37}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 184, 65, 164}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 173, 156}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 117, 137, 203, 11}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 125, 252, 138}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 178, 181, 248}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 59, 124, 239}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 254}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 68, 158}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 152}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 111, 205}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 252, 217, 91, 54}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 13, 51, 114}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 198, 158, 251, 109}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 136, 207, 198, 97}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 195, 158, 141, 145, 52}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 29}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 194, 104, 222, 45}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 193, 105, 123, 245}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 119, 237, 91}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 22, 100, 101}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 115}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 23, 13, 242, 19}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 187}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 0, 0}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 131, 33, 80}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 0, 94, 187}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 3, 132, 165, 115, 155}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 0, 0, 13, 225, 146}, 192},
	{{43, 113, 60, 224, 36, 20, 42, 161, 24, 223, 192, 115, 94, 7, 82, 55}, 192},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 14, 75, 117, 213}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 221, 95, 66, 26, 233, 4, 29, 225, 104}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 207, 168, 200, 149, 10, 38, 142, 66}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 7, 210, 105, 190, 67, 41, 110}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 96, 40, 239, 75, 222, 98, 213, 62}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 181, 237, 5, 179, 12, 203, 35, 236}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 17, 119, 253, 16, 104}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 227, 212, 43, 0, 2}, 160},
	{{61, 77, 121, 176, 138, 152, 215, 19, 75, 50, 55, 137, 249, 250, 207, 68}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 32, 88, 255, 79, 67, 149, 241}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 152, 180}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 92, 125, 73, 82}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 3, 58, 79, 172, 203, 21, 103, 250, 148}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 151, 75, 126, 109, 134, 12, 228, 35, 147}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 93, 133, 146, 222, 194, 225, 107}, 160},
	{{61, 77, 121, 176, 138, 152, 123, 212, 158, 114, 161, 200, 163, 95, 195, 112}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 179, 47, 29, 89}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 95, 92}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 51, 205}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 117, 15}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 215, 117, 100, 252, 38, 55, 14, 150}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 219, 229}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 25, 227, 235, 46, 42, 192, 95, 182}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 135, 115, 164, 39, 198}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 102, 72, 12, 3, 194, 6, 217}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 164, 117, 222, 235, 2, 159}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 186, 229, 185, 85, 202, 208, 136, 64, 135}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 45, 125, 80, 153, 94}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 170, 216, 8, 94}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 239, 208, 246, 84, 1, 157, 57, 66, 220}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 50, 254, 254, 196, 124, 75}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 46, 41, 95, 195, 253, 174, 231, 243}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 140, 12, 16, 75, 82}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 147, 76}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 239, 165, 152, 31}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 213, 241, 204}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 35, 191, 80, 237, 233, 248}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 12, 92, 11}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 215, 15, 164, 206, 150}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 138, 90, 188, 132, 251, 13}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 104, 56, 58}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 71, 81, 195, 179, 99}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 193, 222, 21}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 239, 176, 108, 198, 64, 100, 10, 150, 188}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 89, 105, 250, 75, 109}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 187, 171}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 50, 33, 233, 255, 82, 3, 114}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 8, 240, 88, 177, 26, 206, 130, 51, 197}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 83, 252, 95, 61, 5, 171, 34}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 133, 19, 19}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 252, 222}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 50, 45, 156, 233, 10, 91, 164, 144, 185}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 100, 6, 211, 123, 118, 112, 166}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 110, 12, 58, 2}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 147, 123, 162, 68, 114, 106}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 195, 165}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 31, 118, 82, 249, 234, 59, 57, 237, 155}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 242, 73, 162, 9}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 231, 65, 74, 57, 131, 39, 56, 69}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 26, 97, 195, 251}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 132, 162, 98, 233, 81, 129, 21, 197}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 5, 83, 61, 47, 97}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 56, 183, 224, 114, 166, 209, 203, 245}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 133, 28, 116, 124, 33, 31, 95, 206}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 160, 39, 213, 255}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 147, 148, 224, 29, 175, 21, 212, 75}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 161, 186, 208, 251, 171, 225, 8, 39}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 7, 180, 216, 200, 103, 16, 54}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 73, 137, 40}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 68, 52, 134, 189}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 24, 60, 122, 5, 218}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 157, 218, 10, 142, 123}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 187, 125, 195, 103}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 101, 228, 66}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 136, 131}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 207, 102, 169}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127}, 160},
	{{61, 77, 121, 176, 138, 152, 0, 0, 0, 0, 0, 0, 0, 41, 65, 105}, 160},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 67}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 3, 111, 254}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 165, 79, 222, 105, 84}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 212, 214, 20, 111, 247}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 101}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 204, 77, 164}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 182, 199, 79, 123}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 18, 51, 249, 200}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 254, 44, 125}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 82}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 104, 49, 106, 248, 155}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 191, 151}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 146, 108, 75}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 165, 29}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 109, 36, 62}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 126, 247}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 225, 210, 95, 154}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 130, 152}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 124, 140, 129, 185, 224}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 160, 123, 150}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 159}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 42}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 187, 158, 164, 16}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 139, 186, 244, 253, 5}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 40, 161}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 11, 103, 133, 156, 138}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 195, 239, 80, 55, 249}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 220, 19, 20, 156, 42}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 211, 238, 135, 184, 250}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 108}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 88, 67, 208, 215}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 148}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 65, 56}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 119, 8, 193}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 178, 167, 221}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 139, 250}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 207, 168, 35}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 36, 252, 16}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 44, 212, 24, 226}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 167}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 196}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 197, 116}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 161, 173, 21, 98}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 14, 123, 254}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 231}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 137}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 239, 165, 252, 183, 107}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 150, 132, 68, 69}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 10, 1, 208}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 134, 179}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 143, 57, 181, 70}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 214, 130, 185}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 146, 242, 237, 82}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 99, 135}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 219}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 6, 154}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 77}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 63, 122, 10}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 237, 245, 240, 8, 141}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 122, 254, 251}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 54, 39}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 217, 82, 214, 145}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 221, 231, 90}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 198, 108, 148, 30, 101}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 42, 101, 25}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 22, 60, 64, 137}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 100, 39, 60, 239}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 214, 80, 250, 119}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 85, 195, 76, 81}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 125, 68, 253, 81}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 5, 213}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 99, 86, 209}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 177, 44, 22}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 78, 180}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 243, 249, 87, 131, 26}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 86}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 164}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 25}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 0}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 0, 0, 249}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 0, 241, 228, 20}, 199},
	{{119, 194, 146, 49, 59, 242, 25, 220, 122, 104, 80, 0, 183, 106, 78, 232}, 199},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{254, 162, 155, 47, 187, 3, 1, 114, 142, 191, 152, 44, 144, 26, 202, 0}, 217},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 72}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 216, 234, 253, 218}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 167, 135}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 126, 252}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 167, 162, 249, 249}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 18}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 228}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 164}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 165, 2, 113, 34}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 131}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 145, 167, 46}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 220, 148, 18}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 46, 235, 169}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 57, 82}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 29, 15, 228}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 130, 66, 243}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 205, 150}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 224, 71}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 105}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 208}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 40}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 95, 30}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 204, 179}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 169, 49, 48, 79, 196}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 185, 20, 66, 83}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 204, 14, 236, 57}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 221, 78}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 6, 154, 120}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 27, 249, 78}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 98}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 79, 140, 123}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 157, 136, 228}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 253}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 94}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 125, 97, 20, 17}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 244, 184, 52}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 222, 234, 151}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 214}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 72, 133, 183, 109, 157}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 94, 22, 210, 111, 170}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 225, 111, 33, 16}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 27, 133}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 96, 17}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 158, 16, 213}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 78, 20, 138, 2}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 64, 23, 190, 235}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 35}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 189}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 130, 41, 31}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 19, 90}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 130, 2}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 152, 222, 110}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 98}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 220, 46}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 220, 91, 41}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 65, 28, 19, 194}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 78, 216, 178, 94, 248}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 117}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 62, 12, 37}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 76, 66, 75, 68, 5}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 199, 219, 210, 58, 136}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 73}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 13, 223}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 37, 86, 127, 64, 106}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 42}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 221, 35}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 88, 207}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 74, 91, 139, 41}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 36, 199, 169, 46}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 34, 89, 133, 87, 3}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 251}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 0}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 119, 63, 1, 177}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 108, 62, 181}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 134, 189, 145, 206, 231}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 141, 120}, 75},
	{{176, 1, 114, 42, 191, 145, 43, 1, 141, 18, 64, 0, 0, 0, 0, 126}, 75},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 232}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 206}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 5, 129}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 237, 88}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 26, 26}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 228, 101}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 68, 193}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 12, 43}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 180, 146}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 244, 165}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 7}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 235}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 133}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 36}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 194}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 198}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 119, 203}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 68, 176}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 255}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 194, 6}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 206}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 188, 64}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 134}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 127}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 224, 110}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 45, 33}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 250}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 85, 209}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 138, 165}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 178, 198}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 140}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 66, 253}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 200}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 80}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 15, 252}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 130}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 21}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 225}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 91}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 223}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 167}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 205}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 187}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 91, 38}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 229}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 174}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 5, 194}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 220, 1}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 123, 168}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 180}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 52}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 127}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 189}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 185, 198}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 82, 149}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 212}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 138}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 252}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 93, 186}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 114, 9}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 159, 221}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 22}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 34, 191}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 155}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 139, 81}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 101}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 192, 220}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 113}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 43, 56}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 0}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 0, 132}, 222},
	{{170, 244, 67, 132, 145, 163, 76, 213, 85, 237, 248, 22, 207, 64, 72, 243}, 222},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 23}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 62, 98, 145, 125, 112}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 127, 250, 138, 175}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 68, 8, 149}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 151, 154, 98, 96}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 75, 252}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 229, 230, 126}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 180}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 16, 108}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 254}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 245, 171, 193}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 113, 151}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 133, 168, 249, 160}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 231, 156}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 156, 54, 70}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 115, 117}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 31, 166}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 145}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 4, 139, 22}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 40, 195, 22}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 65, 163}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 159, 101, 23, 224}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 223, 228, 44, 70}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 215, 32, 78, 210, 103}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 128}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 228, 241, 114, 193, 223}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 65}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 134, 101, 135}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 59, 81}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 203, 99, 247, 215, 3}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 88}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 130, 100, 169, 73}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 128, 177, 53, 251}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 172, 107, 22}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 102, 37}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 105, 78, 187, 100}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 244, 147, 219, 145}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 169, 223}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 83, 53}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 1}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 219, 172, 62}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 4, 211}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 79}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 48, 163}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 39, 211}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 151, 216, 98}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 251, 154}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 198, 201}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 251}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 52, 123, 40}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 241, 219}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 127}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 53, 111}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 132, 35, 95}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 5, 50, 5, 97, 187}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 39, 44}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 108, 72, 199}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 162, 127, 26, 82, 114}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 54, 59, 128, 187, 86}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 132, 195}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 80, 238}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 91}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 174, 144, 115}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 131}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 194, 58, 163, 65}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 224}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 233, 121, 15, 175, 32}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 208, 12, 25, 131}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 48, 206, 222}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 74, 217, 164, 101}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 183, 51}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 110, 49, 235, 57}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 20}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 252, 66, 186}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 100, 220, 249, 206, 192}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 83, 159}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 112, 140, 125, 184}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 26, 74, 201}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 189, 184}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 20, 233}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 226, 17, 175, 97}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 173, 48}, 39},
	{{102, 190, 58, 32, 75, 15, 89, 163, 64, 7, 168, 0, 0, 0, 0, 0}, 39},
	{{124, 170, 35, 47, 152, 224, 0, 112, 9, 92, 46, 66, 226, 177, 17, 128}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 144, 87, 100, 89, 121, 142, 86, 191, 0}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 199, 194, 79, 112, 149, 108, 57, 91}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 194, 26}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 253, 129, 144, 109}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 216, 168, 36, 98, 199, 20}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 243, 229, 228, 250, 172, 240}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 138, 218, 219, 179, 65, 75, 45, 217, 140}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 161, 39, 38, 205, 176, 215}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 164, 5, 206}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 65, 165, 45, 99, 227, 100}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 240, 218, 89, 170}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 198, 105, 68, 23, 192, 105}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 225, 53, 52, 104}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 247, 24, 40, 164, 174}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 177, 180, 172, 162, 118, 140, 54, 171, 200}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 186, 100, 101, 215, 77}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 91, 146, 1, 190, 102}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 32, 163, 109, 141}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 16, 132}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 108, 152, 93, 61, 158, 183}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 88, 151, 207, 187}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 58, 184, 56}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 15, 52}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 21, 234}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 121, 3, 223, 249, 9, 63, 75, 195, 114}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 20, 107}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 252, 162, 150, 155, 5, 159, 10, 201}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 200, 187, 246, 241, 36, 108, 86, 66, 140}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 36, 128, 50}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 111, 215}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 27, 147, 195}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 88, 86, 91, 125, 25, 117, 33}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 108, 62, 83, 179, 244, 181, 182, 26}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 47, 137, 160}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 80, 183, 127, 214, 10, 75, 157, 53}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 84, 124, 20, 236, 93, 235, 176}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 91, 50, 129, 190, 132, 81, 20, 191}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 196, 173, 147, 216}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 62, 197, 47, 88, 188, 242}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 202, 171, 236, 240, 118, 2, 40, 148, 161}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 16, 138, 158, 139, 127, 38, 15, 255, 19}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 208, 4, 125, 107, 171, 0, 202, 126}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 185, 44, 56, 201, 126, 44, 176, 17, 99}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 169, 40, 199}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 117, 66, 22, 204, 238}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 106, 131, 120, 23, 153, 112, 163, 98, 39}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 27, 147, 106, 3, 11, 155, 192, 52, 228}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 203, 135, 111, 213, 245, 227}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 99, 40, 83, 132}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 239, 168, 38, 1}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 56, 15, 227, 244, 59, 23, 142, 19, 160}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 32, 246, 2, 38, 125, 75, 30, 58}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 166, 71, 1, 22, 156}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 240, 110, 131, 83, 87, 83, 86, 207}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 131, 5, 82, 180, 5, 145, 95}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 99, 173, 215, 119}, 9},
	{{124, 170, 35, 47, 152, 224, 117, 161, 58, 89, 39, 235, 85, 52, 152, 45}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 152, 82, 153, 247, 24, 44}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 167, 217, 115, 177, 84, 11, 249, 167, 180}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 199, 134, 47}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 205, 178, 232, 153}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 225, 234, 63, 152, 243, 77, 166, 65}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 59, 214, 38, 7, 220, 100}, 9},
	{{124, 170, 35, 47, 152, 224, 9, 7, 225, 250, 143, 83, 183, 232, 106, 130}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 22, 154, 213}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 81, 26, 181, 151, 122, 50, 30}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 18, 84, 114}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 119, 249, 145, 133, 23, 248, 115}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 231, 130, 244, 200, 159}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 108, 89, 241, 50, 129, 244, 94, 62}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 15, 28}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 108, 18, 134, 109, 53}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 12, 9}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 94, 233, 139, 241, 49}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 106, 138, 165, 5, 226}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 1, 52, 217, 4, 147, 0, 27, 110}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 233, 79, 199}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 229, 183, 26, 67, 111, 127}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 141, 97, 215, 175, 60, 102}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 63, 4, 76, 114, 49, 180, 88}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 194, 196}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 249, 251, 78, 189, 135, 179, 1, 203, 1}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 9},
	{{124, 170, 35, 47, 152, 224, 0, 0, 0, 0, 0, 0, 0, 0, 222, 148}, 9},
	{{192, 221, 20, 228, 0, 0, 0, 0, 152, 92, 12, 1, 247, 192, 216, 148}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 23, 173, 90, 246, 122, 248, 242, 214, 207}, 217},
	{{192, 221, 20, 228, 0, 0, 69, 239, 171, 145, 10, 85, 31, 112, 105, 184}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 154, 158, 121, 238, 209, 198}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 53, 139, 55, 26, 228, 11, 15, 91}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 99, 61}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 233}, 217},
	{{192, 221, 20, 228, 0, 0, 203, 112, 178, 97, 46, 61, 171, 32, 214, 22}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 22, 124, 36, 78, 203, 131}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 45, 21, 165, 205, 24, 2, 166, 72}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 39, 85, 240, 235, 50, 35, 208, 168, 140}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 109, 225}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 39, 42}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 163, 157, 115, 64, 79, 44, 249}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 59, 226, 45, 193, 167, 184, 162}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 184, 166, 207, 4, 207, 36, 201, 75}, 217},
	{{192, 221, 20, 228, 0, 176, 251, 32, 203, 209, 140, 254, 160, 221, 197, 134}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 101}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 85, 196, 116, 2, 248, 240, 209}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 158, 8, 119, 48, 77, 177, 152}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 9, 15, 120, 86, 56, 234, 11, 188, 172}, 217},
	{{192, 221, 20, 228, 0, 233, 113, 34, 66, 249, 154, 67, 109, 156, 161, 29}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 148, 219, 175, 225, 38, 249}, 217},
	{{192, 221, 20, 228, 0, 0, 254, 229, 251, 67, 204, 61, 226, 125, 244, 182}, 217},
	{{192, 221, 20, 228, 0, 0, 207, 55, 214, 245, 145, 242, 226, 246, 209, 183}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 66, 49, 26, 97, 120, 195}, 217},
	{{192, 221, 20, 228, 0, 86, 81, 56, 145, 190, 184, 8, 210, 212, 242, 54}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 197, 96, 115, 0, 176}, 217},
	{{192, 221, 20, 228, 0, 0, 62, 175, 207, 94, 116, 167, 95, 203, 243, 71}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 77, 165}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 210, 248, 34, 19, 126, 149, 201}, 217},
	{{192, 221, 20, 228, 0, 0, 250, 228, 178, 54, 137, 39, 199, 90, 253, 127}, 217},
	{{192, 221, 20, 228, 0, 97, 14, 127, 155, 216, 252, 71, 184, 59, 12, 96}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 29, 85, 48, 225, 244, 108, 69}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 26}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 210}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 45}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 85, 60}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 196, 244, 223, 171, 173, 120, 206, 212}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 202, 227}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 47, 134}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 177, 131, 199, 222, 212, 110, 49, 173}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 157}, 217},
	{{192, 221, 20, 228, 0, 0, 81, 13, 79, 170, 150, 64, 8, 160, 37, 151}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 226, 156, 127, 50, 73, 243}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 223, 250, 189, 228, 1, 219, 178, 82, 16}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 6, 60, 209, 167, 174, 26}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 4, 251}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 92, 209, 178, 243, 200}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 185, 78}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 227, 166, 57, 172, 198}, 217},
	{{192, 221, 20, 228, 0, 187, 237, 148, 112, 221, 79, 62, 91, 9, 174, 251}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 67, 163, 218, 127, 176, 91, 109, 165}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 131, 147, 62, 81, 147, 91, 103, 60}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 186, 28, 18, 177}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 89, 52}, 217},
	{{192, 221, 20, 228, 0, 114, 70, 76, 126, 225, 157, 68, 232, 79, 166, 27}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 44, 23, 6, 90}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 124, 191, 33, 188, 107, 236}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 108, 235, 28, 84, 21}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 104, 159, 247, 251, 10, 35, 238}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 133, 239, 25, 109}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 155, 208, 40, 178, 143, 6, 150, 141, 252}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{192, 221, 20, 228, 0, 0, 85, 215, 55, 119, 114, 73, 159, 57, 39, 189}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 231, 31, 162, 1, 231, 237}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 67}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 246, 75}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 52, 73, 134, 220, 31, 169, 220, 108}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 92, 69, 118, 230}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 217},
	{{192, 221, 20, 228, 0, 0, 121, 218, 218, 195, 86, 113, 244, 89, 53, 155}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 90, 67, 206, 8, 181, 198, 6, 18, 186}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 108, 40, 130, 78, 103}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 217},
	{{192, 221, 20, 228, 0, 129, 242, 0, 150, 236, 88, 181, 199, 147, 169, 168}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 62}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 222}, 217},
	{{192, 221, 20, 228, 0, 0, 16, 178, 117, 28, 52, 229, 196, 103, 130, 156}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 20, 105}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 29, 140, 54, 111, 98}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 172, 128}, 217},
	{{192, 221, 20, 228, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 94}, 217},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 62, 165, 92}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 144, 215, 11, 111, 49, 30}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 79, 90, 183, 102, 5, 142, 41, 13}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 236, 162, 198, 201, 209}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 234, 241, 81, 77, 139, 156}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 22, 11, 60}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 82, 105, 35}, 142},
	{{208, 178, 136, 0, 0, 95, 185, 184, 166, 197, 215, 225, 152, 26, 110, 254}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 202}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 41, 212, 127, 207, 137}, 142},
	{{208, 178, 136, 0, 0, 0, 94, 19, 253, 51, 167, 83, 100, 195, 250, 169}, 142},
	{{208, 178, 136, 0, 0, 0, 65, 185, 158, 110, 146, 164, 123, 34, 135, 164}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 75}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 142, 239, 99, 160, 86, 80, 226, 126}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 97, 215}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 37, 38}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 23, 75, 228}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 97, 18, 195}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 76, 244, 126, 230, 100, 28}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 127, 58, 252, 14, 221, 111}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 159, 227, 62, 54, 45, 46}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 183, 210}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 34, 148, 252, 135, 135, 186}, 142},
	{{208, 178, 136, 0, 0, 0, 139, 156, 48, 49, 58, 81, 216, 141, 10, 154}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 229, 188}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 128, 211, 216, 204, 35, 79, 149}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 10, 37}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 161, 207, 236, 83, 140, 115, 204, 39}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 145, 52, 114}, 142},
	{{208, 178, 136, 0, 177, 223, 150, 2, 16, 198, 244, 157, 62, 234, 140, 62}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 247, 110, 113, 16, 3, 91, 56}, 142},
	{{208, 178, 136, 0, 0, 0, 43, 89, 4, 37, 209, 219, 225, 140, 221, 230}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50}, 142},
	{{208, 178, 136, 0, 0, 0, 190, 149, 215, 168, 233, 181, 130, 59, 146, 30}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 139, 107, 211, 131, 106, 36, 11, 221}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 152, 235, 180, 34, 103, 148}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 229, 80, 243, 2, 67, 54, 243, 9}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 212, 93, 73, 172, 196, 23}, 142},
	{{208, 178, 136, 0, 0, 233, 9, 123, 208, 216, 224, 200, 16, 46, 143, 25}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 63, 172, 10, 168, 120, 131, 71, 12, 65}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 133, 27, 14, 223, 196, 152}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 209}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 214, 183, 88, 17, 219, 81, 58}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 140}, 142},
	{{208, 178, 136, 0, 0, 232, 87, 247, 182, 109, 44, 228, 201, 163, 88, 235}, 142},
	{{208, 178, 136, 0, 17, 104, 131, 144, 214, 107, 66, 102, 218, 79, 212, 155}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 74, 14}, 142},
	{{208, 178, 136, 0, 0, 0, 234, 203, 22, 183, 192, 205, 132, 97, 138, 204}, 142},
	{{208, 178, 136, 0, 90, 183, 97, 77, 69, 124, 6, 167, 242, 101, 107, 157}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 72, 190, 227, 240, 234}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 97, 99, 105, 131, 234, 108, 66}, 142},
	{{208, 178, 136, 0, 0, 0, 201, 115, 197, 164, 159, 36, 160, 192, 111, 162}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 26, 244, 88, 251, 63, 16, 180, 19}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 214, 130, 148, 108, 115, 63, 82, 37}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 88, 187}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 184}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 82, 218, 234, 210, 155, 232}, 142},
	{{208, 178, 136, 0, 0, 199, 90, 218, 220, 229, 82, 231, 213, 48, 108, 234}, 142},
	{{208, 178, 136, 0, 67, 32, 214, 158, 237, 66, 134, 141, 42, 15, 138, 204}, 142},
	{{208, 178, 136, 0, 175, 125, 167, 215, 7, 101, 133, 174, 108, 14, 50, 224}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 237}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 121, 150}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 195, 237, 212, 30, 189}, 142},
	{{208, 178, 136, 0, 0, 0, 177, 162, 10, 239, 247, 72, 230, 128, 218, 148}, 142},
	{{208, 178, 136, 0, 0, 0, 38, 135, 11, 26, 232, 125, 155, 5, 140, 210}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 87, 139, 129, 31, 181, 232, 172, 142, 6}, 142},
	{{208, 178, 136, 0, 0, 0, 76, 218, 238, 143, 184, 221, 153, 80, 62, 242}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 186}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 179, 138, 26, 169, 171, 189, 208}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 119, 184, 123, 215, 241}, 142},
	{{208, 178, 136, 0, 0, 0, 155, 121, 86, 238, 126, 201, 78, 183, 99, 63}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 85}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 176, 86, 208, 63, 12, 4, 42, 79}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 156, 18, 211, 126, 39}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 160, 214, 215, 70, 245}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 163, 46}, 142},
	{{208, 178, 136, 0, 163, 151, 183, 237, 246, 115, 41, 122, 82, 162, 58, 88}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 118, 132, 26, 22, 252, 227, 215, 37}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 100, 195, 205, 230, 177, 111, 155, 151, 224}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 103, 255, 64, 20, 206, 218, 150}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 20, 71, 220, 254, 192, 2, 72}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 63, 207, 210, 151, 154, 44, 162}, 142},
	{{208, 178, 136, 0, 0, 0, 179, 217, 6, 177, 85, 65, 117, 7, 135, 64}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 78, 92, 16, 140, 160, 12, 176, 202}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 253, 139}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 31, 35, 124, 174, 205, 174, 105, 118, 186}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 56, 85, 62, 24, 137, 100, 237}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 237, 2, 23, 47, 145, 110}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 99, 241, 30, 133, 155, 120, 247, 74}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 16, 16, 107, 206, 251, 150}, 142},
	{{208, 178, 136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 67, 89}, 142},
	{{208, 178, 136, 0, 0, 0, 78, 211, 160, 194, 161, 22, 10, 108, 58, 142}, 142},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 27, 68}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 203, 135, 255, 92, 228, 143}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 224, 58, 245, 129, 129, 20, 213}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 129, 26}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 141, 133, 222, 72, 113, 124, 171, 147}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 146, 89, 155, 178, 55}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 113, 17, 61, 28}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 192}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 109, 67, 131, 167, 9, 46, 219}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 212, 134, 9, 52, 98}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 45, 156, 108, 110, 102}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 28}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 176}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 108, 64, 18, 40, 112, 119, 204, 51}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 180, 16, 122}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 206, 187, 233, 95}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 88, 227, 79, 158, 134}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 5, 100, 240, 214, 167, 161}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 214, 77, 146}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 7, 2, 218, 1}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 171, 177, 228}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 152, 0, 132, 111, 163}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 79, 5}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 21, 200, 112, 176}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 17, 67, 137, 95, 142}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 171, 202, 68, 211}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 128, 149, 31, 130, 229}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 29, 115}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 155, 96, 9}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 16, 157, 207, 255, 31}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 216, 217, 158}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 97, 233, 166}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 56, 253, 172, 24}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 179, 82, 95}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 20, 208, 232, 175}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 29}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 222, 184, 74, 65, 4, 158}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 86, 250, 251, 52, 77}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 46, 216, 92}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 241, 19, 8, 179, 27}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 6, 158, 72, 154}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 5, 184}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 86, 185, 48, 133, 36, 24}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 71, 220, 243}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 245, 222, 85, 237, 92}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 178, 12}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 7}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 59, 130, 163, 103, 222, 17, 125}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 67, 56}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 223}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 222, 194}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 40, 41, 212, 127, 42, 51}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 43, 206, 172, 247, 198, 184}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 249}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 185, 244, 101, 197, 198}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 57, 77, 159, 13, 83, 69}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 150, 195, 58, 117, 108}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 169, 87, 18, 217}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 151, 226, 170, 209}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 225, 51, 236, 84}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 173, 214, 12, 37, 34}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 254, 93, 25}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 157, 255, 123, 28, 58, 165, 169}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 203}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 76}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 98, 43}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 191, 64}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 157, 166}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 59, 59, 60, 1, 104}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 248, 161, 149, 215, 82, 180}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 132, 214, 96, 107, 58}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 185}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 44}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 30, 143}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 119}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 154, 57, 131, 82, 6}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 206, 15, 147, 246, 165}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 231, 163, 161, 165, 37, 9}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 228, 206, 136, 168, 207, 200}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 169, 235, 255, 92, 86, 86}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 202, 110, 104, 116, 49, 179, 160}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 10, 64, 29, 124, 209, 243}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 131, 87, 63, 47}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 41, 246, 159, 82, 110, 195}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 19, 61}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 42, 137, 30, 174, 237, 9, 117}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 127, 120, 202}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 139, 73, 71, 210}, 18},
	{{188, 68, 77, 30, 68, 153, 102, 180, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 92, 11}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 74, 163}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 63}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 33, 160}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 221, 39}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 236, 104}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 39, 110}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 83}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 86, 34}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 40}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 194, 94}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 117, 191}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 162, 147}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 216}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 110, 64}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 89, 96}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 91}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 184, 103}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 201}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 16, 23}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 170, 197}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 4}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 196}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 176, 187}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 224, 56}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 82, 47}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 195, 203}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 130}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 114, 160}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 195, 93}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 146}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 149, 21}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 86, 247}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 106}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 170, 173}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 34}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 8}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 239}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 36, 153}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 119, 253}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 194, 112}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 232, 41}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 107, 112}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 201}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 94, 220}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 255, 30}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 15}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 233, 219}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 84}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 71}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 118}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 231}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 7}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 199}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 92, 233}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 19, 243}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 11}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 173}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{114, 178, 121, 188, 205, 233, 35, 77, 34, 197, 158, 174, 101, 0, 0, 0}, 180},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 175, 184, 84}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 122, 97, 47, 111, 222, 145, 50, 3}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 58, 213, 117}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 42, 78, 225, 154, 226, 31, 73, 155}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 112, 155, 100, 94, 132, 55, 162}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 246, 210, 144, 133, 173, 80}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 237, 51, 106}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 164, 159, 212, 43, 192, 63, 195, 125}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 95, 164, 181, 91, 101}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 83, 10, 35, 214, 92, 78}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 119, 205, 12, 170, 186}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 82, 170}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 207, 179, 69, 100}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 186, 78, 82, 157, 233, 92, 217, 27}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 234}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 139, 7, 44}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 85, 9, 100, 201, 235, 11, 137}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 18, 29, 88, 220, 84, 185}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 157, 9, 129, 161, 195, 140}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 254, 30, 77, 48}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 215}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 128, 9}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 103, 192, 90}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 158, 210, 193, 150}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 129}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 43, 131, 74}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 135, 175, 20, 209, 145, 69}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 15, 35, 69, 29, 45, 214, 4, 119}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 48, 16, 36, 64, 201}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 215, 170, 114}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 168, 138, 119, 155, 114, 64, 155, 21}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 252, 36, 34}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 152, 204, 54}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 80, 8, 176, 23, 150, 28, 245, 181}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 238, 95, 208, 152, 177}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 7, 71, 32, 46, 212, 178}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 57, 9}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 85, 114, 153}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 151, 107}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 151, 194, 113, 204}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 82, 159, 127, 179}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 243, 145, 250, 21, 210, 188, 177, 146}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 44, 37, 72, 90}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 159, 176, 72, 220, 125, 160, 101, 197}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 120, 59, 58, 154, 151}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 192, 54, 215}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 88, 119, 111, 237, 72, 250}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 31, 176, 116}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 47, 182}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 84, 215, 130, 221, 93, 237, 144, 39}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 143, 239, 124, 208, 129, 20, 124}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 191, 155, 150}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 62, 20, 89, 2, 156, 10, 136}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 130, 117, 23, 0, 92, 239}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 151, 249, 240, 111, 164, 191, 117, 76}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 166, 2, 89, 248, 139, 93, 2}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 131, 100, 9, 122, 224, 24, 86}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 230}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 133}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 57, 236, 210, 7, 8}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 103, 183, 189, 136}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 24, 212, 70, 94, 46, 70, 73}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 20, 69, 161, 71, 110, 190, 154}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 142, 91, 80, 137, 208}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 73, 141, 96, 239, 181}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 219, 172}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 24, 44, 106, 233, 57, 0, 205, 96}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 230, 176, 144, 180, 90}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 139}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 233, 41}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 241, 228, 20, 170, 96}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 86, 204, 184}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 212}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 81, 118, 20, 90, 5, 36}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 82, 10, 84, 174, 69, 68, 59}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 120, 251, 103, 202}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 202, 138, 122, 66}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 129, 20}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 248, 223, 15, 157, 98, 102, 78, 73}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 64, 183, 135, 2}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 111, 49, 81, 159, 110, 137, 71}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 205},
	{{195, 98, 67, 12, 13, 43, 6, 0, 0, 0, 180, 168, 146, 25, 70, 8}, 205},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 89, 202, 241, 169, 247, 23}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 218, 238, 94, 196, 120, 241, 98}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 209, 170, 241, 72}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 99, 6, 222, 114, 240, 129, 35}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 116, 156, 164, 149, 245}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 51, 177, 191, 196, 175, 228, 55, 46}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 13, 99, 181, 110, 77, 129, 7, 45}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 20, 100, 119, 72, 55}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 132, 107, 159, 73, 80, 229}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 156, 219, 48, 117, 252, 105}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 169, 219, 64, 206}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 236, 194, 117, 248, 40}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 29, 6}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 60, 70, 189, 240}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 220, 108}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 161, 114}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 69, 243, 90, 103, 75, 12}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 19, 230, 239, 43, 41, 195, 232}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 21, 0, 10, 173}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 132, 164}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 45, 223, 186, 13, 60, 146}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 134, 180}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 194, 192, 37, 3, 64, 146, 168}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 225, 58, 37, 21, 105, 196, 154}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 116, 175, 204}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 240, 233, 242, 120, 236, 59}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 109, 139}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 70, 11, 238, 195, 118, 46}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 64, 220}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 169, 232, 42, 240, 168, 138, 104}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 133, 115, 35, 98, 47, 8}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 56, 250, 114, 236, 252, 200, 61}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 32, 217, 254, 155, 16, 91, 227}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 23, 67, 213, 122, 173, 203, 37}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 131, 233, 202, 76, 24, 121, 5, 24}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 214}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 147, 78}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 86, 197, 162, 218, 1, 78, 252}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 109, 99}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 67}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 221, 133, 98, 50, 127}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 124, 228}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 34, 133, 232, 168, 206, 209, 24, 34}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 210, 202, 79, 248}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 61, 171}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 48, 62, 84, 244, 143, 221, 100}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 250, 9, 97, 227}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 138, 151, 135, 210, 150, 18}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 203, 156, 56}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 186, 246, 184, 218}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 110, 238, 239, 250, 15, 220}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 253, 51, 61, 160, 73}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 42, 49, 159, 29}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 24, 104, 54, 19, 173, 230, 37}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 156, 102, 88, 121, 110}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 137, 204, 97, 117, 198, 216}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 164, 242}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 180, 99, 201, 34, 99, 177, 13}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 250, 141, 248, 110}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 33, 25, 190, 20, 19}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 167}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 202, 92, 15, 255}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 15, 111}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 155, 28, 4, 236, 146}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 54, 10, 232}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 207, 233, 138, 35, 34, 248, 172, 223}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 102}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 32, 246, 170}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 244, 23}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 243, 165, 17, 172, 66}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 112, 9, 132, 194, 221, 60}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 78}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 51, 213}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 124, 56, 140, 230, 136, 210, 93, 173}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 76, 83, 207, 143, 3, 14}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 27}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 235, 66, 91, 73, 16, 135}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 212, 39, 210, 30}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 105, 204, 243, 185, 232, 153}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 144, 85, 59, 77, 218, 241}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 231, 180}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 132}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 96}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 198, 56, 43, 218, 191, 13, 108, 42}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 94}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 202}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 70}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 69, 255}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 171, 72, 58}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 148, 44, 254, 91}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 143, 178, 165, 60, 20, 24, 89}, 251},
	{{146, 190, 42, 222, 14, 54, 28, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 183, 73, 248, 62, 211, 84, 59, 155}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 124, 222, 107, 121, 192, 255}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 68, 118, 39, 83, 184, 214}, 178},
	{{185, 202, 148, 0, 0, 154, 124, 84, 243, 212, 250, 142, 103, 122, 29, 192}, 178},
	{{185, 202, 148, 0, 0, 0, 129, 223, 151, 221, 99, 220, 206, 172, 121, 211}, 178},
	{{185, 202, 148, 0, 114, 195, 137, 26, 212, 221, 130, 154, 165, 105, 208, 151}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 59, 136, 211, 151, 95, 249, 62, 209}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 182, 64}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 50, 159, 122, 225, 148, 195, 52, 62}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 89}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 80, 69, 14, 164, 223, 77}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 206, 32, 32, 122, 45, 130, 36, 24, 244}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 39, 83, 1, 44, 1, 209, 254}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 84, 31, 164, 189, 141}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 9}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 69, 206, 10, 184, 208, 144, 200, 7, 206}, 178},
	{{185, 202, 148, 0, 0, 165, 69, 75, 81, 141, 83, 195, 243, 50, 153, 240}, 178},
	{{185, 202, 148, 0, 0, 0, 151, 66, 205, 207, 254, 91, 221, 95, 26, 235}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 121, 193, 16, 135, 74, 49, 96, 73, 174}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 137, 179}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 147, 209, 28, 73, 180, 10}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 194, 125, 107, 185, 164}, 178},
	{{185, 202, 148, 227, 6, 237, 35, 218, 141, 164, 227, 254, 204, 255, 146, 224}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 239, 91}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{185, 202, 148, 0, 0, 46, 183, 178, 55, 208, 153, 24, 116, 51, 199, 1}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 26, 166, 202, 42, 114}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 194, 176, 51, 79, 117, 236, 125}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 93, 33, 69, 227, 187, 24}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 176, 108}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 205, 239, 58, 147, 150, 175}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{185, 202, 148, 0, 0, 0, 179, 97, 133, 147, 247, 249, 138, 46, 169, 160}, 178},
	{{185, 202, 148, 0, 0, 6, 159, 37, 214, 169, 95, 27, 103, 19, 251, 221}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 31, 237, 147}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 75, 2}, 178},
	{{185, 202, 148, 0, 0, 63, 206, 117, 216, 228, 91, 194, 175, 36, 141, 199}, 178},
	{{185, 202, 148, 0, 0, 75, 29, 7, 6, 178, 177, 122, 81, 243, 94, 3}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 117}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 238, 189, 195, 211, 126, 71}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 87, 194, 14}, 178},
	{{185, 202, 148, 0, 0, 233, 84, 23, 18, 7, 229, 190, 184, 113, 36, 70}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 74, 164, 30, 66, 54, 185}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 143, 47, 61, 94, 94}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 91, 152, 245, 157, 255, 36}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65}, 178},
	{{185, 202, 148, 0, 118, 90, 22, 107, 88, 231, 74, 46, 142, 138, 49, 217}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 252, 170, 16, 90, 62, 111, 220}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 143, 227, 68, 110, 226, 204}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 202, 131, 211}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 45, 146, 51, 0, 241, 234, 211, 65}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 151, 147, 190, 211, 252, 102, 197}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 187, 188, 119, 44, 83, 0, 140, 203}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 51, 226}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 6, 240, 89, 152, 226, 92, 208, 201, 19}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 83, 232, 62, 73, 29, 204, 141, 152}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 209, 195, 99}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 178},
	{{185, 202, 148, 0, 0, 168, 0, 154, 72, 122, 184, 106, 221, 154, 66, 241}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 121, 230, 121, 63, 26, 244, 77, 64}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 77, 170, 125, 178, 61}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 73, 142, 208, 9, 226, 46, 221, 197}, 178},
	{{185, 202, 148, 0, 60, 123, 115, 83, 177, 26, 217, 150, 115, 163, 240, 11}, 178},
	{{185, 202, 148, 0, 0, 0, 28, 233, 169, 253, 171, 152, 77, 37, 238, 232}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 144}, 178},
	{{185, 202, 148, 0, 205, 221, 71, 98, 242, 124, 82, 1, 119, 136, 248, 96}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 156, 77, 35, 252, 69, 70, 58, 3, 120}, 178},
	{{185, 202, 148, 0, 0, 0, 134, 175, 41, 51, 252, 79, 33, 246, 137, 171}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 17, 240, 76, 25, 232, 237, 84, 86, 225}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 75, 151, 157, 205, 94, 28, 230}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 250, 242, 136, 15, 227}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 60, 13, 184, 171, 99, 162, 208, 229}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 238, 242, 222}, 178},
	{{185, 202, 148, 0, 0, 112, 149, 168, 252, 129, 38, 8, 0, 126, 177, 31}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 98, 2, 53, 30, 114, 112, 165, 167, 234}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 202, 136, 236, 29, 248, 50, 116, 146, 54}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 223}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 63, 169, 156, 73, 255}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 32, 174, 80, 166, 245, 190, 76}, 178},
	{{185, 202, 148, 0, 97, 125, 10, 116, 101, 6, 239, 21, 177, 73, 217, 43}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 116, 1, 64, 79, 255, 133, 32}, 178},
	{{185, 202, 148, 0, 0, 0, 109, 118, 117, 178, 30, 99, 99, 214, 246, 202}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 39, 121, 60, 16, 22, 227, 42}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 107, 49, 127, 113, 153, 255, 63, 222, 128}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189}, 178},
	{{185, 202, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 178},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 65, 215}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 137, 66, 172, 155, 231, 218, 128}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 87, 191, 226, 64, 186, 5, 113, 196}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 78, 184, 8, 126, 189, 207}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 177}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 34, 52, 133, 217, 249, 109, 203}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 197, 61, 218}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 69, 22, 168}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 195, 200, 160, 95, 135, 9}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 123, 62}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 79, 196}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 134, 72}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 159}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 162, 80, 26, 129, 99, 180, 62}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 222, 139, 236, 213}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 81, 26, 36, 194, 251, 235}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 235, 47, 146, 183, 157, 145}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 185, 188, 186, 38, 155, 114, 190, 242}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 235, 123, 220, 179, 171}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 15, 129, 39, 242}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 75, 151, 67, 114, 6, 150, 120, 111}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 43}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 234, 71, 236, 74, 20, 125, 51}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 5, 89, 105}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 26, 173, 191, 23, 44, 50, 108}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 165, 42}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 48, 235}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 41}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 37, 218, 225, 61, 233, 81, 64}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 76, 63, 101}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 5, 130, 252, 179, 1, 24}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 171, 58, 1}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 76, 155, 239, 239, 192, 85, 73, 209}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 128, 60, 235, 145, 247, 94}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 206, 11}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 250, 115, 56, 175, 99, 153}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 147}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 38}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 44, 198, 182, 236, 71}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 152, 124, 198}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 203, 226, 99, 45, 221, 255}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 239, 171, 91, 207}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 82, 92, 66, 46}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 58, 154, 128, 130}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 60, 193, 72, 77}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 155, 174, 43, 31}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 97}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 18, 61}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 77}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 220, 71, 224, 83, 205}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 5, 73, 109}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 74, 170}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 82}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 169, 202, 90}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 65, 124, 182}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 27, 117}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 1, 229, 189, 19, 160}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 29, 141, 243, 142, 84}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 70, 89, 234, 123}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 39}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 244, 196}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 23, 155, 32, 74}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 72, 116, 40}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 141, 244, 42}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 233, 35, 230, 247, 66, 32}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 39, 149, 72, 26, 16}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 137}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 221}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 138, 152, 185, 91}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 51, 11, 170, 214, 49, 172, 111, 12}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 99, 129, 156, 8, 186, 61}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 143, 188, 110, 185, 131, 202, 233}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 87}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 75, 152, 186, 68, 62, 173, 194, 243}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 193, 69, 159, 246}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 178, 17, 167}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 220, 251, 145, 182, 38, 253}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 164}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 89, 254, 16, 203}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 84, 120, 167}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 109, 126}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 162, 206}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 147, 219, 198, 144, 172, 167, 151}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 122, 21, 255, 73, 35}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 0, 0, 0, 28}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 0, 37, 150, 46, 35}, 198},
	{{138, 30, 129, 95, 224, 161, 120, 128, 0, 0, 0, 190, 24, 5, 244, 245}, 198},
	{{69, 181, 5, 227, 64, 0, 84, 18, 169, 215, 176, 29, 238, 109, 76, 141}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 76, 161, 239, 2, 145, 75, 48}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 215, 207, 99, 108, 84}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 140}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 73, 138, 88, 73, 9, 67}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 28, 171, 45, 14, 77, 161}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 129, 204, 33, 198, 107, 105, 240, 44}, 84},
	{{69, 181, 5, 227, 64, 0, 50, 76, 145, 124, 122, 241, 239, 120, 40, 12}, 84},
	{{69, 181, 5, 227, 64, 0, 7, 231, 190, 8, 124, 27, 24, 15, 33, 66}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 238, 99, 171, 54, 225, 204}, 84},
	{{69, 181, 5, 227, 64, 67, 212, 69, 210, 18, 158, 229, 141, 112, 136, 215}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 150, 139, 25, 141}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 48, 70, 165, 6, 7, 239}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 129, 190, 45, 169, 39, 168, 235}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 166, 68, 28}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 216, 88, 212, 225, 108, 75, 217, 241}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 129, 235, 239, 227}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 228, 230, 108, 196, 120, 80, 121, 14}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 154, 91, 64, 246, 0, 59, 173, 80}, 84},
	{{69, 181, 5, 227, 64, 0, 152, 26, 83, 123, 68, 110, 25, 219, 155, 29}, 84},
	{{69, 181, 5, 227, 64, 0, 217, 240, 146, 188, 31, 74, 175, 214, 184, 201}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 42, 100, 220}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 225, 176, 33, 67, 168, 152, 79, 94, 243}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 48, 62, 15, 241}, 84},
	{{69, 181, 5, 227, 64, 0, 149, 0, 67, 20, 19, 29, 215, 222, 106, 64}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 84},
	{{69, 181, 5, 227, 64, 0, 102, 158, 215, 247, 246, 204, 25, 210, 190, 227}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 11, 62, 203}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 75}, 84},
	{{69, 181, 5, 227, 64, 0, 93, 91, 151, 52, 59, 215, 141, 214, 236, 86}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 219, 167, 11, 55, 154, 105}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 198, 107, 129, 13, 175, 66}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{69, 181, 5, 227, 64, 0, 206, 144, 170, 111, 149, 113, 96, 58, 193, 24}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 77, 83, 77, 117, 75, 70}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 148, 226, 151}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 178, 96, 171}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 239, 63, 179}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 20}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 153, 206, 116, 67, 175, 169, 241}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 111, 235, 201, 147, 251, 141, 132, 17, 170}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 115, 156, 98}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 236, 229, 84, 61}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 147}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 160}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 114}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 175, 208, 88, 110, 167}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 161, 89, 99, 214, 164, 87, 9}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 32, 200, 117}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 53, 10, 10, 7, 58, 197, 142, 28}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 152, 26, 176, 170, 223, 114, 136, 45}, 84},
	{{69, 181, 5, 227, 64, 0, 106, 191, 114, 48, 71, 247, 77, 226, 13, 148}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 93, 236, 182, 84, 11, 205, 248}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 4, 172, 105, 160, 110, 9, 96, 62}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 250, 25, 250, 0, 250, 103, 68, 146, 180}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 205}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 55}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 1, 146, 242, 5, 227, 146}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 200, 48, 83, 33, 18, 138, 178, 103}, 84},
	{{69, 181, 5, 227, 64, 199, 158, 55, 153, 59, 186, 214, 185, 66, 118, 99}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 132, 161, 115, 233, 168, 114, 102}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 31, 186, 140, 195, 94, 12, 163, 220}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 230, 70, 230, 119, 66}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 18, 56, 2, 102, 159, 215, 235, 191, 47}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 223}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 231, 90, 155, 199, 48, 58, 139}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 82, 205, 233, 86, 111, 94}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 253, 91, 44, 208}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 154, 134, 43, 146, 70, 31, 228, 88, 122}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 203}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 229, 55, 174}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 196}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 24, 151, 227, 26, 116, 177, 186, 143}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 185, 231, 232, 26}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 204, 77, 218, 124, 26, 99}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 21, 58, 112, 184, 85}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 47, 4, 118, 57, 246}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 84},
	{{69, 181, 5, 227, 64, 0, 0, 0, 0, 0, 106, 112, 196, 144, 11, 68}, 84},
	{{69, 181, 5, 227, 64, 0, 161, 202, 130, 130, 94, 184, 44, 162, 177, 62}, 84},
	{{69, 181, 5, 227, 64, 250, 236, 97, 21, 190, 201, 0, 196, 147, 100, 78}, 84},
	{{69, 181, 5, 227, 64, 73, 157, 130, 109, 97, 111, 171, 50, 197, 73, 187}, 84},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 245, 211, 3, 94}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 217}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 152, 54, 56, 132}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 37, 209, 115, 250}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 199, 75, 8, 43, 165, 189, 81}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 23, 175, 7}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 177, 1, 130, 235, 95, 154}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 131, 50, 43, 19, 248}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 54, 197, 129, 73, 223}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 223, 219, 11, 163, 32}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 226, 19, 144, 111, 149, 249, 241}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 28, 210, 208, 87, 243}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 168, 253, 55}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 156, 241, 93, 201}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 193, 196, 82}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 114, 99, 74, 3, 224, 175}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 15, 205, 231, 64, 153}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 130}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 209, 166, 139, 21, 239, 161}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 119, 130, 62, 242, 129}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 239, 65, 244, 196}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 7, 196, 83, 163, 241, 194}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 160, 248, 15, 242, 24, 106}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 65}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 111, 17}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 114, 45, 221, 16, 198, 192, 11}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 252, 121, 223, 85, 115, 159, 43}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 27, 237, 131}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 223, 168, 219, 129}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 41, 135, 46, 28, 130, 187, 166}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 79, 148}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 121, 110, 56, 246, 167}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 193, 84, 86, 73, 170, 105, 58}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 253, 229, 137, 238, 22}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 158, 120, 114}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 107, 127, 172, 251, 248}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 160, 73, 170, 135, 217}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 7, 251, 191}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 61, 197, 186}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 194, 119, 250, 65, 115, 155}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 130}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 106, 162, 206, 213, 11, 62, 22}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 252, 14, 239, 244, 10}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 27, 45, 179}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 60, 207, 255}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 58, 232}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 43, 47, 206, 156, 229}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 107, 52}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 136}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 226, 33, 99, 16, 47, 13}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 121, 155, 182}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 225, 207, 175, 192}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 78, 205, 36, 43, 25}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 113, 141, 120, 218, 131}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 4}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 229}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 56, 188, 249, 255, 42, 17}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 238, 143, 107, 183, 85, 185, 5}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 206, 155, 86}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 91, 228, 85, 164}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 188, 124, 154, 121, 40}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 50}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 8, 183, 214, 5, 137}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 171}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 83, 81, 212, 165, 196, 139, 185}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 33, 1, 28, 42, 73, 158, 103}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 88}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 237, 126, 229, 88}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 193, 73, 230}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 207, 151, 52, 205}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 160, 248, 107, 109, 94}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 14, 156, 44, 173, 212, 73, 23}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 195, 164, 226}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 25, 66, 153, 99, 189, 88, 196}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 18, 195, 123, 94, 222, 207}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 93, 193, 217, 87, 108}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 36, 12, 40, 129, 187}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 60, 3, 108, 86, 125}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 82, 54, 23}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 227, 153, 243, 70, 147, 230}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 46, 237, 236, 86, 19, 205}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 207, 82, 174, 140, 118}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 153, 217, 146, 186, 157, 243, 225}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 103, 172, 156, 8, 96, 134}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 75, 36, 95, 176, 233, 159}, 128},
	{{90, 180, 0, 164, 227, 75, 174, 119, 128, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 148, 128}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 158}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 187, 223}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 72, 112, 12}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 184}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 138}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 134, 86, 97}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 81, 243}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 139, 112}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 102}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 87, 51}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 87}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 216, 150}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 43}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 136}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 232}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 78, 184}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 192, 92, 91}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 249}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 123, 136, 204}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 92, 110}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 153, 237}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 166}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 2, 9}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 18, 204, 27}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 151, 203}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 52, 117, 175}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 15, 22}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 23}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 77, 235}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 104, 241}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 27}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 142}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 137}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 168, 194, 74}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 63, 215, 249}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 109, 213, 192}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 197}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 113, 164}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 100}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 120}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 177, 251, 254}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 94, 188}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 185, 188}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 94, 190}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 189, 121}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 209, 57, 238}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 243, 116, 39}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 172}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 253, 161}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 134}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 51, 182}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 120, 8, 21}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 21, 29, 85}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 54}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 34, 207, 125}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 57, 181}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 249, 40}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 164, 236, 195}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 168}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 52, 70}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 178, 146}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 2, 61}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 176}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 42, 51}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 209, 242}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 199, 27}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 17}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 167, 198, 42}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 0}, 75},
	{{20, 60, 58, 119, 245, 177, 162, 186, 13, 112, 211, 239, 128, 0, 0, 97}, 75},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 43, 178}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 18, 8}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 165, 67}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 167}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 104, 66}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 237, 50, 84}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 233, 34}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 235}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 226, 84}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 57, 10}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 98}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 44, 156}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 140}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 97, 13, 25}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 254, 173, 200}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 145, 90, 205}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 237, 202}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 84}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 184, 168}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 82, 68}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 2, 250}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 46}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 30}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 192, 254}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 109, 141}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 177, 53}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 129}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 184, 172, 36}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 168}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 93, 35}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 65, 109}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 199}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 235}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 145}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 156, 4}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 82}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 243}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 87}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 210}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 230, 166, 188}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 95, 60}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 242, 44, 207}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 87, 193, 51}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 31}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 84}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 13, 35}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 223, 89}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 184, 227}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 58, 115}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 153, 190}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 116, 180}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 37, 23, 110}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 223}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 99, 68}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 196, 210}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 172}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 71, 251}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 239}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 143}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 2, 136}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 97}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 118, 28}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 29, 82, 189}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 196}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 114, 21}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 222, 160}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 140, 157, 239}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 43, 50, 88}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 122, 232}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 4}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 0}, 192},
	{{158, 124, 157, 25, 230, 139, 51, 212, 76, 109, 236, 210, 48, 0, 0, 246}, 192},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 240}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 237}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 54}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 77}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 44}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 63}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 203}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 169}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 55}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 132}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 155}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 61}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 136}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 39}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 47}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 118}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 158}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 128}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 190}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 220}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 252}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 111}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 2}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 71}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 74}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 234}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 108}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 199}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 13}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 220}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 43}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 166}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 94}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 204}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 132}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 88}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 195}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 89}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 171}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 181}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 170}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 41}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 40}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 26}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 196}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 157}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 0}, 60},
	{{125, 108, 242, 36, 94, 13, 36, 106, 90, 51, 83, 217, 131, 151, 0, 39}, 60},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 200, 184}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 215, 128, 142, 248, 114, 151, 64}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 4, 104, 91, 77, 238, 114}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 87, 85, 60}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 59}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 144, 115, 131, 55}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 109, 20, 128, 84, 164, 163, 136}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 106, 193, 86, 10, 245, 154}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 49, 65, 150}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 29, 1, 33, 211, 52, 193}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 234, 205, 61, 195, 22}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 120, 157}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 10, 0, 102, 191, 136, 79, 43}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 24, 185, 114, 237, 196, 7, 164}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 63, 6, 152, 58, 172}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 19, 93, 204}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 211, 38, 211, 62, 231}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 118, 204, 55, 221, 161}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 176, 212, 61, 188, 185, 6, 47, 238}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 192, 50}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 172, 248, 106, 44, 47}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 178, 61, 51}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 26, 84, 47, 172, 201, 240, 64}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 156}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 158, 66, 179, 220}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 83, 59, 130}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 89, 22, 127, 98, 193}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 202, 92, 221}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 126, 58, 136, 61, 247, 217}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 137, 20, 251, 107, 104}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 159, 187, 186, 215, 23, 206}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 235, 91, 2, 34, 202, 88, 129}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 105}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 225, 44, 56, 198}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 243}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 194, 216, 101, 157}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 215, 209, 213, 228, 7, 207, 91, 137}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 221}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 230, 56, 105, 222, 63, 175}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 123, 74, 150, 106}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 80, 27, 143}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 38, 57, 39, 91, 223}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 27, 145, 221, 252, 11}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 46}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 80, 113, 240, 125, 79}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 155}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 222, 24}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 54, 229, 126, 186}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 185, 78, 188}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 249, 38, 166, 60}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 72, 163, 57, 249, 20, 63}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 98, 48, 70}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 208, 230}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 159, 18, 191, 75, 254, 86}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 61, 84}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 168, 195, 199, 47, 167, 87}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 76, 102, 10}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 8, 48}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 24, 117, 165}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 47, 116}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 78, 230, 193}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 159, 32, 127, 49, 54, 133}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 34, 141, 22, 8, 32}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 100, 160, 244, 158, 16, 73}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 40, 107, 110}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 88, 49, 11, 106, 231, 162, 171}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 20, 228}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 239, 181}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 222, 131, 212, 208, 224, 10}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 11, 232}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 18, 78, 24, 181, 48, 234, 14, 32}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 25, 222, 44, 74, 74, 204, 150, 224}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 27, 218, 16, 63, 226}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 139, 110, 243, 9, 175, 26, 19}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 54, 49, 211, 141, 34, 240, 25}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 242, 107, 136, 217, 62, 242}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 239}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 209, 102, 246}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 73, 34}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 253, 230, 107, 177, 194}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 173, 149}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 195, 232, 193, 77}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 251, 178}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 76, 53, 54, 211, 126}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 0, 0, 93}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 33, 19, 138, 29, 55}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 0, 0, 0, 53, 186, 35}, 169},
	{{222, 218, 162, 158, 15, 53, 191, 178, 0, 0, 71, 133, 222, 142, 232, 9}, 169},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 101, 103}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 250, 137, 94, 71, 115, 155}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 175, 151}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 115, 231, 211, 121}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 149, 8}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 230, 162, 164}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 88, 109, 241, 116, 155, 59, 57}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 128, 205, 150, 39, 41}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 75, 52, 195, 162, 70, 139, 232}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 116, 246, 250, 240, 151}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 251}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 38, 219, 207, 159, 173, 235, 158}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 122, 243, 53, 157, 67, 15}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 174, 53}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 166}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 135, 243, 55}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 124}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 148, 79, 29}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 253, 228, 94}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 30, 148, 190}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 45, 175, 215, 71, 250, 209}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 184, 196, 163, 23}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 150, 246, 130, 104, 208, 3}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 29, 133}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 48, 219, 154, 205}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 164}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 166, 20, 237, 159, 114}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 203, 94, 141, 150, 16}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 209, 95, 74, 253, 212, 115}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 27, 247, 123, 35, 70, 3, 149}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 56, 231, 210, 253, 224, 182}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 132, 113, 181, 101, 46, 150, 241}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 91}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 182, 145, 184}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 50, 198, 237, 124, 106, 117, 107}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 150, 116, 42, 222, 186}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 80, 47, 2}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 177, 38, 2, 56, 177, 83, 156}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 129, 251, 196, 66, 58}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 91, 246}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 10, 184, 238, 235, 253, 214, 78, 103}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 177, 48, 237, 109, 175}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 22, 81, 132}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 84, 109, 89, 134, 249, 33}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 202, 218, 104}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 164, 50, 181, 56}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 121, 8, 174, 120}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 166, 71, 246, 52, 207, 200}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 104}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 3, 6, 74, 10, 83, 244, 32, 94}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 252, 51}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 48, 144, 88, 193}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 241, 173, 168}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 108, 232, 91}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 165}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 216}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 16, 172}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 128, 207, 170, 15}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 57, 101, 101}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 26, 202}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 53, 84, 201, 100, 250}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 178, 155, 138, 14, 232}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 155, 218, 144, 54, 155, 247, 9}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 105}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 236, 217, 28, 171, 127, 233, 147}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 107, 58, 160, 27, 64, 109, 107}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 156, 248, 198, 178}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 200, 161, 109}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 148, 124}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 52, 106, 127, 52, 33, 5}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 100, 198, 197, 171, 163, 59}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 146, 147}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 23}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 80, 131, 205, 153, 229, 132}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 80, 67, 143, 93}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 133, 12, 242, 118}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 9, 38, 222, 180, 51, 137, 146}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 235, 241, 111, 192, 118, 133, 201}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 70, 197, 19, 143, 58, 195, 245}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 42, 123, 202, 107, 32, 103}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 164, 83, 17, 223, 231, 253, 37}, 10},
	{{104, 202, 127, 109, 73, 16, 17, 12, 0, 1, 55, 132, 197, 65, 237, 151}, 10},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 174}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 21}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 222}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 211}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 252}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 28}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 16}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 71}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 233}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 21}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 172}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 69}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 165}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 255}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 80}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 173}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 75}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{172, 171, 246, 26, 176, 34, 22, 152, 246, 56, 173, 120, 105, 60, 92, 0}, 64},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{190, 22, 171, 206, 109, 186, 179, 128, 253, 182, 108, 212, 220, 167, 171, 180}, 182},
	{{119, 208, 0, 0, 0, 0, 0, 158, 105, 122, 160, 140, 166, 229, 40, 225}, 29},
	{{119, 208, 0, 0, 0, 143, 220, 41, 199, 243, 86, 223, 156, 147, 192, 176}, 29},
	{{119, 208, 0, 0, 0, 59, 183, 81, 89, 133, 95, 254, 43, 112, 162, 104}, 29},
	{{119, 208, 121, 112, 157, 133, 186, 141, 214, 221, 24, 221, 164, 226, 164, 161}, 29},
	{{119, 208, 0, 114, 68, 248, 168, 38, 255, 219, 224, 9, 72, 153, 155, 150}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 13, 166, 17, 94, 210, 96, 169, 16, 23}, 29},
	{{119, 208, 0, 86, 98, 82, 55, 65, 157, 201, 195, 60, 195, 107, 155, 219}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 48, 194, 116, 201, 100, 237, 132}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 203}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 8, 120, 89, 53}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 128, 145, 5, 224, 106, 156}, 29},
	{{119, 208, 0, 212, 233, 196, 179, 201, 61, 43, 89, 216, 188, 38, 89, 40}, 29},
	{{119, 208, 0, 0, 227, 73, 128, 153, 131, 144, 77, 199, 228, 92, 89, 122}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 170, 145, 35}, 29},
	{{119, 208, 0, 0, 0, 19, 33, 175, 147, 114, 215, 141, 174, 168, 248, 198}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 140, 35}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 129, 175, 113, 252}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 123}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 116, 86, 52, 244, 238, 217, 252, 177, 180}, 29},
	{{119, 208, 0, 0, 0, 2, 224, 130, 9, 18, 237, 73, 251, 103, 103, 221}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 73, 115, 56}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 55}, 29},
	{{119, 208, 0, 0, 0, 0, 66, 209, 201, 97, 84, 220, 49, 78, 95, 39}, 29},
	{{119, 208, 0, 0, 0, 124, 105, 83, 140, 179, 16, 189, 152, 248, 162, 43}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 88, 118}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 29},
	{{119, 208, 0, 0, 0, 205, 158, 214, 196, 21, 246, 192, 69, 4, 122, 31}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 48, 9, 216, 76, 131, 216}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 22, 242, 208, 11, 53, 247, 13, 200, 198}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 233, 37, 187, 253, 244, 237, 175, 73}, 29},
	{{119, 208, 0, 254, 188, 6, 102, 134, 119, 158, 117, 23, 82, 5, 233, 212}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 5, 246, 231, 142}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 125, 186, 33, 145, 228, 87}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 68, 61, 99, 2, 48, 57, 7, 79, 31}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 238}, 29},
	{{119, 208, 0, 0, 0, 0, 112, 168, 102, 167, 134, 5, 40, 219, 216, 226}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 90, 29, 83}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 146, 10, 21, 93, 105, 153, 245, 94, 99}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{119, 208, 243, 123, 252, 245, 167, 100, 75, 233, 126, 10, 34, 150, 94, 97}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 166, 121, 135, 22, 233, 219, 29, 68, 63}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 82, 34}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 146, 40, 40, 44, 245, 29, 130, 120, 23}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 126, 51}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 45, 119, 16, 181}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 97}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 72, 8, 118}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 218, 119, 103, 35}, 29},
	{{119, 208, 0, 108, 213, 89, 12, 167, 44, 120, 45, 16, 56, 225, 202, 147}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 120, 180, 138, 206, 143, 246, 37, 1}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 221, 198, 48, 161, 65, 33}, 29},
	{{119, 208, 0, 22, 47, 164, 217, 206, 140, 76, 50, 157, 195, 66, 52, 48}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 20, 239, 99, 14, 195, 161, 66, 40}, 29},
	{{119, 208, 0, 0, 196, 90, 178, 9, 235, 179, 66, 195, 238, 54, 72, 225}, 29},
	{{119, 208, 0, 0, 0, 187, 204, 110, 206, 231, 27, 83, 122, 119, 152, 238}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 130, 46, 177, 183, 230, 159}, 29},
	{{119, 208, 0, 0, 0, 72, 155, 226, 141, 98, 112, 37, 253, 208, 20, 49}, 29},
	{{119, 208, 0, 0, 0, 0, 45, 30, 145, 39, 189, 246, 207, 118, 5, 110}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 197, 87, 212, 193, 126, 185, 210, 2}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 66, 9, 100, 183}, 29},
	{{119, 208, 0, 157, 134, 24, 153, 138, 174, 231, 202, 58, 52, 179, 54, 39}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 178, 152, 152}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 192, 45, 175, 106, 114, 230}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 249}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 240, 226, 204, 117}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 104, 154, 23, 195, 110, 49}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 221, 96, 50, 12, 83, 55, 80, 189, 96}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 237, 113}, 29},
	{{119, 208, 0, 0, 0, 0, 115, 114, 99, 53, 237, 205, 8, 198, 245, 128}, 29},
	{{119, 208, 0, 0, 0, 0, 111, 5, 5, 27, 21, 58, 187, 118, 96, 166}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 31, 183, 219, 199, 108, 242, 65, 252}, 29},
	{{119, 208, 0, 0, 0, 0, 209, 140, 138, 63, 199, 198, 83, 185, 2, 215}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 125, 210, 224, 77}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 151, 240, 2}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 137, 202, 87, 60, 207, 68}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 214, 109, 78}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 28, 19, 196, 171, 26, 199, 32, 150, 115}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 99, 144, 196}, 29},
	{{119, 208, 0, 0, 134, 45, 196, 41, 64, 143, 9, 54, 21, 76, 9, 194}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 38, 158, 132, 86, 68, 77, 226}, 29},
	{{119, 208, 0, 0, 0, 0, 30, 123, 25, 55, 248, 192, 222, 88, 206, 246}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 152, 127, 34, 143, 215, 126, 163, 63, 65}, 29},
	{{119, 208, 0, 0, 0, 122, 237, 197, 148, 178, 166, 252, 94, 123, 224, 217}, 29},
	{{119, 208, 0, 124, 126, 33, 252, 183, 141, 97, 222, 69, 88, 68, 15, 109}, 29},
	{{119, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 29},
	{{119, 208, 0, 200, 106, 178, 47, 2, 87, 118, 10, 17, 215, 106, 174, 18}, 29},
	{{119, 208, 0, 0, 0, 0, 194, 84, 13, 201, 89, 42, 118, 3, 78, 22}, 29},
	{{119, 208, 0, 0, 0, 0, 51, 252, 130, 198, 220, 137, 43, 58, 93, 73}, 29},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 92, 43}, 208},
	{{160, 0, 0, 0, 0, 130, 169, 84, 68, 180, 90, 102, 25, 81, 137, 1}, 208},
	{{160, 79, 126, 50, 129, 117, 160, 142, 47, 161, 230, 109, 12, 176, 79, 247}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 249, 193, 88, 73, 198, 132, 155, 27, 236, 74, 101, 153}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 120, 208, 196}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 223, 134, 113, 93, 82, 222, 161, 232}, 208},
	{{160, 0, 0, 0, 0, 0, 232, 17, 4, 93, 27, 236, 102, 150, 109, 177}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 16, 39}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 11, 217}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 40}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 57, 18, 41, 165}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 27, 232, 146, 63, 205, 53, 137}, 208},
	{{160, 0, 0, 0, 0, 0, 202, 157, 37, 34, 187, 97, 4, 95, 72, 112}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 243, 6, 72, 192, 159, 164, 47}, 208},
	{{160, 0, 0, 0, 184, 157, 112, 149, 120, 116, 143, 251, 58, 17, 220, 147}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 254}, 208},
	{{160, 0, 0, 0, 210, 31, 188, 151, 98, 248, 241, 213, 2, 167, 48, 136}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 150, 1, 118, 183, 154, 86, 13}, 208},
	{{160, 0, 199, 84, 187, 58, 165, 41, 127, 254, 235, 165, 89, 125, 168, 65}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 208, 152, 59, 46, 232, 69, 95}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 68, 124, 60, 89, 14, 127, 31}, 208},
	{{160, 0, 0, 0, 0, 0, 107, 53, 29, 139, 126, 64, 209, 202, 21, 2}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 166, 23, 103, 188, 155, 154, 114, 24, 255}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 76, 214}, 208},
	{{160, 0, 0, 0, 0, 0, 25, 74, 29, 173, 219, 18, 80, 60, 15, 227}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 27, 58}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 115, 156, 57, 29, 124, 239, 85, 160}, 208},
	{{160, 0, 0, 0, 152, 10, 147, 71, 245, 58, 161, 15, 22, 195, 144, 50}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 213, 211, 14, 181}, 208},
	{{160, 0, 0, 0, 245, 91, 29, 136, 174, 196, 16, 172, 78, 15, 229, 23}, 208},
	{{160, 0, 0, 0, 0, 101, 145, 9, 3, 46, 100, 177, 182, 122, 45, 180}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 88, 228, 178, 212, 115}, 208},
	{{160, 201, 123, 135, 142, 102, 69, 59, 176, 158, 237, 17, 188, 174, 54, 147}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 161, 254, 247, 69, 131}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 162, 43, 199, 221, 96, 110, 86, 113}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 232, 42, 225, 254, 143, 116, 126, 31}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103}, 208},
	{{160, 0, 0, 45, 11, 243, 208, 128, 180, 12, 5, 202, 14, 74, 161, 125}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 98, 30, 111, 183, 100, 39, 182}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 41}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 59, 164, 42, 2, 147, 11, 92, 176}, 208},
	{{160, 0, 0, 0, 0, 0, 2, 155, 244, 160, 147, 44, 249, 93, 150, 141}, 208},
	{{160, 83, 20, 184, 116, 105, 36, 14, 113, 15, 22, 226, 174, 144, 24, 2}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 14, 50, 222, 54, 202}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 227, 24, 137}, 208},
	{{160, 0, 0, 0, 0, 0, 132, 192, 244, 71, 26, 65, 208, 244, 97, 104}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 208},
	{{160, 0, 0, 0, 0, 0, 248, 233, 152, 29, 179, 96, 79, 36, 121, 173}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 50, 79, 199}, 208},
	{{160, 0, 0, 0, 0, 0, 225, 4, 147, 129, 149, 30, 67, 233, 24, 65}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 244, 246}, 208},
	{{160, 0, 144, 202, 187, 183, 165, 232, 244, 7, 235, 127, 168, 13, 68, 209}, 208},
	{{160, 0, 9, 153, 217, 240, 133, 226, 208, 1, 31, 78, 139, 95, 9, 67}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 54}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 185, 42, 229, 129}, 208},
	{{160, 0, 114, 226, 127, 60, 127, 52, 24, 201, 180, 107, 34, 198, 92, 79}, 208},
	{{160, 0, 0, 0, 47, 246, 179, 120, 192, 58, 146, 52, 243, 174, 184, 22}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 23, 232, 63, 2, 162, 18, 77, 106, 247, 24}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 62, 151}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 206, 230}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 155, 204, 3, 44}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 75, 238, 116, 231, 208, 197, 250}, 208},
	{{160, 216, 191, 31, 31, 144, 175, 19, 183, 32, 159, 90, 186, 77, 115, 180}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 39, 208, 72, 51, 159, 62, 203, 208, 232}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 25, 230, 157, 79, 91, 173, 162}, 208},
	{{160, 0, 0, 0, 0, 47, 4, 113, 4, 226, 135, 162, 0, 195, 251, 154}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 6, 252, 217, 243, 65, 179, 226}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 20, 151, 76, 177, 55, 117, 177, 41, 252}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 183, 184, 59, 41, 235, 111, 187}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 132, 227}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 124, 65, 254, 120, 57, 252, 192, 92}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 56}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 109}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 53, 236, 100, 239, 157, 0, 255, 248, 185}, 208},
	{{160, 0, 201, 32, 78, 23, 76, 139, 35, 134, 220, 152, 148, 121, 14, 118}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 16, 98}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 15, 121, 98, 36, 115, 249, 52}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 235}, 208},
	{{160, 0, 0, 0, 0, 0, 34, 67, 15, 56, 88, 166, 182, 97, 124, 87}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 59, 202}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 168, 45, 81, 0, 219, 112, 148, 45}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 82, 153, 155, 124, 133, 1, 87, 197}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 151, 84, 125, 111, 217, 146, 200}, 208},
	{{160, 0, 0, 0, 130, 7, 138, 84, 250, 132, 250, 139, 107, 122, 168, 121}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 195, 90, 91}, 208},
	{{160, 0, 43, 0, 10, 214, 146, 229, 239, 235, 13, 214, 82, 193, 137, 241}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 87, 29, 64}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 107, 51, 184, 121, 119, 39, 57}, 208},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 124, 241, 106, 89, 190}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 139}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 151, 90, 119, 233, 118, 94, 234, 71}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 148, 208, 50, 67, 203}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 226, 202, 115, 84, 53, 9, 97}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 37, 228, 67, 129, 0, 179}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 103, 149, 210, 233, 24, 68, 185, 2}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 38, 43, 108, 249}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 79, 49, 43, 223, 101, 171, 188}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 128, 120}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 70, 87, 202, 121, 150, 186}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 16, 1, 77, 88, 162, 248, 228, 33, 114}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 223, 140, 1, 93, 150, 29}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 134, 125, 128, 62, 162, 178}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 90, 110}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 111, 52, 133, 6, 111, 68, 0, 145, 34}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 39, 40, 208, 121, 41}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 218, 191, 96, 41, 139, 147, 158}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 166, 245}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 108, 13, 155, 123, 89, 92}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 39, 68, 123, 131, 15}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 108, 142, 13, 178, 127, 39, 122, 7, 242}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 120, 174, 52}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 224, 155, 226, 81, 221, 191, 153}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 159, 30, 129, 195}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 89, 19, 69, 203, 24, 51, 253, 50, 61}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 205, 132, 8, 250, 86, 217, 253, 213}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 187, 157}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 199, 207, 153, 252, 150, 179, 116}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 12, 11, 198, 30, 243}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 63, 204, 145, 123, 82, 83, 222, 112}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 44, 0, 21, 201}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 160, 252, 121, 221, 79, 58, 92, 223, 11}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 32, 88, 1}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 68, 68, 114, 245, 236, 88}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 101, 251, 224, 90, 136, 39, 109}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 69, 51, 6, 66, 206, 49, 82}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 131, 15, 87}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 164, 53, 56, 142, 253}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 116}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 246, 213}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 126, 245, 79, 57, 82, 78, 42}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 167, 23, 51, 128, 176, 149}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 71, 217, 73, 243}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 185, 42, 18, 27, 38, 76, 6, 49}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 225, 166}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 203, 81, 10}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 97, 204, 17, 2, 229, 244, 20, 107}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 119, 114, 48, 75}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 47, 174}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 71, 59, 82, 29, 204}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 16, 145, 61, 242, 114, 22}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 215, 34, 56, 24, 166, 60}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 185, 68, 196, 239}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 160, 148, 207, 64, 230, 15, 22, 106}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 33, 218, 231, 57, 39, 183, 221}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 234, 127, 227, 168, 35}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 76, 247, 5}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 17, 36, 50, 238, 143}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 176, 38}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 241, 78, 111, 117, 71, 5}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 2, 42, 178, 58, 191}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 51, 31, 46, 55, 223, 72, 28, 0}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 65, 176, 240}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 63, 155, 243, 199}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 187, 28, 18, 41, 170, 75, 21, 199, 77}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 145, 242, 15, 11, 159, 178, 95}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 31, 12, 233, 31, 144}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 148, 92, 122, 218, 180, 138, 117, 107, 159}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 46, 14, 13}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 125, 143, 156, 108, 1}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 178, 113}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 231, 75, 142}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 126, 90, 78, 76}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 132, 182, 164, 176, 128, 124, 224, 30}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 77, 78, 1, 229, 186, 242, 158, 92}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 65}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 153, 143, 144}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 177, 43, 100, 2, 246}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 205, 70, 54}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 202, 86, 201, 16, 124, 217, 224, 243}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 232, 49, 127}, 93},
	{{170, 144, 64, 2, 107, 166, 128, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 93},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 121, 209, 66, 83, 240}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 110, 192, 203, 220, 238}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 128, 188, 126, 25, 70, 156}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 233, 167, 200, 142}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 177, 125, 140, 63, 47}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 135, 205, 185, 102}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 241, 122, 18, 252, 56}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 167}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 61, 60, 22, 212}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 50, 182, 1, 163, 101, 214}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 56, 146, 228, 140}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 41, 68, 111}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 42, 155, 212, 39, 169, 195}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 91}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 14, 170, 15}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 124, 44}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 204, 100, 82, 34, 130, 121}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 146, 160, 240}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 171}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 98, 82, 213, 50, 246}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 80, 97, 255, 149, 130}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 68, 81, 216, 110}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 249, 191}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 35, 128, 189}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 187, 216, 126, 40, 27}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 226, 94, 23, 29, 161}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 248, 241, 72}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 113, 250, 248, 228, 65}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 83, 143, 79, 41}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 75, 49, 91, 216}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 242, 189, 175}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 159, 65, 18}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 230}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 125, 125, 244, 139, 98}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 222, 201}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 26, 73, 165, 67, 183}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 241, 135, 22, 172}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 168, 112, 175, 181}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 224, 111, 68}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 10, 29, 134, 15}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 126, 73, 204, 40}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 85, 55, 220, 248, 248, 249}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 11, 133, 3, 216, 41, 133}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 253}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 246, 59}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 65, 87}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 127, 129, 80, 242, 37}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 162, 117, 22, 4}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 41}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 1, 47, 141, 212, 98, 139}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 174, 246, 44, 248, 52}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 226}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 164}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 3, 78}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 3}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 231, 107, 67, 128, 202}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 12}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 1, 225, 246}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 83, 217}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 228, 137, 174, 128}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 99, 40, 177, 171, 155}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 210, 153, 147, 80, 163}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 154, 205, 129, 72, 214}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 189, 77, 164, 152}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 186, 179, 110, 73, 170}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 241, 112, 96}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 203, 142}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 198, 55, 186, 229, 114}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 39}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 117, 126, 13, 22}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 119, 80, 33}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 189}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 24, 145}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 178, 170, 92}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 244, 60, 72, 174, 28, 231}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 0}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 176, 188, 156, 232, 161}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 49, 102}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 89, 190}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 201, 141}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 75}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 0, 51}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 219, 213, 105, 48}, 228},
	{{234, 9, 96, 20, 156, 157, 1, 34, 88, 0, 0, 0, 0, 0, 161, 56}, 228},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 137, 58, 7, 95, 53, 65, 171}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 123, 208, 14, 151, 10, 128}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 165}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 197, 14, 48, 190, 11, 231}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 252, 197, 165, 174}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 187, 43, 76, 237, 167, 208, 97, 163, 197}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 47, 124, 167, 173, 122}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 211, 144, 183, 203, 240}, 236},
	{{147, 237, 16, 120, 192, 83, 8, 213, 183, 115, 58, 188, 208, 89, 29, 74}, 236},
	{{147, 237, 16, 120, 192, 0, 161, 82, 50, 122, 13, 231, 236, 66, 165, 134}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 125, 24, 134, 24, 210, 172, 110, 63, 53}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 250, 89, 34, 1, 210, 42, 138, 229}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 75, 190, 40}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 225, 233, 109, 118, 133}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 219}, 236},
	{{147, 237, 16, 120, 192, 0, 240, 151, 205, 226, 249, 243, 84, 20, 192, 90}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 45, 71, 52, 225}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 235, 223, 144, 240, 143, 89, 34, 228}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 254, 13, 31, 144, 37, 238, 222, 68, 85}, 236},
	{{147, 237, 16, 120, 192, 0, 95, 128, 92, 78, 238, 97, 123, 14, 182, 18}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 56, 252, 161, 245}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 216, 90, 124}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 36, 158, 43, 160, 0, 132, 119}, 236},
	{{147, 237, 16, 120, 192, 0, 164, 199, 194, 159, 163, 75, 176, 193, 47, 0}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 139, 164, 191}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 222}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{147, 237, 16, 120, 192, 0, 105, 125, 203, 33, 244, 146, 250, 72, 255, 35}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 105, 114, 120, 107, 75}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{147, 237, 16, 120, 192, 0, 147, 50, 142, 209, 34, 56, 34, 216, 195, 84}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 208, 13, 138, 111, 88, 95, 47, 132}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 65, 212, 150, 140, 130, 100, 110, 254}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132}, 236},
	{{147, 237, 16, 120, 192, 0, 74, 127, 195, 4, 64, 192, 76, 14, 116, 71}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 176, 240, 119}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 20, 142, 54, 54, 24, 99, 12, 233}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 12, 173, 40, 201, 74, 106}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 163, 199, 2, 236, 194, 179}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 178}, 236},
	{{147, 237, 16, 120, 192, 0, 27, 12, 26, 132, 160, 45, 97, 88, 227, 26}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 245, 218, 37}, 236},
	{{147, 237, 16, 120, 192, 0, 199, 233, 73, 203, 20, 173, 195, 52, 243, 65}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 116}, 236},
	{{147, 237, 16, 120, 192, 0, 138, 70, 49, 241, 184, 65, 174, 87, 217, 47}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 236},
	{{147, 237, 16, 120, 192, 0, 154, 225, 103, 53, 21, 24, 186, 36, 93, 218}, 236},
	{{147, 237, 16, 120, 192, 0, 22, 73, 202, 216, 47, 240, 125, 55, 233, 77}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 162, 34, 95, 126, 213}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 73}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 85, 11, 135, 70, 184, 39}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 17, 9, 157, 106, 5, 239}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 238}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 150, 41, 154, 156, 155, 185, 174, 87, 18}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 174, 53, 55, 86, 207}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 86}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 188, 141, 158, 117, 110, 202, 83}, 236},
	{{147, 237, 16, 120, 192, 0, 194, 120, 66, 58, 230, 37, 214, 171, 152, 128}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 240, 110, 136, 214, 121, 225}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 133, 27, 64, 172, 176, 110}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 54}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 187}, 236},
	{{147, 237, 16, 120, 192, 0, 208, 120, 102, 215, 127, 21, 255, 196, 240, 113}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 108, 253, 248, 4, 207, 178, 127, 233, 214}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 84, 247, 44, 108, 75}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 129, 174, 129, 219, 0, 65, 249, 53, 52}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 123}, 236},
	{{147, 237, 16, 120, 192, 0, 158, 165, 190, 238, 50, 3, 12, 14, 38, 17}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 110, 182, 112, 237, 47, 141, 125, 180}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 244, 132, 68, 154, 219, 252, 58, 49}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 36, 105, 121, 12, 101, 214}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 30, 125, 248, 214, 88, 147}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 169, 176, 191, 208, 89}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 236},
	{{147, 237, 16, 120, 192, 21, 223, 85, 223, 47, 94, 24, 130, 245, 196, 140}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 0, 9, 152, 219, 245}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 6, 243, 202, 225, 41, 54, 24, 148}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 162, 152, 226, 8, 55, 175}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 0, 136, 205, 28, 202, 18}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 0, 253, 39, 209, 20, 177, 253}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 248, 162, 244, 66, 57, 211, 198, 230}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 0, 198, 36, 5, 210, 168, 73, 248}, 236},
	{{147, 237, 16, 120, 192, 0, 0, 0, 128, 3, 98, 90, 247, 164, 144, 220}, 236},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 48, 215, 239, 34, 200}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 60, 211, 86, 104, 130, 166, 171, 156}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 134, 252, 243, 111}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 165, 132, 74, 87, 218, 180}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 187, 92, 54, 13, 141, 43}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 45, 155, 49, 116}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 201, 172, 251, 203, 245, 212, 247}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 26, 72, 102, 115, 243}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 152, 234, 196, 155, 228, 53, 227}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 53, 236, 65}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 201, 121, 195, 78}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 40, 51}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 163, 51}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 108, 100, 239}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 89, 53, 46, 253, 105, 254, 214, 238}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 192, 158, 79, 185, 207}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 249, 235, 221, 20}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 230, 94, 142}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 132, 158, 210, 231, 10}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 255, 235, 175}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 120, 158, 188, 136, 228, 207}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 85, 54, 100, 199}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 54}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 250, 131, 5, 120, 167, 94}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 139, 226, 42}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 223, 77, 61, 174, 71, 111, 32}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 235, 141, 209, 102}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 19, 50}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 246, 19, 199, 236}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 190, 31, 122, 132, 129, 209}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 159, 167, 33, 200, 129}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 215, 176, 35, 28, 196, 38}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 222, 95, 127, 62, 143, 37}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 68, 28, 22}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 252, 130, 239, 130, 74, 135}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 190, 32}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 117, 179, 208}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 174, 135, 99, 192, 78}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 229, 136, 99, 217, 137}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 246, 125, 238, 112, 143, 145, 226, 222}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 215, 46, 176}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 145, 203, 113, 168, 121, 178, 113, 228}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 72, 128}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 233, 70}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 198, 152}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 198, 141, 141, 69}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 35, 70, 45, 168, 244}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 95, 251, 116, 247, 135, 200, 226}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 164, 62}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 247, 56, 11, 106}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 10, 88, 115, 76, 212}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 120, 206, 44, 97}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 61, 74, 149, 9, 212, 146}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 41, 144, 106}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 114, 204, 144, 122, 181}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 18, 73, 83, 212, 101, 72}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 216, 217, 90, 76, 115, 68, 255}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 122, 111, 224, 133, 76, 127}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 104, 92, 207, 52, 169, 103}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 189}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 181, 46, 238, 26}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 240, 102, 47, 66, 79, 167, 111}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 100, 83, 155, 234}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 119, 173, 239, 252}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 139, 175, 101, 170, 115}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 108, 246, 170, 97}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 111, 131, 114, 87, 21}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 46, 127}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 119, 130, 134, 223, 18}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 57, 37, 132, 189, 135, 248, 200}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 49, 190, 110, 239}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 2, 29}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 83, 44, 253, 151, 30, 139, 108, 60}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 159, 81, 251, 165, 74, 134}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 81, 169, 110, 36, 245, 67, 43, 34}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 50, 7, 165, 205}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 183, 226, 47, 105, 171, 140, 250}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 18, 33, 103, 63}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 28, 65}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 206, 134, 177, 250, 11, 151}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 99, 254, 63}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 157, 39, 93, 252, 174, 87, 130}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 50}, 190},
	{{182, 189, 162, 158, 223, 90, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 190},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 254, 88, 211, 176, 81, 216, 132}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 139, 180, 65, 182, 56}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 232, 63}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 249, 77, 255, 182, 227, 243, 10, 41, 32}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 178, 204, 178}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 173, 108, 43, 209, 160}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 11, 66, 194, 245, 177}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 170, 116, 79, 53, 239}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 99, 204, 206, 10, 235, 104, 71, 168}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 44, 98, 47, 230}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 36, 28, 137, 176, 225, 201}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 249, 127, 126, 183}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 54, 189, 2, 77, 172, 139, 135}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 71, 51, 225, 94, 67, 235, 177, 69, 15}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 255, 233, 221, 34, 235}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 130, 40, 240, 158, 227, 162, 45}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 183, 216, 85, 94, 93, 86, 173}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 199, 252, 130, 196, 124, 27, 227, 186}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 71, 145, 156, 187, 121}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 123, 151, 200, 2, 48, 203}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 201, 192, 49}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 140, 125, 101, 80}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 195, 162, 60, 64}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 169, 118, 167, 114, 176, 0, 20, 87, 251}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 118, 243, 23, 211, 251}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 35, 242, 191, 123, 109, 206, 113, 172}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 13, 168, 171}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 37, 186}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 190, 131, 87, 229, 97, 47, 45, 181}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 79, 63, 34, 25, 167, 203}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 243, 238, 211, 94, 128, 18, 140}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 175, 228}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 149, 156, 24, 135, 71, 100, 238, 19}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 233, 172, 175}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 84, 232, 145, 248, 158}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 62, 83, 234}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 199, 170, 76, 117, 70, 93, 231}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 247, 203, 76}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 202, 23, 85}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 76, 206, 232, 30, 136, 37, 189, 236}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 211}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 193, 146}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 212, 172, 5, 165, 177, 185, 182}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 139, 147, 12}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 154, 63, 86, 59}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 222, 10, 150, 147, 73, 189, 113, 230, 130}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 207, 220, 7, 90, 98, 38, 86, 148}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 145, 64, 252, 25}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 142, 242, 53, 90, 189, 126}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 44, 152, 79}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 108, 72}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 49, 102, 199, 192, 25, 111, 122, 97}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 75, 107, 249, 159, 108, 125, 225}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 44, 153, 26, 203, 128, 40, 184}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 102, 226, 239, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 182, 157, 41, 70}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 128, 208, 10}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 26, 200, 43, 215, 19}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 9}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 119, 192, 212, 99, 225}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 34, 26, 97, 193, 146, 221}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 52, 34, 170, 45, 175, 43, 6}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 116, 80, 18, 28}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 202, 230, 126, 201}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 39, 121, 192, 54, 120, 248, 66}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 139, 17, 102, 243, 236, 49}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 99, 155, 141, 70, 217, 255}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 77, 49, 246, 83, 32, 243, 234}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 111, 108}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 25, 76, 183, 82, 36, 228, 5, 137}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 52, 240, 168, 174}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 39, 50, 193, 214}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 193, 82, 144, 106, 123, 244, 4}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 60, 17}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 242, 193, 29, 250, 202}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 11, 161, 196, 123, 28, 133, 85}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 84, 24, 54, 126, 101, 131, 3, 243}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 84, 79, 190, 178}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 112, 87, 143, 93, 151, 57, 143, 22, 250}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 137, 129, 128, 61, 73, 4, 82, 208}, 217},
	{{116, 148, 142, 240, 10, 253, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 172, 65, 238}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 120, 56, 10}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 112}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 135, 236, 254}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 240, 66, 119}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 231, 128, 220}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 90, 132, 57}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 90, 207}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 12}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 19}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 96, 41}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 15, 49, 137, 141}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 179, 103, 207, 16}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 244, 83}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 235, 56, 64}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 210}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 226}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 226, 221}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 208, 97, 186, 98}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 230, 144}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 105, 226}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 41, 181, 80, 10}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 160, 189, 26}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 70, 132}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 137, 12}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 246, 158, 89, 178}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 236, 157}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 129}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 97, 143, 121}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 80, 50}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 185, 89, 47, 112}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 78, 127, 103}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 121, 182, 148, 159}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 169}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 88, 90, 233}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 91, 124, 27}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 254}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 240, 13}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 24, 53}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 140, 218, 58}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 107}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 164}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 56, 50, 229}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 81, 184, 225}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 94, 50}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 246, 41, 227}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 142}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 220, 62, 156}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 225, 133}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 174}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 70}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 89}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 73, 64, 98}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 172, 71, 54}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 87, 209, 63}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 232, 141, 1, 32}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 172, 107, 216}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 18}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 22}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 47, 203}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 75, 182}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 232, 64, 146}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 112}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 75}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 46, 204, 32}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 149, 175}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 183}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 160, 147}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 191, 52}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 80, 22}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 214, 59, 145}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 131, 103, 141}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 63}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 23, 251}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 0}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 0, 242}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 0, 167, 9}, 74},
	{{211, 73, 140, 69, 252, 27, 75, 46, 37, 6, 147, 32, 0, 136, 226, 195}, 74},
	{{148, 61, 120, 49, 220, 65, 150, 0, 179, 103, 94, 84, 242, 232, 115, 152}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 185, 119, 169, 120, 155, 158}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 39, 213}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 27, 236, 229, 84, 209, 188}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 197, 211, 222, 218, 27, 221}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 214, 231, 60, 9, 149}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 17, 138, 50, 148, 138}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 179, 84, 212, 2}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 137, 160, 229, 247, 165}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 28, 222, 186, 201}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 39, 196, 92, 139, 90}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 215, 82, 31, 121}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 95, 84}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 124, 0, 200, 92, 177, 129, 92}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 225, 47}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 103, 19, 194, 211, 48, 137, 11, 223}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 75, 143, 147, 28, 87, 200}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 207, 22, 67, 46}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 17, 244, 170, 71, 31, 127, 227}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 218}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 164, 3, 104}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 139, 41, 123, 124}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 234, 165, 235}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 245, 123, 159, 205, 150, 123, 111, 170}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 188, 112, 148, 123, 253}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 86, 205, 158, 135}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 23, 94, 27}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 187, 247, 50, 162, 175, 48}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 105, 93, 144}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 5, 134, 87, 79, 112}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 231, 22, 196, 4, 86, 173}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 97, 168, 89, 42}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 242, 55, 222}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 108, 250, 158, 200, 178}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 218, 224, 8}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 9, 247}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 24, 65, 172, 49, 52, 127, 35}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 183, 240, 145, 228, 56}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 233, 224}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 20, 164, 153, 72, 45}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 156, 226, 131}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 38, 58, 220, 182}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 79, 253}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 198, 55}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 158, 166, 147, 153}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 50, 96, 228, 38, 97}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 207, 91, 189, 178, 39, 2, 63}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 8, 142, 205, 195, 49}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 128, 29, 132, 68, 155, 71}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 215, 26, 147}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 211, 228, 119}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 47, 135}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 92, 124, 68, 135, 47}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 121, 0, 191, 43}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 42, 117}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 209, 173, 225, 80}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 131, 101, 189, 79}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 196, 236, 106, 200, 195, 232, 169, 95}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 197, 85, 97, 2, 124}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 26, 112, 88, 202, 181, 235, 6}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 197, 103, 125, 61, 162, 3}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 152, 131, 106, 135, 154, 241, 28}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 5, 70}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 18, 254, 0, 73, 122, 141, 20}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 127, 238, 55}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 168, 200, 249, 71, 10}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 90, 176, 223, 198, 183, 172, 203}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 182, 78, 144, 40, 45}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 96, 143, 71, 14, 233}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 123, 69, 17}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 231, 247, 156}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 222, 203, 120, 205}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 9, 94, 220, 23, 114, 214, 37}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 162, 5, 226}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 1, 33, 144, 34, 169, 44, 42}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 157, 77, 67, 116}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 94, 84, 43, 128, 55}, 180},
	{{148, 61, 120, 49, 220, 65, 150, 0, 0, 0, 0, 155, 11, 80, 121, 204}, 180},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 58, 182, 192, 245, 38, 226, 93, 65}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 189, 202, 250}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 20, 229, 125, 168}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 24, 203, 219, 175, 170, 4}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 174, 93, 246, 164, 47, 40, 199, 210}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 147, 5, 237, 132, 44, 251}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 23, 42, 240, 135, 8, 159}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 103, 232, 238, 29, 213}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 79, 251}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 4, 192, 102, 121, 13, 23, 167, 142}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 221, 127, 73, 97, 122, 250}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 39, 10, 250, 246, 197, 24}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 132, 151, 181, 234, 53, 60, 206, 161}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 102, 247, 31, 60, 237}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 186, 157, 149, 50, 42, 89}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 50, 82, 101, 1, 254}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 213, 37, 120, 154, 134, 129, 179, 122}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 183, 42, 72, 210, 121, 102}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 97, 175, 64, 203, 218}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 111, 47, 145, 103, 42, 100}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 195, 41, 10}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 244, 162, 48}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 218, 44, 202, 148, 139, 212}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 121, 12, 223, 229, 214, 238}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 116, 113, 122}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 119, 85, 1, 183}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 238, 61, 96}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 139, 132, 239, 122, 114, 52, 85, 94}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 125, 194, 67, 172, 66, 246}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 23, 13, 143}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 149, 20, 68}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 194, 41, 229, 46}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 67, 216, 66, 64}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 232, 66, 15, 152, 201, 139}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 123, 228, 36, 182, 26, 152}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 169}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 78, 43, 174, 252, 135, 244, 70, 86}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 176, 68}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 254}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 74, 148, 160, 236, 230}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 60, 244, 28, 67, 138, 169, 30, 210}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 194, 69, 158}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 41, 194, 189, 19, 65, 236}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 223, 153, 190, 222, 15, 10, 157, 56}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 193, 47, 58, 100, 5, 86}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 86, 228, 70}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 208, 11, 238, 50, 134}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 197, 193, 89}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 98, 46, 99, 192, 253, 185}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 98, 95, 124, 222, 227, 145, 92, 190}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 115, 44, 147, 152}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 82, 208, 99, 229, 66, 249, 220}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 58, 57}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 50, 68}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 189, 64, 95, 147, 177, 70, 18, 100}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 184}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 104, 133, 172, 129, 53, 242, 230, 33}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 116, 245, 145}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 234, 90, 241, 211, 16, 48, 84}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 88, 199}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 189}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 166, 148, 147, 18}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 204, 34, 223, 5}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 193, 195}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 46, 27, 156, 183, 42, 185, 100, 135}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 169, 50}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 30, 2, 100, 100, 83, 91, 227}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 255, 151, 122, 69, 34}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 190, 30, 198, 217, 222}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 254, 60, 55}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 204, 223, 140, 36, 219, 252}, 91},
	{{172, 35, 202, 180, 129, 75, 240, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 91},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 92, 96, 184, 60, 103, 21, 130}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 75, 12, 172, 236, 87, 242}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 61, 134, 230}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 17, 141, 27}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 115, 5, 13, 31, 147, 158, 124, 158}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 158, 245, 98, 97, 198, 41, 53, 135, 70}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 161, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 7, 193, 112, 187, 123}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 96, 37, 157, 36, 242, 25, 82}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 121, 97}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 124, 228, 117, 90, 83, 134, 35, 44}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 232, 166, 19}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 197, 140, 50}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 14, 176, 252, 70}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 103, 186, 232}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 10, 98, 5, 87}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 94, 50}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 171}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 130, 5, 236, 254}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 75, 62, 173, 46, 234, 50, 144, 14}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 111, 164, 218, 61, 96, 128, 87, 147, 130}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 141, 79, 59, 243, 3, 55, 201}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 212, 194}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 239, 210}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 231, 233, 115, 144, 160, 182}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 240, 205, 165, 144, 235, 187}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 53}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 129, 227, 17, 159, 27}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 27, 111}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 125, 178, 26, 12, 160}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 176, 227, 210}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 176, 189}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 190, 248, 55, 146, 145, 39, 118}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 69, 50}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 164, 219, 47, 147, 114, 16, 162, 81, 2}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 204, 201, 252, 221, 174, 110, 162, 214}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 35}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 189}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 115, 24, 209, 22, 23, 165, 246}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 73, 193, 37, 243, 46}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 195, 150, 15, 137, 27, 10, 171}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 184, 218, 24}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 69}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 73, 158, 81}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 227, 252}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 97, 133, 54, 72, 241, 132, 60, 239}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 131, 131, 124, 242, 175, 55, 149}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 244, 49, 59, 54, 2, 241}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 86, 54, 31, 69, 134, 188, 154, 143}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 218, 99, 144, 211, 182, 253, 121, 21}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 222, 96, 139, 232, 67, 33, 137, 206}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 4, 129, 226, 243, 13, 165, 138}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 194, 125}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 49, 12, 59, 10, 6, 107, 165, 88}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 217, 51, 43, 235, 196}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 71, 34, 48, 253, 61}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 60, 193}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 191, 167, 130, 136, 191, 207}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 5, 54, 176, 213, 175}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 182, 117}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 132, 158, 149, 167, 35}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 149, 244, 78, 163, 239, 232, 11}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 227, 145, 186, 198, 175, 68, 184, 171, 101}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 39, 48}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 238}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 154, 119, 125, 200, 63, 250}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 237, 18, 251, 101}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 102, 131, 2, 180, 104, 31, 190}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 176, 31, 236}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 177, 128, 11, 238}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 54, 133, 136, 12}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 227, 221, 248, 209, 74, 90, 17, 224}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 167, 236, 233, 93, 166, 190}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 231, 106, 212, 61, 238, 239, 130, 20, 253}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 45, 176}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 27, 201, 228, 84, 25, 143, 162}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 37, 110, 253, 79, 229}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 214, 96, 248, 11}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 151}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 198, 106, 240, 24, 185, 150}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 39, 79, 29, 133}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 169, 66, 35, 36, 127, 73, 5}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 254, 227, 179, 158, 134, 156, 200, 164}, 230},
	{{215, 109, 147, 157, 32, 28, 52, 0, 0, 0, 0, 109, 23, 56, 65, 7}, 230},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 92, 221, 48}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 172, 95, 211, 139, 133, 223, 213, 27}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 189, 192, 244}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 181, 72, 125, 69, 245}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 192, 80, 129, 109}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 134, 109, 220, 63, 238, 168, 214}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 86, 9, 157, 46, 251, 208, 118, 133}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 205, 169, 42, 61, 24, 55, 133, 60, 8}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 88, 215, 201, 167, 15, 36, 196}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 123, 150, 46, 205, 42, 20, 49, 230, 86}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 88, 48, 165, 79, 62}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 207, 168, 177, 246, 203, 55, 215, 244, 64}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 138, 217, 99, 246, 211, 45}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 125, 244, 166, 226}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 73, 163, 47}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 233, 21, 13, 228, 17, 23, 21}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 233, 16, 26, 2, 133, 104}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 208, 22, 19, 242, 37, 57, 21, 35, 147}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 118, 162}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 45, 115, 41, 142}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 51, 198, 157, 126}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 80, 126, 33}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 62, 94, 54, 56, 194, 117, 103, 102, 1}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 234, 87, 206, 192, 41}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 122, 20, 195, 94, 132, 59, 61, 105}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 8, 155}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 238, 68}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 218, 167, 96, 30, 179}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 162, 83, 131}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 23, 217, 6, 214}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 149, 11, 253, 244, 26, 88, 24}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 201, 85, 51}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 239, 116, 242}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 158, 39, 229, 136, 196, 252, 99}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 98, 213, 137}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 252, 93, 218, 141, 41, 26, 118}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 212, 100, 194, 182, 112, 167, 243, 176}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 50, 195, 46, 60, 19}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 243, 135, 103, 25, 119, 199, 22, 16, 5}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 77, 71, 66, 35, 71, 29, 55}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 9, 182, 142, 137, 17, 234, 40, 63, 171}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 162, 58, 220}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 145, 188}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 222, 156, 55, 101, 239, 173}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 92, 153}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 241, 196, 125, 202, 237, 133}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 254, 101, 176}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 140, 37, 36, 25, 67, 75, 213, 130, 184}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 187, 241, 252}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 178, 141, 209}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 22, 155}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 149, 109, 125, 22, 195, 36, 128, 138}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 222, 224, 120, 15, 201, 247, 113, 190, 5}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 216, 190, 36, 217, 136, 209, 67, 149}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 33, 233, 172, 206, 6, 129, 46, 40, 159}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 82, 168, 4, 241, 225, 125, 59, 71, 247}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 158, 201, 112, 178, 174, 65}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 204, 209, 202, 113, 84, 34, 177, 87, 68}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 143, 100, 255, 54}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 10, 144}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 225, 126, 134, 237}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 158, 48, 207, 214, 45}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 131, 211, 31, 159, 60, 197, 194, 94}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 42, 200, 37}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 239, 129, 168, 42}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 187, 246, 90, 140, 225, 163, 137, 213, 165}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 88, 122, 252, 245, 186, 79, 194, 159, 42}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 104, 182, 110, 132, 183, 21, 212, 178}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 172, 173, 129, 62}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 88, 128, 36, 188, 131, 8, 137, 185, 173}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 224, 214, 126, 14, 3, 24}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 224, 228, 131}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 214, 44, 195, 196, 155, 108, 164}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 73, 82, 234, 76, 119}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 15, 55, 200, 3, 175, 79, 13, 13}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 1, 63, 173, 127, 99}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 193, 100, 173, 235}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 168, 50, 59, 51, 92, 35, 252}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 99, 97, 121, 88, 146, 96}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 124, 226, 185, 23, 119, 54, 55, 160}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 28, 239, 166, 33}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 234, 251, 20, 74, 136, 46, 81, 220}, 175},
	{{151, 26, 182, 112, 205, 220, 160, 0, 0, 0, 0, 0, 0, 0, 0, 139}, 175},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 153, 207, 12, 146}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 18, 104}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 235, 102, 129, 137, 17}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 212, 124}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 125, 160, 2}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 94, 89, 18, 41, 89}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 98, 67}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 82, 26}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 240, 14, 92, 182}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 207, 57, 79}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 94, 202, 189, 33, 49, 190}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 115, 227, 163, 203, 83, 160}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 116, 60, 6}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 153, 160, 109}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 247, 114, 92, 119, 226}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 65, 64, 7, 138, 180}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 201}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 186}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 190, 116}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 213}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 50, 32, 39, 107, 135}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 166, 43, 190, 83, 49, 126}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 140, 134, 247, 12, 156, 201}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 2, 45}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 21, 39, 180, 64, 33}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 173}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 144}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 61, 187, 186, 136}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 203, 99, 48}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 102}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 153}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 7, 52, 160, 49, 67}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 124, 138, 8, 197}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 16}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 47, 13, 171, 33, 144, 86}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 117, 226, 130, 105, 193, 155}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 19, 142, 41, 143, 209}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 15}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 217, 156, 143}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 135}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 228, 5, 167}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 115, 103, 230, 239}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 79, 79}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 232, 205, 239, 243, 186}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 109, 130, 125, 176}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 231, 243, 151}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 50}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 238, 150, 146, 178, 109}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 34, 178, 212, 79, 238, 74}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 244, 228, 247, 190}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 124}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 45, 211}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 15}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 219, 181}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 223, 51, 179, 77, 19}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 172}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 170, 8, 77}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 172, 122}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 124}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 244, 72, 136}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 45, 177}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 196, 58, 246, 104, 62, 90}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 237, 188, 77}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 33, 197, 130, 225, 77, 238}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 25, 141, 102}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 172, 222, 92}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 187, 136, 148, 68, 115}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 243, 4}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 80, 114}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 147}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 103, 122, 66, 49}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 254, 102, 113}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 42, 111, 14, 80}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 120, 24, 67, 139}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 8, 7, 225, 154, 134}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 222, 53, 241}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 223}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 3, 64, 64, 162, 73, 130}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 33, 143, 65, 239}, 171},
	{{73, 91, 93, 61, 196, 3, 66, 26, 149, 96, 0, 0, 0, 0, 0, 0}, 171},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{203, 163, 52, 247, 28, 119, 56, 223, 138, 70, 174, 97, 77, 59, 46, 0}, 202},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 58, 113, 235, 3, 1, 20}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 230, 66, 58, 72, 117, 133}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 38, 231, 38}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 208, 61, 120, 9, 20, 149, 214, 143}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 245, 51, 4, 92, 117, 11, 21, 189, 219}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 173, 6, 141, 222, 77, 188}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 8, 162, 52, 197, 9, 174, 70, 195, 126}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 152, 116, 69, 162, 113, 54, 129, 85}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 180, 180, 25, 99}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 150, 105, 249, 237}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 115, 213, 17, 46, 77}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 136, 97, 162, 196, 96}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 141, 17, 201, 175, 55}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 134, 69, 198, 191, 188, 90, 96, 208}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 41, 52, 198, 188}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 207, 65, 73, 191, 117, 160, 221, 45}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 254, 75}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 72, 124, 170, 203, 114}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 33, 192, 76, 64, 83, 170, 52, 13}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 171, 127, 127, 177, 32, 107, 153, 97, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 48, 124, 244, 87, 27, 169}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 175, 38, 248}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 27, 207, 229, 165, 28, 100, 75, 181, 253}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 91, 93, 215, 160, 42, 190, 131, 161, 144}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 65, 71, 120, 215, 160, 71, 116, 163, 246}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 136, 195, 87, 51}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 189, 8}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 104, 169, 196, 33, 94}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 26, 158, 21}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 169, 60, 68}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 103, 123, 90}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 113, 115}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 223, 29, 163, 177, 32}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 29, 217, 185, 148, 105, 156, 81, 48}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 100, 82, 68, 138, 112, 102}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 226, 147, 71, 191, 199, 189, 224, 97}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 92, 31, 139, 146, 7, 255}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 74, 123, 58}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 254, 119, 102, 213, 65, 71}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 166, 7, 211}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 97, 170, 178}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 95, 43, 198, 146}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 174, 99, 189, 20, 68, 134, 203}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 88, 178, 190}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 72, 0, 172, 143}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 192, 245, 12, 19, 119, 91, 14, 112, 167}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 250, 195, 209, 230, 71, 116, 76, 89}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 47, 186, 88, 33, 105, 102}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 154, 53}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 26, 177, 233, 191, 56}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 17, 13, 173, 36, 61}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 29, 94}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 243, 9, 111, 6, 20, 115, 146, 112}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 37, 47, 206}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 199, 204, 218, 119, 51}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 77, 4}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 211, 134, 13, 107, 126, 242, 82}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 153, 95, 187, 173, 210}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 57, 48, 7, 185, 49, 199, 225, 21, 223}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 120, 6, 12, 213, 7, 67, 12, 32}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 238, 24, 55, 220, 6, 122, 239, 200}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 16, 111}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 189, 137, 252, 71, 35, 50}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 23, 209, 59, 38, 143, 201}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 175, 252, 17, 14, 27, 100}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 72, 211}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 65, 108, 214, 205, 206}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 150, 191, 9, 50, 124, 5, 251, 175}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 49, 164, 99, 111, 18}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 113, 40, 76, 212, 195}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 169, 249, 114}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 180, 247, 82, 233, 184, 200}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 177, 105, 93, 36, 29, 166, 4, 138, 224}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 130, 86, 140, 20, 53}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 148, 172, 165, 93, 159, 205}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 0, 0, 253, 239, 196, 248}, 113},
	{{251, 50, 228, 178, 202, 195, 0, 0, 0, 0, 165, 182, 77, 135, 135, 192}, 113},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 252}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 184}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 36, 153}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 242, 60}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 133}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 153, 245}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 159, 47, 191}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 74, 173}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 242, 238, 60}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 222, 221}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 211, 161, 8}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 255}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 224}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 203, 164, 149}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 223, 214, 47}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 132, 111}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 40, 232, 198}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 183, 4, 116}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 107}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 79, 175}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 25, 12}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 129, 24}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 118, 68}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 94, 81}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 178}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 149, 99}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 229}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 231, 156, 156}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 67, 100, 197}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 116, 108, 105}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 29}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 6, 182}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 168, 229, 41}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 220, 239, 138}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 154, 161}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 255}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 28, 187}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 154}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 97, 38}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 124, 222}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 138}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 58, 12, 111}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 109}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 114}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 147, 72, 191}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 29, 17, 166}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 179, 129}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 133}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 182}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 191, 203, 83}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 169, 25, 226}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 120, 156}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 14}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 200, 148, 187}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 237, 29, 135}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 236, 44}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 210, 201, 213}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 154, 189}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 2, 21, 38}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 3, 28}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 59, 159, 7}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 47, 211, 166}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 12, 239, 88}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 176, 231, 41}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 70}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 117, 250, 85}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 0}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 130}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 85, 11}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 13}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 248, 45}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 157, 219}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 109}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 0, 154}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 234, 77}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 39, 2, 144}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 68, 16}, 187},
	{{217, 159, 164, 199, 14, 237, 170, 184, 100, 231, 92, 222, 0, 0, 109, 162}, 187},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{16, 161, 85, 193, 202, 21, 3, 155, 63, 116, 124, 203, 34, 13, 215, 0}, 38},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 109, 163, 201, 201, 254, 49, 195}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{111, 52, 10, 0, 0, 0, 10, 161, 69, 69, 211, 221, 226, 84, 169, 46}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 65, 209, 160, 193, 85}, 35},
	{{111, 52, 10, 0, 0, 0, 175, 242, 112, 17, 36, 151, 0, 95, 212, 22}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 251, 106, 142, 5, 5, 123, 110, 229, 50}, 35},
	{{111, 52, 10, 0, 0, 255, 125, 225, 46, 225, 28, 230, 84, 93, 126, 157}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 166, 13, 6, 128, 213, 160}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 29, 123, 237}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 197, 221, 76, 41, 241}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 226, 28, 104, 222, 236, 102, 185}, 35},
	{{111, 52, 10, 0, 0, 0, 26, 116, 237, 88, 150, 45, 102, 74, 97, 14}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 87, 115, 140, 35, 213, 192, 255}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 65, 94, 195}, 35},
	{{111, 52, 10, 0, 89, 13, 80, 222, 206, 209, 135, 3, 172, 229, 248, 33}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 150}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 79, 55, 121, 21, 81, 92, 201}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 67, 183, 52, 142, 5, 75}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 56, 86, 58, 118, 57, 98, 238, 205}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 139}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 173, 108, 255, 164, 174}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 79, 150, 43, 133, 199, 146, 191, 251, 164}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 157, 102, 169, 3, 79, 26, 118, 195}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 13, 184, 107, 199, 143}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 220, 110, 244, 132, 65, 122, 249}, 35},
	{{111, 52, 10, 0, 0, 55, 226, 101, 59, 183, 190, 191, 163, 19, 70, 250}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 166, 194, 66, 66, 141, 158, 66, 125, 134}, 35},
	{{111, 52, 10, 0, 0, 126, 223, 105, 140, 237, 221, 205, 60, 105, 143, 44}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 152, 81, 65, 3, 219, 114, 97, 88}, 35},
	{{111, 52, 10, 0, 0, 132, 123, 140, 243, 27, 247, 73, 152, 64, 73, 208}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 134}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 94, 203, 157, 114, 67, 54}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 61, 109, 69, 93, 130, 2, 183}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 133, 236, 49, 172, 144, 64, 103, 160, 57}, 35},
	{{111, 52, 10, 0, 0, 0, 71, 132, 126, 84, 1, 57, 233, 180, 79, 10}, 35},
	{{111, 52, 10, 0, 0, 0, 155, 214, 25, 219, 76, 242, 129, 53, 124, 214}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 45, 51, 26, 20, 88, 188, 198, 107, 196}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 191, 246, 71, 230, 100}, 35},
	{{111, 52, 10, 0, 0, 5, 50, 228, 65, 131, 5, 112, 155, 66, 32, 52}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 124, 62}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 90, 46, 7, 93, 76, 125}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 133, 96, 117, 250, 27, 68}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 18, 245, 85}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 153, 205, 122}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 46, 44, 6, 20, 115, 231, 92, 189}, 35},
	{{111, 52, 10, 0, 0, 0, 131, 92, 4, 196, 234, 78, 52, 127, 248, 39}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 156, 47, 201, 176, 217}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 194, 72}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 12, 24, 207, 33, 174, 118, 233}, 35},
	{{111, 52, 10, 0, 58, 161, 201, 156, 164, 35, 156, 78, 97, 73, 153, 147}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 68, 44, 124, 239, 180, 254, 26, 109}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 148}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 186, 41, 18}, 35},
	{{111, 52, 10, 0, 0, 0, 222, 127, 121, 57, 121, 156, 88, 77, 223, 185}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 53, 56}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 19, 231, 253}, 35},
	{{111, 52, 10, 0, 0, 139, 19, 85, 91, 154, 107, 239, 29, 68, 90, 74}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 39, 101, 82, 191, 170, 133, 11, 230}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 214, 180, 55, 33, 238, 158, 181, 136, 143}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 186}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 57}, 35},
	{{111, 52, 10, 0, 0, 0, 85, 192, 25, 168, 114, 158, 43, 78, 152, 219}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 254, 111, 161, 231, 101, 201, 134}, 35},
	{{111, 52, 10, 0, 0, 0, 167, 204, 162, 110, 99, 111, 82, 231, 207, 109}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 13, 212, 146, 36, 213, 158, 121, 47}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 170, 77, 218, 12, 87, 194, 129}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 108, 219, 152, 124, 159, 233}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 136, 175}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 226, 86}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 34, 126}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 178, 45, 224, 129, 101, 156, 2, 155}, 35},
	{{111, 52, 10, 0, 0, 117, 64, 57, 36, 145, 172, 30, 245, 22, 1, 245}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 251}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 182, 115, 211, 176, 20, 170}, 35},
	{{111, 52, 10, 0, 0, 9, 142, 136, 220, 84, 51, 140, 204, 1, 86, 191}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 171, 115, 44, 125, 161, 41, 47}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 196, 51, 59, 164, 9, 140, 137, 169}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 71, 245, 63, 3, 209, 173, 65}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 9, 210, 166, 138, 254, 138, 161, 220}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 255, 18, 230, 103, 212}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 24, 170, 169, 229, 16, 144, 146}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 211, 240, 235, 190, 34, 53, 205}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 147, 163, 17, 152, 101}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 33}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 72, 149, 118, 104, 204, 215}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 142, 19, 127, 97, 61, 241, 50, 29, 160}, 35},
	{{111, 52, 10, 0, 0, 0, 0, 0, 0, 0, 168, 49, 184, 185, 220, 22}, 35},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 145, 210, 12, 134}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 85}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 96, 179, 204, 99, 74, 9}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 115},
	{{69, 12, 116, 151, 32, 0, 83, 158, 254, 149, 244, 231, 21, 230, 172, 45}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 31, 52, 44, 233}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 102, 119, 9, 157}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 252, 121, 114, 125, 78}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 187}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 152}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 243, 84, 157, 124, 144, 103}, 115},
	{{69, 12, 116, 151, 32, 0, 197, 50, 112, 131, 174, 125, 52, 232, 206, 198}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 79, 252, 130, 254, 60, 21, 65}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 89, 132, 162, 169, 211, 224, 170, 166, 24}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 34, 131, 43, 140, 33, 91, 167, 58}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 182}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{69, 12, 116, 151, 32, 0, 90, 63, 108, 51, 224, 153, 177, 188, 85, 147}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 27, 197, 144, 226}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 108, 216, 26, 173, 193, 223}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 185, 35, 43, 68, 49, 136, 128}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 243, 9, 113, 111, 32, 244, 8, 208}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 18, 55, 196, 196, 192, 77, 126, 235, 157}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 204, 220, 49, 36, 200, 255, 34, 17}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 148, 133, 100, 40, 244, 147, 206, 26}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 151, 216, 21, 139, 179, 90}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 169, 92, 132, 169}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 133}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 243, 57, 255, 162}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 66, 127, 251, 178, 224, 14, 80, 57}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 209}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 190, 221, 231, 87, 89, 188, 146}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 78, 45, 106}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 163, 132, 51}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 75, 21, 61, 210}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 70, 57, 158, 222, 157}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 142, 244, 194, 120, 221, 31}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 38, 123, 235, 181}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 33, 4, 137, 206, 162}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 213}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 220, 2, 111, 208, 235}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 31, 210, 44, 25, 135, 166, 193, 65, 170}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 95, 131, 135, 247}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 248, 92, 148}, 115},
	{{69, 12, 116, 151, 32, 0, 41, 59, 203, 197, 0, 160, 22, 54, 153, 85}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 12, 101, 204, 72, 116}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 208, 235, 226, 101, 47, 132, 46, 156}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 220, 210, 231, 122, 169, 132, 91, 235, 123}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 178, 59, 49, 87, 95, 242}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 93, 146, 18, 66}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 67, 244, 43, 174, 49, 196, 142}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 90, 219, 189, 241, 153, 236}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 188, 219, 35, 181, 124, 90, 110, 85, 227}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 67, 154, 107, 69, 201}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 248, 223, 122, 13, 18, 144, 84, 162}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 143, 25, 241, 23, 19, 8, 206}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 206, 160, 214, 143}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 249, 156, 244, 220, 155}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 206, 50, 158, 227}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 124, 54, 63, 119, 82, 239}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 113, 75, 79, 0, 108, 190, 174, 248, 145}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 60}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 136, 5, 112, 197, 198, 158, 29, 54, 208}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 54, 39, 176, 106}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 113, 201, 159, 150, 233, 152}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 34, 90, 246, 21, 3, 124, 239, 135, 207}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 130, 126, 21, 19, 45, 242}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 223, 1, 113, 148, 105, 222, 93, 131, 190}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 164, 133, 108, 14, 226, 164}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 40, 64, 19, 90, 106, 199, 3, 246}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 234, 117, 23, 100, 171, 98, 129, 61}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 223, 162, 31, 126, 43, 168}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 115}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 165}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 238, 202, 130, 157, 137, 8, 9, 12}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 241, 215, 71, 74, 182, 46, 111}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 165, 23, 104, 245, 213}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 201, 228, 129, 119, 223, 143, 250}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 238, 241, 107, 17, 20, 42, 109, 84, 139}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 64, 62, 203, 243, 66, 175, 172}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 13, 72, 52, 46, 111, 84, 159, 214, 245}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 115},
	{{69, 12, 116, 151, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 115},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 167, 44, 85, 121, 4, 249}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 145, 169, 172}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 238}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 41, 197, 139}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 90, 182, 180, 114, 144}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 146, 34, 113, 43, 93}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 94, 92, 167, 236}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 60, 83, 79, 53, 15, 75, 40}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 204, 201, 91, 78, 201, 33, 166}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 86, 245, 210}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 236, 240}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 67, 113, 84, 49, 156, 135, 41, 231}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 195, 190, 49, 145, 20, 140}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 184, 72, 209, 13, 219}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 57, 2, 246, 48, 172, 83, 130}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 112, 92, 130, 56, 251, 183, 209, 7}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 251, 199, 13, 136, 223, 193, 171, 140}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 112, 187, 8, 122, 215, 93, 118}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 82, 124, 11, 123, 21}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 13, 147, 210, 113}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 88, 177, 161}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 35, 111, 179}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 94, 6, 240, 18, 15, 224, 43, 167}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 22, 32, 84, 87}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 51, 90, 251, 218}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 151, 135, 156, 155, 56, 132, 9, 128, 96}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 91, 53}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 112, 55, 131}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 65, 132}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 198, 105, 27, 177, 63, 28, 27, 24}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 105, 193, 134, 56, 15}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 146, 128, 106, 115, 69, 154}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 18, 211, 12, 118, 37}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 225, 140}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 102, 7, 160, 130}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 23, 221, 163}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 235, 105, 203, 7}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 153, 21, 87, 126, 56}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 39, 235, 203, 16}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 16, 82, 163}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 77, 28, 47, 199, 246, 174, 24}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 133, 76, 28, 79, 54}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 191}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 212, 161, 228, 229, 47, 254, 0, 94}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 144, 155, 109, 5, 167, 240}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 130, 67, 51, 112, 175}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 113, 202, 100, 242, 53, 101, 36, 97, 141}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 184, 201, 200, 168, 18, 231, 178, 193}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 238, 211, 14}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 11, 130, 87, 202, 141, 226}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 181, 180, 8, 91}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 167, 140, 234, 100, 110}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 33, 251, 234, 90, 229, 141}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 96, 194, 244, 96, 3, 101, 111, 59}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 242, 227, 208, 182, 187, 138, 12, 72}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 248, 108, 186, 108}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 126, 184, 48, 52, 237, 8, 163}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 225, 64, 223}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 112, 58, 175, 14, 121, 100, 247, 126}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 162, 153, 36, 151, 114, 89, 231}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 155, 183}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 184, 101}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 223, 35, 239, 124, 52}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 176, 112, 18, 124, 199, 83, 76}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 125, 5, 85, 100}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 217, 49, 203, 29, 214, 81, 167, 53, 116}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 102, 215, 246}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 243, 58, 46, 174, 200}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 118, 47, 70, 169, 194, 0, 133, 144}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 229, 117}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 188, 76, 20}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 172, 177, 139, 236, 141, 171}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 137, 18}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 94, 15, 156, 133, 59, 245}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 236}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 47, 93, 17, 201}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 32, 127, 92, 244, 130, 69, 209}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 207, 104, 74, 106}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 18},
	{{187, 60, 97, 40, 112, 101, 96, 0, 0, 0, 0, 0, 171, 218, 178, 157}, 18},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 251, 96, 150}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 47, 106, 100, 125, 170, 144, 109}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 236, 3, 221, 42, 74, 84, 12, 45, 142}, 34},
	{{230, 194, 136, 255, 206, 0, 247, 221, 181, 226, 26, 169, 242, 194, 31, 224}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 20, 24, 227, 107, 146, 96}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 52, 93, 79, 70, 30, 48, 187, 193, 14}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 170, 12, 130, 12, 214, 187}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 99}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 119, 58, 154, 111, 164}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 255, 205, 162, 232, 229, 156, 210, 175}, 34},
	{{230, 194, 136, 255, 206, 0, 107, 124, 74, 152, 70, 51, 221, 184, 160, 123}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 2, 34, 89, 54, 160, 30, 42, 201, 127}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 173, 238, 55, 17, 47, 168}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 92, 70, 228, 175, 42, 57}, 34},
	{{230, 194, 136, 255, 206, 0, 62, 78, 84, 219, 28, 120, 209, 125, 150, 255}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 234, 41, 78, 186, 107, 38, 168, 56, 25}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 34, 54, 130, 34}, 34},
	{{230, 194, 136, 255, 206, 0, 141, 212, 29, 236, 2, 38, 30, 164, 41, 106}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 206, 60, 154, 180, 91, 107, 58}, 34},
	{{230, 194, 136, 255, 206, 0, 250, 171, 12, 32, 169, 147, 32, 199, 192, 161}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 53}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 192}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 176, 16, 208}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 241}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 13, 20, 106, 216}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 140, 50, 87, 130, 9, 155, 198}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 22, 219, 129, 94, 169, 38, 182}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 60}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 16, 17, 254, 132, 194, 70, 37, 35, 44}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 134, 195, 125, 253, 60, 18, 117, 190}, 34},
	{{230, 194, 136, 255, 206, 0, 177, 91, 230, 117, 213, 194, 25, 30, 103, 32}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 223, 96, 203, 231}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 171, 164, 146, 137, 113, 220, 240, 138}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 187, 2, 130}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 30, 112, 180, 254, 120, 24, 116}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 57, 190, 133, 20, 127, 130}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 99, 199, 107, 64}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 127, 67, 151, 155, 110, 232, 153, 3}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 128, 15, 209, 132, 8, 23, 103, 19, 66}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 103}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 239, 131, 50, 51, 230, 51, 50, 142}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 18, 246, 255}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 127, 42, 193, 10, 26, 55, 35}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 11, 175, 26, 81}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 182, 184, 166, 250, 160, 92, 211, 168}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 200, 228, 207, 231, 221}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 195, 246, 10, 240, 39, 105}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 150, 125, 4, 213, 157, 201, 146}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 27, 65, 16, 27, 91}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 34, 33, 186, 209, 253, 17, 221, 60}, 34},
	{{230, 194, 136, 255, 206, 236, 115, 229, 2, 46, 94, 73, 223, 46, 135, 230}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 246, 0, 244, 19, 207, 123, 211, 83}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 220, 127, 252, 233, 6, 86}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 42, 250, 134, 226, 195, 137, 182}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 23}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 227, 148, 155, 75, 78, 95}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 190, 25, 114}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 134, 212, 69, 116, 252}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 177, 89, 114, 58, 180, 19, 123, 82}, 34},
	{{230, 194, 136, 255, 206, 0, 88, 254, 158, 145, 94, 82, 91, 160, 214, 198}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 209, 192, 102, 24, 128}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 35, 210, 155}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 96, 228, 180, 212}, 34},
	{{230, 194, 136, 255, 206, 0, 81, 67, 207, 134, 251, 179, 216, 47, 247, 17}, 34},
	{{230, 194, 136, 255, 206, 0, 206, 79, 98, 188, 224, 155, 8, 204, 146, 188}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 120, 136, 46, 251, 246}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 104, 211, 77, 142, 6}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 108, 54, 158, 54, 11}, 34},
	{{230, 194, 136, 255, 206, 0, 48, 175, 60, 205, 123, 31, 137, 78, 201, 247}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 145, 250, 11, 250, 178}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 48, 28, 221, 149, 201, 62}, 34},
	{{230, 194, 136, 255, 206, 0, 28, 93, 91, 192, 234, 12, 155, 68, 239, 0}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 54, 60, 153, 7, 241, 164, 146, 197, 239}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 14, 188, 191, 163, 49, 15}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 203, 106, 236, 66, 5, 84, 112}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 165, 91, 213, 103, 168, 80, 137, 175}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 228, 45, 158, 19, 91, 189}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 199, 255, 30, 105, 210, 52, 184, 77, 33}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 214, 187, 36}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{230, 194, 136, 255, 206, 0, 58, 220, 249, 209, 134, 5, 115, 9, 167, 180}, 34},
	{{230, 194, 136, 255, 206, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 34},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 169, 125, 82}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 163, 128}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 141, 122, 114}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 89, 39, 170}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 15, 41}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 37, 3, 148, 94}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 211, 209, 139, 170}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 107, 21, 46, 154}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 54, 1, 61, 109}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 123, 182}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 246, 116, 97}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 142, 1, 71}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 38}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 223, 244}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 237}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 1, 213, 141}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 182, 68}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 20}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 126, 107}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 190, 210, 111, 190}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 106, 147, 13, 133}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 166, 18, 79}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 145, 126}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 36, 9, 116, 87}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 134, 87}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 171}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 111, 212}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 252, 63, 184}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 27, 129}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 87, 37, 226}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 165, 55}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 220, 77}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 238, 192, 232, 186}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 77, 25, 229, 94}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 80, 33, 145}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 4, 250, 25, 194}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 13}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 42, 21}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 5}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 17, 84, 188}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 235, 150, 26, 215}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 80}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 41}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 230}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 128}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 195, 87}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 91, 244, 236, 49}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 127, 95, 188, 129}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 61, 89, 145, 240}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 53, 109, 116}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 177}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 227, 154, 190, 98}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 1, 65, 55, 121, 162}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 72, 164, 102, 228, 17}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 224, 209, 253, 235}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 64, 158, 233}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 142, 112}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 151}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 18}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 192, 248}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 74, 132}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 55}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 216, 112, 29, 56}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 25}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 204, 54, 247, 135}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 35}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 186, 122, 72, 117}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 180, 34, 64, 98}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 23}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 182, 228}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 47, 242}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 191, 62, 13}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 115, 45, 139, 214}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 149, 223}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 241, 238}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 91, 194}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 251, 162, 240}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 53, 132, 153}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 74, 2, 59, 7, 247}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 243, 34, 176, 78}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 93, 142, 135}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 171, 177}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{179, 239, 170, 107, 3, 13, 212, 67, 177, 69, 8, 0, 0, 0, 0, 0}, 75},
	{{11, 58, 130, 89, 128, 0, 243, 76, 121, 62, 105, 232, 7, 175, 220, 198}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 56, 10, 125, 109, 40}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 20, 133, 158, 90, 25, 200, 95, 105, 21}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 51, 229, 30, 202, 249, 161, 236}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 41, 129, 241, 37, 96, 79}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 180, 98, 5, 148, 4, 20, 151}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 90, 193, 17, 251, 192, 150, 142, 218, 230}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 141, 240, 35}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 34, 59, 219, 224, 198, 46, 229, 247}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 137, 3, 35, 56, 41}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 118, 62, 31, 189, 132}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 171, 118, 2, 88, 208}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 77, 145, 152, 120, 172, 206, 151}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 60, 69, 114, 127, 106, 253, 72}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 177, 100, 151, 135, 89, 30, 166, 154, 179}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 200}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153}, 232},
	{{11, 58, 130, 89, 128, 0, 22, 228, 192, 159, 252, 102, 5, 122, 157, 141}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 177, 146, 2, 150, 27, 207}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 77, 180, 210}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 122, 21, 6, 242, 5, 212, 111, 25, 115}, 232},
	{{11, 58, 130, 89, 128, 166, 43, 219, 11, 173, 155, 142, 203, 114, 250, 238}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 203, 40, 153, 186, 74}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 26, 79, 197, 242, 121, 194}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 238, 109, 59, 88, 108, 100, 83}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 203, 91, 152}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 64, 127, 41, 205, 13}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 16, 228, 87, 21, 9, 190}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 58, 245, 102}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 144, 224, 42, 172, 27, 108, 115, 39}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 76, 248, 65, 10, 101, 27, 112, 17}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 163, 83, 137, 78}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 247, 242, 212, 52, 190, 182, 203}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 31, 194, 26, 141, 199, 186, 192, 52}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 95, 114, 84, 128, 42, 172}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 162}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 124, 234, 253, 62, 7, 145}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 26, 150, 179, 10, 190}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 251, 165, 160, 145, 100, 6}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 76, 195, 166, 180, 87, 52, 235, 136, 51}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 73}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 225, 85, 69, 232, 212, 252}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 249, 46, 150, 65, 173, 243, 210, 249, 176}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 63, 204, 130, 141, 82, 174, 71, 172, 86}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 41, 125, 112, 53, 182, 96, 247}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 238, 126, 102}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 37, 76, 119, 149, 158, 152}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 104, 225, 204, 97, 239, 234, 196, 243}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 80}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 44, 133, 183, 84}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 24, 246, 9, 242, 66, 65, 66}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 155, 117, 249, 3, 12, 123, 81, 219, 176}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 68, 80, 245, 83, 134, 154, 201, 181}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 180, 195, 107, 141, 34, 147, 54}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 240, 254, 93, 8, 59, 31, 15, 193, 193}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 216, 53, 92, 126, 248, 146, 37, 181, 196}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 232},
	{{11, 58, 130, 89, 128, 0, 235, 133, 155, 7, 206, 234, 243, 251, 183, 50}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 29, 182, 102, 69, 109, 74, 26, 233, 105}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 60, 59, 61}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 118, 227, 86, 236, 118, 171, 156}, 232},
	{{11, 58, 130, 89, 128, 96, 183, 186, 33, 54, 20, 94, 55, 19, 41, 72}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 80, 84, 163, 143, 108, 235, 83, 179, 235}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 151, 189, 10, 74}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 140}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 179, 82, 30, 72, 183, 21, 80}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 127, 6, 182, 212, 64, 90}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 185}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 102, 211, 233}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 223, 213, 209, 111, 248, 80, 253, 25}, 232},
	{{11, 58, 130, 89, 128, 100, 55, 217, 113, 42, 89, 245, 9, 65, 93, 120}, 232},
	{{11, 58, 130, 89, 128, 130, 30, 3, 129, 113, 229, 170, 41, 146, 255, 231}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 49, 172, 125, 237, 218, 44, 117, 133, 26}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 45}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 179, 220, 167, 137, 206}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 5}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 228, 68, 23}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 224, 47, 197, 19, 8, 223}, 232},
	{{11, 58, 130, 89, 128, 90, 131, 203, 210, 117, 227, 37, 186, 251, 78, 174}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 38, 49, 157, 168, 61, 118, 197, 62}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 82}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 232},
	{{11, 58, 130, 89, 128, 0, 73, 121, 184, 111, 130, 99, 235, 177, 24, 144}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 224, 205, 78, 48, 91, 115, 57, 54, 250}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 214, 200, 110, 33, 145, 210}, 232},
	{{11, 58, 130, 89, 128, 0, 0, 0, 0, 0, 0, 0, 242, 219, 185, 223}, 232},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 191, 45}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 101}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 118, 129, 28, 1}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 214, 228}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 129, 96, 2, 16}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 72, 251, 91}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 44, 103, 61, 224}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 89, 110}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 14}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 56, 64, 227}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 171, 249}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 229, 175}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 235, 113}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 105, 138, 207, 154}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 205, 67, 1}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 156}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 86, 114, 87, 130}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 34, 37, 217, 249}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 199, 238, 146, 5}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 137, 42}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 150, 233, 237, 123}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 102}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 216, 37, 223, 208}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 142, 106, 5, 117}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 240}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 183, 92, 86, 198}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 42}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 149}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 95}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 147}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 159}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 103, 132, 252, 15}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 230, 126, 219}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 67}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 133}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 36, 132, 46}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 192, 107, 56, 40}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 61, 118, 148}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 55, 211}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 138}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 188}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 180, 135}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 133, 80, 13, 68}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 74, 138, 44}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 35, 10}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 92, 232}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 10}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 114}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 206, 162, 64, 87}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 180, 144, 213}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 3, 112, 72, 171}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 81, 127, 45}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 124, 85, 209}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 178, 147, 68, 88}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 69}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 50, 215}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 46, 39, 161}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 82, 61}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 78, 104}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 241, 108}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 150}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 235, 21, 104}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 210, 40, 118, 191}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 175, 181}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 204, 200, 122}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 122}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 139, 26, 32, 43}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 137, 196, 210}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 96, 252, 153, 25}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 177}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 25}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 163}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 50, 177, 63}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 39, 166}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 14}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 49, 139, 160}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 142, 211}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 230, 138}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 10, 38}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 29, 180, 191, 18}, 154},
	{{217, 178, 43, 203, 234, 20, 234, 186, 157, 88, 146, 192, 0, 0, 0, 0}, 154},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 176, 99}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 185, 131, 201}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 198, 216, 51, 144, 161, 252, 205, 115}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 141}, 195},
	{{6, 180, 224, 182, 154, 253, 106, 117, 190, 3, 194, 26, 55, 222, 246, 48}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 196, 86, 254, 243, 53, 168, 216, 93, 159}, 195},
	{{6, 180, 224, 24, 50, 73, 143, 0, 221, 254, 50, 192, 248, 38, 221, 216}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 84, 71, 101, 105, 235, 31, 233, 111}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 94, 109, 175, 59, 85, 67, 92}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 93, 151, 153, 173, 114, 104, 203, 155}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 91, 96, 235}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 81, 148}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 49, 60, 42}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 64, 177, 87, 101, 4, 244, 212, 74}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 244, 247, 122, 5, 75}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 217, 206, 247, 37, 235}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 213, 2, 232, 245, 73, 243}, 195},
	{{6, 180, 224, 0, 0, 0, 201, 39, 17, 134, 194, 195, 169, 130, 84, 140}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 84, 51, 36, 44, 246, 215, 201, 191, 144}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 81, 21, 208, 137, 222}, 195},
	{{6, 180, 224, 0, 0, 0, 213, 127, 21, 252, 30, 112, 14, 193, 38, 185}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 212, 37, 203, 18, 207, 100, 202}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 145, 206, 147, 195, 8, 215, 160, 163, 208}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 46, 208, 37, 233, 39}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 83, 172, 142}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 217, 102, 102, 196, 230, 127, 255, 190}, 195},
	{{6, 180, 224, 173, 24, 108, 60, 149, 49, 204, 62, 189, 28, 79, 78, 164}, 195},
	{{6, 180, 224, 0, 87, 6, 209, 16, 193, 10, 194, 242, 123, 255, 228, 53}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 123, 148, 87, 35, 253, 146, 166, 163, 134}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 188, 221}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 198, 27, 23, 205, 54, 150, 255, 215, 128}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 174, 173, 221, 247, 40, 245}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 254, 246, 37, 221, 203, 246}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 195},
	{{6, 180, 224, 188, 85, 34, 14, 50, 156, 181, 193, 95, 181, 17, 65, 164}, 195},
	{{6, 180, 224, 0, 0, 253, 92, 167, 135, 253, 87, 59, 41, 141, 174, 150}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 169, 1}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 224, 23, 236, 178, 237, 241, 152, 28, 66}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 163, 20}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 80, 140, 163}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 73, 227, 151, 130, 153, 83}, 195},
	{{6, 180, 224, 0, 0, 0, 136, 27, 14, 177, 128, 135, 232, 251, 152, 32}, 195},
	{{6, 180, 224, 0, 41, 133, 2, 35, 159, 167, 80, 135, 160, 148, 87, 13}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 93, 73, 163}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 33, 234, 70, 118, 65, 0, 252}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 129, 222, 224, 234, 249, 160}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 149, 101, 10, 220, 157}, 195},
	{{6, 180, 224, 0, 92, 33, 77, 58, 251, 138, 42, 180, 195, 46, 55, 218}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 26, 231, 58, 70, 177, 222, 21, 7, 49}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 247, 99, 50, 40, 62, 225, 156, 74, 0}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 48, 198, 18, 78, 114, 99}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 159, 56, 133, 218, 28}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 26}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 141, 185, 63, 144, 213, 164, 88}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 235, 199, 111, 85, 46}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 60, 75, 193, 216, 245, 188}, 195},
	{{6, 180, 224, 0, 0, 14, 126, 14, 227, 77, 202, 8, 19, 208, 41, 41}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 177, 63, 165, 238, 38, 223, 36}, 195},
	{{6, 180, 224, 62, 18, 169, 230, 119, 231, 189, 4, 210, 214, 136, 75, 217}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 143, 231, 107, 3, 59, 255, 7}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 137}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 69, 86}, 195},
	{{6, 180, 224, 0, 0, 0, 250, 50, 28, 235, 44, 45, 110, 106, 165, 141}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 221, 99}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 222, 36, 218, 157, 64, 44, 117, 127}, 195},
	{{6, 180, 224, 0, 0, 0, 210, 204, 70, 199, 139, 45, 148, 126, 226, 7}, 195},
	{{6, 180, 224, 0, 201, 195, 124, 217, 197, 113, 50, 184, 178, 197, 197, 183}, 195},
	{{6, 180, 224, 0, 0, 194, 204, 41, 254, 153, 28, 89, 231, 50, 8, 33}, 195},
	{{6, 180, 224, 0, 29, 104, 91, 11, 9, 98, 115, 19, 74, 120, 107, 252}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{6, 180, 224, 68, 200, 115, 243, 152, 102, 112, 92, 161, 91, 252, 98, 174}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 163, 144, 227, 101, 247, 59}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 13, 167, 139, 182, 239, 52, 96, 228, 106}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 185, 204}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 34}, 195},
	{{6, 180, 224, 0, 0, 207, 195, 213, 207, 231, 207, 127, 204, 106, 41, 48}, 195},
	{{6, 180, 224, 0, 0, 0, 157, 29, 133, 76, 24, 85, 132, 169, 253, 187}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 19, 172, 83, 46, 48, 225}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 148, 158, 237, 224, 240, 45, 187, 146}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 241}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 113, 65, 200, 8, 237, 7, 247, 146}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 163, 184, 24, 216, 203, 64, 145}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 236, 187, 173, 18, 223, 70}, 195},
	{{6, 180, 224, 0, 77, 45, 115, 191, 43, 208, 83, 68, 16, 196, 80, 157}, 195},
	{{6, 180, 224, 0, 0, 81, 209, 245, 100, 204, 214, 94, 229, 221, 29, 96}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 208}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 18, 255, 12, 75, 202, 3, 57, 185}, 195},
	{{6, 180, 224, 0, 0, 3, 213, 248, 84, 193, 168, 21, 112, 108, 43, 226}, 195},
	{{6, 180, 224, 0, 252, 25, 201, 229, 85, 250, 86, 255, 35, 60, 239, 88}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 175, 174}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 135, 53, 248, 73, 25, 22}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 40, 109, 59, 122, 169, 110, 65, 244, 0}, 195},
	{{6, 180, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 220, 46}, 195},
	{{6, 180, 224, 0, 130, 252, 147, 7, 231, 153, 36, 233, 47, 224, 246, 212}, 195},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 40, 150, 247, 63, 238, 108}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 43, 97, 4}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 230, 47}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 130, 233, 54, 192}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 145, 208, 19}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 133, 65, 191, 123, 251, 249}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 12, 230, 193, 197}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 136, 4}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 164, 20, 29}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 34, 188}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 100, 211, 157, 33, 211, 72}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 3, 80, 14}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 36, 27}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 12, 59, 52}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 12, 74, 163, 251, 35, 252}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 202}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 17, 236}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 234, 111}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 171, 166, 105, 184, 122, 43, 184}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 98, 57, 190, 146, 220, 49}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 176, 187, 243, 197, 47}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 148, 241, 123}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 251, 122, 48, 175, 122}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 31, 148, 159, 193, 40, 92}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 19, 168}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 187, 64, 41}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 131, 84, 56, 169, 182, 138}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 124, 77, 179, 89}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 244, 78, 80, 82, 179, 180}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 234, 127, 55}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 125, 3, 38, 9, 8, 108}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 3, 148, 203, 35, 124, 139}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 76, 55, 233}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 123, 248, 44, 131, 2, 232, 110}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 229, 205, 225, 21}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 37, 74, 227, 43, 202}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 94}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 157, 134, 235, 24, 198}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 153, 193, 136, 85, 63, 155}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 122, 143, 75, 30, 27}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 29, 63, 188, 44, 167}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 140, 25, 95, 142, 155}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 64}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 18, 170}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 219, 126, 127, 64, 202, 28}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 202}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 135, 77, 57, 240}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 105, 193, 53, 155, 157, 72}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 238, 195}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 174, 116, 31, 239}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 240, 79}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 201, 151, 91, 96}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 101, 8, 217, 39, 235, 4, 11}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 122, 243, 225, 248, 229, 177}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 60, 191, 91, 153, 101, 133}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 243, 24, 27, 142}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 175, 204, 102, 98, 6, 122}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 58, 49, 218, 160, 147}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 93, 161, 26, 232, 77}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 197, 209, 140, 132}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 53, 61, 6, 12, 199}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 233, 21, 15, 24}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 49, 233, 106, 161, 177}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 251, 173, 71, 78, 131}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 130, 238, 137, 16, 10}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 71, 210, 189}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 151, 151, 208, 236}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 236, 245}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 115}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 221, 94, 63, 202, 181}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 221, 216, 162, 123}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 144, 248}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 181, 215}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 147, 223, 123, 156, 118, 128, 61}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 101}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 26, 137, 191, 192, 159}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 123, 131, 204, 154, 199, 22}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 144, 241, 79, 113, 73, 225, 211}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 46, 173, 15}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 79, 214, 112, 148, 242, 20, 236}, 122},
	{{157, 154, 218, 158, 39, 224, 103, 230, 164, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 40}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 96, 98, 48}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 235, 155, 107, 94, 94, 43, 88, 117, 192}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 167, 4, 203, 164, 225, 174, 234, 141, 137}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 88, 159, 216, 183, 186, 170}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 235}, 97},
	{{225, 10, 131, 0, 0, 0, 186, 14, 124, 120, 209, 86, 161, 18, 191, 251}, 97},
	{{225, 10, 131, 0, 0, 0, 48, 139, 81, 100, 119, 73, 53, 172, 6, 222}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 10, 87, 124, 172, 58, 67, 238, 226, 93}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 11, 124, 198, 175, 156}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 220, 51, 73, 20, 17}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 243, 198, 209}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 49}, 97},
	{{225, 10, 131, 0, 0, 152, 146, 206, 211, 219, 120, 160, 185, 79, 249, 6}, 97},
	{{225, 10, 131, 0, 203, 187, 232, 63, 134, 113, 222, 122, 137, 52, 78, 155}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 135, 29, 86, 69, 202, 253, 105, 117}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 112, 231, 116, 160, 150, 9, 140, 42, 173}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 243, 195, 245, 190, 52, 171, 84, 238, 43}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 98, 72, 133}, 97},
	{{225, 10, 131, 0, 0, 0, 253, 253, 47, 122, 132, 86, 250, 120, 69, 19}, 97},
	{{225, 10, 131, 0, 0, 0, 49, 154, 151, 135, 102, 11, 136, 148, 212, 147}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 253, 86, 43, 36, 204, 176, 162}, 97},
	{{225, 10, 131, 0, 0, 54, 123, 221, 147, 246, 167, 104, 200, 185, 5, 232}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 24, 203, 111, 93, 179, 219, 12}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 118, 47, 135, 40, 87, 40, 251, 57, 251}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 19}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 207, 219, 244, 49, 147, 254, 212, 210, 64}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 10, 60}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 99}, 97},
	{{225, 10, 131, 0, 10, 55, 254, 112, 254, 247, 107, 2, 29, 61, 143, 100}, 97},
	{{225, 10, 131, 0, 0, 102, 77, 255, 116, 233, 20, 108, 50, 145, 108, 47}, 97},
	{{225, 10, 131, 0, 0, 69, 152, 53, 93, 227, 0, 103, 255, 119, 7, 44}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 119, 6, 197, 128, 172, 184, 195, 102, 176}, 97},
	{{225, 10, 131, 0, 246, 133, 63, 128, 227, 43, 142, 48, 15, 236, 61, 130}, 97},
	{{225, 10, 131, 0, 0, 0, 102, 93, 4, 115, 135, 9, 129, 147, 171, 174}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 58, 57, 255, 187, 217, 147}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 97},
	{{225, 10, 131, 0, 0, 0, 79, 218, 51, 74, 52, 149, 30, 104, 254, 122}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 210, 139, 42, 180, 242, 41, 103, 120, 51}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 31, 178, 240}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 99, 143, 115, 198, 163, 105, 216, 70}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 105}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 244, 142}, 97},
	{{225, 10, 131, 0, 0, 0, 118, 224, 175, 23, 110, 231, 132, 168, 103, 158}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 78, 143, 72, 31, 244, 185, 124, 102}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 48, 77}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 239, 126, 181}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 104, 102, 21, 156, 26, 147, 126, 89}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 236, 120, 109, 17, 171, 234, 86}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 200, 28, 203, 144, 44, 21}, 97},
	{{225, 10, 131, 0, 0, 133, 191, 180, 233, 205, 196, 148, 200, 223, 174, 171}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 100, 226, 134, 84, 11, 125}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 152, 213, 23, 155, 175}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 36, 59, 234, 24, 238}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 132, 141}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 141, 14, 190, 131, 50, 18}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 57, 42, 145, 30, 238, 39}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{225, 10, 131, 0, 0, 0, 82, 2, 188, 3, 241, 18, 183, 97, 106, 52}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 166, 187, 151, 34, 45, 164}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 27, 162, 160, 56, 245, 78, 19, 236}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 218, 39, 224, 198, 141, 223, 117, 62}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 60, 182, 216}, 97},
	{{225, 10, 131, 0, 164, 7, 226, 124, 49, 176, 89, 168, 241, 51, 238, 76}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 145, 124, 145, 51, 164, 19, 43, 199}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 42, 68}, 97},
	{{225, 10, 131, 0, 253, 87, 95, 56, 19, 64, 239, 240, 43, 148, 44, 95}, 97},
	{{225, 10, 131, 0, 34, 146, 81, 147, 120, 130, 62, 37, 124, 209, 43, 216}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 242, 145}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{225, 10, 131, 0, 68, 126, 40, 21, 190, 39, 160, 132, 204, 180, 225, 60}, 97},
	{{225, 10, 131, 0, 187, 199, 184, 129, 41, 250, 155, 144, 209, 192, 165, 91}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 167, 151, 19}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 83, 170, 97, 174, 88, 223, 204, 204, 124}, 97},
	{{225, 10, 131, 0, 118, 13, 190, 123, 89, 196, 1, 21, 133, 160, 222, 194}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 241, 110, 146, 235, 120}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 10, 32}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 254, 216, 160, 29, 125}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 191, 210, 36}, 97},
	{{225, 10, 131, 0, 0, 97, 74, 179, 9, 34, 205, 219, 11, 120, 221, 193}, 97},
	{{225, 10, 131, 0, 0, 0, 123, 195, 30, 144, 174, 137, 161, 136, 68, 34}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 74, 51, 166, 71, 241, 92}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 243, 60, 48, 43, 67, 233}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 0, 0, 149, 173, 92, 220, 136}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 31, 222, 157, 126, 152, 183, 164, 62, 203}, 97},
	{{225, 10, 131, 0, 0, 110, 130, 248, 128, 204, 229, 206, 62, 191, 53, 66}, 97},
	{{225, 10, 131, 0, 0, 0, 0, 0, 0, 152, 5, 41, 180, 247, 202, 71}, 97},
	{{16, 0, 0, 0, 0, 46, 194, 222, 161, 95, 197, 19, 42, 104, 195, 136}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 202}, 220},
	{{16, 0, 0, 0, 0, 17, 51, 190, 208, 163, 208, 215, 243, 70, 29, 235}, 220},
	{{16, 0, 0, 0, 0, 8, 152, 157, 185, 100, 57, 124, 96, 57, 163, 55}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 196, 238, 0, 167, 92, 70, 131}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 90, 116, 110}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 80, 58, 234, 219, 11}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 203}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 178, 177, 199, 180}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 119, 75, 7, 16, 200, 213, 119, 68, 36}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 29, 45, 83, 92}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{16, 0, 0, 0, 0, 4, 129, 207, 194, 57, 118, 7, 76, 111, 93, 150}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 199, 164}, 220},
	{{16, 0, 209, 172, 12, 22, 244, 213, 211, 105, 100, 102, 112, 50, 112, 196}, 220},
	{{16, 0, 0, 37, 99, 159, 56, 42, 184, 132, 163, 205, 40, 63, 229, 188}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 142, 180, 226, 139, 145, 249, 134, 131, 166}, 220},
	{{16, 0, 0, 217, 221, 90, 113, 117, 212, 34, 51, 33, 21, 108, 85, 25}, 220},
	{{16, 0, 0, 0, 0, 0, 126, 146, 139, 235, 209, 242, 135, 227, 223, 95}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 159, 185}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 49, 246, 226, 232}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 113}, 220},
	{{16, 0, 0, 0, 62, 164, 184, 38, 117, 242, 72, 218, 50, 240, 15, 194}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 6, 99, 240, 61, 101}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 204, 33, 77}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 186}, 220},
	{{16, 46, 232, 238, 212, 158, 224, 119, 24, 24, 139, 127, 61, 239, 68, 215}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 3, 44, 29, 187, 190, 48, 106}, 220},
	{{16, 0, 0, 0, 245, 133, 127, 89, 176, 41, 111, 248, 255, 170, 97, 244}, 220},
	{{16, 0, 0, 0, 0, 4, 29, 56, 129, 59, 108, 59, 93, 14, 153, 6}, 220},
	{{16, 0, 0, 0, 0, 0, 69, 149, 3, 141, 69, 220, 205, 4, 133, 207}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 195, 174, 37, 96, 170, 14, 12}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 127, 124, 153, 183, 87, 5, 162, 144, 138}, 220},
	{{16, 0, 0, 0, 0, 113, 205, 89, 82, 190, 211, 109, 152, 64, 132, 176}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 189, 154, 135, 30, 173}, 220},
	{{16, 0, 0, 0, 0, 120, 175, 74, 5, 184, 186, 126, 46, 212, 210, 38}, 220},
	{{16, 137, 221, 200, 17, 68, 20, 211, 55, 83, 63, 11, 204, 219, 198, 98}, 220},
	{{16, 0, 0, 0, 0, 101, 17, 158, 199, 141, 21, 62, 35, 173, 137, 205}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{16, 211, 88, 162, 247, 3, 22, 122, 96, 198, 6, 18, 218, 87, 104, 53}, 220},
	{{16, 0, 0, 0, 0, 0, 223, 79, 131, 120, 102, 100, 156, 131, 71, 166}, 220},
	{{16, 0, 0, 136, 97, 149, 228, 16, 224, 24, 163, 8, 33, 60, 251, 219}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 163, 66}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 140}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 162, 196}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 28, 27, 29, 170, 179}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 154, 117, 14, 15, 240, 216, 223, 110}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 57, 230, 167, 238}, 220},
	{{16, 0, 0, 0, 0, 4, 178, 235, 5, 192, 101, 118, 170, 79, 232, 151}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 154, 147, 185, 25, 166, 224, 229, 122, 143}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 171, 126, 94, 72, 29, 26, 175}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 227, 247, 43, 20, 86}, 220},
	{{16, 184, 245, 188, 161, 135, 17, 93, 218, 213, 135, 235, 138, 204, 156, 57}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{16, 0, 154, 183, 137, 116, 76, 179, 44, 252, 255, 21, 181, 80, 24, 151}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 105, 72, 119, 161, 15, 174, 182, 108}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 34}, 220},
	{{16, 0, 69, 234, 70, 81, 114, 235, 83, 108, 151, 242, 96, 92, 132, 223}, 220},
	{{16, 0, 0, 0, 0, 0, 70, 235, 118, 156, 254, 197, 29, 50, 206, 122}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 156, 11, 160, 16, 6, 126, 20}, 220},
	{{16, 0, 0, 0, 0, 0, 74, 7, 197, 230, 217, 1, 109, 39, 157, 238}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 123, 50, 14, 148, 239}, 220},
	{{16, 0, 0, 0, 236, 165, 255, 103, 253, 152, 246, 31, 119, 225, 232, 176}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 243, 16, 83, 81, 84, 115, 211}, 220},
	{{16, 0, 0, 209, 184, 117, 34, 191, 7, 43, 17, 64, 217, 2, 217, 163}, 220},
	{{16, 0, 0, 0, 236, 212, 247, 127, 60, 124, 164, 193, 95, 61, 148, 191}, 220},
	{{16, 0, 0, 0, 0, 175, 204, 184, 2, 56, 154, 132, 38, 238, 234, 124}, 220},
	{{16, 0, 0, 0, 0, 66, 145, 120, 192, 143, 18, 241, 249, 216, 108, 35}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 225, 111}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 178}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{16, 0, 236, 126, 100, 137, 236, 215, 83, 62, 2, 23, 239, 49, 208, 169}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 49, 68, 252, 188, 51, 175, 133, 33, 62}, 220},
	{{16, 0, 0, 170, 131, 7, 109, 109, 75, 193, 81, 204, 31, 129, 90, 152}, 220},
	{{16, 0, 80, 33, 214, 43, 167, 89, 82, 179, 68, 63, 38, 60, 14, 79}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{16, 0, 0, 248, 144, 135, 168, 243, 35, 96, 108, 152, 118, 175, 28, 233}, 220},
	{{16, 0, 0, 57, 155, 0, 49, 34, 4, 114, 125, 220, 130, 190, 67, 150}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 187, 187, 23}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 29, 255, 224, 12, 66, 114, 179, 195}, 220},
	{{16, 0, 208, 228, 13, 24, 69, 0, 52, 38, 31, 4, 60, 216, 160, 126}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 24, 114, 142, 211, 236, 93, 206, 107, 152}, 220},
	{{16, 0, 0, 32, 78, 38, 159, 50, 32, 190, 3, 142, 152, 189, 56, 237}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 246, 94, 182, 121}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 38, 225, 130, 120, 41}, 220},
	{{16, 0, 0, 0, 0, 0, 236, 77, 248, 128, 70, 161, 54, 125, 177, 9}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 108, 235, 196, 96, 150}, 220},
	{{16, 0, 0, 0, 124, 73, 220, 124, 4, 23, 52, 39, 64, 65, 146, 121}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 193, 19, 22}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 255}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 147, 255, 43}, 220},
	{{16, 0, 0, 0, 0, 86, 69, 128, 79, 203, 170, 252, 40, 20, 227, 15}, 220},
	{{16, 0, 0, 23, 143, 97, 146, 193, 253, 1, 71, 8, 8, 140, 5, 113}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 220},
	{{16, 0, 0, 104, 72, 213, 236, 90, 103, 216, 186, 112, 219, 17, 61, 31}, 220},
	{{16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 142, 193, 120, 140, 81}, 220},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 80},
	{{166, 0, 0, 161, 96, 63, 242, 107, 212, 66, 228, 186, 174, 1, 77, 138}, 80},
	{{166, 0, 0, 0, 170, 156, 35, 132, 19, 92, 169, 161, 173, 207, 66, 203}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 59, 240}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 88}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 242}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 102, 223, 171, 56, 241, 236, 195, 36}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 63}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{166, 0, 0, 0, 55, 189, 103, 145, 232, 124, 219, 235, 82, 121, 60, 22}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 51, 8, 32, 49, 126}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 255, 167, 165, 114, 144, 211, 142, 31, 63}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 85, 16, 61, 196}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 255, 127}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 81, 24, 84}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 62, 22, 105, 245}, 80},
	{{166, 227, 1, 128, 131, 214, 93, 149, 133, 51, 14, 95, 130, 176, 147, 223}, 80},
	{{166, 0, 0, 0, 180, 218, 155, 86, 194, 60, 34, 21, 247, 116, 243, 241}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 119, 202, 28, 170, 210, 201, 218}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 228, 168}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 32, 225, 78, 105, 81}, 80},
	{{166, 0, 0, 125, 35, 245, 120, 223, 66, 129, 141, 248, 197, 108, 188, 171}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 177, 122, 196}, 80},
	{{166, 0, 158, 6, 40, 21, 171, 74, 146, 243, 20, 2, 228, 48, 107, 96}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 254, 135, 108, 180}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 195, 125, 30, 221, 118, 161, 172, 232}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 194, 225, 131, 93}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 42, 232}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 46, 232, 214, 10, 190}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 197, 101, 200, 13}, 80},
	{{166, 0, 0, 0, 0, 95, 219, 42, 6, 179, 175, 106, 90, 102, 126, 11}, 80},
	{{166, 102, 71, 106, 138, 226, 27, 186, 176, 174, 185, 137, 65, 97, 227, 100}, 80},
	{{166, 0, 145, 205, 138, 253, 184, 30, 64, 92, 159, 49, 81, 151, 123, 1}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 156, 1, 132, 93, 14}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 70, 195, 41, 121}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 31, 31, 220, 251, 152, 81, 203, 201}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 46, 9, 98}, 80},
	{{166, 0, 153, 190, 201, 100, 161, 17, 104, 172, 5, 196, 248, 230, 201, 167}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 240, 152, 241, 42, 26, 31, 237, 204}, 80},
	{{166, 0, 0, 100, 49, 233, 66, 71, 232, 219, 237, 110, 123, 233, 117, 239}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 59, 15}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 200, 140, 184, 74, 1, 59, 151, 3, 167}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 176, 55, 79, 84, 15}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 124, 145, 250, 15, 195}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 24, 82}, 80},
	{{166, 0, 0, 0, 147, 167, 171, 57, 240, 38, 120, 80, 176, 50, 7, 160}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 168, 184, 134}, 80},
	{{166, 0, 0, 0, 0, 0, 11, 192, 106, 219, 25, 20, 44, 48, 117, 156}, 80},
	{{166, 0, 76, 26, 173, 105, 199, 8, 88, 114, 19, 139, 191, 171, 185, 235}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 53, 204, 193, 144, 131, 223, 198}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 141, 72, 166, 53, 186}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 123, 110, 63, 242, 146, 92, 122, 103}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 110, 183, 169, 62, 1, 255, 158, 56, 67}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 2, 63}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 75}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 22, 149, 92, 35, 216, 149, 207, 12, 7}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 243, 176, 82}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 73, 159, 43}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 216, 73, 102, 127}, 80},
	{{166, 0, 0, 68, 0, 222, 131, 238, 240, 188, 38, 109, 215, 206, 166, 203}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 80},
	{{166, 0, 0, 16, 90, 237, 13, 229, 62, 251, 191, 180, 141, 151, 214, 123}, 80},
	{{166, 0, 0, 0, 0, 0, 182, 157, 166, 79, 38, 169, 193, 152, 24, 57}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 92, 84, 4}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 167, 118, 122, 115, 235, 45, 112, 25}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 64, 111}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 100, 204, 53, 43, 63, 191, 211, 54, 249}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{166, 0, 145, 78, 91, 207, 95, 186, 114, 154, 127, 247, 213, 16, 8, 244}, 80},
	{{166, 0, 0, 217, 28, 23, 80, 204, 155, 18, 14, 36, 237, 91, 42, 156}, 80},
	{{166, 0, 200, 161, 91, 28, 135, 193, 201, 45, 239, 72, 213, 41, 143, 82}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 231, 89, 228, 140, 121, 219, 199}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 241}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 183, 159, 214, 194, 153, 20, 9}, 80},
	{{166, 0, 0, 0, 0, 211, 44, 116, 189, 7, 145, 136, 195, 157, 208, 69}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 20, 136, 104, 59, 255, 80, 221, 232, 173}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 164, 229, 99, 64, 145, 222, 167, 43}, 80},
	{{166, 0, 172, 110, 120, 141, 210, 228, 130, 211, 181, 170, 38, 208, 225, 120}, 80},
	{{166, 0, 0, 0, 0, 0, 67, 172, 14, 65, 142, 203, 187, 29, 71, 243}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 84, 196, 26, 142, 19}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 196, 133, 19, 205, 84}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 80, 204, 95, 208, 66, 105, 254, 132}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 176, 3, 90, 246, 169, 78, 37, 151, 85}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 184, 69, 136, 66, 124, 245, 244, 74}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 134, 245, 12}, 80},
	{{166, 0, 0, 0, 0, 91, 131, 224, 222, 87, 56, 198, 100, 200, 77, 244}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 47}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{166, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 48, 63, 143}, 80},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 131, 164}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 80, 237, 242, 181}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 54, 207, 60, 14, 110}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 233, 154, 232, 55, 54, 3}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 101, 206, 98}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 203, 226, 241, 22}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 19, 117, 136, 137, 52}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 79}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 46, 169, 209, 215, 162, 98}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 224, 119, 207, 227, 167}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 228, 29, 70}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 163, 52, 40}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 40, 7, 62}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 143, 100, 92, 121, 62}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 255, 27, 241, 14}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 23, 116, 144, 89}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 231, 211, 230}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 46}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 153, 28, 18}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 121, 128, 195, 169, 17}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 30, 251, 244}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 110}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 231, 57, 151, 216, 226}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 248, 216, 253, 156}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 66, 243}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 191, 0, 121, 241, 47}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 67, 246, 92}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 16, 6, 18}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 60, 17, 29, 102}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 37}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 33}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 235, 144, 148, 166, 129}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 135, 195, 108, 107, 188}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 196, 51}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 254, 240, 113, 172, 107, 209}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 126}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 84, 176, 210, 181, 32, 10}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 154, 88, 135, 84, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 201, 199}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 154}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 188, 1}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 136, 108}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 101, 117, 199, 195}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 45}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 36, 191, 211, 198}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 208, 8, 134, 83, 229}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 75, 244, 187}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 92, 236, 156}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 74, 228}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 86, 234}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 255, 161}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 196, 191, 85, 226}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 17, 246, 143}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 140, 184, 87}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 81, 81}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 10, 155, 139, 143}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 149, 89, 235, 161}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 151, 137, 21, 17, 31}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 10}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 227, 68, 202}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 162, 19, 253, 50}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 117, 233, 12, 154, 59}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 243, 60, 156}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 175, 7, 96, 221}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 203, 208, 145}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 212, 44, 59}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 0}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 62, 224, 170, 144}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 89, 198}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 188, 155, 199}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 17, 76, 167}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 164, 140, 116, 27, 178}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 213, 32, 139}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 85, 16, 255, 228}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 80, 251, 12, 30, 219}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 180, 87, 28, 39}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 68, 84, 227, 86, 239}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 4, 88, 15, 228}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 4, 79, 148, 41}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 0, 3}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 0, 0, 44, 201}, 133},
	{{29, 190, 131, 215, 232, 246, 41, 226, 52, 192, 0, 0, 4, 151, 150, 255}, 133},
	{{138, 74, 163, 93, 12, 0, 0, 218, 131, 58, 115, 80, 247, 174, 85, 250}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 176, 163, 187, 62, 120, 240, 220}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 199, 183, 41, 240, 6, 166, 68, 175, 197}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 240, 119, 35, 230, 166, 112}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 45, 165, 97, 140, 144}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 237}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 162, 148, 235, 110, 171}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 81, 180, 240, 149, 21, 15, 206, 207, 142}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 20, 190, 254, 181, 126, 21, 225, 142}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 176, 82, 73, 10, 23, 103}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 57, 219, 118, 172}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 146, 168, 201, 55, 75, 241, 220, 138}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 168, 231, 116, 13}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 68, 216, 111}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 236, 60, 117, 246, 190, 66, 201}, 93},
	{{138, 74, 163, 93, 12, 0, 226, 98, 70, 136, 226, 99, 156, 94, 23, 161}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 199, 144, 59}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 77, 170, 93, 17, 137, 133, 85}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 22, 83, 24, 22}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 5, 83, 219, 44, 101, 164}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 216, 193, 81, 5, 70}, 93},
	{{138, 74, 163, 93, 12, 0, 77, 14, 245, 82, 194, 72, 117, 86, 145, 3}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 232, 15, 220, 67, 245}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 21, 78, 203, 220, 104, 87, 145, 145, 243}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 183, 107, 117, 140, 135, 140, 84, 181, 207}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 43, 15, 248, 110, 12, 216}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 58, 54, 162, 106, 60, 57, 26, 121}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 96}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 125, 33, 53, 159}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 13, 10, 213, 211, 9, 35, 181}, 93},
	{{138, 74, 163, 93, 12, 0, 115, 159, 120, 145, 224, 50, 242, 16, 122, 54}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 82, 22, 188, 99, 60, 73, 161}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 102}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 67, 15, 190, 183}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 226, 239, 89, 215, 13, 65, 181}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 168, 95, 82, 199}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 75, 110, 5, 134}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 65, 118, 178, 45, 255, 77}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 239, 210, 128, 228, 112, 144, 92, 241}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 57, 53, 97, 107, 72, 217, 155, 30, 243}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 251, 191, 88, 78, 214}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 240, 252, 94}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 162, 89, 184, 214}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 235, 12, 224, 167, 50}, 93},
	{{138, 74, 163, 93, 12, 247, 90, 129, 138, 219, 24, 197, 12, 54, 244, 203}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 94, 246, 144, 121, 218, 160, 203, 1, 192}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{138, 74, 163, 93, 12, 0, 103, 208, 18, 80, 136, 221, 92, 51, 153, 69}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 221, 0, 9, 238, 149}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 244, 236, 237, 220, 22}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 229, 176, 190, 127, 87, 5, 4, 247, 17}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 190, 241, 129, 148, 45, 146}, 93},
	{{138, 74, 163, 93, 12, 0, 123, 16, 0, 166, 104, 207, 138, 12, 118, 51}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 146, 93, 104, 47, 218, 10}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 93},
	{{138, 74, 163, 93, 12, 0, 184, 207, 118, 11, 151, 100, 213, 199, 239, 210}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 81, 88, 213, 87}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 189, 41, 249, 79, 165, 116, 174, 63}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 143, 50, 161, 73}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 161, 69, 159, 31, 86, 6, 242, 33}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 103, 85, 122, 233, 122}, 93},
	{{138, 74, 163, 93, 12, 0, 156, 246, 167, 201, 22, 57, 156, 83, 129, 148}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 94, 133, 44, 155, 24, 97, 18}, 93},
	{{138, 74, 163, 93, 12, 0, 170, 241, 40, 164, 249, 168, 227, 109, 218, 217}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 155, 5, 9, 40, 214, 97, 28, 153}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 185, 242, 125, 82, 8, 194, 204, 213}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 108, 162, 136, 26, 132, 64, 46}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 95, 23, 75, 237}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 149, 113, 223, 26, 75, 57, 63}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 162, 88, 235, 77}, 93},
	{{138, 74, 163, 93, 12, 0, 252, 122, 58, 98, 219, 63, 130, 94, 154, 103}, 93},
	{{138, 74, 163, 93, 12, 0, 217, 74, 104, 173, 143, 7, 153, 54, 232, 171}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 58, 251, 222}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 195, 179, 209, 68}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 255, 188, 85, 69, 92, 175, 168, 41, 212}, 93},
	{{138, 74, 163, 93, 12, 0, 91, 66, 75, 149, 159, 237, 112, 134, 0, 5}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 164, 115, 192, 121, 167}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 0, 73, 188, 38, 247}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 221, 223, 245, 244, 157, 225, 245, 56}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 231, 188, 236, 47, 142, 120, 136, 77, 74}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 41, 181, 115, 14, 186, 67, 13, 35}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 0, 0, 0, 0, 216, 212, 150, 137, 137}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 65, 142, 203, 78, 76, 131, 226, 187, 25}, 93},
	{{138, 74, 163, 93, 12, 0, 0, 181, 180, 83, 22, 187, 254, 238, 161, 27}, 93},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 116}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 88}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 228, 222}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 165}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 226}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 192}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 63}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 221}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 1}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 63}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 133, 96}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 14}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 65}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 141}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 243}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 15, 52}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 129}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 230}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 205}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 251}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 14}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 140}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 252}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 87}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 85, 43}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 236}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 82, 9}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 250}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 49}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 238, 55}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 141}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 183, 138}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 56}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 141, 23}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 52}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 137}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 41}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 48}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 162, 71}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 173}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 63}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 228}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 18, 49}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 124}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 163}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 6, 48}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 10}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 10}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 74}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 235}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 246}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 0}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 133}, 176},
	{{229, 64, 97, 41, 28, 243, 249, 185, 97, 35, 49, 27, 175, 24, 0, 168}, 176},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 58, 42}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 63, 53}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 204}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 242, 46, 203}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 225}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 180}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 158, 97, 100}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 222, 231, 78}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 247}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 121, 172, 199}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 11}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 254}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 120}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 243, 96, 191}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 111}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 217, 252, 57}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 252}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 59}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 166, 79, 53}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 247}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 138, 170, 201}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 19}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 208, 179, 53}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 182, 230, 32}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 104, 209, 53}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 64, 216}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 76, 153}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 156}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 194, 103, 25}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 251, 44, 136}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 97}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 254, 133, 243}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 245}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 66, 145, 211}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 230}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 238, 92, 142}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 21, 54}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 147}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 8}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 111, 216}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 64, 221, 249}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 201, 150}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 101, 175}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 34}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 6, 247}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 205, 43}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 36}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 234, 111, 192}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 119, 216, 226}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 138, 114}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 118}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 191}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 147, 222, 90}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 222}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 135}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 71, 110}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 54}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 1, 185, 193}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 123, 181, 16}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 49, 81}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 151, 55, 135}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 133}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 205, 243, 186}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 107}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 63, 95}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 205, 90, 193}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 178, 207, 205}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 209, 120, 51, 50}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 226, 96}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 201, 131}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 130, 83}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 0}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 89}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 0, 0, 71}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 52, 193, 203}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 65, 169, 236}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 155, 7, 221, 122}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 252, 19, 182}, 68},
	{{6, 73, 94, 160, 186, 216, 84, 117, 233, 169, 146, 234, 0, 39, 78, 215}, 68},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 202, 165}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 45, 190}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 105, 83}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 226}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 168, 90}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 133, 248}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 40}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 162}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 53}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 162, 221}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 107}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 204, 233}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 53, 206}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 209}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 170, 67, 240}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 142, 71}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 57, 184}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 142, 110}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 227}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 69, 224}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 21, 169}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 11}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 77, 59}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 114, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 164}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 171}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 67}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 102, 90}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 27, 101}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 211}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 47}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 3, 172}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 36, 113}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 199, 231}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 249}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 124, 236}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 200}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 68, 153}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 246, 147}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 60}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 191}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 203}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 225, 144}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 148, 71}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 209, 39}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 63}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 15, 3}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 40, 191}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 83}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 41}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 84, 255, 44}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 231}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 254, 248}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 136, 12, 200}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 94, 208}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 81, 182}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 28, 197}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 81}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 106}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 122, 105}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 100}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 155}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 246, 212}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 178}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 154}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 166, 59}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 181}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 229}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 68, 95}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 117}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 201, 154}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 48, 60}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 202, 230}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{163, 40, 242, 81, 224, 35, 72, 194, 176, 78, 224, 174, 12, 0, 0, 0}, 247},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 65, 150, 104, 171, 54, 64, 184, 125, 172}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 249, 6, 222, 246, 68, 52}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 219}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 136}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 109, 93, 7, 72, 110, 81, 9}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 207, 86, 75, 18, 248}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 207, 255, 210, 94, 148, 13, 98, 158, 81}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 86, 61, 154, 11, 179, 28, 15, 250, 98}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 135}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 219, 28, 45, 221, 10, 44, 56, 196}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 16, 125, 154, 55, 42, 14, 22, 155, 37}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 86, 106, 105, 210, 76, 137, 69, 51, 229}, 240},
	{{2, 205, 40, 24, 0, 103, 160, 82, 33, 103, 244, 27, 233, 244, 101, 114}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 184, 69, 42, 118, 65, 193}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 92, 146, 126, 193, 253}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 210, 57, 91, 19, 76, 246, 122}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 1}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 227, 182, 209, 161, 153, 46, 21, 2}, 240},
	{{2, 205, 40, 24, 0, 0, 126, 143, 55, 196, 27, 237, 234, 148, 12, 53}, 240},
	{{2, 205, 40, 24, 0, 61, 136, 17, 128, 26, 154, 126, 143, 38, 48, 165}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 104, 227, 198, 84, 67, 69}, 240},
	{{2, 205, 40, 24, 0, 0, 221, 181, 75, 214, 71, 205, 62, 112, 151, 158}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 46, 35, 28, 239, 204, 41, 178, 190}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 217, 127}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 164}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{2, 205, 40, 24, 0, 0, 84, 201, 0, 201, 142, 137, 176, 7, 162, 175}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 55, 12, 240, 48}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 222, 253, 66, 212, 96, 244, 249, 62, 166}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 79, 29, 146, 173, 226, 102, 77, 3, 228}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 201, 103, 175, 201}, 240},
	{{2, 205, 40, 24, 0, 238, 149, 224, 151, 251, 170, 2, 51, 192, 192, 70}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 227, 63}, 240},
	{{2, 205, 40, 24, 0, 0, 98, 241, 1, 24, 35, 83, 152, 148, 142, 106}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 94, 22}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 64, 141, 69, 26, 104, 47, 103}, 240},
	{{2, 205, 40, 24, 0, 104, 22, 74, 153, 197, 237, 51, 9, 134, 232, 181}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 120, 204, 82, 15}, 240},
	{{2, 205, 40, 24, 0, 222, 1, 51, 171, 118, 175, 43, 164, 108, 23, 187}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 190, 39, 238, 206, 116, 56, 96}, 240},
	{{2, 205, 40, 24, 0, 0, 38, 184, 172, 82, 106, 119, 39, 77, 83, 61}, 240},
	{{2, 205, 40, 24, 0, 0, 101, 185, 222, 19, 19, 70, 151, 116, 181, 252}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 161, 93, 227, 161, 15, 74}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 188, 10, 160, 189, 57}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 178, 94, 170, 238, 33, 90, 184}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 211, 177, 22, 182, 240, 130, 9, 99}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 231}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 184, 199, 234, 215, 16, 177}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 110, 145, 35, 55, 46, 58, 1, 57, 30}, 240},
	{{2, 205, 40, 24, 0, 73, 102, 13, 248, 148, 42, 94, 76, 182, 233, 249}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 136}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 60}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 138, 25, 208, 17, 144, 35}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 139}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 57, 146, 112, 23, 145, 16, 242}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 158, 85, 189, 108, 121}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 3, 166, 152, 213, 157, 161, 227}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 30, 254, 30, 126, 146}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 219}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 178, 160, 33, 136, 134, 105}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 36, 181, 191, 105, 160, 92, 42, 52, 133}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 85, 14, 109, 167, 172, 119, 201, 53, 42}, 240},
	{{2, 205, 40, 24, 0, 0, 194, 152, 63, 255, 53, 159, 37, 63, 76, 156}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 27}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 126, 188, 98, 216, 109, 211}, 240},
	{{2, 205, 40, 24, 0, 36, 239, 254, 195, 195, 203, 93, 175, 254, 86, 11}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 114, 156, 18, 187, 168, 62, 134}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 181, 23, 66, 37, 43, 223, 44, 139}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 58, 69, 24, 120, 182, 36, 76}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 250, 9, 188, 181}, 240},
	{{2, 205, 40, 24, 0, 203, 25, 173, 116, 89, 207, 51, 115, 227, 236, 76}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 32}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 76, 189, 109, 235, 144}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 69, 157, 190, 214, 191, 49, 59, 111}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 146, 120, 54, 145, 3}, 240},
	{{2, 205, 40, 24, 0, 224, 86, 255, 133, 229, 152, 16, 169, 151, 199, 237}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 51, 114, 10, 120}, 240},
	{{2, 205, 40, 24, 0, 0, 80, 193, 22, 202, 28, 134, 173, 109, 58, 199}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 52, 159, 27, 157, 123, 108, 184}, 240},
	{{2, 205, 40, 24, 0, 65, 178, 63, 90, 198, 244, 239, 52, 23, 70, 138}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 85, 15, 210, 176, 43, 54, 125}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 31}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 9}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 130}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 18}, 240},
	{{2, 205, 40, 24, 0, 0, 0, 0, 0, 0, 0, 26, 89, 183, 72, 166}, 240},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 58, 96, 63}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 29}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 114, 196, 160, 156, 150, 237}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 249, 100}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 19, 255, 238}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 181, 17, 192, 104}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 151, 117, 249, 114, 126}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 161, 24, 50, 27, 54}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 88, 232, 24, 142}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 183}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 179, 170}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 143, 168, 192, 146, 192, 248}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 91, 121, 61, 72}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 101}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 154}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 199, 15}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 136, 168, 166, 227, 1, 217}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 94, 144, 85, 11, 235, 75}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 203}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 145, 96, 18, 84, 21, 63}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 117, 35, 195, 17, 216}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 148, 123, 174, 83, 73, 82}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 235, 204}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 114, 210, 122, 74}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 4, 205, 57, 127, 91, 248}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 102, 237}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 92, 247, 26}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 170}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 178, 71, 59, 241, 65, 183}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 144, 25, 179}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 218}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 124, 88, 66, 212}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 12, 157, 169}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 163, 196, 171, 253, 142}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 244, 32, 229}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 180, 196, 200}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 250, 211, 8, 122}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 228, 221, 58, 161, 2}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 121, 170, 31, 186}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 80, 94}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 71, 224}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 92, 101, 222, 61, 3, 170}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 11, 104, 207, 217, 70}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 210, 120, 5, 107, 159, 153}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 51, 124, 249}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 2, 208, 85, 88}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 130, 77, 69, 205, 244}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 161, 219}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 54, 233, 193, 4, 59, 9}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 234}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 85, 118}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 82, 216, 231, 96}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 244, 120, 189, 185}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 210, 152, 220, 149}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 206, 209, 154, 236}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 65, 203, 172, 5}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 34, 146}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 159, 253}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 202, 91, 66}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 193, 118, 184, 4, 143}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 176, 173, 158, 93}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 193, 156, 19, 130}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 175}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 132}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 139, 6}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 74, 255}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 0}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 246}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 142, 77, 179, 240, 194}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 243, 232, 3, 25, 210, 86}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 118, 72, 216, 236, 29}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 51, 116, 93, 184, 42}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 53, 138, 177, 90}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 1, 94, 21}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 161, 250, 206}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 33}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 100, 69, 6, 63, 130, 59}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 249, 192, 199, 193}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 82}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 0, 0, 0, 199}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 227, 31, 202, 254, 242, 158}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 0, 121, 148, 150, 198}, 83},
	{{174, 225, 240, 160, 212, 8, 246, 67, 36, 0, 0, 90, 165, 70, 198, 96}, 83},
	{{5, 117, 182, 141, 166, 249, 196, 0, 31, 223, 183, 92, 76, 48, 191, 23}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 236, 57, 22, 183, 2, 64, 135, 134}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 219, 166}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 140, 4, 200, 46}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 90, 250, 52, 217, 163, 188}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 242, 154, 239, 180}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 111, 94, 14, 120, 35}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 80, 74, 38, 74, 37}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 204, 178, 152, 218, 98}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 61, 118, 106, 184, 136, 20}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 39, 148, 149, 61, 219, 66, 168, 228}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 214, 223, 93, 168, 123, 122, 34, 92}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 173, 122, 186, 43, 143}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 26, 70, 13, 174, 31, 61, 236}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 121, 235}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 177, 255, 239}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 242, 50, 127, 184, 132}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 194, 97, 128, 220}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 172, 103}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 22}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 251, 132, 163, 197}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 63, 198, 203}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 238, 59, 160, 241, 60}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 201, 197, 196, 38, 235}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 14, 156, 152}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 82}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 33, 208, 238, 25, 95, 244, 234, 253, 192}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 79, 6, 222}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 19, 115, 160}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 126, 218, 123, 227, 226, 169, 70, 164}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 158, 69, 27, 254, 98, 156}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 156, 168, 61, 3, 214, 160}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 218, 150, 89}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 211, 94, 149, 248, 186, 49}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 112, 102, 51}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 236, 38, 202, 47, 115, 93, 141, 235}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 19, 29, 57, 178, 220, 27}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 108, 98, 72, 57}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 233, 129, 65}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 116, 247, 33, 0, 17, 207, 13, 244}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 89, 74, 35}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 178, 243, 69, 199, 100}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 92, 169, 163, 74, 237, 220, 146}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 190, 89, 178, 193, 76, 203, 37, 94}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 103, 90, 101, 99, 40, 61, 8}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 75, 6}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 145, 35}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 139, 250, 226, 217, 54, 93, 184}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 151, 193, 182, 194, 115}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 92, 89, 178, 110, 38, 80, 241}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 234, 253, 170, 209}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 228, 64, 250, 189, 208, 132}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 52, 20, 161, 72, 222, 208, 51, 90}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 17, 154, 39, 88, 210}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 180, 195, 79}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 104, 170, 86}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 148, 13, 39, 136, 161, 22}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 26, 43, 251, 204}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 250, 188, 66, 69, 31, 201, 114}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 234, 207, 51, 52}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 24, 107, 247, 109, 71, 25}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 44, 44, 250, 126, 26, 76, 68, 104}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 186, 10}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 157, 254, 195}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 116, 73, 214, 91, 72, 0, 84, 164}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 113, 251, 140, 91, 46, 7, 17}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 220, 229, 208, 38, 250, 167}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 73, 20}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 165, 230, 49, 9, 3, 233, 89}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 142, 224, 177, 239, 219, 29}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 81, 187, 107, 240, 197, 192, 18, 139}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 234, 127, 35, 216, 55}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 113, 59, 181, 31, 31}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 156, 155, 18, 84, 59, 124, 149, 133}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 0, 0, 0, 0, 0, 0, 0, 232}, 132},
	{{5, 117, 182, 141, 166, 249, 196, 0, 137, 43, 222, 31, 202, 101, 48, 192}, 132},
	{{46, 152, 169, 0, 0, 0, 214, 135, 124, 184, 187, 199, 54, 77, 189, 232}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 201, 104, 173, 25, 97, 172, 164}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 158, 171, 43, 49, 242, 173}, 217},
	{{46, 152, 169, 0, 0, 1, 241, 15, 7, 41, 4, 62, 112, 66, 121, 41}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 246}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 148, 55, 23}, 217},
	{{46, 152, 169, 0, 188, 144, 203, 120, 99, 159, 121, 214, 202, 79, 83, 128}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 107, 167, 80, 175, 149, 194, 113}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 47, 166, 111, 236, 104, 147}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 204, 10}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 110, 51, 251}, 217},
	{{46, 152, 169, 0, 0, 24, 208, 96, 240, 77, 12, 46, 205, 57, 92, 9}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 12, 171, 188, 207, 188, 236}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 14, 87, 73}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 187}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 70, 94, 25, 51, 188, 177, 49}, 217},
	{{46, 152, 169, 0, 0, 0, 173, 246, 139, 143, 133, 106, 172, 55, 191, 93}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 213, 45, 93, 8, 248, 63, 233, 133, 113}, 217},
	{{46, 152, 169, 0, 0, 226, 66, 88, 97, 18, 70, 112, 8, 159, 54, 239}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 242, 96, 244, 9, 183, 105, 240, 12}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 15, 126, 236}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 188, 33, 24}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 204, 82, 228, 179, 39}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 128, 106, 29, 123, 226, 95}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 183, 247, 85, 151, 53, 173}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 81, 40, 10, 145, 92, 147, 109, 37, 246}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 70, 214, 243, 53, 9, 83, 143, 190}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 82, 32}, 217},
	{{46, 152, 169, 0, 16, 56, 98, 111, 171, 252, 47, 243, 85, 145, 72, 207}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 68, 246}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 83, 145, 186, 105, 249, 122, 238, 159}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 109, 40, 251, 234, 252}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 247, 49, 252}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 46, 35, 236, 14, 3, 124, 51, 131, 254}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 42, 41, 157, 190, 170, 103, 108, 104}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 196, 252, 249, 153, 255, 142, 96, 138, 167}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 83, 65, 193, 57, 178}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 94, 57, 121, 0, 190, 52, 159}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 115, 6, 141, 201, 107}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 130, 192}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 24, 210, 116, 88, 44}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 133, 132, 17, 20, 77, 120, 155}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 222, 81, 50, 125, 189, 87, 189, 111, 1}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 61, 117, 196}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 153, 240, 125, 89, 78, 156, 219}, 217},
	{{46, 152, 169, 0, 135, 103, 153, 167, 27, 167, 247, 163, 4, 159, 71, 46}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 128, 149, 13, 159, 158, 160, 34}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{46, 152, 169, 0, 0, 0, 61, 108, 159, 191, 69, 150, 69, 72, 196, 5}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 3, 90, 252, 20, 153, 146}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 83, 225, 116, 255, 98}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 177, 74, 211}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 51, 7, 3}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 168, 23, 16, 181, 150}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{46, 152, 169, 0, 219, 69, 126, 20, 29, 36, 171, 152, 82, 71, 11, 148}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 110, 156, 46, 114, 214, 163, 203, 6, 44}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 16, 235, 241, 151, 185, 36, 171, 129}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 144, 165, 179, 106, 153}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 142, 82}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 29, 127, 144}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 48, 109, 167, 97, 93, 74, 187, 153, 169}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 137, 168, 235, 22, 124, 127, 164, 96}, 217},
	{{46, 152, 169, 0, 0, 196, 235, 223, 103, 188, 61, 50, 229, 166, 119, 86}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 19, 163, 33}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 35, 86, 149, 186, 76, 250, 88}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 6, 179}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 176}, 217},
	{{46, 152, 169, 0, 0, 106, 75, 248, 133, 111, 114, 234, 2, 29, 255, 139}, 217},
	{{46, 152, 169, 0, 0, 4, 153, 132, 51, 236, 19, 133, 223, 155, 207, 94}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 184, 240, 119, 182, 180}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 207, 148, 204, 108, 50, 213, 130}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 13, 117, 233, 26, 136, 28, 125}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 7, 200, 73, 113, 74, 151, 205, 140}, 217},
	{{46, 152, 169, 0, 0, 185, 65, 62, 222, 39, 26, 209, 223, 61, 9, 214}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 215, 163, 158, 202, 159, 53, 129}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 12, 55, 158, 92, 9, 134, 45, 7, 34}, 217},
	{{46, 152, 169, 0, 0, 0, 209, 223, 212, 204, 78, 168, 186, 216, 86, 151}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 1, 27, 42, 57, 90, 182, 247}, 217},
	{{46, 152, 169, 0, 0, 0, 71, 171, 241, 72, 206, 3, 78, 50, 87, 198}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 217},
	{{46, 152, 169, 0, 0, 39, 13, 93, 175, 181, 44, 225, 125, 27, 122, 116}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 231, 126, 29, 114, 240, 230, 113}, 217},
	{{46, 152, 169, 0, 0, 1, 226, 83, 219, 205, 42, 80, 146, 64, 53, 48}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 170, 103, 202, 147, 231, 87, 5, 94, 139}, 217},
	{{46, 152, 169, 0, 0, 0, 247, 208, 167, 208, 107, 41, 90, 242, 170, 118}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 225, 19, 88, 143, 190, 88, 153, 101}, 217},
	{{46, 152, 169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 98}, 217},
	{{46, 152, 169, 0, 88, 62, 14, 230, 14, 217, 255, 30, 10, 213, 130, 157}, 217},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 24}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 205, 107, 157, 198}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 215}, 61},
	{{0, 0, 0, 0, 250, 233, 114, 182, 238, 224, 246, 248, 106, 211, 94, 142}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 0, 30}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 123, 167, 7, 13, 75, 43, 112, 165}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 249, 219, 169}, 61},
	{{0, 0, 0, 137, 19, 7, 12, 97, 224, 10, 22, 50, 253, 55, 213, 136}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 183, 140, 98, 98, 210, 184, 2, 198}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 222}, 61},
	{{0, 0, 10, 103, 98, 113, 170, 243, 106, 6, 99, 207, 49, 34, 139, 16}, 61},
	{{0, 0, 99, 116, 196, 153, 6, 25, 150, 118, 54, 58, 110, 41, 26, 36}, 61},
	{{0, 0, 0, 0, 0, 167, 250, 15, 92, 243, 248, 241, 64, 206, 237, 255}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 220, 89, 244, 155}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 228, 171, 87, 192}, 61},
	{{0, 0, 0, 0, 0, 0, 236, 28, 111, 95, 77, 136, 129, 3, 1, 216}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 249}, 61},
	{{0, 237, 199, 237, 214, 56, 44, 163, 196, 122, 160, 51, 60, 37, 37, 23}, 61},
	{{0, 0, 0, 0, 0, 182, 7, 147, 39, 118, 184, 243, 22, 240, 118, 152}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 27, 81, 72, 159, 212, 18, 24, 196, 3, 25, 94, 177, 149, 76}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 172, 184, 21, 95, 160, 32}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 218}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 229, 54, 1, 93, 81, 255}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 76, 151, 34, 107}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 8, 160, 222, 150}, 61},
	{{0, 0, 0, 19, 87, 104, 5, 140, 180, 124, 238, 228, 101, 148, 90, 225}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 23}, 61},
	{{0, 0, 170, 174, 173, 49, 109, 61, 141, 118, 16, 0, 198, 139, 144, 255}, 61},
	{{0, 144, 49, 240, 149, 73, 65, 240, 98, 128, 136, 182, 252, 76, 145, 185}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197}, 61},
	{{0, 0, 0, 0, 0, 0, 247, 120, 223, 56, 76, 213, 198, 217, 12, 88}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 5, 126, 85, 90, 20}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 16, 79, 35, 149}, 61},
	{{0, 0, 38, 48, 226, 45, 143, 30, 95, 40, 44, 86, 37, 148, 26, 125}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 199, 226}, 61},
	{{0, 52, 93, 199, 208, 170, 160, 158, 62, 187, 64, 153, 80, 128, 15, 6}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 61, 136, 84, 224, 36}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 204, 176}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 61},
	{{0, 0, 0, 0, 0, 0, 118, 234, 215, 171, 14, 242, 170, 74, 119, 101}, 61},
	{{0, 0, 0, 0, 0, 0, 44, 75, 75, 176, 23, 209, 24, 106, 47, 138}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 137, 98}, 61},
	{{0, 0, 0, 0, 0, 90, 219, 188, 87, 233, 113, 175, 205, 181, 184, 20}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 227, 92, 97, 115}, 61},
	{{0, 0, 0, 0, 0, 0, 102, 235, 214, 161, 143, 146, 41, 0, 173, 112}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 83, 244, 185}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 219, 231, 188}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 213, 231, 98, 176, 80, 112, 7, 141}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 106, 155, 190}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 20, 14, 189, 142, 90, 195}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 169}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 230, 183}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 25, 129, 65, 77, 216, 163, 18, 125, 95}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 128}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 52, 196}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 152, 72, 14}, 61},
	{{0, 0, 62, 228, 215, 77, 202, 134, 22, 2, 240, 54, 26, 246, 89, 62}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 190, 204, 103, 64, 126, 212}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 232, 201, 122}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 79, 89, 93}, 61},
	{{0, 0, 0, 0, 0, 0, 183, 157, 153, 0, 49, 40, 12, 84, 59, 224}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 42}, 61},
	{{0, 0, 0, 0, 34, 107, 146, 31, 121, 127, 208, 77, 217, 10, 207, 128}, 61},
	{{0, 0, 0, 105, 198, 119, 50, 24, 61, 0, 92, 5, 205, 114, 177, 32}, 61},
	{{0, 0, 0, 0, 0, 133, 169, 114, 29, 80, 52, 203, 246, 21, 183, 159}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 190, 96, 130, 80, 140, 91}, 61},
	{{0, 0, 0, 0, 38, 239, 149, 241, 240, 64, 64, 190, 32, 106, 65, 251}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 220}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 147, 137, 195, 191, 16, 220, 245, 103, 53}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 239}, 61},
	{{0, 0, 0, 180, 229, 0, 85, 126, 212, 110, 17, 176, 250, 246, 77, 33}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 128, 173, 236, 151, 70}, 61},
	{{0, 0, 0, 0, 0, 0, 73, 21, 201, 56, 93, 13, 121, 129, 16, 61}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 135, 32, 129, 132}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 124, 116}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 233, 168, 0, 229}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 29, 255, 40}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 209, 212, 218, 17, 200}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 111, 50}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 239, 17, 5}, 61},
	{{0, 0, 0, 0, 0, 0, 150, 37, 67, 44, 134, 40, 213, 194, 72, 231}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 226}, 61},
	{{0, 0, 0, 0, 0, 179, 215, 48, 24, 70, 198, 10, 166, 141, 148, 90}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 150, 227, 163, 155}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 78, 176, 241, 240, 18, 172, 156, 62}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 249, 104, 231, 227, 15, 209}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 158, 86, 69, 125, 153}, 61},
	{{0, 0, 0, 16, 207, 141, 210, 103, 224, 121, 175, 5, 112, 155, 126, 115}, 61},
	{{0, 0, 0, 0, 244, 149, 194, 121, 80, 39, 19, 23, 120, 206, 195, 120}, 61},
	{{0, 0, 0, 0, 0, 139, 54, 239, 86, 182, 139, 86, 204, 132, 15, 154}, 61},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 28}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 110, 231}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 147, 167, 142, 1, 219, 164}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 7}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 112, 200, 78, 199, 90}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 165, 47, 64, 9}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 115, 48, 64, 190, 40, 62}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 6, 240, 121, 247}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 90, 57, 224, 71, 126, 226, 167}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 163, 132, 8, 70, 126, 52}, 193},
	{{233, 202, 159, 219, 0, 0, 110, 174, 243, 90, 74, 170, 86, 96, 181, 124}, 193},
	{{233, 202, 159, 219, 0, 0, 162, 137, 75, 225, 38, 149, 184, 166, 107, 9}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 102, 76, 184, 102, 207, 57, 153}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 68, 148, 93, 30}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 241}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 235, 27, 244, 192, 224, 45, 71}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 45, 160, 104, 93, 246, 37}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 80, 122}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 221, 149, 160, 84, 154, 86, 206, 106, 211}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 31}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 34}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 139, 179, 237, 218, 192, 103, 120}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{233, 202, 159, 219, 0, 0, 188, 92, 221, 119, 70, 48, 109, 193, 181, 135}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 231}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 122, 146, 246, 161, 7, 178}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 123, 175, 233, 59, 232, 186, 90}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 120, 209, 19, 194, 36, 117}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 159, 243, 8, 114, 219, 155}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 106, 6}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 114}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 246, 122, 37, 233, 250, 45, 128}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 155, 20, 35, 254, 238, 228, 179, 85, 78}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 111, 188, 15, 243, 82, 243, 224, 65}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 27, 95, 4, 8, 227}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 77, 15, 161, 143, 235, 111, 245}, 193},
	{{233, 202, 159, 219, 0, 0, 195, 227, 43, 178, 150, 124, 137, 251, 137, 27}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 23, 100, 194, 117, 189, 241, 122, 38, 182}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 103}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 67, 88}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 126, 23, 224, 44, 126, 76, 136, 48}, 193},
	{{233, 202, 159, 219, 0, 34, 185, 3, 96, 201, 71, 253, 89, 121, 74, 28}, 193},
	{{233, 202, 159, 219, 0, 167, 173, 213, 234, 99, 57, 88, 15, 124, 50, 113}, 193},
	{{233, 202, 159, 219, 0, 118, 91, 168, 156, 209, 253, 191, 90, 154, 116, 115}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 139, 19, 90, 73, 249}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 147, 238, 27, 42}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 26, 58, 48, 230, 105, 16, 15, 56, 24}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 217}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 197}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 239, 145, 14, 89, 238, 110}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 38, 27, 190, 229, 135, 61, 66, 137, 94}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 83, 93, 127, 244, 133, 52, 185, 57}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 235}, 193},
	{{233, 202, 159, 219, 0, 109, 254, 71, 101, 245, 185, 11, 98, 155, 222, 96}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 31, 170, 167, 190, 58}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 177, 151, 183, 160}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 183, 76}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 109, 204}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 115, 212, 200, 146, 156, 65}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 209, 152, 32, 7, 146}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 133, 236, 97, 3, 148}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 182, 62, 173, 230, 156, 238}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 171, 104, 137, 158}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 96}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 152, 197, 222, 7, 176, 104, 177}, 193},
	{{233, 202, 159, 219, 0, 100, 210, 121, 81, 173, 178, 170, 147, 14, 92, 195}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 156, 152, 16, 146, 198, 186, 142}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 42, 234, 33, 47, 138, 180, 253}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 90, 79, 114, 203}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 8}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 99, 143, 149, 193, 51}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 35, 84}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 173, 98, 47, 117}, 193},
	{{233, 202, 159, 219, 0, 0, 144, 254, 140, 115, 56, 8, 213, 231, 203, 120}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 210, 23}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 22, 20, 172, 216}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 223}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 248, 49, 180, 182, 87, 80, 102, 148, 62}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 92, 31}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 227, 145, 238, 92}, 193},
	{{233, 202, 159, 219, 0, 0, 215, 12, 109, 162, 111, 250, 120, 248, 202, 37}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 213, 164, 59, 194, 14, 255}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 117, 112, 182, 132, 42, 253, 65, 19}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 252, 32, 212, 16, 225, 222, 84}, 193},
	{{233, 202, 159, 219, 0, 0, 80, 59, 53, 212, 45, 237, 209, 250, 40, 193}, 193},
	{{233, 202, 159, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 193},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 254, 59}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 68, 245, 75, 39, 252, 7}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 250, 53, 247, 152, 46}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 34}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 147, 162}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 25, 207, 61, 20, 237, 175}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 160, 185}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 248, 195, 108, 143, 219, 221}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 249, 238, 174, 213, 97}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 93, 137, 17, 70, 165}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 207, 17, 211, 224}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 23, 198, 212, 32, 87}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 121, 245, 127, 245, 11}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 168, 145, 103}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 131, 34, 39, 113, 212, 28}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 200, 49, 192, 103, 60, 134}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 214, 252, 44}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 253, 36, 40, 53, 204, 43, 54}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 84, 47, 127}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 150, 200, 84, 110}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 15, 254, 223, 167, 12}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 3, 94}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 138}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 167, 194}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 160, 215, 166, 175}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 61, 150}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 35, 70}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 146}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 69, 219}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 47, 48, 101, 62, 37, 27}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 63, 181}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 111}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 63, 201, 243, 121}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 196}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 159, 253, 5, 24, 28}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 121}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 152}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 11, 210, 86}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 121, 57, 185, 145}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 218, 31, 236, 242}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 16, 251}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 31}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 29, 13, 166, 106, 132}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 152}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 210, 19, 231}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 14, 196}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 75, 252, 29, 129}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 213, 40}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 201}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 212, 43, 252}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 65, 213, 43, 103, 79, 98}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 223, 146, 142, 20, 251}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 79, 247, 184, 139, 30, 140}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 217, 131, 92, 129, 39}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 120, 26, 248}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 79}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 94, 39, 2, 13}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 219, 139, 130}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 81, 38, 3, 211}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 246}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 42, 12}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 174, 117, 84}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 128, 242, 126, 213, 129, 191}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 231}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 156, 156, 240, 4, 25, 194}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 110}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 206, 177, 252, 146}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 74, 146, 8}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 97}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 45, 240, 34, 33, 38, 27}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 90, 229}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 121, 109, 114, 138}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 15, 36, 110}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 174, 46, 99, 151, 24}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 245, 112}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 105, 60, 26, 130}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 103, 159, 117, 193, 195}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 104, 208, 208}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 195, 170, 165, 149}, 61},
	{{172, 54, 159, 5, 14, 245, 106, 182, 2, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 162}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 108}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 192, 19, 178, 91}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 100, 130, 14, 89, 236}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 240, 103, 117}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 33, 13, 168, 155}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 21, 231, 180, 233}, 65},
	{{241, 222, 251, 114, 200, 0, 120, 145, 67, 43, 124, 132, 59, 105, 171, 226}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 66, 157, 232, 60}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 92, 109, 219, 209}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 43, 20, 245, 71, 7, 218}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 71, 45, 70, 18, 50, 145, 126}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 224}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 205, 5, 83}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 2, 194, 176, 213, 242, 241, 170}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{241, 222, 251, 114, 200, 0, 135, 228, 125, 145, 144, 27, 100, 45, 231, 51}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 145}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 60}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 171, 122, 142, 43, 160, 22, 201, 80}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 208}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 18, 109, 124, 81, 231, 104}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 197, 117, 10}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 166, 185, 85, 112}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 199, 11, 208, 157, 44}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 26, 236, 187, 131}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 196, 239, 31, 203, 108, 85}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 211, 207, 63, 49, 245, 216, 86, 1}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 78, 104, 184}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 5, 244, 149, 119, 72}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 241}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 40, 139, 128, 117, 107, 163}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 55}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 109, 22, 38, 163, 169, 179, 235, 101}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 143}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 202, 110, 28, 2, 194, 40, 17}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 158, 242, 175}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 120, 182, 103, 170}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 159, 105, 192, 77, 241, 168, 17, 125}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 19}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 70, 231, 222, 158, 107, 65, 205, 9}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 60, 241, 247, 139, 58, 217}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 115, 70, 243, 13, 92, 221, 255}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 139}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 160, 165, 178, 235, 128, 250}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 230, 229, 98, 151, 45, 231, 144}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 199}, 65},
	{{241, 222, 251, 114, 200, 0, 182, 50, 83, 2, 189, 5, 239, 35, 253, 121}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 127, 55, 170, 72}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 65},
	{{241, 222, 251, 114, 200, 0, 163, 80, 166, 219, 207, 207, 101, 2, 44, 96}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 101, 219, 93, 254, 88, 38}, 65},
	{{241, 222, 251, 114, 200, 0, 57, 165, 186, 208, 13, 200, 210, 198, 123, 36}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 189, 246, 122, 0, 128}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 51, 6, 196}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 247, 206, 255, 79}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 126, 137, 203, 63}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 49, 124, 55}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160}, 65},
	{{241, 222, 251, 114, 200, 0, 165, 157, 138, 113, 190, 142, 186, 180, 22, 114}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 189, 193, 213}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 70, 140, 89, 118, 18, 113, 82, 190}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 225, 44, 106, 12, 99, 19}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 139}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 185}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 27, 119, 38, 109, 143, 143, 91, 103}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 12, 167, 215, 181}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 193, 59, 199, 166, 103, 86, 53, 89, 79}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 212, 130, 29, 133, 34, 208, 204, 62}, 65},
	{{241, 222, 251, 114, 200, 0, 63, 216, 162, 197, 220, 48, 66, 46, 170, 246}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 11, 223, 22, 74, 227, 171, 171, 69}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 120, 238, 52, 223, 25}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 188, 82, 69, 223}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 79, 154, 82, 119, 7, 18, 165}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 39, 171, 111, 37, 215}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 148, 85, 145, 219, 141, 214, 203, 174, 109}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 201, 113, 212, 120, 204, 89, 50}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 137, 54, 251, 96, 57, 42}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 204, 173, 157, 95, 40, 58, 159, 171}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192}, 65},
	{{241, 222, 251, 114, 200, 0, 111, 179, 138, 11, 118, 177, 34, 40, 136, 125}, 65},
	{{241, 222, 251, 114, 200, 0, 0, 0, 0, 0, 0, 0, 0, 35, 184, 27}, 65},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 201, 117, 175}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 22, 238, 132}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 202, 31, 95}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 83}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 98, 212, 125}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 70, 246, 99, 226}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 236, 123, 140, 215}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 50, 147}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 95, 127, 49, 230}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 234, 148, 70}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 68, 79, 47}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 76}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 166, 32, 60}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 60}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 15, 116, 169}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 36, 66}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 26, 199}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 176, 86}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 34, 54, 128}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 108, 156}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 120, 58, 5, 192}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 171}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 57, 106}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 93, 104, 65}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 95}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 32}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 45, 55, 95}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 141, 51, 222}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 6}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 180, 206}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 94}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 52, 63}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 7, 120}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 124, 72}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 235, 42, 98, 230}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 183, 186, 106}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 234}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 200, 137}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 154}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 58}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 13}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 139, 36, 42}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 129, 26, 81, 124}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 69, 231}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 153, 212, 51, 211}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 190, 33}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 240, 213}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 137, 52, 93, 26}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 30, 102, 235}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 148, 202, 222, 239}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 251}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 64, 103, 152, 67}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 204, 99, 146}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 96, 125}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 149, 166, 103}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 164, 91}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 197}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 224}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 183}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 247, 236}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 246}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 0}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 103, 101, 112, 135}, 108},
	{{31, 243, 190, 4, 207, 198, 249, 59, 167, 127, 93, 64, 0, 0, 0, 56}, 108},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 158, 160, 77, 116, 89, 167}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 142, 198}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 179, 21, 211, 68}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 207, 203}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 252, 187, 153, 91, 114, 153, 116, 165, 208}, 244},
	{{201, 35, 222, 208, 0, 0, 206, 28, 6, 163, 227, 196, 158, 113, 136, 28}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 206, 130, 227, 207, 250}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 199, 156, 72, 177, 81, 186, 92, 157}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 78, 93}, 244},
	{{201, 35, 222, 208, 0, 0, 158, 174, 42, 154, 22, 63, 215, 4, 109, 207}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 85, 181, 87, 233}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 151, 114, 195, 174, 125}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 172, 110, 240, 103, 158, 197}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 113, 68, 12, 10, 133, 208, 154, 44}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 24, 174, 180, 161}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 130, 219, 7, 75, 126}, 244},
	{{201, 35, 222, 208, 0, 0, 213, 121, 15, 42, 231, 31, 121, 136, 232, 52}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 220, 28}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 154, 241, 244, 219}, 244},
	{{201, 35, 222, 208, 197, 151, 156, 84, 52, 94, 249, 237, 1, 221, 70, 14}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 232, 234, 197, 77, 46, 217, 122, 216, 187}, 244},
	{{201, 35, 222, 208, 0, 211, 79, 255, 184, 173, 205, 157, 160, 230, 183, 178}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 118, 14, 167, 28, 62, 143, 78, 197}, 244},
	{{201, 35, 222, 208, 0, 0, 5, 134, 129, 33, 70, 188, 119, 96, 189, 210}, 244},
	{{201, 35, 222, 208, 94, 129, 138, 176, 230, 194, 52, 150, 71, 234, 236, 241}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 118, 237, 93, 30, 160, 163, 164, 169, 194}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 60, 25, 87, 241, 16, 50, 39, 181}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 239, 84, 75, 145, 132, 226}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 89, 85, 105, 223, 122, 106, 5, 21, 106}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 159, 37, 137, 88, 115, 230, 128, 130, 37}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 89, 208, 24, 53, 117, 62}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 155, 97, 173, 83, 163, 144, 244}, 244},
	{{201, 35, 222, 208, 0, 171, 176, 224, 196, 184, 127, 163, 79, 42, 67, 228}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 19, 193, 200, 218, 152, 211}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 92, 20, 94, 235, 237}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 60, 38, 191, 14, 147, 188}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 214, 89, 53, 182}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 255, 235, 61, 85, 133, 94, 165}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 16, 203, 129, 251, 192, 159, 69, 155}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 110, 198, 204, 132, 199, 80}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 38, 248, 77, 11, 47}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 206, 79, 55, 53, 155}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 64, 232, 224, 218, 78, 167, 64, 202, 164}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 211}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 10, 194, 168, 220, 144, 68, 11, 230, 9}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 5, 62, 108, 222, 130, 216, 62}, 244},
	{{201, 35, 222, 208, 201, 254, 72, 27, 196, 118, 61, 60, 203, 94, 204, 224}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 129, 93, 119, 95, 110, 121}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 54, 13, 63, 3, 218, 26, 39, 248}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 172, 203, 219, 186, 198, 1, 239, 241, 5}, 244},
	{{201, 35, 222, 208, 0, 0, 168, 230, 148, 102, 247, 24, 11, 149, 113, 104}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{201, 35, 222, 208, 0, 197, 161, 186, 185, 231, 11, 64, 246, 47, 171, 96}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 166, 226, 80, 152, 120, 150, 166, 5}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 202, 53, 85, 147, 113, 71}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 40, 143, 26, 69}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 155, 13, 36, 116, 32, 110, 197}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 87, 197, 193, 154}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 42, 159, 240, 61, 232, 18, 253, 125}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 161, 110}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 34, 133, 130, 193}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 21, 41, 165, 23, 48, 199}, 244},
	{{201, 35, 222, 208, 0, 251, 176, 69, 37, 105, 153, 197, 97, 21, 132, 94}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 232, 76, 69, 75, 236, 69, 253, 100}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 197, 137, 179, 157, 119, 1, 31}, 244},
	{{201, 35, 222, 208, 0, 0, 78, 149, 143, 84, 2, 232, 219, 201, 252, 230}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 221, 81, 15, 62, 176}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 15, 187, 209, 221, 94, 146}, 244},
	{{201, 35, 222, 208, 0, 237, 36, 89, 9, 37, 87, 1, 140, 132, 130, 94}, 244},
	{{201, 35, 222, 208, 32, 238, 61, 119, 196, 239, 118, 136, 33, 102, 221, 105}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 72, 9, 122, 197}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 43, 103, 33, 141, 203, 9, 170, 44, 232}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 23, 113, 99, 127}, 244},
	{{201, 35, 222, 208, 0, 99, 17, 246, 39, 248, 176, 208, 137, 97, 57, 47}, 244},
	{{201, 35, 222, 208, 0, 224, 100, 229, 7, 191, 111, 200, 95, 215, 116, 165}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 104, 17, 183, 151, 99}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 91, 40, 50, 230, 205, 29, 17, 21, 133}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 148, 7, 42, 1, 75}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 120, 212, 18, 15, 118, 180, 246, 58, 77}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 210, 245, 106, 185, 155, 119, 123, 46}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 156, 27, 136, 72}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 162, 165}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 245, 69, 160, 55, 24, 196}, 244},
	{{201, 35, 222, 208, 0, 0, 25, 82, 66, 7, 143, 68, 130, 100, 145, 117}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 139, 109, 32, 6, 37, 48, 158, 107}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 61, 238, 68, 218, 193, 68, 156}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 54, 219, 228, 140, 159, 241, 37, 222, 89}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 7, 118, 2, 234, 59, 196, 223}, 244},
	{{201, 35, 222, 208, 0, 0, 203, 54, 167, 12, 148, 209, 187, 123, 90, 159}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 224}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 0, 0, 0, 38, 27, 146, 216}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 0, 0, 65, 191, 243, 255, 199, 162, 48}, 244},
	{{201, 35, 222, 208, 0, 0, 0, 81, 230, 236, 113, 201, 235, 162, 131, 81}, 244},
	{{201, 35, 222, 208, 0, 240, 177, 31, 36, 208, 213, 142, 34, 41, 62, 203}, 244},
	{{201, 35, 222, 208, 0, 0, 192, 12, 177, 252, 119, 22, 129, 121, 217, 58}, 244},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 179}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 89, 93, 17, 11}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 158}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 50}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 35}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 219, 155}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 12}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 16}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 254}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 214, 61, 36}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 100, 35}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 131, 248}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 60, 115, 247}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 184}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 186, 230}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 124, 25}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 240}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 25, 19, 68}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 73, 97, 251}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 142, 118}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 140}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 246, 10, 32}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 191, 129, 20}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 209}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 100}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 194, 216}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 121, 199}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 107, 10, 193, 128}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 213, 162}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 31}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 42, 41}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 5, 235, 165}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 56}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 92, 241}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 113, 40}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 40, 60, 101, 99}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 98, 188, 165}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 180, 97}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 78, 209, 114}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 69}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 115, 219}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 217, 26, 3}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 255, 209}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 242}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 125, 247, 233, 72}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 85}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 40}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 8, 230}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 236}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 231}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 36, 229, 69}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 13, 99, 233}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 231, 81, 97}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 46}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 88, 66, 70}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 112}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 13, 221, 185}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 94}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 9, 152, 163}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 25, 198}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 39, 110}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 136, 133, 188}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 74, 16}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 126, 56, 156}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 218, 44}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 153, 236}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 103, 207}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 129, 203}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 10}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 22, 62, 185}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 168, 237}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 175, 138, 151}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 85, 27, 235}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 0}, 194},
	{{187, 105, 13, 114, 238, 197, 145, 23, 169, 116, 91, 28, 0, 0, 0, 113}, 194},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{251, 251, 121, 168, 152, 178, 147, 188, 229, 123, 154, 242, 190, 165, 173, 48}, 82},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 162}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 240}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 164}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 193}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 190}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 28}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 88}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 60}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 140}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 146}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 235}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 11}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 50}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 178}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 202}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 170}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 238}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 54}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 174}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 233}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 69}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 117}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 101}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 146}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 176}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 102}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 73}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 234}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 101}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 205}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 75}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 187}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 7}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 218}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 169}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 68}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 124}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 0}, 45},
	{{66, 187, 191, 164, 31, 196, 40, 186, 148, 115, 134, 57, 222, 254, 48, 79}, 45},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 127, 132, 192}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 212, 97, 164, 142, 223}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 224, 77}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 41, 146, 253, 68}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 142, 100}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 6, 71, 77, 68}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 224, 246, 5, 199}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 191, 98, 196, 241, 148, 91, 149, 84, 27}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 148, 162, 44, 39}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 52, 224, 78, 105, 238, 40, 48, 101}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 64, 243, 120}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 63, 246, 65, 250, 171, 34}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 104, 79, 254, 67, 40, 46, 75}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 138, 73, 38, 47, 55, 42, 37, 168}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 68, 116, 178}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 30, 37, 17, 50}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 135, 56, 23, 200}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 253, 4}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 125, 45, 243, 53, 48, 178, 144}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 197, 183, 100, 91, 148, 255, 185}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 88, 192, 183, 184, 209, 25, 168, 220, 57}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 208, 99, 172, 50, 139, 203}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 135, 246, 92, 34, 89, 189, 189}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 133, 82, 6}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 20, 238, 20, 245, 72, 162}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 221, 165, 98, 253, 201, 75, 132, 127, 45}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 132, 77, 145, 117}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 34, 30, 104, 193, 140, 102}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 88, 185, 163, 165, 147, 143, 218, 141, 5}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 88, 70, 59, 230, 201, 104, 43, 12}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 52, 84, 74, 220, 187, 8}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 207, 30, 116, 141, 205}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 102, 120, 55, 185, 96, 148, 250, 80}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 209, 17}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 52, 225, 138, 242, 30}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 21, 35, 241, 99, 145}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 120, 163, 11, 116}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 190, 25, 157, 3, 112, 46, 204, 207}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 14, 254, 10, 252, 89}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 114, 71, 22, 207, 41, 147, 115, 118, 210}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 124, 58, 141}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 239, 180, 125, 122, 209, 148, 178, 47, 78}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 78, 75, 156}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 185, 60, 54, 92, 194, 113, 40}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 183, 148, 254}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 207, 253, 134, 128, 15, 125}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 58, 184, 74, 107, 160, 169, 3}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 191, 101, 130, 184, 152, 43}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 6, 166, 170, 117}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 235, 196, 253, 165, 136, 76, 139}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 217, 232, 246, 249}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 209, 106, 230, 109, 181, 165, 237, 169, 122}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 242, 243, 240, 206}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 126, 213, 180, 202, 34, 196, 192, 6}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 156, 119, 136, 105, 169, 147, 167}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 43, 57, 202, 6, 2, 67, 152, 43, 26}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 197, 210, 228, 8, 217}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 226, 128, 160, 19}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 182, 123, 17, 121, 66}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 92, 10, 139, 1, 143, 235, 50, 94}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 109, 218, 139, 79, 156}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 14, 160}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 186, 4, 75, 82, 225, 212, 34, 241, 221}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 178, 18, 8, 183, 183, 117, 186, 225, 141}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 238, 119, 76, 160, 230, 127, 7, 27}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 226, 112, 228, 87}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 116, 196, 96, 235, 143, 45, 250}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 185, 127}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 104, 208, 148, 26}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 36, 72, 26, 16, 150}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 122, 40, 216}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 228, 141, 70, 84, 27, 132, 158, 41}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 207, 12, 136, 254, 100, 220, 77, 38}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 166, 106, 168, 211, 9, 233, 103}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 72, 134, 151, 192, 103, 5, 11, 171}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 61, 147, 31, 234}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 205, 253, 4, 99, 105, 118, 196, 186}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 50, 185, 123, 194, 58}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 72, 161, 143, 255, 4, 21, 149}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 95, 252, 194, 252, 214, 86, 19, 235, 14}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 49, 5, 36, 46, 68, 90, 0}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 99, 117, 122, 229, 183}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 221, 151}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 40, 115, 147, 129, 128, 13, 196}, 224},
	{{209, 17, 111, 41, 154, 94, 0, 0, 0, 0, 0, 0, 0, 0, 246, 137}, 224},
	{{40, 245, 128, 0, 0, 0, 120, 203, 170, 185, 249, 22, 82, 188, 38, 168}, 17},
	{{40, 245, 128, 0, 0, 155, 157, 85, 27, 145, 175, 69, 205, 87, 158, 162}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 96, 136, 221}, 17},
	{{40, 245, 128, 193, 184, 166, 187, 99, 127, 167, 172, 81, 240, 135, 234, 95}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 99}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 176, 83}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 79, 150, 151, 203, 239}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 11, 184}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 125, 87}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 172, 239, 87, 233, 224}, 17},
	{{40, 245, 128, 0, 0, 0, 47, 2, 53, 109, 64, 19, 202, 12, 142, 13}, 17},
	{{40, 245, 128, 230, 32, 42, 85, 203, 241, 253, 167, 74, 138, 45, 182, 111}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 143}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 131, 198}, 17},
	{{40, 245, 128, 0, 64, 173, 200, 124, 183, 168, 212, 148, 35, 170, 209, 98}, 17},
	{{40, 245, 128, 245, 139, 27, 10, 2, 76, 116, 158, 222, 165, 173, 250, 248}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 60}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 251, 157, 100, 15, 185, 49}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 221, 86, 248, 154, 35, 19, 57}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 31, 24, 216, 14, 176}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 39, 99}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 23, 20, 216, 5, 102, 17, 194, 174, 166}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 154, 176}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 114, 214, 147, 23, 128, 240, 196}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 48, 0, 240}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 78, 207, 48}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 234}, 17},
	{{40, 245, 128, 0, 0, 238, 158, 16, 4, 139, 69, 108, 111, 167, 185, 88}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 87, 231, 141, 169, 6, 107, 35, 33, 236}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 214, 221, 253, 58, 45, 53, 8, 113}, 17},
	{{40, 245, 128, 0, 0, 3, 126, 223, 1, 151, 187, 251, 179, 211, 169, 154}, 17},
	{{40, 245, 128, 0, 112, 179, 56, 23, 40, 100, 173, 233, 25, 181, 95, 146}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 38, 149, 209}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 58, 143, 113, 22, 57, 129, 198}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 23, 177, 83, 170, 90}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 126, 22, 12, 12, 81, 115}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 46, 35, 221, 242, 212, 84, 200, 132, 164}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 17},
	{{40, 245, 128, 0, 156, 22, 184, 39, 9, 3, 222, 171, 78, 195, 245, 0}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 227, 120, 159, 234, 73, 80, 205, 138}, 17},
	{{40, 245, 128, 0, 163, 149, 34, 16, 254, 75, 130, 119, 158, 93, 132, 242}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 240, 173, 92}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 228, 168, 181, 210, 198, 158, 93, 106}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 70, 167, 237, 175, 13, 139, 15, 233, 204}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 96, 81, 19, 233, 235, 157}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 250, 88}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 189, 97, 178, 197, 58, 49, 249}, 17},
	{{40, 245, 128, 0, 99, 148, 128, 34, 184, 2, 113, 203, 32, 164, 138, 180}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 238, 66, 73, 9, 159, 84, 7, 191, 59}, 17},
	{{40, 245, 128, 0, 125, 185, 172, 234, 23, 72, 82, 2, 42, 137, 3, 58}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 252, 80, 123, 211, 184, 54, 195, 246, 145}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 234, 202, 69, 191, 64, 154, 66, 151}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 156, 129, 2, 10, 0, 143, 220, 247, 116}, 17},
	{{40, 245, 128, 0, 0, 36, 130, 180, 209, 27, 224, 114, 229, 149, 203, 24}, 17},
	{{40, 245, 128, 0, 0, 133, 8, 216, 84, 247, 193, 213, 37, 197, 60, 247}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 194, 22, 180, 33, 15, 80}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 20, 165, 101, 125, 157}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 155, 224, 33}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 50}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 182, 111, 246, 177, 64}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 174, 197, 130, 220, 133, 123, 255}, 17},
	{{40, 245, 128, 0, 0, 207, 79, 212, 118, 196, 204, 48, 112, 115, 59, 245}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 252, 199, 115, 111, 216, 213, 65, 73}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 89, 234, 254, 133, 136, 200, 115, 139, 179}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 243, 167, 5, 137, 202, 250, 189, 31, 31}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 216, 31}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 152, 174, 10}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 69, 252, 42, 249, 181}, 17},
	{{40, 245, 128, 0, 204, 57, 58, 106, 147, 167, 55, 141, 188, 143, 73, 64}, 17},
	{{40, 245, 128, 0, 0, 0, 230, 22, 142, 113, 111, 178, 96, 84, 245, 203}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 168, 17, 101, 12, 84, 44, 198, 39, 75}, 17},
	{{40, 245, 128, 0, 255, 111, 23, 24, 74, 107, 87, 84, 59, 22, 144, 201}, 17},
	{{40, 245, 128, 0, 0, 67, 195, 39, 135, 189, 27, 134, 184, 168, 108, 206}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 120}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 136, 45, 233, 173, 72}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 218, 155, 188, 148, 21, 103}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 133, 76, 131, 84, 75, 223}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 220, 80}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 67, 67, 212, 77, 64, 114}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 157}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 65, 254, 53}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 86, 163, 83, 65, 85, 37}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 157, 31, 183, 121, 228}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 70, 167, 75, 248, 168, 47}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 240, 26, 228, 161, 36, 250}, 17},
	{{40, 245, 128, 0, 135, 227, 39, 58, 223, 135, 86, 249, 72, 120, 80, 146}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 44, 215, 170, 217, 145}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 122, 125, 116, 177, 164, 184, 208}, 17},
	{{40, 245, 128, 0, 222, 29, 191, 179, 59, 195, 214, 101, 82, 36, 232, 69}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 106, 231, 127}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 17},
	{{40, 245, 128, 0, 0, 0, 0, 183, 166, 106, 45, 172, 109, 157, 135, 18}, 17},
	{{40, 245, 128, 0, 0, 134, 65, 241, 113, 138, 98, 219, 242, 198, 182, 6}, 17},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 118, 33, 187, 68, 196, 231}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 158, 55, 239, 22, 111, 34, 32, 243, 77}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 131, 225, 192, 80, 85}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 194, 157, 2, 232, 167, 242, 46, 59}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 95, 172, 229, 112}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 68, 100, 103, 65, 100, 113, 17, 232}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 144, 251, 222, 142, 77}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 211, 41}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 129, 204, 64, 205, 143, 146, 13}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 66, 53, 210, 88, 152, 4, 66}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 252, 121, 52, 50, 160, 41, 55}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 103, 56, 138, 145, 202, 104, 179}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 26, 39, 49, 25}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 149, 0, 159, 87, 229, 248, 217}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 227, 63, 236}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 148, 31, 0, 163, 194, 253, 89}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 217, 227, 120, 176, 52}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 227, 233, 45, 186, 109}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 145, 161, 191, 220, 5, 223}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 170, 189, 47, 206}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 221, 107, 195, 202, 82, 51, 86, 123, 185}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 174, 71, 243, 13}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 1, 127, 185, 10}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 171, 72, 128, 34, 211}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 193, 208, 49, 37, 251}, 133},
	{{72, 121, 151, 83, 170, 80, 252, 250, 194, 131, 123, 228, 213, 164, 130, 255}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 111, 230, 121, 150, 228, 41}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 65, 186, 48, 82, 101, 193, 35, 44, 11}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 11, 124, 237, 4}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 211, 198}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 50, 78, 165, 173}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 146, 81}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 44, 144, 122, 50, 1, 93, 235, 90, 29}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 248, 165, 131, 111, 160}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 4, 180, 234, 174, 195, 63}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 156, 181, 166, 240, 148, 173, 227}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 235, 159, 211, 86, 27, 51, 224, 111, 71}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 142, 215}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 58, 171, 68, 16, 60, 163, 183, 125}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 229, 99, 160, 127, 201}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 180, 47, 68}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 194, 66, 6}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 45, 197, 147, 31, 13, 60, 121, 209}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 60, 249, 55, 24, 166, 209}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 219, 86, 3, 188, 1}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 121, 107, 37, 126, 49, 9, 82, 85}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 36, 51, 236, 177, 151, 105, 65}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 47, 76, 87, 42}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 70, 164, 231, 94, 119, 64}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 174, 11, 129}, 133},
	{{72, 121, 151, 83, 170, 80, 122, 189, 190, 25, 196, 230, 29, 34, 128, 142}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 87, 47, 53, 174, 211, 137}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 125, 82, 59, 17, 197, 209}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 62, 235, 133, 15}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 46, 83, 50}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 222, 222, 73, 141, 8, 207, 43, 77}, 133},
	{{72, 121, 151, 83, 170, 80, 92, 181, 148, 174, 162, 2, 249, 186, 5, 94}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 124, 197, 14}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 11, 189}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 233, 89, 202, 77}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 208, 220, 146}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 244, 90}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 228, 90, 160, 155, 192}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 77, 29, 249, 234, 79, 70, 201, 85, 86}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 63, 16, 38, 245, 185, 109, 172, 70}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 59, 86, 47, 188, 114}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 50, 24, 95, 115, 117, 237}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 206, 239}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 60, 52, 233, 236, 245, 112, 188, 152}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 49, 98, 5, 108, 245, 164, 144, 179, 217}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 174, 166, 105, 242, 23, 199, 89, 214, 116}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 208, 210, 199, 119, 141}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 139, 115, 160, 217, 97}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 188, 221, 11, 251}, 133},
	{{72, 121, 151, 83, 170, 80, 147, 29, 149, 9, 124, 172, 0, 216, 138, 184}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 116, 216, 207, 239, 35, 170, 90, 66, 15}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 247, 228, 201, 135, 136, 96, 221, 153}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 207, 193}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 138, 131, 254, 194, 47}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 206, 191, 153}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 133},
	{{72, 121, 151, 83, 170, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 133},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 29, 88}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 177, 215}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 117}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 62, 224, 214, 21}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 97, 116}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 234, 223, 165}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 57, 23, 85}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 210}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 67, 102, 125}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 206}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 151, 214, 121, 171}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 150, 211}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 49, 144, 188}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 194, 17, 56}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 32, 78}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 46, 119, 158}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 126, 39, 21, 105, 149}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 60, 178}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 157, 76}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 14, 250}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 240, 117, 113}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 85, 228, 171, 247}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 161, 161, 114}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 64}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 91, 159}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 47, 227, 72, 108}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 180, 15, 32}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 69, 220, 65, 104, 239}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 35}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 166, 89, 94, 169}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 74, 3}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 86, 229}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 125, 15, 17, 251, 35}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 3, 36, 34}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 163, 15}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 128, 76}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 162, 245, 255}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 241}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 218, 177, 157, 172}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 136, 50}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 214, 86, 88, 179}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 82, 38, 65, 199}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 150, 197, 214}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 87, 0, 113, 222, 61}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 84, 194, 192}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 168}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 221, 104}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 245, 99}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 188}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 203, 200, 72}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 39, 113}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 194, 14, 165, 13}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 15, 167, 173}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 111, 230, 24, 54}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 153}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 37}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 14, 26}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 242}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 251, 170, 37}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 215, 132, 26}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 55, 6, 181}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 192}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 34, 130, 14}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 221, 207}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 50, 21, 197}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 56, 86}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 18, 148, 132, 255}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 218, 54, 91}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 188, 142, 43, 181}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 200}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 219, 226, 99}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 246, 74}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 182, 189, 173}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 0}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 0, 208}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 248, 135, 21}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 10, 208, 168}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 241, 46, 226, 1}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 6, 137, 249, 97, 141}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 98, 166, 199, 62}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 151, 105, 19}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 203, 113, 62}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 116, 97}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 0, 217, 64}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 87, 18, 35, 217}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 60, 240, 31, 39, 190}, 125},
	{{171, 172, 101, 238, 201, 148, 23, 81, 4, 11, 64, 0, 0, 53, 86, 167}, 125},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 61},
	{{0, 0, 0, 0, 0, 48, 154, 134, 55, 146, 130, 190, 155, 183, 237, 164}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 62, 9}, 61},
	{{0, 0, 0, 73, 77, 75, 5, 129, 84, 193, 84, 160, 235, 78, 164, 162}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 184, 144, 219, 168}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 144, 74, 54, 55, 5, 29, 25, 59}, 61},
	{{0, 199, 138, 82, 74, 114, 232, 31, 64, 133, 32, 37, 39, 18, 102, 6}, 61},
	{{0, 0, 0, 0, 0, 86, 27, 61, 87, 103, 219, 109, 167, 51, 17, 5}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 226, 46, 117}, 61},
	{{0, 0, 231, 189, 147, 181, 212, 63, 109, 32, 145, 236, 10, 100, 211, 165}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 172, 139, 42}, 61},
	{{0, 0, 0, 138, 52, 252, 105, 185, 209, 201, 54, 230, 252, 20, 241, 129}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 237, 118, 241, 36, 244}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 90}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 1, 21}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 117, 149}, 61},
	{{0, 0, 121, 168, 34, 152, 120, 84, 186, 115, 234, 76, 166, 254, 254, 227}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 157, 160, 97, 50}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 235, 222, 91, 32, 241, 7, 166, 40, 103}, 61},
	{{0, 91, 167, 227, 26, 140, 35, 131, 161, 187, 63, 232, 129, 237, 123, 120}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 183, 149, 93, 189, 168}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 227, 24, 222, 111, 160, 220, 17, 70, 108, 70, 125, 57}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 179, 1, 220, 85, 50, 172}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 61},
	{{0, 0, 0, 0, 0, 0, 182, 145, 112, 177, 207, 254, 103, 126, 11, 142}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 125, 160, 191, 239}, 61},
	{{0, 0, 0, 0, 248, 31, 119, 75, 31, 28, 26, 143, 44, 235, 46, 204}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 12, 119}, 61},
	{{0, 0, 0, 0, 0, 204, 82, 87, 26, 215, 203, 177, 97, 10, 206, 220}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 50, 148, 15, 29, 12}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 67, 163, 239, 55, 215, 61, 160, 202}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 119, 231, 70, 143, 35, 99}, 61},
	{{0, 0, 0, 0, 0, 231, 226, 127, 133, 143, 132, 163, 80, 216, 86, 186}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 145, 44, 103, 179}, 61},
	{{0, 0, 0, 0, 0, 0, 50, 53, 111, 97, 80, 226, 208, 95, 30, 125}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 187, 45, 35, 22, 85, 96, 84, 97, 57, 174}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 87}, 61},
	{{0, 0, 0, 0, 0, 0, 158, 47, 156, 188, 154, 52, 103, 69, 145, 109}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 58, 148, 213}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 183, 35, 123, 76, 127, 247}, 61},
	{{0, 0, 0, 0, 94, 82, 80, 227, 8, 192, 116, 186, 37, 76, 133, 61}, 61},
	{{0, 84, 216, 126, 35, 115, 249, 32, 172, 98, 5, 41, 151, 2, 235, 203}, 61},
	{{0, 0, 0, 234, 196, 80, 154, 98, 234, 236, 13, 169, 221, 166, 87, 220}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 61},
	{{0, 0, 182, 53, 4, 220, 24, 247, 10, 215, 31, 161, 55, 193, 180, 122}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 44, 126}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 175, 79, 61}, 61},
	{{0, 0, 125, 53, 196, 196, 228, 238, 147, 199, 233, 208, 73, 86, 169, 38}, 61},
	{{0, 0, 0, 0, 0, 0, 120, 141, 0, 189, 195, 56, 229, 191, 17, 74}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 57, 57, 205, 214, 43, 213, 65, 255}, 61},
	{{0, 0, 0, 0, 41, 118, 129, 94, 87, 119, 72, 221, 57, 135, 237, 78}, 61},
	{{0, 0, 0, 93, 109, 66, 156, 41, 181, 158, 140, 144, 95, 131, 20, 229}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 166, 17, 253, 92, 46}, 61},
	{{0, 0, 0, 0, 0, 0, 188, 175, 114, 27, 15, 16, 105, 176, 192, 115}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 80}, 61},
	{{0, 0, 0, 0, 0, 222, 228, 49, 109, 74, 244, 71, 90, 121, 239, 252}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 179, 251, 183, 53, 79, 66, 46, 72, 197}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140}, 61},
	{{0, 98, 240, 85, 137, 191, 159, 80, 171, 180, 213, 51, 55, 223, 8, 161}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 124}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 162, 84, 184}, 61},
	{{0, 0, 0, 0, 0, 32, 217, 158, 238, 183, 172, 130, 83, 219, 137, 211}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 17, 192, 84, 213, 92, 22, 207, 215, 61}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 136, 76}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 41, 81, 224, 250, 132, 181}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 222, 252, 30, 233, 206, 75, 142, 211, 133, 98, 125, 227, 178, 203}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 119, 121, 213, 153, 154, 72, 76, 245}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 250}, 61},
	{{0, 0, 0, 0, 230, 115, 165, 62, 82, 65, 212, 53, 226, 199, 58, 145}, 61},
	{{0, 0, 0, 0, 101, 62, 83, 116, 84, 215, 178, 163, 173, 115, 142, 16}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 178, 111, 124, 21, 29, 46}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 76}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 230}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 150}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 87, 195, 163, 34, 4, 91, 51, 121, 140}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 70}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 67, 158, 234, 52, 241}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 227}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 51}, 61},
	{{0, 0, 0, 0, 0, 150, 249, 165, 241, 236, 2, 157, 16, 152, 84, 234}, 61},
	{{0, 0, 0, 107, 154, 126, 82, 104, 113, 186, 3, 32, 37, 155, 50, 148}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 208}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 155}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 229, 180}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 206, 71}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 145, 146, 225}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 191, 143}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 216, 130, 222}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 93, 136, 144}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 41}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 211}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 164, 55}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 206}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 195, 166}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 238}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 192, 42}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 143, 175}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 216}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 71, 183}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 34}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 194, 254}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 115, 5, 35}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 170, 243}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 157, 62}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 70, 219}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 205, 220, 230}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 245}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 58, 23, 166}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 38, 166, 64}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 39, 68}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 255}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 82, 60, 17}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 48, 59}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 58, 219}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 80, 152}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 219, 17, 34}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 169}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 251}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 149, 48, 187}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 185, 152}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 150}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 75, 5}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 164, 16, 90}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 201, 84, 47}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 44, 76, 138}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 131, 159}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 147, 148, 150}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 51, 63}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 143, 16}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 104}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 105, 97, 108}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 90, 159, 240}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 209, 57}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 109}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 3, 81, 84}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 143, 125, 141}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 214}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 179, 66, 180}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 161}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 65, 93}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 89, 145}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 202}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 167, 191}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 61}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 25}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 73, 139}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 251, 189, 70}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 40, 13}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 30, 255}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 1, 72}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 29, 198}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 104, 143, 208}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 151, 14, 94}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 245}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 208, 35, 231}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 0}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 184, 197}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 220}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 243}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 0, 0, 179}, 140},
	{{20, 46, 27, 93, 195, 184, 6, 162, 109, 225, 22, 152, 0, 214, 68, 61}, 140},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 19, 179, 4, 36}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 58, 162, 243, 108, 134, 31, 54, 169}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 30, 202, 26, 224}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 229, 9, 54, 88}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 49, 212, 129, 246, 26, 178}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 45, 56, 100, 13, 99, 134, 135}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 232, 183}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 157, 46, 146, 61}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 218, 179, 74, 226, 43, 196, 226, 183, 11}, 91},
	{{243, 122, 30, 80, 146, 158, 175, 239, 119, 5, 131, 191, 64, 167, 217, 195}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 120, 42, 220, 253}, 91},
	{{243, 122, 30, 80, 105, 199, 180, 14, 40, 137, 115, 152, 21, 93, 221, 5}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 141, 1, 208, 203, 0, 149}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 58, 130, 151, 171, 19, 155}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 167, 189}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 239, 67}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 127, 203, 19, 165, 71, 55}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 139, 194, 94, 169, 54}, 91},
	{{243, 122, 30, 80, 0, 193, 148, 164, 130, 178, 63, 86, 34, 195, 25, 193}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 19, 27, 179, 40, 140}, 91},
	{{243, 122, 30, 80, 105, 21, 109, 70, 243, 235, 248, 78, 89, 219, 229, 25}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 76, 89, 163, 220, 129, 208, 164, 33}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 172, 97, 141, 191, 86, 251}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 17}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 196, 79, 107, 143, 130, 40}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 247, 67, 203, 67}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 128, 111, 216, 46, 82, 31}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{243, 122, 30, 80, 0, 202, 245, 30, 152, 211, 138, 226, 22, 250, 58, 95}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 221, 45, 90, 135}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 96, 72, 70, 220, 12, 44, 11, 155}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 224, 180, 181, 130}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 65, 206, 80, 148, 75, 136, 217, 83}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 130, 187, 203, 218, 29, 4}, 91},
	{{243, 122, 30, 80, 0, 0, 50, 186, 247, 214, 24, 240, 25, 152, 204, 50}, 91},
	{{243, 122, 30, 80, 69, 90, 240, 97, 63, 231, 241, 156, 19, 59, 202, 251}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 75, 47, 246, 77, 69, 67}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 96, 121, 24, 154, 40, 46, 60, 27, 107}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 140, 71, 9, 63, 231, 25}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 113, 233, 159, 17, 52}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 195, 105, 204, 67, 118, 19, 125}, 91},
	{{243, 122, 30, 80, 0, 128, 189, 84, 186, 147, 177, 47, 122, 46, 197, 33}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 49, 180, 11, 244, 80, 199, 9}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 229, 200, 95, 245, 163, 245, 247, 0}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 180, 151, 177, 116, 193, 219, 60, 63}, 91},
	{{243, 122, 30, 80, 96, 181, 251, 70, 112, 120, 231, 4, 190, 92, 242, 185}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 104, 118, 146, 238, 64, 161, 142, 55}, 91},
	{{243, 122, 30, 80, 0, 0, 81, 128, 110, 235, 220, 236, 67, 149, 216, 46}, 91},
	{{243, 122, 30, 80, 0, 2, 47, 153, 27, 13, 101, 221, 137, 54, 102, 18}, 91},
	{{243, 122, 30, 80, 0, 146, 94, 86, 74, 122, 135, 204, 74, 231, 40, 178}, 91},
	{{243, 122, 30, 80, 90, 226, 149, 156, 229, 240, 106, 237, 117, 35, 77, 190}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 187, 117, 9, 188}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 91, 73, 236, 26, 237, 9, 74, 240}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 1, 200, 99, 60, 168}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 128, 38, 95, 59}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 30, 218, 69, 217}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 43, 215, 179, 215, 101}, 91},
	{{243, 122, 30, 80, 171, 19, 227, 170, 208, 107, 254, 159, 89, 146, 19, 9}, 91},
	{{243, 122, 30, 80, 0, 0, 192, 230, 41, 163, 120, 22, 105, 52, 198, 15}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 110, 10}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 45, 213, 15, 126, 187}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 127, 72, 128, 205, 194, 201, 216, 68, 88}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 181, 205, 215, 154, 184, 236, 9, 115, 243}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 124, 31, 89, 226, 238}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 149, 23, 165, 65, 157, 1, 184, 140}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 77, 48, 175, 199, 51, 234}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 12, 167, 15, 52, 36, 180, 41, 229, 14}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 30, 60}, 91},
	{{243, 122, 30, 80, 0, 52, 48, 233, 129, 157, 119, 31, 189, 34, 130, 33}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 16, 187, 55, 63, 149}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{243, 122, 30, 80, 0, 0, 125, 129, 80, 198, 73, 20, 69, 75, 94, 217}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 52, 29, 69, 210, 140, 101, 112, 250}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182}, 91},
	{{243, 122, 30, 80, 0, 196, 54, 165, 15, 125, 64, 126, 199, 211, 148, 193}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{243, 122, 30, 80, 0, 245, 46, 241, 209, 32, 11, 47, 127, 7, 148, 32}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 224, 206, 140, 184, 230}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 107, 123, 166, 57, 100}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 98, 66, 108, 130, 124, 234, 153}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 146, 101}, 91},
	{{243, 122, 30, 80, 0, 0, 67, 100, 130, 27, 249, 182, 203, 244, 179, 74}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 91},
	{{243, 122, 30, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 85}, 91},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 241, 196}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 238, 240, 81}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 92, 239, 33, 59}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 52, 178, 125, 143, 34, 232, 250, 82}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 169, 107, 69, 83, 198, 59}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 90, 62, 91, 86, 10, 0, 29}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 66, 157, 215}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 47, 184, 251, 33, 209, 64, 32, 98}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 4, 252, 19}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 73, 161, 32, 165}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 167, 51, 126, 156, 42, 131, 102}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 235, 218}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 203, 85, 35, 142, 171, 61}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 38, 98, 206, 76, 60, 42, 42, 177, 25}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 216, 93}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 54, 191, 208, 160, 62, 96}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 6, 211, 14, 101, 35, 91, 7, 217, 218}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 189, 86, 168, 53, 131, 109, 56, 59, 222}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 244, 55}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 103, 204, 40, 226, 99, 246}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 178, 166, 210, 71, 214}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 251, 53, 228, 231}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 138, 176, 2, 45}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 105, 55, 142, 107, 156, 6}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 112, 45, 77}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 162, 223, 111, 36, 103, 188}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 17, 121, 29, 96, 18, 205}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 91, 77}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 79, 192, 26, 139, 58}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 214, 17}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 139, 201, 75, 183, 230, 214}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 239, 120}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 91, 238, 176, 122, 158, 175, 104}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 82, 168, 71}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 95, 223, 236, 22}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 33, 106}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 212, 179, 119, 10, 205, 56, 126, 176, 40}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 217, 217, 5, 246, 40, 160, 162, 16}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 132, 197}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 38, 79, 221, 248, 159, 172}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 26, 190, 121}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 186, 130, 183}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 27, 65, 210, 230}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 170, 157, 156, 43, 243, 144, 100, 248}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 218, 157, 123, 212, 29, 143, 151, 207}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 231, 84, 46}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 161, 218, 48, 218, 178, 81, 134, 45}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 122, 55, 148, 47, 204}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 140, 223, 73, 208}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 23, 137, 14, 183, 162, 131}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 138, 129, 49, 32, 246, 91, 90, 255, 5}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 49, 94, 208, 239}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 71, 103}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 238, 152}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 31, 77, 110}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 216, 2}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 2, 247, 173, 235, 67, 137, 21, 89}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 210, 18, 253, 165, 103, 67, 35, 150, 99}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 30, 15, 19, 16, 87, 199}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 87, 142, 161, 201, 162, 47, 239}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 243, 53, 54, 211}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 93, 219, 56, 22, 189, 201, 71}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 44, 80}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 49, 253, 177, 131, 204, 49, 148}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 245, 219, 26, 122, 66, 79, 13, 238}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 207, 241, 59}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 78, 239, 237, 99, 181, 159, 187}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 25, 21, 85, 47}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 57, 233, 168, 56, 198, 224, 113, 17}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 104, 254}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 75, 180, 152}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 196, 205, 107, 196}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 45, 81, 144, 231, 213, 188, 142, 168, 163}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 135, 55, 19}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 126, 110, 73}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 54, 220, 123, 98, 177, 76}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 154, 33, 20, 240, 116, 229, 152, 162}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 131, 29}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 20, 242, 183, 15, 160, 16}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 132, 8, 219}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 250, 108, 31, 124, 191, 192}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 0, 105, 158, 145}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 238, 153, 134, 101, 151, 17, 157}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 0, 0, 0, 226, 60, 127, 36}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 48, 23, 111, 119, 164, 183, 33}, 92},
	{{89, 250, 80, 72, 148, 4, 0, 0, 0, 41, 243, 168, 19, 150, 192, 79}, 92},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 164, 244, 97, 174, 55, 48}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 189}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 148, 97, 148, 156, 194, 156}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 39, 42, 161}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 249, 193, 126, 102}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 119, 84, 85}, 125},
	{{187, 152, 0, 0, 0, 0, 253, 110, 52, 161, 46, 161, 61, 209, 245, 186}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 153, 119, 191, 31, 130, 171, 5, 215, 149}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{187, 152, 0, 0, 64, 153, 18, 8, 138, 225, 243, 18, 215, 198, 6, 23}, 125},
	{{187, 152, 0, 0, 167, 248, 132, 117, 26, 146, 162, 24, 185, 72, 172, 216}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 14, 174, 87, 176, 140, 109, 210, 140, 218}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 33, 15, 254}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 239, 172, 250, 165, 255, 132}, 125},
	{{187, 152, 0, 0, 0, 137, 220, 8, 79, 157, 209, 148, 85, 144, 10, 41}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 128, 62, 183, 135}, 125},
	{{187, 152, 0, 0, 0, 28, 106, 58, 53, 8, 80, 227, 188, 166, 12, 31}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 170, 54}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 84, 140, 73, 243, 181, 181, 180, 119}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 140, 178, 119, 123}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 12, 70, 178, 68}, 125},
	{{187, 152, 0, 0, 0, 0, 53, 42, 127, 64, 200, 89, 254, 39, 10, 237}, 125},
	{{187, 152, 0, 0, 0, 74, 175, 19, 183, 170, 59, 225, 60, 156, 202, 65}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 107, 68, 10, 62, 124, 161, 255}, 125},
	{{187, 152, 0, 0, 0, 240, 167, 57, 172, 180, 8, 88, 251, 11, 29, 14}, 125},
	{{187, 152, 0, 0, 211, 62, 209, 131, 61, 21, 35, 27, 169, 7, 81, 235}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 180, 220, 13, 233, 135, 194, 250, 208, 122}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 62, 192, 189}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 198}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 243, 155, 225}, 125},
	{{187, 152, 0, 0, 0, 0, 160, 160, 141, 137, 37, 92, 233, 93, 17, 24}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 113, 236, 105, 39, 175, 175, 163, 176}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 227, 239}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 210, 160, 48, 125, 61, 235, 131, 121, 68}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 65, 179}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 240, 135, 238, 103, 89, 41, 75, 226}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21}, 125},
	{{187, 152, 0, 0, 106, 157, 158, 184, 8, 89, 111, 38, 83, 63, 155, 3}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 75, 1, 101, 224, 138, 121, 110, 142}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 125},
	{{187, 152, 0, 140, 65, 12, 179, 197, 130, 233, 212, 176, 103, 208, 127, 172}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 125, 181}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 140, 72, 77, 255, 177, 80, 51, 23, 56}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 231, 31, 210, 44}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 244, 157, 163, 187, 190, 234, 247, 56, 120}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 59, 236, 23, 249, 93, 16, 229, 13}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 80, 194}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 79, 73, 0}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 76, 8, 168}, 125},
	{{187, 152, 158, 1, 199, 220, 56, 166, 217, 136, 45, 125, 233, 27, 171, 41}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 112, 40, 37, 172, 136, 168, 107, 59}, 125},
	{{187, 152, 0, 0, 0, 162, 140, 7, 61, 95, 77, 216, 140, 99, 0, 93}, 125},
	{{187, 152, 0, 168, 130, 89, 66, 94, 14, 74, 232, 114, 7, 85, 38, 31}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 209}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 65, 227, 39, 246, 13, 169, 232}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 125},
	{{187, 152, 0, 0, 0, 195, 253, 93, 200, 89, 185, 57, 222, 134, 215, 195}, 125},
	{{187, 152, 0, 0, 163, 15, 230, 18, 40, 158, 143, 0, 173, 233, 251, 122}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 174, 90}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 18, 39, 244, 107, 211, 20, 16, 198}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 199, 147, 54, 242}, 125},
	{{187, 152, 0, 0, 0, 0, 109, 211, 152, 183, 221, 18, 230, 4, 123, 10}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 34, 240, 86, 45}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 224, 23, 218}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 80, 208, 51, 187}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 2, 42, 208, 129, 31, 209, 218, 201, 17}, 125},
	{{187, 152, 0, 0, 246, 5, 180, 161, 205, 50, 204, 85, 197, 223, 164, 179}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 199, 18, 29, 1}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 242, 57, 24, 110, 26, 74}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 253}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 131, 173}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 70, 80, 96, 113}, 125},
	{{187, 152, 0, 0, 0, 0, 171, 125, 167, 26, 175, 47, 205, 122, 163, 187}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 125},
	{{187, 152, 0, 154, 246, 182, 227, 98, 161, 78, 69, 189, 231, 41, 57, 29}, 125},
	{{187, 152, 0, 198, 52, 37, 67, 154, 90, 68, 36, 155, 59, 66, 35, 25}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 60, 152, 76, 251}, 125},
	{{187, 152, 0, 246, 227, 3, 27, 203, 93, 223, 130, 141, 203, 45, 45, 135}, 125},
	{{187, 152, 0, 0, 158, 7, 0, 48, 222, 94, 118, 219, 207, 203, 21, 75}, 125},
	{{187, 152, 162, 85, 68, 113, 126, 172, 61, 232, 119, 162, 76, 27, 154, 42}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 76, 103, 7, 61, 156, 142, 77, 61, 67}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 91, 126, 220, 177, 5, 61}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 224}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 183, 54, 22, 1, 91, 88, 101, 46}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 197, 56, 206, 62, 142, 209, 139, 121}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 183, 143, 94, 160, 94, 181, 183, 156, 173}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 195, 189, 234, 33, 100, 23, 194, 50}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 18}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 53, 157, 68, 44, 83, 188, 54, 3}, 125},
	{{187, 152, 0, 0, 0, 0, 0, 0, 0, 43, 121, 214, 104, 229, 157, 210}, 125},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 231}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 112}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 86}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 146, 46}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 61}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 175}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 196}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 98, 13}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 212}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 17}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 147, 252}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 254, 223}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 191}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 241, 21}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 210, 145}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 194, 170}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 194}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 22}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 178, 32}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 107, 158}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 206}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 182}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 31}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 115}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 45, 83}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 254}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 184, 118}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 93, 184}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 118, 242}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 12}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 73}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 84}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 57, 57}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 77, 231}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 123}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 57}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 9, 41}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 77}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 63}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 161}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 253}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 5}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 21}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 52, 160}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 59, 37}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 7}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 80, 220}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 67, 22}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 145}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 97}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 183, 30}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 116, 238}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 85}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 249, 101}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 82, 68}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 151}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 134}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 119}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 115}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 244, 12}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 70}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 45, 96}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 217}, 249},
	{{172, 160, 143, 114, 128, 239, 174, 133, 176, 154, 159, 134, 10, 0, 0, 0}, 249},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 202, 190, 22, 39, 168, 105}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 191, 240, 45, 188}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 12, 51, 103}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 238, 160, 53, 49, 0, 120, 17}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 118, 45, 130, 85, 116, 93, 241, 99, 163}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 248, 111, 211, 81, 125, 62}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 111, 240, 139}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 154, 45, 231, 171, 217}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 65, 75, 195, 215, 213, 132, 199, 237, 130}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 24, 47, 55, 126, 166}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 3, 87, 234}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 152, 114, 40, 210, 191}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 51, 207, 13, 3, 103, 90}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 81, 238, 66, 100, 118, 171}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 254}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 90, 92, 87, 27, 101, 225, 245}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 166, 158, 223, 254}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 52, 255, 120, 192, 203}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 155, 94, 229, 118, 201, 188, 50, 235}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 217}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 66, 84, 241, 107, 53, 214, 241, 152}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 27, 147, 21, 113, 202, 210, 101, 156}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 162}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 156, 105, 43, 167, 147, 129}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 67}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 205, 8, 112, 242, 20, 27, 43}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 232, 194, 8, 222}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 171, 196, 53, 50, 108, 108}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 65, 196, 177, 97, 123, 231, 216, 186, 232}, 202},
	{{254, 202, 113, 112, 173, 0, 99, 113, 107, 218, 146, 79, 141, 29, 47, 85}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 141, 240, 71}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 180, 190, 35, 93, 185, 158, 193, 163}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 38, 69, 146}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 146, 253, 134, 69, 53, 106}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 241, 87, 238, 186, 208}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 202},
	{{254, 202, 113, 112, 173, 0, 246, 18, 146, 238, 30, 192, 132, 233, 222, 56}, 202},
	{{254, 202, 113, 112, 173, 0, 190, 11, 96, 2, 182, 40, 56, 188, 76, 208}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 41, 84, 139, 123, 31, 72, 140, 8}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 207, 145, 35, 141, 152, 165, 137, 96}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 112, 223, 105}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 29, 165, 207, 56, 255, 4, 187}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 159, 60, 88, 239, 28, 113, 84}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 182, 31, 111}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 191}, 202},
	{{254, 202, 113, 112, 173, 0, 233, 225, 129, 79, 136, 47, 43, 84, 32, 197}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 164, 47, 246, 33, 40, 43, 254}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 189}, 202},
	{{254, 202, 113, 112, 173, 0, 61, 117, 122, 233, 21, 167, 203, 223, 30, 167}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 85}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 71, 91, 114, 134, 118, 213, 52}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 100, 173, 224, 192}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 15, 211, 219}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 12, 202, 247, 111, 251, 69, 47, 56, 132}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 251}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 53}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 36, 114, 49, 59, 3, 219}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 124, 243, 39, 15, 74, 164, 46, 192, 140}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 36, 196, 120, 32, 140}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 251}, 202},
	{{254, 202, 113, 112, 173, 0, 136, 99, 112, 168, 233, 102, 74, 245, 88, 224}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 164, 172, 69, 213, 196, 124, 225, 250}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 65, 78, 178, 240, 122, 57, 250}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 178, 102, 222, 52, 0, 118, 163, 80}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 36, 159, 27, 38, 72}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 25, 21, 164, 170, 18, 127, 32}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 118, 82, 217}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 71, 254, 110, 94, 217, 134, 253, 42, 196}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{254, 202, 113, 112, 173, 0, 240, 66, 27, 228, 47, 181, 182, 172, 66, 54}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 226, 42, 7, 45, 161, 65, 188, 210}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 247, 29, 134, 178, 68, 120}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 233, 75, 86, 232}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 115, 82, 61, 124, 65, 98, 34, 64, 186}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 150, 192, 21, 42, 251, 21, 214}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 26, 65, 155, 142, 176, 36}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 249, 47, 184}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 16, 216, 150, 9}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 42, 84, 16}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 0, 0, 0, 0, 107, 57, 217}, 202},
	{{254, 202, 113, 112, 173, 0, 0, 0, 0, 179, 187, 17, 131, 217, 221, 58}, 202},
	{{254, 202, 113, 112, 173, 0, 79, 207, 185, 232, 76, 92, 161, 59, 248, 149}, 202},
	{{254, 202, 113, 112, 173, 0, 80, 159, 88, 145, 208, 177, 14, 167, 253, 99}, 202},
	{{80, 152, 0, 0, 0, 0, 0, 43, 57, 87, 157, 155, 227, 156, 173, 168}, 107},
	{{80, 152, 0, 0, 0, 0, 249, 255, 230, 41, 174, 73, 108, 162, 143, 35}, 107},
	{{80, 152, 0, 0, 0, 0, 104, 5, 179, 93, 201, 60, 113, 129, 178, 246}, 107},
	{{80, 152, 95, 109, 235, 84, 48, 68, 196, 119, 97, 208, 245, 68, 210, 229}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 51}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99}, 107},
	{{80, 152, 43, 94, 146, 234, 180, 183, 37, 1, 157, 236, 43, 130, 16, 201}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 239, 247, 123, 86, 196, 85, 163}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 233}, 107},
	{{80, 152, 0, 0, 164, 210, 137, 135, 76, 221, 138, 72, 217, 207, 122, 26}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 120}, 107},
	{{80, 152, 0, 0, 0, 242, 57, 47, 111, 8, 115, 214, 147, 248, 95, 59}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 107},
	{{80, 152, 0, 0, 80, 122, 155, 247, 32, 147, 92, 233, 169, 118, 163, 148}, 107},
	{{80, 152, 0, 0, 121, 69, 53, 26, 205, 26, 133, 84, 109, 1, 145, 193}, 107},
	{{80, 152, 0, 0, 106, 141, 49, 180, 148, 251, 62, 16, 99, 76, 197, 218}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 88, 202, 28, 57, 151, 202, 210, 82}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{80, 152, 0, 0, 0, 0, 38, 34, 248, 146, 83, 106, 161, 250, 222, 101}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 123, 239, 224, 62, 195, 88}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 32, 206, 144, 93, 114, 11}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 232, 180, 41, 80, 132, 150, 111}, 107},
	{{80, 152, 0, 0, 0, 55, 148, 119, 30, 234, 185, 146, 62, 201, 6, 51}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 162, 31, 73, 195, 41, 220, 106}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 109, 8, 44, 167, 195, 212}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 195, 1, 200, 67, 134, 246, 214, 45}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 54, 43, 46, 98, 21, 178, 143, 233}, 107},
	{{80, 152, 0, 237, 228, 0, 168, 26, 50, 11, 116, 134, 122, 237, 187, 87}, 107},
	{{80, 152, 0, 0, 0, 69, 0, 93, 26, 31, 33, 198, 163, 24, 12, 50}, 107},
	{{80, 152, 251, 206, 33, 49, 86, 149, 208, 167, 114, 137, 15, 163, 246, 212}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 77, 251, 136, 86, 48, 173, 89, 67}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 158, 139, 227, 2, 107, 250}, 107},
	{{80, 152, 0, 0, 0, 16, 73, 29, 130, 234, 86, 249, 229, 207, 167, 50}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 91, 2, 168, 32, 219, 246, 5}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 65, 248, 61, 248}, 107},
	{{80, 152, 194, 40, 18, 99, 177, 154, 166, 211, 153, 150, 39, 160, 251, 63}, 107},
	{{80, 152, 0, 0, 236, 147, 88, 0, 92, 71, 165, 2, 215, 36, 106, 12}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 214, 31, 29, 42, 111, 163, 125, 176}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 237, 8, 19, 93, 71, 165, 60, 87, 112}, 107},
	{{80, 152, 0, 0, 0, 35, 89, 203, 247, 190, 61, 193, 173, 139, 176, 182}, 107},
	{{80, 152, 0, 0, 26, 143, 65, 200, 221, 48, 52, 157, 58, 52, 162, 95}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 207}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 47, 163, 83}, 107},
	{{80, 152, 0, 0, 0, 0, 29, 232, 57, 101, 177, 9, 184, 167, 98, 143}, 107},
	{{80, 152, 97, 204, 48, 190, 81, 89, 240, 171, 11, 171, 119, 18, 174, 8}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 165}, 107},
	{{80, 152, 0, 245, 134, 1, 237, 74, 148, 85, 231, 189, 161, 51, 31, 82}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 153}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 117, 212}, 107},
	{{80, 152, 0, 197, 161, 156, 136, 96, 107, 41, 182, 203, 26, 58, 136, 175}, 107},
	{{80, 152, 0, 0, 0, 237, 191, 68, 4, 51, 60, 169, 27, 77, 232, 181}, 107},
	{{80, 152, 0, 88, 150, 152, 85, 14, 243, 230, 177, 202, 89, 207, 79, 198}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 162, 36, 130, 63, 215, 57, 0}, 107},
	{{80, 152, 0, 117, 175, 198, 161, 33, 92, 174, 246, 29, 104, 169, 19, 175}, 107},
	{{80, 152, 253, 24, 86, 148, 46, 47, 142, 88, 65, 227, 163, 172, 123, 19}, 107},
	{{80, 152, 0, 0, 0, 170, 69, 222, 60, 207, 28, 122, 6, 158, 117, 47}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{80, 152, 207, 92, 8, 167, 187, 252, 3, 250, 86, 97, 138, 194, 162, 197}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 67, 107, 202, 227, 63, 125, 61, 230, 45}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 37, 26, 28}, 107},
	{{80, 152, 0, 0, 190, 87, 65, 177, 7, 193, 78, 136, 64, 124, 105, 139}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 242, 131, 2, 215, 224, 25, 145, 35}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 75, 51}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 141, 17, 234, 199, 159, 104, 20, 67, 208}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 107},
	{{80, 152, 0, 0, 0, 36, 112, 115, 37, 192, 2, 23, 193, 230, 190, 93}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 33, 53, 214, 130, 221, 136}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 234}, 107},
	{{80, 152, 0, 189, 231, 181, 151, 82, 38, 25, 228, 18, 146, 58, 220, 127}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 85, 248, 202, 132, 214, 2, 231}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 137, 199, 152}, 107},
	{{80, 152, 0, 0, 0, 194, 205, 253, 165, 205, 167, 99, 77, 55, 106, 117}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 234, 142, 63, 97, 128, 227, 157, 98}, 107},
	{{80, 152, 0, 0, 0, 0, 113, 64, 173, 190, 30, 143, 46, 46, 112, 122}, 107},
	{{80, 152, 0, 0, 0, 211, 33, 203, 112, 231, 249, 95, 195, 175, 166, 166}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 156, 116, 115, 235, 23, 109, 212}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 2, 4, 198, 149}, 107},
	{{80, 152, 0, 0, 0, 117, 8, 70, 166, 181, 205, 189, 64, 180, 41, 181}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 136, 172, 111, 60, 88, 59, 93, 97}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 132}, 107},
	{{80, 152, 0, 0, 0, 0, 48, 190, 86, 252, 99, 166, 169, 10, 161, 27}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 218, 161}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 254, 213, 155, 95, 77, 112}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 95, 56, 189}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 4, 61, 57, 164, 229, 147}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 255, 54, 3, 6, 71, 63, 61, 175}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 226, 119, 60, 198, 7, 35, 84}, 107},
	{{80, 152, 0, 0, 0, 17, 188, 35, 68, 129, 178, 54, 137, 227, 184, 211}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 230, 199}, 107},
	{{80, 152, 0, 0, 38, 123, 200, 6, 125, 31, 78, 123, 113, 20, 193, 232}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 219, 96, 156, 113}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 233, 192, 244, 246, 213, 162, 56, 246, 172}, 107},
	{{80, 152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 56, 88, 42, 103, 196, 190, 5}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 32, 183, 89, 70}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 172, 28, 32, 6, 178, 48, 3, 19}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 15, 185, 29}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 250, 113}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 124},
	{{222, 216, 0, 0, 0, 0, 128, 32, 41, 84, 206, 38, 1, 56, 252, 158}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 195, 125, 155, 205, 73, 46, 38}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 71, 158, 113, 109, 24, 244, 217}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 124},
	{{222, 216, 0, 0, 0, 0, 102, 236, 219, 60, 147, 51, 45, 71, 104, 87}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 118, 36, 85, 60, 129, 224, 214, 83}, 124},
	{{222, 216, 0, 0, 70, 202, 95, 99, 201, 74, 11, 235, 19, 79, 105, 175}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 177}, 124},
	{{222, 216, 0, 0, 0, 0, 3, 205, 72, 185, 228, 134, 94, 112, 206, 151}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 114, 120}, 124},
	{{222, 216, 0, 0, 34, 165, 194, 205, 53, 219, 158, 164, 20, 17, 140, 88}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 124},
	{{222, 216, 0, 119, 104, 156, 123, 248, 217, 253, 213, 193, 72, 18, 196, 203}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 39, 233, 196, 193, 238, 97, 182, 149}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 180, 1, 110, 246, 138, 127, 247}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 136, 188, 120, 60}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 221, 146, 19, 202}, 124},
	{{222, 216, 0, 0, 0, 0, 17, 174, 252, 139, 86, 53, 42, 96, 133, 241}, 124},
	{{222, 216, 0, 0, 0, 0, 89, 189, 183, 214, 201, 44, 183, 175, 37, 115}, 124},
	{{222, 216, 0, 116, 197, 192, 144, 214, 208, 80, 50, 118, 159, 12, 141, 34}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 112, 21, 198, 211}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 61, 57}, 124},
	{{222, 216, 0, 0, 0, 96, 4, 127, 251, 154, 68, 139, 126, 49, 235, 200}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 239, 115, 194, 2}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 169, 73, 197}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 38, 204, 62, 169}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 162, 228, 181, 163, 184, 218, 240, 220}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 54, 64, 50, 209}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 16}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 231, 238, 54}, 124},
	{{222, 216, 0, 0, 0, 176, 195, 190, 124, 138, 209, 64, 218, 91, 223, 15}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 36, 191, 240}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 216, 165, 138, 157, 184, 137, 192, 79, 1}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 252, 241}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65}, 124},
	{{222, 216, 0, 0, 137, 231, 38, 242, 207, 47, 183, 223, 71, 51, 7, 22}, 124},
	{{222, 216, 0, 0, 240, 59, 111, 131, 230, 102, 82, 79, 241, 234, 211, 0}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 23, 224, 42, 189, 67, 218, 240}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 230, 56, 117, 92, 12, 185, 185}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 12, 152, 202}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 172, 156, 72, 193, 213, 99, 206, 219}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 79, 101, 215, 206, 177, 152}, 124},
	{{222, 216, 0, 0, 87, 85, 78, 40, 0, 51, 116, 111, 209, 204, 207, 98}, 124},
	{{222, 216, 0, 0, 0, 0, 105, 255, 118, 75, 224, 140, 244, 224, 167, 226}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 35, 174, 118, 178, 71, 3, 0, 18}, 124},
	{{222, 216, 0, 0, 251, 88, 215, 236, 250, 44, 117, 127, 5, 189, 248, 127}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 248, 111, 68}, 124},
	{{222, 216, 74, 39, 77, 201, 23, 6, 50, 183, 108, 133, 195, 175, 188, 89}, 124},
	{{222, 216, 0, 0, 0, 166, 146, 47, 211, 182, 27, 86, 12, 166, 186, 196}, 124},
	{{222, 216, 0, 0, 0, 105, 241, 15, 162, 31, 61, 89, 165, 172, 143, 4}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 12, 143, 235, 25, 105, 138, 3, 123, 143}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 0, 204, 45}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 195, 179, 5, 34, 76, 76, 204, 47, 100}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 217}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 137, 186, 155, 153, 193, 211, 254, 173, 106}, 124},
	{{222, 216, 0, 0, 0, 0, 226, 134, 185, 16, 185, 4, 183, 18, 161, 62}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 244, 38, 243, 29, 232, 18, 154, 250, 171}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 26, 35, 92, 7, 78, 46, 74, 139, 147}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 236, 219, 81, 98}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 147}, 124},
	{{222, 216, 0, 0, 103, 22, 66, 212, 174, 122, 114, 200, 113, 49, 182, 38}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 141, 6, 138, 247}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 249, 222, 84, 196, 191, 94, 235, 145, 170}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 113, 168, 231, 15}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 51}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 91, 27, 141, 226, 182, 127, 174, 170}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 135, 103, 151, 197, 138, 201, 225}, 124},
	{{222, 216, 24, 121, 31, 200, 75, 77, 153, 35, 6, 58, 95, 194, 156, 166}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 75, 145, 216}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 195, 33, 37, 249, 23, 55, 239, 202}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 124},
	{{222, 216, 0, 0, 0, 0, 243, 88, 45, 35, 32, 46, 184, 51, 203, 57}, 124},
	{{222, 216, 0, 0, 0, 97, 146, 32, 245, 150, 123, 202, 93, 108, 222, 230}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 105, 138, 81, 8}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 240}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 76, 56, 194, 180}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 58, 52, 187, 89, 118, 41, 200}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 101, 58, 2, 53, 39, 84, 99, 210, 49}, 124},
	{{222, 216, 0, 0, 0, 230, 218, 251, 134, 185, 57, 18, 32, 126, 2, 225}, 124},
	{{222, 216, 0, 0, 14, 56, 160, 62, 177, 207, 241, 170, 236, 92, 235, 4}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 207, 140, 217, 190, 14, 66}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 163, 193}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 20, 64, 255, 60, 60, 42}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 86, 191, 151, 223}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 139, 153}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 152}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 92, 115}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 148, 232, 115, 254}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 102, 188, 57, 183, 166, 67, 93}, 124},
	{{222, 216, 0, 0, 0, 0, 0, 0, 0, 192, 192, 230, 4, 244, 116, 251}, 124},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 148, 125, 14, 253, 234, 92, 98}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 177, 47}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 60, 136, 246}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 77, 176, 17, 157, 172, 186, 253, 190}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 202, 190, 237}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 117, 87, 25, 59}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 227, 237, 229}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 181, 219}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 27, 196}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 145, 238, 136, 163, 26, 70, 222, 155, 33}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 143, 222, 36, 109, 36, 0, 118}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 237, 43, 131, 163, 116}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 200, 99, 55, 178}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 200, 28, 211, 64}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 10, 33, 90, 30, 41}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 194, 87, 250, 207, 31, 11, 79, 33}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 98, 52, 121, 90, 244, 171, 192}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 238, 238}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 168, 56, 95, 144, 132, 179}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 75, 221, 143, 36, 32, 42}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 255, 67, 201, 6, 130, 244, 252, 101, 185}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 112, 134, 210, 195, 96, 97, 227, 164}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 234, 103, 40, 82, 80, 197, 192, 253, 228}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 117, 172, 132, 66, 195, 212}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 134, 174, 253, 176, 28, 169, 181}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 172, 26, 226, 95, 208, 162}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 202, 66, 159, 106, 173}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 19, 85, 105, 96, 43, 251}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 21, 31}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 186, 249, 137, 119, 102, 27}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 33, 137}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 111, 173, 144, 93, 226, 49, 172, 34}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 20, 222, 171, 147, 29}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 29, 217, 139, 1, 202, 176, 190, 194}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 90, 29, 246, 138, 71, 178, 254, 153}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 232, 242, 128, 80, 115, 101, 47, 135, 227}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 63, 246, 127, 48, 190}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 209, 10, 167, 136, 119, 225}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 199, 53}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 99, 172, 153, 98, 32, 105}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 178, 238, 242}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 133, 18, 197, 64}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 134, 104, 98, 28, 41, 131, 105}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 42, 76, 68, 12, 129, 38, 100, 251}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 172, 67, 173, 243, 156}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 232, 181, 218, 210, 234, 69, 168, 66}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 22, 16, 0, 99, 253, 59, 121}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 187, 203, 192, 114, 78, 143}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 11, 143, 250, 223, 214, 70, 34, 3}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 253, 29, 34, 197, 253, 253, 115}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 101, 83, 112, 255, 22, 49, 243, 49}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 22, 199, 252, 213, 158}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 88, 141, 108, 81, 211}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 246, 38, 173, 100, 217, 196, 8, 180}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 1, 70, 74, 178}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 36, 62, 156, 89}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 246, 252, 4, 143, 169, 1, 14, 153}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 10, 148, 171, 71}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 241, 22}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 61, 43, 223, 164, 170, 138, 170, 15, 158}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 236, 15, 78, 117, 228, 102, 195}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 22, 247, 109}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 63, 255, 83, 12, 142, 98}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 116, 71, 196, 252}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 156, 225}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 112, 177, 142, 8, 53, 111, 112, 163}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 186, 216, 81, 6, 55}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 245, 130, 248, 183, 128, 195, 107}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 210, 247, 45, 108}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 21, 3, 62, 32, 143, 145, 209}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 4, 138, 102, 144, 195, 128, 241, 181, 136}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 215, 62, 200, 244, 164, 51}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 156, 34, 180, 209}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 223, 168, 117, 182, 134, 157, 83, 155, 108}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 254, 81, 20, 113, 8, 185, 231, 96}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 45, 128}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 88, 245, 82, 149, 96, 239, 216}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 32, 122, 10, 15}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 227, 253, 165}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 167, 76, 219, 236}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 100, 41, 1, 152, 98}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 206, 90, 83, 174, 149}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 3, 38, 66, 86, 105, 238}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 70, 73}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 212, 215, 8, 252, 102, 234, 51, 191, 89}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 206, 203, 115, 25, 183, 246, 49, 210}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 0, 0, 0, 0, 95, 203}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 0, 0, 8, 238, 67, 234, 96, 215}, 57},
	{{219, 138, 253, 12, 188, 197, 48, 0, 211, 75, 171, 30, 126, 187, 47, 23}, 57},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 25}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 238, 175, 195}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 162}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 200, 16, 96, 129}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 105, 12}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 196, 89}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 49, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 137}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 252, 246, 211}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 242}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 96}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 184, 184}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 238}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 114}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 8, 22, 203}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 96, 127}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 214, 126, 95}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 215}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 65}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 45, 19, 148}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 30}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 239}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 227, 101, 131, 1}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 49, 159, 128, 178}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 6, 164}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 226, 245, 167}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 181, 214, 55}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 183, 30}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 199}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 86, 240, 139}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 2, 146, 24}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 210, 94, 242, 51}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 45, 209, 141}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 25, 56, 104, 8}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 162, 243, 63, 232}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 59, 25}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 171, 130, 18}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 98, 69}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 11, 22, 106}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 143, 8}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 77, 242}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 220}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 179, 179}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 225, 240, 178}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 14, 165}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 215, 52, 128}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 177, 193, 84, 114}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 37, 1}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 81, 138}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 239}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 190, 184, 29}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 231, 20, 244}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 253, 234, 26}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 167, 182, 46}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 241, 88, 137}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 238, 31}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 12}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 18, 164, 25, 157}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 95, 49}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 156, 252, 79, 90}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 232}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 38, 77}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 96, 78, 4}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 80}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 219, 192, 23, 164}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 9, 129}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 217, 68}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 18, 49, 19, 153}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 120}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 167, 90, 189, 73}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 142, 150, 84, 183}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 197}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 200}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{124, 41, 173, 8, 202, 192, 61, 254, 174, 48, 239, 112, 0, 0, 0, 0}, 181},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 90}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 237, 81}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 199, 133, 111, 153, 28}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 158, 187, 202, 82, 129}, 107},
	{{195, 236, 245, 0, 117, 124, 248, 192, 199, 77, 83, 223, 172, 204, 243, 149}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 86, 103, 18, 38, 199, 249, 234, 59}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 71, 121, 111, 46, 138, 192, 195, 36, 223}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 133, 192, 201}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 124, 69}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 200, 124}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 113, 81, 3, 197, 52, 45}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 4, 164}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 243, 119, 30, 164, 181}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 2, 58}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 192, 53, 108, 15, 181, 88, 129}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 248}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 67, 118, 223, 58, 243, 16}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 107, 195}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 87, 155, 246}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 90, 203, 48, 224, 153, 39, 162}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 206, 175, 160, 157, 100}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 162, 205, 232, 148, 140, 247, 108, 186, 234}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 64, 139, 160, 110, 153, 73, 180}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 249, 192, 86, 72, 60, 141, 163, 239}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 106, 169, 7, 97, 98, 194, 66, 188, 185}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 29, 219, 219, 234, 134, 84, 240, 191, 248}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 238, 243, 138, 224, 235, 151}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 113}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 24, 38, 76, 16, 49, 68, 31}, 107},
	{{195, 236, 245, 0, 0, 44, 42, 156, 81, 34, 55, 201, 98, 1, 23, 90}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 135, 87, 126, 52, 249, 197, 40}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 121, 16, 182, 102, 86, 202}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 210, 143, 199, 105, 219, 221}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182}, 107},
	{{195, 236, 245, 0, 0, 0, 252, 69, 82, 6, 5, 251, 217, 255, 209, 61}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 103, 110, 236, 218, 222, 19}, 107},
	{{195, 236, 245, 0, 0, 128, 2, 145, 79, 8, 11, 116, 103, 197, 225, 44}, 107},
	{{195, 236, 245, 0, 0, 0, 244, 196, 84, 214, 68, 232, 158, 244, 231, 73}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 115, 41, 206, 213, 126, 12}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 202, 9, 217, 18, 207, 105, 211}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 15, 22, 174, 150, 131}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 85, 4, 0}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 131, 192, 103}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 214, 152, 24, 156, 104, 17, 93, 29, 219}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 237, 227}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 47, 215, 8, 118, 237, 123}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 1, 117, 215, 54, 170, 48, 7}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 194, 86, 175, 200, 64, 80, 75, 220, 205}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 215, 217, 64, 159, 17, 181, 3, 163, 240}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 5}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 96, 155, 227, 129, 75, 126, 0, 27, 106}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 27, 13, 238}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 137}, 107},
	{{195, 236, 245, 0, 0, 158, 61, 101, 50, 220, 61, 196, 147, 164, 203, 118}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 252, 62, 242, 117, 140, 19}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 14, 217, 52, 33, 61, 77}, 107},
	{{195, 236, 245, 0, 0, 0, 72, 246, 83, 60, 108, 146, 225, 71, 179, 3}, 107},
	{{195, 236, 245, 0, 125, 96, 156, 187, 181, 222, 92, 99, 231, 240, 43, 110}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 100, 130, 252, 184, 204, 44}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 157, 207, 27}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 90, 108, 27}, 107},
	{{195, 236, 245, 0, 200, 105, 239, 226, 15, 138, 118, 114, 62, 195, 5, 39}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 153, 7, 54}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 94, 2, 200}, 107},
	{{195, 236, 245, 0, 0, 8, 244, 116, 142, 141, 211, 34, 21, 59, 83, 242}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 94, 171, 127, 22, 196, 225, 80, 168}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 188, 57, 105, 243, 119}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 229}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 105, 216, 70, 79, 170, 60, 51, 40, 45}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 143, 251, 73}, 107},
	{{195, 236, 245, 0, 0, 182, 45, 218, 213, 158, 187, 132, 57, 251, 207, 85}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 171, 191, 212, 215, 108, 238}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 2, 39, 218, 240, 53, 58, 147}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 88, 204}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 18, 246, 215, 123, 44, 72, 156, 212}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 137}, 107},
	{{195, 236, 245, 0, 44, 120, 195, 141, 49, 99, 51, 106, 56, 241, 177, 109}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 112, 123, 84, 169, 96}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 98, 242, 108, 35, 68, 115, 217, 222}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 0, 0, 0, 0, 186, 181, 15, 35, 215}, 107},
	{{195, 236, 245, 0, 0, 104, 80, 1, 11, 16, 3, 0, 233, 175, 69, 210}, 107},
	{{195, 236, 245, 0, 0, 0, 0, 72, 177, 100, 71, 208, 197, 104, 4, 247}, 107},
	{{195, 236, 245, 0, 0, 0, 15, 81, 20, 199, 127, 62, 81, 235, 88, 222}, 107},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{83, 82, 42, 244, 136, 191, 197, 81, 91, 154, 216, 85, 29, 150, 198, 22}, 101},
	{{112, 0, 0, 0, 0, 113, 62, 76, 208, 238, 78, 119, 64, 237, 250, 192}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 5, 30, 114, 30, 160, 172, 122}, 3},
	{{112, 0, 241, 242, 250, 196, 95, 151, 142, 168, 251, 115, 150, 94, 190, 92}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 146, 81, 156, 144}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 87, 33, 172, 169, 192, 96, 182}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 252, 84, 182, 196, 68, 179, 44, 210, 164}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 49}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 40, 48, 151, 178}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 5, 11, 93, 208}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 146, 111, 128, 204}, 3},
	{{112, 0, 0, 0, 0, 0, 225, 163, 37, 10, 36, 184, 2, 140, 33, 102}, 3},
	{{112, 236, 246, 109, 235, 17, 243, 108, 16, 33, 202, 155, 252, 55, 240, 250}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 60, 203, 78, 40, 16}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 85, 132, 20, 124, 17, 77, 214, 56}, 3},
	{{112, 0, 248, 95, 145, 238, 76, 237, 172, 56, 156, 222, 170, 50, 167, 97}, 3},
	{{112, 0, 0, 0, 123, 167, 15, 39, 152, 185, 125, 249, 213, 16, 195, 189}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 20, 121, 11, 253, 144, 56, 242, 25}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 35, 109}, 3},
	{{112, 0, 0, 0, 87, 39, 134, 120, 97, 99, 172, 65, 105, 185, 53, 193}, 3},
	{{112, 0, 182, 24, 227, 42, 125, 228, 81, 14, 74, 155, 105, 9, 108, 53}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 50, 115}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 98, 241, 17, 30, 14, 177, 114, 160, 181}, 3},
	{{112, 0, 34, 16, 48, 5, 84, 248, 134, 250, 67, 47, 31, 78, 37, 86}, 3},
	{{112, 0, 0, 0, 0, 0, 197, 161, 97, 249, 105, 123, 19, 193, 163, 25}, 3},
	{{112, 0, 89, 254, 86, 126, 119, 218, 176, 248, 57, 182, 55, 61, 38, 226}, 3},
	{{112, 0, 0, 38, 97, 17, 196, 232, 31, 190, 172, 81, 109, 104, 228, 29}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 64, 217, 148, 201, 189, 175, 64, 128, 176, 116, 61}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 254, 148}, 3},
	{{112, 0, 0, 0, 81, 59, 143, 148, 167, 176, 14, 25, 186, 195, 73, 42}, 3},
	{{112, 0, 0, 0, 0, 244, 91, 204, 152, 61, 120, 47, 136, 156, 206, 161}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 45, 84, 106}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 75, 2, 241, 39, 74}, 3},
	{{112, 110, 160, 203, 226, 168, 223, 208, 73, 170, 166, 211, 126, 147, 25, 2}, 3},
	{{112, 0, 0, 0, 0, 154, 152, 166, 42, 39, 88, 149, 48, 205, 207, 98}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 211, 152, 46, 218}, 3},
	{{112, 0, 0, 168, 8, 9, 24, 103, 114, 69, 119, 79, 255, 36, 164, 70}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 146, 187, 218, 106}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 54, 154}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 31, 153}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 165, 238, 62, 210, 248, 26, 19, 114, 173, 223, 233, 138, 183, 176, 29}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 6, 197, 203, 175, 25, 207, 137}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 231, 115, 3, 250}, 3},
	{{112, 0, 0, 25, 152, 208, 59, 207, 120, 52, 86, 90, 56, 250, 254, 187}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 12, 162, 27, 92, 156, 141, 13, 161, 53}, 3},
	{{112, 0, 0, 235, 205, 229, 7, 166, 90, 15, 15, 222, 87, 228, 93, 99}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 88, 175, 173, 16, 104, 127, 133, 158}, 3},
	{{112, 0, 0, 150, 90, 238, 45, 183, 117, 211, 99, 21, 254, 166, 228, 35}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 192, 40, 89, 247, 136, 165, 246}, 3},
	{{112, 219, 191, 74, 215, 205, 0, 104, 104, 57, 96, 252, 174, 34, 23, 24}, 3},
	{{112, 0, 235, 51, 83, 35, 218, 244, 77, 104, 226, 56, 129, 190, 124, 81}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 1, 160, 97}, 3},
	{{112, 0, 0, 29, 10, 167, 212, 122, 107, 166, 240, 222, 171, 37, 249, 94}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 45, 179}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 41, 91, 211, 174, 189, 145, 204, 246, 59}, 3},
	{{112, 0, 0, 0, 0, 111, 120, 197, 182, 48, 247, 110, 255, 161, 12, 225}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 205, 184, 83}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 230, 58, 26}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 144}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 253, 145, 91, 142, 4, 138, 122, 243}, 3},
	{{112, 0, 0, 0, 0, 0, 126, 26, 153, 208, 130, 145, 151, 148, 207, 192}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 233, 129, 79}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 62, 44, 210, 137, 170, 16, 216}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 49, 18, 45, 68, 166, 186, 32, 136}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 184, 167, 3, 67}, 3},
	{{112, 0, 0, 0, 0, 0, 241, 196, 19, 94, 203, 192, 189, 168, 244, 81}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 61, 193, 54, 143, 111, 150, 171, 224}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 85, 224, 129, 126}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 141, 229, 203, 39, 194, 179, 218, 246, 13}, 3},
	{{112, 0, 0, 112, 77, 244, 228, 188, 222, 5, 169, 40, 164, 57, 9, 42}, 3},
	{{112, 0, 0, 0, 0, 77, 138, 184, 107, 133, 65, 204, 124, 5, 104, 248}, 3},
	{{112, 0, 255, 149, 93, 199, 179, 130, 198, 91, 179, 152, 159, 192, 177, 209}, 3},
	{{112, 14, 104, 219, 180, 128, 153, 128, 180, 36, 118, 152, 161, 10, 131, 234}, 3},
	{{112, 0, 0, 0, 0, 233, 223, 8, 13, 122, 165, 243, 148, 157, 241, 233}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 226, 23, 153, 243, 73, 77, 182, 117, 80, 140, 187, 184, 34, 82}, 3},
	{{112, 0, 0, 132, 231, 39, 40, 97, 79, 77, 119, 195, 42, 218, 187, 224}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 175, 203}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 42, 123, 142, 136, 177, 6, 71, 49, 39}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 11, 167}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 142, 218, 177, 171}, 3},
	{{112, 0, 0, 140, 192, 218, 20, 238, 203, 197, 54, 146, 199, 13, 85, 36}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 219, 57, 28, 84}, 3},
	{{112, 0, 0, 0, 0, 255, 44, 56, 54, 76, 198, 59, 169, 249, 80, 105}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 229, 15, 26, 151}, 3},
	{{112, 0, 35, 246, 165, 152, 83, 39, 212, 186, 237, 191, 32, 98, 15, 68}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 33, 54, 199, 109, 230, 31, 73, 31}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 234, 90, 202, 194, 147, 26, 163, 59}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 52}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 137, 28, 211, 160, 187, 47, 135}, 3},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 175, 197}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 22}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 190, 239, 89, 26}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 139, 28, 200, 5}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 105, 73, 22, 63, 200, 16, 111}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 27, 214, 241, 157, 49}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 155}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 75}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 123, 130, 110, 239}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 142, 253}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 134, 89, 232, 121}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 32}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 201}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 71}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 57, 255, 13, 39, 67, 178}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 230, 19, 98, 244, 142, 59, 235}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 35, 107, 243, 253, 183}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 90, 242, 185, 76, 92, 1}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 225, 125, 143, 195, 97, 227, 138, 61}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 182, 75, 9, 15, 200}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 136, 81, 188, 118, 205, 219}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 197}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 192, 231, 69, 98, 30, 60}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 157, 220, 54, 26, 185, 182}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 23, 133, 49, 60, 161}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 154, 132, 146, 205}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 2, 112, 137, 233, 184, 139, 19}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 75}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 118, 91, 125, 192}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 160, 40, 123, 2}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 75, 23}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 212, 166, 160, 211, 139, 248}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 157, 41, 20, 66, 159, 213, 38}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 246, 133}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 239, 102}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 240}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 52}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 96, 40, 116, 234, 142, 39}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 62, 125}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 197, 192, 222, 219, 232}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 52, 206, 29, 98, 38}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 81, 173, 11, 104, 116, 20, 198, 196}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 129, 30, 7, 84, 140, 151, 158}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 239}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 58}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 198, 160, 188}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 249, 235}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 245, 81, 156, 24}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 216}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 13, 210, 239, 127, 105, 59, 217}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 18, 132, 235, 6, 85, 87, 109, 109}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 116, 205, 200, 5, 31, 13, 180}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 96}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 194, 115, 75, 34}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 246, 70, 184, 124, 205, 113, 139}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 170, 100, 76, 134, 149}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 114, 189, 145, 67, 143}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 103, 180, 152, 193}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 163, 198, 31, 6, 90, 13, 179}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 41, 188, 68, 17, 44, 196}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 47, 10, 26}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 149, 43}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 127, 116, 16, 202, 173}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 136, 77, 82}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 131, 150, 144}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 58, 67, 196, 238, 171, 145}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 126, 68, 113}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 158, 39, 214, 171}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 252, 252}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 97, 13, 156, 254, 44, 84}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 208, 46, 184, 225, 159, 54, 251}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 225, 18, 82, 16, 193, 147}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 30, 161, 204, 3, 121, 136}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 12, 30, 175, 85, 224, 166, 103}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 64, 75, 128, 15, 120, 126, 150}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 219, 13, 188}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 162, 20}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 166, 142, 122}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 56, 225, 111, 163, 105, 31, 55}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 76, 151, 205}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 51, 178, 240, 245, 70, 104}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 181, 171, 76, 252, 64, 136, 203}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 70, 109, 191, 246}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 165, 168, 118}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 246, 254, 171, 217, 92}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 200, 42, 176}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 16}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 143, 134, 95, 134, 194}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 86, 221, 169, 162}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 201}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 130, 76, 210, 52, 7, 175, 40}, 136},
	{{44, 30, 219, 248, 214, 88, 225, 132, 0, 0, 0, 0, 0, 0, 0, 155}, 136},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 59, 105, 79, 154, 0, 116}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 69, 21, 65, 224, 185}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 161, 172, 113, 224, 244, 192, 211, 45}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 246, 47, 47, 12}, 114},
	{{41, 171, 206, 178, 195, 80, 210, 56, 66, 163, 108, 69, 225, 34, 187, 61}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 10, 212, 2, 46}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 50, 9, 84}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 145, 180, 19, 237, 176}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 17, 86, 147, 52, 10, 232, 180, 167}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 27, 249, 3, 130, 93, 162, 28, 82, 65}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 133, 128, 47, 71, 116, 230, 229}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 178, 148, 170, 175}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 128, 160, 103, 10, 58, 24, 203}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 204, 100, 1}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 124, 157, 237, 70, 142}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 205, 12, 100}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 197, 209, 120, 140, 143, 247}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 103, 41, 244, 157, 24, 45, 32, 223, 7}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 34, 171}, 114},
	{{41, 171, 206, 178, 195, 80, 172, 201, 67, 61, 194, 241, 70, 240, 63, 73}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 107, 2}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 6, 52, 76, 155, 34}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 109, 81, 228}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 137, 185, 250, 103, 247, 174, 123, 146, 226}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 242, 97, 54}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 85, 127, 51, 152, 97, 231, 206, 70, 198}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 74, 245, 64, 105}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 30, 209, 18, 26, 46, 255, 23, 109, 231}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 120, 7, 7, 242, 123}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 43, 55, 58, 99, 253, 69}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 195, 187, 26, 219}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 54, 90, 111, 135, 180, 196, 183}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 238, 62, 180}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 32, 204, 146}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 27, 76, 77}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 30, 95, 253, 172, 71, 14, 218}, 114},
	{{41, 171, 206, 178, 195, 80, 228, 23, 142, 243, 17, 191, 123, 68, 169, 118}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 66, 238, 250, 221, 245, 176, 230}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 188, 103, 33}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 50, 178, 73, 35}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 80, 205, 231}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 157, 113, 9, 44, 188, 102, 153, 184}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 154, 201, 178, 234}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 63, 53, 87, 214}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 105, 204, 130, 8, 200, 66, 25, 123}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 25, 133, 36, 174, 9}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 45, 149, 225, 66, 133, 14, 90, 208, 86}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 81, 237}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 28, 75, 51, 102, 108}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 155, 54}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 77, 94, 242, 138}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 81, 47, 130, 42, 90, 170, 31, 218, 86, 60}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 41, 218, 107, 219, 129, 167}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 201, 16, 48, 3, 194}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 209, 6, 240, 177, 53, 126, 48}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 249, 117, 129, 110, 34, 55, 141, 89, 140}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 64, 217, 97, 237, 142, 176, 115, 254, 221}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 146, 88, 0, 229, 73, 244}, 114},
	{{41, 171, 206, 178, 195, 80, 139, 207, 155, 158, 106, 57, 142, 166, 210, 27}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 52, 183, 208, 92, 234, 87, 229, 46, 69, 173}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 244, 138, 6, 4, 211, 214, 111, 14}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 95, 143, 102, 50, 104}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 16, 148, 171, 125}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 188, 5, 100, 47, 35}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 54, 145, 251, 42}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 191, 163}, 114},
	{{41, 171, 206, 178, 195, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 114},
	{{159, 15, 180, 0, 0, 0, 62, 146, 221, 34, 103, 137, 46, 225, 240, 28}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 242, 187, 104, 242, 146, 2, 28}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 110}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 215},
	{{159, 15, 180, 130, 162, 20, 171, 120, 131, 185, 17, 185, 36, 171, 49, 109}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168}, 215},
	{{159, 15, 180, 0, 0, 0, 25, 194, 5, 231, 33, 51, 58, 209, 102, 59}, 215},
	{{159, 15, 180, 0, 0, 36, 154, 210, 84, 155, 255, 69, 89, 220, 64, 2}, 215},
	{{159, 15, 180, 0, 0, 0, 51, 154, 0, 25, 230, 9, 204, 6, 220, 25}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 178, 206, 126}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 16, 114, 161, 164, 126}, 215},
	{{159, 15, 180, 0, 99, 191, 189, 215, 61, 111, 87, 84, 48, 153, 233, 27}, 215},
	{{159, 15, 180, 0, 1, 249, 147, 148, 155, 21, 205, 94, 100, 43, 129, 132}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 104, 237, 64, 207, 55, 164}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 200, 159}, 215},
	{{159, 15, 180, 0, 106, 148, 86, 116, 184, 231, 157, 32, 51, 194, 68, 82}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 215},
	{{159, 15, 180, 0, 0, 15, 156, 101, 235, 134, 219, 134, 166, 224, 191, 84}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 54, 114, 118, 222, 129, 155, 127, 212}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 46, 101}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 97, 95, 168, 157, 154, 221, 162, 81}, 215},
	{{159, 15, 180, 0, 23, 9, 212, 184, 148, 95, 93, 2, 229, 61, 125, 107}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 49, 176, 43, 89, 95, 196, 134}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 88, 251, 5}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 39, 34, 130, 187, 188, 97, 227, 242, 55}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 254}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 124}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 119, 138, 73, 138, 97}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 176, 48, 179, 18, 250}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 178, 63, 200, 66, 220, 73, 34, 27, 133}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 109, 55, 181, 118, 250, 248}, 215},
	{{159, 15, 180, 0, 0, 0, 102, 226, 251, 27, 232, 165, 156, 7, 0, 180}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 25, 140, 107, 22, 153, 182, 85, 46}, 215},
	{{159, 15, 180, 73, 19, 76, 60, 204, 48, 122, 65, 187, 39, 229, 81, 73}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 47, 217, 232, 74, 129, 233, 89}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 232, 211, 19, 160, 128}, 215},
	{{159, 15, 180, 120, 157, 147, 186, 227, 229, 194, 105, 125, 16, 81, 201, 157}, 215},
	{{159, 15, 180, 0, 0, 0, 83, 46, 101, 59, 75, 184, 133, 200, 171, 245}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 22, 19, 6, 47, 125, 129, 181, 239, 198}, 215},
	{{159, 15, 180, 0, 0, 0, 122, 187, 197, 215, 236, 246, 209, 110, 204, 234}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 166, 205}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{159, 15, 180, 0, 0, 0, 123, 89, 77, 116, 8, 44, 93, 117, 65, 101}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 131, 174, 160}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 255, 242, 135, 248, 46}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 69, 151, 21}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 48, 162, 11, 254, 2, 43, 150}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 22, 206, 75, 245, 117, 18, 46, 61, 92}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 54, 218, 201}, 215},
	{{159, 15, 180, 0, 0, 0, 1, 235, 92, 230, 237, 56, 122, 57, 190, 190}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{159, 15, 180, 0, 0, 0, 10, 32, 216, 126, 49, 134, 185, 224, 110, 57}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 167, 178, 213, 169, 171, 187, 196, 213, 85}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 9, 81}, 215},
	{{159, 15, 180, 0, 0, 0, 222, 78, 187, 38, 21, 244, 172, 80, 81, 20}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 159, 234, 130, 175, 246}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 95, 88, 182, 23, 192}, 215},
	{{159, 15, 180, 0, 236, 83, 2, 191, 200, 36, 110, 69, 124, 244, 35, 40}, 215},
	{{159, 15, 180, 0, 0, 231, 117, 196, 149, 246, 7, 19, 69, 156, 29, 86}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157}, 215},
	{{159, 15, 180, 0, 137, 65, 57, 61, 63, 150, 27, 15, 131, 125, 139, 36}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 19}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 254, 9, 137, 146, 78}, 215},
	{{159, 15, 180, 0, 0, 75, 110, 157, 171, 224, 211, 253, 160, 189, 131, 6}, 215},
	{{159, 15, 180, 0, 0, 103, 165, 60, 89, 45, 142, 205, 47, 208, 39, 34}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 7, 83}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 249, 210, 109, 37, 180}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 30, 5}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 29, 225, 166, 95, 155, 166, 189, 35, 70}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 105, 4, 13, 50, 25, 207}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 19, 70, 41}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 187, 203, 232, 160, 79, 151}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 249, 24, 159, 80, 210, 164, 40, 24}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 83, 27, 195, 57, 191}, 215},
	{{159, 15, 180, 0, 87, 172, 154, 248, 126, 51, 193, 208, 89, 179, 224, 235}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 234, 108, 226, 112, 115, 51, 127, 5}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 244, 75, 46}, 215},
	{{159, 15, 180, 0, 58, 240, 129, 126, 1, 213, 13, 216, 90, 29, 88, 106}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 75, 79, 239, 58, 29, 137, 166}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 180, 102, 76, 126, 8, 14, 139}, 215},
	{{159, 15, 180, 0, 0, 218, 245, 95, 176, 83, 100, 112, 251, 191, 29, 58}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 147, 214, 175}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 231, 160, 181, 3, 216, 173, 98, 255}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 215},
	{{159, 15, 180, 0, 0, 0, 0, 0, 0, 0, 0, 218, 139, 173, 11, 110}, 215},
	{{159, 15, 180, 0, 0, 193, 206, 89, 176, 2, 223, 142, 167, 36, 88, 62}, 215},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 3, 18, 246}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 166, 245, 26, 214, 3}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 118, 47}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 57, 153, 59, 225}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 2}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 19, 59}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 53, 197, 244, 251, 201}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 241, 177, 107, 143, 241}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 193, 57, 49}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 48, 229, 36}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 87, 155, 59, 195, 14}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 0}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 170, 240}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 235}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 0}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 201, 21}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 81, 192}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 252, 252, 118}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 202, 14}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 0}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 224, 76, 168}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 100, 65, 168, 111, 56, 74}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 112, 249, 44, 205, 202}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 22, 166, 42}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 235}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 196, 72, 85, 120, 114}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 75, 76}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 154}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 138}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 0}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 66, 205, 36}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 38, 103, 74, 39, 156}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 90, 214, 161, 137}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 117, 48, 187, 104, 7}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 240, 183, 99, 185, 124, 217}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 0}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 202, 2, 155}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 208, 221, 217}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 130, 222, 202, 199, 134}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 230, 139}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 131, 98, 121}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 184, 102, 70, 143}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 95, 255, 181, 44}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 175, 173, 213}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 28, 112, 239}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 21, 222, 153, 205}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 134, 31, 159}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 117, 96, 156}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 54, 170, 177}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 112}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 176}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 106}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 212, 33, 112, 7}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 169, 134}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 244}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 221, 147}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 95, 163, 169, 13, 79}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 0}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 248}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 78, 68, 233}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 206}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 86, 237, 48, 230}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 73, 88, 138, 158, 138}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 107, 9, 44, 217}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 61, 235, 130}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 52, 61}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 7, 106}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 94}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 80, 170, 119}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 201}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 176, 236, 139, 58}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 216, 131}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 176, 48, 178, 7}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 78, 231, 91}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 101, 217, 30, 132, 186}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 13, 137, 105, 184}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 136}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 66, 46, 207}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 65, 218, 82}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 84, 245, 133, 188, 154}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 151, 131, 165, 40}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 0}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 113, 206, 222, 82, 76}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 243, 185, 236}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 234}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 198, 244, 167, 32, 170}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 42, 200, 68}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 88, 156, 76, 25, 211, 214}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 255, 191}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 42, 224}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 193, 212, 192, 198, 197}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 221, 205}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 135, 110}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 189, 226}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 191, 143}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 200}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 40, 91, 11, 5}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 234, 178, 117, 21}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 151, 254}, 249},
	{{42, 188, 37, 174, 86, 40, 4, 84, 174, 216, 0, 0, 0, 0, 0, 73}, 249},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 149}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 152, 21, 254, 17}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 214, 164, 112}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 233, 45, 15}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 183, 63}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 76, 38, 210}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 11, 94, 17}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 102, 179, 220}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 74}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 24, 16, 165, 203}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 70}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 87, 159}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 160, 243, 85, 151}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 148, 174, 87}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 120}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 189, 186, 199, 56}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 64, 48, 106}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 110}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 227}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 252, 130, 96}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 136, 22, 192}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 192, 199, 133, 235}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 41, 171, 36, 106}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 158, 159}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 127, 28, 101}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 215, 145}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 64, 195, 210}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 17, 142, 53, 229}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 124, 227}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 86, 187}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 55, 97, 126}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 101, 206}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 52}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 119}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 88}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 93, 51, 101, 214}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 36, 220}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 66}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 211, 111, 238}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 82, 120}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 63}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 103, 226, 82, 188}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 87, 121, 242, 129}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 229, 73, 40, 85}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 229}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 116, 82, 179}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 127}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 76, 107}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 39, 229, 95, 99}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 164, 4, 196}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 196, 116}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 154}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 205, 6}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 158, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 152, 88, 157}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 201, 196, 125}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 191, 12}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 131, 35, 55, 88}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 207, 74, 143, 174}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 64}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 211}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 243, 9, 255}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 143}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 253, 100, 230}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 67, 178, 147, 38}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 18, 107}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 202, 246}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 253, 102, 112}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 22}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 52, 22, 170}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 156}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 1}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 155}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 199, 193, 148}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 148, 55, 67}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 0, 0}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 36, 28, 202, 220}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 164, 23, 111}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 0, 0, 188, 43}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 250, 41, 204, 63}, 29},
	{{185, 227, 85, 177, 219, 95, 250, 227, 69, 154, 118, 0, 233, 130, 31, 145}, 29},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 65, 0, 123, 122, 69}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 83, 218, 101, 87, 193, 165, 43, 132, 249}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 197, 137, 239, 64, 159, 156, 34}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 203, 198, 107}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 91, 44, 190, 123, 64, 4, 151, 159, 242}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 152, 206, 204, 102, 178, 138, 9, 233, 95}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 218, 129, 23, 26}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 3, 65, 57, 110, 230, 122, 22, 233, 121}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 50, 187, 106, 107, 254, 126, 78, 238, 169}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 72, 127, 62, 135, 131, 251, 144, 126, 241}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 71},
	{{22, 185, 238, 100, 25, 16, 193, 177, 108, 77, 164, 109, 226, 22, 68, 169}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 228, 221, 5, 4, 238, 28, 26}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 123, 73, 215, 183, 196, 249, 171}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 209, 92, 27, 246, 92, 62, 253}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 163, 205, 17, 249, 138}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 177, 188, 112, 149, 31}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 21, 1, 231}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 142, 143}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 6, 44, 209, 152, 86, 183, 38, 202, 244}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 18, 55, 58, 64, 137}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 102, 69, 247, 135, 96, 180, 200, 190, 217}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 84, 140, 10, 224, 9, 160}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 181, 17, 86, 46}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 102, 40, 182}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 81, 190, 79, 60, 196, 49, 94, 80, 181}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 154, 228, 224, 217, 201, 83}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 193, 36, 181, 163, 16, 88, 224}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 137, 159, 213, 164, 243, 191, 183}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 209, 100, 125, 36, 130, 93, 22}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 208, 219, 135, 53, 159, 138}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 133, 178, 89}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 85, 13, 62, 11, 195, 76, 149, 187}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 214, 82, 32}, 71},
	{{22, 185, 238, 100, 25, 16, 143, 144, 83, 134, 226, 249, 52, 63, 99, 150}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 182, 47, 169, 116}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 207, 105, 29, 3, 107, 157, 110, 237, 183}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 46, 31, 113, 128, 169, 247}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 144, 173, 70, 81, 157, 151, 50, 166, 219}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 231, 202, 23, 28, 15, 42, 76, 206}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 26, 130, 118, 80, 211, 180, 18, 210}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 184, 134, 165, 104, 187, 45, 125, 169, 159}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 52, 196, 132, 153, 186, 11, 36, 75, 58}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 23, 170, 242, 231, 236, 11, 43, 28}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 219, 93}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 142, 102, 10, 254, 132, 101, 20, 230}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 112, 207, 79, 179, 225, 129, 100}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 223, 10, 39, 85, 116, 51, 249, 160}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 17, 214, 185, 48}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 92, 35, 202}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 197, 197, 140, 30, 218, 234}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 125, 239, 4, 67, 58, 73}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 104, 190, 136, 61, 199, 141, 161}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 158, 52, 35, 76, 124, 29, 179}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 37, 247, 199, 253}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 40, 157}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 156, 208, 77}, 71},
	{{22, 185, 238, 100, 25, 16, 68, 169, 233, 237, 104, 106, 220, 195, 108, 128}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 32, 35, 194, 68, 224}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 62, 70, 192, 254, 128, 93, 104, 48}, 71},
	{{22, 185, 238, 100, 25, 16, 203, 33, 224, 222, 204, 63, 184, 253, 146, 154}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 188, 182, 181, 254, 77, 103, 58, 112, 76}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 20, 53, 88}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 152, 178, 232, 3, 200}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 160, 93, 221, 133, 205, 11, 104, 163}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 82, 188, 36, 236, 12}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 55, 72, 143, 238, 102, 86, 36, 53, 68}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 246, 244, 43, 226, 190, 69, 129, 205, 178}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 136, 109, 29}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 14, 22}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 33, 9}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 175, 111}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 121, 84}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 69, 237, 2, 18, 16}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 168, 199, 35, 28, 115}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 104, 39, 169, 250, 154, 186, 238, 163, 84}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 69, 149, 144, 246, 43, 223}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 199, 21, 67, 221, 76}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 0, 24, 152, 19, 41, 28}, 71},
	{{22, 185, 238, 100, 25, 16, 0, 0, 0, 0, 10, 83, 70, 116, 59, 212}, 71},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{122, 149, 117, 77, 88, 250, 187, 203, 136, 22, 85, 42, 105, 234, 79, 8}, 112},
	{{93, 152, 229, 140, 0, 0, 0, 56, 235, 123, 219, 81, 158, 255, 32, 19}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 102, 58, 254, 62, 9, 205, 242, 117, 12}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 163, 189}, 72},
	{{93, 152, 229, 140, 0, 44, 129, 51, 220, 233, 234, 110, 68, 34, 61, 201}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 249, 218}, 72},
	{{93, 152, 229, 140, 0, 76, 244, 254, 9, 169, 137, 135, 154, 248, 172, 63}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 104, 44, 139, 120, 140, 125, 50, 28}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 168, 91, 239, 255, 132, 33, 171, 43}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 224}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 112}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 47, 237, 71, 139, 14, 162}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 235, 93, 85, 83, 154, 214, 98, 222, 8}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 102, 5, 161, 149, 165, 27, 82, 55}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 81, 230, 204, 247, 237, 158, 196}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 168, 64, 153, 56, 230, 66, 222, 218, 224}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 18, 206, 140, 201, 171, 205, 33, 12, 201}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 107, 9, 94, 134, 117, 181}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 179, 129, 195, 140, 139, 3}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 77, 163, 26, 190, 95, 154, 7, 56}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 73}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 218, 135, 214, 112, 6, 204, 146, 51, 23}, 72},
	{{93, 152, 229, 140, 0, 0, 195, 253, 219, 90, 31, 147, 140, 239, 151, 93}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 30, 176, 211, 254, 146}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 198, 15, 157, 164, 175, 215, 84}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 234, 107, 62, 30, 45, 153, 89, 150}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 170, 162}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 1, 206, 162, 206, 185}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 191, 158}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 147, 63, 99, 93, 68, 208, 45, 223, 167}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 188, 73, 205, 103, 18, 59, 45}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 2, 184, 190, 127, 244, 169, 68, 19}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 43, 236, 183, 223, 207, 174, 137, 165, 224}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 221, 238, 131, 103, 70}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 131, 250, 29, 128, 54, 135}, 72},
	{{93, 152, 229, 140, 0, 180, 129, 152, 106, 71, 38, 187, 89, 209, 193, 47}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 4}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 4}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 239, 25, 41, 130, 56}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 193, 29, 211, 195, 221, 241, 18, 126}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 218, 172, 218, 179, 55, 44, 171}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 191, 152, 18, 135, 18}, 72},
	{{93, 152, 229, 140, 0, 0, 206, 69, 78, 79, 178, 74, 53, 194, 104, 244}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 15, 254, 23, 58}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 215, 179, 91, 67, 106, 77, 5, 120, 115}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 188, 186, 43, 28, 48, 182, 175, 163}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 73, 48, 1, 225, 86}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 19, 73, 104, 212, 110}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 72},
	{{93, 152, 229, 140, 0, 0, 243, 73, 101, 97, 226, 37, 133, 241, 254, 154}, 72},
	{{93, 152, 229, 140, 0, 66, 188, 103, 25, 163, 94, 139, 225, 176, 188, 178}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 10, 23, 135, 144, 80, 209, 229, 233}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 118}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 148, 171}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 9, 63, 5, 241, 212}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 139, 113, 20, 184, 57, 135, 155}, 72},
	{{93, 152, 229, 140, 0, 0, 177, 71, 171, 145, 52, 81, 161, 122, 246, 21}, 72},
	{{93, 152, 229, 140, 0, 0, 229, 44, 56, 252, 9, 207, 241, 112, 248, 24}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 51, 176, 165, 110, 52, 212, 206, 124, 106}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 210, 52, 136, 202, 70}, 72},
	{{93, 152, 229, 140, 0, 171, 34, 94, 3, 195, 68, 236, 58, 85, 181, 38}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 91, 151, 248, 50, 61, 247, 69}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 73}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 112}, 72},
	{{93, 152, 229, 140, 0, 0, 43, 58, 111, 14, 126, 8, 59, 183, 167, 159}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 201, 12, 50, 173, 16, 5}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 84, 130, 71, 200, 57, 194, 69, 173}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 60, 155, 207, 93}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 36, 250, 209, 108, 73, 143, 138, 209}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 134, 125}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 71}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 246, 4, 68, 152, 173, 218}, 72},
	{{93, 152, 229, 140, 0, 127, 235, 208, 178, 172, 209, 131, 198, 134, 191, 228}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 224, 36, 68, 230, 249, 189}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 190, 195, 137, 217, 143, 31, 3, 254, 92}, 72},
	{{93, 152, 229, 140, 0, 0, 96, 3, 250, 3, 244, 221, 44, 17, 98, 156}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 159, 183, 45, 90, 174, 236}, 72},
	{{93, 152, 229, 140, 0, 127, 176, 57, 175, 81, 1, 18, 196, 131, 6, 86}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 198}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 0, 158, 33, 247, 127, 103}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 0, 158, 248, 19, 215, 167, 65}, 72},
	{{93, 152, 229, 140, 0, 0, 0, 0, 0, 39, 188, 114, 53, 77, 119, 13}, 72},
	{{93, 152, 229, 140, 0, 0, 122, 32, 80, 115, 170, 220, 158, 105, 142, 217}, 72},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 137, 67, 59, 235, 209}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 139, 141, 203}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 114, 244}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 3, 6}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 14}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 82, 123, 77, 122, 226}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 195, 10, 173, 175}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 59}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 61, 93, 246, 241, 65}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 174, 17, 186}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 135, 130, 138, 229}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 79, 133, 120, 45}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 117, 154}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 193, 117, 199}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 102, 214, 227, 41}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 57, 41, 153, 155}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 21, 169}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 34, 142, 54, 249, 202}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 148, 218, 104, 78}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 137, 234, 46}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 128, 223, 245, 63, 135, 11}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 11, 130, 18, 132, 72}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 234, 195}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 51, 202, 87, 191, 63}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 83, 103, 119, 115}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 181}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 135, 131, 253, 230, 74, 240}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 155, 223, 59}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 43, 197, 72, 253}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 29, 250, 220, 145}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 1}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 155, 242, 2}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 195}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 243, 249, 226}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 213, 195}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 246, 245}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 227, 151, 68, 223, 2}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 244, 165}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 133, 55}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 9, 216, 135, 75, 65, 171}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 75}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 111}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 112, 85}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 52}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 100}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 49}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 76, 178, 100, 167}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 205, 22, 154, 232, 136}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 50}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 148, 75, 43, 172, 254, 18}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 118, 153, 196, 207}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 41, 181}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 37, 50, 18}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 254, 38}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 183, 126}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 215, 75, 130, 128}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 254, 208, 238, 193, 238, 159}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 1}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 179, 155}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 231, 46, 117, 34}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 158, 185, 241}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 15, 62, 52, 143}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 78, 140}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 139, 182, 255, 18}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 239}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 163, 233}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 26, 194}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 8}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 25, 125, 96, 66}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 240, 62, 0, 16, 166, 238}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 227, 144, 66, 115}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 174, 86, 148, 128, 25}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 40, 59}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 175, 175, 200, 211}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 37, 170, 225, 30, 121, 152}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 105, 143, 4, 180}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 137, 200, 240, 194, 195, 135}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 147, 197, 11, 229}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 245}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 74}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 1}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 135}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 112}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 34, 143}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 132, 78, 66}, 155},
	{{129, 37, 165, 167, 241, 24, 37, 40, 2, 128, 0, 0, 0, 0, 0, 0}, 155},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 143, 175}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 68, 208}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 3}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 232, 145, 180}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 152, 135, 251}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 212, 129, 206, 194, 168, 106, 204}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 117, 95, 202, 75, 92, 184}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 93, 199, 72, 178}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 79, 229, 235}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 182, 118, 149, 72}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 29, 224, 101, 174}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 249, 40, 72, 148, 54, 131, 76}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 32, 181, 60, 222}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 79, 251}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 182, 233, 250}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 243, 181, 134, 135, 74, 243}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 251}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 214, 68, 44, 71, 154}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 65, 125, 24, 12, 27, 5}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 152}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 57, 73, 24, 140, 239, 24, 102}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 126, 158, 144, 198}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 236, 166, 35}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 192, 157, 234, 244, 214}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 241, 223, 252, 91}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 128, 79, 135, 86, 21}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 32, 74, 208, 252, 129, 114}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 143, 234, 113, 195, 192, 183, 219}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 253}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 3, 94, 60, 215, 224, 197, 60, 89}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 62, 147, 164, 252}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 220, 12, 241, 19, 155}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 44, 208, 107, 117}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 44, 39, 131}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 69, 106}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 175, 208, 136}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 9}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 162, 32, 174, 121, 129, 73}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 222, 143, 24}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 155}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 186}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 24, 154, 195, 144}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 174, 204, 45}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 37, 191, 37, 94}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 88, 200, 107, 62, 63}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 49, 23, 39, 17, 121, 39, 164}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 97, 24}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 133, 214, 175, 141, 161, 244}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 134, 151, 254, 222, 236, 208, 176}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 109, 63, 33, 7}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 184, 43}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 67}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 170, 203, 181, 254, 198, 173}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 91}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 80, 86, 252}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 230, 13, 79}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 21, 102, 68, 136, 161, 158}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 215, 151, 169, 4}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 85}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 188, 218, 16}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 76, 6, 73, 177, 164, 94}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 237, 7, 182, 107, 137, 84}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 89, 3, 119, 87}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 14, 175}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 224, 103, 94, 28, 19}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 213, 132, 98, 207}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 99}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 206, 203, 60, 20}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 173}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 38, 42, 22, 148, 164, 112, 156}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 112, 123, 37, 209, 204, 120, 75, 133}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 67, 10, 196, 184}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 131, 176, 222, 44}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 64, 41, 252, 166, 86, 12}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 74}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 161}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 28, 177, 139, 3, 121, 140}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 190, 164, 241, 169, 47, 159}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 20, 167, 61, 42, 56, 88, 82}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 142, 64, 13, 245}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 229, 145, 129, 128, 228}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 55, 89, 175, 28}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 0, 0, 0}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 204, 117, 90, 59}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 0, 0, 0, 0, 0, 222, 11, 209}, 66},
	{{30, 202, 177, 3, 253, 202, 164, 248, 190, 1, 58, 99, 37, 27, 62, 56}, 66},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 105, 33, 107, 18}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 110, 181, 62, 241}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 59}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 199, 155, 211}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 69, 48}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 116, 232, 68}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 48, 210, 173}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 173, 55}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 9, 71}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 197, 202}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 140}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 188, 249, 157, 243}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 130, 88, 181}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 182}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 38, 233, 172}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 22}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 78}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 69, 157, 217}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 218, 107, 154}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 8, 145}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 220, 13, 247}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 126}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 73}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 2, 140, 24, 17}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 7, 42, 58}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 53}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 34, 198}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 30, 85}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 38, 69}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 49, 17, 100}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 73, 175}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 178, 6, 139}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 180}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 145}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 235, 184, 143}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 136, 217}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 236}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 217, 128, 54}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 77, 51}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 191}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 71}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 67, 197, 54, 169}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 10, 30}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 40, 184, 158, 7}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 53, 191, 106}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 123, 211, 40}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 235}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 183}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 81}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 233, 95}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 64, 227}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 93, 154, 144}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 32}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 143, 79, 66}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 112}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 193, 202}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 240}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 111, 38, 250}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 242, 67}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 26}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 187}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 34}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 228, 149}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 22, 1, 132, 154}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 54, 62, 200}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 133, 117, 73}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 172, 70}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 212, 47}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 86, 111, 194, 92}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 232, 171, 101}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 141, 123, 164}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 106, 228, 9, 6}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 230, 93}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 188, 203, 138, 211}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 217, 66}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 170, 231, 197}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 98, 200, 182}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 0, 0, 0, 0}, 77},
	{{176, 25, 220, 120, 194, 228, 10, 45, 225, 142, 192, 96, 234, 136, 2, 118}, 77},
	{{96, 0, 0, 0, 0, 59, 75, 191, 198, 130, 30, 46, 171, 113, 205, 54}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 198, 6, 148, 97}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 119, 141}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 109},
	{{96, 0, 0, 0, 0, 0, 76, 195, 207, 117, 177, 64, 218, 40, 18, 116}, 109},
	{{96, 0, 0, 0, 0, 149, 56, 79, 86, 166, 231, 22, 103, 107, 210, 70}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 90, 43, 217, 250, 239, 38, 81}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 104, 176, 171}, 109},
	{{96, 0, 0, 0, 208, 189, 137, 31, 91, 181, 232, 98, 80, 105, 208, 112}, 109},
	{{96, 0, 0, 0, 0, 0, 59, 233, 247, 159, 187, 21, 245, 65, 58, 227}, 109},
	{{96, 0, 0, 120, 249, 158, 86, 40, 153, 200, 172, 230, 52, 20, 253, 226}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 57, 226, 113}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 64, 115}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 253, 202, 241}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 50, 88, 193, 152, 194}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 89, 170, 104, 46, 176}, 109},
	{{96, 0, 0, 0, 0, 0, 132, 26, 242, 106, 43, 140, 5, 177, 85, 252}, 109},
	{{96, 0, 0, 0, 0, 45, 109, 96, 117, 238, 95, 142, 234, 5, 154, 12}, 109},
	{{96, 0, 0, 169, 101, 41, 68, 19, 175, 58, 206, 47, 74, 151, 38, 205}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 19, 179, 181, 51, 26}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 187, 228, 152, 205, 163, 191, 122, 86}, 109},
	{{96, 0, 0, 0, 0, 0, 18, 35, 22, 139, 126, 59, 97, 173, 178, 51}, 109},
	{{96, 0, 0, 230, 199, 254, 185, 16, 68, 161, 105, 24, 146, 197, 89, 247}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 217}, 109},
	{{96, 0, 0, 0, 0, 135, 63, 152, 172, 66, 192, 96, 167, 122, 215, 199}, 109},
	{{96, 0, 133, 56, 80, 82, 32, 3, 216, 92, 186, 186, 155, 79, 45, 159}, 109},
	{{96, 0, 0, 0, 0, 1, 56, 64, 48, 44, 34, 227, 66, 180, 97, 198}, 109},
	{{96, 0, 0, 0, 7, 192, 255, 192, 32, 0, 220, 135, 167, 74, 27, 61}, 109},
	{{96, 0, 0, 0, 25, 41, 93, 246, 6, 158, 188, 249, 62, 215, 172, 15}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 95, 237, 203}, 109},
	{{96, 0, 0, 0, 0, 245, 38, 66, 135, 26, 121, 245, 5, 143, 162, 23}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 75, 86, 8, 242, 210, 68, 124, 199, 27}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{96, 0, 0, 0, 0, 250, 247, 194, 200, 246, 33, 191, 53, 202, 152, 102}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 50, 48, 117}, 109},
	{{96, 0, 135, 228, 40, 144, 105, 45, 68, 99, 168, 248, 237, 139, 101, 38}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 227, 29, 158, 27, 192, 134, 187, 211, 176}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 197, 107, 27}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 63, 205, 118, 68, 99, 241, 129, 107, 101}, 109},
	{{96, 0, 0, 0, 0, 0, 198, 216, 170, 43, 26, 77, 187, 53, 209, 167}, 109},
	{{96, 0, 0, 182, 229, 136, 32, 160, 138, 214, 189, 174, 240, 207, 242, 155}, 109},
	{{96, 0, 32, 251, 66, 137, 16, 25, 153, 234, 115, 65, 135, 215, 44, 45}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 150, 51, 224, 30, 213, 166, 218, 236}, 109},
	{{96, 0, 0, 0, 136, 94, 89, 57, 234, 117, 162, 25, 173, 29, 235, 222}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 109},
	{{96, 0, 224, 250, 141, 4, 238, 226, 191, 141, 101, 98, 100, 97, 4, 40}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 220, 113, 196, 11}, 109},
	{{96, 0, 0, 0, 0, 57, 246, 239, 32, 136, 177, 103, 120, 112, 255, 60}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 107, 111, 105, 20, 179, 108, 47, 27, 186}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 80, 54, 225, 18, 145, 69, 36}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 245, 156, 183, 80, 135, 243, 72, 102}, 109},
	{{96, 0, 0, 0, 0, 0, 33, 244, 129, 154, 134, 185, 229, 40, 161, 202}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 11, 9, 156}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 211, 183, 196, 181}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 21, 106, 201}, 109},
	{{96, 0, 0, 0, 0, 0, 70, 72, 145, 228, 20, 224, 185, 233, 54, 40}, 109},
	{{96, 247, 57, 226, 91, 0, 142, 232, 108, 13, 155, 176, 81, 61, 243, 118}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 194, 28, 130, 103, 245, 104, 117, 183}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 232, 12, 58}, 109},
	{{96, 0, 175, 128, 254, 156, 21, 128, 172, 110, 205, 138, 147, 73, 70, 86}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 43, 173, 163, 225, 193, 242, 28, 11}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 67, 232, 235, 203, 216, 68, 129, 223, 71}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 204, 207, 143}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 201, 168, 136, 114, 193, 84, 236}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 245}, 109},
	{{96, 0, 0, 0, 0, 249, 250, 162, 198, 217, 87, 173, 34, 66, 98, 188}, 109},
	{{96, 0, 0, 0, 122, 117, 225, 44, 238, 223, 113, 48, 146, 227, 186, 198}, 109},
	{{96, 0, 0, 0, 0, 110, 6, 6, 112, 33, 19, 77, 101, 66, 101, 75}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 83, 149, 104}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 165, 93, 53, 188}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 58, 162, 98, 228, 57}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 226, 18, 162, 37, 50, 203, 133}, 109},
	{{96, 0, 0, 0, 0, 0, 180, 172, 136, 3, 151, 205, 231, 5, 7, 15}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 27, 135, 85, 5, 236, 7, 119}, 109},
	{{96, 0, 106, 80, 135, 138, 93, 217, 203, 143, 249, 183, 163, 171, 33, 127}, 109},
	{{96, 0, 0, 0, 0, 236, 117, 94, 204, 223, 4, 71, 205, 221, 48, 189}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 191, 100, 148, 9, 210}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 43, 67, 240, 120}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 106, 77}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 20, 240, 131, 180, 147}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 4, 122, 67, 129, 188, 167, 39, 40}, 109},
	{{96, 181, 223, 177, 190, 59, 143, 141, 132, 218, 154, 5, 22, 141, 223, 35}, 109},
	{{96, 0, 0, 203, 43, 46, 106, 138, 253, 244, 13, 196, 65, 175, 100, 142}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 216, 51}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 124, 159, 155}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 163, 204}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 20, 232, 185}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 126, 55, 4, 9, 119}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 109},
	{{96, 0, 0, 190, 128, 81, 10, 220, 56, 237, 86, 211, 149, 79, 99, 212}, 109},
	{{96, 0, 0, 0, 0, 0, 189, 105, 154, 5, 234, 170, 203, 211, 250, 192}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 212, 28, 7, 39}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 119, 175, 208, 170, 16}, 109},
	{{96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 35}, 109},
	{{96, 74, 211, 141, 155, 7, 185, 214, 27, 100, 97, 7, 43, 41, 14, 48}, 109},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 191, 213}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 76, 203, 190, 239, 10}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 33, 97, 97, 246}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 31, 209, 62, 70, 5}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 109, 225, 71, 252}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 13, 52, 214, 78, 180}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 212, 142, 91, 99}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 61, 74}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 249, 216, 42, 102, 198}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 32, 239, 210, 249, 96}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 209, 71, 158, 5}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 113, 135, 48, 138, 23, 112}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 53, 42}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 46, 162, 249, 185, 169}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 97}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 117, 37}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 107, 34}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 142}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 168, 100}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 228, 169}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 62, 169, 10, 178, 143}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 217, 78, 136, 15}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 156, 142, 138, 18}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 81, 131, 223, 77, 102, 234}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 252, 117, 152, 162}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 164, 227, 130, 203}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 248, 171}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 176, 195, 203, 2, 20}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 152, 196, 126, 102, 190, 252}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 161}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 113, 61, 199, 4, 127, 124}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 211, 100}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 43, 234, 169, 217, 252, 31}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 75, 57, 240, 10, 131, 135}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 149, 124, 248}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 139, 18, 39, 149, 226, 160}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 33, 105, 255}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 239, 235, 165, 246, 84, 253}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 174, 221, 29, 40}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 47, 90, 52, 48, 25}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 192, 199, 254, 9}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 229, 215, 68, 208, 43}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 181, 75, 251, 164, 153}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 92}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 107}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 220}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 185, 237, 216, 29}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 200, 14, 128}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 42, 140, 44}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 72, 203, 252, 181}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 208}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 84, 15, 88, 210}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 18, 185, 12, 62, 131, 210}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 164, 219, 32, 81, 89}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 155, 168, 224, 242}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 44, 9, 151}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 233}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 14, 233, 187}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 74, 1, 79, 92, 74, 202}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 216, 159, 142}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 89, 61, 226, 226}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 62, 116, 126, 207, 54}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 51, 123, 183}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 221, 141, 116, 232, 101, 54}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 39, 66, 222, 118, 184, 180}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 211, 213, 24, 209}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 144, 236}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 190, 255}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 94}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 50, 161, 60, 195, 212, 91}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 211, 69, 19}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 229, 66}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 70, 14, 253, 237, 243, 69}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 57}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 2, 142}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 110, 79, 132, 130}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 235}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 174, 10}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 75, 48}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 129, 245}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 185, 243}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 165, 233, 4}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 251, 109, 146, 131, 198, 150}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 115}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 51, 174, 209, 168}, 37},
	{{82, 56, 12, 204, 61, 45, 147, 240, 221, 0, 0, 0, 0, 0, 163, 62}, 37},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 184, 114, 47, 161}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 146, 182, 188, 222}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 87, 170}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 122, 247, 79}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 126, 45}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 182, 27, 75, 176}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 252, 95, 74}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 235, 242}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 132}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 92, 12, 73, 122}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 102, 248, 137}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 206, 123, 19}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 172, 162, 134}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 255}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 167, 13, 146, 122}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 207, 238}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 100, 162, 93}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 100, 154, 129}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 136, 232}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 82, 91}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 232, 100, 47}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 248, 79, 183, 2}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 230}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 76, 134, 204, 223}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 61}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 230}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 194, 130, 202, 244}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 65, 96, 79, 196}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 254, 31, 226}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 86}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 125, 165, 104, 126}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 247}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 120}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 211}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 117, 144, 185}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 123}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 113, 255}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 218, 172, 223, 60}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 64, 206, 211, 187}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 236, 135, 84}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 157, 128, 50, 62}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 83, 108}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 230}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 31, 146}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 103, 191}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 76}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 241, 52}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 174, 151, 26, 21}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 48}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 100, 213, 59, 129}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 176, 87}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 212, 177}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 25, 249}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 27, 181}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 232}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 52}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 136, 204, 179}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 247}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 240, 234}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 232, 47, 4, 170}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 81}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 120}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 142, 12, 125}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 101}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 172}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 39, 93, 217, 17}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 172, 222, 155}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 252}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 249}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 94, 85}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 122, 109}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 33, 116, 127}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 214}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 9, 3}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 192, 100}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 0}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 231, 41, 185}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 49, 164}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 0, 2}, 56},
	{{242, 38, 240, 41, 140, 75, 250, 37, 175, 115, 97, 224, 0, 0, 32, 154}, 56},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 84}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 242}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 176}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 122}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 138, 228}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 62}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 162, 150}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 144}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 68}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 73}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 64}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 235}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 92, 2}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 149}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 60, 134}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 107}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 220}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 126, 116}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 152, 253}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 95}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 64}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 200, 158}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 252}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 89}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 91}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 151}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 208, 118}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 241}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 196}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 147, 144}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 131, 48}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 218}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 115}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 44}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 44}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 30, 72}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 37}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 123, 100, 175}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 183}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 70, 62}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 59}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 121, 41}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 190}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 18}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 92, 72}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 174, 17}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 8}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 30, 113}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 36, 234}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 22, 118, 32}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 2}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 122, 102}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 34}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 197, 219}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 207, 35}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 32, 139}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 13}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 0}, 5},
	{{251, 192, 23, 90, 135, 56, 252, 56, 79, 219, 80, 167, 22, 0, 0, 10}, 5},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 213, 186, 60, 154, 148}, 15},
	{{62, 128, 139, 128, 71, 22, 241, 219, 143, 63, 67, 37, 226, 105, 157, 233}, 15},
	{{62, 128, 139, 128, 191, 101, 145, 14, 92, 10, 128, 233, 153, 133, 62, 243}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 21, 173, 249, 81, 144, 172, 35, 71, 117}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 225, 139, 255, 58, 118, 9}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 172, 76, 213, 170, 68, 151}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 38, 40, 3, 213, 80, 41}, 15},
	{{62, 128, 139, 128, 137, 19, 205, 102, 71, 159, 144, 90, 9, 42, 57, 246}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 86, 80, 47, 9, 187, 68, 196, 194}, 15},
	{{62, 128, 139, 128, 0, 99, 202, 219, 3, 6, 221, 72, 132, 20, 247, 235}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 67, 222, 234, 233, 165, 252, 233, 128, 233}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 56}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 102, 85, 63, 10, 127, 21}, 15},
	{{62, 128, 139, 128, 74, 142, 35, 92, 240, 189, 85, 86, 225, 247, 242, 193}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 152, 25, 173, 154, 17, 225, 106}, 15},
	{{62, 128, 139, 128, 0, 179, 185, 51, 251, 212, 149, 133, 170, 78, 187, 200}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 122, 108, 147, 121, 62, 9, 7}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 100, 134, 46, 38, 9, 172, 23, 126, 69}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 102}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 52, 171, 51, 127, 47, 111, 249}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 197, 52, 90, 96, 9, 10, 51, 172, 20}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 82}, 15},
	{{62, 128, 139, 128, 0, 0, 17, 41, 178, 195, 126, 234, 134, 249, 56, 149}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 182, 65}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 225, 29, 123, 60, 217, 9, 23}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 53}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 195, 193, 132, 232, 218, 126, 70, 33, 126}, 15},
	{{62, 128, 139, 128, 170, 186, 64, 40, 166, 205, 92, 5, 140, 125, 150, 98}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 175, 20, 202, 23, 171, 166, 234}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 15},
	{{62, 128, 139, 128, 66, 197, 64, 40, 213, 36, 214, 233, 188, 68, 130, 154}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 48, 34, 62, 211, 80}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 93, 24, 234, 27, 119, 203, 129}, 15},
	{{62, 128, 139, 128, 175, 233, 115, 196, 97, 105, 80, 208, 204, 152, 130, 42}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 119}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 252, 239, 41, 26}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 186, 228, 185, 162, 162, 167, 136}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 19, 188, 56, 201, 239, 164, 212, 138}, 15},
	{{62, 128, 139, 128, 0, 0, 149, 57, 18, 249, 200, 8, 54, 233, 99, 43}, 15},
	{{62, 128, 139, 128, 0, 0, 60, 104, 97, 80, 249, 122, 80, 122, 154, 71}, 15},
	{{62, 128, 139, 128, 0, 0, 167, 185, 207, 88, 219, 127, 233, 162, 56, 252}, 15},
	{{62, 128, 139, 128, 205, 108, 224, 35, 112, 80, 85, 120, 24, 14, 210, 204}, 15},
	{{62, 128, 139, 128, 0, 38, 26, 21, 204, 163, 247, 70, 114, 71, 65, 89}, 15},
	{{62, 128, 139, 128, 0, 0, 86, 171, 44, 12, 150, 113, 63, 228, 23, 80}, 15},
	{{62, 128, 139, 128, 0, 0, 85, 188, 142, 196, 220, 66, 154, 189, 36, 199}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 69, 29, 248, 178, 84, 180, 11, 86}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 37, 225, 225, 133, 45, 141, 9, 43}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 193, 150, 235, 210, 181, 247}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 171}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 79, 198, 86, 222, 120, 198, 164, 183}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 39, 11, 17, 87, 214}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 206, 136, 82, 19, 147, 195, 96, 91}, 15},
	{{62, 128, 139, 128, 0, 21, 137, 251, 49, 190, 242, 206, 161, 181, 108, 66}, 15},
	{{62, 128, 139, 128, 0, 0, 141, 163, 83, 125, 211, 241, 57, 151, 135, 255}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 193, 196, 225, 126, 99}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 234, 12, 55, 3, 100, 29}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 6, 96, 217, 224, 156, 23, 155, 91}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 84, 11}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 222, 33, 48, 127, 58, 60, 219, 134}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 203, 214, 96, 5, 100, 140}, 15},
	{{62, 128, 139, 128, 0, 21, 100, 16, 228, 141, 68, 34, 231, 244, 161, 16}, 15},
	{{62, 128, 139, 128, 0, 0, 151, 243, 60, 28, 223, 170, 204, 138, 97, 23}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 11, 209}, 15},
	{{62, 128, 139, 128, 0, 36, 236, 77, 202, 154, 247, 82, 218, 245, 45, 120}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 85, 205, 222, 141}, 15},
	{{62, 128, 139, 128, 0, 0, 159, 174, 9, 224, 58, 30, 174, 215, 99, 162}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 148, 209, 120, 162, 114}, 15},
	{{62, 128, 139, 128, 0, 0, 21, 213, 89, 130, 126, 72, 60, 234, 27, 161}, 15},
	{{62, 128, 139, 128, 245, 233, 49, 22, 14, 205, 177, 244, 80, 84, 246, 38}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{62, 128, 139, 128, 160, 150, 219, 140, 202, 99, 221, 190, 178, 64, 0, 245}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 46, 188}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 31, 57, 253, 140, 218, 162, 120, 187, 181}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 190, 183, 39, 156, 213}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 76}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 92, 93, 10, 157, 186}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 150, 210}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 66, 138, 34, 76, 167, 221}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 215, 39, 134, 52, 68}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 95, 233, 81, 183, 29, 223}, 15},
	{{62, 128, 139, 128, 0, 3, 84, 62, 120, 229, 93, 132, 122, 172, 140, 91}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{62, 128, 139, 128, 0, 78, 88, 181, 178, 148, 6, 47, 194, 46, 67, 194}, 15},
	{{62, 128, 139, 128, 0, 0, 0, 0, 0, 182, 97, 228, 51, 50, 7, 108}, 15},
	{{214, 1, 84, 232, 0, 0, 0, 0, 79, 194, 184, 245, 164, 243, 225, 88}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 220, 145}, 183},
	{{214, 1, 84, 232, 0, 0, 229, 15, 18, 95, 195, 179, 246, 77, 59, 66}, 183},
	{{214, 1, 84, 232, 0, 0, 20, 224, 79, 209, 229, 139, 188, 40, 59, 238}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 129, 53, 65, 205, 69, 58}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 208, 117, 129, 91, 149, 144}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 57, 125, 78, 85, 16, 118}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 187}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 177, 53, 80, 178, 139, 133, 131, 55}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 186, 179, 253, 178, 125, 124}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 96, 93, 72, 240}, 183},
	{{214, 1, 84, 232, 0, 114, 200, 167, 221, 179, 230, 224, 79, 22, 77, 141}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 183},
	{{214, 1, 84, 232, 0, 0, 118, 138, 174, 209, 253, 117, 30, 83, 115, 180}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 121}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 241, 177, 1, 122, 74, 13, 52, 21}, 183},
	{{214, 1, 84, 232, 69, 241, 70, 43, 107, 204, 103, 176, 112, 176, 239, 41}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 229, 117}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 2, 145, 148, 41, 153, 183, 231, 74, 162}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 254}, 183},
	{{214, 1, 84, 232, 229, 228, 224, 117, 44, 200, 92, 122, 48, 205, 125, 200}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 124, 100, 84, 121, 134, 57}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 255, 251}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 164, 168, 244, 186, 123, 57, 196}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 114, 137, 145, 28, 1}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 183},
	{{214, 1, 84, 232, 0, 0, 128, 172, 47, 136, 127, 104, 59, 42, 62, 55}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 103}, 183},
	{{214, 1, 84, 232, 0, 110, 14, 180, 46, 86, 70, 108, 233, 219, 58, 181}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 237, 29, 9, 140}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 46, 127, 66, 119, 10, 137, 254, 242}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 221, 62, 200, 38, 23, 26}, 183},
	{{214, 1, 84, 232, 0, 0, 152, 112, 138, 53, 41, 166, 20, 245, 0, 65}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 187, 162, 12, 43, 20, 21, 30}, 183},
	{{214, 1, 84, 232, 0, 0, 226, 239, 17, 234, 54, 234, 165, 219, 223, 80}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 251, 182, 193, 68, 237, 201}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 183, 205, 138, 119, 27, 14, 22, 66}, 183},
	{{214, 1, 84, 232, 0, 134, 176, 15, 179, 28, 199, 247, 245, 49, 18, 89}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 164, 14, 210, 43, 240, 159, 239, 207}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 110, 147, 19, 53, 120, 194, 244, 88, 39}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 114, 132, 195, 235, 161, 211, 215, 71}, 183},
	{{214, 1, 84, 232, 0, 0, 16, 204, 62, 14, 252, 52, 244, 34, 80, 164}, 183},
	{{214, 1, 84, 232, 0, 105, 89, 232, 131, 220, 217, 6, 198, 144, 160, 214}, 183},
	{{214, 1, 84, 232, 0, 0, 238, 146, 102, 25, 65, 43, 126, 202, 225, 37}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 183},
	{{214, 1, 84, 232, 0, 32, 51, 29, 206, 5, 90, 3, 172, 211, 149, 244}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 244, 239, 104, 167, 24}, 183},
	{{214, 1, 84, 232, 0, 65, 211, 73, 118, 199, 10, 112, 77, 158, 71, 170}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 119, 88, 248, 18, 155, 241, 49, 211}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 61}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 38, 166, 218, 110, 79, 237, 158, 175}, 183},
	{{214, 1, 84, 232, 0, 0, 227, 31, 254, 83, 123, 121, 165, 5, 78, 114}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 45, 118, 62, 50, 195, 63, 219}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 58, 137, 127, 224, 173}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 200, 31, 243, 53, 247, 45, 142, 172, 158}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59}, 183},
	{{214, 1, 84, 232, 0, 0, 82, 220, 132, 105, 116, 129, 202, 8, 222, 175}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 197, 187, 183, 248, 47, 112, 190, 91, 229}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 183},
	{{214, 1, 84, 232, 0, 22, 105, 65, 107, 161, 215, 91, 84, 247, 128, 218}, 183},
	{{214, 1, 84, 232, 0, 35, 77, 224, 241, 48, 9, 64, 152, 13, 82, 149}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 62, 208}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 196, 18, 233, 63}, 183},
	{{214, 1, 84, 232, 232, 90, 236, 204, 94, 163, 164, 231, 208, 153, 244, 173}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 108}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 58, 248, 192, 12, 11, 45, 133}, 183},
	{{214, 1, 84, 232, 251, 225, 173, 163, 61, 27, 145, 232, 139, 198, 165, 112}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 183},
	{{214, 1, 84, 232, 29, 62, 225, 238, 153, 207, 203, 231, 10, 26, 160, 122}, 183},
	{{214, 1, 84, 232, 0, 144, 250, 150, 49, 70, 105, 48, 58, 85, 77, 89}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 10, 160, 74, 230, 153}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 206}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 242, 5}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 255, 216, 140, 63}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 138, 160, 77, 147, 212, 248, 135, 230}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 119, 8, 245, 123, 30, 51, 119, 209, 86}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 4, 194}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59}, 183},
	{{214, 1, 84, 232, 0, 0, 21, 32, 9, 177, 124, 146, 45, 89, 246, 252}, 183},
	{{214, 1, 84, 232, 0, 0, 8, 232, 67, 130, 126, 8, 231, 217, 208, 129}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 57, 220, 89, 113, 115, 83, 170, 225, 154}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 8, 235, 120, 57, 114, 154, 92, 115, 229}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 192, 225, 151, 135, 88, 70, 213, 50, 180}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 161, 159}, 183},
	{{214, 1, 84, 232, 0, 0, 0, 0, 253, 193, 143, 193, 175, 17, 137, 226}, 183},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 227, 93}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 160}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 171, 40}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 68, 110}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 43, 127}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 219}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 33, 40}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 212}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 212}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 233}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 26, 153}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 97, 235}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 103}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 114}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 3, 24}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 169, 75}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 89}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 46, 61}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 197}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 169, 34}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 17, 138}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 202, 63}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 254}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 160, 107}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 76, 180}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 200, 120}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 255}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 248, 172}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 190, 215}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 35}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 19, 250}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 218, 181}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 211, 26}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 228}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 120}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 113}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 232, 128}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 215, 99}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 189, 48}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 121, 254}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 63}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 199}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 97, 250}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 51}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 149, 81}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 132, 148}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 213, 1}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 171}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 50, 250}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 162, 230}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 230}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 5}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 225}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 74, 27}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 148}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 216, 36}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 190, 24}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 105, 146}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 34, 142}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 0, 0}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 216, 111}, 171},
	{{207, 90, 237, 137, 171, 140, 227, 88, 250, 26, 197, 162, 163, 0, 232, 35}, 171},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 2}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 37}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 147}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 77}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 253}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 235}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 253}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 255}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 152}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 182}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 155}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 153}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 160}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 208}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 113}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 248}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 132}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 117}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 15}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 248}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 43}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 192}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 183}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 11}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 18}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 14}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 41}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 95}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 51}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 201}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 69}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 69}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 43}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 123}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 35}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 246}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 162}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 1}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 129}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 162}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 208}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 238}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 186}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 75}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 113}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 0}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 198}, 202},
	{{196, 151, 235, 232, 114, 248, 1, 207, 193, 184, 186, 71, 157, 0, 0, 225}, 202},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 99, 136, 104}, 136},
	{{152, 0, 0, 0, 0, 38, 250, 240, 127, 110, 39, 173, 28, 2, 222, 114}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 21, 165, 117, 26, 34, 118, 84}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 7}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 143, 101, 178, 24, 197, 220, 205, 49, 184}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 219, 180, 151, 34}, 136},
	{{152, 0, 0, 0, 0, 67, 163, 29, 94, 6, 233, 134, 235, 45, 115, 160}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 232, 164, 109}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 133, 250, 92, 91}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 120, 210, 42, 87, 29, 81, 39, 141, 172}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 196, 99, 47, 110, 245, 133, 232, 221}, 136},
	{{152, 0, 0, 45, 127, 16, 168, 28, 245, 197, 206, 176, 88, 243, 215, 119}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 240, 17, 174, 80, 123, 170, 195, 23, 242}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 6, 71, 171, 236, 138, 133, 12}, 136},
	{{152, 0, 32, 151, 250, 164, 124, 142, 181, 68, 29, 146, 165, 77, 171, 214}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 233, 116, 41, 68, 65, 2, 177}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 79, 5, 93, 220, 135, 216, 142, 54, 153}, 136},
	{{152, 0, 21, 214, 12, 20, 158, 249, 6, 182, 163, 232, 166, 36, 118, 50}, 136},
	{{152, 0, 0, 0, 0, 212, 167, 8, 120, 96, 23, 183, 102, 14, 156, 217}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 67}, 136},
	{{152, 0, 0, 39, 120, 104, 110, 198, 179, 31, 224, 144, 222, 210, 72, 88}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 101}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 68}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 63, 245, 94, 250}, 136},
	{{152, 0, 0, 0, 237, 198, 239, 203, 145, 129, 7, 255, 196, 35, 221, 240}, 136},
	{{152, 186, 30, 230, 97, 248, 86, 20, 35, 14, 71, 88, 99, 138, 76, 227}, 136},
	{{152, 0, 50, 198, 72, 53, 34, 30, 160, 163, 53, 240, 101, 145, 146, 73}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 205}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 203, 106}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 150, 176, 32, 12, 51}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 226, 31, 118}, 136},
	{{152, 160, 159, 145, 87, 11, 60, 255, 162, 36, 79, 59, 125, 1, 243, 206}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 138, 246, 105, 182}, 136},
	{{152, 0, 83, 54, 89, 144, 101, 201, 51, 142, 184, 116, 95, 110, 10, 178}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 132, 221, 241, 214}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 230, 122, 19, 216, 17, 128, 198, 53}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 86, 250, 139, 6, 168, 49, 242, 146, 185}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 233, 42, 240, 27, 52}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 180, 248, 133, 146, 216, 207, 36, 236}, 136},
	{{152, 0, 0, 0, 0, 65, 239, 21, 230, 133, 141, 252, 60, 194, 70, 86}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 112, 196, 198, 69, 55, 0, 204, 223}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 231, 49, 115, 99, 246, 82, 113, 117, 158}, 136},
	{{152, 0, 0, 0, 99, 168, 48, 32, 26, 144, 29, 203, 9, 25, 57, 252}, 136},
	{{152, 0, 0, 0, 0, 0, 248, 105, 57, 98, 36, 170, 32, 88, 40, 163}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 235, 106, 28, 10, 234, 31, 11}, 136},
	{{152, 218, 191, 234, 39, 18, 141, 190, 16, 112, 31, 14, 16, 63, 104, 9}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 147, 83, 186, 234, 58, 224, 142, 94, 160}, 136},
	{{152, 0, 0, 0, 0, 128, 222, 200, 44, 82, 33, 93, 130, 67, 69, 242}, 136},
	{{152, 0, 132, 1, 177, 232, 47, 170, 156, 190, 66, 217, 158, 133, 227, 72}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 214, 13, 195, 76, 188, 194, 186}, 136},
	{{152, 0, 0, 6, 238, 192, 236, 155, 126, 62, 152, 84, 148, 49, 156, 28}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 7}, 136},
	{{152, 0, 0, 0, 0, 0, 242, 36, 28, 159, 226, 189, 38, 84, 122, 50}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 172, 5, 104, 126, 94, 11, 162, 175}, 136},
	{{152, 0, 0, 188, 95, 112, 248, 125, 73, 94, 201, 116, 104, 236, 106, 14}, 136},
	{{152, 0, 0, 0, 0, 82, 94, 89, 90, 189, 206, 145, 208, 152, 231, 165}, 136},
	{{152, 0, 0, 0, 0, 0, 176, 17, 175, 21, 34, 36, 139, 115, 107, 52}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 8, 220, 31, 86, 245, 88, 18, 132, 141}, 136},
	{{152, 124, 96, 81, 182, 82, 119, 233, 236, 17, 40, 190, 181, 145, 52, 237}, 136},
	{{152, 0, 0, 0, 0, 0, 36, 223, 234, 235, 89, 226, 111, 233, 120, 82}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 12, 241}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 57, 57, 86, 38}, 136},
	{{152, 0, 215, 199, 181, 162, 222, 227, 32, 0, 184, 52, 19, 38, 125, 239}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 11, 247, 224, 82, 150}, 136},
	{{152, 0, 0, 169, 21, 118, 64, 83, 88, 120, 224, 160, 219, 178, 49, 113}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 254, 230, 66, 235, 130, 123, 241, 58}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 93, 137, 31}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 41, 237, 31}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 164, 167}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{152, 0, 0, 0, 144, 101, 137, 44, 104, 26, 158, 123, 227, 62, 177, 70}, 136},
	{{152, 0, 0, 87, 238, 185, 38, 185, 72, 55, 157, 180, 21, 157, 194, 197}, 136},
	{{152, 20, 251, 235, 191, 176, 235, 252, 193, 152, 79, 37, 209, 109, 252, 105}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 233}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 75, 18, 161, 225}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 251, 219, 65, 58}, 136},
	{{152, 0, 0, 0, 143, 250, 10, 18, 71, 83, 55, 61, 101, 114, 11, 93}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 49, 251, 8, 244, 79}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 4, 176, 183, 206, 168, 195, 186, 127, 13}, 136},
	{{152, 0, 0, 232, 244, 227, 255, 19, 230, 184, 163, 192, 173, 38, 40, 231}, 136},
	{{152, 0, 0, 0, 0, 207, 142, 140, 4, 34, 229, 173, 212, 96, 190, 144}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 241}, 136},
	{{152, 0, 0, 0, 102, 73, 34, 193, 182, 16, 211, 204, 16, 122, 153, 235}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 199, 77, 89}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 82, 205, 79}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 68}, 136},
	{{152, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 4, 151, 169}, 136},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 208}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 73, 31, 145, 158, 45, 54, 205, 38, 156}, 107},
	{{9, 174, 211, 200, 120, 172, 164, 20, 56, 123, 166, 160, 119, 144, 111, 238}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 119, 227, 77, 159, 107, 195, 173, 133}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 24, 40, 51, 107, 140, 149, 98}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 104, 228, 152, 190, 220, 230, 3}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 62, 86, 112, 46}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 67, 18, 152, 161, 24, 22, 48, 196, 209}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 7, 105, 200, 11, 251, 1, 90, 0}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 123, 175, 194, 97}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 141}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 2, 13, 91, 78, 111, 33, 16}, 107},
	{{9, 174, 211, 200, 120, 0, 195, 29, 23, 35, 153, 228, 146, 91, 8, 232}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 88, 219, 188, 176}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 58, 163, 195, 83, 74, 227, 227, 198, 106}, 107},
	{{9, 174, 211, 200, 120, 0, 53, 95, 233, 248, 152, 217, 53, 72, 190, 163}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 209}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 141, 81, 95, 174}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 120, 8, 163, 162, 216, 7, 31, 153}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 160, 76, 232, 115, 172, 232, 13, 225, 55}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 170, 46, 182, 253, 234, 5}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 120, 103, 88, 19, 76, 85, 68, 227, 247}, 107},
	{{9, 174, 211, 200, 120, 121, 64, 129, 162, 50, 45, 167, 24, 42, 228, 146}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 228, 210, 125, 19, 225, 105, 19}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 187, 212, 180}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 55, 96, 182, 94, 73, 79, 146, 153}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 53, 138, 34, 81}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 6, 128, 3, 226, 42, 136}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 148, 176, 90, 123, 238, 49, 171, 144, 48}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 158, 144, 41, 97, 185, 61}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 39, 81, 246, 157, 196, 17, 235, 196, 164}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 231, 165, 51}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 77, 141, 110, 132, 238}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 154, 33, 16, 162, 40, 9, 246, 252, 150}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 163, 209, 188, 196, 134, 65}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 252, 119, 10, 230, 234}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 19, 52, 94, 71, 95}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 3, 93, 18, 159, 148, 104, 40}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 114, 1, 65, 63, 144, 108}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 118, 191, 248, 187}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 73, 196, 14, 47, 8, 195, 101, 199, 11}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 17}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{9, 174, 211, 200, 120, 0, 190, 151, 253, 145, 102, 107, 116, 17, 253, 56}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 250, 185, 163, 1, 167, 191}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 145, 23, 134, 207, 108}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{9, 174, 211, 200, 120, 0, 48, 97, 65, 156, 25, 122, 165, 7, 38, 153}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 220, 97, 200, 76, 35, 246}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 61}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 211, 84, 240, 231, 254, 110, 133}, 107},
	{{9, 174, 211, 200, 120, 0, 42, 146, 116, 107, 40, 149, 190, 65, 159, 133}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 92, 116, 22, 55, 41, 16}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 181, 40, 145, 162, 180, 189, 159, 123}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 151, 199, 17, 125, 77, 127}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 57}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 37, 144, 206, 201, 107, 16, 157, 235}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 130, 166, 146, 9, 215, 71, 173, 19, 81}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 2, 238, 28, 134, 115, 71, 113, 94, 220}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 15, 104, 125, 247, 190, 84, 244, 37, 112}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 241, 229, 122, 75}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 217, 228, 47, 187, 71}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 160, 41, 5, 187, 237, 255}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 83, 222, 181}, 107},
	{{9, 174, 211, 200, 120, 99, 242, 112, 9, 143, 13, 194, 16, 190, 97, 112}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 141, 188, 202, 116, 56}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 208, 200, 227, 81, 166}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 172, 77, 255, 46, 152, 123, 106}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 5, 39, 164, 39, 174, 225, 97}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 52, 255, 24, 224, 7, 162, 139, 21}, 107},
	{{9, 174, 211, 200, 120, 0, 51, 226, 137, 86, 223, 191, 80, 188, 181, 169}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 107},
	{{9, 174, 211, 200, 120, 0, 84, 235, 14, 224, 85, 166, 153, 148, 221, 174}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 216, 255, 96, 162, 98, 148, 164}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 222, 110, 177, 150}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 220}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 131, 88, 38, 214, 188, 20, 50}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 159, 151, 246}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 153, 19, 229, 158, 151, 121, 31}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 0, 221, 54, 161, 49, 236}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 0, 0, 211, 172, 150, 94, 170, 139}, 107},
	{{9, 174, 211, 200, 120, 0, 0, 0, 249, 52, 208, 184, 243, 90, 22, 24}, 107},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 146, 221, 189, 221}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 39}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 205}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 70}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 162, 86}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 137}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 47, 51, 43, 151}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 249, 52, 21, 199}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 159}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 153, 149, 53, 10, 80}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 184, 24, 119, 17}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 211, 79}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 207}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 255, 220, 4}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 250, 97, 192}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 164, 89, 233, 63}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 225, 227, 200, 200}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 115, 219}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 215}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 138, 16}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 10, 82, 44}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 159, 97, 211, 4, 204}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 225, 228}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 3, 90, 145}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 165, 64, 109, 242}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 155}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 18}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 138}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 98, 86}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 139, 10}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 49}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 9, 164, 58, 252}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 126}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 1, 130, 193, 86}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 62, 207, 33, 192}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 153, 119, 0, 81}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 68, 184}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 59, 243}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 174, 126, 201}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 139, 18, 30, 111, 170}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 156}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 187, 202}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 174}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 213, 66, 211, 245}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 132, 121, 30}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 112, 92, 143, 175}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 12, 66}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 124, 168, 176, 78}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 183, 153, 162, 19}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 23}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 66, 118, 120, 226}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 128}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 252}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 113, 153}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 108, 102}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 47}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 36, 44}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 100, 86, 61}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 175}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 10}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 74, 72}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 40}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 1}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 13, 197}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 3, 127, 167, 116}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 178}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 186}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 209, 139, 33, 242}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 192, 101, 37, 106}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 125}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 71, 143, 93}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 30}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 18, 213, 77, 66}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 149, 74, 225, 195}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 39, 211, 157, 146}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 173, 135}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 163, 115}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 205, 238, 60}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 0, 0, 0, 0}, 193},
	{{89, 150, 95, 28, 209, 13, 125, 159, 254, 244, 110, 0, 57, 217, 238, 141}, 193},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 127, 96, 99, 50, 166}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 158, 104, 80}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 44, 245, 99, 254, 185, 248, 231, 66}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 132, 170, 162, 170, 39, 103}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 42, 220}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 167, 60, 110, 237, 40}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 122, 247}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 119, 94, 144, 17, 130, 4, 219, 173}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 192}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 108, 5, 83, 78, 76, 223}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 111, 26, 72, 27, 129, 132}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 70, 81, 109, 38}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 194, 220, 229, 186, 233, 207, 35}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 240, 204, 81}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 99, 247, 126, 50, 146, 1}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 43, 171, 177, 1, 40, 208, 36}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 227, 196, 169, 3, 186, 129}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 196, 45, 119, 101, 216}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 68, 105, 190, 83, 0}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 125, 18, 57, 252, 112, 200, 135, 63, 81}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 152}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 71, 120, 239, 199}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 200, 137}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 1, 89}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 15, 67, 95, 235}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 203, 191, 239, 56, 143, 179}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 68, 157}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 176, 149, 202, 90, 184, 125}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 1, 21, 3, 90, 107, 219, 74, 100, 123}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 242, 153, 203, 130, 243, 154, 7}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 10, 209}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 225, 255, 183, 74, 237}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 49, 41, 249, 46, 161, 201}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 197, 86, 65, 72, 240, 124, 2, 91}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 48, 133, 226}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 71, 201, 38, 239, 150, 208, 107, 15, 38}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 168, 16, 113, 38, 26, 44, 22, 110}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 48, 143, 79, 45, 220}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 160, 112, 119, 107, 2}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 130, 78, 151, 44, 187, 198}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 54, 233}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 76, 86, 244}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 60, 85, 181, 30, 91}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 235, 40, 178, 173}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 92, 172, 144, 75}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 63, 66, 104, 46}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 186, 52, 143, 54}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 212, 175, 101}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 13, 181, 80, 220}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 151}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 133}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 196, 62, 221, 254}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 165, 232, 145, 20, 10, 34}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 202, 222, 210, 92, 61, 94}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 102, 103, 211, 233}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 34, 222, 155, 166, 210}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 99, 14, 154, 245, 155, 126, 229, 198}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 137, 197, 243, 58, 102, 212}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 110, 113}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 123, 114, 127, 250, 231, 26, 183, 140}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 240, 164, 31}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 120, 124, 43}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 121, 242, 127}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 94, 136, 122, 143, 152}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 199, 145, 39, 3, 173, 167, 240}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 238, 190}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 180, 164, 181, 168}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 102, 88, 58, 63, 27}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 148, 14, 96}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 135, 146, 1, 241, 146, 92}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 59, 136, 2, 199, 234, 182}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 145, 80}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 118, 220, 67, 143, 206}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 90, 108, 253, 86, 114, 66}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 185, 42, 137, 86}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 79, 23}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 207, 164, 23, 138, 183, 95, 82, 66, 216}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 229, 142, 182, 64, 179, 15, 14}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 4},
	{{23, 28, 202, 10, 90, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 4},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 239, 18}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 25, 128}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 126, 26}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 111, 40, 185}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 89, 87}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 116, 34}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 13}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 187, 61, 167}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 36, 22, 156}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 162, 24}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 39, 147}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 218}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 73}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 197, 131}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 103, 82}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 39, 108, 243}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 67, 77, 157}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 87, 52}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 186, 169, 200}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 31, 79, 121}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 245, 227, 79}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 235, 51, 70}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 238, 70}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 45, 192, 55}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 209, 124, 154}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 62}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 228, 83, 238}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 208, 122, 19}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 251, 83, 223}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 101}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 170, 218, 249}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 97, 52}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 135}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 24, 65}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 139, 127, 90}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 183}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 86}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 244}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 201, 176, 83}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 3}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 71, 96, 155}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 88, 39}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 107, 57, 121}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 225, 213}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 117}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 107, 98, 139}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 132, 14}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 146, 96, 87}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 53}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 202}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 139}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 61, 242}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 188}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 72, 177}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 133}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 22, 135}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 235}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 205, 16, 51}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 210}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 86}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 248, 80}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 103, 37}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 158}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 84, 202}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 136, 10, 94}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 0}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 43}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 70, 93}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 68}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 218, 3, 245}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 68, 8, 113}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 81}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 14, 95}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 131}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 18}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 15, 170}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 214, 243}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 0, 157}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 0, 218, 148}, 68},
	{{48, 25, 180, 9, 84, 236, 6, 144, 30, 198, 41, 56, 0, 102, 236, 105}, 68},
	{{252, 0, 0, 0, 0, 0, 0, 0, 21, 111, 167, 28, 196, 178, 228, 10}, 40},
	{{252, 0, 0, 190, 175, 230, 24, 47, 163, 98, 114, 24, 163, 161, 174, 153}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 55, 8}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67}, 40},
	{{252, 0, 0, 0, 174, 190, 67, 179, 117, 201, 33, 254, 43, 216, 200, 90}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 159, 247, 72, 72, 223, 77, 180}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 181, 217, 105, 116, 115, 216, 161, 92, 100}, 40},
	{{252, 0, 0, 0, 53, 170, 213, 49, 0, 244, 146, 161, 51, 72, 244, 69}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 108, 107, 155, 105, 123, 77, 144, 34, 27}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 97, 52, 52, 224, 111, 213, 97}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 58, 225, 163, 116, 16, 132, 169, 92, 127}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 232, 253, 98, 106, 227, 63, 37}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 202, 50, 88}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 208}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 65, 158}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 125, 43, 255, 203, 101, 95, 26}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 244, 123}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 214, 124, 72}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 158, 195, 85, 167}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 235, 49, 36, 135, 250, 36, 132, 218}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 207, 91, 68}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 126, 12}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 29, 52, 190, 109, 89, 228, 62, 176}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 51, 132, 165, 41, 5, 145, 186}, 40},
	{{252, 0, 0, 0, 119, 175, 217, 16, 168, 247, 149, 248, 35, 232, 56, 160}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 151, 117, 59, 0}, 40},
	{{252, 0, 0, 148, 228, 43, 67, 149, 121, 239, 207, 68, 17, 17, 212, 110}, 40},
	{{252, 0, 0, 0, 74, 74, 231, 28, 94, 163, 219, 2, 241, 82, 197, 8}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 232, 25, 194, 184, 103, 75, 159, 181, 250}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 3, 241, 74, 138, 49, 157, 99, 202, 85}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 37}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 156, 149, 216, 205, 173, 134, 1, 179, 173}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 245, 200, 126, 132, 94}, 40},
	{{252, 0, 196, 99, 45, 189, 2, 95, 102, 249, 156, 51, 187, 57, 66, 7}, 40},
	{{252, 0, 0, 0, 0, 27, 251, 148, 146, 220, 182, 242, 27, 4, 119, 199}, 40},
	{{252, 0, 0, 139, 10, 105, 73, 83, 232, 114, 50, 243, 140, 202, 7, 238}, 40},
	{{252, 0, 0, 130, 252, 193, 179, 25, 170, 153, 178, 78, 16, 205, 22, 158}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 187}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 64, 243, 60, 11, 43, 153, 150}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 254, 207, 160, 207, 32}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 57, 64, 72, 66, 24, 41, 159, 8, 211}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 94, 9}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 70}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 232, 6, 202, 33, 202, 140, 130}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 45, 97}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 216, 176, 171, 11, 25}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 33, 164, 109, 77}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 50}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 85, 235, 199, 27}, 40},
	{{252, 0, 0, 178, 236, 155, 169, 182, 254, 100, 236, 222, 249, 164, 66, 73}, 40},
	{{252, 0, 0, 0, 0, 159, 172, 180, 181, 5, 6, 252, 114, 185, 211, 228}, 40},
	{{252, 0, 0, 0, 0, 0, 14, 104, 167, 233, 169, 130, 40, 231, 107, 193}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 37}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 130, 255}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 60, 86}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 183, 1, 55, 95}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 40},
	{{252, 0, 45, 63, 229, 24, 78, 37, 254, 157, 32, 110, 233, 77, 85, 128}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 217, 255, 20, 227, 30}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 30, 105, 207}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 76, 126}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 214, 116, 212, 181, 26, 208, 177, 208}, 40},
	{{252, 0, 0, 0, 195, 190, 142, 10, 129, 21, 119, 179, 38, 7, 176, 79}, 40},
	{{252, 0, 0, 0, 0, 125, 197, 37, 170, 58, 2, 95, 170, 6, 228, 94}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 55, 194, 99, 147, 194}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40},
	{{252, 0, 0, 0, 0, 0, 165, 183, 208, 13, 157, 172, 92, 235, 137, 173}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 0, 233}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 232, 114, 190, 218}, 40},
	{{252, 0, 83, 249, 16, 205, 190, 223, 144, 175, 130, 195, 175, 94, 226, 43}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 61, 9, 186, 39, 141, 75, 82, 23}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 5}, 40},
	{{252, 0, 0, 48, 220, 139, 174, 86, 223, 103, 7, 120, 55, 227, 240, 231}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 196, 194, 28, 156, 90}, 40},
	{{252, 0, 118, 222, 9, 205, 160, 246, 4, 156, 226, 50, 131, 190, 19, 137}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 224, 180, 61, 152, 172, 33, 87}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 66, 124, 218, 83}, 40},
	{{252, 0, 154, 49, 137, 62, 213, 254, 67, 117, 246, 178, 107, 200, 125, 127}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 185, 175, 112, 202, 167, 50, 95, 128, 166}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 115, 0, 19, 243, 192}, 40},
	{{252, 0, 54, 20, 29, 15, 72, 83, 168, 101, 252, 36, 6, 205, 82, 33}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 6, 70, 79, 231, 245, 208, 135}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 141}, 40},
	{{252, 0, 0, 0, 0, 0, 127, 120, 158, 73, 152, 185, 22, 74, 119, 158}, 40},
	{{252, 0, 110, 62, 115, 101, 221, 28, 111, 146, 225, 184, 30, 186, 192, 20}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 79}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 65, 253, 63}, 40},
	{{252, 0, 0, 0, 138, 131, 201, 147, 155, 111, 136, 97, 166, 148, 44, 180}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 184, 64, 201, 69, 171, 94, 204}, 40},
	{{252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 39, 55}, 40},
	{{252, 0, 0, 50, 106, 47, 24, 196, 216, 44, 102, 130, 12, 120, 54, 154}, 40},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 15, 165, 222, 176, 197, 18, 198}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 72, 48, 110, 133}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 103, 100, 3, 158}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 133, 236, 6, 108}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 39}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 201, 100, 81, 132, 236, 180, 240}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 64, 71, 120, 40}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 173, 118, 230, 44, 151, 67, 46}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 181, 65, 251, 9, 162, 7}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 77, 172, 34, 66, 43, 101}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 139, 142, 55, 190, 249, 79, 101}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 21, 254, 213, 128, 104, 173, 69}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 171, 178, 109, 31}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 215, 9, 36, 21, 52, 245, 73, 40}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 141, 74, 242, 92, 213}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 219, 172, 228, 209, 40}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 35, 75, 184, 206, 45, 27, 201, 142, 219}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 147, 175, 36, 239, 145, 185, 181, 123}, 255},
	{{20, 165, 57, 130, 164, 0, 91, 160, 51, 152, 168, 130, 106, 67, 27, 2}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 67, 106, 35, 229, 79, 41, 236, 23}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 123, 78, 187, 82}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 22, 135, 192, 104}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 242, 1, 96, 247, 196, 8, 234}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 255}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 3}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 23, 65, 231, 107, 138}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 184, 101, 188, 55, 68, 169}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 215, 168, 129}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 182, 182, 9, 5, 132}, 255},
	{{20, 165, 57, 130, 164, 0, 137, 145, 35, 86, 177, 158, 213, 174, 205, 224}, 255},
	{{20, 165, 57, 130, 164, 0, 96, 237, 105, 65, 105, 131, 53, 224, 119, 136}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 2, 107, 236, 253, 221, 165}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 129, 142, 17, 52}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 104, 5, 242, 96, 133, 45, 143}, 255},
	{{20, 165, 57, 130, 164, 0, 137, 18, 122, 193, 152, 209, 14, 182, 86, 100}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 131, 76, 92, 44, 204, 145}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 102, 142, 169, 191, 16, 5}, 255},
	{{20, 165, 57, 130, 164, 0, 30, 92, 72, 169, 105, 67, 230, 226, 7, 197}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 38, 192, 127, 110, 230, 189}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 161, 123, 11}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 116, 233, 94, 110, 200}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 237, 237, 163, 152}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 254}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 55, 207, 106, 50}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 169, 209, 24, 177, 191, 95, 225, 156, 61}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 180, 250, 211}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 70, 201, 0, 229, 79, 142, 42, 46}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 52}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 181, 234, 254, 39, 9, 209, 0, 138, 182}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 100, 96, 7, 16, 110, 11, 212}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 179, 31, 39, 222, 43, 108, 243, 55, 246}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 17, 42, 74, 77, 160, 184, 52, 165}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 37}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 120, 38, 56}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 57, 115, 129, 175, 215, 200, 87, 229, 208}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 109, 176, 88}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 99}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 164, 214, 40, 65, 239, 153, 132, 152, 87}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 138, 34, 132, 2}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 192, 180, 137, 238, 11}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 192, 205, 242}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 219, 248, 225, 11, 221, 179}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 239}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 58, 0, 172, 232, 185, 0, 67}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188}, 255},
	{{20, 165, 57, 130, 164, 0, 99, 8, 250, 216, 69, 86, 83, 149, 160, 28}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 191, 40, 67, 221, 133, 221, 157, 202, 92}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 241, 181, 125, 254, 34}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 62, 191, 140, 124, 17, 55, 170}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 47, 203, 111}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 105, 246, 186, 57, 12, 194, 61, 47, 150}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 170, 67, 60, 214, 232, 171}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 176, 39, 251, 121, 30, 228, 64, 53}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 69, 63, 97, 255, 32, 18}, 255},
	{{20, 165, 57, 130, 164, 0, 27, 90, 249, 79, 40, 201, 64, 68, 112, 148}, 255},
	{{20, 165, 57, 130, 164, 0, 249, 181, 221, 29, 126, 53, 216, 120, 180, 226}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{20, 165, 57, 130, 164, 91, 164, 101, 116, 107, 230, 205, 143, 101, 161, 53}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 80, 120, 84, 244, 153, 114, 153, 253, 204}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 171, 100, 196, 199, 244, 103, 194, 142}, 255},
	{{20, 165, 57, 130, 164, 0, 0, 0, 0, 0, 0, 0, 0, 52, 218, 236}, 255},
	{{167, 56, 128, 0, 0, 0, 35, 158, 199, 47, 65, 118, 121, 111, 14, 14}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 68, 125, 216, 239, 87, 95, 65}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 140}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 55}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 127}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 124, 239, 144, 234, 124, 203, 148, 80}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 105, 207, 217, 213, 209}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 140, 69, 65, 178, 72, 103, 255, 40, 176}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 108},
	{{167, 56, 128, 0, 0, 0, 241, 220, 90, 205, 63, 205, 201, 12, 52, 144}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 176, 62, 5, 7, 102, 30, 36}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 26, 15, 58}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 216}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 213, 90, 231}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 75, 215, 28, 245, 92}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 226}, 108},
	{{167, 56, 128, 0, 0, 0, 230, 119, 96, 89, 29, 145, 167, 194, 82, 159}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 110, 146, 187, 73, 90, 19, 94}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 173, 209}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 186, 151, 162, 131, 12, 29}, 108},
	{{167, 56, 128, 0, 0, 0, 246, 222, 215, 39, 255, 145, 41, 146, 95, 221}, 108},
	{{167, 56, 128, 120, 46, 10, 208, 26, 202, 182, 6, 123, 3, 55, 110, 251}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 144}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 72, 204, 124, 240, 83, 107, 68, 136}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 204, 147}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 63, 35, 127, 103, 254, 163, 111}, 108},
	{{167, 56, 128, 0, 0, 0, 12, 61, 219, 28, 219, 229, 125, 155, 203, 209}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 145, 38, 221}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 169, 137, 216, 148, 231, 171, 112, 219, 30}, 108},
	{{167, 56, 128, 0, 0, 0, 44, 127, 121, 15, 62, 134, 27, 89, 68, 104}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 102}, 108},
	{{167, 56, 128, 0, 0, 0, 70, 145, 40, 160, 21, 205, 116, 8, 148, 154}, 108},
	{{167, 56, 128, 0, 0, 0, 233, 37, 53, 181, 34, 142, 186, 189, 138, 81}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 126, 255, 15, 98, 63, 48, 166, 5}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 205, 243, 9, 15, 166}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 211, 151, 221, 40, 138, 36, 188, 6, 48}, 108},
	{{167, 56, 128, 0, 0, 0, 242, 126, 232, 44, 31, 99, 200, 131, 255, 191}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 5, 190, 55, 59, 162}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 102, 101, 128, 234, 171}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 170, 20, 86, 212, 124, 88, 159}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 239, 63, 123, 165, 123, 150, 121, 18}, 108},
	{{167, 56, 128, 0, 4, 166, 95, 75, 234, 191, 72, 162, 234, 61, 18, 48}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 101, 251, 197}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 132, 29, 92, 242, 58, 141, 81}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 36, 175}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 69, 0, 31}, 108},
	{{167, 56, 128, 176, 22, 31, 113, 72, 63, 5, 224, 33, 209, 174, 219, 42}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 198, 252, 197, 145, 126, 153, 221, 209}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 206, 255, 79}, 108},
	{{167, 56, 128, 0, 44, 191, 13, 122, 85, 70, 236, 166, 195, 153, 60, 101}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 215, 217, 34, 201, 47}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 58, 194, 255}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 165, 237, 29, 89, 132, 226, 229}, 108},
	{{167, 56, 128, 0, 158, 164, 178, 238, 29, 150, 81, 88, 155, 112, 187, 175}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 35, 41, 25, 154, 23, 229, 158, 162}, 108},
	{{167, 56, 128, 0, 0, 0, 173, 39, 237, 173, 122, 14, 42, 108, 230, 31}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 152, 163, 65, 176, 85, 156, 49}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 96, 108, 60, 21, 212, 2, 222, 57}, 108},
	{{167, 56, 128, 113, 212, 182, 110, 251, 134, 229, 0, 18, 95, 238, 150, 251}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 74, 150, 57, 17, 83, 166, 63, 71, 26}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 108},
	{{167, 56, 128, 0, 233, 96, 173, 108, 30, 104, 118, 143, 248, 43, 114, 29}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 144, 229, 35, 55, 233}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 4, 226}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 196, 113, 77}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 35, 167}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 57, 117, 191, 79, 242}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 72, 157, 7}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 98, 200, 198, 148, 59, 168, 159, 192}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 137}, 108},
	{{167, 56, 128, 194, 242, 30, 228, 9, 216, 30, 177, 226, 229, 247, 231, 52}, 108},
	{{167, 56, 128, 0, 47, 34, 132, 206, 61, 169, 197, 40, 208, 159, 198, 150}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 45}, 108},
	{{167, 56, 128, 0, 0, 0, 228, 146, 75, 187, 105, 48, 236, 29, 122, 240}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 57, 165, 77, 18, 71, 167, 145}, 108},
	{{167, 56, 128, 10, 204, 20, 255, 47, 169, 62, 222, 177, 123, 70, 64, 185}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 9, 107, 171, 88, 255, 187, 194, 64}, 108},
	{{167, 56, 128, 0, 0, 0, 97, 220, 245, 205, 135, 77, 65, 182, 212, 43}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 136, 99, 192, 158, 142, 85}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 123, 249}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 108, 4}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 231, 11, 29, 253, 117, 119, 176}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 219}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 165, 219}, 108},
	{{167, 56, 128, 0, 85, 145, 105, 99, 190, 20, 217, 126, 100, 81, 137, 77}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 108, 3}, 108},
	{{167, 56, 128, 0, 0, 87, 41, 228, 84, 49, 207, 182, 25, 218, 46, 78}, 108},
	{{167, 56, 128, 0, 0, 104, 116, 137, 110, 16, 20, 64, 131, 113, 251, 220}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 130, 58}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111, 105, 1}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 84}, 108},
	{{167, 56, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133}, 108},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 42, 178}, 219},
	{{91, 204, 0, 0, 39, 241, 21, 59, 160, 111, 24, 53, 197, 81, 239, 137}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 255, 35, 128, 61, 30, 39}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 188, 106, 146, 42, 14, 185}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 245, 130, 141, 187, 254, 48, 47, 69}, 219},
	{{91, 204, 0, 145, 67, 227, 35, 72, 152, 109, 75, 213, 134, 26, 102, 149}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 51, 190, 105, 148, 52, 39, 223}, 219},
	{{91, 204, 0, 75, 1, 250, 242, 129, 188, 199, 123, 190, 23, 161, 183, 92}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 11, 89, 194, 71, 49, 13, 175, 139}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 199, 217, 12, 141, 178, 43, 93, 31}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 86, 113, 165, 23, 202, 132, 160, 175, 88}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 96, 11, 228, 9}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 107, 166}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 55, 188, 155, 51, 22, 251}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 106, 177, 64, 81, 213, 51, 161}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 148, 187, 169}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 123, 229, 26, 66}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 147, 183, 69, 250, 117, 65, 56, 144, 36}, 219},
	{{91, 204, 0, 0, 0, 0, 73, 12, 241, 161, 71, 194, 136, 125, 211, 91}, 219},
	{{91, 204, 0, 0, 0, 0, 164, 31, 15, 253, 216, 69, 254, 9, 86, 240}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{91, 204, 0, 19, 238, 97, 44, 114, 86, 77, 19, 125, 127, 179, 120, 131}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 35, 221, 24, 89}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 147, 200, 238, 58, 174, 19, 221}, 219},
	{{91, 204, 0, 222, 175, 0, 213, 218, 199, 20, 162, 216, 148, 58, 80, 90}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{91, 204, 0, 49, 50, 116, 188, 131, 7, 130, 221, 133, 122, 30, 10, 42}, 219},
	{{91, 204, 0, 0, 174, 246, 207, 91, 244, 129, 131, 179, 245, 4, 216, 30}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 184, 196, 210, 252, 242, 15, 151, 55, 134}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 117, 46, 69, 91, 47, 32, 130, 56, 239}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 19}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 247, 187, 201, 0, 176, 3, 5}, 219},
	{{91, 204, 0, 0, 0, 0, 75, 198, 203, 235, 20, 69, 180, 163, 116, 59}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 214, 2, 213, 66, 216, 143}, 219},
	{{91, 204, 0, 0, 0, 0, 78, 0, 71, 143, 198, 137, 87, 7, 0, 173}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 241, 104, 126, 196, 142, 73, 105, 203}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{91, 204, 0, 0, 142, 12, 180, 196, 164, 54, 201, 7, 7, 243, 35, 13}, 219},
	{{91, 204, 0, 113, 13, 19, 58, 139, 148, 172, 243, 246, 195, 157, 12, 157}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 231, 210}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 187, 209}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 157, 23, 183, 13, 101, 226}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 67, 115, 233, 3}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 99, 249, 54, 58, 207, 89, 208, 56}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 219},
	{{91, 204, 0, 0, 0, 172, 164, 86, 99, 194, 183, 92, 121, 49, 177, 238}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 40, 192, 189, 107, 44, 26, 253}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 184, 237, 232, 9, 223, 105, 72, 57, 28}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 198, 229}, 219},
	{{91, 204, 0, 0, 0, 115, 97, 150, 175, 195, 164, 153, 207, 23, 173, 25}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 175}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 124, 215, 34, 59, 200, 11}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 121, 162, 182, 21, 228, 235, 245, 44, 84}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 55, 240, 140, 1}, 219},
	{{91, 204, 0, 152, 29, 233, 123, 218, 108, 193, 84, 66, 180, 170, 59, 31}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 14, 242, 109}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 15, 249, 65, 212, 38, 170, 17}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{91, 204, 0, 0, 0, 0, 116, 87, 47, 77, 69, 154, 95, 182, 68, 136}, 219},
	{{91, 204, 0, 0, 0, 186, 198, 68, 99, 153, 232, 199, 229, 171, 172, 187}, 219},
	{{91, 204, 0, 0, 112, 171, 222, 181, 206, 185, 86, 155, 82, 178, 212, 78}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 154}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 238}, 219},
	{{91, 204, 0, 0, 0, 0, 222, 28, 204, 84, 247, 248, 179, 203, 124, 11}, 219},
	{{91, 204, 0, 0, 0, 0, 254, 54, 69, 12, 30, 235, 140, 134, 242, 218}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 197, 0, 73}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 15, 18, 20, 30, 232, 136, 207}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 96, 73, 115, 247, 198, 242, 230}, 219},
	{{91, 204, 77, 245, 25, 213, 205, 128, 79, 126, 25, 143, 39, 222, 37, 41}, 219},
	{{91, 204, 0, 63, 247, 172, 221, 99, 117, 100, 56, 48, 228, 121, 35, 175}, 219},
	{{91, 204, 0, 0, 234, 213, 197, 32, 219, 96, 136, 58, 223, 16, 124, 39}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 64, 118}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 24, 143, 84, 199}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 106, 132}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 164, 46, 254, 11, 4, 41, 19, 155, 255}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 163}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 231, 61, 180}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{91, 204, 0, 0, 0, 92, 185, 255, 170, 210, 253, 73, 88, 97, 11, 72}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 237, 137, 246, 123, 170, 1, 188}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 108, 196, 10, 137, 221, 116}, 219},
	{{91, 204, 0, 0, 0, 0, 0, 0, 0, 0, 165, 196, 252, 71, 14, 239}, 219},
	{{91, 204, 0, 0, 0, 0, 178, 74, 43, 95, 55, 175, 139, 144, 36, 138}, 219},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 98}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 241}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 20, 60}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 254}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 145}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 79}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 29}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 29, 90}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 168}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 73, 34}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 176}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 237, 96}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 77}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 229, 21}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 197}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 129}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 126}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 143, 101}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 96}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 96}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 130, 189}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 209}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 110, 7}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 23, 26}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 191, 172}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 109}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 213}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 47}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 174, 3}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 207, 150}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 171}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 213, 204}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 90}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 72}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 146}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 195, 123}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 239}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 123, 254}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 241}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 35, 83}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 35}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 101}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 36, 12}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 65, 89}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 165, 216}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 230, 239}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 179}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 246}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 162, 9}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 45}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 105}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 95}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 32}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 11}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 126}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 101}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{24, 46, 9, 4, 170, 150, 56, 130, 127, 120, 118, 104, 168, 48, 0, 0}, 12},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 59, 234, 86, 111, 92}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196}, 84},
	{{156, 60, 245, 247, 189, 0, 28, 245, 133, 48, 94, 146, 3, 86, 23, 152}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 88, 247, 53}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 25, 228, 113, 93, 10}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 80, 124, 129, 234, 158, 215, 45, 30}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 48, 109, 28, 135, 219, 252, 9, 75, 1}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 35}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 86, 242, 9, 80, 129, 66, 33, 150}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 239}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 180, 249, 136}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 35, 34, 91, 23, 89, 69, 212}, 84},
	{{156, 60, 245, 247, 189, 0, 132, 83, 201, 175, 181, 70, 106, 229, 217, 229}, 84},
	{{156, 60, 245, 247, 189, 0, 49, 121, 83, 192, 64, 181, 18, 187, 126, 210}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 128, 21, 124, 97, 205}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 69, 130, 118}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 239, 64, 7, 119, 155, 30}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 245, 1, 194, 143, 189, 132, 151, 37}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 76, 48, 238, 117, 181, 131}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 50}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 123, 23, 123}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 29, 149, 127, 0, 185, 202}, 84},
	{{156, 60, 245, 247, 189, 0, 5, 173, 55, 173, 184, 209, 84, 88, 8, 144}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 252, 133, 68, 208}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 178, 123, 48, 67, 165, 21, 28}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 8, 120, 95, 124}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 185, 104, 239, 57, 217}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 112, 182, 186, 118, 16, 157, 114, 251}, 84},
	{{156, 60, 245, 247, 189, 0, 229, 7, 107, 224, 240, 170, 192, 98, 187, 188}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 60, 74, 173, 112}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 54, 80, 101, 139, 67, 110, 117, 14, 31}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 48}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 208}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 38, 76, 157, 158, 169, 158, 203, 102, 120}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 117, 182, 34, 249, 228}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169}, 84},
	{{156, 60, 245, 247, 189, 0, 242, 166, 157, 80, 144, 11, 80, 136, 63, 131}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 190, 78, 90, 43, 137, 193, 5, 63, 249}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 158, 208, 94}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 141, 168, 63, 102, 215}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 143, 244, 72}, 84},
	{{156, 60, 245, 247, 189, 0, 81, 129, 152, 133, 230, 141, 30, 83, 175, 172}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 5}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 24, 5, 151, 79, 73, 150, 67, 110, 164}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 161, 128, 63, 243}, 84},
	{{156, 60, 245, 247, 189, 0, 252, 123, 232, 176, 146, 201, 105, 238, 88, 67}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 81, 201, 55, 101, 181, 12, 167, 200, 29}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 112, 249, 172, 144, 51, 80, 55, 127, 222}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 102, 147, 171, 115}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 236, 184, 141, 28, 36}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 187, 188, 226, 51}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 71, 56, 203}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 178, 55, 69, 229}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 77, 48, 88, 147, 53, 223}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 78}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 33, 234, 31, 43, 75, 115, 5}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 2, 81, 182, 10, 88, 27}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 47, 26, 201, 96, 81, 204, 129, 230}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 206, 182, 201, 50, 124}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 188, 236, 46, 44, 33, 18, 119, 119}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 175, 62, 141, 189, 29, 93, 30}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 48, 237, 25, 114, 52, 70, 27}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 43, 26, 55, 156, 255, 118, 167, 201}, 84},
	{{156, 60, 245, 247, 189, 0, 130, 170, 58, 237, 7, 145, 133, 193, 32, 203}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 3, 43, 84, 236}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 229}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 251, 145, 63}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 119, 106, 144, 170}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 194, 142, 243, 21, 210, 11, 154, 226}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 25, 169, 66}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 162, 243, 33, 156}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 152, 107, 124, 63, 24, 129, 139, 175, 83}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 106, 230, 243, 77, 101, 80, 152, 94, 191}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 85, 64, 86}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 84},
	{{156, 60, 245, 247, 189, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 92, 198}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 222}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 55, 6}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 50, 47, 136}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 116}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 104}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 120, 165}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 26, 179}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 201}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 38, 129, 173}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 232, 173, 169}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 99, 213, 245}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 192, 195}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 89, 59, 69}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 252, 47}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 189, 60, 16}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 43, 215, 212}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 36}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 34, 194}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 198}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 47}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 75, 68}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 47, 129}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 222, 105, 202}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 71, 54}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 33}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 221}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 193, 39, 193}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 196}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 157}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 217, 16, 200}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 231, 64, 142}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 192, 42, 239}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 209, 133}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 56, 59, 74}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 226, 254}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 79, 125, 67}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 85, 42, 67}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 180, 89}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 206, 246, 151}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 217, 34, 26}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 124, 62, 105}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 9, 85, 101}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 70, 231, 75}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 77, 228}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 29, 229, 64}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 83, 179}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 7, 156, 74}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 152, 132, 240}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 248, 172, 192}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 91, 127}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 105, 34, 69}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 151, 238}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 65}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 82}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 77, 229}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 182, 175, 148}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 230, 19}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 55}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 34, 91}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 104}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 51}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 175, 240}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 250, 45}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 54, 33, 206}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 155, 146}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 25}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 206}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 183, 35}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 88, 196}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 13, 6}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 25}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 178}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 40}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 84}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 96, 232, 227}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 0, 0}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 184, 244, 193}, 33},
	{{148, 104, 187, 174, 129, 28, 127, 162, 92, 222, 52, 18, 0, 0, 66, 216}, 33},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 106, 164}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 38}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 104, 155}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 218, 201}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 104}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 255}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 207}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 78, 225}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 150, 221, 211, 237}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 19}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 251, 132, 245}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 46}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 129}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 25}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 10, 224, 5}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 122, 27, 184}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 75, 6}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 38, 30, 127}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 101}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 39, 45}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 69, 27, 81}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 201, 235}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 255, 111, 35}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 116, 32, 139}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 156, 174, 105, 6}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 114}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 1, 175}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 173, 21}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 167, 80, 140}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 48, 18, 108}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 239, 179}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 76, 194, 227}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 58, 171}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 114, 49}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 218, 150, 247}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 76}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 42, 224}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 220, 104}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 250, 196, 240}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 213}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 97, 162}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 68, 84}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 23}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 96, 184, 189, 190}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 203, 205, 147, 33}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 216, 137}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 98, 247, 112}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 230, 199}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 254, 247}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 10, 68}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 166}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 155, 102, 161}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 62}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 150, 56}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 143}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 132, 245, 78, 93}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 69}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 26, 49, 198, 129}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 165}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 53, 147}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 172, 31, 216}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 183, 217, 29}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 66, 27, 18, 161}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 160, 163}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 162, 157, 29}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 212, 128, 57}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 239}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 39, 218}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 220}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 135, 166, 175}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 127}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 7, 222, 109}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 137}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 0, 0}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 0, 223, 45}, 199},
	{{38, 253, 182, 153, 233, 194, 159, 41, 94, 193, 254, 160, 0, 179, 19, 52}, 199},
	{{156, 77, 105, 235, 145, 216, 0, 0, 49, 131, 87, 48, 73, 167, 80, 250}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 121, 166, 240, 190, 77, 3, 228}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 91, 205, 40, 0, 73, 60, 211, 93, 124}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 222, 167, 185, 30}, 52},
	{{156, 77, 105, 235, 145, 216, 252, 125, 18, 190, 155, 22, 131, 173, 0, 119}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 111, 231, 31, 201, 15, 207, 71}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 250, 114, 123, 105, 134, 71, 113, 60, 4}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 189, 212, 242}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 216, 62, 94, 199, 21, 41}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 196, 48, 253, 115, 126, 48, 217}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 254, 244, 158}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 209, 68}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 214, 124, 34, 53, 239, 10}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 54, 208, 84, 33}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 90, 176}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 214, 248, 96, 109}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 182, 210, 95}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 215, 72, 209, 142, 240}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 255, 85}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 211, 230, 178}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 52},
	{{156, 77, 105, 235, 145, 216, 233, 131, 251, 153, 140, 93, 173, 248, 218, 156}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 117, 91, 16, 200, 36, 114, 123}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 169, 233}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 76, 159, 250, 155, 254, 87, 97}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 73, 196, 196, 61, 11, 46, 153, 4, 201}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 109, 69, 196}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 74, 157, 200, 219}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 241, 23, 98, 216, 21, 127, 169, 247, 137}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 216, 117, 47, 244, 228, 94, 99}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 147, 95, 58, 5, 251, 15, 131, 140, 245}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 179, 212, 171, 52}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 55, 159, 25, 22, 31, 2}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 241, 227, 109, 186}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 204, 18, 229, 94, 113, 249, 129, 41, 206}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 237, 73, 145, 59, 13, 34, 18, 46}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 202, 209, 189, 143, 237, 38, 143}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 206, 180, 144, 226, 154, 58, 173, 150}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 132, 173, 201, 146, 189, 26, 100}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 122, 248, 111, 201, 214, 223, 151, 195}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 85, 81}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 162, 198, 138}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 60, 118, 146, 221, 38, 82, 21, 151}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 178, 94, 152, 170, 13, 5}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 52, 245, 9, 249, 191, 200, 23, 97}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 180, 141, 92, 92, 243, 58, 29, 158}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 69, 97, 158, 209, 195, 176, 169, 58}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 91, 142, 102, 253, 223, 171, 175, 255}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 69, 54, 131, 134, 73, 106}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 5, 218}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 8, 197}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 82, 78, 33, 187, 206, 125, 5, 57, 115}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 65, 94, 233}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 128, 197, 34, 126, 41}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 58, 63, 221, 172, 94, 141, 30}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 129, 72, 210}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 232, 94, 25, 11, 242}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 60, 253, 188, 65, 31, 181, 35, 211}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 12, 173, 27, 185, 18, 156}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 40, 217, 145}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 126, 219, 120, 247, 187}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 140, 49, 157, 255, 130, 79, 78}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 108, 59, 47, 111, 135, 69, 116, 76, 102}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 80, 87, 51}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 104, 122, 46}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 232, 180}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 187, 81, 101}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 177, 233, 241}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 177, 147, 106, 165, 254, 188, 194}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 81, 132, 107, 254, 50, 137, 75, 57}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 90, 206, 153, 195, 167, 14, 187, 178}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 123, 149, 119, 78, 239}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 213, 181, 53, 184, 53, 66, 126}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 136, 67, 215, 216, 76}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 0, 193, 141, 163}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 63, 25, 64, 37, 157, 156}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 199, 76, 31, 227, 47}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 44, 124, 156, 183, 185, 247}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 239, 49, 21, 89, 110}, 52},
	{{156, 77, 105, 235, 145, 216, 0, 0, 0, 0, 0, 0, 249, 40, 109, 227}, 52},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 221}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 110}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 31}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 52}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 34}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 159}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 207}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 23}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 190}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 25}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 150}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 176}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 183}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 61}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 39}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 198}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 192}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 238}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 81}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 143}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 13}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 13}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 40}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 121}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 111}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 4}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 116}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 48}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 210}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 135}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 161}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 41}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 163}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 131}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 243}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 247}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 33}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 86}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 5}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 238}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 214}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 109}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 107}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 183}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 63}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{100, 211, 238, 147, 65, 222, 99, 73, 252, 113, 46, 113, 52, 136, 0, 0}, 184},
	{{13, 30, 0, 0, 0, 0, 0, 0, 177, 207, 35, 173, 188, 108, 116, 243}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 125, 220, 252, 184, 65, 240, 1, 97}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 129}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 216, 157}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 227, 103, 123}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 29, 166, 219, 22, 146, 122, 239}, 124},
	{{13, 30, 0, 0, 0, 75, 227, 253, 123, 8, 69, 159, 103, 150, 127, 74}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 132, 138, 170, 163, 18, 132, 173}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 124},
	{{13, 30, 0, 0, 56, 49, 35, 39, 107, 231, 192, 160, 144, 243, 155, 34}, 124},
	{{13, 30, 0, 0, 0, 0, 181, 141, 211, 91, 216, 247, 137, 107, 103, 127}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 249, 208, 112, 194, 98, 13, 46, 96}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 185, 240, 235, 28}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 47, 136, 103, 249}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 10, 105}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177}, 124},
	{{13, 30, 0, 0, 0, 58, 147, 118, 66, 161, 44, 82, 67, 12, 35, 88}, 124},
	{{13, 30, 0, 0, 0, 119, 51, 245, 217, 182, 62, 178, 43, 89, 227, 20}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 176}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 2}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 90, 103, 91, 200, 96, 230, 8, 102, 39}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 172, 56, 192, 206, 144, 179, 105}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 182, 182, 152, 87, 217, 51, 216, 99}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 78, 167, 7}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 54, 58, 30, 2, 169, 62, 10, 54}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 6, 203, 210, 36, 157, 139, 130, 157, 170}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 252, 20, 200, 238, 201, 73, 214, 113}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 142, 243, 79, 187, 39, 16}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 165}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 245}, 124},
	{{13, 30, 0, 248, 190, 136, 227, 151, 148, 170, 74, 119, 164, 168, 104, 143}, 124},
	{{13, 30, 0, 0, 0, 0, 212, 122, 44, 205, 65, 248, 187, 109, 183, 17}, 124},
	{{13, 30, 0, 0, 234, 3, 118, 33, 215, 11, 175, 172, 111, 169, 93, 223}, 124},
	{{13, 30, 0, 0, 120, 204, 77, 206, 49, 88, 234, 231, 115, 36, 224, 18}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 157}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 208, 28, 131, 167, 32, 66, 157, 5}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 174, 214, 56, 33, 165, 47}, 124},
	{{13, 30, 0, 0, 0, 0, 144, 248, 179, 170, 178, 216, 146, 47, 244, 50}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 190}, 124},
	{{13, 30, 0, 0, 25, 66, 77, 234, 160, 162, 197, 215, 69, 104, 33, 245}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 130, 32, 15}, 124},
	{{13, 30, 0, 0, 0, 0, 110, 207, 186, 110, 177, 181, 44, 224, 196, 109}, 124},
	{{13, 30, 0, 0, 0, 228, 79, 221, 169, 251, 13, 95, 104, 5, 131, 178}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 70, 159, 49, 92}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 97, 219, 234, 47, 163, 8, 114, 193, 93}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 202}, 124},
	{{13, 30, 0, 0, 0, 0, 124, 196, 37, 10, 139, 237, 245, 160, 9, 165}, 124},
	{{13, 30, 0, 0, 7, 85, 140, 2, 194, 6, 167, 79, 147, 113, 166, 1}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 77, 192, 237, 139, 158, 142, 25}, 124},
	{{13, 30, 0, 0, 241, 29, 229, 222, 239, 165, 127, 79, 10, 113, 255, 112}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 47, 252, 106, 119, 164, 163, 6, 29}, 124},
	{{13, 30, 0, 0, 219, 110, 29, 130, 67, 129, 156, 70, 213, 121, 149, 84}, 124},
	{{13, 30, 0, 0, 0, 130, 99, 227, 140, 10, 80, 103, 6, 43, 140, 237}, 124},
	{{13, 30, 0, 183, 26, 234, 198, 244, 222, 166, 5, 219, 158, 107, 33, 254}, 124},
	{{13, 30, 0, 0, 0, 77, 45, 182, 246, 216, 58, 255, 6, 122, 169, 81}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 69, 137, 200, 234, 42, 80, 207, 44}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 169, 7, 95, 145, 128, 237, 234, 92, 98}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 217, 157, 115, 165, 131, 96}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 103}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 59, 15, 88}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 124},
	{{13, 30, 0, 0, 0, 93, 11, 165, 147, 151, 70, 67, 18, 229, 242, 195}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 165, 110}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 32}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 168, 233}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 44, 150, 53, 133, 171, 58, 197, 134, 35}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 20, 195, 87, 133, 122, 55, 165, 210, 103}, 124},
	{{13, 30, 0, 223, 88, 253, 231, 115, 102, 124, 246, 145, 116, 85, 185, 15}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 205}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 41, 255, 148}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 34, 37, 62, 196, 38, 89, 169, 67}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 164, 239, 214, 82, 154, 65}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141}, 124},
	{{13, 30, 0, 0, 0, 123, 144, 24, 242, 221, 255, 230, 21, 208, 179, 42}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 145, 65, 209, 103, 185, 146, 202}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 136, 7, 201, 186, 215, 119, 87, 58}, 124},
	{{13, 30, 0, 0, 117, 29, 187, 192, 177, 16, 235, 44, 225, 102, 251, 86}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 226}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 69, 229, 245, 130}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 90, 21, 44, 209, 250, 79, 162, 47}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 249, 3, 235, 254, 96, 140, 73, 14}, 124},
	{{13, 30, 0, 5, 97, 180, 239, 167, 163, 123, 164, 54, 68, 35, 104, 149}, 124},
	{{13, 30, 0, 0, 0, 0, 56, 185, 66, 212, 19, 45, 75, 157, 107, 72}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 170, 178, 139}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 122}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 245, 194, 206, 255, 243, 73, 193}, 124},
	{{13, 30, 0, 68, 123, 164, 71, 132, 211, 186, 52, 40, 254, 242, 11, 161}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 110, 115, 61}, 124},
	{{13, 30, 0, 0, 0, 118, 170, 235, 113, 86, 252, 26, 201, 62, 63, 70}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 197}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 124},
	{{13, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 124},
	{{13, 30, 0, 79, 50, 213, 174, 21, 197, 157, 214, 183, 101, 11, 145, 142}, 124},
	{{13, 30, 0, 0, 0, 0, 205, 132, 160, 209, 22, 252, 151, 165, 43, 48}, 124},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 183, 170}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 95}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 81, 113}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 224, 49}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 28}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 57}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 253, 49}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 182, 65}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 129, 29}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 211, 77}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 73}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 201, 131}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 89}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 50}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 11}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 193}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 55}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 229}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 15, 43}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 46, 137}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 137, 208}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 89}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 154}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 55, 37}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 222}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 87}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 5, 69}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 197, 154}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 69}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 213, 152}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 173}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 10}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 98, 186}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 207, 133}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 251}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 65}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 242, 76}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 65}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 232}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 140}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 133, 165}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 172, 40}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 125, 31}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 100}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 147}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 219, 90}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 29}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 26}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 133}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 114, 189}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 238}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 255}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 136, 73}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 189}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 88}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 0}, 128},
	{{29, 240, 141, 230, 78, 237, 25, 135, 131, 6, 65, 77, 77, 248, 0, 156}, 128},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 161, 11, 239, 218, 128, 113, 227, 158, 29}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 55, 126, 78}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 129, 50, 181, 249, 168, 4, 126}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 216, 68, 171, 30, 163, 116}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 1, 220, 185, 239, 152, 139, 96}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 160, 199, 122, 156, 237}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 51, 100, 40, 222, 211, 181}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 86, 26}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 13, 35, 38}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 217, 99, 217, 48, 168, 64, 154, 76}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 194, 9}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 94, 12, 91, 78, 243, 52, 185, 199}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 240, 235, 162, 36, 235, 141}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 131, 139, 125, 9, 145, 158, 182, 248, 169}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 93, 161, 230}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 15, 250, 6, 120, 242, 1, 157}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 35, 187, 131, 90, 51, 82, 19}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 53, 65, 81, 106, 82, 228, 76, 107}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 19, 135, 41, 43, 8}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 243, 183}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 11, 123, 201}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 177, 38, 21, 114, 33, 114, 125}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 101, 227, 249, 187, 55}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 3, 209, 55, 24}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 44, 63, 35}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 207, 192, 199, 216, 43, 98}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 237, 97, 86, 24, 112, 246, 72, 201}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 181, 41, 124, 201, 229, 39, 146, 6}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 149, 195, 168, 168, 226, 140, 150, 135, 34}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 39, 71, 118}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 28, 133, 221, 89, 243}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 2, 154, 107}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 94, 195, 134}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 138, 219, 176, 101, 101, 57, 137}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 159, 132, 248, 255, 190}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 66, 145}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 226, 24}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 120, 185}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 122, 31, 9}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 182, 244}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 133, 80, 215, 78, 32, 45, 9}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 36, 151, 72, 168}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 181, 16, 90, 229, 227, 142, 137, 197}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 49, 149, 241, 176}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 68, 71, 233, 117, 249, 68, 243, 182, 162}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 93, 15, 163, 254, 205, 184, 36, 115, 77}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 137, 48, 102, 80, 3, 214, 233, 16, 2}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 227, 43, 125, 10, 133, 255, 111}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 78, 123, 82, 171, 177, 105}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 66, 176, 87, 202, 9, 175, 17}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 5, 231, 245, 13, 24, 136, 164}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 43, 192, 222}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 62, 213, 231, 64, 255, 63, 216, 159, 11}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 125, 30, 152, 142, 129, 249}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 163, 133, 137, 149}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 255, 110, 110}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 204, 124, 166, 169, 3, 45, 33}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 102, 113, 145}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 14, 184, 15}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 64, 63, 2, 97, 23, 36, 232, 102}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 185, 192, 203, 36, 148, 129, 234}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 59, 152, 29, 251}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 171, 180}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 143, 213, 218, 53, 13, 127, 25}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 100, 218, 135}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 170, 26, 11, 78, 106, 127}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 51, 41, 245, 221, 24, 162, 223}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 215, 199, 132, 153}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 29, 38, 58, 153, 215}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 141, 248, 167, 143, 132, 210, 87}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 126, 179, 231, 36, 141, 60, 230, 110, 35}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 92, 151, 119, 49, 51}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 253, 95}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 55, 49, 82, 32}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 21, 214, 204, 178, 139, 25, 89, 58, 170}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 81, 81, 251, 204}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 253, 178, 50, 85, 78, 156, 24, 189, 39}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 85, 237, 136, 204, 21}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 0, 0, 0, 0, 0, 21, 196}, 255},
	{{15, 192, 109, 31, 149, 221, 0, 0, 0, 128, 104, 251, 187, 181, 214, 181}, 255},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 21}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 131, 126}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 121, 236}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 3, 190}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 77}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 114}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 138, 118}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 7, 140}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 155, 32}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 11}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 81}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 131}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 41}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 79, 79}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 85, 28}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 18}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 61, 99}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 78}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 22}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 196, 90}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 71}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 163, 33}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 22, 203}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 229, 154}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 126, 119}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 13, 124}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 129, 49}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 243}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 255, 252}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 118}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 171}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 100}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 199}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 161}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 30, 204}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 183, 91}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 124}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 172, 60}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 121, 178}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 87}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 226, 53}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 132}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 58}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 248}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 233, 167}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 168}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 230, 163}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 141, 197}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 36, 135}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 130, 114}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 199}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 20}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 235}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 157}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 89, 51}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 146}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 132, 120}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 58, 148}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 39}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 41, 36}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 23, 208}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 124}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 124, 225}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{80, 185, 170, 71, 41, 58, 158, 106, 253, 7, 2, 184, 173, 0, 0, 0}, 146},
	{{16, 229, 224, 0, 0, 39, 201, 227, 80, 231, 159, 111, 140, 75, 73, 113}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 109, 32, 0, 97, 180, 58, 254, 50, 107}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 91, 136, 141, 56, 107, 81, 228}, 172},
	{{16, 229, 224, 0, 0, 229, 171, 151, 98, 176, 195, 210, 223, 4, 233, 75}, 172},
	{{16, 229, 224, 0, 0, 0, 60, 65, 31, 226, 219, 149, 202, 20, 118, 119}, 172},
	{{16, 229, 224, 0, 20, 99, 192, 31, 246, 215, 24, 152, 60, 74, 6, 19}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 38, 62, 149, 134, 52, 158, 179, 82}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 97, 111, 216}, 172},
	{{16, 229, 224, 0, 0, 0, 60, 21, 47, 31, 169, 188, 78, 66, 105, 176}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 213, 186, 121, 125, 106, 127, 129, 65}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 172},
	{{16, 229, 224, 0, 0, 190, 235, 215, 205, 183, 173, 80, 11, 131, 157, 222}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 129, 181, 66, 44, 92, 233, 194, 200}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 22, 100, 78, 140, 43, 242, 225, 52, 83}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 23, 147, 117, 84, 36, 42}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 172, 218, 122, 21, 134, 86, 102}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 241}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 165, 113, 150, 139, 189, 34, 55, 91, 222}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 136, 78, 14, 200, 143, 75, 114, 146, 56}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 213, 112, 11, 187, 139, 185}, 172},
	{{16, 229, 224, 0, 0, 49, 83, 205, 7, 142, 130, 111, 111, 151, 250, 231}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 65, 57, 14, 29, 159, 9, 165, 85, 180}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 24, 129, 205, 166, 121, 44, 228}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 32, 7, 255}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 236, 215, 182, 196, 251, 161, 213, 162, 79}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 176, 226, 57, 236, 84, 107, 154}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 82, 200, 148, 128, 203, 116, 139, 36, 111}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 14, 156, 1, 79, 240, 159, 71, 122, 10}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 115, 205}, 172},
	{{16, 229, 224, 0, 132, 91, 107, 195, 239, 119, 100, 79, 160, 89, 69, 44}, 172},
	{{16, 229, 224, 0, 0, 106, 46, 139, 58, 226, 128, 102, 162, 130, 28, 60}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 204, 237, 131}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 189}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 136}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 126, 240, 242, 229, 174}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 72, 245}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 79, 48, 85, 76, 192}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 251, 95, 42, 124, 253, 86, 76, 240, 77}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 188, 102, 12, 232, 24}, 172},
	{{16, 229, 224, 0, 0, 245, 104, 149, 107, 198, 181, 12, 95, 77, 53, 160}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 79, 125, 28, 242, 67}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 11, 211, 64}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 125, 55}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 137, 213, 215, 194, 48, 111, 14}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 121, 160, 229}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 133, 141}, 172},
	{{16, 229, 224, 0, 239, 151, 123, 197, 39, 125, 201, 84, 221, 130, 17, 228}, 172},
	{{16, 229, 224, 0, 172, 29, 191, 77, 128, 254, 90, 163, 12, 16, 159, 173}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 54, 153, 169, 192, 190, 60, 98, 166}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 240, 203, 109, 29, 245, 114, 61}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 53, 104, 159, 151, 39}, 172},
	{{16, 229, 224, 0, 0, 138, 157, 172, 251, 209, 69, 27, 199, 106, 57, 235}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 235, 120, 210, 202, 165, 93, 233}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 99, 224, 236, 141, 206, 255, 110, 175, 37}, 172},
	{{16, 229, 224, 0, 0, 244, 18, 218, 158, 155, 47, 204, 19, 110, 101, 96}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 204, 18}, 172},
	{{16, 229, 224, 0, 0, 222, 35, 189, 175, 37, 44, 66, 197, 93, 38, 188}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 112, 78, 107, 129, 173, 236, 21, 35}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 47, 33, 37}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 170, 23, 41, 164, 119}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 145, 68, 132}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 119, 173, 117}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 49}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 251, 200, 213, 144, 137}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 4, 172, 188, 87, 151, 64}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 25}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 39, 156, 243, 132, 1, 53}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 113}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 229, 201, 100, 163, 3, 114, 208, 18}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 164, 36, 154, 3, 173}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 142}, 172},
	{{16, 229, 224, 0, 184, 34, 200, 187, 195, 62, 250, 134, 91, 245, 154, 198}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 2, 251, 54, 122, 12, 110, 160, 226}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 27, 203, 175, 82, 238, 7, 1, 196, 114}, 172},
	{{16, 229, 224, 0, 0, 0, 9, 152, 226, 200, 210, 14, 223, 36, 117, 209}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 165, 155, 239, 244, 89, 193, 105, 54, 164}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 236, 215, 76, 220, 183, 103}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 201, 239, 33, 242, 59, 192, 106, 248}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 170, 71, 116, 15, 229, 172, 214}, 172},
	{{16, 229, 224, 0, 0, 0, 184, 117, 173, 86, 210, 180, 111, 205, 220, 36}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 8}, 172},
	{{16, 229, 224, 0, 110, 0, 54, 22, 69, 161, 136, 104, 209, 234, 118, 248}, 172},
	{{16, 229, 224, 0, 0, 165, 253, 178, 145, 124, 6, 175, 88, 245, 189, 164}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 172},
	{{16, 229, 224, 0, 0, 237, 45, 36, 7, 151, 15, 170, 69, 160, 103, 15}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 229, 105, 62, 215, 93}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 91, 150, 192, 217, 10, 48}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 172, 45, 59, 47, 41, 236, 179, 246}, 172},
	{{16, 229, 224, 0, 0, 0, 0, 0, 0, 0, 0, 86, 238, 253, 148, 174}, 172},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 78, 159}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 96}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 143, 101, 221}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 108, 215, 157, 219}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 24, 193, 21, 235, 157}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 241}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 71, 80, 81, 73, 2, 86}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 66, 16, 134}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 137, 121}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 54, 21, 174}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 16, 122, 155, 62}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 186, 202, 135, 109}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 59, 34, 127}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 89}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 87, 39, 79, 252}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 113, 131, 143, 161}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 45, 255, 90, 251, 12}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 41, 237, 151, 67, 47}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 208}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 47, 135, 140, 129, 1}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 98, 125, 248, 226}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 255}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 168, 199}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 35, 37, 61, 178}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 218}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 119, 184}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 34}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 200, 61, 159, 139, 169, 141}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 149, 87}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 142, 228, 89}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 115, 135, 145}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 121, 146}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 101, 128, 240}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 4, 111, 34, 238, 180, 18}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 216, 123, 95, 119, 247, 185, 100}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 126}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 62}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 189, 166, 156, 171, 123}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 55, 134, 110}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 3, 127, 155, 194, 238}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 240}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 214, 29, 52}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 48, 146, 54, 62, 3, 168}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 12, 44, 236, 39, 151}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 140, 201, 116, 186, 109, 161}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 64, 146, 78, 37, 76}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 147, 1, 243, 173, 187, 40}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 5, 130}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 211, 136, 47, 45, 176, 202, 74}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 253, 118, 118, 74, 185, 98}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 238, 175, 34, 132, 42, 47}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 227, 163, 210, 12, 131}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 144}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 186, 140}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 89, 45, 235, 138, 187}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 203}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 139, 0, 58, 170, 248, 95}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 172, 226, 211, 185}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 122, 70}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 58, 111, 100, 118, 139}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 174, 28, 153}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 234, 77, 176}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 69, 3, 227, 68}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 105, 124, 78, 133, 62}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 146}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 169, 97}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 117, 133}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 146, 41}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 196, 122}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 157, 199, 161, 53, 25, 137}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 168, 135, 211}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 50, 59}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 15}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 160}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 181, 87, 201, 241, 163}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 182, 61, 185, 205, 133, 67}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 33, 130, 77, 77, 10}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 228}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 122, 118, 95, 66, 180}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 229, 172, 106, 107, 247, 82}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 5, 239, 189, 98}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 161, 189, 75, 247}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 131, 39, 1, 77}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 192, 75, 226}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 0, 0, 0}, 116},
	{{169, 2, 153, 9, 169, 203, 245, 154, 184, 0, 0, 0, 0, 141, 77, 40}, 116},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 126, 151, 166, 98, 84}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 81}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 122, 251, 223, 151, 184}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 182, 178, 254, 83, 217, 16}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 95, 210}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 23, 93, 95}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 167, 62, 205, 211}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 100, 180, 53, 219, 0}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 23, 178, 98, 137, 25, 79}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 125, 57, 87, 31, 75, 202}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 201, 188, 138}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 109, 147, 105, 232, 151}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 223, 5, 19, 89, 6, 249, 240}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 100, 31, 30, 180, 250, 22}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 49}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 41, 132, 223, 165, 244, 29}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 146, 14, 195, 115, 7, 203}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 20}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 107}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 133}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 56, 62, 255, 82, 11, 187}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 157, 7, 108, 101, 3, 181}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 209}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 241, 79}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 168, 86, 24, 21}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 107, 178, 221, 33, 48, 159}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 116}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 182, 213, 94, 52, 6, 112}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 79, 15, 3}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 184, 210, 168}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 175}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 134, 2, 138, 222}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 158, 173, 38}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 77}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 236, 25, 11, 101, 43, 236}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 8}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 8, 160, 140, 171}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 249, 29, 44, 15}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 99, 229, 173}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 199, 168}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 216}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 69, 160, 220, 120, 14, 250, 203}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 37, 215, 185, 79, 62, 132}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 3, 203, 20, 159, 91, 6}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 183, 98, 183}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 174, 136, 137}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 127, 28, 102}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 248}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 86, 76, 93, 181, 104}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 188, 70, 195, 28, 15, 126, 252}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 113, 115, 192, 198, 219, 207}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 163, 24, 247, 181, 9, 72}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 15, 156}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 239, 65, 170, 181, 213, 79, 78}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 112, 154, 254, 233}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 154, 54, 18, 127, 185, 86, 11}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 245, 1}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 219}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 119, 85, 200, 65, 0, 107, 151}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 157, 232, 13, 163, 168, 212, 234}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 41, 185, 118}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 191, 237, 145}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 178, 136}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 25, 169}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 177, 113, 196}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 92}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 34, 81, 86, 46, 233}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 154, 54, 206, 210, 159}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 54, 254, 183}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 246, 46, 252, 242, 80}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 211, 96, 141, 59}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 22, 216, 229, 96, 204, 35, 34}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 134, 172, 162, 141, 8}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 253, 71, 53, 181, 9, 185, 197}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 117, 48}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 11, 134, 108}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 53}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 237, 52, 233, 233, 48}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 114}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 76, 123, 89, 11, 172}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 230, 230, 205, 158, 98, 34, 84}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 103, 119, 198, 246}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 190}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 91, 132, 250, 244, 213}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 194, 106, 254, 204, 207}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 151, 21}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 48}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 0, 0, 0, 0, 0, 132}, 189},
	{{144, 135, 239, 164, 142, 187, 64, 109, 0, 0, 78, 151, 129, 145, 211, 248}, 189},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 191, 49, 13}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 80}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 67, 2, 103, 162, 157, 37}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 96, 56}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 209, 143, 251, 19, 164, 186}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 155}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 152, 230, 223}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 228, 26, 184, 65, 133}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 222, 244, 61}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 254, 199, 223, 127, 244, 159}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 29, 133}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 219, 227}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 169, 208, 8, 102}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 9, 170, 43, 21, 46, 95}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 126, 135}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 228, 31, 137, 96, 154}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 234, 108, 135, 13, 216}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 88, 222, 132, 164, 160}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 178, 17, 81, 43}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 211, 229, 232, 57}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 203, 23, 112}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 213, 135, 71, 132}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 47, 66, 146}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 166, 12, 60}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 200, 210, 186, 121, 69, 89}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 177, 82, 238}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 196, 226, 104, 79, 30}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 130, 103, 229}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 165}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 101, 113, 137}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 24}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 28, 157, 239, 119, 79, 128}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 7}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 184, 106, 10}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 248, 8, 30}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 61, 65, 29, 88}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 25, 75, 3, 36, 137}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 241, 160, 226, 134, 68}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 92, 90, 240, 185, 56, 206, 200}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 196, 237, 82, 105, 147}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 91, 111, 83}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 17, 201, 223}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 118}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 59, 7, 84}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 54}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 215, 13}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 134, 53, 181, 237, 166}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 200, 4, 125, 69, 220, 75}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 191, 86, 118, 220, 255}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 18, 40, 128, 36}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 111, 133, 203}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 232, 142, 117, 18, 176, 230}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 132, 109}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 16, 162, 48, 78, 96}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 146, 197, 223, 237}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 151, 34, 178}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 45}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 109, 251, 180, 127, 240, 223}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 27}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 92, 246}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 207, 13, 46, 77, 81, 146}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 110, 19, 29, 240, 184, 32}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 135, 43}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 95, 240, 144, 103}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 64, 130, 137, 116}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 19, 2, 51, 157, 168, 37}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 169, 27, 176, 231, 199}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 28, 183, 195, 93, 103}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 210}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 45, 57, 169, 136, 32, 80}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 63}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 193, 101, 71}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 223, 139}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 176, 109}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 0}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 251, 95, 172, 49, 115, 15}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 65, 150, 65}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 235, 165}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 197}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 108, 95}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 150, 35, 204, 216, 45, 243, 212}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 0, 35}, 10},
	{{170, 78, 252, 227, 242, 199, 130, 251, 200, 0, 0, 0, 0, 0, 129, 13}, 10},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 96, 41}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 97, 187, 78}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 9}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 145}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 17}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 204, 93, 43}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 87}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 103}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 201}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 114, 122}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 63, 6}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 170, 136}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 10}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 138, 195}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 177, 205, 104}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 34}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 7}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 155}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 240}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 135}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 139, 72, 165}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 206}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 225, 20}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 169, 114, 29}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 134, 3}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 240, 45, 140}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 88}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 68, 94}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 45}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 142, 143, 158}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 13, 80}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 249, 238}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 96, 90}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 133, 112}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 153, 99, 141}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 63, 223}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 33}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 161, 237}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 111}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 38, 60}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 132}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 133, 70}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 255, 17}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 29, 173, 210}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 84}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 67, 34}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 215, 98, 120}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 163, 13, 110}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 67, 69}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 220, 97}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 235}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 75, 226}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 156, 20}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 80, 152}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 250}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 3, 45, 220}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 205}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 212}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 210, 146, 84}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 252, 203}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 37, 5}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 50}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 228}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 102, 210}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 132, 117}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 29, 75}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 0, 0}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 73, 138}, 184},
	{{232, 18, 15, 126, 166, 126, 58, 25, 209, 62, 76, 79, 0, 0, 103, 22}, 184},
	{{170, 82, 72, 53, 128, 0, 0, 0, 45, 80, 100, 94, 160, 188, 120, 119}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 118, 22, 190, 45, 123, 118, 42, 24, 110}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 1, 173, 222, 59, 113, 208}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 225, 42, 207, 173, 38, 12, 242, 233}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 146}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 219, 137, 41, 108, 157, 195, 35}, 98},
	{{170, 82, 72, 53, 128, 0, 103, 59, 105, 121, 121, 159, 196, 94, 69, 210}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 81, 183, 120, 76, 226, 162, 193}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 82, 151, 204, 147, 192, 166, 10, 52}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 98, 212, 204, 92, 93, 112, 126, 42}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 119, 180, 178, 125, 200, 1, 235, 96, 169}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 33, 218, 97, 17, 192, 173, 252}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 69}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 92, 135, 169, 233, 32, 80, 170, 57}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 81, 113, 233, 142, 236, 205, 144}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 8, 218, 200, 229, 205, 191}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 174, 38, 80, 35, 54, 185}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 124, 68, 211, 56, 231, 222, 71, 237, 99}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 158, 28, 77, 122, 181}, 98},
	{{170, 82, 72, 53, 128, 64, 209, 32, 123, 212, 148, 249, 113, 180, 63, 102}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 116, 70, 229, 189, 3, 19, 1}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 144, 98, 58, 3, 142, 187, 100}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 101, 154, 85, 87, 131, 135}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 46, 127, 181, 17, 128}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{170, 82, 72, 53, 128, 134, 28, 236, 202, 215, 151, 3, 188, 82, 70, 38}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 130, 180, 175, 244, 77, 122, 164}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 245, 202, 39, 244, 124, 179, 143, 44, 217}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 174, 255, 199}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 105, 180, 229, 20, 232, 121, 226, 115, 46}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 107, 9, 207, 212}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 155, 131, 197, 175, 27, 159, 139, 22, 150}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 21, 140, 15, 200, 230, 40}, 98},
	{{170, 82, 72, 53, 128, 30, 140, 114, 40, 65, 172, 145, 122, 44, 104, 12}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 57, 100, 40, 86, 163, 226, 35}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 215, 190, 159, 96, 54, 129, 79}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 11, 197, 197, 150, 28, 134}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 98, 72, 150}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 164, 145, 59}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 43, 60, 78, 9, 3, 238, 56, 57}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 126, 0, 254, 25, 45}, 98},
	{{170, 82, 72, 53, 128, 73, 192, 239, 58, 74, 156, 212, 173, 115, 229, 184}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 115}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 80, 112, 137, 152, 91, 188, 59, 172}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 213, 156, 168}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 242, 44, 183, 254, 106, 157}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158}, 98},
	{{170, 82, 72, 53, 128, 0, 136, 171, 71, 24, 118, 49, 188, 63, 60, 207}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 253, 82, 227, 22, 117, 136, 241, 142}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 98, 211, 159}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 10}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 116, 35, 67, 4, 112, 61, 245}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 143, 121, 100, 246, 106}, 98},
	{{170, 82, 72, 53, 128, 123, 146, 16, 80, 185, 252, 86, 35, 170, 173, 205}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 68, 254, 168, 107, 191, 17}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 207, 61, 138}, 98},
	{{170, 82, 72, 53, 128, 239, 125, 102, 231, 143, 49, 70, 205, 84, 100, 111}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 174, 96, 198, 55}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 180, 240, 99, 111}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 207, 104, 212, 250, 6, 20, 238}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149, 194}, 98},
	{{170, 82, 72, 53, 128, 29, 5, 68, 89, 146, 78, 244, 45, 113, 118, 110}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 169}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 217, 212, 165}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 160}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 36, 239, 0, 66, 14, 244, 137, 203}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 48, 245, 99, 51, 110, 87, 99}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 5, 78, 66, 19}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 115, 186, 5, 212, 120, 10, 142}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 96}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 16, 219, 52, 189, 95}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 39}, 98},
	{{170, 82, 72, 53, 128, 0, 50, 193, 13, 178, 254, 134, 96, 215, 209, 225}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 160, 135, 24, 179, 244, 94}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 160, 249, 207, 175}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 115, 132, 85, 2, 70, 148, 101, 141}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 214, 193, 63}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 216, 158, 139}, 98},
	{{170, 82, 72, 53, 128, 0, 155, 27, 137, 169, 81, 0, 91, 109, 181, 107}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 0, 0, 0, 0, 117, 176, 230}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 112, 35, 203, 144, 57, 86, 58, 118}, 98},
	{{170, 82, 72, 53, 128, 0, 0, 0, 0, 215, 26, 33, 61, 147, 235, 195}, 98},
	{{170, 82, 72, 53, 128, 19, 249, 232, 159, 179, 48, 237, 49, 188, 51, 36}, 98},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 182, 158, 99, 143, 183}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 133, 183, 11, 1}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 118, 67, 8, 129, 108, 108, 41, 97, 155}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 36, 181, 241, 118}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 25, 131, 61}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 58, 230, 150, 26, 44, 196, 70, 167, 13}, 37},
	{{152, 100, 37, 122, 242, 64, 228, 99, 197, 73, 135, 169, 69, 27, 130, 70}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 233, 134, 48, 190, 95, 76, 175, 69}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 133, 204, 209, 90, 219, 245, 55, 161}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 231, 23, 156, 173, 141}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 166, 210, 70, 213, 155, 39, 113}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 185, 210, 45, 196, 251, 255}, 37},
	{{152, 100, 37, 122, 242, 64, 14, 44, 102, 19, 26, 13, 182, 165, 25, 201}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 7, 66, 192}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 89, 243, 78, 34}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 119, 28, 39, 113, 73}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 204, 154, 172, 221, 151, 237, 186, 76, 183}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 29, 118}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 53, 26, 107, 129}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 55, 119, 82, 209, 9, 233}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 189, 29, 145, 150, 243}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 226, 64, 202, 246, 185, 9, 50, 86, 63}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 184, 247, 251, 176, 30, 80, 236}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 91, 133, 0, 203, 62, 115, 66}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 122, 73, 26, 134, 143, 222}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 156, 131, 70, 224, 145, 59}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 146, 176, 31, 2, 7, 30}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 48, 119, 35}, 37},
	{{152, 100, 37, 122, 242, 64, 54, 19, 196, 66, 132, 171, 229, 103, 53, 218}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 31, 240, 75, 224, 33, 69, 47, 209, 28}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 182, 104, 254, 93, 102, 238, 201}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 125, 20, 114, 106, 233, 203, 227, 216}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 16, 102, 233, 235, 199, 167, 73, 4, 106}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 86, 151, 36, 127, 150, 184, 163, 205, 8}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 35, 152, 175, 169, 230, 252}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 161, 107}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 197, 180, 11, 174, 252, 103, 93}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 168, 117, 27}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 11, 24, 118, 28}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 231, 65}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 198, 182}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 29, 31, 228, 193}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 227, 98, 226, 96, 110, 89}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 115, 217, 2, 50, 175, 178, 235, 63}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 125, 169, 166, 249, 164, 158, 118, 119, 218}, 37},
	{{152, 100, 37, 122, 242, 64, 214, 129, 60, 27, 138, 202, 116, 1, 72, 161}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 205, 216, 173, 237, 24, 9}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 139, 194, 84}, 37},
	{{152, 100, 37, 122, 242, 64, 40, 59, 243, 190, 67, 239, 178, 92, 98, 111}, 37},
	{{152, 100, 37, 122, 242, 64, 197, 214, 194, 210, 1, 63, 210, 2, 48, 102}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 141, 190, 248, 184, 161, 241, 210, 88}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 136, 44, 108, 34, 230, 26, 254, 228, 157}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 1, 9}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 33, 142, 167, 165, 157}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 105, 244, 255, 9, 29, 152, 45, 49, 156}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 242, 90}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 33, 88, 99, 167, 133, 28, 180, 34, 122}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 73, 253, 16, 239, 48, 241, 65, 196, 242}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 18, 126, 10, 237, 22, 29}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 123, 8, 21, 207, 89, 14, 56}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 204, 47, 34, 21, 127, 238, 74, 238, 59}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 23, 207, 63, 48, 35, 147, 112}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 148, 127, 75, 229, 199, 4, 59}, 37},
	{{152, 100, 37, 122, 242, 64, 24, 244, 4, 236, 10, 47, 48, 81, 179, 160}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 252, 254, 55, 13, 178, 63}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 246, 209, 234, 104, 103, 100, 109, 150, 177}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 82, 111, 123, 85}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 166, 109, 49}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 46, 54}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 63, 163, 252, 10, 80, 206, 13}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 124, 29, 18, 217, 48, 61, 154, 20}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 44, 50, 45, 110, 40, 222, 180, 6, 165}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 109, 58, 249, 218}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 196, 203, 234, 60}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 1, 44, 16}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 215, 53, 93, 45, 181, 123, 107, 82, 88}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 138, 159, 52}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 182, 242, 33, 90, 169, 17, 4, 151}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 196, 37, 116, 92, 6, 102, 92, 162, 176}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 173, 8, 211}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 200, 182, 27, 167, 212}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 109, 42, 3, 93, 46, 56, 98, 232}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 229, 194, 251, 52, 233, 175, 79, 155, 116}, 37},
	{{152, 100, 37, 122, 242, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 37},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 165, 70}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 131, 86, 2, 218, 138, 78, 32, 152}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 204, 192, 159}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 116, 208}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 146, 134, 202, 238, 12, 139, 119}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 94, 116, 215, 176, 219, 241, 219, 243}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 157, 242, 182, 190, 82, 116}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 227, 207, 186, 227, 79, 212, 122, 10, 108}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 118, 79}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 85, 89, 90, 58, 253, 240, 213}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 220, 224, 130, 5, 141, 37}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 48, 60, 91, 2}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 245, 95, 39, 16, 87}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 15, 232, 58, 128, 58, 127, 4}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 85, 159, 250, 210}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 139, 230, 222, 114}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 138, 179, 232, 211, 35}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 75, 57, 106, 92, 243, 242}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 234, 160, 97, 184, 15, 126, 202}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 13, 190, 14}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 180, 77, 197, 141, 0, 54, 136}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 238, 198, 130, 99, 73}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 59, 141, 125, 48, 107, 180, 220, 169, 123}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 148, 189, 35, 210, 218, 169}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 23, 139, 241, 27, 69, 226}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 74, 97, 153, 56, 64, 172, 142, 197, 188}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 212, 29, 33, 102, 174, 56, 132, 83, 107}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 186, 235, 203, 214}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 178, 68, 44, 167}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 61, 213, 123, 143, 22, 178}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 151, 59, 186, 199}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 22, 67, 195, 54, 211, 31, 171, 84, 133}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 210, 176, 208}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 159, 146, 116, 224, 118}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 105, 192, 230, 158, 60, 4, 134, 119, 214}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 174},
	{{174, 231, 230, 33, 71, 224, 99, 140, 216, 82, 150, 99, 111, 69, 87, 159}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 26, 192}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 248, 172, 151, 4, 223}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 221, 233}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 89, 51, 242}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 245, 193, 213, 248, 191, 84, 45}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 174, 18, 25, 4}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 11, 13, 45, 10}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 122, 149, 144, 169}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 196, 224, 63}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 15, 247, 247, 220, 229, 150, 102, 139}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 173, 227, 219, 148, 2, 204, 141, 160, 122}, 174},
	{{174, 231, 230, 33, 71, 224, 148, 78, 136, 122, 217, 147, 193, 201, 156, 212}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 13, 41}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 125, 175, 12, 172}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 24, 96, 7, 230, 55, 245, 69}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 14, 181, 125}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 101, 107, 184, 155, 156, 152}, 174},
	{{174, 231, 230, 33, 71, 224, 82, 155, 229, 223, 252, 55, 2, 208, 106, 45}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 83, 53, 68}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 120, 35, 223, 240}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 25, 75}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 145, 199, 20, 159, 96, 202, 242, 18, 81}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 241, 124, 215, 149}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 207, 222, 52, 135, 62, 87, 159, 120}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 97, 173, 244, 121, 49, 131, 185}, 174},
	{{174, 231, 230, 33, 71, 224, 240, 90, 124, 27, 215, 225, 114, 227, 104, 171}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 138, 4, 44, 135, 137}, 174},
	{{174, 231, 230, 33, 71, 224, 230, 86, 190, 60, 191, 79, 130, 188, 238, 168}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 174, 160}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 215, 9, 5, 178, 44, 114, 208}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 139, 161}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 240, 161, 131, 113, 175}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 4, 108, 8}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 240, 184, 8, 8, 50, 78}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 235, 109, 165, 48, 232, 37}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 90, 4, 234, 169, 78, 110, 58}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 104, 126, 87, 151, 233, 80, 71, 13}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 246, 75, 17, 110, 19, 69, 3}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 0, 105, 223, 12, 83, 24, 107}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 0, 0, 12, 207, 59, 155, 213, 56, 112}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 130, 89, 158, 158, 81, 237, 222, 61, 67}, 174},
	{{174, 231, 230, 33, 71, 224, 0, 234, 130, 158, 35, 232, 6, 90, 170, 167}, 174},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 187, 3, 41, 46}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 255, 238, 254}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 173, 159, 193, 132, 67}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 112, 150, 226, 14, 83}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 21, 93, 57, 185, 60, 158}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 101, 1, 151, 250}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 187, 244, 25, 130, 157}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 36}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 172, 134, 29, 128}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 61, 171, 155, 117, 40, 218}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 191, 31}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 195, 175, 62, 133}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 63, 203, 160, 112, 172, 175}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 44}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 124, 105}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 90, 70, 229, 207, 4, 30, 181}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 140, 179}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 141, 171, 163, 12, 232}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 6, 168, 99, 92}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 144, 146, 1, 205, 88, 173}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 129, 85, 102, 68}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 52}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 29, 221, 135}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 208, 18, 182, 254, 99, 79, 101}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 34, 145, 36, 173, 248, 143, 80}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 14, 233, 10, 88, 187}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 226, 3, 27, 46, 101}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 130, 209}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 82, 21}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 234, 153}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 94, 188, 192, 142, 251}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 152, 178, 4, 32, 41}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 132, 149, 216, 247}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 89, 212}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 228, 176, 76, 238, 250, 83}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 122, 220, 65, 253}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 77}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 7, 57, 52, 136, 107, 36}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 45}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 251, 169, 107}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 251, 168, 206, 174}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 193, 102, 98, 191}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 63, 214, 179, 209, 255}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 156, 53, 213, 13, 192, 177, 204}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 208, 246, 236, 127, 137, 206, 14}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 99, 192, 224, 135, 5, 161, 152}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 120, 174, 227}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 33, 13, 159}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 127}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 56}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 188}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 58, 45, 160, 96, 116}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 233, 196, 36, 111, 107, 105}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 216, 255, 224, 245, 161, 210}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 155, 210}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 231}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 112, 75, 17, 244, 171}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 3}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 73, 131}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 142, 144, 185, 225, 220, 103}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 106, 213, 255}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 31, 132, 23, 3}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 129, 66, 130, 97}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 241, 165, 7}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 247}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 109, 232, 150, 51}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 87}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 184, 94, 106, 208}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 158, 64, 180, 84, 62, 247}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 248, 69, 35}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 136, 121, 26, 246, 246, 190}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 11, 51, 171, 196, 246, 153}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 247}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 107, 126, 196, 110, 63, 194, 191}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 65, 148, 138, 12}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 236, 227, 195, 82}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 123, 229, 65, 124, 207, 37}, 251},
	{{74, 225, 252, 153, 202, 8, 162, 39, 64, 0, 0, 206, 101, 175, 199, 112}, 251},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 136, 218, 209, 90, 159}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 191, 75, 151, 179, 104, 133, 80, 0, 146}, 115},
	{{167, 186, 101, 187, 122, 0, 164, 141, 30, 251, 140, 161, 26, 215, 70, 194}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 129, 40, 86}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 32, 17, 233, 17}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 127, 40, 96, 72, 184, 121, 129, 108}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 46, 195, 33, 160, 180, 234, 145, 167, 151}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 27, 42, 243, 20}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 229, 111, 222}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 190, 38, 112, 98, 162, 220}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 52}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 169, 89, 49, 159, 31}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 128, 193, 140, 238, 182, 70, 222}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 105, 121, 133, 171, 74, 219, 123}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 124, 11, 19, 118, 200}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 197, 160, 211, 43}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 37, 179, 166}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 10, 148, 222, 223, 138, 151}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 75, 157, 120, 124}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 238, 202, 86, 191, 173, 109, 93}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 26, 198, 128}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 3, 104, 77, 163}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 236, 162, 248, 201, 198, 12}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 138, 35, 51, 57, 63, 85}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 101, 33, 100, 43, 120, 251}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 223, 251, 13, 164, 29, 64, 192, 87}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 94, 182, 202}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 20, 149, 216, 195, 53}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 208, 7, 211, 110}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 45, 181, 241}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 86, 75, 182, 36, 67, 204, 223, 88}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 138, 225, 117, 188, 135, 42}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 194}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 115, 215, 197, 74}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 249, 244, 59, 194, 52, 94, 253, 19}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 92}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 138, 192, 131, 18}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 227, 165, 135, 3, 0}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 32}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 175, 89, 210, 48, 190}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 71, 23}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 26, 201, 0, 10}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 219}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 96, 168, 240, 184, 237, 97, 196, 41, 4}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 124, 217, 211, 201, 13, 138, 193}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 210, 47, 44, 239}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 42, 239, 204, 90, 32, 81}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 73, 117, 24, 212, 120, 97}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 239, 27, 95, 45}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 203, 200, 226, 38, 103, 222, 204}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 222}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 88, 237, 50, 172, 11, 129, 156, 146, 223}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 249, 98, 188, 173, 231, 188, 29, 167, 113}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 157, 148, 50}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 194}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 27, 100, 15}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 235, 3, 186, 217}, 115},
	{{167, 186, 101, 187, 122, 0, 87, 225, 104, 30, 165, 133, 19, 173, 62, 68}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 2, 251, 255, 232, 48, 248, 128}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 197, 23, 232, 19}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 163, 168, 145}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 219, 237, 213, 187, 201, 249, 34, 215}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 214, 54, 16}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 154, 69, 114, 24, 117, 26}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 30}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 164, 241, 12}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 78, 254, 153, 80}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 167, 212, 77, 187, 160, 159, 114, 152}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 111, 49, 120, 94, 31, 232}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 224, 41, 21, 179}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 201, 25, 139, 214, 136, 248, 236, 127}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 1}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 40}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 54, 93, 167, 79, 22, 65, 249, 239}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 204, 52, 117, 165, 110}, 115},
	{{167, 186, 101, 187, 122, 0, 195, 49, 139, 50, 177, 104, 224, 92, 48, 150}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 79, 58, 244, 76, 31, 6, 57, 25}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 250, 9, 82, 38, 115}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 233, 57, 55, 73, 245, 178, 153, 248}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 214, 176, 136, 3, 228, 4, 63, 107}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 134, 6, 26, 231, 92, 107}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 144, 233, 59, 151, 221}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 82, 79, 42, 100}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 91}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 207, 146, 125, 43, 53, 105, 242}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 0, 0, 0, 0, 0, 0, 243, 178, 203}, 115},
	{{167, 186, 101, 187, 122, 0, 0, 232, 165, 247, 108, 97, 241, 216, 217, 24}, 115},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 100}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 124}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 233}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 20, 65}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 151}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 49, 93}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 113}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 41}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 39}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 226}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 182}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 178, 228}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 139, 76}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 136}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 15, 211}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 150}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 191}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 192}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 167}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 227, 137}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 247}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 38, 31}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 30, 204}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 61}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 177}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 79}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 90}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 91, 89}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 172}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 151}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 161}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 174}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 69}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 185}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 106, 72}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 38, 245}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 112}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 175}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 172, 213}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 155, 42}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 76}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 118}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 201, 25}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 13, 227}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 95, 130}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 84}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 196}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 0}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 231, 249}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 74, 219}, 252},
	{{83, 7, 21, 122, 243, 67, 171, 146, 145, 160, 168, 103, 223, 64, 0, 83}, 252},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 251, 219, 251, 105}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 237, 54, 3, 120, 19}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 48, 38, 138, 41, 116, 104, 120, 204, 127}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 24, 91, 241, 246, 5, 72, 84, 219}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 120, 157, 9, 244, 195, 198}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 105, 136, 62, 255, 82, 33, 109, 26, 191}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 147, 9, 10}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 242}, 176},
	{{83, 132, 219, 86, 86, 0, 139, 218, 245, 124, 24, 115, 237, 246, 236, 116}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 208, 16, 193}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 80, 62, 54, 248, 248, 165, 145, 72}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 229}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 163, 29, 199}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 204, 247, 203, 77, 30}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 234, 104, 82, 174, 116, 106, 202, 211}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 21}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 28, 52, 126}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 231, 32, 151, 0, 90, 55, 132, 28}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 103, 90, 13, 148, 166}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 164, 59, 72, 40, 181, 38}, 176},
	{{83, 132, 219, 86, 86, 0, 161, 240, 1, 122, 45, 174, 70, 193, 191, 237}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 85}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 139, 116, 129}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 41, 223, 74, 188}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{83, 132, 219, 86, 86, 0, 10, 71, 157, 117, 214, 19, 15, 89, 90, 183}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 51, 240, 242, 203, 3, 253, 186, 146}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 148, 158, 114, 59, 66}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 219, 63, 151, 216, 102}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 255, 226, 208, 134, 17, 193, 102}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 123, 60, 101, 212, 81, 120, 78, 174}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 209, 93, 106, 127, 31, 119, 217}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 193, 161, 249, 166, 183}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 96, 122, 31, 154, 240, 114, 148, 183}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 115, 191, 176}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 112, 208, 147, 161, 76, 12}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 180, 164, 117, 75, 245, 89}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 193, 38, 195, 229, 93, 110, 208, 171}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 97, 0, 25, 42, 147, 60, 136, 234}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 237, 35, 236, 165, 230, 10, 207, 29}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 87, 66, 234, 107, 5, 156, 46, 133, 248}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 46, 121, 126}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 158, 127, 177, 117, 197}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 75, 68, 89, 162, 64, 228, 162, 123}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 110, 217, 233, 208, 208, 235, 231}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 41, 0, 91, 99, 24, 111, 57, 230}, 176},
	{{83, 132, 219, 86, 86, 0, 187, 57, 244, 255, 22, 63, 195, 219, 186, 223}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 240, 140, 159, 208, 254}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 121, 103, 46, 219, 212, 125, 226, 188, 28}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 95, 123, 191, 52, 250, 187}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 153, 200, 30, 154, 31, 48}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 109}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 179, 114, 248, 36, 172, 71}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 35, 149, 72, 125, 108, 78, 20, 212, 189}, 176},
	{{83, 132, 219, 86, 86, 0, 65, 208, 146, 166, 40, 80, 194, 11, 247, 197}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 8}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 11, 156, 172, 131, 8, 50}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 200, 159, 130, 253, 111, 30, 104, 234, 127}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 230, 212, 69, 42, 199, 211}, 176},
	{{83, 132, 219, 86, 86, 0, 100, 69, 175, 226, 82, 215, 183, 18, 24, 223}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 230, 16, 126, 158, 240}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 187, 125, 254, 174, 136, 111, 193, 78}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 22, 19, 210}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 88, 116, 178, 1, 99, 219, 68, 231, 205}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 36, 160, 150, 176, 225, 105, 138, 54}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 35, 178, 100, 119, 66, 30, 109, 56}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 6, 178, 10, 206}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 84, 178, 30, 59, 251}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 6, 101, 112, 151, 138, 125}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 165, 251, 20, 186}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 74}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 210, 136, 1, 87}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 242, 192, 166, 14, 31}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 229, 81, 137, 162, 181}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 193, 156, 122, 135, 253, 29, 188, 11}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10}, 176},
	{{83, 132, 219, 86, 86, 0, 143, 84, 86, 119, 190, 6, 249, 118, 27, 201}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 216, 233, 69, 82, 171, 15, 119, 243, 81}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 87}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 217, 16, 216, 238, 117, 88}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 199, 131, 192}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 237, 56, 6, 72, 123, 29, 214, 63}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 176},
	{{83, 132, 219, 86, 86, 0, 0, 0, 0, 0, 59, 43, 59, 48, 75, 20}, 176},
	{{83, 132, 219, 86, 86, 0, 58, 2, 110, 176, 251, 131, 49, 202, 245, 235}, 176},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 51, 231}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 237, 154, 241, 57}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 101, 37, 13}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 198}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 57, 50, 211}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 182, 77, 103}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 235, 70, 139}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 188, 238, 191}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 111, 221, 98}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 107, 160, 35}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 253}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 64}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 162, 246}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 225, 235, 16}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 189, 17}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 33}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 138, 96, 85}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 41}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 116}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 253, 15}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 149}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 78, 149, 138, 193}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 94, 172, 41, 199}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 160, 80, 201}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 213}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 248, 120, 76}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 227, 22, 45, 134}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 218}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 63, 40, 230, 165}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 56, 49, 137, 148}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 190, 80, 231}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 167, 128, 111, 117}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 131, 187, 23, 140}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 237, 232}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 114, 189}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 27, 154}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 116}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 154, 255, 211}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 127, 81}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 56, 154}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 109, 156}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 32, 208, 251, 221}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 122, 62, 134}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 28, 32}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 210}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 31, 221, 123}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 76, 228, 86}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 206}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 124, 214, 5}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 181, 44, 70}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 195, 77, 143}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 92}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 244}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 213}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 92, 140}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 153}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 190, 10, 70, 230}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 232, 151}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 143, 103}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 106, 219, 195, 104}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 209}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 171}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 193, 37, 62, 49}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 11, 248}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 13, 83}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 44, 174, 224, 57}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 12, 158, 102}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 155}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 79, 181, 170, 208}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 155, 246}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 117}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 197}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 229, 85}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{22, 113, 72, 102, 73, 16, 236, 57, 197, 122, 31, 0, 0, 0, 0, 0}, 155},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{250, 59, 64, 35, 72, 112, 159, 85, 200, 5, 193, 39, 152, 185, 148, 16}, 36},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 33, 15}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 127, 110, 187}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 75, 35, 1, 97}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 244, 111, 48}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 21, 0, 25, 46}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 220, 73}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 123, 61}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 248, 12, 145}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 131}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 95, 228}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 27, 21, 213}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 154, 227}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 249, 125}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 123, 204, 43}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 186}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 193, 117}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 180, 180, 83, 46}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 177, 14, 134}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 19}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 246}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 13}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 40}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 221, 228, 59}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 113, 119}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 219, 199, 197, 249}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 2, 231, 165, 135}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 193, 141, 8, 112}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 54}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 161, 70, 35}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 60, 117, 56, 205}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 129}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 62}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 84, 27, 189, 183}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 247}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 116}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 110}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 1}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 121, 119}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 53, 222, 39}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 171}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 121, 143, 246, 159}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 132, 132, 56}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 254, 165, 51}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 170, 130, 225, 103}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 105, 127, 121}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 4, 170}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 141}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 201, 208, 163, 128}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 68, 78, 88}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 237, 33, 222, 179}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 194, 225, 40}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 111}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 218, 251, 144}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 254, 170, 6}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 180}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 113, 4}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 95, 124}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 234, 142, 108, 236}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 225, 170, 175, 197}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 148, 193}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 196}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 224, 84, 222, 128}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 246}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 217}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 28, 129, 182}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 148, 221}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 198, 219, 60, 152}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 172, 106}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 74, 134, 180}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 163}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 201, 30, 232, 173}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 97}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 122}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 252, 196, 194}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 86, 107, 247}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 0}, 202},
	{{220, 21, 48, 164, 224, 121, 17, 69, 10, 118, 106, 0, 0, 0, 0, 232}, 202},
	{{160, 0, 0, 0, 6, 76, 64, 56, 25, 49, 182, 166, 114, 130, 34, 73}, 208},
	{{160, 0, 0, 0, 0, 1, 121, 240, 63, 124, 55, 131, 201, 204, 91, 244}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 147, 40, 252, 108, 109, 105, 179}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 30, 64, 16, 124, 194, 62, 51}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 208},
	{{160, 220, 175, 102, 229, 73, 47, 159, 44, 200, 39, 238, 255, 66, 145, 181}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 245, 3, 193}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 208},
	{{160, 0, 48, 207, 183, 23, 85, 79, 255, 39, 65, 175, 75, 184, 95, 168}, 208},
	{{160, 0, 0, 0, 0, 185, 158, 129, 60, 248, 126, 22, 136, 19, 116, 70}, 208},
	{{160, 0, 0, 0, 0, 103, 206, 43, 100, 130, 210, 90, 94, 13, 248, 97}, 208},
	{{160, 0, 0, 0, 148, 85, 44, 138, 166, 16, 122, 104, 117, 82, 97, 79}, 208},
	{{160, 0, 34, 21, 133, 221, 133, 111, 90, 45, 254, 238, 171, 52, 219, 219}, 208},
	{{160, 0, 0, 191, 118, 75, 238, 135, 106, 36, 105, 19, 206, 242, 222, 33}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 144, 74, 14, 52}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 52, 175, 201, 37, 14, 64, 148, 215}, 208},
	{{160, 0, 0, 10, 140, 133, 230, 61, 210, 127, 165, 92, 90, 50, 166, 248}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 8, 16}, 208},
	{{160, 0, 0, 0, 0, 0, 244, 179, 63, 100, 131, 19, 122, 127, 150, 146}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 29, 204, 124, 142}, 208},
	{{160, 0, 0, 0, 81, 236, 217, 230, 247, 20, 32, 121, 252, 155, 192, 233}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 127, 147, 110, 230}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 235, 217, 47, 165, 143, 144, 14, 72, 129}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 240, 200}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 244, 121, 143, 63, 16, 19, 252}, 208},
	{{160, 0, 0, 0, 0, 0, 85, 68, 187, 159, 202, 149, 224, 10, 243, 24}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 159}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 127, 59, 45, 230}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 103, 240, 42, 68}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 7, 86, 251, 1}, 208},
	{{160, 212, 13, 63, 61, 250, 94, 118, 174, 226, 179, 213, 255, 122, 248, 215}, 208},
	{{160, 0, 0, 20, 195, 57, 171, 243, 103, 191, 36, 7, 75, 240, 175, 135}, 208},
	{{160, 18, 205, 37, 123, 195, 43, 245, 66, 160, 105, 73, 94, 81, 135, 2}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 29}, 208},
	{{160, 0, 41, 203, 172, 157, 152, 127, 233, 57, 106, 196, 103, 203, 193, 129}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 106, 107, 176}, 208},
	{{160, 0, 0, 0, 32, 51, 111, 206, 15, 128, 64, 78, 60, 95, 253, 233}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 175}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 20}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 134, 46, 127, 93, 100, 223, 94, 240, 110}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 71, 200, 64}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 208},
	{{160, 0, 0, 0, 0, 0, 123, 146, 163, 43, 95, 58, 252, 173, 81, 241}, 208},
	{{160, 0, 0, 21, 46, 135, 18, 155, 210, 142, 62, 90, 199, 163, 165, 28}, 208},
	{{160, 0, 0, 0, 0, 0, 175, 66, 161, 57, 165, 108, 108, 200, 165, 48}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 153, 186, 13, 243, 219, 114, 86}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 220, 102, 91, 11}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 99, 4, 227}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 214, 39, 113, 222}, 208},
	{{160, 0, 0, 0, 0, 0, 190, 120, 188, 223, 62, 68, 37, 244, 164, 240}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 235, 160, 115, 119, 221}, 208},
	{{160, 0, 121, 9, 37, 76, 33, 29, 96, 78, 78, 252, 172, 191, 219, 143}, 208},
	{{160, 0, 0, 0, 0, 0, 159, 230, 93, 211, 202, 142, 224, 65, 103, 9}, 208},
	{{160, 0, 0, 0, 15, 81, 104, 120, 172, 236, 85, 151, 160, 172, 133, 251}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 190, 78, 235, 75, 168, 208, 102, 130, 178, 123, 106, 25, 136, 250, 46}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 161, 192}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 43}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 208},
	{{160, 0, 10, 181, 219, 127, 152, 153, 220, 50, 137, 128, 109, 26, 192, 159}, 208},
	{{160, 0, 0, 0, 34, 87, 233, 239, 239, 176, 185, 34, 201, 161, 161, 73}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 55, 143, 15, 28, 4}, 208},
	{{160, 237, 32, 214, 201, 20, 58, 85, 168, 20, 154, 9, 237, 57, 102, 70}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 117, 164, 190, 15, 147}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 64, 218, 125, 41, 161, 50, 241}, 208},
	{{160, 0, 204, 110, 156, 31, 97, 82, 153, 72, 226, 32, 248, 93, 60, 239}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 3, 182, 111, 129, 203, 135, 28, 115}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 242, 235, 119, 206, 198, 105, 125}, 208},
	{{160, 0, 0, 0, 52, 209, 194, 64, 96, 22, 129, 247, 5, 140, 34, 153}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 59, 178, 209, 68}, 208},
	{{160, 0, 0, 204, 44, 74, 72, 221, 96, 166, 234, 97, 109, 225, 192, 103}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 56, 241, 247, 16, 97, 141, 239, 150}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 237, 254, 39, 74, 36, 161, 122, 22, 181, 228, 252, 252, 24, 199, 115}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 161, 253, 82}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 240, 178, 210}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 157, 227, 8}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 9, 254, 133}, 208},
	{{160, 0, 0, 0, 207, 125, 45, 43, 30, 61, 30, 82, 19, 7, 165, 167}, 208},
	{{160, 0, 202, 162, 186, 24, 81, 58, 81, 122, 8, 92, 156, 128, 150, 129}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 207, 243, 158, 94, 181, 190, 235, 222}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 111, 71, 125, 239, 65}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 225, 61, 150, 80}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 154, 71, 1, 196, 104}, 208},
	{{160, 0, 0, 0, 60, 143, 48, 197, 221, 208, 207, 95, 218, 16, 67, 77}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 208},
	{{160, 0, 0, 0, 0, 0, 70, 245, 19, 60, 76, 90, 50, 9, 112, 240}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 155, 108}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223}, 208},
	{{160, 0, 0, 68, 102, 83, 137, 184, 53, 237, 60, 110, 165, 10, 143, 253}, 208},
	{{160, 0, 0, 0, 76, 112, 100, 110, 171, 9, 20, 178, 114, 78, 131, 220}, 208},
	{{160, 0, 0, 0, 0, 0, 153, 129, 62, 236, 127, 212, 171, 233, 126, 175}, 208},
	{{160, 0, 0, 0, 201, 76, 120, 139, 215, 135, 76, 252, 42, 87, 187, 11}, 208},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 62, 160, 39, 176, 128}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 112, 202}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 97, 148, 49, 112, 174}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 120, 133, 110, 156, 135}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 200, 185}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 61, 159, 103, 117, 14}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 30, 55, 249}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 185, 212, 246}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 182}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 214}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 12}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 148, 151, 22}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 242, 83}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 106, 87, 233}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 95, 65, 86, 231}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 143, 159}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 44, 226, 95, 40, 103}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 93, 125}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 40, 88}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 77, 61, 30}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 205, 185}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 50, 102}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 25, 160, 41, 238}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 148, 245}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 15, 120, 254, 114, 32}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 69, 178, 47, 91}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 74, 50, 201, 111, 28, 234}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 66, 45}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 218, 116, 122, 97, 35}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 217, 61, 137, 182}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 40}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 153, 243, 161}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 22, 96, 160}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 96, 246}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 115, 237, 85, 141, 153, 229}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 237, 74, 58, 70}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 241, 140, 116, 233}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 142, 87, 187, 127}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 78, 46, 70, 185, 62}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 227, 83, 170}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 97}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 172, 120, 168, 176}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 117, 234, 125, 4}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 216, 194, 4, 153}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 51, 56, 157}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 208, 7}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 127}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 61, 40, 160, 80}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 236, 25, 109, 159, 196, 196}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 228, 134, 130, 12}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 72, 107, 228}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 246, 216}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 198}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 254, 77, 51, 253}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 187, 20, 11, 69, 84, 96}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 250}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 240, 129}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 187, 188, 147, 175, 103, 182}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 216}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 12}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 50, 38}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 159}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 34, 110}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 107, 75, 67}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 230, 208, 3, 104, 213}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 228, 102}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 158}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 252}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 221, 45, 146}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 71, 95, 248}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 117}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 147, 148}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 0}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 221}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 137, 178, 87}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 110, 38, 47}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 116, 194, 21, 153}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 162, 212, 133}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 55, 67, 127}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 20, 20, 103, 55}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 69, 149}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 76, 157}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 0, 50}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 179, 46, 164, 181, 237}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 132, 94, 185, 152}, 158},
	{{247, 64, 83, 125, 195, 225, 50, 76, 18, 104, 0, 0, 0, 0, 16, 227}, 158},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 206, 225, 39, 126, 143, 187}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 251, 225, 67, 242, 167, 148}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 5, 16, 251}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 146}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 105, 144, 115, 86, 173, 135}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 215}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 94, 128, 106, 4, 59}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 225, 209, 160, 178, 116}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 79, 190, 241}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 186, 44}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 160, 172, 230, 198, 138}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 114, 15, 123}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 108, 222, 99, 1, 36}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 88}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 251, 185, 94, 77, 39, 13}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 106, 54, 133, 110}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 213, 29, 120, 48}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 149, 47, 7, 23, 86}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 116}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 124}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 205}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 134}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 235, 138, 32, 235}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 118, 176, 141, 156}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 222}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 39, 149}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 114, 209, 121}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 119, 133, 154, 191, 149, 151}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 151, 143, 45}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 210, 39, 174, 195, 37, 127}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 112, 106, 51, 192, 220, 58}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 182}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 202, 72}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 22, 239, 140, 183}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 254}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 222, 255, 142}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 61, 80, 207}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 90, 113, 200, 29, 182, 18}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 117}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 224, 195, 205, 81, 191, 14}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 166}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 255, 176}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 243}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 2}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 205}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 84, 27, 18, 251, 110, 164}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 16, 165, 16}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 70}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 44}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 211, 125, 178, 133, 81}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 6}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 129, 171, 86, 62, 85, 51}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 43, 200, 18}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 134, 16, 81, 87}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 61, 42, 179, 8, 147}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 164, 235, 153, 133}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 55, 79, 25, 237}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 123, 128, 56}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 187, 150, 192, 31}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 249, 182, 191, 130, 0, 189}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 47, 146, 41, 231}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 197, 205}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 69, 217}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 224, 73, 100}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 176, 36}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 26, 50, 50, 129}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 228}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 157}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 199, 238, 148, 250}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 31, 64, 53, 242}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 251}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 231, 59}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 16, 100, 160, 151, 164}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 144, 93, 114, 8}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 240, 65, 27}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 79, 201}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 103, 47}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 232, 243, 248}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 102, 170, 50, 85, 207, 226}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 164, 69}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 104}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 87, 57, 241}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 217, 121, 212, 231}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 0}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 0, 94}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 143, 136}, 136},
	{{78, 91, 31, 202, 189, 25, 13, 133, 220, 0, 0, 0, 0, 0, 241, 250}, 136},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 237, 144}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 232, 122, 113, 11, 69, 227}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 1, 135, 248, 148, 206, 70, 238, 4}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 177, 101, 183, 99, 186, 188, 132, 232, 194}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 227}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 133}, 191},
	{{105, 197, 26, 80, 210, 87, 113, 6, 41, 227, 120, 19, 26, 3, 14, 24}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 24, 248, 174, 185, 252, 209, 60}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 93, 138, 76, 190, 117}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 193}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 124, 234, 155, 185, 98, 157, 175, 110, 131}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 193, 21, 228, 133, 22, 123, 115, 82}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 197, 206, 103, 2, 84, 200, 203}, 191},
	{{105, 197, 26, 80, 0, 164, 193, 119, 206, 198, 219, 166, 248, 177, 52, 163}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 190, 236, 183, 64}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 186, 112, 92, 140}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 131, 138, 170, 218, 100, 94, 20, 58, 8}, 191},
	{{105, 197, 26, 80, 0, 83, 31, 52, 116, 230, 103, 167, 158, 34, 156, 54}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 134, 80, 40, 114, 246}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 111, 82, 206, 7, 64}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 18, 140, 33, 144, 105, 200}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 203, 188, 139, 182, 240, 168, 204}, 191},
	{{105, 197, 26, 80, 0, 0, 234, 115, 86, 36, 144, 45, 233, 67, 55, 250}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 143, 152}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 56, 33, 115, 63, 125}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 225, 101, 241, 16, 185, 110, 238, 48, 140}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 106}, 191},
	{{105, 197, 26, 80, 208, 241, 60, 138, 238, 125, 208, 147, 39, 239, 43, 182}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 208}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 43, 122, 25, 213, 78}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{105, 197, 26, 80, 124, 10, 81, 104, 239, 57, 242, 221, 72, 97, 28, 244}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 116, 145, 237, 99, 243, 171}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 94, 122, 170, 246, 44, 152}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 136, 133, 73, 78, 103, 79, 71}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 34, 172, 32, 69, 23}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 121, 176, 79, 43}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 55, 133, 162, 162, 73, 47}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 196, 179, 77, 175, 10, 38, 98, 80, 185}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 44, 48}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 229, 78, 45, 202, 245, 105, 97, 227, 163}, 191},
	{{105, 197, 26, 80, 0, 221, 54, 101, 246, 153, 128, 171, 166, 182, 23, 106}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 34, 56, 76, 171}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 18, 173, 153, 135, 113, 214, 115, 21, 162}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 160, 7, 42, 15, 196, 107}, 191},
	{{105, 197, 26, 80, 0, 0, 41, 111, 79, 190, 8, 121, 46, 169, 164, 168}, 191},
	{{105, 197, 26, 80, 0, 0, 77, 221, 151, 245, 239, 219, 245, 154, 253, 85}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 68, 43}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 158, 208, 31, 85, 100, 148, 208, 228}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 198, 144, 48, 106, 104, 43}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 88, 5, 39, 12, 224, 200}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 170, 19, 19, 123, 222}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 86, 180, 187, 27, 181, 178, 239, 159}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 235, 65, 40, 88, 190, 229, 180, 126}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 232, 59, 97, 16, 236, 127}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 210, 56, 42, 157, 96}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 169, 168, 185, 214, 118, 230}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 72, 255, 103, 19, 18, 254, 235}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 74, 239, 242, 8}, 191},
	{{105, 197, 26, 80, 0, 0, 123, 131, 110, 93, 9, 110, 155, 99, 139, 176}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136}, 191},
	{{105, 197, 26, 80, 0, 0, 26, 175, 43, 41, 76, 69, 218, 211, 50, 104}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 244, 74, 185, 50, 126}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 165, 110, 96, 84, 136}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 46, 46, 246, 152}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 42}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 33, 105, 187, 80}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 236, 27, 78, 19, 73, 138}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 53, 216, 69, 159, 83, 239, 22, 128}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 95, 198, 126, 13, 194}, 191},
	{{105, 197, 26, 80, 0, 90, 166, 228, 71, 221, 126, 72, 235, 168, 146, 144}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 108}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 31}, 191},
	{{105, 197, 26, 80, 0, 241, 49, 39, 78, 113, 88, 253, 217, 172, 22, 167}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 248, 190, 84, 53, 105, 28}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 235, 88, 125, 50, 192, 133}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 152, 23, 59, 20, 162, 82, 154, 3, 235}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 208, 52, 112, 77, 147, 196, 9, 211}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 184, 168, 94, 254, 192, 220, 29}, 191},
	{{105, 197, 26, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 162}, 191},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{14, 31, 154, 242, 241, 231, 55, 151, 223, 56, 134, 255, 113, 206, 69, 0}, 126},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{247, 193, 58, 176, 16, 71, 31, 120, 213, 104, 231, 83, 26, 118, 91, 135}, 139},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 216},
	{{136, 32, 240, 0, 0, 0, 226, 67, 154, 155, 224, 14, 91, 36, 221, 143}, 216},
	{{136, 32, 240, 0, 0, 0, 80, 107, 75, 101, 31, 166, 205, 0, 83, 97}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 253}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 107, 47, 161, 199, 77}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 250}, 216},
	{{136, 32, 240, 0, 0, 14, 21, 90, 74, 71, 245, 66, 152, 22, 49, 183}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 8, 213}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 37, 244, 218, 77, 113}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 106}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 116, 87, 20, 217, 193, 228}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 136, 129, 14, 171, 180, 148, 201, 225}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 84}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 149}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 229, 158, 76}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 202}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 131}, 216},
	{{136, 32, 240, 0, 0, 157, 84, 230, 194, 216, 10, 208, 196, 99, 219, 166}, 216},
	{{136, 32, 240, 0, 15, 28, 61, 104, 239, 193, 101, 7, 26, 0, 236, 71}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 88, 58, 59, 196, 34, 32}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 48, 150, 91, 184, 66, 35, 165, 170, 157}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 129, 169, 103, 102, 197, 28, 226, 102, 182}, 216},
	{{136, 32, 240, 0, 0, 0, 80, 190, 59, 60, 17, 88, 137, 128, 150, 242}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 79, 60}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 3, 233, 67}, 216},
	{{136, 32, 240, 0, 0, 0, 8, 170, 8, 88, 92, 4, 165, 168, 212, 17}, 216},
	{{136, 32, 240, 0, 0, 0, 249, 97, 129, 255, 23, 123, 51, 28, 70, 237}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 125, 133, 101, 121, 134, 249, 239}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 227, 190, 209, 145, 51, 83, 207}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 163, 6, 99}, 216},
	{{136, 32, 240, 0, 0, 63, 110, 18, 39, 243, 110, 12, 139, 186, 230, 127}, 216},
	{{136, 32, 240, 0, 246, 249, 250, 199, 11, 146, 221, 160, 151, 36, 205, 95}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 24, 112}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 214, 96, 17, 8, 9}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 139}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 236}, 216},
	{{136, 32, 240, 0, 239, 120, 139, 47, 25, 118, 46, 216, 196, 220, 8, 223}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 229}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 170, 157, 247, 46, 156, 7, 19, 232, 68}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 145, 108, 227, 127, 21, 128, 43, 165}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 130, 244, 14, 7, 195}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 95, 167, 37, 115, 100}, 216},
	{{136, 32, 240, 0, 234, 162, 10, 67, 205, 233, 251, 164, 213, 69, 44, 210}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 211, 239, 33}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 15, 7, 218, 233, 36, 229}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 96, 166, 3, 178, 156, 164}, 216},
	{{136, 32, 240, 0, 45, 204, 136, 16, 9, 85, 249, 215, 42, 170, 90, 8}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 43}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 5, 11, 135, 179, 176, 43, 34, 115, 33}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 130, 163, 23, 60, 156, 37, 224, 16, 85}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 214, 208, 248, 56, 90}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 77, 120, 92, 34, 116, 201}, 216},
	{{136, 32, 240, 0, 0, 225, 255, 190, 50, 133, 218, 48, 39, 119, 229, 151}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 249, 141, 76, 139, 20, 59, 180, 42}, 216},
	{{136, 32, 240, 0, 168, 75, 161, 58, 71, 205, 23, 16, 175, 72, 107, 155}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 52}, 216},
	{{136, 32, 240, 0, 24, 147, 184, 178, 37, 240, 0, 101, 18, 50, 111, 17}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 9, 117, 125, 253, 52, 1, 152, 134, 155}, 216},
	{{136, 32, 240, 0, 0, 0, 129, 149, 24, 91, 222, 107, 27, 224, 68, 147}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 118, 157, 193}, 216},
	{{136, 32, 240, 0, 200, 198, 196, 64, 136, 88, 247, 216, 29, 214, 178, 105}, 216},
	{{136, 32, 240, 0, 0, 188, 128, 230, 147, 20, 149, 11, 219, 75, 169, 248}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 243, 231, 113, 83, 29, 141, 137, 97}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 50, 149, 241, 5, 241, 38, 17, 56, 175}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 84, 72, 22, 166, 107, 132, 64, 191}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 30, 126}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 46, 162, 229, 239, 200}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 86, 184, 172, 80, 249, 213}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 242, 237, 163, 180, 170, 219, 179, 162, 121}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 84, 31, 107, 245, 1, 74, 94, 85}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 229, 85, 30, 208, 183, 119, 191, 62, 191}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 187, 116, 152, 62, 46, 146, 134, 160, 38}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 174, 87, 199, 156, 202, 180, 142, 165}, 216},
	{{136, 32, 240, 0, 0, 170, 241, 22, 84, 29, 205, 234, 79, 207, 72, 7}, 216},
	{{136, 32, 240, 0, 0, 0, 8, 9, 105, 224, 63, 10, 148, 224, 239, 194}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 123}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 135}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 57, 110}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 66, 5, 165, 137, 31}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 99, 181, 155, 6, 157, 180}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 163, 215, 236, 129, 215, 166, 16}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 188}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 200, 30, 215, 247, 188, 92, 51, 165, 42}, 216},
	{{136, 32, 240, 0, 195, 154, 249, 60, 38, 50, 64, 79, 20, 123, 230, 173}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 99, 126, 120, 202, 217, 128, 23}, 216},
	{{136, 32, 240, 0, 0, 0, 100, 171, 33, 146, 127, 25, 255, 26, 192, 162}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 134, 192, 16}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 107, 188, 251, 29, 201, 152, 201, 110}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 140, 69}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 132, 68, 106, 229, 66, 153, 251, 239, 68}, 216},
	{{136, 32, 240, 0, 0, 0, 0, 0, 0, 0, 0, 247, 236, 228, 110, 83}, 216},
	{{136, 32, 240, 0, 161, 251, 175, 79, 126, 117, 177, 171, 100, 17, 138, 48}, 216},
	{{100, 238, 112, 40, 0, 0, 0, 0, 252, 12, 85, 204, 56, 128, 152, 10}, 93},
	{{100, 238, 112, 40, 0, 53, 149, 75, 42, 142, 113, 45, 60, 92, 199, 29}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 13, 159, 233, 214, 86, 202, 112}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 94, 167, 198, 44, 28, 91, 125, 171}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 143, 13}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 218, 92, 194, 209, 187, 59, 16}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 51, 137, 212, 248, 222, 107, 45, 179}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{100, 238, 112, 40, 0, 126, 36, 207, 44, 50, 186, 8, 74, 13, 90, 232}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 35, 187, 125, 204, 51, 58}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 141, 30, 121, 14, 103, 156}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 182, 48}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 236, 122, 154, 187, 161, 52, 74, 47}, 93},
	{{100, 238, 112, 40, 96, 232, 64, 74, 190, 181, 76, 172, 193, 237, 167, 109}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 52, 200, 103, 155}, 93},
	{{100, 238, 112, 40, 0, 220, 160, 63, 145, 168, 148, 7, 43, 234, 9, 61}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 20, 217, 85, 84, 31, 234, 111, 237, 136}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 245, 122, 238, 172, 16, 51, 215}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 140, 157, 220, 0, 200, 199, 12}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 206, 235, 150, 5, 1}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 106}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 91, 46, 229, 35, 35, 128}, 93},
	{{100, 238, 112, 40, 0, 0, 65, 242, 188, 116, 56, 201, 248, 10, 80, 56}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 163, 34, 206, 1, 37, 174}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 26, 14, 84, 38, 253}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 195, 25, 254, 219, 95, 190, 40, 177}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 64, 242, 110, 183, 107, 150}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 76, 177, 160, 179, 136, 73, 153, 34}, 93},
	{{100, 238, 112, 40, 0, 0, 192, 16, 214, 4, 232, 235, 243, 50, 25, 56}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 102}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 21}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 60, 86, 230, 160, 33, 220, 3, 214}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 179, 134, 119, 31, 93, 70, 2}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 78, 179, 55, 86, 159, 162, 208, 131, 225}, 93},
	{{100, 238, 112, 40, 0, 0, 248, 24, 15, 61, 154, 171, 99, 83, 176, 64}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 82, 131, 213, 167, 97, 15, 83, 20}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 16, 74, 240, 25, 32, 232}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 152, 82}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 129, 151}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 28, 156, 67, 214, 165, 169, 142}, 93},
	{{100, 238, 112, 40, 0, 155, 71, 246, 213, 60, 238, 51, 11, 158, 239, 134}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 30, 41, 223, 13, 13, 206, 137, 218}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 104, 100, 47, 168, 145}, 93},
	{{100, 238, 112, 40, 0, 129, 98, 128, 217, 45, 179, 159, 212, 165, 92, 30}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 171}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 116, 25, 161, 238, 191, 126, 169}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 41, 201, 112, 99, 35, 28, 171, 202}, 93},
	{{100, 238, 112, 40, 0, 8, 112, 120, 203, 206, 176, 235, 187, 255, 247, 38}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 26, 38, 9, 88, 228}, 93},
	{{100, 238, 112, 40, 0, 0, 193, 31, 44, 106, 205, 174, 174, 113, 49, 244}, 93},
	{{100, 238, 112, 40, 0, 0, 11, 240, 32, 41, 43, 101, 89, 126, 78, 68}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{100, 238, 112, 40, 217, 229, 70, 99, 67, 25, 154, 43, 37, 144, 238, 88}, 93},
	{{100, 238, 112, 40, 0, 101, 189, 138, 73, 155, 124, 7, 177, 120, 204, 148}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 226, 234, 249, 19}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 235, 208}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 49, 89, 213, 60}, 93},
	{{100, 238, 112, 40, 0, 0, 47, 227, 115, 47, 170, 6, 151, 141, 144, 171}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 13, 140, 21, 172, 25, 81, 126}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 167, 241, 140, 49}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 178, 68, 8, 111, 97, 128, 49, 247, 242}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 180, 253, 225, 136, 185, 128}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 49, 194, 81, 106, 153, 200}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 93, 136, 30, 117, 39}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 140, 112, 212, 253, 169, 95}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 205, 158, 12, 193, 71}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 151, 48, 135, 238, 74, 148}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 38, 9, 104, 126, 196, 175, 201}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 119, 131, 80, 235, 227}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 98, 162, 66, 15, 114, 242}, 93},
	{{100, 238, 112, 40, 0, 0, 165, 143, 204, 172, 66, 80, 114, 78, 92, 45}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 71, 45, 226, 133, 8, 81, 122, 246, 144}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 71, 97, 221, 145, 172}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 24, 24, 42, 36}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 120, 135, 151, 138, 186, 49, 92, 226}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 189, 2, 65, 217}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 94, 88, 160, 109}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 73, 128, 217, 200, 25, 206, 135, 208}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 234, 119, 48, 0, 185, 200}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 234, 189, 116, 195, 14, 162, 201, 218, 217}, 93},
	{{100, 238, 112, 40, 0, 2, 126, 157, 24, 33, 1, 149, 86, 128, 66, 184}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 119, 40, 195, 103, 68, 40, 188}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 8, 218}, 93},
	{{100, 238, 112, 40, 0, 0, 228, 218, 80, 101, 200, 92, 235, 28, 81, 110}, 93},
	{{100, 238, 112, 40, 0, 0, 224, 112, 40, 0, 240, 95, 178, 133, 96, 242}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 241, 143, 121, 141, 122}, 93},
	{{100, 238, 112, 40, 0, 0, 51, 146, 182, 23, 144, 41, 143, 37, 251, 148}, 93},
	{{100, 238, 112, 40, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67}, 93},
	{{100, 238, 112, 40, 0, 0, 176, 226, 194, 114, 209, 112, 49, 156, 3, 157}, 93},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 118, 119, 197, 227, 206, 226, 97, 251, 249}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 26, 5, 83}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 146, 71, 117, 204, 109, 173, 9, 44, 193}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 196},
	{{80, 0, 213, 55, 128, 4, 184, 228, 212, 135, 45, 168, 85, 76, 159, 110}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 68, 162, 82}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 220, 96, 233, 90, 133, 56, 237, 110}, 196},
	{{80, 0, 0, 0, 162, 51, 187, 51, 13, 16, 127, 226, 6, 102, 3, 23}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 23, 16, 37, 14}, 196},
	{{80, 0, 168, 232, 39, 21, 200, 66, 87, 54, 241, 109, 134, 177, 218, 93}, 196},
	{{80, 0, 0, 0, 0, 249, 196, 239, 217, 159, 101, 45, 166, 249, 124, 238}, 196},
	{{80, 0, 0, 0, 155, 65, 6, 238, 133, 56, 230, 177, 56, 109, 53, 141}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 72, 5}, 196},
	{{80, 0, 0, 0, 195, 172, 49, 240, 72, 101, 10, 134, 3, 211, 27, 27}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 196},
	{{80, 205, 113, 96, 0, 169, 224, 95, 118, 62, 95, 212, 241, 156, 234, 203}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 211, 228}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67}, 196},
	{{80, 0, 0, 0, 0, 0, 167, 52, 183, 28, 125, 69, 240, 224, 120, 218}, 196},
	{{80, 0, 119, 5, 128, 238, 136, 179, 187, 161, 55, 186, 33, 109, 34, 87}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 210, 227, 160, 157, 91, 118, 91, 130, 73}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 77, 68, 15, 47, 196, 19, 52, 91}, 196},
	{{80, 0, 0, 0, 83, 242, 37, 132, 164, 90, 160, 42, 52, 85, 170, 72}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 169, 123, 26}, 196},
	{{80, 0, 0, 0, 65, 123, 44, 0, 52, 43, 33, 140, 139, 224, 86, 203}, 196},
	{{80, 0, 0, 0, 195, 34, 107, 100, 176, 19, 94, 183, 158, 35, 50, 146}, 196},
	{{80, 0, 84, 239, 99, 204, 14, 199, 201, 8, 229, 138, 246, 160, 233, 64}, 196},
	{{80, 0, 0, 0, 93, 230, 190, 55, 1, 171, 190, 213, 161, 83, 95, 214}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 159, 93, 154, 233, 32, 246, 115, 220}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107}, 196},
	{{80, 0, 0, 0, 86, 224, 225, 65, 136, 109, 226, 140, 72, 92, 202, 71}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 117, 62, 113, 15}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 196},
	{{80, 0, 0, 0, 0, 66, 121, 44, 219, 1, 107, 1, 138, 23, 187, 19}, 196},
	{{80, 0, 0, 0, 0, 0, 5, 239, 109, 38, 253, 79, 138, 218, 153, 194}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 6, 87, 166, 133, 142}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 115, 72, 61, 201, 172, 81, 23, 227, 219}, 196},
	{{80, 167, 231, 123, 222, 17, 202, 36, 42, 162, 131, 108, 101, 105, 229, 133}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 183, 239, 174, 118, 235, 69, 188, 82, 128}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 196},
	{{80, 0, 0, 200, 235, 127, 183, 72, 192, 122, 218, 125, 41, 237, 232, 36}, 196},
	{{80, 0, 0, 0, 202, 61, 226, 68, 0, 111, 239, 197, 64, 222, 253, 5}, 196},
	{{80, 0, 0, 91, 99, 87, 226, 85, 149, 194, 21, 29, 217, 5, 72, 4}, 196},
	{{80, 0, 0, 0, 0, 0, 84, 236, 14, 101, 18, 251, 193, 239, 87, 186}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 71, 95, 184}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 241, 74, 111, 218}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 175}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 76}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 13, 151, 251, 214}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 46, 169, 111, 190}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 99, 212, 31}, 196},
	{{80, 0, 0, 0, 117, 40, 53, 60, 129, 83, 238, 36, 210, 14, 79, 64}, 196},
	{{80, 0, 0, 5, 185, 231, 95, 43, 230, 44, 117, 222, 52, 177, 179, 58}, 196},
	{{80, 0, 0, 18, 230, 245, 76, 104, 203, 205, 4, 88, 27, 150, 241, 109}, 196},
	{{80, 0, 0, 82, 177, 160, 36, 125, 142, 13, 65, 181, 164, 44, 243, 212}, 196},
	{{80, 0, 0, 107, 13, 220, 131, 140, 239, 92, 220, 111, 100, 22, 121, 174}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 41, 250}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 112, 65}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 238, 167, 253, 229, 235, 216, 145}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 4, 74}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 167, 184, 168, 214, 122, 69, 199}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 196},
	{{80, 0, 0, 62, 126, 233, 76, 73, 243, 84, 20, 28, 96, 200, 1, 189}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30}, 196},
	{{80, 0, 0, 197, 201, 102, 12, 126, 56, 95, 193, 87, 66, 253, 132, 220}, 196},
	{{80, 0, 0, 192, 62, 23, 130, 167, 29, 6, 38, 15, 88, 1, 20, 210}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 181, 92, 248, 11}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 76, 221, 102, 212}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 90, 228, 127, 148, 180, 184, 153, 97, 6}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 99, 228}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 238}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 106, 116}, 196},
	{{80, 0, 231, 84, 147, 254, 156, 151, 106, 180, 132, 184, 116, 129, 150, 236}, 196},
	{{80, 0, 0, 146, 245, 116, 202, 176, 107, 70, 133, 183, 230, 127, 31, 139}, 196},
	{{80, 0, 0, 146, 219, 186, 206, 167, 71, 182, 240, 55, 208, 233, 118, 247}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 163, 78, 241, 248, 169, 222, 104, 198, 250}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 196},
	{{80, 0, 0, 0, 187, 254, 86, 251, 57, 115, 255, 41, 63, 58, 81, 199}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 215}, 196},
	{{80, 0, 0, 0, 0, 69, 247, 122, 173, 50, 72, 113, 207, 132, 168, 40}, 196},
	{{80, 0, 0, 0, 0, 222, 255, 36, 10, 51, 43, 115, 117, 24, 25, 110}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 39, 255}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 46, 240, 30, 15}, 196},
	{{80, 0, 219, 218, 234, 163, 114, 135, 162, 203, 21, 3, 19, 135, 85, 189}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 74, 149}, 196},
	{{80, 107, 203, 226, 63, 107, 238, 18, 3, 144, 58, 127, 144, 231, 146, 114}, 196},
	{{80, 78, 203, 29, 92, 179, 202, 163, 176, 49, 191, 154, 135, 6, 232, 178}, 196},
	{{80, 0, 0, 0, 44, 49, 6, 33, 239, 22, 180, 48, 175, 8, 19, 150}, 196},
	{{80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 220}, 196},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 155, 131, 41}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 33, 121, 29}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 123, 10, 86, 40}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 14}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 93, 162, 177}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 30, 247}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 5}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 35}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 24, 62}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 207}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 213, 44, 31}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 75, 159, 0, 226, 56}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 62, 189}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 19, 41, 157, 90, 59}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 6}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 20, 98, 198, 110, 154}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 117, 89, 32}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 207, 30}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 115}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 58, 188, 212}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 194, 16, 145, 102}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 91}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 62, 27, 98, 181}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 18, 138, 6, 21}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 56, 27, 109, 202}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 50, 215}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 122, 88, 35, 121}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 11, 48, 17}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 11, 52, 21}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 24, 68, 130, 44, 17}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 127, 211, 35, 244}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 180, 163}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 35, 60, 59, 251}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 217, 32}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 124}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 43, 146, 74, 251}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 88, 108}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 150, 146, 42, 158}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 195, 186, 224}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 252, 122, 24}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 68}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 158, 89}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 221, 178, 22, 204}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 24, 52}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 191, 187}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 214, 92, 105, 172}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 202}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 38, 52, 147, 176}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 248, 26, 110}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 113, 208, 90, 226, 134}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 76}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 33, 48}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 7, 8, 249}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 82, 167, 109, 232}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 145, 159, 230, 225, 51}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 48, 212, 79, 131, 144}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 234}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 241, 132, 221}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 44}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 162, 32, 123, 243}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 235, 198, 224, 75, 141}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 231}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 238}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 247}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 173, 201, 236}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 135, 26, 142}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 185, 219, 208}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 47, 146, 51}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 8, 116}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 166, 97, 59}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 155, 89, 142}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 123, 198, 239, 9}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 93, 158}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 87, 93, 171, 227}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 0, 0, 0, 0}, 119},
	{{233, 224, 254, 57, 33, 205, 140, 217, 181, 72, 0, 0, 84, 10, 229, 45}, 119},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 219, 151}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 44}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 142, 115}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 205}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 248, 117}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 154, 206}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 204, 8}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 217}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 219}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 125}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 77}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 54, 220}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 10, 143}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 1, 147}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 150}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 135}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 132}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 97}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 119, 109}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 170, 40}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 196}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 214}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 146}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 170, 63}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 177, 125}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 69, 88}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 240}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 105}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 200}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 8, 117}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 19, 210}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 29, 103}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 165}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 163}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 188, 207}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 69, 242}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 19}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 225, 183}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 34, 93}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 99, 206}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 6}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 36}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 200, 239}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 19, 162}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 31, 95}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 122, 33}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 144, 159}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 204}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 207}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 135}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 244}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 87, 56}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 92}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 52}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 49}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 36, 82}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 49, 220}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 152, 131}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 230}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 29}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 196, 157}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 38, 180}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{107, 75, 65, 158, 128, 142, 191, 188, 188, 240, 148, 243, 116, 0, 0, 0}, 93},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 213, 46, 223}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 203}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 200, 33}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 228, 39}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 84, 245}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 36, 221}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 103}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 226, 190, 67}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 247, 68}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 129, 23}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 175}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 5, 170, 20}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 140, 104}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 153, 14}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 127, 201}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 142}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 34, 205, 90}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 70, 5, 98}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 197}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 204, 210}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 42, 31}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 228, 43}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 148, 227}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 7, 103}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 46, 153, 249}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 94, 93, 21}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 138, 16}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 42}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 225, 183, 249}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 239, 118}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 190, 252}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 173, 55, 65}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 242, 239, 69}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 121, 1, 252}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 231, 188}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 71, 30}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 132, 176}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 172}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 251, 183, 134}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 76, 35}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 102}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 12}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 180, 85, 6}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 252, 73, 204}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 195, 255}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 93}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 160, 60, 238}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 192}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 238, 216, 181}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 86, 147}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 172}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 181, 99, 211}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 20, 132}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 251}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 53}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 223, 198}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 91}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 75, 248}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 71, 146, 4}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 211, 184}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 158}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 77, 173, 104}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 52}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 3, 100, 5}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 193, 26}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 54}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 216, 250, 207}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 176, 68}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 68}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 222, 223}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 134, 202, 25}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 26, 31}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 0, 0}, 183},
	{{39, 70, 120, 114, 69, 237, 95, 48, 233, 176, 91, 154, 0, 0, 212, 16}, 183},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 5, 126, 138, 138, 133}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 152, 77, 220, 132, 106, 82, 255, 188}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 212, 154, 181}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 174, 177, 74, 16, 60}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 146, 188, 37, 22, 117, 118, 181, 94}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 89, 64, 89, 146, 161, 49}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 95, 63, 189, 30, 58, 34, 36, 192}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 65, 202, 253, 189, 83}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 42, 6, 219, 109, 201, 42, 219, 57, 2}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 123, 44, 232, 91, 247, 51, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 182, 117, 247}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 199, 174, 174, 6, 195}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 47, 108, 63, 183}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 124, 79, 139, 242}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 78, 101, 0, 219, 9, 211}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 3, 19, 91, 153, 159}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 163, 248, 75, 211, 194, 15, 135}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 23, 233, 161, 43, 210, 135, 9}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 44, 187, 172, 204, 146, 253, 14}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 123, 182, 127, 97, 31, 152, 166}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 114, 9, 86, 212, 228, 163, 181}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 47, 55, 199, 62, 176}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 230, 183, 37, 149}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 222, 217, 183, 138, 176}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 226, 79, 67, 235, 135, 59, 73, 229, 70}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 49}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 231, 174}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 227, 76, 54, 204, 253, 143, 197}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 18, 169, 241}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 174, 141, 211}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 210, 0, 138, 89, 125, 255, 161, 180, 140}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 64, 243, 218, 134, 145, 83, 76}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 171, 40, 107, 220, 46, 58, 25}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 167, 93, 175, 233, 197, 108, 229}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 161, 119, 103, 206, 205, 167}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 213, 28, 115, 98, 65}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 81, 76, 202, 137}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 80, 107, 246, 153, 203, 233}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 98, 27, 47, 213, 240, 115}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 112, 19}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 102, 242, 11, 174}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 205, 174, 136, 215, 237, 83, 36, 252}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 34, 95, 111, 9, 133, 162, 227}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 163, 210, 21}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 201, 27, 205, 86, 31, 247, 7}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 250, 38, 41, 20, 54}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 191, 57, 73, 207, 101}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 34, 0, 70, 164, 98, 234, 5, 196}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 130, 36, 95, 123, 89, 195, 168}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 35, 66, 216, 237, 197, 249}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 6, 104}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 224, 79, 88, 24, 65, 192}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 228, 16, 72, 58, 5, 2, 228, 92}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 8, 3, 187, 238}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 191, 178}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 233, 38}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 59, 173, 33}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 97, 254, 96, 221, 165, 169}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 231, 113, 64, 0, 253, 36, 242, 42}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 43, 56, 237, 66}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 33, 151, 209}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 62, 66, 242, 246, 202, 231, 50}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 126, 19, 169}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 83, 171, 135, 235, 104, 152}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 151, 43}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 237, 131, 51, 56}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 131, 63, 229, 76, 153, 145, 164}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 59, 141, 122, 54, 184, 117, 113, 211}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 33, 44, 0, 103, 23}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 78, 252, 137, 120, 198}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 125, 167, 157, 163, 112, 137, 51}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 231, 89}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 125, 249, 153, 78, 49, 36, 199, 177}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 236, 119, 176, 45, 150}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 113, 104, 157, 18, 193, 244}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 188, 123, 254, 92, 128, 162}, 207},
	{{10, 61, 43, 101, 64, 102, 208, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 207},
	{{151, 128, 0, 8, 3, 179, 204, 15, 228, 38, 65, 66, 77, 42, 206, 128}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 91, 107, 56, 24, 9, 216, 21, 21}, 102},
	{{151, 128, 0, 0, 0, 0, 147, 240, 170, 121, 76, 192, 207, 213, 200, 175}, 102},
	{{151, 128, 0, 97, 34, 181, 193, 124, 20, 79, 91, 110, 177, 207, 4, 166}, 102},
	{{151, 128, 0, 0, 0, 0, 214, 80, 227, 143, 1, 102, 219, 23, 76, 148}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 214, 89}, 102},
	{{151, 128, 0, 220, 240, 56, 206, 153, 162, 99, 24, 15, 238, 253, 254, 120}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 82, 42, 197, 26, 103, 194, 253, 118, 253}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 106, 105, 158, 162, 152, 17, 141, 191}, 102},
	{{151, 128, 0, 0, 0, 0, 248, 136, 120, 95, 168, 56, 246, 95, 254, 174}, 102},
	{{151, 128, 0, 0, 0, 0, 155, 10, 182, 223, 144, 100, 86, 100, 81, 70}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 238, 92, 211, 48, 241, 25, 250, 241, 125}, 102},
	{{151, 128, 0, 0, 0, 0, 139, 181, 139, 110, 90, 220, 222, 184, 193, 53}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 84}, 102},
	{{151, 128, 0, 0, 40, 110, 100, 240, 240, 164, 129, 188, 109, 63, 138, 121}, 102},
	{{151, 128, 0, 0, 0, 0, 80, 210, 122, 95, 38, 150, 244, 99, 158, 13}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 241, 92, 166, 75}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 119, 105, 215, 118, 127, 186}, 102},
	{{151, 128, 0, 0, 0, 11, 227, 190, 209, 226, 151, 15, 3, 87, 65, 208}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 20, 91, 130, 245, 86, 133, 229}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218, 218, 217, 225, 75}, 102},
	{{151, 128, 0, 0, 16, 109, 24, 197, 242, 15, 79, 107, 109, 247, 239, 214}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{151, 128, 240, 15, 242, 133, 192, 245, 236, 159, 232, 1, 147, 101, 140, 102}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 135}, 102},
	{{151, 128, 0, 0, 0, 0, 222, 102, 157, 184, 41, 173, 74, 232, 69, 59}, 102},
	{{151, 128, 0, 96, 64, 112, 55, 24, 190, 82, 64, 6, 57, 179, 41, 249}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 245, 152, 31, 155, 67, 89}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 155, 9, 147, 210, 160, 135, 167}, 102},
	{{151, 128, 51, 50, 48, 253, 126, 203, 81, 137, 193, 149, 224, 23, 204, 209}, 102},
	{{151, 128, 97, 26, 225, 232, 179, 91, 99, 66, 44, 138, 28, 34, 17, 44}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 95, 51, 236, 235, 66, 53}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 129, 94, 162, 20, 2, 112, 245, 189, 177}, 102},
	{{151, 128, 174, 230, 148, 137, 171, 49, 126, 17, 185, 189, 224, 76, 198, 169}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{151, 128, 0, 0, 0, 0, 32, 179, 173, 253, 174, 244, 66, 224, 180, 217}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 227, 122}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 62, 215, 46}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 186, 117, 132, 11, 89, 125, 8, 145}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 80, 185, 117, 74}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 43, 129, 24, 203, 7, 3, 246, 16}, 102},
	{{151, 128, 0, 0, 0, 9, 221, 252, 90, 244, 44, 2, 221, 188, 240, 178}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 114}, 102},
	{{151, 128, 0, 44, 193, 114, 255, 195, 130, 214, 72, 85, 55, 143, 170, 193}, 102},
	{{151, 128, 0, 0, 159, 34, 215, 71, 207, 117, 202, 194, 180, 52, 146, 24}, 102},
	{{151, 128, 0, 211, 195, 104, 254, 201, 50, 35, 67, 70, 94, 66, 41, 218}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 153, 112, 183, 149, 100, 58, 170}, 102},
	{{151, 128, 109, 20, 20, 92, 4, 246, 156, 24, 27, 102, 162, 129, 243, 14}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 147, 11, 154}, 102},
	{{151, 128, 0, 107, 211, 60, 14, 66, 99, 52, 120, 137, 49, 96, 187, 163}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 223, 204, 67, 203}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 203, 159, 32}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222}, 102},
	{{151, 128, 39, 10, 26, 202, 209, 102, 22, 229, 75, 82, 212, 7, 22, 142}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 79, 63, 128, 57, 98, 31, 42, 11}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 167, 233, 152, 183, 97, 120, 43}, 102},
	{{151, 128, 0, 203, 157, 210, 103, 13, 107, 22, 231, 137, 87, 10, 141, 108}, 102},
	{{151, 128, 0, 0, 110, 84, 210, 49, 232, 14, 120, 175, 69, 99, 70, 244}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 176, 132, 111, 198, 115, 71, 154, 51, 162}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 8, 87, 163, 162, 44, 176}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 105, 43, 56, 45, 175, 218}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 4, 84, 9, 155, 236, 195, 82, 231, 211}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 57, 204, 103, 97, 174, 50, 117, 55}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 97, 69, 220, 228}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 71, 204, 167, 31, 254, 204, 234}, 102},
	{{151, 128, 0, 0, 0, 0, 81, 90, 203, 79, 6, 196, 75, 68, 206, 207}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 155, 51, 83, 72}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 56, 214, 208, 98, 110, 28}, 102},
	{{151, 128, 63, 222, 252, 162, 126, 30, 154, 165, 201, 131, 63, 159, 110, 52}, 102},
	{{151, 128, 0, 0, 0, 73, 48, 254, 244, 74, 194, 30, 16, 187, 225, 219}, 102},
	{{151, 128, 0, 0, 0, 0, 53, 38, 177, 121, 49, 144, 43, 145, 43, 252}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 137, 86}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 163}, 102},
	{{151, 128, 0, 0, 0, 140, 129, 186, 109, 119, 226, 97, 36, 194, 88, 207}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 0}, 102},
	{{151, 128, 132, 241, 8, 91, 24, 236, 100, 75, 94, 9, 247, 157, 25, 177}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 201, 241, 188, 109}, 102},
	{{151, 128, 0, 1, 116, 84, 95, 86, 243, 179, 202, 34, 46, 77, 75, 10}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 94, 226, 92, 41}, 102},
	{{151, 128, 0, 0, 0, 0, 3, 190, 8, 127, 225, 17, 213, 5, 157, 41}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 229}, 102},
	{{151, 128, 0, 0, 0, 109, 161, 163, 18, 113, 216, 180, 132, 64, 143, 240}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 214, 203, 210, 209, 123, 134, 235}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 196, 84, 70, 147}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 121, 49, 196}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 4, 234, 224, 147, 8, 127, 217, 94}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 193}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 191, 7, 65, 56, 78, 24, 81, 49}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 120, 102, 233, 228, 23, 41}, 102},
	{{151, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 213, 79, 243, 73}, 102},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 95, 130, 238, 52, 248, 84}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 81, 248, 87, 19, 49, 144, 163, 203}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 125, 49, 94, 194, 238, 49, 191, 60, 35}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 93, 205, 72, 247, 62, 163, 252}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 149, 183, 203, 19, 151, 111, 173, 164}, 36},
	{{210, 241, 0, 0, 0, 0, 92, 35, 254, 104, 27, 242, 194, 0, 153, 11}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 133, 161, 43, 237, 148, 69}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 188, 142, 91, 126, 223, 15, 58, 63, 194}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 223, 132, 5, 233}, 36},
	{{210, 241, 0, 103, 36, 146, 34, 248, 235, 254, 166, 116, 206, 175, 59, 241}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 171, 42, 155, 235, 63, 107, 236, 139, 122}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 184, 94, 227}, 36},
	{{210, 241, 0, 0, 0, 0, 163, 1, 9, 93, 129, 200, 91, 87, 208, 128}, 36},
	{{210, 241, 0, 0, 0, 0, 22, 206, 138, 41, 154, 88, 120, 198, 132, 229}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 92, 241, 137, 81}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 28, 218, 189, 63, 227, 225, 200}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{210, 241, 0, 0, 0, 0, 133, 117, 118, 141, 110, 38, 38, 109, 178, 174}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 238, 143, 93, 130, 243, 205, 221, 147}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 61, 173, 30, 0, 92, 187, 234}, 36},
	{{210, 241, 0, 41, 161, 90, 79, 33, 158, 114, 170, 111, 118, 161, 179, 10}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 35}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 174, 137, 158, 122, 181, 114, 74}, 36},
	{{210, 241, 0, 0, 0, 120, 84, 53, 148, 236, 167, 185, 91, 19, 113, 95}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{210, 241, 0, 149, 232, 82, 193, 221, 26, 54, 85, 73, 205, 61, 233, 147}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 177, 34, 66, 192, 51, 33, 62}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 32}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 127, 60}, 36},
	{{210, 241, 0, 0, 13, 207, 192, 226, 196, 198, 4, 117, 180, 73, 119, 38}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 192, 141, 95, 129, 148, 19}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 132, 194, 71, 51, 21, 110, 78}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 73}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 4}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 187, 99, 138, 210, 203, 133}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 40, 8, 177, 112}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 229, 244, 151}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 121}, 36},
	{{210, 241, 0, 0, 0, 212, 211, 43, 186, 140, 114, 194, 167, 174, 80, 205}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 144, 97, 228, 138, 198, 87, 158, 163, 123}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 52, 192, 64, 254, 128, 75, 123, 51}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 63, 128}, 36},
	{{210, 241, 0, 0, 53, 42, 9, 74, 210, 73, 240, 36, 7, 75, 54, 76}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 150, 27, 83, 35, 120, 46, 2, 29}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 152, 126}, 36},
	{{210, 241, 0, 0, 0, 0, 129, 77, 197, 223, 41, 163, 230, 173, 3, 149}, 36},
	{{210, 241, 0, 0, 0, 85, 78, 90, 50, 29, 27, 19, 70, 75, 69, 67}, 36},
	{{210, 241, 0, 26, 27, 236, 219, 247, 102, 161, 239, 29, 3, 220, 73, 142}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 35, 73, 220, 154, 204, 111, 2}, 36},
	{{210, 241, 0, 0, 86, 114, 117, 254, 220, 8, 186, 228, 136, 240, 91, 83}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 55, 99, 7}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 208, 48, 128, 85, 138, 8, 126, 164}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 227, 58}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 208}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 10, 200, 46, 192, 179, 75, 66, 228, 184}, 36},
	{{210, 241, 0, 0, 0, 18, 24, 193, 73, 5, 22, 228, 78, 32, 74, 62}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 196, 241, 243, 42, 4, 132, 30, 82, 84}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 103, 126, 54, 246, 63, 21, 131, 165, 105}, 36},
	{{210, 241, 0, 134, 114, 198, 37, 133, 92, 169, 96, 226, 176, 202, 166, 245}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 205, 235, 202, 149, 177, 144, 111}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 179, 12, 81, 205, 113, 8, 112, 51, 142}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 201, 76, 180, 45, 122, 13, 19, 13}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 191, 144}, 36},
	{{210, 241, 0, 0, 0, 5, 88, 109, 102, 84, 231, 201, 1, 212, 50, 233}, 36},
	{{210, 241, 0, 0, 0, 30, 29, 13, 227, 209, 122, 225, 6, 113, 79, 229}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 142, 14}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 88, 82, 38, 46, 47, 172, 91}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 75, 12, 134, 195, 229, 76, 205, 105}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 39, 124, 76}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 22, 249, 232, 160, 27, 48, 195, 226, 225}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 195, 104, 56}, 36},
	{{210, 241, 0, 0, 0, 91, 210, 82, 94, 199, 134, 253, 101, 95, 72, 17}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 174, 207, 48, 60}, 36},
	{{210, 241, 0, 41, 228, 111, 179, 97, 239, 252, 220, 223, 75, 125, 162, 3}, 36},
	{{210, 241, 0, 0, 0, 7, 81, 168, 183, 24, 215, 142, 20, 8, 60, 161}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 3}, 36},
	{{210, 241, 0, 0, 55, 191, 125, 253, 223, 63, 247, 70, 131, 162, 44, 246}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 141, 114}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 173, 48, 250, 21, 46, 219, 238, 231}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 161}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 199, 68, 130, 155, 253, 233, 24, 13, 109}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 150, 119, 133, 146, 0, 35}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 132, 208, 216, 198}, 36},
	{{210, 241, 0, 0, 0, 0, 37, 28, 132, 186, 158, 33, 127, 222, 212, 139}, 36},
	{{210, 241, 0, 0, 97, 200, 140, 40, 232, 1, 115, 12, 175, 86, 18, 19}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 81, 8, 246, 143, 43, 7, 117}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 7, 35, 48, 44, 151, 73, 207, 46}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 168, 14, 154, 138, 48, 252, 120, 51, 162}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 114, 249}, 36},
	{{210, 241, 0, 0, 0, 0, 0, 0, 0, 0, 113, 150, 9, 71, 138, 22}, 36},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 1}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 250, 153, 37}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 20, 24, 219, 149}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 165, 47, 225, 134}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 151}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 56}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 210}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 7}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 234, 233, 242}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 58, 239, 233}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 244, 198, 174, 107}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 191}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 115, 212}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 212, 145, 62}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 154}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 135, 249, 16, 222}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 171, 24, 199}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 155, 220}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 83, 102, 120}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 151, 115, 236}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 225, 170, 16}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 115, 149}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 97}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 95, 40, 150}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 53, 122, 103}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 75}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 95}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 122, 96}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 166, 224, 132, 137}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 163}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 40, 239}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 162}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 203}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 49, 63}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 77, 246, 125}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 58, 181}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 119}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 87, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 195, 208, 78}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 222, 93}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 13, 224, 38}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 53, 150}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 88}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 211}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 33, 144, 134}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 229, 181, 34, 9}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 88}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 241, 81, 178}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 228, 200}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 23, 53, 137, 99}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 183}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 116, 74, 250}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 18, 137, 255}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 36, 56}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 231, 183, 34}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 113, 126, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 204}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 140, 74}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 146, 41}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 201}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 224, 20, 250}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 90, 122}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 84, 219, 5}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 26, 228, 117}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 155, 230, 107}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 241}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 130}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 84, 148, 69, 54}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 150, 103, 26}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 0, 0}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 77, 103, 188}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 213, 27}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 50, 201, 30}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 209, 194}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 120, 202, 192}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 57, 117}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 67, 118}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 0, 127, 61}, 41},
	{{52, 222, 249, 31, 108, 137, 199, 1, 242, 173, 184, 144, 0, 84, 108, 168}, 41},
	{{123, 111, 88, 192, 69, 70, 0, 227, 195, 110, 175, 184, 162, 126, 92, 126}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 130, 193, 230, 161, 184, 27, 81}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 187, 198, 82, 165, 18, 239}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 77, 132, 117, 187, 213, 191, 25, 38}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 8, 119, 2}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 110, 17, 98, 126, 179}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 164, 238, 43, 45, 151, 236, 27}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 136, 226, 246, 39, 15}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 242, 131, 163}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 196, 221, 123, 46, 134}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 155, 164, 63, 52, 135}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 196, 182, 79, 215, 108, 158, 178, 131, 12}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 254, 46, 126}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 98, 152, 172, 30, 31}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 176, 1, 11, 7}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 141, 196, 28, 205, 9, 198, 167, 105, 15}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 116, 143, 146, 244, 226, 175, 163, 82}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 204, 199, 59, 133, 54, 173, 131, 234}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 105, 82, 167, 179}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 19, 134}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 81, 104, 132, 148, 172, 198, 189, 169}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 46, 145, 44, 36, 161, 199, 83, 79, 217}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 168, 120, 139, 105, 47, 105, 146}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 111, 114, 247, 254, 201, 209}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 222, 233, 109, 206, 108, 206, 10, 207}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 238, 176, 161, 68, 182, 254, 41, 245}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 121, 47, 129, 230, 38, 72, 79, 26, 134}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 235, 122, 140, 189}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 176, 63, 57, 21, 164, 167, 80, 94, 193}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 169, 215, 249, 195, 32}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 34, 17, 24, 2, 21, 190, 128}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 126, 66, 218, 158, 150, 106}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 27, 88, 58, 118, 177, 231}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 167, 159, 242, 75, 65, 56, 78}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 39, 126}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 225, 164, 170, 71}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 228, 11, 119, 140, 115, 37, 142, 112}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 107, 70, 66, 62}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 170, 161}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 161, 12, 84}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 49, 55, 81, 175}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 40, 95, 45, 204, 252, 251, 189, 142}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 112, 237, 130, 209, 141, 37, 21}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 226, 3, 5, 168, 150}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 178, 152, 79, 105, 6, 230, 238}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 202, 185, 235, 87, 57, 243}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 200, 50}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 154, 17, 161, 219, 108, 37}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 248, 138, 195, 72, 191, 150, 40}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 37, 119, 23, 86, 75, 39, 18, 179}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 188, 230, 156}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 45, 129, 81, 196, 222, 58, 187, 188, 139}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 111, 68, 29, 194, 23, 90, 33, 224}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 24, 221, 21, 16, 104, 180, 182, 121, 19}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 216, 148}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 18, 211, 237, 187, 221, 189, 231}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 220, 78, 37, 160, 204, 236}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 185, 202}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 162, 212, 156, 239, 19, 214}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 25, 219}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 226, 83, 161, 207, 214, 13, 130, 37}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 253, 81, 134, 181, 218, 130, 120}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 158, 179, 242, 132, 27, 193, 189}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 63, 12, 28, 221, 151}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 139, 118, 79}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 231, 199, 28, 203, 139, 137, 59}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 182, 237}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 234, 236, 33}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 68, 169, 120, 115, 241, 171}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 154, 122, 245, 251, 236, 178, 63, 207}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 100, 176, 150, 219, 86, 179}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 69, 210, 32, 247, 161, 8, 209}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 172, 17, 81, 0}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 0, 0, 0, 56, 133}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 6, 208, 62, 221, 4, 158, 57}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 74, 120, 192, 110, 181, 84, 55, 14, 112}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 242, 105, 98, 181, 119}, 70},
	{{123, 111, 88, 192, 69, 70, 0, 0, 0, 0, 0, 58, 39, 53, 89, 6}, 70},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 197, 156, 167}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 128, 52, 132, 204, 19}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 73}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 14, 231}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 25, 252}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 62, 170, 78}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 142}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 246, 252, 29, 122, 138, 210, 121}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 224, 244, 28, 131, 194, 15}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 98, 152, 132, 170, 216, 89, 124}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 145, 249, 73, 39, 121, 22}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 9, 23, 213, 168, 114, 11, 169}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 208}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 46, 142}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 118, 123, 182, 255, 202}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 204, 91}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 43, 168, 10, 21}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 122, 184, 96, 25, 9, 139, 73}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 212, 97, 192}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 168, 19, 238, 69, 98, 153}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 186, 138, 9, 153}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 92, 20, 4, 111, 75, 113}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 42, 239, 77, 200}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 191, 124, 33, 68}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 4, 143, 17}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 237}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 133, 151, 252, 140}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 89, 138, 34, 174, 154}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 77, 58, 169, 125, 185, 42}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 56, 182, 208, 149, 200}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 178}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 75, 86, 216}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 190, 117, 231, 208, 47}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 11, 232, 219, 148}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 98, 89, 42, 142}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 140, 102}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 54, 164, 192}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 59, 132, 241}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 139, 93, 228}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 37, 167, 64, 62, 95, 98}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 84}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 212, 2}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 244, 81, 127, 148, 127, 61}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 226, 185}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 161}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 99}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 140, 92}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 107, 197, 185, 220, 26, 54}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 22}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 188, 181, 196, 86}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 157, 151, 129, 29, 136, 115, 22}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 210, 182, 33, 77, 62, 202}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 248, 223, 49, 240, 249, 200}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 9, 231, 162, 104, 157}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 107, 61, 12, 134, 110}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 60, 36, 117, 114, 166}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 209, 245, 213, 113}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 10, 115, 121, 193, 59}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 114}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 90, 110, 232, 255}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 128, 71, 65, 88, 0, 220, 238}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 180, 42, 116, 154}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 132, 156, 131, 188, 230, 108}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 12, 224, 17}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 104, 108, 240, 227, 26}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 119}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 14, 63, 216, 105, 78}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 224}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 177, 120, 141}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 157, 38, 36, 152, 16, 240}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 213, 16, 236, 78, 174, 135, 115}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 184, 238, 27, 179}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 102, 95, 155, 93, 204, 177}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 236, 114, 69, 148, 244, 249, 24}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 132, 191, 133, 75, 81, 110}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 74, 252, 134, 7}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 96, 10, 55, 1, 105, 194}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 159, 58}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 0}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 42, 236, 53, 61, 179, 252}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 220, 180}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 132, 60, 128, 233, 232}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 250, 149, 163, 247}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 83, 218, 12, 217, 150}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 160}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 132}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 203, 0, 190, 195, 10}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 205, 12, 246, 40, 218, 96, 117, 217}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 0, 137}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 94, 114, 123, 30, 198}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 124, 19, 7, 240, 103, 36}, 218},
	{{180, 82, 188, 125, 140, 8, 196, 74, 0, 0, 0, 0, 0, 0, 119, 134}, 218},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{77, 158, 34, 101, 196, 102, 56, 220, 42, 143, 181, 187, 240, 64, 161, 0}, 226},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 57}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 98}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 215}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 188}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 154}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 208}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 184}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 40}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 123}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 204}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 242}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 72}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 65}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 11}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 95}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 246}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 207}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 209}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 127}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 230}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 139}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 42}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 49}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 212}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 127}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 88}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 113}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 54}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 31}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 45}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 254}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 50}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 4}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 127}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 158}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 216}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 113}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 26}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{88, 220, 222, 38, 23, 108, 5, 148, 185, 110, 20, 14, 67, 61, 0, 0}, 25},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 65, 217, 96}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 96, 199, 88}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 42}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 236}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 120}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 133, 95}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 207, 226}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 33, 82, 174}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 65, 3}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 74, 127, 25}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 242, 245, 46}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 14}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 163, 41, 85}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 169, 30}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 41, 238}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 141}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 238, 32}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 142, 138}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 92, 6}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 43, 133, 212}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 219}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 103, 110, 244}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 93}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 73, 163, 118}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 193}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 178, 105}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 194}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 130, 50}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 87, 61}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 108}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 193, 68}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 29, 18}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 61}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 140, 166}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 169}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 226, 36, 76}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 63}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 122, 23}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 181}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 30}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 184}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 111}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 22, 233, 97}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 244, 69}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 24, 174}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 14}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 35, 73, 248}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 30, 131}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 38, 235, 63}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 204, 161}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 75}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 224, 228}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 127}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 21, 133}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 174, 250, 222}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 15, 87, 42}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 99, 8}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 55, 138}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 41, 124}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 231, 145}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 93, 237, 104}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 148}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 84}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 187, 214}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 162}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 123}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 191, 1}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 42, 31, 241}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 105, 166}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 120}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 0}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 0, 191}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 221, 19}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 32, 74, 32}, 6},
	{{90, 65, 220, 165, 197, 133, 110, 92, 228, 19, 2, 17, 0, 0, 29, 103}, 6},
	{{35, 32, 0, 0, 0, 0, 100, 32, 206, 154, 164, 220, 235, 241, 8, 199}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 91, 151, 67, 56, 244, 213}, 26},
	{{35, 32, 0, 0, 0, 214, 101, 42, 251, 22, 161, 202, 71, 208, 147, 241}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 187, 139, 44, 195, 181, 239}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 117, 182, 186, 64, 248, 185}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 120}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 34, 106, 252, 55, 153, 155, 108}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 141}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 133, 9, 171, 220, 84, 129, 73}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 33, 136}, 26},
	{{35, 32, 0, 0, 133, 225, 177, 195, 206, 239, 66, 110, 160, 201, 137, 106}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 140, 132, 144, 226, 229, 92}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 181, 104, 193, 134, 241, 204, 141, 161}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 19, 120, 5}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 149, 241, 29, 107, 164, 229, 198}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 134, 128, 146, 86, 235, 254, 190, 76}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 212, 106, 2, 238, 80, 184, 135, 236}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 173, 223, 215}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 71, 194, 98, 236}, 26},
	{{35, 32, 0, 0, 91, 0, 122, 82, 82, 14, 191, 28, 207, 109, 248, 254}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 206}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 159, 189, 145, 121}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 170, 234, 18, 163, 212, 193, 74}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 161, 175}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 241, 201, 123, 129}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 107, 75}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 26},
	{{35, 32, 0, 0, 128, 130, 215, 152, 20, 193, 48, 220, 74, 216, 110, 21}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 145, 133, 43, 192, 184, 5, 101}, 26},
	{{35, 32, 0, 155, 227, 84, 195, 220, 147, 54, 211, 199, 128, 28, 41, 160}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 61, 77, 228, 3, 169, 89, 191, 73}, 26},
	{{35, 32, 0, 0, 18, 10, 207, 5, 59, 47, 155, 32, 30, 134, 180, 158}, 26},
	{{35, 32, 0, 0, 0, 130, 167, 95, 97, 14, 155, 69, 205, 177, 188, 45}, 26},
	{{35, 32, 0, 0, 61, 136, 157, 160, 222, 125, 228, 160, 253, 108, 172, 220}, 26},
	{{35, 32, 128, 125, 246, 104, 190, 226, 27, 245, 111, 83, 83, 154, 168, 183}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 100, 10, 142, 56, 193, 33, 226, 244}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 77, 158, 52, 205, 233, 102}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 211, 82}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{35, 32, 0, 106, 133, 91, 68, 43, 239, 125, 13, 20, 247, 223, 43, 59}, 26},
	{{35, 32, 0, 0, 168, 101, 9, 173, 163, 255, 44, 77, 167, 31, 158, 31}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 27, 214, 178, 126, 40, 96, 115, 2}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 254, 224, 33, 71, 64, 223, 245}, 26},
	{{35, 32, 0, 0, 0, 0, 5, 210, 37, 57, 194, 172, 215, 35, 148, 201}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 58, 4, 248, 140, 161, 106, 171, 161, 239}, 26},
	{{35, 32, 0, 0, 0, 0, 78, 87, 230, 32, 210, 239, 225, 149, 176, 132}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 52, 50, 66, 217, 125, 234}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 186, 127, 87, 72, 81, 74, 77, 189, 23}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 82, 251, 148, 133, 218, 194}, 26},
	{{35, 32, 0, 0, 0, 239, 87, 136, 40, 67, 194, 62, 120, 190, 84, 142}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232}, 26},
	{{35, 32, 0, 0, 0, 100, 189, 139, 36, 46, 173, 41, 236, 57, 22, 111}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 83, 173, 63}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 49, 236, 12, 189, 30, 119, 221, 180, 40}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 180, 74, 58, 17, 78, 133}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 229, 188, 10, 215}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 73, 70, 29, 199, 12, 238}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 112, 106}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 43}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 26},
	{{35, 32, 42, 136, 160, 3, 124, 132, 192, 97, 144, 82, 184, 9, 196, 137}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 100, 72, 58}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{35, 32, 0, 0, 0, 156, 200, 231, 166, 149, 31, 78, 216, 193, 134, 31}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 11, 178}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 233, 248, 2, 49, 130, 234, 255, 222, 139}, 26},
	{{35, 32, 0, 0, 109, 214, 10, 129, 163, 28, 70, 182, 148, 8, 231, 225}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 194, 49, 254, 216, 155, 217}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 142, 143, 170, 135, 162, 72}, 26},
	{{35, 32, 0, 0, 0, 0, 14, 83, 198, 49, 116, 220, 62, 220, 211, 38}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 160, 123, 127, 20, 154, 118, 61, 88}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 108, 102, 85, 30, 80, 194, 169, 241, 117}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 149, 48, 241, 88, 214, 192}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 13, 100, 97, 118, 5, 29, 214, 167, 12}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 236, 122, 87, 217}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 107, 193}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 188, 237, 144, 167, 47, 82, 245, 135, 100}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 43, 86, 134, 41, 214, 207}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 64, 65, 231, 66, 9, 74, 236, 11, 33}, 26},
	{{35, 32, 0, 0, 0, 0, 16, 110, 76, 227, 171, 53, 99, 46, 216, 244}, 26},
	{{35, 32, 0, 0, 65, 19, 89, 234, 41, 78, 3, 238, 72, 106, 120, 150}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 198, 65, 157}, 26},
	{{35, 32, 0, 0, 0, 0, 44, 150, 196, 4, 42, 220, 105, 102, 66, 99}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 55, 99, 242, 38, 13, 14}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 129, 114, 90, 176, 54, 52}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 141, 222, 12, 252}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 197, 48, 92, 34, 240, 241}, 26},
	{{35, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 54, 210, 208, 29}, 26},
	{{35, 32, 0, 0, 0, 60, 113, 135, 75, 112, 169, 254, 7, 198, 166, 108}, 26},
	{{103, 123, 49, 209, 228, 229, 144, 0, 201, 41, 134, 229, 228, 239, 24, 162}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 95, 51}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 170, 142, 21, 109, 245, 55, 166, 248}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 33, 210, 147, 84, 207}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 182}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 250, 32, 89}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 68, 89, 181, 38, 31, 69, 212}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 113}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 46, 210, 48, 70, 0}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 26, 36, 15, 51, 66, 151}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 159, 105, 27}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 196, 88, 107, 64, 70, 31, 127}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 89, 244, 187, 12, 140, 174, 246}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 71, 172, 184, 99, 34, 170}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 227, 86, 130, 51, 220, 41, 60}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 88, 167, 78, 0}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 203, 150, 142}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 185, 111, 50, 100, 213, 138, 78, 29, 30}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 151, 170, 198, 132, 11, 67, 227, 122, 148}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 157}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 27, 159, 61, 215}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 120, 251, 24, 248}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 126, 2, 46, 189}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 135, 2, 73}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 187, 181, 155, 146, 74}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 176, 76, 167}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 221, 204, 39, 94, 192}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 12, 20, 85, 159, 148, 106, 170}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 95, 245}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 26, 148, 93}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 238, 212, 217, 14, 101}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 209, 238, 246, 206}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 182, 92, 52}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 211, 75, 80}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 66, 162}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 79, 162, 120, 98, 248, 27, 187, 6, 32}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 223, 90, 61, 111, 133, 195, 16}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 218, 155, 212, 88, 122}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 250, 228, 238, 196}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 181, 68, 79, 173, 249, 128, 77}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 91, 33, 186, 151, 113}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 83}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 91, 2, 232}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 22, 43, 88, 68}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 58, 52, 55, 238, 52, 78}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 120, 24, 213, 37, 187}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 181, 136, 87, 225, 198, 145, 31, 180}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 120, 7, 97, 64, 218, 167, 225, 86}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 10, 184, 251, 86, 196, 126}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 117, 219}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 112, 16, 235}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 59, 245, 172, 166, 109, 138, 183}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 48, 92, 89}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 255, 233, 117}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 12, 45, 198, 62}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 200, 119, 28, 101, 189, 23, 135, 115}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 12, 253}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 107, 117, 221, 119}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 230, 34, 132, 51, 87, 230, 207, 187, 141}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 238, 101}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 238, 222}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 195, 66, 97}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 49, 92, 17, 226, 10}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 160, 149, 127, 199, 239}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 226, 75, 98, 237}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 130, 36, 176, 104, 54, 27}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 143, 168, 44, 172, 18, 251, 164, 69}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 226}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 176, 146, 96, 223, 131}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 183, 138, 16, 220, 50, 198}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 35, 165, 181, 27}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 242, 25, 111, 138}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 215, 169, 9, 196}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 196, 121, 167, 210, 70, 194, 126, 198, 234}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 172, 152, 252, 78, 18, 193}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 197}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 111, 49}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 52, 52, 57, 103, 185, 209, 173}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 133, 234, 111, 124, 140, 112}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 82, 21}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 109, 250, 222, 243}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 174, 177}, 149},
	{{103, 123, 49, 209, 228, 229, 144, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 149},
	{{50, 244, 58, 191, 95, 156, 0, 227, 150, 151, 92, 212, 102, 38, 142, 157}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 83, 76, 97, 60, 105, 121, 169}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 166, 53, 4, 192}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 91, 202, 184, 97, 78, 1}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 49, 156, 249, 20, 60, 2}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 92, 21, 10, 99, 49}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 78, 17, 189, 58}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 168, 241, 213, 190, 173, 75, 212}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 156, 118, 166, 128, 188, 208, 16}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 217, 13, 77, 176, 204}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 161, 137, 106, 7, 26, 179, 67}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 32, 165, 249, 47, 81, 129, 66, 150, 158}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 232, 133, 16, 143, 221, 67}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 83, 144, 151, 8}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 10, 194, 178, 32, 220, 47, 219, 110}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 145, 88, 211}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 123, 218, 106}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 224, 30, 176, 248, 142}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 31, 95, 221, 160, 69}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 97, 234, 247, 33, 94, 40, 215}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 169, 18, 37, 231, 27, 179, 252, 188, 221}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 104, 181, 23}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 199, 216, 146, 83, 53, 54, 124, 30, 174}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 123, 182, 64}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 238, 192}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 183, 131}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 212, 34, 226, 235}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 26, 171, 235}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 238, 179, 190, 128, 10, 108, 181, 202, 78}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 54, 35, 102, 147, 78, 89, 99}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 64, 164}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 44, 93, 141, 126, 247, 163}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 52, 166, 175, 193, 48, 46}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 66, 46, 172, 187, 206, 59, 104, 209}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 163, 69}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 230, 200, 148}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 167, 198, 90, 207}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 198, 43, 107, 82, 99}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 166, 104, 142, 233, 21, 72, 63}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 110, 105, 8, 7, 220, 180}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 124, 165, 125, 165, 21, 208, 43}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 177, 88, 147, 91, 226, 153, 125, 144}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 10, 163}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 140, 14}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 249, 8, 38, 110, 53}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 204, 161, 225}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 167, 17, 90, 170}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 207, 143, 190, 156, 221}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 58, 203, 198, 67, 48}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 154, 159, 162, 182, 175, 158, 104, 109, 251}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 192, 32, 190, 1}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 189, 226, 215, 188}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 73, 29, 35, 136, 154, 117, 171}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 132, 198, 21, 145, 204, 239, 70}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 8, 232, 98, 237, 18, 196}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 66, 198, 193, 146, 192, 137}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 40, 55, 163, 243, 30, 207, 28, 7}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 88, 124, 139, 124, 248, 186, 120, 11}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 108, 133}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 122, 177, 132}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 217, 199, 184}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 213, 230, 152}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 249, 119, 93, 217, 98, 147, 143, 102, 144}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 169, 111}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 216, 182, 139, 9, 31, 78, 251}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 13, 4, 214, 104, 117, 32}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 236, 15, 227, 139, 57, 138, 146}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 138, 95, 210, 92, 195, 118}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 12, 197, 130, 192, 6, 91, 222}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 98, 125, 213}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 169, 132, 116, 50, 20}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 162, 192, 197, 223, 82, 249, 189, 232, 6}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 235, 28, 178, 197, 224}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 180, 97, 175, 3, 3, 196}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 153, 30, 57, 89}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 6, 112, 208, 151, 181}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 181, 50, 119}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 205, 166, 211, 180}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 152, 251, 80}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 113, 177, 243, 62}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 170, 104, 55, 123, 153, 32}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 238, 135, 216, 120, 19, 188, 22}, 127},
	{{50, 244, 58, 191, 95, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 127},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 38, 230, 166}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 125, 81}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 95, 132}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 159, 53, 142, 40, 29, 81}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 177, 197, 219}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 224, 252, 124, 101, 156, 77, 53, 112}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 61, 48, 241}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 114, 195, 224, 153, 2, 35, 251}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 20, 180}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 67, 66, 124, 110, 227, 67}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 43}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 7, 48, 166, 217, 104, 203, 210}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 226, 92, 84, 206, 99}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 169}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 50, 145, 69, 115, 81}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 242, 188, 73}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 61, 169, 58, 22, 99, 196}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 210, 75, 198, 211, 186, 255, 62}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 21, 158, 206, 59, 131, 162}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 97, 183}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 23}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 212, 196, 127, 169, 250, 132}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 112, 212, 79, 55, 231}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 251, 33, 206, 179, 158, 157, 93, 26}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 59}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 134, 187, 51, 72, 172}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 103}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 193, 7, 232, 251, 142}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 136, 120, 43}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 176, 22, 105, 250, 135, 213, 209}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 172, 161, 239, 237, 55, 6}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 53, 197, 174, 33, 159}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 186, 222, 205, 231, 183, 133, 91}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 245, 254, 172, 109, 224}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 143, 236}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 157, 183, 74, 16, 4}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 178}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 115}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 69, 249, 152, 70, 92, 234, 42}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 93, 10, 215, 53, 202}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 220, 238, 72}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 36, 249, 112, 174, 203, 54}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 230, 128, 75, 53, 75, 85, 167}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 88, 21, 199, 67, 206, 109}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 165}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 220, 68, 200, 165, 26, 186}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 152, 11, 234, 123, 89}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 217, 1}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 79, 37, 241, 190, 40, 73, 72, 2}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 242, 71, 150, 160, 115, 198, 182}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 98, 8, 229, 169, 144}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 248, 197, 87, 156}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 90, 163}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 194}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 201}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 24, 193, 236}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 64, 54, 217, 154, 63}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 174, 41}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 180, 87}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 219, 225, 80, 20, 119, 251, 246}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 58, 21}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 131, 210, 151, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 89, 238, 246, 123, 52, 7}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 31, 136, 81, 0, 189, 161, 53}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 121, 19, 176, 221, 115, 74, 245, 172}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 9, 83, 197, 5, 150, 183}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 204, 197}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 48, 238, 185, 52, 50, 68}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 92, 6, 97, 38, 66}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 149}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 1, 154, 186}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 142, 74, 23}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 63, 212, 44, 218, 127}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 209, 187, 147}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 166, 255, 0, 200, 77}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 79, 76, 250, 214, 173, 148}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 53, 36, 5, 229, 24, 48, 109}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 197}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 60, 195, 26}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 159, 130, 14, 85, 73, 89}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 163, 141, 253, 76, 39}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 127, 31, 80, 204, 230, 47, 221}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 174, 133, 245}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 0, 0, 0, 181, 136, 4}, 144},
	{{140, 169, 75, 77, 78, 86, 40, 16, 0, 0, 241, 4, 114, 27, 24, 77}, 144},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 196, 82, 127, 42, 97, 28}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 201, 12}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 175, 121, 188, 34}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 223, 179, 33, 141, 151, 155, 111}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 209, 222, 231, 210}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 1, 126, 122, 36, 106, 110, 236, 103}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 10, 148, 110, 254, 92}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 72, 186, 217}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 201, 165, 46, 17, 39, 200, 156, 141}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 64, 65, 34, 209, 26, 83, 51}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 167, 93, 11}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 14, 197, 181, 189, 8, 124, 246}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 216, 106, 64, 69, 207, 253, 147}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 184, 111, 121, 233, 221, 255}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 137}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 82, 198, 199, 185}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 107, 86, 141, 121, 180, 150, 118}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 212, 106, 187, 66, 151}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 142, 175, 95}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 207, 110, 194, 39, 18, 60, 122, 254}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 211, 27, 144, 193}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 153, 107, 8, 41, 216, 255}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 19, 233, 52}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 118, 60, 159, 6, 99, 106}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 197, 228, 252, 24, 19}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 247, 184, 133, 107, 81}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 12, 168, 249}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 227, 105, 75, 149}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 129, 96, 37, 46}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 104, 158}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 123}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 209, 221, 213}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 60, 82, 94, 26, 66, 151}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 105, 144}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 238, 186, 203, 10, 168, 29, 218, 142}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 242, 116, 124, 227}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 244, 111, 28}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 50, 178, 217, 234, 159, 41, 189, 136}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 89, 135, 134, 70, 118, 227}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 134, 204, 20, 73, 234, 122, 7, 34}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 9, 153, 216, 1, 20, 105, 3}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 160, 6, 200, 89}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 82, 44, 181}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 151, 128}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 144, 55, 63, 38, 67, 33}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 131, 188, 66, 194, 136}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 236, 253}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 146, 34, 247, 62, 227}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 152, 80, 97, 169, 44, 24, 124, 227}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 65, 121, 94, 92, 42, 219, 22, 68}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 11, 84}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 126, 71, 135, 213, 118}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 18, 203}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 243, 126, 218, 82, 122, 8}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 201, 180, 0, 102, 127, 180, 56, 117}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 109, 133}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 185, 217, 35, 39}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 196, 240, 116, 48, 218, 162, 216, 101}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 45, 172, 69, 45, 102, 213, 50, 45}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 98, 246, 86}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 175, 29, 7, 197, 76, 30, 134}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 78}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 111, 4, 143, 40, 208}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 96, 124, 82, 155, 0, 229, 220}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 76, 164, 95, 163}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 144, 137, 140, 12, 169}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 25, 45, 94, 97}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 7, 56, 37, 135}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 212, 17, 68, 74, 145, 54, 191}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 22, 58, 218, 135, 68, 186, 87, 211}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 1, 252}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 108, 50, 112, 255, 114, 122, 69}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 177, 69, 35, 75, 145, 25, 95}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 38, 156, 50, 23, 126, 124}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 27, 252}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 63, 132, 117, 242, 94, 3, 211, 123}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 106, 205, 114, 44, 76, 191}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 35, 6, 252, 105}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 202, 107, 91, 87}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 81}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 3, 37, 218, 101, 254, 30}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 14, 44, 111, 88, 245, 90}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 234, 215, 130}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 240, 68, 98, 4, 173}, 213},
	{{99, 176, 175, 83, 114, 50, 214, 0, 0, 0, 0, 0, 100, 73, 48, 225}, 213},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 41, 126, 110, 68, 146, 198}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 40, 103, 93}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 212, 31, 148, 193, 141}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 19, 3, 190, 85, 150}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 61, 31, 165, 59, 12}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 150, 100}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 9, 214}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 8, 238, 40, 245}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 110, 184, 246, 222, 254}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 14, 15, 184}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 40, 224, 41}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 155, 106, 183, 61, 130, 92, 198}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 184, 33, 22}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 130, 174, 254, 149, 38, 203}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 114, 57}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 24, 212, 118, 125, 171, 186}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 93, 77, 78, 136, 127, 166, 147}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 35, 106, 131, 161, 232}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 15, 111}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 151, 44}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 251, 12}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 93, 77, 118, 244, 23, 24, 215}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 135, 251, 254, 157, 173, 148, 82}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 191, 152, 96, 213, 238, 169}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 115, 146, 151, 223}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 238, 182, 37, 115}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 88, 255, 56}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 42, 37, 142, 154}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 80, 227, 68}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 46, 49, 239}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 177, 55, 254, 129}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 16, 111, 150, 3}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 230, 84, 190, 93}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 179, 77, 124, 31, 253, 239}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 173, 116, 113}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 78, 22, 113, 177, 34, 150, 4}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 237, 251, 144, 230, 55, 254, 94, 186}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 184, 168, 254, 246, 122, 142}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 161, 72, 23, 86, 27, 128, 243, 226}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 190, 16, 229, 85, 154, 152}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 41, 58, 75}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 216, 88, 60, 152, 129, 115, 185}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 140, 87, 7, 196, 215, 216, 99}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 111, 157}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 71, 193, 132, 143, 1}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 244, 198, 131, 102, 223, 190, 215}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 184, 55, 211, 191}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 90, 248, 159, 75, 15}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 91, 123, 249, 123, 211}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 233, 9, 196, 203, 162, 153, 175}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 28, 161, 231}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 65}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 38, 31, 223, 150}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 237, 155, 7}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 48}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 120, 29, 213}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 65, 135}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 116, 137, 210, 45, 118}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 139, 183, 92, 163, 230}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 1, 93, 221, 172, 138}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 22, 120, 112, 245, 47}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 186, 109, 128, 60, 91, 103}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 70, 217, 198, 212, 71, 193}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 217, 130, 210, 129, 3, 164, 42, 117}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 176, 54, 219, 58, 55, 235, 204, 220}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 172}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 63, 10, 77, 135, 87}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 180, 225}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 125}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 221, 19, 160, 252, 69, 6, 99}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 243, 220}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 0}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 153, 98, 22, 203, 33, 72}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 149}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 161}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 61, 212, 96, 214, 66}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 60}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 26, 32, 30, 185, 204, 71}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 248, 99, 107, 112, 92, 49, 99}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 0, 0, 0, 0, 0, 7}, 115},
	{{19, 208, 211, 76, 85, 176, 247, 64, 0, 0, 81, 121, 5, 85, 6, 254}, 115},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 118, 44, 190, 248}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 10, 83}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 75, 65}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 215, 195, 187}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 245, 72}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 89, 165, 181, 97, 164}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 215, 172, 221}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 68}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 38}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 79, 136, 122, 58}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 219, 217, 176, 149, 133}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 170, 139}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 2, 191, 135, 156, 174}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 189, 34, 5, 236}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 184, 191, 117}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 134, 142}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 165, 55}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 186, 64}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 163, 151, 158, 221}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 83, 29, 49}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 128, 153, 9, 9}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 68}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 85, 152, 181, 37}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 122, 45, 61, 229}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 214, 178}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 235, 30, 91, 180, 192}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 129, 113, 28}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 182, 25, 6}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 232}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 84}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 190, 19, 187}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 251, 4, 32}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 142, 214}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 40, 167, 7, 115}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 68, 206, 22, 17}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 205, 122}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 11, 210, 153, 232}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 173}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 29, 16, 148, 159, 95}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 111, 29}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 32, 178}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 189, 187, 224}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 44, 16, 148}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 189, 133, 26}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 182, 48, 149, 52, 120}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 249, 215}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 168}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 77, 171, 136, 123, 10}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 68, 245, 241}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 13, 111, 220, 176}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 253, 52, 118, 221, 104}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 1, 192}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 8, 32, 172, 134, 246}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 103, 167}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 97, 40, 196, 85, 181}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 95, 91, 228, 59}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 105, 250}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 129, 223, 102, 246}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 170, 89}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 193, 184, 15, 56, 121}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 196, 1, 168}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 161, 23}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 154, 182}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 166, 225}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 123, 86}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 28, 127}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 180, 45}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 79, 61, 63, 83}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 16, 2, 73, 180}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 189, 214}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 225, 45}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 254, 151, 254, 136}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 25}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 7}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 215, 48, 142}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 174}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 98, 207, 62, 232, 75}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 63, 231}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 107, 152, 181, 152}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 207}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 229, 120, 161}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 155, 178, 232}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 13}, 146},
	{{153, 28, 188, 113, 211, 116, 7, 178, 136, 205, 96, 0, 0, 0, 0, 0}, 146},
	{{160, 180, 220, 128, 0, 0, 0, 107, 211, 242, 150, 80, 1, 6, 54, 177}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 26, 122, 143, 105, 131, 211, 249, 203, 117}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 92, 191, 194, 54, 149, 138, 37, 145}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 142, 141, 238, 163, 189, 22, 232, 166, 111}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 31, 145, 55, 122, 198}, 58},
	{{160, 180, 220, 128, 0, 202, 188, 159, 203, 167, 27, 2, 240, 116, 157, 168}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 132, 37, 70, 137, 31, 84, 243, 12, 13}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 165, 253, 198, 54, 125, 169, 156}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 34}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 139}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 41, 127, 88, 57, 24}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 152, 188, 162, 163, 191}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 58},
	{{160, 180, 220, 128, 138, 171, 171, 167, 28, 62, 80, 38, 38, 90, 18, 52}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 247, 221, 166, 73, 217, 222, 202, 62}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 114, 81, 217, 160, 236}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 97, 85, 217, 237, 94, 180, 7}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 79, 54, 119, 15, 19, 126, 194, 182}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 194, 3, 138, 228, 85, 9, 186, 31}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 34, 240, 250, 214}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 200, 7}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 177, 120, 129, 53, 61}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 152, 140, 125, 77}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 249, 105, 161, 236, 254, 202, 239}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 112, 222, 143, 176, 75, 58, 18, 28}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 177, 110, 217, 134, 233, 234, 70}, 58},
	{{160, 180, 220, 128, 0, 42, 217, 181, 186, 177, 7, 90, 122, 246, 56, 101}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 182, 100, 226, 130, 202}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 188, 141}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 213, 251, 212, 173, 197, 236, 31, 132, 221}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 137, 130, 73, 253, 220, 29}, 58},
	{{160, 180, 220, 128, 0, 25, 88, 46, 73, 7, 155, 231, 60, 12, 218, 123}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 12, 79, 33, 158, 213, 85, 137, 162}, 58},
	{{160, 180, 220, 128, 0, 0, 38, 193, 169, 119, 166, 240, 218, 188, 45, 79}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 230, 92, 79, 102, 240, 240}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 13, 119, 23, 222, 101, 27, 140, 160}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 152, 98, 94, 159, 59, 156, 227, 92}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 69, 243}, 58},
	{{160, 180, 220, 128, 0, 0, 74, 176, 31, 204, 219, 67, 68, 213, 221, 51}, 58},
	{{160, 180, 220, 128, 0, 151, 86, 217, 203, 35, 151, 56, 159, 48, 182, 252}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 98, 189, 160, 219, 32}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 159, 84, 112, 87}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 171}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 53, 223, 146, 181}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 45, 25, 51, 164, 185, 238, 48, 249}, 58},
	{{160, 180, 220, 128, 0, 0, 97, 101, 231, 34, 85, 186, 216, 148, 54, 158}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 68}, 58},
	{{160, 180, 220, 128, 0, 0, 140, 185, 239, 149, 242, 76, 234, 51, 198, 52}, 58},
	{{160, 180, 220, 128, 0, 92, 120, 145, 50, 92, 250, 235, 254, 183, 11, 168}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 58},
	{{160, 180, 220, 128, 0, 0, 157, 105, 83, 76, 250, 56, 89, 133, 247, 142}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 141, 93, 245, 54, 34}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 22, 110, 78, 255}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 101}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 88, 240, 116, 78, 88, 41, 65, 59, 201}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 157, 139, 226, 131, 197, 233, 93}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 178, 43, 116, 182, 252, 200, 208, 173}, 58},
	{{160, 180, 220, 128, 0, 119, 30, 246, 107, 11, 170, 207, 147, 5, 0, 20}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 244, 134, 18, 205, 208, 181, 85, 250}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 118, 240}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 126, 98, 68, 131}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 142, 1, 183, 187, 37, 62}, 58},
	{{160, 180, 220, 128, 0, 219, 161, 53, 49, 4, 95, 58, 227, 83, 187, 41}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 84, 228}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 159}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 193, 169, 75, 4, 159, 157, 25, 234, 63}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 165}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 184, 31, 145, 22, 220, 243, 119, 18, 4}, 58},
	{{160, 180, 220, 128, 0, 0, 102, 198, 161, 214, 131, 213, 95, 132, 104, 244}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 217, 165, 128, 9}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 76, 55, 46, 207, 110, 50, 98, 126}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 156, 239, 154, 237, 227, 174, 169}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 154, 230, 243, 60, 95, 157}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 234, 22, 69, 113, 158, 240}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 108, 100, 200, 118, 149, 141, 133, 212}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 244, 153, 16, 193, 227, 141, 47, 247}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 102, 242}, 58},
	{{160, 180, 220, 128, 0, 0, 153, 18, 153, 225, 201, 98, 216, 89, 81, 134}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 144, 97, 197, 247, 79, 31, 235, 15, 203}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 211}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 171, 10, 217, 119, 84, 183, 126}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 234, 11, 200, 0, 142}, 58},
	{{160, 180, 220, 128, 250, 9, 141, 50, 69, 115, 190, 88, 190, 215, 135, 230}, 58},
	{{160, 180, 220, 128, 0, 53, 234, 161, 30, 155, 138, 230, 41, 23, 176, 52}, 58},
	{{160, 180, 220, 128, 0, 0, 54, 108, 21, 154, 148, 225, 62, 7, 21, 83}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 216}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 164, 190}, 58},
	{{160, 180, 220, 128, 0, 0, 102, 225, 36, 208, 124, 24, 157, 54, 33, 109}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 48}, 58},
	{{160, 180, 220, 128, 0, 0, 0, 0, 0, 0, 0, 54, 113, 27, 145, 184}, 58},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 186, 14, 148}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 144, 75, 153, 45, 173, 206, 147}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 108, 178, 176, 143, 207, 77}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 29, 211, 165, 226, 58, 243, 120, 64, 194}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 185, 32, 153, 13}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 171, 80, 1, 87, 223, 190}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 146, 236, 165, 192, 73, 0}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 9, 223, 121, 249, 67, 148}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 246, 205, 73}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 159, 132, 182}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 28, 182}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 30, 48}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 42, 120, 21, 173, 28, 114, 239}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 208, 109, 149, 0, 189, 29, 125, 144}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 68, 81, 84, 239, 170, 92, 231}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 190, 241, 6, 200}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 84, 141, 220}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 251, 148, 222, 190, 117, 133, 21, 32}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 168, 125, 15, 34, 157, 41}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 218, 171, 22, 185, 141, 198, 240, 138, 35}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 206, 148, 43, 151, 96, 131, 145, 125}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 169, 218, 19, 64, 70, 219, 47, 42, 210}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 77, 39, 254, 12, 175, 220, 0, 227}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 214, 84, 159, 132}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 249, 78, 136, 77, 45}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 174, 97, 12, 197, 16, 129}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 162, 198, 57, 84}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 57, 240}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 108, 49, 85, 80, 163, 185, 151, 65, 193}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 98, 251}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 34, 34, 117}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 191, 97, 19, 224, 202, 136, 143, 0, 39}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 131, 3, 31, 48, 164}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 47, 30, 88, 47, 215, 102, 173, 171, 172}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 133, 186, 185, 90, 187, 142, 127, 158, 251}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 8, 92, 115, 101, 199, 224, 226}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 50, 213, 50, 246, 133, 12, 54, 42}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 57, 251, 225, 99, 69, 251, 126, 213}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 238, 192, 77, 172}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 115, 140, 158, 74, 238}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 6, 1, 125, 202, 28, 250, 40}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 131, 201, 104, 31, 104, 45, 69, 197}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 42, 202, 234, 90, 174, 98, 80}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 100, 112, 156, 179, 230, 175, 186, 73}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 4, 102}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 115, 230}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 48, 152, 47, 54, 112}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 129, 2, 22, 201, 126, 124}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 230, 5, 132, 166, 177, 114}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 39, 218}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 108, 133, 42, 157, 163, 36, 205, 255, 110}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 35, 110, 243, 111, 34, 136}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 70, 97, 115, 134, 116, 188, 98, 47}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 130, 97, 209}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 243, 171, 153, 135, 217, 245}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 134, 2, 34, 250}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 20, 203}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 170, 148, 169, 154}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 34, 114, 215, 177}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 180, 86, 124, 101, 246, 79}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 170, 31, 14, 107, 48, 195, 26}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 211, 83, 13, 158, 157}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 109, 59, 173, 148, 1}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 150, 91, 100}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 33, 97, 255, 18}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 1, 139, 157, 84, 80, 194, 0}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 124, 33, 115, 119, 26, 237, 163, 68, 193}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 249, 5, 69, 49}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 72, 96, 56, 61, 55}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 53, 226, 41, 13, 135}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 45, 104, 233, 42, 205, 16}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 177, 236, 98, 33, 29, 43}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 6, 70, 74, 234}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 143, 91, 242, 151, 226, 59, 47, 85}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 211, 97}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 98, 82, 9, 144, 4, 25, 210}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 100, 116, 98, 71, 144, 112, 141}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 15, 202, 214}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 139, 132, 44, 120}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 62, 213, 59, 166, 159, 3, 241, 174, 163}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 115, 60, 94, 53, 129, 177, 249, 67, 107}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 235, 206, 178, 206, 203, 38, 167, 161}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 193, 67, 45, 63, 112, 41, 63, 10, 79}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177}, 222},
	{{234, 6, 112, 19, 61, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 222},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 49, 80}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 222, 111, 234, 223, 226}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 176, 174, 213}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 212, 29, 227, 117}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 48, 190, 30, 248, 145, 56, 144, 9, 89}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 218, 117, 127, 200}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 174, 43, 146, 57, 12, 82, 201}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 227, 20, 204}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 107, 128, 114, 181}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 125, 228, 181, 245, 22}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 109, 233, 230, 230, 85}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 104, 194, 86, 250, 61, 36, 216, 3, 165}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 11, 162, 187, 252}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 210, 238}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 172, 56, 193}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 214, 129}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 17, 238}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 62, 83, 127, 147, 229, 25, 215, 7, 124}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 78, 152, 22, 56, 1, 66, 173, 96, 152}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 74, 22, 212, 254, 223, 178, 228, 205, 249}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 45, 231}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 80, 219, 147}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 115, 16}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 16, 102, 175, 67}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 147, 253, 150}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 134, 113, 189, 184}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 90, 245, 126, 215, 73}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 115, 44, 241, 76, 219, 103, 155, 124, 177}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 207, 123}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 86, 0, 49}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 122, 218, 68, 64, 197, 110, 253}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 182, 73, 36, 163, 117}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 62, 116, 216, 117, 26, 244, 151, 19, 89}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 93, 175, 101, 246, 153, 68, 196, 48}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 233, 111, 225}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 190, 248, 2}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 231, 64}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 231, 162, 229, 95, 164}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 97, 179}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 187, 227, 53, 56, 104, 236, 193}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 9, 5, 31}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 178, 111, 97, 63, 208, 139, 38}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 86, 174, 21, 38, 7, 77, 58, 195}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 186, 166}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 159, 103, 234, 139, 18, 75, 73}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 167, 145, 86, 132, 221, 148}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 239, 105, 41, 141, 137, 232, 27}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 16, 217}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 1, 3, 39, 180, 238}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 122, 181}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 104, 158, 49, 104}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 25, 186, 153, 184, 123, 64, 202, 45}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 248, 78, 98, 49, 15, 219, 75}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 140, 231}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 132, 28, 231, 192, 245}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 91, 133, 185, 123, 196, 86}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 158, 184, 138}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 44, 206, 138, 73, 119, 255, 84, 111}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 184, 244, 244, 4}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 4, 174, 24, 36, 231}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 226, 127, 100, 68, 17}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 91, 74, 162, 149, 79, 72, 128, 70}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 55, 179}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 54, 249, 93, 143, 197}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 167, 197, 92, 132}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 61, 126, 60, 124, 202, 235, 77, 11}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 207, 102, 165, 176, 151, 206}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 129, 39, 234, 172, 137, 111, 5, 37}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 148, 233, 22, 51}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 108, 5, 236, 166, 208, 20, 93, 56, 218}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 110, 86, 150, 211, 161, 214, 31}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 29, 71, 23}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 81, 46, 7, 129, 147}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 62, 110, 42, 90, 117, 143}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 82, 142, 244, 135, 44, 101, 122}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 140, 131, 149, 48, 43}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 167, 24, 222, 231, 236, 140, 7, 228}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 217, 113, 49, 98, 180, 236}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 15, 54, 54, 56, 213}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 236, 141, 208, 34, 211}, 16},
	{{97, 110, 34, 117, 149, 148, 0, 0, 0, 0, 0, 0, 0, 216, 184, 16}, 16},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 111, 92, 170, 88, 181, 249}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 80, 80, 11}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 221, 200, 46, 91}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 22, 10, 207, 192, 87, 61, 130}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 85, 214, 171, 209, 197, 138, 202}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 143, 19, 207, 54, 40, 169}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 146, 113, 49}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 197}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 20, 179}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 72, 165, 156, 38, 171, 55}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 61}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 227, 120}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 29, 236, 157, 108, 15}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 67, 175, 112, 215, 244, 143}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 163, 175, 2, 94, 229, 191}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 248, 69}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 4, 114, 180, 189, 192, 35}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 168, 232, 155, 169, 141}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 72, 221}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 89}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 152, 126, 113, 108, 128}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 24, 110}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 60, 252, 47, 252}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 106}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 230, 173, 248}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 63, 242, 201, 68, 11}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 111}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 38, 184, 110}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 52, 179}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 136, 208, 163, 103, 213}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 190, 242, 134}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 49, 140, 150, 66, 155}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 219}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 89, 82, 136, 201, 101}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 106}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 226, 14, 246}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 2, 219, 87, 139, 197, 127, 138}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 232, 83, 191, 144, 82}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 126, 129, 14, 66, 1, 35}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 91, 166}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 93}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 10, 181, 217}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 183, 237, 98, 197, 159, 161, 175}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 106, 174, 48, 122}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 133, 71}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 108, 63}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 50, 25, 37, 200}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 159}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 25, 162, 135}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 116, 98, 141, 213, 48, 26, 97}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 78, 199, 96, 180, 2}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 176}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 80, 122, 0, 78, 90}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 196, 50, 71, 178, 147, 116, 181}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 126, 70, 61, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 179}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 190, 28}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 90, 218, 32, 106, 22, 123}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 215, 46, 50, 37, 58, 113, 44}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 11, 151}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 176, 187, 176}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 112, 74, 54, 176, 109}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 146, 161, 232}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 134, 132, 158, 202}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 147, 202, 200}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 179, 219, 183, 66, 13, 24}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 196, 172, 221}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 2}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 230, 53, 139, 131, 188, 17, 157}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 32, 176, 198, 193, 178, 96, 170}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 88, 250, 88, 204}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 155, 188}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 254, 121, 41, 215}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 57, 17, 144, 75, 102}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 236, 86, 255, 246, 150, 159}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 190}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 100, 37, 179, 252, 42, 99}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 178, 28}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 234}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 239, 36}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 0}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 110, 183, 215}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 233, 185, 32}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 230, 11, 247, 231, 108, 208}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 215, 235, 222, 168, 102}, 169},
	{{99, 173, 119, 73, 250, 30, 144, 30, 128, 0, 0, 0, 0, 0, 0, 235}, 169},
	{{169, 134, 111, 89, 9, 0, 61, 62, 186, 173, 79, 60, 171, 130, 96, 153}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 96, 138, 54}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 85, 219, 234, 1}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 48, 35, 5, 46}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 233, 230, 115}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 229, 242, 35, 155}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 28}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 23, 170, 122, 247}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 92, 32, 241, 232}, 175},
	{{169, 134, 111, 89, 9, 0, 249, 123, 106, 186, 223, 229, 172, 4, 122, 106}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 206}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 97}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 54, 18, 116, 194, 241, 154, 70, 179, 162}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 143, 182, 33, 230, 148, 253}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 129, 201, 237, 155, 120, 139, 226, 224}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 250, 105, 25}, 175},
	{{169, 134, 111, 89, 9, 0, 202, 250, 98, 228, 10, 146, 97, 187, 241, 211}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 137, 62, 144, 21, 161}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 164, 56, 232, 215, 153}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 184, 97, 115, 92, 17, 238, 39}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 6, 91, 77, 157, 239, 163, 233}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 178, 150, 239}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 211}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 99, 74, 122, 110, 87, 17, 221}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 93, 203, 221, 178}, 175},
	{{169, 134, 111, 89, 9, 0, 169, 192, 129, 73, 9, 24, 220, 127, 223, 72}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 218, 10, 88, 193, 86, 213}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 72, 155, 55, 51, 5, 40}, 175},
	{{169, 134, 111, 89, 9, 0, 182, 187, 181, 101, 108, 148, 58, 240, 74, 17}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 88, 193, 230, 186, 55, 52, 165, 252}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 69}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 204, 173, 72, 97, 71}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 125, 175, 59, 115, 159, 94, 156, 234, 119}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 49}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 155, 205, 160}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 23, 56, 43, 198, 247, 169}, 175},
	{{169, 134, 111, 89, 9, 0, 241, 237, 44, 245, 127, 36, 67, 138, 245, 54}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 114, 102, 208, 230, 181, 138, 248, 20}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 182, 17, 26, 91, 207, 245, 254, 20}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 196, 155, 50}, 175},
	{{169, 134, 111, 89, 9, 0, 14, 50, 173, 163, 120, 92, 54, 133, 216, 19}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 117, 175, 81, 192, 48}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 81, 226, 125, 127, 109, 101, 137}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 25, 159, 110, 232, 5}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 209, 233, 86}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 57, 238, 41, 108, 104, 106}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 60, 185, 187, 58, 237, 131}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 143, 15, 191, 123, 12, 240, 131, 117}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 156, 209, 195, 58, 184, 22, 68, 68}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 178, 158, 162, 244}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 81, 233, 197, 164, 16, 99, 149}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 182, 155, 82}, 175},
	{{169, 134, 111, 89, 9, 0, 8, 44, 49, 109, 85, 74, 214, 73, 232, 85}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 173, 128, 182, 192, 203, 251, 187, 48, 109}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 121, 164, 152, 192, 103, 166, 74}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 59, 98, 100, 66, 67, 122, 152}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 33, 224, 149}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 190, 180, 25, 231, 103, 18, 202, 116, 14}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 250, 186, 39, 194, 119, 54, 228}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 24, 53, 105, 151, 81, 176, 86, 143, 152}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 99}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 120, 174, 94, 182, 127, 137, 36}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 76, 181, 126, 181, 203, 177, 249, 180}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 239}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 50, 245, 151}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 214, 219, 237, 209, 112, 109}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 84, 63, 5, 12, 94, 144}, 175},
	{{169, 134, 111, 89, 9, 0, 71, 159, 204, 245, 152, 52, 50, 82, 254, 250}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 100}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 251}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 57, 73, 66, 34, 16, 140, 53, 74, 174}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 53, 190, 213, 239, 228, 127, 216, 130}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 181, 125, 193, 57}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 44, 2, 239, 65, 75}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 114}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 174, 240, 178, 181, 97, 14}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 169, 89, 63, 176, 251, 221}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 196, 95, 184}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 18, 73, 38}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 135}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 165, 162, 161, 233, 27, 164}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 96}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 137, 190, 221, 173, 103, 31}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 0, 0, 111, 160, 22, 34}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 0, 16, 38, 134, 43, 64, 200}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 70, 172, 225, 152, 188, 60, 173}, 175},
	{{169, 134, 111, 89, 9, 0, 0, 0, 0, 178, 79, 8, 247, 17, 248, 106}, 175},
	{{134, 80, 227, 43, 0, 33, 217, 198, 132, 55, 149, 9, 123, 26, 90, 218}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 26, 104, 153, 180, 134}, 3},
	{{134, 80, 227, 43, 0, 13, 19, 48, 186, 202, 140, 115, 201, 55, 105, 3}, 3},
	{{134, 80, 227, 43, 0, 14, 150, 21, 61, 182, 53, 76, 111, 207, 154, 251}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 75, 175, 125, 50}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 48, 31, 82, 55}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 43, 233, 45, 66, 246}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 5, 101, 20, 45, 211}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{134, 80, 227, 43, 0, 101, 238, 189, 69, 19, 105, 180, 108, 40, 104, 171}, 3},
	{{134, 80, 227, 43, 0, 0, 165, 234, 153, 226, 108, 139, 125, 13, 238, 69}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 41, 247, 88, 38, 9, 225, 142, 156, 80}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 220, 125, 135, 151}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 47, 83, 210, 41}, 3},
	{{134, 80, 227, 43, 0, 0, 137, 42, 103, 115, 36, 155, 218, 80, 86, 125}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 130, 144, 137, 94, 49, 7}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 177, 110, 24, 103, 40, 213, 232, 254, 184}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 137, 129, 50, 97, 50, 33}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 172, 166, 175, 229, 131, 255}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 211, 3, 29, 194, 162, 0, 199, 205, 24}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 255, 21}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 243, 252, 9, 240, 83, 168, 50}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{134, 80, 227, 43, 0, 250, 147, 179, 251, 248, 236, 206, 74, 23, 138, 45}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 248}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 83, 227, 192, 211, 220, 58, 146}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 106, 149, 134, 228, 214, 157, 145, 87, 174}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 180, 48, 198, 252, 20, 134, 148}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 14, 168, 247, 248}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 6, 219, 247, 174, 101}, 3},
	{{134, 80, 227, 43, 0, 0, 217, 191, 21, 37, 176, 95, 238, 245, 145, 234}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 225, 201, 113, 20, 103, 110, 22, 37}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 67, 152, 88, 41, 217, 246, 207, 173, 103}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 3},
	{{134, 80, 227, 43, 0, 0, 4, 19, 145, 253, 1, 5, 64, 234, 101, 169}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{134, 80, 227, 43, 0, 0, 4, 227, 27, 46, 27, 201, 121, 229, 219, 18}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 245, 254, 110, 159, 148, 109}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 161, 120, 212, 169}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 3},
	{{134, 80, 227, 43, 0, 249, 29, 228, 80, 219, 142, 224, 196, 170, 167, 58}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 71, 13, 123, 61, 150, 71, 71, 34}, 3},
	{{134, 80, 227, 43, 0, 0, 56, 214, 203, 178, 186, 92, 61, 85, 138, 191}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 154, 230, 23, 2}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 134, 67, 241, 153}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 5}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 13, 178, 21, 244}, 3},
	{{134, 80, 227, 43, 0, 0, 153, 220, 197, 25, 171, 12, 149, 72, 141, 105}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 171, 206, 24, 130, 207, 74}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 35, 98, 201, 60, 105, 9, 121, 194, 48}, 3},
	{{134, 80, 227, 43, 0, 23, 116, 157, 178, 100, 144, 46, 28, 102, 105, 29}, 3},
	{{134, 80, 227, 43, 0, 0, 221, 35, 119, 253, 152, 102, 167, 31, 98, 116}, 3},
	{{134, 80, 227, 43, 0, 28, 233, 25, 210, 248, 215, 133, 144, 35, 53, 17}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 231}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 84, 57, 127, 43, 149, 238}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 157, 252}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 84, 154, 94, 143, 209, 57, 241, 164}, 3},
	{{134, 80, 227, 43, 0, 93, 76, 28, 63, 250, 219, 141, 24, 172, 250, 118}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131, 74, 145}, 3},
	{{134, 80, 227, 43, 0, 0, 101, 150, 163, 70, 127, 16, 176, 183, 219, 105}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 47, 52}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 153, 142, 86, 24, 58, 8, 178, 175, 122}, 3},
	{{134, 80, 227, 43, 0, 119, 208, 189, 193, 242, 54, 92, 206, 87, 247, 122}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 61, 219, 153, 252, 130, 202, 211, 5}, 3},
	{{134, 80, 227, 43, 0, 61, 8, 247, 47, 50, 194, 187, 253, 4, 1, 207}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 126}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 26, 68, 99, 52, 166, 236}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 142, 33, 206, 110, 133}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 118}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 35}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 164, 41, 18, 101, 144}, 3},
	{{134, 80, 227, 43, 0, 0, 55, 129, 166, 153, 172, 0, 63, 63, 144, 26}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 254, 207, 224, 121, 115}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 66, 104, 155, 184}, 3},
	{{134, 80, 227, 43, 0, 0, 19, 198, 55, 150, 142, 90, 140, 105, 201, 119}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 206, 112, 98, 137, 178, 216}, 3},
	{{134, 80, 227, 43, 0, 0, 182, 153, 45, 174, 60, 109, 185, 227, 232, 140}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 112}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 60, 115, 225, 233}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 38, 187, 236, 193, 215, 145}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 179, 72, 92, 92}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 114}, 3},
	{{134, 80, 227, 43, 0, 0, 206, 193, 252, 76, 55, 150, 131, 155, 215, 67}, 3},
	{{134, 80, 227, 43, 0, 28, 243, 77, 168, 125, 28, 166, 115, 190, 40, 121}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 211}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 187, 3, 154, 115, 148, 96, 206, 109, 75}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 253, 32, 162, 126}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162}, 3},
	{{134, 80, 227, 43, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 60, 179}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 251, 56, 186}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 244}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 142, 62}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 51, 85}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 179}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 67}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 68, 198}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 247, 251}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 174}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 110, 195}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 45, 62, 180}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 73, 255}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 98, 191, 171}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 62}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 188, 46, 79}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 105}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 239, 159}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 53, 138, 56}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 129, 218, 189}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 72}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 28, 247}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 101, 137}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 205}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 146, 193}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 156}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 93, 17, 44}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 152, 215, 30}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 23, 9}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 161, 62, 208}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 42, 232}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 6, 97, 188}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 246, 181, 17}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 20, 151}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 243, 173}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 190, 62, 39}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 180, 78, 227}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 48, 107}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 100, 30, 231}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 24, 84}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 81, 208}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 224}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 140, 226, 15}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 56, 152, 126}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 9, 61, 175}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 204}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 71}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 17, 173}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 215}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 227, 52, 4}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 234, 198}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 84}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 105, 131, 24}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 26, 120, 52}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 224, 130, 174}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 144}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 227}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 212}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 244}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 254, 147, 161}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 158}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 68, 122}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 230, 10, 183}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 8, 127}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 193, 63}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 184, 195, 15}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 50}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 1, 170}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 214, 133, 141}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 66, 244, 17}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 97, 132}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 80, 216}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 27}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 0, 0}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 93, 202}, 2},
	{{231, 243, 35, 80, 75, 207, 128, 137, 54, 170, 71, 238, 0, 0, 99, 39}, 2},
	{{189, 190, 121, 135, 160, 0, 35, 62, 72, 36, 79, 168, 228, 74, 74, 167}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 246}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{189, 190, 121, 135, 160, 0, 146, 36, 10, 240, 137, 133, 102, 198, 45, 216}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 44, 132, 130, 54, 123, 221}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 190, 22, 76, 2, 146, 190, 169, 16}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 94, 54, 56, 117, 42, 17, 247, 73, 1}, 193},
	{{189, 190, 121, 135, 160, 0, 149, 59, 91, 26, 123, 38, 60, 191, 208, 140}, 193},
	{{189, 190, 121, 135, 160, 0, 241, 69, 43, 254, 56, 38, 5, 245, 107, 232}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 167, 5, 223, 38, 109, 201, 89, 112, 169}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 115, 80, 11, 101, 146, 51, 170, 232}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 174}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 59, 16, 196, 191, 96, 20, 205, 42}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 253, 103, 113, 208}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 178, 150, 87, 112, 173, 74}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 247, 159, 241, 175}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 102}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 89, 156, 40, 208, 121}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 217, 99, 223, 180}, 193},
	{{189, 190, 121, 135, 160, 0, 244, 11, 220, 216, 124, 212, 7, 157, 73, 193}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 90, 110, 90, 58, 119, 119}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 211, 81, 182, 244, 59, 131, 113}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 38}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{189, 190, 121, 135, 160, 0, 93, 108, 98, 229, 236, 22, 194, 210, 17, 0}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 143, 184, 162, 46, 232, 216, 217, 5}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 100, 97, 185, 38, 234, 16, 82, 150, 100}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 138, 178, 146, 146, 29, 102, 7, 190}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 78}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 164, 6, 249}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 140, 70, 219, 211, 235, 94, 157, 192, 20}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 2}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 129, 75, 25, 254, 111, 118, 30}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 165, 249, 184, 224}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 117, 122, 87, 46, 29, 221}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 8, 94, 112, 222}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 254, 150, 88, 197, 5, 124, 35, 116, 73}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 138, 131, 9, 57, 187, 201, 222, 156}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 12, 189, 107}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 209, 80, 11, 116, 123}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 231, 129, 46, 165, 52}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 84}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 40, 134, 140, 185, 237, 67, 11, 156}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 30, 219, 229, 83, 194}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 176, 57, 77}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 114, 139, 126}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 141, 95, 78, 180, 243}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 154, 187, 207, 11}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 217}, 193},
	{{189, 190, 121, 135, 160, 0, 32, 33, 180, 155, 101, 254, 94, 113, 222, 126}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 37, 206, 178, 183, 151, 66, 38, 48}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 191, 51, 128, 118, 203, 153}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 136, 196, 119, 147, 165, 156, 122, 149}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 55, 235, 141, 152}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 2, 182, 177, 194}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 210, 131, 205, 33, 218, 88, 82, 226}, 193},
	{{189, 190, 121, 135, 160, 0, 138, 5, 181, 179, 217, 24, 247, 175, 237, 15}, 193},
	{{189, 190, 121, 135, 160, 0, 136, 166, 22, 38, 72, 220, 81, 94, 90, 112}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 35}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 86, 227, 64, 57, 218}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 50, 132, 165}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 8, 0, 33, 211, 167, 186, 226}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{189, 190, 121, 135, 160, 154, 73, 111, 96, 34, 148, 137, 209, 151, 196, 228}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 113, 172, 226, 91, 224, 187, 231, 93, 32}, 193},
	{{189, 190, 121, 135, 160, 214, 140, 233, 230, 33, 25, 62, 17, 249, 191, 80}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 222, 132, 68, 240}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 150, 190, 79, 250, 33, 39}, 193},
	{{189, 190, 121, 135, 160, 0, 25, 159, 86, 185, 146, 21, 56, 31, 168, 193}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 249, 237, 171, 251, 35}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 11, 231, 53, 102, 127, 17, 218, 136}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 179, 145, 212, 99}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 82, 168, 46, 140, 78, 252, 92, 215}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 16}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 71, 120, 21, 45, 138}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 134, 234, 246, 33, 34, 110}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 11, 123, 201, 171, 142, 96, 164, 173, 23}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 68, 214, 234, 136, 92, 22}, 193},
	{{189, 190, 121, 135, 160, 0, 3, 183, 63, 222, 226, 48, 53, 20, 166, 184}, 193},
	{{189, 190, 121, 135, 160, 111, 16, 229, 53, 48, 12, 38, 19, 41, 170, 134}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 250, 28, 75, 13, 154}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 0, 0, 0, 0, 0, 57, 211, 33, 41}, 193},
	{{189, 190, 121, 135, 160, 0, 0, 213, 174, 221, 208, 4, 36, 176, 237, 220}, 193},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 93}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 255}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 116}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 91}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 170}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 140}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 211}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 76}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 123}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 86}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 2}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 140}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 44}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 165}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 125}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 107}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 208}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{143, 155, 216, 193, 239, 205, 204, 153, 143, 236, 69, 23, 200, 211, 0, 0}, 151},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 93, 37, 242, 207, 151, 21, 91}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 252, 230, 132}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 153, 144, 110, 111}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 80, 236, 163}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 227, 67, 96, 8, 117, 15, 209}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 27, 139, 151}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 66, 51, 175, 98, 244, 92, 173}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 2, 205}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 108, 2, 116, 94}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 91, 34}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 78, 221}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 7, 183, 172, 218}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 22, 118, 37, 213, 153, 194, 151, 11}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 83, 194, 96, 190, 7, 96, 23, 113, 0}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 224, 253, 168, 80, 70, 107, 61}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 109, 38, 32, 248, 76}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 6, 134}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 217, 253, 181, 62, 102}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 3, 195, 162, 205, 25, 243}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 239, 210, 216, 30}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 226, 116, 4, 195, 61, 48, 31, 58, 137}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 37, 224, 48, 155}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 114, 123, 118, 227}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 10, 229, 185, 243, 122, 154, 232}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 202, 89, 25}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 31, 56}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 206, 44, 152, 139, 177, 166}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 75, 152}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 83, 82, 249, 93, 4, 81, 230, 225}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 164, 238, 115, 99, 237, 115, 78, 76, 2}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 53, 32, 224, 103}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 229, 137, 41, 121}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 143, 122, 54, 16, 235, 196, 104, 213}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 25, 49, 125, 74, 61, 100, 58, 135}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 180, 83, 254, 54, 124, 233, 60, 75, 87}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 160, 61, 138}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 205, 54, 73}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 193, 77, 133, 53, 69, 38}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 59, 69, 137, 173, 83, 63}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 173, 203, 238, 238, 122, 117, 240, 171}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 66, 91}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 59, 102, 222, 113, 147, 231}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 205, 54, 32, 138, 57, 151, 251, 111, 45}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 71, 152, 81, 244, 233}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 231, 254, 15, 94}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 166, 55, 179, 154, 124, 49, 119, 88}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 6, 0, 143, 39, 59}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 39, 88, 164, 35, 61, 233}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 29, 160}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 57, 147, 162, 133, 118, 141, 62}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 196, 141, 228, 11, 135, 97}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 223, 232, 1, 165, 229}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 165, 69, 131, 22, 252, 86}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 168, 252}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 207, 130, 10, 118, 164}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 134, 15, 92, 24, 108, 95, 28, 103}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 18, 234, 76, 87, 6, 115}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 70, 240}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 212, 124, 243, 201, 200, 31}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 188, 40, 224, 3, 214, 125, 182, 117}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 197, 67, 207, 20}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 211, 188, 93, 0}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 244, 29, 183}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 182, 32}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 162, 105, 161, 244}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 141, 244}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 92, 220, 39, 228}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 27, 137, 143, 120, 146, 226, 141}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 1, 245, 84, 87, 73}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 204, 117}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 132, 0, 192, 17, 174}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 38, 143}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 81, 118, 192, 160, 162, 211, 254, 192}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 101, 253}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 236, 48, 3, 244, 129, 156, 52, 157}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 138, 35, 30, 196, 59, 153, 134, 170}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 140, 138, 15, 47, 15, 240, 43, 116}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 211, 9}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 207, 48, 75, 194, 97, 231}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 57, 248, 23, 232, 213, 180, 5, 138, 127}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 196}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 31, 18, 108, 168, 63, 231}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 216, 255, 178, 92, 26, 191, 166, 152}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 180, 87, 181}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 154, 153, 191, 184}, 182},
	{{32, 1, 115, 244, 33, 219, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 182},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 18, 243, 124, 250, 122, 84}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 226, 232, 226}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 148},
	{{220, 128, 0, 0, 198, 142, 2, 133, 65, 142, 129, 243, 177, 228, 89, 89}, 148},
	{{220, 128, 0, 0, 0, 236, 99, 209, 97, 172, 179, 242, 88, 200, 200, 167}, 148},
	{{220, 128, 0, 218, 117, 150, 38, 172, 134, 156, 151, 120, 157, 42, 92, 81}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 129, 149, 52}, 148},
	{{220, 128, 0, 0, 30, 137, 246, 247, 212, 244, 180, 134, 38, 175, 3, 70}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 199, 204}, 148},
	{{220, 128, 0, 156, 139, 88, 163, 120, 78, 170, 71, 103, 236, 87, 231, 102}, 148},
	{{220, 128, 0, 0, 0, 0, 177, 255, 185, 220, 224, 249, 242, 228, 55, 242}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 138, 163, 153, 1, 221, 22, 143}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 35, 102}, 148},
	{{220, 128, 0, 0, 0, 61, 99, 134, 153, 216, 236, 252, 127, 83, 125, 29}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 12, 133, 53}, 148},
	{{220, 128, 0, 0, 0, 0, 76, 31, 182, 177, 57, 8, 140, 189, 151, 245}, 148},
	{{220, 128, 0, 0, 0, 213, 122, 75, 0, 42, 22, 19, 30, 31, 158, 151}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 130, 27, 97}, 148},
	{{220, 128, 124, 181, 14, 222, 202, 235, 131, 99, 75, 116, 42, 84, 225, 208}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 122, 141, 10, 116, 11, 170, 23, 194, 225}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 149}, 148},
	{{220, 128, 0, 87, 111, 63, 231, 212, 12, 95, 226, 67, 154, 18, 166, 195}, 148},
	{{220, 128, 0, 0, 0, 0, 158, 123, 21, 204, 171, 184, 55, 98, 100, 228}, 148},
	{{220, 128, 0, 0, 0, 0, 192, 198, 198, 252, 122, 154, 80, 148, 69, 86}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 22, 17, 128}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 197, 65, 71, 27, 90, 104, 173, 133, 246}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 221, 152, 104}, 148},
	{{220, 128, 0, 0, 0, 31, 82, 62, 154, 165, 75, 108, 78, 64, 22, 216}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 201, 211, 83, 82, 237, 165}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 131, 153, 38, 106, 163, 9, 85, 31}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 160}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 11, 170, 9}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 96, 248}, 148},
	{{220, 128, 0, 0, 0, 0, 148, 203, 60, 236, 207, 220, 52, 238, 152, 187}, 148},
	{{220, 128, 0, 0, 0, 77, 51, 98, 94, 208, 26, 241, 53, 0, 26, 114}, 148},
	{{220, 128, 0, 0, 94, 215, 184, 197, 96, 236, 48, 235, 182, 232, 38, 129}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 67}, 148},
	{{220, 128, 0, 41, 15, 41, 139, 72, 188, 254, 126, 203, 179, 5, 71, 249}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 40, 196, 195, 100, 112, 240, 101}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 148},
	{{220, 128, 0, 0, 0, 157, 226, 203, 111, 185, 38, 205, 213, 89, 173, 74}, 148},
	{{220, 128, 0, 0, 103, 121, 196, 125, 189, 246, 68, 151, 36, 142, 247, 166}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 169}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99}, 148},
	{{220, 128, 102, 67, 247, 94, 10, 128, 107, 138, 42, 17, 222, 138, 110, 237}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 173, 18, 44, 55, 51, 232, 90}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 148},
	{{220, 128, 0, 0, 0, 0, 76, 197, 6, 43, 59, 228, 9, 105, 116, 154}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 81, 141, 166, 51, 119, 214, 254}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 24, 81}, 148},
	{{220, 128, 0, 0, 0, 0, 63, 177, 55, 7, 37, 191, 59, 224, 225, 80}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 164, 245, 174}, 148},
	{{220, 128, 0, 0, 0, 0, 138, 202, 115, 246, 53, 41, 215, 140, 152, 201}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{220, 128, 0, 0, 116, 179, 146, 38, 58, 141, 152, 233, 50, 141, 54, 169}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 7, 198, 228, 179, 63, 220, 216}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 148},
	{{220, 128, 0, 0, 0, 162, 207, 22, 190, 205, 6, 213, 180, 155, 157, 247}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 234, 184, 85, 118, 132, 243, 244, 79, 153}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 123, 246, 34, 85, 46, 80}, 148},
	{{220, 128, 0, 239, 166, 99, 215, 158, 184, 17, 193, 153, 160, 78, 0, 65}, 148},
	{{220, 128, 0, 0, 0, 198, 216, 100, 254, 98, 71, 83, 56, 186, 66, 28}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 150, 96, 216, 202, 73, 211, 110}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 87, 130}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 46, 38, 58, 128}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 189, 185, 27, 72, 229, 206, 198, 91}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 161, 35, 252, 91}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 126, 24}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 190}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 151, 162}, 148},
	{{220, 128, 0, 0, 0, 192, 34, 229, 94, 233, 218, 89, 198, 192, 190, 29}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 33, 92, 224, 24, 141, 90, 153}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 47}, 148},
	{{220, 128, 0, 0, 0, 0, 83, 255, 199, 236, 58, 127, 14, 72, 244, 6}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 184, 71, 163, 98, 243, 136, 187}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 216, 12, 245, 208, 181, 147}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 15, 247, 44, 16, 93, 128, 128, 247, 139}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 67, 105, 59, 76, 31, 90, 11, 71, 69}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 228, 244, 44, 110, 189, 122}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 33, 61, 76, 249}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 139, 168, 16, 161, 39, 89, 83}, 148},
	{{220, 128, 0, 0, 0, 0, 73, 67, 177, 66, 105, 73, 203, 174, 129, 32}, 148},
	{{220, 128, 0, 0, 0, 69, 34, 147, 150, 60, 65, 91, 137, 8, 135, 26}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 127}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 23, 36}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 116, 161, 42}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 145, 87, 10}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 68, 239}, 148},
	{{220, 128, 0, 0, 0, 0, 252, 222, 72, 172, 58, 113, 142, 10, 140, 82}, 148},
	{{220, 128, 0, 0, 0, 82, 165, 188, 90, 187, 19, 182, 220, 226, 83, 255}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 36, 84, 118, 145, 110, 177, 14, 212}, 148},
	{{220, 128, 0, 33, 26, 48, 216, 58, 38, 155, 172, 141, 20, 16, 184, 0}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 7, 179, 137, 249, 1, 104, 4, 200, 248}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 201, 47, 65}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 182, 0, 254, 53, 7, 9}, 148},
	{{220, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 63, 95, 149, 5}, 148},
	{{206, 87, 135, 235, 116, 128, 152, 71, 153, 196, 236, 95, 120, 215, 235, 36}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 221, 52, 48, 26, 252, 222}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 131, 38, 80}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 177, 35, 134, 79, 90}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 206, 132, 164, 124, 245, 32, 9}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 46, 248, 197, 50, 199, 138, 16, 238, 30}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 124, 89, 43, 148, 188}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 190, 89, 57, 43}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 49, 67, 121, 125, 120, 7}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 103, 37, 235, 153, 155, 36, 103, 75}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 230, 100, 59, 56, 60, 118, 132}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 236, 154}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 120, 20, 171}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 45, 234, 106, 15, 148, 157, 223, 185}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 173, 176, 74, 56, 204, 173, 147}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 164, 126, 189, 122}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 56, 11, 174, 53, 119, 65, 178, 11, 101}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 150, 101, 34, 190, 227, 81, 43, 148}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 143, 63, 194}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 190, 123, 255}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 140, 89, 139, 5, 17, 177, 224}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 206, 97, 178, 184, 37}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 230, 182, 209, 22}, 53},
	{{206, 87, 135, 235, 116, 128, 243, 173, 83, 34, 83, 111, 162, 104, 69, 83}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 40, 70, 107, 117, 239}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 184, 30}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 118, 78, 177, 123, 223, 179, 123}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 34, 126, 135, 214, 240, 0, 54, 239, 233}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 189, 185, 195}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 245, 120, 171, 170, 74, 172, 244, 147}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 18, 221}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 127, 159, 48, 246, 186, 43, 106, 1}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 145, 96, 210, 112}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 200, 87, 82}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 67, 172, 94}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 221, 139, 122, 104, 112, 186, 58}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 82, 115, 204, 16, 147, 252, 148, 118, 204}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 115, 201, 169, 194, 171, 75, 15}, 53},
	{{206, 87, 135, 235, 116, 128, 87, 130, 54, 189, 193, 61, 83, 72, 36, 45}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 62, 65}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 215, 143, 128, 155, 64, 157, 143}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 215, 54, 144}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 110, 113, 110, 69, 30, 255, 20, 175, 130}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 207, 66}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 82, 31, 50, 198}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 178, 27}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 48, 151, 30, 172, 4}, 53},
	{{206, 87, 135, 235, 116, 128, 43, 147, 26, 148, 93, 91, 33, 205, 105, 235}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 53},
	{{206, 87, 135, 235, 116, 128, 179, 246, 67, 249, 166, 203, 223, 175, 27, 25}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 83, 115, 170, 108, 58}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 33, 164, 83, 50}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 7, 89, 218, 105, 35, 244, 15, 165}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 58, 227, 160}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 111, 60}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 27, 242, 16, 246, 105, 42, 202, 28}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 102, 147, 101, 170, 158, 80}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 167, 100, 231, 15, 170, 84, 144, 13}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 142, 79, 84, 139, 95, 124}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 80, 98, 154, 69, 57}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 225, 194, 93, 141, 135, 195, 170}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 15, 104, 162, 39}, 53},
	{{206, 87, 135, 235, 116, 128, 55, 163, 30, 55, 68, 220, 220, 252, 109, 74}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 79, 1, 198, 110, 115, 89, 220, 109}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 16, 168, 21, 153, 116}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 154, 49, 125, 44, 157, 58}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 229, 138, 214}, 53},
	{{206, 87, 135, 235, 116, 128, 109, 149, 188, 245, 249, 198, 63, 42, 148, 8}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 152, 138, 128, 18, 169, 171, 205, 60, 208}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 72, 66}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 208, 180, 67, 173, 204, 161}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 72, 46, 121}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 158, 147, 46, 25, 5, 147}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 18, 45, 55, 16, 140, 136, 143, 31, 202}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 107, 186, 90, 153}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 30, 100, 21, 22}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 199, 64, 141, 125, 122, 16, 234, 4, 116}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 236, 185}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 53},
	{{206, 87, 135, 235, 116, 128, 0, 0, 0, 0, 0, 0, 0, 194, 179, 12}, 53},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{152, 128, 0, 164, 123, 188, 69, 226, 83, 100, 173, 131, 242, 31, 122, 11}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 65, 31, 64, 231, 25, 10, 0, 82}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 87},
	{{152, 128, 0, 86, 139, 105, 72, 187, 158, 90, 105, 83, 148, 124, 96, 25}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{152, 128, 0, 0, 0, 0, 250, 91, 92, 199, 15, 202, 193, 57, 150, 203}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 108, 102, 138, 253, 66, 50, 40, 20, 202}, 87},
	{{152, 128, 158, 216, 178, 211, 226, 138, 135, 75, 140, 118, 144, 90, 96, 135}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 117, 128, 180, 38, 249, 163, 117, 16, 23}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 90}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 115}, 87},
	{{152, 128, 167, 57, 160, 234, 42, 41, 97, 51, 107, 228, 209, 50, 49, 175}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 13}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 177, 180, 208, 154, 206, 32, 254}, 87},
	{{152, 128, 0, 0, 6, 234, 86, 81, 40, 170, 202, 23, 178, 166, 113, 218}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175}, 87},
	{{152, 128, 0, 0, 109, 241, 137, 64, 48, 2, 6, 67, 231, 3, 110, 131}, 87},
	{{152, 128, 0, 151, 133, 175, 60, 70, 128, 180, 100, 83, 39, 102, 168, 239}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 171, 64}, 87},
	{{152, 128, 0, 0, 0, 0, 11, 135, 137, 190, 157, 166, 65, 6, 91, 13}, 87},
	{{152, 128, 0, 245, 86, 106, 11, 111, 124, 38, 111, 217, 52, 205, 206, 129}, 87},
	{{152, 128, 0, 0, 170, 6, 171, 14, 161, 87, 194, 181, 120, 135, 205, 212}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 87},
	{{152, 128, 77, 129, 8, 221, 204, 231, 60, 187, 49, 74, 113, 193, 70, 246}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 3, 221, 238, 151, 41, 33, 190, 28, 84}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 74}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 35, 224, 216, 64, 25, 100}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 23, 156, 164, 61, 191, 172, 169, 233, 113}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 144, 42, 231, 173, 74, 210, 204, 95, 238}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 125, 103, 48}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 103, 198, 85, 60}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 50, 140, 66, 103, 137, 220, 215}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 43}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 183}, 87},
	{{152, 128, 0, 0, 59, 190, 55, 148, 211, 31, 121, 128, 139, 134, 228, 120}, 87},
	{{152, 128, 0, 0, 164, 73, 75, 174, 238, 255, 233, 178, 15, 71, 187, 190}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 70, 50}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 141, 31, 87, 40}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 225, 7, 196, 81, 51, 61, 52}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 244, 193, 62, 223}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 142, 65, 131, 17, 82, 210, 97, 137, 254}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 165, 127, 21, 38, 115, 196, 6}, 87},
	{{152, 128, 0, 0, 0, 237, 136, 247, 219, 155, 170, 229, 18, 17, 185, 206}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 96, 113, 181, 218, 226, 187}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 7, 160}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 98}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 213, 58, 44, 168}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 100, 143}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 63}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 186, 212, 218}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 60, 194, 130, 91, 13, 100, 242}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{152, 128, 0, 0, 168, 225, 145, 63, 89, 41, 224, 37, 25, 0, 164, 81}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 20, 15, 163, 55, 4, 219}, 87},
	{{152, 128, 0, 73, 147, 24, 175, 74, 64, 219, 75, 239, 51, 21, 202, 199}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 118, 155}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 124, 198, 21, 79, 82, 116, 135}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 80}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 109, 215, 28, 200, 45, 30}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 102, 27, 247, 49, 11, 161, 166, 105, 71}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 76}, 87},
	{{152, 128, 0, 173, 124, 54, 108, 199, 126, 42, 141, 228, 40, 135, 165, 75}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 111, 148, 122, 51}, 87},
	{{152, 128, 0, 0, 0, 210, 73, 94, 142, 29, 91, 219, 166, 102, 179, 135}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 236, 164, 23, 36, 19, 150, 22}, 87},
	{{152, 128, 22, 90, 188, 86, 104, 89, 80, 4, 125, 253, 181, 69, 45, 217}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 10, 117, 197, 136}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 225, 122, 13, 169, 191, 165}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 154, 136, 179}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 43, 194, 222, 147}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 191}, 87},
	{{152, 128, 0, 0, 55, 164, 115, 77, 1, 41, 54, 189, 2, 179, 11, 120}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 220}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 150}, 87},
	{{152, 128, 0, 0, 0, 68, 139, 173, 135, 218, 169, 237, 1, 82, 118, 96}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 236, 20, 92, 23, 15, 249, 5}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 38, 82, 82}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 138, 111, 218}, 87},
	{{152, 128, 0, 0, 136, 11, 107, 50, 58, 88, 70, 33, 149, 230, 193, 148}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 60, 93, 105, 147, 8, 170, 47, 126}, 87},
	{{152, 128, 0, 0, 24, 146, 6, 53, 156, 111, 195, 5, 240, 29, 193, 213}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 176}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 113, 21, 229, 186, 93, 9, 27}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 141}, 87},
	{{152, 128, 0, 3, 6, 69, 8, 214, 50, 31, 39, 229, 227, 90, 176, 128}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 127, 254, 132, 141, 24, 66, 72, 228}, 87},
	{{152, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 99, 2, 17}, 87},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 66}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 8, 107, 113}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 119, 248, 255, 173}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 127, 233, 248}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 114, 12, 162, 81, 206, 252}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 42, 214, 154, 186}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 24, 72, 26}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 121, 216, 164, 139}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 146, 119, 11, 43, 100}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 137, 133}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 21, 232, 152, 48}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 223, 60, 235, 187, 84, 51}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 222, 215, 55}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 175, 103, 48, 33, 123}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 252, 148, 119, 255, 35, 126}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 216, 43, 229, 216, 20}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 165, 128, 222}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 234, 201, 148, 122, 166}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 101}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 88, 10, 223, 58}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 153, 255, 110}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 192}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 86}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 102, 109, 103, 31, 180}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 72, 14, 222, 104, 20, 241}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 191}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 83, 96, 27}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 8, 169}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 45, 18, 88, 89, 104, 224}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 109, 185, 61}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 220, 185, 255, 41, 178}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 54, 68}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 113, 251, 23, 48, 116, 139}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 59, 130}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 93, 80, 249}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 61, 64, 238, 38, 230}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 68, 136}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 161}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 71}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 231, 181, 180, 159}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 143, 250, 10}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 201, 48}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 161, 100}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 11, 241, 51, 201, 136, 122}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 158, 108, 161, 44, 17}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 160, 222, 236, 123}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 146, 118, 4, 105, 43, 89}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 151, 218}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 110, 77, 239, 37}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 108, 75, 229}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 243, 235, 150}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 242, 152}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 95, 205, 173, 2}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 234, 55, 63, 79}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 112, 169, 23, 162}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 151, 67, 6, 130, 190}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 173, 27, 172}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 180}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 43, 85}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 85, 222}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 63, 211}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 165, 35, 163, 252}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 169}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 115}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 137, 249, 75, 220}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 170, 39, 41, 138}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 250}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 239, 65, 193, 4, 79, 27}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 139}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 197, 177, 150, 18, 58}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 132}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 52}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 53, 215}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 145, 120, 204, 33, 20}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 225, 117, 62, 129, 57}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 150, 156, 40, 253}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 192, 19, 3, 187, 150}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 65, 208, 23, 70, 159, 6}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 234, 194, 66, 43}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 45, 30, 64, 26}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 0}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 237, 249, 53}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 0, 236}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 126, 118}, 235},
	{{58, 146, 188, 233, 230, 236, 192, 214, 168, 128, 0, 0, 0, 0, 62, 46}, 235},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 150, 184, 213, 167, 0, 10, 18}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 42, 31, 255, 119, 39, 40, 42}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 78, 217}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 1}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 217, 250, 21, 241, 22, 74, 137, 232}, 51},
	{{84, 220, 82, 0, 116, 100, 106, 101, 193, 1, 156, 227, 137, 163, 222, 199}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 153, 141, 51, 167, 54, 251, 217}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 254}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 196, 81, 173, 24, 94, 144, 40, 60, 62}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 213, 81, 75, 32, 62, 68}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 169, 171, 108}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 151}, 51},
	{{84, 220, 82, 0, 221, 237, 36, 159, 164, 140, 38, 157, 112, 135, 187, 127}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 89, 221, 30}, 51},
	{{84, 220, 82, 0, 0, 49, 89, 163, 149, 162, 25, 24, 182, 28, 120, 124}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 196, 229, 142}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 241, 87, 58}, 51},
	{{84, 220, 82, 0, 0, 0, 53, 123, 61, 20, 100, 45, 140, 83, 18, 71}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 197, 88, 11, 133, 114}, 51},
	{{84, 220, 82, 0, 0, 99, 134, 248, 42, 176, 105, 203, 41, 188, 27, 110}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 218, 82}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 50, 86}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 26, 143, 155, 131, 62, 16}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 159, 173, 208, 41, 140, 58, 248, 36}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 87, 146, 253, 221, 119, 21}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 41, 127}, 51},
	{{84, 220, 82, 0, 0, 0, 162, 142, 142, 26, 125, 75, 128, 135, 73, 167}, 51},
	{{84, 220, 82, 0, 0, 146, 9, 107, 203, 98, 212, 219, 176, 64, 207, 105}, 51},
	{{84, 220, 82, 0, 127, 1, 76, 197, 220, 150, 95, 80, 54, 241, 80, 80}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 232, 26, 175, 39, 110, 0, 153}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 242, 217, 95, 189, 243, 133, 91}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 191, 91, 50, 155, 10, 115, 250}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 140, 111}, 51},
	{{84, 220, 82, 0, 248, 159, 25, 178, 163, 187, 16, 226, 220, 188, 7, 226}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 178, 116, 246, 117, 150}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 143, 88, 16, 227, 33}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 161, 63, 93, 80, 116, 44, 109, 109}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 232, 160, 22, 255, 168, 45}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 173, 187, 106}, 51},
	{{84, 220, 82, 0, 0, 0, 3, 221, 242, 61, 176, 23, 129, 5, 92, 1}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 136, 104, 52, 213, 20, 66, 84}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 200, 210, 207, 65, 232, 10, 5, 10}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 174, 29, 102}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 9}, 51},
	{{84, 220, 82, 0, 0, 0, 222, 250, 102, 220, 165, 51, 124, 28, 70, 97}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 247, 14, 124, 41, 155}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 247}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 125, 68, 27, 216, 173, 210, 184, 204, 190}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 66, 65, 202, 160, 227, 71, 8}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 31, 223, 16, 224, 125, 167, 239, 190, 53}, 51},
	{{84, 220, 82, 0, 0, 173, 122, 181, 66, 180, 115, 125, 79, 172, 183, 26}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 79, 119}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 95, 91, 88}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 210, 158, 179}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 179, 74, 171, 120, 40, 155}, 51},
	{{84, 220, 82, 145, 35, 247, 57, 71, 148, 185, 63, 1, 95, 106, 92, 13}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 60, 209, 61}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 71}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 8, 38, 182}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 46, 227, 241, 157, 173}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 115}, 51},
	{{84, 220, 82, 0, 192, 36, 175, 14, 101, 43, 230, 210, 138, 213, 70, 98}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 15, 34, 233}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 51},
	{{84, 220, 82, 0, 0, 0, 229, 81, 85, 6, 202, 87, 150, 66, 221, 115}, 51},
	{{84, 220, 82, 0, 0, 174, 177, 46, 149, 98, 94, 66, 176, 171, 214, 7}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 58}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 168, 227, 151}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 51},
	{{84, 220, 82, 0, 0, 52, 74, 203, 2, 124, 191, 87, 234, 77, 186, 214}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 107}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147, 136, 243, 151}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 109, 149, 130}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 214, 48}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 22, 143}, 51},
	{{84, 220, 82, 0, 0, 90, 79, 19, 76, 92, 252, 53, 147, 122, 173, 112}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 155, 80, 129, 31, 15, 108, 130, 52}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 118, 95, 128}, 51},
	{{84, 220, 82, 0, 62, 253, 191, 84, 98, 171, 29, 143, 7, 240, 148, 91}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 179, 221, 41, 99, 242, 40, 168, 213, 239}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 196, 47, 230, 133, 148, 164, 63, 146}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219}, 51},
	{{84, 220, 82, 0, 86, 55, 236, 67, 64, 2, 158, 228, 209, 233, 183, 199}, 51},
	{{84, 220, 82, 0, 0, 5, 181, 255, 5, 26, 19, 186, 184, 201, 4, 34}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 85, 109, 188, 19, 81, 119, 233, 93, 4}, 51},
	{{84, 220, 82, 0, 113, 70, 169, 33, 192, 90, 87, 43, 66, 154, 61, 84}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 67, 143, 107, 194, 53, 137}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 0, 163, 4}, 51},
	{{84, 220, 82, 0, 0, 0, 0, 0, 205, 235, 104, 253, 233, 242, 64, 199}, 51},
	{{84, 220, 82, 0, 0, 0, 116, 41, 89, 137, 65, 77, 100, 54, 197, 118}, 51},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 135}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 78}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 116}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 74}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 125}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 114}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 254}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 231}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 23}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 251}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 240}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 236}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 163}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 51}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 9}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 174}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 67}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 99}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 165}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 190}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 134}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 178}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 75}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 171}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 206}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 146}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 181}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 74}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 116}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 158}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 34}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 0}, 11},
	{{106, 145, 142, 42, 186, 186, 58, 1, 48, 98, 165, 131, 48, 156, 192, 48}, 11},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 216}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 63, 19, 240, 34}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 191, 55, 130, 140, 77, 98}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 143, 247, 182, 37}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 190, 69, 251, 115, 93}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 138, 40}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 207, 86}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 246, 253, 44, 113}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 12, 100, 205, 149}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 221, 87, 70, 185, 179, 101}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 103, 118}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 202, 123, 151}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 239, 137, 186, 249, 44, 40}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 245, 27, 50}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 36, 163, 104}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 184, 170, 190, 133}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 160, 211, 52, 17, 142}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 115, 52, 171, 239, 252, 192}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 228, 187, 73, 46, 204, 122}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 221, 161}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 186, 48, 137, 24, 143}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 208, 246, 153, 62, 131, 73}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 244, 86, 149}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 92}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 254, 215, 108, 177, 219}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 9}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 138}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 224}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 146, 200}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 170, 36, 206, 132}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 239}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 38, 118, 133, 157}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 177, 1}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 177, 84, 228, 92, 113}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 47, 209, 150, 196, 8, 20}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 101, 158, 119, 165}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 161, 88, 51, 152}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 32}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 129, 45, 2, 138, 228, 35}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 40, 103, 131, 95, 183}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 188, 230, 20, 183, 182, 173}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 230, 91, 131, 8}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 152, 188, 4, 205, 215, 219}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 215, 1}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 41, 147, 150, 255}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 116, 15}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 59, 179}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 180, 61, 199, 248}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 110, 228, 172, 175, 61}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 33, 220, 198}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 10, 146, 63, 240, 10, 185}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 102, 131, 218, 132, 69, 29, 120}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 218, 72, 116, 144}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 171, 92, 31}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 163, 68, 174, 16}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 56, 228, 249}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 237, 247, 151}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 153, 23, 79, 251, 135, 169, 144}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 218, 239, 59, 162, 217, 183}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 232, 212, 242, 195, 137, 219}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 47}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 64, 195, 107, 147, 184}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 119}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 94, 18, 54}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 1, 165, 208, 236, 65}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 112}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 149, 242, 20, 241}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 97, 174, 212, 197, 30}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 181}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 52, 119, 36, 129, 61, 228}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 224, 211, 102, 16}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 137, 50, 227, 78, 163}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 223, 250, 224, 37, 158}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 235}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 18, 63, 66, 74, 210}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 252}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 98, 83, 199, 141, 75}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 151, 43, 29, 17}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 73, 68, 249, 18}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 73, 118, 84, 133, 95, 30}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 49}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 237, 236}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 37, 228, 245}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 160, 36, 28, 135}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 8}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 85, 146, 240, 219, 19, 184, 115}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 197, 92}, 28},
	{{53, 219, 120, 242, 166, 214, 81, 130, 64, 0, 0, 0, 0, 0, 0, 132}, 28},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 69}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 177, 238}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 86, 121}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 38, 49, 115}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 168, 12}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 13, 226}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 15}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 79}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 43, 41}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 154}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 39, 130, 47}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 97}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 126, 145}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 186, 235, 74}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 220, 109, 54}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 160, 40, 144}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 97, 74}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 4}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 154, 146, 74}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 137, 36}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 28, 14}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 241}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 186, 177, 236}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 138, 241}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 89}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 199}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 126, 72}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 222, 110, 150}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 159, 185}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 85}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 174}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 189, 210, 226}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 227, 212, 209}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 123}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 60, 96, 203}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 58}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 153}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 50, 37}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 235}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 162, 118, 53}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 244, 81, 39}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 9, 184, 219}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 163, 163}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 180, 34, 118}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 202, 77}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 105}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 186}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 83, 56, 136}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 152}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 31, 171}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 53}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 173}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 180, 20, 67}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 35, 125}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 39}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 34}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 7}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 44}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 201}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 244, 176, 248}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 187, 72, 34}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 133}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 60, 126, 174}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 20}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 134}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 96, 205}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 154, 227, 101}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 36, 17, 10}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 215, 197, 119}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 169, 66, 133}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 163, 153}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 248}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 167, 238, 132}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 45, 236, 61}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 0}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 179, 118, 255}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 135, 113, 114}, 73},
	{{240, 120, 76, 163, 32, 197, 181, 251, 98, 220, 29, 226, 0, 0, 0, 189}, 73},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 99, 237, 199, 80}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 52, 18, 173, 206, 80, 214, 248, 201}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 176, 74, 219, 254, 68, 39, 40}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 48, 193, 126, 60, 121}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 109, 183}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 47, 154, 195, 122}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 159, 86, 251, 35, 118, 213}, 216},
	{{234, 197, 12, 160, 0, 0, 229, 217, 156, 230, 125, 38, 229, 72, 234, 154}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 134, 61, 155, 107, 183, 121}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 78, 155}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 245, 168, 136, 141, 33, 151, 32}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 70}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 32, 19, 230, 199, 181, 200, 40, 51}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 4, 66, 78, 8, 61, 243, 24}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 27}, 216},
	{{234, 197, 12, 160, 0, 0, 56, 98, 227, 126, 92, 219, 99, 28, 178, 234}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168}, 216},
	{{234, 197, 12, 160, 0, 0, 175, 155, 183, 4, 243, 37, 140, 193, 26, 6}, 216},
	{{234, 197, 12, 160, 151, 182, 119, 205, 26, 63, 100, 72, 56, 218, 227, 185}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 48, 215, 187, 81, 1, 26}, 216},
	{{234, 197, 12, 160, 165, 181, 25, 55, 30, 46, 104, 15, 154, 207, 216, 231}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 43, 250, 16, 81, 101}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 217, 220, 9, 140, 118, 169, 226, 179, 2}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 32, 36, 120, 221, 9, 105, 209}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 171}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 200, 106, 166, 126, 42, 204}, 216},
	{{234, 197, 12, 160, 0, 0, 56, 240, 77, 190, 11, 29, 65, 246, 29, 160}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 124, 162}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 213, 235, 125, 67, 66, 41}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 38, 11, 114, 129, 204, 176, 163, 59}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 44, 38}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 155, 70, 128, 29, 100, 48, 118, 126, 6}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 31, 187}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 66, 218, 176, 38, 157, 194, 210}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 224, 20, 92, 14, 87, 112, 74}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 60, 123, 36, 155, 199, 81, 40, 208, 133}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 82, 166, 208, 160, 71, 99, 149, 191}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 164, 205, 172, 37, 16, 237}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 170, 155, 141, 244, 242, 119, 177}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 46, 36, 129, 243, 52, 123, 42, 214}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 16, 120, 150, 161, 172, 42, 44}, 216},
	{{234, 197, 12, 160, 0, 0, 166, 125, 80, 130, 4, 50, 183, 216, 92, 26}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 169, 95}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 161, 36}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 92, 151, 65, 200, 155, 138}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 91, 117, 78, 15}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 229, 25}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 231, 9, 255, 232, 219}, 216},
	{{234, 197, 12, 160, 0, 0, 7, 186, 2, 166, 107, 132, 37, 247, 35, 80}, 216},
	{{234, 197, 12, 160, 0, 32, 21, 161, 147, 16, 221, 136, 104, 84, 2, 61}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 57, 116, 55, 33, 0}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 200, 214, 157, 235, 218, 195, 15, 132}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 137, 188, 10, 141, 199, 182}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 52}, 216},
	{{234, 197, 12, 160, 0, 0, 114, 99, 90, 233, 187, 6, 254, 134, 150, 166}, 216},
	{{234, 197, 12, 160, 81, 172, 88, 211, 141, 112, 102, 242, 131, 174, 147, 183}, 216},
	{{234, 197, 12, 160, 0, 0, 65, 226, 62, 155, 16, 254, 149, 234, 57, 55}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 86, 143, 46, 145}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 201, 133, 23, 187, 11, 185, 36}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 180, 229, 62, 184, 154}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 120, 219, 205, 240, 9, 239, 42}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 46, 233, 74, 237, 148, 80, 219, 12}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 177, 159, 70, 68, 118, 211}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 95, 51, 9, 2, 91, 24, 145}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 124, 241, 238, 212, 197, 250, 154, 233}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 110, 134, 43, 200, 223}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 229, 48, 152, 84}, 216},
	{{234, 197, 12, 160, 0, 215, 237, 142, 138, 172, 110, 145, 125, 255, 171, 204}, 216},
	{{234, 197, 12, 160, 0, 214, 48, 77, 60, 44, 217, 225, 152, 247, 192, 192}, 216},
	{{234, 197, 12, 160, 110, 3, 229, 94, 237, 175, 113, 60, 182, 68, 156, 168}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 116, 199, 76, 176, 130, 170, 230, 96}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 91}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 235, 63}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 91, 199, 146, 154}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 187, 49, 123, 59, 234}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 182, 23, 91, 91, 136}, 216},
	{{234, 197, 12, 160, 0, 46, 34, 63, 209, 116, 142, 140, 177, 15, 190, 144}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 131, 87, 173, 145, 188, 126, 65}, 216},
	{{234, 197, 12, 160, 0, 0, 245, 54, 46, 139, 159, 17, 165, 112, 213, 30}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 69, 31, 75, 31, 90, 131, 251}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 91, 46, 79, 103, 19, 58, 60, 26}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 249, 118, 93, 167}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 253, 161}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 127}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 180, 28, 29, 198, 213}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 209, 238, 95, 26, 215}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 151, 75, 252, 24, 173, 80, 106, 57}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 189, 156, 241, 226}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 83, 91, 40, 251, 52, 124}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 216},
	{{234, 197, 12, 160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 216},
	{{234, 197, 12, 160, 0, 40, 12, 217, 144, 194, 192, 74, 28, 2, 66, 103}, 216},
	{{191, 94, 0, 0, 0, 0, 0, 207, 71, 28, 201, 114, 223, 124, 245, 4}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 205, 99, 159, 117, 172, 48, 113}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 99},
	{{191, 94, 0, 177, 35, 22, 27, 191, 247, 153, 130, 138, 249, 30, 69, 22}, 99},
	{{191, 94, 0, 3, 51, 166, 25, 139, 194, 231, 193, 101, 152, 208, 125, 197}, 99},
	{{191, 94, 0, 0, 49, 22, 66, 146, 64, 239, 107, 154, 9, 127, 22, 218}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 71}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 43, 133, 225, 25, 120, 61, 247}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 75}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 149, 117}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 21, 169, 17, 213, 194, 149, 194}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 165, 195}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 134, 90, 243, 20, 82, 222}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 34, 30, 201}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 184, 123, 252, 177}, 99},
	{{191, 94, 0, 0, 0, 0, 252, 37, 124, 80, 9, 52, 47, 17, 214, 78}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 174, 61, 129, 252, 39, 8, 228, 91, 72}, 99},
	{{191, 94, 0, 74, 34, 243, 162, 22, 238, 28, 131, 46, 196, 96, 209, 121}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 141, 89, 87, 39}, 99},
	{{191, 94, 0, 0, 246, 158, 218, 227, 230, 188, 135, 162, 61, 143, 113, 33}, 99},
	{{191, 94, 0, 0, 0, 75, 85, 106, 36, 178, 169, 140, 175, 172, 93, 7}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 3}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 50, 145, 90, 112, 188, 212, 241, 100}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 202, 148, 249, 34, 125, 189, 183}, 99},
	{{191, 94, 0, 0, 0, 212, 105, 46, 98, 159, 103, 140, 170, 28, 62, 10}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 245, 97, 83, 74}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 139, 187}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 75, 142, 1, 143}, 99},
	{{191, 94, 0, 0, 0, 0, 152, 156, 1, 2, 110, 71, 62, 199, 221, 224}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139, 172, 124, 178, 84}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 96, 160, 165, 187, 70, 66}, 99},
	{{191, 94, 0, 0, 184, 184, 19, 72, 213, 250, 110, 1, 110, 9, 152, 247}, 99},
	{{191, 94, 0, 185, 28, 229, 19, 222, 185, 91, 224, 128, 152, 147, 24, 207}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 241, 200, 74, 45}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 183}, 99},
	{{191, 94, 0, 0, 0, 243, 30, 91, 108, 141, 13, 177, 251, 80, 233, 28}, 99},
	{{191, 94, 0, 0, 0, 35, 205, 136, 52, 249, 31, 227, 222, 102, 237, 143}, 99},
	{{191, 94, 0, 0, 254, 248, 244, 40, 72, 3, 199, 250, 85, 34, 37, 48}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 89, 45, 236, 203, 255, 24, 38, 65}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 145, 57, 57, 148, 184, 64, 8, 132, 101}, 99},
	{{191, 94, 0, 0, 212, 153, 132, 189, 208, 11, 128, 17, 213, 140, 209, 127}, 99},
	{{191, 94, 0, 0, 0, 18, 73, 190, 135, 61, 233, 99, 0, 95, 179, 11}, 99},
	{{191, 94, 0, 0, 0, 0, 34, 108, 14, 200, 200, 210, 195, 152, 29, 51}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 93, 45, 132}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 252, 43, 185, 13, 122, 41}, 99},
	{{191, 94, 0, 121, 93, 185, 25, 35, 156, 224, 29, 63, 108, 246, 218, 144}, 99},
	{{191, 94, 0, 0, 0, 176, 243, 121, 109, 246, 120, 158, 186, 49, 163, 74}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 130}, 99},
	{{191, 94, 0, 0, 0, 89, 175, 23, 216, 153, 21, 216, 78, 211, 187, 240}, 99},
	{{191, 94, 0, 0, 0, 120, 124, 235, 79, 50, 200, 209, 96, 200, 60, 33}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 241, 183, 107, 183, 31, 41}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 26, 157}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 82, 204, 222}, 99},
	{{191, 94, 0, 180, 154, 226, 201, 55, 157, 21, 51, 185, 239, 253, 64, 186}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 178, 247, 169, 252, 99, 240, 187}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 10, 241, 60, 58, 160, 208, 123, 226}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 244, 172, 132, 14, 76, 135}, 99},
	{{191, 94, 0, 0, 0, 43, 180, 59, 52, 157, 133, 105, 191, 22, 170, 240}, 99},
	{{191, 94, 0, 0, 203, 82, 98, 60, 236, 61, 128, 167, 230, 71, 213, 113}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 250}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 110, 240, 2}, 99},
	{{191, 94, 0, 0, 0, 252, 85, 188, 2, 109, 105, 100, 96, 180, 75, 117}, 99},
	{{191, 94, 0, 124, 195, 4, 75, 132, 53, 68, 23, 228, 105, 193, 228, 111}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 152, 195, 1, 173, 36, 146, 21}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 189, 209, 252, 140, 46, 181, 242, 127}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 46, 130, 44, 71, 27, 240}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 30, 180, 106, 67}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 118, 164, 21}, 99},
	{{191, 94, 0, 0, 168, 37, 34, 114, 139, 71, 96, 102, 187, 199, 27, 190}, 99},
	{{191, 94, 0, 165, 182, 39, 6, 87, 112, 5, 119, 192, 24, 20, 65, 42}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 52, 205, 2, 166, 102, 86, 79}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 184, 249, 90}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 81, 37, 219, 191, 95, 165}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 88, 227, 122, 2, 54, 226, 146, 237, 137}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 99},
	{{191, 94, 0, 236, 60, 60, 209, 86, 249, 137, 142, 101, 169, 79, 61, 121}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 99},
	{{191, 94, 0, 176, 72, 13, 12, 216, 91, 100, 83, 234, 243, 194, 41, 140}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 241, 208, 230, 188}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152}, 99},
	{{191, 94, 0, 0, 0, 0, 67, 199, 214, 194, 21, 255, 201, 50, 206, 237}, 99},
	{{191, 94, 0, 170, 58, 150, 150, 205, 143, 139, 83, 188, 26, 99, 125, 205}, 99},
	{{191, 94, 0, 250, 119, 60, 97, 187, 61, 106, 230, 14, 91, 178, 77, 128}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 166, 224, 0, 142, 153, 252, 164, 50}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 20, 104}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 49, 24}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 36, 143, 169, 19, 64, 250, 109, 87}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221}, 99},
	{{191, 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 38}, 99},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 232, 240, 238, 90, 160, 105}, 35},
	{{200, 8, 0, 0, 230, 47, 77, 202, 229, 132, 57, 128, 8, 220, 118, 252}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 5, 16, 253, 219}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 154, 232, 217, 37, 248, 25}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 80, 96, 88, 92, 152, 126, 36}, 35},
	{{200, 8, 0, 0, 0, 150, 162, 146, 39, 120, 67, 18, 229, 71, 34, 72}, 35},
	{{200, 8, 0, 243, 147, 215, 191, 156, 128, 86, 132, 82, 11, 186, 52, 172}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 158, 87, 46, 39, 136, 91}, 35},
	{{200, 8, 0, 56, 209, 242, 220, 57, 239, 19, 9, 10, 199, 56, 124, 21}, 35},
	{{200, 8, 0, 0, 0, 0, 91, 138, 140, 80, 128, 100, 189, 74, 15, 229}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 140, 124}, 35},
	{{200, 8, 0, 0, 72, 233, 64, 21, 210, 116, 18, 4, 232, 212, 95, 31}, 35},
	{{200, 8, 0, 0, 0, 0, 181, 235, 4, 164, 2, 237, 169, 19, 52, 106}, 35},
	{{200, 8, 0, 0, 0, 184, 234, 233, 224, 246, 137, 10, 138, 180, 254, 198}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 214}, 35},
	{{200, 8, 0, 0, 60, 180, 58, 255, 210, 64, 155, 216, 82, 242, 157, 134}, 35},
	{{200, 8, 0, 0, 0, 0, 159, 197, 159, 190, 244, 212, 250, 53, 251, 225}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 18, 30, 240, 11, 94, 8, 143}, 35},
	{{200, 8, 0, 0, 0, 212, 20, 128, 251, 78, 38, 11, 58, 80, 187, 21}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 8}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 164, 28, 107}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 99, 11, 209, 58, 95, 35}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 79, 48, 111, 67, 110, 193}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{200, 8, 0, 0, 144, 105, 128, 119, 192, 100, 246, 226, 142, 15, 159, 166}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 21, 34, 127, 254, 88, 54, 125, 244, 241}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192}, 35},
	{{200, 8, 0, 146, 42, 183, 180, 207, 45, 15, 16, 196, 91, 134, 199, 227}, 35},
	{{200, 8, 0, 0, 0, 55, 228, 244, 226, 232, 205, 222, 167, 99, 75, 198}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 147, 195, 171, 125, 190, 167, 255, 97, 101}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 1, 130, 146, 213, 3, 42, 23}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 175, 215, 35, 206, 49, 255, 94, 97}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 16, 225, 185, 18}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 41}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 10, 31, 177, 196, 160, 112, 160, 1, 219}, 35},
	{{200, 8, 0, 229, 108, 236, 152, 179, 142, 171, 81, 75, 48, 5, 207, 73}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 228, 217, 244, 37, 103, 11, 242, 32}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 146}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 254, 115}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 249, 93, 78, 236, 31, 6}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 180, 109, 56, 92, 229, 99, 50, 247, 222}, 35},
	{{200, 8, 0, 0, 154, 218, 186, 186, 129, 112, 88, 19, 168, 244, 117, 43}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 140}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 171, 196, 153, 7, 253, 44, 87, 152}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 185, 209, 218, 68, 87, 127, 145}, 35},
	{{200, 8, 0, 0, 150, 183, 34, 187, 31, 53, 189, 94, 27, 70, 12, 28}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 21, 17, 60}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 38, 13, 30, 216, 25, 221}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 24, 125, 55, 195, 27, 176, 36, 247}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 146, 109, 130, 242, 231, 165, 209, 93, 75}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 93, 82, 243}, 35},
	{{200, 8, 0, 0, 123, 144, 107, 104, 246, 180, 220, 224, 119, 41, 163, 26}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 208, 201}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{200, 8, 0, 0, 0, 37, 144, 67, 227, 7, 124, 249, 65, 75, 61, 56}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 255, 226}, 35},
	{{200, 8, 0, 0, 0, 133, 168, 207, 104, 57, 146, 93, 161, 235, 96, 101}, 35},
	{{200, 8, 0, 231, 150, 231, 177, 211, 190, 195, 178, 206, 249, 142, 219, 203}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 222, 78, 8, 8, 1, 169, 90, 101}, 35},
	{{200, 8, 0, 0, 169, 184, 156, 220, 248, 82, 41, 215, 233, 186, 133, 154}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 47, 16, 25, 125}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 69}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 111, 152}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134, 196, 14}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 53}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 89, 221, 225, 254}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 220, 22, 53, 76, 66, 167}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 157, 4, 96, 94, 142, 166, 62}, 35},
	{{200, 8, 0, 0, 0, 0, 72, 168, 8, 135, 58, 181, 167, 72, 17, 40}, 35},
	{{200, 8, 0, 0, 0, 75, 11, 206, 217, 162, 113, 166, 2, 5, 18, 130}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244}, 35},
	{{200, 8, 0, 0, 0, 0, 58, 237, 151, 14, 41, 239, 107, 86, 42, 91}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 148, 231, 104, 240}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 28, 174}, 35},
	{{200, 8, 0, 0, 185, 139, 50, 33, 15, 140, 13, 245, 214, 127, 23, 89}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 192, 162, 184, 74, 126, 66, 89}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 208, 93, 20, 78, 210, 115, 82, 177}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33, 80, 55}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 67, 89, 217}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 220, 195}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 65, 31}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 248, 53, 66, 252, 227, 62, 3, 254, 96}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 102, 19, 177, 189, 178, 141, 146, 63}, 35},
	{{200, 8, 0, 0, 0, 0, 46, 249, 205, 235, 237, 60, 165, 224, 61, 119}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 15}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 112, 246, 196, 141, 9, 86, 116, 235}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 4, 21, 24, 107, 237, 254, 114, 90, 142}, 35},
	{{200, 8, 0, 0, 0, 25, 169, 4, 121, 65, 165, 245, 168, 23, 124, 131}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 0, 53, 89, 155, 236, 133, 241}, 35},
	{{200, 8, 0, 0, 0, 0, 182, 10, 57, 199, 196, 194, 54, 173, 225, 113}, 35},
	{{200, 8, 0, 0, 0, 0, 13, 218, 226, 219, 201, 34, 14, 167, 10, 132}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 73, 33, 172, 95, 113, 242, 215, 95, 235}, 35},
	{{200, 8, 0, 0, 0, 0, 0, 0, 0, 34, 234, 33, 235, 105, 77, 79}, 35},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{29, 129, 47, 83, 19, 75, 158, 1, 28, 24, 26, 147, 82, 119, 140, 100}, 195},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 201}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 34}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 9}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 231}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 138}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 229}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 254}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 234}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 43, 115}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 50, 242}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 34, 97}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 250}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 235, 60}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 189}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 198}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 217, 163}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 150, 16}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 77, 93}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 103}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 97}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 34}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 199, 30}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 25}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 96, 184}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 168}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 98}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 90, 232}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 197, 67}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 78}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 3}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 218}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 117}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 44, 195}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 25}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 100}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 75, 65}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 247}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 235}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 78, 4}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 234}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 122, 251}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 174}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 5}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 97, 59}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 202}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 203, 22}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 161}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 40}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 4}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 157}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 224}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 0}, 176},
	{{241, 174, 26, 53, 152, 112, 200, 134, 84, 187, 177, 176, 42, 64, 0, 254}, 176},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 99, 33}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 174}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 132, 154}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 196, 106, 104}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 16, 239, 232}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 158, 37, 154, 82}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 63, 174}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 92, 24}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 103, 64, 124}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 188, 103, 137, 227, 250}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 246, 176, 42, 24}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 188}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 228, 122, 65, 196}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 156, 132, 197, 71}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 205, 196}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 212, 153, 230}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 173}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 25}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 93, 239, 140, 198}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 161, 252, 106}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 193, 164, 254}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 137, 242, 45}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 29, 89}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 170}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 225}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 45, 142, 32}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 167, 40, 247, 12}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 115, 223, 50, 159}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 237, 78, 101}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 28, 37, 213}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 199, 173, 206}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 14, 135, 141, 103}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 30, 78, 10, 28}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 36, 184, 20, 124}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 102, 24, 155, 34}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 68}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 67, 43, 239}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 231, 102, 152}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 145, 136, 85}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 51}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 24}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 10}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 51, 114, 94}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 135}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 145, 160}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 81, 147, 102}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 14, 31, 57, 199, 169}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 55}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 215, 224}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 242, 5}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 168, 29}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 198, 186, 32}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 224}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 225}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 37, 98, 45}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 130}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 61}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 20, 162, 38, 166}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 185}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 222}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 101}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 25, 93, 127}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 251, 48, 61, 78}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 77, 30, 79}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 162, 84, 11}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 171}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 173, 246, 232, 230}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 112, 4, 225, 20}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 2, 162, 45}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 70}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 214, 175, 49, 169}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 208, 163}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 109}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 184}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 97}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 163, 238, 172}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 141, 202, 173, 145}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 232, 101}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 226}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 234, 40}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 158, 250}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 205}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 125}, 217},
	{{77, 171, 145, 48, 195, 84, 190, 36, 122, 199, 18, 0, 0, 0, 0, 0}, 217},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{105, 104, 135, 53, 226, 118, 238, 169, 9, 253, 132, 162, 217, 123, 191, 96}, 244},
	{{160, 0, 0, 0, 0, 156, 206, 34, 63, 20, 13, 218, 149, 242, 247, 167}, 208},
	{{160, 0, 0, 0, 190, 76, 21, 102, 16, 26, 219, 213, 24, 133, 252, 207}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 251, 188, 197, 215, 32, 2, 151, 117}, 208},
	{{160, 0, 0, 0, 0, 203, 222, 142, 65, 120, 186, 58, 205, 205, 50, 159}, 208},
	{{160, 0, 215, 182, 176, 190, 251, 128, 197, 153, 162, 47, 221, 237, 68, 46}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 193, 228, 66, 206}, 208},
	{{160, 0, 0, 0, 0, 0, 118, 57, 156, 198, 17, 36, 217, 119, 104, 77}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 37, 130, 16}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 184, 129, 71}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 61, 53, 210, 146, 105, 7, 197, 175, 199}, 208},
	{{160, 0, 0, 0, 114, 88, 206, 148, 226, 2, 54, 186, 151, 184, 97, 86}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 123, 22, 132, 88, 136, 212, 93, 149}, 208},
	{{160, 233, 151, 72, 179, 155, 77, 37, 240, 133, 86, 205, 210, 106, 91, 100}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 25, 4}, 208},
	{{160, 0, 0, 0, 0, 112, 152, 214, 157, 67, 197, 111, 56, 220, 94, 75}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 156, 152, 194, 88, 162, 155, 230, 21, 45}, 208},
	{{160, 0, 206, 228, 127, 0, 204, 97, 17, 32, 23, 149, 181, 35, 230, 206}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 202, 60, 120, 56, 254, 48, 67}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 235, 136, 93}, 208},
	{{160, 0, 0, 0, 0, 122, 110, 10, 183, 26, 224, 72, 71, 224, 161, 50}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 205, 29, 13, 235, 68, 26, 80}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 115, 4, 68, 224, 92, 119, 78}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 190, 207, 224}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 34, 156}, 208},
	{{160, 0, 0, 184, 234, 202, 82, 252, 211, 250, 247, 14, 191, 218, 1, 149}, 208},
	{{160, 120, 179, 20, 180, 220, 104, 135, 109, 117, 36, 12, 137, 149, 160, 41}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 44, 69, 84, 109, 19, 120, 30, 147}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 62}, 208},
	{{160, 0, 23, 190, 24, 165, 204, 194, 238, 78, 128, 35, 177, 161, 151, 149}, 208},
	{{160, 0, 166, 7, 205, 106, 198, 159, 215, 215, 190, 197, 198, 7, 187, 174}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 103, 165}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 179, 76}, 208},
	{{160, 0, 51, 115, 164, 178, 163, 91, 118, 88, 54, 124, 30, 59, 127, 136}, 208},
	{{160, 0, 0, 0, 161, 125, 182, 203, 186, 85, 63, 62, 74, 84, 202, 36}, 208},
	{{160, 0, 0, 0, 0, 0, 224, 8, 193, 233, 220, 83, 222, 96, 216, 186}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 89, 9, 204}, 208},
	{{160, 0, 95, 52, 225, 1, 129, 106, 163, 161, 165, 229, 147, 66, 69, 51}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 114, 157, 17, 26, 82, 248, 166, 46, 92}, 208},
	{{160, 0, 0, 0, 0, 0, 81, 103, 136, 184, 167, 195, 19, 52, 154, 142}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 12, 224, 72, 160, 73, 21, 126, 196, 113}, 208},
	{{160, 0, 117, 59, 34, 128, 58, 144, 161, 50, 22, 224, 199, 17, 13, 92}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 19, 156, 173, 251, 74, 56, 121, 176}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 81, 163, 131, 1, 183}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 188, 15, 226, 107, 142}, 208},
	{{160, 120, 107, 254, 255, 212, 210, 151, 197, 43, 232, 118, 202, 211, 10, 57}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 106, 47, 109, 86, 37}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 130, 193, 248, 168, 177}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 86, 41, 166, 54, 72}, 208},
	{{160, 0, 0, 0, 0, 0, 96, 28, 238, 37, 185, 10, 176, 73, 90, 133}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 216, 36, 247, 119, 219, 149, 143}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 25, 103, 56, 247}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 63}, 208},
	{{160, 142, 160, 34, 127, 90, 162, 34, 125, 204, 60, 217, 106, 133, 148, 28}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 166, 187, 223, 101}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 161, 100, 122}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 149, 187, 242, 105, 78, 147, 171, 100, 203}, 208},
	{{160, 0, 154, 183, 121, 107, 224, 195, 205, 6, 110, 65, 32, 36, 217, 186}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 41, 200, 74, 163, 79, 144, 158, 247, 11}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 186, 58, 43, 191, 12, 26, 69, 203, 72}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 224, 59}, 208},
	{{160, 0, 0, 0, 0, 0, 11, 51, 235, 239, 17, 237, 127, 238, 10, 96}, 208},
	{{160, 0, 0, 0, 0, 0, 66, 108, 33, 121, 107, 115, 233, 146, 135, 254}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 82, 187, 112, 2, 152, 234, 164, 0, 131}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 182, 143, 168, 32, 52, 218, 117}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 77, 117, 103, 28, 231, 87, 138, 86}, 208},
	{{160, 0, 0, 0, 0, 0, 178, 83, 84, 101, 147, 252, 219, 159, 251, 239}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 183, 137, 126}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 0, 94, 91, 204}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 199, 249, 7, 254, 124, 71, 33, 157, 151, 93, 147, 85, 24, 230}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 125}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 21, 58, 214, 159, 236}, 208},
	{{160, 0, 0, 0, 119, 225, 65, 156, 61, 99, 70, 89, 106, 33, 141, 181}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 77, 57, 149, 71, 185, 155, 42, 61, 88, 30}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 40, 164, 195, 235, 150, 209, 113, 27}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 174, 4, 253, 125, 14, 43, 47, 41}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 94, 56, 167, 191, 251}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 240, 33, 113, 75, 233, 178, 149, 193, 225}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 48, 90}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 45, 20}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 83, 57, 208, 231}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 132, 52, 213, 70, 135, 79, 51}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 132, 86}, 208},
	{{160, 0, 0, 0, 150, 164, 230, 213, 12, 228, 81, 1, 249, 113, 28, 245}, 208},
	{{160, 0, 0, 0, 60, 121, 172, 14, 248, 77, 40, 225, 147, 196, 54, 206}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 208},
	{{160, 0, 0, 0, 0, 0, 0, 140, 79, 155, 47, 70, 91, 129, 93, 180}, 208},
	{{41, 85, 143, 128, 91, 137, 192, 0, 27, 104, 141, 212, 36, 90, 89, 139}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 88, 92, 178, 6, 152, 9, 26}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 123, 25, 125, 90, 61, 169, 192, 128}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 129}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 216, 83, 148}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 82, 203, 139, 121}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 178, 218, 143, 175, 60}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 254, 102, 202, 114, 174, 103, 91, 124, 68}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 47, 207, 64, 190}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 127, 230, 128, 214}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 74, 102, 192, 113, 211, 53, 85, 205}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 137, 58, 14}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 71}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 135, 1, 201, 190}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 126, 242, 13, 196, 15}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 238, 22, 45, 214}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 28, 251, 178}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 168, 149}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 89, 53, 182}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 97, 114}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 167, 130, 231, 220, 85, 133, 167, 161, 78}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 255, 138, 180, 206, 246, 133, 170, 206}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 129, 195, 205}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 167, 131, 212, 251}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 203, 65, 7, 76, 104, 105}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 39, 156, 188}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 94, 86, 134, 147}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 189, 15, 159, 161, 133, 21, 187, 113}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 118, 69, 28, 160, 247, 78, 23}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 172, 25, 252, 33, 41}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 47, 153, 54, 209, 224, 31}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 9, 127, 82, 215, 98}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 29, 251, 206, 232, 94, 133}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 143, 168, 225, 252, 71, 207}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 174, 91, 144, 125, 135, 26, 30, 7, 116}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 79, 225, 228, 153}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 75, 191, 191, 169, 159, 207, 89, 228, 49}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 162, 83, 241, 115}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 126, 76, 159, 230, 23, 157}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 123, 116, 227, 192, 47, 52, 164, 231}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 99, 248, 37, 242, 74, 192, 128, 240, 171}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 45, 5, 249, 45}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 159, 77, 166, 220, 127, 122}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 46, 199}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 35, 202}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 75, 125}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 16, 10, 8, 172, 163, 120}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 160, 87, 83, 211, 195, 121, 20, 222}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 91, 91, 88, 151, 122, 176, 82, 2, 149}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 53}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 91, 125, 33}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 57, 116, 140, 204, 73}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 235, 8, 89, 134, 236, 131, 9, 31, 239}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 111, 67}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 203, 168, 12, 207, 42}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 199, 6, 212, 133, 33, 151, 82, 126}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 206, 125, 100, 206, 78, 135}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 110}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 215, 103, 247, 69}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 63, 249, 214}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 59, 173}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 116, 92, 159, 103, 95, 224, 242}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 181, 106, 38}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 115, 125, 129, 174, 143, 4}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 117, 78, 61, 27, 164, 98, 122}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 85, 118, 124, 237, 76, 92}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 166, 67, 223, 125, 102, 122, 240}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 4, 24, 57, 140}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 81}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 187}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 10, 51, 27, 213, 27, 214, 37, 46}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 48, 7, 86, 100, 210, 27, 52, 157}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 166, 124, 219, 168, 20, 133, 175, 196}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 121, 22}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 176, 63, 40, 92}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 248, 10, 233, 246, 117, 232, 81}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 201, 225}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 16, 129}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 28, 76}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 71, 66, 242, 71, 107, 174}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 48, 243, 114}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 223, 228, 98, 244, 56}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 56, 19, 140, 193, 24, 216, 233, 71, 40}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 130, 168, 209}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 219},
	{{41, 85, 143, 128, 91, 137, 192, 0, 110, 154, 225, 82, 250, 159, 138, 192}, 219},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 44, 213, 182, 244, 6}, 165},
	{{116, 110, 192, 0, 0, 227, 199, 111, 7, 52, 90, 110, 80, 101, 43, 163}, 165},
	{{116, 110, 192, 0, 0, 87, 247, 56, 156, 174, 209, 143, 214, 190, 152, 106}, 165},
	{{116, 110, 192, 158, 17, 247, 145, 202, 86, 112, 202, 55, 46, 11, 40, 137}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 83, 210, 216, 148, 205}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 51, 162, 73}, 165},
	{{116, 110, 192, 0, 0, 0, 139, 8, 34, 97, 216, 208, 121, 11, 82, 237}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 165},
	{{116, 110, 192, 0, 0, 0, 2, 167, 176, 19, 225, 204, 137, 86, 66, 163}, 165},
	{{116, 110, 192, 43, 0, 157, 196, 146, 224, 168, 196, 118, 69, 20, 156, 132}, 165},
	{{116, 110, 192, 0, 33, 118, 191, 235, 27, 109, 229, 131, 22, 139, 142, 39}, 165},
	{{116, 110, 192, 0, 240, 108, 247, 173, 176, 227, 204, 212, 200, 146, 176, 135}, 165},
	{{116, 110, 192, 28, 122, 13, 33, 139, 229, 80, 47, 0, 255, 193, 185, 251}, 165},
	{{116, 110, 192, 0, 0, 93, 220, 77, 235, 185, 168, 115, 242, 92, 50, 86}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 26, 37, 32, 61, 28, 255, 228, 35}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 96, 101, 161, 197, 18, 228}, 165},
	{{116, 110, 192, 0, 0, 226, 130, 154, 150, 109, 148, 204, 111, 164, 38, 80}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 33, 15, 42, 243, 165, 47}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 47, 106, 117}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 134, 191, 102, 193, 15, 112, 156}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 95, 155}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 203, 240, 185}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 195}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 165},
	{{116, 110, 192, 28, 216, 236, 84, 67, 99, 160, 161, 86, 200, 89, 117, 127}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 58, 204, 43, 51, 87, 24, 1, 236, 19}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 159, 13, 43, 96, 161, 237, 126, 182, 79}, 165},
	{{116, 110, 192, 0, 0, 139, 36, 179, 253, 56, 101, 91, 226, 184, 15, 110}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 79, 221, 175, 251, 13, 250, 80, 60}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 150, 152, 2, 203, 159, 51, 116, 104}, 165},
	{{116, 110, 192, 0, 0, 219, 202, 222, 56, 217, 14, 15, 127, 39, 235, 234}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 165},
	{{116, 110, 192, 0, 182, 237, 141, 63, 170, 79, 251, 103, 86, 21, 118, 48}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 223}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 34, 241, 206, 50, 241, 248, 33, 108, 174}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 169, 12, 154, 227, 210, 253, 85, 34, 115}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 211}, 165},
	{{116, 110, 192, 0, 0, 192, 15, 147, 131, 233, 137, 207, 234, 189, 218, 57}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 76, 30, 215, 143, 178, 64, 160, 210}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 150, 136}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 208, 171, 218, 52, 244}, 165},
	{{116, 110, 192, 0, 194, 123, 155, 77, 28, 89, 136, 99, 0, 36, 213, 46}, 165},
	{{116, 110, 192, 0, 0, 177, 62, 25, 221, 104, 53, 75, 44, 235, 224, 18}, 165},
	{{116, 110, 192, 0, 218, 54, 183, 182, 27, 143, 18, 74, 59, 112, 31, 71}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 154, 95, 132, 84, 64, 194}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 210, 118, 192, 74, 42, 71, 206, 155, 15}, 165},
	{{116, 110, 192, 0, 21, 120, 31, 255, 142, 93, 52, 78, 82, 47, 224, 3}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 87, 240, 36, 194, 12, 4, 149}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 181, 127, 32, 231, 139, 234, 43}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 165},
	{{116, 110, 192, 226, 42, 0, 62, 160, 80, 4, 140, 167, 230, 142, 171, 134}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 190, 93, 83, 185, 64, 246, 78, 20}, 165},
	{{116, 110, 192, 0, 0, 0, 88, 12, 185, 131, 123, 190, 81, 89, 188, 31}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 167, 187}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 165},
	{{116, 110, 192, 0, 169, 224, 141, 232, 102, 141, 147, 148, 214, 202, 250, 204}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 165},
	{{116, 110, 192, 5, 174, 174, 215, 154, 176, 191, 67, 47, 117, 167, 77, 16}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 152, 161, 203, 70, 159}, 165},
	{{116, 110, 192, 0, 0, 30, 195, 85, 102, 236, 166, 184, 41, 76, 90, 118}, 165},
	{{116, 110, 192, 0, 5, 70, 246, 80, 56, 212, 179, 167, 102, 183, 17, 0}, 165},
	{{116, 110, 192, 0, 0, 50, 223, 243, 89, 254, 143, 243, 188, 127, 126, 26}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 212, 215, 167, 185, 222, 232, 92, 89, 18}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 183, 195, 79, 251, 63, 33, 90, 136}, 165},
	{{116, 110, 192, 0, 0, 106, 254, 101, 110, 128, 15, 227, 36, 170, 113, 136}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 80, 91, 231, 40, 96, 199, 254, 157, 22}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 133, 226}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 247, 234, 218, 140, 204, 101}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 4}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 152}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 85, 133, 131, 187, 8}, 165},
	{{116, 110, 192, 0, 0, 0, 89, 214, 130, 235, 23, 129, 114, 84, 172, 134}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 133, 221, 177, 18, 11, 205, 89, 59}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 132, 136, 64}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126, 250}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 175}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 206, 178, 0}, 165},
	{{116, 110, 192, 0, 110, 181, 109, 66, 139, 85, 141, 106, 80, 5, 229, 43}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 222, 124, 186, 228, 21, 53}, 165},
	{{116, 110, 192, 0, 0, 229, 29, 128, 195, 150, 81, 230, 15, 68, 244, 45}, 165},
	{{116, 110, 192, 0, 88, 18, 80, 223, 244, 52, 146, 192, 90, 191, 11, 74}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 68, 20, 172, 231, 246, 175, 127, 67, 113}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 254, 27}, 165},
	{{116, 110, 192, 0, 225, 14, 84, 225, 41, 180, 9, 116, 20, 69, 28, 143}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 225, 229, 8, 255, 229, 18, 76}, 165},
	{{116, 110, 192, 17, 169, 146, 206, 34, 242, 196, 126, 42, 65, 179, 175, 188}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 141, 192, 5}, 165},
	{{116, 110, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 165},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 99}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 28}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 134}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 56}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 137}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 58}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 189}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 226}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 254}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 130}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 209}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 209}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 141}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 64}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 122}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 142}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 169}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 153}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 234}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 245}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 160}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 240}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 247}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 233}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 219}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 218}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 1}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{75, 213, 44, 16, 43, 157, 34, 171, 98, 117, 109, 151, 5, 60, 224, 0}, 6},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 72, 185, 108}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 239, 38}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 230, 122, 56, 168, 92}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 74, 34, 24}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 78, 5, 126, 79, 92, 76}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 17, 141, 194}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 10, 179, 100, 68, 52, 62, 219, 67}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 203, 172, 173, 237}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 215, 54, 49, 230}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 35, 172, 166}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 118, 153, 156, 96, 69}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 69, 0, 183, 133, 86, 134}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 215, 65, 93, 77, 189, 45, 141}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 172, 63, 111, 3, 131}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 46, 226, 16}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 99, 8, 91}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 142, 200, 222, 193, 228, 2, 68}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 111, 59, 69}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 206, 172, 65, 49, 167, 52}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 102, 110, 49, 163, 33, 248}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 9, 155, 214, 183, 46, 143, 168, 35}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 227}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 222, 152, 14}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 95, 196}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 90, 184, 28}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 218, 207, 34}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 220, 109, 8, 196, 164, 97}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 40, 132, 221, 195}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 187, 173, 83, 5, 23, 37, 122, 15}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 53, 51, 93, 6, 250, 31}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 89, 70}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 119, 76, 226}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 222, 212, 167, 139}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 130, 185, 237, 129, 140, 72, 50, 153}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 50, 73}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 169, 82, 87, 122, 113}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 15, 205, 15, 207, 252, 105}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 212, 225, 242}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 88, 205, 224, 234, 91}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 120, 11}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 226, 107, 134, 164}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 5, 231, 49, 214, 36, 236, 132}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 106, 142, 215, 10, 109}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 236, 38, 157, 93, 230, 17, 59}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 51, 0, 92, 48, 66, 183, 199}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 97, 146, 112}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 115, 108, 170, 144, 167, 198, 232, 70, 65}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 20, 0, 44, 75, 4, 128}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 185, 64, 41, 121, 153}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 109, 96, 13, 226, 65, 0, 126, 151, 233}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 203, 18, 77, 76, 80, 179}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 73, 218, 129}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 9, 201, 26, 182, 150, 124}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 20, 105, 255, 128, 65, 242, 164}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 110, 207, 106, 64, 220, 90, 102, 185, 222}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 90, 25, 8}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 113, 145, 92}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 37, 15}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 108, 61, 189, 3, 41, 100, 255}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 237, 110, 42, 6, 132}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 26, 177, 103}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 144, 241}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 120, 234, 160, 6, 181}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 208, 215, 193, 192, 195, 82}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 187, 213, 75, 7, 156, 80}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 128, 204, 193, 227, 125}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 90, 110, 99, 40, 110, 249}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 111, 254, 123, 167, 230}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 198, 210, 82, 182, 85, 13}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 72, 37, 64, 121, 3, 53}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 104, 84, 219, 224, 43, 214}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 129, 53, 220, 43, 113, 64, 200, 168}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 143, 241, 103, 83, 255, 204, 93}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 81, 90, 122, 85, 5, 196, 5}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 216, 252, 23, 58}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 225, 114, 179}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 104, 58, 81, 112}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 175, 52, 107, 191, 46, 106, 35}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 57}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 113, 97}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 215}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 141, 240, 153, 43, 7}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 200, 228, 1, 98, 133, 66, 147, 72}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 44, 138, 94, 246}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 195, 55, 167, 139, 157, 230}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 13, 166, 40, 111, 2, 19}, 47},
	{{229, 23, 116, 61, 80, 139, 200, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 47},
	{{83, 123, 74, 0, 0, 0, 193, 71, 104, 8, 208, 232, 230, 26, 179, 91}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 74, 84, 39, 255, 245}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 212, 149, 237, 145, 60, 32, 231, 82}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 212, 114, 67, 219, 50, 202, 140, 204, 95}, 73},
	{{83, 123, 74, 0, 46, 148, 95, 99, 194, 241, 80, 154, 100, 242, 226, 12}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 73},
	{{83, 123, 74, 0, 201, 220, 208, 94, 8, 189, 220, 113, 229, 115, 58, 3}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 73, 28, 56, 211, 127, 150, 86}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 107, 105, 158, 83, 31, 89, 105}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 33, 170, 59, 118, 21}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 109, 169, 62}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 211, 125, 212, 177, 61, 226, 195}, 73},
	{{83, 123, 74, 0, 148, 254, 190, 21, 24, 194, 23, 122, 26, 245, 208, 119}, 73},
	{{83, 123, 74, 0, 0, 0, 242, 199, 20, 68, 78, 22, 127, 252, 16, 193}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 86, 166, 121, 68, 167, 207, 251, 214}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55, 236, 243, 235}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 32, 148, 184}, 73},
	{{83, 123, 74, 225, 165, 79, 64, 68, 20, 85, 201, 31, 254, 244, 126, 37}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 184, 70, 156, 53, 145, 49}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66}, 73},
	{{83, 123, 74, 0, 34, 142, 221, 18, 5, 5, 54, 144, 71, 194, 131, 180}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 196, 230, 193}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 186, 207}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 235, 218}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 39, 202, 248, 106, 87}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 94, 118, 154}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 214, 222, 55, 157, 173, 28, 192, 141}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 211, 117}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 197, 185, 200, 7, 32, 52, 116, 106, 166}, 73},
	{{83, 123, 74, 0, 217, 220, 167, 233, 59, 64, 245, 119, 158, 136, 90, 165}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 73},
	{{83, 123, 74, 48, 51, 65, 226, 113, 118, 2, 86, 77, 120, 189, 14, 115}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 159, 216}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 73},
	{{83, 123, 74, 0, 0, 105, 117, 64, 136, 95, 224, 205, 66, 101, 168, 87}, 73},
	{{83, 123, 74, 0, 109, 148, 17, 31, 14, 229, 154, 242, 78, 207, 233, 188}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 108}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 156, 86, 183, 156, 154, 71, 148}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 125, 184, 155, 252, 193}, 73},
	{{83, 123, 74, 0, 164, 39, 73, 204, 203, 237, 246, 35, 182, 51, 45, 33}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 73},
	{{83, 123, 74, 0, 0, 111, 58, 5, 27, 216, 219, 135, 57, 114, 228, 95}, 73},
	{{83, 123, 74, 0, 129, 32, 227, 137, 115, 223, 103, 248, 103, 158, 41, 250}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 209}, 73},
	{{83, 123, 74, 0, 0, 69, 188, 99, 197, 31, 255, 190, 123, 169, 245, 21}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 11, 154, 85, 50, 28, 105, 164, 32, 203}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 136, 127, 61, 120, 67, 255}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 59, 78, 79, 179, 197, 0}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 190}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 250, 138}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 165, 57, 81, 194, 90, 50}, 73},
	{{83, 123, 74, 0, 84, 28, 201, 25, 186, 254, 235, 101, 77, 222, 115, 113}, 73},
	{{83, 123, 74, 0, 226, 209, 220, 164, 189, 213, 50, 167, 229, 148, 89, 4}, 73},
	{{83, 123, 74, 0, 0, 0, 195, 122, 197, 4, 107, 246, 70, 126, 168, 194}, 73},
	{{83, 123, 74, 0, 24, 91, 27, 12, 238, 102, 177, 44, 206, 73, 84, 80}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 166, 132, 53, 132, 61, 78, 202, 147}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 249, 87}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 169, 212}, 73},
	{{83, 123, 74, 0, 0, 59, 221, 69, 67, 157, 78, 13, 254, 175, 32, 97}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 214, 254, 9, 123, 76, 108}, 73},
	{{83, 123, 74, 43, 67, 243, 2, 211, 111, 31, 133, 146, 108, 222, 212, 236}, 73},
	{{83, 123, 74, 0, 204, 149, 97, 111, 31, 142, 100, 114, 106, 227, 92, 224}, 73},
	{{83, 123, 74, 0, 152, 239, 12, 210, 165, 134, 253, 32, 98, 108, 190, 159}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 238, 140, 137, 154, 181}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 80}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 43, 179, 240, 97, 121, 48, 78, 179, 251}, 73},
	{{83, 123, 74, 0, 0, 48, 61, 91, 76, 35, 145, 70, 47, 215, 206, 193}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 119, 253, 189, 27, 205}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 42, 90, 136}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 158, 77, 63, 188, 39, 86, 149}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 67, 114, 221, 8, 188, 187}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 27, 28, 161, 216, 41, 97, 242}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 85, 127, 184, 111, 221}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 62, 98}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 139, 151, 181, 80, 22, 33, 26, 250}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 73},
	{{83, 123, 74, 0, 129, 167, 40, 170, 136, 174, 27, 184, 19, 175, 227, 150}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 224, 220, 86, 135, 150, 241}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 73},
	{{83, 123, 74, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 38, 199}, 73},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 130, 116}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 223, 183}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 46, 185, 68, 31}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 196, 134, 72}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 79, 214, 62, 162, 204, 173, 84, 171, 3}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 195, 131, 39, 107, 94, 128, 107, 98, 236, 156}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 231, 82, 147, 24, 213, 80, 8, 189}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 241, 83, 18, 253, 88, 62, 133, 123, 99}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 96, 34, 24}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 63, 49, 98, 12, 185, 218, 101, 209, 72}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 49, 108, 66, 90}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 165, 105, 190, 65, 202, 7, 244, 48}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 176, 190, 125, 197, 148}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 154, 118, 193}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 129, 58, 152, 228}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 44, 192, 197, 105, 81, 189, 77, 7, 95}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 177, 12, 250, 104, 195}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 155, 57, 113, 99, 229, 181, 62}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 150, 39, 233}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 32, 177, 20, 135, 8}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 175, 215, 46}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 190, 97, 3, 205, 54, 70, 170, 85}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 233, 228, 39, 232, 186, 178, 25}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 89, 212, 203, 34, 96}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 107, 241, 26, 58}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 13, 38, 120, 211, 38, 47, 96}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 114, 123, 231, 39, 240, 71, 35, 233}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 65, 208}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 16, 56, 119, 192}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 83, 22}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 197, 63}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 9, 40, 199, 117, 113, 254, 121, 60}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 24, 23, 22, 173, 46, 38, 30}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 166, 171}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 140, 109, 164, 44}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 48, 223, 238, 126, 216, 28, 128, 3, 72}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 78, 146, 10, 144, 99, 182, 240, 183, 2}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 152, 216, 211, 146, 103, 140, 55}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 75, 168, 54, 119}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 57, 40, 140, 195, 107}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 129, 215, 232, 235, 75}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 32, 122, 210, 48, 87, 70, 246, 194, 158}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 32, 144, 244, 253, 122, 249}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 83, 122, 18, 127, 120, 178, 143, 204}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 25, 63, 129, 211, 125, 207, 226, 189, 198}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 255, 117}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 74, 28}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 254, 83, 54, 203, 13}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 112, 224}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 37, 34, 162, 78}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 54, 81}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 132, 184}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 184, 24, 39, 215, 91, 90}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 65, 145, 18, 151, 249, 192, 197, 57}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 79, 60, 63}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 171, 67, 246, 23, 64, 20, 206, 6}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 246, 221, 143, 72, 188, 78, 76, 243, 68}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 89, 44, 72, 8, 159, 84, 138, 35, 69}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 27, 168, 151}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 47, 23, 54, 169, 17, 17, 131, 157, 57}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 67, 186, 164, 80}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 232, 205, 112}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 208, 95, 233, 11, 207, 23}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 236, 223, 115}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 50, 45, 45, 115}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 3, 224, 73, 148}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 85, 18, 15, 205, 207}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 151, 101, 184}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 103, 191, 209}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 44, 64, 120, 214, 168}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 239, 6, 242}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 152, 89, 250, 84, 220, 145, 55}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 172, 94, 231, 119, 34, 230, 247, 88, 147}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 0, 0, 190, 164, 249}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 0, 0, 17, 150, 82, 108, 29}, 98},
	{{151, 243, 45, 217, 216, 158, 0, 0, 0, 151, 49, 16, 202, 110, 181, 44}, 98},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 9, 56, 76, 134}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 175, 219, 143, 38, 51, 90, 105, 5}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 147, 221, 167}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 69, 226, 195, 122, 197, 59, 136, 120, 241}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 7, 223, 83, 230, 62}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 97, 177, 111}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 25, 148, 85, 161, 2, 88}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 178, 104, 120, 90, 147}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 254, 225, 216, 18, 66, 127, 255, 72}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 115, 26}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 161, 40, 90, 250, 15, 160, 76}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 248, 222, 229, 40, 225, 131, 248, 173}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 213, 196, 146, 199, 80, 10, 246, 60}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 44, 169, 69, 231}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 207}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 22, 1, 70, 194, 177, 192, 95}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 193, 251, 30, 210, 159}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 116, 59}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 153, 97, 177}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 25, 51, 82, 102, 70, 29}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 168, 37}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 84, 49, 196, 72, 194, 201}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 209, 24, 164, 227, 190}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 17, 79}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 4, 201, 201}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 200, 131, 140, 28}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 250, 240, 115, 161, 101, 119}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 208, 145, 163, 136, 188, 236, 186, 118, 112}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 10}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 150, 14}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 173}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 8}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 102, 36, 42, 139, 29}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 93, 53, 222, 72, 132, 146, 165, 115}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 109, 63, 121, 217, 54, 236, 96, 116}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 35, 253, 206, 190}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 143, 39, 76, 84, 127, 30, 109, 231}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 35, 229, 63, 193, 167}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 105, 145}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 63, 151, 87, 24, 58, 243, 154, 183}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 235, 65, 30, 227, 193, 140}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 111, 58, 108, 163, 116, 51, 140}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 155, 65, 188, 76, 127, 248, 178}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 78, 37, 166}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 41, 156, 93, 26, 23, 98, 211, 44}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 56, 46, 15, 42}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 241, 228, 192, 124, 167}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 55, 204}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 228, 14, 148, 52, 194}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 199, 73, 137, 179, 94}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 203, 129, 185, 4, 32, 159, 173, 93}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 243, 81}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 168, 40, 231, 93, 55}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 117, 137, 220, 83, 174}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 219, 121, 171, 166}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 124, 105, 66}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 199, 203, 64, 14, 41}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 52, 135, 27, 130, 103, 5, 45, 26}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 248, 233, 129, 74, 251, 156, 247, 195, 95}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 193, 144, 138, 213, 116, 211}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 180, 155, 236, 208, 74, 193, 69}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 75, 151, 199}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 117, 73, 158, 124, 161, 6}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 1, 244, 4, 196, 23, 248}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 22, 116, 107, 184, 111, 125, 123, 246}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 145, 49, 240, 224, 35, 22, 218}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 144, 46, 246, 42, 10, 248, 227, 127, 193}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 35, 225, 220}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 41, 66, 101, 180, 222, 125, 13, 101, 20}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 184, 231, 20}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 184, 32, 28, 185, 183}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 51, 240, 28, 96, 75, 252, 137}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 54, 45}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 59, 234, 103}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 239, 120, 99, 153, 177, 86, 86, 70}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 15, 87, 36}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 199, 149, 194, 84, 229, 202, 246}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 28, 83, 79}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 70, 186, 123, 38, 211, 176, 186}, 21},
	{{171, 184, 110, 211, 237, 114, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 21},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 215}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 84, 43, 6, 68, 62, 131, 125}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 147}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 134, 35, 35, 248, 16, 176, 53, 254, 106}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 104, 223, 181, 6}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 108, 143, 138, 102, 61, 208}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 133, 2, 28, 76, 162, 216, 206, 113, 184}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 121}, 142},
	{{7, 246, 199, 119, 0, 0, 209, 60, 110, 16, 70, 38, 6, 171, 211, 13}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 125, 74, 194, 89, 114, 100}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 172}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 199, 125}, 142},
	{{7, 246, 199, 119, 0, 68, 122, 241, 219, 139, 38, 54, 89, 20, 165, 56}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 89, 128, 7, 239, 106, 118, 62, 31}, 142},
	{{7, 246, 199, 119, 0, 10, 128, 171, 157, 162, 168, 64, 242, 106, 21, 138}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 142, 140}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 161, 147, 135, 251, 22, 230, 18, 110}, 142},
	{{7, 246, 199, 119, 0, 0, 143, 70, 8, 247, 46, 164, 48, 113, 89, 226}, 142},
	{{7, 246, 199, 119, 0, 0, 133, 238, 117, 37, 163, 92, 12, 247, 80, 111}, 142},
	{{7, 246, 199, 119, 0, 0, 20, 165, 125, 61, 35, 67, 198, 242, 214, 140}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 249}, 142},
	{{7, 246, 199, 119, 0, 148, 194, 185, 147, 78, 161, 62, 4, 156, 105, 126}, 142},
	{{7, 246, 199, 119, 0, 0, 218, 49, 97, 127, 153, 140, 54, 112, 147, 71}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 194, 235, 83, 182, 123, 116, 47}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 176, 90, 161, 181, 155, 101, 197, 6}, 142},
	{{7, 246, 199, 119, 0, 0, 54, 228, 197, 135, 173, 188, 103, 164, 50, 125}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 76, 211, 1, 164, 69, 107, 104, 24, 77}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 252, 34, 232, 124, 151, 173, 109}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 77, 110, 145, 128, 20, 253, 231, 112, 89}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 142, 189}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 243, 45, 24, 104, 47, 236, 88, 151}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 218, 2, 166, 182, 185, 241}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 5, 59, 100, 46, 2, 58, 12, 205, 129}, 142},
	{{7, 246, 199, 119, 0, 110, 77, 192, 5, 17, 70, 116, 198, 148, 241, 29}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 206, 177, 56, 181, 4, 76, 207, 186}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 253, 168}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 46, 159, 50, 185, 135, 126, 247, 41}, 142},
	{{7, 246, 199, 119, 0, 110, 77, 180, 193, 187, 116, 255, 247, 158, 22, 67}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73}, 142},
	{{7, 246, 199, 119, 0, 0, 6, 112, 105, 161, 137, 172, 8, 114, 201, 92}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 45, 28, 93, 113, 70, 13, 204, 39}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 52}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 167, 208, 254, 11, 90}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 111, 133, 116, 243, 94, 85, 12}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 33, 75, 172, 70, 17}, 142},
	{{7, 246, 199, 119, 0, 0, 199, 186, 1, 179, 53, 143, 142, 203, 124, 109}, 142},
	{{7, 246, 199, 119, 0, 138, 60, 175, 6, 4, 229, 0, 182, 166, 165, 105}, 142},
	{{7, 246, 199, 119, 0, 72, 25, 103, 192, 119, 147, 254, 213, 24, 130, 79}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 60, 231}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 218}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 102, 21, 103, 111, 53, 146, 70}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 109, 13, 82, 19, 97, 226, 37, 2}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 163, 131}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 101, 129, 113, 29, 76, 16, 144, 180, 88}, 142},
	{{7, 246, 199, 119, 0, 23, 58, 187, 185, 126, 193, 135, 234, 44, 213, 63}, 142},
	{{7, 246, 199, 119, 0, 0, 148, 92, 249, 119, 156, 173, 84, 11, 124, 49}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 36, 231, 138, 101, 11}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 228, 121, 36, 127, 199, 13}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 213}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 84, 226, 67, 253}, 142},
	{{7, 246, 199, 119, 0, 0, 36, 161, 95, 17, 174, 164, 188, 112, 37, 182}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 132, 90, 253, 110, 53, 185}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 201, 104, 137, 15, 226, 12, 162, 82}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 159, 219, 188, 54, 65}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 210, 214, 194, 184, 9, 62, 0, 89, 51}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 135}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 216}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 199, 135, 206, 214, 190}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 181, 175, 252, 122, 43, 121, 253}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 41, 54}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 123, 248, 226, 117, 127, 6, 169, 187}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 55, 48, 14, 81, 204, 57, 90}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 9}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 66, 114, 110, 77}, 142},
	{{7, 246, 199, 119, 0, 0, 37, 184, 81, 160, 223, 241, 136, 129, 226, 251}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 196, 73, 198, 144, 82, 69, 206, 9}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 168, 254, 116, 119, 218, 20}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 18}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 126, 214, 70, 195, 174, 237, 11, 251, 194}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 24, 15, 134, 135}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 201, 213, 15, 126, 53, 40, 0, 163}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 133, 200}, 142},
	{{7, 246, 199, 119, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 224, 238}, 142},
	{{7, 246, 199, 119, 0, 165, 242, 101, 243, 13, 177, 58, 52, 93, 57, 157}, 142},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 103}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 156, 198}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 144, 19, 62}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 50, 19}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 75}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 152, 244, 50, 136}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 69, 127, 13}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 176, 127, 207, 88}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 219, 6}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 210, 174, 73, 147}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 217, 129, 135}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 203, 144, 176}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 48, 246, 249}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 38, 114, 87, 213}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 177, 129}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 64, 188, 94}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 69, 181}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 207}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 71, 198, 150}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 254, 232}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 175, 84, 95}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 175}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 113, 40}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 104, 196, 233}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 134, 242, 118}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 211, 119, 33}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 40, 106, 193}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 214}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 36}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 119, 105, 70}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 12, 220, 64}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 86, 105, 252}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 212, 56}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 218, 201, 26}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 120, 229}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 213, 27}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 254}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 68, 120, 163}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 246, 172}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 226}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 106, 17, 140, 227}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 58, 58}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 185, 222, 244}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 107, 217, 248}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 15}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 28}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 251}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 66, 125, 250, 53}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 97, 51}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 221, 184, 154}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 189}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 70, 239, 120, 157}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 255, 61, 200, 144}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 68, 205}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 157, 94}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 203}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 95, 193}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 82, 96}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 10, 212}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 1, 28}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 69, 218}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 67}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 78, 140, 87}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 116, 248}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 103, 229, 131}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 48, 161, 198}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 210}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 168, 135}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 145, 4}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 85, 20, 204}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 47}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 155}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 0, 0, 0, 0}, 34},
	{{103, 47, 70, 17, 31, 232, 44, 75, 145, 155, 100, 216, 134, 63, 151, 21}, 34},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 17}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 225, 243, 76}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 86, 214, 154, 179}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 63}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 182, 246, 104, 55, 250}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 133, 6, 31}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 220, 102}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 79, 98}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 2, 134, 37, 94, 80}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 205, 37, 147, 217, 164, 177}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 81, 12}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 81, 102}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 107, 222, 1, 45, 247}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 243, 165}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 223, 98, 194}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 49, 206, 74}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 190, 190, 166}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 4, 83, 240, 213, 91}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 224, 232, 0, 147}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 134, 170}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 26, 210, 55, 208}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 58, 181, 123, 27}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 190, 42, 148, 229, 106}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 124, 131, 140, 111}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 247, 20, 43, 174, 135, 195}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 60, 227, 103, 51}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 246, 180, 214, 233, 8}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 165, 113, 30, 173}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 159, 74, 107, 40}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 175}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 180, 71, 181, 71, 121}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 22}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 63, 169, 240, 174, 78}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 152, 126, 214, 50}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 83, 11, 180, 197}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 41, 46, 230, 53, 8}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 250, 58, 24, 196}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 235, 19}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 11}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 250, 122, 219}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 161, 186, 26, 45, 162, 254}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 23, 11, 255, 97, 246}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 41}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 177, 241, 94}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 201, 159, 159, 136, 66, 89}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 114, 221}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 216, 6, 119, 154, 218}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 160, 183}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 218, 87, 31}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 98, 124, 44}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 184, 164, 204, 144, 47, 87}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 81}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 185, 154, 134, 106, 126}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 75}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 197}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 23, 141}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 68, 28}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 123, 205}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 166}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 129, 186, 157, 168}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 4, 18, 63, 92, 88, 83}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 42, 61, 178, 175}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 38, 106}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 128, 233, 118}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 28}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 122}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 142, 197, 188, 168, 229, 238}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 123, 226, 15, 178}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 66, 182}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 250, 71, 233}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 172, 242, 224, 62}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 201, 81, 249}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 99, 186, 242, 246, 20, 163}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 173, 120, 184, 252, 173}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 74, 26, 19, 110, 193}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 38, 176, 145}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 210, 113, 166, 106}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 108, 80, 58, 206}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 20, 38, 43, 116, 174}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 110}, 41},
	{{65, 170, 169, 100, 167, 147, 142, 251, 20, 64, 0, 0, 0, 0, 0, 0}, 41},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 122, 200, 233, 172, 99}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 18, 42, 219, 126, 60}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 42, 91, 97}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 253, 188, 71, 68, 120}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 77, 0, 187, 200, 139, 33, 90}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 101, 169, 241}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 46, 36, 182, 36}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 75, 17, 4, 227, 181, 188, 212, 205}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 199, 113}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 162, 61, 198, 209, 10, 115, 131}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 92, 51, 83, 39}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 148, 188, 33, 229, 223, 68, 38, 134}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 90, 137, 62, 32, 105, 76}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 34, 196, 215, 90, 94, 141}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 54, 154, 126, 64, 58, 168}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 57, 235, 238}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 190, 195, 88}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 99, 126, 198}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 242, 181, 56, 185, 166, 221, 231, 12}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 198, 109, 75, 67, 92, 45, 54}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 145, 83, 53, 96, 20}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 11, 219, 178, 240}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 91, 223, 1, 96, 45, 141, 70}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 218, 246, 14, 143, 205}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 62, 44, 60, 35, 128, 171, 199}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 15, 141, 34, 38, 54, 89}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 45, 102, 99, 242, 6, 31, 4}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 230, 18, 112, 27}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 211, 158, 14}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 29, 217, 107, 60, 12, 101}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 8, 64, 173, 112, 232}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 29, 74}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 85, 73, 178}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 220, 255, 64, 92, 46, 234, 198, 110}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 168, 40, 122, 52, 145, 77}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 96, 62, 19, 179, 210}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 212, 210, 103, 164, 166}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 84, 8, 104, 116, 3}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 91, 246, 44, 3, 58, 14, 207, 54}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 86, 212, 50}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 60, 117, 19, 169, 45, 132}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 197, 184, 156, 147}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 49, 179, 203, 0, 237, 61, 62, 52}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 160, 61}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 23, 61, 180, 92, 136}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 252}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 149, 244, 63, 237, 49, 148, 124, 230}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 17, 237, 100, 39, 165, 22, 168, 170}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 247, 47, 52, 81, 3, 128, 221}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 224, 97}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 214, 52, 117, 66, 209}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 167, 103, 111, 91, 215, 87, 130, 247}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 175, 103, 133}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 192, 56, 126}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 11, 80, 97}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 93, 255, 192, 182, 11, 162}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 88, 86, 108, 37, 123, 35, 85, 167}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 123, 46, 209, 34, 234, 237, 150, 89}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 180, 220, 39, 38, 223, 216, 204}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 16, 191}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 140, 118, 224, 238}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 22, 31, 170, 57}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 220, 143, 180, 236, 162, 199, 113}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 229, 151, 69, 27, 145, 72, 10}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 144, 195, 2, 105, 22, 40, 53}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 76, 121, 246, 115, 244, 161, 219}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 129, 33, 63, 112, 181, 224}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 202, 89, 224, 43, 48, 213}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 59, 165, 214, 28}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 55, 123}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 175, 51, 63}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 59, 51, 48, 233, 188}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 51, 250, 210, 130, 54, 6, 127, 8}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 58, 214, 45, 112, 30}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 195, 239, 60, 132, 146, 3, 67}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 65, 83, 46, 244}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 145, 7, 250}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 0, 0, 55, 110, 173}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 0, 0, 155, 159, 82, 66, 162}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 50, 196, 46, 49, 222, 110, 248, 1}, 80},
	{{235, 6, 229, 248, 151, 137, 36, 0, 0, 139, 249, 98, 18, 218, 139, 118}, 80},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 187, 247, 3, 223, 165, 129}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 129, 91}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 128, 189, 243}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 81, 246, 195, 218, 238, 99, 42, 196, 175}, 11},
	{{156, 39, 96, 0, 92, 34, 43, 28, 176, 78, 242, 9, 163, 10, 50, 228}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 52}, 11},
	{{156, 39, 96, 0, 159, 202, 235, 115, 147, 178, 168, 70, 220, 77, 202, 40}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 16, 31}, 11},
	{{156, 39, 96, 0, 0, 0, 102, 65, 94, 247, 154, 247, 85, 145, 247, 19}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 225, 136, 218, 28, 57, 61, 81, 178, 153}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 165, 102}, 11},
	{{156, 39, 96, 0, 0, 0, 218, 195, 231, 237, 31, 65, 42, 151, 209, 151}, 11},
	{{156, 39, 96, 0, 0, 68, 14, 221, 121, 33, 209, 13, 27, 113, 238, 238}, 11},
	{{156, 39, 96, 0, 0, 0, 17, 93, 164, 88, 53, 90, 78, 61, 146, 144}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 105, 142, 70, 91, 217, 199, 1}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 95, 219, 192, 203, 57, 248, 210}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 249, 116, 152, 195, 108, 246}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 110, 66, 16}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 62}, 11},
	{{156, 39, 96, 0, 0, 51, 168, 38, 160, 123, 100, 123, 44, 66, 161, 224}, 11},
	{{156, 39, 96, 0, 0, 0, 240, 246, 153, 113, 169, 236, 42, 195, 213, 25}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 195, 153, 31, 143, 242, 103, 31, 138}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 1, 185, 7, 74, 46}, 11},
	{{156, 39, 96, 0, 0, 87, 14, 123, 145, 18, 21, 4, 123, 247, 62, 242}, 11},
	{{156, 39, 96, 0, 0, 0, 90, 1, 51, 135, 134, 17, 69, 2, 92, 225}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 44, 79, 135, 46, 193, 117}, 11},
	{{156, 39, 96, 0, 27, 123, 82, 192, 152, 22, 111, 185, 160, 81, 172, 108}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 134, 71, 156, 41, 129, 77, 21}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 231}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 3, 228, 74}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 75, 89, 181, 113, 250}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 199, 113, 178, 220, 121, 102, 37, 247, 33}, 11},
	{{156, 39, 96, 234, 12, 231, 104, 59, 87, 70, 48, 225, 116, 254, 214, 157}, 11},
	{{156, 39, 96, 0, 0, 250, 95, 9, 39, 118, 187, 71, 31, 197, 221, 157}, 11},
	{{156, 39, 96, 74, 112, 75, 169, 2, 18, 210, 247, 75, 79, 20, 24, 203}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 146, 113, 40, 166, 239}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 186}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 103, 255, 44, 192, 149, 200, 172, 110, 48}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 53, 68}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 214, 238, 218, 32, 175, 3, 167, 169, 105}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 8, 84}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157, 211}, 11},
	{{156, 39, 96, 0, 0, 152, 95, 144, 251, 161, 219, 226, 224, 244, 15, 240}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{156, 39, 96, 0, 0, 2, 24, 86, 69, 26, 182, 227, 109, 126, 80, 13}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 122, 54, 218, 128, 45, 123}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 122}, 11},
	{{156, 39, 96, 0, 0, 169, 213, 241, 235, 179, 80, 253, 237, 195, 28, 176}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 73, 68, 61, 188, 198, 237}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 224, 92, 218, 112, 96, 38, 101}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 50, 25, 113, 11, 151}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{156, 39, 96, 214, 53, 21, 101, 112, 95, 197, 16, 229, 254, 57, 64, 201}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 244, 189, 52, 161, 125, 20, 255, 80}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 192, 158, 196}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 94, 31, 244}, 11},
	{{156, 39, 96, 0, 0, 0, 70, 40, 32, 35, 149, 78, 88, 165, 15, 186}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 158, 44}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 240, 211, 126, 3, 131, 41, 9, 175}, 11},
	{{156, 39, 96, 37, 22, 200, 78, 144, 11, 201, 16, 179, 209, 14, 205, 254}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 175, 14, 155}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 147, 29, 53, 50, 80, 133, 243}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{156, 39, 96, 0, 189, 129, 22, 138, 129, 203, 243, 78, 254, 251, 134, 0}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 253, 103, 254, 236, 200, 54, 161, 93}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 153, 197, 78, 5}, 11},
	{{156, 39, 96, 0, 193, 42, 134, 210, 134, 126, 44, 152, 77, 164, 53, 170}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 224}, 11},
	{{156, 39, 96, 0, 155, 239, 44, 89, 38, 202, 96, 49, 72, 159, 90, 89}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 11},
	{{156, 39, 96, 180, 45, 184, 124, 200, 191, 177, 155, 216, 64, 52, 102, 26}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 197, 227, 16, 34, 110, 64, 211, 241, 213}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 68}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 248, 68, 231}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 11},
	{{156, 39, 96, 0, 74, 236, 201, 152, 213, 68, 171, 229, 98, 188, 132, 107}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 183, 167, 228, 63, 48, 62, 221, 77}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 29, 132, 8, 130, 102, 83, 97, 98, 29}, 11},
	{{156, 39, 96, 0, 0, 0, 197, 130, 24, 102, 167, 155, 166, 243, 177, 93}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 82, 178, 200, 172, 195, 239, 225, 172}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 4, 225, 46, 67, 62}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 11},
	{{156, 39, 96, 183, 118, 149, 156, 166, 108, 174, 126, 232, 248, 111, 137, 76}, 11},
	{{156, 39, 96, 0, 0, 177, 46, 169, 236, 246, 233, 122, 120, 58, 159, 232}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 174, 114, 66, 189, 69, 21, 95}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 7, 121, 21, 144, 153, 175}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 33, 156, 164, 235, 217, 113, 40}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 108, 14, 75, 236, 38}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 83, 176, 237, 118, 65, 211}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 106, 24}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 221, 132}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 62, 229, 182, 37, 30, 205, 207, 123, 150}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 0, 206, 240, 125, 223, 87, 3, 47}, 11},
	{{156, 39, 96, 0, 0, 0, 0, 0, 29, 37, 135, 122, 66, 147, 239, 212}, 11},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 76}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 3, 35, 180, 12, 130, 212, 125}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 164, 210, 205}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 194}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 56, 175, 181, 201, 97, 189, 138, 195}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 36, 15, 223, 35}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 18}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 145, 196, 52, 81, 118}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 196, 159, 69, 104, 90, 102}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 236, 68, 145, 99, 118}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 223, 118, 145}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 123, 11}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 12, 83, 49, 103, 25, 209, 212}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 54, 109}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 197, 218, 99, 90, 69, 136}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 162, 162, 77, 115, 253, 97, 145, 64}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 50, 191, 23, 32, 99, 180}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 237, 77, 30, 177, 177, 218}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 252, 96, 244, 226}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 100, 83, 190}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 53, 62, 146, 12, 147, 93, 189, 204}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 8, 171, 204, 95}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 216, 200}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 172, 141, 255, 246, 247, 36, 15}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 230, 115, 212}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 100, 25, 136}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 63, 125}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 206}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 161, 248, 177, 84}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 158}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 218, 175, 205}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 156, 31, 110, 189}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 89, 246, 252}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 189, 198, 85, 65, 97, 154, 174}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 6}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 5, 65}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 186, 208, 155, 76, 33, 98, 248, 166}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 110, 236, 45, 90, 124, 250, 144}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 149, 52, 123, 126}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 206, 1, 10, 64, 20}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 142, 157, 45, 119}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 49, 111, 15, 235, 183}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 246, 1, 3, 60, 206, 171, 162}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 208, 245, 217, 208, 78}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 197, 162, 93, 230}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 215, 14}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 131, 36, 27, 126, 63, 165}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 4, 79}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 153}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 78, 252, 135, 138, 127, 234, 102}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 161, 5, 45, 179, 45, 51}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 48, 252, 104}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 210, 99}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 212, 48, 151}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 156, 137, 206, 236, 36}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 207, 253, 167, 208, 180, 32, 120}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 120, 20, 18, 15, 91, 65}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 53, 238, 213, 199}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 184, 206, 237, 202, 107}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 22, 178, 134, 188}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 231, 184, 137, 205, 192}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 252, 200, 157, 166, 43, 217, 190, 3}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 162, 249, 65}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 54, 208, 121}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 157, 47}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 19, 174, 190, 244}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 255, 35, 97, 135}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 165, 13, 34, 13, 163, 170, 224}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 144, 159, 177, 30, 247}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 26, 54, 26, 37, 108}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 49, 37}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 88, 100, 120}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 198, 38}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 144, 115}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 99, 49}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 121, 104, 221}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 20, 222, 89}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 163, 47}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 102, 244}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 119, 216, 231, 254, 108, 7, 8, 251}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 234, 47, 22, 183, 57, 188, 101, 92}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 97, 144, 57, 233, 186}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 81, 35}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 194, 224, 10, 65}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 5, 121, 48, 211, 230, 99, 66}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 71, 99, 32, 250, 60, 63}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 255, 76, 77, 54, 122}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 229, 211, 113, 73, 90, 248}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 83, 183, 155, 50, 136}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 186, 107, 28, 241, 169}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 125, 182, 28, 21, 131, 229, 25}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 70, 230, 155, 70, 9}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 0, 0, 0, 0, 0, 0, 0, 0}, 254},
	{{92, 188, 82, 192, 142, 249, 190, 128, 216, 36, 37, 56, 178, 93, 82, 193}, 254},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 131, 82}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 111, 82, 127, 226}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 146, 240, 169}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 113, 92, 225, 254, 41, 77, 153, 118, 232}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 63, 53, 19, 67, 54, 197, 10}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 199, 112, 188, 5, 7, 216, 24, 9, 133}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 94, 2}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 118, 249}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 212, 239, 128, 123, 21, 202}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 143, 191}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 156, 103, 18, 166, 19, 9, 47}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 117, 143, 217, 128, 69}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 143, 20, 149, 105}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 152, 198, 67, 162}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 46, 30, 63, 180, 95, 199, 187, 220, 10}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 197, 106, 83}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 238, 10, 35, 89, 165, 165, 241, 2, 169}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 61, 163, 211}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 131, 231, 216, 237, 30, 21, 244, 225}, 95},
	{{253, 218, 181, 46, 134, 144, 42, 233, 136, 2, 74, 176, 225, 83, 47, 79}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 84, 13, 222, 45, 35, 39, 3, 103, 95}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 26, 90, 39, 65, 41, 228, 8}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 197, 33, 68, 154, 171, 184, 67}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 25, 182, 7, 117, 27, 132, 155, 191, 47}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 61, 194, 243, 71}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 107, 89, 192, 36, 134, 24, 115, 69, 6}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 10, 128, 148, 210, 111}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 31, 242, 19, 99}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 220, 239, 69, 188, 254, 226, 154, 188}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 239, 70, 47, 48, 119, 8}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 109, 35, 36, 224, 97, 212, 161, 199, 26}, 95},
	{{253, 218, 181, 46, 134, 144, 27, 224, 128, 225, 239, 175, 109, 218, 225, 151}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 37, 167, 94}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 181, 237}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 64, 167}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 224, 16, 0, 181, 52, 229, 244}, 95},
	{{253, 218, 181, 46, 134, 144, 205, 80, 88, 120, 253, 183, 17, 136, 18, 183}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 37, 242}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 245, 1, 103, 242, 130, 163, 250, 208}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 255, 0, 58, 124, 116, 218}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 24, 197}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 38, 34, 241, 48}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 246, 210, 50, 150, 231, 167, 78, 250, 11}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 199, 210, 250, 201, 181, 242}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 215, 136, 193, 12, 149, 137, 25, 158, 102}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 145, 26, 194}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 23, 186, 216, 147, 32, 24}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 209, 138, 180}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 246, 62, 140, 216, 209, 218, 45}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 221, 218, 62}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 36, 119}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 27, 211, 202}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 221, 37, 4, 42, 177}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 209, 122, 100, 165, 190, 4, 213, 223}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 93, 70, 42, 80}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 181, 96, 85, 32}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 22, 128, 218, 63, 168, 163}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 121, 222, 93, 183, 113, 174, 168, 142}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 146, 93, 3}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 212, 109, 213, 26, 143}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 209, 245, 141}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 12, 81}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 154, 171, 217, 82, 8}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 5, 198, 227, 207, 173, 129, 144, 172}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 242, 37, 74, 80, 68, 27, 222, 255}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 69, 161}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 33, 222, 79}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 212, 179, 224, 139, 78, 62}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 96, 180, 137, 140, 185, 147, 167}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 48, 129, 188, 220, 184, 124, 35}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 219, 229, 186, 188, 137}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 143, 166, 11, 175, 209, 21, 73, 2}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 255, 21, 110, 117, 189, 32, 196}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 62, 219, 105}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 206, 5, 239, 136, 147, 173, 131, 214, 102}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 147, 254, 90, 234, 227, 55}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 0, 0, 0, 142, 154}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 83, 110, 14, 42, 108, 37, 150}, 95},
	{{253, 218, 181, 46, 134, 144, 0, 0, 0, 0, 0, 236, 33, 4, 3, 230}, 95},
	{{189, 19, 31, 244, 80, 0, 230, 11, 177, 190, 152, 150, 24, 222, 41, 122}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 253, 163, 102, 21, 228, 147, 187, 186, 163}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 181, 223, 181, 124, 249, 173, 194, 210}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 146, 236, 77, 66}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 94, 36, 108, 9, 218, 118, 190, 99}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 161, 114, 40, 4, 15, 8, 0, 104, 203}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 78, 80, 168}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 227, 15, 124, 160}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 13}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 80, 144, 95, 211, 10, 137}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 118, 133, 4, 140, 110, 63, 203, 170}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 198, 202, 87, 98}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 176, 206, 122, 142, 5, 127, 107, 226}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 118, 70, 247}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 105, 104, 176, 173, 139, 200, 94}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 73, 96}, 8},
	{{189, 19, 31, 244, 80, 0, 120, 248, 36, 169, 174, 84, 79, 196, 212, 87}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 38, 100, 106}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 36, 23, 250, 204, 239, 187, 242}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 156, 127, 121, 126}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 206}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 157, 78, 98, 81, 216, 101, 242, 113}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53, 61}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215, 176}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 6, 179, 168, 223, 130}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 246, 119, 172, 147, 89, 88}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 74, 91, 248, 187}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 36, 102, 92, 189, 255, 73, 109}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 131, 138, 104, 20}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 232}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 229, 52, 43, 187, 29, 109}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 123, 168, 167, 154, 239, 234, 122, 31}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 12, 232, 75, 144, 99, 61, 164, 137, 176}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 117, 39, 48, 51, 21}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 33, 70, 167, 252}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 48, 40, 68}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 13, 71, 78, 92, 181, 33, 46, 165, 213}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 2, 232, 64, 42, 41, 12}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 245, 124, 135, 4, 183, 154}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 155, 53, 186, 251, 74, 2}, 8},
	{{189, 19, 31, 244, 80, 0, 193, 5, 48, 26, 41, 152, 226, 115, 241, 189}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 218, 1, 123, 43, 84, 204, 91, 240}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 241, 238, 114, 169, 9, 171, 153, 93, 135}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 167, 105, 128, 235, 28, 216, 7}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 63, 133, 247, 195, 174, 128, 193}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 215, 212, 247, 141, 67, 74, 2}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 78, 54, 231, 218, 186, 114, 188}, 8},
	{{189, 19, 31, 244, 80, 0, 107, 71, 255, 111, 223, 46, 149, 48, 35, 147}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 138}, 8},
	{{189, 19, 31, 244, 80, 0, 224, 240, 250, 203, 52, 172, 165, 187, 140, 117}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 20, 244, 182, 16}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 145, 100, 250, 169, 233}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 227}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 115}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 149, 124, 182, 114, 103, 198}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 70, 245, 119, 16, 59}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 143, 247, 215, 152}, 8},
	{{189, 19, 31, 244, 80, 0, 15, 51, 160, 108, 107, 13, 35, 20, 62, 127}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 27, 235, 248}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 132, 45, 224, 244, 124}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 193, 224, 189, 155, 149, 104, 165, 218}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 229, 206, 217, 1}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 231, 91, 233, 182, 67, 190, 49, 81, 172}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 53, 59, 100, 46, 192, 63, 137}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 10}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 170, 65, 161, 251, 148}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 207, 138, 24, 184}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 234, 182, 250, 199, 126, 77, 254, 18, 133}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 85, 45}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 167, 15, 83, 13, 250, 229}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 72, 212, 175, 235, 113, 182}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 137, 242, 139, 100, 25}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 215, 126, 118, 56, 57, 24}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 62}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 32}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 10, 232, 125, 239, 52}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 15, 26, 60, 138, 133, 243, 132, 110, 75}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 146, 10, 88}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 146, 139, 59, 1, 117, 121, 219, 248}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 26, 111, 254}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 223, 85, 81, 116, 108, 129, 87}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 0}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 56, 31, 7, 129, 167, 21, 165, 134, 251}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 121, 75, 170, 82, 32, 49, 231, 216}, 8},
	{{189, 19, 31, 244, 80, 0, 0, 0, 0, 0, 0, 0, 177, 83, 32, 38}, 8},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 27, 227, 46, 252, 42, 132}, 212},
	{{30, 116, 0, 0, 0, 0, 43, 166, 0, 98, 46, 246, 162, 108, 46, 16}, 212},
	{{30, 116, 0, 0, 0, 172, 152, 250, 54, 196, 225, 183, 101, 102, 69, 143}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21}, 212},
	{{30, 116, 0, 0, 106, 30, 46, 210, 206, 148, 176, 58, 208, 181, 177, 223}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 222, 134, 32, 25}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 48, 115, 89, 242, 142, 164}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 206}, 212},
	{{30, 116, 0, 0, 84, 164, 249, 140, 134, 184, 78, 234, 54, 65, 158, 134}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 166, 22, 38, 148}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 122, 123}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 111, 77, 97, 50, 2, 65, 230, 91, 223}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 68, 227, 78, 108, 219, 231, 121, 93}, 212},
	{{30, 116, 0, 0, 109, 253, 240, 199, 157, 42, 118, 160, 115, 119, 186, 36}, 212},
	{{30, 116, 0, 0, 0, 0, 139, 82, 38, 204, 139, 53, 178, 138, 75, 232}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 199, 7, 97, 180, 21, 97, 115}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 112}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 170, 60, 226, 42}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 89, 49, 250, 210, 180, 109}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 212, 74, 130, 149, 187, 246, 210}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 95, 183, 52}, 212},
	{{30, 116, 0, 0, 164, 160, 141, 196, 4, 160, 148, 224, 202, 165, 156, 170}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 212},
	{{30, 116, 66, 195, 90, 70, 188, 117, 152, 203, 165, 46, 213, 138, 255, 166}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119, 80, 248, 23, 174}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 212},
	{{30, 116, 0, 0, 0, 0, 161, 114, 119, 65, 30, 47, 54, 97, 239, 117}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 135, 135, 216, 106, 62, 248, 202, 164, 161}, 212},
	{{30, 116, 0, 0, 171, 18, 184, 199, 185, 254, 37, 114, 129, 233, 207, 198}, 212},
	{{30, 116, 0, 0, 0, 131, 40, 126, 110, 148, 137, 216, 251, 130, 117, 93}, 212},
	{{30, 116, 0, 0, 0, 0, 15, 39, 223, 2, 57, 67, 209, 166, 90, 142}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 25, 198, 174, 249, 236, 230, 124, 109, 160}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 212},
	{{30, 116, 0, 0, 0, 174, 248, 210, 121, 101, 86, 89, 107, 93, 93, 4}, 212},
	{{30, 116, 0, 0, 0, 0, 57, 108, 239, 194, 103, 59, 33, 196, 251, 145}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 122, 14, 30, 57}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 116, 199}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 14, 34, 238, 108, 134, 1, 172}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 252}, 212},
	{{30, 116, 0, 11, 46, 25, 52, 108, 71, 32, 97, 19, 142, 70, 222, 100}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 34}, 212},
	{{30, 116, 0, 0, 223, 239, 16, 219, 222, 242, 194, 97, 48, 213, 26, 168}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 240, 105, 14, 48, 225, 30}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 79, 216, 212, 71}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 75, 114}, 212},
	{{30, 116, 0, 51, 41, 189, 207, 5, 44, 116, 205, 119, 47, 215, 166, 38}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 212},
	{{30, 116, 2, 176, 211, 176, 217, 90, 248, 199, 121, 159, 193, 14, 185, 57}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 9, 77, 202, 52, 127, 147, 161, 128}, 212},
	{{30, 116, 0, 0, 0, 0, 102, 218, 189, 206, 114, 176, 192, 151, 239, 138}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 50, 196, 249, 51, 234, 229, 113, 216}, 212},
	{{30, 116, 0, 0, 124, 26, 78, 192, 109, 146, 161, 204, 124, 20, 44, 89}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 98, 75, 88, 245, 36, 30, 215, 24}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 150, 31, 210, 35, 100, 171, 117}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 244, 8}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 38, 47, 114, 45, 51, 235, 145, 170, 254}, 212},
	{{30, 116, 0, 55, 65, 29, 233, 113, 80, 215, 190, 114, 232, 238, 163, 107}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 150, 129, 134, 31, 212, 174, 67}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 83, 224, 177}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 38, 153, 132, 73, 230, 145, 8, 113}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 217, 184}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 84, 0, 36, 6, 121, 129, 32, 166}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 167, 38, 243, 164}, 212},
	{{30, 116, 0, 240, 89, 40, 190, 38, 225, 102, 121, 207, 102, 23, 75, 217}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 20, 55, 249, 37, 61, 230, 247, 181, 81}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 39, 234, 13, 36, 102, 201}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 194, 236}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 174, 242, 121, 241, 6, 17, 239, 147, 90}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43}, 212},
	{{30, 116, 0, 0, 113, 244, 65, 170, 89, 129, 155, 149, 58, 175, 8, 72}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 62, 145, 192, 239, 117, 183}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 107}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 22, 181, 104, 225}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 201, 99}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 3}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 143, 37, 155, 31, 160, 203}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 161}, 212},
	{{30, 116, 0, 123, 50, 97, 13, 25, 210, 245, 221, 232, 205, 148, 95, 32}, 212},
	{{30, 116, 0, 0, 0, 0, 183, 211, 71, 193, 76, 252, 125, 94, 115, 233}, 212},
	{{30, 116, 0, 238, 31, 116, 67, 101, 242, 90, 246, 150, 214, 197, 48, 221}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158, 199}, 212},
	{{30, 116, 0, 0, 27, 254, 35, 114, 66, 85, 173, 215, 5, 250, 28, 11}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 187, 113, 52, 156}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 185, 86, 122, 207, 25, 82, 35, 98, 209}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 212},
	{{30, 116, 0, 64, 81, 242, 114, 181, 115, 50, 140, 48, 98, 193, 82, 58}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 25, 109, 88, 129}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 189}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 137, 233}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183, 98, 138, 246}, 212},
	{{30, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 247, 156}, 212},
	{{30, 116, 0, 0, 242, 7, 185, 224, 78, 77, 61, 133, 39, 194, 3, 168}, 212},
	{{30, 116, 0, 0, 40, 252, 9, 46, 145, 111, 81, 124, 10, 126, 20, 13}, 212},
	{{30, 116, 0, 0, 0, 208, 43, 147, 134, 158, 107, 30, 150, 140, 65, 179}, 212},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 185, 118, 95}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 150}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 178, 113}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 68, 74, 198}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 33, 59}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 119, 232, 143}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 165, 179}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 233, 76, 51}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 181, 85, 72}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 199}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 154, 197}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 69, 207}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 59, 57}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 188, 97, 50}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 38, 97}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 158, 219}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 87, 197}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 168, 10}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 213, 87, 202}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 123}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 207}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 74, 27, 77, 154}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 56, 162}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 200}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 246, 219, 131, 95}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 9, 5, 204}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 21, 1}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 255}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 113}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 100, 27, 123}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 147, 89}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 3, 57, 235}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 83}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 92, 136}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 40, 182, 69}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 163}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 75}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 106}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 137, 87, 213}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 252}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 41, 206, 189}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 22, 211}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 220, 2, 173}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 27}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 103, 97, 55}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 93, 96, 92}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 150}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 56}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 187, 146}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 236, 168}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 148, 91}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 227, 51, 62}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 4}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 213, 33, 102}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 173}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 247}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 174, 64, 32}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 184, 185, 231}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 114}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 98, 14, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 153}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 226, 66}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 115, 185}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 144, 225, 166}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 244, 106, 7}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 192, 218, 83}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 176, 242, 244}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 72, 127, 79}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 0}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 177, 168}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 175}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 77, 21}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 208}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 142}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 202, 54, 68}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 40, 200, 94}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 0, 222}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 68, 119, 205}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 230, 164, 56}, 217},
	{{81, 226, 13, 173, 79, 123, 223, 124, 108, 80, 83, 238, 0, 0, 38, 52}, 217},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 35, 59, 228, 21, 203, 1}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 223}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 240, 3, 178, 192, 64}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 253, 179, 26, 203, 2, 73, 122}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 246, 251, 91, 98}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 81, 223, 92, 0, 67, 221}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 168, 191, 189, 99}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 164, 166, 60, 178}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 32, 43}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 141, 2, 119, 22}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 55, 66, 219, 161, 149, 58, 116, 133}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 87, 245}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 86, 101, 159, 184, 66, 159, 213}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 12}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 251, 180, 236, 194, 164}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 251, 168, 228}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 215, 149, 203, 72, 154}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 240, 85, 244, 123, 25, 246, 63, 102}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 91, 248, 3, 178, 21, 213, 215, 69}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 111, 199, 53, 218, 13}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 83, 132, 53, 226, 197}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 42, 107, 210, 135, 10}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 70}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 206, 17, 113, 139, 31, 178, 160}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 122}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 23, 46, 59, 227, 137, 74, 144}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 73, 126, 211, 218, 47, 85}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 99, 223, 38, 4, 243, 90, 19, 13}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 11, 18, 152, 90, 245, 214}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 242, 32, 224, 55}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 156, 100, 250, 151, 2, 253, 10, 207}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 65, 182, 124, 88, 95, 42}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 13, 202, 237, 198, 110, 188, 205, 147}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 200, 250, 206, 226, 143}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 177, 205, 233}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 184, 57, 37, 109, 85, 222, 38}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 118, 94, 7, 232, 46}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 211}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 203, 231, 76, 73, 175}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 135, 176, 90}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 84, 8, 186, 148, 227}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 252, 166}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 77, 136}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 150}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 115, 59, 87, 190, 241, 123, 33}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 4, 170, 196}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 16, 255}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 237, 146, 21, 209, 132, 127, 201}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 118, 165, 175, 255}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 27, 183, 64}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 48, 143, 12}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 129, 13, 107, 25, 188, 44}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 177, 154, 128, 30, 76}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 134, 145, 193, 129, 23, 31}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 17, 81}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 225, 215, 123, 171, 9}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 94, 144, 160, 234, 37, 225}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 223, 138, 134, 82, 92, 199}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 186, 152, 128, 226, 214, 118, 112}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 2, 31, 172, 39, 11}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 34, 47, 179}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 215, 208, 251, 199, 160, 15, 68, 214}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 186, 149, 180, 189, 23, 222, 174, 152}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 146, 106, 99}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 51}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 96, 145, 160, 72, 244, 72}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 225, 215, 147, 104, 75, 81, 229}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 27, 31, 244, 125, 194, 80}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 183, 91, 34, 243, 99, 163, 140, 159}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 234, 45, 23, 217, 72, 194}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 214, 135, 70, 150, 47}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 9, 162, 253, 5}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 189, 158, 73}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 140}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 105, 247, 253, 217, 84, 237, 128, 209}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 177, 254, 162, 111, 118, 218, 221}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 169, 207, 25, 166, 165}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 164, 41, 164, 91, 72}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 194, 89, 130, 127}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 15, 6, 201, 148, 114, 27, 180}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 0, 182, 123, 87, 185}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 21, 186, 177, 97, 106}, 15},
	{{126, 211, 206, 82, 147, 215, 6, 0, 0, 0, 0, 228, 185, 137, 147, 90}, 15},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 145, 187}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 90, 92}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 250, 235, 24, 237}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 188}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 155, 34, 220}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 127, 3, 3}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 109, 53, 238, 198, 181}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 97}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 36, 48}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 14}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 167}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 65, 55, 245}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 181}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 39, 74}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 87}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 211}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 246, 252, 104, 76, 140}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 15, 238}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 123, 96, 176, 225}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 15}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 38, 103, 56, 38}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 152, 77}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 42, 107, 241}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 123, 16}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 23, 111, 121, 181}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 30, 73, 63, 219, 191}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 1, 61, 147, 142}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 224, 21, 91, 224}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 231}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 36}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 192, 31, 58}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 153}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 48}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 6, 101, 41, 36}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 147, 33}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 32, 159}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 170, 107, 97, 27, 190}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 211}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 156}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 168, 197, 73}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 109, 122}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 246, 251}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 182}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 119, 220, 249}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 159}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 26, 174}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 59, 222, 209, 148}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 74}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 234}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 237, 248}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 6, 28}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 63, 242}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 215, 165, 160}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 29, 207}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 18}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 63, 216, 88}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 183, 243, 224, 84}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 128, 160}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 84, 226, 201, 242}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 97, 57}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 214, 114}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 184, 253}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 15, 149}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 246, 113, 92, 66, 11}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 149, 62, 168}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 185, 81, 169, 155, 147}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 5, 166, 234, 103, 35}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 49, 150}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 121, 5, 85}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 29}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 141, 69, 233}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 89, 113, 57, 18}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 183}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 120}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 83, 76, 251, 178}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 118, 82, 12, 166, 41}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 0, 0}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 209, 77, 157, 37}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 243, 81, 1, 180}, 66},
	{{42, 229, 135, 197, 196, 243, 94, 181, 133, 34, 16, 0, 0, 0, 184, 63}, 66},
	{{68, 210, 158, 64, 18, 188, 221, 219, 215, 32, 123, 255, 248, 119, 163, 212}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 245, 245, 76, 46, 244, 239, 29, 83, 10}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 78, 224, 183, 16, 68, 140, 111, 44}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 203}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 208, 15}, 122},
	{{68, 210, 158, 64, 0, 3, 0, 183, 230, 164, 73, 27, 16, 122, 59, 104}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 191, 175}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247}, 122},
	{{68, 210, 158, 64, 0, 0, 218, 142, 53, 146, 147, 115, 34, 209, 154, 232}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 192, 135, 226, 35, 251, 69, 177, 61}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110, 251}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 42, 202}, 122},
	{{68, 210, 158, 64, 181, 212, 204, 70, 173, 155, 47, 114, 16, 249, 176, 154}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 103, 243, 81, 17, 60}, 122},
	{{68, 210, 158, 64, 0, 65, 31, 136, 1, 187, 137, 148, 88, 23, 153, 64}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 11}, 122},
	{{68, 210, 158, 64, 0, 149, 144, 53, 96, 17, 77, 39, 175, 75, 192, 50}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 235}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 128, 238, 230, 126, 180, 42, 250, 136}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 136, 195, 3, 108, 141}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 67}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 163, 119, 144, 182, 72, 211, 75, 28}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 174, 211}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 237, 183, 64, 101, 152, 44, 165}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 139}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 113, 137}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 179, 32, 74, 88, 92, 122, 33, 254, 135}, 122},
	{{68, 210, 158, 64, 0, 115, 30, 85, 235, 242, 27, 247, 186, 70, 233, 153}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 124, 209, 156, 121, 239}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 202, 219}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 236, 126, 243, 182, 50}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 94, 250, 7, 84, 199}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 83, 186, 44, 52, 234, 1, 91, 225}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 134}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 1, 173, 104, 65, 25, 36, 46, 248, 136}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{68, 210, 158, 64, 0, 0, 111, 178, 67, 55, 116, 108, 157, 235, 58, 73}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 20, 132, 17, 8, 166, 190, 26, 128, 253}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 90, 148, 80, 248, 216}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 112, 20, 65, 226, 248, 170, 186, 197, 19}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 136, 64, 121, 136, 210, 73, 177}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 82, 250, 176, 131, 196, 3}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 122},
	{{68, 210, 158, 64, 0, 23, 233, 3, 144, 23, 18, 92, 148, 41, 157, 141}, 122},
	{{68, 210, 158, 64, 0, 227, 84, 21, 65, 140, 246, 50, 242, 106, 213, 51}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 231, 34, 153, 209}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 218, 112, 3, 9, 155, 92, 34}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 231, 126, 193, 11, 237, 119, 226, 24}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 15, 131, 1, 235, 211, 238, 138, 133}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 194, 248, 66, 25, 232}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 217, 12, 216, 205, 84, 178, 222, 243, 1}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 183, 155, 191, 211}, 122},
	{{68, 210, 158, 64, 0, 179, 48, 240, 72, 247, 148, 69, 47, 74, 185, 241}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 50, 21, 196, 67, 247, 118, 245, 34, 200}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 119, 172, 93, 254, 175, 26, 181, 76}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 252, 123, 151, 220, 233}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 133, 137, 10, 136, 169, 149, 10, 108, 112}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 80, 81, 114, 110, 34, 119, 153, 87, 99}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 8, 65, 68, 146, 17}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 250}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 97, 164, 162, 172, 186, 168}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 171, 134, 19, 52, 255, 87, 154}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 9, 29, 168, 204, 116, 13, 23, 60, 199}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 201, 227, 161, 40, 83, 157, 11}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 81, 40, 229, 227}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 226, 245, 135, 23, 110, 188, 126}, 122},
	{{68, 210, 158, 64, 0, 121, 238, 156, 47, 20, 141, 96, 45, 108, 28, 164}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250, 31, 160}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 169, 245, 121, 56, 207, 236, 45}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 120}, 122},
	{{68, 210, 158, 64, 0, 0, 76, 204, 171, 192, 244, 30, 130, 236, 101, 230}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 88, 73, 86, 232, 136, 143, 8, 71}, 122},
	{{68, 210, 158, 64, 0, 154, 131, 233, 46, 232, 68, 29, 192, 29, 60, 31}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 211, 160, 154, 225, 137, 194, 25, 86, 130}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 34, 112, 111, 45, 127, 122, 170}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 204, 68, 198, 56, 107, 129, 46, 8}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 33}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 59, 84}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 68, 48, 212, 214, 2}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 200, 221}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 254, 240, 165, 4, 137, 82, 108}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 16, 81, 181, 6, 152, 139}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 122},
	{{68, 210, 158, 64, 0, 0, 214, 102, 49, 229, 59, 119, 35, 88, 237, 20}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 236, 119, 206, 229}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 196, 105, 116, 165, 177}, 122},
	{{68, 210, 158, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 191}, 122},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 192}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 38}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 88, 136, 213}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 158, 48, 204}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 220, 11}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 161}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 60, 23}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 105, 234, 78}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 155, 220}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 248, 7, 67}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 60, 191}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 241, 55}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 53, 86}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 100, 122}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 221}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 160, 196, 98}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 229, 183}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 173, 213}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 166, 203}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 170, 217, 238}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 8}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 58, 137}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 5, 53, 22}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 172, 82, 169}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 235, 12}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 186}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 25, 104, 158}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 51}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 78, 153, 180}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 95, 211}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 58, 177, 52}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 13}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 107, 54}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 144, 184}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 69, 77, 141}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 17, 154}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 171, 156}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 126, 246}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 97, 229, 57}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 201, 24}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 201, 76, 157}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 91, 144}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 118, 121}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 170, 74}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 224, 230, 191}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 5, 226, 251}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 6}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 84}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 248, 124, 215}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 238}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 201, 192, 176}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 89}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 212}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 43}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 171}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 139}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 146, 61, 65}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 147, 53}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 22, 95}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 137, 122, 81}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 226, 210}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 50, 61, 230}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 221, 86}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 182, 108, 204}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 210}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 23, 145, 176}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 11, 175}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 85, 250, 119}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 183}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 206, 26, 12}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 202}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 112, 18, 192}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 113, 202}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 98, 43, 94}, 12},
	{{183, 63, 223, 94, 81, 41, 203, 20, 236, 212, 220, 199, 0, 0, 0, 0}, 12},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 187, 135, 184, 175}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 10, 128, 105, 174, 56, 62}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 155}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 91, 60, 89}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 87, 4, 88, 111, 5}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 123, 125}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 117}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 252, 254, 18}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 58, 189}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 149, 151, 127}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 88, 197}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 225, 104, 86, 174}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 133, 177, 95, 52, 9, 8, 181}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 204, 71, 241, 200, 238}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 79, 197, 227, 140}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 150, 89, 217, 69}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 47, 151}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 2, 208, 97, 237, 25, 157}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 139, 212, 154, 113, 102, 50, 77}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 198}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 211, 173}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 182, 168, 198, 26, 78}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 12, 155, 37, 75}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 64, 50, 91, 151}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 80, 110, 79, 144, 121, 27}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 102, 202, 121, 58, 224, 230}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 239, 94, 83, 75, 213}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 54, 223}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 11, 212, 6, 102, 131}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 126, 16, 228, 114}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 125, 101, 58, 246, 209}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 252, 240, 57}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 94, 200, 51, 106, 97, 146}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 110, 28, 37}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 11, 229, 15}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 78, 190, 50}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 209, 250, 214, 203, 181}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 242, 130, 81}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 253, 135}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 57, 195, 233, 75}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 172}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 171, 5}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 127}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 252, 54, 90, 237, 110}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 238}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 136}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 42}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 248, 94, 151, 130}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 243}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 136, 101, 134, 173, 95, 162}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 125, 114, 57}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 231, 68, 77, 69, 140}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 107, 34, 45}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 90, 174, 126, 201}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 189, 96, 250, 68}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 228, 48, 37}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 228, 254, 121}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 177, 253, 163, 255}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 72, 69}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 20, 22, 231}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 50, 131, 66, 191, 255, 123}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 105, 65}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 170, 85, 181, 230, 179}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 250, 191, 246, 19, 47}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 10}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 21, 136, 92, 76}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 64, 97, 244, 241, 154}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 168}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 60, 103, 109, 22, 168, 212}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 169, 67, 132}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 4, 100, 71, 204}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 77, 201, 12, 155, 171}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 91, 146}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 32, 82}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 0, 0, 224, 164}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 38, 39, 59, 120, 82}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 250, 193, 34, 224}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 32, 165, 124, 7, 13, 159}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 140, 232, 161, 65}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 106, 151, 210, 183, 170}, 171},
	{{131, 146, 2, 125, 174, 43, 231, 20, 194, 0, 0, 0, 39, 126, 107, 44}, 171},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 250, 188}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 241, 58}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 167}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 48, 6}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 254, 232}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 32}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 2, 176}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 165}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 175}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 29, 124}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 205, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 121, 125}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 83}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 84}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 120, 198}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 116, 107}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 207, 76}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 50}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 153}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 91}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 2}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 229}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 21}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 46}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 144}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 166, 169}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 26, 58}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 252}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 204}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 234}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 11, 181}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 120}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 242}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 154}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 210, 159}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 140}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 107, 107}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 80, 81}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 115, 205}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 2}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 72}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 183, 113}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 17}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 33, 140}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 180}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 156}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 27}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 159}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 5}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 40, 164}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 120, 47}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 108}, 42},
	{{31, 180, 246, 158, 28, 192, 236, 39, 237, 55, 74, 195, 171, 192, 0, 0}, 42},
	{{179, 10, 70, 80, 0, 0, 171, 102, 251, 70, 135, 10, 204, 11, 245, 1}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245, 135}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 104, 15, 202, 22, 147, 129, 197, 56}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 173, 84, 27, 171, 137, 63}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 49, 0, 59, 58, 146, 207}, 194},
	{{179, 10, 70, 80, 0, 0, 203, 189, 238, 16, 194, 125, 19, 84, 75, 181}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 144, 8, 108, 220, 188, 80, 140}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 110, 189, 67, 18, 70, 172, 111, 250, 83}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{179, 10, 70, 80, 0, 0, 117, 48, 113, 93, 84, 243, 44, 131, 157, 155}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 141, 180, 120, 74, 31, 196}, 194},
	{{179, 10, 70, 80, 0, 0, 33, 45, 168, 241, 5, 135, 91, 160, 62, 49}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 39, 20, 138, 162}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 38, 174, 42, 191, 217, 90, 165}, 194},
	{{179, 10, 70, 80, 0, 25, 108, 241, 165, 139, 55, 236, 88, 245, 117, 254}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 213, 44, 154, 42, 60, 22, 108, 79, 165}, 194},
	{{179, 10, 70, 80, 0, 177, 43, 53, 167, 42, 36, 217, 242, 23, 191, 40}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 38, 177, 13, 179, 52, 48}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 140, 221}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 60, 230, 254, 157, 237, 74}, 194},
	{{179, 10, 70, 80, 0, 0, 205, 139, 86, 227, 81, 39, 62, 83, 203, 3}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 199}, 194},
	{{179, 10, 70, 80, 0, 0, 226, 140, 145, 191, 117, 149, 70, 27, 160, 84}, 194},
	{{179, 10, 70, 80, 97, 175, 43, 210, 101, 169, 231, 119, 100, 93, 138, 163}, 194},
	{{179, 10, 70, 80, 102, 140, 62, 222, 242, 52, 101, 52, 146, 217, 107, 81}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 133, 67, 87, 243, 197, 206, 211}, 194},
	{{179, 10, 70, 80, 0, 204, 208, 181, 151, 118, 155, 88, 73, 82, 236, 2}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 100, 60, 37, 130}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 193, 240, 77, 224, 173, 195, 97, 180}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174}, 194},
	{{179, 10, 70, 80, 0, 114, 92, 213, 118, 94, 29, 133, 18, 96, 213, 247}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 19, 194, 73, 147, 201, 98, 128}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 25, 94}, 194},
	{{179, 10, 70, 80, 0, 4, 120, 99, 167, 22, 179, 219, 47, 151, 249, 192}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 6, 175, 211, 115, 107}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 14}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 200, 58, 105, 188}, 194},
	{{179, 10, 70, 80, 0, 183, 49, 210, 168, 137, 86, 37, 175, 95, 208, 55}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 143}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 169, 22, 75, 218}, 194},
	{{179, 10, 70, 80, 0, 0, 36, 173, 147, 46, 148, 98, 82, 158, 169, 30}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 51, 144, 242, 186, 9, 237, 114, 199, 4}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 150, 225}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 50, 4, 189, 80, 47, 162}, 194},
	{{179, 10, 70, 80, 0, 0, 36, 227, 63, 242, 212, 95, 83, 231, 66, 224}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 102}, 194},
	{{179, 10, 70, 80, 0, 0, 155, 181, 189, 197, 229, 22, 183, 45, 147, 57}, 194},
	{{179, 10, 70, 80, 0, 251, 252, 209, 94, 29, 112, 168, 179, 43, 62, 14}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 113}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 63, 231, 88, 58, 218, 34, 158, 140, 116}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 50, 41, 219, 44}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 32, 251, 228, 120, 237, 188, 61}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 104, 175, 126, 121}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 94}, 194},
	{{179, 10, 70, 80, 0, 0, 255, 79, 139, 50, 17, 5, 98, 90, 58, 186}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 225, 10, 49, 249, 123}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{179, 10, 70, 80, 0, 0, 166, 53, 58, 220, 37, 67, 52, 83, 154, 28}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 245, 140, 59, 225, 169, 184, 161, 96}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 196, 178, 47, 161, 81, 42, 150}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 21, 37}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 123, 163}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 158, 99, 56, 120, 215, 228}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 233, 253, 49, 152, 178}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 194},
	{{179, 10, 70, 80, 38, 63, 3, 223, 254, 200, 37, 1, 8, 58, 65, 239}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 176, 141, 4, 220, 98}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 117}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 124, 167, 35, 164, 123, 234, 65}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 201}, 194},
	{{179, 10, 70, 80, 0, 0, 242, 113, 148, 147, 104, 233, 154, 53, 44, 162}, 194},
	{{179, 10, 70, 80, 0, 184, 192, 104, 68, 65, 66, 204, 98, 62, 70, 38}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 176, 77, 206, 14}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 61, 14, 33, 31}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 152, 204, 89, 114, 15}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 205, 160, 66, 193, 208, 208, 34}, 194},
	{{179, 10, 70, 80, 0, 0, 8, 152, 109, 198, 187, 15, 3, 235, 106, 69}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 69, 196, 204, 137, 41, 115, 89, 135, 246}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 245}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 160, 27, 45, 228, 46, 31, 58}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 77, 80, 151, 74, 215, 246}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 242, 140, 176, 137, 140}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 58, 22, 209, 127, 104, 12, 148, 132, 55}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 32, 184, 49, 145, 231, 193, 105, 152, 211}, 194},
	{{179, 10, 70, 80, 0, 150, 0, 225, 128, 149, 229, 102, 241, 153, 179, 35}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 143, 79, 55, 246, 128, 155}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 194},
	{{179, 10, 70, 80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 239}, 194},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 188, 255}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 239, 219}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 100, 200}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 117}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 61}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 112}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 185, 254}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 192}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 167, 215}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 249}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 175}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 95}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 229}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 37, 103}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 223}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 110, 10}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 157}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 78}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 246, 195}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 197}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 168, 120}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 246}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 34, 220}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 165, 1}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 112, 205}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 151}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 49}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 16, 39}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 188}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 192, 123}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 39, 119}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 7, 101}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 57}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 42}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 96}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 72, 120}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 162}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 25}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 88, 44}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 180}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 157}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 192}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 67}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 171}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 122, 225}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 213, 163}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 86}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 17, 60}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 240}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 33, 196}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 169}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 77}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 0}, 237},
	{{147, 51, 85, 185, 234, 209, 236, 87, 147, 17, 7, 68, 148, 32, 0, 29}, 237},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 93, 51}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 84, 214, 62}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 65, 246, 90, 153}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 204}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 249, 250, 96}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 78, 235}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 57}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 54, 58, 114}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 155}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 182, 3, 111}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 139}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 179, 165, 156}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 208, 67, 200}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 252, 113, 147}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 236, 252, 65}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 149, 111}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 96, 98, 248}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 6}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 208, 213, 121, 117}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 206, 70, 133}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 145, 205}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 16}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 159, 55, 13}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 157, 141, 143}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 77, 245}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 165}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 62, 14, 6}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 120}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 156, 52}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 57}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 209}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 183, 121}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 203, 147, 98}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 202, 249, 15, 93}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 204}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 54}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 206, 168, 80, 45}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 55, 100, 85}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 237, 250, 140}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 204, 83, 141}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 176, 89, 155}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 167, 142}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 80}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 186, 209}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 81, 253, 201}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 181, 156, 116}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 80, 94, 199}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 25, 126, 161}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 138}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 160}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 168, 164}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 199, 6, 143}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 61, 48}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 149, 118}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 224, 66, 184}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 149, 202}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 227, 86, 117}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 190, 84, 140}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 192, 192, 134}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 77}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 35, 187}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 163, 66, 40, 92}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 206}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 149, 18}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 89, 157, 69}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 103, 232}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 110, 121, 92}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 0, 0}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 0, 0, 55, 91}, 151},
	{{177, 178, 6, 40, 46, 166, 87, 198, 214, 234, 23, 224, 248, 173, 101, 22}, 151},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 3}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 199}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 43}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 52}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 228}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 160}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 49}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 107}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 24}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 177, 42}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 201, 191}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 162}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 178}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 127}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 136}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 193}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 165}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 184}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 247}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 50}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 218}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 22}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 223}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 123}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 50}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 76, 34}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 121}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 55}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 191, 75}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 140}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 227}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 250}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 197}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 57}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 142}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 111, 75}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 99}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 193}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 124}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 53}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 201}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 237}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 154}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 228}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 225, 141}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 234}, 238},
	{{201, 53, 40, 20, 49, 4, 38, 139, 133, 217, 214, 134, 89, 200, 0, 0}, 238},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 204, 160, 54, 71, 68, 68}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 53}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 89, 81, 29, 196, 241}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 103}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 249, 199}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 233, 50, 99, 20, 83, 234}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 180, 105, 72, 19, 208, 134, 24, 107}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 15, 138, 82, 75, 160, 175, 57}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 3, 166, 135, 26, 85, 192, 72}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 153, 133, 196, 251, 53, 138, 102}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 33, 13, 191, 69, 39, 10}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 151}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 157, 159, 168}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 67, 236, 216, 171, 23, 44, 235}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 167}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 118, 39, 76, 21, 142, 97}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 167, 179}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 101}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 79, 86, 64, 112, 35, 186, 59}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 176, 120, 244, 214, 71, 160, 64}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 241, 42, 47}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 123, 216, 113, 117}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 102, 161, 114, 4, 71, 129, 49}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 52, 31, 15, 252, 62}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 51}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 155, 97, 168, 125, 217}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 68, 178, 216, 3, 115, 27, 2}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 182, 234, 190, 152, 202}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 61, 91}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 189, 22, 206, 182, 9}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 243, 86}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 132, 51, 65, 34, 38}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 150, 167, 106, 72, 155, 124, 176}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 191, 253}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 205, 195, 39, 221, 108, 38, 16, 89}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 176, 73, 53, 24}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 188, 4, 54, 4, 161, 173, 45}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 229}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 213, 240}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 26, 202, 128}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 77, 253, 8, 217, 142, 2, 71, 155}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 47, 168, 61, 30, 75}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 127, 36, 55, 174, 183}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 147, 102}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 109, 15}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 222, 234, 190, 119}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 183}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 209, 93, 48, 103}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 80}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 230, 58, 97, 211}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 86, 116, 107, 203}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 186, 242}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 106}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 98, 101}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 108, 81, 17, 241, 132}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 153, 158, 161, 153, 44, 245, 76}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 241, 217, 197, 91, 149}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 181, 189, 217, 15, 145, 160, 94}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 163, 101, 186, 205, 231, 208}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 173, 73, 53, 189, 248, 22, 190, 5}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 146, 144, 61, 253, 147, 214}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 133, 254, 91, 136, 213, 147, 25}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 32, 4, 214, 101, 75, 44, 1, 197}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 27, 62, 85}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 141, 22}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 198, 164, 59, 232, 245}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 81, 252, 149, 183, 89, 137}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 143, 105, 191}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 64, 26, 151, 161, 82, 11, 117, 44}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 58, 132, 166, 228, 40, 64}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 53, 37}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 133}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 135, 205, 188}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 22, 71, 31, 15}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 18, 222, 175, 78, 146, 86, 111}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 0}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 62, 14, 136, 232, 147, 80}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 167, 154}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 120, 253, 190, 133, 205, 71, 120}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 12, 73, 163, 168, 210, 186, 11}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 108, 202, 140, 89}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 49, 5, 239}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 230, 36, 237, 254, 240, 200}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 189, 195, 135}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 24}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 2, 254, 21, 22, 204}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 126, 167, 135, 164, 11, 204, 2, 88}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 0, 0, 0, 0, 119}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 0, 0, 102, 80, 149, 2, 108}, 128},
	{{4, 26, 181, 37, 206, 129, 233, 32, 0, 111, 154, 71, 12, 239, 214, 104}, 128},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 107, 255, 190, 44, 196, 60, 145}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 212}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 27, 100, 69}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 26, 156, 175, 98, 84, 239, 57, 0, 44}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 131}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 81, 156, 61, 197, 125, 135, 157}, 227},
	{{81, 58, 248, 0, 0, 167, 170, 116, 25, 227, 1, 245, 125, 154, 145, 97}, 227},
	{{81, 58, 248, 0, 0, 25, 61, 224, 136, 147, 68, 188, 181, 218, 190, 78}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 161, 19, 238, 130, 107, 224, 235}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 50, 92}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 201, 15, 143, 35, 42}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 31, 243}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 68, 53, 228, 225, 43, 191, 173, 34}, 227},
	{{81, 58, 248, 0, 0, 186, 131, 241, 8, 197, 246, 200, 88, 167, 165, 244}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 180}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 249, 137, 137, 46, 189}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 227},
	{{81, 58, 248, 0, 32, 102, 204, 201, 17, 55, 43, 81, 142, 219, 194, 248}, 227},
	{{81, 58, 248, 0, 0, 50, 51, 154, 83, 126, 174, 15, 220, 163, 116, 232}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 26, 123, 93, 85, 30, 164, 87, 126, 47}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 21, 196, 34, 74, 206, 89, 75, 214, 64}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 231, 43, 131}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 218, 217, 240, 209, 168, 224, 113, 177}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 108, 229, 141, 238, 96, 244, 130, 218}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 173}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 215, 50, 253}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 43}, 227},
	{{81, 58, 248, 0, 0, 0, 33, 82, 164, 100, 92, 221, 58, 214, 239, 4}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 221, 250, 107, 228, 159, 65, 233, 110, 241}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 69}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 189, 5, 198, 104, 190, 68, 69, 167, 114}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 167, 121, 115, 208, 53}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 23, 201, 141, 154, 37, 29, 84, 113, 199}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 58, 188, 217, 218, 110}, 227},
	{{81, 58, 248, 0, 0, 241, 193, 5, 147, 131, 145, 254, 3, 143, 95, 54}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 49, 235, 44, 35, 143, 154, 189}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 158, 138, 155, 224, 172, 129, 88, 197, 3}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 158}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 103, 144, 68}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 226, 16, 111, 82, 181, 133, 143}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 86}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 191, 222, 76, 155, 138}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 81, 206, 68, 101, 196, 35}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 68, 116, 120, 217, 217, 240, 21}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 139}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3}, 227},
	{{81, 58, 248, 0, 0, 0, 78, 27, 118, 165, 97, 151, 133, 85, 185, 93}, 227},
	{{81, 58, 248, 0, 0, 0, 192, 35, 15, 147, 78, 88, 233, 166, 110, 29}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 14, 245, 21, 71, 133, 156, 53, 200}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{81, 58, 248, 0, 246, 12, 191, 131, 72, 37, 238, 234, 235, 229, 238, 110}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 172, 138, 64, 209, 240, 39, 113, 198, 105}, 227},
	{{81, 58, 248, 0, 249, 103, 168, 65, 141, 59, 60, 152, 128, 98, 44, 141}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 95, 94, 83, 24, 201, 139}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 66}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 107}, 227},
	{{81, 58, 248, 0, 81, 50, 238, 164, 74, 187, 191, 109, 181, 30, 126, 125}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 233, 30, 250, 119, 57, 136}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 143, 0, 145, 195, 228, 25}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 174, 157, 85, 238, 11, 240, 162, 203}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 7}, 227},
	{{81, 58, 248, 0, 0, 4, 99, 207, 196, 183, 169, 57, 45, 200, 230, 58}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 31, 23, 91, 201, 201, 65, 36, 38, 90}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 32}, 227},
	{{81, 58, 248, 0, 31, 173, 211, 56, 114, 24, 96, 38, 149, 57, 248, 209}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 53, 141, 178, 75, 186, 98, 158, 52, 196}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 185}, 227},
	{{81, 58, 248, 0, 242, 253, 37, 75, 245, 129, 117, 36, 171, 59, 169, 127}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 107, 163}, 227},
	{{81, 58, 248, 0, 0, 0, 250, 34, 206, 180, 238, 100, 130, 7, 126, 18}, 227},
	{{81, 58, 248, 0, 247, 213, 203, 168, 42, 51, 86, 107, 53, 153, 42, 8}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 51, 8, 114, 121, 168, 234, 216, 52}, 227},
	{{81, 58, 248, 0, 65, 201, 134, 108, 98, 24, 10, 202, 206, 169, 47, 253}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 69, 11}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 161, 97, 186, 255, 125}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207, 24}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 32}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 111, 128, 90, 44, 144, 218, 100, 193, 182}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 179, 147, 75, 124, 18}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 220, 228, 146, 223, 170, 31, 79, 165}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 31, 153, 229, 100, 185, 89, 199, 166}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 217}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 236, 3, 51, 41, 40, 96, 79, 74}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 70, 9, 112}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 132, 191, 67, 40, 106}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 219, 226, 152, 233, 44, 127, 70, 23, 30}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 53, 152, 130, 155, 198, 109, 188, 215, 172}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 227},
	{{81, 58, 248, 0, 0, 0, 0, 0, 156, 192, 239, 165, 121, 74, 198, 159}, 227},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{18, 238, 250, 161, 57, 246, 208, 118, 14, 76, 73, 25, 65, 22, 152, 120}, 138},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 60},
	{{31, 128, 0, 0, 67, 213, 146, 65, 233, 217, 24, 178, 49, 12, 168, 136}, 60},
	{{31, 128, 0, 100, 78, 172, 166, 170, 65, 44, 190, 236, 3, 44, 157, 107}, 60},
	{{31, 128, 252, 110, 81, 96, 145, 129, 112, 193, 18, 222, 21, 167, 208, 221}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 57, 214, 23}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 21}, 60},
	{{31, 128, 0, 0, 0, 0, 246, 33, 201, 245, 150, 124, 58, 89, 91, 85}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 208, 109}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 127, 41, 184, 112, 72, 119}, 60},
	{{31, 128, 0, 0, 233, 136, 168, 163, 46, 229, 90, 255, 51, 218, 139, 197}, 60},
	{{31, 128, 0, 0, 0, 154, 25, 104, 169, 167, 1, 201, 174, 61, 181, 137}, 60},
	{{31, 128, 0, 0, 0, 140, 57, 167, 209, 12, 190, 119, 61, 18, 216, 98}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 81, 232, 230, 206, 106, 49}, 60},
	{{31, 128, 0, 0, 0, 131, 51, 185, 56, 172, 250, 194, 140, 180, 228, 113}, 60},
	{{31, 128, 0, 0, 0, 0, 60, 121, 243, 39, 167, 252, 241, 49, 127, 193}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 118, 38, 173, 203, 1, 10, 118}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 158, 40, 12, 39, 199, 59, 141}, 60},
	{{31, 128, 0, 0, 191, 70, 117, 116, 65, 21, 67, 153, 239, 136, 91, 155}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 153, 150, 95, 128, 83, 102, 1}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 246, 199}, 60},
	{{31, 128, 0, 0, 190, 13, 223, 43, 181, 173, 68, 1, 152, 195, 229, 119}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79}, 60},
	{{31, 128, 10, 127, 81, 11, 234, 191, 78, 125, 45, 206, 196, 35, 229, 107}, 60},
	{{31, 128, 0, 0, 0, 0, 223, 150, 43, 231, 132, 118, 164, 105, 24, 255}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229, 190, 28}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 48, 240, 167, 33, 204, 155, 87}, 60},
	{{31, 128, 0, 0, 0, 0, 18, 131, 214, 114, 75, 109, 251, 207, 228, 152}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 51}, 60},
	{{31, 128, 0, 0, 0, 93, 251, 125, 134, 144, 78, 96, 18, 42, 159, 144}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 159, 44, 58, 179, 245, 184, 125, 40}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 60},
	{{31, 128, 0, 240, 246, 174, 167, 120, 183, 170, 109, 234, 226, 252, 127, 58}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 97, 102}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 21, 49, 137, 199, 223, 248, 42, 181, 66}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 181, 60}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 50, 101, 9}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 38, 199, 192, 201, 75, 120}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 104, 236, 229, 6, 98, 186}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 36, 199, 206, 129, 179, 67}, 60},
	{{31, 128, 0, 0, 126, 193, 250, 214, 60, 151, 51, 63, 82, 56, 12, 116}, 60},
	{{31, 128, 0, 0, 0, 182, 189, 97, 206, 150, 176, 32, 158, 216, 34, 240}, 60},
	{{31, 128, 0, 59, 27, 176, 219, 107, 187, 34, 151, 143, 19, 97, 134, 26}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 173, 24, 23, 176, 239, 9, 244, 217}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 78, 49, 124, 246, 4, 108, 53, 216}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 56, 140}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 30, 114}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 215}, 60},
	{{31, 128, 0, 145, 94, 90, 148, 245, 62, 222, 177, 221, 214, 36, 144, 207}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 80, 144, 208}, 60},
	{{31, 128, 135, 56, 72, 253, 49, 34, 171, 115, 166, 53, 46, 35, 90, 106}, 60},
	{{31, 128, 0, 0, 222, 33, 107, 10, 99, 158, 3, 9, 74, 49, 94, 239}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 77, 249, 125, 33, 169, 75, 251, 141, 217}, 60},
	{{31, 128, 152, 34, 255, 222, 42, 78, 167, 16, 156, 6, 140, 194, 137, 102}, 60},
	{{31, 128, 0, 0, 0, 0, 92, 98, 132, 194, 191, 111, 62, 193, 245, 197}, 60},
	{{31, 128, 208, 158, 56, 49, 54, 168, 237, 21, 80, 88, 58, 61, 169, 49}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230}, 60},
	{{31, 128, 0, 0, 84, 180, 212, 195, 66, 227, 95, 40, 66, 222, 218, 82}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 64, 68, 99, 136, 140, 82}, 60},
	{{31, 128, 0, 0, 0, 0, 252, 65, 76, 76, 131, 143, 230, 191, 248, 147}, 60},
	{{31, 128, 0, 0, 162, 194, 227, 13, 26, 19, 139, 143, 243, 162, 90, 215}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 182, 197, 215}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 239, 137, 221, 183}, 60},
	{{31, 128, 0, 0, 219, 23, 190, 171, 79, 61, 46, 68, 200, 203, 252, 39}, 60},
	{{31, 128, 0, 0, 35, 239, 142, 215, 66, 120, 168, 163, 147, 250, 16, 135}, 60},
	{{31, 128, 0, 0, 0, 0, 82, 157, 135, 82, 13, 16, 148, 57, 239, 205}, 60},
	{{31, 128, 0, 0, 0, 0, 172, 171, 109, 96, 139, 249, 173, 69, 226, 2}, 60},
	{{31, 128, 0, 0, 126, 91, 63, 93, 69, 54, 184, 86, 138, 20, 209, 245}, 60},
	{{31, 128, 0, 9, 94, 97, 134, 24, 181, 118, 228, 54, 180, 55, 13, 102}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 150, 101, 173, 231, 137, 101}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 58}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 14, 113, 237}, 60},
	{{31, 128, 0, 0, 47, 36, 211, 137, 156, 217, 165, 85, 249, 209, 42, 37}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 31, 110, 239, 54, 49, 148, 135, 7}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 82, 124}, 60},
	{{31, 128, 0, 0, 0, 134, 5, 227, 161, 14, 28, 159, 203, 97, 168, 103}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 254, 242, 240, 58, 68, 203, 31}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 220}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 32, 130}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 84, 0, 196, 23, 105, 208, 239}, 60},
	{{31, 128, 0, 34, 75, 69, 5, 93, 71, 88, 117, 62, 180, 168, 46, 110}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 41, 81}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 67, 199}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 54, 83, 49, 163, 251, 24, 21}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 60},
	{{31, 128, 0, 0, 190, 237, 200, 32, 105, 207, 193, 152, 199, 141, 149, 186}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 5, 7, 216, 86, 29, 253, 105}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 26, 176, 111, 209}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 19, 26, 142}, 60},
	{{31, 128, 0, 17, 215, 181, 254, 209, 118, 50, 44, 116, 107, 237, 143, 97}, 60},
	{{31, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 218}, 60},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 50, 201, 43}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200}, 148},
	{{115, 195, 64, 0, 232, 202, 143, 226, 227, 190, 93, 97, 187, 82, 223, 201}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 108}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 212, 141}, 148},
	{{115, 195, 64, 0, 0, 0, 23, 230, 143, 19, 62, 72, 44, 177, 216, 76}, 148},
	{{115, 195, 64, 0, 213, 38, 186, 254, 45, 50, 228, 26, 37, 28, 105, 55}, 148},
	{{115, 195, 64, 187, 186, 175, 207, 37, 156, 9, 70, 216, 192, 100, 18, 172}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 117, 132, 149, 176}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40}, 148},
	{{115, 195, 64, 0, 0, 0, 134, 187, 177, 252, 36, 16, 139, 209, 221, 100}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 116, 66, 215, 223, 59, 10, 23, 92, 29}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 194, 204, 130, 136, 102}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 110, 113, 252, 238, 136, 119, 31}, 148},
	{{115, 195, 64, 0, 0, 54, 220, 18, 49, 96, 115, 147, 57, 162, 61, 241}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 226, 29, 75, 174, 66, 99}, 148},
	{{115, 195, 64, 0, 0, 183, 112, 47, 189, 167, 15, 33, 137, 77, 233, 31}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 159, 75, 69}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 217}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 77, 19, 233, 111, 148, 242, 150}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 20}, 148},
	{{115, 195, 64, 140, 135, 159, 119, 253, 180, 49, 173, 105, 182, 31, 183, 17}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 222, 226}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 169, 90, 177, 85, 94, 177, 77}, 148},
	{{115, 195, 64, 0, 0, 0, 152, 233, 23, 2, 15, 12, 35, 51, 136, 240}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178, 189}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 128, 41}, 148},
	{{115, 195, 64, 0, 108, 151, 22, 76, 238, 139, 138, 190, 62, 102, 129, 212}, 148},
	{{115, 195, 64, 0, 170, 11, 110, 74, 135, 163, 250, 119, 206, 95, 88, 55}, 148},
	{{115, 195, 64, 0, 121, 4, 96, 69, 35, 22, 234, 5, 229, 57, 135, 48}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 64, 255, 121, 131, 151, 84, 29, 247}, 148},
	{{115, 195, 64, 0, 0, 40, 221, 224, 118, 77, 233, 155, 93, 248, 100, 213}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 150, 5, 88}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 214, 170, 84, 170, 138}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 246, 184, 140, 189, 96, 48, 254, 64}, 148},
	{{115, 195, 64, 0, 172, 189, 208, 63, 40, 98, 49, 15, 93, 56, 147, 253}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 45, 213}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 231, 255, 154}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 117, 196, 126}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 48, 151, 210, 142, 69}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 81, 101, 209}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 157}, 148},
	{{115, 195, 64, 0, 101, 195, 67, 62, 147, 85, 108, 105, 230, 46, 92, 190}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 71}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 61, 231, 251, 77, 15, 85, 19}, 148},
	{{115, 195, 64, 0, 0, 0, 40, 172, 204, 69, 111, 214, 27, 148, 62, 138}, 148},
	{{115, 195, 64, 230, 80, 224, 229, 116, 251, 167, 26, 205, 195, 253, 98, 236}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 37}, 148},
	{{115, 195, 64, 119, 164, 145, 5, 55, 79, 126, 81, 225, 128, 97, 59, 50}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 154, 170, 6, 187, 248, 117, 52, 148, 68}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 254}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 11, 207, 207, 48, 230, 96, 222, 27}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 163, 129, 167}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 27, 165, 118, 7, 255}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 140}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 204, 112, 8, 242}, 148},
	{{115, 195, 64, 0, 0, 0, 173, 249, 247, 219, 98, 78, 107, 224, 191, 52}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 63, 82, 15, 188, 215, 116}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 14, 132, 33, 127, 12}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 161, 52, 93, 254, 112, 64, 18}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 30, 90, 193, 3, 79, 190, 219, 145}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 245, 216}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 121}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{115, 195, 64, 0, 0, 0, 3, 106, 126, 207, 32, 86, 44, 142, 4, 167}, 148},
	{{115, 195, 64, 0, 0, 0, 183, 173, 181, 93, 56, 150, 224, 123, 167, 13}, 148},
	{{115, 195, 64, 0, 0, 228, 149, 139, 206, 49, 25, 251, 179, 155, 92, 169}, 148},
	{{115, 195, 64, 130, 163, 141, 190, 41, 125, 41, 76, 12, 21, 85, 164, 117}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 112, 37, 46, 56, 3, 88, 219, 43, 83}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 90, 153, 34, 184, 179, 27, 22}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 85, 9, 75, 94, 85}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 67, 105, 112, 187, 45, 88, 179}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 78, 204, 122}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 184, 96, 135}, 148},
	{{115, 195, 64, 0, 0, 141, 155, 154, 135, 141, 42, 78, 248, 169, 253, 50}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 26, 183, 90, 118, 91, 105, 37}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 151, 135, 44, 167, 162, 52}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 114, 224, 248, 166, 203, 133, 68, 121, 165}, 148},
	{{115, 195, 64, 189, 218, 90, 87, 127, 64, 118, 211, 44, 151, 215, 190, 65}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 148},
	{{115, 195, 64, 97, 22, 33, 248, 193, 191, 58, 239, 168, 58, 84, 226, 86}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 26, 98, 149}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 0, 0, 0, 89, 156, 93, 22, 128}, 148},
	{{115, 195, 64, 0, 42, 95, 12, 130, 207, 203, 13, 100, 167, 6, 136, 251}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 121, 103, 217, 79, 196, 69, 116, 200, 182}, 148},
	{{115, 195, 64, 0, 0, 0, 0, 0, 40, 2, 62, 70, 171, 34, 173, 131}, 148},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{116, 22, 75, 33, 16, 129, 35, 124, 10, 112, 31, 213, 181, 108, 177, 46}, 129},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 195, 26, 237}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 37, 122, 249, 217}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 95, 61, 94, 103}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 47, 72, 243, 8, 45, 26}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 136, 218, 252, 7, 75, 85}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 201, 104, 161, 190, 103}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 222, 241, 236, 15, 158, 176}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 16, 225, 237, 88, 170, 144, 51, 250}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 179, 27, 170, 246, 136, 102, 1}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 17, 148, 91, 1, 188, 188}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 177, 31, 102, 72, 201, 68}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 127, 45}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 2, 101, 5}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 76, 64, 99, 62, 82, 28, 164, 215}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 180, 23, 227, 87, 162, 75}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 64, 191, 122, 56, 11, 178, 217, 215, 13}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 242, 180, 99, 124}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 190, 30, 220, 28, 44, 208, 138, 2, 186}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 239, 112, 202}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 87, 222, 128, 61, 71, 219, 90}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 251, 46, 67}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 37, 46, 64, 27}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 19, 178, 85, 185, 58, 78, 85, 180}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 214}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 131, 195, 68, 180}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 167, 115, 168, 91, 87, 52, 219}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 131, 18, 176, 47, 152, 52}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 98, 250, 101, 4, 165, 236, 185, 233}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 110, 212, 160, 172, 217, 4, 25}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 118, 6, 254, 114, 116, 123}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 184, 103, 18, 181, 85, 94, 191}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 154, 116, 235, 97}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 11, 64, 42, 148, 244, 152, 236}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 235, 158, 46, 42, 121, 97}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 184, 185, 192, 109, 123, 136, 253}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 76, 172}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 134, 155, 142}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 185, 180}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 184, 94, 214, 219}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 55, 126, 84, 114, 239, 90, 87, 128}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 8, 212, 34}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 143, 228, 91, 9, 10, 228}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 156, 39, 151, 71, 23, 88, 252, 60}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 94, 29, 163, 251, 131}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 242, 91, 37, 62}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 80, 2, 23, 252, 18, 217, 250, 20}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 142, 137, 125, 72, 172, 112, 131, 78, 162}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 250, 200, 97, 159, 201, 215}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 72}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 214, 5, 32, 34, 146}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 214, 13, 103, 140}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 71}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 203, 23, 72}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 21}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 59, 208, 81, 130, 161, 18, 17, 162, 45}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 88, 132, 228}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 187, 189, 9, 139, 159, 199, 237}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 210, 178, 185, 155, 96, 25}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 50, 243, 5, 210, 71, 186}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 84, 4, 162, 58, 40, 252, 102}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 69, 191, 21, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 163, 53, 61, 111, 128, 130}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 75, 149, 108, 196, 255, 58, 202}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 169, 45}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 188, 120, 70, 241, 61}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 26, 181, 245, 28, 123, 132, 83, 46}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 211, 110, 243, 134, 192, 132, 62, 189, 82}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 237, 67, 85, 194, 32, 150, 243, 5, 59}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 104, 102, 41, 80, 1, 243}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 195, 224, 137, 116, 30, 166, 58, 108}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 180, 207, 64, 0, 176, 156}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 84, 134, 213, 157, 242}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 170, 125, 131, 61, 0, 147}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 67, 113, 38, 24, 120}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 121, 114, 230, 183, 63, 117}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 245, 1, 197, 197, 43, 8}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 104, 166, 75, 229, 204, 135}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 231, 219}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 0, 0, 98, 151, 122, 41, 77}, 202},
	{{117, 214, 20, 80, 83, 51, 128, 0, 0, 32, 136, 144, 80, 95, 55, 88}, 202},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 195, 181}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 164, 51, 130, 165}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 236}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 125, 102}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 174, 13, 134}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 119, 23, 55}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 225, 71, 93, 10, 234}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 167, 255, 190, 104}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 195, 219, 57}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 77}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 46, 163, 158, 84}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 48, 210}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 137, 121, 58, 65, 9}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 191, 92, 215}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 132, 73, 209}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 255, 56, 108}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 73, 164, 250, 114, 192}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 144, 22, 239, 229, 244}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 135}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 41, 65}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 117, 69, 46}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 248, 195, 170, 128}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 213, 121, 75, 179, 177}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 18, 132, 210, 120}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 206}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 48, 207, 64, 219, 163}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 140, 19, 113, 139}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 105, 31, 213}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 13, 227, 252}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 137, 15, 159}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 188, 140, 4}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 2}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 53, 117, 113, 206}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 237, 157, 193, 95, 201}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 94, 192, 88, 85}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 171, 195, 187, 9}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 70, 123}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 251, 2, 40, 190}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 85}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 195, 240, 73, 139, 208}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 78, 87, 181, 183, 236}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 195}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 64, 240, 222, 243}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 34}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 60, 6, 146, 246, 173}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 111}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 170, 205, 122, 38}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 182, 229, 65, 250}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 227}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 26, 188, 202, 92}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 106, 66, 94, 133, 51}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 210, 32}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 254, 168, 124, 241, 171}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 211}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 71, 22, 103, 157, 85}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 48}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 93}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 152}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 10, 205, 244, 94}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 73, 54}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 251, 182}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 61, 127, 153, 109, 60}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 207, 51, 172, 45}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 207}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 216, 187}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 175, 199, 249, 196, 225}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 68, 119}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 126, 31, 161}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 108, 59, 8, 85}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 123, 118}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 211, 10, 123, 252}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 73, 176}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 151}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 220, 115}, 88},
	{{120, 75, 124, 149, 120, 123, 242, 151, 181, 164, 128, 0, 0, 0, 0, 0}, 88},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 45}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 12, 115, 135}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 8, 11, 153, 13}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 199, 147}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 50, 111, 137, 6}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 247, 83, 9}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 127}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 9}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 166}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 176}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 212}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 243, 70, 173}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 167}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 195}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 99, 140, 134, 50}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 237, 39, 82}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 105}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 126, 222, 26}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 146, 35, 142}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 19, 38}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 99, 134}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 52, 160, 171}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 227}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 3}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 26, 181, 70, 156}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 83}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 198, 134, 90, 143}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 72, 208}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 173, 133, 249}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 94, 226, 157}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 83}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 143}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 37}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 80, 124}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 233}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 190, 47}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 226}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 160, 50}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 8, 252}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 53, 85, 183, 138}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 72}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 176, 118}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 193, 117, 133}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 69, 33}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 248, 57}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 90, 229}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 180}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 108, 182, 219}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 171, 200}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 150}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 112, 8, 36}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 9}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 92, 160, 140}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 99, 139, 114}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 71, 233}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 110, 121}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 137, 115}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 228, 46, 100, 128}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 179}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 250, 79}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 53, 94}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 146, 130, 244, 212}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 88}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 149, 42, 150}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 132, 241, 11}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 191, 32}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 223}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 55, 42, 188}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 207, 8, 75, 84}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 212, 126}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 43, 123, 242, 62}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 0}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 45, 160, 156, 20}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 0, 164}, 3},
	{{87, 238, 168, 62, 88, 166, 52, 104, 219, 169, 93, 128, 0, 0, 65, 148}, 3},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 110, 37}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 15}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 54, 212}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 50}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 111}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 212}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 84}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 173}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 50, 16}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 102}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 250}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 29}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 85, 144}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 103}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 238}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 46, 70}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 64, 64}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 176}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 167}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 28}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 174}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 114}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 124}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 21}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 192}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 249, 89}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 255}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 74}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 200}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 134, 160}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 146, 24}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 235, 16}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 57}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 217}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 168}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 78}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 110}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 33, 139}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 145}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 141}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 229}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 62, 16}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 145, 218}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 218}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 63}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 30}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 145}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 165}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 255}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 67}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 22}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 83}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 84}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 146}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{237, 44, 224, 146, 52, 85, 245, 192, 65, 137, 37, 95, 156, 176, 0, 0}, 243},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 116, 8, 225, 211}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 62, 49, 21, 126}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 135, 92, 232, 217, 3}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 12, 224, 126, 145, 140}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 110}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 164, 227, 243, 33, 28}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 22, 179, 36}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 26}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 144, 236, 249, 5, 18}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 189, 240, 39, 163}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 15}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 147, 251, 214, 243, 72}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 129, 116}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 69, 249, 42}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 11, 9, 190}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 112, 149, 96, 82, 2}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 95}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 17, 211, 254, 67, 31}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 1}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 213}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 35}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 90, 118, 131, 56, 70}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 146, 51, 84, 94, 52}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 25}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 223, 70, 98, 222, 121}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 151, 94, 176, 154, 133}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 78, 2, 158, 223, 208}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 231}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 72, 158, 242, 164, 61}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 213, 14, 39}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 65, 159, 13, 19, 222}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 32}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 91, 1}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 15, 204, 22, 83}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 30, 242}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 59, 18, 148}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 103, 97, 181, 220, 160}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 68}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 113, 13, 140, 196}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 79, 107}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 151, 58, 11, 35}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 79, 237}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 101, 29, 199, 46, 30}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 82, 209}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 253, 187}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 100, 83, 110}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 214, 101}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 88}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 150}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 242, 169, 59, 6}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 143, 51, 91}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 210, 237, 145}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 74}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 95, 221, 101, 206}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 73, 36, 67, 231, 61}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 193, 216, 168}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 77}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 54, 162, 216, 49}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 194, 163, 49}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 112}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 32, 17, 19, 231}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 138, 164, 172}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 252, 217, 169}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 60, 97, 13, 232, 148}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 216}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 233, 199}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 9}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 174, 179, 22}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 10}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 69, 20, 141, 147}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 189, 150, 127}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 15, 157}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 104, 236, 96, 245}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 237, 89, 84}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 85, 109}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 0, 0}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 76, 95, 68}, 95},
	{{214, 241, 51, 63, 73, 61, 193, 165, 23, 108, 0, 0, 0, 0, 9, 174}, 95},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 13, 252}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 238, 232, 244, 11}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 15, 127, 180}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 156, 16, 99, 166}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 54, 247}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 182, 93, 245}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 202, 95, 120, 132}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 26, 119}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 230, 33, 169, 25}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 202}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 90, 198}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 70, 247, 193, 255}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 31, 49, 237, 153}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 129, 168, 152}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 231, 205}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 69, 179, 50, 145}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 251, 5, 118, 124}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 229, 229, 164, 178}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 125}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 234, 133, 204}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 193, 244}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 84}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 87, 192}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 58, 255, 237, 106}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 130, 121}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 98, 76, 236}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 34}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 14, 2}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 152, 161, 5, 19, 146}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 184, 168}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 83, 181}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 170, 140, 128}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 121, 188, 57, 131}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 242, 227, 183}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 251, 162, 44, 18}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 88}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 146, 120}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 75, 207}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 182, 174, 240}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 9, 146, 70}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 93, 194}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 30}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 28, 41, 175, 204}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 57, 196, 7, 22}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 169, 82, 4}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 32, 123}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 52, 141}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 32}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 126, 192}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 139}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 240, 130, 195}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 9, 29, 90}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 45, 196}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 252, 31}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 120}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 251, 162, 164, 162}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 206, 42, 166}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 161}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 38, 16, 103}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 83, 215, 81}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 122, 101, 184}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 250}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 1, 163}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 21, 21, 134, 2, 113}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 138, 140, 128, 249}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 27}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 31, 220}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 38, 133, 67, 188}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 0, 0, 0, 0}, 255},
	{{87, 242, 21, 157, 45, 188, 36, 62, 66, 243, 64, 0, 127, 26, 215, 79}, 255},
	{{0, 97, 220, 64, 0, 0, 58, 248, 15, 217, 179, 218, 152, 223, 226, 206}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 15, 227, 247, 168, 63, 48, 77, 72}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 157, 78, 239, 246, 236, 85, 208}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 117, 161, 210, 129, 160, 196}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 55, 71, 180, 243, 138, 51, 245, 225}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 146, 244, 154, 36}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 119, 144, 75, 131, 238}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 95, 47, 127, 76, 24}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 163, 42, 7, 143, 118, 204}, 48},
	{{0, 97, 220, 64, 237, 135, 209, 99, 86, 217, 161, 88, 251, 12, 197, 26}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 189, 154}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 59, 73, 179, 151}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 68, 239, 143, 121, 22}, 48},
	{{0, 97, 220, 64, 74, 83, 13, 39, 73, 63, 63, 23, 44, 230, 41, 52}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 126, 8, 76, 130, 177, 63, 185, 194}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 126, 136, 74, 92, 114, 166, 190, 128, 143}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 253, 190, 106, 107, 169, 132, 38}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 147, 46, 152, 191, 53}, 48},
	{{0, 97, 220, 64, 0, 73, 105, 117, 144, 182, 53, 199, 216, 203, 213, 80}, 48},
	{{0, 97, 220, 64, 0, 0, 81, 115, 116, 133, 40, 194, 218, 112, 142, 222}, 48},
	{{0, 97, 220, 64, 0, 0, 105, 151, 18, 104, 225, 247, 150, 133, 155, 137}, 48},
	{{0, 97, 220, 64, 111, 47, 17, 98, 19, 93, 219, 95, 197, 233, 115, 52}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 53, 105, 121, 156}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 158, 124, 197, 3, 70, 201}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 188, 139}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 9, 73, 195, 75, 180, 254, 153, 90}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 214, 186, 115, 129, 185, 233}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 74, 72, 166, 67, 10, 215}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 161, 198, 15, 81, 208, 43, 251}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 95, 163, 10, 187, 214, 238, 253, 161, 208}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 233, 182, 224, 151, 209, 103, 67, 137, 185}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 11, 206}, 48},
	{{0, 97, 220, 64, 48, 61, 246, 163, 51, 99, 141, 55, 243, 53, 127, 155}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 60, 95}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 4, 129, 181, 61, 88, 214, 51}, 48},
	{{0, 97, 220, 64, 0, 0, 37, 86, 162, 172, 247, 151, 197, 229, 197, 71}, 48},
	{{0, 97, 220, 64, 0, 0, 252, 114, 233, 46, 227, 157, 189, 191, 233, 81}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 114, 158}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 134, 18, 226, 99, 15, 225, 246}, 48},
	{{0, 97, 220, 64, 0, 0, 93, 74, 172, 57, 242, 0, 68, 158, 18, 72}, 48},
	{{0, 97, 220, 64, 0, 0, 226, 56, 170, 116, 52, 179, 2, 16, 44, 40}, 48},
	{{0, 97, 220, 64, 0, 0, 58, 199, 115, 138, 211, 210, 82, 175, 3, 229}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 39, 132, 200, 213, 59}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 210, 229, 111, 57}, 48},
	{{0, 97, 220, 64, 30, 251, 154, 236, 185, 168, 244, 100, 203, 153, 204, 2}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 100, 88, 44, 132, 232, 68, 58}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 46, 60}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 111, 116, 32, 178, 177, 200, 189, 24}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 197, 1, 211, 109, 231, 235, 122, 155, 177}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 57, 185, 56, 145, 152, 160, 174, 81}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 206, 213, 253}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 176, 43, 71, 237, 72, 238, 200, 126}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 69, 42, 140, 165, 250, 22, 93}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 224, 69, 29, 109}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243, 115, 37}, 48},
	{{0, 97, 220, 64, 0, 125, 238, 160, 174, 108, 164, 177, 47, 40, 6, 129}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{0, 97, 220, 64, 0, 0, 30, 168, 112, 12, 118, 126, 89, 72, 229, 133}, 48},
	{{0, 97, 220, 64, 0, 0, 130, 72, 160, 137, 34, 208, 170, 80, 248, 44}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 61, 148, 16, 102, 140, 200, 242, 25}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 48},
	{{0, 97, 220, 64, 0, 0, 100, 241, 234, 47, 92, 238, 26, 83, 62, 168}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 70, 228, 123, 182, 223, 71, 181, 194}, 48},
	{{0, 97, 220, 64, 0, 0, 246, 61, 187, 244, 181, 45, 137, 239, 171, 25}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 119, 218, 102, 254, 30, 95, 52, 90, 146}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 53, 211, 26, 37, 76, 56, 131, 224, 209}, 48},
	{{0, 97, 220, 64, 0, 54, 159, 57, 77, 23, 29, 202, 203, 188, 99, 196}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 244, 131, 66, 139}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 139, 39, 15, 99, 60, 221, 103, 92, 174}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 63, 253}, 48},
	{{0, 97, 220, 64, 121, 233, 212, 127, 134, 84, 177, 108, 171, 82, 107, 241}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 194, 106}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 137, 48, 240, 75, 169, 159, 5}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 252, 160, 12, 53}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 178, 35, 89, 208, 142, 197, 200}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 216}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 124, 252}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 203, 98}, 48},
	{{0, 97, 220, 64, 0, 133, 92, 116, 4, 151, 41, 9, 78, 139, 81, 209}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 126, 221, 215, 191}, 48},
	{{0, 97, 220, 64, 0, 45, 105, 27, 248, 117, 114, 207, 107, 45, 83, 36}, 48},
	{{0, 97, 220, 64, 0, 0, 129, 172, 195, 145, 114, 65, 206, 89, 129, 129}, 48},
	{{0, 97, 220, 64, 172, 28, 123, 73, 68, 4, 6, 171, 192, 186, 118, 168}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 145, 224, 157}, 48},
	{{0, 97, 220, 64, 0, 0, 177, 200, 90, 176, 87, 37, 52, 197, 248, 47}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 226, 241, 144, 49}, 48},
	{{0, 97, 220, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 48},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 48, 227, 80, 154}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 29, 84, 30, 89}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 143}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 50, 79, 224, 202, 194}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 65, 2, 5, 195, 97, 87, 124, 145, 22}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 39, 72, 4, 191}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 80, 33, 37, 180, 216, 67, 168, 98}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 137, 128}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 31, 121, 14, 34, 246, 117}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 8, 167, 37, 27, 211}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 65, 237, 222, 141, 225, 3, 23, 152}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 211, 91, 21, 6, 152, 232, 69, 91}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 190, 30, 210, 113, 104}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 68, 101, 210, 0, 14, 99}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 149, 126, 105, 61}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 23, 104}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 159, 217, 151, 188, 76, 45, 47}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 105, 59, 86, 173, 98}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 48, 113, 47, 226}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 33, 225, 248, 120, 83, 117, 158}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 23, 221, 45, 4, 12, 127}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 183, 59, 180}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 221, 172, 173, 206, 203, 169}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 191, 12, 77}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 168, 136, 135, 192, 3, 171, 253}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 201, 123, 155, 145, 15, 76, 144}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 244, 92, 152}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 31}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 56, 239, 34, 71, 38, 143, 110}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 226, 167, 192, 122, 59, 103, 205, 103}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 37, 228, 246}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 225, 106, 196, 86}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 78, 90, 166}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 130, 52, 10, 144, 124, 21, 69, 30}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 108, 144, 147, 170, 53, 142}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 121, 217, 146, 216, 218, 57, 16, 36, 10}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 42, 100, 191, 189, 219, 165}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 237, 199}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 211, 30, 157, 15, 5, 23, 72, 224, 170}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 40, 161, 105, 65, 125, 56, 139, 200}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 36, 7, 105, 166, 54, 192, 3, 236}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 234, 132, 49, 24}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 159, 212, 122, 39, 128, 11, 183}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 49, 98, 12, 92, 56}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 48, 252, 72}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 18, 113, 248, 21, 211, 129}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 174, 94, 48, 141}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 56}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 251, 136, 209, 198, 101, 165, 92}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 5, 252, 210, 178}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 82, 94, 51}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 180, 5, 224, 169}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 7, 219, 18, 41, 239, 189, 203, 98}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 191, 228}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 74, 252, 12, 34, 191, 175}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 136, 3, 220, 143, 89, 154, 175, 181, 183}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 128, 175, 62, 203, 72, 66, 128, 157}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 133, 237, 210}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 109, 99, 69, 223, 226, 193}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 169, 189, 170, 170, 84}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 84, 184, 192}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 68, 112, 170, 238}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 116, 100, 139, 184, 218, 74, 228, 115, 92}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 195, 65, 58}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 96, 45}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 179, 250, 70, 26, 146, 151}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 29, 114, 140, 201, 134, 125}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 58, 53, 117}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 24, 209, 202, 31, 9, 127, 105, 148}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 4, 43, 181, 130}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 42, 234, 246, 119, 103, 228, 132, 87, 121}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 104, 34, 49, 86, 94, 151, 255}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 56, 198, 203, 193, 212, 97}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 116, 33, 135, 223, 194}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 131, 134, 202, 53, 45, 54, 24}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 21, 237, 163, 246, 245, 199, 171, 77}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 232, 96, 113, 226, 240, 62}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 163, 246, 158, 63, 143, 3}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 156, 32, 211, 86}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 56, 114, 217, 250, 67, 190}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 78, 34, 135, 89, 62, 194, 136}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 232, 37, 116, 122, 244, 77, 54, 178, 231}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 87, 183, 124, 140, 24}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 235, 228, 225, 204}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 130, 142, 183}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 0, 115, 96}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 231, 73, 55}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 0, 63, 138, 106}, 38},
	{{227, 206, 189, 31, 222, 8, 192, 0, 0, 0, 0, 0, 227, 194, 232, 106}, 38},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 173}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 189}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 220}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 41}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 81}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 98}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 74}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 197}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 114}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 60}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 247}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 220}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 14}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 165}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 53}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 143}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 36}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 13}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 229}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 105}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 119}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 134}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 141}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 30}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 39}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 248}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 114}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 211}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 181}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 212}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 26}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 9}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 14}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 139}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 213}, 20},
	{{174, 27, 0, 16, 13, 150, 33, 122, 154, 59, 236, 35, 248, 178, 64, 0}, 20},
	{{39, 20, 125, 69, 252, 64, 0, 99, 43, 176, 167, 154, 58, 148, 168, 125}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 169, 216, 180}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 68, 34, 25, 185, 172, 76, 89, 82}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 90, 213, 47, 39, 113, 0, 112, 43, 228}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 169, 129, 169, 37, 229}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 140, 56, 3, 75, 46, 60}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 6, 70, 98, 29}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 103, 211, 63, 147, 21, 134, 21, 74}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 186, 153, 107, 216, 160, 2, 182}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 78, 183, 5, 135, 63, 194, 136}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 44, 84}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 143, 72, 7, 13, 153}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 68, 118, 30, 12}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 190, 24, 153, 139}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 74, 91}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 60, 152, 38, 145, 176, 169, 246, 51, 171}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 75, 88, 10, 63, 60, 241, 187}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 210, 214, 223, 42, 238, 208}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 84, 114, 107, 145}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 78, 136, 3, 134, 144, 157, 135, 87, 216}, 41},
	{{39, 20, 125, 69, 252, 64, 121, 65, 155, 209, 249, 48, 77, 238, 246, 171}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 112, 145}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 237, 11, 94, 79, 173}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 19, 129, 94, 146, 90, 170, 48}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 196, 137, 74, 152, 37, 134, 157, 89}, 41},
	{{39, 20, 125, 69, 252, 64, 248, 105, 20, 28, 181, 71, 16, 215, 21, 132}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 248, 193, 43, 77, 8, 54, 223}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 126, 71, 154, 214}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 68, 236, 84, 190, 213, 96, 222}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 13, 97, 36, 24, 196, 131}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 76, 31, 77, 144, 7}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 228, 135, 218}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 225, 73}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 232, 93, 189, 49}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 169, 60, 175, 240, 137, 150, 92}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 74, 69, 85, 125, 47, 163}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 16, 82, 162, 29, 120, 198, 113}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 126, 229, 105, 100, 136, 169}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 172, 153, 214, 114, 1, 38, 31}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 123, 173, 245, 69, 74, 75}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 222, 102, 178, 34, 210, 65}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 82, 163, 0, 42, 201, 169}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 173, 127, 153, 69, 99, 87, 191}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 217, 113, 206, 247}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 161, 191, 14, 57, 194}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 176, 192, 36, 172, 116, 109}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 100, 161}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 75, 164, 116, 194, 26, 214}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 37, 55, 26, 171, 125, 4, 75}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 69, 130, 125, 95, 42, 95, 89}, 41},
	{{39, 20, 125, 69, 252, 64, 74, 223, 92, 8, 232, 212, 28, 221, 168, 164}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 55, 169, 174, 199, 229, 133, 72}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 9, 226, 171, 235, 221, 243, 176, 12, 97}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 171, 6, 148, 88, 95, 94}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 226, 165, 146, 9}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 204, 158}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 252, 139, 43, 247, 25, 219}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 54, 5, 148, 123, 150, 62}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 83, 34, 70, 113}, 41},
	{{39, 20, 125, 69, 252, 64, 36, 159, 234, 27, 175, 111, 112, 91, 174, 186}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 130, 214}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 84, 246, 176}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 172, 59, 195, 19, 31, 37}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 27, 19, 253, 158, 125, 187, 159, 204, 218}, 41},
	{{39, 20, 125, 69, 252, 64, 54, 39, 190, 39, 231, 206, 184, 184, 93, 21}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 27, 215, 215, 202}, 41},
	{{39, 20, 125, 69, 252, 64, 213, 61, 19, 190, 120, 210, 68, 141, 92, 62}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 2, 100, 246}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 252, 253}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 124, 60, 44, 206, 219, 98}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 179, 108, 202, 198, 196, 167, 246}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 64, 73, 25, 191, 223, 155}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 132, 200, 20, 134, 85, 190, 117, 140, 54}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 117, 253, 236}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 82, 197}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 168, 163, 193}, 41},
	{{39, 20, 125, 69, 252, 64, 243, 136, 1, 51, 219, 112, 7, 122, 135, 60}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 119, 224, 59, 48, 146, 227, 108}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 3, 5, 188, 143, 6}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 10, 197, 109, 244, 99, 15, 146}, 41},
	{{39, 20, 125, 69, 252, 64, 141, 180, 113, 125, 136, 66, 245, 181, 89, 192}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 181, 118, 88, 209, 224}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 240, 73, 230, 52, 45, 28}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 41},
	{{39, 20, 125, 69, 252, 64, 0, 82, 51, 160, 82, 145, 67, 51, 65, 116}, 41},
	{{39, 20, 125, 69, 252, 64, 46, 39, 30, 158, 163, 205, 170, 44, 213, 133}, 41},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 105, 17}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 33, 105, 184}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 205, 106, 182}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 20}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 186, 1}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 162, 136, 106}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 245}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 30, 233, 74, 180}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 68, 232, 57, 201}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 195, 208}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 130, 111}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 99}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 146, 147, 249}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 251, 171, 173, 96}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 231}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 119, 162, 156}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 84, 237}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 139}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 229, 88, 22, 148}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 172, 224, 251}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 197, 16, 51}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 56, 247, 77, 161}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 124, 92, 171}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 195}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 122, 225, 170, 198}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 161, 232, 214}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 107, 92, 26, 240}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 120, 234}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 231, 249, 16}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 129, 193}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 201, 153, 25}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 154, 139, 52}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 88}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 195}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 129, 195}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 10}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 129}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 1}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 158, 26, 128, 42}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 224}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 80, 45}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 236}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 220}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 186, 186}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 193, 87, 55}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 174, 207}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 121, 8}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 250, 39, 56}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 247}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 189, 95, 203, 33}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 232}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 56, 147, 134, 33}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 230, 229}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 235, 188, 105}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 109}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 119, 24, 154}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 19, 143}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 118, 72}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 178, 214}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 168, 91}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 144, 67, 29}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 58}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 203, 171, 169}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 105, 136, 36}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 0, 0, 0, 0}, 133},
	{{141, 232, 1, 12, 125, 229, 168, 14, 125, 116, 180, 0, 82, 162, 201, 57}, 133},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 214, 50, 210}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 173, 93}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 152, 62, 10}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 173, 241}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 153}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 217, 72, 254}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 185, 113, 233}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 222, 51, 59}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 236, 244, 21}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 124, 206, 176}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 209}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 207, 205}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 201, 52, 38}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 143}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 152, 124}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 70, 223}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 94, 211}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 157, 10}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 127, 208}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 41}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 49}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 117, 145}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 137}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 201}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 128, 117}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 23, 236, 184}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 106}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 51, 6, 121}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 212}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 32}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 25}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 238, 112, 183}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 194}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 54}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 141, 206}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 121, 52, 110}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 117, 145, 124}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 54, 123, 95}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 92, 27, 30}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 238, 37}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 130}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 103, 106, 91}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 152}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 122, 46, 222}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 2}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 175}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 205, 56}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 46, 110, 220}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 70, 215}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 94, 64, 238}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 49, 127}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 66}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 195, 87, 14}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 113, 49}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 2, 143}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 167, 81, 134}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 162, 143}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 214, 188}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 103}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 229, 220}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 66}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 20, 250, 216}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 145, 192, 163}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 152, 19}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 1, 105, 254}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 112, 196, 168}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 130}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 214}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 69}, 189},
	{{93, 238, 40, 228, 254, 203, 251, 6, 60, 82, 243, 242, 0, 0, 0, 0}, 189},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 230, 52}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 129}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 27, 219, 192}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 135}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 248}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 5}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 193, 179}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 36}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 182, 64}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 106, 80}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 236, 155, 53}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 220, 34, 59}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 182}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 64, 186, 63}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 254, 186, 131}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 160, 31}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 236, 9}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 247, 142, 36}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 155, 38}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 78, 146}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 132}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 71, 212, 45}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 13, 199, 212}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 3, 198}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 4, 243, 232}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 73}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 49, 158, 140}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 218, 248, 149}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 132, 195, 12}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 115, 240}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 171}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 141, 17, 180}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 240, 50}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 140, 165}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 79}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 102, 14}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 185}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 23, 125}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 151}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 85, 124}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 164}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 206, 205, 175}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 154, 178, 128}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 37, 106, 55}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 62, 77, 188}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 155, 163}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 199}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 232}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 247, 132, 27}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 157, 35}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 127}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 175}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 43}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 196, 21, 141, 255}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 72}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 68, 29, 70}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 90}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 127, 177, 119}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 41, 93, 41}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 132, 42, 86}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 253}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 139, 170}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 113}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 72, 230}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 73}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 67, 61, 186, 67}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 115, 53}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 226}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 185, 173, 114}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 158}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 184, 48}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 0, 0}, 151},
	{{44, 115, 200, 17, 146, 223, 115, 253, 126, 206, 152, 90, 0, 0, 110, 40}, 151},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 26, 189, 162, 89, 61, 244, 175}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 221, 3}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 60, 24}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 73}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 197, 46, 101}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 191, 213}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 3, 3, 7, 56, 49, 3, 59}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 161}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 221, 92, 57, 214}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 149, 85, 133, 76, 126, 24}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 121, 111, 16}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 73}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 17, 7, 27, 221, 152}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 153, 73, 24}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 245, 242, 105}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 228, 102, 65, 195, 42, 201}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 111, 2, 88, 190, 158}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 34}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 46}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 87}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 23, 208, 216, 36}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 51, 212, 29, 121}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 81, 96, 101, 245, 85, 133}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 186, 129}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 174, 25, 2}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 108, 102, 101}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 127}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 92, 214, 80, 173}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 176, 245, 37, 214, 208, 223}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 63}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 180, 190, 50, 194}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 215, 26, 254, 149, 34}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 217, 173, 15, 85}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 82, 222, 36, 101, 98, 42}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 253}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 6, 113}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 255, 10, 98, 190, 5}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 10}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 108, 191, 200, 185, 208}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 32}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 198}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 198, 62, 184}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 80, 230, 110, 186, 9}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 163, 243, 138, 77, 63}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 237, 216, 73, 118, 26}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 188, 16, 5, 246, 108, 193}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 250, 121}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 108}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 194}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 166, 105, 96, 166, 94, 60}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 109}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 215}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 16, 155, 130, 124, 48, 103}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 59, 119}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 72, 167}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 210, 99, 169}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 75}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 42, 96}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 99, 145, 189}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 101}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 191, 116, 77, 104}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 39, 173, 150, 64, 183, 251, 93}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 195, 188, 208, 151}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 35, 134, 248, 174, 20}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 1, 177, 158, 55, 249, 246}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 51, 143, 105}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 78, 68, 95, 178, 176, 118}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 0}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 68, 1}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 231, 124, 92, 139, 161}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 129}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 168, 253, 252, 231, 164, 113}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 142, 170, 254, 16}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 252, 188, 109, 192, 225, 231, 108}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 34, 51, 89, 213, 34, 163}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 0, 104}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 43, 40, 58, 58, 71}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 39, 185, 108, 187, 1, 157, 100}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 45, 195, 226, 7}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 238, 59, 147, 98}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 166, 127, 185, 155, 51}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 99, 118, 15, 179}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 250, 49, 212}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 11, 155, 244, 96, 180}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 188, 106, 233, 155, 96, 18, 167}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 120, 111, 54, 81, 112, 22}, 100},
	{{213, 58, 235, 255, 6, 163, 61, 10, 224, 0, 0, 0, 0, 0, 15, 130}, 100},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 207, 212, 3, 145, 107, 31, 182}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 130, 210, 240, 215, 218, 8, 73, 32, 107}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 85, 185, 118, 88, 104, 105, 97, 140}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 237, 6, 218}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 234, 107}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 65, 84, 36, 36}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 41, 159, 85, 88, 77}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 197, 63, 36}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 53, 211, 17, 87, 100, 244, 39, 154}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 193, 141, 57, 52, 87, 70, 33, 5, 181}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 111, 63, 167, 183}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 231, 236, 220, 190}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 156, 128, 153, 219, 90, 26, 22, 71}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 44, 79, 19, 177}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 131, 76, 1, 101, 232, 102, 80, 224, 189}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 164, 24, 213}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 121, 167, 173, 12, 208, 179}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 15, 92}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 233, 132, 198, 15, 56, 82, 105}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 225, 124, 162, 42, 247, 113, 253, 72}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 80, 44, 237, 70, 16, 137, 203, 217, 12}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 85, 138, 205, 137}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 142, 28, 24, 170, 63, 199}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 220, 162, 85, 214, 100, 102}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 47, 51}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 67, 221, 243, 54, 145, 134, 101}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 40, 146, 118, 6}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 228, 127, 179, 47, 224, 245, 75, 130}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 197, 164}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 33, 124, 118, 77}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 105, 34}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 196, 205, 108, 85, 148, 2, 255}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 131, 107, 133, 104}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 62, 109, 140, 156, 11}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 119}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 212, 77}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 2, 58, 113, 5, 57, 233, 126, 193}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 44, 64, 6, 208}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 171, 27, 231, 237, 228, 150, 44, 35, 61}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 178, 14, 4, 20, 108, 213, 230}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 47, 227, 64, 178}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 39, 173, 109, 233, 99, 143, 71, 88}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 142, 211, 159}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 198, 220, 124, 60}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 53, 20, 30, 113}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 151, 42, 37, 101, 124, 208, 40, 7, 66}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 122, 163, 100, 83, 44, 211, 41}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 241, 56, 11, 229}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 239, 243, 201, 243, 110}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 43, 73}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 93, 42, 116, 226, 76, 172, 95}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 190, 217, 227, 183, 180, 169}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 57, 120}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 45, 67, 48, 1}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 187, 83, 19, 116, 95, 79, 6, 186}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 238, 114, 11, 224, 137, 78, 52, 177}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 174, 50, 58, 108, 166, 147, 166, 198}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 230, 179, 0, 162, 171, 116}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 53, 182}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 116, 178, 128}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 21, 34, 199}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 119, 188}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 176, 209, 220, 235, 103, 215, 72}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 185, 183}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 196, 234, 142, 29, 140}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 118, 192}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 6, 195, 105, 124, 44, 160, 166, 209, 169}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 203, 248, 80, 26, 178, 76, 16, 230}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 81, 89, 19, 138, 72, 85}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 104, 102, 73, 4, 203}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 191, 55, 210, 10, 193, 12}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 30, 123, 65, 5, 151, 38}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 234, 247, 26, 139, 5, 150, 135}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 42, 249, 87}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 83, 144, 41, 189, 0, 42}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 2, 35, 12, 160, 18, 7, 195}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 164, 98, 95, 100, 32, 195, 2, 97}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 50, 67, 181, 130, 224, 87, 124}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 234, 82}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 169, 36, 174}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 110}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 230, 117, 41, 83, 223, 115, 211, 232}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 128, 177, 201, 29, 253, 255}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 130, 109, 188, 231, 209, 75, 142, 53, 189}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 143, 229, 107, 232, 48, 54, 54, 28}, 118},
	{{25, 86, 139, 116, 190, 88, 0, 0, 0, 0, 0, 0, 189, 85, 125, 211}, 118},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 160, 146, 205, 240, 19, 214, 210}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 191, 239, 232, 216, 176}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 70, 223, 19, 106, 103}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 239, 155, 98, 191}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 84}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 105, 236, 27, 58}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 60, 101, 154, 77, 23, 70, 236, 8}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 67, 131, 150, 51}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 158, 54, 190, 50, 19, 183}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 131, 251, 155, 248}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 126, 56, 39, 186, 168, 21, 241, 184, 34}, 164},
	{{113, 40, 65, 141, 64, 224, 5, 187, 119, 253, 250, 187, 108, 152, 139, 207}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 245, 120, 55, 109, 118, 107, 65, 31}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 94, 77, 239, 85, 50, 229, 143, 106}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 88, 60, 90, 128, 237}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 57, 230, 97, 142}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 130, 120, 192, 159, 162}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 221, 141, 169, 148}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 210, 31, 115, 192, 197, 2, 232}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 153}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 60, 32, 57, 15, 231, 190}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 209}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 32, 172, 221, 100}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 81, 46, 1, 230, 178, 145, 248, 61, 101}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 43, 250, 124}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 20, 176, 247, 186, 5, 248, 206, 246}, 164},
	{{113, 40, 65, 141, 64, 186, 94, 1, 8, 221, 246, 9, 116, 181, 75, 240}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 212, 235, 11, 174}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 53, 121, 202, 124, 248}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 179, 145, 189, 181, 195, 246, 44}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 252, 203, 38, 176, 116}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 20, 214, 221, 31, 192, 105, 220, 161, 19}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 230, 129, 15, 113}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 255, 155, 89, 173, 158, 224, 72, 181, 193}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 176, 41, 174, 75, 17, 132, 229, 107}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 252, 195, 22, 226, 210}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 140, 97, 146, 147, 140, 223}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 107, 91, 246, 22, 144, 139}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 8, 189, 233, 248, 130, 10, 250, 8}, 164},
	{{113, 40, 65, 141, 64, 116, 111, 67, 20, 224, 197, 78, 227, 247, 87, 89}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 38, 83, 120, 69, 117, 234, 160, 246}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 134}, 164},
	{{113, 40, 65, 141, 64, 249, 119, 18, 25, 72, 243, 120, 242, 200, 223, 23}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 220, 213, 142, 254, 141, 98, 152, 210}, 164},
	{{113, 40, 65, 141, 64, 0, 192, 41, 102, 217, 86, 100, 113, 123, 170, 23}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 169, 78, 99, 138, 147, 169, 123, 15}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 200, 19, 47, 16}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 111}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 149, 105, 190, 255}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 90}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 224}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 194}, 164},
	{{113, 40, 65, 141, 64, 0, 58, 165, 202, 204, 174, 149, 141, 170, 142, 200}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248}, 164},
	{{113, 40, 65, 141, 64, 185, 254, 87, 104, 105, 170, 233, 105, 12, 217, 223}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 94, 134, 177, 53, 31, 238}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 45}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 2, 235, 123, 81, 23, 206, 198, 192}, 164},
	{{113, 40, 65, 141, 64, 0, 47, 191, 138, 250, 231, 197, 189, 57, 144, 236}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 164},
	{{113, 40, 65, 141, 64, 30, 135, 177, 236, 50, 175, 46, 181, 137, 243, 99}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 160, 158, 99, 254}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 132, 36, 102, 76, 18, 182, 243}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 225, 221, 77, 107, 70}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 124, 199, 121, 139, 183, 114}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 49, 26, 63, 232, 221, 246, 155, 68}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 196, 224, 166, 174, 242, 191, 69}, 164},
	{{113, 40, 65, 141, 64, 0, 5, 9, 214, 151, 179, 68, 91, 253, 135, 99}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 5, 0, 171, 239, 96, 34, 154, 0, 93}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 188, 28, 56, 111, 152}, 164},
	{{113, 40, 65, 141, 64, 51, 96, 155, 66, 167, 40, 67, 103, 48, 23, 91}, 164},
	{{113, 40, 65, 141, 64, 151, 47, 59, 118, 60, 109, 42, 122, 163, 84, 156}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 215, 128, 3, 156, 47, 47, 61, 249, 216}, 164},
	{{113, 40, 65, 141, 64, 0, 215, 139, 46, 52, 147, 73, 205, 88, 22, 137}, 164},
	{{113, 40, 65, 141, 64, 0, 144, 206, 90, 130, 187, 195, 32, 111, 205, 126}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 212, 144, 130, 93}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 36, 18, 64, 99, 149, 136, 1, 56}, 164},
	{{113, 40, 65, 141, 64, 0, 21, 166, 214, 252, 13, 107, 112, 182, 5, 186}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 192, 177, 89, 118, 91, 7}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 205, 60, 28, 161, 194}, 164},
	{{113, 40, 65, 141, 64, 0, 30, 48, 254, 194, 219, 142, 61, 4, 172, 13}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 15, 140, 11, 63}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 193, 238, 13}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 40, 243, 170, 166}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 184, 119, 153, 223, 225, 191, 212}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 199, 68, 40, 214, 135, 28, 12, 100, 226}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 215}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 52}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 0, 250, 43, 173, 14, 145, 12, 89, 84}, 164},
	{{113, 40, 65, 141, 64, 0, 135, 61, 75, 92, 168, 87, 180, 17, 201, 208}, 164},
	{{113, 40, 65, 141, 64, 0, 0, 76, 240, 48, 90, 72, 242, 123, 219, 40}, 164},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 100, 197, 22}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 87, 106}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 208}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 199, 63}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 100, 10}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 147, 117}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 205, 133, 133}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 75}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 102, 116}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 146, 180}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 48, 130}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 181, 58}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 146, 147, 213}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 247, 253}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 14, 120, 111}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 130, 226, 209}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 120, 47}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 122}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 165}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 57}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 26, 176}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 91, 176, 43}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 7, 21}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 20, 16, 61}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 138, 3}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 19, 61}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 236, 57, 2}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 63, 187}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 111, 71, 64}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 213}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 54, 18, 242}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 36, 254}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 160}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 78, 143, 82}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 161, 86, 40}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 53}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 184, 229, 133}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 117, 187, 4}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 195, 222}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 53}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 43, 219}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 131}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 15}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 242, 29, 99}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 108, 1, 21}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 246}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 72, 2}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 14}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 95, 216}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 43, 88}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 6, 1}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 192}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 92}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 237, 200, 220}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 124, 50}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 125, 146, 210}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 158}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 162, 26, 107}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 129, 177}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 138, 254}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 146, 54}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 15, 151, 46}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 63, 223}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 123}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 0, 0}, 71},
	{{149, 205, 200, 186, 19, 126, 215, 199, 94, 37, 100, 32, 128, 0, 78, 193}, 71},
	{{39, 0, 0, 183, 241, 137, 43, 36, 171, 17, 232, 124, 22, 153, 194, 124}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 69, 62, 180, 64, 71, 237, 29}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 133, 220, 177, 124}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 139, 208, 207, 42, 40, 144, 234, 31}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{39, 0, 0, 0, 0, 0, 14, 83, 223, 138, 68, 235, 82, 17, 27, 94}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{39, 0, 0, 16, 156, 176, 134, 123, 80, 150, 83, 183, 238, 150, 160, 168}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 9, 136, 159, 232, 183}, 251},
	{{39, 0, 0, 0, 0, 82, 239, 178, 132, 221, 78, 243, 126, 84, 130, 228}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 160}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 92, 85, 167, 138, 124, 4, 97, 235}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 145, 183, 151, 59, 14}, 251},
	{{39, 0, 0, 0, 0, 79, 39, 246, 200, 62, 177, 244, 139, 107, 125, 107}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 178, 168, 237, 247, 127}, 251},
	{{39, 0, 0, 0, 0, 0, 113, 149, 120, 88, 59, 215, 197, 235, 156, 5}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 64, 184, 74, 98, 3}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 54, 108}, 251},
	{{39, 0, 226, 202, 123, 33, 218, 235, 223, 15, 180, 173, 118, 239, 68, 0}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 176, 225, 152, 120, 254}, 251},
	{{39, 0, 0, 0, 0, 0, 65, 178, 133, 80, 169, 201, 159, 150, 59, 95}, 251},
	{{39, 0, 0, 160, 232, 14, 165, 214, 198, 249, 216, 208, 154, 250, 148, 112}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 133, 87, 86}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 107}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 193, 99, 7, 105, 82, 126, 222, 130, 172}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 199, 124, 52, 165, 82, 145, 21}, 251},
	{{39, 0, 0, 0, 0, 87, 70, 191, 184, 12, 89, 11, 148, 132, 36, 162}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 64, 114}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 92, 108, 225, 189, 163, 245, 127, 101}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 134, 193}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 191, 238, 255}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 208}, 251},
	{{39, 0, 0, 177, 17, 195, 58, 67, 87, 221, 192, 32, 251, 94, 15, 40}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{39, 0, 0, 179, 200, 186, 181, 227, 154, 199, 85, 70, 117, 214, 44, 219}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 169, 251, 230, 101, 121, 238, 246, 116}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 34, 98, 159, 0, 160, 170, 48, 118}, 251},
	{{39, 0, 0, 0, 0, 203, 211, 2, 115, 19, 107, 147, 86, 51, 191, 91}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 143, 254}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 189, 60, 224, 239, 108, 118, 112}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 122, 130, 77, 186, 198, 140, 200}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 110, 118, 84, 248, 153, 215, 217, 184}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 128, 147, 226, 86}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 64, 163, 0, 143, 48, 239, 14, 96}, 251},
	{{39, 0, 0, 0, 0, 0, 240, 39, 203, 71, 165, 93, 87, 234, 62, 153}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 170, 166, 198, 199, 105, 242, 152, 49}, 251},
	{{39, 0, 76, 106, 21, 16, 206, 252, 128, 250, 58, 241, 186, 19, 1, 180}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 241, 198, 221, 115, 104}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 87}, 251},
	{{39, 0, 0, 0, 0, 0, 83, 49, 134, 86, 228, 165, 158, 248, 176, 239}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 213, 112, 124, 197, 47, 142, 231, 63, 225}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 150, 81, 117}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 93, 225}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{39, 0, 0, 0, 113, 171, 145, 230, 200, 247, 121, 53, 24, 171, 38, 150}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 251},
	{{39, 0, 0, 0, 8, 252, 181, 184, 206, 119, 245, 52, 241, 99, 35, 112}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 69, 146, 166, 94, 13, 31, 192}, 251},
	{{39, 0, 0, 0, 0, 156, 11, 238, 93, 251, 190, 141, 187, 254, 98, 127}, 251},
	{{39, 0, 0, 0, 0, 0, 178, 224, 198, 250, 79, 15, 134, 11, 232, 116}, 251},
	{{39, 0, 70, 79, 102, 7, 99, 233, 113, 51, 143, 0, 203, 212, 153, 166}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 126, 41, 226, 196, 68}, 251},
	{{39, 0, 105, 95, 205, 198, 69, 110, 146, 201, 39, 7, 222, 176, 23, 68}, 251},
	{{39, 0, 0, 0, 0, 232, 248, 91, 248, 217, 137, 50, 55, 195, 255, 235}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 25, 63, 243, 1, 238, 135, 88, 183}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 103, 19}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13}, 251},
	{{39, 0, 167, 207, 33, 247, 54, 39, 31, 114, 80, 123, 169, 220, 145, 166}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 230, 230, 159, 0}, 251},
	{{39, 0, 71, 232, 252, 97, 25, 205, 176, 49, 187, 135, 233, 35, 33, 247}, 251},
	{{39, 0, 0, 10, 173, 135, 240, 187, 166, 210, 17, 142, 32, 24, 94, 10}, 251},
	{{39, 0, 0, 0, 0, 0, 214, 179, 184, 143, 121, 133, 46, 65, 251, 186}, 251},
	{{39, 0, 0, 0, 0, 163, 16, 188, 106, 247, 46, 125, 23, 172, 159, 175}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 116}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 98, 50}, 251},
	{{39, 0, 0, 0, 0, 0, 12, 174, 157, 41, 181, 166, 189, 40, 134, 132}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 175, 120, 9, 19}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 151, 152, 222, 3, 76, 199, 101, 216}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 1, 7, 194, 157, 42, 220, 197, 222}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 9, 95, 119}, 251},
	{{39, 0, 122, 32, 134, 235, 234, 106, 108, 85, 40, 61, 182, 160, 186, 18}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 138, 166, 199, 146, 26, 157, 183}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 99}, 251},
	{{39, 0, 0, 0, 0, 253, 250, 214, 107, 121, 245, 225, 8, 138, 139, 252}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 152, 174, 163, 241}, 251},
	{{39, 0, 0, 0, 11, 80, 193, 136, 224, 63, 202, 145, 168, 26, 139, 194}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 103, 88, 160, 68, 136, 22, 199, 233}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 67, 187, 64, 89}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 199, 29, 111, 217, 24}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 122, 246, 245, 151, 177, 201, 36, 48}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 106, 247, 211, 99, 253}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 17, 32, 205}, 251},
	{{39, 0, 0, 96, 112, 175, 43, 56, 231, 173, 191, 13, 207, 249, 131, 126}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 0, 164, 91, 10, 51, 167, 246, 102, 43}, 251},
	{{39, 0, 0, 0, 0, 0, 0, 144, 27, 96, 108, 159, 157, 97, 27, 181}, 251},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 175, 225, 101, 169, 119, 64, 236}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 194, 129, 64, 130, 254, 207}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 230, 57, 40, 16}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 48, 253, 2, 25, 111}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 216, 192, 38, 159, 77, 13, 33}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 90, 221, 96, 174, 128, 7, 40}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 122, 117}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 37, 11, 178, 242, 199, 91}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 156, 98, 139, 224}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 23, 92, 96, 250, 178}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 77, 205, 12, 82, 209, 119, 105, 48}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 178, 183}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 20, 185, 161, 163, 141, 223, 3, 145}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 172, 87, 190}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 177, 24, 15}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 126, 116, 220, 175}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 109, 55}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 183, 79, 6, 119, 7, 127, 111}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 15, 4, 54}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 32, 178, 151, 210, 107, 230, 192, 186}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 176, 167, 13, 165}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 57, 222, 170, 48, 7, 217, 192, 29}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 141, 189}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 167, 60, 88, 36}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 146, 58, 110, 61, 221, 29}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 90, 156, 23, 102, 86}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 111, 54, 204, 68, 165, 253, 146}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 181, 226}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 2, 27, 115, 187, 64}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 184, 60, 44, 98}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 232, 40, 178}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 71, 108, 163, 117}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 20, 241, 6, 121, 59, 6, 94, 39}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 208, 30, 162, 40, 157}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 47, 139, 103}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 123}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 243, 226, 205, 74}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 219, 23, 245, 200}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 137, 18, 156, 254, 219}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 223}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 224, 163, 234, 180, 156, 203, 86, 228}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 191, 70, 56, 9}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 4}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 27, 250}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 33, 190, 104, 140, 163, 144, 100, 161}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 185}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 234, 9, 105, 67}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 68, 253, 226, 122, 249, 134, 21, 151}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 184, 224, 113}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 7, 171, 59, 10, 125, 147, 65, 93}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 208, 235, 110, 104, 72, 159, 254}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 179, 82, 221, 113, 110, 91}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 30, 145, 78, 108}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 7, 152}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 92, 209, 158, 39, 29, 98}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 50, 222, 169, 155, 100, 126, 12}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 127}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 169, 251, 191, 13, 139, 83, 215}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 163, 63, 161, 47, 70, 25, 200, 194}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 188, 41, 192, 128}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 150, 77, 59, 230, 165}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 116, 166, 79, 40, 77}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 71, 22, 23, 3, 78, 214}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 210, 167, 226, 253, 168, 60}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 6, 109, 153}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 48, 174, 242, 118, 203}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 20, 63, 212, 84, 163, 181}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 86}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 37, 246, 190, 112, 31}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 25, 0, 179, 181, 164, 49}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 207, 97, 140, 170}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 61, 19, 48, 40, 151, 17, 74}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 49, 216, 78, 200, 115, 149}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 49, 206, 175, 132, 140, 214}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 88, 93, 86}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 170, 225, 195}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 221, 252, 240, 10, 0}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 209}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 156, 193, 85, 75, 253, 56, 159}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 196, 159, 105}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 113, 30, 181, 97, 190, 65, 86, 106}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 131, 102, 116, 232, 15, 159}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 228, 217, 26, 12, 141, 55}, 51},
	{{81, 87, 80, 173, 163, 166, 104, 0, 0, 0, 0, 0, 0, 151, 14, 243}, 51},
	{{0, 0, 0, 0, 0, 0, 0, 0, 8, 124, 193, 240, 71, 174, 112, 75}, 61},
	{{0, 0, 0, 0, 0, 0, 142, 8, 29, 45, 213, 128, 178, 156, 28, 162}, 61},
	{{0, 0, 0, 1, 130, 73, 119, 98, 68, 137, 219, 147, 12, 96, 190, 25}, 61},
	{{0, 0, 0, 26, 100, 18, 61, 172, 136, 210, 212, 82, 90, 122, 112, 246}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 129, 109, 126}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 206, 21, 250, 204, 32, 92, 20, 75, 64, 241, 191, 53, 108}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 15, 107, 70}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194, 14, 7}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 131, 243, 36}, 61},
	{{0, 0, 83, 27, 1, 120, 174, 98, 177, 43, 181, 173, 44, 223, 155, 60}, 61},
	{{0, 158, 205, 104, 239, 133, 64, 123, 66, 110, 62, 156, 147, 19, 220, 85}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89}, 61},
	{{0, 0, 0, 0, 200, 58, 181, 41, 210, 243, 109, 251, 198, 105, 105, 249}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 169, 34, 126, 210, 58, 77}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14}, 61},
	{{0, 0, 0, 153, 173, 148, 70, 12, 225, 28, 10, 76, 242, 203, 105, 21}, 61},
	{{0, 0, 0, 0, 96, 212, 102, 38, 177, 142, 218, 192, 129, 12, 21, 88}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 150, 63, 26, 207, 31, 173}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 247, 163}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 184, 13, 131, 250, 165, 137, 28, 15, 172}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 52, 60, 106, 88}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199}, 61},
	{{0, 0, 171, 39, 120, 231, 26, 66, 62, 69, 144, 101, 110, 112, 206, 66}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 129, 28, 93}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 143, 59, 198}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 115, 165, 140, 252, 100}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 199, 220, 101, 14, 45, 250, 122}, 61},
	{{0, 128, 178, 188, 97, 72, 192, 224, 92, 7, 73, 84, 57, 197, 190, 7}, 61},
	{{0, 0, 0, 0, 180, 143, 32, 235, 15, 213, 153, 226, 83, 185, 169, 151}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 61, 197, 105, 154, 20, 119, 179, 215, 234}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 118, 142, 66, 54, 191, 42, 156, 215}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 181, 193, 129}, 61},
	{{0, 0, 232, 151, 67, 53, 172, 64, 154, 175, 75, 161, 124, 254, 158, 128}, 61},
	{{0, 0, 0, 0, 0, 250, 95, 252, 51, 209, 0, 160, 38, 64, 208, 240}, 61},
	{{0, 0, 98, 6, 32, 82, 50, 141, 102, 135, 3, 81, 39, 202, 45, 29}, 61},
	{{0, 0, 0, 0, 227, 73, 119, 152, 98, 57, 61, 66, 40, 38, 38, 22}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 223, 44, 242, 19, 33, 188, 73, 60, 242, 102, 87, 255, 1}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 102, 147, 246, 228, 89, 23, 178, 64, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 77, 122, 97}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 89, 83, 198}, 61},
	{{0, 0, 0, 0, 68, 99, 12, 14, 19, 200, 90, 118, 184, 156, 189, 39}, 61},
	{{0, 0, 0, 0, 0, 149, 199, 73, 57, 66, 212, 29, 142, 50, 122, 213}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 77, 32, 200, 93, 172, 232, 98, 186}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 204}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59, 250, 232, 92, 73, 20}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 76, 236, 158, 228, 33}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 93, 150}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 147, 104, 142, 78}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 116, 2}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177}, 61},
	{{0, 0, 0, 0, 0, 67, 49, 254, 253, 0, 231, 37, 126, 55, 31, 170}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 103, 217}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 235}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 108, 139, 244, 163, 223, 167, 229, 252, 205}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 222, 78, 158, 28, 236}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 63, 155, 172, 198, 36, 253, 232}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 36, 141, 73, 252, 121, 168, 76, 74, 159}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 174, 13, 247, 33, 11, 59, 181, 151, 100}, 61},
	{{0, 0, 0, 0, 0, 33, 189, 141, 237, 246, 13, 251, 213, 103, 107, 211}, 61},
	{{0, 0, 0, 0, 182, 162, 167, 0, 155, 44, 94, 10, 163, 49, 226, 161}, 61},
	{{0, 41, 236, 218, 204, 190, 193, 201, 207, 29, 93, 49, 87, 63, 227, 168}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125, 193, 36}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 7}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 81, 219, 88, 17, 89, 39, 61, 210}, 61},
	{{0, 0, 0, 0, 0, 0, 48, 249, 126, 50, 107, 167, 133, 95, 120, 100}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 179}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 221, 93}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 60, 124, 169}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 64, 236, 203}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 115, 153, 238, 54}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115}, 61},
	{{0, 0, 0, 158, 217, 255, 130, 7, 64, 37, 102, 150, 229, 159, 15, 182}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 181, 255, 200, 242, 53, 100, 201, 145, 143, 197}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 132, 11, 184, 159, 178, 185, 194, 198, 245}, 61},
	{{0, 0, 0, 76, 5, 219, 81, 234, 28, 94, 188, 39, 94, 234, 219, 28}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 177, 145, 172, 216, 172, 22, 98, 252}, 61},
	{{0, 0, 158, 73, 45, 112, 201, 189, 65, 183, 217, 36, 185, 237, 133, 41}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 202, 90, 191}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 88, 43, 117, 217, 120}, 61},
	{{0, 0, 0, 0, 0, 0, 84, 220, 205, 45, 92, 179, 173, 34, 247, 245}, 61},
	{{0, 0, 0, 0, 0, 59, 241, 142, 20, 53, 150, 172, 94, 33, 203, 158}, 61},
	{{0, 0, 0, 0, 0, 0, 74, 162, 9, 173, 60, 156, 44, 173, 24, 222}, 61},
	{{0, 0, 0, 0, 183, 233, 34, 219, 28, 60, 126, 195, 158, 193, 39, 225}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 235, 252, 1}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 159, 67, 2}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 215, 218, 142}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 55, 234, 75, 121, 228, 194}, 61},
	{{0, 0, 0, 122, 243, 212, 83, 191, 40, 20, 2, 27, 37, 33, 164, 63}, 61},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 101, 226, 195, 165}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 168, 85}, 144},
	{{140, 128, 0, 0, 0, 0, 61, 237, 219, 161, 212, 140, 91, 243, 188, 41}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 132, 1, 184, 58, 27, 240}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 100}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 31, 108, 78, 232, 165, 99}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 128, 0, 0, 145, 101, 178, 94, 225, 102, 237, 218, 151, 29, 175, 121}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 144, 154, 77, 140, 205, 43, 13, 55}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 128, 0, 0, 175, 53, 118, 62, 142, 145, 167, 191, 252, 40, 133, 51}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 128, 34, 142, 187, 9, 167, 8, 143, 58, 223, 242, 186, 183, 226, 89}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 31, 251, 179, 50, 165, 195, 223, 52, 114}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 191, 18, 170, 174}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 179, 125, 7, 7, 232, 94, 29}, 144},
	{{140, 128, 0, 0, 0, 0, 185, 255, 128, 19, 231, 140, 195, 190, 103, 172}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 100}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 85, 188, 170, 237, 86, 195, 83, 96, 22}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 169}, 144},
	{{140, 128, 0, 62, 152, 77, 133, 17, 233, 205, 37, 236, 15, 211, 89, 62}, 144},
	{{140, 128, 144, 45, 118, 134, 207, 50, 105, 64, 255, 59, 89, 203, 223, 146}, 144},
	{{140, 128, 0, 0, 0, 0, 237, 5, 96, 193, 10, 190, 196, 134, 243, 9}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 216, 18, 195, 162}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 95, 207, 164}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 149, 126}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 63, 3, 72, 164, 9, 117, 250, 0, 213}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 1, 115, 135, 238, 14, 116, 84}, 144},
	{{140, 128, 0, 190, 199, 85, 203, 16, 32, 162, 89, 104, 168, 128, 170, 116}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 77, 4, 36}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 168, 176, 150, 199, 78, 187, 237, 198}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 128, 0, 234, 134, 84, 50, 217, 96, 244, 191, 121, 107, 202, 40, 50}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 180, 177, 130, 38}, 144},
	{{140, 128, 0, 0, 176, 155, 200, 249, 182, 247, 128, 75, 100, 43, 65, 212}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 58, 141, 79, 234, 13, 219, 16, 100}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 68, 215, 136, 244, 220, 86}, 144},
	{{140, 128, 0, 0, 0, 0, 202, 215, 18, 198, 253, 76, 33, 65, 54, 186}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 89, 24, 186}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 11, 81, 160}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 67, 4, 17}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 220, 86}, 144},
	{{140, 128, 0, 78, 9, 51, 90, 156, 140, 156, 206, 156, 91, 242, 152, 172}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 34, 180, 11, 138, 180, 21, 48}, 144},
	{{140, 128, 0, 0, 0, 121, 207, 207, 92, 144, 242, 65, 85, 160, 233, 184}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 81, 93, 2, 139, 210, 54, 209, 190}, 144},
	{{140, 128, 0, 0, 198, 24, 14, 189, 146, 106, 25, 77, 144, 56, 40, 247}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 70, 189, 48}, 144},
	{{140, 128, 0, 0, 85, 169, 9, 248, 146, 1, 103, 48, 121, 110, 191, 237}, 144},
	{{140, 128, 249, 200, 131, 77, 2, 78, 145, 27, 120, 45, 21, 96, 238, 1}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 103}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 69, 122, 176, 188, 68, 111, 93}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 232, 108, 56, 19}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 19, 105, 94, 100}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 210, 58}, 144},
	{{140, 128, 0, 22, 29, 104, 119, 248, 28, 169, 77, 87, 216, 227, 188, 205}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 80, 108, 4, 22, 102, 69, 65}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 144},
	{{140, 128, 0, 0, 73, 144, 209, 152, 76, 3, 120, 14, 192, 171, 158, 37}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 183, 0}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233, 33, 20}, 144},
	{{140, 128, 0, 0, 0, 0, 30, 242, 106, 195, 140, 16, 75, 161, 9, 230}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 106, 155, 102}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 16, 127, 161, 20}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 3, 249, 222, 132, 100, 29, 168, 25}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 41, 101, 231, 27}, 144},
	{{140, 128, 0, 0, 0, 0, 163, 171, 145, 29, 60, 217, 131, 220, 46, 231}, 144},
	{{140, 128, 0, 16, 101, 255, 248, 85, 191, 157, 70, 168, 218, 194, 185, 114}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 77, 249, 129, 74, 69, 159, 121, 78, 175}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 170, 92, 181, 1, 42, 204, 178}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 65, 61, 79, 77, 237, 136, 199, 152}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 22, 56, 95, 14, 179, 213}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231, 88, 169}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 225, 211, 102, 191, 226, 118}, 144},
	{{140, 128, 63, 204, 160, 47, 152, 175, 30, 83, 49, 78, 242, 13, 222, 91}, 144},
	{{140, 128, 0, 0, 0, 201, 160, 208, 5, 216, 74, 204, 176, 113, 217, 135}, 144},
	{{140, 128, 0, 0, 222, 161, 199, 124, 255, 164, 110, 56, 213, 176, 78, 156}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 185, 247, 215, 183, 10, 80, 93, 82}, 144},
	{{140, 128, 0, 0, 60, 93, 5, 99, 175, 194, 65, 149, 199, 246, 39, 239}, 144},
	{{140, 128, 114, 150, 20, 229, 159, 107, 117, 153, 137, 162, 43, 26, 95, 131}, 144},
	{{140, 128, 34, 189, 236, 90, 163, 234, 146, 100, 219, 237, 120, 193, 55, 69}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 86, 237, 173, 183, 207, 107, 185, 213}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 110, 72, 126, 38, 48, 57, 159, 208, 105}, 144},
	{{140, 128, 0, 130, 241, 189, 204, 79, 105, 93, 95, 203, 249, 220, 73, 26}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 24, 110, 170, 255, 94, 180, 15, 155}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170, 119, 145}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 77, 0, 25, 79}, 144},
	{{140, 128, 0, 245, 165, 207, 160, 12, 14, 76, 181, 102, 27, 223, 167, 72}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 189, 222, 7}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 79, 3, 198, 220, 139, 59, 55, 175}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 41}, 144},
	{{140, 128, 0, 0, 0, 130, 109, 235, 192, 103, 20, 209, 24, 137, 227, 121}, 144},
	{{140, 128, 0, 0, 0, 0, 0, 0, 0, 241, 23, 139, 63, 137, 77, 200}, 144},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 4}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 85, 100, 242, 177, 163}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 155, 108, 164}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 148, 115, 114}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 149, 20, 234, 49}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 76, 185, 151}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 217, 190, 130, 69}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 126}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 44}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 104, 159, 191}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 36, 42, 45, 229}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 219}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 24}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 32, 90, 72, 30}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 68, 59, 161}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 141, 33, 62}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 190, 162, 61}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 216, 41, 6}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 13, 153}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 107, 140, 120, 161}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 95}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 48}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 25, 241, 66}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 196, 69, 29, 49}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 106, 204, 98, 13}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 109}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 86, 136, 25}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 94}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 162, 214, 183}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 106, 128, 224}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 184, 43}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 86, 27, 107, 215}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 166}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 91, 48, 121, 175}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 158, 211}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 85, 41}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 239, 7, 151, 146, 137}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 231, 129, 16, 84, 173}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 156}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 84, 67, 185}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 5, 123, 47}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 110, 123, 79}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 124}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 234, 144}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 131}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 176, 176, 241, 223, 166}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 204, 159, 24, 151, 134}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 181, 86}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 218, 242, 14}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 229}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 27}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 135, 198, 35}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 86, 244, 219, 225, 147}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 89, 139, 218, 129}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 233, 82, 48}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 115, 147}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 200, 7, 227, 127}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 231, 167}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 14}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 208, 6}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 36, 81}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 27, 177, 152}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 141}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 211, 9, 161, 91, 65}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 181, 144, 91}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 54, 195, 158}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 229, 184, 54}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 6}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 116}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 126, 134, 202, 94}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 206, 155, 94, 229}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 49, 26, 39, 229}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 4}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 74, 87, 187}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 92, 95, 210}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 222, 15, 122}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 9, 189, 85, 120, 10}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 69, 177, 55, 173}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 103, 41}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 0}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 218, 205, 177, 204}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 0, 0, 0, 27}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 180, 248, 151, 119}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 187, 251, 155, 169}, 51},
	{{6, 42, 1, 178, 250, 53, 186, 178, 114, 121, 192, 0, 206, 29, 71, 19}, 51},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 216}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 149, 64, 140}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 31, 19, 233, 74}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 241, 44, 45, 253}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 60}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 90, 101, 170}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 20, 38}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 130, 220, 215, 200}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 211, 65, 75, 223}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 198}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 46, 243}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 107, 115, 214}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 181, 143}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 124, 22, 180}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 188, 187, 42, 192}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 239, 206, 120, 148}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 243}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 9}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 21}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 9, 145}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 48, 34, 188}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 132, 128, 140, 117}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 99, 113, 60, 172}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 65, 155, 224}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 88, 81}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 201, 184}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 145, 243, 181, 91}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 123, 148, 16}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 174}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 225, 144, 12}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 66}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 229}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 100, 71, 113}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 222, 121, 58}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 124, 173}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 182, 56}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 48}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 230}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 173}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 199, 73, 207, 4}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 96, 20}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 223}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 163, 171, 68, 229}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 175, 122}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 99, 23, 239, 145}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 74}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 193, 164, 219}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 164, 52}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 150}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 198}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 105, 14, 146, 234}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 130}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 138}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 15, 176, 164}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 61, 65, 73, 218}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 93, 161, 125, 94}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 237, 84, 127, 137}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 207, 31, 182}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 165, 59}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 166, 227}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 244, 41, 191, 114}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 246, 190}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 65, 101, 117, 47}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 99, 248, 29, 239}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 72, 63, 205}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 40, 132}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 118, 46, 73}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 254, 171}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 28, 39, 211}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 160, 213, 157, 251}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 142, 224, 60}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 115, 117}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 202}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 77, 226, 212, 210}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 213, 174}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 10, 40}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 89}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 178}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 180, 134}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 248, 253, 238, 122}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 41}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 0, 0}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 0, 0, 98, 54}, 32},
	{{2, 17, 234, 51, 169, 5, 219, 149, 245, 237, 4, 0, 63, 2, 112, 56}, 32},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 137, 240, 74, 22, 140, 91, 13}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 4, 22, 132, 50, 235, 86}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 56, 193, 138, 223, 192, 116, 37}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 164, 59}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 34, 235, 41}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 220, 143, 101, 140, 191, 146, 98}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 250, 15, 79, 172}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 222, 241, 48, 208, 230}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 193, 142, 255, 235, 201, 48}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 9}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 20, 170, 5, 127}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 29, 241, 154}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 221, 250, 61, 104, 133, 14}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 71, 125, 15}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 161, 78}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 150, 79, 228, 111}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 140, 5, 154, 184}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 11, 158, 92, 113, 43, 3}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 191, 224, 27, 29, 85, 37}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 110}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 61, 210, 12, 205, 46, 187}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 125, 72, 170}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 119}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 100, 45}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 143}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 106, 230}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 175, 144, 228}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 201}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 84, 48, 63}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 230, 141}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 62}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 152, 175}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 141, 251, 33, 65}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 132, 46, 225, 103}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 39, 42, 167}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 169, 239, 180, 146, 233, 67}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 242, 151, 35, 171, 135}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 175, 129}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 160, 48, 189, 251}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 227, 180}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 205, 179, 105}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 195, 209, 114}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 163, 134, 40}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 37, 15, 22}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 175, 177, 154, 69}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 101, 83, 6}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 219, 123, 218, 111}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 164, 137, 238, 213, 60, 61}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 44, 208}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 120, 183, 133, 74, 90}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 43}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 121}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 146}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 157}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 161, 117, 142, 118, 213, 221}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 114}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 63, 15}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 93}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 148, 169, 64, 24, 4}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 99}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 249, 16, 94, 23, 99}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 145, 252, 222, 207, 119}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 198, 96, 180, 176}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 22, 82, 27, 119, 218}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 165, 169, 229, 220}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 168}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 27, 161}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 132, 18, 192, 26, 37, 92}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 218}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 181, 8, 42, 40, 150, 129}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 102, 174, 145}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 250, 41, 24}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 106, 96, 96, 145, 175, 114}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 223, 250, 178, 142, 249, 80, 74}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 106, 139, 40, 9, 225, 153}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 55, 21, 215, 0}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 90, 14}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 217, 194, 2, 205, 10, 41}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 172, 133, 75, 67}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 0, 0, 117}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 71, 213, 158}, 137},
	{{112, 187, 173, 17, 229, 171, 225, 170, 8, 0, 0, 0, 0, 89, 187, 178}, 137},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 191, 132, 192, 120, 156, 230, 142}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 241, 107, 81, 155, 92, 13}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 194, 157, 163, 25, 95, 111, 188, 200}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 36, 13, 70, 199, 127}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 90, 187, 0, 180, 60, 91, 19, 50}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 55, 131}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 206, 122, 203, 71, 66, 42, 183, 33}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 159, 192, 38, 112}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 14, 197, 26, 173, 29, 64}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 170, 224}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 207, 22, 154, 148, 96}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 93, 217, 110}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 47, 64, 127, 29, 172, 90, 30, 176}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 48, 150}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 54, 55, 85, 200, 28, 170, 182}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 207}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 57, 59}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 104, 121}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 17, 213, 40, 130, 31, 182, 181, 89}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 153, 78, 134, 193, 245, 180}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 152, 4, 77, 74, 78, 143}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 189, 232, 195}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 132}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 186, 107, 254, 24}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 4, 222, 63, 213}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 11, 14, 129, 194, 95, 159, 234}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 231, 30, 238, 136, 26, 122, 61}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 60, 119, 85}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 91, 159, 152, 216, 173, 244}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 153, 105, 217, 236, 225, 230}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 123, 153, 133, 209, 174}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 140}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 175, 199, 163, 177, 122}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 231, 22, 103, 85, 196, 171}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 103, 147, 224, 15, 25, 151, 239}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 8, 77, 7}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 157, 109, 180}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 158, 204, 247}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 129, 71, 134, 57, 79}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 255, 174, 109}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 11, 105, 158, 211, 131}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 1, 179, 94, 30, 40, 249, 162, 175}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 50, 127}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 172, 58, 159, 24, 1}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 73, 127, 182, 20, 165, 215, 174, 84}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 152}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 184, 62, 87, 114, 83, 142, 36, 223}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 136, 20, 136, 58}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 208, 62, 149, 137, 239, 217, 176}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 176, 22, 193, 199, 50, 163, 246}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 179, 218, 110, 201, 19, 69}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 76, 239, 109, 170, 13, 19}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 117, 83, 172, 192}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 130, 182, 69, 188, 148, 165, 149, 90}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 39, 204, 37, 108, 250, 9}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 43, 196}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 101, 78, 149}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 151, 163, 81, 35, 217}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 228}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 7, 169, 207, 192}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 165, 33}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 110, 117, 166, 13, 242, 42}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 249, 230, 63, 249, 105}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 23, 209, 43, 156, 192, 23}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 178, 136, 205}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 137, 136, 209, 189, 11, 51}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 111, 98}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 117, 144, 119}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 94, 196}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 50}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 69, 232, 196, 64, 95, 124, 15}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 249, 162, 80, 84}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 59, 221, 127, 136, 94, 65, 47}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 8, 137}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 220, 158, 88, 241}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 88, 91, 249}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 80, 231, 48, 243, 122, 119, 50, 178}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 177, 21, 9, 56, 109, 139}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 111, 52, 241, 161, 225, 72}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 0, 0, 0}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 163, 0, 240, 11}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 220, 29, 206}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 222, 27, 140}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 231, 91, 191}, 2},
	{{203, 71, 140, 237, 113, 96, 123, 16, 0, 0, 0, 0, 0, 189, 30, 14}, 2},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 236, 134, 144}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 38, 118}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 30, 133, 184, 210, 216, 99, 113}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 177, 36, 127, 231, 48, 101, 60}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 220, 176, 111, 246, 233}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 157, 190, 200}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 160, 173}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 165, 92, 204, 71, 143}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 240, 215, 10, 189, 233}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 60, 2, 7, 242, 33, 239, 156}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 2, 136, 253, 136, 41, 78}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 73, 107, 247, 47, 166, 177}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 131, 51, 145, 207, 150, 17}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 128, 214, 108, 182, 40, 148, 39}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 180, 164, 31, 121, 192, 139, 247}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 14}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 145, 82, 146, 36}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 167, 54, 87}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 65, 207, 148, 56, 225, 238}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 95, 231}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 3, 135, 223, 1, 140}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 131, 162, 156, 197, 178, 155}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 192, 253, 83, 77, 49, 195, 31, 254}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 57, 21, 159, 182, 230, 23}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 87, 124, 141, 99, 113, 88}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 116, 70, 228, 171, 174, 211, 253}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 193, 93, 167, 22}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 123, 185, 163, 252}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 243, 208, 80, 50, 251, 25, 121}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 228, 182}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 152, 78, 44}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 90, 150, 211, 54, 74}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 91, 210, 75, 85, 123, 70, 59}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 43, 204, 142, 151, 165, 33}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 20, 240, 253, 10, 33}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 216, 116, 121, 176, 222}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 68, 168, 84, 244, 221, 118, 95}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 73, 102, 92, 231, 74, 153, 15}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 94, 71}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 34, 58, 164, 246, 196, 111}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 103, 223, 147, 210, 7, 70}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 232, 76, 232}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 123, 203}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 52, 53, 198, 75}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 248, 3, 33, 183, 178, 210, 1}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 94, 86, 162, 245}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 183, 116, 179, 46, 83, 173, 7}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 2}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 219, 107, 164}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 80, 9, 112, 216, 41, 115}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 16, 171, 129, 91, 127}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 9, 208, 237, 35, 55}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 65, 81, 177, 137, 10, 87, 64, 249}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 102}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 191, 134, 151, 82, 80}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 6}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 90, 54, 225, 193, 232}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 218}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 255, 254, 149, 76, 159, 173, 80}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 187, 10, 102, 177, 34, 34}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 147, 181, 112, 116, 46, 143}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 70, 238, 61, 23, 55, 93}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 72, 231, 111, 108, 186, 252, 94}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 120, 18, 131, 19, 98, 7, 204}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 25, 177, 140}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 231, 50, 160, 242, 84, 247, 162}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 43, 87, 83, 115}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 184, 7, 82, 25}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 0}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 226, 228, 226, 233, 199, 14}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 7, 251, 128, 19, 143}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 190, 161}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 185, 73, 121, 238, 39, 236}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 51}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 146, 25}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 151, 83, 216, 100, 50, 30, 207}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 6, 117, 249, 190, 31}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 64, 253, 210, 162, 27, 98, 238}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 245}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 194, 17, 244, 124}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 91, 126, 24, 145, 226}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 21, 144, 10}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 22, 177, 28, 253, 142, 130}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 78, 17, 98, 214, 186, 21}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 194, 17, 223}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 250, 5}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 129, 79, 245, 224, 208, 83, 253}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 115, 9}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 245, 52, 221, 123, 51}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 143, 3}, 163},
	{{99, 138, 207, 2, 244, 25, 211, 98, 0, 0, 0, 0, 0, 0, 0, 123}, 163},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 108, 136}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 106, 5}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 222, 255}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 13}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 15}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 50, 169}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 2, 220}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 154, 90, 153}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 254, 168, 83}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 18, 156}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 8, 160}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 163}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 112, 166}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 68}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 215}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 12, 43, 95}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 31, 251, 223}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 32, 185, 21}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 99, 160, 81}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 20}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 13, 55}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 220, 152}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 226, 45}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 244}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 64, 140}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 94, 194}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 100, 6}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 143, 27}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 160}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 184}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 208, 79}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 92}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 140}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 59, 27}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 105, 197}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 202, 89}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 164, 19}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 252}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 156, 232}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 245}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 238, 143}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 229, 59}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 201, 93}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 164, 176}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 154, 125}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 95}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 64}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 184, 57, 47}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 219}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 69}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 168}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 217}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 42}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 121, 94}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 28}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 83, 139, 114}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 234, 219}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 49, 219, 3}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 84, 165}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 162, 180}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 63, 247, 174}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 176, 205}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 183, 23}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 164}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 6, 210, 232}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 118}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 0}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 62}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 0, 243}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 0, 206, 100}, 162},
	{{114, 42, 98, 246, 252, 48, 233, 118, 63, 226, 157, 226, 192, 91, 23, 147}, 162},
	{{161, 64, 0, 0, 0, 0, 128, 101, 47, 2, 74, 86, 38, 169, 181, 58}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 91, 151, 146, 111, 137, 241, 184}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 196, 1, 93, 94, 145, 230, 225, 82}, 192},
	{{161, 64, 0, 0, 0, 0, 59, 93, 255, 171, 165, 60, 71, 219, 249, 30}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 192},
	{{161, 64, 19, 159, 199, 89, 51, 72, 82, 248, 175, 171, 225, 219, 94, 253}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 189, 153, 200}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 6, 196, 255, 169, 49, 227}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 253, 5, 179, 20, 213, 138, 107, 122}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 126, 254, 23, 115, 158, 29, 175, 124}, 192},
	{{161, 64, 0, 0, 208, 22, 97, 180, 165, 34, 6, 146, 90, 28, 56, 76}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{161, 64, 57, 141, 197, 76, 188, 106, 232, 19, 225, 31, 236, 240, 147, 171}, 192},
	{{161, 64, 0, 0, 0, 0, 70, 171, 78, 237, 49, 145, 83, 162, 6, 145}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 76, 166, 173, 183, 205, 79, 169}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 207, 236, 49, 139, 204, 5, 72, 208, 160}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 37, 144, 179, 175, 91, 11, 219, 46}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 214, 180, 117, 62}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 214, 223}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 243, 25, 148, 110, 202, 130}, 192},
	{{161, 64, 152, 107, 165, 87, 89, 92, 82, 218, 181, 148, 214, 184, 96, 39}, 192},
	{{161, 64, 0, 0, 0, 221, 203, 216, 61, 144, 105, 248, 190, 251, 76, 30}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 172, 174, 192, 152, 127, 155, 18, 249}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 121, 1, 79, 7, 160, 132, 94, 62, 86}, 192},
	{{161, 64, 0, 0, 0, 0, 2, 10, 149, 63, 194, 108, 15, 56, 164, 186}, 192},
	{{161, 64, 0, 17, 206, 140, 160, 184, 2, 134, 181, 126, 218, 208, 81, 54}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 128, 220, 233, 46, 179, 249, 125, 7, 61}, 192},
	{{161, 64, 0, 185, 12, 186, 190, 18, 230, 93, 84, 184, 195, 113, 32, 197}, 192},
	{{161, 64, 0, 7, 65, 100, 155, 38, 220, 34, 118, 139, 46, 103, 192, 30}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 153, 40, 201, 135}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 194}, 192},
	{{161, 64, 0, 0, 0, 0, 122, 163, 150, 106, 120, 109, 62, 103, 202, 230}, 192},
	{{161, 64, 199, 130, 48, 70, 233, 92, 106, 65, 66, 203, 17, 172, 20, 69}, 192},
	{{161, 64, 91, 119, 36, 135, 1, 193, 95, 144, 179, 88, 96, 62, 204, 247}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 116, 224, 18, 104, 0, 209}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 240, 104, 224, 107, 188, 82, 184, 231, 158}, 192},
	{{161, 64, 0, 0, 0, 149, 60, 42, 13, 171, 107, 77, 235, 6, 52, 119}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 48, 110, 122, 183, 71, 179, 6}, 192},
	{{161, 64, 0, 0, 0, 214, 235, 35, 21, 171, 117, 47, 197, 224, 127, 27}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 150, 248, 173, 195, 88, 107, 176, 60}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 172}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 196, 67, 39, 146, 131, 52}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 123, 107, 79}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189, 63}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 192, 39, 101, 173, 146, 146, 144, 84, 197}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 112, 46, 229, 75, 15, 158}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 46, 131, 222, 173, 22, 229, 96, 82, 216}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 147, 232, 110, 4, 126, 113, 135, 137}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 93, 227, 99, 39, 19, 118, 23, 244, 36}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 95, 209, 63, 210, 195, 82, 16, 142}, 192},
	{{161, 64, 0, 0, 0, 0, 226, 22, 131, 197, 136, 62, 64, 140, 99, 167}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 185, 215, 157, 223, 212, 225, 37, 216, 13}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{161, 64, 0, 0, 0, 0, 26, 189, 85, 178, 134, 90, 182, 45, 81, 135}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 185, 245, 188, 102, 207, 160, 42, 137, 40}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 51, 168, 203, 48, 82, 34, 3, 53}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 205, 199, 173, 83, 8, 150, 99, 151, 76}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 252, 63, 159, 134, 155, 77}, 192},
	{{161, 64, 0, 0, 106, 255, 227, 103, 32, 86, 183, 148, 219, 40, 67, 231}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{161, 64, 0, 0, 0, 0, 134, 192, 15, 39, 1, 218, 86, 27, 110, 202}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 169, 23, 102, 107, 51, 80, 115, 101, 181}, 192},
	{{161, 64, 0, 0, 196, 213, 19, 117, 58, 193, 5, 76, 121, 218, 183, 29}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 140, 166}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 73, 51, 16, 44, 141, 55}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 156, 95, 206, 2, 241, 117, 195, 157}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 232, 15, 206, 203, 220, 28, 153, 155}, 192},
	{{161, 64, 0, 0, 135, 192, 225, 81, 141, 195, 39, 169, 135, 158, 239, 166}, 192},
	{{161, 64, 65, 241, 45, 65, 17, 43, 183, 25, 180, 50, 31, 5, 9, 157}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 223, 109}, 192},
	{{161, 64, 130, 174, 108, 176, 186, 212, 126, 177, 62, 189, 32, 210, 20, 128}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 220, 7, 50, 76, 3, 5, 199}, 192},
	{{161, 64, 0, 0, 48, 58, 25, 47, 49, 200, 68, 242, 141, 147, 176, 251}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 37, 230, 70, 162, 214, 20, 245, 114}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 132, 242, 67, 65, 94, 21}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 26, 88, 233, 23}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 209, 100, 65, 86, 123, 35, 100, 91}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 155, 181, 108, 186}, 192},
	{{161, 64, 0, 0, 0, 209, 228, 115, 163, 106, 247, 69, 168, 5, 229, 117}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 56, 145, 10, 205}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 235, 17, 153, 1, 208, 252, 243, 176, 27}, 192},
	{{161, 64, 0, 0, 80, 215, 226, 117, 245, 95, 31, 86, 40, 227, 251, 46}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 52, 174, 50, 114, 232, 158}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 192, 164, 27, 117, 17, 145, 250, 116, 164}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 54, 254, 127, 70, 188, 89, 222, 246}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 98, 124, 187, 245}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 79, 144, 6, 82, 216, 225, 30, 217, 201}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 103, 244, 31, 53, 229, 252, 208, 52}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 192},
	{{161, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109, 150, 101, 134, 54}, 192},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 186, 180, 109, 253, 0, 175}, 185},
	{{233, 70, 240, 45, 240, 0, 171, 165, 209, 153, 249, 75, 218, 42, 159, 172}, 185},
	{{233, 70, 240, 45, 240, 90, 177, 199, 128, 30, 55, 223, 68, 175, 118, 26}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 185, 99, 22, 50, 106, 204, 51, 124}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 158}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 62, 151, 162, 52}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 204, 198, 116, 22, 210, 182}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 184, 234, 131, 189, 6, 199, 125, 52, 147}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 238, 230, 67}, 185},
	{{233, 70, 240, 45, 240, 0, 246, 27, 109, 225, 36, 83, 195, 12, 217, 165}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 122, 182, 29}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 88, 23, 15, 185, 162, 210}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 9, 227, 181, 60, 73, 234, 150}, 185},
	{{233, 70, 240, 45, 240, 0, 163, 100, 134, 236, 171, 227, 2, 18, 66, 212}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 236, 182, 160, 20, 25, 239, 92, 217, 132}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 37, 68, 209, 162, 246, 154}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 27, 227, 22, 253}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 23}, 185},
	{{233, 70, 240, 45, 240, 0, 133, 145, 24, 20, 188, 104, 174, 77, 69, 152}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 48, 248, 180}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182}, 185},
	{{233, 70, 240, 45, 240, 0, 34, 24, 174, 52, 25, 53, 144, 210, 233, 184}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 78, 246, 12, 147, 200, 219, 56, 52}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 160, 85, 80, 141, 127, 168, 111, 65}, 185},
	{{233, 70, 240, 45, 240, 49, 7, 159, 71, 4, 71, 33, 105, 71, 169, 3}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 222, 40}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 178, 212, 249, 123, 148, 251, 152}, 185},
	{{233, 70, 240, 45, 240, 165, 121, 37, 69, 119, 87, 47, 164, 118, 169, 125}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 97, 191, 148, 99, 186, 124, 70, 75}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 64, 165, 69}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 125, 219, 45, 83}, 185},
	{{233, 70, 240, 45, 240, 0, 74, 5, 171, 101, 64, 168, 44, 235, 115, 42}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 237, 89}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 184, 54, 130, 72, 199, 223, 57, 95}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 149, 150, 255, 103}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 5, 219, 22, 162, 236, 112, 185}, 185},
	{{233, 70, 240, 45, 240, 0, 43, 37, 149, 153, 223, 151, 159, 20, 229, 201}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 135, 148, 202, 56, 191}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 197, 46, 75, 254, 141, 181, 36, 48}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 126, 37, 253, 36, 80}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 118, 208}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 11, 64, 37, 64, 34, 0, 20}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 247, 61, 101, 71, 37, 10, 146, 127, 0}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 136, 218}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 7, 122, 253, 174, 119}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 100, 172, 197, 107, 249, 190, 194, 127}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 190, 226, 57, 164, 109, 158, 7, 197, 217}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 235, 67, 77, 92, 200}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 231}, 185},
	{{233, 70, 240, 45, 240, 0, 63, 123, 60, 86, 40, 101, 52, 22, 33, 247}, 185},
	{{233, 70, 240, 45, 240, 0, 24, 134, 255, 9, 133, 181, 77, 144, 80, 5}, 185},
	{{233, 70, 240, 45, 240, 0, 108, 56, 188, 179, 185, 189, 85, 20, 194, 67}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 42, 83, 137, 11, 255, 192, 80, 145}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 101, 149, 8, 193, 14, 189, 157}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 95, 218, 29, 122, 95, 194, 197, 9, 224}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 197, 117, 184, 138}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 131, 124, 154, 195, 23}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 188}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 143, 145, 237, 197, 179, 84, 16}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 12, 42, 255, 235, 20, 254}, 185},
	{{233, 70, 240, 45, 240, 0, 255, 121, 185, 66, 31, 34, 47, 232, 136, 75}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 217, 248, 3, 35, 136, 180, 120}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 109, 202, 246}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212, 8}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 28}, 185},
	{{233, 70, 240, 45, 240, 0, 133, 175, 104, 44, 199, 53, 230, 6, 167, 228}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 129, 170, 84, 100, 177, 250, 164}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 176, 139, 202, 115, 144, 157, 190, 248}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 13, 189, 213, 130, 175, 59, 198}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 160, 56, 244, 230, 138}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 153, 214, 223, 188, 253, 50, 42, 118, 1}, 185},
	{{233, 70, 240, 45, 240, 185, 180, 230, 26, 188, 195, 73, 215, 203, 197, 251}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 185},
	{{233, 70, 240, 45, 240, 0, 65, 131, 80, 32, 96, 210, 8, 206, 198, 190}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 108, 67, 188, 229, 127, 64, 42}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 211, 227, 82, 133, 134}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 34, 164, 156, 0, 19, 135, 163}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 244, 236, 28, 130, 25, 189, 36, 6}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 184, 28, 55, 244, 196, 236}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 228, 118, 61, 115, 230, 52}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 203, 193, 241, 224, 28, 47, 244}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 105, 209, 165, 163}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 59, 185, 144, 251, 244, 204, 228}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 39, 228, 31, 193, 179, 224, 148, 169}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 179, 56}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 0, 0, 0, 171, 25, 157}, 185},
	{{233, 70, 240, 45, 240, 0, 0, 0, 0, 0, 81, 50, 144, 159, 51, 63}, 185},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 204, 247, 138}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 45, 98, 24, 52, 43, 50, 216, 70}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 160}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 19, 176}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 170, 27, 158, 32, 63, 2, 73}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 134, 72, 165, 17, 137, 36, 108}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 243, 228, 196, 249}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 113, 182, 58}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 60, 86, 128, 29, 252}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 32, 26, 68, 137}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 121, 66, 5}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 43, 112}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 85, 90, 70, 53, 197}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 231, 51, 119, 32, 175}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 150}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 67, 37, 78, 71}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 109, 8, 113, 171, 147, 47, 192, 122}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 4, 29, 209}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 121, 26, 49, 237, 52, 176, 19, 22}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 115, 43, 105}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 201, 181, 232, 171, 188, 40, 105, 2}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 139, 43, 3, 112, 57}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 238, 21, 34, 75, 117}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 205, 13, 119}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 158, 177, 97, 114, 217, 34}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 88}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 115, 20}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 157}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 239}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 142, 178, 60, 144, 43, 153, 248, 225}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 21, 244, 48, 76, 114}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 139, 198, 212}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 78, 128}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 160, 238}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 187, 152, 10, 113, 120, 63, 88, 78}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 175, 115, 65, 85, 242, 50, 80, 81}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 166, 159, 13, 145, 124, 212}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 233, 131, 252, 151, 129, 11}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 90, 127, 161, 37}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 220, 16, 46, 5, 194, 223}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 210, 51, 79, 21, 90, 217, 142}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 71}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 197, 191, 61, 226}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 124, 158, 85, 199, 214, 49, 29, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 237, 147, 204, 149, 152}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 40, 149, 105, 246, 133, 65, 33}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 153, 101, 122, 146, 198, 65}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 168, 59, 193, 125}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 23, 40}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 176}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 188, 208, 252}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 16}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 247, 93}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 167, 53, 94, 52, 28, 226, 207}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 102, 76, 204, 79, 54, 199, 107, 226}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 164}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 201, 145, 32, 40}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 219, 125, 251, 255}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 225, 6, 208, 158, 248, 196, 39}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 10, 104, 241, 180, 136, 154, 56, 169}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 149}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 77, 6, 202, 38}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 253, 162, 91, 86, 144}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 218, 148, 106}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 198, 171, 70, 210, 135, 210, 245}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 7, 72, 177, 249, 145, 139}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 181, 103, 35}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 190, 254, 143}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 20, 95, 253, 89, 75, 207}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 208, 144, 79, 7}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 164, 235, 173, 8, 7}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 55, 206, 230, 196}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 23}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 27}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 111, 215, 189}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 217, 72, 3, 191, 172, 31, 73}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 104, 202, 66, 180, 13}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 153, 190, 195, 70, 162, 159}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 207, 237, 215, 32, 89, 69}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 154, 89, 150}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 0}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 84, 36, 130, 193, 45, 168}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 0, 0, 0, 0, 0, 21}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 86, 153, 69, 23, 123, 204, 82}, 51},
	{{28, 123, 31, 176, 235, 229, 169, 192, 0, 0, 169, 45, 236, 42, 50, 187}, 51},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 63, 118, 46, 92, 95, 223}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 89, 38, 88, 33, 153, 183, 219, 203}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 158, 55}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 25, 10, 135, 21, 210, 65, 15}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 83, 124, 228, 4}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 101, 10, 200, 58, 5, 232, 103}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 143, 130, 246, 12, 202, 41, 15, 173}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 230, 171, 219, 231, 16}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 36, 13, 120, 235, 153, 185, 42, 98}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 132}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 166, 13, 119}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 210, 17, 197, 215, 172, 252, 219, 84}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 148, 216, 14, 129, 122, 229, 245, 249}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 213, 199, 81, 207, 106, 89, 59, 97}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 13, 152, 255}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 116, 255, 80, 123, 190, 233}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 39, 190, 103}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 89, 94, 178, 169, 16, 69, 200, 78, 84}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 92, 189, 107, 106, 142, 198, 112}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 101}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 160, 43, 102}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 132, 44, 204, 152, 12, 180}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 32}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 68, 99, 127}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 40, 29, 75, 194, 7, 188, 231}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 133}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 156, 154, 149}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 65, 182}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 74, 26, 175}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 92}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 244, 151, 77, 10, 135, 88, 154, 117, 209}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 129, 174, 155, 76, 243, 186, 182, 120}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 81, 26}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 45, 131, 55, 115, 163, 185, 204}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 69, 28, 251, 133, 120}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 3, 213, 145, 181, 188, 238, 30}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 203, 84, 156, 234, 30, 48, 132, 189}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 233, 81, 0, 234, 221}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 222, 9, 25, 177, 143, 5}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 146, 126, 110, 164, 53, 30, 86, 230}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 248, 177, 139, 204, 155, 243, 122}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 1, 73, 204, 118, 254, 73, 226}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 171, 164}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 101, 103, 144}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 199, 182, 71, 131, 40, 172, 197, 247}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 153, 157, 48, 201, 147, 130}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 163, 46}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 96, 35, 124, 76, 183, 216, 199, 192}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 203, 152, 175, 230, 54, 251, 127, 139}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 161, 222, 130, 208, 73, 115, 238, 40}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 215, 221, 14, 57}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 174, 4, 45, 133, 150, 113}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 75, 49}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 215}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 221, 123}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 161, 107}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 164, 71, 220, 111, 150}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 182, 64, 44, 102, 43, 224, 79}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 186, 33, 36, 152}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 208, 93, 20, 143, 221}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 169}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 189, 217, 229, 62, 111}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 231, 68, 197, 63, 38, 228, 85}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 74, 36, 104, 80, 223, 151, 55}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 242}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 140}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 56, 167}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 61, 138, 107, 198, 30, 147, 3}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 44, 245, 224, 73, 156, 40, 189, 180}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 97}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 150, 146, 106, 123, 67, 38, 169, 117}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 74, 152, 107, 155, 173, 236}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 241, 199, 70, 38}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 222, 40, 123, 253}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 85, 207}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 146, 62, 167, 50, 116, 99, 184, 46, 222}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 141, 226, 99, 77, 219, 16, 118, 185}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 175, 200, 70, 217, 155}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 136, 169, 180, 23}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 243}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 59, 56, 49, 230, 176, 192, 2}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 36}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 239, 244, 185, 211, 164, 143, 16}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 114, 159, 103, 28, 75}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 83, 178, 136}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 88}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 93},
	{{146, 197, 243, 235, 243, 56, 140, 0, 0, 223, 72, 39, 167, 29, 7, 56}, 93},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 249, 214, 246, 97, 116, 193}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 233}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 80, 189, 18, 98, 134}, 61},
	{{0, 0, 0, 0, 127, 61, 140, 86, 77, 116, 180, 161, 17, 200, 185, 121}, 61},
	{{0, 0, 0, 68, 56, 51, 110, 19, 147, 155, 98, 247, 247, 190, 91, 150}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 80, 87, 234}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 242, 7}, 61},
	{{0, 0, 0, 0, 0, 0, 143, 169, 140, 106, 85, 182, 86, 99, 242, 30}, 61},
	{{0, 0, 0, 0, 56, 100, 212, 144, 149, 230, 252, 46, 249, 229, 194, 106}, 61},
	{{0, 0, 65, 185, 248, 229, 119, 62, 208, 72, 18, 202, 127, 92, 4, 217}, 61},
	{{0, 0, 0, 0, 0, 0, 255, 142, 105, 12, 154, 105, 234, 61, 53, 223}, 61},
	{{0, 0, 0, 0, 76, 148, 115, 229, 118, 108, 58, 44, 74, 34, 211, 237}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 221, 204}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 216, 146, 92}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 132, 147, 5}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 233, 74, 250, 149, 15}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 124, 152, 131, 65}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 6, 100, 60, 75, 139, 88, 183, 194, 43, 101, 110, 140}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 211, 34, 10, 17, 140, 179}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 57, 72, 19, 162}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 60, 210}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 83, 11, 225, 93, 187, 112, 133, 31}, 61},
	{{0, 0, 0, 0, 0, 0, 198, 248, 211, 253, 255, 33, 170, 145, 28, 23}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 89, 250, 120, 7, 115, 193}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 189}, 61},
	{{0, 0, 123, 27, 198, 2, 180, 222, 173, 234, 15, 67, 163, 152, 88, 41}, 61},
	{{0, 20, 219, 171, 21, 217, 145, 214, 88, 189, 4, 67, 26, 193, 78, 68}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163, 112, 3, 50, 144}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 40, 224, 130, 246, 20, 41, 97, 28, 113}, 61},
	{{0, 0, 0, 0, 0, 0, 185, 225, 120, 86, 62, 239, 114, 204, 12, 94}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 187, 150, 58, 86, 122, 223, 119, 56, 181, 62, 82, 53}, 61},
	{{0, 0, 0, 0, 0, 221, 137, 181, 159, 125, 220, 202, 175, 211, 135, 28}, 61},
	{{0, 0, 0, 0, 0, 149, 232, 17, 81, 245, 86, 159, 167, 64, 111, 79}, 61},
	{{0, 0, 0, 38, 111, 234, 117, 17, 91, 252, 185, 88, 185, 166, 187, 3}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 120, 186, 79, 240, 151, 1, 181, 140, 18}, 61},
	{{0, 0, 0, 33, 236, 44, 246, 33, 124, 147, 187, 84, 88, 226, 87, 128}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 194}, 61},
	{{0, 0, 0, 0, 45, 61, 209, 64, 110, 238, 178, 252, 186, 139, 216, 118}, 61},
	{{0, 0, 0, 191, 225, 124, 185, 175, 22, 54, 26, 221, 245, 80, 112, 120}, 61},
	{{0, 0, 0, 0, 202, 93, 221, 81, 53, 16, 104, 226, 26, 247, 215, 139}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 95, 208, 130, 38, 198, 72, 194, 44}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102}, 61},
	{{0, 228, 44, 63, 196, 51, 97, 70, 20, 177, 54, 82, 163, 130, 73, 185}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 0, 251, 4, 223, 5, 10}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 209, 101, 4, 62, 234, 86, 7}, 61},
	{{0, 0, 0, 0, 191, 79, 85, 57, 188, 171, 227, 116, 3, 45, 46, 104}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 87, 8, 160, 46, 204, 199, 104}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 194, 110, 223, 63}, 61},
	{{0, 80, 148, 166, 30, 230, 205, 38, 29, 118, 70, 199, 28, 165, 8, 5}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 236, 166, 94, 249, 107, 64}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 203, 172, 63}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 155, 134, 245, 247, 91, 16, 101, 108, 206}, 61},
	{{0, 0, 0, 0, 0, 238, 243, 55, 2, 240, 22, 38, 34, 2, 3, 180}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216, 168, 87, 237}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 19}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 128, 78, 205, 42, 128, 89}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 16, 193}, 61},
	{{0, 0, 0, 0, 0, 0, 65, 51, 251, 54, 74, 130, 101, 130, 210, 209}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 87, 138, 146, 63, 227, 230, 107, 23, 15}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 194, 132, 107, 53, 177, 249}, 61},
	{{0, 0, 196, 97, 3, 83, 16, 122, 155, 136, 68, 140, 86, 26, 178, 244}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 70, 224, 119, 127, 186}, 61},
	{{0, 0, 0, 0, 0, 0, 27, 25, 73, 174, 102, 232, 49, 222, 144, 188}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 9, 74, 50, 194, 26}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65}, 61},
	{{0, 3, 89, 198, 185, 155, 183, 216, 131, 160, 27, 69, 75, 58, 220, 144}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 66, 146, 149, 71, 194, 226, 242, 41, 178}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 22, 33, 109}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 181, 170, 61, 86, 138, 90}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27}, 61},
	{{0, 0, 0, 0, 14, 84, 249, 156, 104, 198, 242, 153, 240, 94, 196, 174}, 61},
	{{0, 0, 0, 0, 172, 84, 217, 244, 166, 42, 101, 254, 32, 35, 117, 131}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 212, 41}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 91, 111, 179, 6, 79, 110}, 61},
	{{0, 0, 0, 147, 150, 139, 72, 137, 227, 96, 140, 229, 104, 83, 111, 145}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 216, 154}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 24}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 117, 69, 82, 111, 53, 201, 8, 129}, 61},
	{{0, 0, 0, 0, 0, 71, 77, 199, 55, 50, 36, 40, 221, 31, 139, 174}, 61},
	{{0, 0, 60, 2, 118, 83, 202, 232, 196, 110, 153, 26, 147, 209, 60, 139}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 254, 133, 69, 113, 10, 105, 252}, 61},
	{{0, 0, 0, 0, 103, 221, 104, 20, 142, 15, 112, 40, 235, 83, 19, 189}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 0, 145, 37, 33, 51, 25, 47, 0, 205, 155, 124}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 65, 114, 123, 231, 136, 216, 36, 3}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 134, 158, 247, 241, 244, 237, 47, 112}, 61},
	{{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 61},
	{{0, 0, 0, 0, 0, 59, 77, 85, 181, 121, 29, 16, 71, 31, 70, 155}, 61},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 231, 220}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 134, 219}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 185}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 130, 15, 46, 153, 202, 118}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 133, 90, 231, 204, 198}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 134, 48, 24}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 71, 172, 170}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 217}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 88}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 188, 71, 187, 122, 199}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 247, 70, 240, 91, 81}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 134, 163, 26, 8, 73}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 97, 183, 44}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 175, 164, 103}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 34, 9, 98, 108}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 221, 88, 192, 240, 84, 50}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 189, 13}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 126, 34, 47}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 44, 148, 111, 64, 166, 239}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 93, 212, 111}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 180, 186, 167, 173, 229, 156}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 112, 192, 7, 212, 95}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 195, 27}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 132, 12}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 187, 94, 250, 141, 211}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 166, 14, 94, 56, 83, 111}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 95, 4, 120, 245, 93, 81}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 248, 78, 107, 245, 18}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 185, 109, 62, 167, 38}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 183}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 210, 94}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 251, 101, 27, 161}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 33, 49}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 175, 195, 203}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 171, 147, 205}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 140}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 115, 207, 203, 38, 201, 193}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 155, 242, 107}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 159, 4, 241, 204, 22, 218}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 2, 219, 126, 147, 105}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 119, 214, 116, 185}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 148, 238, 20, 63, 3}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 4, 66, 101, 21, 103, 10}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 98, 107, 16, 226, 231}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 24}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 107, 81, 81, 107}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 181, 179, 203, 72, 138}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 42}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 59, 101, 173, 58}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 98, 193, 242}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 114, 72}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 61, 61, 48}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 102, 91, 248, 131, 19, 96}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 132, 165, 194, 148, 18}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 83, 139, 201, 115, 130}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 25, 91, 131, 168}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 3}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 24, 16, 143, 100, 18, 172}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 151, 2, 145, 149}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 227, 23}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 76}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 99, 129, 18}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 12}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 191, 92, 162, 150}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 21, 141, 52, 48}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 176, 162, 188, 226, 204}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 56, 116, 182, 69, 58}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 254, 61, 212, 0, 146}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 122, 87, 252, 140, 49, 6}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 11, 200, 203, 99, 29, 12}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 138, 127, 34}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 215, 30}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 59, 167, 181}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 162}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 73, 3, 1}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 223}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 0}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 199}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 168, 10, 219, 1, 30}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 156}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 0, 0, 57}, 189},
	{{141, 92, 13, 27, 87, 241, 171, 143, 220, 0, 0, 0, 0, 82, 134, 105}, 189},
	{{164, 151, 192, 0, 218, 0, 146, 211, 35, 160, 218, 204, 62, 131, 38, 104}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 95, 165, 208, 211, 187, 169}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 49, 155, 185, 13, 174, 17, 251}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 140, 227}, 248},
	{{164, 151, 192, 0, 0, 0, 201, 246, 180, 254, 207, 158, 132, 105, 99, 123}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 43, 67, 85, 17, 223, 11, 26}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 138, 121, 33}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 232, 198, 101, 198, 232}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 160, 184, 232, 0, 187}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 193, 237, 4, 35, 138, 183, 42}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 180, 221}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 135, 82, 151, 88, 69, 23, 239, 6, 19}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 101, 217, 215, 4, 16, 42, 143, 198}, 248},
	{{164, 151, 192, 214, 234, 48, 52, 118, 245, 88, 46, 91, 151, 155, 54, 82}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 49, 195}, 248},
	{{164, 151, 192, 0, 0, 0, 21, 42, 119, 85, 43, 220, 83, 62, 117, 73}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 240, 147, 48}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 154, 53}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 33, 240, 168, 239, 140, 231, 180}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 179, 42, 136, 166, 32}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 171, 41, 54, 171, 218}, 248},
	{{164, 151, 192, 0, 48, 107, 30, 89, 42, 155, 246, 67, 177, 2, 89, 123}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 203, 120, 231, 153, 33, 60, 66, 137}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 89, 10, 135, 202, 84, 27, 232, 212, 221}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 235, 74, 41, 227, 188}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 205, 17, 117, 23, 140, 87, 40, 75}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 108, 38, 116, 225, 105, 134, 139, 221}, 248},
	{{164, 151, 192, 0, 0, 0, 194, 98, 214, 65, 218, 130, 205, 246, 53, 133}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 235, 140, 69, 35, 82, 122, 6, 246}, 248},
	{{164, 151, 192, 0, 0, 0, 11, 229, 222, 133, 4, 121, 63, 156, 218, 101}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 17, 130, 125, 145, 253, 29, 36, 100, 87}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 215, 230}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 189, 35, 236, 15, 85, 155, 122, 8, 121}, 248},
	{{164, 151, 192, 0, 0, 0, 85, 37, 71, 197, 211, 216, 251, 254, 89, 191}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 233, 174, 116, 168, 168, 206, 198}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 29, 192, 67, 225, 248, 72}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 140, 207, 253, 66, 48, 157, 129, 14}, 248},
	{{164, 151, 192, 0, 118, 30, 100, 208, 254, 29, 182, 110, 147, 163, 176, 248}, 248},
	{{164, 151, 192, 97, 111, 181, 250, 237, 254, 251, 193, 0, 160, 28, 82, 190}, 248},
	{{164, 151, 192, 0, 0, 87, 164, 122, 143, 172, 206, 48, 24, 253, 105, 178}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 249}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 47, 237, 15}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 248},
	{{164, 151, 192, 0, 0, 182, 101, 45, 224, 113, 51, 54, 31, 26, 43, 186}, 248},
	{{164, 151, 192, 0, 0, 0, 160, 72, 48, 79, 212, 212, 37, 145, 164, 235}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 228, 254, 190, 220, 199, 78, 200, 130}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 153, 64, 74}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 8, 22, 183, 182, 244}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 96, 157, 244, 46, 104, 141, 169, 157, 178}, 248},
	{{164, 151, 192, 0, 0, 186, 98, 199, 69, 167, 136, 209, 105, 68, 185, 221}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 106, 219, 30, 95, 229, 54}, 248},
	{{164, 151, 192, 0, 0, 0, 92, 188, 62, 187, 229, 234, 39, 73, 229, 33}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 31, 100, 246, 176, 81, 180}, 248},
	{{164, 151, 192, 194, 238, 109, 121, 129, 92, 131, 139, 238, 145, 6, 171, 98}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 78, 49, 65, 97, 92, 19}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 224, 217, 205, 155, 175, 45, 230, 105}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200, 168, 168}, 248},
	{{164, 151, 192, 0, 0, 176, 115, 215, 77, 91, 24, 28, 51, 195, 219, 242}, 248},
	{{164, 151, 192, 0, 0, 91, 215, 207, 224, 83, 53, 20, 169, 214, 251, 39}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 133, 212, 66, 53, 63}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 96, 140, 70, 197, 51, 215, 73}, 248},
	{{164, 151, 192, 0, 0, 0, 242, 81, 233, 123, 49, 77, 129, 9, 226, 179}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 184, 42, 133, 207, 72, 48, 150, 63, 36}, 248},
	{{164, 151, 192, 0, 0, 244, 71, 0, 101, 42, 142, 127, 190, 125, 104, 105}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 40}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 43, 87, 48, 62, 159, 28, 170}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 72, 153, 92, 3, 229}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 192, 189, 21, 167, 209, 34}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 162, 198, 182, 210, 236, 22}, 248},
	{{164, 151, 192, 0, 209, 158, 8, 163, 27, 19, 192, 234, 182, 122, 153, 146}, 248},
	{{164, 151, 192, 0, 0, 0, 237, 237, 171, 215, 5, 142, 99, 163, 36, 155}, 248},
	{{164, 151, 192, 0, 0, 0, 247, 171, 58, 75, 1, 105, 73, 168, 245, 239}, 248},
	{{164, 151, 192, 0, 205, 190, 9, 121, 109, 181, 213, 241, 83, 56, 209, 48}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 23, 233, 244, 0, 28, 164, 212, 16, 130}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 86, 13, 202, 5, 137, 91, 54}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 205, 217, 244, 128, 109, 196, 249, 1, 202}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 248},
	{{164, 151, 192, 0, 0, 35, 98, 212, 97, 81, 179, 158, 153, 199, 220, 97}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 130, 177, 136, 175, 224}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 5, 176, 63, 154, 21, 235, 171, 138, 223}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 244, 134, 12, 251, 235}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52, 176, 220}, 248},
	{{164, 151, 192, 0, 165, 220, 175, 1, 82, 4, 103, 232, 233, 62, 24, 221}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61, 42, 200}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 195, 101, 107, 76, 152, 40}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 157}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 3, 9, 73, 67, 247, 79, 230}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 164, 57, 128}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 186, 208, 189, 6, 169, 71, 84, 244}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 149, 53, 146, 108, 85, 7}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 109, 58, 228, 51, 103, 45, 219}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 248},
	{{164, 151, 192, 21, 40, 243, 32, 4, 180, 231, 195, 173, 9, 71, 101, 157}, 248},
	{{164, 151, 192, 0, 0, 0, 0, 0, 0, 0, 84, 62, 16, 12, 210, 40}, 248},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{35, 188, 248, 79, 39, 151, 232, 215, 248, 245, 185, 144, 78, 102, 173, 128}, 38},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 124, 87}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 94, 87, 164, 65}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 31, 226, 70, 119, 100}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 223, 122, 34, 30}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 31, 79, 20}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 59, 122, 35}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 22}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 99, 101, 80}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 96}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 107, 119, 62}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 81, 138, 8, 22, 35}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 148, 62, 194, 91}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 146, 30, 33, 136, 167, 183}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 11, 175, 75, 87, 27}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 191, 38, 217}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 172}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 179, 18, 79, 113, 122}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 99, 30, 16, 81}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 245, 71, 155, 86}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 40, 38, 131, 126, 55}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 23, 21}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 255}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 203, 103}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 55, 123, 219, 164}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 194, 144, 51, 89}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 112, 228, 114}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 47, 113, 82}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 157, 29, 116}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 223, 244, 235}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 252, 228}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 24}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 15, 128, 205, 183}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 152}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 5, 40, 168, 170}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 208, 167, 146, 187}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 226, 154, 174, 195, 55}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 102, 128, 203, 210, 75, 225}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 4, 248}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 64, 104, 205}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 241, 11, 253}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 42, 66, 111, 174, 210, 143}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 59, 125}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 38, 183, 76, 252, 197}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 226, 195, 88, 146, 241}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 59, 245}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 113, 216, 80, 205, 228}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 172, 125, 211, 45}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 198, 102}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 94}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 94, 90, 46, 159, 36}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 72, 10, 153, 99}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 182, 6}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 223, 206, 185}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 246, 39}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 254}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 62, 247, 80}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 29, 88}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 51, 114}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 60, 128, 136, 42}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 5, 180}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 179, 67, 114, 112}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 96, 10}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 208, 24, 151, 141, 181, 155}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 4, 15, 199, 234, 97}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 248, 242}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 12, 220}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 35, 22, 238}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 188, 244, 189, 172, 232, 57}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 27}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 102, 149, 161, 206}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 180, 84}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 64, 104, 239}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 235, 175, 60}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 50}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 110, 192, 119, 58, 224}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 0}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 106, 189, 75}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 0, 163}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 172, 176, 255}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 8, 74, 216, 130}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 50, 142, 38, 96, 248, 85}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 161, 229, 73, 107}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 216, 217, 238, 35}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 166, 33}, 167},
	{{193, 232, 166, 60, 62, 80, 230, 225, 165, 240, 0, 0, 0, 0, 197, 237}, 167},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 6, 30, 182}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 69, 49, 185, 199, 148, 46, 161, 66}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 97, 114, 153, 193, 6, 191, 112, 181}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 183, 12, 29, 86, 207, 26, 154}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 34, 174, 55, 125}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 116, 140, 99, 211, 7, 228, 143}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 198, 250, 3, 120, 88}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 81, 25, 255, 172, 108, 15}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 139, 92, 252, 131, 155, 251, 80}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 126}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 240, 68, 133, 9, 158, 177}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 254, 74, 77, 169, 24, 86, 106}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 135, 33, 67, 32, 210, 82}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 191, 241, 201, 99, 208, 111}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 223, 240, 228, 14, 127, 91}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 89, 28, 247, 36, 32, 100, 58}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 68, 105, 177, 208, 214, 147, 16, 101}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 70, 139, 202, 235, 34}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 220, 62, 86, 223, 145, 14, 174, 38}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 51, 128, 196, 5, 9, 40}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 104, 62}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 166, 174, 234, 55, 199, 189, 39, 201}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 170, 85, 66, 104, 103, 83, 89, 152}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 10, 122, 18, 125, 135, 144, 118, 11}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 96, 115, 108, 160, 107, 137}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 43, 131, 249, 197, 40, 23, 236, 123}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 181, 124, 212, 167, 20, 233, 204, 233}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 29, 105, 48}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 26, 141, 50, 84, 206, 203}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 86, 228, 44, 244}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 19, 53, 227, 95, 119, 227, 147, 51}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 138, 98, 107}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 242, 15, 81, 160, 122, 251, 202, 142}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 149, 169, 142, 149, 210, 140, 147, 235}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 123, 210, 118, 181, 72, 173, 84, 54, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 168, 172, 182, 247, 219}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 56, 162, 208, 19, 45, 98, 217, 178}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 34, 15, 104, 190, 219}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 155, 126}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 236, 159, 137}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 178}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 131, 21, 53, 164, 137, 248, 14}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 186, 199, 150}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 219, 36}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 25, 52, 94, 68, 37, 223, 255, 165, 99}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 90, 129, 244, 101, 142, 221, 169, 28, 242}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 180, 26, 141, 157, 151, 69, 15, 154}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 79, 32, 247, 219, 175}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 238, 213, 76, 88, 161, 66, 66, 174}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 110, 11, 12, 187, 80, 130, 98, 42, 131}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 118, 254}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 51, 123, 29, 85, 70, 207, 31, 127, 185}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 53, 239, 229, 233}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 177, 14}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 78, 17, 3, 230, 244}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 35, 193, 247, 205, 51, 107, 254, 88}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 111, 63, 92, 76, 9}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 28, 75, 59, 221, 15}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 101, 81}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 10, 100, 179, 55, 32, 159, 233, 193}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 98, 196, 185, 198, 185}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 117, 111, 195, 200, 198, 124}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 19, 38, 16}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 35, 89, 92, 116, 63, 105, 89, 221}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 222, 92, 81, 229}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 247, 19, 85, 0, 225, 169, 8, 26}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 183, 27, 230}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 34, 246, 181, 204, 39, 65, 22, 104}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 19, 135}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 243, 103, 201, 96, 89, 109, 69}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 40, 94, 109, 218, 96, 6, 253}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 67, 121, 30, 151, 34, 133, 49}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 0, 68, 190}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 171, 166, 167, 97, 99}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 18, 93, 242, 56, 236}, 28},
	{{109, 229, 118, 155, 43, 154, 0, 0, 0, 0, 0, 0, 0, 241, 41, 160}, 28},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{160, 62, 63, 212, 218, 138, 154, 108, 163, 127, 197, 237, 183, 44, 140, 192}, 37},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 109}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 78}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 246}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 106}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 6, 95}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 214, 59}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 131}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 76, 108}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 84, 163}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 231}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 176}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 201, 140}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 238}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 13, 36}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 168}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 234, 69}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 181}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 188}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 228}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 206, 29}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 200, 70}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 252, 147}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 244, 29}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 137}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 69}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 93}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 199}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 71}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 182, 8}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 195}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 63, 106}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 219, 243}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 38}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 133}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 133, 189}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 103, 11}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 18}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 130, 5}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 125, 9}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 201, 98}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 101, 61}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 6}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 46, 217}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 169}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 250, 42}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 129, 22}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 56}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 190}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 22, 173}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 255, 179}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 34, 47}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 40, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 201}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 212}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 134}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 203}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 251, 154}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 134}, 234},
	{{196, 37, 51, 146, 26, 85, 53, 31, 216, 141, 52, 218, 153, 32, 0, 0}, 234},
	{{228, 128, 0, 0, 0, 0, 101, 17, 13, 15, 158, 73, 127, 81, 182, 253}, 70},
	{{228, 128, 0, 0, 44, 125, 69, 18, 108, 193, 115, 149, 117, 203, 133, 119}, 70},
	{{228, 128, 0, 77, 53, 132, 37, 50, 252, 156, 222, 88, 168, 211, 50, 87}, 70},
	{{228, 128, 0, 159, 189, 211, 251, 84, 62, 68, 95, 133, 83, 33, 228, 250}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 120, 141, 27}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35, 111, 140}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 57, 168, 54, 28, 68, 113, 120, 26, 63}, 70},
	{{228, 128, 0, 0, 0, 0, 43, 97, 6, 102, 248, 69, 112, 64, 13, 104}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 145, 244, 42, 65}, 70},
	{{228, 128, 0, 40, 219, 132, 22, 190, 43, 136, 211, 103, 243, 213, 25, 87}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 234, 86, 25, 196, 106, 107}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198, 192, 172, 17, 171}, 70},
	{{228, 128, 0, 0, 123, 5, 211, 243, 112, 162, 191, 105, 32, 111, 99, 210}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 210, 25, 243, 103, 23, 89, 153, 216, 179}, 70},
	{{228, 128, 0, 0, 125, 201, 209, 42, 6, 141, 15, 70, 177, 32, 194, 229}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 187, 90}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{228, 128, 207, 218, 131, 146, 12, 10, 97, 26, 37, 207, 250, 105, 203, 32}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{228, 128, 0, 152, 60, 66, 41, 183, 143, 198, 179, 227, 147, 184, 43, 216}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 62}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 31, 178, 107, 25}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 14, 72}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 217}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 248, 59, 173, 30, 133, 108, 187, 4}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171, 3}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 62, 215, 0, 247, 217, 158, 32, 108}, 70},
	{{228, 128, 0, 0, 90, 36, 63, 139, 123, 255, 255, 122, 49, 14, 219, 212}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 204, 2, 243, 187, 152, 170, 180}, 70},
	{{228, 128, 0, 0, 0, 27, 203, 151, 231, 50, 254, 112, 4, 118, 216, 233}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202, 254, 198}, 70},
	{{228, 128, 0, 0, 0, 0, 123, 87, 117, 162, 171, 29, 130, 163, 106, 140}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 167, 69, 93, 91, 245}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 54, 78, 153, 249, 229}, 70},
	{{228, 128, 225, 97, 174, 52, 16, 35, 68, 225, 32, 123, 142, 15, 130, 87}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 54, 34, 185, 90}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 246}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 173, 254}, 70},
	{{228, 128, 0, 253, 203, 191, 4, 112, 187, 224, 100, 76, 3, 197, 236, 53}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172, 93}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 64, 192, 141, 126, 148, 142, 106, 4, 230}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 157, 72}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 194}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 39, 164, 173, 23, 33, 182, 98}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 223, 242}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 72, 244, 124}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 73, 44, 249}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 98, 70, 229, 60, 66, 205, 47, 56, 241}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 124, 232, 11, 70, 78, 122, 151, 184}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 49, 208, 11, 49, 142, 59, 130, 77}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 204}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 96, 81, 155, 49, 29, 114, 219, 246}, 70},
	{{228, 128, 0, 0, 181, 203, 255, 186, 206, 220, 58, 100, 136, 76, 135, 67}, 70},
	{{228, 128, 0, 0, 0, 104, 145, 111, 41, 151, 10, 228, 52, 50, 221, 220}, 70},
	{{228, 128, 242, 140, 85, 45, 117, 179, 126, 82, 58, 140, 167, 8, 209, 222}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 116, 87, 73, 166, 254, 125}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 58, 63, 197, 103, 193}, 70},
	{{228, 128, 0, 0, 0, 105, 40, 244, 94, 112, 209, 239, 30, 107, 90, 12}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 195, 79, 120}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 165, 2, 182}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 70},
	{{228, 128, 0, 0, 0, 0, 233, 158, 140, 80, 10, 185, 146, 118, 228, 182}, 70},
	{{228, 128, 0, 0, 0, 77, 35, 221, 181, 99, 112, 76, 151, 28, 221, 143}, 70},
	{{228, 128, 217, 138, 226, 99, 22, 249, 34, 139, 220, 61, 229, 68, 30, 45}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 245}, 70},
	{{228, 128, 0, 0, 52, 199, 145, 196, 41, 29, 133, 188, 150, 28, 51, 45}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 171, 36, 228, 209, 26, 251}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 23, 197, 40, 40}, 70},
	{{228, 128, 103, 75, 50, 10, 227, 45, 148, 155, 0, 251, 135, 152, 217, 132}, 70},
	{{228, 128, 0, 0, 0, 42, 170, 255, 158, 229, 8, 66, 134, 41, 197, 238}, 70},
	{{228, 128, 33, 138, 209, 228, 131, 30, 50, 246, 113, 9, 161, 117, 168, 131}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 136, 131, 13, 58, 214, 93, 206, 176}, 70},
	{{228, 128, 0, 0, 0, 13, 193, 0, 183, 40, 235, 91, 38, 189, 67, 147}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 70, 147, 142, 169, 34, 128, 79, 163}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 182, 67}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19, 9, 226, 81}, 70},
	{{228, 128, 0, 0, 0, 0, 107, 56, 126, 203, 130, 212, 141, 94, 223, 11}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 93, 238}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 113, 12, 199, 240}, 70},
	{{228, 128, 0, 0, 133, 121, 235, 9, 232, 67, 166, 11, 129, 233, 26, 56}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 95, 54, 43, 104, 107, 71, 198, 162, 73}, 70},
	{{228, 128, 0, 0, 0, 15, 2, 130, 174, 11, 57, 161, 184, 72, 249, 6}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31, 119, 5, 10}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 84, 233, 12, 202, 208, 244, 193, 227, 247}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 253, 172, 41, 16}, 70},
	{{228, 128, 0, 81, 112, 68, 55, 158, 51, 1, 82, 49, 91, 85, 232, 144}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 32, 84, 222, 31, 233, 238}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 192, 82, 206}, 70},
	{{228, 128, 0, 0, 115, 222, 172, 24, 137, 203, 239, 157, 130, 210, 18, 135}, 70},
	{{228, 128, 215, 177, 101, 54, 191, 1, 115, 13, 87, 229, 162, 249, 89, 76}, 70},
	{{228, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46}, 70},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 242, 135}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 67}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 23}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 79}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 201}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 54, 72}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 123, 43}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 203}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 231}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 14}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 62}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 41}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 210}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 106, 222}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 43}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 162, 48}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 156}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 158}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 168}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 237}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 112, 3}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 44}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 5}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 169}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 250}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 239}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 255}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 175}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 110, 122}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 67, 141}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 13}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 44}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 97}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 64, 226}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 95}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 204}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 196, 47}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 142}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 65}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 139}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 184}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 148}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 155, 214}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 246}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 135, 152}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 214, 67}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 151}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 0}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 242, 145}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 81}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 34, 54}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 186, 214}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 212}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 79}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 162}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 39}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 38}, 50},
	{{154, 248, 20, 242, 154, 244, 63, 17, 121, 52, 70, 84, 118, 208, 0, 52}, 50},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 80}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 98, 75}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 220, 119}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 214, 242, 151, 99, 40}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 225, 239}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 11, 240}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 84}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 33, 74, 250, 31, 237, 191, 140, 38, 72}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 188, 83, 98}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 85}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 110, 21, 157}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 214, 202, 146, 191, 65}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 110, 122, 191, 208}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 131, 228, 84}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 82, 100, 162, 95}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 3, 181}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 247, 254, 20, 250, 120, 207, 44}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 24, 205, 127, 84, 165, 68, 96, 5}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 25, 195, 30, 203, 187}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 177, 82, 24}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 65, 226, 45, 53, 227, 252, 253, 136}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 39, 254, 206}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 54, 20, 186, 67, 188, 8}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 37, 5, 151, 93, 78, 60, 51}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 241, 14, 180, 86}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 86, 58}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 30, 90, 125, 124, 93}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 158, 79}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 225, 172, 78, 111, 177, 133, 195, 221}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 195, 117, 36, 44, 84, 45, 250, 193}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 222, 185, 148, 141, 189}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 58, 176, 249, 107, 37}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 208, 173, 213, 123, 70, 75, 168, 67}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 67, 241, 153}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 119, 211}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 23}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 233, 133, 56, 240, 117, 39, 39}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 186, 75, 231, 51, 135, 202, 85, 253}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 63, 13}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 243, 207, 77, 128, 224, 112, 147, 169, 3}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 112, 173, 119}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 222, 102, 10, 224}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 211, 183}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 143, 94, 77}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 155, 88, 244, 102, 183, 99, 130, 236, 102}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 154}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 91, 210, 95, 133, 84, 216, 10}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 103, 98}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 162, 195, 154, 57, 171, 180, 175, 96, 111}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 228, 216, 94, 3, 71}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 232, 166, 199, 34, 17, 58, 188}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 195}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 166, 130, 151, 243, 40}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 225, 17, 122, 72, 113, 45}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 36, 144, 24, 156, 7}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 227, 85, 109, 128, 136, 210}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 61, 199, 110, 20, 212, 156, 204}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 234}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 204}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 7, 92, 222, 0, 237, 67}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 242, 67, 76, 63}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 50, 59}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 162, 134}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 190, 133, 211, 220, 226}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 247, 7, 186, 53}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 194, 193, 116, 84, 230, 199, 102}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 255, 236}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 65, 48, 209, 205, 251, 70}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 82, 94, 134, 253, 107, 240}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 231, 78, 77}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 182, 156, 26}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 43, 125}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 1, 117, 91, 89}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 135, 218, 24}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 147, 40, 12, 189}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 244, 92, 175}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 19, 237, 230, 177, 44}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 28, 150, 130, 109, 78}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 78}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 110}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 174, 252, 143, 44, 127, 21, 134, 240}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 201, 127, 16, 214, 162, 218}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 137, 193, 169, 80, 39, 78, 100, 185}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 40, 111, 93, 255, 198, 2, 242, 233}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 64, 76, 118, 136, 77, 132}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 37, 173, 65, 246, 43, 126, 38, 73}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 110, 101, 90, 238, 56, 244, 48, 22, 164}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 70, 62, 19, 33}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 174, 47, 72, 102, 100, 104, 247, 251}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 0, 125}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 236, 233, 31, 75}, 171},
	{{41, 100, 27, 84, 106, 112, 96, 0, 0, 0, 0, 0, 0, 0, 23, 170}, 171},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 41}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 53}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 54}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 236}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 231}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 50}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 248}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 250}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 254}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 53}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 66}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 61}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 18}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 172}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 43}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 89}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 190}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 29}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 175}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 130}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 175}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 106}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 10}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 117}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 215}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 234}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 231}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 244}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 162}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 94}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 228}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 138}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 125}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 130}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 144}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 232}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 215}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 8}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 144}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 231}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 122}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 197}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 122}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 249}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 62}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 213}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 137}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 0}, 236},
	{{81, 99, 197, 139, 30, 150, 230, 216, 81, 190, 84, 165, 29, 64, 128, 254}, 236},
	{{112, 0, 0, 0, 0, 0, 0, 0, 159, 223, 148, 164, 106, 163, 39, 232}, 3},
	{{112, 35, 163, 101, 15, 51, 236, 88, 74, 47, 22, 153, 33, 28, 67, 234}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 241, 64}, 3},
	{{112, 0, 0, 141, 153, 9, 25, 190, 124, 196, 185, 236, 106, 88, 133, 122}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 92, 122}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 39, 248, 166, 107, 148, 184, 196}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223}, 3},
	{{112, 0, 0, 0, 138, 95, 11, 129, 31, 238, 230, 124, 108, 57, 160, 137}, 3},
	{{112, 0, 0, 38, 154, 25, 175, 183, 221, 212, 1, 89, 76, 245, 99, 239}, 3},
	{{112, 0, 0, 0, 0, 65, 17, 226, 161, 251, 227, 144, 234, 20, 42, 192}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 70, 81, 86, 210}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38}, 3},
	{{112, 0, 0, 0, 251, 87, 163, 125, 237, 43, 117, 144, 161, 0, 240, 111}, 3},
	{{112, 0, 0, 0, 0, 137, 152, 231, 120, 173, 119, 145, 221, 83, 27, 103}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 39, 32, 178}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 23, 148, 31, 164, 114, 35, 227, 134}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 5, 201, 247, 194, 223, 202, 144, 246, 218}, 3},
	{{112, 0, 0, 0, 0, 0, 170, 177, 141, 245, 123, 210, 225, 227, 235, 108}, 3},
	{{112, 0, 0, 52, 166, 57, 47, 50, 14, 171, 199, 49, 18, 231, 94, 2}, 3},
	{{112, 9, 166, 37, 84, 231, 24, 19, 144, 26, 142, 158, 26, 105, 32, 167}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 205, 20, 213, 33, 67, 128, 251}, 3},
	{{112, 0, 0, 0, 0, 0, 223, 217, 108, 145, 222, 86, 255, 193, 182, 88}, 3},
	{{112, 0, 0, 0, 0, 0, 72, 23, 202, 219, 29, 222, 73, 12, 2, 52}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 244, 5, 24, 147, 124, 18, 187, 232, 110}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 124, 214, 91, 85, 133, 160, 72, 70}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 85, 231}, 3},
	{{112, 0, 0, 0, 64, 169, 229, 122, 9, 62, 97, 157, 70, 240, 130, 153}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 94, 162, 150, 103}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 180, 223, 134}, 3},
	{{112, 0, 0, 0, 206, 36, 183, 224, 108, 25, 184, 122, 186, 89, 98, 55}, 3},
	{{112, 0, 0, 0, 0, 49, 168, 208, 135, 91, 213, 244, 142, 151, 153, 239}, 3},
	{{112, 0, 0, 201, 177, 184, 129, 87, 106, 46, 44, 141, 101, 211, 239, 107}, 3},
	{{112, 0, 165, 68, 37, 3, 73, 93, 235, 194, 185, 238, 19, 221, 164, 8}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 126, 102}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 150, 55, 105, 97, 245}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 102, 56, 193, 218, 67, 24, 38}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 239, 99, 103, 246}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 162, 72, 117, 45, 238, 19, 122}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 93, 27, 90, 27, 152, 207, 14, 14, 44}, 3},
	{{112, 0, 0, 252, 216, 244, 88, 92, 181, 198, 96, 141, 6, 161, 3, 159}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 250, 30, 171}, 3},
	{{112, 0, 0, 0, 0, 17, 127, 179, 211, 62, 168, 249, 170, 68, 72, 28}, 3},
	{{112, 0, 0, 0, 0, 0, 159, 42, 130, 92, 36, 115, 47, 198, 232, 42}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 237, 169}, 3},
	{{112, 0, 0, 0, 160, 120, 196, 63, 124, 147, 103, 46, 215, 171, 167, 245}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17, 161, 228, 125, 213}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 234, 152}, 3},
	{{112, 0, 0, 0, 36, 237, 56, 188, 249, 236, 164, 118, 143, 133, 232, 191}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 62, 49, 67, 137, 51, 159, 159}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 236, 199}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 221, 89, 27}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 95, 111, 117, 70}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 156, 108, 80, 68, 99, 132, 44, 218}, 3},
	{{112, 0, 0, 0, 102, 242, 1, 150, 30, 97, 42, 222, 34, 56, 157, 53}, 3},
	{{112, 0, 0, 0, 0, 150, 232, 30, 131, 253, 14, 145, 27, 29, 178, 28}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 211, 61}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 53, 158, 244, 141, 224, 72, 97, 144, 108}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 199, 104, 146, 123}, 3},
	{{112, 0, 0, 0, 0, 0, 239, 112, 160, 166, 243, 9, 81, 178, 111, 140}, 3},
	{{112, 0, 0, 0, 0, 168, 206, 188, 70, 26, 152, 93, 159, 177, 220, 142}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 109, 66, 215, 40}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 28, 36, 240, 230}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 218, 169, 46, 188}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41, 95, 42, 127}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156}, 3},
	{{112, 0, 48, 80, 2, 103, 159, 139, 190, 32, 21, 118, 7, 12, 17, 182}, 3},
	{{112, 0, 0, 188, 105, 151, 96, 211, 22, 139, 72, 81, 49, 219, 40, 180}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 63}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 141, 26, 129, 21}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 3},
	{{112, 0, 0, 0, 0, 0, 26, 35, 23, 218, 171, 155, 83, 213, 155, 177}, 3},
	{{112, 0, 0, 50, 162, 203, 25, 139, 161, 11, 127, 151, 22, 49, 215, 41}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 31, 187}, 3},
	{{112, 0, 0, 0, 36, 93, 167, 245, 65, 241, 249, 104, 126, 195, 52, 92}, 3},
	{{112, 0, 156, 94, 146, 48, 82, 95, 22, 144, 0, 154, 99, 111, 58, 203}, 3},
	{{112, 0, 0, 0, 0, 0, 170, 224, 185, 221, 195, 59, 96, 85, 242, 12}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 143, 154, 246}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 53, 105, 98, 154, 47, 41, 153}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 235, 82, 46}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 120, 232, 59, 163, 160, 164, 116, 113, 90}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 36, 222, 15, 226, 149, 218, 36, 101, 212}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 242, 6, 250, 184, 197, 60, 34, 7, 233}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 171, 89, 154, 200}, 3},
	{{112, 0, 0, 0, 0, 0, 108, 161, 150, 185, 36, 108, 252, 183, 1, 170}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 3},
	{{112, 0, 0, 203, 132, 179, 111, 217, 200, 26, 129, 90, 184, 189, 44, 8}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 3},
	{{112, 0, 0, 0, 0, 204, 213, 61, 178, 222, 189, 37, 15, 201, 82, 52}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 134, 200, 139, 34, 84, 18, 243}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 28, 61, 83, 61, 5}, 3},
	{{112, 0, 0, 0, 243, 10, 142, 240, 110, 16, 205, 220, 54, 240, 188, 174}, 3},
	{{112, 0, 0, 0, 0, 0, 0, 154, 124, 131, 71, 30, 220, 17, 179, 236}, 3},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 71, 40}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 85, 135, 212, 231}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 99, 76, 180, 98, 61}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 175, 19}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 249}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 98}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 249, 140, 131}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 138, 226}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 145, 28, 146}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 153}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 78, 213, 149, 137, 28}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 226}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 54, 132}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 209, 35, 147}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 63}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 78, 78, 179}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 192, 157}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 61, 186, 82}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 95}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 90, 127, 134}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 205}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 192, 76, 58, 140}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 164, 47, 12}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 111, 205}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 126}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 215, 160, 57}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 248, 98}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 222, 228}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 9, 164}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 14, 206, 236, 240}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 18}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 13, 48}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 65}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 154}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 7, 176, 38}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 222, 42, 42, 255, 28}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 251, 42, 80, 197, 80}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 129, 96}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 131, 48, 93}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 41, 10, 137, 129}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 57, 17, 179, 4}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 204, 191}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 46, 64, 31, 67, 113}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 137, 223}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 190, 26, 179, 131}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 60, 196, 246, 101}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 106, 23, 55}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 70, 63, 89, 106, 18}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 176, 141, 95, 212}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 77, 114}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 125, 202, 37, 143, 11}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 79, 114}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 2}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 244, 164, 199}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 90, 207}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 192, 12}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 73, 147, 255}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 235, 22}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 14, 70, 98, 41}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 205}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 104, 49, 90}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 28, 251}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 138, 16}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 131, 148, 107, 58}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 131, 253, 154, 83}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 157, 75, 79, 103}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 91, 187}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 63, 14, 103}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 5, 74}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 140, 233, 134, 79}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 76}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 10, 25}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 0}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 249, 96, 225}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 184, 163}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 150, 107, 160}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 150, 121, 254, 87}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 217}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 179}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 103, 23, 28, 95}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 171, 205}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 0, 240}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 100, 155}, 64},
	{{164, 119, 253, 126, 160, 249, 183, 191, 119, 111, 224, 0, 0, 0, 131, 79}, 64},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 180, 233}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 2}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 216}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 167}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 155}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 146}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 114}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 212, 1}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 106, 140}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 183, 225}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 227}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 223}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 24, 169}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 95, 167}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 130, 16}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 14, 41}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 54}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 151}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 138, 209}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 39, 104}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 250}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 38}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 246, 165}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 152}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 56}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 1, 191}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 59}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 189}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 147}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 162}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 191}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 151}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 251}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 254}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 181}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 143, 54}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 47}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 4, 32}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 105}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 46, 22}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 10}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 22, 175}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 177}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 237}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 32}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 22}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 198, 72}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 236}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 130, 28}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 211, 69}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 105}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 0, 0}, 213},
	{{138, 58, 198, 254, 0, 197, 60, 91, 132, 199, 181, 251, 78, 160, 29, 8}, 213},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 251}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 39, 72, 217, 153}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 200, 177, 231, 245, 203, 14}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 167, 56, 240, 228}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 86, 107}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 37, 238, 67, 162, 208, 191, 109, 108}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 156, 74, 232}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 154, 91, 186, 95, 238, 86, 153}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 48, 41, 213, 75}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 59, 27, 96}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 197}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 92, 127, 158, 206, 216}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 37, 196, 185}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 53, 174, 170, 176}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 65}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 20, 189, 15, 205, 38, 191, 247, 80}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 112, 0, 131, 96}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 11}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 47}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 117, 130, 90, 253, 101, 151}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 23, 138}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 152, 196, 208, 48, 73, 118}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 253, 203, 222, 69}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 12, 55}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 147, 252, 218, 231, 123, 192}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 161, 62, 195, 111, 44, 111}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 29, 28, 197, 222}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 87}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 236}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 6, 133, 27, 37, 57, 114, 77}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 208, 103, 119}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 147, 209, 247, 129, 198, 224}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 130, 213, 215, 22, 227, 250, 153, 78}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 171, 41, 190, 36, 101, 206}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 231, 74, 39, 61, 242, 208, 92, 91}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 194, 238, 229, 159}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 119, 32, 182, 250, 106, 127, 200, 45}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 73, 106, 198, 174, 102, 232, 46, 45}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 92, 65, 91}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 72, 145}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 70, 25, 187, 244, 116, 11, 254}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 77, 149, 74, 71, 147}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 18, 9, 181, 29, 138, 193}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 81}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 37, 67, 223, 28, 247, 218, 73, 222}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 48}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 117, 88, 58, 178}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 212, 49, 27, 31, 74}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 55}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 162, 86, 215}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 180, 232, 122, 141, 125, 126, 79}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 121, 14, 180, 215}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 158, 248, 72, 2, 165, 238}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 128, 200}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 69, 178, 22, 100, 33}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 36, 152, 106, 91, 82, 61, 16}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 165, 173, 230, 126, 98}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 118, 21, 239, 100}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 86, 6, 190}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 190}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 254, 15, 129, 164}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 46, 2}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 229}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 10, 133, 202, 32, 42, 189, 7, 114}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 32, 14, 21, 236, 108, 83, 162, 22, 127}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 250, 244, 170, 143, 172, 178}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 207, 163, 77, 21, 61, 3, 139, 3}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 174, 202, 119, 96, 208, 186, 204, 172}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 83, 104, 194, 191, 33, 60}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 213, 68, 34, 14, 11}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 13, 25, 116, 104, 167, 243}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 245, 39}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 25, 215, 167, 150}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 31, 62, 215, 0, 133, 72, 217, 47}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 247, 178, 198, 81, 99, 228}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 125, 204, 186, 254, 152, 58, 178, 6}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 177, 139, 17, 75, 77, 202, 249}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 229, 220, 109, 242, 41, 169, 226, 19}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 168, 12, 109}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 134}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 79, 205, 248, 114, 124, 213}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 136, 43, 198, 102}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 114, 145, 131, 202, 16, 79, 201}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 3, 138, 143, 110, 114, 176}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 0, 169, 46, 86}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 76, 111, 46, 152, 0, 255, 26}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 238, 235, 68, 138, 234}, 15},
	{{209, 89, 168, 236, 146, 169, 100, 0, 0, 0, 0, 0, 140, 122, 243, 177}, 15},
	{{131, 210, 208, 130, 83, 88, 132, 172, 174, 146, 179, 49, 231, 39, 95, 221}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 250, 198, 64, 136, 137, 161, 175, 46, 128}, 145},
	{{131, 210, 208, 0, 0, 0, 78, 132, 229, 201, 63, 240, 202, 116, 72, 214}, 145},
	{{131, 210, 208, 0, 0, 0, 77, 35, 229, 223, 140, 154, 125, 159, 212, 31}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 238, 61}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 58, 253, 40, 249, 169}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 195, 120, 115, 107}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 122, 139, 143, 51, 13, 207, 231, 18, 238}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 177, 141, 11, 147, 113}, 145},
	{{131, 210, 208, 0, 0, 47, 2, 56, 116, 15, 204, 221, 145, 196, 175, 115}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 147}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 215, 188, 68, 20, 104, 167, 189}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 181, 51, 104, 55, 168, 45}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 81, 125, 151, 0}, 145},
	{{131, 210, 208, 0, 0, 0, 152, 11, 159, 10, 174, 88, 16, 82, 16, 186}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 145},
	{{131, 210, 208, 0, 0, 0, 25, 70, 226, 47, 214, 203, 170, 141, 98, 64}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 25}, 145},
	{{131, 210, 208, 0, 0, 185, 204, 145, 0, 194, 34, 120, 42, 79, 6, 71}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 92, 220, 38, 189, 175, 170, 45}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 55, 89, 241, 156, 18}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 217, 231, 199}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 151, 248, 79}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 91}, 145},
	{{131, 210, 208, 13, 93, 27, 186, 19, 185, 81, 14, 214, 35, 201, 84, 129}, 145},
	{{131, 210, 208, 0, 0, 229, 103, 184, 43, 67, 194, 43, 199, 1, 100, 169}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 109, 156, 29, 56, 70, 73}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 107, 146, 223}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 173, 187, 45, 250, 230, 231, 3, 82, 93}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 227, 1, 192, 54}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 52, 155, 39}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 113, 117, 246}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 203, 18, 121}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 220, 94, 84}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 212}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 193, 198}, 145},
	{{131, 210, 208, 0, 232, 209, 94, 132, 236, 65, 122, 55, 175, 228, 252, 88}, 145},
	{{131, 210, 208, 0, 179, 26, 55, 53, 62, 226, 157, 204, 53, 231, 128, 169}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 228, 98, 5, 44, 190, 98, 4}, 145},
	{{131, 210, 208, 0, 22, 115, 177, 64, 110, 82, 198, 224, 241, 93, 6, 6}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 232, 191}, 145},
	{{131, 210, 208, 57, 234, 151, 208, 41, 197, 124, 119, 68, 92, 27, 23, 99}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 85, 230, 117, 16, 62, 113}, 145},
	{{131, 210, 208, 0, 55, 172, 36, 79, 68, 160, 149, 141, 228, 158, 189, 140}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 86, 139}, 145},
	{{131, 210, 208, 24, 226, 130, 197, 91, 199, 151, 77, 18, 115, 8, 167, 234}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 34, 204, 226, 168, 216, 211}, 145},
	{{131, 210, 208, 166, 124, 76, 68, 183, 228, 208, 137, 48, 184, 167, 213, 133}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 25, 12, 111, 49, 161}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 14, 7, 40}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 179, 17, 20, 192, 183, 18, 232}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 182, 250, 83, 136, 159, 52}, 145},
	{{131, 210, 208, 0, 0, 0, 55, 161, 136, 51, 94, 62, 194, 64, 124, 50}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 56}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 156, 69, 203, 198, 195, 92, 78}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 132, 33, 41, 38, 192}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 25, 135, 170, 39, 194, 182, 63}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 220, 210, 236, 79, 66, 246}, 145},
	{{131, 210, 208, 0, 129, 194, 240, 220, 151, 215, 46, 186, 214, 171, 217, 42}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 246, 68}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 154, 122, 209, 137, 150}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 146, 241, 161}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 120, 173, 2, 79, 81, 79, 229}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 239, 64, 175, 202, 119, 229, 106, 117, 127}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 231, 75, 178, 202, 237, 243, 170, 92, 194}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 143, 46, 158, 74, 87}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 101, 191, 110, 176, 233, 136, 112}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 24, 41, 29, 255, 105, 142}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 254, 43, 85, 45, 219, 110, 199, 195}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 145},
	{{131, 210, 208, 0, 0, 0, 214, 94, 163, 8, 162, 61, 82, 23, 234, 166}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 198}, 145},
	{{131, 210, 208, 0, 214, 190, 60, 74, 108, 252, 173, 107, 105, 254, 93, 230}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 51, 137, 216, 43, 139, 180, 126, 54, 4}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 251, 18, 111}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 170}, 145},
	{{131, 210, 208, 0, 0, 65, 221, 199, 24, 8, 220, 54, 185, 115, 160, 176}, 145},
	{{131, 210, 208, 164, 15, 78, 181, 21, 240, 159, 128, 10, 245, 42, 135, 189}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 55, 236, 105, 252, 226, 237, 250, 126}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 172}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 91, 110, 249, 210}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 13, 231, 219, 98, 250, 30, 208, 94, 62}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 189, 254, 220, 34, 202, 162, 156}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 202}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 158}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 30, 116, 2, 32, 66, 11}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 170, 88, 243, 45, 169, 94}, 145},
	{{131, 210, 208, 0, 0, 0, 0, 0, 0, 0, 0, 0, 108, 12, 173, 36}, 145},
	{{131, 210, 208, 0, 56, 25, 167, 108, 197, 33, 157, 5, 110, 237, 25, 15}, 145},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 215, 193, 29, 61, 5, 241}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 212, 236, 57, 103}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 227, 119, 51, 172, 13}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 11, 207, 31, 186, 211, 164, 91, 112}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 112, 47}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 46, 114}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 226, 208, 74, 0, 5, 12, 82, 190}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 229, 206, 137, 105, 58, 191, 17, 163}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 230, 172, 182, 234, 136, 43, 221}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 212, 177, 128, 157, 71, 68, 16}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 92, 147}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 150, 56, 22, 58, 9, 114}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 74, 87, 175, 121, 169, 254, 29}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 163, 46, 13, 119, 192, 110}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 35, 196, 154, 122, 92, 224, 246}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 128, 231, 42, 19, 157, 165, 6, 243}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 36, 168, 177, 169, 26}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 148}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 33, 181, 25, 113}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 115, 231, 135, 190, 211, 16, 97}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 27, 99, 100}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 138, 99, 87, 56, 128, 175}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 135, 11, 216}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 192, 30, 99, 206, 225}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 97, 151, 188, 171, 227, 60}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 220, 211, 249, 119, 112, 192}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 245, 138, 56, 15, 70, 191, 49, 150}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 221, 229, 17, 244, 161, 25, 76}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 24, 165, 21}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 99, 58, 10, 254, 238}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 102, 121, 111}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 49, 132, 222, 210, 5, 137, 112}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 49, 48}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 131, 179, 148, 139, 239, 120}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 42, 30, 174}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 50, 162, 95, 30, 53, 219, 254, 154}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 175}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 73, 128, 232, 227, 251}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 122, 161, 223, 171, 99, 205}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 10, 215, 252, 86, 120, 99}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 107, 232, 181, 126, 2, 247}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 19, 135, 96, 22, 243, 5, 187}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 172, 107, 113, 53, 23}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 40, 182, 187, 206, 246, 33, 81, 231}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 116, 139, 119, 75, 8, 161, 149}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 117}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 47, 82, 186, 199, 97, 31, 77}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 12, 79, 87}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 141, 156, 163, 32, 222, 109, 31}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 205, 185, 51}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 119, 31, 138, 201, 251, 105}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 18, 160, 146, 160, 219, 226}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 239, 31}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 207, 94, 253}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 144, 82, 63, 149, 254}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 197, 248, 10, 171}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 15, 101, 6, 192, 47, 78, 201}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 74, 33, 81, 198, 194, 103}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 115, 80, 142, 41, 139, 227}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 196, 239, 70}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 232, 138, 69, 127, 57}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 143, 63, 236, 165, 121, 190, 78, 103}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 37, 211, 46, 248, 12, 155, 118}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 112, 245, 0, 185, 101}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 59, 179, 138, 249, 223, 183}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 255, 247}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 218, 159, 189, 57, 78, 59, 132, 244}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 67, 0, 65, 141}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 235, 33, 130, 123, 129, 8, 207}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 61}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 164, 254, 200, 77, 25, 240, 91, 115}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 212, 143, 154, 85}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 224, 152, 209, 171, 217, 243}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 158, 155, 27, 227, 80}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 186, 238}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 169, 248}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 185, 38, 210, 118, 110, 240, 247, 131}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 109, 37, 240, 40, 142, 227, 171, 224}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 108}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 156, 234, 80}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 12, 24, 211, 183, 35, 208}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 91, 211, 159}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 57, 92, 182, 19, 212}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 87, 48, 31, 90, 13, 49, 134, 145}, 27},
	{{165, 190, 157, 7, 131, 5, 147, 0, 0, 0, 0, 0, 0, 0, 131, 17}, 27},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{179, 226, 57, 204, 187, 70, 52, 81, 119, 162, 229, 42, 47, 185, 9, 162}, 75},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{98, 235, 155, 51, 107, 167, 127, 137, 254, 246, 162, 171, 180, 13, 233, 0}, 76},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 210}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 48}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 140}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 85}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 117}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 221}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 71}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 12}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 11}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 137}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 139}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 15}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 55}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 28}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 222}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 224}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 177}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 12}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 207}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 236}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 102}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 69}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 253}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 54}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 174}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 163}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 151}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 43}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 56}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 50}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 180}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 207}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 65}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 138}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 241}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 109}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 247}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 172}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 58}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 218}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 39}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 48}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 0}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 150}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 28}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 28}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 112}, 247},
	{{107, 79, 76, 90, 94, 151, 155, 31, 33, 115, 19, 204, 98, 115, 0, 100}, 247},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 9, 48, 191}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 202, 4, 240, 49, 91}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 240, 49, 144}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 195, 205, 227, 73, 75, 126, 178}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 124, 107}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 119, 4, 135}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 161, 53, 131, 246, 145}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 221, 233, 225, 243}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 185, 66}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 54, 135, 199, 210, 250, 16, 184}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 88, 150, 130, 25, 94, 80, 9, 238, 64}, 121},
	{{143, 46, 30, 175, 224, 0, 249, 237, 99, 227, 161, 32, 178, 125, 76, 147}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 46, 188, 242, 10, 68, 187, 218, 170, 166}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 62, 85, 4, 145, 123, 63, 231}, 121},
	{{143, 46, 30, 175, 224, 0, 113, 22, 135, 183, 84, 108, 186, 242, 96, 89}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 72, 6, 169, 43}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 52, 209, 168, 50, 223, 143, 56, 244}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 229, 22, 85, 114, 49, 114}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 208}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 108, 210, 208, 63}, 121},
	{{143, 46, 30, 175, 224, 0, 164, 184, 178, 166, 90, 244, 71, 58, 26, 69}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 148, 63, 163, 222, 137, 95, 9}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 247, 241, 19, 131, 53, 176, 184, 53}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 227, 234, 191, 209, 44, 191, 114, 198}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 153}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 122, 232, 50, 109, 38, 242, 169, 195}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 157, 99, 243, 91, 159, 15, 61, 231}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50, 52}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 128, 179, 194, 207, 146, 33, 232}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 153, 21, 219, 44, 102, 228, 234, 149, 192}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 246, 43, 233, 195}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 237, 26, 80, 104, 55, 44, 31, 4, 226}, 121},
	{{143, 46, 30, 175, 224, 0, 188, 255, 116, 127, 139, 219, 187, 53, 116, 143}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 76, 104, 104, 232, 148, 223, 143, 77, 198}, 121},
	{{143, 46, 30, 175, 224, 0, 205, 165, 250, 70, 117, 187, 73, 178, 164, 195}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 13, 27, 207, 99, 170, 60}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 180, 90, 122, 212, 56, 63, 57}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 71, 116, 194, 181}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 20, 64, 21}, 121},
	{{143, 46, 30, 175, 224, 0, 11, 223, 38, 208, 176, 68, 238, 210, 134, 9}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 223, 254, 104, 171, 240, 22, 59, 89}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 250, 223, 32, 13, 144, 139, 62, 24}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 170, 44, 194, 146, 36, 222, 216}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 186, 205, 2, 239, 99, 150, 193, 175, 149}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 11, 148, 166}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 64, 156, 233, 228, 211, 164}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 248, 58, 170, 117, 213, 228, 152}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 93, 192, 230, 9, 52}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 145, 225, 200}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 194, 101, 171, 234, 140}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 227, 106, 86}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 171, 35, 58, 130, 23, 11, 1}, 121},
	{{143, 46, 30, 175, 224, 0, 179, 161, 229, 205, 242, 52, 203, 74, 222, 181}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 108, 164, 217, 183, 33, 238, 209, 54}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 118, 238, 194, 3, 173}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 177, 255, 20, 39, 186, 32, 20}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 24, 91, 24, 91, 97, 90, 179, 121, 97}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 14, 178, 90, 126, 227, 126, 146, 250, 13}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 79, 58, 14, 214, 199, 245, 97, 127, 48}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 119, 193, 188, 69}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 245, 233, 72, 149, 31, 221, 128}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 130, 212, 140, 177}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 10, 59, 13, 206, 218, 183, 130, 119, 76}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 113, 240, 63, 219}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 89, 61, 39, 71, 215, 89}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 175, 209, 235, 125, 232}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 11, 208, 210, 250, 69, 121, 225, 78}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 215, 183, 168, 213, 94, 49, 209}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 164, 110, 132, 153, 65, 97, 82, 164, 232}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 45, 142, 57, 20, 6}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 139, 79, 192, 236, 8, 145, 160, 63, 179}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 95, 196, 135, 89, 166, 124, 160}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 221, 147, 26, 72}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 135, 38, 181, 233}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 132, 180, 98, 140, 165, 41, 202, 93, 110}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 223, 231, 83, 45, 154, 224, 59, 136, 236}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 215, 163, 251, 43, 157, 65, 94, 217, 8}, 121},
	{{143, 46, 30, 175, 224, 0, 64, 37, 143, 250, 10, 105, 9, 6, 153, 170}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 132, 3, 219, 231, 224, 89}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 0, 0, 0, 201, 57, 244}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 175, 171, 36, 255, 212, 158}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 38, 211, 242, 225, 75, 187}, 121},
	{{143, 46, 30, 175, 224, 0, 0, 0, 0, 0, 88, 203, 220, 216, 123, 106}, 121},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 163, 212, 184, 134, 56}, 214},
	{{155, 85, 217, 180, 32, 235, 48, 45, 11, 236, 248, 176, 77, 7, 2, 34}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 179, 85, 238, 234, 252, 180, 84}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 81, 214, 68, 97, 205}, 214},
	{{155, 85, 217, 180, 0, 11, 200, 255, 0, 164, 200, 168, 211, 23, 48, 168}, 214},
	{{155, 85, 217, 180, 0, 0, 250, 29, 158, 73, 88, 167, 170, 100, 146, 19}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 25}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 192, 106, 224, 221, 61, 39}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 149, 20, 172, 108, 4, 110, 67}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 132, 115, 179, 185, 147}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 125, 254, 104, 245, 74, 172, 121}, 214},
	{{155, 85, 217, 180, 0, 0, 253, 26, 214, 139, 146, 27, 73, 7, 158, 188}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 65, 11, 120, 209, 220, 194, 12}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 17, 129, 155, 145, 100}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 37, 220, 64, 152, 5, 124, 17, 175, 86}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 126, 229, 65, 116, 133, 75}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 97, 190, 197}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 121, 52, 36, 144, 79, 70}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{155, 85, 217, 180, 0, 59, 18, 76, 96, 87, 69, 131, 152, 161, 107, 204}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 66, 75}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 170, 18}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 106, 221, 90, 42, 13, 219, 139, 102, 49}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 180, 103, 30, 134, 109, 79, 13, 7}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 87, 243, 135, 174, 96}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 14, 14, 98, 78, 185, 126, 41}, 214},
	{{155, 85, 217, 180, 0, 0, 164, 149, 121, 27, 23, 253, 244, 59, 196, 220}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 139, 58, 240, 86, 234, 93, 236, 135}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 154, 197, 42, 38}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 160, 239, 59, 254, 190}, 214},
	{{155, 85, 217, 180, 201, 60, 89, 13, 240, 123, 171, 148, 128, 49, 42, 104}, 214},
	{{155, 85, 217, 180, 0, 98, 23, 20, 209, 144, 218, 240, 152, 106, 191, 205}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 142, 65, 146, 198, 167, 4, 103, 184, 11}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 143, 121, 207, 175, 129}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 35, 117}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 30, 139, 65, 226, 7}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 72, 13, 100, 243, 58, 83, 226, 223}, 214},
	{{155, 85, 217, 180, 0, 0, 247, 32, 22, 209, 212, 112, 164, 183, 31, 186}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 113, 6, 169, 90, 240, 98, 210, 91, 127}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 252, 213, 52, 170, 46, 18, 169, 130, 109}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 220, 160, 116, 60, 102, 124, 115, 141, 251}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 51, 74, 140}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 37, 84, 102, 9, 5, 62, 158, 106}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 191, 25, 116, 93}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 70, 77, 73, 152, 56, 103, 205}, 214},
	{{155, 85, 217, 180, 0, 0, 96, 192, 153, 39, 55, 11, 192, 116, 119, 165}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205, 160, 92}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 26, 75, 24, 195, 108, 233, 17, 5}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 204, 5, 186, 165, 123, 54, 142}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 181, 133, 253, 30, 208, 48, 102}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 17, 122, 172, 155, 150, 192, 31, 90, 124}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 182, 203, 212, 227, 240, 142, 223}, 214},
	{{155, 85, 217, 180, 0, 0, 229, 128, 22, 130, 35, 237, 48, 6, 246, 1}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 88, 121, 179, 243, 168, 74, 73}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68}, 214},
	{{155, 85, 217, 180, 0, 0, 60, 21, 114, 32, 144, 177, 111, 55, 196, 234}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{155, 85, 217, 180, 0, 0, 21, 173, 36, 43, 250, 51, 111, 234, 77, 65}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 246, 241, 73, 27}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 137, 9}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 240, 55, 44, 208}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 180, 47, 207, 36, 13, 4, 120}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 236, 150, 58, 122, 18}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 39}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 107, 252, 149, 177}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 72}, 214},
	{{155, 85, 217, 180, 0, 0, 89, 75, 143, 171, 203, 246, 101, 4, 134, 209}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 44, 194, 136, 81, 202, 160, 218, 131, 57}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 69, 16, 83, 215}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 190, 188}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 230, 61}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 114, 93, 197}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 53, 237, 101, 254}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 52, 210, 97, 62, 177, 155, 167}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 100, 170, 236, 91, 136, 190}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 40, 9, 37, 75, 37, 88}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 73, 202, 176, 56, 63, 203}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 215, 249}, 214},
	{{155, 85, 217, 180, 0, 0, 56, 246, 188, 200, 0, 90, 108, 96, 59, 28}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 27, 218, 118, 78, 109}, 214},
	{{155, 85, 217, 180, 8, 216, 51, 214, 60, 116, 59, 169, 210, 239, 185, 5}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 160, 138}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 148, 255, 89, 71, 48, 241, 138}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 214},
	{{155, 85, 217, 180, 0, 0, 0, 0, 7, 4, 235, 172, 45, 77, 225, 232}, 214},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 44, 105, 40, 57, 58, 36}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 167, 138, 145, 18, 212, 102, 104}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203}, 221},
	{{58, 62, 156, 0, 0, 0, 249, 81, 150, 209, 236, 216, 219, 225, 81, 145}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 212, 119, 153, 101, 245, 117, 87, 227, 44}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 219, 30, 112}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 29, 8, 244, 149, 3, 203}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 127, 242}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 213, 111, 243}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 162, 147, 188}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 63, 15, 174, 100, 62, 220, 172, 35}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 5, 198}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 109, 18, 183, 145, 207, 63, 191, 75, 91}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{58, 62, 156, 0, 38, 89, 215, 27, 52, 224, 40, 151, 147, 54, 54, 109}, 221},
	{{58, 62, 156, 0, 0, 121, 6, 69, 79, 77, 126, 90, 244, 201, 182, 19}, 221},
	{{58, 62, 156, 0, 0, 73, 170, 207, 156, 158, 87, 14, 206, 134, 167, 43}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 133, 33, 212, 38, 125, 58}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 178, 120, 197, 24, 208, 159, 228, 241}, 221},
	{{58, 62, 156, 0, 0, 0, 123, 53, 122, 56, 94, 13, 165, 139, 117, 170}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 65, 210, 98, 43, 32}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 201, 7, 124, 103, 253, 53, 241, 184}, 221},
	{{58, 62, 156, 0, 0, 46, 27, 153, 245, 79, 210, 109, 122, 64, 144, 85}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 196, 51, 116, 232, 156}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 143}, 221},
	{{58, 62, 156, 0, 0, 0, 163, 131, 3, 248, 39, 112, 160, 66, 186, 212}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 106, 131}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 63, 197, 173, 215, 153}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 200, 195, 105, 186, 180}, 221},
	{{58, 62, 156, 0, 0, 195, 126, 85, 202, 13, 124, 50, 106, 238, 79, 232}, 221},
	{{58, 62, 156, 0, 0, 0, 130, 117, 113, 135, 200, 238, 223, 241, 4, 222}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 75, 102, 12, 36}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 197, 13, 191, 15, 36, 252}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 90, 162, 205, 158, 74}, 221},
	{{58, 62, 156, 0, 0, 221, 199, 63, 134, 52, 238, 163, 236, 211, 105, 17}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 115, 200, 30, 212, 109, 171}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 231, 217, 249, 199, 205, 69, 206, 75}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 216, 15, 65, 195, 98, 8}, 221},
	{{58, 62, 156, 0, 0, 39, 108, 179, 5, 93, 203, 253, 225, 120, 143, 221}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{58, 62, 156, 0, 0, 174, 169, 90, 229, 24, 53, 219, 189, 96, 19, 140}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 114, 12, 176, 40, 198}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 99, 156, 60, 161, 0, 24}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 251, 22, 105, 166, 152, 40}, 221},
	{{58, 62, 156, 0, 0, 178, 98, 238, 160, 20, 197, 140, 113, 117, 162, 187}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 79, 253, 174, 95, 220, 233}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 136, 137, 79, 1, 52}, 221},
	{{58, 62, 156, 0, 67, 225, 218, 199, 147, 59, 247, 140, 197, 184, 161, 125}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 211, 97, 62}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 117}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 21, 94, 178, 157, 146, 162, 25}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 213, 94, 39, 55, 35, 246, 8, 32, 186}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{58, 62, 156, 0, 0, 173, 47, 119, 92, 221, 48, 84, 196, 130, 42, 108}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 248}, 221},
	{{58, 62, 156, 0, 0, 3, 214, 159, 241, 102, 118, 160, 147, 140, 90, 149}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 13, 209, 59, 3, 236, 211, 209}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 200, 77, 157, 236, 192, 134, 115, 78, 131}, 221},
	{{58, 62, 156, 0, 0, 147, 210, 13, 30, 0, 38, 143, 138, 56, 222, 224}, 221},
	{{58, 62, 156, 0, 46, 116, 170, 179, 50, 214, 42, 229, 33, 190, 72, 117}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 78, 98, 189}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 40, 62}, 221},
	{{58, 62, 156, 0, 0, 0, 110, 58, 97, 74, 4, 190, 211, 123, 80, 74}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 167, 104, 84, 69, 129, 103, 29, 162, 241}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 2, 112, 223, 88, 237, 7, 213}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70, 132, 203, 243}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 48, 59, 4, 162, 14}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 16, 42, 108, 32, 38, 95, 238, 77, 39}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 165, 36, 32, 229, 243, 83, 133}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{58, 62, 156, 0, 0, 0, 221, 239, 172, 250, 241, 157, 62, 203, 44, 33}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 34, 47, 28, 164, 37, 205, 184}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 241, 77}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 69, 240}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191, 43, 178, 252}, 221},
	{{58, 62, 156, 0, 0, 0, 130, 235, 109, 110, 63, 79, 93, 77, 76, 174}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 188, 49, 2, 26, 234, 195, 93, 217, 2}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 31, 75}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 26, 123, 86, 197, 227, 8, 109}, 221},
	{{58, 62, 156, 0, 0, 0, 232, 46, 233, 54, 122, 117, 189, 43, 249, 2}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 214, 176, 144, 137, 25, 242, 223, 16}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 141, 43, 117, 127, 231, 34}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 225, 233, 72, 202, 211}, 221},
	{{58, 62, 156, 0, 0, 0, 132, 221, 109, 176, 61, 139, 101, 139, 62, 26}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 219, 121, 147, 206, 127, 91}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 147, 249, 168, 222, 109}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 28, 136, 159, 253, 241, 202}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 221}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 23, 118, 150, 203, 99, 199, 65, 221}, 221},
	{{58, 62, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 221},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 32, 45, 77, 26, 41, 143, 188}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 67, 115}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 202, 150, 179, 168, 94, 10}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 57, 47, 101, 48, 208, 17}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 186, 214, 207}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 172, 91, 125, 145}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 23, 177, 156, 148, 146, 107, 38, 154}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 125, 144}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 210, 87}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 48, 33, 132, 139, 140, 208, 63}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 187, 113, 112, 136, 243, 100}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 64, 82, 110, 85, 60, 159, 155}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 249, 120, 148, 106, 125}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 230, 31}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 244, 109, 19, 136, 211, 135}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 16, 1, 187, 30}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 150, 90, 98, 178, 17, 185, 133}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 245}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 146, 162, 142, 72, 10, 74, 167}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 234, 29, 101, 122, 128, 180}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 68, 134}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 255}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 183, 167, 40}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 236, 15, 127}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 163, 106, 84, 177, 78}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 130, 131, 149, 91, 45, 245}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 151, 206}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 198, 208}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 10, 131, 63, 30, 206, 101}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 135}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 17, 171}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 212, 116, 126}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 117, 134, 225, 13, 92, 26}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 168, 55, 70, 138}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 166, 206, 171, 7, 151, 96}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 232, 133, 216, 23, 242, 210, 223}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 86, 152, 189, 128, 17, 132}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 12, 84}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 20, 236, 128, 124, 72, 116, 149}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 215, 198, 106, 218, 65, 89}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 99, 14, 98, 37, 126, 6, 67}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 149, 149, 190, 71, 51, 1}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 41, 55, 162, 99}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 198, 28, 152, 84}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 151, 209, 153, 238}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 122, 74, 87, 109, 149, 41, 184}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 22, 213, 21, 204, 93, 204, 239}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 165, 111, 212, 193, 190}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 89, 194}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 215, 99, 135, 233, 111, 187, 83}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 17, 31}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 80, 119, 150, 123, 230, 172}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 31, 74}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 191, 161, 3, 187, 225, 150}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 196, 23, 86, 231}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 247, 169, 194, 141, 141, 32}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 225}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 19, 33, 237}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 145, 77, 14, 229, 122, 181}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 35}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 225, 109, 172, 133, 206, 216, 206}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 27, 94}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 23, 128, 34, 95}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 79, 137, 43, 8, 2, 46, 232}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 94}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 168, 213, 180}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 98, 71, 199, 100, 106, 146, 55}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 83, 107, 70, 177, 10, 131, 7}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 36}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 11, 59, 187, 202, 41, 235, 94}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 1, 62, 115}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 65, 170, 62, 202, 215}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 123, 203, 75, 32, 145, 45, 179, 98}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 2, 154}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 228}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 19, 21, 27, 17, 48, 118, 125}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 0}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 86, 161, 19, 108, 175, 15}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 129, 37, 27, 126, 123}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 74, 244}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 168, 147, 189, 143, 8, 211, 220}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 91, 3, 183, 17}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 147, 154, 159, 43, 63, 37, 136}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 0, 42}, 102},
	{{92, 155, 53, 3, 39, 108, 155, 200, 0, 0, 0, 0, 0, 0, 4, 103}, 102},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 131, 233, 156, 142, 158, 15, 1, 146}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 242, 126, 172, 224, 147, 14, 144, 186, 160, 182, 57}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 183, 104}, 84},
	{{64, 108, 54, 140, 176, 2, 225, 175, 194, 15, 239, 115, 189, 12, 238, 220}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 244, 5, 25, 247, 67, 232}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 102, 210}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62}, 84},
	{{64, 0, 191, 51, 99, 149, 109, 165, 216, 41, 43, 50, 170, 238, 150, 251}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 238, 147, 88, 121}, 84},
	{{64, 0, 0, 0, 0, 0, 94, 229, 41, 137, 202, 209, 1, 119, 187, 238}, 84},
	{{64, 0, 0, 0, 0, 0, 92, 47, 247, 10, 133, 205, 178, 129, 103, 75}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 186, 38, 242, 142, 235}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 34, 194}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 193, 87, 6, 87, 43, 99}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 63}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 76, 105, 19}, 84},
	{{64, 0, 0, 0, 0, 0, 134, 133, 2, 165, 25, 25, 196, 136, 47, 199}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 202, 246, 70, 98, 41, 174, 151, 203, 98, 199, 240, 198, 17, 108}, 84},
	{{64, 0, 239, 186, 29, 228, 209, 245, 53, 135, 99, 195, 25, 145, 98, 116}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 82}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 252, 121, 218, 253, 24}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 228, 195, 201, 248, 61, 177, 12, 6, 208}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 75, 117, 143, 42, 39, 162, 66, 219}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 201, 9}, 84},
	{{64, 0, 23, 195, 152, 245, 35, 181, 184, 48, 141, 130, 185, 27, 38, 1}, 84},
	{{64, 0, 0, 0, 0, 0, 29, 109, 27, 232, 132, 135, 1, 134, 44, 56}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 92, 219, 140, 196, 86, 177}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 98}, 84},
	{{64, 0, 0, 0, 0, 0, 181, 48, 198, 12, 51, 200, 116, 187, 240, 150}, 84},
	{{64, 0, 0, 0, 178, 201, 145, 213, 210, 60, 114, 1, 124, 97, 52, 44}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 165, 109, 157, 103}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 68, 65, 126, 50}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 138, 29, 44, 115, 217, 122, 85, 202, 24}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 47, 48, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 147, 115}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 149}, 84},
	{{64, 0, 0, 0, 162, 246, 210, 42, 82, 4, 237, 166, 26, 85, 166, 92}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 227, 98, 117, 13, 69, 236, 247, 133, 224}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 118, 57, 134, 57, 164, 218, 20, 73}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 232, 164, 227, 130, 123}, 84},
	{{64, 0, 0, 0, 228, 240, 33, 21, 221, 154, 211, 172, 106, 3, 247, 180}, 84},
	{{64, 0, 0, 0, 200, 23, 78, 55, 170, 186, 69, 155, 38, 176, 26, 120}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 156, 8, 255, 53, 164, 241}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 165, 238, 170, 177, 21, 55, 7, 107}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 251, 20, 227, 30, 76, 253, 244, 22, 53, 184}, 84},
	{{64, 0, 0, 0, 28, 218, 79, 99, 186, 94, 78, 183, 77, 228, 138, 43}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 101, 248}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 169, 164, 45, 88, 189, 228, 97}, 84},
	{{64, 0, 0, 0, 0, 197, 213, 151, 15, 226, 22, 202, 58, 210, 230, 162}, 84},
	{{64, 0, 0, 0, 20, 46, 155, 234, 10, 12, 168, 111, 184, 87, 71, 3}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 89, 235, 44, 211, 150, 1, 65, 172, 81, 48, 160}, 84},
	{{64, 0, 0, 0, 0, 133, 161, 84, 23, 233, 121, 126, 222, 202, 123, 66}, 84},
	{{64, 187, 239, 42, 94, 235, 130, 19, 103, 53, 20, 68, 30, 99, 44, 177}, 84},
	{{64, 0, 0, 0, 45, 2, 185, 147, 138, 130, 157, 196, 13, 191, 15, 96}, 84},
	{{64, 0, 0, 45, 40, 111, 46, 224, 147, 17, 39, 116, 147, 89, 209, 3}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43, 211, 39, 156, 17}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 99, 22, 21, 200}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 232, 110, 81, 174, 25, 169, 249}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79, 35, 114}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197, 17, 237, 19, 64}, 84},
	{{64, 0, 0, 0, 134, 204, 145, 119, 117, 58, 168, 134, 0, 97, 21, 9}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27, 169}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 123, 164, 30, 197, 93, 203, 233, 64, 201, 98, 224, 93}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 78, 52}, 84},
	{{64, 0, 0, 0, 0, 168, 172, 119, 114, 92, 126, 142, 201, 45, 69, 158}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160}, 84},
	{{64, 0, 75, 62, 138, 170, 117, 11, 61, 224, 69, 185, 177, 213, 84, 193}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 83, 50, 192, 143, 21, 218, 127}, 84},
	{{64, 0, 0, 148, 137, 249, 79, 222, 122, 214, 46, 199, 25, 148, 147, 138}, 84},
	{{64, 0, 0, 0, 0, 30, 18, 7, 185, 160, 80, 32, 244, 253, 172, 70}, 84},
	{{64, 0, 249, 87, 18, 112, 198, 109, 22, 130, 196, 5, 109, 117, 239, 122}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 44, 98, 135, 49}, 84},
	{{64, 0, 0, 0, 0, 99, 118, 76, 162, 119, 11, 100, 116, 28, 232, 244}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29, 11, 217, 106, 92}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 51, 207, 216, 79, 67, 235, 19}, 84},
	{{64, 0, 0, 0, 182, 122, 39, 253, 153, 237, 225, 166, 70, 248, 10, 14}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 203, 197, 5, 212, 101}, 84},
	{{64, 0, 0, 0, 87, 205, 213, 150, 38, 128, 229, 145, 103, 203, 119, 218}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 163, 131, 148, 15, 67, 58, 35, 49}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 245, 188, 111, 176, 31, 188, 29, 15}, 84},
	{{64, 0, 0, 250, 80, 136, 131, 92, 250, 161, 37, 161, 60, 96, 102, 180}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 72, 141, 81, 90, 155}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 63, 131, 30, 162, 215}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 80, 76, 174}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 182, 40, 87, 16, 97, 59}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 84},
	{{64, 0, 0, 0, 0, 0, 0, 242, 225, 72, 4, 247, 71, 8, 112, 29}, 84},
	{{64, 186, 145, 1, 94, 157, 186, 176, 142, 229, 61, 235, 78, 196, 196, 65}, 84},
	{{64, 0, 0, 0, 223, 211, 46, 181, 154, 203, 252, 148, 88, 154, 11, 233}, 84},
	{{64, 0, 0, 180, 166, 78, 234, 45, 62, 216, 136, 104, 236, 59, 170, 45}, 84},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 185, 157, 218, 54, 110}, 197},
	{{63, 134, 251, 59, 192, 0, 233, 95, 69, 50, 240, 108, 240, 248, 241, 92}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 92, 129, 245, 133, 95}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 125, 109, 66, 92, 113, 131, 140, 70, 145}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 186, 175, 229, 112, 226, 108, 242}, 197},
	{{63, 134, 251, 59, 192, 0, 24, 69, 196, 24, 220, 191, 86, 27, 121, 0}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 104, 91, 249, 198}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 246, 45, 228, 52, 254}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 171}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 83, 231, 114, 201, 214, 65, 238, 65}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 51, 213, 99, 137, 226}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 251, 115, 43, 204}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 249, 201}, 197},
	{{63, 134, 251, 59, 192, 0, 193, 21, 203, 161, 155, 170, 152, 153, 189, 25}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 16, 84, 37, 163, 78, 23, 235, 234, 116}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 247, 34, 118, 112, 36}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 216, 0, 153, 33, 199, 78, 168, 5, 209}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 50, 149, 120, 226}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 247, 121}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 82, 58, 93, 110, 70}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 223, 196}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 148, 244, 45, 67, 145, 77}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 99, 242, 155}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 216}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 139, 141, 5, 234}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 52}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 183}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 8, 252, 237, 43, 27, 203, 54}, 197},
	{{63, 134, 251, 59, 192, 0, 236, 70, 231, 67, 93, 18, 86, 168, 101, 54}, 197},
	{{63, 134, 251, 59, 192, 0, 140, 160, 186, 221, 221, 10, 35, 159, 65, 228}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 16, 222, 158, 39}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 247, 4, 220, 83, 54}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 104, 114, 167, 207, 167, 214, 251, 96}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 39, 190, 222, 119, 248, 102, 240}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 201, 128, 158, 192}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 224, 86, 254, 222, 238, 154, 144, 224, 245}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 220, 10}, 197},
	{{63, 134, 251, 59, 192, 0, 56, 101, 73, 127, 89, 202, 217, 24, 87, 7}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 169, 205, 219}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 52, 67, 20, 243, 255, 81}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 126, 41, 237, 77, 233, 212, 5}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 208, 195, 65, 86, 88}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 222, 246, 205, 166, 80, 55, 224, 82}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 228, 17, 208, 212, 125}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 88, 35}, 197},
	{{63, 134, 251, 59, 192, 0, 165, 239, 210, 187, 240, 86, 168, 17, 99, 107}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 254, 211, 40}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 166, 98}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 184, 105, 191}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 46, 224, 113, 211, 204}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 178, 26, 4, 93, 177, 143}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 151}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 177, 126, 254, 231, 95, 42, 44, 239, 57}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 207, 243, 169, 151, 205, 44, 206, 64, 120}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 184, 214, 170, 21, 66, 144, 92, 26, 69}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 243, 101, 134, 6, 134}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 175, 158, 193}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 88, 87, 73, 117, 28, 250, 254, 233}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 26, 78, 54, 192, 66, 116, 229, 34}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150, 202}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 159, 25, 147}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 149, 41, 132, 180, 35}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 215, 30, 166, 128}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 132, 221, 143, 95}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 205}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 108, 227, 185, 6, 23, 226, 157}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 64, 77, 121, 228, 228, 179, 21, 4}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 191, 56, 248, 25, 253, 211, 103, 88, 170}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 94, 147, 114, 206, 28, 150}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 234, 62, 170, 77, 41, 61, 243, 196}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 104, 125, 85, 28, 62, 34, 78, 237}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 117, 222, 66}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 84, 58, 128, 152, 126, 126, 217}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 36, 129, 188, 90, 107, 70}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 155, 84, 247}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 32, 99, 143, 39, 85, 93, 244, 24, 29}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 139}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 67, 187, 159, 128}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 191, 77, 116}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 186, 254, 247}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 148, 252, 37, 39, 121, 213, 107, 56}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 155, 14}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 36, 64, 160, 91, 25, 89}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 121, 86, 42, 100, 68, 46, 105}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 0, 247, 23, 77}, 197},
	{{63, 134, 251, 59, 192, 0, 0, 0, 0, 0, 0, 0, 98, 38, 76, 171}, 197},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 51}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 155, 179, 111, 96, 154}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 202}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 242, 251}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 36, 187, 75, 205}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 125, 115, 194}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 115, 155}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 197, 5, 83}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 174, 54}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 204}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 249}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 37, 192, 68, 19, 123}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 87, 194, 29, 200, 80}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 40, 172, 160, 87}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 150, 142, 124, 203}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 181, 132}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 239, 173, 81}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 219, 20}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 162, 107, 141, 163}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 196, 118, 101}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 60, 95, 22, 150, 23}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 120, 138, 174, 18, 9}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 148}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 115, 134, 121}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 51, 187, 230, 172, 206, 250}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 218, 229}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 102, 212, 38, 181}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 36}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 234, 76, 154, 56}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 128, 251, 236, 164}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 7, 48, 49}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 174, 53}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 41, 24}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 235, 90}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 133}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 182, 239, 200, 64}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 94, 213, 91, 211, 29}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 29, 133, 10, 19, 23}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 74, 27}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 59}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 6, 61, 51}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 64, 196, 243}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 246}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 241, 253}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 145, 248}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 16, 242, 166, 72, 55}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 23, 178, 196}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 145, 226, 171, 219}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 45, 128, 229}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 169, 117, 60, 67, 173}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 234, 203}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 99}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 113, 85, 171}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 197, 34, 254, 77, 70}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 77}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 177, 172, 23, 205, 62}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 67, 44, 60, 81}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 150}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 44, 29, 226, 4, 201}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 213, 190}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 24}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 229, 206}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 184}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 43, 29, 11}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 9, 97, 201, 254, 254}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 74}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 104, 138}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 174, 210, 47, 153, 105}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 125, 139, 43}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 84, 70, 193, 222, 160}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 50, 166, 16, 118, 249}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 13, 245}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 91}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 169, 25, 35, 19, 91}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 36, 38, 50}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 246, 178, 214}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 99}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 243, 231}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 192, 255, 23, 61, 18}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 181}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 66, 235}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 7, 158, 192}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 0, 0}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 0, 0, 0, 218, 13}, 106},
	{{234, 149, 220, 106, 0, 144, 214, 128, 35, 102, 0, 61, 44, 226, 224, 132}, 106},
};

#define  NUM_ROUTE_ENTRIES (sizeof(large_route_table) / sizeof(large_route_table[0]))
#define  NUM_IPS_ENTRIES (sizeof(large_ips_table) / sizeof(large_ips_table[0]))

#endif /* _TEST_LPM_ROUTES_H_ */
